/****
*
*	File name :		ssqueues.h
*	Author :		Steve Johnson
*	Creation date :	August 27, 1985
*
*	Copyright (c) 1985,1999 Sigma Six Corporation
*
*	Include file for the queueing library
*
****/

/****
*
*	This is the buffer structure for maintaining I/O queues
*
****/

typedef struct queue_def {
	struct queue_def	*forward;
	struct queue_def	*backward;
} QUEUE_DEF;

extern void	queue_init (QUEUE_DEF *);
extern void	*queue_get (QUEUE_DEF *);
extern void	*queue_tail (QUEUE_DEF *);
extern void	*queue_next (QUEUE_DEF *);
extern void	queue_append (QUEUE_DEF *, QUEUE_DEF *);
extern void	queue_new_head (QUEUE_DEF *, QUEUE_DEF *);
extern void	queue_move_to_tail (QUEUE_DEF *, QUEUE_DEF *);
extern void	queue_remove (QUEUE_DEF *, QUEUE_DEF *);
extern int	queue_count (QUEUE_DEF *);
extern int	queue_search (QUEUE_DEF *, QUEUE_DEF *);

