/****
*
*	File name :		sstrace.h
*	Author :		Steve Johnson
*	Creation date :	September 10, 1993
*
*	Copyright (c) 1985,1999 Sigma Six Corporation
*
*	Include file for the trace utility
*
****/

typedef void	*TRACE_HANDLE;

/****
*
*	use the compile switch -DTRACES_OFF to compile out full traces
*
****/

#ifdef TRACES_OFF

#define TRACE(a)
#define TRACE_I(a,b)
#define TRACE_L(a,b)
#define TRACE_S(a,b)
#define TRACE_B(a,b,c)
#define TRACE_SIZE(a,b)

#else

#define TRACE(a)			trace_message (a)
#define TRACE_I(a,b)		trace_int (a, b)
#define TRACE_L(a,b)		trace_long (a, b)
#define TRACE_S(a,b)		trace_string (a, b)
#define TRACE_B(a,b,c)		trace_buffer (a, b, c)
#define TRACE_SIZE(a,b)		trace_int (a, b)
#define TRACE_SYS(a)		trace_system (a)

#endif


#define ERROR_TRACE(a)			trace_error_message (a)
#define ERROR_TRACE_I(a,b)		trace_error_int (a, b)
#define ERROR_TRACE_L(a,b)		trace_error_long (a, b)
#define ERROR_TRACE_S(a,b)		trace_error_string (a, b)
#define ERROR_TRACE_B(a,b,c)	trace_error_buffer (a, b, c)
#define ERROR_TRACE_SIZE(a,b)	trace_error_int (a, b)
#define ERROR_TRACE_SYS(a)		trace_error_system (a)

extern TRACE_HANDLE		trace_init (char *);
extern void 			trace_exit (TRACE_HANDLE);
extern void				trace_debug_on (TRACE_HANDLE);
extern void				trace_debug_off (TRACE_HANDLE);
extern void				trace_console_on (TRACE_HANDLE);
extern void				trace_console_off (TRACE_HANDLE);
extern void 			trace_message (char *);
extern void 			trace_int (char *, int);
extern void 			trace_long (char *, long);
extern void 			trace_string (char *, char *);
extern void 			trace_buffer (char *, int, void *);
extern void 			trace_system (char *);
extern void 			trace_error_message (char *);
extern void 			trace_error_int (char *, int);
extern void 			trace_error_long (char *, long);
extern void 			trace_error_string (char *, char *);
extern void 			trace_error_buffer (char *, int, void *);
extern void 			trace_error_system (char *);

