/*agentPorts.h,v 1.1.1.1 1999/08/03 14:41:18 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		CHANNEL ACCESS AGENT PORT ASSIGNMENTS		*/
/*								*/
/*	"Well known" port numbers are required for each of	*/
/*	the three active elements of the agent architecture	*/
/*	for channel access. Channel Acquisition and Control	*/
/*	and the name server need well defined TCP ports. 	*/
/*	Socket Creation and Maintenance needs both a TCP and	*/
/*	a UDP port. This header file defines all those socket	*/
/*	numbers.						*/
/*								*/
/*	Author:	Gordon Uchenick					*/
/*								*/
/****************************************************************/

#ifndef	INCagentportsH
#define	INCagentportsH

/****************************************************************/
/*								*/
/*			HISTORICAL PERSPECTIVE			*/
/*								*/
/*	The original development of the dbServer/dbClient	*/
/*	architecture used port 8585 which was picked from an	*/
/*	old disgusting rock 'n' roll song by Zaeger & Evans:	*/
/*								*/
/*	"In the year 8585, if man is still alive,		*/
/*	If woman can survive, what will they find?"		*/
/*								*/
/*	Time synchronization came along next and got 8586.	*/
/*								*/
/****************************************************************/
#define	SCM_PORT		8587	/* Socket Acquisition and Maintenance */
#define CAM_PORT		8588	/* Channel Acquisition and Maintenance */
#define	NAM_PORT		8589	/* Name Server */
#define RSV_PORT		8591	/* IOC Sever UDP port */

#endif	INCagentportsH
