/*alarmString.h,v 1.1.1.1 1999/08/03 14:41:19 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*  @(#)alarmString.h	1.5 9/10/91
 *      Author: 
 *      Date:   
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the Regents of the University of California,
 *      and the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contracts:
 *      (W-7405-ENG-36) at the Los Alamos National Laboratory,
 *      and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *      Initial development by:
 *              The Controls and Automation Group (AT-8)
 *              Ground Test Accelerator
 *              Accelerator Technology Division
 *              Los Alamos National Laboratory
 *
 *      Co-developed with
 *              The Controls and Computing Group
 *              Accelerator Systems Division
 *              Advanced Photon Source
 *              Argonne National Laboratory
 *
 * Modification Log:
 * -----------------
 * .01  06-06-91        bkc     Modified alarmSeverityString: add VALID alarm,
 *				remove INFO alarm
 * .02  09-10-91        bkc     Change status string corresponding to 
 *				dbconV2/menus.c
 * .03  02-22-94	ems	added MV ERROR thru PARAMETER
 * .04  03-08-94	ems	chg UNEXPECTED to PERMISSIVE, UNEXPECTED
 *				not used anymore
 * .05  03-15-94	ems	added new TANK level and temperature alarms
 * .06	04-15-94	ems	added NO INIT alarm
 * .07	03-07-95	ems	chg BAD_SUB to BAD UDB
 * .08	08-07-95	wep	chg COMM to OPEN T/C
 *      ...
 */

/* alarmString.h - String values for alarms (Must match alarm.h)!!!!*/
/* share/epicsH @(#)alarmString.h	1.3     11/6/90 */
#ifndef INCalarmStringh
#define INCalarmStringh 1


/*** NOTE:  
	this list MUST be kept in sync with the list of alarms in
		.../share/ascii/choiceGbl.ascii
		.../share/epicsH/alarm.h
		.../share/epicsH/decTalkalarmStrings.h
***/

char * alarmSeverityString[]={
	"NO ALARM",
	"INFO",
	"EVENT",
	"MINOR",
	"MAJOR",
	"INVALID ALARM",
#ifdef CONN	/* DEK 3/17/94  --  Removed to be consistent. */
	"CONN",
#endif
	0
	};

char * validSeverityString[]={
	"NO ALARM",
	"INFO",
	"EVENT",
	"MINOR",
	"MAJOR",
#ifdef CONN
	"CONN",
#endif
	0
	};

short validSeverities[]={
	NO_ALARM,
	INFO_ALARM,
	EVENT_ALARM,
	MINOR_ALARM,
	MAJOR_ALARM,
#ifdef CONN
	CONN_ALARM,
#endif
	};

/*** NOTE:  
	this list MUST be kept in sync with the list of alarms in
		.../share/ascii/choiceGbl.ascii
		.../share/epicsH/alarm.h
		.../share/epicsH/decTalkalarmStrings.h
***/

char * alarmStatusString[]={
	"RETRN NORMAL",
	"READ        ",
	"WRITE       ",
	"HIHI        ",
	"HIGH        ",
	"LOLO        ",
	"LOW         ",
	"SBAD        ",
	"ROC         ",
	"STATE       ",
	"COS         ",
	"OPEN T/C    ",
	"TIMEOUT     ",
	"HW_LIMIT    ",
	"CALC        ",
	"SCAN        ",
	"LINK        ",
	"SOFT        ",
	"BAD UDB     ",
	"UDF         ",
	"INHIBIT     ",
	"TAGGED      ",
	"CMD NOT ALLW",
	"VOLUME      ",
	"HIHI LEVEL  ",
	"TEMPERATURE ",
	"PRESSURE    ",
	"BSW         ",
	"TANK_VALVE  ",
	"VLV OPEN ALM",
	"VLV CLS  ALM",
	"VLV TORQ LAG",
	"VLV FAULT   ",
	"VLV POSITION",
	"AUTOMATIC   ",
	"VIBRATION   ",
	"PUMP START  ",
	"PUMP STOP   ",
	"POT DROP RDY",
	"PERMISSIVE  ",
	"UNCOMMANDED ",
	"THRSHLD EXCD",
	"MV ERROR    ",
	"OUTPUT ERROR",
	"DEVIATION   ",
	"TRACKNG MODE",
	"SETPT HI CLP",
	"SETPT LO CLP",
	"OUTPT HI CLP",
	"OUTPT LO CLP",
	"MAN OVERRIDE",
	"SETPT ERROR ",
	"OUT MODE ERR",
	"PARAMETER   ",
	"HIGH LEVEL  ",
	"LOW LEVEL   ",
	"LOLO LEVEL  ",
	"HIHI TEMP   ",
	"HIGH TEMP   ",
	"LOW TEMP    ",
	"LOLO TEMP   ",
	"NO INIT     ",
	"",
};

#endif
