/**********
*
*	File:	aoredfldidx.h
*	Author:	William H. Szostak
*	Date:	14-Feb-1993
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the analog input record.
*
*	Modification Log
*       ----------------
*	.01  03-12-93	ems	deleted ACK, adjusted indicies accordingly
*	.02  04-15-94	ems	added INI2, chg NUMFLDS to NUMAOFLDS
*	.03  10-12-94	ems	added TIME
*	.04  10-20-94	ems	chg TIME to LATM (last alarm time)
*	.05  01-31-96	ems	added LOVL
*	.06  04-03-96	ems	added HHLL,HILO,RTCT,LARF
*
**********/

#define		STAT	0	/* current alarm status		*/
#define		SEVR	1	/* current alarm severity	*/
#define		VAL	2	/* current output value		*/
#define		LALM	3	/* last VAL alarmed		*/
#define		INI2	4	/* secondary init flag		*/
#define		LATM	5	/* last VAL alarm time		*/
#define		MLST	6	/* last VAL monitored		*/
#define		LOVL	7	/* last output value		*/
#define		HHLL	8	/* hihi/lolo alarm counter	*/
#define		HILO	9	/* high/low alarm counter	*/
#define		RTCT	10	/* return to normal counter	*/
#define		LARF	11	/* last alarm flag		*/

#define		NUMAOFLDS    (LARF + 1)
