 
/****************************************************************************
 *
 *  FILE    :   deadtimeredfldidx.h
 *  DATE    :   13 Sep 93
 *  AUTHOR  :   emsteel
 *  PURPOSE :   This file contains the field descriptor indicies used by the
 *              redundant update memory que for the deadtime record
 *
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :28 Feb 94
 *  REVISION: removed ALST, MLST not needed
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :12 May 94
 *  REVISION: ADDED INI2
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :12 Oct 94
 *  REVISION:	added TIME and LALM
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :20 Oct 94
 *  REVISION:	chg TIME to LATM (last larm time)
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :20 Dec 94
 *  REVISION:	removed LALM, not needed
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :7 Feb 95
 *  REVISION:	added LMIN
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :14 Feb 95
 *  REVISION:	added LMAV, LMCM, LMCX
 *
****************************************************************************/

/****************************************************************************
 *
 * Programmer's Notes:
 *
 * NOTE: The order of the fields in this list MUST match the order and the
 *       spelling in the namelist[] in recDeadtime.c. Spelling must also
 *       match that in deadtimeRecord.ascii
 *
 *
****************************************************************************/


#define    STAT   0     /* alarm status              */
#define    SEVR   1     /* alarm severity            */
#define    IVAL   2     /* input value               */
#define    ISTA   3     /* input STAT                */
#define    ISEV   4     /* input SEVR                */
#define    DETI   5     /* deadtime index            */
#define    NUMP   6     /* num topush onto que       */
#define    SDET   7     /* delay value, local value  */
#define    DTRC   8     /* delay rate constant value */
#define    INI2   9     /* secondary init flag       */
#define    LATM   10    /* last alarm time	     */
#define	   MLST	  11	/* last VAL monitored	     */
#define    LMIN   12	/* last input monitored      */
#define    LMAV   13	/* last monitored CAVE       */
#define    LMCM   14	/* last monitored CMIN       */
#define    LMCX   15	/* last monitored CMAX       */

#define    NUMDEADTIME_FLDS (LMCX + 1)

