/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/**********
*
*	File:	ldfw2redfldidx.h
*	Author:	emsteel
*	Date:	30 May 96
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the lead follow 1 record.
*
*	NOTE: The order of the fields in this list must match the order of
*		the list in ldfw2.c.
*
*	Modification Log
*       ----------------
*	.01	05-30-96	ems	creation date
**********/


#define		LDFW2_STAT	0	/* current alarm status		*/
#define		LDFW2_SEVR	1	/* current alarm severity	*/
#define		LDFW2_VAL	2	/* current value		*/
#define		LDFW2_LALM	3	/* last VAL alarmed		*/
#define		LDFW2_INI2	4	/* secondary init flag		*/
#define		LDFW2_LATM	5	/* last alarm time		*/
#define		LDFW2_MLST	6	/* last VAL monitored		*/
#define		LDFW2_PSPD	7	/* output pump speed		*/
#define		LDFW2_LPST	8	/* last pump started		*/
#define		LDFW2_NPRC	9	/* pumps with run confirm	*/

#define		NUMLDFW2FLDS    (LDFW2_NPRC + 1)

