/*pathNames.h,v 1.1.1.1 1999/08/03 14:41:26 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		PATH NAMES FOR CHANNEL ACCESS			*/
/*								*/
/*	There are a few cases where we need to know the		*/
/*	path names and explicit directory locations in the	*/
/*	workstations. All of those definitions are here.	*/
/*								*/
/*	Author:	Gordon Uchenick					*/
/*								*/
/****************************************************************/

#ifdef WIN32
/******
	File names for execl
******/

#define SMNAME	"\\tis4000\\tasks\\sockMnt"
#define CANAME	"\\tis4000\\tasks\\chanAcq"
#define NSNAME	"\\tis4000\\tasks\\nameSrv"

/******
	Paths for working directories for each program
******/

#define SMPATH	"\\tis4000\\tasks\\scM"
#define CAPATH	"\\tis4000\\tasks\\caC"
#define NSPATH	"\\tis4000\\tasks\\nmS"

/******
	File names for mutual exclusion
******/

#define SMLOCK	"sockMnt.lock"
#define CALOCK	"chanAcq.lock"
#define NSLOCK	"nameSrv.lock"

#else
/******
	File names for execl
******/

#define SMNAME	"/tis4000/tasks/sockMnt"
#define CANAME	"/tis4000/tasks/chanAcq"
#define NSNAME	"/tis4000/tasks/nameSrv"

/******
	Paths for working directories for each program
******/

#define SMPATH	"/tis4000/tasks/scM"
#define CAPATH	"/tis4000/tasks/caC"
#define NSPATH	"/tis4000/tasks/nmS"

/******
	File names for mutual exclusion
******/

#define SMLOCK	"sockMnt.lock"
#define CALOCK	"chanAcq.lock"
#define NSLOCK	"nameSrv.lock"
#endif WIN32

/******
	Function Prototypes
******/

void serverInit();	/* General initialization */
