/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/**********
*
*	File:	patredfldidx.h
*	Author:	emsteel
*	Date:	26 Apr 95
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the PAT block
*
*	Modification Log
*       ----------------
*  .01	mm-dd-yy	xxx	comment
*  .02	06-20-95	ems	added MODE, ASTP, MONT, MOFT, RVAL, CT
*  .03	09-14-95	ems	added LMSP and LASP
*  .08  04-10-96	ems	added HHLL,HILO,RTCT,LARF,SBCT,HLSC
*  .09	07-01-96	ems	added SSTP
*
**********/


#define		STAT	0	/* current alarm status		*/
#define		SEVR	1	/* current alarm severity	*/
#define		VAL	2	/* current block value		*/
#define		LALM	3	/* last value alarmed		*/
#define		INI2	4	/* secondary init flag		*/
#define		LATM	5	/* last alarm time		*/
#define         MLST    6	/* last value monitored		*/
#define		RLVL	7	/* remote/local value		*/
#define		ASTP	8	/* current setpoint		*/
#define		CT	9	/* previous clock ticks		*/
#define		MODE	10	/* mode for tracking		*/
#define		MOFT	11	/* minimum off time		*/
#define		MONT	12	/* minimum on time		*/
#define		RVAL	13	/* current raw value		*/
#define		LMSP	14	/* last monitored setpoint	*/
#define		LASP	15	/* last archived setpoint	*/
#define		HHLL	16	/* hihi/lolo alarm counter	*/
#define		HILO	17	/* high/low alarm counter	*/
#define		RTCT	18	/* return to normal counter	*/
#define		LARF	19	/* last alarm flag		*/
#define		SBCT	20	/* SBAD alarm counter		*/
#define		HLSC	21	/* hi/lo setpt clamp counter	*/
#define		HPOS	22	/* manual positive control	*/
#define		HNEG	23	/* manual negative control	*/
#define		HAND	24	/* manual output control	*/
#define		SSTP	25	/* save setpoint		*/

#define		NUMPATFLDS    (SSTP + 1)

