/****************************************************************************
 *
 *  FILE    :   potredfl.h
 *  DATE    :   09 June 93
 *  AUTHOR  :   emsteel
 *  PURPOSE :   This file contains the field descriptor indicies used by the
 *              redundant update memory que for the pot record
 *
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 23 Feb 94
 *  REVISION:  deleted INIT, ALST, MLST, not needed
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 20 May 94
 *  REVISION:  added INI2, PCMD and cmd fields
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 Oct 94
 *  REVISION:  added TIME
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :20 Oct 94
 *  REVISION:	chg TIME to LATM (last larm time)
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :13 Jan 95
 *  REVISION:	added MLST
 *
****************************************************************************/

/****************************************************************************
 *
 * Programmer's Notes:
 *       The order of the fields in this list MUST match the order and the
 *       spelling in namelist[] in recPot.c. Speeling must also match that
 *       in potRecord.<ascii,h>
 *
****************************************************************************/


#define	STAT	0       /* alarm status            */
#define	SEVR	1       /* alarm severity          */
#define	VAL	2       /* pot volume transfered   */
#define	STTS	3       /* pot status              */
#define	POSV    4       /* pot status local        */
#define	QVOL	5  	/* quiescent volume        */
#define	LALM	6  	/* last volume alarmed     */
#define ESOU    7       /* emergency stop output   */
#define INI2	8	/* secondary init flag     */
#define PCMD	9	/* last command            */
#define CMDS	10	/* string command field	   */
#define CISS	11	/* issue command	   */
#define CREC	12	/* receive command	   */
#define CSTP	13	/* stop command		   */
#define ISSC	14	/* special issue command   */
#define RESC	15	/* special receive command */
#define STSC	16	/* special stop command    */
#define LATM	17	/* last alarm time	   */
#define	MLST	18	/* last VAL monitored	   */

#define  NUMPOTFLDS  (MLST + 1)

