
	/****************************************************************************
 *
 *  FILE    :   pumpredfldidx.h
 *  DATE    :   11 May 93
 *  AUTHOR  :   emsteel
 *  PURPOSE :   This file contains the field descriptor indicies used by the
 *              redundant update memory que for the pump record
 *
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 28 Feb 94
 *  REVISION:  removed INIT, not needed
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 2 May 94
 *  REVISION:  removed VAL, not needed, added PCMD and INI2
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 10 May 94
 *  REVISION: added command fields
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 Oct 94
 *  REVISION: added TIME
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :20 Oct 94
 *  REVISION:	chg TIME to LATM (last larm time)
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :14 Feb 95
 *  REVISION:	added VAL
 *
 *  REVISED BY             :emsteel
 *  REVISION DATE          :09 Feb 96
 *  REVISION:	added SVRT,ACRT,LPRT, LSVL
 *
****************************************************************************/

/****************************************************************************
 *
 * Programmer's Notes:
 *
 * NOTE: The order of the fields in this list MUST match the order and the
 *       spelling in the namelist[] in recPump.c. Spelling must also match
 *       that in pumpRecord.<ascii,h>
 *
 *
****************************************************************************/


#define	STAT	0	/* alarm status            */
#define	SEVR	1	/* alarm severity          */
#define	PUST	2	/* pump status             */
#define	SWST	3	/* ROL switch status       */
#define	PASV	4	/* pump status local       */
#define	SWSV	5	/* ROL switch status local */
#define	LMOD	6	/* learn mode              */
#define	ESTP	7	/* init emergency stop     */
#define	EXON	8	/* start time in seconds   */
#define	EXOF	9	/* stop time in seconds    */
#define	TTIM	10	/* timer value             */
#define	SPED	11	/* pump speed              */
#define	SMOD	12	/* save MODE               */
#define	LMEN	13	/* learn mode enable       */
#define	LCMD	14	/* last command            */
#define	LSTA	15	/* last tiem alarm stat    */
#define	LSEV	16	/* las ttime alarm sevr    */
#define	PLTR	17	/* last local tracking     */
#define	PCMD	18	/* last command		   */
#define	INI2	19	/* secondary init flag     */
#define	CMDS	20	/* command string          */
#define	CSTR	21	/* start cmd		   */
#define	CSTP	22	/* stop cmd		   */
#define	STRS	23	/* special start cmd	   */
#define	STPS	24	/* special stop cmd	   */
#define	LATM	25	/* last alarm time         */
#define	VAL	26	/* status                  */
#define	SVRT	27	/* saved run time	   */
#define	ACRT	28	/* accumulated run time	   */
#define	LPRT	29	/* last posted ACRT	   */
#define	LSVL	30	/* last stop value	   */

#define	NUMPUMPFLDS	(LSVL + 1)
