
/* pidRecord.h */
#ifndef INCpidRecordh
#define INCpidRecordh
#ifndef	INCLlstLibh
#include <lstLib.h>	/* list structure definition for the monitor list */
#endif
#ifndef	INCLsemLibh
#include <semLib.h>	/* semaphore structure definition for the monitor lock*/
#endif
#ifndef INCLfast_lockh
#include <fast_lock.h>	/* fast lock data structures and macros */
#endif
#ifndef INCLlinkh
#include <link.h>	/* fast lock data structures and macros */
#endif
#ifndef INC_tsDefs_h
#include <tsDefs.h>	/* time-stamp related definitions */
#endif
struct pidRecord	{
	char		name[28];		/*  */
	char		desc[41];		/*  */
	char alignPad1;		/*  */
	unsigned short	scan;		/*  */
	short		phas;		/*  */
	short		evnt;		/*  */
	unsigned short	dtyp;		/*  */
	unsigned short	tenb;		/*  */
	struct dset	*dset;		/*  */
	LIST		mlis;		/*  */
	FAST_LOCK	mlok;		/*  */
	struct link	sdis;		/*  */
	struct link	adis;		/*  */
	short		disv;		/*  */
	short		disa;		/*  */
	unsigned char	pact;		/*  */
	unsigned char	udf;		/*  */
	short		lset;		/*  */
	short		lcnt;		/*  */
	short		proc;		/*  */
	short		init;		/*  */
	unsigned short	stat;		/*  */
	unsigned short	sevr;		/*  */
	unsigned short	nsta;		/*  */
	unsigned short	nsev;		/*  */
	short		tagd;		/*  */
	TS_STAMP	latm;		/*  */
	TS_STAMP      lptm;		/*  */
	unsigned short	ack;		/*  */
	unsigned short	oscn;		/*  */
	unsigned short	aenb;		/*  */
	char		resn[16];		/*  */
	char		algp[16];		/*  */
	short		rdur;		/*  */
	void          *radr;		/*  */
	short		rduf;		/*  */
	short		rcrc;		/*  */
	struct scanLock *lsad;		/*  */
	struct dbCommon *lsnr;		/*  */
	short		ini2;		/*  */
	unsigned short	msev;		/*  */
	unsigned short	psta;		/*  */
	unsigned short	psev;		/*  */
	short		hhll;		/*  */
	short		hilo;		/*  */
	short		aldl;		/*  */
	short		rtct;		/*  */
	unsigned long	larf;		/*  */
	short		dvct;		/*  */
	unsigned short	itag;		/*  */
	long		tstp;		/*  */
	short		ralm;		/*  */
	char alignPad3[2];		/*  */
	/* start of pid specific fields */ 
	float		istp;		/*  */
	float		astp;		/*  */
	struct link	mvl;		/*  */
	struct link	stpl;		/*  */
	struct link	dscs;		/*  */
	struct link	rout;		/*  */
	struct link	flnk;		/*  */
	char		egu[16];		/*  */
	float		eguf;		/*  */
	double		val;		/*  */
	float		egul;		/*  */
	float		sthc;		/*  */
	float		stlc;		/*  */
	float		outh;		/*  */
	float		outl;		/*  */
	float		kp;		/*  */
	float		ki;		/*  */
	float		kd;		/*  */
	float		hval;		/*  */
	float		hopr;		/*  */
	float		lopr;		/*  */
	float		devl;		/*  */
	float		hyst;		/*  */
	float		adel;		/*  */
	float		mdel;		/*  */
	float		cdel;		/*  */
	float		mval;		/*  */
	float		nmv;		/*  */
	float		csp;		/*  */
	float		nsp;		/*  */
	float		p;		/*  */
	float		i;		/*  */
	float		d;		/*  */
	unsigned long	ct;		/*  */
	float		err;		/*  */
	float		lerr;		/*  */
	float		ersq;		/*  */
	float		lesq;		/*  */
	float		derr;		/*  */
	float		lder;		/*  */
	float		dval;		/*  */
	float		ldvl;		/*  */
	float		pval;		/*  */
	float		lalm;		/*  */
	float		alst;		/*  */
	float		mlst;		/*  */
	float		span;		/*  */
	float		zero;		/*  */
	short		prec;		/*  */
	short		lmde;		/*  */
	short		csm1;		/*  */
	short		csm2;		/*  */
	short		csmd;		/*  */
	unsigned short	uscs;		/*  */
	unsigned short	am;		/*  */
	unsigned short	rini;		/*  */
	unsigned short	cpct;		/*  */
	unsigned short	velo;		/*  */
	unsigned short	ract;		/*  */
	unsigned short	esqr;		/*  */
	unsigned short	dmod;		/*  */
	unsigned short	optr;		/*  */
	unsigned short	aclo;		/*  */
	unsigned short	hold;		/*  */
	unsigned short	dvsv;		/*  */
	unsigned short	nssv;		/*  */
	unsigned short	ncsv;		/*  */
	unsigned short	nosv;		/*  */
	unsigned short	nccs;		/*  */
	unsigned short	tmsv;		/*  */
	unsigned short	chsv;		/*  */
	unsigned short	clsv;		/*  */
	unsigned short	mode;		/*  */
	unsigned short	iact;		/*  */
	float		srmp;		/*  */
	float		spt;		/*  */
	float		sptg;		/*  */
	unsigned short	sptc;		/*  */
	short		fgcr;		/*  */
	unsigned short	sndf;		/*  */
	short		gact;		/*  */
	float		ngap;		/*  */
	unsigned short	ustp;		/*  */
	short		fpps;		/*  */
	float		lmas;		/*  */
	float		laas;		/*  */
	float		lmmv;		/*  */
	float		lamv;		/*  */
	short		hloc;		/*  */
	short		hlsc;		/*  */
	float		sstp;		/*  */
};
#endif

