
/* pipeRecord.h */
#ifndef INCpipeRecordh
#define INCpipeRecordh
#ifndef	INCLlstLibh
#include <lstLib.h>	/* list structure definition for the monitor list */
#endif
#ifndef	INCLsemLibh
#include <semLib.h>	/* semaphore structure definition for the monitor lock*/
#endif
#ifndef INCLfast_lockh
#include <fast_lock.h>	/* fast lock data structures and macros */
#endif
#ifndef INCLlinkh
#include <link.h>	/* fast lock data structures and macros */
#endif
#ifndef INC_tsDefs_h
#include <tsDefs.h>	/* time-stamp related definitions */
#endif
struct pipeRecord	{
	char		name[28];		/*  */
	char		desc[41];		/*  */
	char alignPad1;		/*  */
	unsigned short	scan;		/*  */
	short		phas;		/*  */
	short		evnt;		/*  */
	unsigned short	dtyp;		/*  */
	unsigned short	tenb;		/*  */
	struct dset	*dset;		/*  */
	LIST		mlis;		/*  */
	FAST_LOCK	mlok;		/*  */
	struct link	sdis;		/*  */
	struct link	adis;		/*  */
	short		disv;		/*  */
	short		disa;		/*  */
	unsigned char	pact;		/*  */
	unsigned char	udf;		/*  */
	short		lset;		/*  */
	short		lcnt;		/*  */
	short		proc;		/*  */
	short		init;		/*  */
	unsigned short	stat;		/*  */
	unsigned short	sevr;		/*  */
	unsigned short	nsta;		/*  */
	unsigned short	nsev;		/*  */
	short		tagd;		/*  */
	TS_STAMP	latm;		/*  */
	TS_STAMP      lptm;		/*  */
	unsigned short	ack;		/*  */
	unsigned short	oscn;		/*  */
	unsigned short	aenb;		/*  */
	char		resn[16];		/*  */
	char		algp[16];		/*  */
	short		rdur;		/*  */
	void          *radr;		/*  */
	short		rduf;		/*  */
	short		rcrc;		/*  */
	struct scanLock *lsad;		/*  */
	struct dbCommon *lsnr;		/*  */
	short		ini2;		/*  */
	unsigned short	msev;		/*  */
	unsigned short	psta;		/*  */
	unsigned short	psev;		/*  */
	short		hhll;		/*  */
	short		hilo;		/*  */
	short		aldl;		/*  */
	short		rtct;		/*  */
	unsigned long	larf;		/*  */
	short		dvct;		/*  */
	unsigned short	itag;		/*  */
	long		tstp;		/*  */
	short		ralm;		/*  */
	char alignPad3[2];		/*  */
	/* start of pipe specific fields */ 
	double		val;		/*  */
	double		tset;		/*  */
	char		prod[18];		/*  */
	char		sttn[18];		/*  */
	caddr_t         pstr;		/*  */
	long		snum;		/*  */
	long		anum;		/*  */
	double		sgrv;		/*  */
	caddr_t         papi;		/*  */
	char		apit[18];		/*  */
	unsigned short	volu;		/*  */
	unsigned short	tmpu;		/*  */
	short		prec;		/*  */
	struct link	prpv;		/*  */
	struct link	tepv;		/*  */
	struct link	flnk;		/*  */
	double		vold;		/*  */
	double		hyst;		/*  */
	unsigned short	alsv;		/*  */
	unsigned short	iems;		/*  */
	char		psts[18];		/*  */
	char		runs[18];		/*  */
	char		stps[18];		/*  */
	short		pisv;		/*  */
	char		cmds[18];		/*  */
	char		runc[18];		/*  */
	char		stpc[18];		/*  */
	short		crun;		/*  */
	short		cstp;		/*  */
	short		srun;		/*  */
	short		sstp;		/*  */
	short		esou;		/*  */
	unsigned long	tcks;		/*  */
	double		ttim;		/*  */
	double		cpre;		/*  */
	double		ctem;		/*  */
	double		texp;		/*  */
	double		ullg;		/*  */
	double		qvol;		/*  */
	double		gcap;		/*  */
	double		netv;		/*  */
	double		adel;		/*  */
	double		mdel;		/*  */
	double		lalm;		/*  */
	double		alst;		/*  */
	double		mlst;		/*  */
	char		pcmd[18];		/*  */
	short		fpps;		/*  */
	unsigned short	mode;		/*  */
	short		tval;		/*  */
};
#endif

