
/* tankRecord.h */
#ifndef INCtankRecordh
#define INCtankRecordh
#ifndef	INCLlstLibh
#include <lstLib.h>	/* list structure definition for the monitor list */
#endif
#ifndef	INCLsemLibh
#include <semLib.h>	/* semaphore structure definition for the monitor lock*/
#endif
#ifndef INCLfast_lockh
#include <fast_lock.h>	/* fast lock data structures and macros */
#endif
#ifndef INCLlinkh
#include <link.h>	/* fast lock data structures and macros */
#endif
#ifndef INC_tsDefs_h
#include <tsDefs.h>	/* time-stamp related definitions */
#endif
struct tankRecord	{
	char		name[28];		/*  */
	char		desc[41];		/*  */
	char alignPad1;		/*  */
	unsigned short	scan;		/*  */
	short		phas;		/*  */
	short		evnt;		/*  */
	unsigned short	dtyp;		/*  */
	unsigned short	tenb;		/*  */
	struct dset	*dset;		/*  */
	LIST		mlis;		/*  */
	FAST_LOCK	mlok;		/*  */
	struct link	sdis;		/*  */
	struct link	adis;		/*  */
	short		disv;		/*  */
	short		disa;		/*  */
	unsigned char	pact;		/*  */
	unsigned char	udf;		/*  */
	short		lset;		/*  */
	short		lcnt;		/*  */
	short		proc;		/*  */
	short		init;		/*  */
	unsigned short	stat;		/*  */
	unsigned short	sevr;		/*  */
	unsigned short	nsta;		/*  */
	unsigned short	nsev;		/*  */
	short		tagd;		/*  */
	TS_STAMP	latm;		/*  */
	TS_STAMP      lptm;		/*  */
	unsigned short	ack;		/*  */
	unsigned short	oscn;		/*  */
	unsigned short	aenb;		/*  */
	char		resn[16];		/*  */
	char		algp[16];		/*  */
	short		rdur;		/*  */
	void          *radr;		/*  */
	short		rduf;		/*  */
	short		rcrc;		/*  */
	struct scanLock *lsad;		/*  */
	struct dbCommon *lsnr;		/*  */
	short		ini2;		/*  */
	unsigned short	msev;		/*  */
	unsigned short	psta;		/*  */
	unsigned short	psev;		/*  */
	short		hhll;		/*  */
	short		hilo;		/*  */
	short		aldl;		/*  */
	short		rtct;		/*  */
	unsigned long	larf;		/*  */
	short		dvct;		/*  */
	unsigned short	itag;		/*  */
	long		tstp;		/*  */
	short		ralm;		/*  */
	char alignPad3[2];		/*  */
	/* start of tank specific fields */ 
	double		val;		/*  */
	double		htln;		/*  */
	double		diam;		/*  */
	double		elev;		/*  */
	double		htrp;		/*  */
	double		ltrp;		/*  */
	char		prod[18];		/*  */
	unsigned short	shap;		/*  */
	char           pad1[2];		/*  */
	unsigned short	rtyp;		/*  */
	double		rwgt;		/*  */
	double		rllv;		/*  */
	double		rflv;		/*  */
	struct link	levp;		/*  */
	struct link	denp;		/*  */
	struct link	bswp;		/*  */
	struct link	tmpp;		/*  */
	struct link	volp;		/*  */
	struct link	masp;		/*  */
	struct link	hlpv;		/*  */
	struct link	llpv;		/*  */
	struct link	htpv;		/*  */
	struct link	ltpv;		/*  */
	double		plva;		/*  */
	double		blva;		/*  */
	unsigned short	pmea;		/*  */
	unsigned short	bmea;		/*  */
	unsigned short	levu;		/*  */
	unsigned short	denu;		/*  */
	unsigned short	masu;		/*  */
	unsigned short	tmpu;		/*  */
	unsigned short	volu;		/*  */
	unsigned short	flru;		/*  */
	struct link	t01v;		/*  */
	struct link	t02v;		/*  */
	struct link	t03v;		/*  */
	struct link	t04v;		/*  */
	struct link	t05v;		/*  */
	struct link	t06v;		/*  */
	struct link	t07v;		/*  */
	struct link	t08v;		/*  */
	struct link	t09v;		/*  */
	struct link	t10v;		/*  */
	double		t01l;		/*  */
	double		t02l;		/*  */
	double		t03l;		/*  */
	double		t04l;		/*  */
	double		t05l;		/*  */
	double		t06l;		/*  */
	double		t07l;		/*  */
	double		t08l;		/*  */
	double		t09l;		/*  */
	double		t10l;		/*  */
	char		v01p[30];		/*  */
	char		v02p[30];		/*  */
	char		v03p[30];		/*  */
	char		v04p[30];		/*  */
	char		v05p[30];		/*  */
	char		v06p[30];		/*  */
	char		v07p[30];		/*  */
	char		v08p[30];		/*  */
	char		v09p[30];		/*  */
	char		v10p[30];		/*  */
	struct dbAddr   pv1_dbAddr;		/*  */
	struct dbAddr   pv2_dbAddr;		/*  */
	struct dbAddr   pv3_dbAddr;		/*  */
	struct dbAddr   pv4_dbAddr;		/*  */
	struct dbAddr   pv5_dbAddr;		/*  */
	struct dbAddr   pv6_dbAddr;		/*  */
	struct dbAddr   pv7_dbAddr;		/*  */
	struct dbAddr   pv8_dbAddr;		/*  */
	struct dbAddr   pv9_dbAddr;		/*  */
	struct dbAddr   pv10_dbAddr;		/*  */
	unsigned short	v01s;		/*  */
	unsigned short	v02s;		/*  */
	unsigned short	v03s;		/*  */
	unsigned short	v04s;		/*  */
	unsigned short	v05s;		/*  */
	unsigned short	v06s;		/*  */
	unsigned short	v07s;		/*  */
	unsigned short	v08s;		/*  */
	unsigned short	v09s;		/*  */
	unsigned short	v10s;		/*  */
	unsigned short	v01i;		/*  */
	unsigned short	v02i;		/*  */
	unsigned short	v03i;		/*  */
	unsigned short	v04i;		/*  */
	unsigned short	v05i;		/*  */
	unsigned short	v06i;		/*  */
	unsigned short	v07i;		/*  */
	unsigned short	v08i;		/*  */
	unsigned short	v09i;		/*  */
	unsigned short	v10i;		/*  */
	unsigned short	v01r;		/*  */
	unsigned short	v02r;		/*  */
	unsigned short	v03r;		/*  */
	unsigned short	v04r;		/*  */
	unsigned short	v05r;		/*  */
	unsigned short	v06r;		/*  */
	unsigned short	v07r;		/*  */
	unsigned short	v08r;		/*  */
	unsigned short	v09r;		/*  */
	unsigned short	v10r;		/*  */
	unsigned short	v01n;		/*  */
	unsigned short	v02n;		/*  */
	unsigned short	v03n;		/*  */
	unsigned short	v04n;		/*  */
	unsigned short	v05n;		/*  */
	unsigned short	v06n;		/*  */
	unsigned short	v07n;		/*  */
	unsigned short	v08n;		/*  */
	unsigned short	v09n;		/*  */
	unsigned short	v10n;		/*  */
	unsigned short	v01m;		/*  */
	unsigned short	v02m;		/*  */
	unsigned short	v03m;		/*  */
	unsigned short	v04m;		/*  */
	unsigned short	v05m;		/*  */
	unsigned short	v06m;		/*  */
	unsigned short	v07m;		/*  */
	unsigned short	v08m;		/*  */
	unsigned short	v09m;		/*  */
	unsigned short	v10m;		/*  */
	double		stto;		/*  */
	double		isto;		/*  */
	double		reto;		/*  */
	double		ruto;		/*  */
	unsigned short	evss;		/*  */
	unsigned short	eves;		/*  */
	caddr_t        papi;		/*  */
	double		sgrv;		/*  */
	char		apit[18];		/*  */
	char		apid[10];		/*  */
	long		anum;		/*  */
	char		sttn[18];		/*  */
	char           pad2[2];		/*  */
	long		snum;		/*  */
	caddr_t        pstr;		/*  */
	unsigned short	alsv;		/*  */
	unsigned short	iems;		/*  */
	double		vold;		/*  */
	double		lllv;		/*  */
	unsigned short	llle;		/*  */
	unsigned short	lllx;		/*  */
	unsigned short	lole;		/*  */
	unsigned short	lolx;		/*  */
	double		lolv;		/*  */
	unsigned short	llse;		/*  */
	unsigned short	llsx;		/*  */
	unsigned short	hhle;		/*  */
	unsigned short	hhlx;		/*  */
	double		hhlv;		/*  */
	double		hilv;		/*  */
	unsigned short	hile;		/*  */
	unsigned short	hilx;		/*  */
	unsigned short	hlse;		/*  */
	unsigned short	hlsx;		/*  */
	double		lltv;		/*  */
	unsigned short	llte;		/*  */
	unsigned short	lltx;		/*  */
	unsigned short	lote;		/*  */
	unsigned short	lotx;		/*  */
	double		lotv;		/*  */
	double		hhtv;		/*  */
	unsigned short	hhte;		/*  */
	unsigned short	hhtx;		/*  */
	unsigned short	hite;		/*  */
	unsigned short	hitx;		/*  */
	double		hitv;		/*  */
	unsigned short	lope;		/*  */
	unsigned short	lopx;		/*  */
	unsigned short	hipe;		/*  */
	unsigned short	hipx;		/*  */
	double		hibv;		/*  */
	unsigned short	hibe;		/*  */
	unsigned short	hibx;		/*  */
	short		esin;		/*  */
	short		esou;		/*  */
	double		lhst;		/*  */
	double		hyst;		/*  */
	double		thst;		/*  */
	double		bhst;		/*  */
	double		tset;		/*  */
	char		tsts[18];		/*  */
	char		isss[18];		/*  */
	char		recs[18];		/*  */
	char		runs[18];		/*  */
	char		stps[18];		/*  */
	char		rsts[18];		/*  */
	char		rlls[18];		/*  */
	char		rfls[18];		/*  */
	char		rcrs[18];		/*  */
	char		rnis[18];		/*  */
	char		cmds[18];		/*  */
	char		issc[18];		/*  */
	char		recc[18];		/*  */
	char		runc[18];		/*  */
	char		stpc[18];		/*  */
	short		ciss;		/*  */
	short		crec;		/*  */
	short		crun;		/*  */
	short		cstp;		/*  */
	short		siss;		/*  */
	short		srec;		/*  */
	short		srun;		/*  */
	short		sstp;		/*  */
	short		prec;		/*  */
	double		plev;		/*  */
	double		bswl;		/*  */
	double		bswv;		/*  */
	double		pbsw;		/*  */
	double		gcap;		/*  */
	double		gvol;		/*  */
	double		netv;		/*  */
	double		avap;		/*  */
	double		ullg;		/*  */
	double		qvol;		/*  */
	double		wcap;		/*  */
	double		gmas;		/*  */
	double		nmas;		/*  */
	double		dnct;		/*  */
	double		dncr;		/*  */
	double		frat;		/*  */
	double		texp;		/*  */
	double		tpav;		/*  */
	double		ttim;		/*  */
	double		vtim;		/*  */
	double		lalm;		/*  */
	double		alst;		/*  */
	double		mlst;		/*  */
	double		llal;		/*  */
	double		ltal;		/*  */
	double		lbal;		/*  */
	double		adel;		/*  */
	double		mdel;		/*  */
	double		lvhh;		/*  */
	double		lvhi;		/*  */
	double		lvlo;		/*  */
	double		lvll;		/*  */
	unsigned short	mode;		/*  */
	unsigned short	mlos;		/*  */
	unsigned long	tcks;		/*  */
	short		tasv;		/*  */
	short		tval;		/*  */
	unsigned short	lavl;		/*  */
	char		pcmd[18];		/*  */
	struct link	flnk;		/*  */
	short		fpps;		/*  */
};
#endif

