/**********
*
*	File:	selredfldidx.h
*	Author:	Gordon M. Uchenick
*	Date:	27-MAY-1993
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the analog input record.
*
*	NOTE: The order of the fields in this list must match the order of
*		the list in recSel.c.
*
*	Modification Log
*       ----------------
*  .01	03-21-94	ems	deleted INIT
*  .02	05-06-94	ems	added INI2, chg NUMFLDS to NUMSELFLDS
*  .03	10-13-94	ems	added TIME
*  .04	10-20-94	ems	chg TIME to LATM (last alarm time)
*  .05	01-13-95	ems	added MLST
*  .05	04-03-96	ems	added HHLL,HILO,RTCT,LARF,DVCT
**********/

#define		STAT	0	/* current alarm status		*/
#define		SEVR	1	/* current alarm severity	*/
#define		VAL	2	/* current value		*/
#define		ROCI	3	/* rate of change index		*/
#define		ROCC	4	/* rat eof change number	*/
#define		LALM	5	/* last VAL alarmed		*/
#define		INI2	6	/* secondary init flag		*/
#define		LATM	7	/* last VAL alarm time		*/
#define		MLST	8	/* last VAL monitored		*/
#define		HHLL	9	/* hihi/lolo alarm counter	*/
#define		HILO	10	/* high/low alarm counter	*/
#define		RTCT	11	/* return to normal counter	*/
#define		LARF	12	/* last alarm flag		*/
#define		DVCT	13	/* deviation alarm counter	*/

#define		NUMSELFLDS	(DVCT + 1)
