/*tagvu.h,v 1.1.1.1 1999/08/03 14:41:31 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 * data structure sizes
 */
#ifndef	INCtagvuH
#define	INCtagvuH

#include "cadef.h"
#include "dbDefs.h"

#define	DATE_SIZE			8
/* GCT 14-May-1998 format size for 4 digit year (output to screen only) */
#define EXT_DATE_SIZE		DATE_SIZE+2
#define	TIME_SIZE			8
#define	REASON_SIZE			100
#define	ITAG_SIZE			4

/*
 * miscellaneous
 */
#define	LINES_PER_TAG		3
#define	TAG_BLOCK_SIZE		1000
#define	MAX_ARGS		20
#define CA_PEND_EVENT_TIME	0.001	
#define CA_IO_TIMEOUT		5.
#define	ADD_TAG			1
#define	REMOVE_TAG		2
#define	TIMEOUT_VALUE		3
#define FILTER_STRING_SZ	200
#define LINE_SIZE		200
#define TAGVU_TIMER_INTERVAL	10

enum {LINE_0_INDEX=0,LINE_1_INDEX,LINE_2_INDEX};

typedef enum
{
	TAGVU_ERROR_SUCCESS=0,
	TAGVU_ERROR_TAGDESC,
	TAGVU_ERROR_PVMAP,
	TAGVU_ERROR_TAGINDEX,
	TAGVU_ERROR_OPTRAK,
	TAGVU_ERROR_CA,
	TAGVU_ERROR_SVC
} TAGVU_ERROR_CODES;

typedef enum
{
	FILTER_SHOW_ALL=0,
	FILTER_SHOW_TAGGED,
	FILTER_SHOW_UNTAGGED
}TAGVU_FILTER_STATES;

/*
 * Defines for the type of tag
 */
#define	OUT_SERVICE_TAG		"Out of Service Tag"
#define	INFO_TAG		" Informational Tag"

typedef struct
{
	char		pointName[PVNAME_SZ+1];
	char		location[LOCATION_SZ+1];
	char		descriptor[DESCRIPTOR_SZ+1];
	char		dateApplied[DATE_SIZE+1];
	char		timeApplied[TIME_SIZE+1];
	char		operatorApplied[OPERATOR_SZ+1];
	char		reasonApplied[REASON_SIZE+1];
	char		dateRemoved[DATE_SIZE+1];
	char		timeRemoved[TIME_SIZE+1];
	char		operatorRemoved[OPERATOR_SZ+1];
	char		reasonRemoved[REASON_SIZE+1];
	char		tagType;	/* O = out of service tag,I = informational tag */
	int		isDeleted;	/* 1 = deleted */
	int		recNumber;
} PntTagRecord;

typedef struct
{
	unsigned int 	type;
	long		recordNum;
	int		tagIndex;
	char *		*timeoutId;
	int		timeout;
	char		pointName[PVNAME_SZ+1];
	char		location[LOCATION_SZ+1];
	char		descriptor[DESCRIPTOR_SZ+1];
	char		reason[REASON_SIZE+1];
	chid		chId;
	void		*thisPointer;	/* this will be cast to appropriate "this" */
	short 		tagValue;
	char		tagType;	/* O = out of service tag, I = informational tag */
} TagValueData;

/*
	Search key information structure. Not a class because
	it is just a place to hold data
*/
typedef struct
{
	char	pointName[PVNAME_SZ+1];
	char	location[LOCATION_SZ+1];
	char	dateApplied[EXT_DATE_SIZE+1];
	char	operatorApplied[OPERATOR_SZ+1];
	int	tagState;
	int	dateDirection; /* 0 = < 1 = > */
} FILTER_DATA,*FILTER_DATA_PTR;

#endif	INCtagvuH
