/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	This include file contains the message definitions for the Client/Server
	implementation of the tagVu utility.

	24-Aug-1998
	G. Tomalesky
*/
enum
	{
	ADDTAG_MSG_ID=1,
	REMOVETAG_MSG_ID,
	FIRSTRECORD_MSG_ID,
	NEXTRECORD_MSG_ID,
	ADDACK_MSG_ID,
	REMACK_MSG_ID,
	ADDNACK_MSG_ID,
	UPDATELIST_MSG_ID
	};
typedef struct
{
	short msgType;
} TAGVU_MSG_HEADER;

typedef struct
{
	short msgType;
	char pointName[PVNAME_SZ+1];
	char reason[REASON_SIZE+1];
	char operatorApplied[OPERATOR_SZ+1];
	char tagType;		/* O = out of service tag,1 = informational */
} TAGVU_MSG_ADDTAG;					// client -> server
typedef struct
{
	short msgType;
} TAGVU_MSG_ADDACK;					// server -> client used for NACK too
typedef struct
{
	short msgType;
	int recordNum;
	char reason[REASON_SIZE+1];
	char operatorApplied[OPERATOR_SZ+1];
} TAGVU_MSG_REMOVETAG;				// client -> server
typedef struct
{
	short msgType;
} TAGVU_MSG_REMACK;					// server -> client
typedef struct
{
	short msgType;
} TAGVU_MSG_UPDATELIST;				// server -> client
typedef struct
{
	short msgType;
	FILTER_DATA newTagFilter;			// filter struct for this request
} TAGVU_MSG_RECORD_REQ;				// client -> server
typedef struct
{
	short msgType;
	PntTagRecord newTagRecord;			// record response info
} TAGVU_MSG_RECORD_RESP;			// server -> client
/* unions of msgs */
typedef union
{
	TAGVU_MSG_HEADER msgHeader;
	TAGVU_MSG_ADDTAG addTag;
	TAGVU_MSG_REMOVETAG removeTag;
	TAGVU_MSG_RECORD_REQ recRequest;
} REQ_MSG_UNION;

typedef union
{
	TAGVU_MSG_HEADER msgHeader;
	TAGVU_MSG_RECORD_RESP recResponse;
	TAGVU_MSG_ADDACK addAck;
	TAGVU_MSG_REMACK remAck;
	TAGVU_MSG_UPDATELIST updateList;
} RESP_MSG_UNION;

