/****************************************************************/
/*								*/
/*		TIME SYNCHRONIZATION MESSAGE FORMAT		*/
/*								*/
/*	This file defines the structure of the time synch	*/
/*	message that is transmitted from the current network	*/
/*	time master to all other nodes. The message contains	*/
/*	an Epics time stamp and also the current number of	*/
/*	minutes west of UCT. This number will change as the	*/
/*	time master slips into and out of daylight savings	*/
/*	time. The purpose of dynamically adjusting the time	*/
/*	zone is to make all of the time and date stamping	*/
/*	routines in the IOC conform to whatever is happening	*/
/*	in the workstation.					*/
/*								*/
/****************************************************************/

struct tisTimeSync
	{
	TS_STAMP	time;
	int		minWest;
	};
