/* ************************************************************** */
/* *							      	* */
/* *	FILE:	tpro.h						* */
/* *	Rev:	1.0						* */
/* *	Author:	Philip M. Mills 				* */
/* *	Date:   July 1, 1992					* */
/* *	OS:	SunOS Version 4.1				* */
/* *								* */
/* *	Copyright (c) 1990,91,92 Odetics, Inc.			* */
/* *	This is proprietary to Odetics, inc.			* */
/* *	Modification history:					* */
/* *								* */
/* *								* */
/* ************************************************************** */

/* ************************************************************** */
/* * 								* */
/* *	Description:						* */
/* *								* */
/* *		Header file for tpro/tsat-s device driver.	* */
/* *	Defines board registers and masks for use by tpro.c	* */
/* *								* */
/* ************************************************************** */

#define u_short unsigned short 
#define u_byte unsigned char
#define u_char unsigned char
#define TPRO_UNIT(dev) minor(dev)
/* Pointer to the parallel time registers.....	*/
struct		tproreg {
	u_long		tprolow;
	u_long		tprohigh;
	u_byte		tprocom;
	u_byte		tproevt;
	u_byte		tprofifo;
	u_byte		tprostat;
	u_byte		tprores;
	u_byte		tpromode;	
	u_long		ksires1;
	u_long		ksires2;
	u_long		ksires3;
	u_long		ksires4;
			};


/* now for the current time structure.  Once again we will define */
/* u_shorts for byte quantities since we are accessing the board  */
/* on a 16 bit basis.						*/

struct 		currtime {
	u_short		hundays;	/* hundreds of days	*/
	u_short		tendays;	/* tens of days		*/
	u_short		days;		/* units of days.	*/
	u_short		tenhours;	/* tens of hours	*/
	u_short		hours;		/* units of hours	*/
	u_short		tenminutes;	/* tens of minutes	*/
	u_short		minutes;	/* units of minutes	*/
	u_short		tenseconds;	/* tens of seconds	*/
	u_short		seconds;	/* units of seconds	*/
	u_short		hunmilsecs;	/* hundreds of mils	*/
	u_short		tenmilsecs;	/* tens of milsecs 	*/
	u_short		milsecs;	/* units of milsecs	*/
	u_short		hunmicsecs;	/* hundreds of mics	*/
	u_short		tenmicsecs;	/* tens of mics		*/
	u_short		micsecs;	/* units of mics	*/
	long		tv_sec;		/* units of seconds	*/
	long		tv_usec;	/* microseconds		*/
	u_short		status;		/* copy of status reg.	*/
			};



/* status register masks */
#define	TIMEAVAIL 	0x0001
#define NOSIGNAL	0x0002
#define NOSYNC		0x0004




/* * End of tpro.h * */
