/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/**********
*
*	File:	udbredfldidx.h
*	Author:	Ed Steel
*	Date:	23 Jan 95
*
*	This file contains the field descriptor indices used by the
*	redundant update memory que routines for the user defined block
*	udb
*
*	NOTE: The order of the fields in this list must match the order of
*		the list in recUdb.c.
*		The total can not be greater than REDQ_MAX_MSG defined in
*		.../share/epicsH/redque.h
*	      The current buffer size required is:
*			20	header
*		       420	for field size
*		       456	ptr to each field
*                     ----
*		       896
*
*	Modification Log
*       ----------------
*  .01	01-11-96	ems	added ZCMF
*  .02	01-15-95	ems	added FPAS
*  .03	04-12-96	ems	added HHLL, RTCT
*/


#define		STAT	0 		/*2 current alarm status */
#define		SEVR	1		/*2 current alarm severity */
#define		INI2	2		/*2 secondary init	*/
#define		VAL	3		/*2 current value	*/
#define		LVAL	4		/*2 last value		*/
#define		MLST	5		/*2 last value monitored */
#define		MODE	6		/*2 current mode	*/
#define		LCMD	7		/*2 last command	*/
#define		FUNC	8		/*2 new function	*/
#define		NCMD	9		/*2 new command		*/
#define		STTS	10		/*2 current status	*/
#define		CK1	11		/*2 check box		*/
#define		CK2	12		/*2 check box		*/
#define		CK3	13		/*2 check box		*/
#define		CK4	14		/*2 check box		*/
#define		CK5	15		/*2 check box		*/
#define		CK6	16		/*2 check box		*/
#define		CK7	17		/*2 check box		*/
#define		CK8	18		/*2 check box		*/
#define		N01	19		/*4 numeric float	*/
#define		N02	20		/*4 numeric float	*/
#define		N03	21		/*4 numeric float	*/
#define		N04	22		/*4 numeric float	*/
#define		N05	23		/*4 numeric float	*/
#define		N06	24		/*4 numeric float	*/
#define		N07	25		/*4 numeric float	*/
#define		N08	26		/*4 numeric float	*/
#define		N09	27		/*4 numeric float	*/
#define		N10	28		/*4 numeric float	*/
#define		N11	29		/*4 numeric float	*/
#define		N12	30		/*4 numeric float	*/
#define		D01	31		/*8 numeric double	*/
#define		D02	32		/*8 numeric double	*/
#define		D03	33		/*8 numeric double	*/
#define		D04	34		/*8 numeric double	*/
#define		D05	35		/*8 numeric double	*/
#define		D06	36		/*8 numeric double	*/
#define		U01	37		/*4 numeric ulong	*/
#define		U02	38		/*4 numeric ulong	*/
#define		MSGF	39		/*32 message field	*/
#define		LALM	40		/*2 last value alarmed	*/
#define		CTCK	41		/*4 clock ticks		*/
#define		TM01	42		/*4 timer		*/
#define		TM02	43		/*4 timer		*/
#define		TM03	44		/*4 timer		*/
#define		TM04	45		/*4 timer		*/
#define		TM05	46		/*4 timer		*/
#define		TM06	47		/*4 timer		*/
#define		TM07	48		/*4 timer		*/
#define		TM08	49		/*4 timer		*/
#define		TM09	50		/*4 timer		*/
#define		TM10	51		/*4 timer		*/
#define		TM11	52		/*4 timer		*/
#define		TM12	53		/*4 timer		*/
#define		TF01	54		/*2 timer flag		*/
#define		TF02	55		/*2 timer flag		*/
#define		TF03	56		/*2 timer flag		*/
#define		TF04	57		/*2 timer flag		*/
#define		TF05	58		/*2 timer flag		*/
#define		TF06	59		/*2 timer flag		*/
#define		TF07	60		/*2 timer flag		*/
#define		TF08	61		/*2 timer flag		*/
#define		TF09	62		/*2 timer flag		*/
#define		TF10	63		/*2 timer flag		*/
#define		TF11	64		/*2 timer flag		*/
#define		TF12	65		/*2 timer flag		*/
#define		FP01	66		/*4 temp float		*/
#define		FP02	67		/*4 temp float		*/
#define		FP03	68		/*4 temp float		*/
#define		FP04	69		/*4 temp float		*/
#define		FP05	70		/*4 temp float		*/
#define		FP06	71		/*4 temp float		*/
#define		FP07	72		/*4 temp float		*/
#define		FP08	73		/*4 temp float		*/
#define		FP09	74		/*4 temp float		*/
#define		FP10	75		/*4 temp float		*/
#define		FP11	76		/*4 temp float		*/
#define		FP12	77		/*4 temp float		*/
#define		FP13	78		/*4 temp float		*/
#define		FP14	79		/*4 temp float		*/
#define		FP15	80		/*4 temp float		*/
#define		FP16	81		/*4 temp float		*/
#define		LU01	82		/*4 temp ulong		*/
#define		LU02	83		/*4 temp ulong		*/
#define		LU03	84		/*4 temp ulong		*/
#define		LU04	85		/*4 temp ulong		*/
#define		LU05	86		/*4 temp ulong		*/
#define		LU06	87		/*4 temp ulong		*/
#define		LU07	88		/*4 temp ulong		*/
#define		LU08	89		/*4 temp ulong		*/
#define		DB01	90		/*8 temp double		*/
#define		DB02	91		/*8 temp double		*/
#define		DB03	92		/*8 temp double		*/
#define		DB04	93		/*8 temp double		*/
#define		BL01	94		/*2 boolean flag	*/
#define		BL02	95		/*2 boolean flag	*/
#define		BL03	96		/*2 boolean flag	*/
#define		BL04	97		/*2 boolean flag	*/
#define		BL05	98		/*2 boolean flag	*/
#define		BL06	99		/*2 boolean flag	*/
#define		BL07	100		/*2 boolean flag	*/
#define		BL08	101		/*2 boolean flag	*/
#define		BL09	102		/*2 boolean flag	*/
#define		BL10	103		/*2 boolean flag	*/
#define		BL11	104		/*2 boolean flag	*/
#define		BL12	105		/*2 boolean flag	*/
#define		BL13	106		/*2 boolean flag	*/
#define		BL14	107		/*2 boolean flag	*/
#define		BL15	108		/*2 boolean flag	*/
#define		BL16	109		/*2 boolean flag	*/
#define		ZCMF	110		/*2 zero cmd flag	*/
#define		FPAS	111		/*2 1st pass flag	*/
#define		HHLL	112		/*2 STATE alarm counter	*/
#define		RTCT	113		/*2 rtn to normal cntr	*/

#define		NUMUDBFLDS	(RTCT + 1)

