/*drvBendix.c,v 1.1.1.1 1999/08/03 14:41:54 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
/*  File: drvBendix.c
/*  Edit: 4/25/93 12:33 JLD
	: 1/18/94: 	WEP: name change only
	: 3/30/94	ems:startlmpt, remove check ln >= 0, since
				       it is unsigned will always be true
			    startlmp, same
			    msgxfer, remove cast (char *) for logmsg
/*     :  05/05/94      WEP: moved while(TRUE) taskDelay logic to while(master) loop.
/*     :  06/15/94      WEP: modified register_resource to print pointname causing error.
/*     :  06/22/94      WEP: corrected performance and use of the cmd_force_offline flag.
/*     :  01/05/94      WEP: modified 'aidriver' to mask out MSBit of statistics counts.
/*
  
*/
/* #define TEST	1 */
#ifdef TEST
#include<bioscomm.h>
#include<dummyos.h>
#include <lmpbus.h>
#include<bdxproto.h>
#define logMsg		printf
#endif
#ifndef TEST
#include <ctype.h>
/*#include <malloc.h>*/
#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>
#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvBendix.h>
#include <drvBendix_proto.h>
#include <restable.h>
#include <tsDefs.h>
#endif

extern	TS_STAMP  time_stamp;

static long	init();

struct {
	long		number;
	DRVSUPFUN	report;
	DRVSUPFUN	init;
} drvBendix={
	2,
	NULL,
	init};


/*
/*      Storage for MODBUS PLC Structures
/*
*/

static LMPDEV		*plcs[LMPLINES] = {FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
					   FALSE,FALSE,FALSE,FALSE,FALSE,FALSE,
					   FALSE,FALSE,FALSE,FALSE,FALSE,FALSE};
static unsigned short	lmode[LMPLINES];
static unsigned short	ltrace[LMPLINES];
static unsigned char	resnames [LMPLINES][RESNAMELEN];
static RES_TABLE	*prestable[LMPLINES];
static unsigned short	resresponse[LMPLINES];
static unsigned short	line_activity[LMPLINES];
unsigned short		lmpdatalock[LMPLINES];
static unsigned short	drvtrace[LMPLINES];
static unsigned short	drvrestrace[LMPLINES];
static OUTPUTQUE	*oq[LMPLINES];		/* array of output queues and their control structures */
static SEM_ID		semids[LMPLINES][2];
static short		backup_mode[LMPLINES];
static short		channel_select[LMPLINES];
static short		linetimers[LMPLINES];
static short		bdxrxtimers[LMPLINES];
/*
/*      Storage for Bendix LMP Line Structures
/*
*/


static RXLINE          *rxlinetab[LMPLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL,} ; /* array of pointers to dynamically allocated comm controls/buffers */

static TXLINE          *txlinetab[LMPLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL,} ; /* array of pointers to dynamically allocated comm controls/buffers */

static char    *bools[] = {
	"TRUE ",
	"FALSE"
    };
static int		taskId [LMPLINES];

static char *tasknames[] = {"LMP Ch0","LMP Ch1","LMP Ch2","LMP Ch3","LMP Ch4","LMP Ch5","LMP Ch6","LMP Ch7","LMP Ch8","LMP Ch9","LMP Ch10","LMP Ch11",
"LMP Ch12","LMP Ch13","LMP Ch14","LMP Ch15","LMP Ch16","LMP Ch17"};

static	short	hpaids[2] = {6,7};
static unsigned char	aconv[] = {'0','1','2','3','4','5','6','7',
				   '8','9','A','B',0x0C,0x0D,0x0E,0x0F,
				   0x10,0x11,0x12,0x13,'K',0x15,0x16,0x17,
				   0x18,0x19,0x1A,0x1B,0x1C,0x1D,0x1E,'V',
				   'W',0x21,0x22,0x23,0x24,'-',' ','d',
				   'm',0x29,0x2A,0x2B,0x2C,0x2D,0x2E,0x2F };

/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init () {
	return (0);
}
/********
/*
/*	This routine enables logging of comm trace messages
/*
********/
void lmptraceon(unsigned short line)
    {
	drvtrace[line] = TRUE;
    }

/********
/*
/*	This routine disables logging of comm trace messages
/*
********/
void lmptraceoff(unsigned short line)
    {
	drvtrace[line] = FALSE;
    }

/********
/*
/*	This routine enables logging of resource trace messages
/*
********/
void lmprestraceon(unsigned short line)
    {
	drvrestrace[line] = TRUE;
    }

/********
/*
/*	This routine disables logging of resource trace messages
/*
********/
void lmprestraceoff(unsigned short line)
    {
	drvrestrace[line] = FALSE;
    }

/********
/*
/*	This routine controls logging of trace messages
/*
********/
void lmptrlv(unsigned short line, unsigned short level)
    {
	ltrace[line] = level;
    }


#ifndef TEST
int stoplmpdrv (short ln)
{
	if (comm_disconnect (ln) != -1) {
	    taskDelete (taskId [ln]);
	    return (1);
	} else {
	    return (-1);
	}
}
int startlmpt(unsigned short ln, char *mode, unsigned short devtype,
	     unsigned short private, unsigned short rxtimeoutv)
{

	if ( ln <= LMPLINES )
	{
	    taskId [ln] = taskSpawn(tasknames[ln],LMP_PRIORITY,LMP_TASK_OPTIONS,LMP_STACK,lmp_driver,ln, mode,
				    devtype, private, rxtimeoutv);

	    logMsg("Started the Bendix LMP driver on line %d\n",ln);

	    return (1);
	} else {

	    logMsg ("Invalid line number %d\n", ln);
	    return (-1);
	}
}

int startlmp(unsigned short ln, char *mode, unsigned short devtype,
	     unsigned short private)
{

	if ( ln <= LMPLINES )
	{
	    taskId [ln] = taskSpawn(tasknames[ln],LMP_PRIORITY,LMP_TASK_OPTIONS,LMP_STACK,lmp_driver,ln, mode,
				    devtype, private, RXTIMEOUT);

	    logMsg("Started the Bendix LMP driver on line %d\n",ln);

	    return (1);
	} else {

	    logMsg ("Invalid line number %d\n", ln);
	    return (-1);
	}
}
#endif




/*
/*      lmp_driver
/*
/*      The purpose of this task is to scan the Bendix LMP device
/*      lines. It will maintain a configuration list supporting online additions
/*      and repplacement of modules, and  maintain a table of most recently
/*      scanned values.
/*
*/
void lmp_driver (unsigned short line, unsigned char *mode,
		 unsigned short devtype, unsigned short private,
		 unsigned short rxtime)


    {

	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	LMPDEV          *pmod;
	unsigned short  activity, pstate, lstate, execute, command,i;
	long		this_time, last_time;	


	RXLINE                  *rxp;


	/* Initialize the data structures */
	ltrace[line] = 0;
	bdxrxtimers[line] = rxtime;
	lmode[line] = devtype;
	lmpdatalock[line] = FALSE;
	resresponse[line] = FALSE;
	resnames[line][0] = 0;
	prestable[line] = NULL;
	drvtrace[line] = FALSE;
	drvrestrace[line] = FALSE;
	plcs[line] = (LMPDEV *)calloc(1,(sizeof(LMPDEV)*NUMLMPDEVS));
	if (!plcs[line]) {
	    logMsg ("Not enough memory for LMP line %d \n",line);
	    return;
	}

        /* output queue initialization */
	oq[line] = (OUTPUTQUE *)calloc(1,(sizeof(OUTPUTQUE)));
	if (!oq[line]) {
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}

        /* communication initialization */
	rxlinetab[line] = (RXLINE *)calloc(1,(sizeof(RXLINE)));
	if (!rxlinetab[line]) {
	    logMsg ("Not enough memory for PLC line %d (rx)\n",line);
	    return;
	}
	txlinetab[line] = (TXLINE *)calloc(1,(sizeof(TXLINE)));
	if (!txlinetab[line]) {
	    logMsg ("Not enough memory for PLC line %d (tx)\n",line);
	    return;
	}

	comm_init(line, mode, &tx_int_proc, &rx_int_proc);

	pmod=plcs[line];
	for (i=0; (i<MAXSCROLL);i++) {
	    pmod->scrolllines[i].was_logged = FALSE;
	    pmod->scrolllines[i].databuf[0] = 0;
	}

	init_line_tabs (line);

	clear_rts(line);
	onlinefreq = 1;

	/* enable the reciever interrupt after set to ignore */
	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints(line);

	if (lmode[line] == OPMODEHPA)  hpatimeoutset(line,TRUE);

#ifdef  TEST
	scansome();
#endif
	/* Wait for resource to be defined */
	while ( (resnames[line][0] == 0) || (prestable[line] == NULL) ) {
	    if (ltrace[line] == 1) logMsg ( "No Resource Defined for line - %d \n",
				line);

	    taskDelay(120);
	}
	if (!private) {
	    resClearCaAnswer(prestable[line]);		/* Start Quiet */
	    resPutLocalState(prestable[line],RES_SLV);	/* As Slave */
	    if (drvrestrace[line]) logMsg ("1] Became RES_SLV \n");
	    taskDelay(300);
	    resGetStates(prestable[line],&lstate,&pstate);
	    activity = check_line_activity(line);
	}

	/* if the partner is not there be master */
	if ( (private) || ((pstate != RES_MSTR) &&
			   (pstate != RES_SLVWANT) &&
			   (!activity)) ) {
	    resSetCaAnswer(prestable[line]);
	    resPutLocalState(prestable[line],RES_MSTR);
	    lstate = RES_MSTR;
	    if (drvrestrace[line]) logMsg ("2] Became RES_MSTR \n");
	}


	/* Task will process all modules sending outputs and getting inputs */
	/* It will then try to configure requested non responding modules   */

	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet(); /* Initialize the time  */


	while (TRUE) {

	    while (lstate == RES_SLV) {

		if (pstate != RES_SLVWANT) {
		    clear_rts(line); /* Make sure line is left for master */
		}
		resresponse[line] = FALSE; /* Make Sure driver is not responding */

		resPutCommand(prestable[line],0); /* clear out commands */

		activity = check_line_activity(line);
		resGetStates(prestable[line],&lstate,&pstate);

		/* If partner is there and must give it up take it */
		if (pstate == RES_SLVWANTCA) {
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (drvrestrace[line]) logMsg ("3] Became RES_MSTR \n");
		    break;
		}

		/* If partner is there and wants to give it up try to take it */
		if (pstate == RES_SLVWANT) {
		    execute = FALSE;
		    set_rts(line);
		    taskDelay(2); /* Time for switch to occure */

		    /* See if any one will answer to me */
		    for ( mod=1; (mod<NUMLMPDEVS); mod++) {
			pmod = plcs[line]+mod;
			if ((pmod->was_requested) &&    /* data points have been requested      */
                            (!pmod->cmd_force_offline)) /* user has NOT forced plc offline      */
                        {
			    on_line(line,mod);
                            /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
			    {
				execute = TRUE;
				break;
			    }
			}
		    }

		    /* If someone answered then become master and make sure partner gave it up */
		    if (execute) {
			resPutLocalState(prestable[line],RES_MSTR);
			lstate = RES_MSTR;
			if (drvrestrace[line]) logMsg ("4] Became RES_MSTR \n");
			execute = FALSE;
			for (i=0;(i<60);i++) {
			    activity = check_line_activity(line);
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ( (pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) ) {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute) {   /* Partner did not give it up go back to slave */
			    resPutLocalState(prestable[line],RES_SLV);
			    lstate = RES_SLV;
			    if (drvrestrace[line]) logMsg ("5] Became RES_SLV \n");
			}
			else { /* Assume control by taking the CA responsibilities */ 
			    resSetCaAnswer(prestable[line]);
			    prepresponses(line);
			    break;
			}
		    }
		}

		/* if the partner is not talking be master */
		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity)) {
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (drvrestrace[line]) logMsg ("6] Became RES_MSTR \n");
		    prepresponses(line);
		}

	    }
	
	    while (lstate == RES_SLVWANTCA) {

		clear_rts(line); /* Make sure line is left for master */
		taskDelay(2);
		resresponse[line] = FALSE; /* Make Sure driver is not responding */

		resGetStates(prestable[line],&lstate,&pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT)){
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLV);
		    lstate = RES_SLV;
		    if (drvrestrace[line]) logMsg ("7] Became RES_SLV \n");
		    break;
		}
		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0); /* clear out commands */
		if (command == RES_CANCELREL) {
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (drvrestrace[line]) logMsg ("8] Became RES_MSTR \n");
		    prepresponses(line);
		}

	    }
	    last_time = tickGet ();		/* initialize gap */
	    while ((lstate == RES_MSTR) || (lstate == RES_SLVWANT)) {

		set_rts(line);	/* Grab Switch */
		resresponse[line] = TRUE; /* Make Sure driver is responding */

		if (!private) {
		    resGetCommand(prestable[line],&command);
		    resPutCommand(prestable[line],0); /* clear out commands */
		    if (command == RES_RELINQUISH) {
			resClearCaAnswer(prestable[line]);
			resPutLocalState(prestable[line],RES_SLVWANTCA);
			lstate = RES_SLVWANTCA;
			if (drvrestrace[line]) logMsg ("9] Became RES_SLVWANTCA \n");
			break;
		    }
		}

		modspolled = 0;

		for ( mod=0; (mod < NUMLMPDEVS); mod++ ) {

		    pmod = plcs[line]+mod;  /* shorthand pointer */

		    if (pmod->cmd_force_offline) {
			pmod->is_responding = FALSE;
		    }

		    if ((pmod->is_responding) && (!pmod->cmd_force_offline)) {
			modspolled++;
			scan_plc(pmod,line,mod);
			if (!pmod->is_responding) mark_not_valid(pmod);
		    } /* end of module */

		    pmod->holdflag = FALSE; 

		    if (!private) {
			resGetCommand(prestable[line],&command);
			if (command == RES_RELINQUISH) break;
		    }

		} /* end of scan loop */

		if (lmode[line] == OPMODELMP)
			taskDelay(12);
		cnt = 0;  /* count the number to bring on in one pass */

		/* do we try to bring any on this pass */
		if (--onlinefreq == 0) { 
		    onlinefreq = BRINGBACKCNT;

		    for ( mod=0; (mod<NUMLMPDEVS); mod++) {
			cfgchk++;
		 	if (cfgchk==NUMLMPDEVS) cfgchk=0;
			pmod = plcs[line]+cfgchk;
			if ((!pmod->is_responding) &&
			    (pmod->was_requested) &&
			    (!pmod->cmd_force_offline)) {

			    on_line(line,cfgchk);
			    modspolled++;
			    cnt++;
			    if (cnt == MAXCFGCK) break;
			}
			pmod->holdflag = FALSE; 
		    }
		}

		/* Check for no one responding */

		if ( (!private) && (!any_responding(line)) ) {
		    /* See if it is time to let partner try */
		    this_time = tickGet();
		    if ((this_time - last_time) > (3*SLWWINDOW)) {

			/* Switch States to let partner Know its his time to try */
			resPutLocalState(prestable[line],RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (drvrestrace[line]) logMsg ("10] Became RES_SLVWANT \n");

			/* Give Him Access to the Hardware */
			clear_rts(line);

			/* Let Partner try 1/10 of the time seconds */

			last_time = tickGet(); /* Remember the time of this try */

			for (i=0; (i<SLWWINDOW); i+=10) {

			    taskDelay(10);

			    /* If he picked up let him have control */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT)) {
				resClearCaAnswer(prestable[line]);
				resPutLocalState(prestable[line],RES_SLV);
				lstate = RES_SLV;
				if (drvrestrace[line]) logMsg ("11] Became RES_SLV \n");
				break;
			    }
			}
			/* Go Back to Master and take control of hardware */
			if (lstate != RES_SLV) {
			    resPutLocalState(prestable[line],RES_MSTR);
			    lstate = RES_MSTR;
			    if (drvrestrace[line]) logMsg ("12] Became RES_MSTR \n");
			    set_rts(line);
			}
			
		    }
		}	
                if (modspolled==0)  taskDelay(60);
                else taskDelay(10);
	    }
	} /* end task loop */

     }


/*
/* Try to bring a PLC on line
/*
*/
static void    on_line(unsigned short line,unsigned short mod)

    {
	LMPDEV  *pmod;
	unsigned short i,j;

	pmod = plcs[line] + mod;

	if (ltrace[line] == 1) logMsg ( "Bring Online line - %d  mod - %d \n",
				line,mod );

	switch (lmode[line]) {
	    case(OPMODELMP):
		if (!getsegment(ONERETRY+line,mod,pmod,1)) return;
		break;
	    case(OPMODEASCII):
		/* always assume it will be there */
		break;
	    case(OPMODEMIMIC1):
		if(!getmim1status(line,mod,pmod)) return;
		break;
	    case(OPMODEMIMIC2):
		if(!getmim2status(line,mod,pmod)) return;
		break;
	    case(OPMODEHPA):
		hpatimeoutset(line,FALSE);
		pmod->hpa[0].is_responding = gethpastatus(line,mod,pmod,HPASTATUPDATE,0);
		pmod->hpa[1].is_responding = gethpastatus(line,mod,pmod,HPASTATUPDATE,1);
		if (!((pmod->hpa[0].is_responding) || (pmod->hpa[1].is_responding)) ) {
		    taskDelay(600);
		    return;
		}
		hpatimeoutset(line,FALSE);
		break;
	    case(OPMODEMIMIC3):
		if(!getmim3status(line,mod,pmod)) return;
		break;
	}

	mark_not_valid(pmod);

	pmod->is_responding = TRUE;

    }



/*
/* Mark all of the scaned data as no longer valid
/*
*/
static void    mark_not_valid(LMPDEV  *pmod)

    {
	
	unsigned short i,j;

/*
/*      SEGMENTS ARE INITIALIZED AS
/*              - READ BACK NOT VALID
*/

	for (i=0; (i<MAXSEGS); i++) {
	    pmod->segments[i].data_valid = FALSE;
	}

/*
/*      DIRECTIVE RESPONSES ARE INITIALIZED AS  NOT VALID
*/
	for (i=0; (i<RESBUFLEN); i++) {
	    pmod->responses[i].data_valid = FALSE;
	}

/*
/*      ASYNCHRONOUS EVENTS ARE INITIALIZED AS  NOT VALID
*/
	for (i=0; (i<MAXASYNEVENTS); i++) {
	    pmod->asynevents[i].data_valid = FALSE;
	}

/*
/*      ASCII RESPONSES ARE INITIALIZED AS  NOT VALID
*/
	for (i=0; (i<MAXASCEVENTS); i++) {
	    pmod->ascmsg[i].data_valid = FALSE;
	}

/*
/*      MIMIC 1 and MIMIC 2 STATUS ARE INITIALIZED AS  NOT VALID
*/
	pmod->mimic1.data_valid = FALSE;
	pmod->mimic2.data_valid = FALSE;

/*
/*      HPA STATUS, LIMIT AND FREQ DATA ARE INITIALIZED AS  NOT VALID
*/
	pmod->hpa[0].hpastat.data_valid = FALSE;
	pmod->hpa[0].hpahwlimits.data_valid = FALSE;
	pmod->hpa[0].hpaswllimits.data_valid = FALSE;
	pmod->hpa[0].hpaswhlimits.data_valid = FALSE;
	pmod->hpa[0].hpachnfreq.data_valid = FALSE;

	pmod->hpa[1].hpastat.data_valid = FALSE;
	pmod->hpa[1].hpahwlimits.data_valid = FALSE;
	pmod->hpa[1].hpaswllimits.data_valid = FALSE;
	pmod->hpa[1].hpaswhlimits.data_valid = FALSE;
	pmod->hpa[1].hpachnfreq.data_valid = FALSE;


    }


/*
/* Scan a Bendix Device - call appropriate scan routine based on lmode
/*
*/

static	void    scan_plc(LMPDEV *pmod, unsigned short line,unsigned short mod)

    {
	unsigned short  was_responding;

	checkoutputs(line);

	if (ltrace[line] == 1) logMsg ( "Scan  line - %d  mod - %d \n",
				line,mod );

	switch (lmode[line]) {
	    case(OPMODELMP):
		scan_lmp(pmod,line,mod);
		break;
	    case(OPMODEASCII):
		/* Dont scan ascii device, output and reponse only */
		taskDelay(16);
		break;
	    case(OPMODEMIMIC1):
		getmim1status(line,mod,pmod);
		taskDelay(16);
		break;
	    case(OPMODEMIMIC2):
		getmim2status(line,mod,pmod);
		taskDelay(16);
		break;
	    case(OPMODEHPA):
		was_responding = pmod->hpa[0].is_responding;
		gethpastatus(line,mod,pmod,HPASTATUPDATE,0);
		if ((!was_responding) && (pmod->hpa[0].is_responding)) {
			pmod->hpa[0].hpastat.data_valid = FALSE;
			pmod->hpa[0].hpahwlimits.data_valid = FALSE;
			pmod->hpa[0].hpaswllimits.data_valid = FALSE;
			pmod->hpa[0].hpaswhlimits.data_valid = FALSE;
			pmod->hpa[0].hpachnfreq.data_valid = FALSE;
		}

		checkoutputs(line);
/*
/*		if (pmod->hpa[0].is_responding) 
/*			gethpastatus(line,mod,pmod,HPASTATHW,0);
/*		checkoutputs(line);
/*		if (pmod->hpa[0].is_responding)
/*			gethpastatus(line,mod,pmod,HPASTATLOW,0);
/*		checkoutputs(line);
/*		if (pmod->hpa[0].is_responding)
/*			gethpastatus(line,mod,pmod,HPASTATHIGH,0);
/*		checkoutputs(line);
/*		if (pmod->hpa[0].is_responding)
/*			gethpastatus(line,mod,pmod,HPASTATCHN,0);
*/

		was_responding = pmod->hpa[1].is_responding;
		gethpastatus(line,mod,pmod,HPASTATUPDATE,1);
		if ((!was_responding) && (pmod->hpa[1].is_responding)) {
			pmod->hpa[1].hpastat.data_valid = FALSE;
			pmod->hpa[1].hpahwlimits.data_valid = FALSE;
			pmod->hpa[1].hpaswllimits.data_valid = FALSE;
			pmod->hpa[1].hpaswhlimits.data_valid = FALSE;
			pmod->hpa[1].hpachnfreq.data_valid = FALSE;
		}

/*		checkoutputs(line);
/*		if (pmod->hpa[1].is_responding)
/*			gethpastatus(line,mod,pmod,HPASTATHW,1);
/*		checkoutputs(line);
/*		if (pmod->hpa[1].is_responding)
/*			gethpastatus(line,mod,pmod,HPASTATLOW,1);
/*		checkoutputs(line);
/*		if (pmod->hpa[1].is_responding)
/*			gethpastatus(line,mod,pmod,HPASTATHIGH,1);
/*		checkoutputs(line);
/*		if (pmod->hpa[1].is_responding)
/*			gethpastatus(line,mod,pmod,HPASTATCHN,1);
*/
		taskDelay(30);
		break;
	    case(OPMODEMIMIC3):
		getmim3status(line,mod,pmod);
		taskDelay(16);
		break;
	}

    }



/*
/* Scan a Bendix LMP Device -  get inputs an set outputs as required
/*
*/

static	void    scan_lmp(LMPDEV *pmod, unsigned short line,unsigned short mod)

    {
	unsigned short i, j, val, bitaddr, regaddr, readlen;
	unsigned long   ticks;

	checkoutputs(line);

	/* read the segment values to be scanned */

	for (i=1; (i<MAXSEGS); i++) {
	    if ( (pmod->segments[i].was_requested) &&
		 (pmod->segments[i].has_descriptor) ) {

		ticks = tickGet(); /* get the time  */
		if ( (pmod->segments[i].force_fetch) ||
		     ( (pmod->segments[i].fetchfreq != 0) &&
		       (ticks>(pmod->segments[i].last_time_fetched+
			       pmod->segments[i].fetchfreq)) )  ) {
		    pmod->segments[i].force_fetch = FALSE;
		    pmod->segments[i].last_time_fetched = ticks;
		    if (!getsegment(line,mod,pmod,i)) return;
	    	    checkoutputs(line);
	    	    if (pmod->haveasyncevent) {
	                if (!asynevent(line,mod,pmod)) return;
	    	    }

		}
	    }
	}

    }


/*
/* checkoutputs
/*      checks output que and returns if empty.
/*      if there is something on the que it attempts to process all
/*      pending outputs doing imediate retries. If attempts fail the request is dropped
/*
*/
static	void checkoutputs(unsigned short line)

    {
	OUTQENT *optr;
	int		aoval;
	unsigned char	*poval;
	unsigned short  addr,link,adapter,len,card;
	unsigned long	mask,bvalue;
	LMPDEV  *pmod;

	while ((optr=ogetnextp(line)) != NULLP) {

	  switch (optr->otype) {

	    case (BOUTTYPE):
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;
		pmod = plcs[link];
		addr = optr->out.bonode.bosignal;
		card = optr->out.bonode.card;
		poval = optr->out.bonode.bovalue;
		mask = optr->out.bonode.bomask;
		bvalue = optr->out.bonode.bobvalue;

		if (ltrace[line] == 2) 
			logMsg ( "Binary Output to line %d, card %d, address %d, signal  - %d\n",
				link, adapter, card, addr );

		if ((!pmod->cmd_force_offline) && (resresponse[link])) {
		    switch (lmode[link]) {

			case (OPMODELMP):
	 		    if (!(senddir (link,adapter,pmod,addr,poval,0))) {
				pmod->badoutcnt++;
			    }
			    break;
			case (OPMODEASCII):
	 		    if (!(sendasc (link,adapter,card,pmod,addr,poval,0))) {
				pmod->badoutcnt++;
			    }
			    break;
			case (OPMODEMIMIC1):
			    if (!(sendmim1bo (link,adapter,pmod,addr,bvalue))) {
				pmod->badoutcnt++;
			    }
			    break;
			case (OPMODEMIMIC2):
			    if (!(sendmim2bo (link,adapter,pmod,addr,bvalue))) {
				pmod->badoutcnt++;
			    }
			    break;
			case (OPMODEHPA):
			    if (!(sendhpabo (link,adapter,pmod,addr,bvalue))) {
				pmod->badoutcnt++;
			    }
			    break;
			case (OPMODEMIMIC3):
			    if (!(sendmim3bo (link,adapter,pmod,addr,bvalue))) {
				pmod->badoutcnt++;
			    }
			    break;
		    }
		}
	        break;

	    case (AOUTTYPE):
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;
		card = optr->out.aonode.card;
		pmod = plcs[link];
		addr = optr->out.aonode.aosignal;
		aoval = optr->out.aonode.aovalue;

		if (ltrace[line] == 2) 
			logMsg ( "Analog Output to line %d, card %d, address %d, signal  - %d\n",
				link, adapter, card, addr );

		if ((!pmod->cmd_force_offline) && (resresponse[link])) {
		    switch (lmode[link]) {

			case (OPMODELMP):
			    break;
			case (OPMODEASCII):
			    break;
			case (OPMODEMIMIC1):
			    if (!(sendmim1ao (link,adapter,pmod,addr,aoval))) {
				pmod->badoutcnt++;
			    }
			    break;
			case (OPMODEMIMIC2):
			    break;
			case (OPMODEHPA):

			    if (!(sendhpaao (link,adapter,pmod,addr,aoval))) {
				pmod->badoutcnt++;
			    }

			    break;
			case (OPMODEMIMIC3):
			    if (!(sendmim3ao (link,adapter,pmod,addr,aoval))) {
				pmod->badoutcnt++;
			    }
			    break;
		    }
		}
		break;
	    case (SOUTTYPE):
		link = optr->out.sonode.link;
		adapter = optr->out.sonode.adapter;
		card = optr->out.sonode.card;
		pmod = plcs[link];
		addr = optr->out.sonode.sosignal;
		poval = optr->out.sonode.sovalue;
		len = optr->out.sonode.solen;

		if (ltrace[line] == 2) 
			logMsg ( "String Output to line %d, card %d, address %d, signal  - %d\n",
				link, adapter, card, addr );

		if ((!pmod->cmd_force_offline) && (resresponse[link])) {
		    switch (lmode[link]) {

			case (OPMODELMP):
			    if (!(senddir (link,adapter,pmod,addr,poval,len))) {
				pmod->badoutcnt++;
			    }
			    break;
			case (OPMODEASCII):
			    if (!(sendasc (link,adapter,card,pmod,addr,poval,len))) {
				pmod->badoutcnt++;
			    }
			    break;
			case (OPMODEMIMIC1):
			    break;
			case (OPMODEMIMIC2):
			    break;
			case (OPMODEMIMIC3):
			    break;
			case (OPMODEHPA):
			    break;
		    }
		}
		break;
	  }

	  oreleasefull(line);     /* release the output que entry */

	}

    }
/*
/*      wfdriver
/*
/*      This routines main purpose is to return an array of data foa a 
/*	waveform point type.
/*      a (-1) will be returned if there is no valid data ready.
/*	a (-2) will be returned if the module is in hold state
*/
int	lmp_wfdriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned short *pdata, unsigned short numelm, long *pelemret)

    {
	LMPDEV  *pmod;
	unsigned short  len,i;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= LMPLINES) {
	    return (-1);
	}

	if (adapter  != ASCIISEG) return (-1);

	if (signal == 999) {
	    for (i=0;((i<numelm)&&(i<WFDATASIZE));i++) {
	        if (i<302) {
	            pdata[i] = i;
	        } else {
		    pdata[i] = (604-i);
		}
	    }
	    if (numelm < WFDATASIZE) *pelemret = numelm;
	    else *pelemret = WFDATASIZE;
	    return(0);
	}

	pmod = plcs [link];

	pmod->wf.was_requested = TRUE;
	if (!resresponse[link]) return (-1);
	if (pmod->holdflag) return (-2);
	if (!pmod->is_responding) return (-1);
	if (!pmod->wf.data_valid) {
	    return (-1);
	}

	if (pmod->wf.was_read) return (2);

	for (i=0;((i<numelm)&&(i<WFDATASIZE));i++) {
	    pdata[i] = pmod->wf.data[i];
	}

	if (numelm < WFDATASIZE) *pelemret = numelm;
	else *pelemret = WFDATASIZE;

	pmod->wf.was_read = TRUE;

	return (0);

    }





/*
/*      aidriver
/*
/*      This routines main purpose is to return a pointer to 
/*      the analog input value for the specified module. For a module value
/*      a (-1) will be returned if there is no valid data ready.
/*	a (-2) will be returned if the module is in hold state
*/
int lmp_aidriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, char *pvalue, unsigned short conversion,
		unsigned short ascnumlen, unsigned char *resname)

    {
	LMPDEV  *pmod;
	unsigned short  len,i,ix;
	unsigned char	*pdata;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= LMPLINES) {
	    return (-1);
	}

	if ((adapter >= MAXSEGS) && (adapter != DIRSEG) && 
	     (adapter  != DIRCODESEG) && (adapter != ASYNSEG) &&
	     (adapter  != ASCIISEG) && (adapter != MIMICUDCSEG) &&
	     (adapter != HPASEG) && (adapter != HPASEG2) &&
	     (adapter != PSEUDO) && (adapter != MIMICUPSEG) &&
	     (adapter != ASCIICNVSEG) ) {

	    return (-1);
	}

	pmod = plcs [link];

	switch (conversion) {

	    case(LMPCNVINTEGER):
		len = 2;
		break;
	    case(LMPCNVDOUBLEINT):
		len = 4;
		break;
	    case(LMPCNVFLOAT):
		len = 4;
		break;
	    case(LMPCNVDOUBLEFLT):
		len = 8;
		break;
	    case(LMPCNVASCIIFLT):
		if (ascnumlen != 0) len = ascnumlen;
		else len = 12;
		break;
/*	    case(LMPCNVTIME):
/*		len = 12;
/*		break;
/*	    case(LMPCNVASCII_2):
/*		len = 2;
/*		break;
/*	    case(LMPCNVASCII_4):
/*		len = 2;
/*		break;
/*	    case(LMPCNVASCII_12):
/*		len = 12;
/*		break;
/*	    case(LMPCNVASCII_20):
/*		len = 20;
/*		break;
*/
	    default:
		len = 2;
		break;

 	}

	if ((adapter < MAXSEGS) &&
	    (((card)+len) >= (pmod->segments[adapter].size-2))) {
	    return (-1);
	}
	if ((adapter == DIRSEG) && (card >= (RESBUFLEN))) {
	    return (-1);
	}
	if ((adapter == DIRCODESEG) && (card >= (RESBUFLEN))) {
	    return (-1);
	}
	if ((adapter == ASYNSEG) && (card >= (MAXASYNEVENTS))) {
	    return (-1);
	}

	if (((adapter == ASCIISEG) ||(adapter == ASCIICNVSEG))  && 
	    (card >= (MAXASCEVENTS)) ) {
	    return (-1);
	}

	if ((adapter == HPASEG) && (card != 0)) {
	    return (-1);
	}

	if ((adapter == HPASEG2) && (card != 0)) {
	    return (-1);
	}

	pmod->was_requested = TRUE;

	if (adapter == PSEUDO) {
	    switch (signal) {

	    case 0: /* Were the PLC values requested */
		*((short *)pvalue) = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*((short *)pvalue) = pmod->is_responding;
		break;

	    case 2: /* The program Load request */
		*((short *)pvalue) = pmod->prog_load_stat;
		break;

	    case 3: /* PLC Program Load Block Number */
		*((short *)pvalue) = pmod->prog_load_page;
		break;

	    case 4: /* Set the program number to Load */
		 *((short *)pvalue) = pmod->prog_load_number;
		break;

	    case 5: /* Output Messages */
		*((short *)pvalue) = pmod->no_dataout_msgs & 0x7fff;
		break;

	    case 6: /* Input Messages */
		*((short *)pvalue) = pmod->no_datain_msgs & 0x7fff;
		break;

	    case 7: /* No Receiver Responses */
		*((short *)pvalue) = pmod->no_rxnoresp & 0x7fff;
		break;

	    case 8: /* No Transmitter Response */
		*((short *)pvalue) = pmod->no_txnoresp & 0x7fff;
		break;

	    case 9: /* Data Echo Errors */
		*((short *)pvalue) = pmod->no_dataerr & 0x7fff;
		break;

	    case 10: /* Message Retries */
		*((short *)pvalue) = pmod->no_retries & 0x7fff;
		break;

	    case 11: /* RX Hardware errors */
		*((short *)pvalue) = pmod->no_rxhwerrs & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*((short *)pvalue) = pmod->no_txhwerrs & 0x7fff;
		break;

	    case 13: /* CRC errors */
		*((short *)pvalue) = pmod->no_crcerrs & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*((short *)pvalue) = pmod->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*((short *)pvalue) = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*((short *)pvalue) = pmod->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*((short *)pvalue) = pmod->badoutcnt & 0x7fff;
		break;

	    case 18: /* What is the backup mode for the line*/
		*((short *)pvalue) = backup_mode[link];
		break;

	    case 19: /* What is the selected channel for the line */
		*((short *)pvalue) = channel_select[link];
		break;

	    case 20: /* What is the current dirrective sequence number */
		*((short *)pvalue) = pmod->dirseqno;
		break;

	    case 21: /* What is the current async event sequence number */
		*((short *)pvalue) = pmod->asyneventseqno & 0x7fff;
		break;

	    case 22: /* What is the current async event count */
		*((short *)pvalue) = pmod->asyneventcount & 0x7fff;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if (adapter < MAXSEGS) {

	    pmod->segments[adapter].was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->segments[adapter].data_valid) {
		return (-1);
	    }
	    if (pmod->segments[adapter].segdatabuf == NULLP) return (-1);
	    pdata = &pmod->segments[adapter].segdatabuf[(card)];
	}

	if (adapter == DIRSEG) {

	    pmod->responses[card].was_requested = TRUE;
	    if ((signal+len) >= pmod->responses[card].respstrlen) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->responses[card].data_valid) {
		return (-1);
	    }
	    pdata = &pmod->responses[card].response[signal];
	}

	if (adapter == DIRCODESEG) {

	    if (len != 2) return (-1);
	    pmod->responses[card].was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->responses[card].data_valid) {
		return (-1);
	    }
	    *((short *)pvalue) = pmod->responses[card].response_code;
	    return(0);
	}

	if (adapter == ASYNSEG) {

	    pmod->asynevents[card].was_requested = TRUE;
	    if ((signal+len) >= pmod->asynevents[card].asynstrlen) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->asynevents[card].data_valid) {
		return (-1);
	    }
	    pdata = &pmod->asynevents[card].asyncmsg[signal];
	}

	if ((adapter == ASCIISEG) ||(adapter == ASCIICNVSEG)) {

	    pmod->ascmsg[card].was_requested = TRUE;
	    if ((signal+len) >= pmod->ascmsg[card].astrlen) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->ascmsg[card].data_valid) {
		return (-1);
	    }
	    pdata = &pmod->ascmsg[card].adatabuf[signal];
	}

	if (adapter == MIMICUDCSEG) {
	    pmod->mimic1.was_requested = TRUE;
	    if (signal > MAXM1AISIGNAL ) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->mimic1.data_valid) {
		return (-1);
	    }
	    switch (signal) {

	        case 1:
		    *((short *)pvalue)= pmod->mimic1.atten;
		    return (0);
		    break;

	        default:
		    return (-1);
		    break;
	    }
	}
	if (adapter == MIMICUPSEG) {
	    pmod->mimic3.was_requested = TRUE;
	    if (signal > MAXM3AISIGNAL ) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->mimic3.data_valid) {
		return (-1);
	    }
	    switch (signal) {

	        case 0:
		    *((short *)pvalue)= pmod->mimic3.atten[0];
		    return (0);
		    break;

	        case 1:
		    *((short *)pvalue)= pmod->mimic3.atten[1];
		    return (0);
		    break;

	        default:
		    return (-1);
		    break;
	    }

	}

	if ((adapter == HPASEG) || (adapter == HPASEG2)){

	    if (adapter == HPASEG) ix = 0;
	    else ix = 1;

	    if (signal >= MAXHPAAI) return (-1);

	    if (signal < SHPAHWLIMS) {
		if (signal >= MAXHPAOPPARAMS+3) return (-1);
		if (len != 2) return (-1);
		pmod->hpa[ix].hpastat.was_requested = TRUE;
		if (!resresponse[link]) return (-1);
		if (pmod->holdflag) return (-2);
		if (!pmod->is_responding) return (-1);
		if (!pmod->hpa[ix].is_responding) return (-1);
		if (!pmod->hpa[ix].hpastat.data_valid) return (-1);
		if (signal == SHPAFLTCNT) {
		    *((short *)pvalue) = pmod->hpa[ix].hpastat.fltcnt;
		    return(0);
		}
		if (signal == SHPAALMCNT) {
		    *((short *)pvalue) = pmod->hpa[ix].hpastat.almcnt;
		    return(0);
		}
		if (signal == SHPAFTD) {
		    *((short *)pvalue) = pmod->hpa[ix].hpastat.ftd;
		    return(0);
		}
		*((short *)pvalue) = pmod->hpa[ix].hpastat.opparams[signal-(SHPAFTD+1)];
		return(0);
	    }

	    if ((signal >= SHPAHWLIMS) && (signal < SHPASWLLIMS)) {
		if (signal >= SHPAHWLIMS+MAXHPAHWLIMITS) return (-1);
		if (len != 2) return (-1);
		pmod->hpa[ix].hpahwlimits.was_requested = TRUE;
		if (!resresponse[link]) return (-1);
		if (pmod->holdflag) return (-2);
		if (!pmod->is_responding) return (-1);
		if (!pmod->hpa[ix].hpahwlimits.data_valid) return (-1);
		*((short *)pvalue) = pmod->hpa[ix].hpahwlimits.limits[signal-SHPAHWLIMS];
		return(0);
	    }


	    if ((signal >= SHPASWLLIMS) && (signal < SHPASWHLIMS)) {
		if (signal >= SHPASWLLIMS+MAXHPASWLLIMITS) return (-1);
		if (len != 2) return (-1);
		pmod->hpa[ix].hpaswllimits.was_requested = TRUE;
		if (!resresponse[link]) return (-1);
		if (pmod->holdflag) return (-2);
		if (!pmod->is_responding) return (-1);
		if (!pmod->hpa[ix].hpaswllimits.data_valid) return (-1);
		*((short *)pvalue) = pmod->hpa[ix].hpaswllimits.limits[signal-SHPASWLLIMS];
		return(0);
	    }

	    if ((signal >= SHPASWHLIMS) && (signal < SHPANUMCHAN)) {
		if (signal >= SHPASWHLIMS+MAXHPASWHLIMITS) return (-1);
		if (len != 2) return (-1);
		pmod->hpa[ix].hpaswhlimits.was_requested = TRUE;
		if (!resresponse[link]) return (-1);
		if (pmod->holdflag) return (-2);
		if (!pmod->is_responding) return (-1);
		if (!pmod->hpa[ix].hpaswhlimits.data_valid) return (-1);
		*((short *)pvalue) = pmod->hpa[ix].hpaswhlimits.limits[signal-SHPASWHLIMS];
		return(0);
	    }


	    if ((signal >= SHPANUMCHAN) && (signal < MAXHPAAI) ) {
		if (signal >= SHPANUMCHAN+MAXHPACHCHGFREQ+2) return (-1);
		if (len != 4) return (-1);
		pmod->hpa[ix].hpachnfreq.was_requested = TRUE;
		if (!resresponse[link]) return (-1);
		if (pmod->holdflag) return (-2);
		if (!pmod->is_responding) return (-1);
		if (!pmod->hpa[ix].hpachnfreq.data_valid) return (-1);
		if (card == SHPANUMCHAN) {
		    *((short *)pvalue) = pmod->hpa[ix].hpachnfreq.numchans;
		    return(0);
		}
		if (signal == SHPACURCHN) {
		    *((short *)pvalue) = pmod->hpa[ix].hpachnfreq.curchan;
		    return(0);
		}
		*((float *)pvalue) = pmod->hpa[ix].hpachnfreq.freqs[signal-SHPACURCHN];
		return(0);
	    }
	}


	lockdata(link);
	for (i=0; (i<len); i++) {
	    if ((adapter == ASCIICNVSEG) && (pdata[i] < 40)) {
		pvalue[i] = aconv[pdata[i]];
	    } else {
		pvalue[i] = pdata[i];
	    }
	}
	unlockdata(link);
	return(0);
    }



/*
/*      lmp_aodriver
/*
/*      The main purpose of this routine is to set the request analog output
/*      value(s) on the requested card. This routine will return a (-1) if the
/*      requested module is the wrong type or not configured yet.
/*
*/
int lmp_aodriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		  unsigned short signal, double dvalue, int value, unsigned char *resname)


    {
	LMPDEV  *pmod;
	OUTQENT *oqp;
	unsigned short  blkix,i;

	if (!plcs [link]) {
	    return (-1);
	}
	if (link >= LMPLINES) {
	    return (-1);
	}

	if ( (adapter != MIMICUDCSEG) && (adapter != MIMICUPSEG) &&
	     (adapter != HPASEG) && (adapter != HPASEG2)) { 
	    return (-1);
	}

	if ((adapter == MIMICUDCSEG) && (card != 0)) {
	    return (-1);
	}

	if ((adapter == MIMICUPSEG) && (card != 0)) {
	    return (-1);
	}

	pmod = plcs [link];


	if (adapter == HPASEG) {
	    if ((card != 0) || (signal > MAXHPAAI))  return (-1);
	    if (!pmod->hpa[0].is_responding) return (-1);
	}

	if (adapter == HPASEG2) {
	    if (!pmod->hpa[1].is_responding) return (-1);
	    if ((card != 0) || (signal > MAXHPAAI))  return (-1);
	}

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	pmod->was_requested = TRUE;

	if (!resresponse[link]) return (-1);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline)) {
	    return (-1);
	}

	oqp = ogetemptyp (link);

	if (oqp == NULLP) {
	    return (-1);		/* output que is full */
	}

	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;
	oqp->out.aonode.aovalue = value;

	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
    }



/*
/*      lmp_aoread
/*
/*      This routines main purpose is to return the value last read back
/*      from the analog output hardware. This is used to initialize analog
/*      outputs. This will return a (-1) if the module is the wrong type or
/*      the data is not yet valid
*/
int lmp_aoread (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned int *pvalue, unsigned char *resname)

    {
	LMPDEV  *pmod;
	unsigned short  blkix;
	unsigned long	tvalue;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= LMPLINES) {
	    return (-1);
	}

	if ( (adapter == MIMICUDCSEG) || (adapter == MIMICUPSEG) || 
	     (adapter == HPASEG) || (adapter == HPASEG2) ) {
	    /* Allow Initialization of values that cannot be read */
	    *pvalue = 0;
	    return(0);
	}

	return (-1);

    }



/*
/*      lmp_bidriver
/*
/*      The main purpose of this routine is to return the request digital input
/*      value(s) from the requested card. This routine will return a (-1) if the
/*      requested module is the wrong type or the data is not yet valid.
/*
*/

int lmp_bidriver(char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask,unsigned long *pvalue,
		unsigned char *resname)

    {
	LMPDEV  *pmod;
	unsigned short blkix, tindex,ix;
	unsigned long tvalue;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= LMPLINES) {
	    return (-1);
	}

	if ((adapter >= MAXSEGS) &&       (adapter != DIRCODESEG) &&
	     (adapter  != ASCIISEG) &&    (adapter != MIMICUDCSEG) &&
	     (adapter  != MIMICLNASEG) && (adapter != HPASEG) &&
	     (adapter != HPASEG2) &&      (adapter != MIMICUPSEG) && 
	     (adapter != PSEUDO)) {
	    return (-1);
	}

	pmod = plcs [link];

	if ((adapter < MAXSEGS) &&
	    (card >= (pmod->segments[adapter].size-2))) {
	    return (-1);
	}

	if ((adapter == DIRCODESEG) && (card >= (RESBUFLEN))) {
	    return (-1);
	}

	if ((adapter == ASCIISEG) && 
	    ( (card >= (MAXASCEVENTS)) || (signal >= MAXASCBITOFF) ) ){
	    return (-1);
	}

	if ((adapter == HPASEG) && (card != 0)) {
	    return (-1);
	}

	pmod->was_requested = TRUE;

	if (adapter == PSEUDO) {
	    switch (signal) {

	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 18: /* What is the backup mode for the line*/
		*pvalue = backup_mode[link];
		break;

	    case 19: /* What is the selected channel for the line */
		*pvalue = channel_select[link];
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	if (adapter < MAXSEGS) {

	    pmod->segments[adapter].was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->segments[adapter].data_valid) {
		return (-1);
	    }
	    if (pmod->segments[adapter].segdatabuf == NULLP) return (-1);
	    tvalue = (unsigned short) pmod->segments[adapter].segdatabuf[(card)];

	    *pvalue = tvalue & mask;

	    return (0);

	}

	if  (adapter == ASCIISEG) {

	    pmod->ascmsg[card].was_requested = TRUE;
	    if ((signal/8) >= pmod->ascmsg[card].astrlen) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->ascmsg[card].data_valid) {
		return (-1);
	    }

	    tindex = ((signal/32)*4);	/* make byte index to 32 bit boundary */
	    tvalue = pmod->ascmsg[card].adatabuf[tindex] +
		     (unsigned long) (pmod->ascmsg[card].adatabuf[tindex+1] << 8) +
		     (unsigned long) (pmod->ascmsg[card].adatabuf[tindex+2] << 16) +
		     (unsigned long) (pmod->ascmsg[card].adatabuf[tindex+3] << 24);

	    *pvalue = tvalue & mask;

	    return (0);

	}


	if (adapter == DIRCODESEG) {

	    pmod->responses[card].was_requested = TRUE;
	    if (signal >= LMPMSGLEN) return -1;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->responses[card].data_valid) {
		return (-1);
	    }
	    tvalue = pmod->responses[card].response_code;

	    *pvalue = tvalue & mask;

	    return (0);

	}

	if (adapter == MIMICUDCSEG) {
	    pmod->mimic1.was_requested = TRUE;
	    if (signal > MAXM1BISIGNAL ) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->mimic1.data_valid) {
		return (-1);
	    }
	    tvalue = pmod->mimic1.status;

	    *pvalue = tvalue & mask;

	    return (0);

	}

	if (adapter == MIMICLNASEG) {
	    pmod->mimic2.was_requested = TRUE;
	    if (signal > MAXM2BISIGNAL ) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->mimic2.data_valid) {
		return (-1);
	    }
	    tvalue = pmod->mimic2.status;

	    *pvalue = tvalue & mask;

	    return (0);

	}

	if (adapter == MIMICUPSEG) {
	    pmod->mimic3.was_requested = TRUE;
	    if (signal > MAXM3BISIGNAL ) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->mimic3.data_valid) {
		return (-1);
	    }
	    tvalue = pmod->mimic3.status;

	    *pvalue = tvalue & mask;

	    return (0);

	}

	if ((adapter == HPASEG) || (adapter == HPASEG2)){

	    if (adapter == HPASEG) ix = 0;
	    else ix = 1;

	    if  (signal >= (MAXHPASTATBITS)) return (-1);

	    pmod->hpa[ix].hpastat.was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->hpa[ix].is_responding) return (-1);
	    if (!pmod->hpa[ix].hpastat.data_valid) return (-1);

	    tindex = ((signal/32)*4);	/* make byte index to 32 bit boundary */
	    tvalue = pmod->hpa[ix].hpastat.statbits[tindex] +
		     (unsigned long) (pmod->hpa[ix].hpastat.statbits[tindex+1] << 8) +
		     (unsigned long) (pmod->hpa[ix].hpastat.statbits[tindex+2] << 16) +
		     (unsigned long) (pmod->hpa[ix].hpastat.statbits[tindex+3] << 24);

	    *pvalue = tvalue & mask;

	    return (0);

	}


	return (-1);
    }




/*
/*      lmp_bodriver
/*
/*      The main purpose of this routine is to set the request digital output
/*      value(s) on the requested card. This routine will return a (-1) if the
/*      requested module is the wrong type or not configured yet.
/*
*/
int lmp_bodriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		  unsigned short signal, unsigned char *value, unsigned long bvalue,
		  unsigned long mask, unsigned char *resname)


    {
	LMPDEV  *pmod;
	OUTQENT *oqp;
	unsigned short  blkix,i,o;

	if (!plcs [link]) {
	    return (-1);
	}
	if (link >= LMPLINES) {
	    return (-1);
	}

	if ((adapter >= MAXSEGS) && (adapter != DIRSEG) && 
	     (adapter  != ASCIISEG) && (adapter != MIMICUDCSEG) &&
	     (adapter  != MIMICLNASEG) && (adapter != HPASEG) &&
	     (adapter != HPASEG2) && (adapter != MIMICUPSEG) &&
	     (adapter != PSEUDO)) { 

	    return (-1);
	}

	if ((adapter == MIMICUDCSEG) || (adapter == MIMICUPSEG)) {
 	    if (bvalue == 0) return (0); 
	}


	if ((adapter == DIRSEG) && (card >= RESBUFLEN)) {
	    return (-1);
	}

	pmod = plcs [link];

	pmod->was_requested = TRUE;

	if (adapter < MAXSEGS) {
	    /* Any write to a segment will force a fetch */
	    pmod->segments[adapter].force_fetch = TRUE;
	    return(0);
	}

	if (adapter == PSEUDO) {
	    switch (signal & 0x1f) {

	    case 2: /* Set the program Load request */
		if (bvalue != 0)
		    pmod->prog_load_stat = PLC_LOAD_REQUESTED;
		break;

	    case 15: /* Reset the accumulated statistics */
		if (bvalue != 0) initstats(pmod);
		break;

	    case 16: /* Force the PLC offline */
		pmod->cmd_force_offline = (bvalue != 0);
                if (bvalue != 0 )
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		break;

	    case 18: /* What is the backup mode for the line*/
		backup_mode[link] = (bvalue != 0);
		break;

	    case 19: /* What is the selected channel for the line */
		channel_select[link] = (bvalue != 0);
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}



	pmod->responses[card].was_requested = TRUE;

	if (!resresponse[link]) return (-1);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline)) {
	    return (-1);
	}

	if (adapter == HPASEG) {
	    	    if (!pmod->hpa[0].is_responding) return (-1);
	}

	if (adapter == HPASEG2) {
	    if (!pmod->hpa[1].is_responding) return (-1);
	}


	/* If LMP Dirrective Insert it in scroll Area */
	if ((lmode[link]== OPMODELMP) && (adapter == DIRSEG)) {
	    insertscroll(pmod,value,link);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP) {
	    /* If LMP Dirrective Add error msg to scroll area */
	    if ((lmode[link]== OPMODELMP ) && (adapter == DIRSEG)) {
		insertscroll(pmod,"Output Que Full",link);
	    }
	    return (-1);		/* output que is full */
	}

	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bobvalue = bvalue;

	/* Move in the output string (should be a strncpy) */

	for (i=o=0;(i<LMPMSGLEN);i++,o++) {
	    if (value[i] == EXPCHAR) {
		switch (value[i+1]) {
		    case (EXPCHAR):
			i++;
			oqp->out.bonode.bovalue[o] = value[i];
			break;
		    case ('0'):
		    case (' '):
			i++;
			oqp->out.bonode.bovalue[o] = 0x20;
			break;
		    case ('1'):
			i++;
			oqp->out.bonode.bovalue[o] = CR;
			break;
		    case ('2'):
			i++;
			oqp->out.bonode.bovalue[o] = LF;
			break;
		    case ('3'):
			i++;
			oqp->out.bonode.bovalue[o++] = CR;
			oqp->out.bonode.bovalue[o] = LF;
			break;
		    default:
			oqp->out.bonode.bovalue[o] = value[i];
			break;
 		}
	    }
	    else oqp->out.bonode.bovalue[o] = value[i];
	}
	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
    }


/*
/* Insert a Message in the scrool area
*/
static void insertscroll(LMPDEV *pmod,unsigned char *value,unsigned short line)

    {
	unsigned short i;

	lockdata(line);
	for (i=0; (i<(MAXSCROLL-1));i++) {
	    strcpy(pmod->scrolllines[i].databuf,
		   pmod->scrolllines[i+1].databuf);
	    pmod->scrolllines[i].was_logged = 
		   pmod->scrolllines[i+1].was_logged;
	}
	strcpy(pmod->scrolllines[MAXSCROLL-1].databuf,
	       &value[0]);
	pmod->scrolllines[i].was_logged = FALSE;
	unlockdata(line);
    }



/*
/*      lmp_boread
/*
/*      This routines main purpose is to return the value last read back
/*      from the digital output hardware. This is used to initialize digital
/*      outputs. This will return a (-1) if the module is the wrong type or
/*      the data is not yet valid
*/
int lmp_boread (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)

    {
	LMPDEV  *pmod;
	unsigned short  blkix;
	unsigned long	tvalue;

	if (!plcs [link]) {
	    return (-1);
	}
	if (link >= LMPLINES) {
	    return (-1);
	}

	if (adapter < MAXSEGS) {
	    /* Allow Initialization of force fetch bo */
	    *pvalue = 0;
	    return(0);
	}

	if ( (adapter  == ASCIISEG) || (adapter == MIMICUDCSEG) || (adapter == MIMICUPSEG) ||
	     (adapter  == MIMICLNASEG) || (adapter == HPASEG) || (adapter == HPASEG2) ) {
	    /* Allow Initialization of values that cannot be read */
	    *pvalue = 0;
	    return(0);
	}


	if ((adapter != DIRSEG) && (adapter != PSEUDO)) { 
	    return (-1);
	}

	if ((adapter == DIRSEG) && (card >= RESBUFLEN)) {
	    return (-1);
	}

	pmod = plcs [link];


	if (adapter == PSEUDO) {
	    switch (signal) {

	    case 2: /* Set the program Load request */
		*pvalue = 0;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 18: /* What is the backup mode for the line*/
		*pvalue = backup_mode[link];
		break;

	    case 19: /* What is the selected channel for the line */
		*pvalue = channel_select[link];
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	pmod->responses[card].was_requested = TRUE;

	if (!resresponse[link]) return (-1);
	if (pmod->holdflag) return (-2);
	if (!pmod->is_responding) return (-1);

	*pvalue = 0;

	return (0);
    }


/*
/*      lmp_sidriver
/*
/*      The main purpose of this routine is to get the requested string
/*      from the data buffered from  the Bendix LMP device.
/*	 This routine will return a (-1) if the
/*      requested module is the wrong type or not configured yet.
/*
*/
int lmp_sidriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned char *value, unsigned short len,
		unsigned char *resname)


    {
	LMPDEV  *pmod;
	OUTQENT *oqp;
	unsigned char	*pdata,timebuf[80];
	unsigned short  i,maxlen,mlen;

	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= LMPLINES) {
	    return (-1);
	}

	if ((adapter >= MAXSEGS) && (adapter != DIRSEG) && 
	     (adapter != ASYNSEG) &&  (adapter != SCROLLSEG) &&
	     (adapter != ASCIISEG) && (adapter != TIMESEG) &&
	     (adapter != ASCIICNVSEG) )  {

	    return (-1);
	}

	pmod = plcs [link];

	if ((adapter < MAXSEGS) &&
	    (((card)+len) >= (pmod->segments[adapter].size-2))) {
	    return (-1);
	}
	if ((adapter == DIRSEG) && (card >= (RESBUFLEN))) {
	    return (-1);
	}
	if ((adapter == ASYNSEG) && (card >= (MAXASYNEVENTS))) {
	    return (-1);
	}
	if (((adapter == ASCIISEG) || (adapter == ASCIICNVSEG)) &&
	    (card >= (MAXASCEVENTS)) ) {
	    return (-1);
	}
	if ((adapter == SCROLLSEG) && (card >= (MAXSCROLL))) {
	    return (-1);
	}

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	pmod->was_requested = TRUE;

	if (adapter < MAXSEGS) {

	    pmod->segments[adapter].was_requested = TRUE;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->segments[adapter].data_valid) {
		return (-1);
	    }
	    if (pmod->segments[adapter].segdatabuf == NULLP) return (-1);
	    pdata = &pmod->segments[adapter].segdatabuf[(card)];
	}

	if (adapter == DIRSEG) {

	    pmod->responses[card].was_requested = TRUE;
	    if ((signal+len) >= pmod->responses[card].respstrlen) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->responses[card].data_valid) {
		return (-1);
	    }
	    pdata = &pmod->responses[card].response[signal];
	}

	if (adapter == ASYNSEG) {

	    pmod->asynevents[card].was_requested = TRUE;
	    if ((signal+len) >= pmod->asynevents[card].asynstrlen) return -1;
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->asynevents[card].data_valid) {
		return (-1);
	    }
	    pdata = &pmod->asynevents[card].asyncmsg[signal];
	}


	if ((adapter == ASCIISEG) || (adapter == ASCIICNVSEG)) {

	    if (!pmod->ascmsg[card].data_valid) {
	        value[0]=0;
		return (0);
	    }
	    pmod->ascmsg[card].was_requested = TRUE;
	    if ((signal+len) >= pmod->ascmsg[card].astrlen) return (-1);
	    if (!resresponse[link]) return (-1);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    pdata = &pmod->ascmsg[card].adatabuf[signal];
	}

	if (adapter == SCROLLSEG) {
	    pdata = &pmod->scrolllines[card].databuf[0];
	}

	if (adapter == TIMESEG) {
	    tsStampToText(&time_stamp, TS_TEXT_MONDDYYYY, timebuf);
	    if (signal == 0){
		pdata = &timebuf[0];
	    }
	    else {
		pdata = &timebuf[13];
	    }
	}

	lockdata(link);
	mlen = len;
	if (len == 0) mlen = LMPMSGLEN;
	for (i=0; (i<mlen); i++) {
	    if ((adapter == ASCIICNVSEG) && (pdata[i] < 40)) {
		value[i] = aconv[pdata[i]];
	    } else {
		value[i] = pdata[i];
	    }
	    if ((value[i] < 0x20) || (value[i] > 0x7e)) {
		value[i] = 0;
		break;
	    }
	}
	value[i]=0;	/* put in final Null */
	unlockdata(link);
	return(0);
    }



/*
/*      lmp_sodriver
/*
/*      The main purpose of this routine is to send the requested string
/*      to the Bendix LMP device. This routine will return a (-1) if the
/*      requested module is the wrong type or not configured yet.
/*
*/
int lmp_sodriver (char *pname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned char *value, unsigned short len,
		unsigned char *resname)


    {
	LMPDEV  *pmod;
	OUTQENT *oqp;
	unsigned short  blkix,i,o;


	if (!plcs [link]) {
	    return (-1);
	}

	if (link >= LMPLINES) {
	    return (-1);
	}

	if ((adapter != DIRSEG) && (adapter != ASCIISEG)) { 
	    return (-1);
	}

	if ((adapter == DIRSEG) && (card >= RESBUFLEN)) {
	    return (-1);
	}

	pmod = plcs [link];

	if (resname != 0) { 
	    register_resource(link,pmod,resname,pname);
	}

	pmod->was_requested = TRUE;

	pmod->responses[card].was_requested = TRUE;

	if (!resresponse[link]) return (-1);

	if ((!pmod->is_responding) || (pmod->cmd_force_offline)) {
	    return (-1);
	}

	/* If LMP Dirrective Insert it in scroll Area */
	if ((lmode[link]== OPMODELMP) && (adapter == DIRSEG)) {
	    insertscroll(pmod,value,link);
	}
	oqp = ogetemptyp (link);
	if (oqp == NULLP) {
	    /* If LMP Dirrective Add error msg to scroll area */
	    if ((lmode[link]== OPMODELMP) && (adapter == DIRSEG)) {
		insertscroll(pmod,(unsigned char *)"Output Que Full",link);
	    }
	    return (-1);		/* output que is full */
	}
	oqp->otype = SOUTTYPE;
	oqp->out.sonode.link = link;
	oqp->out.sonode.adapter = adapter;
	oqp->out.sonode.card = card;
	oqp->out.sonode.sosignal = signal;
	oqp->out.sonode.solen = len;

	/* Move in the output string (should be a strncpy) */

	for (i=o=0;(i<LMPMSGLEN);i++,o++) {
	    if (value[i] == EXPCHAR) {
		switch (value[i+1]) {
		    case (EXPCHAR):
			i++;
			oqp->out.sonode.sovalue[o] = value[i];
			break;
		    case ('0'):
		    case (' '):
			i++;
			oqp->out.sonode.sovalue[o] = 0x20;
			break;
		    case ('1'):
			i++;
			oqp->out.sonode.sovalue[o] = CR;
			break;
		    case ('2'):
			i++;
			oqp->out.sonode.sovalue[o] = LF;
			break;
		    case ('3'):
			i++;
			oqp->out.sonode.sovalue[o++] = CR;
			oqp->out.sonode.sovalue[o] = LF;
			break;
		    default:
			oqp->out.sonode.sovalue[o] = value[i];
			break;
 		}
	    }
	    else oqp->out.sonode.sovalue[o] = value[i];
	}

	omarkfull (link);		/* Mark this entry as ready for output */

	return (0);
    }


/*
/* lockdata
/*
/*	The purpose of this routine is to provide locking on the 
/*	data elements with in the LMP line. Since the scan tasks read
/*	this data and the driver writes it we must protect against
/*	a partially updated data element being read by the scan task
*/
static void	lockdata(unsigned short line)

    {
/*  Remove for a while !!!!!!!!!!
	while (TRUE) {
	    if (lmpdatalock[line]) taskDelay(1);
	    else {
		lmpdatalock[line] = TRUE;
		break;
	    }
	}
*/
    }

static void	unlockdata(unsigned short line)

    {
	lmpdatalock[line] = FALSE;
    }
		

/*
/* register_resource                                                              	
/*                                                                                	
/*	This routine is used to initialize the resource pointers                  	
/*  If this is the first time the resource for this line is being                  	
/*  referenced the pointer to the resource table entry will be set                  	
/*  and the resource name will be saved. If the resource name has                       
/*  already been set, this routine will verify that all other points                 	
/*  for this driver are using the same resource name.                                	
/*                                                                                   	
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
			    BOREAD, SIDRIVER, and SODRIVER.                             
*/                               	

static void  register_resource (unsigned short link, LMPDEV *pmod,
                                unsigned char *resname, char *pointname)
    {
	if (resnames[link][0] == 0) /* This is the first reference */
	{
	    if (resGetByName( resname, &prestable[link]) != RES_OK)
	    {
		logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
				resname );
	    }
	    else strcpy(resnames[link], resname);
	}
	else
	{
	    if (strcmp(resnames[link], resname) != 0)
	    {
		logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
				resnames[link],
                                pointname,
				resname );
	    }
	}
    }



/*
/*      Initialize the Queue
*/
static	void outqueinit (unsigned short line)

    {
	oq[line]->ooutix = oq[line]->oinix = 0;

    }



/*
/*  ogetempty - get the next available slot on the output list
*/
static	OUTQENT *ogetemptyp (unsigned short line)

    {

	if (((oq[line]->oinix + 1) % OUTQSIZE) != oq[line]->ooutix) {
	    return (&oq[line]->outque[oq[line]->oinix]);
	}
	if (ltrace[line] == 1) 
		logMsg ( "Output Que Full line - %d\n",line);

	else return (NULLP);

    }



/*
/* omarkfull
/*      mark the next block as full 
*/
static	void omarkfull(unsigned short line)
	{
	    oq[line]->oinix = ((oq[line]->oinix + 1) % OUTQSIZE);
	}


/*
/*  ogetfullp - get the next full slot on the output list
*/
static	OUTQENT *ogetnextp (unsigned short line)

    {

	if (oq[line]->ooutix != oq[line]->oinix) {
	    return (&oq[line]->outque[oq[line]->ooutix]);
	}
	else return (NULLP);

    }


/*
/* oreleasefull - release the current full output block
*/
static	void oreleasefull(unsigned short line)

    {

	if (oq[line]->ooutix == oq[line]->oinix) return;
	oq[line]->ooutix = ((oq[line]->ooutix + 1) % OUTQSIZE);

    }




/*
/*      link_status
/*
/*      The purpose of this routine is to print out the state of each of the
/*      analog devices lines and the statistics gathered about them.
/*
*/
static	void link_status(unsigned short line)

    {
    if (line > LMPLINES-1) return;
    }



/*
/*      startrx
/*
/*      The purpose of this routine is to initialize a line table 
/*      for receive and to enable the receiver.
/*
*/
static	void start_rx( unsigned short line,SEM_ID semid,unsigned short *pstatus )

    {

	RXLINE                  *rxp;

/*	disable_rx_ints(line); */
	rxp=rxlinetab[line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	rxp->rxstate = RXSOHST;
/*	enable_rx_ints(line); */
    }


/*
/*      stoprx
/*
/*      The purpose of this routine is to initialize a line table
/*      for receive and to disable the receiver.
/*
*/
static	void stop_rx( unsigned short line )

    {
	RXLINE                  *rxp;

	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
    }


/*
/*      rx_int_proc
/*
/*      The purpose of this routine is to process a receive character interrupt
/*      for a given line.
/*
*/
static	void rx_int_proc( unsigned short line )

    {
	unsigned char   rxchar;
	unsigned short  rxstat;
	unsigned short  rx_err_mask;
	RXLINE          *rxp;

	read_rx_hw(line,&rxchar,&rxstat,&rx_err_mask);
	rxp=rxlinetab[line];

	/* Something is sending in data */
	line_activity[line] = TRUE;

	if (rxp->rxstate==RXIGNORE) return;

	if ((rxstat & rx_err_mask) != 0) {
	    if (rxp->rxix == 0) return;
	    *(rxp->status) = RXBAD;
	    rxp->rxstate=RXIGNORE;
	    rxp->rxbuf[100]=rxstat;
	    rxp->rxbuf[101]=rxchar;
	    return;
	}
	rxp->rxbuf[rxp->rxix++] = rxchar;
/*!	restart_timer ( linetimers[line], bdxrxtimers[line]); */
	if (rxp->rxix >= (MAXRXMSG-1)) {
	    rxp->rxstate=RXIGNORE;
	    return;
	}

	switch (lmode[line]) {
	    case(OPMODELMP):
		rxlmp(rxp,rxchar);
		break;
	    case(OPMODEASCII):
		rxasc(rxp,rxchar);
		break;
	    case(OPMODEMIMIC1):
		rxmimic(rxp,rxchar);
		break;
	    case(OPMODEMIMIC2):
		rxmimic(rxp,rxchar);
		break;
	    case(OPMODEHPA):
		rxhpa(rxp,rxchar);
		break;
	    case(OPMODEMIMIC3):
		rxmimic(rxp,rxchar);
		break;
	}
	return;
    }


/*
/*      rxasc
/*
/*      The purpose of this routine is to process a receive character interrupt
/*      for an ASCII dumb device. The termination type is in the RXLINE
/*	Structure. It may be any of the following:
/*		TNULL	0
/*		TCR	1
/*		TLF	2
/*		TCRLF	3
/*		T5D	4
/*		WFDATA	5
/*		ENDTIME	6
/*		TFLEN	10	(Length is this value - 10)
/*
*/
static	void rxasc( RXLINE *rxp, unsigned char rxchar )

    {
	unsigned short	done,termtype;

	done = FALSE;

	switch (rxp->rxstate) {
	    case RXSOHST:
		termtype = rxp->terminator;
		if (termtype >= TFLEN) termtype = TFLEN;
		switch (termtype) {

		    case (TNULL):
			done = (rxchar == 0);
			break;
		    case (TCR):
			done = (rxchar == CR);
			break;
		    case (TLF):
			done = (rxchar == LF);
			break;
		    case (TCRLF):
			if ( (rxp->rxix >= 2) && (rxchar == LF) &&
			     (rxp->rxbuf[rxp->rxix-2] == CR) ){
				done = TRUE;
			}
			break;
		    case (T5D):
			done = (rxchar == 0x5d);
			break;
		    case (WFRESP):
			if (rxp->rxix >= (WFDATASIZE*2)) {
			    done = TRUE;
			}
			break;
		    case (ENDTIME):
			done = FALSE; /* Receive until timeout */
			break;
		    case (ENDAACRLF):
			if ( (rxp->rxix >= 6) && (rxchar == LF) &&
			     (rxp->rxbuf[rxp->rxix-2] == CR) &&
			     (rxp->rxbuf[rxp->rxix-3] == '1') &&
			     (rxp->rxbuf[rxp->rxix-4] == '3') &&
			     (rxp->rxbuf[rxp->rxix-5] == '1') &&
			     (rxp->rxbuf[rxp->rxix-6] == '3')    ){
				done = TRUE;
			}
			break;
		    case (TFLEN):
			if (rxp->rxix >= (rxp->terminator-TFLEN)) {
			    done = TRUE;
			}
			break;
		}

		if (done) {
		    *(rxp->status) = RXGOOD;
		    rxp->rxstate=RXIGNORE;
		    semGive(rxp->semid);
		}
		return;
		break;
	    default:
		rxp->rxstate=RXIGNORE;
		return;
		break;

	}
	return;
    }


/*
/*      rxlmp
/*
/*      The purpose of this routine is to process a receive character interrupt
/*      for a LMP device.
/*
*/
static	void rxlmp( RXLINE *rxp, unsigned char rxchar )

    {
	switch (rxp->rxstate) {
	    case RXSOHST:
		if (rxchar != LMPSOH) {
		    rxp->rxix = 0;
		}
		else {
		    rxp->rxstate = RXADRST;
		}
		return;
	    case RXADRST:
		rxp->rxstate = RXLEN1ST;
		return;
	    case RXLEN1ST: /* High Order Length */
		rxp->rxstate = RXLEN2ST;
		rxp->rxmsglen = (unsigned short)(rxchar*256);
		return;
	    case RXLEN2ST:
		rxp->rxstate = RXDATAST;
		rxp->rxmsglen = (rxp->rxmsglen)+rxchar;
		if ((rxp->rxmsglen <= 4) ||
		    (rxp->rxmsglen >= MAXRXMSG)) {

		    rxp->rxstate=RXIGNORE;
		    return;
		}
		rxp->rxmsglen = (rxp->rxmsglen)-4;  /* sub 4 for header */
		return;
	    case RXDATAST: 
		rxp->rxmsglen--;
		if (rxp->rxmsglen == 0) {
		    *(rxp->status) = RXGOOD;
		    rxp->rxstate=RXIGNORE;
		    semGive(rxp->semid);
		    return;
		}
		return;
	    default:
		rxp->rxstate=RXIGNORE;
		return;

	}
	return;
    }

/*
/*      rxmimic
/*
/*      The purpose of this routine is to process a receive character interrupt
/*      for a MIMIC device.
/*
*/
static	void rxmimic( RXLINE *rxp, unsigned char rxchar )

    {
	switch (rxp->rxstate) {
	    case RXSOHST:
		if (rxchar != MIMICOPEN) {
		    rxp->rxix = 0;
		}
		else {
		    rxp->rxstate = MIMGETCLOSE;
		}
		return;
	    case MIMGETCLOSE:
		if (rxchar != MIMICCLOSE) {
		    return;
		}
		else {
		    rxp->rxstate = MIMGETCSUM;
		}
		return;
	    case MIMGETCSUM:
		*(rxp->status) = RXGOOD;
		rxp->rxstate=RXIGNORE;
		semGive(rxp->semid);
		return;
	    default:
		rxp->rxstate=RXIGNORE;
		return;

	}
	return;
    }

/*
/*      rxhpa
/*
/*      The purpose of this routine is to process a receive character interrupt
/*      for a HIGH POWER AMP device.
/*
*/
static	void rxhpa( RXLINE *rxp, unsigned char rxchar )

    {
	switch (rxp->rxstate) {
	    case RXSOHST:
		if (rxchar != HPASOM) {
		    rxp->rxix = 0;
		}
		else {
		    rxp->rxstate = HPAGETLEN;
		}
		return;
	    case HPAGETLEN:
		rxp->rxmsglen = rxchar;
		rxp->rxstate = HPAGETMSG;
		return;
	    case HPAGETMSG:
		rxp->rxmsglen--;
		if (rxp->rxmsglen == 0) {
		    rxp->rxstate = HPAGETCSUM;
		}
		return;
	    case HPAGETCSUM:
		*(rxp->status) = RXGOOD;
		rxp->rxstate=RXIGNORE;
		semGive(rxp->semid);
		return;
	    default:
		rxp->rxstate=RXIGNORE;
		return;

	}
	return;
    }




/*
/*      check_line_activity
/*
/*      The purpose of this routine is to process a receive character interrupt
/*      for a given line.
/*
*/
static	int check_line_activity( unsigned short line )

    {
	RXLINE          *rxp;

	line_activity[line] = FALSE;
	rxp = rxlinetab[line];
	rxp->rxstate = RXIGNORE;
/*	enable_rx_ints(line);  */
	taskDelay(30);		/* .5 seconds */
	return (line_activity[line]);
    }



/*
/*      starttx
/*
/*      The purpose of this routine is to initialize a line table
/*      for send and to enable the transmitter.
/*
*/
static	void start_tx( unsigned short line,SEM_ID semid,unsigned short *pstatus )

    {

	TXLINE                  *txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;
	/* Might have to output the first character here */


	enable_tx_ints(line);

    }


/*
/*      stoptx
/*
/*      The purpose of this routine is to initialize a line table
/*      for receive and to disable the receiver.
/*
*/
static	void stop_tx( unsigned short line )

    {
	TXLINE			*txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txdisable=TRUE;
    }


/*
/*      tx_int_proc
/*
/*      The purpose of this routine is to process a receive character interrupt
/*      for a given line.
/*
*/
static	void tx_int_proc( unsigned short line )

    {

	char                    txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

	txp=txlinetab[line];
	if (txp->txdisable) return;
	if (txp->txix == txp->txmsglen) {
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive(txp->semid);
	    return;
	} else {
	    txchar = txp->txbuf[txp->txix++];
	    write_tx_hw ( line,txchar,&txstat,&tx_err_mask );
	    if ( (txstat & tx_err_mask) != 0 ) {
	 	txp->txdisable=TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive(txp->semid);
	        return;
	    }

	}

	if (txp->txix >= MAXTXMSG) {
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive(txp->semid);
	    return;
	}

    }


/*
/*      msgxfer
/*
/*      The purpose of this routine is to transmit a buffer to the
/*      devices and to await a response. The transmit and receive
/*      buffers are in their respective line tables. This routine will retry
/*      the message up to a maximum number of times or until a response
/*      is received witha proper checksum.
/*              returns         XFERGOOD if response received
/*                              XFERBAD  if no good repsonse is received
/*
*/

static	unsigned short  msgxfer(unsigned short fline,unsigned short resplen, LMPDEV *pmod, short rxlength)

    {

	unsigned short  retry,txstatus,rxstatus,rxlen,line,ix;
	RXLINE          *rxp;
	TXLINE          *txp;
	unsigned char   csums[2];

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

	rxp = rxlinetab[line];

	for (retry=((fline == line)?0:MAXRETRYS-1); (retry<MAXRETRYS); retry++ ) {
/*!	    stop_timer(linetimers[line]);  */
	    txstatus = IO_TIMEOUT;
	    rxp->fixedlen = resplen;
	    rxp->rxmsglen = rxlength;
	    rxstatus = IO_TIMEOUT;
	    semTake(semids[line][TXSEM], NO_WAIT);
	    semTake(semids[line][RXSEM], NO_WAIT);

	    start_rx(line, semids[line][RXSEM], &rxstatus);
	    start_tx(line, semids[line][TXSEM], &txstatus);
/*!	    start_timer (linetimers[line],TXTIMEOUT,semids[line], &txstatus); */
	    if ((semTake(semids[line][TXSEM], TXTIMEOUT)) == ERROR)
		txstatus = IO_TIMEOUT;
/*!	    stop_timer(linetimers[line]); */
	    stop_tx(line);

	    if (txstatus == TXGOOD) {

		if (rxlength == -1) {
		    stop_rx(line);
		    return (XFERGOOD);
		}

/*!		start_timer (linetimers[line],(bdxrxtimers[line] * 2),semids[line], &rxstatus); */

		if ((semTake(semids[line][RXSEM], (int)(bdxrxtimers[line] * 2))) == ERROR)
		    rxstatus = IO_TIMEOUT;
/*!		stop_timer(linetimers[line]);*/

		stop_rx(line);

		rxlen = rxp->rxix;
		if ((lmode[line] == OPMODEASCII) && (rxp->terminator == ENDTIME) && (rxlen != 0) )
			rxstatus = RXGOOD;
		if (rxstatus == RXGOOD) {
		    switch (lmode[line]) {
			case(OPMODELMP):
			    if (rxlen < 6) {
				if (drvtrace[line]) logMsg("Invlalid rxlen... %d\n", rxlen);
			    } else {
			        makecrc(&rxp->rxbuf [0], rxlen-2, csums);
			    }
			    if ( (csums[0]==rxp->rxbuf[rxp->rxix-2]) &&
				 (csums[1]==rxp->rxbuf[rxp->rxix-1]) ) {
				 return (XFERGOOD);
			    } else {
				pmod->no_crcerrs++;
				if (drvtrace[line]) logMsg ("CRC Message Length = %d\n", rxlen);
				if (drvtrace[line]) logMsg ("%x%x%x%x Bad CRC\n",
						rxp->rxbuf[rxp->rxix-2],rxp->rxbuf[rxp->rxix-1],
						csums [0], csums [1] );
				for (ix = 0; ix < rxlen; ix++) {
				    if (drvtrace[line]) logMsg("%x\n",  rxp->rxbuf[ix]);
				}
			    }
			    break;
			case(OPMODEASCII):
			    return (XFERGOOD);
			    break;
			case(OPMODEMIMIC1):
			case(OPMODEMIMIC2):
			case(OPMODEMIMIC3):
			    if (rxlen < 5) {
				if (drvtrace[line]) logMsg("Invlalid rxlen... %d\n", rxlen);
			    } else {
			        makesum(&rxp->rxbuf [0], rxlen-1, csums);
			    }
			    if (csums[0]==rxp->rxbuf[rxp->rxix-1]) {
				 return (XFERGOOD);
			    } else {
				pmod->no_crcerrs++;
				if (drvtrace[line]) logMsg ("CRC Message Length = %d\n", rxlen);
				if (drvtrace[line]) logMsg ("Got %x Expected %x Bad Checksum\n",
								rxp->rxbuf[rxp->rxix-1],
								csums [0] );
				for (ix = 0; ix < rxlen; ix++) {
				    if (drvtrace[line]) logMsg("%x\n", rxp->rxbuf[ix]);
				}
			    }
			    break;
			case(OPMODEHPA):
			    if (rxlen < 4) {
				if (drvtrace[line]) logMsg("Invlalid rxlen... %d\n", rxlen);
			    } else {
			        makehpasum(&rxp->rxbuf [0], rxp->rxix-1, csums);
			    }
			    if (csums[0]==rxp->rxbuf[rxp->rxix-1]) {
				 return (XFERGOOD);
			    } else {
				pmod->no_crcerrs++;
				if (drvtrace[line]) logMsg ("CRC Message Length = %d\n", rxlen);
				if (drvtrace[line]) logMsg ("Got %x Expected %x Bad Checksum\n",
								rxp->rxbuf[rxp->rxix-1],
								csums [0] );
				for (ix = 0; ix < rxlen; ix++) {
				    if (drvtrace[line]) logMsg("%x\n", rxp->rxbuf[ix]);
				}
			    }
			    break;

		    }
		} else if (rxstatus == IO_TIMEOUT) {
		    if (drvtrace[line]) logMsg ("Receive Timeout... Length: %d\n", rxlen);
		    pmod->no_rxnoresp++;
		} else {
		    if (drvtrace[line]) logMsg ("Receive Error\n");

		    if (drvtrace[line]) logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
			 rxp->rxbuf[100],
			 rxp->rxbuf[101],
			 rxp->rxix);
			 pmod->no_rxhwerrs++;
		}
	    } else if (txstatus == IO_TIMEOUT) {
		if (drvtrace[line]) logMsg ("Transmit Timeout\n");
		pmod->no_txnoresp++;
	    } else {
		if (drvtrace[line]) logMsg ("Transmit Error\n");
		pmod->no_txhwerrs++;
	    }
	if (retry != MAXRETRYS) pmod->no_retries++;
	}
	if (drvtrace[line]) logMsg ("Xfer Bad\n");

	stop_rx(line);
	return (XFERBAD);

    }


/*
/*      init_line_tabs
/*
/*      The purpose of this routine is to initialize the line tables for the
/*      LMP devices
/*
*/
static	void init_line_tabs(unsigned short line)

    {

	unsigned short  mod,i;
	LMPDEV  *pmod;

	for (mod=0; (mod<NUMLMPDEVS); mod++) {

	    pmod = plcs[line]+mod;

	    pmod->is_responding = FALSE;
	    pmod->holdflag = FALSE;
	    pmod->was_requested = FALSE;
	    pmod->cmd_force_offline = FALSE;
	    pmod->prog_load_stat = PLC_NOT_LOADED;
	    pmod->dirseqno = 0;
	    pmod->asyneventseqno = 0;
	    pmod->dirseqqueix = 0;

	    /* initialize the response sequence number que */
	    for (i=0; (i<RESPSEQQLEN); i++) {
		pmod->respseqq[i].dirseqno = 0xFFFF; /* Not a valid seq number */
	    }

	    /* read the segment descriptor file to initialize the structure */

	    initplc(pmod);
	    if (lmode[line] == OPMODELMP) getsegdesc(line,pmod);
	    initstats(pmod);

	}
	linetimers[line] = gettimer();
	if (linetimers[line] == -1) {
		/*  put an error message in here */
	}

	/* Initialize this tasks semaphore*/
	semids[line][0]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
	semids[line][1]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);


    }

/*
/* getsegdesc
/*
/*	read the segment descriptor file and allocate space
/*
*/
static void    getsegdesc(unsigned short line,LMPDEV *pmod)

    {

	char	buf[80];
	FILE		*fp;
	unsigned char	aline[2];
	int		status,i;
	unsigned short	number[3];

	strcpy(buf,"lmpseg");
	aline[1] = 0;
	aline[0] = '0'+line;
	strcat(buf,aline);
	strcat(buf,".seg");

	if ((fp = fopen(buf,"r"))== NULL) {
	    logMsg("Could not open segment descriptor file %s\n",
			buf);
	    return;
	}

	status = ~EOF;
	while (status != EOF) {

	    status = getopen(fp);
	    if (status == EOF) break;

	    /* Try to get a triple */
	    /* (Segment,Size,Frequency) */
	    for (i=0;(i<3);i++) {
		if ((status = getnumber(fp,&number[i])) == EOF) break; 
		if (status == '(' ) break;
	    }
	    if (i==3) {
		if ((number[0]<MAXSEGS) && (number[1]<MAXSEGSIZE)) {
		    pmod->segments[number[0]].segdatabuf = 
			(unsigned char *)calloc(1,number[1]);
		    if (!pmod->segments[number[0]].segdatabuf) {
	    		logMsg ("Not enough memory for LMP line %d segment %d\n",
				line,
				number[0]);
		    }
		    else {
			pmod->segments[number[0]].size = number[1];
			pmod->segments[number[0]].fetchfreq = number[2];
			pmod->segments[number[0]].has_descriptor = TRUE;
		    }

		}
		else {
		    logMsg ( "Invalid segment description line = %d segment = %d size = %d\n",
			line,
			number[0],
			number[1]);
		}
	    }
	}
    }

		

/*
/* getopen
/*
/*	reads until "(" or EOF
/*
*/
static  int getopen(FILE *fp)

    {
	int	status,done;


	done = FALSE;
	while (!done) {
	    status = getc(fp);
	    if (status == EOF) break;
	    if (status == '(') break;
	}
	return(status);
    }

/*
/* getnumber
/*
/*	reads until "(" or EOF or a digit
/*	if EOF returns EOF
/*	if "(" returns "("
/*	if digit
/*		 reads until non digit converting to decimal
/*		 when non digit it puts it back and returns
*/
static int getnumber(FILE *fp, unsigned short *number)

    {
	int	status,done;


	done = FALSE;
	while (!done) {
	    status = getc(fp);
	    if (status == EOF) return(status);
	    if (status == '(') {
		ungetc(status,fp);
		return(status);
	    }
	    if (isdigit(status)) break;
	}
	*number = (status & 0x0f);

	while (isdigit(status = getc(fp))) {
	    *number = (*number * 10) + (status & 0x0f);
	}

	ungetc(status,fp);
	return(~EOF);
    }



/*
/* Cold Init a PLC
/*
*/
static void    initplc (LMPDEV  *pmod)

    {

	unsigned short i,j;



/*
/*      SEGMENTS ARE INITIALIZED AS
/*              - READ BACK NOT VALID & NOT REQUESTED
*/

	for (i=0; (i<MAXSEGS); i++) {
	    pmod->segments[i].data_valid = FALSE;
	    pmod->segments[i].was_requested = FALSE;
	    pmod->segments[i].has_descriptor = FALSE;
	    pmod->segments[i].force_fetch = FALSE;
	    pmod->segments[i].size = 0;
	    pmod->segments[i].fetchfreq = 0;
	    pmod->segments[i].last_time_fetched = 0;
	    pmod->segments[i].segdatabuf = NULLP;

	
	}

/*
/*      DIRECTIVE RESPONSES ARE INITIALIZED AS  NOT VALID
*/
	for (i=0; (i<RESBUFLEN); i++) {
	    pmod->responses[i].data_valid = FALSE;
	}

/*
/*      ASYNCHRONOUS EVENTS ARE INITIALIZED AS  NOT VALID
*/
	for (i=0; (i<MAXASYNEVENTS); i++) {
	    pmod->asynevents[i].data_valid = FALSE;
	}

/*
/*      ASCII MESSAGES EVENTS ARE INITIALIZED AS  NOT VALID
*/
	for (i=0; (i<MAXASCEVENTS); i++) {
	    pmod->ascmsg[i].data_valid = FALSE;
	}

/*
/*      WAVE FORM DATA IS INITIALIZED AS  NOT VALID
*/
	pmod->wf.was_requested = FALSE;
	pmod->wf.data_valid = FALSE;

/*
/*	MIMIC 1 reset status
*/
	pmod->mimic1.status = 0;
/*
/*	MIMIC 2 reset status
*/
	pmod->mimic2.status = 0;


    }


/*
/*
/* initialize the statistics for a Bendix LMP
/*
*/

static	void initstats(LMPDEV *pmod)

    {
	pmod->no_dataout_msgs = 0;      /* 5  Count Output Msgs */
	pmod->no_datain_msgs = 0;       /* 6  Count Data Requests */
	pmod->no_rxnoresp = 0;          /* 7  Count No Responses */
	pmod->no_txnoresp = 0;          /* 8  Count No Responses */
	pmod->no_dataerr = 0;           /* 9  Count Message Echo Errors */
	pmod->no_retries = 0;           /* 10 Count Retries */
	pmod->no_rxhwerrs = 0;          /* 11 Count Comm Hardware Errors */
	pmod->no_txhwerrs = 0;          /* 12 Count Comm Hardware Errors */
	pmod->no_crcerrs = 0;           /* 13 Count CRC Errors */
	pmod->no_offlines = 0;          /* 14 Count Off Line Transitions */
	pmod->badoutcnt = 0;		/* 17 Count failed output commands */
	pmod->asyneventcount = 0;	/* 22 Number of Async Events Requested */

    }



/*
/*     prepresponses
/*
/*      The purpose of this routine is to mark the PLCs as on hold and the 
/*	data as not valid until read again from the PLC
/*
*/
static	void prepresponses(unsigned short line)

    {

	unsigned short  mod;
	LMPDEV  *pmod;

	for (mod=0; (mod<NUMLMPDEVS); mod++) {

	    pmod = plcs[line]+mod;
	    pmod->holdflag = TRUE;
 	    mark_not_valid(pmod);
	}
    }



/*
/*      any_responding
/*
/*      The purpose of this routine is to see if any units are 
/*	responding on this line
/*
*/
static	int any_responding(unsigned short line)

    {

	unsigned short  mod;
	LMPDEV  *pmod;

	for (mod=0; (mod<NUMLMPDEVS); mod++) {

	    pmod = plcs[line]+mod;
            /* check cmd_force_offline flag because it is set in an asynchronous task */
            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
               return(TRUE);
	}

	return(FALSE);

    }


/* 
/* getsegment
*/
static	unsigned short getsegment(unsigned short line, unsigned short mod,
			 LMPDEV *pmod, unsigned short segno)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
		rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] =  LMPSOM;
	txp->txbuf[1] =  mod;
	txp->txbuf[2] =  (SEGREQLEN/256);
	txp->txbuf[3] =  (SEGREQLEN & 0xFF);
	txp->txbuf[4] =  0;
	txp->txbuf[5] =  SEGREQ;
	txp->txbuf[6] =  0;
	txp->txbuf[7] =  (segno & 0x7F);

	makecrc(&(txp->txbuf[0]),SEGREQLEN-2,&(txp->txbuf[SEGREQLEN-2]));

	txp->txmsglen = SEGREQLEN;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != LMPSOM) ||
	    (rxp->rxbuf[1] != mod) ||
	    ((rxp->rxbuf[5] & 0x7f) != SEG ) ||
	    (((rxp->rxbuf[6] >>1) & 0x7f) != segno) ) {

	    pmod->no_dataerr++;
	    return(FALSE);

	}

	if ((rxp->rxbuf[5] & 0x80) != 0) {
	    pmod->haveasyncevent = TRUE;
	}
	else {
	    pmod->haveasyncevent = FALSE;
	}

	/* verify message is not too long */
	len = (unsigned short)rxp->rxbuf[2] * 256;
	len = len + rxp->rxbuf[3];
	len = len - SEGRESPOVERHEAD;
	if ( len > pmod->segments[segno].size) {
	    pmod->no_dataerr++;
	    return(FALSE);

	}

	/* Store the returned data                      */

	for ( i=0; (i<len); i++ ) {
	    pmod->segments[segno].segdatabuf[i] = rxp->rxbuf[SEGDATAIX+i];
	}

	pmod->segments[segno].data_valid = TRUE; 
	return(TRUE);

    }

/* 
/* senddir
*/
static	unsigned short senddir(unsigned short line, unsigned short mod,
			 LMPDEV *pmod, unsigned short signal,
			 unsigned char *buf, unsigned short olen)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,saveseqno,temp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;


	/* Format the output message */

	txp->txbuf[0] =  LMPSOM;
	txp->txbuf[1] =  0;	/* Not Multidropped */

	/* Move in the data and compute the length */

	/* Store the transmit data                      */

	i=0;
	tlen = olen;
	while  (i<LMPMSGLEN) {
	    if ((olen != 0) && (i==tlen)) break;
	    txp->txbuf[DIRDATAIX+i] = buf[i];
	    if (olen == 0) {
		if ((buf[i] == CR) || (buf[i] == 0)) {
		    i++;
		    break;
		}
	    }
	    i++;
	}

	tlen = i + 8;
	txp->txbuf[2] =  (tlen/256);
	txp->txbuf[3] =  (tlen & 0xFF);
	txp->txbuf[4] =  pmod->dirseqno;
	saveseqno     =  pmod->dirseqno;
	txp->txbuf[5] =  DIR;

	/* Register this sequence number for late responses */

	pmod->respseqq[(pmod->dirseqno % RESPSEQQLEN)].dirseqno =
		  pmod->dirseqno;
	pmod->respseqq[(pmod->dirseqno % RESPSEQQLEN)].responseix =
		  signal;


	/* Bump the sequence number wrap at 255*/

	if (pmod->dirseqno++ > 256) pmod->dirseqno = 0;


	makecrc(&(txp->txbuf[0]),tlen-2,&(txp->txbuf[tlen-2]));

	txp->txmsglen = tlen;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	return (verify_dirrective_response(rxp,(line & (~ONERETRY)),
		pmod,mod,saveseqno,signal));

    }

/*
/* verify_dirrective_response
/*
*/
static  int	verify_dirrective_response(RXLINE *rxp, unsigned short line,
		LMPDEV *pmod,unsigned short mod, unsigned short saveseqno,
		unsigned short signal)

    {
	unsigned short	len,i,temp;

	/* Verify the response */

	if ((rxp->rxbuf[0] != LMPSOM) ||
	    (rxp->rxbuf[4] != saveseqno) ||
	    ((rxp->rxbuf[5] & 0x7f) != DIRRESP) ) {

	    pmod->no_dataerr++;
	    return(FALSE);

	}

	if ((rxp->rxbuf[5] & 0x80) != 0) {
	    pmod->haveasyncevent = TRUE;
	}
	else {
	    pmod->haveasyncevent = FALSE;
	}

	/* verify message is not too long */
	len = (unsigned short)rxp->rxbuf[2] * 256;
	len = len + rxp->rxbuf[3];
	len = len - DIRRESPOVERHEAD;
	if ( len > LMPMSGLEN) {
	    pmod->no_dataerr++;
	    return(FALSE);
	}

	/* Store the returned data                      */

	for ( i=0; (i<len); i++ ) {
	    pmod->responses[signal].response[i] = rxp->rxbuf[DIRRESPDATAIX+i];
	}
	pmod->responses[signal].response[i] = 0; /* NULL */
	pmod->responses[signal].respstrlen = len; 

	temp = (unsigned short)rxp->rxbuf[DIRRESPCODEIX] * 256;
	temp = temp + rxp->rxbuf[DIRRESPCODEIX+1];
	pmod->responses[signal].response_code = temp;

	pmod->responses[signal].data_valid = TRUE; 

	insertscroll(pmod,pmod->responses[signal].response,line);
	return(TRUE);

    }


/* 
/* asynevent
*/
static	unsigned short asynevent(unsigned short line, unsigned short mod,
			 LMPDEV *pmod)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  saveseqno,signal,i,len;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->asyneventcount++;

	/* Format the output message */

	txp->txbuf[0] =  LMPSOM;
	txp->txbuf[1] =  mod;
	txp->txbuf[2] =  (ASYNCREQLEN/256);
	txp->txbuf[3] =  (ASYNCREQLEN & 0xFF);
	txp->txbuf[4] =  0;
	txp->txbuf[5] =  ASYNCREQ;
	txp->txbuf[6] =  0;
	txp->txbuf[7] =  pmod->asyneventseqno;

	makecrc(&(txp->txbuf[0]),ASYNCREQLEN-2,&(txp->txbuf[ASYNCREQLEN-2]));

	txp->txmsglen = ASYNCREQLEN;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != LMPSOM) ||
	    (rxp->rxbuf[1] != mod) ||
	    (((rxp->rxbuf[5] & 0x7f) != ASYNC ) &&
	     ((rxp->rxbuf[5] & 0x7f) != DIRRESP ))) {

	    pmod->no_dataerr++;
	    return(FALSE);

	}

	/* Bump the async event sequence number */
	pmod->asyneventseqno++;

	if ((rxp->rxbuf[5] & 0x80) != 0) {
	    pmod->haveasyncevent = TRUE;
	}
	else {
	    pmod->haveasyncevent = FALSE;
	}

	if ((rxp->rxbuf[5] & 0x7f) == DIRRESP ) {

	    /* Find the sequence number in the late response que */
	    saveseqno = rxp->rxbuf[4];
	    signal = RESBUFLEN+1;
	    for (i=0; (i<RESPSEQQLEN); i++) {
		if (pmod->respseqq[i].dirseqno == saveseqno) {
		    signal = pmod->respseqq[i].responseix;
		    break;
		}
	    }
	    if (signal > RESBUFLEN) {
		logMsg ("Late Response Sequence # %x Not Found \n",saveseqno);
		pmod->no_dataerr++;
		return(TRUE);
	    }
	    else {

		/* Verify and store the response */
		if (!verify_dirrective_response(rxp,(line & (~ONERETRY)),
						pmod,mod,saveseqno,signal))
		    pmod->no_dataerr++;
		    return(TRUE);
	    }
	    return(TRUE);
	}

	if ((rxp->rxbuf[5] & 0x7f) == ASYNC ) {
	    signal = rxp->rxbuf[ASYNSEQIX];
	    if (signal < MAXASYNEVENTS) {

		/* verify message is not too long */
		len = (unsigned short)rxp->rxbuf[2] * 256;
		len = len + rxp->rxbuf[3];
		len = len - ASYNRESPOVERHEAD;
		if ( len > LMPMSGLEN) {
		    pmod->no_dataerr++;
		    return(TRUE);
		}

		/* Store the returned data   */

		for ( i=0; (i<len); i++ ) {
		    pmod->asynevents[signal].asyncmsg[i] =
			rxp->rxbuf[ASYNDATAIX+i];
		}

		pmod->asynevents[signal].asyncmsg[i] = 0; /* NULL */

		pmod->asynevents[signal].asynstrlen = len; 

		pmod->asynevents[signal].asyncmsg_code = 
			rxp->rxbuf[ASYNCLASSIX];


		pmod->asynevents[signal].data_valid = TRUE;

		insertscroll(pmod,pmod->asynevents[signal].asyncmsg,
			     (line & (~ONERETRY)));
 
	    }
	    else {
		pmod->no_dataerr++;
	    }

	}

	return(TRUE);	/* Even if data error dont bounce line */

    }


/* 
/* sendasc
*/
static	unsigned short sendasc(unsigned short line, unsigned short mod,
			 unsigned short card, LMPDEV *pmod, unsigned short signal,
			 unsigned char *buf, unsigned short olen)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,j,k,len,tlen,temp;
	short		getresp;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;


	/* Format the output message */

	/* Move in the data and compute the length */

	/* Store the transmit data                      */

	i=0;
	tlen = olen;
	while  (i<LMPMSGLEN) {
	    if ((olen != 0) && (i==tlen)) break;
	    txp->txbuf[i] = buf[i];
	    if (olen == 0) {
		if (buf[i] == 0) {
		    break;
		}
	    }
	    i++;
	}

	if (ltrace[line] == 4) 
		logMsg ( "Ascii output message line - %d = %s\n",
				(line & (~ONERETRY)), txp->txbuf );


	txp->txmsglen = i;

	/* set the receive terminator condition */
	rxp->terminator = signal;

	if (card > MAXASCEVENTS) getresp = (-1);
	else getresp  = 0;

	/* Send out the message */
	if (msgxfer((line + ONERETRY),VARRESP,pmod,getresp) == XFERBAD) {
	    pmod->no_offlines++;


	    if (signal == WFRESP) {
	        /* clear the wave form data area  */
	        for (i=0; (i<WFDATASIZE); i++) {
		    pmod->wf.data[i] = 0;
	        }
	        pmod->wf.was_read = FALSE;
	        pmod->wf.data_valid = FALSE;   /* will get cleared buffer if no data comes back */
	    } else {
		pmod->ascmsg[card].data_valid = FALSE;
	        if ((signal == ENDTIME) || (signal == ENDAACRLF)) {
	            for ( i=card; ((i < (card+8))&&(i < MAXASCEVENTS));i++)
		        pmod->ascmsg[i].data_valid = FALSE;
	        }
	    }

	    /*pmod->is_responding = FALSE; !! Temporary*/
	    return(TRUE);
	}

	if (getresp == -1) return (TRUE);

	if ((signal == ENDTIME) || (signal == ENDAACRLF)) {
	    for ( i=card; ((i < (card+8))&&(i < MAXASCEVENTS));i++)
		pmod->ascmsg[i].adatabuf[0] = 0;
	}

	if (signal == WFRESP) {
	    /* process wave form response */
	    for (i=0; (i<rxp->rxix); i+=2) {
		pmod->wf.data[i/2] = (((unsigned short)rxp->rxbuf[i] << 8) + rxp->rxbuf[i+1]);
	    }
	    pmod->wf.was_requested = TRUE;
	    pmod->wf.data_valid = TRUE;
	    pmod->wf.was_read = FALSE;
	    return (TRUE);
	}

	/* If Response is too large to hold */
	if (rxp->rxix > LMPMSGLEN) {
	    return(TRUE);
	}

	/* If a response was received ok save it */
	for (i=0,j=0,k=card; (i<rxp->rxix); i++) {
	    if (j > LMPMSGLEN) return(TRUE);
	    pmod->ascmsg[k].adatabuf[j++] = rxp->rxbuf[i];
	    if (((signal== ENDTIME) || (signal == ENDAACRLF)) && (rxp->rxbuf[i] == LF)) {
		pmod->ascmsg[k].astrlen = j;
		pmod->ascmsg[k].data_valid = TRUE;
		j=0;
		k++;
		if (k >= MAXASCEVENTS) return (TRUE);
	    }
	}
	pmod->ascmsg[card].astrlen = rxp->rxix;
	pmod->ascmsg[i].adatabuf[pmod->ascmsg[i].astrlen] = 0; /* terminare the message */
	pmod->ascmsg[card].data_valid = TRUE;
	return(TRUE);

    }


/*
/*	Scan a Mimic down convertor
/*
*/
static getmim1status(unsigned short line, unsigned short mod,
		          LMPDEV *pmod)
   {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,saveseqno,temp;
	long		value;

	checkoutputs(line);

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] = MIMICOPEN;
	txp->txbuf[1] = MIMICADDR;
	txp->txbuf[2] = M1STATREQ;
	txp->txbuf[3] = MIMICCLOSE;

        makesum(&txp->txbuf[0], 4, &txp->txbuf[4]);

	txp->txmsglen = 5;

	/* Send out the message */

	if (msgxfer((line + ONERETRY),VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[1] != MIMICADDR) ||
	    (rxp->rxbuf[2] != M1STATREQ) ||
	    (rxp->rxbuf[3] != 'T') ||
	    (rxp->rxbuf[7] != 'R') ||
	    (rxp->rxbuf[10] != 'M') ||
	    (rxp->rxbuf[12] != '?') ) {

	    pmod->no_dataerr++;
	    return(TRUE);

	}
	/* If a response was received ok save it */
	if (!makenum(&rxp->rxbuf[4],3,&value)) return;
	pmod->mimic1.atten = value;
	if (rxp->rxbuf[8] == '0') (pmod->mimic1.status &= (~0x80));
	else (pmod->mimic1.status |= (0x80));
	if (rxp->rxbuf[9] == '0') (pmod->mimic1.status &= (~0x40));
	else (pmod->mimic1.status |= (0x40));
	if (rxp->rxbuf[11] == '0') (pmod->mimic1.status &= (~0x20));
	else (pmod->mimic1.status |= (0x20));
	if (rxp->rxbuf[13] == '0') (pmod->mimic1.status &= (~0x10));
	else (pmod->mimic1.status |= (0x10));
	if (rxp->rxbuf[14] == '0') (pmod->mimic1.status &= (~0x08));
	else (pmod->mimic1.status |= (0x08));
	if (rxp->rxbuf[15] == '0') (pmod->mimic1.status &= (~0x04));
	else (pmod->mimic1.status |= (0x04));

	pmod->mimic1.data_valid = TRUE;

	return(TRUE);

    }

/* 
/* sendmim1 binary output
*/
static	unsigned short sendmim1bo (unsigned short line, unsigned short mod,
			 LMPDEV *pmod, unsigned short signal,
			 unsigned long bval)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,saveseqno,temp;
	unsigned char command;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	/* Format the output message */

	txp->txbuf[0] = MIMICOPEN;
	txp->txbuf[1] = MIMICADDR;

	if (signal == 0) command = M1DECATTEN;
	if (signal == 1) command = M1INCATTEN;
	if (signal == 2) command = M1MUTE;
	if (signal == 3) command = M1UNMUTE;

	txp->txbuf[2] = command; 

	txp->txbuf[3] = MIMICCLOSE;

        makesum(&txp->txbuf[0], 4, &txp->txbuf[4]);

	txp->txmsglen = 5;

	/* Send out the message */

	if (msgxfer((line + ONERETRY),VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[1] != MIMICADDR) ||
	    (rxp->rxbuf[2] != command) ) {

	    pmod->no_dataerr++;
	    return(TRUE);

	}

	return (TRUE);
    }


/*
/* 
/* sendmim1 analog output
*/
static	unsigned short sendmim1ao (unsigned short line, unsigned short mod,
			 LMPDEV *pmod, unsigned short signal,
			 int oval)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	long		power;
	unsigned short  i,len,tlen,saveseqno,temp,olen;
	unsigned char command;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	/* Format the output message */

	txp->txbuf[0] = MIMICOPEN;
	txp->txbuf[1] = MIMICADDR;

	if (signal == 0) {
	    return (TRUE);
	}
	else  {
	    command = M1ATTENSET;
	    power = (long) 1000;
	    olen = 3;
	}

	txp->txbuf[2] = command; 
	oval = (oval % power);
	power = (power/10);

	for (i=0; (i<olen); i++) {
	    txp->txbuf[3+i] = (oval/power)+'0';
	    oval = (oval % power);
	    power = (power/10);
	}

	txp->txbuf[3+olen] = MIMICCLOSE;

        makesum(&txp->txbuf[0], (4+olen), &txp->txbuf[(4+olen)]);

	txp->txmsglen = (5+olen);

	/* Send out the message */

	if (msgxfer((line + ONERETRY),VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[1] != MIMICADDR) ||
	    (rxp->rxbuf[2] != command) ) {

	    pmod->no_dataerr++;
	    return(TRUE);

	}

	return (TRUE);
    }


/*
/*	Scan a Mimic LNA
/*
*/
static getmim2status(unsigned short line, unsigned short mod,
		          LMPDEV *pmod)
   {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,saveseqno,temp;
	long		value;

	checkoutputs(line);

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] = MIMICOPEN;
	txp->txbuf[1] = LNAADDR;
	txp->txbuf[2] = M2STATREQ;
	txp->txbuf[3] = MIMICCLOSE;

        makesum(&txp->txbuf[0], 4, &txp->txbuf[4]);

	txp->txmsglen = 5;

	/* Send out the message */

	if (msgxfer((line | ONERETRY),VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[1] != LNAADDR) ||
	    (rxp->rxbuf[2] != M2STATREQ) ||
	    (rxp->rxbuf[6] != 'S') ||
	    (rxp->rxbuf[8] != 'L') ||
	    (rxp->rxbuf[3] != 'P') ||
	    (rxp->rxbuf[10] != '?') ) {

	    pmod->no_dataerr++;
	    return(TRUE);

	}

	/* If a response was received ok save it */
	if (rxp->rxbuf[7] == '0') (pmod->mimic2.status &= (~0x80));
	else (pmod->mimic2.status |= (0x80));
	if (rxp->rxbuf[9] == '0') (pmod->mimic2.status &= (~0x40));
	else (pmod->mimic2.status |= (0x40));
	if (rxp->rxbuf[4] == '0') (pmod->mimic2.status &= (~0x20));
	else (pmod->mimic2.status |= (0x20));
	if (rxp->rxbuf[5] == '0') (pmod->mimic2.status &= (~0x10));
	else (pmod->mimic2.status |= (0x10));
	if (rxp->rxbuf[11] == '0') (pmod->mimic2.status &= (~0x08));
	else (pmod->mimic2.status |= (0x08));
	if (rxp->rxbuf[12] == '0') (pmod->mimic2.status &= (~0x04));
	else (pmod->mimic2.status |= (0x04));
	if (rxp->rxbuf[13] == '0') (pmod->mimic2.status &= (~0x02));
	else (pmod->mimic2.status |= (0x02));
	if (rxp->rxbuf[14] == '0') (pmod->mimic2.status &= (~0x01));
	else (pmod->mimic2.status |= (0x01));

	pmod->mimic2.data_valid = TRUE;

	return(TRUE);

    }

/* 
/* sendmim2 binary output
*/
static	unsigned short sendmim2bo (unsigned short line, unsigned short mod,
			 LMPDEV *pmod, unsigned short signal,
			 unsigned long bval)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,saveseqno,temp;
	unsigned char command, insw, outsw ,amsw;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	/* Format the output message */

	txp->txbuf[0] = MIMICOPEN;
	txp->txbuf[1] = LNAADDR;

	if (signal == 0)  {
	    txp->txbuf[2] = command = M2ONOFFSET;
	    insw = outsw =  '0';
	    if (bval & 1) insw = '1';
	    if (bval & 2) outsw = '1';

	    txp->txbuf[3] = insw;
	    txp->txbuf[4] = outsw;

	    txp->txbuf[5] = MIMICCLOSE;

	    makesum(&txp->txbuf[0], 6, &txp->txbuf[6]);

	    txp->txmsglen = 7;
	}

	else {
	     txp->txbuf[2] = command = M2AUTOMANSET;

	    amsw =  '0';
	    if (bval & 4) amsw = '1';

	    txp->txbuf[3] = amsw;

	    txp->txbuf[4] = MIMICCLOSE;

	    makesum(&txp->txbuf[0], 5, &txp->txbuf[5]);

	    txp->txmsglen = 6;

	}

	/* Send out the message */

	if (msgxfer((line | ONERETRY),VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[1] != LNAADDR) ||
	    (rxp->rxbuf[2] != command) ) {

	    pmod->no_dataerr++;
	    return(TRUE);

	}

	return (TRUE);
    }

/*
/*	Scan a Mimic up convertor
/*
*/
static getmim3status(unsigned short line, unsigned short mod,
		          LMPDEV *pmod)
   {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,saveseqno,temp;
	long		value;

	checkoutputs(line);

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] = MIMICOPEN;
	txp->txbuf[1] = MIMICADDR;
	txp->txbuf[2] = M3STATREQ;
	txp->txbuf[3] = MIMICCLOSE;

        makesum(&txp->txbuf[0], 4, &txp->txbuf[4]);

	txp->txmsglen = 5;

	/* Send out the message */

	if (msgxfer((line | ONERETRY),VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[1] != MIMICADDR) ||
	    (rxp->rxbuf[2] != M1STATREQ) ||
	    (rxp->rxbuf[3] != 'T') ||
	    (rxp->rxbuf[4] != '1') ||
	    (rxp->rxbuf[8] != 'T') ||
	    (rxp->rxbuf[9] != '2') ||
	    (rxp->rxbuf[13] != 'R') ||
	    (rxp->rxbuf[16] != 'M') ||
	    (rxp->rxbuf[18] != '?') ) {

	    pmod->no_dataerr++;
	    return(TRUE);

	}
	/* If a response was received ok save it */
	if (!makenum(&rxp->rxbuf[5],3,&value)) return;
	pmod->mimic3.atten[0] = value;
	if (!makenum(&rxp->rxbuf[10],3,&value)) return;
	pmod->mimic3.atten[1] = value;
	if (rxp->rxbuf[14] == '0') (pmod->mimic3.status &= (~0x80));
	else (pmod->mimic3.status |= (0x80));
	if (rxp->rxbuf[15] == '0') (pmod->mimic3.status &= (~0x40));
	else (pmod->mimic3.status |= (0x40));
	if (rxp->rxbuf[17] == '0') (pmod->mimic3.status &= (~0x20));
	else (pmod->mimic3.status |= (0x20));
	if (rxp->rxbuf[19] == '0') (pmod->mimic3.status &= (~0x10));
	else (pmod->mimic3.status |= (0x10));
	if (rxp->rxbuf[20] == '0') (pmod->mimic3.status &= (~0x08));
	else (pmod->mimic3.status |= (0x08));
	if (rxp->rxbuf[21] == '0') (pmod->mimic3.status &= (~0x04));
	else (pmod->mimic3.status |= (0x04));

	pmod->mimic3.data_valid = TRUE;

	return(TRUE);

    }

/* 
/* sendmim3 binary output
*/
static	unsigned short sendmim3bo (unsigned short line, unsigned short mod,
			 LMPDEV *pmod, unsigned short signal,
			 unsigned long bval)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,saveseqno,temp;
	unsigned char command;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	i = 0;

	/* Format the output message */

	txp->txbuf[i++] = MIMICOPEN;
	txp->txbuf[i++] = MIMICADDR;

	if (signal == 0) command = M3DECATTEN;
	if (signal == 1) command = M3DECATTEN;
	if (signal == 2) command = M3INCATTEN;
	if (signal == 3) command = M3INCATTEN;
	if (signal == 4) command = M3MUTE;
	if (signal == 5) command = M3UNMUTE;

	txp->txbuf[i++] = command; 

	if ((signal == 0) || (signal == 2)) {
	    txp->txbuf[i++] = '1';
	}

	if ((signal == 1) || (signal == 3)) {
	    txp->txbuf[i++] = '2';
	}

	txp->txbuf[i++] = MIMICCLOSE;

        makesum(&txp->txbuf[0], i, &txp->txbuf[i]);

	txp->txmsglen = i+1;

	/* Send out the message */

	if (msgxfer((line + ONERETRY),VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[1] != MIMICADDR) ||
	    (rxp->rxbuf[2] != command) ) {

	    pmod->no_dataerr++;
	    return(TRUE);

	}

	return (TRUE);
    }


/*
/* 
/* sendmim3 analog output
*/
static	unsigned short sendmim3ao (unsigned short line, unsigned short mod,
			 LMPDEV *pmod, unsigned short signal,
			 int oval)

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	long		power;
	unsigned short  i,len,tlen,saveseqno,temp,olen;
	unsigned char command,id;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	/* Format the output message */

	txp->txbuf[0] = MIMICOPEN;
	txp->txbuf[1] = MIMICADDR;

	if (signal == 0) {
	    id = '1';
	}
	else  {
	    id = '2';
	}

	command = M3ATTENSET;
	power = (long) 1000;
	olen = 3;

	txp->txbuf[2] = command; 
	txp->txbuf[3] = id;

	oval = (oval % power);
	power = (power/10);

	for (i=0; (i<olen); i++) {
	    txp->txbuf[4+i] = (oval/power)+'0';
	    oval = (oval % power);
	    power = (power/10);
	}

	txp->txbuf[4+olen] = MIMICCLOSE;

        makesum(&txp->txbuf[0], (5+olen), &txp->txbuf[(5+olen)]);

	txp->txmsglen = (6+olen);

	/* Send out the message */

	if (msgxfer((line + ONERETRY),VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[1] != MIMICADDR) ||
	    (rxp->rxbuf[2] != command) ) {

	    pmod->no_dataerr++;
	    return(TRUE);

	}

	return (TRUE);
    }



/*
/*	Set the GPIB convertortime out to 100 ms
/*
*/
static hpatimeoutset(unsigned short line,unsigned short issue_reset)
   {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,saveseqno,temp,tsval;
	long		value;

	/* Set up pointers for comm buffers */
	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	if (issue_reset) {
	    txp->txbuf[0] = '@';
	    txp->txbuf[1] = '@';
	    /* Send out the message */

	    txp->txmsglen = 2;

	    msgxfer((line | ONERETRY),VARRESP,0,-1);

	    taskDelay(300); /* wait 5 seconds after reset */
	}


	txp->txbuf[0] =  'T'; 
	txp->txbuf[1] =  'I';
	txp->txbuf[2] =  'M';
	txp->txbuf[3] =  'E';
	txp->txbuf[4] =  ' ';
	txp->txbuf[5] =  'O';
	txp->txbuf[6] =  'U';
	txp->txbuf[7] =  'T';
	txp->txbuf[8] =  ' ';
	txp->txbuf[9] =  '1';
	txp->txbuf[10] = 0x0d;
	txp->txbuf[11] = 0x0a;
	/* Send out the message */

	txp->txmsglen = 12;

	msgxfer((line | ONERETRY),VARRESP,0,-1);

    }
	

/*
/*	Scan a HPA
/*
*/
static gethpastatus(unsigned short line, unsigned short mod,
		          LMPDEV *pmod, unsigned char type,
				 unsigned short unit)
   {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,saveseqno,temp,tsval;
	long		value;

	checkoutputs(line);

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Insert the header to talk to the converter */
	gpibheader(txp,hpaids[unit],5);

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0+GPIBHEADERLEN] = HPASOM;
	txp->txbuf[1+GPIBHEADERLEN] = HPASTATTLEN;
	txp->txbuf[2+GPIBHEADERLEN] = HPASTAT;
	txp->txbuf[3+GPIBHEADERLEN] = type;

        makehpasum(&txp->txbuf[0+GPIBHEADERLEN], 4, &txp->txbuf[4+GPIBHEADERLEN]);

	txp->txbuf[ 5+GPIBHEADERLEN ] = 0x0a;	/* Trailing NewLine */
	txp->txmsglen = 5+GPIBHEADERLEN+1;

	addenter(txp,hpaids[unit]);

	/* Send out the message */

	if (msgxfer((line | ONERETRY),VARRESP,pmod,0) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->hpa[unit].is_responding = FALSE;
	    pmod->is_responding = ((pmod->hpa[0].is_responding) || (pmod->hpa[1].is_responding));
	    return(pmod->is_responding);
	}

	/* Verify the response */

	if ((rxp->rxbuf[2] != HPASTAT) ||
	    (rxp->rxbuf[3] != type)  ) {

	    pmod->no_dataerr++;
	    return(TRUE);
	}

	switch (type) {
	    case (HPASTATUPDATE):
		for (i=0; (i<((MAXHPASTATBITS+7)/8));i++) {
		    pmod->hpa[unit].hpastat.statbits[i] = rxp->rxbuf[5+i];
		}
		pmod->hpa[unit].hpastat.fltcnt = rxp->rxbuf[13];
		pmod->hpa[unit].hpastat.almcnt = rxp->rxbuf[14];
		tsval = ((unsigned short)rxp->rxbuf[15] << 8);
		tsval += rxp->rxbuf[15+1];
		pmod->hpa[unit].hpastat.ftd = tsval;

		for (i=0; (i<MAXHPAOPPARAMS); i++) {
		    tsval = ((unsigned short)rxp->rxbuf[17+(i*2)] << 8);
		    tsval += rxp->rxbuf[17+(i*2)+1];
		    pmod->hpa[unit].hpastat.opparams[i] = tsval;
		}
		pmod->hpa[unit].hpastat.data_valid = TRUE;
		break;

	    case (HPASTATHW):
		for (i=0; (i<MAXHPAHWLIMITS); i++) {
		    tsval = ((unsigned short)rxp->rxbuf[5+(i*2)] << 8);
		    tsval += rxp->rxbuf[5+(i*2)+1];
		    pmod->hpa[unit].hpahwlimits.limits[i] = tsval;
		}
		pmod->hpa[unit].hpahwlimits.data_valid = TRUE;
		break;

	    case (HPASTATLOW):
		for (i=0; (i<MAXHPASWLLIMITS); i++) {
		    tsval = ((unsigned short)rxp->rxbuf[5+(i*2)] << 8);
		    tsval += rxp->rxbuf[5+(i*2)+1];
		    pmod->hpa[unit].hpaswllimits.limits[i] = tsval;
		}
		pmod->hpa[unit].hpaswllimits.data_valid = TRUE;
		break;

	    case (HPASTATHIGH):
		for (i=0; (i<MAXHPASWHLIMITS); i++) {
		    tsval = ((unsigned short)rxp->rxbuf[5+(i*2)] << 8);
		    tsval += rxp->rxbuf[5+(i*2)+1];
		    pmod->hpa[unit].hpaswhlimits.limits[i] = tsval;
		}
		pmod->hpa[unit].hpaswhlimits.data_valid = TRUE;
		break;

	    case (HPASTATCHN):
		pmod->hpa[unit].hpachnfreq.numchans = rxp->rxbuf[5];
		pmod->hpa[unit].hpachnfreq.curchan = rxp->rxbuf[6];
		for (i=0; (i<MAXHPACHCHGFREQ); i++) {
		    value = ((unsigned long)rxp->rxbuf[7+(i*4)+0] << 24);
		    value += ((unsigned long)rxp->rxbuf[7+(i*4)+1] << 16);
		    value += ((unsigned long)rxp->rxbuf[7+(i*4)+2] << 8);
		    value += rxp->rxbuf[7+(i*4)+3];
		    /* Force to a float */
		    (long)pmod->hpa[unit].hpachnfreq.freqs[i] = value;
		}
		pmod->hpa[unit].hpachnfreq.data_valid = TRUE;
		break;

	}

	return(TRUE);

    }




static char hpabocmds[] =  {"HFRPTLOAAW"};
static char hpabocmd0v[] = {"0D@I@@M@@D"};
static char hpabocmd1v[] = {"1A*E**ARLE"};
static unsigned short hpabocmdl[] = {2,2,1,2,1,1,2,4,4,2,};



/*
/*	sendhpabo
/*
*/
static int sendhpabo (unsigned short line, unsigned short mod,
			 LMPDEV *pmod, unsigned short signal,
			 unsigned long bval)

   {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i,len,tlen,saveseqno,temp,tsval,unit;
	long		value;

	if (mod == HPASEG) unit = 0;
	else unit = 1;

	if ((signal == SHPARESETBO) && (bval != 0)) {
	    hpatimeoutset(line,TRUE);
	    if (ltrace[line] == 1)
		logMsg ("HPA RESET ISSUED FOR LINE - %d \n",
			line);
	    return(TRUE);
	}



	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	/* Format the output message */

	txp->txbuf[0+GPIBHEADERLEN] = HPASOM;
	txp->txbuf[1+GPIBHEADERLEN] = hpabocmdl[signal];

	txp->txbuf[2+GPIBHEADERLEN] = hpabocmds[signal];
	if (bval == 0) {
	    if (hpabocmd0v[signal] == '@') return (TRUE);
	    if (hpabocmd0v[signal] != '*')
		    txp->txbuf[3+GPIBHEADERLEN] = hpabocmd0v[signal];
	}
	else {
	    if (hpabocmd1v[signal] == '@') return (TRUE);
	    if (hpabocmd1v[signal] != '*')
		    txp->txbuf[3+GPIBHEADERLEN] = hpabocmd1v[signal];
	}

	len = hpabocmdl[signal]+2;

        makehpasum(&txp->txbuf[0+GPIBHEADERLEN], len, &txp->txbuf[len+GPIBHEADERLEN]);

	len++;	/* send out the checksum too */

	/* Insert the header to talk to the converter */
	gpibheader(txp,hpaids[unit],len);

	txp->txbuf[ len+GPIBHEADERLEN ] = 0x0a;	/* Trailing NewLine */

	txp->txmsglen = len+GPIBHEADERLEN+1;

	/* Send out the message */

	if (msgxfer((line | ONERETRY),VARRESP,pmod,(-1)) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->hpa[unit].is_responding = FALSE;
	    if (!((pmod->hpa[0].is_responding) || (pmod->hpa[1].is_responding)) ) return(FALSE);
	    return(TRUE);
	}
	return (hpaconfirmcmd(line,pmod,hpaids[unit]));

    }




/*
/*	sendhpabo
/*
*/
static int sendhpaao (unsigned short line, unsigned short mod,
			 LMPDEV *pmod, unsigned short signal,
			 int val)

   {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  len,unit;

	/* need segment to determint gpid addr */
	if (mod == HPASEG) unit = 0;
	else unit = 1;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	txp->txbuf[0+GPIBHEADERLEN] = HPASOM;

	/* Format the output message */

	if (signal == 0) {
	    len = txp->txbuf[1+GPIBHEADERLEN] = 4;
	    txp->txbuf[2+GPIBHEADERLEN] = HPAOUTPWR;
	    txp->txbuf[3+GPIBHEADERLEN] = HPAOUTPWVAL;
	    txp->txbuf[4+GPIBHEADERLEN] = ((val/256) & 0xff);
	    txp->txbuf[5+GPIBHEADERLEN] = (val & 0xff);
	}
	if ((signal >= 1) && (signal <= 32) ){
	    len = txp->txbuf[1+GPIBHEADERLEN] = 4;
	    txp->txbuf[2+GPIBHEADERLEN] = HPACHGSLL;
	    txp->txbuf[3+GPIBHEADERLEN] = (signal-1);
	    txp->txbuf[4+GPIBHEADERLEN] = ((val/256) & 0xff);
	    txp->txbuf[5+GPIBHEADERLEN] = (val & 0xff);
	}
	if ((signal >= 33) && (signal <= 64) ){
	    len = txp->txbuf[1+GPIBHEADERLEN] = 4;
	    txp->txbuf[2+GPIBHEADERLEN] = HPACHGSHL;
	    txp->txbuf[3+GPIBHEADERLEN] = (signal-33);
	    txp->txbuf[4+GPIBHEADERLEN] = ((val/256) & 0xff);
	    txp->txbuf[5+GPIBHEADERLEN] = (val & 0xff);
	}
	if (signal == 65) {
	    len = txp->txbuf[1+GPIBHEADERLEN] = 2;
	    txp->txbuf[2+GPIBHEADERLEN] = HPACHGCHN;
	    txp->txbuf[3+GPIBHEADERLEN] = (val & 0xff);
	}

	len = len+2;

        makehpasum(&txp->txbuf[0+GPIBHEADERLEN], len, &txp->txbuf[len+GPIBHEADERLEN]);

	/* Insert the header to talk to the converter */
	gpibheader(txp,hpaids[unit],len+1);

	txp->txbuf[ len+GPIBHEADERLEN+1] = 0x0a;	/* Trailing NewLine */


	txp->txmsglen = len+GPIBHEADERLEN+2;

	/* Send out the message */

	if (msgxfer((line | ONERETRY),VARRESP,pmod,(-1)) == XFERBAD) {
	    pmod->no_offlines++;
	    pmod->hpa[unit].is_responding = FALSE;
	    if (!((pmod->hpa[0].is_responding) || (pmod->hpa[1].is_responding)) ) return(FALSE);
	    return(TRUE);
	}
	return (hpaconfirmcmd(line,pmod,hpaids[unit]));

    }


/*
/*	hpaconfirmcmd
*/
static hpaconfirmcmd(unsigned short line, LMPDEV *pmod,unsigned short gpibid)

    {
	TXLINE  *txp;
	RXLINE  *rxp;


	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	txp->txbuf[0] =  'S'; 
	txp->txbuf[1] =  'P';
	txp->txbuf[2] =  'O';
	txp->txbuf[3] =  'L';
	txp->txbuf[4] =  'L';
	txp->txbuf[5] =  ' ';
	txp->txbuf[6] =  (gpibid/10)+'0';
	txp->txbuf[7] =  (gpibid%10)+'0';
	txp->txbuf[8] =  0x0d;
	txp->txbuf[9] =  0x0a;
	txp->txmsglen = 10;

	msgxfer((line | ONERETRY),VARRESP,0,-1);
	
	return (TRUE);
    }
	 
/*
/*	gpibheader
*/
static void gpibheader(TXLINE *txp,unsigned short gpibid, unsigned short len)

    {
	txp->txbuf[0] =  'O'; 
	txp->txbuf[1] =  'U';
	txp->txbuf[2] =  'T';
	txp->txbuf[3] =  'P';
	txp->txbuf[4] =  'U';
	txp->txbuf[5] =  'T';
	txp->txbuf[6] =  (gpibid/10)+'0';
	txp->txbuf[7] =  (gpibid%10)+'0';
	txp->txbuf[8] =  '#';
	txp->txbuf[9] =  (len/10)+'0';
	txp->txbuf[10] =  (len%10)+'0';
	txp->txbuf[11] = ';';

    }


/*
/*	addenter
*/
static void addenter(TXLINE *txp,unsigned short gpibid)

    {
	unsigned short len;
	len = txp->txmsglen;

	txp->txbuf[txp->txmsglen++] =  'E'; 
	txp->txbuf[txp->txmsglen++] =  'N';
	txp->txbuf[txp->txmsglen++] =  'T';
	txp->txbuf[txp->txmsglen++] =  'E';
	txp->txbuf[txp->txmsglen++] =  'R';
	txp->txbuf[txp->txmsglen++] =  (gpibid/10)+'0';
	txp->txbuf[txp->txmsglen++] =  (gpibid%10)+'0';
	txp->txbuf[txp->txmsglen++] =  ' ';
	txp->txbuf[txp->txmsglen++] =  'E';
	txp->txbuf[txp->txmsglen++] =  'O';
	txp->txbuf[txp->txmsglen++] =  'I';
	txp->txbuf[txp->txmsglen++] = 0x0d;
	txp->txbuf[txp->txmsglen++] = 0x0a;
    }



/*
/* makenum
/*
*/
static int makenum(char *buf,unsigned short len, long *value)

    {
	unsigned short i,sign,offset;

	offset = 0;
	sign = FALSE;
	if (buf[i] == '-') {
	    sign = TRUE;
	    offset = 1;
	}
	*value = 0;
	for (i=offset;(i<len);i++) {
	    if ((buf[i]<'0')||(buf[i]>'9')) return (FALSE);
	    *value = (*value*10)+(buf[i]-'0');
	}
	if (sign) *value = -*value;

	return (TRUE);

    }



/* makecrc
/*
*/
static	void makecrc( unsigned char *chkbuf, int len,char unsigned *retbuf)

    {
	unsigned short checksum;
	unsigned int     i, j;
	unsigned short   flag;
	unsigned char   tempch;

	checksum = 0x0ffff;
	for (j = 0; j < len; j++) {
	    tempch = chkbuf [j];
	    checksum ^= tempch;
	    for (i = 0; i < 8; i++)
	    {
		flag = checksum & 1;
		checksum >>= 1;
		if (flag) {
		    checksum ^= (unsigned short) 0x0a001;
		}
	    }
	}
	retbuf[1] = ((checksum >> 8) & 0xff);
	retbuf[0] = (checksum & 0xff);
}

/* makesum
/*
*/
static	void makesum( unsigned char *chkbuf, int len,char unsigned *retbuf)

    {
	unsigned short checksum;
	unsigned int     i, j;

	checksum = 0;
	for (j = 0; j < len; j++) {
	    checksum += (chkbuf[j]-32);
	}
	retbuf[0] = ((checksum % 95)+32);
}


/* makehpasum
/*
*/
static	void makehpasum( unsigned char *chkbuf, int len,char unsigned *retbuf)

    {
	unsigned short checksum;
	unsigned int     i, j;

	checksum = 0;
	for (j = 0; j < len; j++) {
	    checksum ^= (chkbuf[j]);
	}
	retbuf[0] = checksum;
}



/*
/*      hexascii
/*
/*      The purpose of this routine is to convert the hex byte to 2 ascii
/*      characters and to place them into the buffer.
/*
*/
static	void hexascii(unsigned short val,char *buf)

    {
	char    hi,lo;

	hi = ((val & 0x0f0) >> 4);
	lo = (val & 0x0f);

	if (hi<=9)  hi+='0'; else hi+=('A'-10);
	if (lo<=9)  lo+='0'; else lo+=('A'-10);

	buf[0] = hi;
	buf[1] = lo;

    }


/*
/*      asciihex
/*
/*      The purpose of this routine is to convert the next 2 ascii
/*      characters in the buffer to hex and return them in val. It
/*      will return TRUE if good converdion of FALSE if bad.
*/
static	short asciihex(unsigned short *val,char *buf)

    {

	if ((buf[0] < '0') || (buf[0] > 'F')) return (FALSE);
	if ( buf[0] <= '9') *val = ((buf[0] & 0x0f) << 4);
	else {
	    if (buf[0] < 'A') return (FALSE);
	    else *val = ((buf[0] - 'A' + 10) << 4);
	}
	if ((buf[1] < '0') || (buf[1] > 'F')) return (FALSE);
	if ( buf[1] <= '9') *val += (buf[1] & 0x0f);
	else {
	    if (buf[1] < 'A') return (FALSE);
	    else *val += (buf[1] - 'A' + 10);
	}
	return (TRUE);
    }



/*
/*      dump_lmp_table
/*
/*      The purpose of this routine is to dump the module description
/*      portion of the analog devices driver tables for the selected line.
/*      It will print out two lines for each module which is responding.
/*      The first line will give the general module header, the second line
/*      will give module type specific info.
*/
static	void dump_lmp_table(unsigned short line)

    {
	LMPDEV  *pmod;
	short           ix;



	if (!plcs[line]) return;

	if (line != line) return;  /* No Warnings */
	for (ix=0; ix<NUMLMPDEVS; ix++) {
	    pmod = plcs[line]+ix;
	    if (pmod->is_responding) {


	    }
	}
    }

/*
/* dump line statistics
*/
lmpstats(unsigned short line)
    {
	return (lmpaidump(line,999,0,0,0));
    }

/*
/*      aidump
/*
/*      This routines main purpose is to return a pointer to 
/*      the analog input value for the specified module. For a module value
/*      a (-1) will be returned if there is no valid data ready.
/*	a (-2) will be returned if the module is in hold state
*/
int lmpaidump (unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned short conversion)

    {
	LMPDEV  *pmod;
	unsigned short  len,i,ix;
	unsigned char	*pdata;

	if (!plcs [link]) {
	    logMsg ("PLC Not Defined \n");
	    return (-1);
	}

	if (link >= LMPLINES) {
	    logMsg ("Line number too high\n");
	    return (-1);
	}

	if ((adapter >= MAXSEGS) && (adapter != DIRSEG) && 
	     (adapter  != DIRCODESEG) && (adapter != ASYNSEG) &&
	     (adapter  != ASCIISEG) && (adapter != MIMICUDCSEG) &&
	     (adapter != HPASEG) && (adapter != HPASEG2) &&
	     (adapter != PSEUDO) && (adapter != MIMICUPSEG)  &&
	     (adapter != ASCIICNVSEG) ){

	    logMsg ("Bad adapter value \n");
	    return (-1);
	}

	pmod = plcs [link];

	switch (conversion) {

	    case(LMPCNVINTEGER):
		len = 2;
		break;
	    case(LMPCNVDOUBLEINT):
		len = 4;
		break;
	    case(LMPCNVFLOAT):
		len = 4;
		break;
	    case(LMPCNVDOUBLEFLT):
		len = 8;
		break;
	    case(LMPCNVASCIIFLT):
		len = 12;
		break;
/*
/*	    case(LMPCNVTIME):
/*		len = 12;
/*		break;
/*	    case(LMPCNVASCII_2):
/*		len = 2;
/*		break;
/*	    case(LMPCNVASCII_4):
/*		len = 2;
/*		break;
/*	    case(LMPCNVASCII_12):
/*		len = 12;
/*		break;
/*	    case(LMPCNVASCII_20):
/*		len = 20;
/*		break;
*/
	    default:
		len = 2;
		break;

 	}

	if ((adapter < MAXSEGS) &&
	    (((card)+len) >= (pmod->segments[adapter].size-2))) {
	    return (-1);
	}
	if ((adapter == DIRSEG) && (card >= (RESBUFLEN))) {
	    return (-1);
	}
	if ((adapter == DIRCODESEG) && (card >= (RESBUFLEN))) {
	    return (-1);
	}
	if ((adapter == ASYNSEG) && (card >= (MAXASYNEVENTS))) {
	    return (-1);
	}

	if (((adapter == ASCIISEG) ||(adapter == ASCIICNVSEG))  && 
	    (card >= (MAXASCEVENTS)) ) {
	    return (-1);
	}

	if ((adapter == HPASEG) && (card != 0)) {
	    return (-1);
	}

	if ((adapter == HPASEG2) && (card != 0)) {
	    return (-1);
	}


	pmod->was_requested = TRUE;

	if (adapter == PSEUDO) {
		logMsg (" Was requested = %d \n", pmod->was_requested);
		logMsg (" Is responding = %d \n", pmod->is_responding);
		logMsg (" Prog Load State = %d \n", pmod->prog_load_stat);
		logMsg (" Prog Load Page = %d \n",  pmod->prog_load_page);
		logMsg (" Prog Number = %d \n", pmod->prog_load_number);
		logMsg (" # Output messages = %d \n", pmod->no_dataout_msgs & 0x7fff);
		logMsg (" # Data in messages = %d \n", pmod->no_datain_msgs & 0x7fff);
		logMsg (" #No Rx Response = %d \n", pmod->no_rxnoresp & 0x7fff);
		logMsg (" #No Tx Responses = %d \n", pmod->no_txnoresp & 0x7fff);
		logMsg (" #Data Errors = %d \n", pmod->no_dataerr & 0x7fff);
		logMsg (" #Retries = %d \n", pmod->no_retries & 0x7fff);
		logMsg (" #Rx Hw Errors = %d \n", pmod->no_rxhwerrs & 0x7fff);
		logMsg (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs & 0x7fff);
		logMsg (" #Crc Errors = %d \n", pmod->no_crcerrs & 0x7fff);
		logMsg (" #Off Lines = %d \n", pmod->no_offlines & 0x7fff);
		logMsg (" Reset Statistics = %d \n", pmod->cmd_reset_stat);
		logMsg (" Force Offline = %d \n", pmod->cmd_force_offline);
		logMsg (" #Failed Outputs = %d \n", pmod->badoutcnt & 0x7fff);
		logMsg (" Directive Sequence Number = %d \n", pmod->dirseqno);
		logMsg (" Asyn Event Seq # = %d \n", pmod->asyneventseqno & 0x7fff);
		logMsg (" #Asyn events = %d \n", pmod->asyneventcount & 0x7fff);
	}

	logMsg (" Resource Responding = %d \n", resresponse[link]);
	logMsg (" Module Is Responding = %d \n", pmod->is_responding );
	logMsg (" Hold flag  = %d \n", pmod->holdflag );

	if (adapter < MAXSEGS) {
	    if (!resresponse[link]) return (-2);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->segments[adapter].data_valid) {
	        logMsg (" Data Not Valid = %d \n");
		return (-1);
	    }

	    if (pmod->segments[adapter].segdatabuf == NULLP) {
	         logMsg (" Segment not allocated \n");
		 return (-1);
	    }
	    pdata = &pmod->segments[adapter].segdatabuf[(card)];
	}

	if (adapter == DIRSEG) {

	    if ((signal+len) >= pmod->responses[card].respstrlen) {
		logMsg ("Not Enough Characters, len = %d \n",pmod->responses[card].respstrlen);
		return (-1);
	    }
	    if (!resresponse[link]) return (-2);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->responses[card].data_valid) {
	        logMsg (" Data Not Valid = %d \n");
		return (-1);
	    }
	    pdata = &pmod->responses[card].response[signal];
	}

	if (adapter == DIRCODESEG) {

	    if (len != 2) {
		logMsg("Invalid Length should be 2 \n");
		return (-1);
	    }
	    if (!resresponse[link]) return (-2);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->responses[card].data_valid) {
	        logMsg (" Data Not Valid = %d \n");
		return (-1);
	    }
	    logMsg( "Dirrective Response Code = %d \n",pmod->responses[card].response_code);
	    return(0);
	}

	if (adapter == ASYNSEG) {

	    if ((signal+len) >= pmod->asynevents[card].asynstrlen) {
		logMsg ("Not Enough Characters, len = %d \n",pmod->asynevents[card].asynstrlen);
		return (-1);
	    }
	    if (!resresponse[link]) return (-2);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->asynevents[card].data_valid) {
	        logMsg (" Data Not Valid = %d \n");
		return (-1);
	    }
	    pdata = &pmod->asynevents[card].asyncmsg[signal];
	}

	if ((adapter == ASCIISEG) ||(adapter == ASCIICNVSEG)) {

	    if ((signal+len) >= pmod->ascmsg[card].astrlen) {
		logMsg ("Not Enough Characters, len = %d \n",pmod->ascmsg[card].astrlen);
		return (-1);
	    }
	    if (!resresponse[link]) return (-2);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->ascmsg[card].data_valid) {
	        logMsg (" Data Not Valid = %d \n");
		return (-1);
	    }
	    pdata = &pmod->ascmsg[card].adatabuf[signal];
	}

	if (adapter == MIMICUDCSEG) {
	    if (signal > MAXM1AISIGNAL ) {
		logMsg("Signal > %d \n",MAXM1AISIGNAL);
		return (-1);
	    }
	    if (!resresponse[link]) return (-2);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->mimic1.data_valid) {
	        logMsg (" Data Not Valid = %d \n");
		return (-1);
	    }
	    switch (signal) {

	        case 1:
		    logMsg ("Value = %d \n",pmod->mimic1.atten);
		    return (0);
		    break;

	        default:
	            logMsg (" Signal Not Valid = %d \n");
		    return (-1);
		    break;
	    }
	}
	if (adapter == MIMICUPSEG) {
	    if (signal > MAXM3AISIGNAL) {
		logMsg("Signal > %d \n",MAXM3AISIGNAL);
		return (-1);
	    }
	    if (!resresponse[link]) return (-2);
	    if (pmod->holdflag) return (-2);
	    if (!pmod->is_responding) return (-1);
	    if (!pmod->mimic3.data_valid) {
	        logMsg (" Data Not Valid = %d \n");
		return (-1);
	    }
	    switch (signal) {

	        case 0:
		    logMsg ("Value = %d \n",pmod->mimic3.atten[0]);
		    return (0);
		    break;

	        case 1:
		    logMsg ("Value = %d \n",pmod->mimic3.atten[1]);
		    return (0);
		    break;

	        default:
	            logMsg (" Signal Not Valid = %d \n");
		    return (-1);
		    break;
	    }

	}

	if ((adapter == HPASEG) || (adapter == HPASEG2)){

	    if (adapter == HPASEG) ix = 0;
	    else ix = 1;

	    if (signal >= MAXHPAAI) {
		logMsg("Signal > %d \n",MAXHPAAI);
		return (-1);
	    }

	    if (signal < SHPAHWLIMS) {
		if (signal >= MAXHPAOPPARAMS+3) {
		    logMsg("Signal > %d \n",MAXHPAOPPARAMS+3);
		    return (-1);
	        }
		if (len != 2) {
		    logMsg("Length Must be 2 \n");
		    return (-1);
		}
		if (!resresponse[link]) return (-2);
		if (pmod->holdflag) return (-2);
		if (!pmod->is_responding) return (-1);
		if (!pmod->hpa[ix].is_responding){
		    logMsg("HPA %d is not responding \n",ix);
		    return (-1);
		}
		if (!pmod->hpa[ix].hpastat.data_valid){
		    logMsg("Data not valid for HPA %d \n",ix);
		    return (-1);
		}
		if (signal == SHPAFLTCNT) {
		    logMsg("Value = %d \n",pmod->hpa[ix].hpastat.fltcnt);
		    return(0);
		}
		if (signal == SHPAALMCNT) {
		    logMsg("Value = %d \n",pmod->hpa[ix].hpastat.almcnt);
		    return(0);
		}
		if (signal == SHPAFTD) {
		    logMsg("Value = %d \n",pmod->hpa[ix].hpastat.ftd);
		    return(0);
		}
		logMsg("Value = %d \n",pmod->hpa[ix].hpastat.opparams[signal-(SHPAFTD+1)]);
		return(0);
	    }

	    if ((signal >= SHPAHWLIMS) && (signal < SHPASWLLIMS)) {
		if (signal >= SHPAHWLIMS+MAXHPAHWLIMITS) {
		    logMsg("Signal > %d \n",SHPAHWLIMS+MAXHPAHWLIMITS);
		    return (-1);
	        }
		if (len != 2) {
		    logMsg("Length Must be 2 \n");
		    return (-1);
		}
		if (!resresponse[link]) return (-2);
		if (pmod->holdflag) return (-2);
		if (!pmod->is_responding) return (-1);
		if (!pmod->hpa[ix].hpahwlimits.data_valid){
		    logMsg("Data not valid for HPA %d \n",ix);
		    return (-1);
		}

		logMsg("Value = %d \n",pmod->hpa[ix].hpahwlimits.limits[signal-SHPAHWLIMS]);
		return(0);
	    }


	    if ((signal >= SHPASWLLIMS) && (signal < SHPASWHLIMS)) {
		if (signal >= SHPASWLLIMS+MAXHPASWLLIMITS) {
		    logMsg("Signal > %d \n",SHPASWLLIMS+MAXHPASWLLIMITS);
		    return (-1);
	        }
		if (len != 2) {
		    logMsg("Length Must be 2 \n");
		    return (-1);
		}

		if (!resresponse[link]) return (-2);
		if (pmod->holdflag) return (-2);
		if (!pmod->is_responding) return (-1);
		if (!pmod->hpa[ix].hpaswllimits.data_valid){
		    logMsg("Data not valid for HPA %d \n",ix);
		    return (-1);
		}

		logMsg("Value = %d \n",pmod->hpa[ix].hpaswllimits.limits[signal-SHPASWLLIMS]);
		return(0);
	    }

	    if ((signal >= SHPASWHLIMS) && (signal < SHPANUMCHAN)) {
		if (signal >= SHPASWHLIMS+MAXHPASWHLIMITS) {
		    logMsg("Signal > %d \n",SHPASWHLIMS+MAXHPASWHLIMITS);
		    return (-1);
	        }
		if (len != 2) {
		    logMsg("Length Must be 2 \n");
		    return (-1);
		}

		if (!resresponse[link]) return (-2);
		if (pmod->holdflag) return (-2);
		if (!pmod->is_responding) return (-1);
		if (!pmod->hpa[ix].hpaswhlimits.data_valid){
		    logMsg("Data not valid for HPA %d \n",ix);
		    return (-1);
		}

		logMsg("Value = %d \n",pmod->hpa[ix].hpaswhlimits.limits[signal-SHPASWHLIMS]);
		return(0);
	    }


	    if ((signal >= SHPANUMCHAN) && (signal < MAXHPAAI) ) {
		if (signal >= SHPANUMCHAN+MAXHPACHCHGFREQ+2) {
		    logMsg("Signal > %d \n",SHPANUMCHAN+MAXHPACHCHGFREQ+2);
		    return (-1);
	        }
		if (len != 4) {
		    logMsg("Length Must be 4 \n");
		    return (-1);
		}

		if (!resresponse[link]) return (-2);
		if (pmod->holdflag) return (-2);
		if (!pmod->is_responding) return (-1);
		if (!pmod->hpa[ix].hpachnfreq.data_valid){
		    logMsg("Data not valid for HPA %d \n",ix);
		    return (-1);
		}

		if (card == SHPANUMCHAN) {
		    logMsg("Value = %d \n",pmod->hpa[ix].hpachnfreq.numchans);
		    return(0);
		}
		if (signal == SHPACURCHN) {
		    logMsg("Value = %d \n",pmod->hpa[ix].hpachnfreq.curchan);
		    return(0);
		}
		logMsg("Value = %f \n",pmod->hpa[ix].hpachnfreq.freqs[signal-SHPACURCHN]);
		return(0);
	    }
	}

	switch (conversion) {

	    case(LMPCNVINTEGER):
		logMsg("Value = %d \n",*pdata);
		return(0);
	    case(LMPCNVDOUBLEINT):
		logMsg("Value = %d \n",*pdata);
		return(0);
	    case(LMPCNVFLOAT):
		logMsg("Value = %f \n",*pdata);
		return(0);
	    case(LMPCNVDOUBLEFLT):
		logMsg("Value = %lf \n",*pdata);
		return(0);
	    case(LMPCNVASCIIFLT):
		logMsg("Value = %s \n",*pdata);
		return(0);
	    case(LMPCNVTIME):
		logMsg("Value = %d \n",*pdata);
		return(0);
	    case(LMPCNVASCII_2):
	    case(LMPCNVASCII_4):
	    case(LMPCNVASCII_12):
		logMsg("Value = %s \n",*pdata);
		return(0);
	    case(LMPCNVASCII_20):
		logMsg("Value = %s \n",*pdata);
		return(0);
	    default:
		logMsg("Value = %d \n",*pdata);
		return(0);
 	}
	return(0);
    }

/* 
/* Routine to do hex dump of ascii table for a given line
/*
*/
hexasctbl(unsigned short line)
    {
	LMPDEV  *pmod;
	unsigned short  len,i,j,k;
	unsigned char	*pdata;

	if (!plcs [line]) {
	    logMsg ("PLC Not Defined \n");
	    return (-1);
	}

	if (line >= LMPLINES) {
	    logMsg ("Line number too high\n");
	    return (-1);
	}

	pmod = plcs [line];

	for (i = 0;(i<MAXASYNEVENTS);i++) {
	    if (!pmod->ascmsg[i].data_valid)
		printf("Line %d  Ascii Message %d  - No Data Valid \n",line,i);
	    else {
		printf("Line %d  Ascii Message %d  - Length %d \n",line,i,pmod->ascmsg[i].astrlen);
		for (j=0;(j<pmod->ascmsg[i].astrlen);j++) {
		    if ((j%16)==0) logMsg("\n     ");
		    printf("%02x,",pmod->ascmsg[i].adatabuf[j]);
		}
	    }
	}

	return(TRUE);
    }
/* 
/* Routine to do hex dump of ascii table for a given line
/*
*/
asctbl(unsigned short line)
    {
	LMPDEV  *pmod;
	unsigned short  len,i,j,k;
	unsigned char	*pdata;

	if (!plcs [line]) {
	    logMsg ("PLC Not Defined \n");
	    return (-1);
	}

	if (line >= LMPLINES) {
	    logMsg ("Line number too high\n");
	    return (-1);
	}
	pmod = plcs [line];
	for (i = 0;(i<MAXASYNEVENTS);i++) {
	    if (!pmod->ascmsg[i].data_valid)
		printf("Line %d  Ascii Message %d  - No Data Valid \n",line,i);
	    else {
		printf ("Line %d  Ascii Message %d  - Length %d \n",line,i,pmod->ascmsg[i].astrlen);
		printf("Value = %s \n",pmod->ascmsg[i].adatabuf);
	    }
	}

	return(TRUE);
    }




