/*drvCompumotor_proto.h,v 1.1.1.1 1999/08/03 14:42:09 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/* Name: drvCompumotor_proto.h */

static	long init ();

	void TRACEON (unsigned short line);

	void TRACEOFF (unsigned short line);

	void TRAFFICON (unsigned short line);

	void TRAFFICOFF (unsigned short line);

	void RTRACE (unsigned short line, unsigned short level);

	void RTRACEON (unsigned short line);

	void RTRACEOFf (unsigned short line);

	void TRACELEVEL (unsigned short line, unsigned short level);

        void SIMON (unsigned short line, unsigned short delay, int low,
			int high, int digenable);

        void SIMOFF (unsigned short line);

        void CONTRACEON (unsigned short line);

        void CONTRACEOFF (unsigned short line);

        void RUNTRACEON (unsigned short line);

        void RUNTRACEOFF (unsigned short line);

        void REJECTTRACEON (unsigned short line);

        void REJECTTRACEOFF (unsigned short line);

        void NACKTRACEON (unsigned short line);

        void NACKTRACEOFF (unsigned short line);

        void DEFAULTTRACE (unsigned short line);

	int STOPDRIVER (short ln);

        int STARTDRIVER1 (unsigned short line,
                          char *mode,
                          unsigned short delay,
                          unsigned short hdflag,
                          unsigned short delay1,
                          unsigned short delay2,
                          unsigned short private,
			  unsigned short PosMode);

	void SETCOMM (unsigned short line,
                      unsigned short tickcount1,
                      unsigned short hdflag,
                      unsigned short tickcount2,
                      unsigned short tickcount3);

	void MAIN (unsigned short line,
                   unsigned char *mode,
                   unsigned short delay,
                   unsigned short hdflag,
                   unsigned short delay1,
                   unsigned short delay2,
                   unsigned short private,
		   unsigned short PosMode);

static void getsemaphore (unsigned short line);

static 	void on_line (unsigned short line, unsigned short mod,
			unsigned short PosMode);

static 	void mark_not_valid (CMPMTR  *pmod);

static	void scan_plc (CMPMTR *pmod, unsigned short line, unsigned short mod);

static	void checkoutputs (unsigned short line);

	int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal, short *pvalue,
			unsigned short conversion, unsigned char *resname);

	int AODRIVER (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal, double dvalue,
			unsigned short value, unsigned short conversion,
			unsigned char *resname);

	int AOREAD (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal,
			unsigned short *pvalue, unsigned short conv,
			unsigned char *resname);

	int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal,
			unsigned long mask, unsigned long *pvalue,
			unsigned char *resname);

	int BODRIVER (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal,
			unsigned long value, unsigned long mask,
			unsigned char *resname);

	int BOREAD (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal,
			unsigned long *pvalue, unsigned long mask,
			unsigned char *resname);

        int SIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal,
			unsigned char *pvalue, unsigned short len, unsigned char *resname);

        int SODRIVER (char *pointname, unsigned short link, unsigned short adapter,
			unsigned short card, unsigned short signal,
			unsigned char *value, unsigned short len,
			unsigned char *resname);

static void  register_resource (unsigned short link, CMPMTR *pmod,
				unsigned char *resname, char *pointname);

static	void outqueinit (unsigned short line);

static	OUTQENT *ogetemptyp (unsigned short line);

static	void omarkfull (unsigned short line);

static	OUTQENT *ogetnextp (unsigned short line);

static	void oreleasefull (unsigned short line);

static	void link_status (unsigned short line);

static 	int allocate_plc (unsigned short line, unsigned short plc);

static	void start_rx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus);

static	void stop_rx (unsigned short line );

static	void rx_int_proc (unsigned short line );

static	int check_line_activity (unsigned short line, unsigned short predelay);

static	void start_tx (unsigned short line, SEMAPHORE *semid,
			unsigned short *pstatus);

static	void stop_tx (unsigned short line );

static	void tx_int_proc (unsigned short line );

static	unsigned short msgxfer (unsigned short fline, unsigned short resplen,
				CMPMTR *pmod, int opt_timeout);

static	void init_plc_tab (unsigned short line, unsigned short mod);

static 	void initplc (CMPMTR  *pmod);

static	void initstats (CMPMTR *pmod);

static	unsigned short modloopback (unsigned short line, unsigned short mod,
					CMPMTR *pmod);

static	void prepresponses (unsigned short line);

static	int any_responding (unsigned short line);

static	unsigned short readDFS (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readDFX (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readDPA1 (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readDPE1 (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readDVA1 (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readDVS1 (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readFS (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readIS (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readPR (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readPX (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readR (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readRA (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readRB (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short readSS (CMPMTR *pmod, unsigned short line,
				unsigned short mod);

static	unsigned short setcoil (unsigned short line, unsigned short mod,
				CMPMTR *pmod, unsigned short bitaddr,
				unsigned long mask, unsigned long val);

static	unsigned short setreg (unsigned short line, unsigned short mod,
				CMPMTR *pmod, unsigned short regaddr,
				unsigned short val, double dblval,
				unsigned short conv);


static	void hexascii (unsigned short val, char *buf);

static	short asciihex (unsigned short *val, char *buf);

        void DUMPMSGCNTS (unsigned short line);

        void CLEARMSGCNTS (unsigned short line);

        void DUMPPLCSTATS (unsigned short line, unsigned short maddr);

        void CLEARPLCSTATS (unsigned short line, unsigned short maddr);

	void TABLEINFO (unsigned short line, unsigned short maddr);

static 	void printcoilhdr (unsigned char *buffer, unsigned short cnt);

static 	void printdihdr (unsigned char *buffer, unsigned short cnt);

static	void printaihdr (unsigned char *buffer, unsigned short cnt);

static 	void printreghdr (unsigned char *buffer, unsigned short cnt);

	LINEINFO ();

/* End of File:     drvCompumotor_proto.h */


