/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
/*  File: drvHyundai.c
*/

/* Edit: 12/20/94       WEP: initialized pstatewait to 60 seconds.
*/

#define  MAIN        hyundai_driver		/* NOTE: change here */
#define  AIDRIVER    hyundai_aidriver		/* NOTE: change here */
#define  AODRIVER    hyundai_aodriver		/* NOTE: change here */
#define  AOREAD      hyundai_aoread		/* NOTE: change here */
#define  BIDRIVER    hyundai_bidriver		/* NOTE: change here */
#define  BODRIVER    hyundai_bodriver		/* NOTE: change here */
#define  BOREAD      hyundai_boread		/* NOTE: change here */

#define  TRACEON     hyundaitraceon		/* NOTE: change here */
#define  TRACEOFF    hyundaitraceoff		/* NOTE: change here */
#define  RTRACEON    hyundairestraceon		/* NOTE: change here */
#define  RTRACEOFF   hyundairestraceoff		/* NOTE: change here */
#define  TRACELEVEL  hyundaitrlv		/* NOTE: change here */

#define  STOPDRIVER  stophyundai		/* NOTE: change here */
#define  STARTDRIVER starthyundai		/* NOTE: change here */
#define  TABLEINFO   dump_hyundai_table		/* NOTE: change here */
#define  LINEINFO    showlineinfo		/* NOTE: change here */


#include <ctype.h>

#include <vxWorks.h>
#include <types.h>
#include <in.h>
#include <bootLib.h>
#include <inetLib.h>
#include <sysLib.h>
#include <semLib.h>
#include <errno.h>
#include <socket.h>
#include <selectLib.h>
#include <fcntl.h>
#include <ioLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <restable.h>
#include <drvHyundai.h>				/* NOTE: change here */
#include <drvHyundai_proto.h>			/* NOTE: change here */


/* static long	init (); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvHyundai = { 2, NULL, init};

/*
/*      External Line Level Data Structures (declared in drvcommon.c)
/*
*/
	/* array of resource name strings.		*/

extern	unsigned char	resnames [NUM_ICM] [RESNAMELEN];

	/* array of resource response flags. 		*/

	/* False = not active resource (slave),		*/
	/* True = active resource (master) 		*/

extern	unsigned short	resresponse [NUM_ICM];							
	/* true/false line active flag. calculated	*/
	/* using activity_time below. 			*/

extern	unsigned short	line_activity [NUM_ICM];

	/* assigned value of line_activity prior to	*/
	/* it's recalculation.   			*/

extern	unsigned short	lastactivity [NUM_ICM];

	/* controls output of communication error log	*/
	/* messages (true/false) 			*/

extern	unsigned short	modtrace [NUM_ICM];

	/* controls output of certain resource related	*/
	/* log messages (level) 			*/

extern	unsigned short	mltrace [NUM_ICM];

	/* controls output of MASTER/SLAVE arbitration	*/
	/* log messages (binary) 			*/

extern	unsigned short	modrestrace [NUM_ICM];

	/* holds timetick of last activity. used to	*/
	/* set line_activity flag  			*/

extern	long		activity_time [NUM_ICM];

	/* holds max time in seconds that driver will   */
	/* wait to obtain partner state on first        */
	/* attempting to decide if it should be master. */

extern  unsigned short  pstatewait [NUM_ICM];                                                        			
	/* True after database has been completely traversed */

extern	int		firstInitPass;

/*
/*      Storage for Hyundai Data structures
/*
*/
	/* holds timestamp of beginning of major loop.  */

static unsigned int     lastscan [NUM_ICM];

	/* holds actual time taken to scan plcs.        */

static unsigned int     scantime [NUM_ICM];

	/* array of pointers to the     		*/
	/* fixed length dynamically allocated PLC       */
	/* control and data structures. extra pointer   */
	/* is for Query structure used independently    */
	/* of the others. it also allows for the array  */
	/* index to match the mod value.                */

static HHI_IO		*plcs [NUM_ICM];

	/* controls output of system error messages:	*/
	/* bit mapped controls                          */

static	unsigned short	trace [NUM_ICM];

	/* holds id and password of the user that       */
	/* spawned the driver task required by host to  */
	/* check file read privileges on PLC load files */

static char		user [40], password [40];

static char    *bools [] =
{
	"TRUE ",
	"FALSE"
};

static int		taskId [NUM_ICM];
static int		redtaskId [NUM_ICM];
static WDOG_ID		hhiwdog [NUM_ICM];
static SEM_ID		hhirsi [NUM_ICM];

static char *tasknames [] =
{
	"HYUNDAI Ch0","HYUNDAI Ch1","HYUNDAI Ch2","HYUNDAI Ch3",
	"HYUNDAI Ch4","HYUNDAI Ch5","HYUNDAI Ch6","HYUNDAI Ch7",
	"HYUNDAI Ch8","HYUNDAI Ch9","HYUNDAI Ch10","HYUNDAI Ch11",
	"HYUNDAI Ch12","HYUNDAI Ch13","HYUNDAI Ch14",
	"HYUNDAI Ch15","HYUNDAI Ch16","HYUNDAI Ch17",
	"HYUNDAI Ch18","HYUNDAI Ch19","HYUNDAI Ch20"
};

static char *redtasknames [] =
{
	"HYUNDAI R0","HYUNDAI R1","HYUNDAI R2","HYUNDAI R3",
	"HYUNDAI R4","HYUNDAI R5","HYUNDAI R6","HYUNDAI R7",
	"HYUNDAI R8","HYUNDAI R9","HYUNDAI R10","HYUNDAI R11",
	"HYUNDAI R12","HYUNDAI R13","HYUNDAI R14",
	"HYUNDAI R15","HYUNDAI R16","HYUNDAI R17",
	"HYUNDAI R18","HYUNDAI R19","HYUNDAI R20"
};

/*	Define array of TIS device types and corresponding arrays of
	Hyundai card types and number of points for that card type	*/

/*	WARNING! These types must correspond to devSup.ascii WARNING!*/

short	tisCards[] =
{
	21,	/* AOM8  (ao)       */
	22,	/* AOM4  (ao)       */
	24,	/* AIM16 (ai)       */
	32,	/* DOM16 (bo, mbbo) */
	36,	/* DIM32 (bi, mbbi) */
	37,	/* DIM16 (bi, mbbi) */
	38,	/* DIM8  (bi, mbbi) */
};

short	hyundaiCards[] =
{
	HHI_AOM8,
	HHI_AOM4,
	HHI_AIM16,
	HHI_DOM16,
	HHI_DIM32,
	HHI_DIM16,
	HHI_DIM8,
};

/*	Define array of TIS device types and corresponding arrays of
	Hyundai card types and number of points for that card type	*/

/*	WARNING! These types must correspond to devSup.ascii WARNING! */

/*	
	These types are arbitrary and just really control a switch statement
	in the downloading code. However, they must start at zero and be
	consecutive. The max number is coded in redHyundai.c
*/

#define	HHI_AI	0
#define HHI_AO	1
#define	HHI_DI	2
#define HHI_DO	3

short	hyundaiTypes[] =
{
	HHI_AO,
	HHI_AO,
	HHI_AI,
	HHI_DO,
	HHI_DI,
	HHI_DI,
	HHI_DI,
};

short	hyundaiCounts[] =
{
	8,	/* AOM8  */
	4,	/* AOM4  */
	16,	/* AIM16 */
	16,	/* DOM16 */
	32,	/* DIM32 */
	16,	/* DIM16 */
	8,	/* DIM8	 */
};

static unsigned short	crsi;

/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
{
	return (0);
}

/********
/*
/*	This routine outputs information to help with debugging.
/*
********/
void HELP (void)
{
    printf ("Hyundai Driver Control & Display Functions");
    printf ("\n\n");
    printf ("modtraceon (N) Enable the following debug messages for line N\n");
    printf (" 1) Major Scan loop Info:\n");
    printf ("    Scan time\n"); 
    printf ("    Backplane errors encountered in scan_plc\n");
    printf ("    All parametric errors encountered in the I/O drivers\n");
    printf ("\n");
    printf ("modtraceoff (N) Disable all debug messages for line N\n");
    printf ("\n");
    printf ("modrestraceon (N) Enable display of master/slave state\n");
    printf ("\n");
    printf (" modrestraceoff (N) Disable display of master/slave state\n");
    printf ("\n");

    taskDelay (2 * 60); /* Time for operator to see it and pause the output */

    printf ("modtrlv (N, X) Enable the following message for line N:                    \n");
    printf (" X = 0  Disable all trace level messages\n");
    printf (" X = 1  Resource definition error in MAIN\n");
    printf ("        Attempts to bring a plc online\n");
    printf (" X = 2  Calls to AODRIVER, BODRIVER\n");
    printf (" X = 10 Calls to AODRIVER, BODRIVER\n");
    printf ("\n");

    taskDelay (2 * 60); /* Time for operator to see it and pause the output */

    printf (" dumplinestats (N) Display line N comm stats\n");
    printf (" clearlinestats (N) Display and clear line N comm stats\n");
    printf (" dumpplcstats (N) Display line N, comm stats\n");
    printf (" clearplcstats (N) Display and clear line N status & errors\n");
    printf (" dump_mod_table (N) Display line N status, errors and data\n");
    printf ("\n");
}

/********
/*
/*	This routine enables logging of comm trace messages
/*
********/
void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/********
/*
/*	This routine disables logging of comm trace messages
/*
********/
void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}

/********
/*
/*	This routine enables logging of resource trace messages
/*
********/
void RTRACEON (unsigned short line)
{
	modrestrace [line] = TRUE;
}

/********
/*
/*	This routine disables logging of resource trace messages
/*
********/
void RTRACEOFF (unsigned short line)
{
	modrestrace [line] = FALSE;
}

/********
/*
/*	This routine controls logging of trace messages
/*
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}

int STOPDRIVER (short ln)
{
	taskDelete (taskId [ln]);
	return (1);
}
void setrsi (rsi)
{
	if (rsi == 0)
	{
	    crsi = 15;
	}
	else
	{
	    crsi = rsi;
	}
}

int STARTDRIVER (unsigned short line, unsigned short rsi)
{
	if (line < NUM_ICM)
	{
	    if ((hhiwdog [line] = wdCreate ()) == NULL)
	    {
		logMsg ("Can't create HHI watchdog\n");
		return (1);
	    }
	    if (rsi == 0)
	    {
		crsi = 20;
	    }
	    else
	    {
		crsi = rsi;
	    }
	    hhirsi [line] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
	    taskId [line] = taskSpawn (tasknames [line],
                                     HHI_PRIORITY,
                                     HHI_TASK_OPTIONS,
                                     HHI_STACK,
                                     MAIN,
                                     line
				     );

	    logMsg ("Started the HYUNDAI driver on line %d\n", line);

	    remCurIdGet (user, password);
	    return (1);
	}
	else
	{

	    logMsg ("Invalid line number %d\n", line);
	    return (-1);
	}
}
void hhischeduler (unsigned short line)
{
	semGive (hhirsi [line]);
	wdStart (hhiwdog [line], crsi, hhischeduler, line);
}

/**********
*											
*      HHI_driver
*                                                                                     	*
      The purpose of this task is to scan the modbus plc                             	*
      lines. It will maintain a configuration list supporting online additions       	*
      and replacement of modules, and maintain a table of most recently              	*
      scanned values.                                                                	*                                                                                     	**********/                                                                                     	
/* not called from within this driver 	*/

void MAIN (unsigned short line)
{
	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command,i;
	long	        this_time, last_time;
	HHI_IO          *pmod;
        unsigned int    temptick, tempdiff;


/* Initialize the data structures */

	resresponse [line] = FALSE;
	resnames [line] [0] = 0;

	activity_time [line] = tickGet ();
	lastactivity [line] = line_activity [line] = FALSE;
	
	pstatewait[line] = 60; /* wait for valid partner state for up to 60 seconds */

        /* debug structures */

	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = TRUE;

	/* causes on_line calls to begin on first pass if master */

	onlinefreq = 1;

	pmod = plcs [line];
	if (pmod == NULL)
	{
	    if (!allocate_plc (line))
	    {
		return;
	    }
	    pmod = plcs [line];
	}
	UnlockSharedMem (pmod);
	pmod->redundSem = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
	wdStart (hhiwdog [line], crsi, hhischeduler, line);

	/* Wait for resource to be defined via an initial call
		to 'register_resource' via driver call.  */

	while ((resnames [line] [0] == 0) || (pmod->radr == NULL))
	{
	    if (mltrace [line] == 1)
	    {
	    	logMsg ( "No Resource Defined for line - %d \n", line);
	    }
	    taskDelay (600);
	}

	/* Start out as slave */

	resClearCaAnswer (pmod->radr);		/* start quiet */
	resPutLocalState (pmod->radr, RES_SLV);
	if (modrestrace [line])
	{
	    logMsg ("1] Initialized as RES_SLV");
	}

        /* wait finite time for pstate to be resolved */

        logMsg ("Begin wait for pstate to become valid.\n");
        for (i = 0; i <= pstatewait [line]; i++)
        {
            resGetStates (pmod->radr, &lstate, &pstate);
	    if (pstate == 0)
	    {
		break;
	    }
            taskDelay (60);
        }
        if (pstate == 0)
	{
            logMsg ("Timeout of pstate wait.\n");
        }
	else
	{
            logMsg ("Completion of pstate wait.\n");
	}

	hyundaiSockCreate (pmod);

	redtaskId [line] = taskSpawn (redtasknames [line],
                                     HHI_PRIORITY,
                                     HHI_TASK_OPTIONS,
                                     HHI_STACK,
                                     redHyundaiTask,
                                     pmod);

	logMsg ("Started the HYUNDAI redundant task on line %d\n", line);

	semGive (pmod->redundSem);
	taskDelay (120);
	if (pmod->lastStrobeRx == 'M')
	{
	    line_activity [line] = TRUE;
	}
	activity = check_line_activity (line, ACTIVITYTIME);
	resGetStates (pmod->radr, &lstate, &pstate);

	/* if the partner is not there, be master */

	if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
	{
	    resSetCaAnswer (pmod->radr);
	    resPutLocalState (pmod->radr, RES_MSTR);

            lastscan [line] = tickGet ();
            scantime [line] = 0;

	    lstate = RES_MSTR;
	    if (modrestrace [line])
	    {
	    	logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
	    }
	}

	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet (); /* Initialize the time  */

	while (TRUE)
	{
	    activity_time [line] = tickGet ();
	    lastactivity [line] = line_activity [line] = FALSE;

            /******************************************************************************
*
* we arrive here because we are a slave.                                                   * we stay until:
*		asked to be master by partner.
*		if we can reach PLCs, we become master.
*		the partner is not master and there is no activity on the line.         *
******************************************************************************/

	    while (lstate == RES_SLV)
	    {
		hyundaiUDPCheck (pmod);
		pmod->lastStrobeRx = 0;
		semGive (pmod->redundSem);
		taskDelay (12);
		if (pmod->lastStrobeRx == 'M')
		{
		    line_activity [line] = TRUE;
		}
		else
		{
		    line_activity [line] = FALSE;
		}

		if (pmod->config_changed)
		{
		    hyundaiICMDownload (pmod);
		    pmod->config_changed = FALSE;
		}

 		/* make sure driver is not responding 	*/

		resresponse [line] = FALSE;

 		/* clear out commands 			*/

		resPutCommand (pmod->radr, 0);

 		/* wait 10 seconds before checking 	*/

		activity = check_line_activity (line, 10);
		resGetStates (pmod->radr, &lstate, &pstate);

                /* see if needed by partner to be master.
		   if yes, do it and break out of slave state.   */

		if (pstate == RES_SLVWANTCA)
		{
		    resSetCaAnswer (pmod->radr);
		    resPutLocalState (pmod->radr, RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
			logMsg ("3] Became RES_MSTR  P= %x A= %d \n",
					pstate, activity);
		    }
		    break;
		}
                /* If partner is there and wants to give it up,
		   try to take it */

		if (pstate == RES_SLVWANT)
		{
		    execute = FALSE;
		    taskDelay (2); /* Time for switch to occur */

		    /* See if anyone is out there and able to respond
			to a loopback command */

		    for (mod = 1; (mod <= NUM_ICM); mod++)
		    {
			pmod = plcs [line];

			/* verify pointer validity prior to use */
			/* that data points have been requested */
			/* user has NOT forced plc offline      */

			if ((pmod) && (pmod->was_requested) &&
				(!pmod->cmd_force_offline))
			{
			    on_line (line);	

                            /* check cmd_force_offline flag before AND after
				due to asynchronous tasks */

                            if ((pmod->is_responding) &&
				(!pmod->cmd_force_offline))
			    {
				execute = TRUE;
				break;
			    }
			}
		    }
		    /* If someone answered, become master and make sure
			partner really gave it up */

		    if (execute)
		    {
			resPutLocalState (pmod->radr, RES_MSTR);
			lstate = RES_MSTR;

                        lastscan [line] = tickGet ();
                        scantime [line] = 0;

			if (modrestrace [line])
			{
			    logMsg ("4] Became RES_MSTR  P= %x A= %d \n",
					pstate, activity);
			}
			execute = FALSE;
			activity_time [line] = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < 60); i++)
			{
			    /* pause before testing */

			    activity = check_line_activity (line, 2);
			    resGetStates (pmod->radr, &lstate, &pstate);
			    if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT)
				&& (!activity) )
			    {
				/* Partner Gave It Up so take CA */

				execute = TRUE;
				break;
			    }
			}
			if (!execute)
			{
			    /* Partner did not give it up go back to slave */

			    resPutLocalState (pmod->radr, RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace [line])
			    {
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",
						pstate, activity);
			    }
			}
			else
			{
			    /* Assume control by taking CA responsibilities */ 

			    resSetCaAnswer (pmod->radr);
			    prepresponses (line);
			    break;
			}
		    }
		}

		/* if the partner is not talking, be master */

		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) &&
			(!activity))
		{
		    resSetCaAnswer (pmod->radr);
		    resPutLocalState (pmod->radr, RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n",
					pstate, activity);
		    }
		    prepresponses (line);
		}
	    }

/**********
*
* to arrive here, we used to be master, and had been told to relinquish
* master status.
* stay in this loop until the partner takes over, or the command is canceled
*
**********/
	    while (lstate == RES_SLVWANTCA)
	    {
		hyundaiUDPCheck (pmod);
		pmod->lastStrobeRx = 0;
		semGive (pmod->redundSem);

                /* Give OS a chance...  */

	        taskDelay (62);
		if (pmod->lastStrobeRx == 'M')
		{
		    line_activity [line] = TRUE;
		}
		else
		{
		    line_activity [line] = FALSE;
		}
		if (pmod->config_changed)
		{
		    hyundaiICMDownload (pmod);
		    pmod->config_changed = FALSE;
		}

 		/* Make Sure driver is not responding   */

		resresponse [line] = FALSE;

		resGetStates (pmod->radr, &lstate, &pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer (pmod->radr);
		    resPutLocalState (pmod->radr, RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace [line])
		    {
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",
					pstate, activity);
		    }
		    break;
		}
		resGetCommand (pmod->radr, &command);

		/* clear out commands */

		resPutCommand (pmod->radr, 0);

		if (command == RES_CANCELREL)
		{
		    resSetCaAnswer (pmod->radr);
		    resPutLocalState (pmod->radr, RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
		    {
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",
					pstate, activity);
		    }
		    prepresponses (line);
		}
	    }

/**********
*
* it doesn't appear that we ever come here in a RES_SLVWANT lstate mode.
* it happens within this loop, but is never seen by the while loop
* conditional evaluation.
*
**********/
            while (lstate == RES_SLVWANT)
	    {
                /* this condition should NEVER occur. */

                logMsg (" Diagnostic WEP.0001. Ignore this message. \n");
                taskDelay (120);
            }
/**********
*
* we come here because we have gone to, or are looping in, the master state.
* we stay in this loop until:
*	we have been told to give master state to the partner.
*       we break out to RES_SLVWANTCA.
*       we have successfully handed master state to partner.
*
* While master, this task will process all modules sending outputs
* and getting inputs. It will then try to configure requested
* non-responding modules.
*
**********/

	    last_time = tickGet ();		/* initialize gap */
	    while (lstate == RES_MSTR)
	    {
		semTake (hhirsi [line], WAIT_FOREVER);	/* hhischeduler does semGive */
		hyundaiUDPCheck (pmod);
		semGive (pmod->redundSem);

		if (pmod->config_changed)
		{
		    hyundaiICMDownload (pmod);
		    pmod->config_changed = FALSE;
		}

		/* Make sure driver is responding. driver won't */
                /* issue commands if not set.                   */

		resresponse [line] = TRUE;
		resGetCommand (pmod->radr, &command);
		resPutCommand (pmod->radr, 0);        /* clear out commands */

                /* if relinquish command sent, change state and
			break out to outer loop */

		if (command == RES_RELINQUISH)
		{
		    resClearCaAnswer (pmod->radr);
		    resPutLocalState (pmod->radr, RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace [line])
		    {
                       logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",
					pstate, activity);
		    }
		    break;
		}

		/* scan plcs for data i/o, if allowed */

		modspolled = 0;

		/* call 'scan_plc' for each PLC device, unless user has */
                /* taken it off line or it is not responding.           */

		for (mod = 1; (mod <= NUM_ICM); mod++)
		{
		    pmod = plcs [line];		/* shorthand pointer */
		    if (pmod)			/* verify pointer  */
		    {
			if (pmod->cmd_force_offline)
			{ 
			    /* if user has turned this plc offline
				 mark it as not responding. */

 			    pmod->is_responding = FALSE;
	    		}
			else if (pmod->is_responding)
			{
                            /* local/partner lockstep recovery */

                            resGetStates (pmod->radr, &lstate, &pstate);
                            if (pstate == RES_MSTR)
                            {
                                resClearCaAnswer (pmod->radr);
                                resPutLocalState (pmod->radr, RES_SLV);
                                lstate = RES_SLV;
                                if (modrestrace [line])
				{
                                    logMsg ("13] Became RES_SLV  P= %x A= %d\n",
					pstate, activity);
				}

				/* random 5 to 12 second delay */

                                taskDelay (((tickGet () % 8) + 5) * 60);
                                break;
                            }
			    modspolled++;

			    scan_plc (pmod, line);	/* I/O done here! */
			    if (!pmod->is_responding)
			    {
				mark_not_valid (pmod);
                            }
			}
		    }
		    /* end of single module action */

		    /* if told to relinquish our master state,
			stop plc scanning immediately. */
		    /* don't trash the command, so that we can still
			read it on the next loop */
                    /* through this while statement. */

		    resGetCommand (pmod->radr, &command);
		    if (command == RES_RELINQUISH)
		    {
			break;
		    }
		} /* end of scan loop */

                /* measure how long the scan took.
			to be displayed at beginnig of next loop. */

                temptick = tickGet ();
                scantime [line] = temptick - lastscan [line];

		/* try and bring all nonresponding plcs on line, but */
                /* don't bring in more than a specified number.      */

		cnt = 0;

 		/* do we try to bring any in on this pass? */

		if (--onlinefreq == 0)
		{ 
		    onlinefreq = BRINGBACKCNT;
		    for (mod = 1; (mod <= NUM_ICM); mod++)
		    {
			cfgchk++;		/* manage plc index */
			if (cfgchk == NUM_ICM + 1)
			{
			    cfgchk = 1;	/* wrap plc index */
                        }
			pmod = plcs [line];
			if ((pmod) &&		/* verify pointer */
			    (!pmod->is_responding) &&
			    (pmod->was_requested) &&
			    (!pmod->cmd_force_offline))
		    	{
			    /* loopback testing done here! 	*/

			    on_line (line);
			    modspolled++;
			    cnt++;
                            if (cnt == MAXCFGCK)
			    {
				break;
			    }
			}
		    }
		}

		/* see if anyone on the line has been responding. */
                /* if not, try to get partner to become slave.    */
		/* Check for no one responding */

		if (!any_responding (line))
		{
		    /* See if it is time to let partner try */

		    this_time = tickGet ();
		    if ((this_time - last_time) > (3 * SLWWINDOW))
		    {
			/* #ticks for slave to try */

			/* Switch States to let partner know it's time to try */

			resPutLocalState (pmod->radr, RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace [line])
			{
			    logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",
					pstate, activity);
			}

			/* Remember the time of this try */

			last_time = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < SLWWINDOW); i += 10)
			{
			    /* SLWINDOW is the # of ticks for slave to try */

			    taskDelay (10);

		    	    /* If partner picked up let it have control */
			    /* check immediately */

			    activity = check_line_activity (line, 0);
			    resGetStates (pmod->radr, &lstate, &pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT)
				|| (activity))
			    {
				resClearCaAnswer (pmod->radr);
				resPutLocalState (pmod->radr, RES_SLV);
				lstate = RES_SLV;
				if (modrestrace [line])
				{
				    logMsg ("11] Became RES_SLV  P= %x A= %d\n",
						pstate, activity);
				}
				taskDelay (240);
				break;
			    }
			}
			/* Go Back to being the Master and take
				control of the hardware */

			if (lstate != RES_SLV)
			{
			    resPutLocalState (pmod->radr, RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace [line])
			    {
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d\n",
						pstate, activity);
			    }
			}
		    }
		}

		/* take plcs off hold status. the plc's data are not
			to be held off since now master.   */

		for (mod = 1; (mod <= NUM_ICM); mod++ )
		{
		    pmod = plcs [line];
		    if (pmod)			/* verify pointer */
		    {        
			pmod->holdflag = FALSE;
                    }
		}
	    }
	} /* end infinite task loop */
}

/**********
*
*	Try to bring a PLC on line
*
**********/

/*	this routine only called from MAIN	*/

static void on_line (unsigned short line)
{
	HHI_IO			*pmod;
	unsigned	short	i, j;

	pmod = plcs [line];
	if (pmod)			/* verify pointer prior to use */
	{
	    if (mltrace [line] == 1)
	    {
	        logMsg ( "Bring Online line - %d\n", line);
	    }

	    /* a PLC that has just been brought online must have    */
            /* it's data marked as being not valid.                 */

	    if (!firstInitPass)
	    {
		return;
	    }
	    if (pmod->config_changed)
	    {
		hyundaiICMDownload (pmod);
		pmod->config_changed = FALSE;
	    }
	    mark_not_valid (pmod);	
	    pmod->is_responding = TRUE;
        }
}
/**********
*							
*	Mark all plc data elements as VME_TIMEOUT / INVALID
*                                             		
**********/                                             	

/*	called from on_line and prepresponses	*/    	

static void mark_not_valid (HHI_IO  *pmod)
{
	unsigned	short	i, j;

	for (i = 0; (i < NUM_ICM_PTS); i++)
	{
	    pmod->image [i].status = VME_TIMEOUT;
	}
}


/**********
*
*	Scan a HYUNDAI ICM -  get inputs and set outputs as required
*                                                            	
**********/

/* this routine only called from MAIN 		*/

static	void scan_plc (HHI_IO *pmod, unsigned short line)
    {
	unsigned short	i;
        unsigned short  status;

	/* Process the inputs */

	if (!LockSharedMem (pmod))
	{
	    if (pmod->is_responding)
	    {
		pmod->no_offlines++;
	    }
	    pmod->is_responding = FALSE;
	    line_activity [line] = FALSE;
	    return;
	}
	pmod->sm.PI_sync = MPM_INPUT;
	UnlockSharedMem (pmod);
	vmeIntGen ();
	taskDelay (4);
	LockSharedMem (pmod);
	status = pmod->sm.PI_sync;
	UnlockSharedMem (pmod);
	if (status != MPM_INPUT_R)
	{
	    if (pmod->is_responding)
	    {
		pmod->no_offlines++;
	    }
	    pmod->no_dataerr++;
	    pmod->is_responding = FALSE;
	    pmod->mpm_status [(i / NUM_MPM_PTS)] = FALSE;
	    pmod->icm_status = FALSE;
	    line_activity [line] = FALSE;
	    return;
	}

	/* Update the IOC Point Image from the shared memory region */
	/* Update the shared memory image from the IOC point image */

	for (i = 0; (i < NUM_ICM_PTS); i++)
	{
	    if (pmod->image [i].was_requested)
	    {
		if (pmod->image [i].output_pending)
		{
		    pmod->blk.b_data [i].value = pmod->image [i].value;
		}
		else
		{
		    pmod->image [i].value = pmod->blk.b_data [i].value;
		}
		pmod->image [i].status = (pmod->blk.b_data [i].quality & 0x7f);
		if (pmod->image [i].status == COMM_ERROR)
		{
		    pmod->mpm_status [(i / NUM_MPM_PTS)] = 0;
		}
		else
		{
		    if ((pmod->blk.b_data [i].quality & 0x80) == 0x80)
		    {
			pmod->mpm_status [(i / NUM_MPM_PTS)] = 1;
		    }
		    else
		    {
			pmod->mpm_status [(i / NUM_MPM_PTS)] = 2;
		    }
		}
		if ((pmod->image [i].status == CARD_FAULT) ||
			(pmod->image [i].status == COMM_ERROR))
		{
		    status = 0;
		}
		else
		{
		    status = 1;
		}
		switch (((i % NUM_MPM_PTS) / NUM_PTS_SLOT))
		{
		case 0:
		    pmod->card_0_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 1:
		    pmod->card_1_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 2:
		    pmod->card_2_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 3:
		    pmod->card_3_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 4:
		    pmod->card_4_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 5:
		    pmod->card_5_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 6:
		    pmod->card_6_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 7:
		    pmod->card_7_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 8:
		    pmod->card_8_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 9:
		    pmod->card_9_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 10:
		    pmod->card_10_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 11:
		    pmod->card_11_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 12:
		    pmod->card_12_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 13:
		    pmod->card_13_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 14:
		    pmod->card_14_stat [(i / NUM_MPM_PTS)] = status;
		    break;

		case 15:
		    pmod->card_15_stat [(i / NUM_MPM_PTS)] = status;
		    break;
		}
	    }
	}

	/* Process the outputs */

	if (!LockSharedMem (pmod))
	{
	    if (pmod->is_responding)
	    {
		pmod->no_offlines++;
	    }
	    pmod->is_responding = FALSE;
	    line_activity [line] = FALSE;
	    return;
	}
	pmod->sm.PI_sync = MPM_OUTPUT;
	UnlockSharedMem (pmod);
	vmeIntGen ();
	taskDelay (4);
	LockSharedMem (pmod);
	status = pmod->sm.PI_sync;
	UnlockSharedMem (pmod);
	if (status != MPM_OUTPUT_R)
	{
	    if (pmod->is_responding)
	    {
		pmod->no_offlines++;
	    }
	    pmod->no_dataerr++;
	    pmod->is_responding = FALSE;
	    pmod->mpm_status [(i / NUM_MPM_PTS)] = FALSE;
	    pmod->icm_status = FALSE;
	    line_activity [line] = FALSE;
	    return;
	}
	line_activity [line] = TRUE;
	pmod->is_responding = TRUE;
	pmod->icm_status = TRUE;
}

/**********
*
*	AIDRIVER
*
*	This routines main purpose is to return the analog input value for the
*	specified module. For a module value a (-1) will be returned if
*	there is no valid data ready.
*
**********/

/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, short *pvalue,
		unsigned short conversion, unsigned char *resname,
		unsigned short dtyp)
    {
	HHI_IO		*pmod;
	unsigned short  blkix;
	unsigned short	*pdata;
        unsigned short	card_idx;

	if (link >= NUM_ICM)
	{
	    return (-1);
	}
	if (adapter >= NUM_MPM)
	{
	    return (-1);
	}
	if ((card >= NUM_MPM_SLOTS) && (card != PSEUDO))
	{
	    return (-1);
        }
	pmod = plcs [link];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link];
	}
	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 9: /* Data Errors / Invalid status from ICM */
		*pvalue = pmod->no_dataerr & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*pvalue = pmod->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 118:
		*pvalue = pmod->lastSeqTx;
		break;

	    case 119:
		*pvalue = pmod->lastSeqRx;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}
	switch (dtyp)
	{
	case TIS_AOM8:
            card_idx = 0;
	    break;

	case TIS_AOM4:
	    card_idx = 1;
	    break;

	case TIS_AIM16:
	    card_idx = 2;
	    break;

	default:
	    return (-1);
        }
	if (signal >= hyundaiCounts [card_idx])
	{
	    return (-1);
	}
	pmod->was_requested = TRUE;

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	if (pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type != hyundaiCards [card_idx])
	{
	    pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type = hyundaiCards [card_idx];
	    if (firstInitPass)
	    {
		pmod->config_changed = TRUE;
	    }
        }
	blkix = (adapter * NUM_MPM_PTS) + (card * NUM_PTS_SLOT) + signal;
	pmod->image [blkix].was_requested = TRUE;
	if (!resresponse [link])
	{
	    return (-1);
	}
	if (pmod->holdflag)
	{
	    return (-2);
	}
	if (!pmod->is_responding)
	{
	    return (-1);
	}
	if (pmod->image [blkix].status)
        {
	    switch (pmod->image [blkix].status)
	    {
	    case SENSOR_BAD:
	    case SENSOR_FAULT:
	    case CARD_FAULT:
		return (-3);

	    case COMM_ERROR:
	    default:
		return (-1);
	    }
	}
        *pvalue = pmod->image [blkix].value;
	return (0);
}

/**********
*      AODRIVER
*      This routines main purpose is to set requested analog outputs to the
*      specified module.
*
**********/                                                                            	
/* this routine not called from within this driver */

int AODRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal, double dvalue,
		unsigned short value, unsigned short conversion,
		unsigned char *resname, unsigned short dtyp)
{
	HHI_IO		*pmod;
	unsigned	short  blkix;
	unsigned short	card_idx;

	if (link >= NUM_ICM)
	{
	    return (-1);
	}
	if (adapter >= NUM_MPM)
	{
	    return (-1);
	}
	if ((card >= NUM_MPM_SLOTS) && (card != PSEUDO))
	{
	    return (-1);
        }
	pmod = plcs [link];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link];
	}
	if (card == PSEUDO)
	{
	    switch (signal)
	    {
	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats (pmod);
		}
		break;

	    case 16: /* Force the PLC online/offline */
		pmod->cmd_force_offline = (value != 0);
                if (value != 0)
		{
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		}
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	switch (dtyp)
	{
	case TIS_AOM8:
            card_idx = 0;
	    break;

	case TIS_AOM4:
	    card_idx = 1;
	    break;

	default:
	    return (-1);
        }
	if (signal >= hyundaiCounts [card_idx])
	{
	    return (-1);
	}

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	if (pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type != hyundaiCards [card_idx])
	{
	    pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type = hyundaiCards [card_idx];
	    if (firstInitPass)
	    {
		pmod->config_changed = TRUE;
	    }
        }
	blkix = (adapter * NUM_MPM_PTS) + (card * NUM_PTS_SLOT) + signal;
	pmod->image [blkix].was_requested = TRUE;

	if (!resresponse [link])
	{
	    return (-1);
	}
	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
	    return (-1);
	}
	if (pmod->image [blkix].status)
	{
	    switch (pmod->image [blkix].status)
	    {
	    case SENSOR_BAD:
	    case SENSOR_FAULT:
	    case CARD_FAULT:
		return (-3);

	    case COMM_ERROR:
	    default:
		return (-1);
	    }
	}
	pmod->image [blkix].value = value;
        pmod->image [blkix].output_pending = TRUE;
	pmod->image [blkix].redundant_update = TRUE;
	return (0);
}

/**********
*
*      AOREAD
*      This routines main purpose is to return the value last read back
*      from the analog output hardware. This is used to initialize analog
*      outputs.
*
**********/

/* this routine not called from within this driver */

int AOREAD (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal,
		unsigned short *pvalue, unsigned short conversion,
		unsigned char *resname, unsigned short dtyp)

    {
	HHI_IO		*pmod;
	unsigned short  blkix, *pdata;
	unsigned short	card_idx;

	if (link >= NUM_ICM)
	{
	    return (-1);
	}
	if (adapter >= NUM_MPM)
	{
	    return (-1);
	}
	if ((card >= NUM_MPM_SLOTS) && (card != PSEUDO))
	{
	    return (-1);
        }
	pmod = plcs [link];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link))
	    {
                return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link];
	}
	if (card == PSEUDO)
	{
	    signal++;
	    switch (signal)
	    {
	    case 15: /* read statistics command value */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Read the current PLC offline command status */
		*pvalue = pmod->cmd_force_offline;
		break;

	    default:
		return(-1);
	    }
	    return (0);
	}

	switch (dtyp)
	{
	case TIS_AOM8:
            card_idx = 0;
	    break;

	case TIS_AOM4:
	    card_idx = 1;
	    break;

	default:
	    return (-1);
        }
	if (signal >= hyundaiCounts [card_idx])
	{
	    return (-1);
	}
	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	if (pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type != hyundaiCards [card_idx])
	{
	    pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type = hyundaiCards [card_idx];
	    if (firstInitPass)
	    {
		pmod->config_changed = TRUE;
	    }
        }
	blkix = (adapter * NUM_MPM_PTS) + (card * NUM_PTS_SLOT) + signal;
	pmod->image [blkix].was_requested = TRUE;
	if (!resresponse [link])
	{
	    return (-1);
	}
	if (pmod->holdflag)
	{
	    return (-2);
	}
	if (!pmod->is_responding)
	{
	    return (-1);
	}
	if (pmod->image [blkix].status)
        {
	    switch (pmod->image [blkix].status)
	    {
	    case SENSOR_BAD:
	    case SENSOR_FAULT:
	    case CARD_FAULT:
		return (-3);

	    case COMM_ERROR:
	    default:
		return (-1);
	    }
	}
	pmod->image [blkix].output_pending = TRUE;
	pmod->image [blkix].redundant_update = TRUE;
        *pvalue = pmod->image [blkix].value;
	return (0);
}

/**********
*
*	BIDRIVER - This routine is called from the device interface
*	module to read binary inputs.
*
**********/                                                                                     
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask, unsigned long *pvalue,
		unsigned char *resname, unsigned short dtyp)

    {
	HHI_IO 		*pmod;
	unsigned short	blkix, i, j;
	unsigned long	tvalue, tmask;
	unsigned short	card_idx;

	if (link >= NUM_ICM)
	{
	    return (-1);
	}
	if (adapter >= NUM_MPM)
	{
	    return (-1);
	}
	if ((card >= NUM_MPM_SLOTS) && (card != PSEUDO))
	{
	    return (-1);
        }
	pmod = plcs [link];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link];
	}
	if (card == PSEUDO)
	{
	    for (j = 0, tmask = mask; ((tmask & 1) == 0); j++, tmask >>= 1);

	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		tvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		tvalue = pmod->is_responding;
		break;

	    case 15: /* reset statistics */
		tvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		tvalue = pmod->cmd_force_offline;
		break;

	    case 100:
		tvalue = pmod->mpm_status [adapter];
		break;

	    case 101:
		tvalue = pmod->card_0_stat [adapter];
		break;

	    case 102:
		tvalue = pmod->card_1_stat [adapter];
		break;

	    case 103:
		tvalue = pmod->card_2_stat [adapter];
		break;

	    case 104:
		tvalue = pmod->card_3_stat [adapter];
		break;

	    case 105:
		tvalue = pmod->card_4_stat [adapter];
		break;

	    case 106:
		tvalue = pmod->card_5_stat [adapter];
		break;

	    case 107:
		tvalue = pmod->card_6_stat [adapter];
		break;

	    case 108:
		tvalue = pmod->card_7_stat [adapter];
		break;

	    case 109:
		tvalue = pmod->card_8_stat [adapter];
		break;

	    case 110:
		tvalue = pmod->card_9_stat [adapter];
		break;

	    case 111:
		tvalue = pmod->card_10_stat [adapter];
		break;

	    case 112:
		tvalue = pmod->card_11_stat [adapter];
		break;

	    case 113:
		tvalue = pmod->card_12_stat [adapter];
		break;

	    case 114:
		tvalue = pmod->card_13_stat [adapter];
		break;

	    case 115:
		tvalue = pmod->card_14_stat [adapter];
		break;

	    case 116:
		tvalue = pmod->card_15_stat [adapter];
		break;

	    case 117:
		tvalue = pmod->icm_status;
		break;

	    case 120:
		tvalue = pmod->partner_pcu_stat;
		break;

	    default:
		return (-1);
	    }
	    *pvalue = ((tvalue << j) & mask);
	    return (0);
	}

	switch (dtyp)
	{
	case TIS_DOM16:
            card_idx = 3;
	    break;

	case TIS_DIM32:
	    card_idx = 4;
	    break;

	case TIS_DIM16:
	    card_idx = 5;
	    break;

	case TIS_DIM8:
	    card_idx = 6;
	    break;

	default:
	    return (-1);
        }
	if (signal >= hyundaiCounts [card_idx])
	{
	    return (-1);
	}
	pmod->was_requested = TRUE;

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}
	if (pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type != hyundaiCards [card_idx])
	{
	    pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type = hyundaiCards [card_idx];
	    if (firstInitPass)
	    {
		pmod->config_changed = TRUE;
	    }
        }
	blkix = (adapter * NUM_MPM_PTS) + (card * NUM_PTS_SLOT) + signal;

	for (j = 0, tmask = mask; ((tmask & 1) == 0); j++, tmask >>= 1);
	for (i = 0, tvalue = 0; tmask != 0; i++)
	{
	    pmod->image [blkix + i].was_requested = TRUE;
	    if (pmod->image [blkix + i].status)
	    {
		switch (pmod->image [blkix].status)
		{
		case SENSOR_BAD:
		case SENSOR_FAULT:
		case CARD_FAULT:
		    return (-3);

		case COMM_ERROR:
		default:
		    return (-1);
		}
	    }
	    tvalue <<= 1;
	    tvalue |= (((long) pmod->image [blkix + i].value) & 1);
	    tmask >>= 1;
	}	
	*pvalue = ((tvalue << j) & mask);
	return (0);
}

/**********
*
*	BODRIVER - This routine is called from the device interface
*	module to set / clear binary outputs.
*
**********/

/* this routine not called from within this driver */

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal,
		unsigned long value, unsigned long mask,
		unsigned char *resname, unsigned short dtyp)
{
	HHI_IO 		*pmod;
	unsigned short  blkix, i;
	unsigned long	tvalue, tmask;
	unsigned short	card_idx;

	if (link >= NUM_ICM)
	{
	    return (-1);
	}
	if (adapter >= NUM_MPM)
	{
	    return (-1);
	}
	if ((card >= NUM_MPM_SLOTS) && (card != PSEUDO))
	{
	    return (-1);
        }
	pmod = plcs [link];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link))
	    {
		return(-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link];
	}
	if (card == PSEUDO)
	{
	    switch (signal)
	    {

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats (pmod);
		}
		break;

	    case 16: /* Force the PLC offline */
		pmod->cmd_force_offline = (value != 0);
                if (value != 0)
		{
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		}
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}

	switch (dtyp)
	{
	case TIS_DOM16:
            card_idx = 3;
	    break;

	default:
	    return (-1);
        }
	if (signal >= hyundaiCounts [card_idx])
	{
	    return (-1);
	}
	pmod->was_requested = TRUE;

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}

	if (pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type != hyundaiCards [card_idx])
	{
	    pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type = hyundaiCards [card_idx];
	    if (firstInitPass)
	    {
		pmod->config_changed = TRUE;
	    }
        }
	blkix = (adapter * NUM_MPM_PTS) + (card * NUM_PTS_SLOT) + signal;

	for (tmask = mask, tvalue = value; ((tmask & 1) == 0); tmask >>= 1, tvalue >>= 1);
	for (i = 0; tmask != 0; i++)
	{
	    pmod->image [blkix + i].was_requested = TRUE;
	    if (pmod->image [blkix + i].status)
	    {
		switch (pmod->image [blkix].status)
		{
		case SENSOR_BAD:
		case SENSOR_FAULT:
		case CARD_FAULT:
		    return (-3);

		case COMM_ERROR:
		default:
		    return (-1);
		}
	    }
	    pmod->image [blkix + i].output_pending = TRUE;
	    pmod->image [blkix + i].value = (tvalue & 1);
	    pmod->image [blkix + i].redundant_update = TRUE;
	    tmask >>= 1;
	    tvalue >>= 1;
	}	
	return (0);
}

/**********
*
*      BOREAD
*
*      This routines main purpose is to return the value last read back
*      from the digital output hardware. This is used to initialize digital
*      outputs. This will return a (-1) if the module is the wrong type or
*      the data is not yet valid
*
**********/

/* this routine not called from within this driver */

int BOREAD (char *pointname, unsigned short link, unsigned short adapter,
		unsigned short card, unsigned short signal,
		unsigned long *pvalue, unsigned long mask,
		unsigned char *resname, unsigned short dtyp)
{
	HHI_IO		*pmod;
	unsigned short  blkix, i, j;
	unsigned long	tvalue, tmask;
	unsigned short	card_idx;

	if (link >= NUM_ICM)
	{
	    return (-1);
	}
	if (adapter >= NUM_MPM)
	{
	    return (-1);
	}
	if ((card >= NUM_MPM_SLOTS) && (card != PSEUDO))
	{
	    return (-1);
        }
	pmod = plcs [link];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link))
	    {
		return(-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link];
	}
	if (card == PSEUDO)
	{
	    switch (signal)
	    {

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    default:
		return (-1);
	    }
	    return (0);
	}
	switch (dtyp)
	{
	case TIS_DOM16:
            card_idx = 3;
	    break;

	default:
	    return (-1);
        }
	if (signal >= hyundaiCounts [card_idx])
	{
	    return (-1);
	}
	pmod->was_requested = TRUE;

	if (resname != 0)
	{
             register_resource (link, pmod, resname, pointname);
	}
	if (pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type != hyundaiCards [card_idx])
	{
	    pmod->config [(adapter * NUM_MPM_SLOTS) + card].card_type = hyundaiCards [card_idx];
	    if (firstInitPass)
	    {
		pmod->config_changed = TRUE;
	    }
        }
	blkix = (adapter * NUM_MPM_PTS) + (card * NUM_PTS_SLOT) + signal;

	for (j = 0, tmask = mask; ((tmask & 1) == 0); j++, tmask >>= 1);
	for (i = 0, tvalue = 0; tmask != 0; i++)
	{
	    pmod->image [blkix + i].was_requested = TRUE;
	    if (pmod->image [blkix].status)
	    {
		switch (pmod->image [blkix].status)
		{
		case SENSOR_BAD:
		case SENSOR_FAULT:
		case CARD_FAULT:
		    return (-3);

		case COMM_ERROR:
		default:
		    return (-1);
		}
	    }
	    tvalue <<= 1;
	    tvalue |= ((long) pmod->image [blkix + i].value) & 1;
	    tmask >>= 1;
	    pmod->image [blkix + i].redundant_update = TRUE;
	}	
	*pvalue = ((tvalue << j) & mask);
	return (0);
}

/**********
*
* register_resource
*
*	This routine is used to initialize the resource pointers
*	If this is the first time the resource for this line is being
*	referenced the pointer to the resource table entry will be set
*	and the resource name will be saved. If the resource name has
*	already been set, this routine will verify that all other points
*	for this driver are using the same resource name.
*
**********/

/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
*			    BOREAD.
*/                               	

static void  register_resource (unsigned short link, HHI_IO *pmod,
                                unsigned char *resname, char *pointname)
{
	if (resnames [link] [0] == 0) /* This is the first reference */
	{
	    if (resGetByName (resname, &pmod->radr) != RES_OK)
	    {
		logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
				resname );
	    }
	    else
	    {
		strcpy (resnames [link], resname);
	    }
	}
	else
	{
	    if (strcmp (resnames [link], resname) != 0)
	    {
		logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
				resnames[link],
                                pointname,
				resname );
	    }
	}
}

/**********
*
*      link_status                                                           	
*                                                                            	
*      The purpose of this routine is to print out the state of each of the  	
*      analog devices lines and the statistics gathered about them.         	
*                                                                           	
**********/

/* not called from within this driver */

static	void link_status (unsigned short line)
{
	if (line > NUM_ICM-1)
	{
	    return;
	}
}

/**********
*                                                                              
*	allocate_plc                                                            
*                                                                              
*	The purpose of this routine is to allocate the memory for a single      
*	plc data structure. If not successful, a console error message is  	
*	printed and an error flag is returned to the caller.                    
*	If successful, the newly allocated data structures are initialized.     
*                                                                             	
**********/

static int allocate_plc (unsigned short line )
{
	plcs [line] = (HHI_IO *) calloc (1, (sizeof (HHI_IO)));
	if (!plcs [line])
	{
	    logMsg ("Unable to allocate memory");
	    printf (" for HHI_IO data structure on line %d\n",line);
	    return(FALSE);
	}
	else
	{
	    logMsg ("Allocated memory for HHI_IO data structure on line %d\n",line);
	    init_plc_tab (line);	     /*	initialize the data structures. */
	}

	return (TRUE);
}

/**********                                                                             *
*      check_line_activity                                                     
*
**********/

/* only called from MAIN  */

static	int check_line_activity (unsigned short line, unsigned short predelay)

    {
	long		thistime;
	short		status;

	if (predelay != 0)
	{
	    taskDelay (predelay);
	}
	thistime = tickGet ();
	if ((thistime - activity_time [line]) < ACTIVITYTIME)
	{
	    return (lastactivity [line] || (line_activity [line]));
	}
	lastactivity [line] = status = line_activity [line];
	line_activity [line] = FALSE;
	activity_time [line] = thistime;
	return (status);
}

/**********
*
*      init_plc_tab
*
*      The purpose of this routine is to initialize the line tables for the
*      analog devices I/O
*
**********/

/* only called from allocate_plc  */

static	void init_plc_tab (unsigned short line)
{
	HHI_IO  *pmod;

	pmod = plcs [line];
	if (!pmod)
	{
		return;
	}
	pmod->is_responding = FALSE;
	pmod->holdflag = FALSE;
	pmod->was_requested = FALSE;
	pmod->cmd_force_offline = FALSE;

	initplc (pmod);
	initstats (pmod);
}
/**********
*
* Cold Init a PLC
*
**********/

/* only called from init_line_tabs  */

static void initplc (HHI_IO  *pmod)
{
	unsigned short	i,j;
}

                                                           		
/**********
*                                                              	
* initialize the statistics for the Hyundai I/O                 	
*                                                              	
**********/                                                               	

/* called from AODRIVER, BODRIVER, and init_line_tabs  */


static	void initstats (HHI_IO *pmod)

{
	pmod->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
	pmod->no_dataerr = 0;
}

/**********
*                                                                       
* modloopback                                                            
*                                                                        
**********/                                                                          	
/* only called from on_line */

static	unsigned short modloopback (unsigned short line, unsigned short mod,
			 HHI_IO *pmod)

{
	return (TRUE);
}

/**********
*
*     prepresponses
*
*      The purpose of this routine is to mark the PLCs as on hold and the
*	data as not valid until read again from the PLC
*
**********/

/* only called from MAIN */

static	void prepresponses (unsigned short line)

{
	unsigned short	mod;
	HHI_IO		*pmod;

	for (mod = 1; (mod <= NUM_ICM); mod++)
	{
	    pmod = plcs [line];
	    if (pmod)			/* verify pointer */
	    {
	    	pmod->holdflag = TRUE;
		mark_not_valid (pmod);
            }
	}
}




/**********                                                                  	*
*      any_responding                                               	
*                                                                   	
*      The purpose of this routine is to see if any units are       	
*	responding on this line                                      	
*                                                                   	
**********/

/* only called from MAIN */

static	int any_responding (unsigned short line)
{
	unsigned short  mod;
	HHI_IO		*pmod;

	for (mod = 1; (mod <= NUM_ICM); mod++)
	{
	    pmod = plcs [line];
	    if (pmod)			/* verify pointer */
	    {
                /* check cmd_force_offline flag because it is
			set in an asynchronous task */

                if ((pmod->is_responding) && (!pmod->cmd_force_offline))
		{
		    return (TRUE);
		}
	    }
	}
	return (FALSE);
}

/**********
*
*	LockSharedMem
*
*	This routine will gain access to the shared memory region and
*	lock it. This routine will not return until it is successful.
*
**********/

int LockSharedMem (HHI_IO *pmod)
{
	unsigned int	i, status;

	for (i = 0; i < 10; i++)
	{
	    if ((status = sysBusTas ( (char *) &pmod->sm)) == TRUE)
	    {
		return (status);
	    }
	    else
	    {
		taskDelay (1);
	    }
	}
	return (status);
}

/**********
*
*	UnlockSharedMem
*
*	This routine unlocks the shared memory region so that the ICM
*	can gain access to it
*
**********/

VOID	UnlockSharedMem (HHI_IO *pmod)
{
	pmod->sm.access = 0;
}

/**********
*
*	vmeIntGen
*
**********/

vmeIntGen ()
{
	*VME_INT_VEC_REGS = VINT_VEC_NO;
	*VME_INT_GEN = FGA_VIRQGEN2;
}

/**********
*
*	hhidata
*
*	The purpose of this routine is to dump the data regions
*	for this driver.
*
**********/

void hhiconfig (unsigned short line)

{
	HHI_IO		*pmod;
	unsigned short	i;
	
	pmod = plcs [line];
	if (!pmod)
	{
	    logMsg ("Line Not Defined \n");
	    return;
	}

	printf ("        MPM CONFIGURATION TABLE\n");
	for (i = 0; i < NUM_ICM_SLOTS; i++)
	{
	    printf ("MPM: %d Slot: %d Card Type: %d Card Status: %d\n",
			(i / NUM_MPM_SLOTS), (i % NUM_MPM_SLOTS),
			pmod->config [i].card_type,
			pmod->config [i].card_status);
	}
}
/**********
*
*	hhidata
*
*	The purpose of this routine is to print all of the data points
*	that have been requested by the initUpdate task.
*
**********/

void hhidata (unsigned short line)
{
	HHI_IO		*pmod;
	unsigned short	i;

	pmod = plcs [line];
	if (!pmod)
	{
	    logMsg ("Line Not Defined \n");
	    return;
	}


	for (i = 0; i < NUM_ICM_PTS; i++)
	{
	    if (pmod->image [i].was_requested)
	    {
		printf ("Index: %d In/Out: %d Status: %d Value %d\n",
			i,
			pmod->image [i].output_pending,
			pmod->image [i].status,
			pmod->image [i].value);
	    }
	}
}	    

/**********
*
*	hhistats
*
*	The purpose of this routine is to dump the plc level
*	statistics for this driver.
*
**********/

/* called from TABLEINFO */

void hhistats (unsigned short line, unsigned short mpm)
{
	HHI_IO		*pmod;

	pmod = plcs [line];
	if (!pmod)
	{
	    logMsg ("Line Not Defined \n");
	    return;
	}

	printf ("Was requested = %d\n", pmod->was_requested);
	printf ("Is responding = %d\n", pmod->is_responding);
	printf ("Off Lines = %d\n", pmod->no_offlines);
	printf ("Data transfer errors = %d\n", pmod->no_dataerr);
	printf ("Reset Statistics = %d\n", pmod->cmd_reset_stat);
	printf ("Force Offline = %d\n", pmod->cmd_force_offline);
	printf ("Resource Responding = %d \n", resresponse [line]);
	printf ("Hold flag  = %d\n\n", pmod->holdflag );
	printf ("ICM status = %d\n", pmod->icm_status);
	printf ("Partner PCM status = %d\n\n", pmod->partner_pcu_stat);
	printf ("MPM Unit %d: Slot 0 Status = %d\n", mpm, pmod->card_0_stat [mpm]);
	printf ("MPM Unit %d: Slot 1 Status = %d\n", mpm, pmod->card_1_stat [mpm]);
	printf ("MPM Unit %d: Slot 2 Status = %d\n", mpm, pmod->card_2_stat [mpm]);
	printf ("MPM Unit %d: Slot 3 Status = %d\n", mpm, pmod->card_3_stat [mpm]);
	printf ("MPM Unit %d: Slot 4 Status = %d\n", mpm, pmod->card_4_stat [mpm]);
	printf ("MPM Unit %d: Slot 5 Status = %d\n", mpm, pmod->card_5_stat [mpm]);
	printf ("MPM Unit %d: Slot 6 Status = %d\n", mpm, pmod->card_6_stat [mpm]);
	printf ("MPM Unit %d: Slot 7 Status = %d\n", mpm, pmod->card_7_stat [mpm]);
	printf ("MPM Unit %d: Slot 8 Status = %d\n", mpm, pmod->card_8_stat [mpm]);
	printf ("MPM Unit %d: Slot 9 Status = %d\n", mpm, pmod->card_9_stat [mpm]);
	printf ("MPM Unit %d: Slot 10 Status = %d\n", mpm, pmod->card_10_stat [mpm]);
	printf ("MPM Unit %d: Slot 11 Status = %d\n", mpm, pmod->card_11_stat [mpm]);
}

/****************************************************************/
/*								*/
/*		CREATE THE TCP & UDP SOCKETS			*/
/*								*/
/****************************************************************/

hyundaiSockCreate(pHHI)
HHI_IO		*pHHI;
{
    struct sockaddr_in		addr;
    BOOT_PARAMS			bootParams;

    /*
    Create and bind the UDP socket.
    */

    pHHI -> udpFd = socket(PF_INET, SOCK_DGRAM, 0);
    if (pHHI -> udpFd == ERROR)
	{
	perror("Can't create Hyundai UDP socket");
	return (ERROR);
	}
    addr.sin_family = AF_INET;
    addr.sin_addr.s_addr = htonl(INADDR_ANY);
    addr.sin_port = htons(HHI_PORT);
    if (bind(pHHI -> udpFd, (struct sockaddr *) &addr, sizeof(addr)) == ERROR)
	{
	perror("Can't bind Hyundai UDP socket");
	return (ERROR);
	}

    /*
    Create and bind the TCP socket.
    */

    pHHI -> tcpFd = socket(PF_INET, SOCK_STREAM, 0);
    if (pHHI -> tcpFd == ERROR)
	{
	perror("Can't create Hyundai TCP socket");
	return (ERROR);
	}
    addr.sin_family = AF_INET;
    addr.sin_addr.s_addr = htonl(INADDR_ANY);
    addr.sin_port = htons(HHI_PORT);
    if (bind(pHHI -> tcpFd, (struct sockaddr *) &addr, sizeof(addr)) == ERROR)
	{
	perror("Can't bind Hyundai TCP socket");
	return (ERROR);
	}
    listen(pHHI -> tcpFd, 2);

    /*
    Access the bootline to find our backplane network's Inet address.
    We add one to our backplane Inet addr to get the ICM's address.
    */

    bootStringToStruct(0x700, &bootParams);
    pHHI -> icmInet = inet_addr(bootParams.bad);
    if (pHHI -> icmInet == ERROR)
	{
	perror("Can't get backplane Inet Addr from boot line");
	return (ERROR);
	}

    /*
    Correct the ICM address and put into host Endian. This is because 
    we code endian translation for all network calls as a habit.
    */

    pHHI -> icmInet = ntohl(pHHI -> icmInet) + 1;
    return (1);
}


/****************************************************************/
/*								*/
/*		CHECK THE STATE OF THE UDP SOCKET		*/
/*								*/
/*	This routine is to be called every 1/4 second. It	*/
/*	will check the UDP socket to see if there is any	*/
/*	available input datagram. If the data is a boot		*/
/*	request from the ICM, then we will send the shared	*/
/*	memory address, exec address, block data address, and	*/
/*	then invoke the download. If not from the ICM, then we	*/
/*	post the address for action by the redundancy task.	*/
/*								*/
/****************************************************************/

hyundaiUDPCheck(pHHI)
HHI_IO		*pHHI;
{
    fd_set			hhiFds;
    struct sockaddr_in		addr;
    struct timeval		pollTimer;
    int				addrSize;

    /*
    See if we haven't heard from the redundant partner.
    */

    if (pHHI -> partnerInet == 0)
	{
	short		message;

	/*
	We haven't. If we know his Inet address, boink him.
	When he responds, we'll post his address which will
	make the redundant update task connect.
	*/

	if (pHHI -> radr -> partnerInet)
	    {
	    addr.sin_family = AF_INET;
	    addr.sin_addr.s_addr = htonl(pHHI -> radr -> partnerInet);
	    addr.sin_port = htons(HHI_PORT);
	    sendto(pHHI -> udpFd, (char *) &message, sizeof(message), 0, &addr, sizeof(addr));
	    }
	}

    /*
    Check the UDP port to see if there's anything there to read.
    If so, drain the socket completely.
    */

    FD_ZERO(&hhiFds);
    FD_SET(pHHI -> udpFd, &hhiFds);
    pollTimer.tv_sec = 0;
    pollTimer.tv_usec = 0;
    while (select(pHHI -> udpFd + 1, &hhiFds, NULL, NULL, &pollTimer) > 0)
	{

	/*
	There was. Get it and then see who it was from
	*/

	addrSize = sizeof(addr);
	recvfrom(pHHI -> udpFd, pHHI -> sockBuff, sizeof(pHHI -> sockBuff), 
		0, (struct sockaddr *) &addr, &addrSize);
	if (ntohl(addr.sin_addr.s_addr) != pHHI -> icmInet)
	    {

	    /*
	    Not the ICM. It must be our redundant partner. Record the fact
	    that we've been boinked.
	    */

	    pHHI -> partnerInet = ntohl(addr.sin_addr.s_addr);
	    }

	else
	    {

	    /*
	    It was the ICM. If the message is his universal startup, then force feed
	    him the things that he needs.
	    */

	    if (!strcmp(pHHI -> sockBuff, "icm"))
		{
		int		i;
		int		j;
		char		*busAddr;

		/*
		Set ICM status to initializing. Then translate and send him the
		shared memory address, the exec structure address, the block
		data address, and then call the download routine.
		*/

		pHHI -> icm_status = 1;
		sysLocalToBusAdrs(0x0d, &(pHHI -> sm), &busAddr);
		sendto(pHHI -> udpFd, (char *) &busAddr, sizeof(busAddr), 0, &addr, sizeof(addr));

		/*
		Configure the exec structure. For each MPM that has been configured, bump the
		number of MPMs and set the corresponding MPM flag to 2.
		*/

		pHHI -> exec.total_mpm_no = 0;
		for (i = 0; i < NUM_MPM; i++)
		    {
		    for (j = i * NUM_MPM_SLOTS; j < (i + 1) * NUM_MPM_SLOTS; j++)
			{
			if (pHHI -> config[j].card_type != HHI_EMPTY)
			    {
			    pHHI -> exec.mpm_dnld_flag[i] = 2;
			    pHHI -> exec.total_mpm_no++;
			    break;
			    }
			}
		    }

		sysLocalToBusAdrs(0x0d, &(pHHI -> exec), &busAddr);
		sendto(pHHI -> udpFd, (char *) &busAddr, sizeof(busAddr), 0, &addr, sizeof(addr));
		sysLocalToBusAdrs(0x0d, &(pHHI -> blk), &busAddr);
		sendto(pHHI -> udpFd, (char *) &busAddr, sizeof(busAddr), 0, &addr, sizeof(addr));
		hyundaiICMDownload(pHHI);
		}
	    }
	}
}


/****************************************************************/
/*								*/
/*			DOWNLOAD THE ICM			*/
/*								*/
/*	Send the configuration structures in the following	*/
/*	order: 							*/
/*		1. MPM Configuration				*/
/*		2. Point Number array				*/
/*		3. Digital Inputs				*/
/*		4. Digital Outputs				*/
/*		5. Analog Inputs				*/
/*		6. Analog Outputs				*/
/*								*/
/****************************************************************/

hyundaiICMDownload(pHHI)
HHI_IO		*pHHI;
{
    MPM_CFG_STRUCT	mpmConfig;
    TNO_STRUCT		pointCounts;
    int			i;
    int			j;
    int			index;
    int			cardIndex;
    int			typeIndex;
    int			nchib;
    short		numPoints;
    short		cardPoints;
    struct sockaddr_in	addr;
    int			addrSize;
    fd_set		drainFds;
    struct timeval	pollTime;

/*
	Configure the exec structure. For each MPM that has been configured, bump the
	number of MPMs and set the corresponding MPM flag to 2.
*/

    pHHI -> exec.total_mpm_no = 0;
    for (i = 0; i < NUM_MPM; i++)
        {
        for (j = i * NUM_MPM_SLOTS; j < (i + 1) * NUM_MPM_SLOTS; j++)
    	    {
    	    if (pHHI -> config[j].card_type != HHI_EMPTY)
    	        {
    	        pHHI -> exec.mpm_dnld_flag[i] = 2;
    	        pHHI -> exec.total_mpm_no++;
    	        break;
    	        }
    	    }
        }


    /*
    Establish the ICM address
    */

    addr.sin_family = AF_INET;
    addr.sin_addr.s_addr = htonl(pHHI -> icmInet);
    addr.sin_port = htons(HHI_PORT);

    /*
    Build and send the MPM configuration array. While we are scanning the
    MPM configuration, build up the structure for the point count for
    each of the four fundamental point types.
    */

    index = 0;
    memset((void *) &pointCounts, 0, sizeof(pointCounts));

    for (i = 0; i < NUM_MPM; i++)
	{
	int	mpmIndex;

	mpmIndex = 0;
    	memset((void *) &mpmConfig, 0, sizeof(mpmConfig));
	for (j = 0; j < NUM_MPM_SLOTS; j++)
	    {
	    if (pHHI -> config[index].card_type == HHI_EMPTY)
		{
		index++;
		continue;
		}
	    mpmConfig.slot[mpmIndex].addr = j | 0xf0;
	    mpmConfig.slot[mpmIndex].type = pHHI -> config[index].card_type;
	    mpmIndex++;
	    cardIndex = findHyundaiCard(pHHI -> config[index].card_type);
	    index++;
	    switch (hyundaiTypes[cardIndex])
		{
		case HHI_AI:
		    pointCounts.ai_tno += hyundaiCounts[cardIndex];
		    break;

		case HHI_AO:
		    pointCounts.ao_tno += hyundaiCounts[cardIndex];
		    break;

		case HHI_DI:
		    pointCounts.di_tno += hyundaiCounts[cardIndex];
		    break;

		case HHI_DO:
		    pointCounts.do_tno += hyundaiCounts[cardIndex];
		    break;
		}
	    }
	memmove(pHHI -> sockBuff + 1 + i * sizeof(mpmConfig), (char *) &mpmConfig, sizeof(mpmConfig));
	}
    pHHI -> sockBuff[0] = MPM_LOAD;
    sendto(pHHI -> udpFd, pHHI -> sockBuff, sizeof(mpmConfig) * 4 + 1, 0, &addr, sizeof(addr));

    /*
    Send the point count array.
    */

    pHHI -> sockBuff[0] = TNO_LOAD;
    memmove(pHHI -> sockBuff + 1, (char *) &pointCounts, sizeof(pointCounts));
    sendto(pHHI -> udpFd, pHHI -> sockBuff, sizeof(pointCounts) + 1, 0, &addr, sizeof(addr));

    /*
    Now download each of the four fundamental point types
    */

    for (typeIndex = 0; typeIndex < 4; typeIndex++)
	{
	memset((void *) (pHHI -> sockBuff + 1), 0, sizeof(short));
	nchib = 3;
	numPoints = 0;
	index = 0;
	for (i = 0; i < NUM_MPM; i++)
	    {
	    int		slot;

	    slot = 0;
	    for (j = 0; j < NUM_MPM_SLOTS; j++)
		{

		/*
		First see if this is the type that we are currently downloading.
		If not, then bail out of this loop.
		*/

		if (pHHI -> config[index].card_type == HHI_EMPTY)
		    {
		    index++;
		    continue;
		    }
	    	cardIndex = findHyundaiCard(pHHI -> config[index].card_type);
		index++;
		if (hyundaiTypes[cardIndex] != typeIndex)
		    {
		    slot++;
		    continue;
		    }

		/*
		It is. Get the number of points for this card type and create the
		proper number of data structures for this point type.
		*/

		cardPoints = hyundaiCounts[cardIndex];
		while (cardPoints--)
		    {
		    switch (typeIndex)
			{
			case HHI_AI:
			    {
			    AI_STRUCT		aiStruct;

			    pHHI -> sockBuff[0] = AIP_LOAD;
			    memset((void *) &aiStruct, 0, sizeof(aiStruct));
			    if ((nchib + sizeof(aiStruct)) > sizeof(pHHI -> sockBuff))
				{
				sendto(pHHI -> udpFd, pHHI -> sockBuff, nchib, 0, &addr, sizeof(addr));
				nchib = 3;
				memmove(pHHI -> sockBuff + 1, (char *) &numPoints, sizeof(short));
				taskDelay(1);		/* Give him time to eat this! */
				}
			    aiStruct.unit_no = i;
			    aiStruct.slot_no = slot;
			    aiStruct.point_no = cardPoints;
			    aiStruct.block_no = i * NUM_MPM_PTS + j * NUM_PTS_SLOT + cardPoints;
			    aiStruct.zero = 0.0;
			    aiStruct.span = 4095.0;
			    memmove(pHHI -> sockBuff + nchib, (char *) &aiStruct, sizeof(aiStruct));
			    nchib += sizeof(aiStruct);
			    numPoints++;
			    break;
			    }

			case HHI_AO:
			    {
			    AO_STRUCT		aoStruct;

			    pHHI -> sockBuff[0] = AOP_LOAD;
			    memset((void *) &aoStruct, 0, sizeof(aoStruct));
			    if ((nchib + sizeof(aoStruct)) > sizeof(pHHI -> sockBuff))
				{
				sendto(pHHI -> udpFd, pHHI -> sockBuff, nchib, 0, &addr, sizeof(addr));
				nchib = 3;
				memmove(pHHI -> sockBuff + 1, (char *) &numPoints, sizeof(short));
				taskDelay(1);
				}
			    aoStruct.unit_no = i;
			    aoStruct.slot_no = slot;
			    aoStruct.point_no = cardPoints;
			    aoStruct.block_no = i * NUM_MPM_PTS + j * NUM_PTS_SLOT + cardPoints;
			    aoStruct.zero = 0.0;
			    aoStruct.span = 1023.0;
			    memmove(pHHI -> sockBuff + nchib, (char *) &aoStruct, sizeof(aoStruct));
			    nchib += sizeof(aoStruct);
			    numPoints++;
			    break;
			    }

			case HHI_DI:
			    {
			    DI_STRUCT		diStruct;

			    pHHI -> sockBuff[0] = DIP_LOAD;
			    memset((void *) &diStruct, 0, sizeof(diStruct));
			    if ((nchib + sizeof(diStruct)) > sizeof(pHHI -> sockBuff))
				{
				sendto(pHHI -> udpFd, pHHI -> sockBuff, nchib, 0, &addr, sizeof(addr));
				nchib = 3;
				memmove(pHHI -> sockBuff + 1, (char *) &numPoints, sizeof(short));
				taskDelay(1);
				}
			    diStruct.unit_no = i;
			    diStruct.slot_no = slot;
			    diStruct.point_no = cardPoints;
			    diStruct.block_no = i * NUM_MPM_PTS + j * NUM_PTS_SLOT + cardPoints;
			    diStruct.contact_type = 0;
			    memmove(pHHI -> sockBuff + nchib, (char *) &diStruct, sizeof(diStruct));
			    nchib += sizeof(diStruct);
			    numPoints++;
			    break;
			    }

			case HHI_DO:
			    {
			    DO_STRUCT		doStruct;

			    pHHI -> sockBuff[0] = DOP_LOAD;
			    memset((void *) &doStruct, 0, sizeof(doStruct));
			    if ((nchib + sizeof(doStruct)) > sizeof(pHHI -> sockBuff))
				{
				sendto(pHHI -> udpFd, pHHI -> sockBuff, nchib, 0, &addr, sizeof(addr));
				nchib = 3;
				memmove(pHHI -> sockBuff + 1, (char *) &numPoints, sizeof(short));
				taskDelay(1);
				}
			    doStruct.unit_no = i;
			    doStruct.slot_no = slot;
			    doStruct.point_no = cardPoints;
			    doStruct.block_no = i * NUM_MPM_PTS + j * NUM_PTS_SLOT + cardPoints;
			    memmove(pHHI -> sockBuff + nchib, (char *) &doStruct, sizeof(doStruct));
			    nchib += sizeof(doStruct);
			    numPoints++;
			    break;
			    }
			}
		    }
		slot++;
		}
	    }
	
	/*
	Flush the buffer if there's anything left.
	*/

	if (nchib > 3)
	    sendto(pHHI -> udpFd, pHHI -> sockBuff, nchib, 0, &addr, sizeof(addr));
	}

    /*
    Set ICM status to operational.
    */

    pHHI -> icm_status = 2;

    /*
    Now drain the UDP socket just in case the ICM has several messages buffered
    up to us. If he crashed during the load, he'll repeat his reastart in 2 seconds.
    If we dropped a boink from the redundant IOC, then he'll also repeat that.
    */

    FD_ZERO(&drainFds);
    FD_SET(pHHI -> udpFd, &drainFds);
    pollTime.tv_sec = 0;
    pollTime.tv_usec = 0;
    addrSize = sizeof(addr);
    while (select(pHHI -> udpFd + 1, &drainFds, NULL, NULL, &pollTime) > 0)
	recvfrom(pHHI -> udpFd, pHHI -> sockBuff, sizeof(pHHI -> sockBuff), 
		0, (struct sockaddr *) &addr, &addrSize);
    return (0);
}


/****************************************************************/
/*								*/
/*		FIND A HYUNDAI CARD GIVEN TYPE			*/
/*								*/
/*	Return the index into the array of card types.		*/
/*								*/
/****************************************************************/

findHyundaiCard(cardType)
int	cardType;
{
    short	i;

    for (i = 0; i < sizeof(hyundaiCards) / sizeof(short); i++)
	if (cardType == hyundaiCards[i])
	    return (i);
}



/****************************************************************/
/*								*/
/*		HYUNDAI I/O REDUNDANT UPDATE TASK		*/
/*								*/
/****************************************************************/

redHyundaiTask(pHHI)
HHI_IO		*pHHI;
{
    int			tycoFd;
    char		heartBeat;
    struct sockaddr_in	addr;
    long		ourInet;
    int			intSize;
    int			optVal = 1;
    fd_set		redFds;
    struct timeval	pollTimer = {0, 0};
    int			lastPeriodic;

    /*
    Start off by grabbing the tyCo port for redundant heartbeats.
    */

    if ((tycoFd = open("/tyCo/2", O_RDWR)) == ERROR)
	{
	perror("Can't open serial line for redundancy");
	taskSuspend (taskIdSelf());
	}

    /*
    Find our local Inet address.
    */

    local_addr(0, &addr);
    ourInet = ntohl(addr.sin_addr.s_addr);

    /*
    This is our main loop.
    */

    for (;;)
	{

	/*
	Wait for a "kick" to get going.
	*/

	semTake(pHHI -> redundSem, WAIT_FOREVER);

	/*
	See if we don't have a connection to our redundant partner.
	*/

	if (pHHI -> redFd == 0)
	    {

	    /*
	    Is the partner Inet address known?
	    */

	    if (pHHI -> partnerInet)
		{

		/*
		It is known. Do we make the connection or does our partner?
		*/

		if (ourInet > pHHI -> partnerInet)
		    {

		    /*
		    We do. Create a socket and try to connect it.
		    */

		    pHHI -> redFd = socket(PF_INET, SOCK_STREAM, 0);
		    addr.sin_family = AF_INET;
		    addr.sin_addr.s_addr = htonl(pHHI -> partnerInet);
		    addr.sin_port = htons(HHI_PORT);
		    if (connect(pHHI -> redFd, (struct sockaddr *) &addr, sizeof(addr)) == ERROR)
			{

			/*
			Can't connect. We'll try again later.
			*/

			close(pHHI -> redFd);
			pHHI -> redFd = 0;
			}
		    else
			{

			/*
			Got it. Get current buffer sizes and set up for non-blocking I/O.
			*/

			pHHI -> redRxBuffmax = 0;
			pHHI -> tcpRxBuffBytes = 0;
			pHHI -> lastSeqTx = 0;
			lastPeriodic = 0;
			intSize = sizeof(pHHI -> redTxBuffsize);
			getsockopt(pHHI -> redFd, SOL_SOCKET, SO_SNDBUF, &(pHHI -> redTxBuffsize), 
				&intSize);
			intSize = sizeof(pHHI -> redRxBuffsize);
			getsockopt(pHHI -> redFd, SOL_SOCKET, SO_SNDBUF< &(pHHI -> redRxBuffsize),
				&intSize);
			ioctl(pHHI -> redFd, FIONBIO, &optVal);
			}
		    }

		else
		    {

		    /*
		    Partner connects. See if he's trying to connect.
		    */

		    FD_ZERO(&redFds);
		    FD_SET(pHHI -> tcpFd, &redFds);
		    if (select(pHHI -> tcpFd + 1, &redFds, NULL, NULL, &pollTimer) > 0)
			{
			/*
			He is. Set him up and condition the socket for non-blocking I/O.
			*/

			intSize = sizeof(addr);
			pHHI -> redFd = accept(pHHI -> tcpFd, &addr, &intSize);
			pHHI -> redRxBuffmax = 0;
			pHHI -> tcpRxBuffBytes = 0;
			pHHI -> lastSeqTx = 0;
			lastPeriodic = 0;
			intSize = sizeof(pHHI -> redTxBuffsize);
			getsockopt(pHHI -> redFd, SOL_SOCKET, SO_SNDBUF, &(pHHI -> redTxBuffsize), 
				&intSize);
			intSize = sizeof(pHHI -> redRxBuffsize);
			getsockopt(pHHI -> redFd, SOL_SOCKET, SO_SNDBUF< &(pHHI -> redRxBuffsize),
				&intSize);
			ioctl(pHHI -> redFd, FIONBIO, &optVal);
			}
		    }
		}
	    }

	/*
	Determine which byte to send out the async port as a heartbeat.
	*/

	if (pHHI -> radr -> caAnswer)
	    heartBeat = 'M';
	else
	    heartBeat = 'S';
	write(tycoFd, &heartBeat, sizeof(heartBeat));

	/*
	See if there's a byte to read on the serial port.
	*/

	FD_ZERO(&redFds);
	FD_SET(tycoFd, &redFds);
	while (select(tycoFd + 1, &redFds, NULL, NULL, &pollTimer) > 0)
	    {
	    read(tycoFd, &(pHHI -> lastStrobeRx), sizeof(pHHI -> lastStrobeRx));
	    pHHI -> lastStrobeRxTime = tickGet();
	    }
	
	/*
	Remaining processing requires a connection with our redundant partner.
	If there is no such connection, then there is nothing to do!
	*/

	if (pHHI -> redFd)
	    {
	    short		msgType;
	    HHI_UPDT_MSG	updtMsg;

	    FD_ZERO(&redFds);
	    FD_SET(pHHI -> redFd, &redFds);
	    pHHI -> sockBytes = 0;

	    /*
	    Check the socket for any inputs from the other side and process all of them
	    */

	    while (select(pHHI -> redFd + 1, &redFds, NULL, NULL, &pollTimer) > 0)
		{

		/*
		Check to see if we need to expand the receive buffer size
		*/

		if (!(pHHI -> redRxBuffmax))
		    {
		    ioctl(pHHI -> redFd, FIONREAD, &intSize);
		    if (intSize == pHHI -> redRxBuffsize)
			{
			pHHI -> redRxBuffsize += 1024;
			if (setsockopt(pHHI -> redFd, SOL_SOCKET, SO_RCVBUF, &(pHHI -> redRxBuffsize),
				sizeof(pHHI -> redRxBuffsize)) == ERROR)
			    pHHI -> redRxBuffmax = 1;
			}
		    }

		/*
		Get a big chunk into our buffer. Start by moving things down if there
		is already stuff in the buffer and it's not at the beginning.
		*/

		if (pHHI -> tcpRxBuffBytes && pHHI -> tcpRxBuffIdx)
		    memmove(pHHI -> tcpRxBuff, pHHI -> tcpRxBuff + pHHI -> tcpRxBuffIdx,
			    pHHI -> tcpRxBuffBytes);
		intSize = recv(pHHI -> redFd, pHHI -> tcpRxBuff + pHHI -> tcpRxBuffBytes,
			sizeof(pHHI -> tcpRxBuff) - pHHI -> tcpRxBuffBytes, 0);
		if (intSize <= 0)
		    {

		    /*
		    Error. Close the socket and bail out of here.
		    */

		    close(pHHI -> redFd);
		    pHHI -> redFd = 0;
		    pHHI -> partnerInet = 0;
		    break;
		    }
		pHHI -> tcpRxBuffBytes += intSize;
		pHHI -> tcpRxBuffIdx = 0;

		/*
		Process all of the messages that we can.
		*/

		while (haveCompleteHyundaiMsg(pHHI))
		    {
		    HHI_ACK_MSG		ackMsg;

		    /*
		    Get the message type and handle accordingly.
		    */

		    getHyundaiBytes(pHHI, (char *) &msgType, sizeof(msgType));
		    if (msgType == HHI_ACK)
			{

			/*
			Acknowledgment for a redundant update. Read the rest of
			the message, post the sequence number and the current
			vxWorks tick count so that the driver can make redundancy
			role decisions. However, if we're slave, ignore the message.
			*/

			getHyundaiBytes(pHHI, (char *) &ackMsg, sizeof(ackMsg));
			if (!(pHHI -> radr -> caAnswer))
			    continue;
			pHHI -> lastSeqRx = ackMsg.ackSeqNo;
			pHHI -> lastSeqRxTime = tickGet();
			}

		    else if (msgType == HHI_REDUPDT)
			{

			/*
			A redundant update. Read the rest of the message. If we are
			slave, ack the message and then post the data in the shared
			area. Ignore the message if we're master.
			*/

			getHyundaiBytes(pHHI, (char *) &updtMsg, sizeof(updtMsg));
			if (pHHI -> radr -> caAnswer)
			    continue;
			ackMsg.ackSeqNo = updtMsg.ackSeqNo;
			msgType = HHI_ACK;
			putHyundaiBytes(pHHI, msgType, (char *) &ackMsg, sizeof(ackMsg));
			pHHI -> image[updtMsg.blockNo].value = updtMsg.value;
			pHHI -> image[updtMsg.blockNo].output_pending = 1;
			}
		    }
		}

	    /*
	    If it was more than one minute since our last periodic report, create one now
	    */

	    if ((pHHI -> radr -> caAnswer) && ((tickGet() - lastPeriodic) > 3600))
		{
		int	index;

		msgType = HHI_REDUPDT;
		for (index = 0; index < NUM_ICM_PTS; index++)
		    {
		    if (pHHI -> image[index].output_pending)
			{
			updtMsg.ackSeqNo = ++(pHHI -> lastSeqTx);
			updtMsg.blockNo = index;
			updtMsg.value = pHHI -> image[index].value;
			pHHI -> image[index].redundant_update = 0;
			putHyundaiBytes(pHHI, msgType, (char *) &updtMsg, sizeof(updtMsg));
			}
		    }
		lastPeriodic = tickGet();
		}

	    else if (pHHI -> radr -> caAnswer)
		{
		int		index;

	        /*
	        We are master. Traverse the point image looking for the "needs redundant
	        update" bit set. Create an update message for each one of them.
	        */

		msgType = HHI_REDUPDT;
		for (index = 0; index < NUM_ICM_PTS; index++)
		    {
		    if (pHHI -> image[index].redundant_update)
			{
			updtMsg.ackSeqNo = ++(pHHI -> lastSeqTx);
			updtMsg.blockNo = index;
			updtMsg.value = pHHI -> image[index].value;
			pHHI -> image[index].redundant_update = 0;
			putHyundaiBytes(pHHI, msgType, (char *) &updtMsg, sizeof(updtMsg));
			}
		    }
		}

	    /*
	    Flush the buffer if there's anything left in it
	    */

	    hyundaiFlush(pHHI);
	    }
	}
}


/****************************************************************/
/*								*/
/*	FLUSH THE TCP/IP BUFFER TO OUR REDUNDANT PARTNER	*/
/*								*/
/****************************************************************/

hyundaiFlush(pHHI)
HHI_IO		*pHHI;
{
    int		bytesSent;

    if (pHHI -> redFd == 0)
	return;
    bytesSent = send(pHHI -> redFd, pHHI -> sockBuff, pHHI -> sockBytes, 0);
    if (bytesSent == ERROR)
	{
	if (errno == EWOULDBLOCK)
	    {
	    pHHI -> redTxBuffsize += pHHI -> sockBytes;
	    if (setsockopt(pHHI -> redFd, SOL_SOCKET, SO_SNDBUF, &(pHHI -> redTxBuffsize),
		    sizeof(pHHI -> redTxBuffsize)) == ERROR)
		{
		close(pHHI -> redFd);
		pHHI -> redFd = 0;
		pHHI -> partnerInet = 0;
		return (0);
		}
	    return (hyundaiFlush(pHHI));
	    }
	else
	    {
	    close(pHHI -> redFd);
	    pHHI -> redFd = 0;
	    pHHI -> partnerInet = 0;
	    return (0);
	    }
	}
    else if (bytesSent != pHHI -> sockBytes)
	{
	pHHI -> sockBytes -= bytesSent;
	memmove(pHHI -> sockBuff, pHHI -> sockBuff + bytesSent, pHHI -> sockBytes);
	return (hyundaiFlush(pHHI));
	}
    pHHI -> sockBytes = 0;
    return (1);
}


/****************************************************************/
/*								*/
/*		PUT A MESSAGE INTO THE TCP/IP BUFFER		*/
/*								*/
/****************************************************************/

putHyundaiBytes(pHHI, msgType, buff, nbytes)
HHI_IO		*pHHI;
short		msgType;
char		*buff;
int		nbytes;
{
    /*
    See if there's room in the buffer. If not, make some.
    */

    if ((pHHI -> sockBytes + sizeof(msgType) + nbytes) > sizeof(pHHI -> sockBuff))
	hyundaiFlush(pHHI);
    memmove(pHHI -> sockBuff + pHHI -> sockBytes, (char *) &msgType, sizeof(msgType));
    pHHI -> sockBytes += sizeof(msgType);
    memmove(pHHI -> sockBuff + pHHI -> sockBytes, buff, nbytes);
    pHHI -> sockBytes += nbytes;
    return (0);
}


/****************************************************************/
/*								*/
/*		GET BYTE STREAM FROM THE RX BUFFER		*/
/*								*/
/****************************************************************/

getHyundaiBytes(pHHI, buff, nbytes)
HHI_IO		*pHHI;
char		*buff;
int		nbytes;
{
    memmove(buff, pHHI -> tcpRxBuff + pHHI -> tcpRxBuffIdx, nbytes);
    pHHI -> tcpRxBuffIdx += nbytes;
    pHHI -> tcpRxBuffBytes -= nbytes;
    return (0);
}


/****************************************************************/
/*								*/
/*	DETERMINE IF THE BUFFER HAS A COMPLETE MESSAGE		*/
/*								*/
/****************************************************************/

haveCompleteHyundaiMsg(pHHI)
HHI_IO		*pHHI;
{
    short	msgType;

    if (pHHI -> tcpRxBuffBytes < sizeof(short))
	return (0);
    memmove((char *) &msgType, pHHI -> tcpRxBuff + pHHI -> tcpRxBuffIdx, sizeof(msgType));
    if (msgType == HHI_ACK)
	{
	if (pHHI -> tcpRxBuffBytes >= (sizeof(short) + sizeof(HHI_ACK_MSG)))
	    return(1);
	else
	    return (0);
	}
    else if (msgType == HHI_REDUPDT)
	{
	if (pHHI -> tcpRxBuffBytes >= (sizeof(short) + sizeof(HHI_UPDT_MSG)))
	    return (1);
	else
	    return (0);
	}
    printf("Hyundai redundant socket got out of sync!\n");
    return (0);
}

/*	End of File:	drvmodbus.c */
