/*drvInf7_proto.h,v 1.1.1.1 1999/08/03 14:43:06 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/* Name: drvInf7_proto.h */
/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long 		init ();

       void 		inf7help (void);

       void 		inf7traceon (unsigned short line);

       void 		inf7traceoff (unsigned short line);

       void 		inf7traffic (unsigned short line, unsigned char add,
					unsigned type);

       void 		inf7trafficon (unsigned short line);

       void 		inf7trafficoff (unsigned short line);

       void 		inf7restrlv (unsigned short line, unsigned short level);

       void 		inf7restraceon (unsigned short line);

       void 		inf7restraceoff (unsigned short line);

       void 		inf7trlv (unsigned short line, unsigned short level);

       void 		inf7contraceon (unsigned short line);

       void 		inf7contraceoff (unsigned short line);

       void 		inf7runtraceon (unsigned short line);

       void 		inf7runtraceoff (unsigned short line);

       void 		inf7rejecttraceon (unsigned short line);

       void 		inf7rejecttraceoff (unsigned short line);

       void 		inf7defaulttrace (unsigned short line);

       void 		inf7errortrace (unsigned short line);

       int  		stopinf7 (short ln);

       int  		startinf7 (unsigned short line,
                 		char *mode,
                 		unsigned short delay,
                 		unsigned short hdflag,
                 		unsigned short delay1,
                 		unsigned short delay2,
                 		unsigned short private);

       void 		inf7comm (unsigned short line,
                 		unsigned short tickcount1,
                 		unsigned short hdflag,
                 		unsigned short tickcount2,
                 		unsigned short tickcount3);

       void 		inf7_driver (unsigned short line,
                  		unsigned char *mode,
                  		unsigned short delay,
                  		unsigned short hdflag,
                  		unsigned short delay1,
                  		unsigned short delay2,
                  		unsigned short private);

static void 		on_line (unsigned short line,unsigned short unit);

static void 		mark_not_valid (INF7 *punit);

static void 		scan_unit (INF7 *punit, unsigned short line, unsigned short unit);

static void 		sim_unit (INF7 *punit, unsigned short line, unsigned short unit);

       int  		inf7_aidriver (char *pointname, unsigned short link,
					unsigned short adapter, unsigned short card,
					unsigned short signal, float *pvalue,
					unsigned short conversion, unsigned char *resname);

       int 		inf7_aodriver (char *pointname, unsigned short link,
					unsigned short adapter, unsigned short card,
					unsigned short signal,double dvalue,
					unsigned short value, unsigned short conversion,
					unsigned char *resname);

       int 		inf7_aoread (char *pointname, unsigned short link,
					unsigned short adapter, unsigned short card,
					unsigned short signal, unsigned short *pvalue,
					unsigned short conversion, unsigned char *resname);

       int 		inf7_bidriver (char *pointname, unsigned short link,
					unsigned short adapter, unsigned short card,
					unsigned short signal, unsigned long mask,
					unsigned long *pvalue, unsigned char *resname);

       int 		inf7_bodriver (char *pointname, unsigned short link,
					unsigned short adapter, unsigned short card,
					unsigned short signal, unsigned long value,
					unsigned long mask, unsigned char *resname);

       int 		inf7_boread (char *pointname, unsigned short link,
					unsigned short adapter, unsigned short card,
					unsigned short signal, unsigned long *pvalue,
					unsigned long mask, unsigned char *resname);

static void  		register_resource (unsigned short link, INF7 *punit,
					unsigned char *resname, char *pointname);

static int 		allocate_unit (unsigned short line, unsigned short unit );

static	void 		start_rx (unsigned short line, SEMAPHORE *semid,
					unsigned short *pstatus );

static	void 		stop_rx (unsigned short line );

static	void 		rx_int_proc (unsigned short line );

static int 		check_line_activity (unsigned short line, unsigned short predelay );

static void 		start_tx (unsigned short line, SEMAPHORE *semid,
					unsigned short *pstatus);

static void 		stop_tx (unsigned short line );

static void 		tx_int_proc (unsigned short line );

static unsigned short  	msgxfer (unsigned short fline, INF7 *punit);

static void 		init_unit_tab (unsigned short line, unsigned short unit);

static void 		initunit (INF7  *punit);

static void 		initstats (INF7 *punit);

static unsigned short 	inf7loopback (unsigned short line, unsigned short unit,
					INF7 *punit);

static void 		prepresponses (unsigned short line);

static int 		any_responding (unsigned short line);

static unsigned short 	readblocka (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short 	readblockb (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short 	readblockc (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short 	readblockd (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short 	readblocke (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short 	readdisplaymode (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short 	readmode (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readcnfg1 (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readcnfg2 (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readcnfg3 (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readavgcnfg (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readmeastime (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readalarmtime (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readbatrtedp (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readtotaldp (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readbatldrteof (unsigned short line,
					unsigned short unit, INF7 *punit);

static unsigned short	readbatscrtesc (unsigned short line,
					unsigned short unit, INF7 *punit);

static unsigned short	readtotalof (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readtotalsc (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readrawbatchcnt (unsigned short line,
					unsigned short unit, INF7 *punit);

static unsigned short	readrawbatchno (unsigned short line,
					unsigned short unit, INF7 *punit);

static unsigned short	readrawtotal (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readrawtime (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	readunitmeas1 (unsigned short line, unsigned short unit, INF7 *punit);

static unsigned short	readunitmeas2 (unsigned short line, unsigned short unit,
					INF7 *punit);

static unsigned short	writerawtotal (unsigned short line, unsigned short unit,
					INF7 *punit, unsigned long value);

	unsigned char	translate (unsigned char graycode);

	void		inf7dumpmsgcnts (unsigned short line);

	void		inf7clearmsgcnts (unsigned short line);

	void		inf7dumpstats (unsigned short line, unsigned short maddr);

	void		inf7clearstats (unsigned short line, unsigned short maddr);

	void		inf7info (unsigned short line);

			inf7showlineinfo ();

static void		makecsum (unsigned char *buf, int len);

static	short asciihex (unsigned long *val, char *buf, unsigned short len);

/* End of File:     drvModicon_proto.h */


