/*drvMetone.c,v 1.1.1.1 1999/08/03 14:43:19 tis4000 Exp */

/****************************************************************/
/*                                                              */
/*    This software is the proprietary property of Tate         */
/*    Integrated Systems, L.P.  Patents and copyrights are      */
/*    pending.                                                  */
/*                                                              */
/*    This software is furnished under a license and may        */
/*    be used and copied only in accordance with the terms      */
/*    of such license and with the inclusion of the above       */
/*    notice. This software or any other copies thereof         */
/*    may not be provided or otherwise made available to        */
/*    any other person. No title to and ownership of the        */
/*    software is hereby transferred.                           */
/*                                                              */
/*    The information in this software is subject to            */
/*    change without notice and should not be construed         */
/*    as a commitment by Tate Integrated Systems L.P. or        */
/*    its third party suppliers.                                */
/*                                                              */
/*    Tate Integrated Systems, L.P. (TIS) and its third         */
/*    party suppliers assume no responsibility for the          */
/*    use or inability to use any of its software. TIS          */
/*    software is provided "as is" without warranty of          */
/*    any kind and TIS expressly disclaims all implied          */
/*    warranties, including but not limited to the implied      */
/*    warranties of merchantability and fitness for a           */
/*    particular purpose.                                       */
/*                                                              */
/*    Notice: Notwithstanding any other lease or license        */
/*    that may pertain to or accompany the delivery of this     */
/*    computer software, the rights of the Government           */
/*    regarding its use, reproduction, and disclosure are       */
/*    as set forth in Section 52.227-19 of the FARS             */
/*    Computer Software-Restricted Rights clause.               */
/*                                                              */
/****************************************************************/
/*
/*  File: drvMetone.c
/*  Edit:  1/09/96     wep : created                              
/*                         :
/*
*/                                                                                                                      

#define  MAIN           metone_driver           /* NOTE: change here */
#define  AIDRIVER       metone_aidriver         /* NOTE: change here */
#define  BIDRIVER       metone_bidriver         /* NOTE: change here */
#define  BODRIVER       metone_bodriver         /* NOTE: change here */
#define  BOREAD         metone_boread           /* NOTE: change here */

#define  ASCIION        m1_asciion              /* NOTE: change here */
#define  ASCIIOFF       m1_asciioff             /* NOTE: change here */
#define  TRAFFICON      m1_trafficon            /* NOTE: change here */
#define  TRAFFICOFF     m1_trafficoff           /* NOTE: change here */
#define  TRAFFIC        m1_traffic              /* NOTE: change here */
#define  TRACEON        m1_traceon              /* NOTE: change here */
#define  TRACEOFF       m1_traceoff             /* NOTE: change here */
#define  RTRACE         m1_restrlv              /* NOTE: change here */
#define  RTRACEON       m1_restraceon           /* NOTE: change here */
#define  RTRACEOFF      m1_restraceoff          /* NOTE: change here */
#define  TRACELEVEL     m1_trlv                 /* NOTE: change here */
#define  CONTRACEON     m1_contraceon           /* NOTE: change here */
#define  CONTRACEOFF    m1_contraceoff          /* NOTE: change here */
#define  RUNTRACEON     m1_runtraceon           /* NOTE: change here */
#define  RUNTRACEOFF    m1_runtraceoff          /* NOTE: change here */
#define  REJECTTRACEON  m1_rejecttraceon        /* NOTE: change here */
#define  REJECTTRACEOFF m1_rejecttraceoff       /* NOTE: change here */
#define  NACKTRACEON    m1_nacktraceon          /* NOTE: change here */
#define  NACKTRACEOFF   m1_nacktraceoff         /* NOTE: change here */
#define  DEFAULTTRACE   m1_defaulttrace         /* NOTE: change here */
                                           
#define  HELP           m1_help                 /* NOTE: change here */
#define  SIMON          m1_simon                /* NOTE: change here */
#define  SIMOFF         m1_simoff               /* NOTE: change here */

#define  STOPDRIVER     stopmetone              /* NOTE: change here */
#define  STARTDRIVER    startmetone             /* NOTE: change here */
#define  SETCOMM        m1_comm                 /* NOTE: change here */

#define  DUMPMSGCNTS    m1_dumpmsgcnts          /* NOTE: change here */
#define  CLEARMSGCNTS   m1_clearmsgcnts         /* NOTE: change here */
#define  DUMPMODSTATS   m1_dumpmodulestats      /* NOTE: change here */
#define  CLEARMODSTATS  m1_clearmodulestats     /* NOTE: change here */
                                           
#define  TABLEINFO      m1_tableinfo            /* NOTE: change here */
#define  MODULEINFO     m1_modinfo              /* NOTE: change here */
#define  LINEINFO       m1_lineinfo             /* NOTE: change here */

#define  DUMPSTATE      m1_dumpstate            /* NOTE: change here */

#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvMetone.h>                          /* NOTE: change here */
#include <drvMetone_proto.h>                    /* NOTE: change here */
#include <restable.h>


/* static long    init(); */
struct {
            long        number;
            DRVSUPFUN   report;
            DRVSUPFUN   init;
       }
        drvMetone={ 2, NULL, init};

/*
/*      External Line Level Data Structures (declared in drvcommon.c)
/*
*/

extern  unsigned char   resnames [METONELINES] [RESNAMELEN]; /* array of resource name strings.       */

extern  RES_TABLE      *prestable [METONELINES];      /* array of pointers to resource tables         */

extern  unsigned short  resresponse [METONELINES];    /* array of resource response flags.            */
                                                      /* False = not active resource(slave),          */
                                                      /* True = active resource(master).              */

extern  unsigned short  line_activity [METONELINES];  /* true/false line active flag. calculated      */
                                                      /* using activity_time below.                   */
extern  unsigned short  lastactivity [METONELINES];   /* assigned value of line_activity prior to     */
                                                      /* it's recalculation.                          */

extern  unsigned short  modtrace [METONELINES];       /* controls output of communication error log   */
                                                      /* messages (true/false)                        */
extern  unsigned short  mltrace [METONELINES];        /* controls output of certain resource related  */
                                                      /* log messages (level)                         */
extern  unsigned short  modrestrace [METONELINES];    /* controls output of MASTER/SLAVE arbitration  */
                                                      /* log messages (binary)                        */

extern  SEM_ID          semids [METONELINES] [2];     /* 'new' semaphore logic. the old SEMAPHORE is  */
                                                      /* still used.                                  */

extern  unsigned short  intermsgdelay [METONELINES];  /* holds value passed in task spawn. used for   */
                                                      /* each msgxfer attempt                         */
extern	unsigned short	pretxdelay [METONELINES];     /* holds post RTS delay before TX.              */
extern	unsigned short	posttxdelay [METONELINES];    /* holds post TX delay before dropping RTS.     */


extern  long            activity_time [METONELINES];  /* holds timetick of last activity. used to     */
                                                      /* set line_activity flag                       */

extern  SEM_ID          linemux [METONELINES];        /* 1/03/94: mutual-exclusion semaphore for      */
                                                      /* shared resource of the data link             */
                                                      /* controls access to common path shared by     */
                                                      /* data and diagnostic channels.                */
                                                      /* originally designed for use with MDS remote  */
                                                      /* radio diagnostics.                           */

extern  unsigned short  pstatewait [METONELINES];     /* holds max time in seconds that driver will   */
                                                      /* wait to obtain partner state on first        */
                                                      /* attempting to decide if it should be master. */


/*
/*      Storage for Met One Comm Line Structures
/*
*/

static RXLINE          *rxlinetab [METONELINES] =
                        {NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically         */
                                                          /* allocated comm controls/buffers          */

static TXLINE          *txlinetab [METONELINES] =
                        {NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,
                         NULL, NULL, NULL, NULL, NULL,} ; /* array of pointers to dynamically         */
                                                          /* allocated comm controls/buffers          */


/*
/*      Storage for Met One Structures
/*
*/
static unsigned int     modsim [METONELINES];         /* 0 = normal operation, 1 = simulation.        */

static unsigned int     simdelay [METONELINES];

static          int     simlow [METONELINES];

static          int     simhigh [METONELINES];

static          int     simdigon [METONELINES];

static unsigned int     tick [METONELINES][5];

static unsigned int     lastscan [METONELINES];       /* holds timestamp of start of main loop.       */

static unsigned int     scantime [METONELINES];       /* holds actual time taken to scan modules.     */

static unsigned int     loopoutmsgs [METONELINES];

static unsigned int     loopmsgs [METONELINES];

static LINESTATS        linestats [METONELINES];      /* array of line level statistics.              */


static METONE          *modules [METONELINES] [NUMMODS]; /* two dimensional array of pointers to      */
                                                      /* fixed length dynamically allocated Met One   */
                                                      /* control and data structures.                 */

static  unsigned short  trace [METONELINES];          /* controls output of system error messages:    */
                                                      /* bit mapped controls                          */
static  unsigned char   traceadr [METONELINES];
static  unsigned char   tracetype [METONELINES];

static           char   user [40], password [40];     /* holds id and password of the user that       */
                                                      /* spawned the driver task required by host to  */
                                                      /* check file read privileges on load files     */


static  unsigned short  options [METONELINES];        /* store half/full duplex line status           */

static           char  *bools [] = {"TRUE ", "FALSE"};

static           int    taskId [METONELINES];
static           short  watchdogId [METONELINES];


static           char  *tasknames [] =
                           {"METONE Ch0", "METONE Ch1", "METONE Ch2", "METONE Ch3",
                            "METONE Ch4", "METONE Ch5", "METONE Ch6", "METONE Ch7",
                            "METONE Ch8", "METONE Ch9", "METONE Ch10","METONE Ch11",
                            "METONE Ch12","METONE Ch13","METONE Ch14",
                            "METONE Ch15","METONE Ch16","METONE Ch17",
                            "METONE Ch18","METONE Ch19","METONE Ch20"};


/**********
*
*    This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
{
    return (0);
}

m1_set_rts(line)
{
    set_rts(line);
}

m1_clear_rts(line)
{
    clear_rts(line);
}


/********
/*
/*    This routine outputs information to help with debugging.
/*
********/
void HELP (void)
{
    printf ("Starting and Stopping the Met One Driver:\n");
    printf ("\n");
    printf (" startmetone(N,C,T1,H,T2,T3,P)                                                     \n");
    printf ("                      N: line number                                              \n");
    printf ("                      C: communications parameter string (comma delimited ascii)  \n"); 
    printf ("                     T1: intermessage delay (in ticks).                           \n");
    printf ("                      H: 1 = half duplex.                                         \n");
    printf ("                     T2: post RTS assert, pre TX delay (in ticks).                \n");
    printf ("                     T3: post TX, pre RTS drop delay (in ticks).                  \n");
    printf ("                      P: Private/Redundant mode.  0 = redundant, !0 = private.    \n");
    printf ("                                                                                  \n");
    printf (" Example: startmetone(2,\"19200,N,8,1\",4,1,0,0,0)                                \n");
    printf ("                                                                                  \n");
    printf (" stopmetone(N)                                                                    \n");
    printf ("                     N = line number                                              \n");
    printf ("\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf ("Met One Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" m1_traceon(N)      Enable the following debug messages for line N:             \n");
    printf ("                         1) Major Scan loop Info:                               \n");
    printf ("                           scan time, total output messages, and total messages.\n"); 
    printf ("                         2) Output Queue Overflow.                              \n");
    printf ("                         3) All communication errors encountered in msgxfer.    \n");
    printf ("*m1_traceoff(N)     Disable all of the modtraceon debug messages for line N.    \n");
    printf ("\n");
    printf (" m1_restrace(N,X)   Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*m1_restraceon(N)   Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" m1_restraceoff(N)  Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" m1_contraceon(N)     Enable display of configuration errors in driver calls.     \n");
    printf ("*m1_contraceoff(N)    Disable display of configuration errors in driver calls.    \n");
    printf (" m1_runtraceon(N)     Enable display of runtime errors (queue overflow).          \n");
    printf ("*m1_runtraceoff(N)    Disable display of runtime errors (queue overflow).         \n");
    printf (" m1_rejecttraceon(N)  Enable display of driver call rejections in driver calls.   \n");
    printf ("*m1_rejecttraceoff(N) Disable display of driver call rejections in driver calls.  \n");
    printf (" m1_nacktraceon(N)    Enable display of point deselection on METONE command NACK. \n");
    printf ("*m1_nacktraceoff(N)   Disable display of point deselection on METONE command NACK.\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" m1_trlv(N,X)       Enable the following message for line N:                    \n");
    printf ("                         X=0,  display none of the messages below.              \n");
    printf ("                         X=1,  beginning of scan loop, bringing modules online. \n");
    printf ("                         X=2,  beginning of scan.                               \n");
    printf ("                         X=3 to 7,   reserved                                   \n");
    printf ("                         X=8,  AIDRIVER: normal call return.                    \n");
    printf ("                         X=9,  BIDRIVER: normal call return.                    \n");
    printf ("                         X=10 to 254,  reserved.                                \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" m1_trafficon(N)    Enable traffic tracing for all module addresses             \n");
    printf ("                         and all Met One functions on line N.                   \n");
    printf ("*m1_trafficoff(N)   Disable all traffic tracing on line N.                      \n");
    printf (" m1_traffic(N,X,Y)  Modifies line N traffic tracing as follows:                 \n");
    printf ("                         X=0   disables tracing of all addresses.               \n");
    printf ("                         X=255 enables tracing of all addresses.                \n");
    printf ("                         0 < X < 255 enables tracing of address X traffic.      \n");
    printf ("                         Y=0   disables tracing of all Met One functions.       \n");
    printf ("                         Y=255 enables tracing of all Met One functions.        \n");
    printf ("                         0 < Y < 255 enables tracing of function Y traffic.     \n");
    printf ("\n");
    printf (" m1_defaulttrace(N) Restores default setting for all traces.                    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" m1_simon(N,D,L,H,T) Enables the simulation of responding modules.                 \n");
    printf ("                        D: simulation interval (in seconds). if D<1 or D>60, D=60. \n");
    printf ("                        L: low value of analog simulation range.                   \n");
    printf ("                        H: high value of analog simulation range.                  \n");
    printf ("                        T: 0 = digital inputs are zero. 1 = digitial inputs toggle.\n");
    printf ("*m1_simoff(N)        Disables simulation, thus enabling normal driver function.    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" m1_comm(N,t1,h,t2,t3) Set communication timing parameters for line N as follows:   \n");
    printf ("                         t1: intermessage delay (in ticks).                         \n");
    printf ("                          h: 1 = half duplex.                                       \n");
    printf ("                         t2: post RTS assert, pre TX delay (in ticks).              \n");
    printf ("                         t3: post TX, pre RTS drop delay (in ticks).                \n");
    printf ("\n");
    printf (" m1_dumpmsgcnts(N)     Display line N communication statistics.                    \n");
    printf (" m1_clearmsgcnts(N)    Display and clear line N communication statistics.          \n");
    printf (" m1_dumpmodulestats(N,X)  Display line N, module X, communication statistics.      \n");
    printf (" m1_clearmodulestats(N,X) Display and clear line N, module X, xfers, status & errors.\n");
    printf (" m1_tableinfo(N,X)     Display line N, mod X, xfers, status, errors and input data.\n");
    printf (" m1_modinfo(N)         Display summary stats for all known modules on the line.    \n");
    printf (" m1_lineinfo           Display simple status info for all metone driver lines.     \n");
    printf (" m1_dumpstate(N)       Display debug state data structures.                        \n");
    printf (" m1_help               Display this information.                                   \n");
}


/********
/*
/*    This routine enables logging of comm trace messages
/*
********/
void TRACEON (unsigned short line)
{
    modtrace [line] = TRUE;
}

/********
/*
/*    This routine disables logging of comm trace messages
/*
********/
void TRACEOFF (unsigned short line)
{
    modtrace [line] = FALSE;
}

/********
/*
/*    This routine enables detailed display of normal communications traffic
/*
********/
void TRAFFIC (unsigned short line, unsigned char add, unsigned type)
{
    trace [line] = trace [line] | ALLTRAFFICTRACE;
    traceadr [line] = add;
    tracetype [line] = type;
    return;
}

/********
/*
/*    This routine enables detailed display of normal communications traffic
/*
********/
void TRAFFICON (unsigned short line)
{
    trace [line] = trace [line] | ASCIITRAFFICTRACE;
    trace [line] = trace [line] | ALLTRAFFICTRACE;
    traceadr [line] = 255;  /* every address */
    tracetype [line] = 255; /* every message type */
}

/********
/*
/*    This routine disables detailed display of normal communications traffic
/*
********/
void TRAFFICOFF (unsigned short line)
{
    trace [line] = trace [line] & ~ALLTRAFFICTRACE;
    trace [line] = trace [line] & ~ASCIITRAFFICTRACE;
}

/********
/*
/*    This routine enables detailed display of normal communications traffic in ascii
/*
********/
void ASCIION (unsigned short line)
{
    trace [line] = trace [line] | ASCIITRAFFICTRACE;
}

/********
/*
/*    This routine returns detailed display of normal communications traffic in ascii-hex
/*
********/
void ASCIIOFF (unsigned short line)
{
    trace [line] = trace [line] & ~ASCIITRAFFICTRACE;
}

/********
/*
/*    This routine enables logging of resource trace messages
/*
********/
void RTRACE (unsigned short line, unsigned short level)
{
    modrestrace [line] = level;
}

/********
/*
/*    This routine enables logging of resource trace messages
/*
********/
void RTRACEON (unsigned short line)
{
    modrestrace [line] = 1;
}

/********
/*
/*    This routine disables logging of resource trace messages
/*
********/
void RTRACEOFF (unsigned short line)
{
    modrestrace [line] = 0;
}

/********
/*
/*    This routine controls logging of trace messages
/*
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
    mltrace [line] = level;
}

/********
/*
/*    This routine enables the simulation of responding modules, reading all input values as zero.
/*
********/
void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable)
{
    if ((delay < 1) || (delay > 60))
    {
        simdelay [line] = 60;
    }
    else
    {
        simdelay [line] = delay;
    }
    if (low > high)
    {
        simhigh [line] = low;
        simlow [line] = high;
    }
    else
    {
        simlow [line] = low;
        simhigh [line] = high;
    }
    modsim [line] = TRUE;
    simdigon [line] = digenable;
}

/********
/*
/*    This routine disables simulation, thus enabling normal driver function.
/*
********/
void SIMOFF (unsigned short line)
{
    modsim [line] = FALSE;
}

/********
/*
/*    These routines enable and disable tracing of database configuration errors in driver calls
/*
********/
void CONTRACEON (unsigned short line)
{
    trace[line] = trace[line] | CONFIGURATIONTRACE;
}

void CONTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~CONFIGURATIONTRACE;
}

/********
/*
/*    These routines enable and disable tracing of runtime errors in driver calls
/*
********/
void RUNTRACEON (unsigned short line)
{
    trace[line] = trace[line] | RUNTIMEERRORTRACE;
}

void RUNTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
}

/********
/*
/*    These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void REJECTTRACEON (unsigned short line)
{
    trace[line] = trace[line] | CALLREJECTTRACE;
}

void REJECTTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~CALLREJECTTRACE;
}


/********
/*
/*    These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void NACKTRACEON (unsigned short line)
{
    trace[line] = trace[line] | MODBUSNACKTRACE;
}

void NACKTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~MODBUSNACKTRACE;
}

/********
/*
/*    These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void m1allstatuson (unsigned short line)
{
    trace[line] = trace[line] |
                  OKTRACE |
                  COMMTRACE |
                  PROGTRACE |
                  FATALTRACE |
                  CONFIGTRACE |
                  UNKNOWNTRACE |
                  0;
}

void m1allstatusoff (unsigned short line)
{
    trace[line] = trace[line] &
                  ~OKTRACE &
                  ~COMMTRACE &
                  ~PROGTRACE &
                  ~FATALTRACE &
                  ~CONFIGTRACE &
                  ~UNKNOWNTRACE &
                  ~0;
}

/********
/*
/*    These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void m1badstatuson (unsigned short line)
{
    trace[line] = trace[line] |
                  COMMTRACE |
                  PROGTRACE |
                  FATALTRACE |
                  CONFIGTRACE |
                  UNKNOWNTRACE |
                  0;
}

void m1badstatusoff (unsigned short line)
{
    trace[line] = trace[line] &
                  ~COMMTRACE &
                  ~PROGTRACE &
                  ~FATALTRACE &
                  ~CONFIGTRACE &
                  ~UNKNOWNTRACE &
                  ~0;
}

/********
/*
/*    This routine restores default setting for all traces.
/*
********/
void DEFAULTTRACE (unsigned short line)
{
    /* debug structures */
    modtrace [line] = FALSE;
    mltrace [line] = 0;
    modrestrace [line] = 1;
    trace [line] = 0;
    traceadr [line] = 255;  /* every address      */
    tracetype [line] = 255; /* every message type */
}

int STOPDRIVER (short ln)
{
    if (comm_disconnect (ln) != -1)
    {
        /* if watchdog timer has been attached, detach it before deleting the task */
        if (taskId[ln])
        {
            tisWatchDogDetach(taskId[ln]);
        }
        taskDelete (taskId [ln]);
        return (1);
    }
    else
    {
        return (-1);
    }
}

int STARTDRIVER (unsigned short line,       /* the line number of this driver.                      */
                  char *mode,               /* UART initializations string (comma delimited ascii). */
                  unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                  unsigned short slug,      /* half duplex flag placeholder: ignored.               */
                  unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                  unsigned short delay2,    /* half duplex post TX, pre RTS drop delay.             */
                  unsigned short private)   /* private flag. if 0, normal. if !0, no partner driver.*/
{
    if (line < METONELINES)
    {
        taskId [line] = taskSpawn (tasknames [line],
                                   METONE_PRIORITY,
                                   METONE_TASK_OPTIONS,
                                   METONE_STACK,
                                   MAIN,
                                   line,
                                   mode,
                                   delay,
                                   delay1,
                                   delay2,
                                   private);

        logMsg ("Started the METONE driver on line %d\n",line);

        remCurIdGet (user,password);
        return (1);
    }
    else
    {
        logMsg ("Invalid line number %d\n", line);
        return (-1);
    }
}

/********
/*
/* Set communication logic time delays to handle radio delays and half duplex delays. */
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short slug,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
	pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}


/*                                                                              
/*    metone_driver                                                             
/*                                                                              
/*      The purpose of this task is to scan the metone module lines.            
/*      It will maintain a configuration list supporting online additions       
/*      and replacement of modules, and maintain a table of most recently       
/*      scanned values.                                                         
/*                                                                              
*/                                                                                         
/* not called from within this driver     */

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short delay1,
           unsigned short delay2,
           unsigned short private)
{
    unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
    unsigned short  activity, pstate, lstate, execute, command,i;
    long            this_time, last_time;
    METONE          *pmod;
    RXLINE          *rxp;
    unsigned int    temptick, tempdiff;
    int             temp;

    short  *ptable_id;

    /* Initialize the data structures */
    intermsgdelay [line] = delay;
    pretxdelay [line]    = delay1;
    posttxdelay [line]   = delay2;


    resresponse [line] = FALSE;
    resnames [line] [0] = 0;
    prestable [line] = NULL;

    activity_time [line] = tickGet ();
    lastactivity [line] = line_activity [line] = FALSE;

    pstatewait[line] = 60;      /* will wait up to one minute for partner to become valid */

    /* debug structures */
    /* moddebugtrace (line); */
    DEFAULTTRACE (line);

    tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

    linestats [line].TXintcount = 0;
    linestats [line].RXintcount = 0;
    linestats [line].msgxfercount = 0;
    linestats [line].startingtick = tickGet ();

    modsim [line] = FALSE;              /* start with normal operation. */

    /* communication initialization */
    rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
    if (!rxlinetab [line])
    {
        logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
        return;
    }
    txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
    if (!txlinetab [line])
    {
        logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
        return;
    }

    taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */
    comm_init (line, mode, &tx_int_proc, &rx_int_proc);
    clear_rts (line);
    taskUnlock ();

    onlinefreq = 1;   /* causes on_line calls to begin on first pass if master */

    /* Initialize the Rx interrupts to receive once for activity check         */
    /* enable the receiver interrupt after set to ignore                       */

    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
    enable_rx_ints (line);

/*                                                                                                  
/* 1/03/94:                                                                                         
/*  initialize mutual-exclusion semaphore logic for diagnostic driver path sharing. The Take/Put    
/*  logic implemented below is designed to insure, under heavy diagnostic demand, that scan_module  
/*  and the on_line while routine are executed once for every two diagnostic Take/Put sequences.    
/*  Furthermore, diagnostic activities are suspended during master/slave arbitration by Taking      
/*  the semaphore while the local state is not the master state.                                    
/*
*/   
    taskLock ();
    linemux [line] = semMCreate (SEM_Q_PRIORITY); /* default: semaphore initializes as 'full',    */
                                                  /* ready to be Taken.                           */
    if (!linemux [line])
    {
        logMsg  ("Not enough memory for line %d data structure (mutual-exclusion semaphore)\n",line);
        taskUnlock ();
        return;
    }
    if ((semTake (linemux [line], MUXTIMEOUT)) == ERROR)
    {
        logMsg ("Metone: Mutual-Exclusion Semaphore Timeout on Line\n",line);
        taskDelay(300);
    }

    taskUnlock ();
    taskDelay (120);/* short delay for diagnostic readability */


    /* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
    while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
    {
        if (modrestrace [line] > 1)
        {
            logMsg ( "No Resource Defined for this line.\n");
        }
        taskDelay (600);
    }
    /* diagnostic message */
    logMsg ( "Resource has now been defined for this line.\n");
    taskDelay (60);

    /* attach this driver task to the watchdog timer monitoring function. */
    ptable_id = &watchdogId[line];

    if (tisWatchDogAttach(taskId[line],WATCHDOGTIMEOUT, ptable_id) != OK)
    {
        logMsg("Attempt at watchdog attachment failed.\n");
        tisWatchDogDetach(taskId[line]);
        return;
    }
    if (tisWatchDogPulse(watchdogId[line]) != OK)
    {
        logMsg("First attempt at watchdog pulsing failed.\n");
        tisWatchDogDetach(taskId[line]);
        return;
    }

    /* diagnostic message */
    logMsg ( "Watchdog timer is now attached.\n");
    taskDelay (60);

    if (private)
    {
        /*****************************/
        /* Immediately become master */
        /*****************************/

        resSetCaAnswer (prestable [line]);
        resPutLocalState (prestable [line], RES_MSTR);

        lastscan [line] = tickGet ();
        scantime [line] = 0;

        lstate = RES_MSTR;
        if (modrestrace [line])
        {
            logMsg ("0] Private: Initialize as RES_MSTR\n");
        }
        semGive (linemux [line]);    /* give back semaphore so diagnostics can run   */
    }
    else /* this is the 'normal' path */
    {
        /**********************/
        /* Start out as slave */

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        resClearCaAnswer (prestable [line]);        /* start quiet */
        resPutLocalState (prestable [line], RES_SLV);

        if (modrestrace [line])
        {
            logMsg ("1] Initialized as RES_SLV\n");
        }

        /* wait finite time for pstate to be resolved */
        logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
        for (i = 0; i <= pstatewait [line]; i++)
        {
            resGetStates (prestable [line], &lstate, &pstate);
            if (pstate != 0)
            {
                break;
            }
            taskDelay (60);
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/
        }

        if (pstate == 0)
        {
            logMsg ("Timeout of pstate wait.\n");
        }
        else
        {
            logMsg ("Completion of pstate wait.\n");
        }

        for (i = 0; i < ACTIVITYTIME/10; i++) ;  /* ten seconds */
        {
            taskDelay(10);
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/
        }

        activity = check_line_activity(line, 0);
        resGetStates (prestable [line], &lstate, &pstate);

        /******************************************/
        /* if the partner is not there, be master */

        if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
        {
            resSetCaAnswer (prestable [line]);
            resPutLocalState (prestable [line], RES_MSTR);
            lastscan [line] = tickGet ();
            scantime [line] = 0;
            lstate = RES_MSTR;
            if (modrestrace [line])
            {
                logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
            }
            semGive (linemux [line]);    /* give back semaphore so diagnostics can run   */
        }
    }

    cfgchk = 0;               /* Init the new config pointer.  */
    last_time = tickGet ();   /* Initialize the time.          */

    while (TRUE)
    {
        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        activity_time [line] = tickGet ();
        lastactivity [line] = line_activity [line] = FALSE;

        /*********************************************************************************************/
        /* we arrive here because we are a slave.                                                    */
        /* we stay until:   asked to be master by partner. if we can reach modules, we become master.*/
        /*                  the partner is not master and there is no activity on the line.          */
        /*********************************************************************************************/
        while (lstate == RES_SLV)
        {
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* check for module simulated mode. */
            if (modsim [line])
            {
                semGive (linemux [line]);    /* give back semaphore so diagnostics can function      */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                if (modrestrace [line])
                {
                    logMsg ("Simulation Mode] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                }
                break;
            }
            if (pstate != RES_SLVWANT)
            {
                clear_rts (line);                      /* make sure line is left for master    */
            }
            resresponse [line] = FALSE;                /* make sure driver is not responding   */
            resPutCommand (prestable [line], 0);       /* clear out commands                   */
            activity = check_line_activity (line, 10); /* wait 10 seconds before checking      */
            resGetStates (prestable [line], &lstate, &pstate);

            /****************************************************************************************/
            /* see if needed by partner to be master. if yes, do it and break out of slave state.   */
            if (pstate == RES_SLVWANTCA)
            {
                semGive (linemux [line]);    /* give back semaphore so diagnostics can function     */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;
                onlinefreq = 1;	  /* causes on_line calls to begin on first pass if master */

                if (modrestrace [line])
                {
                    logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                }
                break;
            }
            /***************************************************************/
            /* If partner is there and wants to give it up, try to take it */

            if (pstate == RES_SLVWANT)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                execute = FALSE;
                taskDelay (2); /* Time for switch to occur */

                /* See if anyone is out there and able to respond to a loopback command */
                for (mod = 0; (mod < NUMMODS); mod++)
                {
                    pmod = modules [line] [mod];
                    if ((pmod) &&            /* verify pointer validity prior to use */
                        (pmod->was_requested) &&    /* data points have been requested      */
                        (!pmod->cmd_force_offline)) /* user has NOT forced module offline      */
                    {
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        on_line (line, mod);
                        /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                        if ((pmod->is_responding) && (!pmod->cmd_force_offline))
                        {
                            execute = TRUE;
                            break;
                        }
                    }
                }
                /* If someone answered, become master and make sure partner really gave it up */
                if (execute)
                {
                    resPutLocalState (prestable [line], RES_MSTR);
                    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

                    if (modrestrace [line])
                    {
                        logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                    }
                    execute = FALSE;
                    activity_time [line] = tickGet ();
                    lastactivity [line] = line_activity [line] = FALSE;
                    for (i = 0; (i < 60); i++)
                    {
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/

                        activity = check_line_activity (line, 2); /* pause before testing */
                        resGetStates (prestable [line], &lstate, &pstate);
                        if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
                        {
                            execute = TRUE; /* Partner Gave It Up so take CA */
                            break;
                        }
                    }
                    if (!execute)
                    {   /* Partner did not give it up go back to slave */
                        resPutLocalState (prestable [line], RES_SLV);
                        lstate = RES_SLV;
                        if (modrestrace [line])
                        {
                            logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                        }
                    }
                    else
                    { /* Assume control by taking the CA responsibilities */
                        semGive (linemux [line]);  /* give back semaphore so diagnostics can run. */
                        resSetCaAnswer (prestable [line]);
                        prepresponses (line);
                        break;
                    }
                }
            }

            /********************************************/
            /* if the partner is not talking, be master */

            if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
            {
                semGive (linemux [line]);          /* give back semaphore so diagnostics can run.  */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                lastscan [line] = tickGet ();
                scantime [line] = 0;

                onlinefreq = 1;	  /* causes on_line calls to begin on first pass if master */
                if (modrestrace [line])
                {
                    logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
                }
                prepresponses (line);
            }
        }

        /****************************************************************************************/
        /* to arrive here, we used to be master, and had been told to relinquish master status. */
        /* stay in this loop until the partner takes over, or the command is canceled.          */
        /****************************************************************************************/
        while (lstate == RES_SLVWANTCA)
        {
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            taskDelay (2);                   /* Give OS a chance...  */
            clear_rts (line);                /* Make sure line is left for master    */
            resresponse [line] = FALSE;      /* Make Sure driver is not responding   */

            resGetStates (prestable [line], &lstate, &pstate);
            if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
            {
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                if (modrestrace [line])
                {
                    logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                }
                break;
            }
            resGetCommand (prestable [line], &command);
            resPutCommand (prestable [line], 0); /* clear out commands */
            if (command == RES_CANCELREL)
            {
                semGive (linemux [line]);        /* give back semaphore so diagnostics can run.  */
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;
                if (modrestrace [line])
                {
                    logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                }
                prepresponses (line);
            }
        }

        /****************************************************************************************/
        /* in normal operation this code should never execute. it has, however, been seen to    */
        /* execute when the database has been inadvertently configured with the same resource   */
        /* assigned to two different drivers in the same IOC. The state does funny things.      */
        /****************************************************************************************/
        while (lstate == RES_SLVWANT)
        {
            if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))
            {
                /* condition should NEVER occur. print error message every 5 seconds. */
                logMsg ("Illegal Local Resource State.\n");
                if (trace[line] & CONFIGURATIONTRACE)
                {
                    logMsg ("  Possible Resource Configuration Error:\n");
                    logMsg ("   Check for multiple drivers sharing single Resource.\n");
                }
                taskDelay (600);
            }
            taskDelay (2);
        }

        /****************************************************************************************/
        /* we come here because we have gone to, or are looping in, the master state.           */
        /* we stay in this loop until:    we have been told to give master state to the partner.*/
        /*                                we break out to RES_SLVWANTCA.                        */
        /*                                we have successfully handed master state to partner.  */
        /* While master, this task will process all modules sending outputs and getting inputs. */
        /* It will then try to configure requested non-responding modules.                      */
        /****************************************************************************************/
        last_time = tickGet ();        /* initialize gap */
        while (lstate == RES_MSTR)
        {
            if (mltrace [line] == 1)
            {
                logMsg ( "Top of Master Loop... \n");
            }
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* check for module simulated mode. */
            while (modsim [line])
            {
                resresponse [line] = TRUE; /* Make sure driver is responding. driver won't      */
                for (mod = 0; (mod < NUMMODS); mod++)
                {
                    pmod = modules [line] [mod];    /* shorthand pointer                        */
                    if (pmod)                       /* verify pointer validity prior to use.    */
                    {
                        if (pmod->cmd_force_offline)
                        {
                            /* if user has turned this module offline via pseudo commands,      */
                            /* mark it as not responding.                                       */
                            pmod->is_responding = FALSE;
                        }
                        else
                        {
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/

                            sim_module (pmod, line, mod);      /* I/O done here!         */
                            taskDelay (simdelay [line]);
                        }
                    }
                }
            }
            /* initial stuff */
            resresponse [line] = TRUE; /* Make sure driver is responding. driver won't   */
                                       /* issue commands if not set.                     */

            resGetCommand (prestable [line], &command);
            resPutCommand (prestable [line], 0);        /* clear out commands */

            /************************************************************************/
            /* if relinquish command sent, change state and break out to outer loop */
            if (command == RES_RELINQUISH)
            {
                getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLVWANTCA);
                lstate = RES_SLVWANTCA;
                if (modrestrace [line])
                {
                    logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
                }
                break;
            }

            /* measure time between scans of the entire set of modules. display if requested. */
            temptick = tickGet ();
            tempdiff = temptick - lastscan [line];

            if (modtrace [line])
            {
                logMsg ("ScanTime: =%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                         scantime[line], loopoutmsgs[line], loopmsgs[line]);
            }

            loopoutmsgs [line] = 0;
            loopmsgs [line] = 0;
            lastscan [line] = temptick;

            /* scan modules for data i/o, if allowed */

            modspolled = 0;

            /* call 'scan_module' for each Met One Module, unless the   */
            /* user has taken it off line or it is not responding.     */
            for (mod = 0; (mod < NUMMODS); mod++)
            {
                pmod = modules [line] [mod];  /* shorthand pointer                    */
                if (pmod)                     /* verify pointer validity prior to use */
                {
                    if (pmod->cmd_force_offline)
                    {
                        /* if user has turned this module offline via pseudo commands,   */
                        /* mark it as not responding.                                    */
                        pmod->is_responding = FALSE;
                    }
                    else if (pmod->is_responding)
                    {
                        /* local/partner lockstep recovery */
                         resGetStates (prestable [line], &lstate, &pstate);
                        if (pstate == RES_MSTR)
                        {
                            resClearCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_SLV);
                            lstate = RES_SLV;
                            clear_rts (line);         /* Make sure line is left for master */
                            if (modrestrace [line])
                            {
                                logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                            }
                            temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                            for ( i = 0; i < temp; i++)
                            {
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                            }
                            break;
                        }
                        modspolled++;

                        getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                        scan_module (pmod, line, mod);          /* I/O done here!              */
                        semGive (linemux [line]);
                        if (!pmod->is_responding)
                        {
                            mark_not_valid (pmod);
                        }
                    }
                }
                /* end of single module action */

                /* if told to relinquish our master state, stop module scanning immediately. */
                /* immediately, don't trash the command, so that we can still read it on     */
                /* the next loop through this while statement.                               */
                resGetCommand (prestable [line], &command);
                if (command == RES_RELINQUISH)
                {
                    break;
                }
            } /* end of scan loop */

            /* test for lockstep detection. */
            if (lstate != RES_MSTR) break;

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* measure how long the scan took. to be displayed at beginning of next loop. */
            temptick = tickGet ();
            scantime [line] = temptick - lastscan [line];

            /* try and bring all nonresponding modules on line, but */
            /* don't bring in more than a specified number.         */

            cnt = 0;
            if (--onlinefreq == 0)         /* do we try to bring any in on this pass? */
            {
                onlinefreq = BRINGBACKCNT;
                for (mod = 0; (mod < NUMMODS); mod++)
                {
                    cfgchk++;           /* manage module index */
                    if (cfgchk == NUMMODS)
                    {
                        cfgchk=0;    /* wrap module index */
                    }
                    pmod = modules [line] [cfgchk];
                    if ((pmod) &&        /* verify pointer validity prior to use*/
                        (!pmod->is_responding) &&
                        (pmod->was_requested) &&
                        (!pmod->cmd_force_offline))
                    {
                        getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/

                        on_line (line, cfgchk);    /* loopback testing done here!     */
                        semGive (linemux [line]);

                        modspolled++;
                        cnt++;
                        if (cnt == MAXCFGCK)
                        {
                            break;
                        }
                    }
                }
            }

            /* see if anyone on the line has been responding. */
            /* if not, try to get partner to become slave.    */
            /* Check for no one responding.                   */

            if ((!any_responding (line)) && (!private))
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                /* See if it is time to let partner try */

                this_time = tickGet ();
                if ((this_time - last_time) > (3 * SLWWINDOW))
                {   /* #ticks for slave to try */

                    /* Switch States to let partner know it's its time to try */

                    /* make semGet(linemux[line]) call before the switch to make sure diagnostic */
                    /* task is quiescent while partner is checking the line with the loopback    */
                    /* command. if local not master, then diagnostic won't try anyway, for       */
                    /* either master or remote radios, but it might have begun a 12 second test  */
                    /* sequence just before we got here.                                         */
                    getsemaphore(line);

                    /* we must semGive the semaphore back if and when we go to being the master */


                    resPutLocalState (prestable [line], RES_SLVWANT);
                    lstate = RES_SLVWANT;
                    if (modrestrace [line])
                    {
                        logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate, activity);
                    }
                    /* Give partner access to the hardware */
                    clear_rts (line);

                    /* Remember the time of this try */
                    last_time = tickGet ();
                    lastactivity [line] = line_activity [line] = FALSE;
                    for (i = 0; (i < SLWWINDOW); i += 10)
                    {               /* SLWINDOW is the # of ticks for slave to try */
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        taskDelay (10);
                        /* If partner picked up let it have control */
                        activity = check_line_activity (line, 0);  /* check immediately */
                        resGetStates (prestable [line], &lstate, &pstate);
                        if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
                        {
                            resClearCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_SLV);
                            lstate = RES_SLV;
                            if (modrestrace [line])
                            {
                                logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                            }
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay(60);
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay(60);
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            taskDelay(60);
                            break;
                        }
                    }
                    /* Go Back to being the Master and take control of the hardware */
                    if (lstate != RES_SLV)
                    {
                        semGive (linemux [line]);    /* give back semaphore so diagnostics can run. */
                        resSetCaAnswer (prestable [line]);
                        resPutLocalState (prestable [line], RES_MSTR);
                        lstate = RES_MSTR;
                        if (modrestrace [line])
                        {
                            logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                        }
                    }
                }
            }

            /* take modules off hold status. the module's data are not to be held off since now master. */
            for (mod = 0; (mod < NUMMODS); mod++ )
            {
                pmod = modules [line] [mod];
                if (pmod)            /* verify pointer validity prior to use */
                {
                    pmod->holdflag = FALSE;
                }
            }
            if (modspolled == 0)
            {
                taskDelay(6);
            }
            else
            {
                taskDelay(2);
            }
        }
    } /* end infinite task loop */
}


static void getsemaphore(unsigned short line)
{
    int i;     

    while ((semTake(linemux[line], 10)) == ERROR)
    {
        i =+ 10;
        if (i >= MUXTIMEOUT)
        {
            i = 0;
            logMsg (" Waiting for Radio Diagnostics:");
            printf (" Mutual-Exclusion Semaphore Timeout on Line %d\n", line);
        }
        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/
    }
    return;
}

/*
/* Try to bring a Met One module on line
/*
*/

/* this routine only called from MAIN */

static void on_line (unsigned short line, unsigned short mod)
{
    METONE          *pmod;
    unsigned short   i, j;

    pmod = modules [line] [mod];
    if (pmod)            /* verify pointer prior to use */
    {
        if (mltrace [line] == 1)
        {
            logMsg ( "Bring Online Met One Module %d\n", mod );
        }


        /* Use the loopback function to see if the unit is there and responding */
        if (!selectcounter (ONERETRY + line, mod, pmod))
            return; /* if no response, get out */
        if (!setmode (ONERETRY + line, mod, pmod))
            return; /* if no response, get out */
        if (!stopcount (ONERETRY + line, mod, pmod))
            return; /* if no response, get out */

        /* we have initialized the Module and it is ready to read */

        mark_not_valid (pmod);    /* a module that has just been brought online must  */
                                  /* have it's data marked as being not valid.        */
        pmod->is_responding = TRUE;
        pmod->controlstate = INITCOUNT;
    }
}


/*                                                          
/* Mark all module data elements as not valid               
/*                                                          
*/                                                 
/* called from on_line and prepresponses              */        

static void mark_not_valid (METONE  *pmod)
{
    unsigned    short i, j;

    /* Particle Counters are initalized in the driver as not valid. */
    for (i = 0; (i < NUMPCCHANNELS); i++)
    {
        pmod->pcinputs [i].data_valid = FALSE;
    }
    /* Analog Inputs are initalized in the driver as not valid. */
    for (i = 0; (i < NUMAICHANNELS); i++)
    {
        pmod->aiinputs [i].data_valid = FALSE;
    }
}

/*                                                                  
/* Scan a METONE Module -  get inputs and set outputs as required   
/*                                                                  
*/
/* this routine only called from MAIN         */

static void scan_module (METONE *pmod, unsigned short line, unsigned short mod)
{
    unsigned short  i, j, k, val, bitaddr, regaddr, readlen;
    unsigned long   bitmask;
    unsigned short  temp, cmd;

    pmod->tscanpass++;

    if (mltrace [line] == 2)
    {
        logMsg ( "Scanning Module %d.\n", mod  + MINMODNO);
    }


    if (!selectcounter (line, mod, pmod))
        return;          /* if no response, get out                                 */


    if (pmod->controlstate == COUNTING)
    {
        if ((tickGet() - pmod->starttimestamp) > COUNTTIME)
        {
            if (!stopcount (line, mod, pmod))
            {
                 return; /* if no response, or unexpected response, get out         */
            }
            pmod->stoptimestamp = tickGet ();
            pmod->counttime = pmod->stoptimestamp - pmod->starttimestamp;

            /* at 100 ml/minute flow rate, (100/60*60)*counttime gives particles per millileter. */
            pmod->normfactor = (float)(60*60)/((float)100 * (float)pmod->counttime);
            pmod->controlstate = COUNTDONE;
        }
        else
        {
            /* keep communications active, even when waiting for count time to end. */
            if (!sendmode (line, mod, pmod))
            {
                 return; /* if no response, or unexpected response, get out         */
            }
        }
    }

    if (pmod->controlstate == COUNTDONE)
    {
        pmod->controlstate = REQUESTDATA;
        if (!sendrecord (line, mod, pmod))
        {
            pmod->controlstate = REREQUESTDATA;
            if (!resendrecord (line, mod, pmod))
            {
                if (!resendrecord (line, mod, pmod))
                {
                     pmod->controlstate = REQUESTFAIL;
                     return; /* if no response, or unexpected response, get out */
                }
                pmod->controlstate = REQUESTDONE;
            }
            else
            {
                pmod->controlstate = REQUESTDONE;
            }
        }
        else
        {
            pmod->controlstate = REQUESTDONE;
        }
    }

    if ((pmod->controlstate == INITCOUNT) ||
        (pmod->controlstate == REQUESTFAIL) ||
        (pmod->controlstate == REQUESTDONE))
    {
        if (!startcount (line, mod, pmod))
        {
             return; /* if no response, or unexpected response, get out */
        }
        pmod->starttimestamp = tickGet ();

        pmod->controlstate = COUNTING;
        return;
    }
}


static void sim_module (METONE *pmod, unsigned short line, unsigned short mod)
{
    unsigned short   i, j, k, val, bitaddr, regaddr, readlen;
    unsigned long    bitmask;
    unsigned short   temp, cmd;

    pmod->is_responding = pmod->was_requested;

    pmod->statusbyte = 0;

    pmod->counttime = 30*60;
    pmod->normfactor = (float)(60*60)/((float)100 * (float)pmod->counttime);

    /* read the particle counters values to be scanned */
    for (i = 0; (i < NUMPCCHANNELS); i++)
    {
        if ( pmod->pcinputs [i].was_requested )
        {
            pmod->pcinputs [i].data_valid = TRUE;

            pmod->pcinputs [i].raw_label[0] = 'C';
            pmod->pcinputs [i].raw_label[1] = '0' + (i%10);
            pmod->pcinputs [i].raw_label[2] = '0' + (i/10);

            pmod->pcinputs [i].raw_label[0] = 'S';
            pmod->pcinputs [i].raw_label[1] = 'I';
            pmod->pcinputs [i].raw_label[2] = 'M';
            pmod->pcinputs [i].raw_label[0] = '0';
            pmod->pcinputs [i].raw_label[1] = '0' + (i%10);
            pmod->pcinputs [i].raw_label[2] = '0' + (i/10);

            if ((pmod->pcinputs [i].last_data < (simlow [line] + (i*100))) ||
                (pmod->pcinputs [i].last_data >= (simhigh [line] + (i*100))))
            {
                pmod->pcinputs [i].last_data = simlow [line] + (i*100);
            }
            else
            {
                pmod->pcinputs [i].last_data += 1;
            }

            /* calculate differential data immediately. */
            if (i == 0)
            {
                pmod->pcinputs [i].diff_data = pmod->pcinputs [i].last_data;
            }
            else
            {
                pmod->pcinputs [i].diff_data = pmod->pcinputs [i].last_data - pmod->pcinputs [i-1].last_data;
            }

            pmod->pcinputs [i].last_norm = pmod->pcinputs [i].last_data * pmod->normfactor;
            pmod->pcinputs [i].diff_norm = pmod->pcinputs [i].diff_data * pmod->normfactor;
            pmod->pcinputs [i].data_valid = TRUE;




        }
    }
    /* read the ai values to be scanned */
    for (i = 0; (i < NUMAICHANNELS); i++)
    {
        if ( pmod->aiinputs [i].was_requested )
        {
            pmod->aiinputs [i].data_valid = TRUE;


            pmod->aiinputs [i].raw_label[0] = 'A';
            pmod->aiinputs [i].raw_label[1] = '0' + (i%10);
            pmod->aiinputs [i].raw_label[2] = '0' + (i/10);

            pmod->aiinputs [i].raw_label[0] = 'S';
            pmod->aiinputs [i].raw_label[1] = 'I';
            pmod->aiinputs [i].raw_label[2] = 'M';
            pmod->aiinputs [i].raw_label[0] = '0';
            pmod->aiinputs [i].raw_label[1] = '0' + (i%10);
            pmod->aiinputs [i].raw_label[2] = '0' + (i/10);

            if ((pmod->aiinputs [i].last_data < (simlow [line] + (i*100))) ||
                (pmod->aiinputs [i].last_data >= (simhigh [line] + (i*100))))
            {
                pmod->aiinputs [i].last_data = simlow [line] + (i*100);
            }
            else
            {
                pmod->aiinputs [i].last_data += 1;
            }
        }
    }
}


/*                                                                                     
/*      AIDRIVER                                                                       
/*                                                                                     
/*      This routines main purpose is to return the analog input value for the         
/*      specified module. For a module value                                           
/*      a (-1) will be returned if there is no valid data ready.                       
/*
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
        unsigned short signal, float *pvalue, unsigned short conversion,
        unsigned char *resname)
{
    METONE          *pmod;
    unsigned short   blkix;
    float           *pdata;

    if (link > METONELINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((adapter > MAXMODNO) || (adapter < MINMODNO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
         return (-1);
    }

    if (((card > MAXAICARDNO) || (card < MINAICARDNO)) &&
        ( card > MAXPCCARDNO) &&
        ( card != MPSEUDO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pmod = modules [link] [adapter - MINMODNO];
    if (pmod == NULL)
    {
        if (!allocate_module (link, adapter - MINMODNO))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = modules [link] [adapter - MINMODNO];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the Module values requested */
                *pvalue = pmod->was_requested;
                break;

            case 1: /* Is the Module responding */
                *pvalue = pmod->is_responding;
                break;

            case 6: /* Input Messages */
                *pvalue = pmod->no_datain_msgs & 0x7fff;
                break;

            case 7: /* No Receiver Responses */
                *pvalue = pmod->no_rxnoresp & 0x7fff;
                break;

            case 8: /* No Transmitter Response */
                *pvalue = pmod->no_txnoresp & 0x7fff;
                break;

            case 9: /* Message Reply Errors */
                *pvalue = pmod->no_dataerr & 0x7fff;
                break;

            case 10: /* Message Retries */
                *pvalue = pmod->no_retries & 0x7fff;
                break;

            case 11: /* RX Hardware errors */
                *pvalue = pmod->no_rxhwerrs & 0x7fff;
                break;

            case 12: /* TX Hardware errors */
                *pvalue = pmod->no_txhwerrs & 0x7fff;
                break;

            case 13: /* Metone reported checksum errors */
                *pvalue = pmod->no_chksumerrs & 0x7fff;
                break;

            case 14: /* Offline transitions */
                *pvalue = pmod->no_offlines & 0x7fff;
                break;

            case 15: /* reset statistics */
                *pvalue = pmod->cmd_reset_stat;
                break;

            case 16: /* Force the Module offline */
                *pvalue = pmod->cmd_force_offline;
                break;

	    case 17: /* Failed output commands */
		*pvalue = pmod->badoutcnt & 0x7fff;
		break;

            case 19: /* Metone reported no errors */
                *pvalue = pmod->noerror & 0x7fff;
                break;

            case 20: /* Metone Bit 0 Error responses */
                *pvalue = pmod->bit0error & 0x7fff;
                break;

            case 21: /* Metone Bit 1 Error responses */
                *pvalue = pmod->bit1error & 0x7fff;
                break;

            case 22: /* Metone Bit 2 Error responses */
                *pvalue = pmod->bit2error & 0x7fff;
                break;

            case 23: /* Metone Bit 3 Error responses */
                *pvalue = pmod->bit3error & 0x7fff;
                break;

            case 24: /* Metone Bit 4 Error responses */
                *pvalue = pmod->bit4error & 0x7fff;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        /* check for illegal conversion type */
        if (conversion != NOCONV)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal Pseudo Point Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        return (0);
    }

    /* check for illegal signal */
    if ((card <= MAXPCCARDNO) && (signal > MAXPCNO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d, min=%d\n",
                    pointname, link, adapter, card, signal, MAXPCNO, MINPCNO);
        return (-1);
    }

    /* check for illegal signal */
    if ((card <= MAXAICARDNO) && (card >= MINAICARDNO) && (signal != MAXAINO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d, min=%d\n",
                    pointname, link, adapter, card, signal, MAXAINO, MINAINO);
        return (-1);
    }

    if (resname != 0)
    { 
        register_resource (link, pmod, resname, pointname);
    }
    pmod->was_requested = TRUE;


    /* check for illegal conversion type */
    if ((conversion != NOCONV) && (conversion != LINEAR) && (conversion != AICNVSQRROOT))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }


    /* as soon as the address is confirmed as valid, set was_requested flag. */
    if ((card <= MAXPCCARDNO))
    {
        pmod->pcinputs [card-MINPCCARDNO].was_requested = TRUE;
    }

    if ((card <= MAXAICARDNO) && (card >= MINAICARDNO))
    {
        pmod->aiinputs [card-MINAICARDNO].was_requested = TRUE;
    }

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (pmod->holdflag)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }

    if (!pmod->is_responding)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if ((card <= MAXPCCARDNO))
    {
        if (!pmod->pcinputs[card-MINPCCARDNO].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        switch (signal)
        {
            case 0:
                *pvalue = pmod->pcinputs [card-MINPCCARDNO].last_norm;
                break;
            case 1:
                *pvalue = pmod->pcinputs [card-MINPCCARDNO].diff_norm;
                break;
            case 2:
                *pvalue = pmod->pcinputs [card-MINPCCARDNO].last_label;
                break;
        }
    }

    if ((card <= MAXAICARDNO) && (card >= MINAICARDNO))
    {
        if (!pmod->aiinputs[card-MINAICARDNO].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        *pvalue = pmod->aiinputs [card-MINAICARDNO].last_data;
    }

    if (mltrace[link] == 8)
        logMsg("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%12.6f\n",
                pointname, link, adapter, card, signal, *pvalue);

    return(0);
}


/*                                                                                    
/*      BIDRIVER                                                                      
/*                                                                                    
/*      The main purpose of this routine is to return the request digital input       
/*      value(s) from the requested card. This routine will return a (-1) if the      
/*      requested module is the wrong type or the data is not yet valid.              
/*                                                                                    
*/
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
        unsigned short signal, unsigned long mask, unsigned long *pvalue,
        unsigned char *resname)
{
    METONE          *pmod;

    if (link > METONELINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if ((adapter > MAXMODNO) || (adapter < MINMODNO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if ((card != MPSEUDO) && (card != METSTATUS))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    pmod = modules [link] [adapter - MINMODNO];
    if (pmod == NULL)
    {
        if (!allocate_module (link, adapter - MINMODNO))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = modules [link] [adapter - MINMODNO];
    }

    pmod->was_requested = TRUE;

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the Module values requested */
                *pvalue = pmod->was_requested;
                break;

            case 1: /* Is the Module responding */
                *pvalue = pmod->is_responding;
                break;

            case 15: /* reset statistics */
                *pvalue = pmod->cmd_reset_stat;
                break;

            case 16: /* Force the Module offline */
                *pvalue = pmod->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        if (mltrace[link] == 9)
            logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, pvalue);
        return (0);
    }

    /* to arrive here, the card must be MODULE STATUS */


    /* check for illegal signal */
    if (signal > MAXDINO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d, min=%d\n",
                    pointname, link, adapter, card, signal, MAXDINO, MINDINO);
        return (-1);
    }

    if (resname != 0)
    { 
        register_resource (link, pmod, resname, pointname);
    }
    pmod->was_requested = TRUE;

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (pmod->holdflag)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }

    if (!pmod->is_responding)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    *pvalue = (unsigned long) pmod->statusbyte & (1 << signal); /* there is only one BI byte */

    if (mltrace[link] == 9)
        logMsg("BIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V= %12.6f\n",
                pointname, link, adapter, card, signal, *pvalue);
    return(0);
}

/*                                                                                     
/*      BODRIVER                                                                       
/*                                                                                     
/*      The main purpose of this routine is to set the request digital output          
/*      value(s) on the requested card. This routine will return a (-1) if the         
/*      requested module is the wrong type or not configured yet.                      
/*                                                                                     
*/
/* this routine not called from within this driver */

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
        unsigned short signal, unsigned long value, unsigned long mask,
        unsigned char *resname)
{
    METONE         *pmod;

    if (link > METONELINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if ((adapter > MAXMODNO) || (adapter < MINMODNO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
            return (-1);
    }

    pmod = modules [link] [adapter - MINMODNO];
    if (pmod == NULL)
    {
        if (!allocate_module (link, adapter - MINMODNO))
        {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = modules [link] [adapter - MINMODNO];
    }

    if (card == MPSEUDO)
    {
        switch (signal & 0x1f)
        {
            case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats (pmod);
                }
                break;

            case 16: /* Force the Module offline */
                pmod->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
                }
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }
}

/*                                                                              
/*      BOREAD                                                                  
/*                                                                              
/*      This routines main purpose is to return the value last read back        
/*      from the digital output hardware. This is used to initialize digital    
/*      outputs. This will return a (-1) if the module is the wrong type or     
/*      the data is not yet valid                                               
*/
/* this routine not called from within this driver */


int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
        unsigned short signal, unsigned long *pvalue, unsigned long mask,
        unsigned char *resname)

{
    METONE          *pmod;

    if (link > METONELINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((adapter > MAXMODNO) || (adapter < MINMODNO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
         return (-1);
    }

    pmod = modules [link] [adapter - MINMODNO];
    if (pmod == NULL)
    {
        if (!allocate_module (link, adapter - MINMODNO))
        {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = modules [link] [adapter - MINMODNO];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 15: /* reset statistics */
                *pvalue = pmod->cmd_reset_stat;
                break;

            case 16: /* Force the Module offline */
                *pvalue = pmod->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }
}
/*                                                                              
/* register_resource                                                            
/*                                                                              
/*    This routine is used to initialize the resource pointers                  
/*  If this is the first time the resource for this line is being               
/*  referenced the pointer to the resource table entry will be set              
/*  and the resource name will be saved. If the resource name has               
/*  already been set, this routine will verify that all other points            
/*  for this driver are using the same resource name.                           
/*                                                                              
*/                                                                                        
/* this routine called from AIDRIVER, AODRIVER, AOREAD,                         
/*  BIDRIVER, BODRIVER, and BOREAD.                                             
*/                                   

static void  register_resource (unsigned short link, METONE *pmod,
                                unsigned char *resname, char *pointname)
{
    if (resnames [link] [0] == 0) /* This is the first reference */
    {
        if (resGetByName (resname, &prestable [link]) != RES_OK)
        {
        logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
                resname );
        }
        else
        {
        strcpy (resnames [link], resname);
        }
    }
    else
    {
        if (strcmp (resnames [link], resname) != 0)
        {
        logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
                resnames[link],
                                pointname,
                resname );
        }
    }
}


/*                                                                              
/*                                                                              
/*    allocate_module                                                           
/*                                                                              
/*    The purpose of this routine is to allocate the memory for a single        
/*    module data structure. If not successful, a console error message is      
/*    printed and an error flag is returned to the caller.                      
/*    If successful, the newly allocated data structures are initialized.       
/*                                                                              
*/

static int allocate_module (unsigned short line, unsigned short module )
{
    modules [line] [module] = (METONE *) calloc (1, (sizeof (METONE)));
    if (!modules [line] [module])
    {
        logMsg ("Unable to allocate memory");
            printf (" for METONE data structure on line %d, module %d\n",line ,module);
        return(FALSE);
    }
    else
    {
        logMsg ("Allocated memory for METONE data structure on line %d, module %d\n",line ,module);
        init_module_tab (line, module);         /*    initialize the data structures. */
    }

    return (TRUE);
}



/*                                                                          
/*      start_rx                                                            
/*                                                                          
/*      The purpose of this routine is to initialize a line table           
/*      for receive and to enable the receiver.                             
/*                                                                          
*/
/* only called from msgxfer */

static  void start_rx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus)
{
    RXLINE        *rxp;

    rxp = rxlinetab [line];
    rxp->rxix = 0;
    rxp->semid = semid;
    rxp->status = pstatus;
    rxp->rxstate = RXRESPONSE;
}

/*                                                                               
/*      stop_rx                                                                  
/*                                                                               
/*      The purpose of this routine is to initialize a line table                
/*      for receive and to disable the receiver.                                 
/*                                                                               
*/
/* only called from msgxfer */

static  void stop_rx (unsigned short line )

{
    RXLINE        *rxp;

    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
}


/*                                                                                 
/*      NEW rx_int_proc                                                            
/*                                                                                 
/*      The purpose of this routine is to process a receive character interrupt    
/*      for a given line.                                                          
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static  void rx_int_proc (unsigned short line )
{
    unsigned char   rxchar;
    unsigned short  rxstat;
    unsigned short  rx_err_mask;
    RXLINE         *rxp;

    read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);
    linestats [line].RXintcount++;
    rxp = rxlinetab [line];

    /* Something is sending in data. */
    line_activity [line] = TRUE;
    if (rxp->rxstate == RXIGNORE)
    {
        return;
    }
    /* no matter what the state, errors cause a logical reset of the message processing */
    if ((rxstat & rx_err_mask) != 0)
    {
        rxp->rxstate = RXRESPONSE; /* if comm goes bad, assume it was garbage,  */
                                   /* and go wait for the good stuff.           */ 
        rxp->rxix = 0;             /* reset the buffer index/counter            */
        return;
    }

    rxp->rxbuf [rxp->rxix++] = rxchar; /* store the character in the buffer and bump the index. */
    switch (rxp->rxstate)
    {
        case RXRESPONSE:          /* Waiting for reply completion: fixed count or CRLF   */
            if (rxp->rxix >= rxp->rxmsglenexpected)
            {
                *(rxp->status) = RXGOOD;
                rxp->rxstate = RXIGNORE;
                semGive (rxp->semid);
                return;
            }
            if (rxchar == 0x0d)
            {
                rxp->rxstate = RXCRLF;
                return;
            }

        case RXCRLF:              /* Waiting for terminating linefeed */
            if (rxchar == 0x0a)
            {
                *(rxp->status) = RXGOOD;
                rxp->rxstate = RXIGNORE;
                semGive (rxp->semid);
                return;
            }
            else
            {
                rxp->rxstate = RXRESPONSE;      /* presume it was a false CR earlier. */
                                                /* go wait for the real one.          */ 
                return;
            }

            if (rxp->rxix >= MAXRXMSG)          /* don't overflow the buffer.     */
            {
                *(rxp->status) = RXBAD;
                rxp->rxstate = RXIGNORE;
                semGive (rxp->semid);
                return;
            }
    }
    return;
}


/*                                                                             
/*      check_line_activity                                                    
/*                                                                             
*/
/* only called from MAIN  */

static  int check_line_activity (unsigned short line, unsigned short predelay )
{
    RXLINE      *rxp;
    long         thistime;
    short        status;

    if (predelay != 0)
    {
        taskDelay (predelay);
    }
    thistime = tickGet ();
    if ((thistime - activity_time [line]) < ACTIVITYTIME)
    {
        return (lastactivity [line] || (line_activity [line]));
    }
    lastactivity [line] = status = line_activity [line];
    line_activity [line] = FALSE;
    activity_time [line] = thistime;
    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;

    return (status);
}


/*                                                                                 
/*      start_tx                                                                   
/*                                                                                 
/*      The purpose of this routine is to initialize a line table                  
/*      for send and to enable the transmitter.                                    
/*                                                                                 
*/
/* only called from msgxfer  */

static  void start_tx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus )
{
    TXLINE        *txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txix = 0;
    txp->semid = semid;
    txp->status = pstatus;
    txp->txdisable = FALSE;

    enable_tx_ints (line);
}


/*                                                                                 
/*      stop_tx                                                                    
/*                                                                                 
/*      The purpose of this routine is to initialize a line table                  
/*      for receive and to disable the receiver.                                   
/*                                                                                 
*/
/* only called from msgxfer  */

static  void stop_tx (unsigned short line )
{
    TXLINE        *txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txdisable = TRUE;

    /* the 485 interface uses RTS to control direction of line transmission. */
    clear_rts (line);
}


/*                                                                                
/*      tx_int_proc                                                               
/*                                                                                
/*      The purpose of this routine is to process a transmit character interrupt  
/*      for a given line.                                                         
/*                                                                                
*/
/* only called from MAIN  */

static  void tx_int_proc (unsigned short line )
{
    char            txchar;
    unsigned short  txstat;
    unsigned short  tx_err_mask;
    TXLINE         *txp;

    linestats [line].TXintcount++;

    txp = txlinetab [line];

    if (txp->txdisable)
    {
        return;
    }

    if (txp->txix < txp->txmsglen)
    {
        txchar = txp->txbuf [txp->txix++];
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD;
            semGive (txp->semid);
            return;
        }
        if (txp->txix >= MAXTXMSG)
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD;
            semGive (txp->semid);
            return;
        }
        return;
    }

    if (txp->txix == txp->txmsglen)
    {
        /* the 485 interface uses RTS to control direction of line transmission.        */
        /* we transmit an extra character (NULL) in order to provide time for the last  */
        /* 'real' character to be transmitted before completing tranmission interrupt   */
        /* servicing and reversing the RTS line in order to receive the reply.          */

        txchar = 0;
        txp->txix++;
/*        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        if ((txstat & tx_err_mask) != 0 )
        {
*/
/*            txp->txdisable = TRUE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD;
            semGive (txp->semid);
*/
/*        } */
/*        return;
    }

    if (txp->txix > txp->txmsglen)
    {
*/
        txp->txdisable = TRUE;
        disable_tx_ints (line);
        *(txp->status) = TXGOOD;
        semGive (txp->semid);
        return;
    }
}


/*                                                                               
/*      msgxfer                                                                  
/*                                                                               
/*      The purpose of this routine is to transmit a buffer to the               
/*      Metone Module and to await a response. The transmit and receive buffers  
/*      are in their respective line tables. This routine will retry the         
/*      message up to a maximum number of times or until a response is received  
/*      with a proper checksum.                                                  
/*              returns         XFERGOOD if response received                    
/*                              XFERBAD  if no good response is received         
/*                                                                               
*/

static  unsigned short  msgxfer (unsigned short fline, METONE *pmod, unsigned short responselen)
{
    unsigned short  retry, txstatus, rxstatus, txlen, rxlen, line, ix, i;
    RXLINE         *rxp;
    TXLINE         *txp;
    unsigned char   csums [2];
    unsigned short  oldrxix;
    unsigned int    tick1, tick2, tick3, tick4;
    unsigned int    delta40, delta01, delta12, delta23, delta34;
    unsigned long   msgstart;
    unsigned short  status, statusclass;
    unsigned char   tempbuf[2];
             short  baseoffset;

    msgstart = tickGet();
    line = (fline & (~ONERETRY));          /* strip off the no retry flag*/
    delta40 = delta01 = delta12 = delta23 = delta34 = 0;

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++)
    {
        linestats [line].msgxfercount++;
        loopmsgs [line]++;

        /* time since end of last msgxfer */
        tick [line] [0] = tickGet ();
        delta40 = (tick [line] [0] - tick [line] [4]);

        if (intermsgdelay [line] != 0)
        {
            taskDelay (intermsgdelay [line]);
        }

        txstatus = IO_TIMEOUT;
        rxstatus = IO_TIMEOUT;

        semTake (semids [line] [TXSEM], NO_WAIT);
        semTake (semids [line] [RXSEM], NO_WAIT);

        txlen = txp->txmsglen;

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        if ((trace [line] & ALLTRAFFICTRACE) &&
            ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
            ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
        {
            printf ("TX:____");
            if (trace [line] & ASCIITRAFFICTRACE)
            {
                for (ix = 0; ix < txlen ; ix++) /* just print what is there to print */
                {
                    if (!((txp->txbuf [ix]) < 0x20))
                    {
                        printf("%c", txp->txbuf [ix]);
                    }
                    else
                    {
                        printf ("<%x>", txp->txbuf [ix]);
                    }
                }
                printf ("\n");
            }
            else
            {
                for (ix = 0; ix < 12 ; ix++) /* 12 is maximum TX message length */
                {
                    if (ix < txlen)
                    {
                        printf("_%2x", txp->txbuf [ix]);
                    }
                    else
                    {
                        printf ("...");
                    }
                }
                printf ("\n");
            }
        }

        /* the 485 interface uses RTS to control direction of line transmission.        */
        /* we assert RTS immediately prior to beginning transmission.                   */
        set_rts (line);

        if (pretxdelay [line] != 0)
        {
            taskDelay (pretxdelay [line]);
        }

        /* time from entering msgxfer to starting transmission. (including delays & diags) */
        tick [line] [1] = tickGet ();
        delta01 = (tick [line] [1] - tick [line] [0]);

        rxp->rxmsglenexpected = responselen;
         
        start_rx (line, semids [line] [RXSEM], &rxstatus);
        start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */

        if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
        {
            txstatus = IO_TIMEOUT;
        }

        /* the 485 interface uses RTS to control direction of line transmission.        */
        /* we clear the RTS line immediately after transmitting the full message.       */
        stop_tx (line);

        if (posttxdelay [line] != 0)
        {
            taskDelay (posttxdelay [line]);
        }

        clear_rts (line);

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        /* time to transmit message. */
        tick [line] [2] = tickGet ();
        delta12 = (tick [line] [2] - tick [line] [1]);


        /* intermessage wait time. */
        tick [line] [3] = tickGet ();
        delta23 = (tick [line] [3] - tick [line] [2]);

        if (txstatus == TXGOOD)
        {
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            oldrxix = -1;    /* make it pass through timeout loop at least once */
            while ((semTake (semids [line] [RXSEM], (int) (RXTIMEOUT))) == ERROR)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                if (oldrxix == rxp->rxix)
                {
                    if (modtrace [line])
                    {
                        logMsg("RX timeout\n");
                    }
                    rxstatus = IO_TIMEOUT;
                    break;
                }
                else
                {
                    if ((modtrace [line]) || (mltrace[line] == 12))
                    {
                         logMsg("waiting...");
                    }
                }
                oldrxix = rxp->rxix;
            }
            stop_rx (line);

            /* time to receive message. */
            tick [line] [4] = tickGet();
            delta34 = (tick [line] [4] - tick [line] [3]);

            rxlen = rxp->rxix; /* index is just past last received character. length EQUALS index */
            if (rxstatus == RXGOOD)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                    ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                {
                    printf ("RX:____");
                    if (trace [line] & ASCIITRAFFICTRACE)
                    {
                        for (ix = 0; ix < rxlen ; ix++) /* just print what is there to print */
                        {
                            baseoffset = (short) ix - 21;

                            if (((baseoffset)%44 == 0) && (baseoffset != 0))
                            {
                                printf ("\n                            "); /* avoid line wrap */
                            }

                            if (!((rxp->rxbuf [ix]) < 0x20))
                            {
                                printf("%c", rxp->rxbuf [ix]);
                            }
                            else
                            {
                                printf ("<%x>", rxp->rxbuf [ix]);
                            }
                        }
                        /* printf ("\n");*/
                    }
                    else
                    {
                        for (ix = 0; ix < 20 ; ix++) /* 20 is maximum RX message length */
                        {
                            if (ix < rxlen)
                            {
                                printf("_%2x", rxp->rxbuf [ix]);
                            }
                            else
                            {
                                printf ("...");
                            }
                        }
                        /* printf ("\n"); */
                    }
                    printf(" ............. DELTA: %3d %3d %3d %3d %3d\n",
                            delta40, delta01, delta12, delta23, delta34);
                }
                /**********************************************/
                /**********************************************/

                pmod->msgs++;
                pmod->responsetime += (tickGet() - msgstart);
                return (XFERGOOD);
            } /* bottom of rxstatus == RXGOOD */
            else
            {
                if (rxstatus == IO_TIMEOUT)
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/
                    
                    if (modtrace [line])
                    {
                        logMsg ("Receive Timeout... Length: %d\n", rxlen);
                    }
                    if ((trace [line] & ALLTRAFFICTRACE) &&
                        ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                        ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                    {
                        printf ("DELTA: %3d %3d %3d %3d %3d\n",
                                delta40, delta01, delta12, delta23, delta34);
                    }
                    pmod->no_rxnoresp++;
                }
                else
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/
                
                    if (modtrace [line])
                    {
                        logMsg ("Receive Error:   RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
                         rxp->rxbuf[100],
                         rxp->rxbuf[101],
                         rxp->rxix);
                    }
                    pmod->no_rxhwerrs++;
                }
            }
        }
        else
        {
            if (txstatus == IO_TIMEOUT)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                if (modtrace [line])
                {
                    logMsg ("Transmit Timeout\n");
                }
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                    ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d\n",
                            delta40, delta01, delta12, delta23, delta34);
                }
                pmod->no_txnoresp++;
            }
            else
            {
                if (modtrace [line])
                {
                    logMsg ("Transmit Error\n");
                }
                pmod->no_txhwerrs++;
            }
        }
        /* bottom of retry loop */
        if (retry != MAXRETRYS)
            pmod->no_retries++;
    }
    if (modtrace [line])
    {
        logMsg ("Xfer Bad\n");
    }
    return (XFERBAD);
}


/*
/*                                                                      
/*      asciidec                                                        
/*                                                                      
/*      The purpose of this routine is to convert the next 2 ascii      
/*      characters in the buffer to decimal and return them in val.     
/*      It will return TRUE if good conversion or FALSE if bad.         
*/                                                                         	

static	short asciidec (unsigned short *val, char *buf)
{
    if ((buf [0] < '0') || (buf [0] > '9'))
    {
        return (FALSE);
    }
    *val = ((buf [0] & 0x0f) * 10);

    if ((buf [1] < '0') || (buf [1] > '9'))
    {
        return (FALSE);
    }
    *val += (buf [1] & 0x0f);

    return (TRUE);
}

/*
/*                                                                      
/*      asciihex                                                    	
/*                                                                      
/*      The purpose of this routine is to convert the next 2 ascii      
/*      characters in the buffer to hex and return them in val. It      
/*      will return TRUE if good conversion or FALSE if bad.            
*/                                                                         	

static short asciihex (unsigned short *val, char *buf)
{
    if ((buf [0] < '0') || (buf [0] > 'F'))
    {
        return (FALSE);
    }
    if (buf [0] <= '9')
    {
        *val = ((buf [0] & 0x0f) << 4);
    }
    else
    {
        if (buf [0] < 'A')
        {
            return (FALSE);
        }
        else
        {
            *val = ((buf [0] - 'A' + 10) << 4);
        }
    }
    if ((buf [1] < '0') || (buf [1] > 'F'))
    {
        return (FALSE);
    }
    if ( buf [1] <= '9')
    {
        *val += (buf [1] & 0x0f);
    }
    else
    {
        if (buf [1] < 'A')
        {
            return (FALSE);
        }
        else
        {
            *val += (buf [1] - 'A' + 10);
        }
    }
    return (TRUE);
}



/*
/*      init_module_tab
/*
/*      The purpose of this routine is to initialize the line tables for the
/*      analog devices I/O
/*
*/
/* only called from allocate_module  */


static  void init_module_tab (unsigned short line, unsigned short mod)
{
    METONE  *pmod;

    pmod = modules [line] [mod];
    if (!pmod)
    {
        return;
    }
    pmod->is_responding = FALSE;
    pmod->holdflag = FALSE;
    pmod->was_requested = FALSE;
    pmod->cmd_force_offline = FALSE;
    pmod->statusbyte = 0;

    initmodule (pmod);
    initstats (pmod);

    /* Initialize this tasks semaphore*/

    semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
    semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
}

/*
/* Cold Init a Module
/*
*/
/* only called from init_line_tabs  */


static void initmodule (METONE  *pmod)
{
    unsigned short    i,j;
                                                                    
/*                                                                       
/*      Analog Inputs are initialized as not requested & data not valid. 
/*                                                                       
*/
    for (i = 0; (i < NUMPCCHANNELS); i++)
    {
        pmod->pcinputs [i].was_requested = FALSE;
        pmod->pcinputs [i].data_valid = FALSE;

        pmod->pcinputs [i].raw_label[0] = '-';
        pmod->pcinputs [i].raw_label[1] = '-';
        pmod->pcinputs [i].raw_label[2] = '-';
        pmod->pcinputs [i].last_label = 0;
        pmod->pcinputs [i].raw_data[0] = '-';
        pmod->pcinputs [i].raw_data[1] = '-';
        pmod->pcinputs [i].raw_data[2] = '-';
        pmod->pcinputs [i].raw_data[3] = '-';
        pmod->pcinputs [i].raw_data[4] = '-';
        pmod->pcinputs [i].raw_data[5] = '-';
        pmod->pcinputs [i].last_data = 0;
        pmod->pcinputs [i].diff_data = 0;
        pmod->pcinputs [i].last_norm = 0;
        pmod->pcinputs [i].diff_norm = 0;
    }
    for (i = 0; (i < NUMAICHANNELS); i++)
    {
        pmod->aiinputs [i].was_requested = FALSE;
        pmod->aiinputs [i].data_valid = FALSE;

        pmod->aiinputs [i].raw_label[0] = '-';
        pmod->aiinputs [i].raw_label[1] = '-';
        pmod->aiinputs [i].raw_label[2] = '-';
        pmod->aiinputs [i].raw_data[0] = '-';
        pmod->aiinputs [i].raw_data[1] = '-';
        pmod->aiinputs [i].raw_data[2] = '-';
        pmod->aiinputs [i].raw_data[3] = '-';
        pmod->aiinputs [i].raw_data[4] = '-';
        pmod->aiinputs [i].raw_data[5] = '-';
        pmod->aiinputs [i].last_data = 0;
    }
}


/*                                                                    
/*                                                                    
/* initialize the statistics for a Metone Module                      
/*                                                                    
*/                                                                   
/* called from AODRIVER, BODRIVER, and init_line_tabs  */

static  void initstats (METONE *pmod)
{
    pmod->no_dataout_msgs = 0;  /* 5  Count Output Msgs               */
    pmod->no_datain_msgs = 0;   /* 6  Count Data Requests             */
    pmod->no_rxnoresp = 0;      /* 7  Count No Responses              */
    pmod->no_txnoresp = 0;      /* 8  Count No Responses              */
    pmod->no_dataerr = 0;       /* 9  Count Message Reply Errors      */
    pmod->no_retries = 0;       /* 10 Count Retries                   */              
    pmod->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors      */
    pmod->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors      */
    pmod->no_chksumerrs = 0;    /* 13 Count Checksum Errors           */
    pmod->no_offlines = 0;      /* 14 Count Off Line Transitions      */
    pmod->no_frameerrs = 0;     /*    Count Framing Errors            */

    pmod->tscanpass = 0;        /* module scan pass counter           */
    pmod->msgs = 0;             /* good response message counts       */
    pmod->responsetime = 0;     /* total wait time for good messages  */

    pmod->noerror = 0;
    pmod->bit0error = 0;
    pmod->bit1error = 0;
    pmod->bit2error = 0;
    pmod->bit3error = 0;
    pmod->bit4error = 0;
}


/*
/* selectcounter                                                
/*                                                              
*/                                                                              
/* called from on_line and every other command */

static  unsigned short selectcounter (unsigned short line, unsigned short mod, METONE *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i, usrmod;

    usrmod = mod + MINMODNO;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = usrmod;
/*    txp->txbuf [0] = 'U'; */
    txp->txmsglen = 1;
    pmod->no_datain_msgs++;

    /****************************/
    /****************************/

    /* Send out the message */
    if (msgxfer (line, pmod, 1) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting an echo of the counter select address. if anything else, its an error. */
    if (rxp->rxbuf [0] != txp->txbuf [0])
    {
        pmod->no_dataerr++;
        return (FALSE);
    }
    return (TRUE);
}


/*                                                              
/* setmode                                                      
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short setmode (unsigned short line, unsigned short mod, METONE *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = ENTERACTIVEMODE;
    txp->txmsglen = 1;
    pmod->no_dataout_msgs++;

    /* Send out the message */
    if (msgxfer (line, pmod, STARTACTIVEMODELEN) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting a status response. if anything else, its a mistake */
    if (rxp->rxbuf [0] != txp->txbuf [0])
    {
        pmod->no_dataerr++;
        return (FALSE);
    }

    return (TRUE);
}

    
/*                                                              
/* startcount                                                   
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short startcount (unsigned short line, unsigned short mod, METONE *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = STARTCOUNTING;
    txp->txmsglen = 1;
    pmod->no_datain_msgs++;



    /* Send out the message */
    if (msgxfer (line, pmod, STARTCOUNTINGLEN) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting a status response. if anything else, its a mistake */
    if (rxp->rxbuf [0] != txp->txbuf [0])
    {
        pmod->no_dataerr++;
        return (FALSE);
    }

    return (TRUE);
}


/*                                                              
/* stopcount                                                    
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short stopcount (unsigned short line, unsigned short mod, METONE *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = STOPCOUNTING;
    txp->txmsglen = 1;
    pmod->no_datain_msgs++;



    /* Send out the message */
    if (msgxfer (line, pmod, STOPCOUNTINGLEN) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting a status response. if anything else, its a mistake */
    if (rxp->rxbuf [0] != txp->txbuf [0])
    {
        pmod->no_dataerr++;
        return (FALSE);
    }

    return (TRUE);
}


/*                                                              
/* sendmode                                                     
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short sendmode (unsigned short line, unsigned short mod, METONE *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = MODEREQUEST;
    txp->txmsglen = 1;
    pmod->no_datain_msgs++;




/*****************************************************************************/
/*****************************************************************************/
/* this code inserted for version 2 only to allow debugging to go forward. /**/
/*  /* Send out the message */                                             /**/
/*  if (msgxfer (line, pmod, 1) == XFERBAD)                                /**/
/*  {                                                                      /**/
/*      pmod->no_offlines++;                                               /**/
/*      pmod->holdflag = TRUE;                                             /**/
/*      pmod->is_responding = FALSE;                                       /**/
/*      return (FALSE);                                                    /**/
/*  }                                                                      /**/
/*  /* expecting a '?' response in the version 2 software. */              /**/
/*  if (rxp->rxbuf [0] != '?')                                             /**/
/*  {                                                                      /**/
/*      pmod->no_dataerr++;                                                /**/
/*      return (FALSE);                                                    /**/
/*  }                                                                      /**/
/*  return (TRUE);                                                         /**/
/* end of special version two response handler.                            /**/
/*****************************************************************************/
/*****************************************************************************/



    /* Send out the message */
    if (msgxfer (line, pmod, MODEREQUESTLEN) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting an echo of the command. if anything else, its an error. */
    if (rxp->rxbuf [0] != txp->txbuf [0])
    {
        pmod->no_dataerr++;
        return (FALSE);
    }
    /* expecting a valid status response. if anything else, its a mistake */
    if ((rxp->rxbuf [1] != 'C') &&
        (rxp->rxbuf [1] != 'H') &&
        (rxp->rxbuf [1] != 'S'))
    {
        pmod->no_dataerr++;
        return (FALSE);
    }
    return (TRUE);
}

/*                                                              
/* sendrecord                                                   
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short sendrecord (unsigned short line, unsigned short mod, METONE *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = SENDRECORD;
    txp->txmsglen = 1;
    pmod->no_datain_msgs++;

    /* Send out the message */
    if (msgxfer (line, pmod, SENDRECORDLEN) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting a status response. if anything else, its a mistake */
    if (rxp->rxbuf [0] != txp->txbuf [0])
    {
        pmod->no_dataerr++;
        return (FALSE);
    }

    /* process response */
    if (!processresponse( line, mod, pmod))
    {
        return (FALSE);
    }
    return (TRUE);
}


/*                                                              
/* resendrecord                                                 
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short resendrecord (unsigned short line, unsigned short mod, METONE *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Format the output message */
    txp->txbuf [0] = RESENDRECORD;
    txp->txmsglen = 1;
    pmod->no_datain_msgs++;

    /* Send out the message */
    if (msgxfer (line, pmod, RESENDRECORDLEN) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    /* expecting a status response. if anything else, its a mistake */
    if (rxp->rxbuf [0] != txp->txbuf [0])
    {
        pmod->no_dataerr++;
        return (FALSE);
    }

    /* process response */
    if (!processresponse( line, mod, pmod))
    {
        return (FALSE);
    }
    return (TRUE);
}



/*                                                              
/* processresponse                                              
/*                                                              
*/                                                                              
/* only called from ___________ */

static  unsigned short processresponse (unsigned short line, unsigned short mod, METONE *pmod)
{
    RXLINE          *rxp;
    unsigned short  rxlen;
    unsigned char   tempbuf[6];
    unsigned short  bodylen, cstext, csdata;
    unsigned short  baseoffset, i, j, k, l, index;
    float           datavalue;

    /* Set up pointers for comm buffer */
    rxp = rxlinetab [line & (~ONERETRY)];

    rxlen = rxp->rxix;
    bodylen = rxlen - 13;

    cstext = bodylen + 1;
    csdata = cstext + 4;

    /* expecting a 'C/S' string prior to the checksum data. */
    if ((rxp->rxbuf [cstext+0] != 'C') ||
        (rxp->rxbuf [cstext+1] != '/') ||
        (rxp->rxbuf [cstext+2] != 'S'))
    {
        pmod->no_chksumerrs++;
        return (FALSE);
    }

    /* test for valid checksum */
    checkchksum (&rxp->rxbuf [0], bodylen, &tempbuf[0]);
    if ((rxp->rxbuf [csdata+0] == '0') &&
        (rxp->rxbuf [csdata+1] == '0') &&
        (rxp->rxbuf [csdata+2] == tempbuf[0]) &&
        (rxp->rxbuf [csdata+3] == tempbuf[1]) &&
        (rxp->rxbuf [csdata+4] == tempbuf[2]) &&
        (rxp->rxbuf [csdata+5] == tempbuf[3]))
    {
        /* checksum is valid. parse the data in the response */

        /* store current status byte */
        pmod->statusbyte = rxp->rxbuf[1];

        /* bump statistics counters */
        if (pmod->statusbyte & 0x1f)
        {
            if (pmod->statusbyte & 0x10) pmod->bit0error++;
            if (pmod->statusbyte & 0x10) pmod->bit1error++;
            if (pmod->statusbyte & 0x10) pmod->bit2error++;
            if (pmod->statusbyte & 0x10) pmod->bit3error++;
            if (pmod->statusbyte & 0x10) pmod->bit4error++;
        }
        else pmod->noerror++;

        baseoffset = 22;
        for (i = 0; i < NUMPCCHANNELS; i++)
        {
            index = baseoffset + (i*11);
            /* check for parsing beyond the end of the response */
            if (index >= bodylen) break;

            pmod->pcinputs [i].raw_label[0] = rxp->rxbuf[index+0];
            pmod->pcinputs [i].raw_label[1] = rxp->rxbuf[index+1];
            pmod->pcinputs [i].raw_label[2] = rxp->rxbuf[index+2];
            if (!parsefloat (&rxp->rxbuf [index], 3, &datavalue))
            {
                /* there was a conversion problem. this is not an error.          */
                /* it only indicates that this is not a particle counter channel. */
                for (k = 0; k < NUMAICHANNELS; k++)
                {
                    index = baseoffset + ((k+i)*11);
                    /* check for parsing beyond the end of the response */
                    if (index >= bodylen) break;
                    pmod->aiinputs [k].raw_label[0] = rxp->rxbuf[index+0];
                    pmod->aiinputs [k].raw_label[1] = rxp->rxbuf[index+1];
                    pmod->aiinputs [k].raw_label[2] = rxp->rxbuf[index+2];

                    index = index + 4;
                    pmod->aiinputs [k].raw_data[0] = rxp->rxbuf[index+0];
                    pmod->aiinputs [k].raw_data[1] = rxp->rxbuf[index+1];
                    pmod->aiinputs [k].raw_data[2] = rxp->rxbuf[index+2];
                    pmod->aiinputs [k].raw_data[3] = rxp->rxbuf[index+3];
                    pmod->aiinputs [k].raw_data[4] = rxp->rxbuf[index+4];
                    pmod->aiinputs [k].raw_data[5] = rxp->rxbuf[index+5];
                    if (!parsefloat (&rxp->rxbuf [index], 6, &datavalue))
                    {
                        /* there was a conversion problem. all values fields must be valid numerics. */
                        pmod->no_dataerr++;
                        return (CMDFAIL);
                    }
                    pmod->aiinputs [k].last_data = datavalue;
                    pmod->aiinputs [k].data_valid = TRUE;
                }
                /* after sucessfully parsing the string, fill & invalidate the remaining ai records. */
                for (l = k; l < NUMAICHANNELS; l++)
                {
                    /* fill unreturned data with zero and mark as invalid */
                    pmod->aiinputs [l].data_valid = FALSE;

                    pmod->aiinputs [l].raw_label[0] = '-';
                    pmod->aiinputs [l].raw_label[1] = '-';
                    pmod->aiinputs [l].raw_label[2] = '-';
                    pmod->aiinputs [l].raw_data[0] = '-';
                    pmod->aiinputs [l].raw_data[1] = '-';
                    pmod->aiinputs [l].raw_data[2] = '-';
                    pmod->aiinputs [l].raw_data[3] = '-';
                    pmod->aiinputs [l].raw_data[4] = '-';
                    pmod->aiinputs [l].raw_data[5] = '-';
                    pmod->aiinputs [l].last_data = 0;
                }
                break; /* leave the 'i' loop. */
            }
            pmod->pcinputs [i].last_label = datavalue;
/*            index = baseoffset + (i*11) + 4; */
            index = index + 4;
            pmod->pcinputs [i].raw_data[0] = rxp->rxbuf[index+0];
            pmod->pcinputs [i].raw_data[1] = rxp->rxbuf[index+1];
            pmod->pcinputs [i].raw_data[2] = rxp->rxbuf[index+2];
            pmod->pcinputs [i].raw_data[3] = rxp->rxbuf[index+3];
            pmod->pcinputs [i].raw_data[4] = rxp->rxbuf[index+4];
            pmod->pcinputs [i].raw_data[5] = rxp->rxbuf[index+5];
            if (!parsefloat (&rxp->rxbuf [index], 6, &datavalue))
            {
                /* there was a conversion problem. all values fields must be valid numerics. */
                pmod->no_dataerr++;
                return (CMDFAIL);
            }
            pmod->pcinputs [i].last_data = datavalue;

            /*****************************/
            /*****************************/
            /* generate interesting data */
            if (mltrace [line] == 100)
            {
                /* fake data so we have something to look at on the dm screen */
                pmod->pcinputs [i].last_data = 50*(i+1)*(i+1);
            }
            /*****************************/
            /*****************************/

            /* calculate differential data immediately. */
            if (i == 0)
            {
                pmod->pcinputs [i].diff_data = pmod->pcinputs [i].last_data;
            }
            else
            {
                pmod->pcinputs [i].diff_data = pmod->pcinputs [i].last_data - pmod->pcinputs [i-1].last_data;
            }

            pmod->pcinputs [i].last_norm = pmod->pcinputs [i].last_data * pmod->normfactor;
            pmod->pcinputs [i].diff_norm = pmod->pcinputs [i].diff_data * pmod->normfactor;
            pmod->pcinputs [i].data_valid = TRUE;
        }
        /* after sucessfully parsing the string, fill & invalidate the remaining pc records. */
        for (j = i; j < NUMPCCHANNELS; j++)
        {
            /* fill unreturned data with zero and mark as invalid */
            pmod->pcinputs [j].data_valid = FALSE;

            pmod->pcinputs [j].raw_label[0] = '-';
            pmod->pcinputs [j].raw_label[1] = '-';
            pmod->pcinputs [j].raw_label[2] = '-';
            pmod->pcinputs [j].last_label = 0;
            pmod->pcinputs [j].raw_data[0] = '-';
            pmod->pcinputs [j].raw_data[1] = '-';
            pmod->pcinputs [j].raw_data[2] = '-';
            pmod->pcinputs [j].raw_data[3] = '-';
            pmod->pcinputs [j].raw_data[4] = '-';
            pmod->pcinputs [j].raw_data[5] = '-';
            pmod->pcinputs [j].last_data = 0;
            pmod->pcinputs [j].diff_data = 0;
            pmod->pcinputs [j].last_norm = 0;
            pmod->pcinputs [j].diff_norm = 0;
        }
        return (TRUE);
    }
    pmod->no_chksumerrs++;
    return (FALSE);
}

/*
/*              
/* checkchksum  
/*              
*/

static  void checkchksum (unsigned char *chkbuf, int len, char unsigned *retbuf)
{
    unsigned long  checksum;
    unsigned int   i, work;
    unsigned short temp0, temp1, temp2, temp3;

    checksum = 0;
/*    for (i = 0; i < len; i++) */
    for (i = 1; i < len; i++)
    {
        checksum += chkbuf [i];
    }
    work = checksum % 65536;    

    temp3 = (work % 16) + '0';
    if (temp3 > '9') temp3 += 7;
    work = work/16;

    temp2 = (work % 16) + '0';
    if (temp2 > '9') temp2 += 7;
    work = work/16;

    temp1 = (work % 16) + '0';
    if (temp1 > '9') temp1 += 7;
    work = work/16;

    temp0 = (work % 16) + '0';
    if (temp0 > '9') temp0 += 7;

    retbuf [0] = temp0;
    retbuf [1] = temp1;
    retbuf [2] = temp2;
    retbuf [3] = temp3;
}

/*
/*   parsefloat                                                                  
/*                                                                         	 
/*      The purpose of this routine is to convert the specified number of ascii  
/*      characters in the buffer as a floating point value and return it in val. 
/*      It will return TRUE if good conversion of FALSE if bad.                  
*/                                                                         	
/* not called from within this driver */

static short parsefloat (char *buf, unsigned short length, float *datavalue)
{
    unsigned short i, dpflag, multiplier, divisor, digit;
             float temp;

    dpflag = FALSE;
    multiplier = 10;
    divisor = 1;
    temp = 0;

    for (i = 0; i < length; i++)
    {
        if (buf[i] == '.')
        {
            if (dpflag)
            {
                return (FALSE);
            }
            else
            {
                dpflag = TRUE;
                multiplier = 1;
            }
        }  
        else
        {
            if (dpflag)
            {
                divisor = divisor * 10;
            }
            if (onefascii(&digit, buf[i]))
            {
                /* only 0 - 9 are valid digits */
                if ( digit > 9)
                {
                    return (FALSE);
                }
                temp = (temp*multiplier) + (((float) digit)/divisor);
            }
            else
            {
                return (FALSE);
            } 
	}
    }
    *datavalue = temp; 
    return (TRUE);
}

static short onefascii (unsigned short *val, char ch)
{
    if ((ch < '0') || (ch > 'F'))
    {
        return (FALSE);
    }
    if (ch <= '9')
    {
        *val = ch & 0x0f;
    }
    else
    {
        if (ch < 'A')
        {
            return (FALSE);
        }
        else
        {
            *val = (ch - 'A') + 10;
        }
    }
    return (TRUE);
}


/*                                                                              
/*     prepresponses                                                            
/*                                                                              
/*      The purpose of this routine is to mark the Modules as on hold and the   
/*    data as not valid until read again from the Module                        
/*                                                                              
*/
/* only called from MAIN */

static  void prepresponses (unsigned short line)
{
    unsigned short   mod;
    METONE          *pmod;

    for (mod = 0; (mod < NUMMODS); mod++)
    {
        pmod = modules [line] [mod];
        if (pmod)                /* verify pointer validity prior to use */
        {
            pmod->holdflag = TRUE;
            mark_not_valid (pmod);
        }
    }
}


/*                                                                       
/*      any_responding                                                   
/*                                                                       
/*      The purpose of this routine is to see if any units are           
/*    responding on this line                                            
/*                                                                       
*/
/* only called from MAIN */

static  int any_responding (unsigned short line)
{
    unsigned short  mod;
    METONE        *pmod;

    for (mod = 0; (mod < NUMMODS); mod++)
    {
        pmod = modules [line] [mod];
        if (pmod)            /* verify pointer validity prior to use */
        {
            /* check cmd_force_offline flag because it is set in an asynchronous task */
            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
            {
                return (TRUE);
            }
        }
    }
    return (FALSE);
}


/*
/*      DUMPMSGCNTS
/*
/*      The purpose of this routine is to dump the line level statistics for this driver. 
/*
*/
/* called from TABLEINFO */

void DUMPMSGCNTS (unsigned short line)
{
    unsigned long    temp, t, x, y, z;

    temp = tickGet ();
    t = (temp - linestats [line].startingtick);

    x = linestats [line].TXintcount;
    y = linestats [line].RXintcount;
    z = linestats [line].msgxfercount;

    if (z == 0)
    {
        printf (" ******  No Messages Transferred ****** \n");
        return;
    }

    printf ("\n");
    printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
    printf ("\n");
    printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
    printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
    printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
    printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
    printf ("\n");
    printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
    printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
    printf ("\n");
    printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
    printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
    printf ("\n");
    return;
}

/*
/*      CLEARMSGCNTS
/*
/*      The purpose of this routine is to dump and clear the line level statistics
/*      for this driver.
/*
*/
/* called from TABLEINFO */

void CLEARMSGCNTS (unsigned short line)
{
    DUMPMSGCNTS (line);

    linestats [line].TXintcount = 0;
    linestats [line].RXintcount = 0;
    linestats [line].msgxfercount = 0;

    linestats [line].startingtick = tickGet ();
    printf (" ******  All Counts Cleared  ****** \n", linestats [line].msgxfercount);
    printf ("\n");
    return;
}



/*                                                                                           
/*      DUMPMODSTATS                                                                         
/*                                                                                           
/*      The purpose of this routine is to dump the module level statistics for this driver.  
/*                                                                                           
*/                                                                                           
/* called from TABLEINFO */

void DUMPMODSTATS (unsigned short line, unsigned short maddr)
{
    METONE         *pmod;
    unsigned long   microsecs;

    pmod = modules [line] [maddr];
    if (!pmod)
    {
        logMsg ("Line/Module Address Not Defined \n");
        return;
    }

    printf (" Was requested        = %5d         ", pmod->was_requested);
    printf (" Is responding        = %5d       \n", pmod->is_responding);
    printf (" # Data out messages  = %5d         ", pmod->no_dataout_msgs & 0x7fff);
    printf (" # Data in messages   = %5d       \n", pmod->no_datain_msgs & 0x7fff);
    printf (" #No Rx Response      = %5d         ", pmod->no_rxnoresp & 0x7fff);
    printf (" #No Tx Responses     = %5d       \n", pmod->no_txnoresp & 0x7fff);
    printf (" #Data Errors         = %5d         ", pmod->no_dataerr & 0x7fff);
    printf (" #Retries             = %5d       \n", pmod->no_retries & 0x7fff);
    printf (" #Rx Hw Errors        = %5d         ", pmod->no_rxhwerrs & 0x7fff);
    printf (" #Tx Hw Errors        = %5d       \n", pmod->no_txhwerrs & 0x7fff);
    printf (" #Checksum Errors     = %5d         ", pmod->no_chksumerrs & 0x7fff);
    printf (" #Framing Errors      = %5d       \n", pmod->no_frameerrs & 0x7fff);
    printf (" #Off Lines           = %5d         ", pmod->no_offlines & 0x7fff);
    printf (" Reset Statistics     = %5d       \n", pmod->cmd_reset_stat);
    printf (" Force Offline        = %5d       \n", pmod->cmd_force_offline);
    printf ("\n");

    printf (" PCX Responses Counts\n");
    printf ("     No Error            = %5d    \n", pmod->cmd_force_offline);
    printf ("     Calibrate Mode Fail = %5d    \n", pmod->cmd_force_offline);
    printf ("\n");

    printf (" # of Messages %d \n", pmod->msgs);
    printf (" # Total response time (ticks) = %lu \n", pmod->responsetime);
    if (pmod->msgs)
    {
        printf ("   Average response time (ticks) = %d \n", (pmod->responsetime/pmod->msgs));
        microsecs = (16667*pmod->responsetime)/pmod->msgs;
        printf ("   Average response time (msec) = %d.%1d \n", microsecs/1000, (microsecs%1000)/100);
    }

    printf (" # of scan passes = %d \n", pmod->tscanpass);
    printf ("\n");

    printf (" Resource Responding = %d \n", resresponse[line]);
    printf (" Hold flag  = %d \n", pmod->holdflag );
        return;
}


/*                                                                        
/*      DUMPSTATE                                                         
/*                                                                        
/*      The purpose of this routine is to dump the driver control state.  
/*                                                                        
*/                                                                                           
/* called from TABLEINFO */

void DUMPSTATE (unsigned short line)
{
    /* print the driver's debug structures */
    printf (" modtrace      = %5d       \n", modtrace [line]);
    printf (" mltrace       = %5d       \n", mltrace [line]);
    printf (" modrestrace   = %5d       \n", modrestrace [line]);
    printf (" trace         = %5d       \n", trace [line]);
    printf (" traceadr      = %5d       \n", traceadr [line]);
    printf (" tracetype     = %5d       \n", tracetype [line]);
    return;
}

/*
/*      CLEARMODSTATS
/*
/*      The purpose of this routine is to clear the module level statistics for this driver.
/*
*/
/* called from TABLEINFO */

void CLEARNMODSTATS (unsigned short line, unsigned short maddr)
{
    METONE        *pmod;

    pmod = modules [line] [maddr];
    if (!pmod)
    {
        logMsg ("Line/Module Address Not Defined \n");
        return;
    }
    initstats (pmod); /* use existing procedure */
    return;
}



/*
/*      dump_mod_table                                                  
/*                                                                      
/*      The purpose of this routine is twofold:                         
/*         1) dump the module level statistics for the Metone driver.   
/*         2) dump the data for the specified Met One counter.          
/*                                                                      
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)
{
    METONE          *pmod;
    unsigned short   i, n;

    unsigned short   addr, linecnt;
    unsigned char    buffer [200];

    pmod = modules [line] [maddr];
    if (!pmod)
    {
        logMsg("Line/Module Address Not Defined \n");
        return;
    }

    /* previously integral code moved to seperate procedure for debugging convenience */
    DUMPMODSTATS (line, maddr);

    printf ("\n");
    printf (" Status Byte          = '%c'     \n", pmod->statusbyte);
    printf (" Count Time (ticks)   = %5d      \n", pmod->counttime);
    printf (" Count Time (seconds) = %8.3f    \n", ((float)pmod->counttime / (float)TICKSPERSEC));
    printf (" Normalization Factor = %10.5f   \n", pmod->normfactor);
    printf ("\n");

    linecnt = 1;
    printhdr (buffer, linecnt);
    for (i = 0; i < (NUMPCCHANNELS); i++)
    {
        printf(" %2d:   %2d     %2d    %c%c%c    %6.2f    %c%c%c%c%c%c  %10.3f  %10.3f  %10.3f  %10.3f\n",
               (i),
               pmod->pcinputs[i].was_requested,
               pmod->pcinputs[i].data_valid,
               pmod->pcinputs[i].raw_label[0],
               pmod->pcinputs[i].raw_label[1],
               pmod->pcinputs[i].raw_label[2],
               pmod->pcinputs[i].last_label,
               pmod->pcinputs[i].raw_data[0],
               pmod->pcinputs[i].raw_data[1],
               pmod->pcinputs[i].raw_data[2],
               pmod->pcinputs[i].raw_data[3],
               pmod->pcinputs[i].raw_data[4],
               pmod->pcinputs[i].raw_data[5],
               pmod->pcinputs[i].last_data,
               pmod->pcinputs[i].diff_data,
               pmod->pcinputs[i].last_norm,
               pmod->pcinputs[i].diff_norm);
        linecnt++;
        if ((linecnt >= 24) && ((i + 1)  < NUMPCCHANNELS))
        {
            linecnt = 1;
            printhdr(buffer, linecnt);
        }
        /* print one past last valid record, then stop. */
        if (!pmod->pcinputs[i].data_valid) break;
    }
    printhdr (buffer, linecnt);
    for (i = 0; i < (NUMAICHANNELS); i++)
    {
        printf(" %2d:   %2d     %2d    %c%c%c              %c%c%c%c%c%c  %10.3f\n",
               (i),
               pmod->aiinputs[i].was_requested,
               pmod->aiinputs[i].data_valid,
               pmod->aiinputs[i].raw_label[0],
               pmod->aiinputs[i].raw_label[1],
               pmod->aiinputs[i].raw_label[2],
               pmod->aiinputs[i].raw_data[0],
               pmod->aiinputs[i].raw_data[1],
               pmod->aiinputs[i].raw_data[2],
               pmod->aiinputs[i].raw_data[3],
               pmod->aiinputs[i].raw_data[4],
               pmod->aiinputs[i].raw_data[5],
               pmod->aiinputs[i].last_data);
        linecnt++;
        if ((linecnt >= 24) && ((i + 1)  < NUMAICHANNELS))
        {
            linecnt = 1;
            printhdr(buffer, linecnt);
        }
        /* print one past last valid record, then stop. */
        if (!pmod->aiinputs[i].data_valid) break;
    }
}
/*
/* only called from dump_mod_table 
*/
static void printhdr (unsigned char *buffer, unsigned short cnt)
{    
    taskDelay (120);
    printf ("\n");
    sprintf (buffer,"                            METONE MODULE DATA     ");
    printf ( "%s\n", buffer);
    cnt += 1;
    sprintf (buffer,
      " CH#  WasR   DVal  LABEL LABELVALUE  RAWDATA   LASTDATA    DIFFDATA    LASTNORM    DIFFNORM");
    printf ( "%s\n", buffer);
    cnt += 1;
}

/*
/*      mod info                                                        
/*                                                                      
/*      The purpose of this routine is to list summary information      
/*        for all modules allocated and referenced on this line.        
/*
*/
/* not called from within this driver */

void MODULEINFO (unsigned short line)
{
    METONE          *pmod;
    unsigned short   i, n;

    unsigned short   addr, linecnt;
    unsigned char    buffer [200];

    printmodhdr (buffer, linecnt);
    for (i = 0; i < NUMMODS; i++)
    {
        pmod = modules [line] [i];
        if (pmod)
        {
            linecnt = 1;
            printf(" %2d:   %1d    %1d    %1d    %5d %5d %5d %5d %5d %5d %5d %5d %5d  %5d  %5d\n",
                    i,
                    pmod->was_requested,
                    pmod->is_responding,
                    pmod->cmd_force_offline,
                    pmod->no_dataout_msgs & 0x7fff,
                    pmod->no_datain_msgs & 0x7fff,
                    pmod->no_rxnoresp & 0x7fff,
                    pmod->no_txnoresp & 0x7fff,
                    pmod->no_dataerr & 0x7fff,
                    pmod->no_retries & 0x7fff,
                    pmod->no_chksumerrs & 0x7fff,
                    pmod->no_frameerrs & 0x7fff,
                    pmod->no_offlines & 0x7fff,
                    pmod->noerror & 0x7fff,
                    pmod->bit0error & 0x7fff);

            linecnt += 1;
            if ((linecnt >= 20) && ((i + 1)  < NUMMODS))
            {
                linecnt = 1;
                printmodhdr(buffer, linecnt);
            }
        }
    }
}
/*
/* only called from dump_mod_table 
*/
static void printmodhdr (unsigned char *buffer, unsigned short cnt)
{    
    taskDelay (30);
    printf ("\n");
    sprintf (buffer,"                        METONE MODULE CONFIGURATION INFO");
    printf ( "%s\n", buffer);
/*    cnt += 1; */
    sprintf (buffer,
      " MOD   --- Status ---  # Messages   ------- Comm Error Counts by Type ------- ");
    printf ( "%s\n", buffer);
    sprintf (buffer,
      " NUM  Req  Res  FOL   In    Out   NoTx  NoRx  DatEr Retry Chksm Frame Offln  NoErrs Bit0Errs");
    printf ( "%s\n", buffer);
/*    cnt += 1; */
}

/*
**                                                                
**    The purpose of this routine is to display the contents      
**    of the static variables contained within this driver.       
**                                                                
*/

/* this routine not called from within this driver */

LINEINFO ()
{
    short    i;
    char    buffer [132];
    char    *resrsp;
    char    *lineact;


    printf ("                                 Met One Line Information Table          \n");
    printf ("\n");
    printf (" Line        Pointer to        Resource      Resource");
    printf ("       Line      Intermessage   Activity\n");
    printf ("Number      METONE Table         Name        Response");
    printf ("     Activity      IM  .TX  TX.         Time\n");
    printf ("\n");

    for (i = 0; i < METONELINES; i++)
    {
        if(modules [i] == NULL)
        {
        continue;
        }
        if (resresponse [i] == 0)
        {
        resrsp = "FALSE";
        }
        else
        {
        resrsp = "TRUE";
        }
        if (line_activity [i] == 0)
        {
        lineact = "FALSE";
        }
        else
        {
        lineact = "TRUE";
        }
        sprintf (buffer,
                       "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
            i,
            modules[i],
            &resnames[i],
            &resrsp[0],
            &lineact[0],
            intermsgdelay[i],
            pretxdelay[i],
            posttxdelay[i],
            activity_time[i]);
        printf ( "%s\n", buffer);
    }
    return 0;
}

/*    End of File:    drvMetone.c */
