/*drvModiconslv.c,v 1.1.1.1 1999/08/03 14:43:22 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/*  File: drvModicon.c
*/

#include <ctype.h>

#include    <vxWorks.h>
#include    <sysLib.h>
#include    <semLib.h>
#include    <wdLib.h>
#include    <rngLib.h>
#include    <logLib.h>
#include    <tickLib.h>
#include    <remLib.h>
#include    <stdioLib.h>
#include    <string.h>

/*#include    "iocsiodvr_bridge.h"*/
#include    "task_params.h"
#include    "dbDefs.h"
#include    "drvSup.h"
#include    "drvModiconslv.h"
#include    "drvModiconslv_proto.h"
#include    "restable.h"
#include    "iocsiodvr_bridge.h"
#include     <serialFile.h>
#include    "resmgr.h"

void modslvtraceon (unsigned short line);

void modslvtraceoff (unsigned short line);

void modslvtrafficon (unsigned short line);

void modslvtrafficoff (unsigned short line);

void modslvrestrlv (unsigned short line, unsigned short level);

void modslvrestraceon (unsigned short line);

void modslvrestraceoff (unsigned short line);

void modslvtrlv (unsigned short line, unsigned short level);

void modslvsimon (unsigned short line, unsigned short delay, int low, int high, int digenable);

void modslvsimoff (unsigned short line);

void modslvcontraceon (unsigned short line);

void modslvcontraceoff (unsigned short line);

void modslvruntraceon (unsigned short line);

void modslvruntraceoff (unsigned short line);

void modslvrejecttraceon (unsigned short line);

void modslvrejecttraceoff (unsigned short line);

void modslvnacktraceon (unsigned short line);

void modslvnacktraceon (unsigned short line);

void modslvdefaulttrace (unsigned short line);

int stopmodbusslv (short ln);

int startmodbusslv (unsigned short line, char *mode, unsigned short delay,
		 unsigned short hdflag, unsigned short delay1,
		 unsigned short delay2, unsigned short private);

void modslvcomm (unsigned short line, unsigned short tickcount1,
	      unsigned short hdflag, unsigned short tickcount2,
	      unsigned short tickcount3);

void modslv_driver (unsigned short line, unsigned char *mode, unsigned short delay,
		 unsigned short hdflag, unsigned short delay1,unsigned short delay2,
		 unsigned short private);

static long	init();
static 	void mark_not_valid (MODPLC  *pmod);
static void  register_resource (unsigned short link, MODPLC *pmod,
                                unsigned char *resname, char *pointname);
static 	int allocate_plc (unsigned short line, unsigned short plc);
static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus);
static	int rx_int_proc (unsigned short line );
static	int check_line_activity (unsigned short line, unsigned short predelay);
static	void start_tx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus);
static	void stop_tx (unsigned short line );
static	int tx_int_proc (unsigned short line );
static	void init_plc_tab (unsigned short line, unsigned short mod);
static 	void initplc (MODPLC  *pmod);
static	void initstats (MODPLC *pmod);
static	void prepresponses (unsigned short line);
static	void makecrc (unsigned char *chkbuf, int len,char unsigned *retbuf);
static 	void printcoilhdr (unsigned char *buffer, unsigned short cnt);
static 	void printdihdr (unsigned char *buffer, unsigned short cnt);
static	void printaihdr (unsigned char *buffer, unsigned short cnt);
static 	void printreghdr (unsigned char *buffer, unsigned short cnt);
static	void sim_plc (MODPLC *pmod, unsigned short line, unsigned short mod);
static  int checkgroup (unsigned short line, unsigned short *lstate, unsigned short tracenum);
static void getandprocess (unsigned short line);
static unsigned short rxhavemsg(unsigned short line, unsigned short ix,unsigned short *len);
static void modreadcoil(unsigned short line, unsigned short address);
static void modreaddi(unsigned short line, unsigned short address);
static void modreadbinary( unsigned short line, unsigned short mod, unsigned short function,
				   unsigned short maxcount, unsigned char *dataaddr);
static void modreadreg(unsigned short line, unsigned short address);
static void modreadai(unsigned short line, unsigned short address);
static void modreadanalog( unsigned short line, unsigned short mod, unsigned short function,
				   unsigned short maxcount, unsigned short *dataaddr);
static void modwriteregs( unsigned short line, unsigned short mod);
static void modwritereg( unsigned short line, unsigned short mod);
static void modwritecoils( unsigned short line, unsigned short mod);
static void modwritecoil( unsigned short line, unsigned short mod);
static void modloopback( unsigned short line, unsigned short address);
static void processmessage (unsigned short line, unsigned short address);


struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvModicon={ 2,	NULL, init};

/*
**      External Line Level Data Structures (declared in drvcommon.c)
**
*/
static	unsigned char	resnames [MODLINES] [RESNAMELEN]; /* array of resource name strings.		*/

static	RES_TABLE	*prestable [MODLINES];		/* array of pointers to resource tables 	*/

static	unsigned short	resresponse [MODLINES];		/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

static	unsigned short	line_activity [MODLINES];	/* true/false line active flag. calculated	*/
							/* using activity_time below. 			*/
static	unsigned short	lastactivity [MODLINES];	/* assigned value of line_activity prior to	*/
							/* it's recalculation.   			*/

static	unsigned short	modtrace [MODLINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/
static	unsigned short	mltrace [MODLINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/
static	unsigned short	modrestrace [MODLINES];		/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/

static	SEM_ID		semids [MODLINES] [2];		/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

static	unsigned short	intermsgdelay [MODLINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/
static	unsigned short	pretxdelay [MODLINES];		/* holds post RTS delay before TX. 		*/
static	unsigned short	posttxdelay [MODLINES];		/* holds post TX delay before dropping RTS. 	*/

static	long		activity_time [MODLINES];	/* holds timetick of last activity. used to	*/
							/* set line_activity flag  			*/

static  unsigned short  halfduplex [MODLINES];          /* store half/full duplex line status           */

static  unsigned short  pstatewait [MODLINES];          /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */


static  short           rxstatus[MODLINES];		/* Receiver status location                     */
static  short           resGroupLock [];                /* holds line driver group lock flags.          */
static  char           *resGroupTripName [];            /* holds line driver trip name.                 */


/*
**      Storage for MODBUS Comm Line Structures
**
*/

static RXLINE          *rxlinetab [MODLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL,} ; /* array of pointers to dynamically           */
                                        /* allocated comm controls/buffers            */

static TXLINE          *txlinetab [MODLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL,} ; /* array of pointers to dynamically           */
                                        /* allocated comm controls/buffers            */

/*
**      Storage for MODBUS PLC Structures
**
*/
static unsigned short   pryvate [MODLINES];              /* 0 = redundant mode,   !0=private mode      */
static unsigned short   link [MODLINES];              	/* line Number started with for file I/O */
static unsigned int     modsim [MODLINES];               /* 0 = normal operation, 1 = plc simulation.  */

static unsigned int	simdelay [MODLINES];

static 		int	simlow [MODLINES];

static 		int	simhigh [MODLINES];

static		int	simdigon [MODLINES];

static unsigned int     tick [MODLINES][5];

static LINESTATS	linestats [MODLINES];		/* array of line level statistics.              */

static MODPLC		*plcs [MODLINES] [NUMMODPLCS + 1];/* two dimensional array of pointers to the   */
                                                        /* fixed length dynamically allocated PLC       */
                                                        /* control and data structures. extra pointer   */
                                                        /* is for Query structure used independently    */
							/* of the others. it also allows for the array  */
                                                        /* index to match the mod value.                */

static	unsigned short	trace [MODLINES];		/* controls output of system error messages:	*/
							/* bit mapped controls                          */
static  unsigned char   traceadr [MODLINES];
static  unsigned char   tracetype [MODLINES];
                                                        /* their control structures                     */
static char		user [40], password [40];	/* holds id and password of the user that       */
                                                        /* spawned the driver task required by host to  */
                                                        /* check file read privileges on PLC load files */
static char modes [MODLINES][16];			/* Room to save the mode strings */

static int		taskId [MODLINES];

static char *tasknames [] = {"MODBUS Ch0", "MODBUS Ch1", "MODBUS Ch2", "MODBUS Ch3",
                             "MODBUS Ch4", "MODBUS Ch5", "MODBUS Ch6", "MODBUS Ch7",
                             "MODBUS Ch8", "MODBUS Ch9", "MODBUS Ch10","MODBUS Ch11",
                             "MODBUS Ch12","MODBUS Ch13","MODBUS Ch14","MODBUS Ch15",
                             "MODBUS Ch16","MODBUS Ch17","MODBUS Ch18","MODBUS Ch19",
                             "MODBUS Ch20","MODBUS Ch21","MODBUS Ch22","MODBUS Ch23",
                             "MODBUS Ch24","MODBUS Ch25","MODBUS Ch26","MODBUS Ch27",
                             "MODBUS Ch28","MODBUS Ch29","MODBUS Ch30","MODBUS Ch31"
                           };

static unsigned short modResGroups [MODLINES] =
			{0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0} ; /* line driver group assignments   */

/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
{
	return (0);
}

/********
**
**	This routine outputs information to help with debugging.
**
********/
void modslvhelp (void)
{
    printf ("Starting and Stopping the Modicon Slave Driver:\n");
    printf ("\n");
    printf (" startmodbusslv(N,C,t1,f,t2,t3,P)                                                  \n");
    printf ("                     N:  start the driver on line N.                            \n");
    printf ("                     C:  communications parameter string (comma delimited ascii)\n"); 
    printf ("                     t1: intermessage delay (in ticks)                          \n");
    printf ("                     f:  half duplex flag. 1=half duplex mode, 1!=full duplex   \n");
    printf ("                     t2: post RTS assert, pre TX delay (in ticks)               \n");
    printf ("                     t3: post TX, pre RTS drop delay (in ticks)                 \n");
    printf ("                     P:  Private flag.  0 = Redundant, 1 = Non-Redundant        \n");
    printf ("                                                                                \n");
    printf (" Example: startmodbusslv(2,\"9600,N,8,1\", 2,1,4,0)                                \n");
    printf ("                                                                                \n");
    printf (" stopmodbusslv(N)                                                                  \n");
    printf ("                     N = line number                                            \n");
    printf ("\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" Modbus Slave Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" modlsvtraceon(N)         Enable the following debug messages for line N:             \n");
    printf ("                         1) Major Scan loop Info:                                  \n");
    printf ("                           scan time, total output messages, and total messages.   \n"); 
    printf ("                         2) Output Queue Overflow.                                 \n");
    printf ("                         3) All communication errors encountered in msgxfer.       \n");
    printf ("*modslvtraceoff(N)        Disable all of the modtraceon debug messages for line N.    \n");
    printf ("\n");
    printf (" modslvrestrace(N,X)      Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*modslvrestraceon(N)      Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" modslvrestraceoff(N)     Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" modslvcontraceon(N)      Enable display of configuration errors in driver calls.     \n");
    printf ("*modslvcontraceoff(N)     Disable display of configuration errors in driver calls.    \n");
    printf (" modslvruntraceon(N)      Enable display of runtime errors (queue overflow).          \n");
    printf ("*modslvruntraceoff(N)     Disable display of runtime errors (queue overflow).         \n");
    printf (" modslvrejecttraceon(N)   Enable display of driver call rejections in driver calls.   \n");
    printf ("*modslvrejecttraceoff(N)  Disable display of driver call rejections in driver calls.  \n");
    printf (" modslvnacktraceon(N)     Enable display of point deselection on MODBUS command NACK. \n");
    printf ("*modslvnacktraceoff(N)    Disable display of point deselection on MODBUS command NACK.\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" modslvtrlv(N,X)          Enable the following message for line N:                  \n");
    printf ("                         X=0,  display none of the messages below.               \n");
    printf ("                         X=1,  beginning of plc scan loop, bringing plcs online. \n");
    printf ("                         X=2,  beginning of plc scan.                            \n");
    printf ("                         X=3,  AO queue actions (normal: modslv_aodriver & checkoutputs)\n");
    printf ("                         X=4,  BO queue actions (normal: modslv_bodriver & checkoutputs)\n");
    printf ("                         X=5,  SO queue actions (normal: modslv_sodriver & checkoutputs)\n");
    printf ("                         X=6,  calls to checkoutputs.                            \n");
    printf ("                         X=7,  checkoutputs: trace each queue entry read.        \n");
    printf ("                         X=8,  AIDRIVER, AOREAD: normal call return.             \n");
    printf ("                         X=9,  BIDRIVER, BOREAD: normal call return.             \n");
    printf ("                         X=10, SIDRIVER: normal call return.                     \n");
    printf ("                         X=11 to 14,  reserved.                                  \n");
    printf ("                         X=15, 'Microsol Busy', waiting in checkoutputs.         \n");
    printf ("                         X=16 to 254,  reserved.                                 \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" modslvtrafficon(N)       Enable traffic tracing for all plc addresses                \n");
    printf ("                         and all modbus functions on line N.                       \n");
    printf ("*modslvtrafficoff(N)      Disable all traffic tracing on line N.                      \n");
    printf (" modslvtraffic(N,X,Y)     Modifies line N traffic tracing as follows:                 \n");
    printf ("                         X=0   disables tracing of all addresses.                  \n");
    printf ("                         X=255 enables tracing of all addresses.                   \n");
    printf ("                         0 < X < 255 enables tracing of address X traffic.         \n");
    printf ("                         Y=0   disables tracing of all modbus functions.           \n");
    printf ("                         Y=255 enables tracing of all modbus functions.            \n");
    printf ("                         0 < Y < 255 enables tracing of function Y traffic.        \n");
    printf ("\n");
    printf (" modslvdefaulttrace(N)    Restores default setting for all traces.                    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" modslvsimon(N,D,L,H,T)   Enables the simulation of responding plcs.                  \n");
    printf ("                        D: simulation interval (in seconds). if D<1 or D>60, D=60. \n");
    printf ("                        L: low value of analog simulation range.                   \n");
    printf ("                        H: high value of analog simulation range.                  \n");
    printf ("                        T: 0 = digital inputs are zero. 1 = digitial inputs toggle.\n");
    printf ("*modslvsimoff(N)          Disables simulation, thus enabling normal driver function.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" modslvinfo(N)            Display startup and current state information.              \n");
    printf (" modslvcomm(N,t1,f,t2,t3) Set communication timing parameters for line N as follows:  \n");
    printf ("                         t1: intermessage delay (in ticks).                        \n");
    printf ("                          f: 0 = full duplex, 1 = half duplex.                     \n");
    printf ("                         t2: post RTS assert, pre TX delay (in ticks).             \n");
    printf ("                         t3: post TX, pre RTS drop delay (in ticks).               \n");
    printf ("\n");
    printf (" modslvdumpmsgcnts(N)     Display line N communication statistics.                    \n");
    printf (" modslvclearmsgcnts(N)    Display and clear line N communication statistics.          \n");
    printf (" modslvdumpplcstats(N,X)  Display line N, plc X, communication statistics.            \n");
    printf (" modslvclearplcstats(N,X) Display and clear line N, plc X, xfers, status & errors.    \n");
    printf (" dump_modslv_table(N,X)   Display line N, plc X, xfers, status, errors and input data.\n");
    printf (" modslvhelp               Display this information.                                   \n");
    printf ("\n");
    printf (" modslvResGroup(N,G)      Assign line N to group G (valid G range is 1 to 16)         \n");
}

/********
**
**	This routine holds the task from starting to grap for debug
**
********/
int modslvtaskhold = FALSE; /* Default to run freely */
void modlsvtasklock (unsigned short line)
{
	modslvtaskhold  = TRUE;
}

/********
**
**	This routine lets the task start up
**
********/
void modslvtaskunlock (unsigned short line)
{
	modslvtaskhold  = FALSE;
}

/********
**
**	This routine enables logging of comm trace messages
**
********/
void modslvtraceon (unsigned short line)
{
	modtrace [line] = TRUE;
}

/********
**
**	This routine disables logging of comm trace messages
**
********/
void modslvtraceoff (unsigned short line)
{
	modtrace [line] = FALSE;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void modslvtraffic (unsigned short line, unsigned char add, unsigned type)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = add;
        tracetype [line] = type;
        return;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void modslvtrafficon (unsigned short line)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = 255;  /* every address */
        tracetype [line] = 255; /* every message type */
}

/********
**
**	This routine disables detailed display of normal communications traffic
**
********/
void modslvtrafficoff (unsigned short line)
{
	trace [line] = trace [line] & ~ALLTRAFFICTRACE;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void modslvrestrlv (unsigned short line, unsigned short level)
{
	modrestrace [line] = level;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void modslvrestraceon (unsigned short line)
{
	modrestrace [line] = 1;
}

/********
**
**	This routine disables logging of resource trace messages
**
********/
void modslvrestraceoff (unsigned short line)
{
	modrestrace [line] = 0;
}

/********
**
**	This routine controls logging of trace messages
**
********/
void modslvtrlv (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}

/********
**
**	This routine enables the simulation of responding plcs, reading all input values as zero.
**
********/
void modslvsimon (unsigned short line, unsigned short delay, int low, int high, int digenable)
{
	if ((delay < 1) || (delay > 60))
	{
	    simdelay [line] = 60;
	}
	else
	{
	    simdelay [line] = delay;
	}
	if (low > high)
	{
	    simhigh [line] = low;
	    simlow [line] = high;
	}
	else
	{
	    simlow [line] = low;
	    simhigh [line] = high;
	}
	modsim [line] = TRUE;
	simdigon [line] = digenable;
}

/********
**
**	This routine disables simulation, thus enabling normal driver function.
**
********/
void modslvsimoff (unsigned short line)
{
	modsim [line] = FALSE;
}

/********
**
**	These routines enable and disable tracing of database configuration errors in driver calls
**
********/
void modslvcontraceon (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }
void modslvcontraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }

/********
**
**	These routines enable and disable tracing of runtime errors in driver calls
**
********/
void modslvruntraceon (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }
void modslvruntraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/********
**
**	These routines enable and disable tracing of call rejection errors in driver calls
**
********/
void modslvrejecttraceon (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }
void modslvrejecttraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }


/********
**
**	These routines enable and disable tracing of call rejection errors in driver calls
**
********/
void modslvnacktraceon (unsigned short line)
    {
	trace[line] = trace[line] | MODBUSNACKTRACE;
    }
void modslvnacktraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~MODBUSNACKTRACE;
    }

/********
**
**	This routine restores default setting for all traces.
**
********/
void modslvdefaulttrace (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = 1;
        trace [line] = 0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
    }
/********
**
**	This routine turns on all error tracing.
**
********/
void modslverrortrace (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = TRUE;
	modrestrace [line] = 2;
	trace[line] = MODBUSNACKTRACE ||
                      CONFIGURATIONTRACE ||
                      RUNTIMEERRORTRACE ||
                      CALLREJECTTRACE ||
                      0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
    }


int stopmodbusslv (short ln)
{
	if (comm_disconnect (link[ln]) != -1)
	{
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int startmodbusslv (unsigned short tlink,      /* the line number of this driver.                      */
                  char 		*mode,      /* UART initializations string (comma delimited ascii). */
                  unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                  unsigned short hdflag,    /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                  unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                  unsigned short delay2,    /* half duplex post TX, pre RTS drop delay.             */
                  unsigned short private)   /* private flag. if 0, normal. if !0, no partner driver.*/

{
    unsigned short	line;

	if (tlink >=FILELINESTART) {
	    line = tlink - FILELINESTART;
	    if (line >= MODLINES)
		return(-1); 
	} else {
	    line = tlink;
	}


	if (line < MODLINES)
	{
	    strncpy (modes[line],mode,sizeof(modes[line]));

	    link[line] = tlink;
	    taskId [line] = taskSpawn (tasknames [line],
                                     MODSLV_PRIORITY,
                                     MODSLV_TASK_OPTIONS,
                                     MODSLV_STACK,
                                     (FUNCPTR) modslv_driver,
                                     line,
                                     (int) modes[line],
                                     delay,
                                     hdflag,
                                     delay1,
                                     delay2,
                                     private,
				     0, 0, 0);

	    logMsg ("Started the MODBUS driver on line %d\n",line, 0,0,0,0,0);

	    remCurIdGet (user,password);
	    return (1);
	}
	else
	{

	    logMsg ("Invalid line number %d\n", line, 0,0,0,0,0);
	    return (-1);
	}
}

/********
**
** Set communication logic time delays to handle half/full duplex, radio delays, etc 
**
********/
void modslvcomm (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
	halfduplex [line]    = hdflag;
	pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}

int modslvResGroup (unsigned short line, unsigned short group)
{
    if (line < MODLINES)
    {
        if (group <= MAXGROUPNUM)
        {
            modResGroups [line] = group;
            logMsg ("Assigned Line %d to Group %d\n", line, group, 0,0,0,0);
            return (1);
        }
        else
        {
            logMsg ("Invalid Group Assignment: line %d: group number must be less than %d.\n", line, MAXGROUPNUM+1, 0,0,0,0);
            return (-1);
        }
    }
    else
    {
        logMsg ("Invalid Group Assignment: line %d: line number must be less than %d\n", line, MODLINES, 0,0,0,0);
        return (-1);
    }
}

void modslvgrouptable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager:  Limitorque Driver Line to Group Map Table\n");
    printf (" -----------------------------------------------------------------------\n");
    printf ("  Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp \n");

    x = 8;
    y = MODLINES/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d  ",
                    index/10,
                    index%10,
                    modResGroups [index]/10,
                    modResGroups [index]%10);
        }
        printf ("\n");
    }
}

void modslvlocktable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Grp:Flg   Grp:Flg   Grp:Flg   Grp:Flg\n");

    x = 4;
    y = MAXGROUPNUM/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d   ",
                    (index+1)/10,
                    (index+1)%10,
                    resGroupLock [index]/10,
                    resGroupLock [index]%10);
        }
        printf ("\n");
    }
}

void modslvlockall (void)
{
    unsigned short i;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Group  Flag  Trip Name\n");
    for (i = 0; i < MAXGROUPNUM; i++)
    {
        printf ("   %d%d     %d%d",
                    (i+1)/10,
                    (i+1)%10,
                    resGroupLock [i]/10,
                    resGroupLock [i]%10);
        if (resGroupTripName[i])
        {
            printf ("   %s\n", resGroupTripName[i]);
        }
        else
        {
            printf ("\n");
        }
    }
}

void modslvsetlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Setting Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 1;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1, 0,0,0,0);
    }
}

void modslvclrlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Clearing Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 0;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1, 0,0,0,0);
    }
}

void modslvgrouphelp (void)
{
    printf (" Modicon Driver Group Related Functions\n");
    printf ("\n");
    printf (" modResGroup(N, G)     Assign line N to group G (valid G range is 1 to 16)         \n");
    printf (" modgrouptable         Display the Limitorque's line to group assignment table.    \n");
    printf (" modlocktable          Display the resource group lock Global Array.               \n");
    printf (" modlockall            Display the resource group lock and trip name Global Array. \n");
    printf (" modsetlock (G)        Set the resource group lock for group G. (1 to 16)          \n");
    printf (" modclrlock (G)        Clear the resource group lock for group G. (1 to 16)        \n");
    printf (" modgrouphelp          Display this help message.                                  \n");
    printf ("\n");
}

/********
**
** Show Driver Info and Current State Information 
**
********/
void modslvinfo (unsigned short line)
{
    printf ("intermsgdelay [%d]  = %d\n", line, intermsgdelay[line]);
    printf ("halfduplex [%d]     = %d\n", line, halfduplex[line]);
    printf ("pretxdelay [%d]     = %d\n", line, pretxdelay[line]);
    printf ("posttxdelay [%d]    = %d\n", line, posttxdelay[line]);
    printf ("pryvate [%d]        = %d\n", line, pryvate[line]);
    printf ("resresponse [%d]    = %d\n", line, resresponse[line]);
    printf ("activity_time [%d]  = %ld\n", line, activity_time[line]);
    printf ("line_activity [%d]  = %d\n", line, line_activity[line]);
    printf ("lastactivity [%d]   = %d\n", line, lastactivity[line]);
    printf ("modtrace [%d]       = %d\n", line, modtrace[line]);
    printf ("mltrace [%d]        = %d\n", line, mltrace[line]);
    printf ("modrestrace [%d]    = %d\n", line, modrestrace[line]);
}


/*
**      modslv_driver
**
**      The purpose of this task is to scan the modbus plc
**      lines. It will maintain a configuration list supporting online additions
**      and replacement of modules, and maintain a table of most recently
**      scanned values.
**
*/                                                                                     	

void modslv_driver (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2,
           unsigned short private)
{
    unsigned short  mod;
    unsigned short  activity, pstate, lstate, command,i;
    MODPLC          *pmod;
    RXLINE          *rxp;
    int             temp;
    unsigned short  group;

    activity = 0;	/* assign a default value */

    /* Initialize the data structures */
    intermsgdelay [line] = delay;

    halfduplex [line]  = hdflag;
    pretxdelay [line]  = delay1;
    posttxdelay [line] = delay2;

    pryvate [line]     = private;

    resresponse [line] = FALSE;
    resnames [line] [0] = 0;
    prestable [line] = NULL;

    activity_time [line] = tickGet ();
    lastactivity [line] = line_activity [line] = FALSE;

    pstatewait[line] = 60;      /* will wait up to one minute for partner to become valid */

    /* debug structures */
    modslvdefaulttrace (line);

    tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

    linestats [line].TXintcount = 0;
    linestats [line].RXintcount = 0;
    linestats [line].RXbadcount = 0;
    linestats [line].msgxfercount = 0;
    linestats [line].startingtick = tickGet ();

    modsim [line] = FALSE;              /* start with normal operation. */

    /* communication initialization */

    rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
    if (!rxlinetab [line]) {
        logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line, 0,0,0,0,0);
        return;
    }
    txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
    if (!txlinetab [line]) {
        logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line, 0,0,0,0,0);
        return;
    }

    /* Debug task hold off */
    if (modslvtaskhold) {
        logMsg ("Modicon driver for line %d waiting for modslvtaskunlock\n",line,0,0,0,0,0);
        while (modslvtaskhold) {
            taskDelay(10);
        }
    }


    taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */
    comm_init (link[line], mode, (FUNCPTR)tx_int_proc, (FUNCPTR)rx_int_proc);
    clear_rts (link[line]);
    taskUnlock ();


    /* Initialize the Rx interrupts to receive once for activity check         */
    /* enable the receiver interrupt after set to ignore                       */

    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
    enable_rx_ints (link[line]);

    /* Initialize the line communication semaphores */
    semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
    semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);

    /* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
    while ((resnames [line] [0] == 0) || (prestable [line] == NULL)) {
        if (modrestrace [line] > 1) {
            logMsg ( "No Resource Defined for line - %d \n", line, 0,0,0,0,0);
        }
        taskDelay (120);
    }

    if (pryvate [line]) {
        /* mark the restable as private */
        rmPrivate(resnames [line]); 
        /*****************************/
        /* Immediately become master */
        /*****************************/

        resSetCaAnswer (prestable [line]);
        resPutLocalState (prestable [line], RES_MSTR);

        lstate = RES_MSTR;
        if (modrestrace [line]) {
            logMsg ("0] Private: Initialize as RES_MSTR\n", 0,0,0,0,0,0);
        }
    } else {   /* this is the 'normal' path */
        /**********************/
        /* Start out as slave */

        resClearCaAnswer (prestable [line]);		/* start quiet */
        resPutLocalState (prestable [line], RES_SLV);
        if (modrestrace [line]) {
            logMsg ("1] Initialized as RES_SLV\n", 0,0,0,0,0,0);
        }

        /* wait finite time for pstate to be resolved */
        logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line], 0,0,0,0,0);
        for (i = 0; i <= pstatewait [line]; i++) {
            resGetStates (prestable [line], &lstate, &pstate);
            if (pstate != 0) {
                break;
            }
            taskDelay (60);
        }
        if (pstate == 0) {
            logMsg ("Timeout of pstate wait.\n", 0,0,0,0,0,0);
        } else {
            logMsg ("Completion of pstate wait.\n", 0,0,0,0,0,0);
        }

        for (i = 0; i < ACTIVITYTIME/10; i++) {  /* ten seconds */
            taskDelay(10);
        }

        activity = check_line_activity(line, 0);
        resGetStates (prestable [line], &lstate, &pstate);

        /******************************************/
        /* if the partner is not there, be master */

        if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity)) {
            resSetCaAnswer (prestable [line]);
            resPutLocalState (prestable [line], RES_MSTR);

            lstate = RES_MSTR;
            if (modrestrace [line]) {
                logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity, 0,0,0,0);
            }
        }
    }

    /* Set up the receiver and let it run */
    start_rx (line, semids [line] [RXSEM], &rxstatus[line]);

    while (TRUE) {

        /************************************/
        /* check for line group disablement */
        /************************************/
        group = modResGroups [line];
        if ((group) && (resGroupLock [group-1])) {
            if (modrestrace [line]) {
                logMsg ("13] Forced to RES_SLV.\n", 0,0,0,0,0,0);
            }
            resClearCaAnswer (prestable [line]);
            resPutLocalState (prestable [line], RES_SLV);
            lstate = RES_SLV;
            resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */
            if (modrestrace [line]) {
                logMsg ("14] Resource Group Locked     P= %x A= %d \n", pstate, activity, 0,0,0,0);
            }
            while (resGroupLock [group-1]) {
                group = modResGroups [line];
                if (group) {
                    clear_rts (link[line]); 		/* Make sure line is left for master    */
                    taskDelay (2);
                } else {     /* the line has been taken out of the group */
                    break;
                }
            }
            if (modrestrace [line]) {
                logMsg ("15] Resource Group Unlocked   P= %x A= %d \n", pstate, activity, 0,0,0,0);
                logMsg ("16] Released to RES_SLV.\n", 0,0,0,0,0,0);
            }
        }



        /*  *******************************************************************************************/
        /* we arrive here because we are a slave.                                                   */
        /* we stay until:   asked to be master by partner. if we can reach PLCs, we become master.  */
        /*                  the partner is not master and there is no activity on the line.         */
        /********************************************************************************************/
        while (lstate == RES_SLV) {
            /* check for plc simulated mode. */
            if (modsim [line]) {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                if (modrestrace [line]) {
                    logMsg ("Simulation Mode] Became RES_MSTR  P= %x A= %d \n",pstate,activity, 0,0,0,0);
                }
                break;
            }

            if (pstate != RES_SLVWANT) {
                clear_rts (link[line]); 				/* make sure line is left for master 	*/
            }
            resresponse [line] = FALSE; 			/* make sure driver is not responding 	*/
            resPutCommand (prestable [line], 0); 		/* clear out commands 			*/
            activity = check_line_activity (line, 10); 	/* wait 10 seconds before checking 	*/
            resGetStates (prestable [line], &lstate, &pstate);

            /************************************/
            /* check for line group disablement */
            if (checkgroup (line, &lstate, 17)) break;

            /****************************************************************************************/
            /* see if needed by partner to be master. if yes, do it and break out of slave state.   */
            if (pstate == RES_SLVWANTCA) {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                if (modrestrace [line]) {
                    logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity, 0,0,0,0);
                }
                break;
            }
            /***************************************************************/
            /* If partner is there and wants to give it up take it */

            if (pstate == RES_SLVWANT) {
                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 19)) break;


                taskDelay (2); /* Time for switch to occur */

                resPutLocalState (prestable [line], RES_MSTR);
                resSetCaAnswer (prestable [line]);
                prepresponses (line);
                break;
            }

            if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity)) {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;

                if (modrestrace [line]) {
                    logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity, 0,0,0,0);
                }
                prepresponses (line);
            }
        }

        /****************************************************************************************/
        /* to arrive here, we used to be master, and had been told to relinquish master status. */
        /* stay in this loop until the partner takes over, or the command is canceled */
        while (lstate == RES_SLVWANTCA) {
            taskDelay (2);                   /* Give OS a chance...  */
   
            /************************************/
            /* check for line group disablement */
            if (checkgroup (line, &lstate, 20)) break;

            clear_rts (link[line]); 		/* Make sure line is left for master    */
            resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */

            resGetStates (prestable [line], &lstate, &pstate);
            if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT)) {
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                if (modrestrace [line]) {
                    logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity, 0,0,0,0);
                }
                break;
            }
            resGetCommand (prestable [line], &command);
            resPutCommand (prestable [line], 0); /* clear out commands */
            if (command == RES_CANCELREL) {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lstate = RES_MSTR;
                if (modrestrace [line]) {
                    logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity, 0,0,0,0);
                }
                prepresponses (line);
            }
        }

        /****************************************************************************************/
        /* in normal operation this code should never execute. it has, however, been seen to    */
        /* execute when the database has been inadvertently configured with the same resource   */
        /* assigned to two different drivers in the same IOC. The state does funny things.      */
        /****************************************************************************************/
        while (lstate == RES_SLVWANT) {
            if (checkgroup (line, &lstate, 21)) break;
            if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE)) {
                /* condition should NEVER occur. print error message every 5 seconds. */
                logMsg ("Illegal Local Resource State.\n", 0,0,0,0,0,0);
                if (trace[line] & CONFIGURATIONTRACE) {
                    logMsg ("  Possible Resource Configuration Error:\n", 0,0,0,0,0,0);
                    logMsg ("   Check for multiple drivers sharing single Resource.\n", 0,0,0,0,0,0);
                }
                taskDelay (600);
            }
            taskDelay (2);
            resGetStates (prestable [line], &lstate, &pstate);
        }
        /****************************************************************************************/
        /* we come here because we have gone to, or are looping in, the master state.           */
        /* we stay in this loop until:    we have been told to give master state to the partner.*/
        /*                                we break out to RES_SLVWANTCA.                        */
        /*                                we have successfully handed master state to partner.  */
        /* While master, this task will process all modules sending outputs and getting inputs. */
        /* It will then try to configure requested non-responding modules.                      */
        /****************************************************************************************/
        while (lstate == RES_MSTR) {
            /* check for plc simulated mode. */
            while (modsim [line]) {
                resresponse [line] = TRUE; /* Make sure driver is responding. driver won't         */
                for (mod = 1; (mod <= NUMMODPLCS); mod++) {
                    pmod = plcs [line] [mod];   /* shorthand pointer 			*/
                    if (pmod) {                 /* verify pointer validity prior to use */
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 22)) break;

                        if (!pmod->cmd_force_offline) { 
                            sim_plc (pmod, line, mod);      /* I/O done here! 		*/
                           taskDelay (simdelay [line]);
                        }
                    }
                }
                /************************************/
                /* test for line group disablement. */
                if (lstate == RES_LOCKED) break;

            }

            /************************************/
            /* test for line group disablement. */
            if (lstate == RES_LOCKED) break;

            /* initial stuff */
            resresponse [line] = TRUE; /* Make sure driver is responding. driver won't           */
                                       /* issue commands if not set.                             */

            resGetCommand (prestable [line], &command);
            resPutCommand (prestable [line], 0);        /* clear out commands */

            /************************************************************************/
            /* if relinquish command sent, change state and break out to outer loop */
            if (command == RES_RELINQUISH) {
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLVWANTCA);
                lstate = RES_SLVWANTCA;
                if (modrestrace [line]) {
                    logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity, 0,0,0,0);
                }
                break;
            }


            /* Do a timed wait for a message */
            /* If we got a message process it */
            /* This routine will come back after every message or 5 ticks, which every comes first */
            getandprocess (line);

            /************************************/
            /* check for line group disablement */
            if (checkgroup (line, &lstate, 23)) break;

            /* local/partner lockstep recovery */

            resGetStates (prestable [line], &lstate, &pstate);
            if ((pstate == RES_MSTR) && (!pryvate[line])) {
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                clear_rts (link[line]); 		/* Make sure line is left for master */
                if (modrestrace [line]) {
                    logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity, 0,0,0,0);
                }
                temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                for ( i = 0; i < temp; i++) {
                    taskDelay(60);
                }
                break;
            }

            /* if told to relinquish our master state, stop plc scanning immediately. */
            /* don't trash the command, so that we can still read it on the next loop */
            /* through this while statement.                                          */
            resGetCommand (prestable [line], &command);
            if (command == RES_RELINQUISH) {
                break;
            }
        } /* end of master loop */

    } /* end infinite task loop */
}


/************************************/
/* check for line group disablement */
/************************************/
int checkgroup (unsigned short line, unsigned short *lstate, unsigned short tracenum)
{
    unsigned short group;

    group = modResGroups [line];
    if ((group) && (resGroupLock [group-1]))
    {
        *lstate = RES_LOCKED;
        if (modrestrace [line])
        {
            logMsg ("%d] Resource Group Lock Detected.\n", tracenum, 0,0,0,0,0);
        }
        return (TRUE);
    }
    return (FALSE);
}



/*							
** Mark all plc data elements as not valid     		
**                                             		
*/                                             	

static void mark_not_valid (MODPLC  *pmod)
{
	unsigned	short i;


/*
**      COILS ARE INITIALIZED AS READ WRITE VALUES      
**              - READ BACK NOT VALID 			
*/
	for (i = 0; (i < (NUMCOILS/8)); i++)
	{
	    pmod->coilsvalid [i] = FALSE;
	}

/*
**      REGISTERS ARE INITIALIZED AS READ WRITE VALUES		
**      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS 	
**              - READ BACK NOT VALID      	               	
*/
	for (i = 0; (i < NUMREGS); i++)
	{
	    pmod->regsvalid [i] = FALSE;
	}
}

static	void sim_plc (MODPLC *pmod, unsigned short line, unsigned short mod)
    {
	unsigned short	i, j;

	pmod->is_responding = pmod->was_requested;

	/* read the coil values to be scanned */

	for (i = 0; (i < (NUMCOILS/8)); i++)
	{
	    pmod->coilsvalid [i] = pmod->coilsdef [i];
	    if (simdigon [line])
	    {
		pmod->coils [i] = ~pmod->coils [i];
	    }
	}


	/* read the reg values to be scanned */

	for (i = 0; (i < NUMREGS); i++)
	{
	    pmod->regsvalid [i] = pmod->regsdef [i];
	    for (j = 0; j < NUMREGS; j++)
	    {
		if ((pmod->regs [i] < simlow [line]) ||
		    (pmod->regs [i] >= simhigh [line]))
		{
		    pmod->regs [i] = simlow [line];
		}
		else
		{
			pmod->regs [i] += 1;
		}
	    }
	}
}

/*                                                                                     
**      modslv_aidriver                                                                       
**                                                                                     
**      This routines main purpose is to return the analog input value for the         
**      specified module. For a module value                                           
**      a (-1) will be returned if there is no valid data ready.                       
**
*/

int modslv_aidriver (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname)
    {
	MODPLC		*pmod;
	unsigned short    itemlen,i;
	unsigned short	*pdata;

	if (link > MODLINES)
      {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        (int) pointname, link, adapter, card, signal, 0);
            return (-1);
      }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        (int) pointname, link, adapter, card, signal, 0);
            return (-1);
      }
	if ((card != MREGS) && (card != MPSEUDO))
      {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        (int) pointname, link, adapter, card, signal, 0);
            return (-1);
      }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 5: /* Output Messages */
		*pvalue = pmod->no_dataout_msgs & 0x7fff;
		break;

	    case 6: /* Input Messages */
		*pvalue = pmod->no_datain_msgs & 0x7fff;
		break;


	    case 8: /* No Transmitter Response */
		*pvalue = pmod->no_txnoresp & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = pmod->no_txhwerrs & 0x7fff;
		break;

	    case 13: /* CRC errors */
		*pvalue = pmod->no_crcerrs & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            (int) pointname, link, adapter, card, signal, 0);
		return (-1);
	    }
	    return (0);
	}

      signal--; /* Signals are defined as 1 relative */

      switch (conversion)
	{
	    case (AICNVDOUBLEINT):
	    case (AICNVFLOAT):
	        itemlen = 2;
		  break;
	    case (AICNVDOUBLEFLT):
	        itemlen = 4;
	        break;
	    case (AICNVINTEGER):
	    default:
	        itemlen = 1;
	        break;
      }

      if ((signal+itemlen) >= NUMREGS)
      {
          if (trace[link] & CONFIGURATIONTRACE)
              logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal, 0);
          return (-1);
      }

      if (resname != 0)
      { 
          register_resource(link,pmod,resname,pointname);
      }

      pmod->was_requested = TRUE;


      /* as soon as the address is confirmed as valid, set requested bits. */
      if (!resresponse[link])
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("AIDRIVER: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal+1, 0);
          return (-1);
      }
      if (pmod->holdflag)
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("AIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal+1, 0);
          return (-2);
      }

      if (pmod->cmd_force_offline)
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("AIDRIVER: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal+1, 0);
          return (-1);
      }

	for (i = 0; (i<itemlen); i++) {
	     pmod->regsdef[signal+i] = TRUE;
	}

	for (i = 0; (i<itemlen); i++) {
	    if (!pmod->regsvalid [signal+i])
          {
              if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Data Not Valid(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                           (int) pointname, link, adapter, card, signal+1, 0);
	        return (-1);
	    }
      }

      pdata = &(pmod->regs [signal]);

      /* Select the Size and Type of Response based on Conversion */
	switch (conversion)
	{
	    case (AICNVDOUBLEINT):
	        pvalue[0] = pdata[1];
	        pvalue[1] = pdata[0];
	        break;
	    case (AICNVFLOAT):
              pvalue[0] = pdata[1];
	        pvalue[1] = pdata[0];
	        break;
	    case (AICNVDOUBLEFLT):
	        pvalue[0] = pdata[3];
	        pvalue[1] = pdata[2];
	        pvalue[2] = pdata[1];
	        pvalue[3] = pdata[0];
	        break;
	    case (AICNVINTEGER):
	    default:
	       *pvalue = *pdata;
	       break;
      }
      if (mltrace[link] == 8)
          logMsg("AIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, V=0x%x 0x%x\n",
                 (int) pointname, link, adapter, card, pvalue[0], pvalue[1]);
      return(0);
    }

/*  										
**      modslv_aodriver                                                                
**                                                                            	
**      This routines main purpose is to set requested analog outputs to the  	
**      specified module.                                                     	
*/                                                                            	


int modslv_aodriver (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	    unsigned short signal,double dvalue, unsigned short value,
	    unsigned short conversion, unsigned char *resname)

{
	MODPLC		   *pmod;
	unsigned    short  i,*pvals,*pdef,*pvalid, itemlen;

   	union 	u_value {
		    short		ivalue[4];
		    long		lvalue;
		    float		fvalue;
		    double		dvalue;
		    char		afvalue[100];
		}  uval;


	uval.fvalue = dvalue;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        (int) pointname, link, adapter, card, signal, value);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        (int) pointname, link, adapter, card, signal, value);
            return (-1);
        }
	if ((card != MAINS) && (card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        (int) pointname, link, adapter, card, signal, value);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats(pmod);
		}
		break;

	    case 16: /* Force the PLC online/offline */
		pmod->cmd_force_offline = (value != 0);
                if (value != 0)
		{
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		}
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            (int) pointname, link, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}

	signal--; /* Signals are defined as 1 relative */

	switch (conversion)
	{
	    case (ASCFLT):
	        itemlen = 2;
		  break;
	    default:
	        itemlen = 1;
		  break;
      }

      if ( ((card == MAINS) && (signal+itemlen > NUMAINS)) || 
           ((card == MREGS) && (signal+itemlen > NUMREGS)) ) { 
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg( "AODRIVER: Point extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            (int) pointname, link, adapter, card, signal+1, value);
                return (-1);
      }

	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}

	pmod->was_requested = TRUE;


 	if (!resresponse[link])
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("AODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                      (int) pointname, link, adapter, card, signal+1, value);
          return (-1);
      }

      if (pmod->holdflag)
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("AODRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal+1, 0);
          return (-2);
      }

	if (pmod->cmd_force_offline)
	{
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        (int) pointname, link, adapter, card, signal+1, value);
	    return (-1);
	}

      if (card == MAINS) {
          pvals = &pmod->ais[0];
	    pdef = &pmod->ainsdef[0];
          pvalid = &pmod->ainsvalid[0];
      } else {
          pvals = &pmod->regs[0];
	    pdef = &pmod->regsdef[0];
          pvalid = &pmod->regsvalid[0];
      }

	for (i = 0; (i<itemlen); i++) {
          pdef[signal+i] = TRUE;
	    pvalid[signal+i] = TRUE;
	}

	/* may be endian sensitive */
	if (itemlen == 1) {
	    pvals[signal] = value;
	} 
	if (itemlen == 2) {
	    pvals[signal] = uval.ivalue[1];
	    pvals[signal+1] = uval.ivalue[0];
      }

	return (0);
}

/*                                                                             
**      modslv_aoread                                                                  
**                                                                          	
**      This routines main purpose is to return the value last read back     	
**      from the analog output hardware. This is used to initialize analog   	
**      outputs.                                                             	
*/


int modslv_aoread (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	  unsigned short signal, unsigned short *pvalue,
	  unsigned short conversion, unsigned char *resname)

    {
	MODPLC		*pmod;
	unsigned short  i,*pvals,*pdef,*pvalid, itemlen;
	
	if (link > MODLINES)
      {
          if (trace[link] & CONFIGURATIONTRACE)
              logMsg("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal, 0);
          return (-1);
      }
	if (adapter > NUMMODPLCS)
	{
          if (trace[link] & CONFIGURATIONTRACE)
              logMsg("AOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal, 0);
          return (-1);
      }
	if ((card != MAINS) && (card != MREGS) && (card != MPSEUDO))
      {
          if (trace[link] & CONFIGURATIONTRACE)
              logMsg("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d \n",
                      (int) pointname, link, adapter, card, signal,0 );
          return (-1);
      }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
              return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {

	        case 15: /* read statistics command value */
		      *pvalue = pmod->cmd_reset_stat;
		      break;

	        case 16: /* Read the current PLC offline command status */
		      *pvalue = pmod->cmd_force_offline;
		      break;

	        default:
                  if (trace[link] & CONFIGURATIONTRACE)
                      logMsg("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                              (int) pointname, link, adapter, card, signal, 0);
		      return(-1);
	    }
	    return (0);
	}

      signal--; /* Signals are defined as 1 relative */

	switch (conversion)
	{
	    case (ASCFLT):
	        itemlen = 2;
		  break;
	    default:
	        itemlen = 1;
		  break;
      }

      if ( ((card == MAINS) && (signal+itemlen > NUMAINS)) || 
           ((card == MREGS) && (signal+itemlen > NUMREGS)) ) { 
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg( "AOREAD: Point extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d%d\n",
                            (int) pointname, link, adapter, card, signal+1,0);
                return (-1);
      }
	
      if (resname != 0)
      { 
          register_resource(link,pmod,resname,pointname);
      }

      pmod->was_requested = TRUE;

      if (!resresponse[link])
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("AOREAD: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal+1, 0);
          return (-1);
      }
      if (pmod->holdflag)
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("AOREAD: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal+1, 0);
          return (-2);
      }

      if (pmod->cmd_force_offline)
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("AOREAD: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal+1, 0);
          return (-1);
      }

      /* as soon as the address is confirmed as valid, set requested bits. */
      if (card == MAINS) {
          pvals = &pmod->ais[0];
	    pdef = &pmod->ainsdef[0];
          pvalid = &pmod->ainsvalid[0];
      } else {
          pvals = &pmod->regs[0];
	    pdef = &pmod->regsdef[0];
          pvalid = &pmod->regsvalid[0];
      }

	for (i = 0; (i<itemlen); i++) {
          pdef[signal+i] = TRUE;
	}


#ifdef MSLVREADBACK
	/* AINS are only written internally and cannot be read back therefore always init with 0 */
        if (card == MAINS) {
#else
	/* None can be read back therefore always init with 0 */
        if ((card == MAINS) || (card == MREGS)) {
#endif MSLVREADBACK

            for (i=0;(i<itemlen);i++) {
                pvalue[i] = 0;
                pvalid[signal+i] = TRUE;
	    }
            return (0);
        } 

	/* For registers make sure we have had them written to us first */
	for (i = 0; (i<itemlen); i++) {
	    if (!pmod->regsvalid [signal+i])
          {
              if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: Data Not Valid(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                           (int) pointname, link, adapter, card, signal+1, 0);
	        return (-1);
	    }
      }

	/* may be endian sensitive */
	if (itemlen == 1) {
	    pvalue[0] = pvals[signal];
	} 
	if (itemlen == 2) {
	    pvalue[1] = pvals[signal];
	    pvalue[0] = pvals[signal+1];
      }

        return (0);

    }

/*                                                                                     
**      modslv_bidriver                                                                        
**                                                                               	
**      The main purpose of this routine is to return the request digital input  	
**      value(s) from the requested card. This routine will return a (-1) if the  	
**      requested module is the wrong type or the data is not yet valid.          	
**                                                                                	
*/

int modslv_bidriver (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask, unsigned long *pvalue,
		unsigned char *resname)
{
    MODPLC              *pmod;
    unsigned short      blkix,i,itemlen,isvalid;
    unsigned long       tvalue,smask;

    if (link > MODLINES) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }
    if (adapter > NUMMODPLCS) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }
    if ( (card != MCOILS) && (card != MPSEUDO)) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }
    pmod = plcs [link] [adapter];
    if (pmod == NULL) {
        if (!allocate_plc (link, adapter)) {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = plcs [link] [adapter];
    }

    if (card == MPSEUDO) {
        switch (signal) {
            case 0: /* Were the PLC values requested */
                *pvalue = pmod->was_requested;
                break;

            case 15: /* reset statistics */
                *pvalue = pmod->cmd_reset_stat;
                break;

            case 16: /* Force the PLC offline */
                *pvalue = pmod->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                (int) pointname, link, adapter, card, signal, 0);
                return (-1);
        }
        return (0);
    }

    tvalue = 0;

    signal--; /* Signals are defined as 1 relative */
    blkix = ((signal / 8));		/* 8 bits per digital BLOCK */
    blkix &= 0xfffc;			/* all bis are referenced as though they start on 32 bit bounds */

    itemlen = 0;
    for (i=0, smask = 0xff; (i<4); i++) {
        if  ((mask & smask) != 0) {
            itemlen = i;
	}
	smask = smask << 8;
    }
			
    if ((signal+itemlen >= (NUMCOILS/8)) ) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                   (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }
    if (resname != 0) { 
        register_resource(link,pmod,resname,pointname);
    }

    pmod->was_requested = TRUE;

    if (!resresponse[link]) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIDRIVER: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal+1, 0);
        return (-1);
    }
    if (pmod->holdflag) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal+1, 0);
        return (-2);
    }

    if (pmod->cmd_force_offline) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIDRIVER: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal+1, 0);
        return (-1);
    }

    tvalue = 0;
    isvalid = TRUE;

    for (i=0, smask = 0xff; (i<4); i++) {
        if  ((mask & smask) != 0) {
            pmod->coilsdef [blkix+i] = TRUE;
            if (!pmod->coilsvalid [blkix+i])
                isvalid = FALSE;
	}
	smask = smask << 8;
	tvalue += (pmod->coils [blkix+i] << (8*i));
    }

    if (!isvalid) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal+1, 0);
        return (-1);
    }

    *pvalue = tvalue & mask;
    if (mltrace[link] == 8)
        logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                (int) pointname, link, adapter, card, signal+1, *pvalue);
    return (0);

}

/*                                                                                     
**      modslv_bodriver                                                                        
**                                                                                 	
**      The main purpose of this routine is to set the request digital output      	
**      value(s) on the requested card. This routine will return a (-1) if the     	
**      requested module is the wrong type or not configured yet.                  	
**                                                                                 	
*/

int modslv_bodriver (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long value, unsigned long mask,
		unsigned char *resname)
{
    MODPLC 		*pmod;
    unsigned short  blkix;
    unsigned long   smask,tvalue;
    unsigned short  i,*pdef,*pvalid, itemlen;
    unsigned char   *pvals;

    if (link > MODLINES) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    (int) pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (adapter > NUMMODPLCS) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    (int) pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if ((card != MCOILS) && (card != MDINS) && (card != MPSEUDO)) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    (int) pointname, link, adapter, card, signal, value);
        return (-1);
    }

    pmod = plcs [link] [adapter];
    if (pmod == NULL) {
        if (!allocate_plc (link, adapter)) {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = plcs [link] [adapter];
    }

    if (card == MPSEUDO) {
        switch (signal & 0x1f) {

            case 15: /* Reset the accumulated statistics */
                if (value != 0) {
                     initstats (pmod);
                }
                break;

            case 16: /* Force the PLC offline */
                pmod->cmd_force_offline = (value != 0);
                if (value != 0) {
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
                }
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            (int) pointname, link, adapter, card, signal, value);
            return (-1);
        }
        return (0);
    }

    signal--; /* Signals are defined as 1 relative */
    blkix = ((signal / 8));		/* 8 bits per digital BLOCK */
    blkix &= 0xfffc;			/* all bis are referenced as though they start on 32 bit bounds */


    itemlen = 0;
    for (i=0, smask = 0xff; (i<4); i++) {
        if  ((mask & smask) != 0) {
            itemlen = i;
        }
        smask = smask << 8;
    }

    if (  ( (card == MCOILS) && (signal+itemlen >= (NUMCOILS/8)) ) ||
          ( (card == MDINS ) && (signal+itemlen >= (NUMDINS/8 )) ) ) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                   (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }


    if (resname != 0) { 
        register_resource(link,pmod,resname,pointname);
    }

    pmod->was_requested = TRUE;

    if (!resresponse[link]) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    (int) pointname, link, adapter, card, signal+1, value);
        return (-1);
    }

    if (pmod->holdflag) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BODRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal+1, 0);
        return (-2);
    }

    if (pmod->cmd_force_offline) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    (int) pointname, link, adapter, card, signal+1, value);
        return (-1);
    }

    if (card == MDINS) {
        pvals = &pmod->dis[0];
        pdef = &pmod->dinsdef[0];
        pvalid = &pmod->dinsvalid[0];
    } else {
        pvals = &pmod->coils[0];
        pdef = &pmod->coilsdef[0];
        pvalid = &pmod->coilsvalid[0];
    }

    tvalue = 0;
    for (i=0, smask = 0xff; (i<4); i++) {
        if  ((mask & smask) != 0) {
            pdef [blkix+i] = TRUE;
            pvalid [blkix+i] = TRUE;
        }
        smask = smask << 8;
        tvalue += (pvals [blkix+i] << (8*(3-i)));
    }

    /* Clear out the bits we are writing */
    tvalue = tvalue & (~mask);
    /* or in the new values */
    tvalue = tvalue | value;

    /* Put the new data back */
    for (i=0; (i<4); i++) {
        smask = smask << 8;
        pvals[blkix+i] = tvalue & 0xff;
        tvalue = tvalue >> 8;
    }

    if (mltrace[link] == 4)
        logMsg("BODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                (int) pointname, link, adapter, card, signal+1, value);
    return (0);
}


/*
**      modslv_boread                                                                  
**                                                                              
**      This routines main purpose is to return the value last read back      	
**      from the digital output hardware. This is used to initialize digital  	
**      outputs. This will return a (-1) if the module is the wrong type or    	
**      the data is not yet valid                                              	
*/


int modslv_boread (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)

    {
	MODPLC		*pmod;
    unsigned short  blkix;
    unsigned long   tvalue,smask;
    unsigned short  i,*pdef,*pvalid, itemlen,isvalid;
    unsigned char   *pvals;

      if (link > MODLINES)
      {
          if (trace[link] & CONFIGURATIONTRACE)
              logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal, 0);
          return (-1);
      }
      if (adapter > NUMMODPLCS)
      {
          if (trace[link] & CONFIGURATIONTRACE)
              logMsg("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal, 0);
          return (-1);
      }
      if ((card != MCOILS) && (card != MDINS) && (card != MPSEUDO))
      {
          if (trace[link] & CONFIGURATIONTRACE)
              logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal, 0);
          return (-1);
      }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return(-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            (int) pointname, link, adapter, card, signal, 0);
		return (-1);
	    }
	    return (0);
	}


      signal--; /* Signals are defined as 1 relative */
      blkix = (signal / 8);		/* 8 bits per digital BLOCK */
      blkix &= 0xfffc;			/* all bis are referenced as though they start on 32 bit bounds */


      itemlen = 0;
      for (i=0, smask = 0xff; (i<4); i++) {
          if  ((mask & smask) != 0) {
              itemlen = i;
          }
          smask = smask << 8;
      }

      if ( ( (card == MCOILS) && (signal+itemlen >= (NUMCOILS/8)) ) ||
           ( (card == MDINS ) && (signal+itemlen >= (NUMDINS/8 )) ) )
      {
          if (trace[link] & CONFIGURATIONTRACE)
              logMsg("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                     (int) pointname, link, adapter, card, signal, 0);
          return (-1);
      }

	if (resname != 0)
	{
           register_resource (link, pmod, resname, pointname);
	}

      pmod->was_requested = TRUE;


      if (!resresponse[link])
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("BOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d \n",
                      (int) pointname, link, adapter, card, signal+1, 0);
          return (-1);
      }

      if (pmod->holdflag)
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("BOREAD: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal+1, 0);
          return (-2);
      }

      if (pmod->cmd_force_offline)
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("BOREAD: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d \n",
                      (int) pointname, link, adapter, card, signal+1,0);
          return (-1);
      }

      if (card == MDINS) {
          pvals = &pmod->dis[0];
          pdef = &pmod->dinsdef[0];
          pvalid = &pmod->dinsvalid[0];
      } else {
          pvals = &pmod->coils[0];
          pdef = &pmod->coilsdef[0];
          pvalid = &pmod->coilsvalid[0];
      }

    	tvalue = 0;
	isvalid = TRUE;

	for (i=0, smask = 0xff; (i<4); i++) {
          if  ((mask & smask) != 0) {
	        pdef [blkix+i] = TRUE;
		  if (!pvalid [blkix+i])
                  isvalid = FALSE;
	    }
	    smask = smask << 8;
	    tvalue += (pvals [blkix+i] << (8*(3-i)));
	}

#ifdef MSLVREADBACK
	if (card == MDINS) {
#else
	if ( (card == MDINS) || (card == MCOILS) ) {
#endif MSLVREADBACK

	    *pvalue = 0;

          return 0;
      }

      if (!isvalid)
      {
          if (trace[link] & CALLREJECTTRACE)
              logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                      (int) pointname, link, adapter, card, signal+1, 0);
		  return (-1);
      }

	*pvalue = tvalue & mask;

      if (mltrace[link] == 8)
          logMsg("BOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                  (int) pointname, link, adapter, card, signal+1, *pvalue);
	return (0);

  }

/*                                                                                     
**      modslv_sidriver                                                                        
**                                                                              	
**      This routines main purpose is to return the analog input value for the         	
**      specified module. For a module value                                           	
**      a (-1) will be returned if there is no valid data ready.                       	
**                                                                                     	
*/

int modslv_sidriver (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short len,
		unsigned char *resname)
{
	MODPLC          *pmod;
        unsigned short  reglen;
        int             i;


    if (link > MODLINES) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }
    if (adapter > NUMMODPLCS) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }

    if ((card != MREGS) ) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }

    pmod = plcs[link][adapter];
    if (pmod == NULL) {
        if (!allocate_plc(link, adapter))
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        pmod = plcs[link][adapter];
    }

    signal--; /* Signals are defined as 1 relative */
    reglen = (len+1)/2;     /* round up odd length character count string lengths */

    if ((signal+(reglen)) >= NUMAINS) {
        if (trace[link] & CONFIGURATIONTRACE) {
            logMsg( "SIDRIVER: String extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal, 0);
            return (-1);
        }
    }

    if (resname != 0) { 
        register_resource(link,pmod,resname,pointname);
    }

    pmod->was_requested = TRUE;

    if (!resresponse[link]) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("SIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d \n",
                    (int) pointname, link, adapter, card, signal+1,0);
        return (-1);
    }

    if (pmod->holdflag) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("SIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal+1, 0);
        return (-2);
    }

    if (pmod->cmd_force_offline) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("SIDRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d \n",
                    (int) pointname, link, adapter, card, signal+1,0);
        return (-1);
    }

    /* Strings Must begin on a register boundary and 
    *  either end on a register boundary or be null terminated
    */
    for ( i = 0; (i < reglen) ; i++) {
        pmod->ainsdef [signal+i] = TRUE;
    }

    for ( i = 0; (i < reglen) ; i++) {
        if (!pmod->ainsvalid [signal+i]) {
            if (trace[link] & CALLREJECTTRACE) {
                logMsg("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        (int) pointname, link, adapter, card, signal+1, 0);
                return (-1);
            }
        }
        pvalue[i] = pmod->ais [signal+1];
    }
    pvalue[i] = 0; /* null terminate the string */
    return(0);

}



/*  										
**      modslv_sodriver                                                                
**                                                                            	
**      This routines main purpose is to set requested string outputs to the  	
**      specified module via the output buffer.                                 
*/                                                                            	

int modslv_sodriver (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	    unsigned short signal, unsigned char *value, unsigned short len, unsigned char *resname)
{
    MODPLC  *pmod;
    unsigned short reglen;
    int            i;
    unsigned short  *pvals,*pdef,*pvalid;

    if (link > MODLINES) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }

    if (adapter > NUMMODPLCS) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }

    if ((card != MREGS) && (card != MAINS) ) {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("SODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal, 0);
        return (-1);
    }
    pmod = plcs[link][adapter];
    if (pmod == NULL) {
        if (!allocate_plc(link, adapter))
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        pmod = plcs[link][adapter];
    }

    signal--; /* Signals are defined as 1 relative */
    reglen = (len+1)/2;     /* round up odd length character count string lengths */

    if ( ((card != MAINS) && ((signal+(reglen)) >= NUMAINS) ) ||
         ((card != MREGS) && ((signal+(reglen)) >= NUMREGS) )  ) {
        if (trace[link] & CONFIGURATIONTRACE) {
            logMsg( "SODRIVER: String extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal, 0);
            return (-1);
        }
    }

    if (resname != 0) { 
        register_resource(link,pmod,resname,pointname);
    }

    pmod->was_requested = TRUE;

    if (!resresponse[link]) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("SODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    (int) pointname, link, adapter, card, signal+1,(int) value);
        return (-1);
    }

    if (pmod->holdflag) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("SODRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    (int) pointname, link, adapter, card, signal+1, 0);
        return (-2);
    }

    if (pmod->cmd_force_offline) {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("SODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    (int) pointname, link, adapter, card, signal+1,(int) value);
        return (-1);
    }

    /* as soon as the address is confirmed as valid, set requested bits. */
    if (card == MAINS) {
        pvals = &pmod->ais[0];
        pdef = &pmod->ainsdef[0];
        pvalid = &pmod->ainsvalid[0];
    } else {
        pvals = &pmod->regs[0];
        pdef = &pmod->regsdef[0];
        pvalid = &pmod->regsvalid[0];
    }

    /* Strings start on must start on a register boundary and be null 
    *  padded to a register boundary 
    */

    for (i = 0; (i<reglen); i++) {
        pdef[signal+i] = TRUE;
        pvalid[signal+1] = TRUE;
        pvals[signal+i] = value[i];
    }

    return(0);

  }



/*
** register_resource
**
**	This routine is used to initialize the resource pointers
**  If this is the first time the resource for this line is being
**  referenced the pointer to the resource table entry will be set
**  and the resource name will be saved. If the resource name has
**  already been set, this routine will verify that all other points
**  for this driver are using the same resource name.
**
*/                                                                                    	
                               	

static void  register_resource (unsigned short link, MODPLC *pmod,
                                unsigned char *resname, char *pointname)
{
    int group;

    if (resnames [link] [0] == 0) { /* This is the first reference */
        if (resGetByName (resname, &prestable [link]) != RES_OK) {
            logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                            (int) pointname,
                            (int) resname, 0,0,0,0 );
        } else {
            strcpy (resnames [link], resname);
            group = modResGroups [link];
            if (group) {
                if (assignLockGroup (group, resname) == ERROR) {
                    logMsg ("assignLockGroup error: Line = %d, Group = %d, Point Name = %s, Resource Name = %s\n",
                                 link, group, (int) pointname, (int) resname, 0,0);
                }
            }
        }
    } else {
        if (strcmp (resnames [link], resname) != 0) {
            logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
                          (int) resnames[link],
                          (int) pointname,
                          (int) resname, 0,0,0 );
        }
    }
}

/*                                                                             	
**                                                                              
**	allocate_plc                                                            
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	plc data structure. If not successful, a console error message is  	
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_plc (unsigned short line, unsigned short plc )
{

    plcs [line] [plc] = (MODPLC *) calloc (1, (sizeof (MODPLC)));
    if (!plcs [line] [plc]) {
        logMsg ("Unable to allocate memory", 0,0,0,0,0,0);
        printf (" for MODPLC data structure on line %d, plc %d\n",line ,plc);
        return(FALSE);
    } else {
        logMsg ("Allocated memory for MODPLC data structure on line %d, plc %d\n",line, plc, 0,0,0,0);
        init_plc_tab (line, plc);	     /*	initialize the data structures. */
    }

    return (TRUE);
}


/*                                                                   		
**      start_rx                                                        	
**                                                                     	 	
**      The purpose of this routine is to initialize a line table        	
**      for receive and to enable the receiver.                           	
**                                                                        	
*/


static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

{
	RXLINE		*rxp;

	rxp = rxlinetab [line];
	rxp->semid = semid;
	rxp->status = pstatus;
}


/*                                                                        	
**      NEW rx_int_proc                                                        	
**                                                                         	
**      The purpose of this routine is to process a receive character interrupt	
**      for a given line.                                                     	
*/
/* Message Types Supported
*
*	01 -	Read Coils
*	02 -	REad Input Status
*	03 -	Read Holding Registers
*	04 -	Read Input Registers
*	05 -	Force Single Coil
*	06 -	Preset Single Register
*	0F -	Force Multiple Coils
*	10 -	Preset Multiple Registers
*	08 -	Diagnostics
*               00 Return Data Query
*/
static	short	msgtypes[] = { 0x01, 0x02, 0x03, 0x04, 0x05, 0x06, 0x0F, 0x10, 0x08 };
static	short msglens[]  = { 0x06, 0x06, 0x06, 0x06, 0x06, 0x06, 0xFF, 0xFF, 0x06 };
#define	NUMMSGTYPES 9


static	int rx_int_proc (unsigned short line )
  {
    unsigned char   rxchar;
    unsigned short  rxstat,i,len;
    unsigned short  rx_err_mask;
    RXLINE          *rxp;

    read_rx_hw (link[line], &rxchar, &rxstat, &rx_err_mask);

    /* only execute if no comm error */
    if ((rxstat & rx_err_mask) == 0)
    {
        /* Something is sending in data. */
        line_activity [line] = TRUE;
        linestats [line].RXintcount++;
    } else {
        linestats [line].RXbadcount++;
    }

    rxp = rxlinetab [line];

    rxp->rxwindow[rxp->rxwinix++] = rxchar;

    if (rxp->rxwinix >= (MAXRXMSG*2)) {
        bcopy(&rxp->rxwindow[1],&rxp->rxwindow[0],((MAXRXMSG*2)-1));
        rxp->rxwinix--;
    }
    if (rxp->rxwinix < 7)
        return 0;

    for  (i=0;(i<rxp->rxwinix-7);i++) {
        if (rxhavemsg(line, i,&len)) {
            bcopy(&rxp->rxwindow[i],&rxp->rxbuf[0],len);
            rxp->rxmsglen = len;
            rxp->rxwinix=0;
            *(rxp->status) = RXGOOD;
            semGive (rxp->semid);
            return 0;
        }
    }
    return 0;
}

/*
* rxhavemsg(i,&len) 
*
*        The purpose of this routine is to see if the rxwindow contains
*        a valid message starting at the offset passed ending before the current 
*        end pointer. If so it returns true and sets the length
*/
static unsigned short rxhavemsg(unsigned short line, unsigned short ix,unsigned short *len)
{

    RXLINE            *rxp;
    unsigned char     *buf,crcs[2];
    unsigned short    length,addr,i,datalen;

    rxp = rxlinetab [line];
    buf = &rxp->rxwindow[ix];

    /* test address field */
    if ((buf[MSGADDR] > NUMMODPLCS)) {
        return FALSE;
    }
    if (plcs [line] [buf[MSGADDR]] == NULL) {
        return FALSE;
    }

    /* test the function code */

    for (i=0;(i<NUMMSGTYPES); i++) {
        if (buf[MSGFUNC] == msgtypes[i])
            break;
    }
    if (i == NUMMSGTYPES) {
        return FALSE;
    }

    /*  get the length indicated by the message type */

    length = msglens[i];                /* Set the length from the table */

    if (length != 0xff) {
        /* It is a fixed size message therefor it must all be in the buffer */
        /* so verify the checksum */
        makecrc (&(buf [0]), length, &crcs[0]);
        if ( (crcs[0] == buf[length]  ) && 
             (crcs[1] == buf[length+1]) ) {
            *len = length+MODCRCLEN;
            return TRUE;
        }
        return FALSE;
    }  

    /* It is variable get the address and length from the message */
    addr = (buf[MSGSTARTHI] << 8) + (buf[MSGSTARTLO]);
    length = (buf[MSGLENHI] << 8) + (buf[MSGLENLO]);

    if (buf[MSGFUNC] == MODMREGWRITE) {
         datalen = (length*2) + 2;  /* 2 bytes per register plus 2 bytes for crc */
    } else {
         datalen = ((length+7)/8) +2;    /* 8 bits per byte plus 2 bytes for crc */
    }

    /* compare the length to the maxaimum message size */
    if ( (datalen+MODVARMGSOVHD+MODCRCLEN) >= (MAXRXMSG-6)) {
        return FALSE;
    }
    /* Compare the length to the amount of data we have in the buffer */
    if ( ((datalen+9) + i) < rxp->rxwinix) { 
        return FALSE;
    }
    /* Verify the checksum on the data in the buffer */
    makecrc (&(buf [0]), (datalen+MODVARMGSOVHD), &crcs[0]);
    if ( (crcs[0] == buf[length]  ) && 
         (crcs[1] == buf[length+1]) ) {
        *len = datalen+MODVARMGSOVHD+MODCRCLEN;
        return TRUE;
    }
    return FALSE;
}  



/*                                                                             
**      check_line_activity                                                     
**                                                                             	
*/
static	int check_line_activity (unsigned short line, unsigned short predelay )

    {
	long		thistime;
	short		status;

	if (predelay != 0)
	{
	    taskDelay (predelay);
	}
	thistime = tickGet ();
	if ((thistime - activity_time [line]) < ACTIVITYTIME)
	{
	    return (lastactivity [line] || (line_activity [line]));
	}
	lastactivity [line] = status = line_activity [line];
	line_activity [line] = FALSE;
	activity_time [line] = thistime;
	return (status);
}

/*                                                                         	
**      start_tx                                                            	
**                                                                          	
**      The purpose of this routine is to initialize a line table           	
**      for send and to enable the transmitter.                              	
**                                                                            	
*/
static	void start_tx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )
{

	TXLINE		*txp;

	disable_tx_ints (link[line]);
	txp = txlinetab [line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */


	enable_tx_ints (link[line]);

}
/*
**      stop_tx                                                                	
**                                                                             	
**      The purpose of this routine is to initialize a line table              	
**      for receive and to disable the receiver.                               	
**                                                                             	
*/


static	void stop_tx (unsigned short line )

    {
	TXLINE		*txp;

	disable_tx_ints (link[line]);
	txp = txlinetab [line];
	txp->txdisable = TRUE;
    }

/*                                                                           	
**      tx_int_proc                                                           	
**                                                                            	
**      The purpose of this routine is to process a transmit character interrupt
**      for a given line.                                                  	
**                                                                         	
*/


static	int tx_int_proc (unsigned short line )

{
    char                    txchar;
    unsigned short          txstat;
    unsigned short          tx_err_mask;
    TXLINE                  *txp;

    linestats [line].TXintcount++;

    txp = txlinetab [line];
    if (txp->txdisable)
    {
        return 0;
    }
    if (txp->txix == txp->txmsglen)
    {
        txp->txdisable = TRUE;
        disable_tx_ints (link[line]);
        *(txp->status) = TXGOOD;
        semGive (txp->semid);
        return 0;
    } else {
        txchar = txp->txbuf [txp->txix++];
        write_tx_hw (link[line], txchar, &txstat, &tx_err_mask);
        if ((txstat & tx_err_mask) != 0 ) {
            txp->txdisable = TRUE;
            disable_tx_ints (link[line]);
            *(txp->status) = TXBAD;
            semGive (txp->semid);
            return 0;
        }
    }

    if (txp->txix >= MAXTXMSG) {
        txp->txdisable = TRUE;
        disable_tx_ints (link[line]);
        *(txp->status) = TXBAD;
        semGive (txp->semid);
        return 0;
    }
    return 0;
}


/*                                                                         	
**      getandprocess (line)                                                              	
**                                                                           	
**      The purpose of this routine is to wait for message in the buffer,
**      and to process the message and send a response. The routine will return to 
**      the caller between every message or after 1 second, whichever comes first
*/
static void getandprocess (unsigned short line)
{

    RXLINE          *rxp;
    unsigned short  ix,rxlen;

    rxp = rxlinetab [line];
    rxlen = rxp->rxmsglen;

    if (semTake (semids [line] [RXSEM], (int) (RXTIMEOUT)) != ERROR) {
        /* Print out the message if trace is on */
        if ((trace [line] & ALLTRAFFICTRACE) &&
            ((traceadr [line] == rxp->rxbuf [MSGADDR]) || (traceadr [line] == 255)) &&
            ((tracetype [line] == rxp->rxbuf [MSGFUNC]) || (tracetype [line] == 255))) {
                printf("RX:");
                for (ix = 0; ix < 26; ix++) { /* 26 is maximum RX message length */
                    if (ix < rxlen) {
                        printf("_%2x", rxp->rxbuf [ix]);
			  } else {
                        printf("...");
                    }
                } 
	          printf("\n");
        }
        linestats [line].msgxfercount++;
        processmessage (line,rxp->rxbuf [MSGADDR]);
    }
    return;
}

/*                                                                         	
**      processmessage (line,address)                                                              	
**                                                                           	
**      The purpose of this routine is to wait for message in the buffer,
**      and to process the message and send a response. The routine will return to 
**      the caller between every message or after 1 second, whichever comes first
*/
static void processmessage (unsigned short line, unsigned short address)
{

    RXLINE          *rxp;
    TXLINE          *txp;
    unsigned short  txstatus,txlen,ix;
    MODPLC  *pmod;

    pmod = plcs[line][address];


    rxp = rxlinetab [line];
    txp = txlinetab [line];
    switch (rxp->rxbuf[MSGFUNC]) {

        case MODCOILREAD:
            modreadcoil(line,address);
            break;
        case MODDIREAD:
            modreaddi(line,address);
            break;
        case MODREGREAD:
            modreadreg(line,address);
            break;
        case MODAIREAD:
            modreadai(line,address);
            break;
        case MODCOILWRITE:
            modwritecoil(line,address);
            break;
        case MODREGWRITE:
            modwritereg(line,address);
            break;
        case MODLOOPBACK:
            modloopback(line,address);
            break;
        case MODMCOILWRITE:
            modwritecoils(line,address);
            break;
        case MODMREGWRITE:
            modwriteregs(line,address);
            break;
        default:
            return;
            break;
    }

    /* Transmit out the response
    *    The data and the length are in the transmit buffer
    */

    set_rts (link[line]);
    set_dtr (link[line]);

    if (pretxdelay [line] != 0) {
        taskDelay (pretxdelay [line]);
    }

    txstatus = IO_TIMEOUT;

    semTake (semids [line] [TXSEM], NO_WAIT);
    start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */

    if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR) {
        txstatus = IO_TIMEOUT;
    }

    stop_tx (line);

    if (posttxdelay [line] != 0) {
        taskDelay (posttxdelay [line]);
    }

    /* Slaves turn off the transmitter */
    clear_rts (link[line]);

    /* May be a redundancy issue here */
    clear_dtr (link[line]);

    /* If there was a transmit error process it here */
    if (txstatus != TXGOOD) {
 
        if ((txstatus == IO_TIMEOUT) && (modtrace [line])) {
            logMsg ("Transmit Timeout\n", 0,0,0,0,0,0);
            pmod->no_txnoresp++;
        } else {
            if (modtrace [line]) {
                logMsg ("Transmit Error\n", 0,0,0,0,0,0);
            }
            pmod->no_txhwerrs++;
        }
        return;
    }

    txlen = txp->txmsglen;

    if ((trace [line] & ALLTRAFFICTRACE) &&
        ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
        ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255))) {
            printf ("TX:");
            for (ix = 0; ix < 12 ; ix++) {   /* 12 is maximum TX message length */
                if (ix < txlen) {
                    printf("_%2x", txp->txbuf [ix]);
                } else {
                    printf ("...");
                }
            } 
            printf ("\n");
    }

    return;
}
/*
* modreadcoil ( line,address)
*
*	Process a message for a read coil request 
*     put the response and the length in the transmit structure
*/
static void modreadcoil(unsigned short line, unsigned short address)
{
    MODPLC		*pmod;


    pmod = plcs [line] [ address ];
    modreadbinary( line, address, MODCOILREAD, NUMCOILS, pmod->coils);

}
/*
* modreaddi ( line,address)
*
*	Process a message for a read binary request 
*     put the response and the length in the transmit structure
*/
static void modreaddi(unsigned short line, unsigned short address)
{
    MODPLC		*pmod;


    pmod = plcs [line] [ address ];
    modreadbinary( line, address, MODDIREAD, NUMDINS, pmod->dis);

}
/*
* modreadbinary(line, mod, function, maxcount, dataaddr)
*
*     The function of this routine is to validate that the request is valid
*     Prepare a error response if necessary
*     Prepare a data response in the transmit buffer
*	Set the response length
*/
static void modreadbinary( unsigned short line, unsigned short mod, unsigned short function,
				   unsigned short maxcount, unsigned char *dataaddr)

{
    unsigned short	length, addr, byteaddr, shift, val, i;
    RXLINE          *rxp;
    TXLINE          *txp;
    MODPLC	    *pmod;


    pmod = plcs [line] [ mod ];

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    addr = (rxp->rxbuf[MSGSTARTHI] << 8) + (rxp->rxbuf[MSGSTARTLO]);
    length = (rxp->rxbuf[MSGLENHI] << 8) + (rxp->rxbuf[MSGLENLO]);
    if ( ((addr+length) > maxcount  ) ||
         ((length/8) > (MAXTXMSG-8) ) ) {
        txp->txbuf [0] =  mod;
        txp->txbuf [1] =  function | FNCERRBIT;
        txp->txbuf [2] =  MODEXCEPTADR;
        makecrc (&(txp->txbuf [0]), NAKMSGLEN, &(txp->txbuf [NAKMSGLEN]));
        txp->txmsglen = NAKMSGLEN+2;
        pmod->no_dataerr++;
        return;
    }

    pmod->no_datain_msgs++;

    byteaddr = (addr+7)/8;

    /* format a data response message */
    txp->txbuf [0] =  mod;
    txp->txbuf [1] =  function;
    txp->txbuf [2] =  (length+7)/8;

    shift = addr % 8;
    for ( i=0; ( i < ((length+7)/8) ); i++) {
        val = dataaddr[byteaddr+i+1];
        val = (val << 8) + dataaddr[byteaddr+i];
        val = (val >> shift) & 0xff;
        txp->txbuf [3+i] =  val;
    }
    makecrc (&(txp->txbuf [0]), (3+((length+7)/8)), &(txp->txbuf [(3+((length+7)/8))]));
    txp->txmsglen = (3+((length+7)/8))+2;
    return;
}



/*
* modreadreg ( line,address)
*
*	Process a message for a read register request 
*     put the response and the length in the transmit structure
*/
static void modreadreg(unsigned short line, unsigned short address)
{
    MODPLC		*pmod;


    pmod = plcs [line] [ address ];
    modreadanalog( line, address, MODREGREAD, NUMREGS, pmod->regs);

}
/*
* modreadai ( line,address)
*
*	Process a message for a read analog request 
*     put the response and the length in the transmit structure
*/
static void modreadai(unsigned short line, unsigned short address)
{
    MODPLC		*pmod;


    pmod = plcs [line] [ address ];
    modreadanalog( line, address, MODAIREAD, NUMAINS, pmod->ais);

}
/*
* modreadanalog(line, mod, function, maxcount, dataaddr)
*
*     The function of this routine is to validate that the request is valid
*     Prepare a error response if necessary
*     Prepare a data response in the transmit buffer
*	Set the response length
*/
static void modreadanalog( unsigned short line, unsigned short mod, unsigned short function,
				   unsigned short maxcount, unsigned short *dataaddr)

{
    unsigned short  length, addr, val, i;
    RXLINE          *rxp;
    TXLINE          *txp;
    MODPLC		*pmod;


    pmod = plcs [line] [ mod ];

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    addr = (rxp->rxbuf[MSGSTARTHI] << 8) + (rxp->rxbuf[MSGSTARTLO]);
    length = (rxp->rxbuf[MSGLENHI] << 8) + (rxp->rxbuf[MSGLENLO]);
    if ( ((addr+length) > maxcount) ||
         ((length*2) > (MAXTXMSG-8)) ) {
        txp->txbuf [0] =  mod;
        txp->txbuf [1] =  function | FNCERRBIT;
        txp->txbuf [2] =  MODEXCEPTADR;
        makecrc (&(txp->txbuf [0]), NAKMSGLEN, &(txp->txbuf [NAKMSGLEN]));
        txp->txmsglen = NAKMSGLEN+2;
        pmod->no_dataerr++;
        return;
    }

   pmod->no_datain_msgs++;

   /* format a data response message */
    txp->txbuf [0] =  mod;
    txp->txbuf [1] =  function;
    txp->txbuf [2] =  length*2;

    for ( i=0; ( i < length ); i++) {
        val = dataaddr[addr+i];
        txp->txbuf [3+(i*2)] =  (val >> 8) & 0xff;
        txp->txbuf [3+(i*2)+1] =  val & 0xff;
    }
    makecrc (&(txp->txbuf [0]), (3+(length*2)), &(txp->txbuf [(3+(length*2))]));
    txp->txmsglen = (3+(length*2))+2;

    return;
}

/*
* modwriteregs(line, mod)
*
*     The function of this routine is to validate that the request is valid
*     Prepare a error response if necessary
*     Store the data
*     Prepare a data response in the transmit buffer
*	Set the response length
*/
static void modwriteregs( unsigned short line, unsigned short mod)

{
    unsigned short  length, addr, val, i;
    RXLINE          *rxp;
    TXLINE          *txp;
    MODPLC		*pmod;


    pmod = plcs [line] [ mod ];

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    addr = (rxp->rxbuf[MSGSTARTHI] << 8) + (rxp->rxbuf[MSGSTARTLO]);
    length = (rxp->rxbuf[MSGLENHI] << 8) + (rxp->rxbuf[MSGLENLO]);
    if  ((addr+length) > NUMREGS)  {
        txp->txbuf [0] =  mod;
        txp->txbuf [1] =  MODMREGWRITE | FNCERRBIT;
        txp->txbuf [2] =  MODEXCEPTADR;
        makecrc (&(txp->txbuf [0]), NAKMSGLEN, &(txp->txbuf [NAKMSGLEN]));
        txp->txmsglen = NAKMSGLEN+2;
        pmod->no_dataerr++;
        return;
    }

    pmod->no_dataout_msgs++;

    /* Store the data */
    for ( i=0; ( i < length ); i++) {
        val = rxp->rxbuf[MODWRITEMREGHLEN+(i*2)];
        val = (val << 8) + rxp->rxbuf[MODWRITEMREGHLEN+(i*2)+1];
        pmod->regs[addr+i] = val;
        pmod->regsvalid[addr+i] = TRUE;
    }

    /* format a data response message */
    for (i=0;(i<MODSETMREGRESPLEN);i++) {
        txp->txbuf [i] = rxp->rxbuf [i];
    } 

    makecrc (&(txp->txbuf [0]), MODSETMREGRESPLEN, &(txp->txbuf[MODSETMREGRESPLEN]));
    txp->txmsglen = MODSETMREGRESPLEN+2;

    return;
}
/*
* modwritereg(line, mod)
*
*     The function of this routine is to validate that the request is valid
*     Prepare a error response if necessary
*     Store the data
*     Prepare a data response in the transmit buffer
*	Set the response length
*/
static void modwritereg( unsigned short line, unsigned short mod)

{
    unsigned short  addr, val, i;
    RXLINE          *rxp;
    TXLINE          *txp;
    MODPLC		*pmod;


    pmod = plcs [line] [ mod ];

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    addr = (rxp->rxbuf[MSGSTARTHI] << 8) + (rxp->rxbuf[MSGSTARTLO]);
    if  (addr > NUMREGS)  {
        txp->txbuf [0] =  mod;
        txp->txbuf [1] =  MODREGWRITE | FNCERRBIT;
        txp->txbuf [2] =  MODEXCEPTADR;
        makecrc (&(txp->txbuf [0]), NAKMSGLEN, &(txp->txbuf [NAKMSGLEN]));
        txp->txmsglen = NAKMSGLEN+2;
        pmod->no_dataerr++;
        return;
    }

    pmod->no_dataout_msgs++;

    /* Store the data */
    val = rxp->rxbuf[MODWRITEHDRLEN];
    val = (val << 8) + rxp->rxbuf[MODWRITEHDRLEN+1];
    pmod->regs[addr] = val;
    pmod->regsvalid[addr] = TRUE;

    /* format a data response message */
    for (i=0;(i<MODSETMREGRESPLEN);i++) {
        txp->txbuf [i] = rxp->rxbuf [i];
    } 

    makecrc (&(txp->txbuf [0]), MODSETREGRESPLEN, &(txp->txbuf[MODSETREGRESPLEN]));
    txp->txmsglen = MODSETREGRESPLEN+2;

    return;
}

/*
* modwritecoils(line, mod)
*
*     The function of this routine is to validate that the request is valid
*     Prepare a error response if necessary
*     Prepare a data response in the transmit buffer
*	Set the response length
*/
static void modwritecoils( unsigned short line, unsigned short mod)

{
    unsigned short  length, byteaddr, addr, val, i, shift;
    RXLINE     *rxp;
    TXLINE     *txp;
    unsigned   char mask, trimmask;
    MODPLC     *pmod;

    pmod = plcs [line] [ mod ];

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    addr = (rxp->rxbuf[MSGSTARTHI] << 8) + (rxp->rxbuf[MSGSTARTLO]);
    length = (rxp->rxbuf[MSGLENHI] << 8) + (rxp->rxbuf[MSGLENLO]);
    if ( ((addr+length) > NUMCOILS) ||
         ((length/8) > (MAXTXMSG-8)) ) {
        txp->txbuf [0] =  mod;
        txp->txbuf [1] =  MODMCOILWRITE | FNCERRBIT;
        txp->txbuf [2] =  MODEXCEPTADR;
        makecrc (&(txp->txbuf [0]), NAKMSGLEN, &(txp->txbuf [NAKMSGLEN]));
        txp->txmsglen = NAKMSGLEN+2;
        pmod->no_dataerr++;
        return;
    }

    pmod->no_dataout_msgs++;

    byteaddr = (addr+7)/8;
    shift = (addr % 8);

    /* Store the data */
    for ( i=0; ( i < ((length+7)/8) ); i++) {
        val = rxp->rxbuf[MODWRITEMCOILHLEN+i];
        val = (val << 8) + rxp->rxbuf[MODWRITEMCOILHLEN+i-1];
        mask = trimmask = 0xff;
        /* Need to or in bits of partial 1st byte */
        if (i==0) {
            mask = mask << (addr % 8);
        }
        /* Need to or in bits of partial last byte */   
        if (i == (((length+7)/8)-1) ) {
            trimmask = trimmask >> ((addr+length)%8);
            mask = mask & trimmask;
        }
        val = ((val << shift) >> 8) & 0xff;
        val = rxp->rxbuf[MODWRITEMCOILHLEN+(i*2)];
        pmod->coils[byteaddr+i] &= ~mask;
        pmod->coils[byteaddr+i] |= (val & mask);
        pmod->coilsvalid[byteaddr+i] = TRUE;
    }

    /* format a data response message */
    for (i=0;(i<MODMSETCOILRESPLEN);i++) {
        txp->txbuf [i] = rxp->rxbuf [i];
    } 

    makecrc (&(txp->txbuf [0]), MODMSETCOILRESPLEN, &(txp->txbuf[MODMSETCOILRESPLEN]));

    txp->txmsglen = MODSETCOILRESPLEN+2;

    return;
}
/*
* modwritecoil(line, mod)
*
*     The function of this routine is to validate that the request is valid
*     Prepare a error response if necessary
*     Prepare a data response in the transmit buffer
*	Set the response length
*/
static void modwritecoil( unsigned short line, unsigned short mod)

{
    unsigned short  byteaddr, addr, coilval, i;
    RXLINE     *rxp;
    TXLINE     *txp;
    unsigned   char mask;
    MODPLC     *pmod;

    pmod = plcs [line] [ mod ];

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    addr = (rxp->rxbuf[MSGSTARTHI] << 8) + (rxp->rxbuf[MSGSTARTLO]);
    coilval = (rxp->rxbuf[MODWRITEHDRLEN] << 8) + (rxp->rxbuf[MODWRITEHDRLEN]);
    if (addr > NUMCOILS) {
        txp->txbuf [0] =  mod;
        txp->txbuf [1] =  MODCOILWRITE | FNCERRBIT;
        txp->txbuf [2] =  MODEXCEPTADR;
        makecrc (&(txp->txbuf [0]), NAKMSGLEN, &(txp->txbuf [NAKMSGLEN]));
        txp->txmsglen = NAKMSGLEN+2;
        pmod->no_dataerr++;
        return;
    }

    pmod->no_dataout_msgs++;

    byteaddr = (addr+7)/8;
    mask = (1 << (addr % 8));

    /* Store the data */
    if (coilval == 0) {
        pmod->coils[byteaddr] &= ~mask;
    } else {
        pmod->coils[byteaddr] |= mask;
    }
    pmod->coilsvalid[byteaddr] = TRUE;


    /* format a data response message */
    for (i=0;(i<MODSETCOILRESPLEN);i++) {
        txp->txbuf [i] = rxp->rxbuf [i];
    } 

    makecrc (&(txp->txbuf [0]), MODMSETCOILRESPLEN, &(txp->txbuf[MODMSETCOILRESPLEN]));

    txp->txmsglen = MODMSETCOILRESPLEN+2;

    return;
}

/*
*        modloopback(line,address);
*            The purpose of this routine is to respond to a diagnostic loop
*            back message. All other diagnostic inquireies will be nacked
*/
static void modloopback( unsigned short line, unsigned short address)
{

    unsigned short  diagsubfunc, i;
    RXLINE          *rxp;
    TXLINE          *txp;
    MODPLC          *pmod;

    pmod = plcs [line] [ address ];

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    diagsubfunc= (rxp->rxbuf[MSGDIAGFUNCHI] << 8) + (rxp->rxbuf[MSGDIAGFUNCLO]);

    if ( diagsubfunc != MLOOPDATAQUERYFUNC){
        txp->txbuf [0] =  address;
        txp->txbuf [1] =  MODLOOPBACK | FNCERRBIT;
        txp->txbuf [2] =  MODEXCEPTFNC;
        makecrc (&(txp->txbuf [0]), NAKMSGLEN, &(txp->txbuf [NAKMSGLEN]));
        txp->txmsglen = NAKMSGLEN+2;
        pmod->no_dataerr++;
        return;
    }

    /* format a data response message */
    for (i=0;(i<MODLOOPBACKLEN);i++) {
        txp->txbuf [i] = rxp->rxbuf [i];
    } 

    makecrc (&(txp->txbuf [0]), MODLOOPBACKLEN, &(txp->txbuf[MODLOOPBACKLEN]));

    txp->txmsglen = MODLOOPBACKLEN+2;

    return;
}




/*
**      init_plc_tab
**
**      The purpose of this routine is to initialize the line tables for the
**      analog devices I/O
**
*/


static	void init_plc_tab (unsigned short line, unsigned short mod)

{
	MODPLC  *pmod;

	pmod = plcs [line] [mod];
	if (!pmod)
	{
		return;
	}
	pmod->holdflag = FALSE;	
	pmod->was_requested = FALSE;
	pmod->cmd_force_offline = FALSE;

	initplc (pmod);
	initstats (pmod);
}
/*
** Cold Init a PLC
**
*/


static void initplc (MODPLC  *pmod)

{

	unsigned short	i;

                                                               	
/*                                                              	
**      COILS ARE INITIALIZED AS READ WRITE VALUES              	
**      WRITES ARE TREATED BY INDIVIDUAL BITS NOT GROUPS       		
**              - NOT REQUESTED                                		
**              - READ BACK NOT VALID                             	
**              - NO NEW VALUES TO GO                                	
*/

	for (i = 0; (i < (NUMCOILS/8)); i++)
	{
	    pmod->coilsdef [i] = FALSE;
	    pmod->coilsvalid[i] = FALSE;
	    pmod->coils [i] = 0;
	}

/*                                                                 	
**      DIGITALS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID		
*/
	for (i = 0; (i < (NUMDINS/8)); i++)
	{
	    pmod->dinsdef [i] = FALSE;
	    pmod->dinsvalid [i] = FALSE;
	}

/*                                                                 	
**      ANALOG INS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID    	
*/
	for (i = 0; (i < NUMAINS); i++)
	{
	    pmod->ainsdef [i] = FALSE;
	    pmod->ainsvalid [i] = FALSE;
	}

/*                                                             		
**      REGISTERS ARE INITIALIZED AS READ WRITE VALUES             	
**      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS      	
**              - NOT REQUESTED                                    	
**              - READ BACK NOT VALID                              	
**              - NO NEW VALUES TO GO                               	
*/                                                                  	
	for (i = 0; (i < NUMREGS); i++)
	{
	    pmod->regsdef [i] = FALSE;
	    pmod->regsvalid [i] = FALSE;
	    pmod->regs [i] = 0;
	}

}

/*                                                            		
**                                                              	
** initialize the statistics for a modicon PLC                  	
**                                                              	
*/                                                               	


static	void initstats (MODPLC *pmod)

{
	pmod->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
	pmod->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
	pmod->no_txnoresp = 0;      /* 8  Count No Responses 		*/
	pmod->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
	pmod->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
}




/*                                                                           	
**     prepresponses
**                                                                             	
**      The purpose of this routine is to mark the PLCs as on hold and the    	
**	data as not valid until read again from the PLC                       	
**                                                                           	
*/

static	void prepresponses (unsigned short line)

{
	unsigned short	mod;
	MODPLC		*pmod;

	for (mod = 1; (mod <= NUMMODPLCS); mod++)
	{
            pmod = plcs [line] [mod];
	    if (pmod)				/* verify pointer validity prior to use */
	    {
	    	pmod->holdflag = FALSE;         /* Was FALSE HERE but not decided yet what to do */
		mark_not_valid (pmod);
            }
	}
}



/*                                                                           	
** makecrc 									
**                                                                        	
*/

static	void makecrc (unsigned char *chkbuf, int len,char unsigned *retbuf)

    {
	unsigned short	checksum;
	unsigned int    i, j;
	unsigned short  flag;
	unsigned char   tempch;

	checksum = 0x0ffff;
	for (j = 0; j < len; j++)
	{
	    tempch = chkbuf [j];
	    checksum ^= tempch;
	    for (i = 0; i < 8; i++)
	    {
		flag = checksum & 1;
		checksum >>= 1;
		if (flag)
		{
		    checksum ^= (unsigned short) 0x0a001;
		}
	    }
	}
	retbuf [1] = ((checksum >> 8) & 0xff);
	retbuf [0] = (checksum & 0xff);
}

/*
**      modslvdumpmsgcnts
**
**      The purpose of this routine is to dump the line level statistics for this driver. 
**
*/

void modslvdumpmsgcnts (unsigned short line)

    {
        unsigned long  x, y, e, z;


 	x = linestats [line].TXintcount;
	y = linestats [line].RXintcount;
	e = linestats [line].RXbadcount;
	z = linestats [line].msgxfercount;

        if (z == 0)
        {
            printf ("TX Interrupt Count    = %10ld\n", x);
            printf ("RX Interrupt Count    = %10ld\n", y);
            printf ("BadRX Intrpt Count    = %10ld\n", e);
            printf (" ******  No Messages Transferred ****** \n");
            return;
        }

        return;
}

/*
**      modslvclearmsgcnts
**
**      The purpose of this routine is to dump and clear the line level statistics
**      for this driver.
**
*/

void modslvclearmsgcnts (unsigned short line)

{
        modslvdumpmsgcnts (line);

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].RXbadcount = 0;
	linestats [line].msgxfercount = 0;

        linestats [line].startingtick = tickGet ();
	printf (" ******  All Counts Cleared  ****** \n");
 	printf ("\n");
        return;
}


/*
**      modslvdumpplcstats
**
**      The purpose of this routine is to dump the plc level statistics for this driver.  
**
*/

void modslvdumpplcstats (unsigned short line, unsigned short maddr)
{
    MODPLC		*pmod;

    pmod = plcs [line] [maddr];
    if (!pmod)
    {
        logMsg ("Line/ModbusAddress Not Defined \n", 0,0,0,0,0,0);
        return;
    }

    printf (" Was requested = %d \n", pmod->was_requested);
    printf (" Is responding = %d \n", pmod->is_responding);
    printf (" # Output messages = %d \n", pmod->no_dataout_msgs & 0x7fff);
    printf (" # Data in messages = %d \n", pmod->no_datain_msgs & 0x7fff);
    printf (" #No Tx Responses = %d \n", pmod->no_txnoresp & 0x7fff);
    printf (" #Data Errors = %d \n", pmod->no_dataerr & 0x7fff);
    printf (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs & 0x7fff);
    printf (" Reset Statistics = %d \n", pmod->cmd_reset_stat);
    printf (" Force Offline = %d \n", pmod->cmd_force_offline);

    printf ("\n");

    printf (" Resource Responding = %d \n", resresponse[line]);
    printf (" Hold flag  = %d \n", pmod->holdflag );
    return;
}

/*
**      modslvclearplcstats
**
**      The purpose of this routine is to clear the plc level statistics for this driver. 
**
*/

void modslvclearplcstats (unsigned short line, unsigned short maddr)

    {
	MODPLC		*pmod;

	pmod = plcs [line] [maddr];
	if (!pmod)
	{
	    logMsg ("Line/ModbusAddress Not Defined \n", 0,0,0,0,0,0);
	    return;
	}

	initstats (pmod); /* use existing procedure */

        return;
    }


/*
**      dump_modslv_table                                                       	
**                                                                           	
**      The purpose of this routine is twofold:                                 
**         1) dump the plc level statistics for the modbus driver.              
**         2) dump the data for the specified modbus plc.                       
**                                                                              
*/

void dump_modslv_table (unsigned short line, unsigned short maddr)

    {

MODPLC      *pmod;
unsigned    short	i, n; 

    unsigned    short       addr, linecnt;
    unsigned    char        buffer [200];
    unsigned    short       skip,s;

    pmod = plcs [line] [maddr];
    if (!pmod)
    {
        logMsg("Line/ModbusAddress Not Defined \n", 0,0,0,0,0,0);
        return;
    }

    /* previously integral code moved to seperate procedure for debugging convenience */
    modslvdumpplcstats (line, maddr);


    linecnt = 1;
    printcoilhdr (buffer, linecnt);
    addr = 1;
    for (i = 0; i < (NUMCOILS/8); i += 4)
    {

        skip = TRUE;
        for (s = 0; s < 4; s++) {
            if (pmod->coilsdef[i+s]) {
                skip = FALSE;
                break;
            }
        }
        if (skip) {
    	      addr += 32;		
            continue;
        }
			
        printf("  %4d    ", addr);

        for (n = 0; n < 4; n++)
        {		
            printf("%1x,  %1x,         %1x,\t",
                          pmod->coilsdef[i+n],
                          pmod->coilsvalid[i+n],
                          pmod->coils[i+n]);
        }
        printf ("\n");
        linecnt += 1;
        if ( (linecnt >= 17) && ((i + 4)  < (NUMCOILS/8)) )
        {
            linecnt = 1;
            printcoilhdr(buffer, linecnt);
        }
        addr += 32;		
    }

    linecnt = 1;
    printdihdr (buffer, linecnt);
    addr = 1;

    for (i = 0; i < (NUMDINS/8); i += 4) {

        skip = TRUE;
        for (s = 0; s < 4; s++) {
            if (pmod->dinsdef[i+s]) {
                skip = FALSE;
                break;
            }
        }
        if (skip) {
            addr += 32;		
            continue;			
        }

        printf ("  %4d    ", addr);

        for (n = 0; n < 4; n++)
        {		
            printf("%1x,  %1x,         %1x,\t",
                           pmod->dinsdef[i+n],
                           pmod->dinsvalid[i+n],
                           pmod->dis[i+n]);
        }
        printf ("\n");
        linecnt += 1;
        if ((linecnt >= 17) && ((i + 4)  < (NUMDINS/8)) )
        {
            linecnt = 1;
            printdihdr (buffer, linecnt);
        }
        addr += 32;		
    }


    linecnt = 1;
    printaihdr(buffer, linecnt);
    addr = 1;

    for (i = 0; i < NUMAINS; i +=4)
    {
        skip = TRUE;
        for (s = 0; s < 4; s++) {
            if (pmod->ainsdef[i+s]) {
                skip = FALSE;
                break;
            }
        }
        if (skip) {
            addr += 4;		
            continue;
        }

        printf ("  %4d\t", addr);

        for (n = 0; n < 4; n++ )
        {		
            printf ("\t%1x, %1x,\t%6d,\t", pmod->ainsdef[i+n], pmod->ainsvalid[i+n], pmod->ais[i+n]);
        }
        printf("\n");
        linecnt += 1;
        if ((linecnt >= 17) && ((i + 4)  < NUMAINS) )
        {
            linecnt = 1;
            printaihdr (buffer, linecnt);
        }
        addr += 4;		
    }

    linecnt = 1;
    printreghdr (buffer, linecnt);
    addr = 1;
    for (i = 0; i < NUMREGS; i += 4)
    {
        skip = TRUE;
        for (s = 0; s < 4; s++) {
            if (pmod->regsdef[i+s]) {
                skip = FALSE;
                break;
            }
        }
        if (skip) {
            addr += 4;		
            continue;
        }

        printf("  %4d\t", addr);

        for (n = 0; n < 4; n++)
        {
            printf("\t%1x, %1x,\t%6d,\t", pmod->regsdef[i+n], pmod->regsvalid[i+n], pmod->regs[i+n]);
        }
        printf ("\n");
        linecnt += 1;
        if ((linecnt >= 17) && ((i + 8)  < NUMREGS) )
        {
            linecnt = 1;
            printreghdr (buffer, linecnt);
        }
        addr += 4;		
    }
}

/*
*/


static void printcoilhdr (unsigned char *buffer, unsigned short cnt)
{	
    taskDelay (120);
    printf ("\n");
    sprintf (buffer,"                                                    PLC REPORT         ");
    printf ( "%s\n", buffer);
    cnt += 1;
    printf ("\n");
    cnt += 1;
    sprintf (buffer,"                                                   MODBUS COILS        ");
    printf ( "%s\n", buffer);
    cnt += 1;
    sprintf (buffer,
               "          R   V      Value\tR   V      Value\tR   V      Value\tR   V      Value");
    printf ( "%s\n", buffer);
    cnt += 1;
}
/*
*/


static void printdihdr (unsigned char *buffer, unsigned short cnt)
{
    taskDelay (120);
    printf ("\n");
    sprintf (buffer,"                                                    PLC REPORT         ");
    printf ( "%s\n", buffer);
    cnt += 1;
    printf ("\n");
    cnt += 1;
    sprintf (buffer,"                                              MODBUS DIGITAL INPUTS        ");
    printf ( "%s\n", buffer);
    cnt += 1;
    sprintf (buffer,
                "          R   V      Value\tR   V      Value\tR   V      Value\tR   V      Value");
    printf ( "%s\n", buffer);
    cnt += 1;
}
/*
*/


static void printaihdr(unsigned char *buffer, unsigned short cnt)
{
    taskDelay (120);
    printf ("\n");
    sprintf (buffer,"                                               PLC REPORT         ");
    printf ( "%s\n", buffer);
    cnt += 1;
    printf ("\n");
    cnt += 1;
    sprintf (buffer,"                                            MODBUS ANALOG INPUTS        ");
    printf ( "%s\n", buffer);
    cnt += 1;
    sprintf (buffer,"\t\tR  V\tValue\t\tR  V\tValue\t\tR  V\tValue\t\tR  V\tValue");
    printf ( "%s\n", buffer);
    cnt += 1;
}

/*
*/


static void printreghdr (unsigned char *buffer, unsigned short cnt)
{
    taskDelay (120);
    printf ("\n");
    sprintf (buffer,"                                               PLC REPORT         ");
    printf ( "%s\n", buffer);
    cnt += 1;
    printf ("\n");
    cnt += 1;
    sprintf (buffer,"                                             MODBUS REGISTERS        ");
    printf ( "%s\n", buffer);
    cnt += 1;
    sprintf (buffer,"\t\tR  V\tValue\t\tR  V\tValue\t\tR  V\tValue\t\tR  V\tValue");
    printf ( "%s\n", buffer);
    cnt += 1;

}
/*                                                               		
**                                                                	 	
**	The purpose of this routine is to display the contents            	
**	of the static variables contained within this driver.             	
**                                                                        	
*/



int modslvlineinfo ()
{
    short    i;
    char     buffer [132];
    char     *resrsp;
    char     *lineact;


    printf ("                                 Modbus Line Information Table          \n");
    printf ("\n");
    printf (" Line        Pointer to        Resource      Resource");
    printf ("       Line        Delay Times:       Activity\n");
    printf ("Number      MODPLC Table         Name        Response");
    printf ("     Activity      IM  .TX  TX.         Time\n");
    printf ("\n");

    for (i = 0; i < MODLINES; i++)
    {
        if(plcs [i] == NULL)
        {
            continue;
        }
        if (resresponse [i] == 0)
        {
            resrsp = "FALSE";
        }
        else
        {
            resrsp = "TRUE";
        }
        if (line_activity [i] == 0)
        {
            lineact = "FALSE";
        }
        else
        {
            lineact = "TRUE";
        }
        sprintf (buffer,
                 "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4ld\n",
                 i, (int) plcs[i], resnames[i],
                 &resrsp[0],
                 &lineact[0],
                 intermsgdelay[i],
                 pretxdelay[i],
                 posttxdelay[i],
                 activity_time[i]);
        printf ( "%s\n", buffer);
    }
    return 0;
}

/* Temporary Test routines */

int tsetai (unsigned short link, unsigned short adapter,
		unsigned short signal, unsigned short value )
{
    MODPLC 		*pmod;

    if (link > MODLINES) {
            logMsg("tsetai: Illegal line: L=%d, A=%d, S=%d, V=%d\n",
                    link, adapter, signal, value ,0,0 );
            return (-1);
    }

    if (adapter > NUMMODPLCS) {
            logMsg("tsetai: Illegal adapter:L=%d, A=%d, S=%d, V=%d\n",
                    link, adapter, signal, value ,0,0 );
            return (-1);
    }


    pmod = plcs [link] [adapter];
    if (pmod == NULL) {
        if (!allocate_plc (link, adapter)) {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = plcs [link] [adapter];
    }
    if ((signal-1) >= NUMAINS) {
            logMsg("tsetai: Illegal signal: L=%d, A=%d, S=%d, V=%d\n",
                    link, adapter, signal, value ,0,0 );
            return (-1);
    }

    
    pmod->ais[signal-1] = value;
    pmod->ainsdef[signal-1] = TRUE;
    pmod->ainsvalid[signal-1] = TRUE;

    return (0);

}

int tsetreg (unsigned short link, unsigned short adapter,
		unsigned short signal, unsigned short value )
{
    MODPLC 		*pmod;

    if (link > MODLINES) {
            logMsg("tsetreg: Illegal line: L=%d, A=%d, S=%d, V=%d\n",
                     link, adapter, signal, value ,0,0 );
            return (-1);
    }

    if (adapter > NUMMODPLCS) {
            logMsg("tsetreg: Illegal adapter: L=%d, A=%d, S=%d, V=%d\n",
                     link, adapter, signal, value ,0,0 );
            return (-1);
    }


    pmod = plcs [link] [adapter];
    if (pmod == NULL) {
        if (!allocate_plc (link, adapter)) {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = plcs [link] [adapter];
    }
    if ((signal-1) >= NUMREGS) {
            logMsg("tsetreg: Illegal signal: L=%d, A=%d, S=%d, V=%d\n",
                    link, adapter, signal, value ,0,0 );
            return (-1);
    }

    
    pmod->regs[signal-1] = value;
    pmod->regsdef[signal-1] = TRUE;
    pmod->regsvalid[signal-1] = TRUE;

    return (0);

}

int tsetdin (unsigned short link, unsigned short adapter,
		unsigned short signal, unsigned short value )
{
    MODPLC 		*pmod;

    if (link > MODLINES) {
            logMsg("tsetdin: Illegal line: L=%d, A=%d, S=%d, V=%d\n",
                    link, adapter, signal, value ,0,0 );
            return (-1);
    }

    if (adapter > NUMMODPLCS) {
            logMsg("tsetdin: Illegal adapter: L=%d, A=%d, S=%d, V=%d\n",
                    link, adapter, signal, value ,0,0 );
            return (-1);
    }


    pmod = plcs [link] [adapter];
    if (pmod == NULL) {
        if (!allocate_plc (link, adapter)) {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = plcs [link] [adapter];
    }
    if ((signal-1) >= NUMDINS) {
            logMsg("tsetdin: Illegal signal: L=%d, A=%d, S=%d, V=%d\n",
                    link, adapter, signal, value ,0,0 );
            return (-1);
    }

    if (value)
        pmod->dis[(signal-1)/8] |= ( 1 << ((signal-1) % 8) );
    else 
        pmod->dis[(signal-1)/8] &= ~( 1 << ((signal-1) % 8) );
 
    pmod->dinsdef[(signal-1)/8] = TRUE;
    pmod->dinsvalid[(signal-1)/8] = TRUE;

    return (0);

}
int tsetcoil (unsigned short link, unsigned short adapter,
		unsigned short signal, unsigned short value )
{
    MODPLC 		*pmod;

    if (link > MODLINES) {
            logMsg("tsetcoil: Illegal line: L=%d, A=%d, S=%d, V=%d\n",
                    link, adapter, signal, value ,0,0 );
            return (-1);
    }

    if (adapter > NUMMODPLCS) {
            logMsg("tsetcoil: Illegal adapter: L=%d, A=%d, S=%d, V=%d\n",
                    link, adapter, signal, value ,0,0 );
            return (-1);
    }


    pmod = plcs [link] [adapter];
    if (pmod == NULL) {
        if (!allocate_plc (link, adapter)) {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        pmod = plcs [link] [adapter];
    }
    if ((signal-1) >= NUMCOILS) {
            logMsg("tsetcoil: Illegal signal: L=%d, A=%d, S=%d, V=%d\n",
                    link, adapter, signal, value ,0,0 );
            return (-1);
    }

    if (value)
        pmod->coils[(signal-1)/8] |= ( 1 << ((signal-1) % 8) );
    else 
        pmod->coils[(signal-1)/8] &= ~( 1 << ((signal-1) % 8) );
 
    pmod->coilsdef[(signal-1)/8] = TRUE;
    pmod->coilsvalid[(signal-1)/8] = TRUE;

    return (0);

}


/*	End of File:	drvModiconslv.c */
