/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*  File: drvSecurity_proto.h
/*  Edit:  7/20/95      WEP: original version.
/*                         :
*/

static	long init ();

	void TRACEON (unsigned short line);

	void TRACEOFF (unsigned short line);

	void TRAFFICON (unsigned short line);

	void TRAFFICOFF (unsigned short line);

	void RTRACE (unsigned short line, 
		     unsigned short level);

	void RTRACEON (unsigned short line);

	void RTRACEOFF (unsigned short line);

	void TRACELEVEL (unsigned short line, 
			 unsigned short level);

        void CONTRACEON (unsigned short line);

        void CONTRACEOFF (unsigned short line);

        void RUNTRACEON (unsigned short line);

        void RUNTRACEOFF (unsigned short line);

        void REJECTTRACEON (unsigned short line);

        void REJECTTRACEOFF (unsigned short line);

        void NACKTRACEON (unsigned short line);

        void NACKTRACEOFF (unsigned short line);

        void DEFAULTTRACE (unsigned short line);

	void ERRORTRACE (unsigned short line);

	int STOPDRIVER (short ln);

        int STARTDRIVER (unsigned short line,
                         char *mode,
                         unsigned short delay,
                         unsigned short private);

	void SETCOMM (unsigned short line,
                      unsigned short tickcount1);

	void MAIN (unsigned short line,
                   unsigned char *mode,
                   unsigned short delay,
                   unsigned short private);

static 	void on_line (unsigned short line);

static	void scan_terminal (unsigned short line);

static	void checkoutputs (unsigned short line);

	int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, short *pvalue,
	    unsigned short conversion, unsigned char *resname);

	int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned long mask,
	    unsigned long *pvalue, unsigned char *resname);

	int BODRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned long value,
	    unsigned long mask, unsigned char *resname);

	int BOREAD (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned long *pvalue,
	    unsigned long mask, unsigned char *resname);

        int SIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
            unsigned short card, unsigned short signal, char *pvalue,
            unsigned short len, unsigned char *resname);

        int SODRIVER (char *pointname, unsigned short link, unsigned short adapter,
            unsigned short card, unsigned short signal, unsigned char *value,
            unsigned short len, unsigned char *resname);

static void  register_resource (unsigned short link, 
				unsigned char *resname, 
				char *pointname);

static	void outqueinit (unsigned short line);

static	OUTQENT *ogetemptyp (unsigned short line);

static	void omarkfull (unsigned short line);

static	OUTQENT *ogetnextp (unsigned short line);

static	void oreleasefull (unsigned short line);

static	void link_status (unsigned short line);

static 	int allocate_security (unsigned short line);

static	void start_rx (unsigned short line);

static	void stop_rx (unsigned short line );

static	void rx_int_proc (unsigned short line );

static	void start_tx (unsigned short line, 
		       SEMAPHORE *semid, 
		       unsigned short *pstatus);

static	void stop_tx (unsigned short line );

static	void tx_int_proc (unsigned short line );

static	unsigned short msgxfer (unsigned short line);

static	void init_security_tab (unsigned short line);

static 	void initsecurity (unsigned short line);

static	void initstats (unsigned short line);

static	void prepresponses (unsigned short line);

static	unsigned short setbinary (unsigned short line,
		       unsigned short bitaddr, unsigned long mask,
		       unsigned long val);

static	unsigned short setanalog (unsigned short line,
		       unsigned short regaddr, unsigned short val,
		       double dblval, unsigned short conv);

static  unsigned short setstring (unsigned short, 
				  unsigned short, 
				  unsigned char *, 
				  unsigned short);

        void DUMPMSGCNTS (unsigned short line);

        void CLEARMSGCNTS (unsigned short line);

        void DUMPPLCSTATS (unsigned short line);

        void CLEARPLCSTATS (unsigned short line);

static  int  checkCh (unsigned short);

static  unsigned char getCh (unsigned short);

static  unsigned short putCh (unsigned short, unsigned char);

static  unsigned short putStr (unsigned short, unsigned char *);

static  int  valid_id (unsigned short, int *);

static  int  valid_passwd (unsigned short);

static  void reset_new_login (unsigned short);

static  void checkoutmsgs (unsigned short, SECURITY *);

static  int loaduserfile (unsigned short);

static  void terminateload (LOADUSER *,
			    unsigned short,
			    unsigned short);

static  int get_timeout (LOADUSER *,
			 unsigned short *);

static  int get_string (LOADUSER *,
			char *,
			unsigned char *);


static  void eatspaces (char *,
			FILE *);

static  void eatline (FILE *);

void    SecShowUser (unsigned short);

static  void SecPrtHdr (unsigned short *);

/* End of File:     drvSecurity_proto.h */


