/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


extern TS_STAMP	time_stamp;	/* defined in .../share/src/time/ts_drive.c */

static void scan_terminal (line)
{
    SECURITY		*psec;
    LOADUSER		*puserlist;
    char		tsStampText[128];
    char		*p;
    unsigned char	currChar;
    unsigned long	current_clk_ticks;
    unsigned long	delta_ticks;
    int			need_password;

    psec = security[line];
    puserlist = userlist[line];

    psec->tscanpass++;
    if (mltrace[line] == 2)
    {
	logMsg ("Scanning Terminal\n");
    }

    checkoutputs (line);
    tsStampToText (&time_stamp, TS_TEXT_MONDDYYY, tsStampText);
    if ((p = strchr (tsStampText, '.')) != NULL)
	*p = NULL;
    current_clk_ticks = tickGet ();

    if (psec -> logonstatus == SEC_LOGGED_ON)
    {
	if (checkCh (line))
	{
	    currChar = getCh (line);
	    if ((currChar == 'Y') || (currChar == 'y'))
	    {
		strncpy (psec -> logoffstamp, tsStampText, 
					      sizeof (psec -> logofftime));
		psec -> logonstatus = SEC_LOGGED_OFF;
		putStr (line, SEC_ID_PROMPT);
		reset_new_login (line);
		return;
	    }
	}
	delta_ticks = current_clk_ticks - psec -> last_clk_ticks;
	psec -> logontime += delta_ticks;
	if (psec -> logontime >= puserlist -> timeout)
	{
	    strncpy (psec -> logoffstamp, tsStampText, sizeof (psec -> logofftime));
	    psec -> logonstatus = SEC_TIMED_OUT;
	    putStr (line, SEC_ID_PROMPT);
	    reset_new_login (line);
	    return;
	}
    }
    else
    {
	switch (psec -> login_state)
	{
	    case SEC_LOGIN_ID:
		/* is there a character */
		if (checkCh (line))
		{
		    currChar = getChar (line);
		    switch (currChar)
		    {
			case '\n':
			case '\r':
			    psec -> idx++;
			    psec -> newuserid[psec -> idx] = 0;
			    if ( (valid_id (line, &need_password)) == SEC_INVALID_ID)
			    {
				psec -> baduseridcnt++;
				reset_new_login (line);
				putStr (line, SEC_ILLEGAL_ID_MSG);
				putStr (line, SEC_ID_PROMPT);
				break;
			    }
			    if (need_password)
			    {
				putStr (line, SEC_PASSWD_PROMPT);
				psec -> login_state = SEC_PASSWORD;
			    }
			    else
			    {
				psec -> newpasswd[0] = '*';
				psec -> newpasswd[1] = 0;
				psec- > login_state = SEC_LOGIN_FINISH;
			    }
			    break;
			default:
			    psec -> idx++;
			    if (psec -> idx >= MAXUSERIDLEN)
			    {
				reset_new_login (line);
				putStr (line, SEC_LOGNAME_TO_LONG_MSG);
				putStr (line, SEC_ID_PROMPT);
			    }
			    else
			    {
				/* echo the character back to the terminal */
				putCh (line, currChar);
				psec -> last_clk_ticks = current_clk_ticks;
				psec -> newuserid[psec -> idx] = the character;
			    }
			    break;
		    }
		}
		/* someone is trying to log on */
		else
		{
		    if (psec -> idx >= 0)
		    {
			delta_ticks = current_clk_ticks - psec -> last_clk_ticks;
			if ( (psec -> last_clk_ticks + delta_ticks) > SEC_CHAR_TIMEOUT)
			{
			    reset_new_login (line);
			    putStr (line, SEC_INPUT_TIMEOUT_MSG);
			    putStr (line, SEC_ID_PROMPT);
			}
		    }
		}
		break;

	    case SEC_PASSWD_ID:
		if (checkCh (line))
		{
		    currChar = getCh (line);
		    switch (currChar)
		    {
			case '\n':
			case '\r':
			    psec -> idx++;
			    psec -> newpasswd[psec -> idx] = 0;
			    psec -> login_state = SEC_LOGIN_FINISH;
			    break;
			default:
			    psec -> idx++;
			    if (psec -> idx >= MAXPASSLEN)
			    {
				reset_new_login (line);
				putStr (line, SEC_LOGNAME_TO_LONG_MSG);
				putStr (line, SEC_ID_PROMPT);
			    }
			    else
			    {
				psec -> last_clk_ticks = current_clk_ticks;
				psec -> newuserid[psec -> idx] = the character;
			    }
			    break;
		    }
		}
		/* someone is trying to enter a password */
		else
		{
		    if (psec -> idx >= 0)
		    {
			delta_ticks = current_clk_ticks - psec -> last_clk_ticks;
			if ( (psec -> last_clk_ticks + delta_ticks) > SEC_CHAR_TIMEOUT)
			{
			    reset_new_login (line);
			    putStr (line, SEC_INPUT_TIMEOUT_MSG);
			    putStr (line, SEC_ID_PROMPT);
			}
		    }
		}
		break;

	    case SEC_LOGIN_FINISH:
		if ( (valid_passwd (line) == SEC_VALID_LOGIN))
		{
		    psec -> last_clk_ticks = current_clk_ticks;
		    strncpy (psec -> logonstamp, tsStampText, sizeof (psec -> logonstamp));
		    strncpy (psec -> userid, psec -> newuserid, sizeof (psec -> userid));
		    psec -> logonstatus = SEC_LOGGED_ON;
		    output SEC_LOGOFF_PROMPT msg
		}
		else
		{
		    psec -> badpasswordcnt++;
		    putStr (line, SEC_INVALID_PASSWD_MSG);
		    putStr (line, SEC_ID_PROMPT);
		}
		reset_new_login (line);
		break;
	}
    }

    return;
}

static void reset_new_login (line)
    unsigned short	line;
{
    SECURITY	*psec;

    psec = security[line];

    bzero (psec -> newuserid, sizeof (psec -> newuserid));
    bzero (psec -> newpasswd, sizeof (psec -> newpasswd));
    psec -> login_state = SEC_LOGIN_ID;
    psec -> idx = -1;
    return;
}

static int valid_id (line, need_password)
    unsigned short	line;
    int			*need_password;
{
    SECURITY	*psec;
    LOADUSER	*puserlist;
    USER	*puser;

    psec = security[line];
    puserlist = userlist[line];
    if (puserlist -> firstuser == NULL)
	return (SEC_INVALID_ID);
    puser = puserlist -> firstuser;
    while (puser)
    {
	if ((strncmp (puser -> userid, psec -> newuserid, sizeof (puser -> userid))) == NULL)
	{
	    if (puser -> password[0] == '*')
		*need_password = 0;
	    else
		*need_password = 1;
	    return (SEC_VALID_ID);
	}
	puser = puser -> nextuser;
    }
    return (SEC_INVALID_ID);
}

static int valid_passwd (line)
    unsigned short	line;
{
    SECURITY	*psec;
    LOADUSER	*puserlist;
    USER	*puser;

    psec = security[line];
    puserlist = userlist[line];
    if (puserlist -> firstuser == NULL)
	return (SEC_INVALID_PASSWD);

    puser = puserlist -> firstuser;
    while (puser)
    {
	if ((strncmp (puser -> userid, psec -> newuserid, sizeof (puser -> userid))) == NULL)
	{
	    if (strncmp (puser -> password, psec -> newpasswd, sizeof (puser -> password))
		return (SEC_VALID_LOGIN)
	    else
		return (SEC_INVALID_PASSWD);
	}
	puser = puser -> nextuser;
    }
    return (SEC_INVALID_PASSWD);
}

static int checkCh (line)
    unsigned short	line;
{
    SECURITY	*psec;

    psec = security[line];

    return (0);
}

static unsigned char getCh (line)
    unsigned short	line;
{
    SECURITY		*psec;
    unsigned char	currChar;

    psec = security[line];

    return (currChar);
}

static void putCh (line, ch)
    unsigned short	line;
    unsigned char	ch;
{
    SECURITY	*psec;

    psec = security[line];

    return;
}

static void putStr (line, str)
    unsigned short	line;
    char		*str;
{
    SECURITY	*psec;

    psec = security[line];

    return;
}


