/*drvTankway.c,v 1.1.1.1 1999/08/03 14:44:58 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File: drvTankway.c
**  Edit:  7/21/97      WEP: created driver                                          
**        12/18/97	WEP: added support for reading tank level in both formats    
**
*/

#define  VERSIONNUM     20                    /* NOTE: change here */

#define  MAIN           tank_driver           /* NOTE: change here */
#define  AIDRIVER       tank_aidriver         /* NOTE: change here */
#define  AODRIVER       tank_aodriver         /* NOTE: change here */
#define  AOREAD         tank_aoread           /* NOTE: change here */
#define  BIDRIVER       tank_bidriver         /* NOTE: change here */
#define  BODRIVER       tank_bodriver         /* NOTE: change here */
#define  BOREAD         tank_boread           /* NOTE: change here */

#define  TRAFFICON      tanktrafficon         /* NOTE: change here */
#define  TRAFFICOFF     tanktrafficoff        /* NOTE: change here */
#define  TRAFFIC        tanktraffic           /* NOTE: change here */
#define  TRACEON        tanktraceon           /* NOTE: change here */
#define  TRACEOFF       tanktraceoff          /* NOTE: change here */
#define  RTRACE         tankrestrlv           /* NOTE: change here */
#define  RTRACEON       tankrestraceon        /* NOTE: change here */
#define  RTRACEOFF      tankrestraceoff       /* NOTE: change here */
#define  TRACELEVEL     tanktrlv              /* NOTE: change here */
#define  CONTRACEON     tankcontraceon        /* NOTE: change here */
#define  CONTRACEOFF    tankcontraceoff       /* NOTE: change here */
#define  RUNTRACEON     tankruntraceon        /* NOTE: change here */
#define  RUNTRACEOFF    tankruntraceoff       /* NOTE: change here */
#define  REJECTTRACEON  tankrejecttraceon     /* NOTE: change here */
#define  REJECTTRACEOFF tankrejecttraceoff    /* NOTE: change here */
#define  DEFAULTTRACE   tankdefaulttrace      /* NOTE: change here */

#define  HELP           tankhelp              /* NOTE: change here */
#define  SIMON          tanksimon             /* NOTE: change here */
#define  SIMOFF         tanksimoff            /* NOTE: change here */

#define  STOPDRIVER     stoptankway           /* NOTE: change here */
#define  STARTDRIVER    starttankway          /* NOTE: change here */
#define  SETCOMM        tankcomm              /* NOTE: change here */
#define  SHOWINFO       tankinfo              /* NOTE: change here */

#define  DUMPMSGCNTS    tankdumpmsgcnts       /* NOTE: change here */
#define  CLEARMSGCNTS   tankclearmsgcnts      /* NOTE: change here */
#define  DUMPPLCSTATS   tankdumpstats         /* NOTE: change here */
#define  CLEARPLCSTATS  tankclearstats        /* NOTE: change here */

#define  TABLEINFO      tanktable             /* NOTE: change here */
#define  LINEINFO       showlineinfo          /* NOTE: change here */


#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
/*#include <module_types.h>*/
#include <drvTankway.h>			  /* NOTE: change here */
#include <drvTankway_proto.h> 		  /* NOTE: change here */
#include <restable.h>


/* static long	init(); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvTankway={ 2,	NULL, init};

/*
**      External Line Level Data Structures (declared in drvcommon.c)
**
*/
extern	unsigned char	resnames [TANKLINES] [RESNAMELEN]; /* array of resource name strings.		*/

extern	RES_TABLE	*prestable [TANKLINES];		/* array of pointers to resource tables 	*/

extern	unsigned short	resresponse [TANKLINES];	/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

extern	unsigned short	line_activity [TANKLINES];	/* true/false line active flag. calculated	*/
							/* using activity_time below. 			*/
extern	unsigned short	lastactivity [TANKLINES];	/* assigned value of line_activity prior to	*/
							/* it's recalculation.   			*/

extern	unsigned short	modtrace [TANKLINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/
extern	unsigned short	mltrace [TANKLINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/
extern	unsigned short	modrestrace [TANKLINES];	/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/

extern	SEM_ID		semids [TANKLINES] [2];		/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

extern	unsigned short	intermsgdelay [TANKLINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/
extern	unsigned short	pretxdelay [TANKLINES];		/* holds post RTS delay before TX. 		*/
extern	unsigned short	posttxdelay [TANKLINES];	/* holds post TX delay before dropping RTS. 	*/

extern	long		activity_time [TANKLINES];	/* holds timetick of last activity. used to	*/
							/* set line_activity flag  			*/

extern  unsigned short  halfduplex [TANKLINES];         /* store half/full duplex line status           */

extern  unsigned short  pstatewait [TANKLINES];         /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */


/*
**      Storage for Tankway Comm Line Structures
**
*/

static RXLINE          *rxlinetab [TANKLINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL,} ; /* array of pointers to dynamically           */
                                        /* allocated comm controls/buffers            */

static TXLINE          *txlinetab [TANKLINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL,} ; /* array of pointers to dynamically           */
                                        /* allocated comm controls/buffers            */

/*
**      Storage for Tankway PLC Structures
**
*/
static unsigned short   pryvate [TANKLINES];             /* 0 = redundant mode,   !0=private mode      */

static unsigned int     modsim [TANKLINES];              /* 0 = normal operation, 1 = unit simulation.  */

static unsigned int	simdelay [TANKLINES];

static 		int	simlow [TANKLINES];

static 		int	simhigh [TANKLINES];

static		int	simdigon [TANKLINES];

static unsigned int     tick [TANKLINES][5];

static unsigned int     lastscan [TANKLINES];            /* holds timestamp of beginning of major loop.  */

static unsigned int     scantime [TANKLINES];            /* holds actual time taken to scan units.        */

static unsigned int     loopoutmsgs [TANKLINES];

static unsigned int     loopmsgs [TANKLINES];

static LINESTATS	linestats [TANKLINES];		/* array of line level statistics.              */

static TANKWAY		*units [TANKLINES] [NUMUNITS];  /* two dimensional array of pointers to the     */
                                                        /* fixed length dynamically allocated Unit      */
                                                        /* control and data structures.                 */

static  unsigned short  trace [TANKLINES];              /* controls output of system error messages:    */
                                                        /* bit mapped controls                          */
static  unsigned char   traceadr [TANKLINES];
static  unsigned char   tracetype [TANKLINES];

static char		user [40], password [40];	/* holds id and password of the user that       */
                                                        /* spawned the driver task required by host to  */
                                                        /* check file read privileges on PLC load files */


static  unsigned short  options [TANKLINES];            /* store half/full duplex line status           */

static char    *bools [] = {
	"TRUE ",
	"FALSE"
    };

static int		taskId [TANKLINES];

static char *tasknames [] = {"TANKWAY Ch0", "TANKWAY Ch1", "TANKWAY Ch2", "TANKWAY Ch3",
                             "TANKWAY Ch4", "TANKWAY Ch5", "TANKWAY Ch6", "TANKWAY Ch7",
                             "TANKWAY Ch8", "TANKWAY Ch9", "TANKWAY Ch10","TANKWAY Ch11",
                             "TANKWAY Ch12","TANKWAY Ch13","TANKWAY Ch14","TANKWAY Ch15",
                             "TANKWAY Ch16","TANKWAY Ch17","TANKWAY Ch18","TANKWAY Ch19",
                             "TANKWAY Ch20","TANKWAY Ch21","TANKWAY Ch22","TANKWAY Ch23",
                             "TANKWAY Ch24","TANKWAY Ch25","TANKWAY Ch26","TANKWAY Ch27",
                             "TANKWAY Ch28","TANKWAY Ch29","TANKWAY Ch30","TANKWAY Ch31"
                           };

static unsigned char graytable [256] =
{/*   0 */   0,   1,   3,   2,   7,   6,   4,   5,  15,  14,  12,  13,   8,   9,  11,  10,
 /*  16 */  31,  30,  28,  29,  24,  25,  27,  26,  16,  17,  19,  18,  23,  22,  20,  21,
 /*  32 */  63,  62,  60,  61,  56,  57,  59,  58,  48,  49,  51,  50,  55,  54,  52,  53,
 /*  48 */  32,  33,  35,  34,  39,  38,  36,  37,  47,  46,  44,  45,  40,  41,  43,  42,
 /*  64 */ 127, 126, 124, 125, 120, 121, 123, 122, 112, 113, 115, 114, 119, 118, 116, 117,
 /*  80 */  96,  97,  99,  98, 103, 102, 100, 101, 111, 110, 108, 109, 104, 105, 107, 106,
 /*  96 */  64,  65,  67,  66,  71,  70,  68,  69,  79,  78,  76,  77,  72,  73,  75,  74,
 /* 112 */  95,  94,  92,  93,  88,  89,  91,  90,  80,  81,  83,  82,  87,  86,  84,  85,
 /* 128 */ 191, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 /* 144 */ 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 /* 160 */ 190, 255, 189, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 /* 176 */ 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255, 255,
 /* 192 */ 128, 129, 131, 130, 135, 134, 132, 133, 143, 142, 140, 141, 136, 137, 139, 138,
 /* 208 */ 159, 158, 156, 157, 152, 153, 155, 154, 144, 145, 147, 146, 151, 150, 148, 149,
 /* 224 */ 255, 255, 188, 255, 184, 185, 187, 186, 176, 177, 179, 178, 183, 182, 180, 181,
 /* 240 */ 160, 161, 163, 162, 167, 166, 164, 165, 175, 174, 172, 173, 168, 169, 171, 170};


/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
{
	return (0);
}

/********
**
**	This routine outputs information to help with debugging.
**
********/
void HELP (void)
{
    printf ("Starting the Tankway Driver:\n");
    printf ("\n");
    printf (" starttankway(N,C,t1,f,t2,t3,P)                                                  \n");
    printf ("                     N:  start the driver on line N.                            \n");
    printf ("                     C:  communications parameter string (comma delimited ascii)\n"); 
    printf ("                     t1: intermessage delay (in ticks)                          \n");
    printf ("                     f:  half duplex flag. 1=half duplex mode, 1!=full duplex   \n");
    printf ("                     t2: post RTS assert, pre TX delay (in ticks)               \n");
    printf ("                     t3: post TX, pre RTS drop delay (in ticks)                 \n");
    printf ("                     P:  Private flag.  0 = Redundant, 1 = Non-Redundant        \n");
    printf ("                                                                                \n");
    printf (" Example: starttankway(2,\"9600,N,8,1\", 2,1,4,0)                                \n");
    printf ("                                                                                \n");
    printf ("                                                                                \n");
    printf ("  (v%d)                                                             \n", VERSIONNUM);
    printf ("\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" Tankway Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" tanktraceon(N)         Enable the following debug messages for line N:             \n");
    printf ("                          1) Major Scan loop Info:                                  \n");
    printf ("                            scan time, total output messages, and total messages.   \n"); 
    printf ("                          2) Output Queue Overflow.                                 \n");
    printf ("                          3) All communication errors encountered in msgxfer.       \n");
    printf ("*tanktraceoff(N)        Disable all of the tanktraceon debug messages for line N.   \n");
    printf ("\n");
    printf (" tankrestrace(N,X)      Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*tankrestraceon(N)      Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" tankrestraceoff(N)     Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" tankcontraceon(N)      Enable display of configuration errors in driver calls.     \n");
    printf ("*tankcontraceoff(N)     Disable display of configuration errors in driver calls.    \n");
    printf (" tankruntraceon(N)      Enable display of runtime errors (queue overflow).          \n");
    printf ("*tankruntraceoff(N)     Disable display of runtime errors (queue overflow).         \n");
    printf (" tankrejecttraceon(N)   Enable display of driver call rejections in driver calls.   \n");
    printf ("*tankrejecttraceoff(N)  Disable display of driver call rejections in driver calls.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" tanktrlv(N,X)          Enable the following message for line N:                    \n");
    printf ("                          X=0,  display none of the messages below.                 \n");
    printf ("                          X=1,  beginning of unit scan loop, bringing units online. \n");
    printf ("                          X=2,  beginning of unit scan.                             \n");
    printf ("                          X=3 to 7,  reserved.                                      \n");
    printf ("                          X=8,  AIDRIVER, AOREAD: normal call return.               \n");
    printf ("                          X=9,  BIDRIVER, BOREAD: normal call return.               \n");
    printf ("                          X=10 to 254,  reserved.                                   \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" tanktrafficon(N)       Enable traffic tracing for all unit addresses               \n");
    printf ("                          and all tankway functions on line N.                      \n");
    printf ("*tanktrafficoff(N)      Disable all traffic tracing on line N.                      \n");
    printf (" tanktraffic(N,X,Y)     Modifies line N traffic tracing as follows:                 \n");
    printf ("                          X=0   disables tracing of all addresses.                  \n");
    printf ("                          X=255 enables tracing of all addresses.                   \n");
    printf ("                          0 < X < 255 enables tracing of address X traffic.         \n");
    printf ("                         Y=0   disables tracing of all tankway functions.           \n");
    printf ("                         Y=255 enables tracing of all tankway functions.            \n");
    printf ("                          0 < Y < 255 enables tracing of function Y traffic.        \n");
    printf ("\n");
    printf (" tankdefaulttrace(N)    Restores default setting for all traces.                    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" tanksimon(N,D,L,H,T)   Enables the simulation of responding units.                 \n");
    printf ("                         D: simulation interval (in seconds). if D<1 or D>60, D=60. \n");
    printf ("                         L: low value of analog simulation range.                   \n");
    printf ("                         H: high value of analog simulation range.                  \n");
    printf ("                         T: 0 = digital inputs are zero. 1 = digitial inputs toggle.\n");
    printf ("*tanksimoff(N)          Disables simulation, thus enabling normal driver function.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" tankinfo(N)            Display startup and current state information.              \n");
    printf (" tankcomm(N,t1,f,t2,t3) Set communication timing parameters for line N as follows:  \n");
    printf ("                          t1: intermessage delay (in ticks).                        \n");
    printf ("                           f: 0 = full duplex, 1 = half duplex.                     \n");
    printf ("                          t2: post RTS assert, pre TX delay (in ticks).             \n");
    printf ("                          t3: post TX, pre RTS drop delay (in ticks).               \n");
    printf ("\n");
    printf (" tankdumpmsgcnts(N)     Display line N communication statistics.                     \n");
    printf (" tankclearmsgcnts(N)    Display and clear line N communication statistics.           \n");
    printf (" tankdumpstats(N,X)     Display line N, unit X, communication statistics.            \n");
    printf (" tankclearstats(N,X)    Display and clear line N, unit X, xfers, status & errors.    \n");
    printf (" tanktable(N,X)         Display line N, unit X, xfers, status, errors and input data.\n");
}


/********
**
**	This routine enables logging of comm trace messages
**
********/
void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/********
**
**	This routine disables logging of comm trace messages
**
********/
void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFIC (unsigned short line, unsigned char add, unsigned type)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = add;
        tracetype [line] = type;
        return;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFICON (unsigned short line)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = 255;  /* every address */
        tracetype [line] = 255; /* every message type */
}

/********
**
**	This routine disables detailed display of normal communications traffic
**
********/
void TRAFFICOFF (unsigned short line)
{
	trace [line] = trace [line] & ~ALLTRAFFICTRACE;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACE (unsigned short line, unsigned short level)
{
	modrestrace [line] = level;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACEON (unsigned short line)
{
	modrestrace [line] = 1;
}

/********
**
**	This routine disables logging of resource trace messages
**
********/
void RTRACEOFF (unsigned short line)
{
	modrestrace [line] = 0;
}

/********
**
**	This routine controls logging of trace messages
**
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}

/********
**
**	This routine enables the simulation of responding units, reading all input values as zero.
**
********/
void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable)
{
	if ((delay < 1) || (delay > 60))
	{
	    simdelay [line] = 60;
	}
	else
	{
	    simdelay [line] = delay;
	}
	if (low > high)
	{
	    simhigh [line] = low;
	    simlow [line] = high;
	}
	else
	{
	    simlow [line] = low;
	    simhigh [line] = high;
	}
	modsim [line] = TRUE;
	simdigon [line] = digenable;
}

/********
**
**	This routine disables simulation, thus enabling normal driver function.
**
********/
void SIMOFF (unsigned short line)
{
	modsim [line] = FALSE;
}

/********
**
**	These routines enable and disable tracing of database configuration errors in driver calls
**
********/
void CONTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }
void CONTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }

/********
**
**	These routines enable and disable tracing of runtime errors in driver calls
**
********/
void RUNTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }
void RUNTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/********
**
**	These routines enable and disable tracing of call rejection errors in driver calls
**
********/
void REJECTTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }
void REJECTTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }


/********
**
**	This routine restores default setting for all traces.
**
********/
void DEFAULTTRACE (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = 1;
        trace [line] = 0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
    }
/********
**
**	This routine turns on all error tracing.
**
********/
void tankerrortrace (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = TRUE;
	modrestrace [line] = 2;
	trace[line] = MODBUSNACKTRACE ||
                      CONFIGURATIONTRACE ||
                      RUNTIMEERRORTRACE ||
                      CALLREJECTTRACE ||
                      0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
    }


int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER (unsigned short line,      /* the line number of this driver.                      */
                 char *mode,               /* UART initializations string (comma delimited ascii). */
                 unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                 unsigned short hdflag,    /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                 unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                 unsigned short delay2,    /* half duplex post TX, pre RTS drop delay.             */
                 unsigned short private)   /* private flag. if 0, normal. if !0, no partner driver.*/

{
	if (line < TANKLINES)
	{
	    taskId [line] = taskSpawn (tasknames [line],
                                     TANK_PRIORITY,
                                     TANK_TASK_OPTIONS,
                                     TANK_STACK,
                                     MAIN,
                                     line,
                                     mode,
                                     delay,
                                     hdflag,
                                     delay1,
                                     delay2,
                                     private);

	    logMsg ("Started the Tankway driver on line %d\n", line);

	    remCurIdGet (user,password);
	    return (1);
	}
	else
	{

	    logMsg ("Invalid line number %d\n", line);
	    return (-1);
	}
}

/********
**
** Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
	halfduplex [line]    = hdflag;
	pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}

/********
**
** Show Driver Info and Current State Information */ 
**
********/
void SHOWINFO (unsigned short line)
{
    printf ("intermsgdelay [%d]  = %d\n", line, intermsgdelay[line]);
    printf ("halfduplex [%d]     = %d\n", line, halfduplex[line]);
    printf ("pretxdelay [%d]     = %d\n", line, pretxdelay[line]);
    printf ("posttxdelay [%d]    = %d\n", line, posttxdelay[line]);
    printf ("pryvate [%d]        = %d\n", line, pryvate[line]);
    printf ("resresponse [%d]    = %d\n", line, resresponse[line]);
    printf ("activity_time [%d]  = %d\n", line, activity_time[line]);
    printf ("line_activity [%d]  = %d\n", line, line_activity[line]);
    printf ("lastactivity [%d]   = %d\n", line, lastactivity[line]);
    printf ("modtrace [%d]       = %d\n", line, modtrace[line]);
    printf ("mltrace [%d]        = %d\n", line, mltrace[line]);
    printf ("modrestrace [%d]    = %d\n", line, modrestrace[line]);
    printf ("trace [%d]          = %d\n", line, trace[line]);
}


/*                                                                         
**      tankway_driver                                                     
**                                                                         
**      The purpose of this task is to scan the tankway unit lines. It     
**      will maintain a configuration list supporting online additions     
**      and replacement of modules, and maintain a table of most recently  
**      scanned values.                                                    
**                                                                         
*/                                                                                     	
/* not called from within this driver 	*/

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2,
           unsigned short private)
{
	unsigned short  unit, cfgchk, cnt, unitspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command, i;
	long	        this_time, last_time;
	TANKWAY         *punit;
	RXLINE          *rxp;
        unsigned int    temptick, tempdiff;
        int             temp;


/* Initialize the data structures */
	intermsgdelay [line] = delay;
	halfduplex [line]  = hdflag;
	pretxdelay [line]  = delay1;
	posttxdelay [line] = delay2;
        pryvate [line]     = private;

	resresponse [line] = FALSE;
	resnames [line] [0] = 0;
	prestable [line] = NULL;

	activity_time [line] = tickGet ();
	lastactivity [line] = line_activity [line] = FALSE;
        pstatewait[line] = 60;      /* will wait up to one minute for partner to become valid */

        /* debug structures */
/*        tankdebugtrace (line); */
        tankdefaulttrace (line);

        tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].RXbadcount = 0;
	linestats [line].msgxfercount = 0;
        linestats [line].startingtick = tickGet ();

        modsim [line] = FALSE;              /* start with normal operation. */

        /* communication initialization */
	rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
	if (!rxlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
	    return;
	}
	txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
	if (!txlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
	    return;
	}

        taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */
	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
        taskUnlock ();

	onlinefreq = 1;	  /* causes on_line calls to begin on first pass if master */

	/* Initialize the Rx interrupts to receive once for activity check         */
	/* enable the receiver interrupt after set to ignore                       */
	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);

        /* Initialize the line communication semaphores */
        semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
        semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);

	/* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
	while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
	{
            if (modrestrace [line] > 1)
	    {
	    	logMsg ( "No Resource Defined for line - %d \n", line);
	    }
	    taskDelay (600);
	}

        if (pryvate [line])
        {
            /*****************************/
	    /* Immediately become master */
            /*****************************/

	    resSetCaAnswer (prestable [line]);
	    resPutLocalState (prestable [line], RES_MSTR);

            lastscan [line] = tickGet ();
            scantime [line] = 0;

	    lstate = RES_MSTR;
	    if (modrestrace [line])
	    {
	    	logMsg ("0] Private: Initialize as RES_MSTR\n");
	    }
        }
        else /* this is the 'normal' path */
        {
            /**********************/
            /* Start out as slave */

            resClearCaAnswer (prestable [line]);		/* start quiet */
            resPutLocalState (prestable [line], RES_SLV);

            if (modrestrace [line])
            {
                logMsg ("1] Initialized as RES_SLV\n");
            }

            /* wait finite time for pstate to be resolved */
            logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
            for (i = 0; i <= pstatewait [line]; i++)
            {
                resGetStates (prestable [line], &lstate, &pstate);
                if (pstate != 0)
                {
	            break;
                }
                taskDelay (60);
            }
            if (pstate == 0)
            {
                logMsg ("Timeout of pstate wait.\n");
            }
            else
            {
                logMsg ("Completion of pstate wait.\n");
            }

            for (i = 0; i < ACTIVITYTIME/10; i++) ;  /* ten seconds */
            {
                taskDelay(10);
            }

            activity = check_line_activity(line, 0);
            resGetStates (prestable [line], &lstate, &pstate);

            /******************************************/
            /* if the partner is not there, be master */
            if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
            {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lastscan [line] = tickGet ();
                scantime [line] = 0;

                lstate = RES_MSTR;
                if (modrestrace [line])
                {
                    logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
                }
            }
        }

	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet (); /* Initialize the time  */

	while (TRUE)
	{
	    activity_time [line] = tickGet ();
	    lastactivity [line] = line_activity [line] = FALSE;

            /********************************************************************************************/
	    /* we arrive here because we are a slave.                                                   */
	    /* we stay until:   asked to be master by partner. if we can reach Units, we become master. */
            /*                  the partner is not master and there is no activity on the line.         */
            /********************************************************************************************/

	    while (lstate == RES_SLV)
	    {
                /* check for unit simulated mode. */
                if (modsim [line])
                {
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
                        logMsg ("Simulation Mode] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
		    }
		    break;
                }

		if (pstate != RES_SLVWANT)
		{
		    clear_rts (line); 				/* make sure line is left for master 	*/
		}
		resresponse [line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand (prestable [line], 0); 		/* clear out commands 			*/
		activity = check_line_activity (line, 10); 	/* wait 10 seconds before checking 	*/
		resGetStates (prestable [line], &lstate, &pstate);

                /****************************************************************************************/
		/* see if needed by partner to be master. if yes, do it and break out of slave state.   */
		if (pstate == RES_SLVWANTCA)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
			logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}
                /***************************************************************/
		/* If partner is there and wants to give it up, try to take it */

		if (pstate == RES_SLVWANT)
		{
		    execute = FALSE;
		    taskDelay (2); /* Time for switch to occur */

		    /* See if anyone is out there and able to respond to a loopback command */
		    for (unit = 0; (unit <= NUMUNITS); unit++)
		    {
			punit = units [line] [unit];
			if ((punit) &&			 /* verify pointer validity prior to use */
			    (punit->was_requested) &&    /* data points have been requested      */
                            (!punit->cmd_force_offline)) /* user has NOT forced unit offline     */
			{
			    on_line (line, unit);
                            /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                            if ((punit->is_responding) && (!punit->cmd_force_offline))
			    {
				execute = TRUE;
				break;
			    }
			}
		    }
		    /* If someone answered, become master and make sure partner really gave it up */
		    if (execute)
		    {
			resPutLocalState (prestable [line], RES_MSTR);
			lstate = RES_MSTR;

                        lastscan [line] = tickGet ();
                        scantime [line] = 0;

			if (modrestrace [line])
			{
				logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			}
			execute = FALSE;
			activity_time [line] = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < 60); i++)
			{
			    activity = check_line_activity (line, 2); /* pause before testing */
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */
			    resPutLocalState (prestable [line], RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace [line])
			    {
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
			    }
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 
			    resSetCaAnswer (prestable [line]);
			    prepresponses (line);
			    break;
			}
		    }
		}

                /********************************************/
		/* if the partner is not talking, be master */

		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
		    }
		    prepresponses (line);
		}
	    }

            /****************************************************************************************/
            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is canceled */
	    while (lstate == RES_SLVWANTCA)
	    {
	        taskDelay (2);                   /* Give OS a chance...  */
		clear_rts (line); 		 /* Make sure line is left for master    */
		resresponse [line] = FALSE; 	 /* Make Sure driver is not responding   */

		resGetStates (prestable [line], &lstate, &pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace [line])
		    {
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}
		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
		    {
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
		    prepresponses (line);
		}
	    }

            /****************************************************************************************/
	    /* in normal operation this code should never execute. it has, however, been seen to    */
            /* execute when the database has been inadvertently configured with the same resource   */
	    /* assigned to two different drivers in the same IOC. The state does funny things.      */
            /****************************************************************************************/
	    while (lstate == RES_SLVWANT)
	    {
                if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))

		{
                    /* condition should NEVER occur. print error message every 5 seconds. */
                    logMsg ("Illegal Local Resource State.\n");
                    if (trace[line] & CONFIGURATIONTRACE)
                    {
                        logMsg ("  Possible Resource Configuration Error:\n");
                        logMsg ("   Check for multiple drivers sharing single Resource.\n");
                    }
                    taskDelay (600);
                }
                taskDelay (2);
            }
            /****************************************************************************************/
            /* we come here because we have gone to, or are looping in, the master state.           */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
	    /* It will then try to configure requested non-responding modules.                      */
            /****************************************************************************************/

	    last_time = tickGet ();		/* initialize gap */
	    while (lstate == RES_MSTR)
	    {
		if (mltrace [line] == 1)
		{
			logMsg ( "Top of Master Loop... \n");
	        }
                /* check for Tankway unit simulated mode. */
                while (modsim [line])
                {
                    resresponse [line] = TRUE; /* Make sure driver is responding. driver        */
                                               /* won't issue commands if not set.              */
		    for (unit = 0; (unit < NUMUNITS); unit++)
		    {
		        punit = units [line] [unit];	/* shorthand pointer 			*/
		        if (punit)			/* verify pointer validity prior to use */
		        {
			    if (punit->cmd_force_offline)
			    { 
				/* if user has turned this unit offline via pseudo commands,    */
                                /* mark it as not responding.                                   */
 				punit->is_responding = FALSE;
	    		    }
			    else
			    {
				sim_unit (punit, line, unit);      /* I/O done here! 		*/
		   		taskDelay (simdelay [line]);			    }
			}
		    }
                }
		/* initial stuff */
		resresponse [line] = TRUE; /* Make sure driver is responding. driver won't      */
                                           /* issue commands if not set.                        */

		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0);        /* clear out commands */

                /************************************************************************/
		/* if relinquish command sent, change state and break out to outer loop */
		if (command == RES_RELINQUISH)
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace [line])
		    {
                       logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}

                /* measure time between scans of the entire set of units. display if requested. */
                temptick = tickGet ();
                tempdiff = temptick - lastscan [line];

                if (modtrace [line])
		{
                    logMsg ("ScanTime: =%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                            scantime[line], loopoutmsgs[line], loopmsgs[line]);
		}

                loopoutmsgs [line] = 0;
                loopmsgs [line] = 0;
                lastscan [line] = temptick;

		/* scan units for data i/o, if allowed */
		unitspolled = 0;

		/* call 'scan_unit' for each PLC device, unless user has */
                /* taken it off line or it is not responding.           */

		for (unit = 0; (unit < NUMUNITS); unit++)
		{
		    punit = units [line] [unit];		/* shorthand pointer 			*/
		    if (punit)				/* verify pointer validity prior to use */
		    {
			if (punit->cmd_force_offline)
			{ 
			    /* if user has turned this unit offline via pseudo commands,     */
                            /* mark it as not responding.                                   */
 			    punit->is_responding = FALSE;
	    		}
			else if (punit->is_responding)
			{
                            /* local/partner lockstep recovery */

                            resGetStates (prestable [line], &lstate, &pstate);
                            if ((pstate == RES_MSTR) && (!pryvate[line]))
                            {
                                resClearCaAnswer (prestable [line]);
                                resPutLocalState (prestable [line], RES_SLV);
                                lstate = RES_SLV;
                                clear_rts (line); 		/* Make sure line is left for master */
                                if (modrestrace [line])
				{
                                    logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
				}
                                temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                                for ( i = 0; i < temp; i++)
                                {
                                   taskDelay(60);
                                }
                                break;
                            }
			    unitspolled++;

			    scan_unit (punit, line, unit);      	/* I/O done here! 		*/
			    if (!punit->is_responding)
			    {
				mark_not_valid (punit);
                            }
			}
		    }
		    /* end of single unit action */

		    /* if told to relinquish our master state, stop unit scanning immediately. */
		    /* don't trash the command, so that we can still read it on the next loop */
                    /* through this while statement.                                          */
		    resGetCommand (prestable [line], &command);
		    if (command == RES_RELINQUISH)
		    {
			break;
		    }
		} /* end of scan loop */

                /* test for lockstep detection. */
                if (lstate != RES_MSTR) break;

                /* measure how long the scan took. to be displayed at beginning of next loop. */
                temptick = tickGet ();
                scantime [line] = temptick - lastscan [line];

		/* try and bring all nonresponding units on line, but */
                /* don't bring in more than a specified number.      */

		cnt = 0;
		if (--onlinefreq == 0) 		/* do we try to bring any in on this pass? */
		{ 
		    onlinefreq = BRINGBACKCNT;
		    for (unit = 0; (unit < NUMUNITS); unit++)
		    {
			cfgchk++;		/* manage unit index */
			if (cfgchk == NUMUNITS)
			{
			    cfgchk=0;	/* wrap unit index */
                        }
			punit = units [line] [cfgchk];
			if ((punit) &&		/* verify pointer validity prior to use*/
			    (!punit->is_responding) &&
			    (punit->was_requested) &&
			    (!punit->cmd_force_offline))
		    	{
			    on_line (line, cfgchk);	/* loopback testing done here! 	*/

			    unitspolled++;
			    cnt++;
                            if (cnt == MAXCFGCK)
			    {
				break;
			    }
			}
		    }
		}

		/* see if anyone on the line has been responding. */
                /* if not, try to get partner to become slave.    */
		/* Check for no one responding */

		if (!any_responding (line) && (!pryvate[line]))
		{
		    /* See if it is time to let partner try */

		    this_time = tickGet ();
		    if ((this_time - last_time) > (3 * SLWWINDOW))
		    {   /* #ticks for slave to try */

			/* Switch States to let partner know it's its time to try */
			resPutLocalState (prestable [line], RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace [line])
			{
			    logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate, activity);
			}
			/* Give partner access to the hardware */
			clear_rts (line);

			/* Remember the time of this try */
			last_time = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < SLWWINDOW); i += 10)
			{       		/* SLWINDOW is the # of ticks for slave to try */
			    taskDelay (10);
		    				/* If partner picked up let it have control */
			    activity = check_line_activity (line, 0);  /* check immediately */
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
			    {
				resClearCaAnswer (prestable [line]);
				resPutLocalState (prestable [line], RES_SLV);
				lstate = RES_SLV;
				if (modrestrace [line])
				{
				    logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);
				}
                                taskDelay(60);
                                taskDelay(60);
                                taskDelay(60);
				break;
			    }
			}
			/* Go Back to being the Master and take control of the hardware */
			if (lstate != RES_SLV)
			{
                            resSetCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace [line])
			    {
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			    }
			}
		    }
		}

		/* take units off hold status. the unit's data are not to be held off since now master. */
		for (unit = 0; (unit < NUMUNITS); unit++ )
		{
		    punit = units [line] [unit];
		    if (punit)			/* verify pointer validity prior to use */
		    {        
			punit->holdflag = FALSE;
                    }
		}
                if (unitspolled == 0)
		{
                   taskDelay(6);
		}
                else
		{
		    taskDelay(2);
		}
	    }
	} /* end infinite task loop */
}





/*
** Try to bring a PLC on line
**
*/

/* this routine only called from MAIN */


static void on_line (unsigned short line,unsigned short unit)
   {
	TANKWAY	       *punit;
	unsigned	short i, j;

	punit = units [line] [unit];
	if (punit)			/* verify pointer prior to use */
	{
		if (mltrace [line] == 1)
		{
			logMsg ( "Bring Online PLC %d\n", unit );
	        }
                if (!tankloopback (ONERETRY + line, unit, punit))
                    return; /* if no response, get out */

		mark_not_valid (punit);	/* a PLC that has just been brought online must have    */
                                        /* it's data marked as being not valid.                 */

		punit->is_responding = TRUE;
        }
}
/*							
** Mark all unit data elements as not valid
**                                             		
*/                                             	
/* called from on_line and prepresponses      		*/    	

static void mark_not_valid (TANKWAY  *punit)
{
    punit->levels.data_valid   = FALSE;
    punit->levels.data_valid16 = FALSE;
    punit->levels.data_valid32 = FALSE;
    punit->temps[0].data_valid = FALSE;
    punit->temps[1].data_valid = FALSE;
}
/*                                                 
** Scan a Tankway Unit - get inputs as required	   
**                                                 
*/
/* this routine only called from MAIN 		*/


static	void scan_unit (TANKWAY *punit, unsigned short line, unsigned short unit)
{
    unsigned short  i, temp, cmd;

    punit->tscanpass++;

    if (mltrace [line] == 2)
    {
        logMsg ( "Scanning Tankway Unit %d.\n", unit);
    }
    /* read the level value */
    if (punit->levels.was_requested)
    {
        temp = readlevel (line, unit, punit);
        if (temp == CMDFAIL)
        {
            return;
        }
    }

    /* read the temp values */
    for (i = 0; i < 2; i++)
    {
        if (punit->temps[i].was_requested)
        {
            temp = readtemp (line, unit, punit, i);
            if (temp == CMDFAIL)
            {
                return;
            }
        }
    }
    return;
}


static	void sim_unit (TANKWAY *punit, unsigned short line, unsigned short unit)
{
    unsigned short	i;

    punit->is_responding = punit->was_requested;

    /* generate the level value */
    punit->levels.data_valid   = punit->levels.was_requested;
    punit->levels.data_valid16 = punit->levels.was_requested;
    punit->levels.data_valid32 = punit->levels.was_requested;
    if ((punit->levels.last_read16 <  simlow  [line]) ||
        (punit->levels.last_read16 >= simhigh [line]))
    {
        punit->levels.last_read16 = simlow [line];
    }
    else
    {
        punit->levels.last_read16 += 1;
    }

    /* generate the temp values */
    for (i = 0; i < 2; i++)
    {
        punit->temps[i].data_valid = punit->temps[i].was_requested;
        if ((punit->temps[i].last_read <  simlow  [line]) ||
            (punit->temps[i].last_read >= simhigh [line]))
        {
            punit->temps[i].last_read = simlow [line];
        }
        else
        {
            punit->temps[i].last_read += 1;
        }
        if (simdigon [line])
        {
            punit->temps[i].discretes = (~punit->temps[i].discretes) & 0x03;
        }
    }
}

/*                                                                                      
**      AIDRIVER                                                                        
**                                                                                      
**      This routines main purpose is to return the analog input value for the          
**      specified unit. A (-1) will be returned if there is no valid data ready.        
**                                                                                      
**
*/

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, float *pvalue, unsigned short conversion,
		unsigned char *resname)
{
    TANKWAY         *punit;
    unsigned short   blkix;
    unsigned short  *pdata;

    if (link > TANKLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > NUMUNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((card != LEVEL) && (card != TEMP) && (card != MPSEUDO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    punit = units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = units [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the Unit values requested */
                *pvalue = punit->was_requested;
                break;

            case 1: /* Is the Unit responding */
                *pvalue = punit->is_responding;
                break;

            case 5: /* Output Messages */
                *pvalue = punit->no_dataout_msgs & 0x7fff;
                break;

            case 6: /* Input Messages */
                *pvalue = punit->no_datain_msgs & 0x7fff;
                break;

            case 7: /* No Receiver Responses */
                *pvalue = punit->no_rxnoresp & 0x7fff;
                break;

            case 8: /* No Transmitter Response */
                *pvalue = punit->no_txnoresp & 0x7fff;
                break;

            case 9: /* Data Echo Errors */
                *pvalue = punit->no_dataerr & 0x7fff;
                break;

            case 10: /* Message Retries */
                *pvalue = punit->no_retries & 0x7fff;
                break;

            case 11: /* RX Hardware errors */
                *pvalue = punit->no_rxhwerrs & 0x7fff;
                break;

            case 12: /* TX Hardware errors */
                *pvalue = punit->no_txhwerrs & 0x7fff;
                break;

            case 13: /* CRC errors */
                *pvalue = punit->no_crcerrs & 0x7fff;
                break;

            case 14: /* Offline transitions */
                *pvalue = punit->no_offlines & 0x7fff;
                break;

            case 15: /* reset statistics */
                *pvalue = punit->cmd_reset_stat;
                break;

            case 16: /* Force the Unit offline */
                *pvalue = punit->cmd_force_offline;
                break;

           default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }

    if (card == LEVEL)
    {
        if (signal > MAXLEVEL)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d : max=%d\n",
                        pointname, link, adapter, card, signal, MAXLEVEL);
            return (-1);
        }
        if (resname != 0)
        { 
            register_resource (link, punit, resname, pointname);
        }

        punit->was_requested = TRUE;
        /************************************************************/
        /* verify conversion type - MUST BE NO CONVERSION or LINEAR */
        /************************************************************/
        if ((conversion != NOCONV) &&
            (conversion != LINEAR))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("                                 :[%s] conversion type = %d\n",
                        pointname, conversion);
             return (-1);
        }

        punit->levels.was_requested = TRUE;
        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (punit->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!punit->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        switch (signal)
        {
            case 0:
                if (!punit->levels.data_valid16)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                *pvalue = punit->levels.last_read16;
                break;

            case 1:
                if (!punit->levels.data_valid16)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                *pvalue = punit->levels.gray1_read16;
                break;

            case 2:
                if (!punit->levels.data_valid16)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                *pvalue = punit->levels.gray2_read16;
                break;

            case 3:
                if (!punit->levels.data_valid16)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                *pvalue = punit->levels.tmp1_read16;
                break;

            case 4:
                if (!punit->levels.data_valid16)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                *pvalue = punit->levels.tmp2_read16;
                break;

/*
            case 5:
                if (!punit->levels.data_valid1)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                *pvalue = punit->levels.raw1_read;
                break;

            case 6:
                if (!punit->levels.data_valid)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                *pvalue = punit->levels.raw2_read;
                break;
*/
            case 10:
                if (!punit->levels.data_valid32)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                *pvalue = punit->levels.last_read32;
                break;

            case 11:
                if (!punit->levels.data_valid32)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                *pvalue = punit->levels.raw_read32;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d : max=%d\n",
                            pointname, link, adapter, card, signal, MAXLEVEL);
                return (-1);
        }

        if (mltrace[link] == 8)
            logMsg("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, *pvalue);
        return(0);
    }



    if (card == TEMP)
    {
        if (signal > MAXTEMP)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d : max=%d\n",
                        pointname, link, adapter, card, signal, MAXTEMP);
            return (-1);
        }
        if (resname != 0)
        { 
            register_resource(link, punit, resname, pointname);
        }

        punit->was_requested = TRUE;
        /************************************************************/
        /* verify conversion type - MUST BE NO CONVERSION or LINEAR */
        /************************************************************/
        if ((conversion != NOCONV) &&
            (conversion != LINEAR))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("                                 :[%s] conversion type = %d\n",
                        pointname, conversion);
             return (-1);
        }

        punit->temps[signal].was_requested = TRUE;
        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (punit->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!punit->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (!punit->temps[signal].data_valid)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        switch (signal)
        {
            case 0:
                *pvalue = punit->temps[0].last_read;
                break;

            case 1:
                /* this value not actually possible with current MAXTEMP */
                *pvalue = punit->temps[0].raw1_read;
                break;

            case 2:
                /* this value not actually possible with current MAXTEMP */
                *pvalue = punit->temps[0].raw2_read;
                break;

            default:
                /* this value not actually possible with current MAXTEMP */
                *pvalue = punit->temps[0].last_read;
                break;

        }

        if (mltrace[link] == 8)
            logMsg("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, *pvalue);
        return(0);
    }
    return(-1);
}

/*
**      AODRIVER                                                                
**                                                                            	
**      This routines main purpose is to set requested analog outputs to the  	
**      value on the requested pseudo points.                                   
**                                                                              
*/

int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
              unsigned short signal,double dvalue, unsigned short value,
              unsigned short conversion, unsigned char *resname)
{
    TANKWAY           *punit;
    unsigned  short    blkix;

    if (link > TANKLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if (adapter > NUMUNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    punit = units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
             return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = units [link] [adapter];
    }
    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats(punit);
                }
                break;

            case 16: /* Force the PLC online/offline */
                punit->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    punit->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		}
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
	}
	return (0);
    }
    return (-1);
}

/*                                                                              
**      AOREAD                                                                  
**                                                                          	
**      This routines main purpose is to return the value last value written   	
**      to the specified point. This is used to initialize analog outputs.      
**                                                                              
*/


int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
            unsigned short signal, unsigned short *pvalue,
            unsigned short conversion, unsigned char *resname)
{
    TANKWAY         *punit;
    unsigned short   blkix, *pdata;

    if (link > TANKLINES)
    {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
    if (adapter > NUMUNITS)
    {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
    if ((card != TEMP) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

    punit = units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = units [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 15: /* read statistics command value */
                *pvalue = punit->cmd_reset_stat;
                break;

            case 16: /* Read the current PLC offline command status */
                *pvalue = punit->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return(-1);
        }
        return (0);
    }
    return(-1);
}

/*                                                                                     
**      BIDRIVER                                                                        
**                                                                               	
**      The main purpose of this routine is to return the request digital input  	
**      value(s) from the requested unit. This routine will return a (-1) if the  	
**      requested module is the wrong type or the data is not yet valid.          	
**                                                                                	
*/
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
              unsigned short signal, unsigned long mask, unsigned long *pvalue,
              unsigned char *resname)
{
    TANKWAY         *punit;
    unsigned short    blkix;
    unsigned long    tvalue;

    if (link > TANKLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > NUMUNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if ((card != DISCRETE) && (card != MPSEUDO))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    punit = units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = units [link] [adapter];
    }

    punit->was_requested = TRUE;

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 0: /* Were the PLC values requested */
                *pvalue = punit->was_requested;
                break;

            case 1: /* Is the PLC responding */
                *pvalue = punit->is_responding;
                break;

            case 15: /* reset statistics */
                *pvalue = punit->cmd_reset_stat;
                break;

            case 16: /* Force the PLC offline */
                *pvalue = punit->cmd_force_offline;
                 break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }

    tvalue = 0;

    if (card == DISCRETE)
    {
        if (signal > MAXDISCRETE)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (resname != 0)
        { 
            register_resource(link,punit,resname,pointname);
        }

        punit->was_requested = TRUE;

        if ( (mask & 0x00000003) != 0)
        {
            punit->temps[0].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (punit->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-2);
            }
            if (!punit->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (!punit->temps[0].data_valid)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            tvalue = punit->temps[0].discretes & mask;
            *pvalue = tvalue & mask;
                if (mltrace[link] == 9)
                    logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                            pointname, link, adapter, card, signal+1, pvalue);
            return (0);
        }
    }
    return (-1);
}
/*                                                                                     
**      BODRIVER                                                                        
**                                                                                      
**      The main purpose of this routine is to set the request digital output           
**      value(s) on the requested pseudo points.                                        
**                                                                                      
*/

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
              unsigned short signal, unsigned long value, unsigned long mask,
              unsigned char *resname)
{
    TANKWAY        *punit;

    if (link > TANKLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if (adapter > NUMUNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }
    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    punit = units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = units [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal & 0x1f)
        {
            case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats (punit);
                }
                break;

            case 16: /* Force the PLC offline */
                punit->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    punit->is_responding = FALSE;/* only required when asserting cmd_force_offline */
                }
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
            return (-1);
        }
        return (0);
    }
    return (-1);
}
/*                                                                             
**      BOREAD                                                                  
**                                                                              
**      This routines main purpose is to return the value last value written    
**      to the specified point. This is used to initialize digital outputs.     
**                                                                              
*/

int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
            unsigned short signal, unsigned long *pvalue, unsigned long mask,
            unsigned char *resname)

{
    TANKWAY        *punit;
    unsigned short  blkix;
    unsigned long    tvalue;

    if (link > TANKLINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (adapter > NUMUNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (card != MPSEUDO)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    punit = units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return(-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = units [link] [adapter];
    }

    if (card == MPSEUDO)
    {
        switch (signal)
        {
            case 15: /* reset statistics */
                *pvalue = punit->cmd_reset_stat;
                break;

            case 16: /* Force the PLC offline */
                *pvalue = punit->cmd_force_offline;
                break;
            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
            return (-1);
        }
        return (0);
    }
    return (-1);
}
/*
** register_resource
**
**	This routine is used to initialize the resource pointers
**  If this is the first time the resource for this line is being
**  referenced the pointer to the resource table entry will be set
**  and the resource name will be saved. If the resource name has
**  already been set, this routine will verify that all other points
**  for this driver are using the same resource name.
**
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
			    BOREAD, SIDRIVER, and SODRIVER.                             
*/                               	

static void  register_resource (unsigned short link, TANKWAY *punit,
                                unsigned char *resname, char *pointname)
{
    if (resnames [link] [0] == 0) /* This is the first reference */
    {
        if (resGetByName (resname, &prestable [link]) != RES_OK)
        {
            logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                     pointname, resname );
        }
        else
        {
            strcpy (resnames [link], resname);
        }
    }
    else
    {
        if (strcmp (resnames [link], resname) != 0)
        {
            logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
                     resnames[link], pointname, resname );
        }
    }
}


/*
**                                                                              
**	allocate_unit                                                           
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	unit data structure. If not successful, a console error message is      
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_unit (unsigned short line, unsigned short unit )
{
    units [line] [unit] = (TANKWAY *) calloc (1, (sizeof (TANKWAY)));
    if (!units [line] [unit])
    {
        logMsg ("Unable to allocate memory");
                 printf (" for TANKWAY data structure on line %d, unit %d\n",line ,unit);
        return(FALSE);
    }
    else
    {
        logMsg ("Allocated memory for TANKWAY data structure on line %d, unit %d\n",line ,unit);
        init_unit_tab (line, unit);	     /*	initialize the data structures. */
    }
    return (TRUE);
}


/*                                                                   		
**      start_rx                                                        	
**                                                                     	 	
**      The purpose of this routine is to initialize a line table        	
**      for receive and to enable the receiver.                           	
**                                                                        	
*/
/* only called from msgxfer */

static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )
{
    RXLINE    *rxp;

    rxp = rxlinetab [line];
    rxp->rxix = 0;
    rxp->semid = semid;
    rxp->status = pstatus;
    rxp->rxstate = RXBYTE1;
    rxp->rxmsglen = rxp->rxmsglenexpected;
}

/*                                                                           	
**      stop_rx                                                              	
**                                                                           	
**      The purpose of this routine is to initialize a line table            	
**      for receive and to disable the receiver.                             	
**                                                                           	
*/

static	void stop_rx (unsigned short line )
{
    RXLINE    *rxp;

    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
}

/*                                                                        	
**      NEW rx_int_proc                                                        	
**                                                                         	
**      The purpose of this routine is to process a receive character interrupt	
**      for a given line.                                                     	
*/

static	void rx_int_proc (unsigned short line )
{
    unsigned char   rxchar;
    unsigned short  rxstat;
    unsigned short  rx_err_mask;
    RXLINE          *rxp;

    read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);

    /* only execute if no comm error */
    if ((rxstat & rx_err_mask) == 0)
    {
        /* Something is sending in data. */
        line_activity [line] = TRUE;
        linestats [line].RXintcount++;
    }
    else
    {
        linestats [line].RXbadcount++;
    }

    rxp = rxlinetab [line];

    if (rxp->rxstate == RXIGNORE)
    {
        return;
    }
    /* no matter what the state, errors cause a logical reset of the message processing */
    if ((rxstat & rx_err_mask) != 0)
    {
        rxp->rxstate = RXBYTE1;    /* if comm goes bad, assume it was garbage,  */
                                   /* and go wait for the good stuff.           */ 
        rxp->rxix = 0;             /* reset the buffer index/counter            */
        return;
    }

    rxp->rxbuf [rxp->rxix++] = rxchar; /* store the character in the buffer and bump the index.*/

    switch (rxp->rxstate)
    {
        case RXBYTE1:
            rxp->rxstate = RXBYTE2;
            return;

        case RXBYTE2:
        default:
            *(rxp->status) = RXGOOD;
            rxp->rxstate = RXIGNORE;
            semGive (rxp->semid);
            return;
    }
    return;
}

/*                                                                             
**      check_line_activity                                                     
**
*/
/* only called from MAIN  */


static int check_line_activity (unsigned short line, unsigned short predelay )
{
    RXLINE         *rxp;
    long            thistime;
    short           status;

    if (predelay != 0)
    {
        taskDelay (predelay);
    }
    thistime = tickGet ();
    if ((thistime - activity_time [line]) < ACTIVITYTIME)
    {
        return (lastactivity [line] || (line_activity [line]));
    }
    lastactivity [line] = status = line_activity [line];
    line_activity [line] = FALSE;
    activity_time [line] = thistime;
    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
    return (status);
}

/*
**      start_tx
**
**      The purpose of this routine is to initialize a line table
**      for send and to enable the transmitter.
**
*/
/* only called from msgxfer  */


static void start_tx (unsigned short line,SEMAPHORE *semid, unsigned short *pstatus)
{
    TXLINE        *txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txix = 0;
    txp->semid = semid;
    txp->status = pstatus;
    txp->txdisable = FALSE;
    enable_tx_ints (line);
}


/*
**      stop_tx
**
**      The purpose of this routine is to initialize a line table
**      for receive and to disable the receiver.
**
*/
/* only called from msgxfer  */


static void stop_tx (unsigned short line )
{
    TXLINE        *txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txdisable = TRUE;
}

/*
**      tx_int_proc
**
**      The purpose of this routine is to process a transmit character interrupt
**      for a given line.
**
*/
/* only called from MAIN  */


static void tx_int_proc (unsigned short line )
{
    char                    txchar;
    unsigned short          txstat;
    unsigned short          tx_err_mask;
    TXLINE                 *txp;

    linestats [line].TXintcount++;

    txp = txlinetab [line];
    if (txp->txdisable)
    {
        return;
    }
    if (txp->txix == txp->txmsglen)
    {
        txp->txdisable = TRUE;
        disable_tx_ints (line);
        *(txp->status) = TXGOOD;
        semGive (txp->semid);
        return;
    }
    else
    {
        txchar = txp->txbuf [txp->txix++];
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD;
            semGive (txp->semid);
            return;
        }
    }

    if (txp->txix >= MAXTXMSG)
    {
        txp->txdisable = TRUE;
        disable_tx_ints (line);
        *(txp->status) = TXBAD;
        semGive (txp->semid);
        return;
    }
}


/*
**      msgxfer
**
**      The purpose of this routine is to transmit a buffer to the
**      analog devices I/O and to await a response. The transmit and receive
**      buffers are in their respective line tables. This routine will retry
**      the message up to a maximum number of times or until a response
**      is received with a proper checksum.
**              returns         XFERGOOD if response received
**                              XFERBAD  if no good response is received
**
*/

static unsigned short  msgxfer (unsigned short fline, TANKWAY *punit, unsigned short dataflag)
{
    unsigned short  retry, txstatus, rxstatus, txlen, rxlen, line, ix, i;
    RXLINE          *rxp;
    TXLINE          *txp;
    unsigned char   csums [2];
    unsigned short  oldrxix;
    unsigned int    tick1, tick2, tick3, tick4;
    unsigned int    delta40, delta01, delta12, delta23, delta34;
    unsigned long   msgstart;
    unsigned short  x, y;
    float           feet, inches, q;
    float           feet32, high32, low32;

    msgstart = tickGet();

    line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

    delta40 = delta01 = delta12 = delta23 = delta34 = 0;

    enable_rx_ints (line);

    rxp = rxlinetab [line];
    txp = txlinetab [line];

    for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++)
    {
        linestats [line].msgxfercount++;
        loopmsgs [line]++;

        /* time since end of last msgxfer */

        tick [line] [0] = tickGet ();
        delta40 = (tick [line] [0] - tick [line] [4]);

        if (intermsgdelay [line] != 0)
        {
            taskDelay (intermsgdelay [line]);
        }
        set_rts (line);

        if (pretxdelay [line] != 0)
        {
            taskDelay (pretxdelay [line]);
        }

        txstatus = IO_TIMEOUT;
        rxstatus = IO_TIMEOUT;
        semTake (semids [line] [TXSEM], NO_WAIT);
        semTake (semids [line] [RXSEM], NO_WAIT);

        txlen = txp->txmsglen;

        if ((trace [line] & ALLTRAFFICTRACE) &&
            ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
            ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
        {
            printf ("TX:");
            for (ix = 0; ix < 4 ; ix++) /* 4 is maximum TX message length (2 actually, but I want the dots */
            {
                if (ix < txlen)
                {
                     printf("_%2x", txp->txbuf [ix]);
                }
                else
                {
                     printf ("...");
                }
            } 
        }

        /* time from entering msgxfer to starting transmission. (including delays & diags) */ 
        tick [line] [1] = tickGet ();
        delta01 = (tick [line] [1] - tick [line] [0]);

        if (halfduplex [line] == FALSE)
        {
            start_rx (line, semids [line] [RXSEM], &rxstatus);
        }
        start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */

        if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
        {
            txstatus = IO_TIMEOUT;
        }

        /* time to transmit message. */
        tick [line] [2] = tickGet ();
        delta12 = (tick [line] [2] - tick [line] [1]);

        stop_tx (line);

        if (posttxdelay [line] != 0)
        {
            taskDelay (posttxdelay [line]);
        }

        if (halfduplex [line] == TRUE)
        {
            clear_rts (line);
            start_rx (line, semids [line] [RXSEM], &rxstatus);
        }

        /* intermessage wait time. */
        tick [line] [3] = tickGet ();
        delta23 = (tick [line] [3] - tick [line] [2]);

        if (txstatus == TXGOOD)
        {
            oldrxix = -1;    /* make it pass through timeout loop at least once */
            while ((semTake (semids [line] [RXSEM], (int) (RXTIMEOUT))) == ERROR)
            {
                if (oldrxix == rxp->rxix)
                {
                    if (modtrace [line])
                    {
                        logMsg("RX timeout\n");
                    }
                    rxstatus = IO_TIMEOUT;
                    break;
                }
                else
                {
                    if ((modtrace [line]) || (mltrace[line] == 12))
                    {
                         logMsg("waiting...");
                    }
                }
                oldrxix = rxp->rxix;
            }
            stop_rx (line);

            /* time to receive message. */

            tick [line] [4] = tickGet();
            delta34 = (tick [line] [4] - tick [line] [3]);

            rxlen = rxp->rxix;
            if (rxstatus == RXGOOD)
            {
                if ((trace [line] & ALLTRAFFICTRACE) &&
                     ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                    ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                {
                    printf("RX:");
                    for (ix = 0; ix < 8; ix++) /* 8 is maximum RX message length */
                    {
                        if (ix < rxlen)
                        {
                            printf("_%2x", rxp->rxbuf [ix]);
                        }
                        else
                        {
                            printf("...");
                        }
                    } 
                    if (dataflag == LEVELWORD)
                    {
                        /* translate from gray code to binary */
                        x = translate (rxp->rxbuf [0]); /* raw value is in half foot units */
                        y = translate (rxp->rxbuf [1]); /* raw value is in 1/16 inch units */

                        /* convert to feet and inches */
                        if ((x%2 == 0) && (y > 96))
                        {
                            feet = ((float)x/2)-1;
                        }
                        else
                        {
                            feet = (int)(x/2);
                        }
                        inches = (float)y/16;

                        /* convert to floating point feet */
                        q = feet + (inches/12);

                        /*************************************************************/
                        /* 12/18/97 : treat returned value as non gray code as well. */
                        high32 = rxp->rxbuf [0]; /* raw value is in 8 inch units     */
                        low32  = rxp->rxbuf [1]; /* raw value is in 1/32 inch units  */

                        /* convert to floating point feet */
                        feet32 = (((high32 * 256) + low32) /32)/12;

                        printf("_.5ft =%d, 16ths in =%d, feet =%f : h32=%f, l32=%f, f32 =%f",
                                       x,            y,        q,   high32, low32,  feet32);
                    }
                    printf("\n");
                    printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                }
                if (rxlen != 2)
                {
                    if (modtrace [line])
                    {
                        logMsg("Invalid rxlen... %d\n", rxlen);
                    }
                }
                else
                {
                    switch (dataflag)
                    {
                        case LEVELWORD:
/*****************************************/
/* 12/18/97: ignore syntax of level word */
/*                            ** translate from gray code to binary */
/*                            x = translate (rxp->rxbuf [0]); ** raw value is in half foot units */
/*                            y = translate (rxp->rxbuf [1]); ** raw value is in 1/16 inch units */
/*                            ** Verify the data conversion */
/*                            if ((x != 255) && (y != 255))
**                            {
**                                punit->msgs++;
**                                punit->responsetime += (tickGet() - msgstart);
**                                disable_rx_ints (line);
**                                return (XFERGOOD);
**                            }
**                            else
**                            {
**                                punit->no_dataerr++;
**                                if (modtrace [line])
**                                {
**                                    logMsg ("Gray Decoding Error\n");
**                                }
**                            }
**                            break;
*/
                        case LOOPBACK:
                        case TEMPWORD:
                        default:
                            punit->msgs++;
                            punit->responsetime += (tickGet() - msgstart);
                            disable_rx_ints (line);
                            return (XFERGOOD);
                    }
                }
            }
            else if (rxstatus == IO_TIMEOUT)
            {
                if (modtrace [line])
                {
                    logMsg ("Receive Timeout... Length: %d\n", rxlen);
                }
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                    ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                }
                punit->no_rxnoresp++;
            }
            else
            {
                if (modtrace [line])
                {
                    logMsg ("Receive Error\n");
                }
                punit->no_rxhwerrs++;
            }
        }
        else if (txstatus == IO_TIMEOUT)
        {
            if (modtrace [line])
            {
                logMsg ("Transmit Timeout\n");
            }
            if ((trace [line] & ALLTRAFFICTRACE) &&
                ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
            {
                printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
            }
            punit->no_txnoresp++;
        }
        else
        {
            if (modtrace [line])
            {
                logMsg ("Transmit Error\n");
            }
            punit->no_txhwerrs++;
        }
        if (retry != MAXRETRYS)
            punit->no_retries++;
    }
    if (modtrace [line])
    {
        logMsg ("Xfer Bad\n");
    }
    disable_rx_ints (line);
    return (XFERBAD);

}

/*
**      init_unit_tab
**
**      The purpose of this routine is to initialize the line tables for the
**      analog devices I/O
**
*/
/* only called from allocate_unit  */

static void init_unit_tab (unsigned short line, unsigned short unit)
{
    TANKWAY  *punit;

    punit = units [line] [unit];
    if (!punit)
    {
        return;
    }
    punit->is_responding = FALSE;
    punit->holdflag = FALSE;
    punit->was_requested = FALSE;
    punit->cmd_force_offline = FALSE;

    initunit (punit);
    initstats (punit);
}
/*
** Cold Init a PLC
**
*/
/* only called from init_line_tabs  */

static void initunit (TANKWAY  *punit)
{
    unsigned short  i;

    punit->levels.was_requested = FALSE;

    punit->levels.data_valid   = FALSE;
    punit->levels.raw1_read = 0;
    punit->levels.raw2_read = 0;

    punit->levels.data_valid16 = FALSE;
    punit->levels.last_read16 = 0;
    punit->levels.gray1_read16 = 0;
    punit->levels.gray2_read16 = 0;
    punit->levels.tmp1_read16 = 0;
    punit->levels.tmp2_read16 = 0;

    punit->levels.data_valid32 = FALSE;
    punit->levels.raw_read32 = 0;
    punit->levels.last_read32 = 0;

    for (i = 0; i < 2; i++)
    {
        punit->temps[i].data_valid = FALSE;
        punit->temps[i].was_requested = FALSE;
        punit->temps[i].discretes = 0;
        punit->temps[i].overrange = 0;
        punit->temps[i].raw1_read = 0;
        punit->temps[i].raw2_read = 0;
        punit->temps[i].last_read = 0;
    }
}

/*
**
** initialize the statistics for a modicon PLC
**
*/
/* called from AODRIVER, BODRIVER, and init_line_tabs  */

static    void initstats (TANKWAY *punit)
{
    punit->no_dataout_msgs = 0;  /* 5  Count Output Msgs              */
    punit->no_datain_msgs  = 0;  /* 6  Count Data Requests            */
    punit->no_rxnoresp     = 0;  /* 7  Count No Responses             */
    punit->no_txnoresp     = 0;  /* 8  Count No Responses             */
    punit->no_dataerr      = 0;  /* 9  Count Message Echo Errors      */
    punit->no_retries      = 0;  /* 10 Count Retries                  */
    punit->no_rxhwerrs     = 0;  /* 11 Count Comm Hardware Errors     */
    punit->no_txhwerrs     = 0;  /* 12 Count Comm Hardware Errors     */
    punit->no_crcerrs      = 0;  /* 13 Count CRC Errors               */
    punit->no_offlines     = 0;  /* 14 Count Off Line Transitions     */
    punit->badoutcnt       = 0;  /* 17 Count failed output commands   */

    punit->tscanpass       = 0;  /* unit scan pass counter            */
    punit->msgs            = 0;  /* good response message counts      */
    punit->responsetime    = 0;  /* total wait time for good messages */
}




/*                                                                        
** tankloopback                                                           
**                                                                        
*/
/* only called from on_line */

static unsigned short tankloopback (unsigned short line, unsigned short unit, TANKWAY *punit)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    long            buildreg;
    unsigned short  i, dataflag;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    punit->no_datain_msgs++;

    /* Format the output message */
    txp->txbuf [0] =  0x80 | unit;
    txp->txbuf [1] =  READTANKLEVEL;
    txp->txmsglen = 2;

    dataflag = LEVELWORD;

/*    ** Format the output message */
/*    txp->txbuf [0] =  0x80 | unit;
**    txp->txbuf [1] =  TANKLOOPBACK;
**    txp->txmsglen = 2;
**
**    dataflag = LOOPBACK;
**
*/
    /* Send out the message */
    if (msgxfer (line, punit, dataflag) == XFERBAD)
    {
        punit->is_responding = FALSE;
        return (FALSE);
    }

    return (TRUE);
}

/*
**     prepresponses
**
**      The purpose of this routine is to mark the PLCs as on hold and the
**    data as not valid until read again from the PLC
**
*/
/* only called from MAIN */

static void prepresponses (unsigned short line)
{
    unsigned short    unit;
    TANKWAY          *punit;

    for (unit = 1; (unit <= NUMUNITS); unit++)
    {
        punit = units [line] [unit];
        if (punit)                /* verify pointer validity prior to use */
        {
            punit->holdflag = TRUE;
            mark_not_valid (punit);
        }
    }
}


/*
**      any_responding
**
**      The purpose of this routine is to see if any units are
**    responding on this line
**
*/
/* only called from MAIN */

static int any_responding (unsigned short line)
{
    unsigned short  unit;
    TANKWAY        *punit;

    for (unit = 0; (unit < NUMUNITS); unit++)
    {
        punit = units [line] [unit];
        /* verify pointer validity prior to use */
        if (punit)  
        {
            /* check cmd_force_offline flag because it is set in an asynchronous task */
            if ((punit->is_responding) && (!punit->cmd_force_offline))
            {
                return (TRUE);
            }
        }
    }
    return (FALSE);
}


/*
** Readlevel
**
*/
static unsigned short readlevel (unsigned short line, unsigned short unit, TANKWAY *punit)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  i, dataflag;
    unsigned short  x, y;
    float           feet, inches, q;
    float           raw32, feet32;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    punit->no_datain_msgs++;

    /* Format the output message */
    txp->txbuf [0] =  0x80 | unit;
    txp->txbuf [1] =  READTANKLEVEL;
    txp->txmsglen = 2;

    dataflag = LEVELWORD;

    /* Send out the message */
    if (msgxfer (line, punit, dataflag) == XFERBAD)
    {
        punit->no_offlines++;
        punit->holdflag = TRUE;
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    /* Store the true returned data */
    punit->levels.raw1_read = rxp->rxbuf [0];
    punit->levels.raw2_read = rxp->rxbuf [1];
    punit->levels.data_valid = TRUE;


    /* translate from gray code to binary */
    x = translate (rxp->rxbuf [0]); /* raw value is in half foot units */
    y = translate (rxp->rxbuf [1]); /* raw value is in 1/16 inch units */

    /* if gray-coded bytes are valid, then data is ok */
    if ((x != 255) && (y != 255))
    {
        /* convert to feet and inches */
        if ((x%2 == 0) && (y > 96))
        {
            feet = ((float)x/2)-1;
        }
        else
        {
            feet = (int)(x/2);
        }
        inches = (float)y/16;

        /* convert to floating point feet */
        q = feet + (inches/12);

        /* Store the returned data */
        punit->levels.gray1_read16 = x;
        punit->levels.gray2_read16 = y;
        punit->levels.tmp1_read16 = feet;
        punit->levels.tmp2_read16 = inches;
        punit->levels.last_read16 = q;
        punit->levels.data_valid16 = TRUE;
    }
    else
    {
        punit->levels.data_valid16 = FALSE;
    }

    /* convert to high and low 1/32nd inch bytes to raw 1/32nd integer */
    raw32 = ((rxp->rxbuf [0]) * 256) + (rxp->rxbuf [1]);

    /* convert to high and low 1/32nd inch bytes to floating point feet */
    feet32 = (raw32/32)/12;

    /* Store the returned data */
    punit->levels.raw_read32 = raw32;
    punit->levels.last_read32 = feet32;
    punit->levels.data_valid32 = TRUE;

    return (CMDDONE);
}




unsigned char translate (unsigned char graycode)
{
    return graytable[graycode];
}



static unsigned short readtemp (unsigned short line, unsigned short unit,
                                TANKWAY *punit, unsigned short i)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  dataflag;
    unsigned short  a, b, x, y;
    short           z;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    punit->no_datain_msgs++;

    /* Format the output message */
    txp->txbuf [0] =  0x80 | unit;
    if (i == 0)
    {
        txp->txbuf [1] =  READTANKTEMP1;
    }
    else
    {
        txp->txbuf [1] =  READTANKTEMP2;
    }
    txp->txmsglen = 2;

    dataflag = TEMPWORD;

    /* Send out the message */
    if (msgxfer (line, punit, dataflag) == XFERBAD)
    {
        punit->no_offlines++;
        punit->holdflag = TRUE;
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    /* strip out and format data */
    x = rxp->rxbuf [1];
    y = rxp->rxbuf [0];
    a = (x >> 4) & 0x01;    /* overrange bit  */
    b = (x >> 6) & 0x03;    /* discrete bits  */
/*    z = ((x & 0x0f)*256)+y; ** temp magnitude */

    /* 8/21/87: temp magnitude (modified to treat overrange bit as a magnitude bit. */
    /*          this gives potential magnitude range of -8192 to +8191              */
    z = ((x & 0x1f)*256)+y;



    if (x & 0x20)           /* temp sign:  1 = positive  */
    {
        z = z;
    }
    else                    /* temp sign:  0 = negative  */
    {
        z = -z;
    }

    /* Store the returned data */
    punit->temps[i].raw1_read = x;
    punit->temps[i].raw2_read = y;
    punit->temps[i].last_read = z;
    punit->temps[i].overrange = a;
    punit->temps[i].discretes = b;
    punit->temps[i].data_valid = TRUE;

    return (CMDDONE);
}


/*
**      DUMPMSGCNTS
**
**      The purpose of this routine is to dump the line level statistics for this driver. 
**
*/
/* called from TABLEINFO */

void DUMPMSGCNTS (unsigned short line)
{
    unsigned long    temp, t, x, y, e, z;

    temp = tickGet ();
    t = (temp - linestats [line].startingtick);

    x = linestats [line].TXintcount;
    y = linestats [line].RXintcount;
    e = linestats [line].RXbadcount;
    z = linestats [line].msgxfercount;

    if (z == 0)
    {
        printf ("TX Interrupt Count    = %10d\n", x);
        printf ("RX Interrupt Count    = %10d\n", y);
        printf ("BadRX Intrpt Count    = %10d\n", e);
        printf (" ******  No Messages Transferred ****** \n");
        return;
    }

    if (t == 0)
    {
        printf ("TX Interrupt Count    = %10d\n", x);
        printf ("RX Interrupt Count    = %10d\n", y);
        printf ("BadRX Intrpt Count    = %10d\n", e);
        printf (" ******  Timer Failure ****** \n");
        return;
    }

     printf ("\n");
     printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
     printf ("\n");
     printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
     printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
     printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
     printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
     printf ("BadRX Intrpt Count    = %10d\n", e);
     printf ("\n");
     printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
     printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
     printf ("\n");
     printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
     printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
     printf ("\n");
     return;
}

/*
**      CLEARMSGCNTS
**
**      The purpose of this routine is to dump and clear the line level statistics
**      for this driver.
**
*/
/* called from TABLEINFO */

void CLEARMSGCNTS (unsigned short line)
{
    DUMPMSGCNTS (line);

    linestats [line].TXintcount = 0;
    linestats [line].RXintcount = 0;
    linestats [line].RXbadcount = 0;
    linestats [line].msgxfercount = 0;

    linestats [line].startingtick = tickGet ();
    printf (" ******  All Counts Cleared  ****** \n", linestats [line].msgxfercount);
    printf ("\n");
        return;
}


/*
**      DUMPPLCSTATS
**
**      The purpose of this routine is to dump the unit level statistics for this driver.
**
*/
/* called from TABLEINFO */

void DUMPPLCSTATS (unsigned short line, unsigned short maddr)
{
    TANKWAY        *punit;
    unsigned long   microsecs;

    punit = units [line] [maddr];
    if (!punit)
    {
        logMsg ("Line/ModbusAddress Not Defined \n");
        return;
    }

    printf (" Was requested = %d \n",       punit->was_requested);
    printf (" Is responding = %d \n",       punit->is_responding);
    printf (" # Output messages = %d \n",   punit->no_dataout_msgs & 0x7fff);
    printf (" # Data in messages = %d \n",  punit->no_datain_msgs & 0x7fff);
    printf (" #No Rx Response = %d \n",     punit->no_rxnoresp & 0x7fff);
    printf (" #No Tx Responses = %d \n",    punit->no_txnoresp & 0x7fff);
    printf (" #Data Errors = %d \n",        punit->no_dataerr & 0x7fff);
    printf (" #Retries = %d \n",            punit->no_retries & 0x7fff);
    printf (" #Rx Hw Errors = %d \n",       punit->no_rxhwerrs & 0x7fff);
    printf (" #Tx Hw Errors = %d \n",       punit->no_txhwerrs & 0x7fff);
    printf (" #Crc Errors = %d \n",         punit->no_crcerrs & 0x7fff);
    printf (" #Off Lines = %d \n",          punit->no_offlines & 0x7fff);
    printf (" Reset Statistics = %d \n",    punit->cmd_reset_stat);
    printf (" Force Offline = %d \n",       punit->cmd_force_offline);
    printf (" #Failed Outputs = %d \n",     punit->badoutcnt & 0x7fff);

    printf ("\n");
    printf (" # of Messages %d \n",         punit->msgs);
    printf (" # Total response time (ticks) = %lu \n", punit->responsetime);
    if (punit->msgs)
    {
        printf ("   Average response time (ticks) = %d \n", (punit->responsetime/punit->msgs));
        microsecs = (16667*punit->responsetime)/punit->msgs;
        printf ("   Average response time (msec) = %d.%1d \n", microsecs/1000, (microsecs%1000)/100);
    }
    printf (" # of scan passes = %d \n",    punit->tscanpass);
    printf ("\n");

    printf (" Resource Responding = %d \n", resresponse[line]);
    printf (" Hold flag  = %d \n",          punit->holdflag );
        return;
}

/*
**      CLEARPLCSTATS
**
**      The purpose of this routine is to clear the unit level statistics for this driver.
**
*/
/* called from TABLEINFO */

void CLEARPLCSTATS (unsigned short line, unsigned short maddr)
{
    TANKWAY        *punit;

    punit = units [line] [maddr];
    if (!punit)
    {
        logMsg ("Line/ModbusAddress Not Defined \n");
        return;
    }
    initstats (punit); /* use existing procedure */
    return;
}


/*
**      tanktable
**
**      The purpose of this routine is twofold:                                 
**         1) dump the unit level statistics for the tankway driver.
**         2) dump the data for the specified tankway unit.
**                                                                              
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)
{
    TANKWAY          *punit;
    unsigned short    i;
    TANKLEVELS       *levelptr;
    TANKTEMPS        *tempptr;

    punit = units [line] [maddr];
    if (!punit)
    {
        logMsg("Line/Address Not Defined \n");
        return;
    }

    DUMPPLCSTATS (line, maddr);
    printf ("\n");

    printf ("Tank Level:  Was Requested = %d,   Valid Flag = %d,   Raw Byte 0 = %d,   Raw Byte 1 = %d\n",
             punit->levels.was_requested,
             punit->levels.data_valid,
             punit->levels.raw1_read,
             punit->levels.raw2_read);
    printf ("Tank Level:  Gray Valid Flag = %f,  Post-Gray Feet(*2) = %f,  Post-Gray 1/16 inches = %f\n",
             punit->levels.data_valid16,
             punit->levels.gray1_read16,
             punit->levels.gray2_read16);
    printf ("Tank Level:                         Post-Gray Feet = %f,   Post-Gray Inches = %f,  Floating Point Feet = %f\n",
             punit->levels.tmp1_read16,
             punit->levels.tmp2_read16,
             punit->levels.last_read16);
    printf ("Tank Level:  (32nd) Valid Flag = %d,  (32nd) 32nds of an Inch = %d,  (32nd) Floating Point Feet = %f\n",
             punit->levels.data_valid32,
             punit->levels.raw_read32,
             punit->levels.last_read32);
    printf ("\n");

    for (i = 0; i < 2; i++)
    {
        printf ("Temperature[%d]:  Was Requested = %d,   Valid Flag = %d,   Overrange = %d\n",
                 i+1,
                 punit->temps[i].was_requested,
                 punit->temps[i].data_valid,
                 punit->temps[i].overrange);
        printf ("Temperature[%d]:  raw high byte = 0x%x,   raw low byte = 0x%x\n",
                 i+1,
                 punit->temps[i].raw1_read,
                 punit->temps[i].raw2_read);
        printf ("Temperature[%d]:  Value = %d\n", i+1, punit->temps[i].last_read);
        printf ("Discretes[%d]:    Value = 0x%x\n", i+1, punit->temps[i].discretes);
        printf ("\n");
    }
}

/*
**
**    The purpose of this routine is to display the contents
**    of the static variables contained within this driver.
**
*/

/* this routine not called from within this driver */


LINEINFO ()
{
    short    i;
    char    buffer [132];
    char    *resrsp;
    char    *lineact;


        printf ("                                 Tankway Line Information Table          \n");
        printf ("\n");
        printf (" Line        Pointer to        Resource      Resource");
        printf ("       Line        Delay Times:       Activity\n");
        printf ("Number      TANKWAY Table         Name        Response");
        printf ("     Activity      IM  .TX  TX.         Time\n");
    printf ("\n");

    for (i = 0; i < TANKLINES; i++)
    {
        if(units [i] == NULL)
        {
        continue;
        }
        if (resresponse [i] == 0)
        {
        resrsp = "FALSE";
        }
        else
        {
        resrsp = "TRUE";
        }
        if (line_activity [i] == 0)
        {
        lineact = "FALSE";
        }
        else
        {
        lineact = "TRUE";
        }
        sprintf (buffer,
                       "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
            i,units[i],&resnames[i],
            &resrsp[0],
            &lineact[0],
            intermsgdelay[i],
            pretxdelay[i],
            posttxdelay[i],
            activity_time[i]);
        printf ( "%s\n", buffer);
    }
    return 0;
}

/*    End of File:    drvTankway.c */
