/*drvTankway_proto.h,v 1.1.1.1 1999/08/03 14:44:58 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/* Name: drvTankway_proto.h */
/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ();

       void HELP (void);

       void TRACEON (unsigned short line);

       void TRACEOFF (unsigned short line);

       void TRAFFIC (unsigned short line, unsigned char add, unsigned type);

       void TRAFFICON (unsigned short line);

       void TRAFFICOFF (unsigned short line);

       void RTRACE (unsigned short line, unsigned short level);

       void RTRACEON (unsigned short line);

       void RTRACEOFF (unsigned short line);

       void TRACELEVEL (unsigned short line, unsigned short level);

       void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable);

       void SIMOFF (unsigned short line);

       void CONTRACEON (unsigned short line);

       void CONTRACEOFF (unsigned short line);

       void RUNTRACEON (unsigned short line);

       void RUNTRACEOFF (unsigned short line);

       void REJECTTRACEON (unsigned short line);

       void REJECTTRACEOFF (unsigned short line);

       void DEFAULTTRACE (unsigned short line);

       void tankerrortrace (unsigned short line);

       int  STOPDRIVER (short ln);

       int  STARTDRIVER (unsigned short line,
                 char *mode,
                 unsigned short delay,
                 unsigned short hdflag,
                 unsigned short delay1,
                 unsigned short delay2,
                 unsigned short private);

       void SETCOMM (unsigned short line,
                 unsigned short tickcount1,
                 unsigned short hdflag,
                 unsigned short tickcount2,
                 unsigned short tickcount3);

       void SHOWINFO (unsigned short line);

       void MAIN (unsigned short line,
                  unsigned char *mode,
                  unsigned short delay,
                  unsigned short hdflag,
                  unsigned short delay1,
                  unsigned short delay2,
                  unsigned short private);

static void on_line (unsigned short line,unsigned short unit);

static void mark_not_valid (TANKWAY *punit);

static void scan_unit (TANKWAY *punit, unsigned short line, unsigned short unit);

static void sim_unit (TANKWAY *punit, unsigned short line, unsigned short unit);

       int  AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                      unsigned short signal, float *pvalue, unsigned short conversion,
                      unsigned char *resname);

       int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                     unsigned short signal,double dvalue, unsigned short value,
                     unsigned short conversion, unsigned char *resname);

       int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                   unsigned short signal, unsigned short *pvalue,
                   unsigned short conversion, unsigned char *resname);

       int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                     unsigned short signal, unsigned long mask, unsigned long *pvalue,
                     unsigned char *resname);

       int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                     unsigned short signal, unsigned long value, unsigned long mask,
                     unsigned char *resname);

       int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
                   unsigned short signal, unsigned long *pvalue, unsigned long mask,
                   unsigned char *resname);

static void  register_resource (unsigned short link, TANKWAY *punit,
                                unsigned char *resname, char *pointname);

static int allocate_unit (unsigned short line, unsigned short unit );

static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus );

static	void stop_rx (unsigned short line );

static	void rx_int_proc (unsigned short line );

static int check_line_activity (unsigned short line, unsigned short predelay );

static void start_tx (unsigned short line,SEMAPHORE *semid, unsigned short *pstatus);

static void stop_tx (unsigned short line );

static void tx_int_proc (unsigned short line );

static unsigned short  msgxfer (unsigned short fline, TANKWAY *punit, unsigned short dataflag);

static void init_unit_tab (unsigned short line, unsigned short unit);

static void initunit (TANKWAY  *punit);

static void initstats (TANKWAY *punit);

static unsigned short tankloopback (unsigned short line, unsigned short unit, TANKWAY *punit);

static void prepresponses (unsigned short line);

static int any_responding (unsigned short line);

static unsigned short readlevel (unsigned short line, unsigned short unit, TANKWAY *punit);

       unsigned char translate (unsigned char graycode);

static unsigned short readtemp (unsigned short line, unsigned short unit,
                                TANKWAY *punit, unsigned short i);

       void DUMPMSGCNTS (unsigned short line);

       void CLEARMSGCNTS (unsigned short line);

       void DUMPPLCSTATS (unsigned short line, unsigned short maddr);

       void CLEARPLCSTATS (unsigned short line, unsigned short maddr);

       void TABLEINFO (unsigned short line, unsigned short addr);

       LINEINFO ();


/* End of File:     drvModicon_proto.h */


