/*drvTosg2.c,v 1.1.1.1 1999/08/03 14:45:07 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File: drvTosg2.c                                                                    
**  Edit: 10/06/95      WEP: original code                                              
**                         :                                                            
**        07/24/96      WEP: fixed bug in post-message NULL padding logic.              
**                         : Added padding command description to g2help.               
**                                                                                      
*/                                                                                                                      

#define  MAIN           tosg2_driver        /* NOTE: change here */
#define  AIDRIVER       tosg2_aidriver      /* NOTE: change here */
#define  AODRIVER       tosg2_aodriver      /* NOTE: change here */
#define  AOREAD         tosg2_aoread        /* NOTE: change here */
#define  BIDRIVER       tosg2_bidriver      /* NOTE: change here */
#define  BODRIVER       tosg2_bodriver      /* NOTE: change here */
#define  BOREAD         tosg2_boread        /* NOTE: change here */

#define  ASCIION        g2asciion           /* NOTE: change here */
#define  ASCIIOFF       g2asciioff          /* NOTE: change here */
#define  TRAFFICON      g2trafficon         /* NOTE: change here */
#define  TRAFFICOFF     g2trafficoff        /* NOTE: change here */
#define  TRAFFIC        g2traffic           /* NOTE: change here */
#define  TRACEON        g2traceon           /* NOTE: change here */
#define  TRACEOFF       g2traceoff          /* NOTE: change here */
#define  RTRACE         g2restrlv           /* NOTE: change here */
#define  RTRACEON       g2restraceon        /* NOTE: change here */
#define  RTRACEOFF      g2restraceoff       /* NOTE: change here */
#define  TRACELEVEL     g2trlv              /* NOTE: change here */
#define  CONTRACEON     g2contraceon        /* NOTE: change here */
#define  CONTRACEOFF    g2contraceoff       /* NOTE: change here */
#define  RUNTRACEON     g2runtraceon        /* NOTE: change here */
#define  RUNTRACEOFF    g2runtraceoff       /* NOTE: change here */
#define  REJECTTRACEON  g2rejecttraceon     /* NOTE: change here */
#define  REJECTTRACEOFF g2rejecttraceoff    /* NOTE: change here */
#define  NACKTRACEON    g2nacktraceon       /* NOTE: change here */
#define  NACKTRACEOFF   g2nacktraceoff      /* NOTE: change here */
#define  DEFAULTTRACE   g2defaulttrace      /* NOTE: change here */

#define  HELP           g2help              /* NOTE: change here */
#define  SIMON          g2simon             /* NOTE: change here */
#define  SIMOFF         g2simoff            /* NOTE: change here */

#define  STOPDRIVER     stoptosg2           /* NOTE: change here */
#define  STARTDRIVER    starttosg2          /* NOTE: change here */
#define  SETCOMM        g2comm              /* NOTE: change here */

#define  DUMPMSGCNTS    g2dumpmsgcnts       /* NOTE: change here */
#define  CLEARMSGCNTS   g2clearmsgcnts      /* NOTE: change here */
#define  DUMPUNITSTATS  g2dumpunitstats     /* NOTE: change here */
#define  CLEARUNITSTATS g2clearunitstats    /* NOTE: change here */

#define  TABLEINFO      g2table             /* NOTE: change here */
#define  UNITINFO       g2unit              /* NOTE: change here */
#define  LINEINFO       g2line              /* NOTE: change here */

#define  SETPADDING     g2padding           /* NOTE: change here */


#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
/*#include <module_types.h>
*/
#include <tsDefs.h>
#include <drvTosg2.h>			  /* NOTE: change here */
#include <drvTosg2_proto.h> 		  /* NOTE: change here */
#include <restable.h>


extern TS_STAMP	time_stamp;	/* current time stamp, defined in .../share/src/time/ts_drive.c */


/* static long	init(); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvTosg2={ 2,	NULL, init};

/*
**      External Line Level Data Structures (declared in drvcommon.c)
**
*/
extern	unsigned char	resnames [G2LINES] [RESNAMELEN]; /* array of resource name strings.		*/

extern	RES_TABLE	*prestable [G2LINES];		/* array of pointers to resource tables 	*/

extern	unsigned short	resresponse [G2LINES];		/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

extern	unsigned short	line_activity [G2LINES];	/* true/false line active flag. calculated	*/
							/* using activity_time below. 			*/
extern	unsigned short	lastactivity [G2LINES];	        /* assigned value of line_activity prior to	*/
							/* it's recalculation.   			*/

extern	unsigned short	modtrace [G2LINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/
extern	unsigned short	mltrace [G2LINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/
extern	unsigned short	modrestrace [G2LINES];		/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/

extern	SEM_ID		semids [G2LINES] [2];		/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

extern	unsigned short	intermsgdelay [G2LINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/
extern	unsigned short	pretxdelay [G2LINES];		/* holds post RTS delay before TX. 		*/
extern	unsigned short	posttxdelay [G2LINES];		/* holds post TX delay before dropping RTS. 	*/

extern	long		activity_time [G2LINES];	/* holds timetick of last activity. used to	*/
							/* set line_activity flag  			*/

extern  SEM_ID		linemux [G2LINES];		/* 1/03/94: mutual-exclusion semaphore for	*/
							/* shared resource of the data link 		*/
							/* controls access to common path shared by	*/
							/* data and diagnostic channels. 		*/
							/* originally designed for use with MDS remote	*/
							/* radio diagnostics. 				*/

extern  unsigned short  halfduplex [G2LINES];           /* store half/full duplex line status           */

extern  unsigned short  pstatewait [G2LINES];           /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */

/*
**      Storage for Toshiba G2 Comm Line Structures
**
*/

static RXLINE          *rxlinetab [G2LINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,}; /* array of pointers to dynamically           */
                                                         /* allocated comm controls/buffers            */

static TXLINE          *txlinetab [G2LINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,}; /* array of pointers to dynamically           */
                                                         /* allocated comm controls/buffers            */

/*
**      Storage for Toshiba G2 Inverter Structures
**
*/
static unsigned int	padcount [G2LINES];

static unsigned int     modsim [G2LINES];               /* 0 = normal operation, 1 = G2 unit simulation.*/

static unsigned int	simdelay [G2LINES];

static 		int	simlow [G2LINES];

static 		int	simhigh [G2LINES];

static		int	simdigon [G2LINES];

static unsigned int     tick [G2LINES][5];

static unsigned int     lastscan [G2LINES];             /* holds timestamp of beginning of major loop.  */

static unsigned int     scantime [G2LINES];             /* holds actual time taken to scan g2units.     */

static unsigned int     loopoutmsgs [G2LINES];

static unsigned int     loopmsgs [G2LINES];

static LINESTATS	linestats [G2LINES];		/* array of line level statistics.              */

static G2UNIT          *g2units [G2LINES] [NUMG2UNITS + 1];/* two dimensional array of pointers to the  */
                                                        /* fixed length dynamically allocated G2 unit   */
                                                        /* control and data structures. extra pointer   */
                                                        /* is for Query structure used independently    */
							/* of the others. it also allows for the array  */
                                                        /* index to match the unit value.               */

static	unsigned short	trace [G2LINES];		/* controls output of system error messages:	*/
							/* bit mapped controls                          */
static  unsigned char   traceadr [G2LINES];
static  unsigned char   tracetype [G2LINES];
static  unsigned char   tracenumber [G2LINES];

static OUTPUTQUE	*oq [G2LINES];			/* array of ptrs to the line output queues and  */
                                                        /* their control structures                     */
static unsigned long	nextouttime [G2LINES];

static unsigned long	outagain [G2LINES];

static  unsigned short  options [G2LINES];             /* store half/full duplex line status           */

static char    *bools [] = {"TRUE ", "FALSE"};

static int		taskId [G2LINES];
static short        watchdogId [G2LINES];


static char *tasknames [] = {"TOSG2 Ch0", "TOSG2 Ch1", "TOSG2 Ch2", "TOSG2 Ch3",
                             "TOSG2 Ch4", "TOSG2 Ch5", "TOSG2 Ch6", "TOSG2 Ch7",
                             "TOSG2 Ch8", "TOSG2 Ch9", "TOSG2 Ch10","TOSG2 Ch11",
                             "TOSG2 Ch12","TOSG2 Ch13","TOSG2 Ch14",
                             "TOSG2 Ch15","TOSG2 Ch16","TOSG2 Ch17",
                             "TOSG2 Ch18","TOSG2 Ch19","TOSG2 Ch20"
                           };
/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
{
	return (0);
}

/********
**
**	This routine outputs information to help with debugging.
**
********/
void HELP (void)
{
    printf ("Starting and Stopping the Toshiba G2 Driver:\n");
    printf ("\n");
    printf (" starttosg2(N,C,T1,H,T2,T3,P)                                                     \n");
    printf ("                      N: line number                                              \n");
    printf ("                      C: communications parameter string (comma delimited ascii)  \n"); 
    printf ("                     T1: intermessage delay (in ticks).                           \n");
    printf ("                      H: 0 = full duplex, 1 = half duplex.                        \n");
    printf ("                     T2: post RTS assert, pre TX delay (in ticks).                \n");
    printf ("                     T3: post TX, pre RTS drop delay (in ticks).                  \n");
    printf ("                      P: Private/Redundant mode.  0 = redundant, !0 = private.    \n");
    printf ("                                                                                  \n");
    printf (" Example: starttosg2(2,\"9600,N,8,1\",1,0,0,0,0)                                  \n");
    printf ("                                                                                  \n");
    printf (" stoptosg2(N)                                                                     \n");
    printf ("                     N = line number                                              \n");
    printf ("\n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" Toshiba G2 Driver Control & Display Functions (* = default)\n");
    printf ("\n");
    printf (" g2traceon(N)         Enable the following debug messages for line N:             \n");
    printf ("                         1) Major Scan loop Info:                                 \n");
    printf ("                            scan time, total output messages, and total messages. \n"); 
    printf ("                         2) Output Queue Overflow.                                \n");
    printf ("                         3) All communication errors encountered in msgxfer.      \n");
    printf ("*g2traceoff(N)        Disable all of the g2traceon debug messages for line N.     \n");
    printf ("\n");
    printf (" g2restrace(N,X)      Resource Trace Level: 0 = off. 1 = state change; 2 = delay. \n");
    printf ("*g2restraceon(N)      Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" g2restraceoff(N)     Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" g2contraceon(N)      Enable display of configuration errors in driver calls.     \n");
    printf ("*g2contraceoff(N)     Disable display of configuration errors in driver calls.    \n");
    printf (" g2runtraceon(N)      Enable display of runtime errors (queue overflow).          \n");
    printf ("*g2runtraceoff(N)     Disable display of runtime errors (queue overflow).         \n");
    printf (" g2rejecttraceon(N)   Enable display of driver call rejections in driver calls.   \n");
    printf ("*g2rejecttraceoff(N)  Disable display of driver call rejections in driver calls.  \n");
    printf (" g2nacktraceon(N)     Enable display of point deselection on TOSG2 command NACK.  \n");
    printf ("*g2nacktraceoff(N)    Disable display of point deselection on TOSG2 command NACK. \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" g2trlv(N,X)          Enable the following message for line N:                   \n");
    printf ("                         X=0,  display none of the messages below.               \n");
    printf ("                         X=1,  beginning of scan loop, bringing g2units online.  \n");
    printf ("                         X=2,  beginning of g2unit scan.                         \n");
    printf ("                         X=3,  AO, BO, & MBBO Ram output queue actions:          \n");
    printf ("                                (normal: AODRIVER, BODRIVER & checkoutputs)      \n");
    printf ("                         X=4,  BO & MBBO Command output queue actions:           \n");
    printf ("                                (normal: BODRIVER & checkoutputs)                \n");
    printf ("                         X=5,  reserved                                          \n");
    printf ("                         X=6,  calls to checkoutputs.                            \n");
    printf ("                         X=7,  checkoutputs: trace each queue entry read.        \n");
    printf ("                         X=8,  AIDRIVER, AOREAD: normal call return.             \n");
    printf ("                         X=9,  BIDRIVER, BOREAD: normal call return.             \n");
    printf ("                         X=10 to 254,  reserved.                                 \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" g2trafficon(N)       Enable traffic tracing for all units addresses              \n");
    printf ("                         and all g2bus functions on line N.                       \n");
    printf ("*g2trafficoff(N)      Disable all traffic tracing on line N.                      \n");
    printf (" g2traffic(N,X,Y,Z)   Modifies line N traffic tracing as follows:                 \n");
    printf ("                         X=0   disables tracing of all addresses.                 \n");
    printf ("                         X=255 enables tracing of all addresses.                  \n");
    printf ("                         0 < X < 255 enables tracing of address X traffic.        \n");
    printf ("                         Y=0   disables tracing of all g2bus functions.           \n");
    printf ("                         Y=255 enables tracing of all g2bus functions.            \n");
    printf ("                         0 < Y < 255 enables tracing of function Y traffic.       \n");
    printf ("                         Z=0   disables tracing of all g2bus memory numbers.      \n");
    printf ("                         Z=255 enables tracing of all g2bus memory numbers.       \n");
    printf ("                         0 < Z < 255 enables tracing of memory number Z traffic.  \n");
    printf ("\n");
    printf (" g2defaulttrace(N)    Restores default setting for all traces.                    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" g2simon(N,D,L,H,T)   Enables the simulation of responding g2units.                 \n");
    printf ("                        D: simulation interval (in seconds). if D<1 or D>60, D=60.  \n");
    printf ("                        L: low value of analog simulation range.                    \n");
    printf ("                        H: high value of analog simulation range.                   \n");
    printf ("                        T: 0 = digital inputs are zero. 1 = digitial inputs toggle. \n");
    printf ("*g2simoff(N)          Disables simulation, thus enabling normal driver function.    \n");
    printf ("\n");

    taskDelay (30); /* Time for operator to see it and pause the output */

    printf (" g2padding(N,X)        Set number of post-message padded NULL characters as follows:\n");
    printf ("                          N: line number                                            \n");
    printf ("                          X: Number of NULLS to pad to the end of the message       \n");
    printf (" g2comm(N,t1,f,t2,t3) Set communication timing parameters for line N as follows:    \n");
    printf ("                         t1: intermessage delay (in ticks).                         \n");
    printf ("                          f: 0 = full duplex, 1 = half duplex.                      \n");
    printf ("                         t2: post RTS assert, pre TX delay (in ticks).              \n");
    printf ("                         t3: post TX, pre RTS drop delay (in ticks).                \n");
    printf ("\n");
    printf (" g2dumpmsgcnts(N)      Display line N communication statistics.                     \n");
    printf (" g2clearmsgcnts(N)     Display and clear line N communication statistics.           \n");
    printf (" g2dumpunitstats(N,X)  Display line N, unit X, communication statistics.            \n");
    printf (" g2clearunitstats(N,X) Display and clear line N, unit X, xfers, status & errors.    \n");
    printf (" g2table(N,X)          Display line N, unit X, xfers, status, errors and input data.\n");
    printf (" g2unit(N)             Display summary stats for all known G2 units on the line.    \n");
    printf (" g2line                Display simple status info for all Toshiba G2 driver lines.  \n");
    printf (" g2help                Display this information.                                    \n");
}


/********
**
**	This routine enables logging of comm trace messages
**
********/
void SETPADDING (unsigned short line, unsigned short count)
{
    if (count <= 8)
    {
        padcount [line] = count;
    }
}

/********
**
**	This routine enables logging of comm trace messages
**
********/
void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/********
**
**	This routine disables logging of comm trace messages
**
********/
void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFIC (unsigned short line, unsigned char add, unsigned char type, unsigned char number)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = add;
        tracetype [line] = type;
        tracenumber [line] = number;
        return;
}

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFICON (unsigned short line)
{
    trace [line] = trace [line] | ASCIITRAFFICTRACE;
    trace [line] = trace [line] | ALLTRAFFICTRACE;
    traceadr [line] = 255;  /* every address */
    tracetype [line] = 255; /* every message type */
    tracenumber [line] = 255;
}

/********
**
**	This routine disables detailed display of normal communications traffic
**
********/
void TRAFFICOFF (unsigned short line)
{
    trace [line] = trace [line] & ~ASCIITRAFFICTRACE;
    trace [line] = trace [line] & ~ALLTRAFFICTRACE;
}

/********
**
**    This routine enables detailed display of normal communications traffic in ascii
**
********/
void ASCIION (unsigned short line)
{
    trace [line] = trace [line] | ASCIITRAFFICTRACE;
}

/********
**
**    This routine returns detailed display of normal communications traffic in ascii-hex
**
********/
void ASCIIOFF (unsigned short line)
{
    trace [line] = trace [line] & ~ASCIITRAFFICTRACE;
}


/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACE (unsigned short line, unsigned short level)
{
    modrestrace [line] = level;
}

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACEON (unsigned short line)
{
    modrestrace [line] = 1;
}

/********
**
**	This routine disables logging of resource trace messages
**
********/
void RTRACEOFF (unsigned short line)
{
    modrestrace [line] = 0;
}

/********
**
** This routine controls logging of trace messages
**
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
    mltrace [line] = level;
}

/********
**
** This routine enables the simulation of responding g2units, reading all input values as zero.
**
********/
void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable)
{
    if ((delay < 1) || (delay > 60))
    {
        simdelay [line] = 60;
    }
    else
    {
        simdelay [line] = delay;
    }
    if (low > high)
    {
        simhigh [line] = low;
        simlow [line] = high;
    }
    else
    {
        simlow [line] = low;
        simhigh [line] = high;
    }
    modsim [line] = TRUE;
    simdigon [line] = digenable;
}

/********
**
** This routine disables simulation, thus enabling normal driver function.
**
********/
void SIMOFF (unsigned short line)
{
    modsim [line] = FALSE;
}

/********
**
** These routines enable and disable tracing of database configuration errors in driver calls
**
********/
void CONTRACEON (unsigned short line)
{
    trace[line] = trace[line] | CONFIGURATIONTRACE;
}

void CONTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~CONFIGURATIONTRACE;
}

/********
**
** These routines enable and disable tracing of runtime errors in driver calls
**
********/
void RUNTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }

void RUNTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/********
**
** These routines enable and disable tracing of call rejection errors in driver calls
**
********/
void REJECTTRACEON (unsigned short line)
{
    trace[line] = trace[line] | CALLREJECTTRACE;
}

void REJECTTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~CALLREJECTTRACE;
}


/********
**
** These routines enable and disable tracing of call rejection errors in driver calls
**
********/
void NACKTRACEON (unsigned short line)
{
    trace[line] = trace[line] | G2NACKTRACE;
}

void NACKTRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~G2NACKTRACE;
}

/********
**
** This routine restores default setting for all traces.
**
********/
void DEFAULTTRACE (unsigned short line)
{
    /* debug structures */
    modtrace [line] = FALSE;
    mltrace [line] = 0;
    modrestrace [line] = 1;
    trace [line] = 0;
    traceadr [line] = 255;  /* every address      */
    tracetype [line] = 255; /* every message type */
    tracenumber [line] = 255;
}

/********
**
** This routine turns on all error tracing.
**
********/
void moderrortrace (unsigned short line)
{
    /* debug structures */
    modtrace [line] = TRUE;
    modrestrace [line] = 2;
    trace[line] = G2NACKTRACE ||
                  CONFIGURATIONTRACE ||
                  RUNTIMEERRORTRACE ||
                  CALLREJECTTRACE ||
                  0;
    traceadr [line] = 255;  /* every address      */
    tracetype [line] = 255; /* every message type */
    tracenumber [line] = 255;
}


int STOPDRIVER (short ln)
{
    if (comm_disconnect (ln) != -1)
    {
        /* if watchdog timer has been attached, detach it before deleting the task */
        if (taskId[ln])
        {
            tisWatchDogDetach(taskId[ln]);
        }
	taskDelete (taskId [ln]);
	return (1);
    }
    else
    {
        return (-1);
    }
}

int STARTDRIVER (unsigned short line,       /* the line number of this driver.                      */
                  char *mode,               /* UART initializations string (comma delimited ascii). */
                  unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                  unsigned short hdflag,    /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                  unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                  unsigned short delay2,    /* half duplex post TX, pre RTS drop delay.             */
                  unsigned short private)   /* private flag. if 0, normal. if !0, no partner driver.*/

{
    if (line < G2LINES)
    {
        taskId [line] = taskSpawn (tasknames [line],
                                   G2_PRIORITY,
                                   G2_TASK_OPTIONS,
                                   G2_STACK,
                                   MAIN,
                                   line,
                                   mode,
                                   delay,
                                   hdflag,
                                   delay1,
                                   delay2,
                                   private);

        logMsg ("Started the TOSG2 driver on line %d\n", line);

        return (1);
    }
    else
    {

        logMsg ("Invalid line number for TOSG2 driver %d\n", line);
        return (-1);
    }
}

/********
**
** Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
    intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
    halfduplex [line]    = hdflag;
    pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
    posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}

/*
**      g2_driver
**
**      The purpose of this task is to scan the Toshiba G2 inverter
**      lines. It will maintain a configuration list supporting online additions
**      and replacement of modules, and maintain a table of most recently
**      scanned values.
**
*/                                                                                     	
/* not called from within this driver 	*/

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2,
           unsigned short private)
{
	unsigned short  unit, cfgchk, cnt, unitspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command,i;
	unsigned short  masterpass1;
	long	        this_time, last_time;
	G2UNIT         *punit;
	RXLINE         *rxp;
        unsigned int    temptick, tempdiff;
        int             temp;

        short  *ptable_id;

        padcount [line] = 2;

/* Initialize the data structures */

	intermsgdelay [line] = delay;

	halfduplex [line]  = hdflag;
	pretxdelay [line]  = delay1;
	posttxdelay [line] = delay2;

	resresponse [line] = FALSE;
	resnames [line] [0] = 0;
	prestable [line] = NULL;

	activity_time [line] = tickGet ();
	lastactivity [line] = line_activity [line] = FALSE;
	nextouttime [line] = 0;
	outagain [line] = 0;

        pstatewait[line] = 60;      /* will wait up to one minute for partner to become valid */

        /* debug structures */
/*        moddebugtrace (line); */
        g2defaulttrace (line);

        tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].msgxfercount = 0;
        linestats [line].startingtick = tickGet ();

        modsim [line] = FALSE;              /* start with normal operation. */

        /* output queue initialization */
	oq [line] = (OUTPUTQUE *) calloc (1, (sizeof (OUTPUTQUE)));
	if (!oq [line])
	{
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}
        outqueinit (line);

        /* communication initialization */

	rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
	if (!rxlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
	    return;
	}
	txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
	if (!txlinetab [line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
	    return;
	}

        taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */
	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
        taskUnlock ();

	onlinefreq = 1;	  /* causes on_line calls to begin on first pass if master */

	/* Initialize the Rx interrupts to receive once for activity check         */
	/* enable the receiver interrupt after set to ignore                       */

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);

/*                                                                                                      
** 1/03/94:                                                                                             
**         initialize mutual-exclusion semaphore logic for diagnostic driver path sharing. The Take/Put 
**         logic implemented below is designed to insure, under heavy diagnostic demand, that scan_unit	
**         and the on_line while routine are executed once for every two diagnostic Take/Put sequences. 
**         Furthermore, diagnostic activities are suspended during master/slave arbitration by Taking  	
**         the semaphore while the local state is not the master state.                                	
**
*/   
        taskLock ();
	linemux [line] = semMCreate (SEM_Q_PRIORITY); /* default: semaphore initializes as 'full',    */
                                                      /* ready to be Taken.                           */
	if (!linemux [line])
	{
	    logMsg  ("Not enough memory for line %d data structure (mutual-exclusion semaphore)\n",line);
            taskUnlock ();
	    return;
        }
        if ((semTake (linemux [line], MUXTIMEOUT)) == ERROR)
        {
	      logMsg ("Mutual-Exclusion Semaphore Timeout on Line\n",line);
              taskDelay(300);
	}
        taskUnlock ();
	taskDelay (120);/* short delay for diagnostic readability */

	/* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
	while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
	{
            if (modrestrace [line] > 1)
	    {
	    	logMsg ( "No Resource Defined for this line\n");
	    }
	    taskDelay (600);
	}

        /* attach this driver task to the watchdog timer monitoring function. */
        ptable_id = &watchdogId[line];

        if (tisWatchDogAttach(taskId[line],WATCHDOGTIMEOUT, ptable_id) != OK)
        {
            logMsg("Attempt at watchdog attachment failed.\n");
            tisWatchDogDetach(taskId[line]);
            return;
        }
        if (tisWatchDogPulse(watchdogId[line]) != OK)
        {
            logMsg("First attempt at watchdog pulsing failed.\n");
            tisWatchDogDetach(taskId[line]);
            return;
        }

        if (private)
        {
            /*****************************/
	    /* Immediately become master */
            /*****************************/

	    resSetCaAnswer (prestable [line]);
	    resPutLocalState (prestable [line], RES_MSTR);

            lastscan [line] = tickGet ();
            scantime [line] = 0;

	    lstate = RES_MSTR;
	    if (modrestrace [line])
	    {
	    	logMsg ("0] Private: Initialize as RES_MSTR\n");
	    }
	    semGive (linemux [line]);	/* give back semaphore so diagnostics can run   */
        }
        else /* this is the 'normal' path */
        {
            /**********************/
            /* Start out as slave */

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            resClearCaAnswer (prestable [line]);		/* start quiet */
            resPutLocalState (prestable [line], RES_SLV);

            if (modrestrace [line])
            {
                logMsg ("1] Initialized as RES_SLV\n");
            }

            /* wait finite time for pstate to be resolved */
            logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
            for (i = 0; i <= pstatewait [line]; i++)
            {
                resGetStates (prestable [line], &lstate, &pstate);
                if (pstate != 0)
                {
	            break;
                }
                taskDelay (60);
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/
            }
            if (pstate == 0)
            {
                logMsg ("Timeout of pstate wait.\n");
            }
            else
            {
                logMsg ("Completion of pstate wait.\n");
            }

            for (i = 0; i < ACTIVITYTIME/10; i++) ;  /* ten seconds */
            {
                taskDelay(10);
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/
            }

            activity = check_line_activity(line, 0);
            resGetStates (prestable [line], &lstate, &pstate);

            /******************************************/
            /* if the partner is not there, be master */

            if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
            {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lastscan [line] = tickGet ();
                scantime [line] = 0;

                lstate = RES_MSTR;
                if (modrestrace [line])
                {
                    logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
                }
                semGive (linemux [line]);	/* give back semaphore so diagnostics can run   */
                onlinefreq = 1;	       /* causes on_line calls to begin on first pass as master */
                masterpass1 = TRUE;
            }
        }

	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet (); /* Initialize the time  */

	while (TRUE)
	{
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

	    activity_time [line] = tickGet ();
	    lastactivity [line] = line_activity [line] = FALSE;

            /********************************************************************************************/
	    /* we arrive here because we are a slave.                                                   */
	    /* we stay until:   1) asked to be master by partner. if we can reach one or more Inverter  */
            /*                     Units, we become master.                                             */
            /*                  2) the partner is not master and there is no activity on the line.      */
            /********************************************************************************************/

	    while (lstate == RES_SLV)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                /* check for g2 unit simulated mode. */
                if (modsim [line])
                {
		    semGive (linemux [line]);	/* give back semaphore so diagnostics can function      */
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
                        logMsg ("Simulation Mode] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
                    masterpass1 = TRUE;
		    break;
                }

		if (pstate != RES_SLVWANT)
		{
		    clear_rts (line); 				/* make sure line is left for master 	*/
		}
		resresponse [line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand (prestable [line], 0); 		/* clear out commands 			*/
		activity = check_line_activity (line, 10); 	/* wait 10 seconds before checking 	*/
		resGetStates (prestable [line], &lstate, &pstate);

                /****************************************************************************************/
		/* see if needed by partner to be master. if yes, do it and break out of slave state.   */
		if (pstate == RES_SLVWANTCA)
		{
		    semGive (linemux [line]);	/* give back semaphore so diagnostics can function      */
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
			logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
                    onlinefreq = 1;	       /* causes on_line calls to begin on first pass as master */
                    masterpass1 = TRUE;
		    break;
		}
                /***************************************************************/
		/* If partner is there and wants to give it up, try to take it */

		if (pstate == RES_SLVWANT)
		{
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

		    execute = FALSE;
		    taskDelay (2); /* Time for switch to occur */

		    /* See if anyone is out there and able to respond to a loopback command */
		    for (unit = 1; (unit <= NUMG2UNITS); unit++)
		    {
			punit = g2units [line] [unit];
			if ((punit) &&			 /* verify pointer validity prior to use */
			    (punit->was_requested) &&    /* data points have been requested      */
                            (!punit->cmd_force_offline)) /* user has NOT forced unit offline     */
			{
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
			    on_line (line, unit);
                            /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                            if ((punit->is_responding) && (!punit->cmd_force_offline))
			    {
				execute = TRUE;
				break;
			    }
			}
		    }
		    /* If someone answered, become master and make sure partner really gave it up */
		    if (execute)
		    {
			resPutLocalState (prestable [line], RES_MSTR);
			lstate = RES_MSTR;

                        lastscan [line] = tickGet ();
                        scantime [line] = 0;

			if (modrestrace [line])
			{
				logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			}
			execute = FALSE;
			activity_time [line] = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < 60); i++)
			{
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/

			    activity = check_line_activity (line, 2); /* pause before testing */
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */
			    resPutLocalState (prestable [line], RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace [line])
			    {
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
			    }
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 
			    semGive (linemux [line]);	/* give back semaphore so diagnostics can run   */
			    resSetCaAnswer (prestable [line]);
			    prepresponses (line);
			    break;
			}
		    }
		}

                /********************************************/
		/* if the partner is not talking, be master */

		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
		    semGive (linemux [line]);		/* give back semaphore so diagnostics can run.  */
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line] = 0;

		    if (modrestrace [line])
		    {
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
		    }
		    prepresponses (line);
                    onlinefreq = 1;	       /* causes on_line calls to begin on first pass as master */
                    masterpass1 = TRUE;
		}
	    }

            /****************************************************************************************/
            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is canceled           */
	    while (lstate == RES_SLVWANTCA)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

	        taskDelay (2);                  /* Give OS a chance...  */
		clear_rts (line); 		/* Make sure line is left for master    */
		resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */

		resGetStates (prestable [line], &lstate, &pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace [line])
		    {
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}
		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    semGive (linemux [line]);		/* give back semaphore so diagnostics can run.  */
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
		    {
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
		    prepresponses (line);
                    onlinefreq = 1;	       /* causes on_line calls to begin on first pass as master */
                    masterpass1 = TRUE;
		}
	    }

            /****************************************************************************************/
	    /* in normal operation this code should never execute. it has, however, been seen to    */
            /* execute when the database has been inadvertently configured with the same resource   */
	    /* assigned to two different drivers in the same IOC. The state does funny things.      */
            /****************************************************************************************/
	    while (lstate == RES_SLVWANT)
	    {
                if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))

		{
                    /* condition should NEVER occur. print error message every 5 seconds. */
                    logMsg ("Illegal Local Resource State.\n");
                    if (trace[line] & CONFIGURATIONTRACE)
                    {
                        logMsg ("  Possible Resource Configuration Error:\n");
                        logMsg ("   Check for multiple drivers sharing single Resource.\n");
                    }
                    taskDelay (600);
                }
                taskDelay (2);
            }
            /****************************************************************************************/
            /* we come here because we have gone to, or are looping in, the master state.           */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
	    /* It will then try to configure requested non-responding modules.                      */
            /****************************************************************************************/

	    last_time = tickGet ();		/* initialize gap */
	    while (lstate == RES_MSTR)
	    {
		if (mltrace [line] == 1)
		{
			logMsg ( "Top of Master Loop... \n");
	        }
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                /* check for g2 unit simulated mode. */
                while (modsim [line])
                {
		    resresponse [line] = TRUE; /* Make sure driver is responding. driver won't  */
		    for (unit = 1; (unit <= NUMG2UNITS); unit++)
		    {
		        punit = g2units [line] [unit];	/* shorthand pointer 			*/
		        if (punit)			/* verify pointer validity prior to use */
		        {
			    if (punit->cmd_force_offline)
			    { 
				/* if user has turned this g2 unit offline via pseudo commands, */
                                /* mark it as not responding.                                   */
 				punit->is_responding = FALSE;
	    		    }
			    else
			    {
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/

				sim_unit (punit, line, unit);      /* I/O done here! 		*/
		   		taskDelay (simdelay [line]);
                            }
			}
		    }
                }
		/* initial stuff */
		resresponse [line] = TRUE; /* Make sure driver is responding. driver won't           */
                                           /* issue commands if not set.                             */

		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0);        /* clear out commands */

                /************************************************************************/
		/* if relinquish command sent, change state and break out to outer loop */
		if (command == RES_RELINQUISH)
		{
                    getsemaphore(line);       /* make sure radio diagnostics are quiescent */

		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace [line])
		    {
                       logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}

                /* measure time between scans of the entire set of g2units. display if requested. */
                temptick = tickGet ();
                tempdiff = temptick - lastscan [line];

                if (modtrace [line])
		{
                    logMsg ("ScanTime: =%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                            scantime[line], loopoutmsgs[line], loopmsgs[line]);
		}

                loopoutmsgs [line] = 0;
                loopmsgs [line] = 0;
                lastscan [line] = temptick;

		/* scan g2units for data i/o, if allowed */

		unitspolled = 0;

		/* call 'scan_unit' for each G2 unit, unless user has   */
                /* taken it off line or it is not responding.           */

		for (unit = 1; (unit <= NUMG2UNITS); unit++)
		{
		    punit = g2units [line] [unit];	/* shorthand pointer 			*/
		    if (punit)				/* verify pointer validity prior to use */
		    {
			if (punit->cmd_force_offline)
			{ 
			    /* if user has turned this g2 unit offline via pseudo commands, */
                            /* mark it as not responding.                                   */
 			    punit->is_responding = FALSE;
	    		}
			else if (punit->is_responding)
			{
                            /* local/partner lockstep recovery */
                            resGetStates (prestable [line], &lstate, &pstate);
                            if (pstate == RES_MSTR)
                            {
                                resClearCaAnswer (prestable [line]);
                                resPutLocalState (prestable [line], RES_SLV);
                                lstate = RES_SLV;
                                clear_rts (line); 		/* Make sure line is left for master */
                                if (modrestrace [line])
				{
                                    logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
				}
                                temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                                for ( i = 0; i < temp; i++)
                                {
                                   /******************************/
                                   tisWatchDogPulse(watchdogId[line]);
                                   /******************************/
                                   taskDelay(60);
                                }
                                break;
                            }
			    unitspolled++;

                            getsemaphore(line);       /* make sure radio diagnostics are quiescent */

			    scan_unit (punit, line, unit);      	/* I/O done here! 		*/
			    semGive (linemux [line]);
			    if (!punit->is_responding)
			    {
				mark_not_valid (punit);
                            }
			}
		    }
		    /* end of single module action */

		    /* if told to relinquish our master state, stop unit scanning immediately. */
		    /* don't trash the command, so that we can still read it on the next loop */
                    /* through this while statement.                                          */
		    resGetCommand (prestable [line], &command);
		    if (command == RES_RELINQUISH)
		    {
			break;
		    }
		} /* end of scan loop */

                /* test for lockstep detection. */
                if (lstate != RES_MSTR) break;

                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                /* measure how long the scan took. to be displayed at beginning of next loop. */
                temptick = tickGet ();
                scantime [line] = temptick - lastscan [line];

		/* try and bring all nonresponding g2units on line, but */
                /* don't bring in more than a specified number.      */

		cnt = 0;
		if (--onlinefreq == 0) 		/* do we try to bring any in on this pass? */
		{ 
		    onlinefreq = BRINGBACKCNT;
		    for (unit = 1; (unit <= NUMG2UNITS); unit++)
		    {
			cfgchk++;		/* manage unit index */
			if (cfgchk == NUMG2UNITS + 1)
			{
			    cfgchk=1;	/* wrap unit index */
                        }
			punit = g2units [line] [cfgchk];
			if ((punit) &&		/* verify pointer validity prior to use*/
			    (!punit->is_responding) &&
			    (punit->was_requested) &&
			    (!punit->cmd_force_offline))
		    	{
                            getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/

			    on_line (line, cfgchk);	/* loopback testing done here! 	*/
			    semGive (linemux [line]);

			    unitspolled++;
			    cnt++;
                            if (cnt == MAXCFGCK)
			    {
				break;
			    }
			}
		    }
		}
		/* see if anyone on the line has been responding. */
                /* if not, try to get partner to become slave.    */
		/* Check for no one responding */

		if ((!any_responding (line)) && (!private))
		{
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

		    /* See if it is time to let partner try */

		    this_time = tickGet ();
		    if ((this_time - last_time) > (3 * SLWWINDOW))
		    {   /* #ticks for slave to try */

			/* Switch States to let partner know it's its time to try */

                        /* make semGet(linemux[line]) call before the switch to make sure diagnostic */
                        /* task is quiescent while partner is checking the line with the loopback    */
                        /* command. if local not master, then diagnostic won't try anyway, for       */
                        /* either master or remote radios, but it might have begun a 12 second test  */
                        /* sequence just before we got here.                                         */
                        getsemaphore(line);

                        /* we must semGive the semaphore back if and when we go to being the master */


			resPutLocalState (prestable [line], RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace [line])
			{
			    logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate, activity);
			}
			/* Give partner access to the hardware */
			clear_rts (line);

			/* Remember the time of this try */
			last_time = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < SLWWINDOW); i += 10)
			{       		/* SLWINDOW is the # of ticks for slave to try */
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
			    taskDelay (10);
		    				/* If partner picked up let it have control */
			    activity = check_line_activity (line, 0);  /* check immediately */
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
			    {
				resClearCaAnswer (prestable [line]);
				resPutLocalState (prestable [line], RES_SLV);
				lstate = RES_SLV;
				if (modrestrace [line])
				{
				    logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);
				}
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
				break;
			    }
			}
			/* Go Back to being the Master and take control of the hardware */
			if (lstate != RES_SLV)
			{
			    semGive (linemux [line]);	/* give back semaphore so diagnostics can run. */
                            resSetCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace [line])
			    {
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			    }
                            onlinefreq = 1;	       /* causes on_line calls to begin on first pass as master */
                            masterpass1 = TRUE;
                            break;
			}
		    }
		}

		/* take g2 units off hold status. the unit's data are */
                /*  not to be held off since now master.              */
		for (unit = 1; (unit <= NUMG2UNITS); unit++ )
		{
		    punit = g2units [line] [unit];
		    if (punit)			/* verify pointer validity prior to use */
		    {        
			punit->holdflag = FALSE;
                    }
		}
                if (unitspolled == 0)
		{
                   taskDelay(6);
		}
                else
		{
		    taskDelay(2);
		}
	    }
	} /* end infinite task loop */
}


static void getsemaphore(unsigned short line)
{
    int i;     

    while ((semTake(linemux[line], 10)) == ERROR)
    {
        i =+ 10;
        if (i >= MUXTIMEOUT)
        {
            i = 0;
            logMsg (" Waiting for Radio Diagnostics:");
            printf (" Mutual-Exclusion Semaphore Timeout on Line %d\n", line);
        }
        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/
    }
    return;
}

/*
** Try to bring a G2 unit on line
**
*/

/* this routine only called from MAIN */


static void on_line (unsigned short line, unsigned short unit)
{
    G2UNIT         *punit;
    unsigned short  i, j;

    punit = g2units [line] [unit];
    if (punit)			/* verify pointer prior to use */
    {
        if (mltrace [line] == 1)
        {
            logMsg ( "Bring Online G2 Unit %d\n", unit );
        }
        /* Read location zero of RAM as a loopback function to see if the unit can respond. */

        if (readzero (ONERETRY + line, unit, punit) != CMDDONE)
            return; /* if no response, get out */

        mark_not_valid (punit);	/* a G2 unit that has just been brought online must have */
                                /* it's data marked as being not valid.                  */
        punit->is_responding = TRUE;
    }
}
/*							
** Mark all g2 unit data elements as not valid 		
**                                             		
*/                                             	
/* called from on_line and prepresponses      		*/    	

static void mark_not_valid (G2UNIT  *punit)
{
    unsigned short i;

/*
**      Initialize RAM 
*/
    for (i = 0; (i < RAMDATASIZE); i++)
    {
        punit->ram [i].data_valid = FALSE;
    }

/*
**      Initialize MONITOR STATUS 
*/
    for (i = 0; (i < MONDATASIZE); i++)
    {
        punit->monitor [i].data_valid = FALSE;
    }

/*
**      Initialize SYSTEM STATUS 
*/
    for (i = 0; (i < SYSDATASIZE); i++)
    {
        punit->system [i].data_valid = FALSE;
    }

/*
**      Initialize COMMAND IMAGE 
*/
    for (i = 0; (i < COMDATASIZE); i++)
    {
        punit->commands [i].data_valid = FALSE;
    }
}

/*                                                              
** Scan a TOSG2 PLC -  get inputs and set outputs as required   
**                                                            	
*/
/* this routine only called from MAIN 		*/

static void scan_unit (G2UNIT *punit, unsigned short line, unsigned short unit)
{
    unsigned short i, temp;

    punit->tscanpass++;

    if (mltrace [line] == 2)
    {
        logMsg ( "Scanning G2 Unit - %d.\n", unit);
    }
    if (punit->holdoff)
    {
        if ((tickGet() - punit->holdofftick) < G2HOLDOFFTICKS)
        {
            return;
        }
        punit->holdoff = FALSE;
    }
    checkoutputs (line);
    if (punit->holdoff)
    {
        return;
    }

    /* determine the RAM values to be scanned */
    for (i = 0; (i < RAMDATASIZE); i++)
    {
        if (punit->ram [i].was_requested)
        {
            temp = readram (line, unit, punit, i);
            if (temp == CMDFAIL)
            {
                return;
            }
            if (temp == CMDREJECT)
            {
                /* disable the entire range of NACKed points */
                if (trace[line] & G2NACKTRACE)
                    logMsg ("G2 Command Reject: Disabling Point at L=%d,A=%d,C=%d,S=1\n",
                             line, unit, i+RAMBASE);
                punit->ram [i].was_requested = FALSE;
                punit->ram [i].data_valid = FALSE;
            }
        }
        checkoutputs (line);
        if (punit->holdoff)
        {
            return;
        }
    }

    /* read the Monitor Status values to be scanned */
    for (i = 0; (i < MONDATASIZE); i++)
    {
        if (punit->monitor [i].was_requested)
        {
            temp = statusmonitor (line, unit, punit, i);
            if (temp == CMDFAIL)
            {
                return;
            }
            if (temp == CMDREJECT)
            {
                /* disable the entire range of NACKed points */
                if (trace[line] & G2NACKTRACE)
                    logMsg ("G2 Command Reject: Disabling Point at L=%d,A=%d,C=%d,S=1\n",
                             line, unit, i+MONBASE);
                punit->monitor [i].was_requested = FALSE;
                punit->monitor [i].data_valid = FALSE;
            }
        }
        checkoutputs (line);
        if (punit->holdoff)
        {
            return;
        }
    }

    /* Note: system status is read back with every response. there is no explicit command to read it. */
    /* Note: output command values are written from this side, not read from the other.               */
    return;
}

static	void sim_unit (G2UNIT *punit, unsigned short line, unsigned short unit)
{
    unsigned short    i, j, k, val;
    unsigned short    temp, cmd;

    punit->is_responding = punit->was_requested;

    /* determine the RAM values to be simulated */
    for (i = 0; (i < RAMDATASIZE); i++)
    {
        if (punit->ram [i].was_requested)
        {
            punit->ram [i].data_valid = TRUE;
            if ((punit->ram [i].last_read < simlow [line]) ||
                (punit->ram [i].last_read >= simhigh [line]))
            {
                punit->ram [i].last_read = simlow [line];
            }
            else
            {
                punit->ram [i].last_read += 1;
            }
            /* after handling integer, copy to float */
            punit->ram[i].last_fread = punit->ram[i].last_read;
        }
    }

    /* determine the Monitor Status values to be simulated */
    for (i = 0; (i < MONDATASIZE); i++)
    {
        if (punit->monitor [i].was_requested)
        {
            punit->monitor [i].data_valid = TRUE;
            if ((punit->monitor [i].last_read < simlow [line]) ||
                (punit->monitor [i].last_read >= simhigh [line]))
            {
                punit->monitor [i].last_read = simlow [line];
            }
            else
            {
                punit->monitor [i].last_read += 1;
            }
            /* after handling integer, copy to float */
            punit->monitor [i].last_fread = punit->monitor [i].last_read;
        }
    }

    /* determine the System Status values to be simulated */
    for (i = 0; (i < SYSDATASIZE); i++)
    {
        if (punit->system [i].was_requested)
        {
            punit->system [i].data_valid = TRUE;
            if ((punit->system [i].last_read < simlow [line]) ||
                (punit->system [i].last_read >= simhigh [line]))
            {
                punit->system [i].last_read = simlow [line];
            }
            else
            {
                punit->system [i].last_read += 1;
            }
        }
    }
}

/*                                                                                                      
** checkoutputs                                                                                         
**      checks output queue and returns if empty. if there is something on the queue it attempts to     
**      process all pending outputs, doing immediate retries. If attempts fail the request is dropped.  
**                                                                                                      
*/
/* this routine only called from scan_unit */

static	void checkoutputs (unsigned short line)
{
    OUTQENT        *optr;
    G2UNIT         *punit;
    unsigned short  addr, link, adapter, signal;
    float           val;
    unsigned short  write_status;
    unsigned short  index;

    if (mltrace [line] == 6)
    {
        logMsg ("Checking Output Queue ...\n"); 
    }

    while ((optr = ogetnextp (line)) != NULLP)
    {
        if ((optr->otype) == ROUTTYPE)
        {
            link = optr->out.ronode.link;
            adapter = optr->out.ronode.adapter;
            punit = g2units [link] [adapter];
            if (punit == NULL)
            {
                if (!allocate_unit (link, adapter))
                {
                    return; /* if not allocated, try. if can't allocate, get out. */
                }
                punit = g2units [link] [adapter];
            }
            addr = optr->out.ronode.card;
            val = optr->out.ronode.rovalue;
            if (mltrace [link] == 7)
            {
                logMsg("RAM OUTPUT IN QUEUE: L=%d, A=%d,      S=%d, V=%f\n",
                        link, adapter, addr, val);
            } 

            if ((!punit->cmd_force_offline) &&
                (resresponse [link]) &&
                (punit->is_responding))
            {
                loopoutmsgs [line]++;
                write_status = writeram (link, adapter, punit, addr, val);
                if (write_status != CMDDONE)
                {
                    punit->badoutcnt++;
                    if (mltrace [link] == 3)
                    {
                        logMsg ("RAM OUTPUT DEQUEUE: Output failed: L=%d, A=%d,      S=%d, V=%f\n",
                                link, adapter, addr, val);
                    } 
                }
                else
                {
                    if (mltrace [link] == 3)
                    {
                        logMsg ("RAM OUTPUT DEQUEUE: Output succeeded: L=%d, A=%d,      S=%d, V=%f\n",
                                 link, adapter, addr, val);
                    } 
                }
            }
        }
        else if ((optr->otype) == COUTTYPE)
        {
            link = optr->out.conode.link;
            adapter = optr->out.conode.adapter;
            punit = g2units [link] [adapter];
            if (punit == NULL)
            {
                if (!allocate_unit (link, adapter))
                {
                    return; /* if not allocated, try. if can't allocate, get out. */
                }
                punit = g2units [link] [adapter];
            }
            addr = optr->out.conode.card;
            index = addr - COMBASE;
            signal = optr->out.conode.cosignal;
            val = optr->out.conode.covalue;
            if (mltrace [link] == 7)
            {
                logMsg("COMMAND IN QUEUE: L=%d, A=%d,      S=%d, V=%f\n",
                        link, adapter, addr, val);
            }

            if ((!punit->cmd_force_offline) &&
                (resresponse [link]) &&
                (punit->is_responding))
            {
                loopoutmsgs [line]++;

                switch (index)
                {
                  case 0:
                    if (signal == 0) /* if mbbo, val is the command */
                    {
                        write_status = writerun (link, adapter, punit, addr, val-1);
                    }
                    else
                    {
                        write_status = writerun (link, adapter, punit, addr, signal-1);
                    }
                    break;

                  case 1:
                    if (signal == 0) /* if mbbo, val is the command */
                    {
                        write_status = writestop (link, adapter, punit, addr, val-1);
                    }
                    else
                    {
                        write_status = writestop (link, adapter, punit, addr, signal-1);
                    }
                    break;

                  case 2:
                    if (signal == 0) /* if mbbo, val is the command */
                    {
                        write_status = writejog (link, adapter, punit, addr, val-1);
                    }
                    else
                    {
                        write_status = writejog (link, adapter, punit, addr, signal-1);
                    }
                    break;

                  case 3:
                    write_status = writeemergencystop (link, adapter, punit, addr, signal-1);
                    break;

                  case 4:
                    write_status = writetripclear (link, adapter, punit, addr, signal-1);
                    /* if write was successful, the unit won't be accepting any more commands for a  */
                    /* while. exiting now will leave any pending commands in the queue for later     */
                    /* processing. if we try to process them now they will be ignored and discarded. */
                    if (write_status == CMDDONE)
                    {
                        if (mltrace [link] == 4)
                        {
                            logMsg("COMMAND DEQUEUE: Trip Clear: L=%d, A=%d,      S=%d, V=%f\n\n",
                                    link, adapter, addr, val);
                            logMsg("   The Toshiba G2+ Inverter will not respond to \n");
                            logMsg("     any commands for the next several seconds, \n");
                            logMsg("     so the driver will delay before trying.    \n");
                        }
                        oreleasefull (line);     /* release the output que entry */
                        return;
                    }
                    break;

                  default:
                    write_status = FALSE;
                    break;
                }
                  
                if (write_status != CMDDONE)
                {
                    punit->badoutcnt++;
                    if (mltrace [link] == 4)
                    {
                        logMsg ("COMMAND DEQUEUE: Output failed: L=%d, A=%d,      S=%d, V=%f\n",
                                 link, adapter, addr, val);
                    }
                }
                else
                {
                    if (mltrace [link] == 4)
                    {
                        logMsg("COMMAND DEQUEUE: Output succeeded: L=%d, A=%d,      S=%d, V=%f\n",
                                link, adapter, addr, val);
                    }
                }
            }
        }
        oreleasefull (line);     /* release the output que entry */
    }
}

/*                                                                                     
**      AIDRIVER                                                                       
**                                                                                     
**      This routines main purpose is to return the analog input value for the         
**      specified module. For a module value                                           
**      a (-1) will be returned if there is no valid data ready.                       
**                                                                                     
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
              unsigned short card, unsigned short signal, float *pvalue,
              unsigned short conversion, unsigned char *resname)
{
    G2UNIT          *punit;
    unsigned short   blkix;
    unsigned short  *pdata;
    unsigned short   index;

    if (link > G2LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (adapter > NUMG2UNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if ((!((card <= MAXRAMCARD))) &&
        (!((card >= MINMONCARD) && (card <= MAXMONCARD))) &&
           (card != PSEUDOCARD))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    punit = g2units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = g2units [link] [adapter];
    }

    if (card == PSEUDOCARD)
    {
        switch (signal)
        {
            case 0: /* Were the G2 unit values requested */
                *pvalue = punit->was_requested;
                break;

	    case 1: /* Is the G2 unit responding */
		*pvalue = punit->is_responding;
		break;

	    case 5: /* Output Messages */
		*pvalue = punit->no_dataout_msgs & 0x7fff;
		break;

	    case 6: /* Input Messages */
		*pvalue = punit->no_datain_msgs & 0x7fff;
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = punit->no_rxnoresp & 0x7fff;
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = punit->no_txnoresp & 0x7fff;
		break;

	    case 9: /* Data Echo Errors */
		*pvalue = punit->no_dataerr & 0x7fff;
		break;

	    case 10: /* Message Retries */
		*pvalue = punit->no_retries & 0x7fff;
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = punit->no_rxhwerrs & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = punit->no_txhwerrs & 0x7fff;
		break;

	    case 13: /* Checksum errors */
		*pvalue = punit->no_chksumerrs & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*pvalue = punit->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = punit->cmd_reset_stat;
		break;

	    case 16: /* Force the G2 unit offline */
		*pvalue = punit->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = punit->badoutcnt & 0x7fff;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }
	    return (0);
	}

    if (signal != 1)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (resname != 0)
    { 
        register_resource(link, punit, resname, pointname);
    }

    punit->was_requested = TRUE;

    /* verify conversion type */
    if (conversion != NOCONV)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AIDRIVER: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
         return (-1);
    }

    if ((card <= MAXRAMCARD))
    {
        index = card - RAMBASE;

        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->ram [index].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Driver Offline(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (punit->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: On Hold(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!punit->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Not Responding(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (punit->ram [index].data_valid != TRUE)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Data Not Valid(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        *pvalue = punit->ram [index].last_fread;

        if (mltrace[link] == 8)
            logMsg("AIDRIVER: Data Returned(0):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, *pvalue);
         return(0);
    }

    if ((card >= MINMONCARD) && (card <= MAXMONCARD))
    {
        index = card - MONBASE;

        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->monitor [index].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (punit->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!punit->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (punit->monitor [index].data_valid != TRUE)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        *pvalue = punit->monitor [card-MONBASE].last_fread;

        if (mltrace[link] == 8)
        {
            logMsg("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, *pvalue);
        }
         return(0);
    }
    return(-1);
}
/*  										
**      AODRIVER                                                                
**                                                                              
**      This routines main purpose is to set requested analog outputs to the  	
**      specified module.                                                     	
*/                                                                            	
/* this routine not called from within this driver */

int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
              unsigned short signal, double dvalue, float value,
              unsigned short conversion, unsigned char *resname)
{
    G2UNIT          *punit;
    unsigned short   blkix;
    OUTQENT         *oqp;
    unsigned short   index;


     if (link > G2LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    if (adapter > NUMG2UNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    if ((!(card <= MAXRAMCARD)) &&
          (card != PSEUDOCARD))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    punit = g2units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = g2units [link] [adapter];
    }

    if (card == PSEUDOCARD)
    {
        switch (signal)
        {
            case 15: /* Reset the accumulated statistics */
                if (dvalue != 0)
                {
                    initstats(punit);
                }
                break;

            case 16: /* Force the G2 unit online/offline */
                punit->cmd_force_offline = (dvalue != 0);
                if (dvalue != 0)
                {
                    punit->is_responding = FALSE;/* only required when asserting cmd_force_offline */
                }
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                            pointname, link, adapter, card, signal, dvalue);
                return (-1);
        }
        return (0);
    }

    if (signal != 1)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        return (-1);
    }

    if (resname != 0)
    { 
        register_resource (link, punit, resname, pointname);
    }

    punit->was_requested = TRUE;

    /* verify conversion type */
    if (conversion != NOCONV)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AODRIVER: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
         return (-1);
    }

    if ((card <= MAXRAMCARD))
    {
        if (dvalue > 9999)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
            {
                logMsg("AODRIVER: Output Value Too Large:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                        pointname, link, adapter, card, signal, dvalue);
            }
            return (-1);
        }

        index = card - RAMBASE;

        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->ram [index].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                        pointname, link, adapter, card, signal, dvalue);
            return (-1);
        }

        /* check for g2 unit simulated mode. */
        if (modsim [link])
        {
            if (mltrace [link] == 3)
            {
                logMsg("AODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                        pointname, link, adapter, card, signal, dvalue);
            }
            return (0);
        }

        if ((!punit->is_responding) || (punit->cmd_force_offline))
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                        pointname, link, adapter, card, signal, dvalue);
            return (-1);
        }

        oqp = ogetemptyp (link);
        if (oqp == NULLP)
        {
            if (trace[link] & RUNTIMEERRORTRACE)
            {
                logMsg("AODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                        pointname, link, adapter, card, signal, dvalue);
            }
            punit->badoutcnt++;
            return (-1);		/* output queue is full */
        }
        oqp->otype = ROUTTYPE;
        oqp->out.ronode.link = link;
        oqp->out.ronode.adapter = adapter;
        oqp->out.ronode.card = card;
        oqp->out.ronode.rosignal = signal;

        oqp->out.ronode.rovalue = dvalue;

        omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace [link] == 3)
        {
            logMsg("RAM OUTPUT QUEUED (AO):[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, dvalue);
        }
        return (0);
    }
}

/*                                                                              
**      AOREAD                                                                  
**                                                                          	
**      This routines main purpose is to return the value last read back     	
**      from the analog output hardware. This is used to initialize analog   	
**      outputs.                                                             	
*/
/* this routine not called from within this driver */

int AOREAD (char *pointname, unsigned short link, unsigned short adapter,
            unsigned short card, unsigned short signal, float *pvalue,
            unsigned short conversion, unsigned char *resname)
{
    G2UNIT          *punit;
    unsigned short   blkix;
    unsigned short  *pdata;
    unsigned short   index;

    if (link > G2LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (adapter > NUMG2UNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if ((!((card <= MAXRAMCARD))) &&
           (card != PSEUDOCARD))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    punit = g2units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = g2units [link] [adapter];
    }

    if (card == PSEUDOCARD)
    {
        switch (signal)
        {
            case 15: /* read statistics command value */
                *pvalue = punit->cmd_reset_stat;
                break;

            case 16: /* Read the current G2 unit offline command status */
                *pvalue = punit->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return(-1);
            }
            return (0);
        }


    if (signal != 1)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (resname != 0)
    { 
        register_resource(link, punit, resname, pointname);
    }

    punit->was_requested = TRUE;

    /* verify conversion type */
    if (conversion != NOCONV)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("AOREAD: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
         return (-1);
    }

    if ((card <= MAXRAMCARD))
    {
        index = card - RAMBASE;

        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->ram [index].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (punit->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!punit->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (punit->ram [index].data_valid != TRUE)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        *pvalue = punit->ram [index].last_fread;

        if (mltrace[link] == 8)
            logMsg("AOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=%f\n",
                    pointname, link, adapter, card, signal, *pvalue);
         return(0);
    }
    return(-1);
}
/*                                                                                     
**      BIDRIVER                                                                        
**                                                                               	
**      The main purpose of this routine is to return the request digital input  	
**      value(s) from the requested card. This routine will return a (-1) if the  	
**      requested module is the wrong type or the data is not yet valid.          	
**                                                                                	
*/
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
              unsigned short card, unsigned short signal, unsigned long mask,
              unsigned long *pvalue, unsigned char *resname)
{
	G2UNIT 		*punit;
	unsigned short	blkix;
	unsigned long	tvalue;
        unsigned short  index;

    if (link > G2LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (adapter > NUMG2UNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if ((!((card <= MAXRAMCARD))) &&
           (card != 104) &&
           (card != 105) &&
           (card != MINSYSCARD) &&
           (card != PSEUDOCARD))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    punit = g2units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = g2units [link] [adapter];
    }

    if (card == PSEUDOCARD)
    {
        switch (signal)
        {
            case 0: /* Were the G2 unit values requested */
                *pvalue = punit->was_requested;
                break;

            case 1: /* Is the G2 unit responding */
                *pvalue = punit->is_responding;
                break;

            case 15: /* reset statistics */
                *pvalue = punit->cmd_reset_stat;
                break;

            case 16: /* Force the G2 unit offline */
                *pvalue = punit->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }

    if (resname != 0)
    { 
        register_resource(link, punit, resname, pointname);
    }

    punit->was_requested = TRUE;

    if ((card <= MAXRAMCARD))
    {
        index = card - RAMBASE;

        if (signal != 1)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->ram [index].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Driver Offline(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (punit->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: On Hold(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!punit->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Not Responding(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (punit->ram [index].data_valid != TRUE)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Data Not Valid(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        *pvalue = punit->ram [index].last_read;

        if (mltrace[link] == 9)
            logMsg("BIDRIVER: Data Returned(0):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, *pvalue);
         return(0);
    }


    if ((card == 104) || (card == 105))
    {
        index = card - MONBASE;

        if ((signal < 1) || (signal > 8))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal signal(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->monitor [index].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (punit->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!punit->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (punit->monitor [index].data_valid != TRUE)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        *pvalue = punit->monitor [index].last_read;

        if (mltrace[link] == 9)
            logMsg("BIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, *pvalue);
         return(0);
    }

    if (card == MINSYSCARD)
    {
        index = card - SYSBASE;

        if ((signal < 1) || (signal > 16))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal signal(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->ram [index].was_requested = TRUE;

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Driver Offline(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (punit->holdflag)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: On Hold(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-2);
        }
        if (!punit->is_responding)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Not Responding(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if (punit->system [index].data_valid != TRUE)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BIDRIVER: Data Not Valid(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        *pvalue = punit->system [index].last_read;

        if (mltrace[link] == 9)
            logMsg("BIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, *pvalue);
         return(0);
    }
    return (-1);
}
/*                                                                                     
**      BODRIVER                                                                        
**                                                                                 	
**      The main purpose of this routine is to set the request digital output      	
**      value(s) on the requested card. This routine will return a (-1) if the     	
**      requested module is the wrong type or not configured yet.                  	
**                                                                                 	
*/
/* this routine not called from within this driver */

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long value, unsigned long mask,
		unsigned char *resname)
{
    G2UNIT         *punit;
    OUTQENT        *oqp;
    unsigned short  blkix;
    unsigned short  index;
    unsigned short  noprocess;

    noprocess = FALSE;

    if (link > G2LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (adapter > NUMG2UNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if ((!((card <= MAXRAMCARD))) &&
        (!((card >= MINCOMCARD) && (card <= MAXCOMCARD))) &&
           (card != PSEUDOCARD))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    punit = g2units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = g2units [link] [adapter];
    }

    if (card == PSEUDOCARD)
    {
        switch (signal & 0x1f)
        {
            case 15: /* Reset the accumulated statistics */
                if (value != 0)
                {
                    initstats (punit);
                }
                break;

            case 16: /* Force the G2 unit offline */
                punit->cmd_force_offline = (value != 0);
                if (value != 0)
                {
                    punit->is_responding = FALSE;/* only required when asserting cmd_force_offline */
                }
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
                return (-1);
        }
        return (0);
    }

    if (resname != 0)
    { 
        register_resource(link, punit, resname, pointname);
    }

    punit->was_requested = TRUE;


    if ((card <= MAXRAMCARD))
    {
        index = card - RAMBASE;

        if (signal != 1)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->ram [index].was_requested = TRUE;
    }

    if ((card >= MINCOMCARD) && (card <= MAXCOMCARD))
    {
        index = card - COMBASE;

        if (signal == 0) /* signal zero is only valid for MBBO */
        {
            switch (index)
            {
                case 0:
                    if (value > 8) /* zero allows user to deselect 'real' actions */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg("BODRIVER: Illegal MBBO value(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                    pointname, link, adapter, card, signal, value);
                        return (-1);
                    }
                    break;

                case 1:
                case 5:
                    if (value > 2) /* zero allows user to deselect 'real' actions */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg("BODRIVER: Illegal MBBO value(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                    pointname, link, adapter, card, signal, value);
                        return (-1);
                    }
                    break;

                case 2:
                    if (value > 3) /* zero allows user to deselect 'real' actions */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg("BODRIVER: Illegal MBBO value(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                    pointname, link, adapter, card, signal, value);
                        return (-1);
                    }
                    break;

                default:
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BODRIVER: Illegal signal(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                pointname, link, adapter, card, signal, value);
                    return (-1);
                    break;
            }
            if (value == 0) /* zero is not an error, but results in no action being taken. */
            {
                noprocess = TRUE;
            }
        }
        else /* all below are BO, not MBBO */
        {
          switch (index)
          {
            case 0:
                if ((signal < 1) || (signal > 8))
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BODRIVER: Illegal signal(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                pointname, link, adapter, card, signal, value);
                    return (-1);
                }
                break;

            case 1:
            case 5:
                if ((signal < 1) || (signal > 2))
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BODRIVER: Illegal signal(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                pointname, link, adapter, card, signal, value);
                    return (-1);
                }
                break;

            case 2:
                if ((signal < 1) || (signal > 3))
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BODRIVER: Illegal signal(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                pointname, link, adapter, card, signal, value);
                    return (-1);
                }
                break;

            case 3:
            case 4:
                if (signal != 1)
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BODRIVER: Illegal signal(1):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                pointname, link, adapter, card, signal, value);
                    return (-1);
                }
                break;
            }
        }
        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->commands [index].was_requested = TRUE;
    }


    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    if (modsim [link])
    {
        if (mltrace [link] == 4)
        {
            logMsg("BODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        }
        return (0);
    }
    if ((!punit->is_responding) || (punit->cmd_force_offline))
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        return (-1);
    }

    /* ignore mbbo zero value outputs. */
    if (noprocess) return(0);

    oqp = ogetemptyp (link);
    if (oqp == NULLP)
    {
        if (trace[link] & RUNTIMEERRORTRACE)
            logMsg("BODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
        punit->badoutcnt++;
        return (-1);		/* output queue is full */
    }
    if ((card <= MAXRAMCARD))
    {
        oqp->otype = ROUTTYPE;
        oqp->out.ronode.link = link;
        oqp->out.ronode.adapter = adapter;
        oqp->out.ronode.card = card;
        oqp->out.ronode.rosignal = signal;
        oqp->out.ronode.rovalue = (float) value;
        omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 3)
            logMsg("RAM OUTPUT QUEUED (BO):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
    }
    else
    {
        oqp->otype = COUTTYPE;
        oqp->out.conode.link = link;
        oqp->out.conode.adapter = adapter;
        oqp->out.conode.card = card;
        oqp->out.conode.cosignal = signal;
        oqp->out.conode.covalue = value;
        omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 4)
            logMsg("COMMAND QUEUED (BO):[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
    }
    return (0);
}
/*
**      BOREAD                                                                  
**                                                                              
**      This routines main purpose is to return the value last read back      	
**      from the digital output hardware. This is used to initialize digital  	
**      outputs. This will return a (-1) if the module is the wrong type or    	
**      the data is not yet valid                                              	
*/
/* this routine not called from within this driver */

int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)
{
    G2UNIT         *punit;
    unsigned short *pdata;
    unsigned short  index;

    if (link > G2LINES)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if (adapter > NUMG2UNITS)
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    if ((!((card <= MAXRAMCARD))) &&
        (!((card >= MINCOMCARD) && (card <= MAXCOMCARD))) &&
           (card != PSEUDOCARD))
    {
        if (trace[link] & CONFIGURATIONTRACE)
            logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }

    punit = g2units [link] [adapter];
    if (punit == NULL)
    {
        if (!allocate_unit (link, adapter))
        {
            return (-1); /* if not allocated, try. if can't allocate, get out. */
        }
        punit = g2units [link] [adapter];
    }

    if (card == PSEUDOCARD)
    {
        switch (signal)
        {
            case 15: /* reset statistics */
                *pvalue = punit->cmd_reset_stat;
                break;

            case 16: /* Force the G2 unit offline */
                *pvalue = punit->cmd_force_offline;
                break;

            default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
        }
        return (0);
    }

    if (resname != 0)
    { 
        register_resource(link, punit, resname, pointname);
    }

    punit->was_requested = TRUE;


    if ((card <= MAXRAMCARD))
    {
        index = card - RAMBASE;

        if (signal != 1)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->ram [index].was_requested = TRUE;
    }


    if ((card >= MINCOMCARD) && (card <= MAXCOMCARD))
    {
        index = card - COMBASE;

        switch (index)
        {
            case 0:
                if ((signal > 8))
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BOREAD: Illegal signal(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                break;

            case 1:
            case 5:
                if ((signal > 2))
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BOREAD: Illegal signal(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                break;

            case 2:
                if ((signal > 3))
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BOREAD: Illegal signal(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                break;

            case 3:
            case 4:
                if (signal != 1)
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BOREAD: Illegal signal(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
                }
                break;
        }
        /* as soon as the address is confirmed as valid, set requested bits. */
        punit->commands [index].was_requested = TRUE;
    }

    if (!resresponse[link])
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }
    if (punit->holdflag)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-2);
    }
    if (!punit->is_responding)
    {
        if (trace[link] & CALLREJECTTRACE)
            logMsg("BOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                    pointname, link, adapter, card, signal);
        return (-1);
    }


    if ((card <= MAXRAMCARD))
    {
        index = card - RAMBASE;

        if (punit->ram [index].data_valid != TRUE)
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        *pvalue = punit->ram [index].last_read;

        if (mltrace[link] == 9)
            logMsg("BOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, *pvalue);
        return(0);
    }


    if ((card >= MINCOMCARD) && (card <= MAXCOMCARD))
    {
        *pvalue = punit->commands [index].last_write;
        if (mltrace[link] == 9)
            logMsg("BOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal, *pvalue);
        return(0);
    }
    return(-1);
}

/*
** register_resource
**
**	This routine is used to initialize the resource pointers
**  If this is the first time the resource for this line is being
**  referenced the pointer to the resource table entry will be set
**  and the resource name will be saved. If the resource name has
**  already been set, this routine will verify that all other points
**  for this driver are using the same resource name.
**
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
			    BOREAD, SIDRIVER, and SODRIVER.                             
*/                               	

static void  register_resource (unsigned short link, G2UNIT *punit,
                                unsigned char *resname, char *pointname)
{
    if (resnames [link] [0] == 0) /* This is the first reference */
    {
        if (resGetByName (resname, &prestable [link]) != RES_OK)
        {
            logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                     pointname, resname);
        }
        else
        {
            strcpy (resnames [link], resname);
        }
    }
    else
    {
        if (strcmp (resnames [link], resname) != 0)
        {
            logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
                     resnames[link], pointname, resname);
        }
    }
}

/*
**      Initialize the Queue                                        		
*/                                                                        	
/* not called from within this driver */

static	void outqueinit (unsigned short line)
{
    oq [line]->ooutix = oq [line]->oinix = 0;
}


/*                                                                     		
**  ogetempty - get the next available slot on the output list         		
*/
/*    called from AODRIVER and BODRIVER   */

static OUTQENT *ogetemptyp (unsigned short line)
{
    if (((oq [line]->oinix + 1) % OUTQSIZE) != oq [line]->ooutix)
    {
        return (&oq [line]->outque[oq [line]->oinix]);
    }
    if (mltrace [line] == 11)
    {
        logMsg ( "Output Queue Full\n");
    }
    return (NULLP);
}


/*                                                                    		
** omarkfull                                                          		
**      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static void omarkfull (unsigned short line)
{
    oq [line]->oinix = ((oq [line]->oinix + 1) % OUTQSIZE);
}


/*                                                                      	
**  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
{
    if (oq [line]->ooutix != oq [line]->oinix)
    {
        return (&oq [line]->outque[oq [line]->ooutix]);
    }
    else
    {
        return (NULLP);
    }
}


/*                                                       	               	
** oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
{
    if (oq [line]->ooutix == oq [line]->oinix)
    {
        return;
    }
    oq [line]->ooutix = ((oq [line]->ooutix + 1) % OUTQSIZE);
}

/*                                                                             	
**                                                                              
**	allocate_unit                                                           
**                                                                              
**	The purpose of this routine is to allocate the memory for a single      
**	g2 unit data structure. If not successful, a console error message is  	
**	printed and an error flag is returned to the caller.                    
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_unit (unsigned short line, unsigned short unit )
{
    g2units [line] [unit] = (G2UNIT *) calloc (1, (sizeof (G2UNIT)));
    if (!g2units [line] [unit])
    {
        logMsg ("Unable to allocate memory");
        printf (" for G2UNIT data structure on line %d, unit %d\n", line, unit);
        return(FALSE);
    }
    else
    {
        logMsg ("Allocated memory for G2UNIT data structure on line %d, unit %d\n", line, unit);
        init_unit_tab (line, unit);	     /*	initialize the data structures. */
    }

    return (TRUE);
}

/*                                                                   		
**      start_rx                                                        	
**                                                                     	 	
**      The purpose of this routine is to initialize a line table        	
**      for receive and to enable the receiver.                           	
**                                                                        	
*/
/* only called from msgxfer */


static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )
{
    RXLINE        *rxp;

    rxp = rxlinetab [line];
    rxp->rxix = 0;
    rxp->semid = semid;
    rxp->status = pstatus;
    rxp->rxstate = RXHEADER;
}

/*                                                                           	
**      stop_rx                                                              	
**                                                                           	
**      The purpose of this routine is to initialize a line table            	
**      for receive and to disable the receiver.                             	
**                                                                           	
*/
/* only called from msgxfer */

static	void stop_rx (unsigned short line )
{
    RXLINE		*rxp;

    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;
}

/*                                                                        	
**      NEW rx_int_proc                                                        	
**                                                                         	
**      The purpose of this routine is to process a receive character interrupt	
**      for a given line.                                                     	
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static	void rx_int_proc (unsigned short line )
{
    unsigned char   rxchar;
    unsigned short  rxstat;
    unsigned short  rx_err_mask;
    RXLINE          *rxp;

    read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);

    linestats [line].RXintcount++;

    rxp = rxlinetab [line];

    /* Something is sending in data. */

    line_activity [line] = TRUE;

    if (rxp->rxstate == RXIGNORE)
    {
        return;
    }
    /* no matter what the state, errors cause a logical reset of the message processing */
    if ((rxstat & rx_err_mask) != 0)
    {
        rxp->rxstate = RXHEADER;   /* if comm goes bad, assume it was garbage,  */
                                   /* and go wait for the good stuff.           */ 
        rxp->rxix = 0;             /* reset the buffer index/counter            */
        return;
    }

    /* regardless of current state, don't exceed buffer length. */
    if (rxp->rxix >= MAXRXMSG)
    {
        *(rxp->status) = RXBAD;
        rxp->rxstate = RXIGNORE;
        semGive (rxp->semid);
        return;
    }

    rxp->rxbuf [rxp->rxix++] = rxchar; /* store the character in the buffer and bump the index.*/

    switch (rxp->rxstate)
    {
        case RXHEADER:    /* Looking for Opening Left Parenthesis */
             /* test for address validity */
             if (rxchar == '(')
             {
        	rxp->rxstate = RXBODY;
                return;
             }
             else
             {
                rxp->rxstate = RXHEADER;               /* presume it was a false input.  */
                                                       /* go wait for the real one.      */ 
                rxp->rxix = 0;                         /* reset the buffer index/counter.*/
                return;
             }
             break;

        case RXBODY:      /* Looking for Closing Carriage Return */
            if (rxchar == 0x0d)
            {
              *(rxp->status) = RXGOOD;
               rxp->rxstate = RXIGNORE;
               semGive (rxp->semid);
               return;
            }
            if (rxchar == '(')
            {
                rxp->rxstate = RXBODY;                 /* restart message input. old stuff was noise. */
                rxp->rxix = 0;                         /* reset the buffer index/counter, store the   */
                rxp->rxbuf [rxp->rxix++] = rxchar;     /* character in the buffer and bump the index. */
                return;
            }
            break;
    }
    return;
}

/*                                                                             
**      check_line_activity                                                     
**                                                                             	
*/
/* only called from MAIN  */

static	int check_line_activity (unsigned short line, unsigned short predelay )
{
    RXLINE          *rxp;
    long		thistime;
    short		status;

    if (predelay != 0)
    {
        taskDelay (predelay);
    }
    thistime = tickGet ();
    if ((thistime - activity_time [line]) < ACTIVITYTIME)
    {
        return (lastactivity [line] || (line_activity [line]));
    }
    lastactivity [line] = status = line_activity [line];
    line_activity [line] = FALSE;
    activity_time [line] = thistime;
    rxp = rxlinetab [line];
    rxp->rxstate = RXIGNORE;

    return (status);
}

/*                                                                         	
**      start_tx                                                            	
**                                                                          	
**      The purpose of this routine is to initialize a line table           	
**      for send and to enable the transmitter.                              	
**                                                                            	
*/
/* only called from msgxfer  */

static	void start_tx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )
{
    TXLINE  *txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txix = 0;
    txp->semid = semid;
    txp->status = pstatus;
    txp->txdisable = FALSE;

    enable_tx_ints (line);
    return;
}


/*
**      stop_tx                                                                	
**                                                                             	
**      The purpose of this routine is to initialize a line table              	
**      for receive and to disable the receiver.                               	
**                                                                             	
*/
/* only called from msgxfer  */

static	void stop_tx (unsigned short line )
{
    TXLINE   *txp;

    disable_tx_ints (line);
    txp = txlinetab [line];
    txp->txdisable = TRUE;
}

/*                                                                           	
**      tx_int_proc                                                           	
**                                                                            	
**      The purpose of this routine is to process a transmit character interrupt
**      for a given line.                                                  	
**                                                                         	
*/
/* only called from MAIN  */

static	void tx_int_proc (unsigned short line )
{
    char            txchar;
    unsigned short  txstat;
    unsigned short  tx_err_mask;
    TXLINE         *txp;

    linestats [line].TXintcount++;

    txp = txlinetab [line];
    if (txp->txdisable)
    {
        return;
    }
    if (txp->txix == txp->txmsglen)
    {
        txp->txdisable = TRUE;
        disable_tx_ints (line);
        *(txp->status) = TXGOOD;
        semGive (txp->semid);
        return;
    }
    else
    {
        txchar = txp->txbuf [txp->txix++];
        write_tx_hw (line, txchar, &txstat, &tx_err_mask);
        if ((txstat & tx_err_mask) != 0 )
        {
            txp->txdisable = TRUE;
            disable_tx_ints (line);
            *(txp->status) = TXBAD;
            semGive (txp->semid);
            return;
        }
    }
    if (txp->txix >= MAXTXMSG)
    {
        txp->txdisable = TRUE;
        disable_tx_ints (line);
        *(txp->status) = TXBAD;
        semGive (txp->semid);
        return;
    }
}

/*                                                                                   
**      msgxfer                                                                      
**                                                                                   
**      The purpose of this routine is to transmit a buffer to the                   
**      analog devices I/O and to await a response. The transmit and receive         
**      buffers are in their respective line tables. This routine will retry         
**      the message up to a maximum number of times or until a response              
**      is received with a proper checksum.                                          
**        returns                                                                    
**                 CMDDONE     if expected response received without any error       
**                 CMDFAIL     if communications failed, including checksum error    
**                 CMDNACK     if no checksum error, but format problems encountered
**                 CMDREJECT   if command rejected by the G2 Inverter                
**
*/

static	unsigned short  msgxfer (unsigned short fline, G2UNIT *punit)
{
	unsigned short  retry, txstatus, rxstatus, txlen, rxlen, line, ix, i;
	RXLINE          *rxp;
	TXLINE          *txp;
	unsigned char   csums;
        unsigned short  oldrxix;
        unsigned int    tick1, tick2, tick3, tick4;
        unsigned int    delta40, delta01, delta12, delta23, delta34;
        unsigned long   msgstart;
        unsigned char   tempbuf[2];
        unsigned short  datavalue;
        unsigned short  floatlength, errorcode;
                 float  floaterror;

	msgstart = tickGet();

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

        delta40 = delta01 = delta12 = delta23 = delta34 = 0;

	rxp = rxlinetab [line];
	txp = txlinetab [line];

	for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++)
	{
            linestats [line].msgxfercount++;
            loopmsgs [line]++;

            /* time since end of last msgxfer */

            tick [line] [0] = tickGet ();
            delta40 = (tick [line] [0] - tick [line] [4]);

	    if (intermsgdelay [line] != 0)
	    {
		taskDelay (intermsgdelay [line]);
	    }
	    set_rts (line);

	    if (pretxdelay [line] != 0)
	    {
		taskDelay (pretxdelay [line]);
	    }

	    txstatus = IO_TIMEOUT;
	    rxstatus = IO_TIMEOUT;

	    semTake (semids [line] [TXSEM], NO_WAIT);
	    semTake (semids [line] [RXSEM], NO_WAIT);

	    txlen = txp->txmsglen;

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            if ((trace [line] & ALLTRAFFICTRACE) &&
                ((traceadr [line] == txp->address) || (traceadr [line] == 255)) &&
                ((tracetype [line] == txp->function) || (tracetype [line] == 255)) &&
                ((tracenumber [line] == txp->number) || (tracenumber [line] == 255)))
            {
                printf ("TX:____");
                if (trace [line] & ASCIITRAFFICTRACE)
                {
                    for (ix = 0; ix < txlen ; ix++) /* just print what is there to print */
                    {
                        if (!((txp->txbuf [ix]) < 0x20))
                        {
                            printf("%c", txp->txbuf [ix]);
                        }
                        else
                        {
                            printf ("<%x>", txp->txbuf [ix]);
                        }
                    }
                    printf ("\n");
                }
                else
                {
                    for (ix = 0; ix < 20 ; ix++) /* 20 is maximum TX message length */
                    {
                        if (ix < txlen)
                        {
                            printf("_%2x", txp->txbuf [ix]);
                        }
                        else
                        {
                            printf ("...");
                        }
                    }
                    printf ("\n");
                }
            }

            /* time from entering msgxfer to starting transmission. (including delays & diags) */ 

            tick [line] [1] = tickGet ();
            delta01 = (tick [line] [1] - tick [line] [0]);

            start_rx (line, semids [line] [RXSEM], &rxstatus);
	    start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */

	    if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
	    {
		txstatus = IO_TIMEOUT;
	    }

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            /* time to transmit message. */

            tick [line] [2] = tickGet ();
            delta12 = (tick [line] [2] - tick [line] [1]);

	    stop_tx (line);

	    if (posttxdelay [line] != 0)
	    {
		taskDelay (posttxdelay [line]);
	    }

	    if (halfduplex [line] == TRUE)
	    {
	       clear_rts (line);
	    }
            /* intermessage wait time. */

            tick [line] [3] = tickGet ();
            delta23 = (tick [line] [3] - tick [line] [2]);

	    if (txstatus == TXGOOD)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                oldrxix = -1;    /* make it pass through timeout loop at least once */
                while ((semTake (semids [line] [RXSEM], (int) (RXTIMEOUT))) == ERROR)
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

                    if (oldrxix == rxp->rxix)
                    {
                        if (modtrace [line])
			{
                            logMsg("RX timeout\n");
			}
                        rxstatus = IO_TIMEOUT;
                        break;
                    }
                    else
                    {
                        if ((modtrace [line]) || (mltrace[line] == 12))
			{
                             logMsg("waiting...");
			}
                    }
                    oldrxix = rxp->rxix;
                }
		stop_rx (line);

                /* time to receive message. */

                tick [line] [4] = tickGet();
                delta34 = (tick [line] [4] - tick [line] [3]);

		rxlen = rxp->rxix;
                if (rxstatus == RXGOOD)
		{
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

                    if ((trace [line] & ALLTRAFFICTRACE) &&
                        ((traceadr [line] == txp->address) || (traceadr [line] == 255)) &&
                        ((tracetype [line] == txp->function) || (tracetype [line] == 255)) &&
                        ((tracenumber [line] == txp->number) || (tracenumber [line] == 255)))
                    {
                        printf ("RX:____");
                        if (trace [line] & ASCIITRAFFICTRACE)
                        {
                            for (ix = 0; ix < rxlen ; ix++) /* just print what is there to print */
                            {
                                if (!((rxp->rxbuf [ix]) < 0x20))
                                {
                                    printf("%c", rxp->rxbuf [ix]);
                                }
                                else
                                {
                                    printf ("<%x>", rxp->rxbuf [ix]);
                                }
                            }
                            /* printf ("\n");*/
                        }
                        else
                        {
                            for (ix = 0; ix < 20 ; ix++) /* 20 is maximum RX message length */
                            {
                                if (ix < rxlen)
                                {
                                    printf("_%2x", rxp->rxbuf [ix]);
                                }
                                else
                                {
                                    printf ("...");
                                }
                            }
                            /* printf ("\n"); */
                        }
                        printf(" ............. DELTA: %3d %3d %3d %3d %3d\n",
                                delta40, delta01, delta12, delta23, delta34);
                    }
                    if (rxlen < 3)
                    {
                        if (modtrace [line])
                        {
                            logMsg("Invalid rxlen... %d\n", rxlen);
                        }
                    }
                    else
                    {
                        /* test for valid checksum */
                        checkchksum (&rxp->rxbuf [0], rxlen-4, &tempbuf[0]);
                        if ((rxp->rxbuf [rxlen-4] == tempbuf[0]) &&
                            (rxp->rxbuf [rxlen-3] == tempbuf[1]))
                        {
                            /* the checksum is valid */

                            /* Verify the unit response: Leading Code, Unit Address, Ending. */
                            if ((rxp->rxbuf [0] != txp->txbuf[0]) ||    /* "("               */
                                (rxp->rxbuf [1] != txp->txbuf[1]) ||    /* unit (MSD)        */
                                (rxp->rxbuf [2] != txp->txbuf[2]) ||    /* unit (LSD)        */
                                (rxp->rxbuf [rxlen - 5] != '&')  ||     /* ampersand         */
                                (rxp->rxbuf [rxlen - 2] != ')')  ||     /* right parenthesis */
                                (rxp->rxbuf [rxlen - 1] != 0x0d))       /* CR                */
                            {
                                punit->no_dataerr++;
                                punit->no_retries++;
                                continue;
                            }

                            /* ok. we have now determined that the response is syntactically correct */
                            /* read the status */
                            if (asciihex (&datavalue, &rxp->rxbuf [rxlen - 9]))
                            {
                                punit->system [i].last_read = datavalue;
                                punit->system [i].data_valid = TRUE;
                            }
                            else
                            {
                                /* there was a conversion problem */
                                punit->system [i].data_valid = FALSE;

                                punit->no_dataerr++;
                                punit->no_retries++;
                                continue;
                            }

                            if (rxp->rxbuf [3] == NACKRESPONSE)        /* Handle the NACK response. */
                            {
                                /* it is a NACK response. parse the error number */
                                floatlength = 1; 
                                if (!parsefloat (&rxp->rxbuf [4], floatlength, &floaterror))
                                {
                                    /* there was a conversion problem */
                                    punit->no_dataerr++;
                                    punit->no_retries++;
                                    continue;
                                }
                                if (modtrace [line])
                                {
                                    errorcode = (unsigned short) floaterror;
                                    switch (errorcode)
                                    {
                                        case (0):
                                            logMsg("Toshiba G2 Error: Execution Disabled. \n");
                                            break;

                                        case (1):
                                            logMsg("Toshiba G2 Error: Beyond modified data range. \n");
                                            break;

                                        case (2):
                                            logMsg("Toshiba G2 Error: Beyond data number range. \n");
                                            break;

                                        case (3):
                                            logMsg("Toshiba G2 Error: Checksum error. \n");
                                            break;

                                        case (4):
                                            logMsg("Toshiba G2 Error: Illegal command. \n");
                                            break;

                                        case (5):
                                            logMsg("Toshiba G2 Error: Format error. \n");
                                            break;

                                        case (6):
                                            logMsg("Toshiba G2 Error: Communication is disabled. \n");
                                            break;

                                        default:
                                            logMsg("Toshiba G2 Error: Unknown Error Code [%f].\n", errorcode);
                                            break;
                                    }
                                }
                                punit->msgs++;
                                punit->responsetime += (tickGet() - msgstart);
                                return (XFERREJECT);
                            }
                            /* there was no problem. this a a good response */
                            punit->msgs++;
                            punit->responsetime += (tickGet() - msgstart);
                            return (XFERGOOD);
                        }
                        else
                        {
                            punit->no_chksumerrs++;
                            if (modtrace [line])
                            {
                                logMsg ("Checksum Message Length = %d\n", rxlen);
                                logMsg ("%c%c Bad Checksum\n",
                                         rxp->rxbuf [rxp->rxix - 4],
                                         rxp->rxbuf [rxp->rxix - 3]);
                            }
                            for (ix = 0; ix < rxlen; ix++)
                            {
                                if (modtrace [line])
                                {
                                    logMsg ("%x\n", rxp->rxbuf [ix]);
                                }
                            }
                        }
                    }
                }
                else if (rxstatus == IO_TIMEOUT)
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

                    if (modtrace [line])
                    {
                        logMsg ("Receive Timeout... Length: %d\n", rxlen);
                    }
                    if ((trace [line] & ALLTRAFFICTRACE) &&
                        ((traceadr [line] == txp->address) || (traceadr [line] == 255)) &&
                        ((tracetype [line] == txp->function) || (tracetype [line] == 255)) &&
                        ((tracenumber [line] == txp->number) || (tracenumber [line] == 255)))
                    {
                        printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                    }
                    punit->no_rxnoresp++;
                }
                else
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

                    if (modtrace [line])
                    {
                        logMsg ("Receive Error\n");
                        logMsg ("RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
                                 rxp->rxbuf[100],
                                 rxp->rxbuf[101],
                                 rxp->rxix);
                    }
                    punit->no_rxhwerrs++;
                }
            }
            else if (txstatus == IO_TIMEOUT)
            {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                if (modtrace [line])
                {
                    logMsg ("Transmit Timeout\n");
                }
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->address) || (traceadr [line] == 255)) &&
                    ((tracetype [line] == txp->function) || (tracetype [line] == 255)) &&
                    ((tracenumber [line] == txp->number) || (tracenumber [line] == 255)))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                }
                punit->no_txnoresp++;
            }
            else
            {
                if (modtrace [line])
                {
                    logMsg ("Transmit Error\n");
                }
                punit->no_txhwerrs++;
            }
            if (retry != MAXRETRYS)
               punit->no_retries++;
        }
        if (modtrace [line])
        {
            logMsg ("Xfer Bad\n");
        }
       	return (XFERBAD);
}
/*
** checkchksum  
**             
*/

static  void checkchksum (unsigned char *chkbuf, int len, char unsigned *retbuf)
{
    unsigned short  checksum;
    unsigned int    i, j;
    unsigned short  temp0, temp1;

    checksum = 0;
    for (j = 0; j < len; j++)
    {
        checksum += chkbuf [j];
    }
    checksum = checksum % 256;    
    temp0 = (checksum / 16) + '0';
    temp1 = (checksum % 16) + '0';
    if (temp0 > '9') temp0 += 7;
    if (temp1 > '9') temp1 += 7;
    retbuf [0] = temp0;
    retbuf [1] = temp1;
}

/*
**      init_unit_tab
**
**      The purpose of this routine is to initialize the line tables for the
**      analog devices I/O
**
*/
/* only called from allocate_unit  */

static	void init_unit_tab (unsigned short line, unsigned short unit)
{
    G2UNIT  *punit;

    punit = g2units [line] [unit];
    if (!punit)
    {
        return;
    }
    punit->is_responding = FALSE;
    punit->holdflag = FALSE;
    punit->was_requested = FALSE;
    punit->cmd_force_offline = FALSE;

    punit->holdoff = FALSE;

    initunit (punit);
    initstats (punit);

    /* Initialize this tasks semaphore*/

    semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
    semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
}
/*
** Cold Init a G2 Unit
**
*/
/* only called from init_line_tabs  */

static void initunit (G2UNIT  *punit)
{
    unsigned short i;

/*
**      Initialize RAM 
*/
    for (i = 0; (i < RAMDATASIZE); i++)
    {
        punit->ram [i].was_requested = FALSE;
        punit->ram [i].data_valid = FALSE;
        punit->ram [i].last_read = 0;
        punit->ram [i].last_fread = 0;
    }

/*
**      Initialize MONITOR STATUS 
*/
    for (i = 0; (i < MONDATASIZE); i++)
    {
        punit->monitor [i].was_requested = FALSE;
        punit->monitor [i].data_valid = FALSE;
        punit->monitor [i].last_read = 0;
        punit->monitor [i].last_fread = 0;
    }

/*
**      Initialize SYSTEM STATUS 
*/
    for (i = 0; (i < SYSDATASIZE); i++)
    {
        punit->system [i].was_requested = FALSE;
        punit->system [i].data_valid = FALSE;
        punit->system [i].last_read = 0;
    }
}
/*                                                            		
**                                                              	
** initialize the statistics for a G2 inverter unit                  	
**                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_line_tabs  */

static	void initstats (G2UNIT *punit)
{
    punit->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
    punit->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
    punit->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
    punit->no_txnoresp = 0;      /* 8  Count No Responses 		*/
    punit->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
    punit->no_retries = 0;       /* 10 Count Retries                    */
    punit->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
    punit->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
    punit->no_chksumerrs = 0;    /* 13 Count Chksum Errors 		*/
    punit->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
    punit->badoutcnt = 0;	 /* 17 Count failed output commands     */

    punit->tscanpass = 0;        /* unit scan pass counter           */
    punit->msgs = 0;             /* good response message counts     */
    punit->responsetime = 0;     /* total wait time for good messages*/
}


/*
**                                                                      
**      asciihex                                                    	
**                                                                      
**      The purpose of this routine is to convert the next 4 ascii      
**      characters in the buffer to hex and return them in val. It      
**      will return TRUE if good conversion or FALSE if bad.            
*/                                                                         	

static short asciihex (unsigned short *val, char *buf)
{
    unsigned short i, temp, x;

    x = 0;
    for (i = 0; i < 4; i++)
    {
        if (!oneascii (&temp, buf[i]))
        {
            return (FALSE);
        }
        x = (x << 4) + temp;
    }
    *val = x;
    return (TRUE);
}


static short oneascii (unsigned short *val, char ch)
{
    if ((ch < '0') || (ch > 'F'))
    {
        return (FALSE);
    }
    if (ch <= '9')
    {
        *val = ch & 0x0f;
    }
    else
    {
        if (ch < 'A')
        {
            return (FALSE);
        }
        else
        {
            *val = (ch - 'A') + 10;
        }
    }
    return (TRUE);
}

/*
**                                                                           
**      decascii                                                             
**                                                                           
**      The purpose of this routine is to convert val to decimal and fill    
**      in the buffer with the two least significant digit ascii characters. 
*/

static void decascii (unsigned short val, char *buf)
{
    unsigned short temp;

    temp = (val%100)/10; 
    buf[0] = temp + '0';
    temp = val%10;
    buf[1] = temp + '0';
    return;
}

/*
**                                                                           
**      floatascii                                                           
**                                                                           
**      The purpose of this routine is to convert val to a fixed 6 character 
**      ascii floating point format and store it in the specified buffer.    
*/

static void floatascii (float val, char *buf)
{
    long          temp;
    short         resolution, i;
    unsigned char ch;

    i = 0;
    resolution = 2;

    temp = (int)(val*100);      /* output up to 2 decimal places */
    temp = temp%1000000;        /* max val is 999900 */

    ch = temp/100000;

    if ( ch != 0)
    {
        resolution = 1;
        buf[i++] = ch + '0';
    }

    temp  = temp - (ch*100000);
    ch = temp/10000;
    buf[i++] = ch + '0';

    temp  = temp - (ch*10000);
    ch = temp/1000;
    buf[i++] = ch + '0';

    temp  = temp - (ch*1000);
    ch = temp/100;
    buf[i++] = ch + '0';

    buf[i++] = '.';

    temp  = temp - (ch*100);
    ch = temp/10;
    buf[i++] = ch + '0';

    if (resolution == 2)
    {
        temp  = temp - (ch*10);
        ch = temp/1;
        buf[i++] = ch + '0';
    }

    return;
}

/*
** makechksum  
**             
*/

static unsigned short makechksum (unsigned char *chkbuf, int len, char unsigned *retbuf)
{
    unsigned short  checksum;
    unsigned int    i, j;
    unsigned short  temp, temp0, temp1;

    /* Checksum: Leading Code */
    retbuf [0] = '&';

    checksum = 0;
    for (j = 0; j < len; j++)
    {
        checksum += chkbuf [j];
    }
    checksum += '&';
    checksum = checksum % 256;
    hexascii (checksum, &(retbuf[1]));
    retbuf [3] = ')';
    retbuf [4] = 0x0d;
    temp = len + 5;

    /* appended null characters used for message padding */
    retbuf [5] = 0;
    retbuf [6] = 0;
    retbuf [7] = 0;
    retbuf [8] = 0;
    retbuf [9] = 0;
    retbuf [10] = 0;
    retbuf [11] = 0;
    retbuf [12] = 0;
    return (temp);
}

/*                                                                           	
**     prepresponses                                                            
**                                                                             	
**      The purpose of this routine is to mark the G2 units as on hold and the 	
**	data as not valid until read again from each of the units              	
**                                                                           	
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)
{
    unsigned short	unit;
    G2UNIT		*punit;

    for (unit = 1; (unit <= NUMG2UNITS); unit++)
    {
        punit = g2units [line] [unit];
        if (punit)				/* verify pointer validity prior to use */
        {
            punit->holdflag = TRUE;
            mark_not_valid (punit);
        }
    }
}


/*                                                                  	
**      any_responding                                               	
**                                                                   	
**      The purpose of this routine is to see if any units are       	
**	responding on this line                                      	
**                                                                   	
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)
{
    unsigned short  unit;
    G2UNIT		*punit;

    for (unit = 1; (unit <= NUMG2UNITS); unit++)
    {
        punit = g2units [line] [unit];
        if (punit)			/* verify pointer validity prior to use */
        {
            /* check cmd_force_offline flag because it is set in an asynchronous task */
            if ((punit->is_responding) && (!punit->cmd_force_offline))
            {
                return (TRUE);
            }
        }
    }
    return (FALSE);
}

/*
** readzero                                                       	
**                                                                  	
*/
static	unsigned short readzero (unsigned short fline, unsigned short unit, G2UNIT *punit)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  i;
    unsigned short  length, status;
    unsigned short  floatlength;
             float  datavalue;

    unsigned short  line;

    /* strip off the no retry flag */
    line = (fline & (~ONERETRY));

    /* Count number of input messages */
    punit->no_datain_msgs++;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* set up selective traffic tracing parameters */
    txp->address = unit;
    txp->function = DATAREAD;
    txp->number = 0;

    /* Format the output message */
    txp->txbuf [0] =  '(';
    decascii (unit, &(txp->txbuf[1]));
    txp->txbuf [3] =  DATAREAD; /* Test mode */
    decascii (0, &(txp->txbuf[4]));
    length = makechksum (&(txp->txbuf [0]), DATAREADLEN, &(txp->txbuf [DATAREADLEN]));
    txp->txmsglen = length + padcount [line];

    /* Send out the message */
    status = msgxfer (fline, punit);
    if (status == XFERBAD)
    {
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    if (status == XFERREJECT)
    {
        punit->no_dataerr++;
        return (CMDREJECT);
    }

    /* Verify the unit response: Data Address */
    if ((rxp->rxbuf [4] != txp->txbuf[4]) ||    /* address (LSD) */
        (rxp->rxbuf [5] != txp->txbuf[5]))      /* address (LSD) */
    {
        punit->no_dataerr++;
        return (CMDFAIL);
    }

    /* everything looks good. go parse the data value itself */

    floatlength = rxp->rxix - 15;
    if (!parsefloat (&rxp->rxbuf [6], floatlength, &datavalue))
    {
        /* there was a conversion problem */
        punit->no_dataerr++;
        return (CMDFAIL);
    }

    return (CMDDONE);
}
/*
** readram                                                       	
**                                                                  	
*/
static	unsigned short readram (unsigned short fline, unsigned short unit,
                                G2UNIT *punit, unsigned short address)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  i;
    unsigned short  length, status;
    unsigned short  floatlength;
             float  datavalue;

    unsigned short  line;

    /* strip off the no retry flag */
    line = (fline & (~ONERETRY));

    /* Count number of input messages */
    punit->no_datain_msgs++;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* set up selective traffic tracing parameters */
    txp->address = unit;
    txp->function = DATAREAD;
    txp->number = address;

    /* Format the output message */
    txp->txbuf [0] =  '(';
    decascii (unit, &(txp->txbuf[1]));
    txp->txbuf [3] =  DATAREAD; /* Test mode */
    decascii (address, &(txp->txbuf[4]));
    length = makechksum (&(txp->txbuf [0]), DATAREADLEN, &(txp->txbuf [DATAREADLEN]));
    txp->txmsglen = length + padcount [line];

    /* Send out the message */
    status = msgxfer (fline, punit);
    if (status == XFERBAD)
    {
        punit->no_offlines++;
        punit->holdflag = TRUE;
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    if (status == XFERREJECT)
    {
        punit->no_dataerr++;
        return (CMDREJECT);
    }

    /* Verify the unit response: Data Address */
    if ((rxp->rxbuf [4] != txp->txbuf[4]) ||    /* address (LSD) */
        (rxp->rxbuf [5] != txp->txbuf[5]))      /* address (LSD) */
    {
        punit->no_dataerr++;
        return (CMDFAIL);
    }

    /* everything looks good. go parse the data value itself */

    floatlength = rxp->rxix - 15;
    if (!parsefloat (&rxp->rxbuf [6], floatlength, &datavalue))
    {
        /* there was a conversion problem */
        punit->no_dataerr++;
        return (CMDFAIL);
    }

    /* Store the returned data                      */
    punit->ram [address].last_fread = datavalue;
    punit->ram [address].last_read =  (unsigned short) datavalue%65535;
    punit->ram [address].data_valid = TRUE;

    return (CMDDONE);
}

/*                                                                	
** statusmonitor                                                        
**                                                                  	
*/
static	unsigned short statusmonitor (unsigned short fline, unsigned short unit,
                                      G2UNIT *punit, unsigned short address)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  i;
    unsigned short  length, status;
    unsigned short  floatlength;
             float  datavalue;
    unsigned short  hexlength;
             float  hexvalue;

    unsigned short  line;

    /* strip off the no retry flag */
    line = (fline & (~ONERETRY));

    /* Count number of input messages */
    punit->no_datain_msgs++;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* set up selective traffic tracing parameters */
    txp->address = unit;
    txp->function = STATUSMONITOR;
    txp->number = address;

    /* Format the output message */
    txp->txbuf [0] =  '(';
    decascii (unit, &(txp->txbuf[1]));
    txp->txbuf [3] =  STATUSMONITOR; /* status monitor */
    decascii (address, &(txp->txbuf[4]));
    length = makechksum (&(txp->txbuf [0]), STATUSMONITORLEN, &(txp->txbuf [STATUSMONITORLEN]));
    txp->txmsglen = length + padcount [line];

    /* Send out the message */
    status = msgxfer (fline, punit);
    if (status == XFERBAD)
    {
        punit->no_offlines++;
        punit->holdflag = TRUE;
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    if (status == XFERREJECT)
    {
        punit->no_dataerr++;
        return (CMDREJECT);
    }

    /* Verify the unit response: Data Address */
    if ((rxp->rxbuf [4] != txp->txbuf[4]) ||    /* address (LSD) */
        (rxp->rxbuf [5] != txp->txbuf[5]))      /* address (LSD) */
    {
        punit->no_dataerr++;
        return (CMDFAIL);
    }

    switch (address)
    {
        case 4:
        case 5:
            /* everything looks good. go parse the data value itself */
            hexlength = rxp->rxix-15;
            if (!parsehex (&rxp->rxbuf [6], hexlength, &hexvalue))
            {
                /* there was a conversion problem */
                punit->no_dataerr++;
                return (CMDFAIL);
            }
            /* Store the returned data                      */
            punit->monitor [address].last_fread = hexvalue;
            punit->monitor [address].last_read =  hexvalue;
            punit->monitor [address].data_valid = TRUE;
            break;
        case 0:
        case 1:
        case 2:
        case 3:
        case 6:
        case 7:
        case 8:
        case 9:
        default:
            /* everything looks good. go parse the data value itself */
            floatlength = rxp->rxix-15;
            if (!parsefloat (&rxp->rxbuf [6], floatlength, &datavalue))
            {
                /* there was a conversion problem */
                punit->no_dataerr++;
                return (CMDFAIL);
            }
            punit->monitor [address].last_fread = datavalue;
            punit->monitor [address].last_read =  (unsigned short) datavalue%65535;
            punit->monitor [address].data_valid = TRUE;
            break;
    }

    return (CMDDONE);
}

/*                                                                	
** writeram                                                       	
**                                                                  	
*/
static	unsigned short writeram (unsigned short fline, unsigned short unit,
                                G2UNIT *punit, unsigned short address, float value)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  index;
    unsigned short  length, status;
    unsigned short  floatlength;
    unsigned short  line;

    index = address - RAMBASE;

    /* strip off the no retry flag */
    line = (fline & (~ONERETRY));

    /* Count number of output messages */
    punit->no_dataout_msgs++;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* set up selective traffic tracing parameters */
    txp->address = unit;
    txp->function = WRITEDATA;
    txp->number = address;

    /* Format the output message */
    txp->txbuf [0] =  '(';
    decascii (unit, &(txp->txbuf[1]));
    txp->txbuf [3] =  WRITEDATA; /* Test mode */
    decascii (index, &(txp->txbuf[4]));
    floatascii (value, &(txp->txbuf[6]));
    length = makechksum (&(txp->txbuf [0]), WRITEDATALEN, &(txp->txbuf [WRITEDATALEN]));
    txp->txmsglen = length + padcount [line];

    /* Send out the message */
    status = msgxfer (fline, punit);
    if (status == XFERBAD)
    {
        punit->no_offlines++;
        punit->holdflag = TRUE;
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    if (status == XFERREJECT)
    {
        punit->no_dataerr++;
        return (CMDREJECT);
    }

    /* Verify the unit response: Data Address */
    if ((rxp->rxbuf [4] != txp->txbuf[4]) ||    /* address (LSD) */
        (rxp->rxbuf [5] != txp->txbuf[5]))      /* address (LSD) */
    {
        punit->no_dataerr++;
        return (CMDFAIL);
    }
    punit->ram[index].last_fwrite = value;
    return (CMDDONE);
}

/*
** writerun                                                       	
**                                                                  	
*/
static	unsigned short writerun (unsigned short fline, unsigned short unit,
                                 G2UNIT *punit, unsigned short address,
                                 unsigned short signal)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  index;
    unsigned short  length, status;
    unsigned short  line;


    index = address - COMBASE;

    /* strip off the no retry flag */
    line = (fline & (~ONERETRY));

    /* Count number of output messages */
    punit->no_dataout_msgs++;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* set up selective traffic tracing parameters */
    txp->address = unit;
    txp->function = RUNMODE;
    txp->number = signal;

    /* Format the output message */
    txp->txbuf [0] =  '(';
    decascii (unit, &(txp->txbuf[1]));
    txp->txbuf [3] =  RUNMODE; /* Run Mode Command */
    txp->txbuf [4] = signal + '0';
    length = makechksum (&(txp->txbuf [0]), RUNMODELEN, &(txp->txbuf [RUNMODELEN]));
    txp->txmsglen = length + padcount [line];

    punit->commands[index].was_requested = TRUE;

    /* Send out the message */
    status = msgxfer (fline, punit);
    if (status == XFERBAD)
    {
        punit->no_offlines++;
        punit->holdflag = TRUE;
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    if (status == XFERREJECT)
    {
        punit->no_dataerr++;
        return (CMDREJECT);
    }

    punit->commands[index].data_valid = TRUE;
    punit->commands[index].last_write = signal;
    return (CMDDONE);
}
/*
** writestop                                                       	
**                                                                  	
*/
static	unsigned short writestop (unsigned short fline, unsigned short unit,
                                  G2UNIT *punit, unsigned short address,
                                  unsigned short signal)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  index;
    unsigned short  length, status;
    unsigned short  line;

    index = address - COMBASE;

    /* strip off the no retry flag */
    line = (fline & (~ONERETRY));

    /* Count number of output messages */
    punit->no_dataout_msgs++;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* set up selective traffic tracing parameters */
    txp->address = unit;
    txp->function = STOPMODE;
    txp->number = signal;

    /* Format the output message */
    txp->txbuf [0] =  '(';
    decascii (unit, &(txp->txbuf[1]));
    txp->txbuf [3] =  STOPMODE; /* Stop Mode Command */
    txp->txbuf [4] = signal + '0';
    length = makechksum (&(txp->txbuf [0]), STOPMODELEN, &(txp->txbuf [STOPMODELEN]));
    txp->txmsglen = length + padcount [line];

    punit->commands[index].was_requested = TRUE;

    /* Send out the message */
    status = msgxfer (fline, punit);
    if (status == XFERBAD)
    {
        punit->no_offlines++;
        punit->holdflag = TRUE;
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    if (status == XFERREJECT)
    {
        punit->no_dataerr++;
        return (CMDREJECT);
    }

    punit->commands[index].data_valid = TRUE;
    punit->commands[index].last_write = signal;
    return (CMDDONE);
}
/*
** writejog                                                       	
**                                                                  	
*/
static	unsigned short writejog (unsigned short fline, unsigned short unit,
                                 G2UNIT *punit, unsigned short address,
                                 unsigned short signal)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  index;
    unsigned short  length, status;
    unsigned short  line;

    index = address - COMBASE;

    /* strip off the no retry flag */
    line = (fline & (~ONERETRY));

    /* Count number of output messages */
    punit->no_dataout_msgs++;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* set up selective traffic tracing parameters */
    txp->address = unit;
    txp->function = JOGMODE;
    txp->number = signal;

    /* Format the output message */
    txp->txbuf [0] =  '(';
    decascii (unit, &(txp->txbuf[1]));
    txp->txbuf [3] =  JOGMODE; /* Jog Mode Command */
    txp->txbuf [4] = signal + '0';
    length = makechksum (&(txp->txbuf [0]), JOGMODELEN, &(txp->txbuf [JOGMODELEN]));
    txp->txmsglen = length + padcount [line];

    punit->commands[index].was_requested = TRUE;

    /* Send out the message */
    status = msgxfer (fline, punit);
    if (status == XFERBAD)
    {
        punit->no_offlines++;
        punit->holdflag = TRUE;
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    if (status == XFERREJECT)
    {
        punit->no_dataerr++;
        return (CMDREJECT);
    }

    punit->commands[index].data_valid = TRUE;
    punit->commands[index].last_write = signal;
    return (CMDDONE);
}
/*                                                                              
** writeemergencystop                                                       	
**                                                                  	        
*/
static	unsigned short writeemergencystop (unsigned short fline, unsigned short unit,
                                           G2UNIT *punit, unsigned short address,
                                           unsigned short signal)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  index;
    unsigned short  length, status;
    unsigned short  line;

    index = address - COMBASE;

    /* strip off the no retry flag */
    line = (fline & (~ONERETRY));

    /* Count number of output messages */
    punit->no_dataout_msgs++;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* set up selective traffic tracing parameters */
    txp->address = unit;
    txp->function = EMERGENCYSTOP;

    /* Format the output message */
    txp->txbuf [0] =  '(';
    decascii (unit, &(txp->txbuf[1]));
    txp->txbuf [3] =  EMERGENCYSTOP; /* Emergency Stop Command */
    length = makechksum (&(txp->txbuf [0]), EMERGENCYSTOPLEN, &(txp->txbuf [EMERGENCYSTOPLEN]));
    txp->txmsglen = length + padcount [line];

    punit->commands[index].was_requested = TRUE;

    /* Send out the message */
    status = msgxfer (fline, punit);
    if (status == XFERBAD)
    {
        punit->no_offlines++;
        punit->holdflag = TRUE;
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    if (status == XFERREJECT)
    {
        punit->no_dataerr++;
        return (CMDREJECT);
    }

    punit->commands[index].data_valid = TRUE;
    punit->commands[index].last_write = signal;
    return (CMDDONE);
}


/*                                                                              
** writetripclear                                                       	
**                                                                  	        
*/
static	unsigned short writetripclear (unsigned short fline, unsigned short unit,
                                       G2UNIT *punit, unsigned short address,
                                       unsigned short signal)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  index;
    unsigned short  length, status;
    unsigned short  line;

    index = address - COMBASE;

    /* strip off the no retry flag */
    line = (fline & (~ONERETRY));

    /* Count number of output messages */
    punit->no_dataout_msgs++;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line];
    rxp = rxlinetab [line];

    /* set up selective traffic tracing parameters */
    txp->address = unit;
    txp->function = TRIPCLEAR;

    /* Format the output message */
    txp->txbuf [0] =  '(';
    decascii (unit, &(txp->txbuf[1]));
    txp->txbuf [3] =  TRIPCLEAR; /* Trip Clear Command */
    length = makechksum (&(txp->txbuf [0]), TRIPCLEARLEN, &(txp->txbuf [TRIPCLEARLEN]));
    txp->txmsglen = length + padcount [line];

    punit->commands[index].was_requested = TRUE;

    /* Send out the message */
    status = msgxfer (fline, punit);
    if (status == XFERBAD)
    {
        punit->no_offlines++;
        punit->holdflag = TRUE;
        punit->is_responding = FALSE;
        return (CMDFAIL);
    }

    if (status == XFERREJECT)
    {
        punit->no_dataerr++;
        return (CMDREJECT);
    }

    punit->commands[index].data_valid = TRUE;
    punit->commands[index].last_write = signal;

    /* the g2+ unit is non-responsive for a 5 sec interval after trip clear */
    punit->holdoff = TRUE;
    punit->holdofftick = tickGet();

    return (CMDDONE);
}
/*
**      hexascii                                                            	
**                                                                          	
**      The purpose of this routine is to convert the hex byte to 2 ascii   	
**      characters and to place them into the buffer.                       	
**                                                                          	
*/
/* not called from within this driver */


static	void hexascii (unsigned short val, char *buf)
{
    char    hi, lo;

    hi = ((val & 0x0f0) >> 4);
    lo = (val & 0x0f);

    if (hi <= 9)
    {
        hi+='0';
    }
    else
    {
        hi += ('A' - 10);
    }
    if (lo <= 9)
    {
        lo += '0';
    }
    else
    {
        lo += ('A' - 10);
    }
    buf [0] = hi;
    buf [1] = lo;
}
/*                                                                               
**   parsefloat                                                                  
**                                                                         	 
**      The purpose of this routine is to convert the specified number of ascii  
**      characters in the buffer as a floating point value and return it in val. 
**      It will return TRUE if good conversion of FALSE if bad.                  
*/                                                                         	
/* not called from within this driver */

static short parsefloat (char *buf, unsigned short length, float *datavalue)
{
    unsigned short i, dpflag, multiplier, divisor, digit;
             float temp;

    dpflag = FALSE;
    multiplier = 10;
    divisor = 1;
    temp = 0;

    for (i = 0; i < length; i++)
    {
        if (buf[i] == '.')
        {
            if (dpflag)
            {
                return (FALSE);
            }
            else
            {
                dpflag = TRUE;
                multiplier = 1;
            }
        }  
        else
        {
            if (dpflag)
            {
                divisor = divisor * 10;
            }
            if (onefascii(&digit, buf[i]))
            {
                /* only 0 - 9 are valid digits */
                if ( digit > 9)
                {
                    return (FALSE);
                }
                temp = (temp*multiplier) + (((float) digit)/divisor);
            }
            else
            {
                return (FALSE);
            } 
	}
    }
    *datavalue = temp; 
    return (TRUE);
}

static short onefascii (unsigned short *val, char ch)
{
    if ((ch < '0') || (ch > 'F'))
    {
        return (FALSE);
    }
    if (ch <= '9')
    {
        *val = ch & 0x0f;
    }
    else
    {
        if (ch < 'A')
        {
            return (FALSE);
        }
        else
        {
            *val = (ch - 'A') + 10;
        }
    }
    return (TRUE);
}
/*
**   parsehex                                                                   
**                                                                         	
**      The purpose of this routine is to convert the specified number          
**      of ascii hexidecimal characters in the buffer to hex and return         
**      them in datavalue. Return TRUE if good conversion of FALSE if bad.      
*/                                                                         	
/* not called from within this driver */

static short parsehex (char *buf, unsigned short length, float *datavalue)
{
    unsigned short i, digit;
    float temp;

    temp = 0;

    for (i = 0; i < length; i++)
    {
        if (onefascii(&digit, buf[i]))
        {
            temp = (temp*16) + (float) digit;
        }
        else
        {
            return (FALSE);
        } 
    }
    *datavalue = temp; 
    return (TRUE);
}

/*
**      DUMPMSGCNTS
**
**      The purpose of this routine is to dump the line level statistics for this driver. 
**
*/
/* called from TABLEINFO */

void DUMPMSGCNTS (unsigned short line)

    {
        unsigned long	temp, t, x, y, z;

        temp = tickGet ();
        t = (temp - linestats [line].startingtick);

 	x = linestats [line].TXintcount;
	y = linestats [line].RXintcount;
	z = linestats [line].msgxfercount;

        if (z == 0)
        {
            printf (" ******  No Messages Transferred ****** \n");
            return;
        }

 	printf ("\n");
	printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
 	printf ("\n");
 	printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
 	printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
 	printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
 	printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
 	printf ("\n");
 	printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
 	printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
 	printf ("\n");
	printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
	printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
 	printf ("\n");
        return;
}

/*
**      CLEARMSGCNTS
**
**      The purpose of this routine is to dump and clear the line level statistics
**      for this driver.
**
*/
/* called from TABLEINFO */

void CLEARMSGCNTS (unsigned short line)

{
        DUMPMSGCNTS (line);

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].msgxfercount = 0;

        linestats [line].startingtick = tickGet ();
	printf (" ******  All Counts Cleared  ****** \n", linestats [line].msgxfercount);
 	printf ("\n");
        return;
}

/*
**      DUMPUNITSTATS
**
**      The purpose of this routine is to dump the unit level statistics for this driver.
**
*/
/* called from TABLEINFO */

void DUMPUNITSTATS (unsigned short line, unsigned short maddr)

{
    G2UNIT         *punit;
    unsigned long   microsecs;

    punit = g2units [line] [maddr];
    if (!punit)
    {
        logMsg ("Line/G2 Address Not Defined \n");
        return;
    }

    printf (" Was requested = %d \n", punit->was_requested);
    printf (" Is responding = %d \n", punit->is_responding);
    printf (" # Output messages = %d \n", punit->no_dataout_msgs & 0x7fff);
    printf (" # Data in messages = %d \n", punit->no_datain_msgs & 0x7fff);
    printf (" #No Rx Response = %d \n", punit->no_rxnoresp & 0x7fff);
    printf (" #No Tx Responses = %d \n", punit->no_txnoresp & 0x7fff);
    printf (" #Data Errors = %d \n", punit->no_dataerr & 0x7fff);
    printf (" #Retries = %d \n", punit->no_retries & 0x7fff);
    printf (" #Rx Hw Errors = %d \n", punit->no_rxhwerrs & 0x7fff);
    printf (" #Tx Hw Errors = %d \n", punit->no_txhwerrs & 0x7fff);
    printf (" #Chksum Errors = %d \n", punit->no_chksumerrs & 0x7fff);
    printf (" #Off Lines = %d \n", punit->no_offlines & 0x7fff);
    printf (" Reset Statistics = %d \n", punit->cmd_reset_stat);
    printf (" Force Offline = %d \n", punit->cmd_force_offline);
    printf (" #Failed Outputs = %d \n", punit->badoutcnt & 0x7fff);
    printf ("\n");

    printf ("\n");
    printf (" # of Completed Messages %d \n", punit->msgs);
    printf (" Total Response Time (in ticks) = %lu \n", punit->responsetime);
    printf ("   (includes retries prior to each completed message)\n");
    if (punit->msgs)
    {
        printf ("   Average response time (ticks) = %d \n", (punit->responsetime/punit->msgs));
        microsecs = (16667*punit->responsetime)/punit->msgs;
        printf ("   Average response time (msec) = %d.%1d \n", microsecs/1000, (microsecs%1000)/100);
    }
    printf (" # of scan passes = %d \n", punit->tscanpass);
    printf ("\n");

    printf (" Resource Responding = %d \n", resresponse[line]);
    printf (" Hold flag  = %d \n", punit->holdflag );
    return;
}

/*
**      CLEARUNITSTATS
**
**      The purpose of this routine is to clear the unit level statistics for this driver.
**
*/
/* called from TABLEINFO */

void CLEARUNITSTATS (unsigned short line, unsigned short maddr)
{
    G2UNIT		*punit;

    punit = g2units [line] [maddr];
    if (!punit)
    {
        logMsg ("Line/G2 Address Not Defined \n");
        return;
    }

    initstats (punit); /* use existing procedure */
    return;
}

/*
**      dump_g2_table
**                                                                           	
**      The purpose of this routine is twofold:                                 
**         1) dump the unit level statistics for the Toshiba G2 driver.         
**         2) dump the data for the specified Toshiba G2 unit.                  
**                                                                              
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)
{
    G2UNIT		*punit;
    short           ix;
    unsigned	short	i, n, j; 

    unsigned	short req, val, value, addr, firstaiinblk, firstreginblk, linecnt;
    unsigned	long	bigvalue;
    unsigned	char	buffer [200];


    punit = g2units [line] [maddr];
    if (!punit)
    {
        logMsg("Line/G2 Address Not Defined \n");
        return;
    }

    /* previously integral code moved to seperate procedure for debugging convenience */
    DUMPUNITSTATS (line, maddr);

    /************/
    /* RAM DATA */
    /************/
    linecnt = 1;
    printramhdr (buffer, &linecnt);
    addr = 0;
    for (i = 0; i < RAMDATASIZE; i += 4)
    {
        printf("%4d   ", addr+RAMBASE);
        for (n = 0; n < 4; n++)
        {		
            printf("%1x,%1x:%4d,%7.2f,%7.2f     ",
                          punit->ram[i].was_requested,
                          punit->ram[i].data_valid,
                          punit->ram[i].last_read,
                          punit->ram[i].last_fread,
                          punit->ram[i].last_fwrite);
        }
        printf ("\n");
        linecnt += 1;
        if ( (linecnt >= 17) && ((i + 4) < RAMDATASIZE) )
        {
            linecnt = 1;
            printramhdr(buffer, &linecnt);
        }
        addr += 4;
    }

    /****************/
    /* MONITOR DATA */
    /****************/
    linecnt = 1;
    printmonitorhdr (buffer, &linecnt);
    addr = 0;
    for (i = 0; i < MONDATASIZE; i += 4)
    {
        printf("%4d   ", addr+MONBASE);
        for (n = 0; n < 4; n++)
        {		
            printf("%1x,%1x: 0x%4x, %7.2f      ",
                          punit->monitor[i].was_requested,
                          punit->monitor[i].data_valid,
                          punit->monitor[i].last_read,
                          punit->monitor[i].last_fread);

        }
        printf ("\n");
        linecnt += 1;
        if ( (linecnt >= 17) && ((i + 4) < MONDATASIZE) )
        {
            linecnt = 1;
            printmonitorhdr(buffer, &linecnt);
        }
        addr += 2;		
    }

    /***************/
    /* SYSTEM DATA */
    /***************/
    linecnt = 1;
    printsystemhdr (buffer, &linecnt);
    addr = 0;
    for (i = 0; i < SYSDATASIZE; i += 4)
    {
        printf("%4d   ", addr+SYSBASE);
        for (n = 0; n < 4; n++)
        {		
            printf("%1x,%1x: 0x%4x      ",
                          punit->system[i].was_requested,
                          punit->system[i].data_valid,
                          punit->system[i].last_read);


        }
        printf ("\n");
        linecnt += 1;
        if ( (linecnt >= 17) && ((i + 4) < SYSDATASIZE) )
        {
            linecnt = 1;
            printsystemhdr(buffer, &linecnt);
        }
        addr += 2;		
    }

    /****************/
    /* COMMAND DATA */
    /****************/
    linecnt = 1;
    printcommandshdr (buffer, &linecnt);
    addr = 0;
    for (i = 0; i < COMDATASIZE; i += 4)
    {
        printf("%4d   ", addr+COMBASE);
        for (n = 0; n < 4; n++)
        {		
            printf("%1x,%1x: 0x%4x      ",
                          punit->commands[i].was_requested,
                          punit->commands[i].data_valid,
                          punit->commands[i].last_write);


        }
        printf ("\n");
        linecnt += 1;
        if ( (linecnt >= 17) && ((i + 4) < COMDATASIZE))
        {
            linecnt = 1;
            printcommandshdr(buffer, &linecnt);
        }
        addr += 2;		
    }
}


/*
** only called from dump_g2_table
*/


static void printramhdr (unsigned char *buffer, unsigned short *cnt)
{	
    taskDelay (60);
    printf ("\n");
    sprintf (buffer,"                         TOSHIBA G2 UNIT REPORT:  RAM DATA");
    printf ( "%s\n", buffer);
    *cnt += 1;
    printf ("\n");
    *cnt += 1;
    sprintf (buffer,
    "Addr   R,V VAL,   RDVAL,  WRVAL     R,V:VAL,   RDVAL,  WRVAL     R,V:VAL,   RDVAL,  WRVAL     R,V:VAL,   RDVAL,  WRVAL");
    printf ( "%s\n", buffer);
    *cnt += 1;
}
/*
** only called from dump_g2_table
*/


static void printmonitorhdr (unsigned char *buffer, unsigned short *cnt)
{
    taskDelay (60);
    printf ("\n");
    sprintf (buffer,"                         TOSHIBA G2 UNIT REPORT:  MONITOR DATA");
    printf ( "%s\n", buffer);
    *cnt += 1;
    printf ("\n");
    *cnt += 1;
    sprintf (buffer,
    "Addr   R,V: VAL,      RDVAL      R,V: VAL,      RDVAL      R,V: VAL,      RDVAL      R,V: VAL,      RDVAL");
    printf ( "%s\n", buffer);
    *cnt += 1;
}
/*
** only called from dump_g2_table
*/


static void printsystemhdr(unsigned char *buffer, unsigned short *cnt)
{
    taskDelay (60);
    printf ("\n");
    sprintf (buffer,"                         TOSHIBA G2 UNIT REPORT:  SYSTEM DATA");
    printf ( "%s\n", buffer);
    *cnt += 1;
    printf ("\n");
    *cnt += 1;
    sprintf (buffer, "Addr   R,V: VAL         R,V: VAL         R,V: VAL         R,V: VAL");
    printf ( "%s\n", buffer);
    *cnt += 1;
}


/*
** only called from dump_g2_table
*/


static void printcommandshdr (unsigned char *buffer, unsigned short *cnt)
{
    taskDelay (60);
    printf ("\n");
    sprintf (buffer,"                         TOSHIBA G2 UNIT REPORT:  COMMANDS DATA");
    printf ( "%s\n", buffer);
    *cnt += 1;
    printf ("\n");
    *cnt += 1;
    sprintf (buffer,"Addr   R,V: VAL         R,V: VAL         R,V: VAL         R,V: VAL");
    printf ( "%s\n", buffer);
    *cnt += 1;
}
/*                                                                       
**      unit info                                                        
**                                                                       
**      The purpose of this routine is to list summary information       
**        for all G2 units allocated and referenced on this line.        
**
*/
/* not called from within this driver */

void UNITINFO (unsigned short line)
{
    G2UNIT          *punit;
    unsigned short   i, n;

    unsigned short   addr, linecnt;
    unsigned char    buffer [200];

    printunithdr (buffer, linecnt);
    for (i = 0; i < NUMG2UNITS; i++)
    {
        punit = g2units [line] [i];
        if (punit)
        {
            linecnt = 1;
            printf(" %2d:    %1d   %1d   %1d    %5d  %5d  %5d  %5d  %5d  %5d   %5d   %5d\n",
                    i,
                    punit->was_requested,
                    punit->is_responding,
                    punit->cmd_force_offline,
                    punit->no_datain_msgs & 0x7fff,
                    punit->no_dataout_msgs & 0x7fff,
                    punit->no_txnoresp & 0x7fff,
                    punit->no_rxnoresp & 0x7fff,
                    punit->no_dataerr & 0x7fff,
                    punit->no_retries & 0x7fff,
                    punit->no_chksumerrs & 0x7fff,
                    punit->no_offlines & 0x7fff);
            linecnt += 1;
            if ((linecnt >= 20) && ((i + 1)  < NUMG2UNITS))
            {
                linecnt = 1;
                printmodhdr(buffer, linecnt);
            }
        }
    }
    printf ("\n");
}
/*
** only called from dump_mod_table 
*/
static void printunithdr (unsigned char *buffer, unsigned short cnt)
{    
    taskDelay (30);
    printf ("\n");
    sprintf (buffer,
      "                TOSHIBA G2 INVERTER UNIT CONFIGURATION INFO");
    printf ( "%s\n", buffer);
/*    cnt += 1; */
    sprintf (buffer,
      " UNIT  -- Status --     # Messages   ---------- Comm Error Counts by Type ---------- ");
    printf ( "%s\n", buffer);
    sprintf (buffer,
      " NMBR  Req Res FOL     In     Out    NoTx   NoRx   DatEr  Retry  Chksm  Offln ");
    printf ( "%s\n", buffer);
/*    cnt += 1; */
}


/*
**                                                                	 	
**	The purpose of this routine is to display the contents            	
**	of the static variables contained within this driver.             	
**                                                                        	
*/

/* this routine not called from within this driver */


LINEINFO ()
{
	short	i;
	char	buffer [132];
	char	*resrsp;
	char	*lineact;


        printf ("                                 Toshiba G2 Line Information Table          \n");
        printf ("\n");
        printf (" Line        Pointer to        Resource      Resource");
        printf ("       Line        Delay Times:       Activity\n");
        printf ("Number      G2UNIT Table         Name        Response");
        printf ("     Activity      IM  .TX  TX.         Time\n");
	printf ("\n");

	for (i = 0; i < G2LINES; i++)
	{
	    if(g2units [i] == NULL)
	    {
		continue;
	    }
	    if (resresponse [i] == 0)
	    {
		resrsp = "FALSE";
	    }
	    else
	    {
		resrsp = "TRUE";
	    }
	    if (line_activity [i] == 0)
	    {
		lineact = "FALSE";
	    }
	    else
	    {
		lineact = "TRUE";
	    }
	    sprintf (buffer,
                       "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
			i,g2units[i],&resnames[i],
			&resrsp[0],
			&lineact[0],
			intermsgdelay[i],
			pretxdelay[i],
			posttxdelay[i],
			activity_time[i]);
	    printf ( "%s\n", buffer);
	}
	return 0;
}
/*	End of File:	drvTosg2.c */
