/*drvTrane_proto.h,v 1.1.1.1 1999/08/03 14:45:09 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/* Name: drvTrane_proto.h */

static	long init ();

	void TRACEON (unsigned short line);

	void TRACEOFF (unsigned short line);

	void TRAFFICON (unsigned short line);

	void TRAFFICOFF (unsigned short line);

	void RTRACELEVEL (unsigned short line, unsigned short level);

	void RTRACEON (unsigned short line);

	void RTRACEOFf (unsigned short line);

	void TRACELEVEL (unsigned short line, unsigned short level);

	int STOPDRIVER (short ln);

        int STARTDRIVER  (unsigned short line,      /* the line number of this driver.               */
                          char *mode,               /* UART initializations string.                  */
                          unsigned short delay,     /* intermessage delay value, expressed in ticks. */
                          unsigned char driver_net, /* unique value used to identify both the local  */
                                                    /* driver's BACnet network number and its local  */
                                                    /* MAC address on this same network.             */
                          unsigned char BCU_net);   /* unique value, configured in the BCU, which    */
                                                    /* is used to identify both the BCU's BACnet     */
                                                    /* network number and its local MAC address.     */

	void SETCOMM (unsigned short line,
                      unsigned short tickcount1);


        void MAIN (unsigned short line,      /* the line number of this driver.               */
                   unsigned char *mode,      /* UART initializations string.                  */
                   unsigned short delay,     /* intermessage delay value, expressed in ticks. */
                   unsigned char driver_net, /* unique value used to identify both the local  */
                                             /* driver's BACnet network number and its local  */
                                             /* MAC address on this same network.             */
                   unsigned char BCU_net);   /* unique value, configured in the BCU, which    */
                                             /* is used to identify both the BCU's BACnet     */
                                             /* network number and its local MAC address.     */

static  void getsemaphore(unsigned short line);

static 	void on_line (unsigned short line);

static 	void mark_not_valid (BCU  *pbcu);

static	void scan_bcu (unsigned short line);

static	void checkoutputs (unsigned short line);

	int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, short *pvalue,
	    unsigned short conversion, unsigned char *resname);

	int AODRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal,double dvalue, unsigned short value,
	    unsigned short conversion, unsigned char *resname);

	int AOREAD (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned short *pvalue,
	    unsigned short conv, unsigned char *resname);

	int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned long mask,
	    unsigned long *pvalue, unsigned char *resname);

	int BODRIVER (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned long value,
	    unsigned long mask, unsigned char *resname);

	int BOREAD (char *pointname, unsigned short link, unsigned short adapter,
	    unsigned short card, unsigned short signal, unsigned long *pvalue,
	    unsigned long mask, unsigned char *resname);

static void  register_resource (unsigned short link, BCU *pbcu,
                                unsigned char *resname, char *pointname);

static	void outqueinit (unsigned short line);

static	OUTQENT *ogetemptyp (unsigned short line);

static	void omarkfull (unsigned short line);

static	OUTQENT *ogetnextp (unsigned short line);

static	void oreleasefull (unsigned short line);

static	void link_status (unsigned short line);

static 	int allocate_bcu (unsigned short line);

static	int check_line_activity (unsigned short line, unsigned short predelay);

static	void init_bcu_tab (unsigned short line, BCU  *pbcu);

static 	void initplc (BCU  *pbcu);

static	void initstats (BCU *pbcu);

static	void prepresponses (unsigned short line);

static	int any_responding (unsigned short line);


/********************************/
/* application layer procedures */
/********************************/

static	void initapplicationlayer (BCU *pbcu);

static	unsigned short launch_read (unsigned short line, BCU *pbcu);

static	unsigned short readbinaryoutputs (unsigned short line, BCU *pbcu);

static	unsigned short readbinaryinputs   (unsigned short line, BCU *pbcu);

static	unsigned short readanaloginputs   (unsigned short line, BCU *pbcu);

static	unsigned short readanalogoutputs  (unsigned short line, BCU *pbcu);

static	unsigned short setbinaryoutputs (unsigned short line,
		       BCU *pbcu, unsigned short bitaddr, unsigned long mask,
		       unsigned long val);

static	unsigned short setanalogoutputs (unsigned short line,
		       BCU *pbcu, unsigned short analogoutputaddr, unsigned short val,
		       double dblval, unsigned short conv);

static unsigned short deliver_inputAPDU(unsigned short line, BCU *pbcu,
                                        unsigned short srcnet,
                                        unsigned short srcmac,
                                        unsigned short desnet,
                                        unsigned short desmac,
                                        unsigned char *msgaddress,
                                        unsigned short msglength);

static unsigned short process_inputAPDU (unsigned short line);

static void clientAPDUHandler(unsigned short line, unsigned char raw);

static void serverAPDUHandler(unsigned short line, unsigned char raw);


/********************************/
/* network layer procedures     */
/********************************/

static	void initnetworklayer (BCU *pbcu);

static unsigned short deliver_inputNPDU(unsigned short line, BCU *pbcu);

static unsigned short process_inputNPDU(unsigned short line, BCU *pbcu);

static unsigned short build_NPDU(unsigned short line, BCU *pbcu);

/********************************/
/* data link layer procedures   */
/********************************/

static	void initdatalayer (BCU *pbcu);

static	unsigned short  bcu_connect (unsigned short line);

static	void  bcu_disconnect (unsigned short line);

static	void  forced_bcu_disconnect (unsigned short line);

static	unsigned short  output_connectinit (unsigned short line, BCU *pbcu);

static	unsigned short  send_data (unsigned short line, BCU *pbcu);

static	unsigned short  output_data (unsigned short line, BCU *pbcu);

static	unsigned short  send_frame (unsigned short line, unsigned char frametype, unsigned short length);

static	void  manage_output_state (unsigned short line, BCU *pbcu);

static	unsigned short  receive_frame (unsigned short line, BCU *pbcu);

static	void  parse_frame (unsigned short line, BCU *pbcu);

/*********************************/
/* physical/int layer procedures */
/*********************************/

static	void rxrawqueinit (unsigned short line);

static	RXRAW *rxrawgetemptyp (unsigned short line);

static	void rxrawmarkfull (unsigned short line);

static	RXRAW *rxrawgetnextp (unsigned short line);

static	void rxrawreleasefull (unsigned short line);

static	void start_rx (unsigned short line);

static	void next_rx (unsigned short line);

static	void stop_rx (unsigned short line);

static	void rx_int_proc (unsigned short line);

static void rxrawprocess(unsigned short line);

static unsigned char makeheadercrc(unsigned char dataValue, unsigned char crcValue);

static unsigned short makedatacrc(unsigned char dataValue, unsigned short crcValue);

static	void start_tx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus);

/* static	void stop_tx (unsigned short line); */

static void tx_int_proc (unsigned short line);

unsigned short txout(unsigned short line, unsigned char txchar);



/* end of file: drvTrane_proto.h */

