/*atcamain.h,v 1.1.1.1 1999/08/03 14:41:37 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#include <lpixport.h>			/* Lotus Add-in ToolKit defs */
#include "db_access.h"			/* for real DBF_XXXX defs */
#include "cadef.h"			/* EPICS channel access defs */
#include "lstLib.h"			/* linked list library */

#define	GETVALUE_NAME	("GETVALUE")
#define PUTNUMBER_NAME	("PUTNUMBER")
#define	PUTSTRING_NAME	("PUTSTRING")

#define MIN_TIMEOUT	(0.1)		/* minimum channel access timeout in seconds */
#define PV_NAME_LENGTH	(48)		/* max size of PV plus '.' and field name */
#define STRING_VALUE_LENGTH	(100)	/* max size of string I/O value GCT 26-Aug-96 increase to 100 from 34*/
#define	NUM_ARGS	(2)		/* total number of accepted arugments get/put */
#define	FIRST_ARG	(0)
#define	SECOND_ARG	(1)
/*
	The following structure will be allocated when the process variable name supplied
	with the '@' function is NOT found. When this happens the channel ID for that
	variable will be used to add the point to the event handler list. The user variable
	that may be supplied with the 'ca_add_event' function will be the address of this
	ENTRY. On subsequent invocations of the '@' function, the table will be searched
	for the supplied process variable. When found, the value stored in the table will
	be returned to the spreadsheet. The event handler will be called asyncronously to
	123 any time the value of the points in its list have changed. The 'get' function
	will block on a 'ca_pend_event' before fetching the value. This means that the
	spreadsheet will lock-up until something happens!
*/
typedef	union
	{
	char	byte_value;				/* union of possible values */
	long	long_value;				/* based on type from event handler */
	short	short_value;
	float	float_value;
	} CA_VALUE;
#define	VALUE_SIZE	sizeof(CA_VALUE)

typedef struct table_entry
	{
	NODE		next;				/* next node in list or 0 if last */
	char		var[PV_NAME_LENGTH];
	CA_VALUE	value;
	CA_VALUE	lastvalue;			/* equal to current if changed */
	char		string[STRING_VALUE_LENGTH];	/* for those who return strings */
	char		laststring[STRING_VALUE_LENGTH]; /* for those who return strings */
	long		type;				/* returned type of value as DBF_XXXX */
	chid		channel_id;			/* channel ID for 'ca_put' */
	int			valid;				/* if 1 then data has been received */
	int			firstConnect;		/* 1 means CA connected alt least once */
	} ENTRY;					/* table entry structure */
#define	ENTRY_SIZE (sizeof(ENTRY))			/* for malloc */

void	atcaMonitor();
void	atcaRead();
void	atcaConnect();
void	ATCA_FreeMem();
void	ATCA_SetValue();
ENTRY	*ATCA_Search();
ENTRY	*ATCA_ProcessPoint();
