#ifndef	alcfginfodialogclassHXX
#define	alcfginfodialogclassHXX

//** INFO DIALOG **************************************************************

class alCfgInfoApplyButtonClass;
class alCfgInfoDismissButtonClass;
class alCfgInfoClearButtonClass;

class	alCfgInfoDialogClass : public vdialog
{
    // pointer to mainDialog
    alCfgApplication		*app;
    alCfgMainDialogClass	*mainDialog;
    vstr			*title;
    GROUPINFO_PTR		newInfo;
    TREENODE_PTR		treeNode;
    int				modified;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(alCfgInfoDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(alCfgInfoDialogClass, vdialog);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    void infoOpen ( alCfgMainDialogClass *mainDialog, TREENODE_PTR node);

    // normal mode values
    filteredTextitem		*nMinorPrinter;
    filteredTextitem		*nMajorPrinter;
    filteredTextitem		*nInfoPrinter;
    filteredTextitem		*nEventPrinter;
    filteredTextitem		*nNormalPrinter;
    filteredTextitem		*nMinorSound;
    filteredTextitem		*nMajorSound;
    filteredTextitem		*nInfoSound;
    filteredTextitem		*nEventSound;
    spinnerClass		*nMinorRate;
    spinnerClass		*nMajorRate;
    spinnerClass		*nInfoRate;
    spinnerClass		*nEventRate;
    filteredTextitem		*nManScript;
    filteredTextitem		*nAutoScript;

    // auxiliary mode values
    filteredTextitem		*aMinorPrinter;
    filteredTextitem		*aMajorPrinter;
    filteredTextitem		*aInfoPrinter;
    filteredTextitem		*aEventPrinter;
    filteredTextitem		*aNormalPrinter;
    filteredTextitem		*aMinorSound;
    filteredTextitem		*aMajorSound;
    filteredTextitem		*aInfoSound;
    filteredTextitem		*aEventSound;
    spinnerClass		*aMinorRate;
    spinnerClass		*aMajorRate;
    spinnerClass		*aInfoRate;
    spinnerClass		*aEventRate;
    filteredTextitem		*aManScript;
    filteredTextitem		*aAutoScript;

    // other stuff
    filteredTextitem		*displayName;
    filteredTextitem		*helpTopic;
    filteredTextitem		*modeSelectPV;
    filteredTextitem		*guidance;

    alCfgInfoApplyButtonClass	*applyButton;
    alCfgInfoDismissButtonClass	*dismissButton;
    alCfgInfoClearButtonClass	*clearButton;

    // function to handle mainDialog
    alCfgMainDialogClass *getMainDialog (void)
	{ return (mainDialog); }

    // functions to handle newInfo ptr
    GROUPINFO_PTR getNewInfo (void)
	{ return (newInfo); }
    void saveInfoDialog (void);

    // function to get modified
    int getModifiedFlag (void)
	{ return (modified); }

    // other functions
    void loadInfoDialog (void);
    void clearInfoDialog (void);

    // function used by caller to get new parameters
    void updateParameters (TREENODE_PTR node);

};


// *** INFO DIALOG BUTTON CLASSES *********************************

class alCfgInfoApplyButtonClass : public vbutton
{
    alCfgInfoDialogClass	*infoDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (alCfgInfoApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (alCfgInfoApplyButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the infoDialog
    void storeInfoDialog (alCfgInfoDialogClass *cd) 
	{ infoDialog = cd; }
};


class alCfgInfoDismissButtonClass : public vbutton
{
    alCfgInfoDialogClass	*infoDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (alCfgInfoDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (alCfgInfoDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the infoDialog
    void storeInfoDialog (alCfgInfoDialogClass *cd) 
	{ infoDialog = cd; }
};


class alCfgInfoClearButtonClass : public vbutton
{
    alCfgInfoDialogClass	*infoDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (alCfgInfoClearButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (alCfgInfoClearButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the infoDialog
    void storeInfoDialog (alCfgInfoDialogClass *cd) 
	{ infoDialog = cd; }
};

#endif	alcfginfodialogclassHXX
