#ifndef alcfglistdialogclassHXX
#define	alcfglistdialogclassHXX

#define	REMOVE_GROUP_FLAG	1
#define	INSERT_GROUP_FLAG	2
#define	EDIT_PRINTER_FLAG	3
#define	REMOVE_PRINTER_FLAG	4

#define	ALCFG_SELECTEDNAME_SIZE	AL_GROUPNAME_SIZE

class alCfgListClass;
class alCfgListOkButtonClass;
class alCfgListCancelButtonClass;


//** LIST DIALOG CLASS *********************************************

class	alCfgListDialogClass : public vdialog
{
    // pointer to mainDialog
    alCfgMainDialogClass	*mainDialog;
    vstr			*title;
    int				listType;
    vchar			selectedName[ALCFG_SELECTEDNAME_SIZE + 1];

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(alCfgListDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(alCfgListDialogClass, vdialog);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    void listOpen ( alCfgMainDialogClass *mainDialog, int flag);

    alCfgListClass		*listView;
    alCfgListOkButtonClass	*okButton;
    alCfgListCancelButtonClass	*cancelButton;

    // function to handle mainDialog
    alCfgMainDialogClass *getMainDialog (void)
	{ return (mainDialog); }

    // function to handle listType
    int getListType (void)
	{ return (listType); }

    // function to handle selectedName
    vchar *getSelectedName (void)
	{ return (selectedName); }

    // function to delete an item from the list
    int deleteListItem (vchar *item);

    // function to verify inserting group ito tree
    int insertGroup (vlist *list, vchar *item);

};


//** LIST CLASS ***************************************************

class	alCfgListClass : public vlistview
{
    alCfgListDialogClass	*listDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(alCfgListClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(alCfgListClass, vlistview);

    // virtual member function override
    void ObserveSelect (int state);

    // functions to handle listDialog
    void storeListDialog (alCfgListDialogClass *cd)
	{ listDialog = cd; }

};


// *** LIST DIALOG OK BUTTON CLASSES *********************************

class alCfgListOkButtonClass : public vbutton
{
    alCfgListDialogClass	*listDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (alCfgListOkButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (alCfgListOkButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the listDialog
    void storeListDialog (alCfgListDialogClass *cd) 
	{ listDialog = cd; }
};


//** LIST DIALOG CANCEL BUTTON CLASS **********************************

class alCfgListCancelButtonClass : public vbutton
{
    alCfgListDialogClass	*listDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (alCfgListCancelButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (alCfgListCancelButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the listDialog
    void storeListDialog (alCfgListDialogClass *cd) 
	{ listDialog = cd; }
};

#endif	alcfglistdialogclassHXX
