#ifndef	alcfgprtdialogclassHXX
#define	alcfgprtdialogclassHXX

//** PRINT DIALOG *******************************************************************

class alCfgPrtApplyButtonClass;
class alCfgPrtDismissButtonClass;
class alCfgPrtClearButtonClass;

class	alCfgPrtDialogClass : public vdialog
{
    // pointer to mainDialog
    alCfgMainDialogClass	*mainDialog;
    alCfgApplication		*app;
    vstr			*title;
    vchar			*prtGroupName;
    int				modified;
    PRINTER_ENTRY_PTR		prtEntry;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(alCfgPrtDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(alCfgPrtDialogClass, vdialog);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    void prtOpen ( alCfgMainDialogClass *mainDialog, vchar *groupName);

    filteredTextitem		*printers[MAX_PRINTERS_PER_GROUP];
    alCfgPrtApplyButtonClass	*applyButton;
    alCfgPrtDismissButtonClass	*dismissButton;
    alCfgPrtClearButtonClass	*clearButton;

    // function to handle mainDialog
    alCfgMainDialogClass *getMainDialog (void)
	{ return (mainDialog); }

    // function to handle modified flag
    int getModFlag (void)
	{ return (modified); }

    // other functions
    void clearPrtDialog (void);
    void loadPrtDialog (void);
    void savePrtDialog (void);

};


// *** PRINT DIALOG BUTTON CLASSES *********************************

class alCfgPrtApplyButtonClass : public vbutton
{
    alCfgPrtDialogClass	*prtDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (alCfgPrtApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (alCfgPrtApplyButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the prtDialog
    void storePrtDialog (alCfgPrtDialogClass *cd) 
	{ prtDialog = cd; }
};


class alCfgPrtDismissButtonClass : public vbutton
{
    alCfgPrtDialogClass	*prtDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (alCfgPrtDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (alCfgPrtDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the prtDialog
    void storePrtDialog (alCfgPrtDialogClass *cd) 
	{ prtDialog = cd; }
};


class alCfgPrtClearButtonClass : public vbutton
{
    alCfgPrtDialogClass	*prtDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (alCfgPrtClearButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (alCfgPrtClearButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // handle the pointer to the prtDialog
    void storePrtDialog (alCfgPrtDialogClass *cd) 
	{ prtDialog = cd; }
};

#endif	alcfgprtdialogclassHXX
