/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* dbFormats.c */

/* This file contains the formats of all dBase files associated with the alarming system. */

/* This file contains information that is global to all alarms. It will */
/* only ever contain a single record. */
 
F4FIELD_INFO globalFields [] = {
	{ "LOGFILE",		'C',	AL_PATHNAME_SIZE,	0 },
	{ 0, 0, 0, 0}
};

/* This file contains the names of all groups defined by alarmConfig. */

F4FIELD_INFO groupNameFields [] = {
	{ "GROUPNAME",		'C',	AL_GROUPNAME_SIZE,	0 },
	{ 0, 0, 0, 0 }
};

/* This file contains the alarm tree. It need not be indexed since */
/* the entire file is read and/or written as a unit.  The root node is a */
/* child with no parent. */

F4FIELD_INFO treeFields [] = {
	{ "PARENT",		'C',	AL_GROUPNAME_SIZE,	0 },
	{ "CHILD",		'C',	AL_GROUPNAME_SIZE,	0 },
	{ 0, 0, 0, 0 }
};

/* This file contains each group that is being alarmed and the parameters */
/* associated with each. */

F4FIELD_INFO infoFields [] = {
	{ "GROUPNAME",		'C',	AL_GROUPNAME_SIZE,	0 },	/* Name of group */
	{ "ASCRIPT",		'C',	AL_SCRIPTNAME_SIZE,	0 },	/* Automatically executed script */
	{ "AUXASCRIPT",		'C',	AL_SCRIPTNAME_SIZE,	0 },	/* Aux automatically executed script */
	{ "MSCRIPT",		'C',	AL_SCRIPTNAME_SIZE,	0 },	/* Manually executed script */
	{ "AUXMSCRIPT",		'C',	AL_SCRIPTNAME_SIZE,	0 },	/* Manually executed script */
	{ "DISPNAME",		'C',	AL_SCRIPTNAME_SIZE,	0 },	/* dm display file name */
	{ "HELPTOPIC",		'C',	AL_HELPTOPIC_SIZE,	0 },	/* Help topic for help engine */
	{ "GUIDANCE",		'C',	AL_GUIDANCE_SIZE,	0 },	/* Guidance string */
	{ "MAJPRINT",		'C',	AL_PATHNAME_SIZE,	0 },	/* Printer for major alarms */
	{ "MINPRINT",		'C',	AL_PATHNAME_SIZE,	0 },	/* Printer for minor alarms */
	{ "INFOPRINT",		'C',	AL_PATHNAME_SIZE,	0 },	/* Printer for informational alarms */	
	{ "EVPRINT",		'C',	AL_PATHNAME_SIZE,	0 },	/* Printer for event alarms */
	{ "NORMPRINT",		'C',	AL_PATHNAME_SIZE,	0 },	/* Printer for return to normal */
	{ "AMAJPRINT",		'C',	AL_PATHNAME_SIZE,	0 },	/* Aux Printer for major alarms */
	{ "AMINPRINT",		'C',	AL_PATHNAME_SIZE,	0 },	/* Aux Printer for minor alarms */
	{ "AINFOPRINT",		'C',	AL_PATHNAME_SIZE,	0 },	/* Aux Printer for informational alarms */	
	{ "AEVPRINT",		'C',	AL_PATHNAME_SIZE,	0 },	/* Aux Printer for event alarms */
	{ "ANORMPRINT",		'C',	AL_PATHNAME_SIZE,	0 },	/* Aux Printer for return to normal */
	{ "MAJSOUND",		'C',	AL_PATHNAME_SIZE,	0 },	/* Sound file for major alarms */
	{ "MAJRATE",		'C',	AL_RATE_SIZE,		0 },	/* Sound rate for major alarms */
	{ "MINSOUND",		'C',	AL_PATHNAME_SIZE,	0 },	/* Sound file for minor alarms */
	{ "MINRATE",		'C',	AL_RATE_SIZE,		0 },	/* Sound rate for minor alarms */
	{ "INFOSOUND",		'C',	AL_PATHNAME_SIZE,	0 },	/* Sound file for informational alarms */
	{ "INFORATE",		'C',	AL_RATE_SIZE,		0 },	/* Sound rate for informational alarms */
	{ "EVSOUND",		'C',	AL_PATHNAME_SIZE,	0 },	/* Sound file for event alarms */
	{ "EVRATE",		'C',	AL_RATE_SIZE,		0 },	/* Sound rate for event alarms */
	{ "AMAJSOUND",		'C',	AL_PATHNAME_SIZE,	0 },	/* Aux Sound file for major alarms */
	{ "AMAJRATE",		'C',	AL_RATE_SIZE,		0 },	/* Aux Sound rate for major alarms */
	{ "AMINSOUND",		'C',	AL_PATHNAME_SIZE,	0 },	/* Aux Sound file for minor alarms */
	{ "AMINRATE",		'C',	AL_RATE_SIZE,		0 },	/* Aux Sound rate for minor alarms */
	{ "AINFOSOUND",		'C',	AL_PATHNAME_SIZE,	0 },	/* Aux Sound file for informational alarms */
	{ "AINFORATE",		'C',	AL_RATE_SIZE,		0 },	/* Aux Sound rate for informational alarms */
	{ "AEVSOUND",		'C',	AL_PATHNAME_SIZE,	0 },	/* Aux Sound file for event alarms */
	{ "AEVRATE",		'C',	AL_RATE_SIZE,		0 },	/* Aux Sound rate for event alarms */
	{ "AUXSELPV",		'C',	AL_POINTNAME_SIZE,	0 },	/* PV used to select aux vs. normal mode */
	{ 0, 0, 0, 0 }
};

T4TAG_INFO infoTags [] = {
	{ "GROUPTAG",	"GROUPNAME",	".NOT. DELETED()", 0, 0 },
	{ 0, 0, 0, 0, 0 }
};

/* This is the alarm log file. It contains both alarms and acknowledgements.  An acknowledgement can */
/* be identified by non-empty ACKSEC & ACKSECS fields.  The values in these fields will match the */
/* ALARMSECS & ALARMMSECS fields of the matching alarm.  The OPERATOR field indicates the username of */
/* the operator that ACKed the alarm. The DATE & TIME fields are in local time */
/* and are for customer convienience only.  The RECVACK indicates that the alarm was received from CA */
/* already ACKed and no ACK record exists in the log. */

F4FIELD_INFO	alarmLogFields [] =
{
	{ "ISACK",	'C',		1,			0 },	/* Is an ACK entry */
	{ "POINTNAME",	'C',		AL_POINTNAME_SIZE,	0 },	/* Point that is in alarm */
	{ "ALARMSECS",	'C',		AL_GMTSECS_SIZE,	0 },	/* Alarm time (GMT seconds since 1/1/70) */
	{ "ALARMMSECS",	'C',		AL_GMTMSECS_SIZE,	0 },	/* Alarm time (millisecond) */
	{ "ACKSECS",	'C',		AL_GMTSECS_SIZE,	0 },	/* ACK (GMT seconds since 1/1/70) */
	{ "ACKMSECS",	'C',		AL_GMTSECS_SIZE,	0 },	/* ACK (milliseconds) */
	{ "STATUS",	'C',		AL_STATUS_SIZE,		0 },	/* HI, HIHI, LO, LOLO, etc */
	{ "SEVERITY",	'C',		AL_SEVERITY_SIZE,	0 },	/* M, m, I, E, V */
	{ "ACKED",	'L',		1,			0 },	/* Alarm has been ACKed */
	{ "NOPRINT",	'L',		1,			0 },	/* No alarm message printed */
	{ "OPERATOR",	'C',		AL_OPERATOR_SIZE,	0 },	/* Operator that ACKed the alarm */
	{ "RESOURCE",	'C',		AL_RESOURCE_SIZE,	0 },	/* Resource that PV belongs to */
	{ "STATION",    'C',            AL_IOCNAME_SIZE,        0 },    /* Station name */
	{ "GROUPNAME",	'C',		AL_GROUPNAME_SIZE,	0 },	/* Group to which this point belongs */
	{ "DESCRIPTOR",	'C',		AL_DESCRIPTOR_SIZE,	0 },	/* Point descriptor from pv_map */
	{ "EGUTAG",	'C',		AL_EGUTAG_SIZE,		0 },	/* EGU tag for PV */
	{ "VALUE",	'C',		AL_VALUE_SIZE,		0 },	/* Value of PV at alarm time */
	{ "DATE",	'C',		AL_DATE_SIZE,		0 },	/* Local date mm/dd/yy */
	{ "TIME",	'C',		AL_TIME_SIZE,		0 },	/* Local time hh:mm:ss */
	{ "COMMENT",	'M',		10,			0 },	/* Alarm comment field */
#if defined(INFOFIELDS) || defined(WIN32)
	{ "INFO1",	'C',		AL_INFO_SIZE,		0 },	/* Extra info saved at alarm report */
	{ "INFO2",	'C',		AL_INFO_SIZE,		0 },	/* Extra info saved at alarm report */
	{ "INFO3",	'C',		AL_INFO_SIZE,		0 },	/* Extra info saved at alarm report */
	{ "INFO4",	'C',		AL_INFO_SIZE,		0 },	/* Extra info saved at alarm report */
	{ "INFO5",	'C',		AL_INFO_SIZE,		0 },	/* Extra info saved at alarm report */
#endif INFOFIELDS
	{ 0,		0,		0,			0 }
};

T4TAG_INFO	alarmLogTags [] =
{
	{ "EVENTTIME",	"ALARMSECS+ALARMMSECS+POINTNAME+ISACK+STR(RECNO(),8,0)", "",	0,	0 },
	{ 0, 0, 0, 0, 0 }
};

/* The point state file contains the latest state of each point that is on alarm. */
/* It is used to initialize the alarmMgr when it is started. */

F4FIELD_INFO	pointStateFields [] =
{
	{ "POINTNAME",	'C',		AL_POINTNAME_SIZE,	0 },	/* Point that is in alarm */
	{ "ALARMSECS",	'C',		10,			0 },	/* Alarm time in log (second, EPICS timestamp) */
	{ "ALARMNSECS",	'C',		10,			0 },	/* Alarm time in log (millisecond, EPICS timestamp) */
	{ "ACKSECS",	'C',		10,			0 },	/* ACK time (seconds, EPICS timestamp) */
	{ "ACKNSECS",	'C',		10,			0 },	/* ACK time (milliseconds, EPICS timestamp) */
	{ "TIMESECS",	'C',		10,			0 },	/* Alarm time from CA (seconds, EPICS timestamp) */
	{ "TIMENSECS",	'C',		10,			0 },	/* Alarm time from CA (milliseconds, EPICS timestamp) */
	{ "STATUS",	'C',		3,			0 },	/* Internal numeric format */
	{ "SEVERITY",	'C',		2,			0 },	/* Internal numeric format */
	{ "VALUE",	'C',		AL_VALUE_SIZE,		0 },	/* Value of PV at alarm time */
	{ "USTATUS",	'C',		3,			0 },	/* Internal numeric format */
	{ "USEVERITY",	'C',		2,			0 },	/* Internal numeric format */
	{ "UVALUE",	'C',		AL_VALUE_SIZE,		0 },	/* Unacked value of PV at alarm time */
	{ "ACK",	'C',		1,			0 },	/* Alarm has been ACKed */
	{ "RTN",	'C',		1,			0 },	/* Alarm has RTN */
	{ "AENB",	'C',		1,			0 },	/* Alarms enabled for this point */
	{ "OSCN",	'C',		1,			0 },	/* Point is on scan */
	{ "DESCRIPTOR",	'C',		AL_DESCRIPTOR_SIZE,	0 },	/* Point descriptor from pv_map */
	{ "EGUTAG",	'C',		AL_EGUTAG_SIZE,		0 },	/* EGU tag for PV */
	{ "OPERATOR",	'C',		AL_OPERATOR_SIZE,	0 },	/* Operator that ACKed the alarm */
	{ "INSUM",	'C',		1,			0 },	/* Point is in the alarm summary */
	{ 0,		0,		0,			0 }
};

static T4TAG_INFO	pointStateTags [] =
{
	{ "POINTNAME",	"POINTNAME",	"",	0,	0 },
	{ 0, 0, 0, 0, 0 }
};

/* Alarm Destination Table */

F4FIELD_INFO	alarmPrinterFields [] =
{
	{ "NAME",	'C',		AL_GROUPNAME_SIZE,	0 },	/* Alarm Group Name */
	{ "PTR1",	'C',		AL_PATHNAME_SIZE,	0 },	/* Alarm Printer 1 */
	{ "PTR2",	'C',		AL_PATHNAME_SIZE,	0 },	/* Alarm Printer 2 */
	{ "PTR3",	'C',		AL_PATHNAME_SIZE,	0 },	/* Alarm Printer 3 */
	{ "PTR4",	'C',		AL_PATHNAME_SIZE,	0 },	/* Alarm Printer 4 */
	{ "PTR5",	'C',		AL_PATHNAME_SIZE,	0 },	/* Alarm Printer 5 */
	{ "PTR6",	'C',		AL_PATHNAME_SIZE,	0 },	/* Alarm Printer 6 */
	{ "PTR7",	'C',		AL_PATHNAME_SIZE,	0 },	/* Alarm Printer 7 */
	{ "PTR8",	'C',		AL_PATHNAME_SIZE,	0 },	/* Alarm Printer 8 */
	{ "PTR9",	'C',		AL_PATHNAME_SIZE,	0 },	/* Alarm Printer 9 */
	{ "PTR10",	'C',		AL_PATHNAME_SIZE,	0 },	/* Alarm Printer 10 */
	{ 0, 0, 0, 0 }
};


