/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "alarmDefs.h"
#include "shareMem.h"
#include "alarmLib.h"

void PrintTree (TreeNode *p);
void PrintGroup (TreeNode *p);

/************************************************************************************
  dump the input pvname.
************************************************************************************/
main (argc, argv)

    int    argc;
    char  *argv[];

    {

	char		groupName [100];
	TreeNode	*p;
		
	if (argc != 2) {
	    printf ("Usage: dumpGroup <groupName>, using MAIN\n");
	    strcpy (groupName, "MAIN");
	}
	else
	    strcpy (groupName, argv[1]);

	if (!MapSharedMemory ()) {
	    printf ("Unable to access alarmMgr shared memory region.\n");
	    exit (0);
	}
 
	/* Find point in shared memory */
	p = FindGroup (NULL, groupName);
	if (p == NULL) {
	    printf ("%s not found in shared memory region.\n", groupName);
	    UnmapSharedMemory ();
	    exit (-1);
	}

	PrintTree (p);
	UnmapSharedMemory ();
   
	return 0;
    }

void PrintTree (TreeNode *p)
{
	PrintGroup (p);
	if (p->leftChild)
	    PrintTree (p->leftChild);
	if (p->rightSibling)
	    PrintTree (p->rightSibling);
}

void PrintGroup (TreeNode *p)
{
/*	int		i; */
	PvData		*pv;

	/* Print out the various data items */

	printf ("%s chan=%d, aux=%d\n", p->groupName, p->chanNum, p->auxValue);

	printf ("\t\tnRnA\tRnA\tnRA\tAlarms\tUnacked\n");

	printf ("\t major:\t%hd\t%hd\t%hd\t%hd\t%hd\n",
			p->groupData.notRTNnotACK [MAJOR_ALARM],
			p->groupData.RTNnotACK [MAJOR_ALARM],
			p->groupData.notRTNandACK [MAJOR_ALARM],
			p->groupData.numAlarmsBySeverity [MAJOR_ALARM],
			p->groupData.numUnackedBySeverity [MAJOR_ALARM]);

	printf ("\t minor:\t%hd\t%hd\t%hd\t%hd\t%hd\n",
			p->groupData.notRTNnotACK [MINOR_ALARM],
			p->groupData.RTNnotACK [MINOR_ALARM],
			p->groupData.notRTNandACK [MINOR_ALARM],
			p->groupData.numAlarmsBySeverity [MINOR_ALARM],
			p->groupData.numUnackedBySeverity [MINOR_ALARM]);

	printf ("\t  info:\t%hd\t%hd\t%hd\t%hd\t%hd\n",
			p->groupData.notRTNnotACK [INFO_ALARM],
			p->groupData.RTNnotACK [INFO_ALARM],
			p->groupData.notRTNandACK [INFO_ALARM],
			p->groupData.numAlarmsBySeverity [INFO_ALARM],
			p->groupData.numUnackedBySeverity [INFO_ALARM]);

	printf ("\t event:\t%hd\t%hd\t%hd\t%hd\t%hd\n",
			p->groupData.notRTNnotACK [EVENT_ALARM],
			p->groupData.RTNnotACK [EVENT_ALARM],
			p->groupData.notRTNandACK [EVENT_ALARM],
			p->groupData.numAlarmsBySeverity [EVENT_ALARM],
			p->groupData.numUnackedBySeverity [EVENT_ALARM]);

	printf ("\t  noal:\t%hd\t%hd\t%hd\t%hd\t%hd\n",
			p->groupData.notRTNnotACK [NO_ALARM],
			p->groupData.RTNnotACK [NO_ALARM],
			p->groupData.notRTNandACK [NO_ALARM],
			p->groupData.numAlarmsBySeverity [NO_ALARM],
			p->groupData.numUnackedBySeverity [NO_ALARM]);

   	printf ("\t   gstat=%hd, gsevr=%hd\n", p->groupData.groupStatus,
			p->groupData.groupSeverity);


	if (pv = p->pvList)
	{
	    while (pv)
	    {
		printf ("\t%s\tstatus: %d\tseverity: %d\tustatus: %d\tuseverity: %d\n",
		    pv->pvName, pv->status, pv->severity, pv->unAckedStatus, pv->unAckedSeverity);
		printf ("\t\t lastAlarm: %ld,%ld\tvalue: %s\tuvalue: %s\n",
		    pv->lastAlarm.secPastEpoch, pv->lastAlarm.nsec, pv->value, pv->unAckedValue);
		pv = pv->nextPv;
	    }
	}
/*
	for (i=0 ; i<ALARM_NSTATUS ; i++)
	    printf ("%d=%hd ", i, p->groupData.curStat [i]);
	printf ("\n");
*/
}
