/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "alarmDefs.h"
#include "shareMem.h"
#include "alarmLib.h"

/**********************************************************************************
  dump the input pvname.
**********************************************************************************/
void main(int argc, char **argv)

    {

	char	pointName[100];
	PvData	*p;
		
	if (argc != 2) {
	    printf ("Usage: dumpPoint <pointName>\n");
	    exit (0);
	}

	strcpy (pointName, argv[1]);

	if (!MapSharedMemory ()) {
	    printf ("Unable to access alarmMgr shared memory region.\n");
	    exit (0);
	}
 
	/* Find point in shared memory */

	p = FindPV (NULL, pointName);
	if (p == NULL) {
	    printf ("%s not found in shared memory region.\n", pointName);
	    UnmapSharedMemory ();
	    exit (-1);
	}

	/* Print out the various data items */

	printf ("point: %s        group: %s\n", p->pvName, p->parentGroup->groupName);
	printf ("Ack: %d     RTN: %d     status: %d     severity: %d     ustatus: %d     useverity: %d\n",
		p->Ack, p->RTN, p->status, p->severity, p->unAckedStatus, p->unAckedSeverity);
	printf ("value: %s     uvalue: %s\n", p->value, p->unAckedValue);
	printf ("description: %s     eguTag: %s\n", p->description, p->eguTag);
	printf ("lastAlarm: %ld,%ld     lastAck: %ld,%ld    lastGordon: %ld,%ld\n",
			p->lastAlarm.secPastEpoch, p->lastAlarm.nsec,
			p->lastAck.secPastEpoch, p->lastAck.nsec,
			p->lastAlarmReceived.secPastEpoch, p->lastAlarmReceived.nsec);
	printf ("OSCN: %d    AENB: %d\n", (int)(p->oscn), (int)(p->aenb));
	printf ("op: %s     inSummary: %s\n", p->op, (p->prevSummaryPv != (PvData *)-1) ? "yes" : "no");
	printf ("On Scan: %d   Alarm Enabled: %d\n", p->oscn, p->aenb);
	printf ("Resource: %s    Station: %s\n", p->resource, p->stationName);
	UnmapSharedMemory ();
   
    }

