/*alarmvu.h,v 1.1.1.1 1999/08/03 14:41:45 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 * miscellaneous
 */
#define	ALARMVU_MAGIC_NUMBER		22456
#define	ALARMVU_VERSION			2
#define	ACK_STRING			"ACK"
#define	CONNECT_ERR_STRING		"CONNECT ERR"
#define	REMOTE_OPERATOR_STRING		"Remote Oper"

#define NUM_SEV_COLORS (AL_NUM_SEVR + 1) /* room for VALID_ALARM */

#define	FIRSTCOLOR			0
#define	LASTCOLOR			64
#define	SHIFT_DOWN			1
#define	SHIFT_UP			2
#define	GROUP_SHIFT_DOWN		3
#define	GROUP_SHIFT_UP			4
#define	GROUP_DISPLAY			5
#define	ALARM_HISTORY			6
#define	HISTORY_SHIFT_DOWN		7
#define	HISTORY_SHIFT_UP		8
#define	MSGPORT				8583
#define	BCASTPORT			8584
#define	PRINTERPORT			2000	/* 6/14/94 DEK - Network printer parallel port */

/*
 * window layout constants
 */
#define	MENUBAR_HEIGHT			31
#define	SCROLLBAR_WIDTH			18
#define MAX_LINES_IN_WINDOW		50
#define	MAX_WINDOW_WIDTH		2048
#define INITIAL_LINES_IN_WINDOW		5

/*
 * data structure sizes
 */
#define	GROUP_SIZE			16
#define	SEVR_SIZE			1
#define	DATE_SIZE			8
#define	TIME_SIZE			8
#define	POINTNAME_SIZE			28
#define	DESCRIPTOR_SIZE			28
#define	LOCATION_SIZE			16
#define	TYPE_SIZE			12
#define	SEVERITY_SIZE			8
#define	VALACK_SIZE			25
#define	TAGOP_SIZE			30
#define	OLD_SIZE			1
#define	SUMDISPLAY_SIZE			1
#define	FIELDNAME_SIZE			4
#define FIFO_SIZE			171	/* DEK 7/26/94 - Size of message to receive from alarmhnd */

#define	LINEPRINTER_SIZE		20

#define	FILTER_ACKNOWLEDGED		0x01
#define	FILTER_SEVERITY			0x02
#define	FILTER_LOCATION			0x04
#define	FILTER_ALARM_GROUP		0x08
#define	FILTER_DATE_TIME		0x10
#define	FILTER_GROUP_DISPLAY_ALARM	0x20
#define	FILTER_GROUP_DISPLAY_UNACK_ALARM	0x40
#define	FILTER_OLD_ALARMS		0x80
#define	FILTER_OPERATOR			0x100

/*
 * point option indices
 */
#define	GUIDANCE_POINT_OPTION		0
#define	DISPLAY_POINT_OPTION		1
#define	DISABLE_POINT_OPTION		2
#define	ENABLE_POINT_OPTION		3
#define	COMMENT_POINT_OPTION		4	/* DEK 2/9/94  Alarm memo maintenance */

/*
 * index file types
 */
#define	ALRM_INDEX_FILE			0
#define	ALRMLOG_INDEX_FILE		1
#define	ALRMEVT_INDEX_FILE		2
#define	ALRMSYS_INDEX_FILE		3
#define NUMIXFILES			4

#ifdef USEX11
 /*
 * dialog window identifiers
 */
#define	IDD_ALARM_EVENT_SUMMARY		1
#define	IDD_LISTBOX_POPUP		2
#define	IDD_ALARM_GROUP			3
#define	IDD_DYNAMIC_GROUP		4
#define	IDD_ALARM_TRACK			5
#define	IDD_ALARM_HISTORY		6
#define	IDD_ALARM_WINDOW		7
#define	IDD_TEXT			8
#define	IDD_DATE_TIME_POPUP		9
#define	IDD_PROMPT_POPUP		10
#define	IDD_EVENT_HISTORY		11
#define	IDD_REPORTS			12
#define	IDD_ABOUT			16
#define IDD_PALETTE			17
#define IDD_SELECT			18
#define	IDD_POP_ALARM			19
#define	IDD_ALARM_COMMENT		20	/* DEK (3/1/94) Window for maintaining alarm comments */
#define	IDD_ALARM_TAG			21	/* DEK (3/30/94) Id for comment window label */
#define	IDD_ALARM_STRING		22	/* DEK (3/30/94) Id for alarm string being commented */

/*
 * colors
 */
#define ID_RED				25
#define ID_GREEN			26
#define ID_BLUE				27
#define ID_LIST				28

/*
 * scroll bar identifiers
 */
#define	IDSB_VERTICAL			50

/*
 * list box identifiers
 */
#define	IDLB_POINT_OPTIONS		85
#define	IDLB_GROUP_LIST			86
#define	IDLB_TEXT			87

/*
 * menu identifiers
 */
#define	IDM_ALARM_EVENT_SUMMARY		100
#define	IDM_ALARM_GROUP			101
#define	IDM_DYNAMIC_GROUP		102
#define	IDM_ALARM_TRACK			103
#define	IDM_ALARM_HISTORY		104
#define	IDM_ALARM_WINDOW		105
#define	IDM_GROUP_FILE			106
#define	IDM_ALARM_SUMMARY		107

#define	IDMI_SELECT_FILTER		200
#define	IDMI_NEW_FILTER			201
#define	IDMI_EDIT_FILTER		202
#define	IDMI_DELETE_FILTER		203
#define	IDMI_FILE_EVENT_FILE		204
#define	IDMI_FILE_ALARM_LOG		205
#define	IDMI_FILE_OPERATOR_LOG		206
#define	IDMI_FILE_EVENT_LOG		207
#define	IDMI_FILE_PRINT			208
#define	IDMI_FILE_ABOUT			209

#define	IDMI_VIEW_GROUP			211
#define	IDMI_VIEW_ALARM_WINDOW		212
#define	IDMI_VIEW_ALARM_SUMMARY		213
#define	IDMI_VIEW_ALARM_HISTORY		214
#define	IDMI_VIEW_EVENT_HISTORY		215
#define	IDMI_VIEW_OPERATOR_HISTORY	216
#define	IDMI_VIEW_REPORTS		217
#define	IDMI_VIEW_GROUP_FILE		221
#define	IDMI_VIEW_EVENT_FILE		222

#define	IDMI_CONTROL_DISABLE_POINT	231
#define	IDMI_CONTROL_ENABLE_POINT	232
#define	IDMI_CONTROL_DISABLE_GROUP	233
#define	IDMI_CONTROL_ENABLE_GROUP	234

#define	IDMI_SETUP_PRINTERS		241
#define	IDMI_SETUP_SOUNDS		242
#define	IDMI_SETUP_DEFAULT_FILTER	243
#define	IDMI_SETUP_ALARM_WINDOW		246
#define	IDMI_SETUP_POPUP_ALARM		247

#define	IDMI_SETUP_COLORS		248
#define IDMI_SETUP_COLORS_NORMAL	248
#define IDMI_SETUP_COLORS_EVENT_ALARM	249
#define IDMI_SETUP_COLORS_INFO_ALARM	250
#define	IDMI_SETUP_COLORS_MINOR_ALARM	251
#define	IDMI_SETUP_COLORS_MAJOR_ALARM	252
#define IDMI_SETUP_COLORS_CONN_ALARM	253

#define IDMI_SETUP_USE_DEFAULTS		254
#define IDMI_SETUP_SAVE			255

#define	IDMI_FILTER			271

#define IDMI_ACK_ALL			281
#define IDMI_ACK_PAGE			289

#define IDMI_DISPLAY			282
#define IDMI_COMMAND			288

#define IDMI_GUIDANCE			283

#define IDMI_CLOSE			284

#define IDMI_PAUSE			285
#define IDMI_CONTINUE			286

#define IDMI_CLEAR			287

#define IDMI_PRINT_WINDOW		301
#define IDMI_PRINT_HISTORY		302
#define IDMI_PRINT_FILE			303

#define IDMI_SILENCE			305

#define	IDMI_MEMO_CLOSE			401
#define	IDMI_MEMO_SAVE			402
#define	IDMI_MEMO_UNDO			403
#define	IDMI_MEMO_DELETE		404

/*
 * button identifiers
 */
#define IDB_SILENCE			1001
#define IDB_OPEN_CLOSE			1002

#define IDB_OK				1003
#define IDB_CANCEL			1004

#define IDB_BEFORE			1005
#define IDB_AFTER			1006

#define IDB_ACK				1007
#define IDB_DISPLAY			1008

#define IDB_ACK_BUTTON1			1011
#define IDB_ACK_BUTTON2			1012
#define IDB_ACK_BUTTON3			1013
#define IDB_ACK_BUTTON4			1014
#define IDB_ACK_BUTTON5			1015
			/* reserved thru 1011 + MAX_LINES_IN_WINDOW */

/*
 * text identifiers
 */
#define IDT_FONTSIZE			2000

#define IDT_DATE1			2001
#define IDT_TIME1			2002
#define IDT_NAME1			2003
#define IDT_DESCRIPTOR1			2004
#define IDT_LOCATION1			2005
#define IDT_ALARM_TYPE1			2006
#define IDT_VALACK1			2007
#define IDT_TAGOP1			2008
#define IDT_FIELD1			2009
#define IDT_OLDVALUE1			2010
#define IDT_NEWVALUE1			2011
#define IDT_DATE2			2012
#define IDT_TIME2			2013
#define IDT_NAME2			2014
#define IDT_DESCRIPTOR2			2015
#define IDT_LOCATION2			2016
#define IDT_ALARM_TYPE2			2017
#define IDT_VALACK2			2018
#define IDT_TAGOP2			2019
#define IDT_FIELD2			2020
#define IDT_OLDVALUE2			2021
#define IDT_NEWVALUE2			2022
#define IDT_DATE3			2023
#define IDT_TIME3			2024
#define IDT_NAME3			2025
#define IDT_DESCRIPTOR3			2026
#define IDT_LOCATION3			2027
#define IDT_ALARM_TYPE3			2028
#define IDT_VALACK3			2029
#define IDT_TAGOP3			2030
#define IDT_FIELD3			2031
#define IDT_OLDVALUE3			2032
#define IDT_NEWVALUE3			2033
#define IDT_DATE4			2034
#define IDT_TIME4			2035
#define IDT_NAME4			2036
#define IDT_DESCRIPTOR4			2037
#define IDT_LOCATION4			2038
#define IDT_ALARM_TYPE4			2039
#define IDT_VALACK4			2040
#define IDT_TAGOP4			2041
#define IDT_FIELD4			2042
#define IDT_OLDVALUE4			2043
#define IDT_NEWVALUE4			2044
#define IDT_DATE5			2045
#define IDT_TIME5			2046
#define IDT_NAME5			2047
#define IDT_DESCRIPTOR5			2048
#define IDT_LOCATION5			2049
#define IDT_ALARM_TYPE5			2050
#define IDT_VALACK5			2051
#define IDT_TAGOP5			2052
#define IDT_FIELD5			2053
#define IDT_OLDVALUE5			2054
#define IDT_NEWVALUE5			2055
			/* reserved thru 2001 + MAX_LINES_IN_WINDOW * 11 */

#define IDT_CONNECT_ACK			3050
#define IDT_MAJOR_ACK			3051
#define IDT_MINOR_ACK			3052
#define IDT_INFO_ACK			3053
#define IDT_EVENT_ACK			3054
#define IDT_CONNECT_UNACK		3055
#define IDT_MAJOR_UNACK			3056
#define IDT_MINOR_UNACK			3057
#define IDT_INFO_UNACK			3058
#define IDT_EVENT_UNACK			3059

#define IDT_TEXT1			3061
#define IDT_TEXT2			3062
#define IDT_TEXT3			3063
#define IDT_TEXT4			3064
#define IDT_TEXT5			3065

#define IDT_CONNECT			3070
#define IDT_MAJOR			3071
#define IDT_MINOR			3072
#define IDT_INFO			3073
#define IDT_EVENT			3074
#define IDT_UNACK			3075
#define IDT_ACK				3076

#define IDE_DATE			4000
#define IDE_TIME			4001
#define IDE_PROMPT			4002

#define	ID_COLOR			5000

#endif USEX11
