#ifndef utilsHXX
#define	utilsHXX

#define MAXACKPVPTRS   25

extern "C"
{
#include "OperPrivErr.h"
}

typedef struct {
    void *link;
    int  total;
    int  current;
    void *pvptrs [MAXACKPVPTRS];
    int  msgtype [MAXACKPVPTRS];
} AckGroupPvPtrs;

extern char	**GetGroups (TreeNode ***);
extern char	**GetChannels (PvData ***);
extern void	OpenGroupSoundFiles (TreeNode *);
extern void	SpawnGroupScript (TreeNode *group);
extern void	SpawnScript (PvData *p);
extern int	HaveScript (char *script);
extern char *	ExpandScript (char *script, TreeNode *group, char *ptName, int ptStatus,
				int ptSeverity, char *ptValue, int ptAck);
extern void	SpawnCommand (char *);
extern void	SpawnGroupDisplay (TreeNode *group);
extern void	SpawnPointDisplay (PvData *p);
extern void	SpawnDisplay (char *);
extern void	SpawnDetail (char *);
extern int	InitPrivTrack ( );
extern int	CheckPriv (char *chan);
extern int	CheckTrackPriv (char *chan, char *OldValue, char *NewValue);
extern int	DisablePoint(PvData *p);
extern int	EnablePoint (PvData *p);
extern int	AckAlarm (PvData *p);
extern int	AckGroups (TreeNode *);
extern int	AckGroup (TreeNode *);
extern int	DisableGroups (TreeNode *);
extern int	DisableGroup (TreeNode *);
extern int	EnableGroups (TreeNode *);
extern int	EnableGroup (TreeNode *);
extern int	Send_storeMemoText ( char memoBuf[], AlarmLogRecord *recptr );
extern int	Send_removeMemoText ( AlarmLogRecord *recptr );
extern int	CountGroupEntries (TreeNode *, Filter *);
extern int	IsGroupFiltered (TreeNode *, Filter *);
extern int	IsChannelFiltered (PvData *, Filter *);
extern int	IsChannelFiltered (PvData *, Filter *, int);
extern int	GetGMT_TS_STAMP (char *, TS_STAMP *);
extern int	TCPRecv (int, char *, int);
extern char	*StripWhitespace (char *);
extern int	HighestSeverity (short sevr[]);
extern int	BeginMsgGroup (AckGroupPvPtrs **ackgroupptr);
extern int	AddMsgItem (AckGroupPvPtrs **ackgroupptr, void *itemptr, int itemtype);
extern int	EndMsgGroup (AckGroupPvPtrs **ackgroupptr);

#define	min(a,b)	(((a) < (b)) ? (a) : (b))

#endif	utilsHXX

