/*atdb_functions.c,v 1.1.1.1 1999/08/03 14:41:50 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			20-Feb-1993				      */
/*									      */
/*	Module Name:		ATDB_FUNCTIONS.C			      */
/*	Module Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Modification History:						      */
/*				20-Feb-1993	GCT	First time.	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#define	USE_REGISTER
#define	USE_ATDATE
#include "atdbmain.h"
#include <time.h>

/* #define DEBUG_ADDINS	1 */

void	atdbConvertDate(),atdbConvertTime();
static char daytab[2][13] =
	{
	{0,31,28,31,30,31,30,31,31,30,31,30,31},
	{0,31,29,31,30,31,30,31,31,30,31,30,31}
	};
static	char	key[MAXSTRING],sp[MAXSTRING];
char	*sev = "VMmIE";
unsigned long	sevbits [] =  {0x80000000, 0x40000000, 0x20000000, 0x10000000,0x08000000};
#define NUMSEV 5
char	*qual = "*QCqF"; 							/* in precedence order*/
unsigned long	qualbits [] = {0x04000000, 0x02000000, 0x01000000,0x00800000, 0x00400000};
#define NUMQUAL 5
char	*alms = "FuBEKUXTIRGNcMCSrHhLlW ";
unsigned long	almbits []= {0x00200000, 0x00100000,
				 0x00080000, 0x00040000, 0x00020000, 0x00010000,
				 0x00008000, 0x00004000, 0x00002000, 0x00001000,
				 0x00000800, 0x00000400, 0x00000200, 0x00000100,
				 0x00000080, 0x00000040, 0x00000020, 0x00000010,
				 0x00000008, 0x00000004, 0x00000002, 0x00000001,
				 0};
#define NUMALM 22
#define MAX_SAMPLE_COUNT 60

extern	double	tempvalue;		/* from atdb_main.c */
extern	double	atdbRate;
extern	int	atdbFieldIndex,atdbSampleCnt,tag_status;
extern	char	tempstatus[];
extern	lslong	atdbMinute,atdbSecond,atdbOffsetMinute,atdbFileHour;
extern	DB_TABLE_PTR	table;
extern	DB_FIELD_PTR	dbRate,dbOffset,dbDOY,dbYear,dbHour,dbCnt;
extern	DATA_FIELDS		pFields[60];
extern	time_t	current_time;
DB_RECORD_PTR	rec;
extern double  min2sec;
int	ATDB_DoExtract(table,key,field,type,value)
char	*table,*key,*field;
int	*type;
void	*value;
{
DB_TABLE_PTR	tbl;
DB_FIELD_PTR	fld;
DB_RECORD_PTR	rec;
char		*kptr,savekey[MAXSTRING];
if((tbl = DB_MapTable(table)) == 0)			/* map to table */
	return(0);
if((fld = DB_MapField(tbl,field)) == 0)			/* map field */
	return(0);
/*
	parse the key name from key string
*/
strcpy(savekey,key);
kptr = strstr(savekey,"=");
if(kptr == 0)
	return(0);
*kptr++ = '\0';						/* make two strings...key & key value */
if((DB_UseKey(tbl,savekey)) == 0)
	return(0);
if((rec = DB_Seek(tbl,kptr)) == 0)			/* find record using key value */
	{
	return(0);
	}
DB_GetFieldValue(rec,fld,value,type);			/* get the value from the field */
return(1);
}
int	atdbDayOfYear(year,month,day)
int	year,month,day;
{
int	i,leap;
leap = year%4 == 0 && year%100 != 0 || year%400 == 0;
for(i = 1;i < month;i++)
	day += daytab[leap][i];
return(day-1);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			24-Feb-1993				      */
/*									      */
/*	Function Name:		ATDB_GetRecord				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
int	ATDB_GetRecord(table,name,method,year,doy,hour,fieldname)
DB_TABLE_PTR	table;
char		*name;
char		*method;
int		year,hour,doy;
char		*fieldname;			/* either "VALUE" or "STATUS" */
{
double		val,thour,tmin,temp;
int			type,stat,slot_num,filedoy,fileyear,skip_ahead,rate,seek_stat;
int			start_time,target_time,i,offset;
char		slot_data[11],*statptr;
sprintf(key,"%-*.*s%3.3s%4d%3d%2d\0",PVNAME_SZ,PVNAME_SZ,name,method,year,doy,hour);	/* build key for new AR_SNAP files */
#ifdef	DEBUG_ADDINS
fprintf(stderr,"Key <%s>\n",key);
#endif
rec = (DB_RECORD_PTR)DB_SeekStatus(table,key,&seek_stat);		/* new function ... seek and return status */
#ifdef	DEBUG_ADDINS
fprintf(stderr,"Status from FIRST SEEK=%d,rec = %d\n",seek_stat,rec);
#endif
if(seek_stat < DB_OK)
	{
	return(0);					/* seek error */
	}
if((seek_stat == DB_AFTER) || (seek_stat == DB_EOF))			/* not exactly found backup 1 record */
	{
	rec = (DB_RECORD_PTR)DB_SeekPrev(table);
#ifdef	DEBUG_ADDINS
fprintf(stderr,"SeekPrev returned =%d,rec = %d\n",rec);
#endif
	if(rec == 0)
		{
		return(0);
		}
	seek_stat = DB_OK;
	}
if(seek_stat == DB_OK)							/* record found...get data*/
	{
	target_time = hour * 3600 + atdbMinute * 60 + atdbSecond;
	while(1)
		{
#ifdef	DEBUG_ADDINS
fprintf(stderr,"Found record\n");
#endif
		DB_GetFieldValue(rec,dbRate,slot_data,&type);	/* >= one. # of hours in record = sample_cnt/rate */
		atdbRate = (double)atof(slot_data);
		if(dbRate->field_size == 2)			/* old size then * 60 */
		  min2sec = 60;
		else
		  min2sec = 1;					/* else already in seconds */
		DB_GetFieldValue(rec,dbOffset,&temp,&type);
		atdbOffsetMinute = temp;
		DB_GetFieldValue(rec,dbDOY,&temp,&type);
		filedoy = temp;
		DB_GetFieldValue(rec,dbYear,&temp,&type);
		fileyear = temp;
		DB_GetFieldValue(rec,dbHour,&temp,&type);
		atdbFileHour = temp;
		DB_GetFieldValue(rec,dbCnt,&temp,&type);			/* # of samples in record <= 60 */
		atdbSampleCnt = temp;
#ifdef	DEBUG_ADDINS
fprintf(stderr,"DOY=%d,Hour=%d,offset=%d,rate=%f\n",filedoy,atdbFileHour,atdbOffsetMinute,atdbRate);
#endif
		if(atdbRate <= 0.0)
			return(0);				/* rate can't be zero */
		if(atdbSampleCnt == 0)						/* no data in file */
			return(0);
		if(filedoy != doy)						/* requested record not in file */
			return(0);
/*
	Check to make sure that the requested data is in the current record. If the requested time is earlier than
	the start time in the current record then I must skip back one record. If the requested time is
	later than the end time in the current record then I must skip ahead one record. Anything else is
	OK and I can proceed.
*/
	    start_time = atdbFileHour * 3600 + atdbOffsetMinute * 60;
	    offset = atdbRate*MAX_SAMPLE_COUNT;
	    if((target_time >= start_time) && (target_time < (start_time + offset)))
	      break;
	    else
	      rec = (DB_RECORD_PTR)DB_SeekNext(table);	/* go ahead one record and re-read fields */
#ifdef OLD_SKIP
		if(((atdbFileHour * 60 + atdbOffsetMinute) + (atdbRate * min2sec + atdbOffsetMinute)) <= (hour * 60 + atdbMinute))
				{
#ifdef	DEBUG_ADDINS
fprintf(stderr,"Skipping to next record\n");
#endif
				rec = (DB_RECORD_PTR)DB_SeekNext(table);	/* go ahead one record and re-read fields */
				if(rec == 0)
					return(0);
				continue;
				}
		break;								/* requested time is in the current record...get the value */
#endif
		}/*end while */
/*
		Get value from record
*/
		/* then error */
	if(year != fileyear)
		return(0);				/* must be same year too */
	start_time = atdbFileHour * 3600 + atdbOffsetMinute * 60;
	rate = atdbRate * min2sec;
#ifdef	DEBUG_ADDINS
fprintf(stderr,"start time=%d,target time %d\n",start_time,target_time);
fprintf(stderr,"requested minute=%d,minute offset=%d\n",atdbMinute,atdbOffsetMinute);
fprintf(stderr,"hour=%d,filehour=%d,samples=%d,rate=%f,minute=%d\n",
	hour,atdbFileHour,atdbSampleCnt,atdbRate,atdbMinute);
fprintf(stderr,"doy=%d,filedoy=%d\n",doy,filedoy);
fprintf(stderr,"field index %d\n",atdbFieldIndex);
#endif
#ifdef OLD_INDEX
	for(i = start_time,atdbFieldIndex=0;i <= target_time;i += rate,atdbFieldIndex++);
#else
	atdbFieldIndex = ((target_time - start_time)/rate) + 1;
#endif
	if ((atdbFieldIndex < 1) || (atdbFieldIndex > atdbSampleCnt))
		return(0);				/* no data to get */
	if(!strcmp(fieldname,"VALUE"))
		{
		DB_GetFieldValue(rec,pFields[atdbFieldIndex - 1].pVal,slot_data,&type);
		if(slot_data[0] == 0)
			return(0);
		else
			tempvalue = (double)atof(slot_data);
#ifdef	DEBUG_ADDINS
fprintf(stderr,"Field value=<%f>\n",tempvalue);
#endif
		}
	else
		{
		DB_GetFieldValue(rec,pFields[atdbFieldIndex - 1].pStat,tempstatus,&type);
#ifdef	DEBUG_ADDINS
fprintf(stderr,"tempstatus = %3.3s\n",tempstatus);
#endif
		}
	return(1);
	}
else
	{
	return(0);
	}
}
void	atdbConvertDate(dv,y,m,d)
lfloat8	dv;
lslong	*y,*m,*d;
{
LpiAtdYear(floor(dv),y);
LpiAtdMonth(floor(dv),m);
LpiAtdDay(floor(dv),d);
*y += 1900;
}
void	atdbConvertTime(dv,h,m,s)
lfloat8	dv;
lslong	*h,*m,*s;
{
LpiAtdHour(fmod(dv,floor(dv)),h);
LpiAtdMinute(fmod(dv,floor(dv)),m);
LpiAtdSecond(fmod(dv,floor(dv)),s);
}
char *StrStatus (stat, str) 
long stat;
char *str;
{
    int i;

	str[0] = 0;
	if (stat != 0xffffffffL)
	{
		str[0] = '-';
		for (i = 0; i < NUMQUAL; i++)
		{
			if (stat & qualbits[i])
			{
				str [0] = qual[i];
				break;
			}
		}
		str[1] = '-';
		for (i = 0; i < NUMSEV; i++)
		{
			if (stat & sevbits[i])
			{
				str [1] = sev[i];
				break;
			}
		}
		str[2] = '-';
		for (i = 0; i < NUMALM; i++)
		{
			if (stat & almbits[i])
			{
				str [2] = alms[i];
				break;
			}
		}
		str[3] = 0;
	}
    return str;
}
long longStatus (stat)
char *stat;
{
	unsigned long retstatus = 0;
	char *cp;

	if (stat[0] && (cp = strchr (qual, stat[0])))
	{
		retstatus = retstatus | qualbits [ cp-qual ];
	}
	if (stat[1] && (cp = strchr (sev, stat[1])))
	{
		retstatus = retstatus | sevbits [ cp-sev ];
	}
	if (stat[2] && (cp = strchr (alms, stat[2])))
	{
		retstatus = retstatus | almbits [ cp-alms ];
	}
	return retstatus;
}
