/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include "aim.h"

/* create and manage the AVM edit dialog box */
static Widget aimList,aimBrowser,sel,editRowCol,editEnabClean;
static Widget editDaily,editFSize,editEnabArch,editMaxDur,editSpace,editClean,frame,editOlder;
static Widget fileList;
static XmString aimCurrentItem;
int entryChanged = 0;
void aimCreateEdit(Widget parent)
{
  Widget label;
  int n=0;
  Arg args[20];
  XmString title,listLabel,okLabel,cancelLabel,helpLabel,dirString;
  
  title = XmStringCreateLocalized("Archive Configuration");
  aimEditDialog = XmCreateBulletinBoard(parent,"ARCHCFG",args,n);
  XtVaSetValues(aimEditDialog,
		XmNnoResize,True,
		XmNautoUnmanage,False,
		XmNdialogTitle,title,NULL);
  n=0;
  listLabel = XmStringCreateLocalized("Archiving Directory List:");
  okLabel = XmStringCreateLocalized("Browse");
  cancelLabel = XmStringCreateLocalized("Dismiss");
  helpLabel = XmStringCreateLocalized("Delete");
  /* set args */
  XtSetArg(args[n],XmNlistLabelString,listLabel);n++;
  XtSetArg(args[n],XmNokLabelString,okLabel);n++;
  XtSetArg(args[n],XmNcancelLabelString,cancelLabel);n++;
  XtSetArg(args[n],XmNhelpLabelString,helpLabel);n++;
  XtSetArg(args[n],XmNscrollBarDisplayPolicy,XmSTATIC);n++;
  XtSetArg(args[n],XmNlistVisibleItemCount,13);n++;
  /* create dialog */
  sel = XmCreateSelectionBox(aimEditDialog,"DIR",args,n);
  aimList = XmSelectionBoxGetChild(sel,XmDIALOG_LIST);
  XtVaSetValues(aimList,XmNscrollBarDisplayPolicy,XmSTATIC,NULL);
  XtRemoveAllCallbacks(aimList,XmNdefaultActionCallback);
  XtRemoveAllCallbacks(aimList,XmNbrowseSelectionCallback);
  XtAddCallback(aimList,XmNbrowseSelectionCallback,(XtCallbackProc)aimSelect,(XtPointer)0);
  XtManageChild(XmSelectionBoxGetChild(sel,XmDIALOG_APPLY_BUTTON));
  XtUnmanageChild(XmSelectionBoxGetChild(sel,XmDIALOG_TEXT));
  XtUnmanageChild(XmSelectionBoxGetChild(sel,XmDIALOG_SELECTION_LABEL));
  XtAddCallback(sel,XmNokCallback,(XtCallbackProc)aimBrowse,(XtPointer)0);
  XtAddCallback(sel,XmNhelpCallback,(XtCallbackProc)aimDelete,(XtPointer)0);
  XtAddCallback(sel,XmNcancelCallback,(XtCallbackProc)aimDismiss,(XtPointer)0);
  XtAddCallback(sel,XmNapplyCallback,(XtCallbackProc)aimApply,(XtPointer)0);
  /* manage selection box and free strings */
  XtManageChild(sel);
  XtManageChild(aimEditDialog);
  XmStringFree(title);
  XmStringFree(listLabel);
  XmStringFree(okLabel);
  XmStringFree(cancelLabel);
  XmStringFree(helpLabel);
  /* Add text widgets */
  /* Run daily at xxx O'Clock */
  n=0;
  XtSetArg(args[n],XmNx,580);n++;
  XtSetArg(args[n],XmNy,20);n++;
  XtSetArg(args[n],XmNmaxLength,2);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,3);n++;
  editDaily = XmCreateText(aimEditDialog,"DAILY",args,n);
  XtManageChild(editDaily);
  XtAddCallback(editDaily,XmNmodifyVerifyCallback,(XtCallbackProc)aimCheckDigits,(XtPointer)0);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Run daily at:",14,
				  XmNx,473,
				  XmNy,26,
				  NULL);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"O'Clock",8,
				  XmNx,625,
				  XmNy,26,
				  NULL);
 /* Target file size in MBytes */
  n=0;
  XtSetArg(args[n],XmNx,580);n++;
  XtSetArg(args[n],XmNy,60);n++;
  XtSetArg(args[n],XmNmaxLength,3);n++;
  XtSetArg(args[n],XmNcolumns,4);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  editFSize = XmCreateText(aimEditDialog,"FSIZE",args,n);
  XtManageChild(editFSize);
  XtAddCallback(editFSize,XmNmodifyVerifyCallback,(XtCallbackProc)aimCheckDigits,(XtPointer)0);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Target file size:",18,
				  XmNx,441,
				  XmNy,66,
				  NULL);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"MBytes",7,
				  XmNx,630,
				  XmNy,66,
				  NULL);
  /* Max file duration in days */
  n=0;
  XtSetArg(args[n],XmNx,580);n++;
  XtSetArg(args[n],XmNy,100);n++;
  XtSetArg(args[n],XmNmaxLength,3);n++;
  XtSetArg(args[n],XmNcolumns,4);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  editMaxDur = XmCreateText(aimEditDialog,"MAXDUR",args,n);
  XtAddCallback(editMaxDur,XmNmodifyVerifyCallback,(XtCallbackProc)aimCheckDigits,(XtPointer)0);
  XtManageChild(editMaxDur);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Max file duration:",19,
				  XmNx,433,
				  XmNy,106,
				  NULL);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Days",5,
				  XmNx,630,
				  XmNy,106,
				  NULL);

  /* Disk space margin */
  n=0;
  XtSetArg(args[n],XmNx,580);n++;
  XtSetArg(args[n],XmNy,140);n++;
  XtSetArg(args[n],XmNmaxLength,2);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  XtSetArg(args[n],XmNcolumns,3);n++;
  editSpace = XmCreateText(aimEditDialog,"SPACE",args,n);
  XtAddCallback(editSpace,XmNmodifyVerifyCallback,(XtCallbackProc)aimCheckDigits,(XtPointer)0);
  XtManageChild(editSpace);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Disk space margin:",19,
				  XmNx,433,
				  XmNy,146,
				  NULL);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Pcnt.",6,
				  XmNx,630,
				  XmNy,146,
				  NULL);

  /* Clean non-archived data after ddd days */
  n=0;
  XtSetArg(args[n],XmNx,580);n++;
  XtSetArg(args[n],XmNy,180);n++;
  XtSetArg(args[n],XmNmaxLength,3);n++;
  XtSetArg(args[n],XmNcolumns,4);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  editClean = XmCreateText(aimEditDialog,"CLEAN",args,n);
  XtAddCallback(editClean,XmNmodifyVerifyCallback,(XtCallbackProc)aimCheckDigits,(XtPointer)0);
  XtManageChild(editClean);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Clean after:",14,
				  XmNx,481,
				  XmNy,186,
				  NULL);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Days",5,
				  XmNx,630,
				  XmNy,186,
				  NULL);


  /* Archive data older than ddd days */
  n=0;
  XtSetArg(args[n],XmNx,580);n++;
  XtSetArg(args[n],XmNy,220);n++;
  XtSetArg(args[n],XmNmaxLength,3);n++;
  XtSetArg(args[n],XmNcolumns,4);n++;
  XtSetArg(args[n],XmNverifyBell,True);n++;
  editOlder = XmCreateText(aimEditDialog,"OLDER",args,n);
  XtAddCallback(editOlder,XmNmodifyVerifyCallback,(XtCallbackProc)aimCheckDigits,(XtPointer)0);
  XtManageChild(editOlder);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Archive data older than:",25,
				  XmNx,385,
				  XmNy,226,
				  NULL);
  label = XtVaCreateManagedWidget("label",xmLabelWidgetClass,aimEditDialog,
				  XtVaTypedArg,XmNlabelString,XmRString,"Days",5,
				  XmNx,630,
				  XmNy,226,
				  NULL);


  /* Set/Display archive/clean enable/disable */
  frame = XtVaCreateManagedWidget("frame",xmFrameWidgetClass,aimEditDialog,
				  XmNx,451,
				  XmNy,275,
				  XmNshadowType,XmSHADOW_ETCHED_OUT,
				  NULL);
  editRowCol = XtVaCreateManagedWidget("rowcol",xmRowColumnWidgetClass,frame,
				       XmNorientation,XmHORIZONTAL,
				       XmNpacking,XmPACK_COLUMN,
				       XmNnumColumns,2,
				       NULL);
  editEnabArch = XtVaCreateManagedWidget("ENABARCH",xmToggleButtonWidgetClass,editRowCol,
					  XtVaTypedArg,XmNlabelString,XmRString,"Enable archiving",17,
					  XmNindicatorSize,15,
					  XmNmarginHeight,0,
					  NULL);
  XtAddCallback(editEnabArch,XmNvalueChangedCallback,(XtCallbackProc)aimModified,0);
  
  editEnabClean = XtVaCreateManagedWidget("ENABCL",xmToggleButtonWidgetClass,editRowCol,
					  XtVaTypedArg,XmNlabelString,XmRString,"Enable clean-up",16,
					  XmNindicatorSize,15,
					  XmNmarginHeight,0,
					  NULL);
  XtAddCallback(editEnabClean,XmNvalueChangedCallback,(XtCallbackProc)aimModified,0);

  /*
    Create the browser dialog here
    */
  title = XmStringCreateLocalized("Archive directorys");
  dirString = XmStringCreateLocalized("/tis4000");
  n=0;
  XtSetArg(args[n],XmNautoUnmanage,False);n++;
  XtSetArg(args[n],XmNdialogTitle,title);n++;
  XtSetArg(args[n],XmNdirectory,dirString);n++;
  aimBrowser = (Widget)XmCreateFileSelectionDialog(aimEditDialog,"BROWSE",args,n);
  fileList = XmSelectionBoxGetChild(aimBrowser,XmDIALOG_LIST);
  XtUnmanageChild(XtParent(fileList));
  XtUnmanageChild(XmSelectionBoxGetChild(aimBrowser,XmDIALOG_LIST_LABEL));
  XtUnmanageChild(XmSelectionBoxGetChild(aimBrowser,XmDIALOG_HELP_BUTTON));
  XtAddCallback(aimBrowser,XmNokCallback,(XtCallbackProc)aimSetDir,(XtPointer)0);
  XtAddCallback(aimBrowser,XmNcancelCallback,(XtCallbackProc)aimBrowseCancel,(XtPointer)0);
  XmStringFree(title);
  XmStringFree(dirString);
}
/*
  load the first record and fill in the data
*/
void editInit()
{
  /*
    The file is written in the following order. The order follows the layout of the dialog box.

    Run daily
    Target file size
    Max file duration
    Disk space margin
    Clean after
    Archive data older than
    enable archiving
    enable clean-up
    number of directories in list if zero then done else write list
    directory list...
    */
  FILE *fp;
  char text[80];
  int numItems,i;
  XmString item;

  XmTextSetString(editDaily,"0");		/* set text widget default value */
  XmTextSetString(editFSize,"0");		/* set text widget default value */
  XmTextSetString(editMaxDur,"0");		/* set text widget default value */
  XmTextSetString(editSpace,"0");		/* set text widget default value */
  XmTextSetString(editClean,"0");		/* set text widget default value */
  XmTextSetString(editOlder,"0");		/* set text widget default value */
  if((fp = fopen(AIM_CONFIG_FILE,"r")) != 0)
    {
      fgets(text,79,fp);			/* get line from file */
      text[strlen(text)-1] = 0;			/* drop LF */
      XmTextSetString(editDaily,text);		/* set text widget value */

      fgets(text,79,fp);			/* get line from file */
      text[strlen(text)-1] = 0;			/* drop LF */
      XmTextSetString(editFSize,text);		/* set text widget value */

      fgets(text,79,fp);			/* get line from file */
      text[strlen(text)-1] = 0;			/* drop LF */
      XmTextSetString(editMaxDur,text);		/* set text widget value */

      fgets(text,79,fp);			/* get line from file */
      text[strlen(text)-1] = 0;			/* drop LF */
      XmTextSetString(editSpace,text);		/* set text widget value */

      fgets(text,79,fp);			/* get line from file */
      text[strlen(text)-1] = 0;			/* drop LF */
      XmTextSetString(editClean,text);		/* set text widget value */

      fgets(text,79,fp);			/* get line from file */
      text[strlen(text)-1] = 0;			/* drop LF */
      XmTextSetString(editOlder,text);		/* set text widget value */

      fgets(text,79,fp);			/* get line from file */
      text[strlen(text)-1] = 0;			/* drop LF */
      XmToggleButtonSetState(editEnabArch,(!strcmp(text,AIM_ARCH_ENABLED) ? 1 : 0),False);

      fgets(text,79,fp);			/* get line from file */
      text[strlen(text)-1] = 0;			/* drop LF */
      XmToggleButtonSetState(editEnabClean,(!strcmp(text,AIM_ARCH_ENABLED) ? 1 : 0),False);

      fgets(text,79,fp);			/* get line from file */
      text[strlen(text)-1] = 0;			/* drop LF */
      numItems = atoi(text);			/* number of directory items */
      for(i = 0;i < numItems;i++)
	{
	  fgets(text,79,fp);			/* get line from file */
	  text[strlen(text)-1] = 0;	       	/* drop LF */
	  item = XmStringCreateLocalized(text); /* create item string */
	  XmListAddItem(aimList,item,0);	/* add item to list */
	  XmStringFree(item);			/* free XmString */
	}
    }
  else
    aimCreateInfo("Can't open config file for reading","alarmConfig");
  entryChanged = 0;
}
/*
  Apply any changes to the record specified by the startDate
  */
void aimApply(Widget w,XtPointer client_data,XmSelectionBoxCallbackStruct *cbs)	/* save data to current record */
{
  /*
    The file is written in the following order. The order follows the layout of the dialog box.

    Run daily
    Target file size
    Max file duration
    Disk space margin
    Clean after
    enable archiving
    enable clean-up
    number of directories in list if zero then done else write list
    directory list...
    */
  FILE *fp;
  char *text;
  int numItems;
  XmStringTable items;

  if((fp = fopen(AIM_CONFIG_FILE,"w")) != 0)
    {
      text = XmTextGetString(editDaily);
      fprintf(fp,"%s\n",(strlen(text) ? text : "0"));
      XtFree(text);

      text = XmTextGetString(editFSize);
      fprintf(fp,"%s\n",(strlen(text) ? text : "0"));
      XtFree(text);

      text = XmTextGetString(editMaxDur);
      fprintf(fp,"%s\n",(strlen(text) ? text : "0"));
      XtFree(text);

      text = XmTextGetString(editSpace);
      fprintf(fp,"%s\n",(strlen(text) ? text : "0"));
      XtFree(text);

      text = XmTextGetString(editClean);
      fprintf(fp,"%s\n",(strlen(text) ? text : "0"));
      XtFree(text);

      text = XmTextGetString(editOlder);
      fprintf(fp,"%s\n",(strlen(text) ? text : "0"));
      XtFree(text);

      fprintf(fp,"%s\n",(XmToggleButtonGetState(editEnabArch) ? AIM_ARCH_ENABLED : AIM_ARCH_DISABLED));
      fprintf(fp,"%s\n",(XmToggleButtonGetState(editEnabClean) ? AIM_ARCH_ENABLED : AIM_ARCH_DISABLED));

      XtVaGetValues(aimList,XmNitemCount,&numItems,XmNitems,&items,NULL);
      fprintf(fp,"%d\n",numItems);
      while(--numItems >= 0)
	{
	  XmStringGetLtoR(items[numItems],XmSTRING_DEFAULT_CHARSET,&text);
	  fprintf(fp,"%s\n",text);
	  XtFree(text);
	}
      fclose(fp);
    }
  else
    aimCreateInfo("Can't open config file for writing","alarmConfig");
  entryChanged = 0;
}
void aimDismiss(Widget w,XtPointer client_data,XtPointer call_data)   	/* ask to exit program...prompt if modified */
{
  if(entryChanged)
    {
      aimCreateAreYouSure("Quit without saving changes ?","archConfig");
      XtRemoveAllCallbacks(aimAreYouSure,XmNokCallback);
      XtAddCallback(aimAreYouSure,XmNokCallback,aimDoDismiss,(XtPointer)0);
      return;
    }
  exit(1);
}
void aimDoDismiss(Widget w,XtPointer client_data,XtPointer call_data)  	/* exit program */
{
  exit(1);
}
void aimDelete(Widget w,XtPointer client_data,XtPointer call_data)     /* ask to delete current(selected) record */
{
  aimCreateAreYouSure("Delete selected directory","archConfig");
  XtRemoveAllCallbacks(aimAreYouSure,XmNokCallback);
  XtAddCallback(aimAreYouSure,XmNokCallback,aimDoDelete,(XtPointer)0);
  return;
}
void aimDoDelete(Widget w,XtPointer client_data,XtPointer call_data)	/* actually delete record */
{
  XmListDeleteItem(aimList,aimCurrentItem);
  XmStringFree(aimCurrentItem);
  entryChanged = 1;
}
void aimSelect(Widget w,XtPointer client_data,XmSelectionBoxCallbackStruct *cbs)     /* select record from list based on date range */
{
  aimCurrentItem = XmStringCopy(cbs->value);
  entryChanged = 1;
}
void aimModified(Widget w,XtPointer client_data,XtPointer call_data)	/* mark record as modified via this callback */
{
  entryChanged = 1;
}
void aimBrowse(Widget w,XtPointer client_data,XtPointer call_data)	/* pop-up directory box */
{
  XtManageChild(aimBrowser);
}
void aimSetDir(Widget w,XtPointer client_data,XmFileSelectionBoxCallbackStruct *cbs)
{
  XmListAddItem(aimList,cbs->dir,False);
  entryChanged = 1;
}
void aimCheckDigits(Widget w,char *data,XmTextVerifyCallbackStruct *cbs)
{
  if(cbs -> event == NULL)			/* if other than keyboard entry ignore */
    return;
  entryChanged=1;
#ifdef SOLARIS
  if(cbs->text->length == 0)
    {
      return;
    }
#else
  if(cbs->text->ptr == NULL)
    {
      return;
    }
#endif
/* Only 0 - 9 */
  if(!isdigit(cbs->text->ptr[0]))
    {
      cbs->doit = False;				/* don't put char in widget */
      return;
    }
  entryChanged = 1;
}
void aimBrowseCancel(Widget w,XtPointer client_data,XtPointer call_data)	/* pop-up directory box */
{
  XtUnmanageChild(aimBrowser);
}
