
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
 /* 	FILE NAME   :	catFixup.c
  *	PURPOSE	    :	Install Unix time fields in track file
  *
  *	AUTHOR	    :	Grant Irani
  *	DATE	    :	Feb 2, 1998
  *
  *	Copyright 1997, Tate Integrated Systems, L.P.  All rights reserved.
  */
#include <stdio.h>
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32
#ifdef WIN32
#include <time.h>
#else
#include <sys/time.h>
#include <sys/types.h>
#endif WIN32
#ifdef AXP
#include <sys/stat.h>
#endif
#if defined(SOLARIS) || defined(WIN32)
#include <sys/stat.h>
#endif
#include <fcntl.h>

#ifndef FALSE
#define	FALSE		(0)
#define	TRUE		(1)
#endif

#include "avmDefs.h"

FIELD4INFO	avmFieldInfo[] = 
	{
	{AVM_STARTDATE_NAME,	'C',	AVM_STARTDATE_SIZE,	0},
	{AVM_ENDDATE_NAME,	'C',	AVM_ENDDATE_SIZE,	0},
	{AVM_MOUNTED_NAME,	'L',	AVM_MOUNTED_SIZE,      	0},
	{AVM_DISKLABEL_NAME,	'C',	AVM_DISKLABEL_SIZE,	0},
	{AVM_MOUNTPNT_NAME,	'C',	AVM_MOUNTPNT_SIZE,	0},
	{AVM_TABLENAME_NAME,	'C',	AVM_TABLENAME_SIZE,	0},
	{0,0,0,0}
	};
T4TAG_INFO	avmTagInfo[] = 
	{
	{"STARTDATE",	"STARTDATE",	0,	0,	0},
	{0,0,0,0,0}
	};

/************************************************************************
 *			PUBLIC DECLARATIONS				*
 ************************************************************************/

static	C4CODE		cb;				/* Codebase status configuration block */
static	D4DATA		*catFile;		/* Codebase file descriptors */
static	char		catName[30];	/* Name of db file */
static	char		FilePath[40];


/********************************************************************************************************/
#define CONVERTSUB
#ifdef WIN32
#define TIS4000DB   "\\tis4000db\\"
#else
#define TIS4000DB   "/tis4000db"
#endif WIN32
#define DBCNVRT	    "catsave"
#define FIELDINFO   avmFieldInfo
#define TAGINFO	    avmTagInfo

static void InsertUnixTime (DATA4 *data)
{
}

#include "convertdb.h"

int	main ( )
{
    char FullName [80];	/* name + path */
    struct tm tmstruct;
    char *stringp;

    strcpy( catName, "volCatalog" );

    d4init( &cb );		/* Initialize the Codebase settings. */
#if defined(USECB63) || defined(WIN32)
    cb.errGo = 0;
    cb.errCreate = 0;
    cb.errOpen = 0;
    cb.errTagName = 0;
    cb.errFieldName = 0;
#else
    cb.go_error = 0;
    cb.create_error = 0;
    cb.open_error = 0;
    cb.tag_name_error = 0;
    cb.field_name_error = 0;
#endif USECB63

    sprintf (FullName, "%s%s", TIS4000DB, catName);
    if (!(catFile = d4open (&cb, FullName)))
    {
	printf ("No catalog file exists\n");
    }
    else if (d4field (catFile, "UNIX_TIME") == 0)
    {
	/* Tracking file must be converted. */
	d4close( catFile );

	convertDB (catName);

	/* Set file protections for other users in the group */
	memset( FilePath, 0, sizeof FilePath );
	sprintf( FilePath, "%s.dbf", catName );
	chmod( FilePath, 0666 );
	sprintf( FilePath, "%s.mdx", catName );
	chmod( FilePath, 0666 );

	printf ("File converted\n");
    }
    else
    {
	for (d4top (catFile); !d4eof (catFile); d4skip (catFile, 1))
	{
	    if (!d4deleted (catFile) && f4long (d4field( catFile, "UNIX_TIME" )) == 0)
	    {
		/* Convert date/time fields to time_t unix_time */
		stringp = f4str( d4field( catFile, "TRK_DATE" ));
		tmstruct.tm_year = atoi( stringp + 6 );
		tmstruct.tm_mon = atoi( stringp ) - 1;
		tmstruct.tm_mday = atoi( stringp + 3 );
		stringp = f4str( d4field( catFile, "TRK_TIME" ));
		tmstruct.tm_hour = atoi( stringp );
		tmstruct.tm_min = atoi( stringp + 3 );
		tmstruct.tm_sec = atoi( stringp + 6 );
		tmstruct.tm_isdst = -1;
		f4assign_long ( d4field( catFile, "UNIX_TIME" ), mktime (&tmstruct));
		d4flush (catFile);
	    }
	}
    }
}
