/*
 * Defines
 * All paths, old and new are defined here.
 */
#define ROOT_DIR        "/ata0/"
#define BINARY_BASE_DIR "/ata0/tis4000"
#define OLD_BINARIES    "/ata0/tis4000/torTasks/X486/"
#define NEW_BINARIES    "/ata0/tasks/"
#define OLD_SCRIPT_BASE "/ata0/tis4000d/"
#define NEW_SCRIPTS     "/ata0/scripts/"
#define OLD_DB          "/ata0/tis4000d/"
#define NEW_DB          "/ata0/tis4000d/"
#define SSL_BASE_DIR    "/ata0/usr/"
#define OLD_CERTS       "/ata0/usr/local/ssl/certs/"
#define NEW_CERTS       "/ata0/certs/"

/* Define the size of a fully qualified file name */
#define FQN_SIZE        50


/*
 * Function prototypes
 */

/*
 * Function:      SimplifyDirectory
 * Purpose:       To rearange the directory structure of an IOC
 * Arguments;     void
 * Returns:       STATUS
 * Preconditions: Old directory structure in place
 */
STATUS SimplifyDirectory(int verbosity);

/*
 * Function:      MoveFiles
 * Purpose:       To move executable files from one directory to another
 * Arguments:     Source and destination directories and type of file for debug messages
 * Returns:       STATUS OK on success or error
 * Preconditions: Files should be in the source dir and the parent of the destination
 *                directory should exist
 */
STATUS MoveFiles(char *old_dir, char *new_dir, char *file_type);

/*
 * Function:      CleanDir
 * Purpose:       Removes all files in a directory
 * Arguments:     Directory name
 * Returns:       STATUS OK if successfull or ERROR if directory does not exist
 * Preconditions: Directory should exist
 */
STATUS CleanDir (char *dir);

