/*caBuild.c,v 1.1.1.1 1999/08/03 14:41:58 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*			OPEN A CHANNEL				*/
/*								*/
/*	Author:	Gordon Uchenick					*/
/*								*/
/****************************************************************/
#ifdef vxWorks
#include <vxWorks.h>
#include <taskLib.h>
#endif vxWorks

#ifdef	vms
#include <selectvms.h>
#endif vms
#ifdef WIN32
#include <sys/types.h>
#include	<winsock.h>
#else
#include <types.h>
#include <in.h>
#endif WIN32

#include "agentErrs.h"
#include "agentMsgs.h"
#include "cadef.h"
#include "dataTypes.h"
#include "caContext.h"
#include "db_access.h"		/* Original EPICS header */

#ifdef vxWorks
#include "localChannel.h"
#endif vxWorks

#if defined(AXP) || defined(vxWorks)
#include <string.h>
#endif


int ca_build_and_connect(name, type, count, pChid, pValue, pFunc, pUser)
char	*name;
int	type;
int	count;
chid	*pChid;
void	*pValue;
void	(*pFunc)(struct connection_handler_args);
void	*pUser;
{
    chid	currChid;
    short	msgType;
    short	length;
    CATX	*ctx;
    struct
	{
        CH_BUILD	chBuild;
	char		nameBuff[sizeof(currChid -> chanName)];
	} m;

    /*
    Get our context
    */

    ctx = getContext();

    /*
    First validate that this is a legal request. The data types
    passed by the user are the ones defined in <db_access.h>.
    The only reason for this is to maintain source compatibility
    between the original implementation and this one.
    */

    if (type != AGNT_NOCONN)
        if (!OLD_VALID_DB_REQ(type))
	    return (AGNT_BADTYPE);

    /*
    Validate that the name is not too big.
    */

    if (strlen(name) > (sizeof(currChid -> chanName) - 1))
	return (AGNT_STRTOBIG);

    /*
    Get a currChid and put at the front of the chain
    */

    currChid = newCHID();
    if (!currChid)
	return (AGNT_ALLOCMEM);
    currChid -> pNextChan = ctx -> pFirstChid;
    ctx -> pFirstChid = currChid;
    if (currChid -> pNextChan)
	currChid -> pNextChan -> pPrevChan = (struct chanBlock *) currChid;

    /*
    Fill out the information in the CHID
    */

    currChid -> chanState = neverOpened;
    currChid -> nativeType = AGNT_NOCONN;
    strcpy(currChid -> chanName, name);
    currChid -> buildType = type;
    currChid -> buildCount = count;
    currChid -> buildValue = pValue;
    currChid -> connFunc = pFunc;
    currChid -> puser = pUser;
#ifdef vxWorks
    currChid -> paddr = (void *) taskIdSelf();
#endif

    /*
    Now create a message and send it to Channel Acquisition.
    */

#ifndef POINTER64
    m.chBuild.chHandle = (int) currChid;
#else
    m.chBuild.chHandle = currChid ->chidToken;
#endif
    if (type != AGNT_NOCONN)
    	m.chBuild.chType = htons(dbrXlate[type]);
    else
	m.chBuild.chType = htons((unsigned short)AGNT_NOCONN);
    m.chBuild.chCount = htons(currChid -> buildCount);
    length = strlen(name) + 1;
    m.chBuild.chNameLen = htons(length);
    strcpy(m.nameBuff, name);
    msgType = htons(CHAN_BUILD);
    sendCAQ(msgType, (char *) &m, sizeof(CH_BUILD) + length);

    /*
    Also, see if this channel is local
    */

#ifdef vxWorks
    checkLocalChannel(name, &(currChid -> pDbAddr));
#endif

    /*
    Set the currChid in caller's variable and we are done
    */

    *pChid = currChid;
    return(AGNT_NORMAL);
}

