/*caGet.c,v 1.1.1.1 1999/08/03 14:41:58 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*			ARRAY DIRECT READ			*/
/*								*/
/*	Check that the data type conforms with the way that	*/
/*	the channel was opened. If so, then post the user's	*/
/*	data address in the chid and send the message to 	*/
/*	Channel Acquisition and Control to make him do the	*/
/*	read.							*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/
#ifdef vxWorks
#include <vxWorks.h>
#endif

#ifdef WIN32
#include <winsock.h>
#endif WIN32

#ifdef WIN32
#include <sys/types.h>
#include	<winsock.h>
extern int sendCAQ(short, char *, int);
#else
#include <types.h>
#include <in.h>
#endif WIN32
#include "agentMsgs.h"
#include "agentErrs.h"
#include "dataTypes.h"
#include "dbDefs.h"
#include "db_access.h"		/* Original EPICS source file */
#include "cadef.h"

#ifdef vxWorks
#include "caContext.h"
#include "localChannel.h"
#endif

int ca_array_get(type, count, pChid, pValue)
int	type;
int	count;
chid	pChid;
void	*pValue;
{
    short	msgType;
    CH_DIRREAD	dirRead;
#ifdef vxWorks
    CATX	*ctx;
#endif

    if (!pChid)
	return (AGNT_BADCHID);
    if (count == 0)
	count = 1;
    if (count > pChid -> nativeCount)
	return (AGNT_BADCOUNT);
    if (!dbr_type_is_valid(type))
	return (AGNT_BADTYPE);

    /*
    See if we can do this locally.
    */

#ifdef vxWorks
    ctx = getContext();
    if (localDbGet(pChid -> pDbAddr, dbrXlate[type], count, ctx -> caDbrBuff))
	{
	caConvType(ctx -> caDbrBuff, dbrXlate[type], pValue, type, count);
	return (AGNT_NORMAL);
	}
#endif

    pChid -> buildType = type;
    pChid -> buildCount = count;
    pChid -> buildValue = pValue;

    msgType = htons(CHAN_DIRREAD);
    dirRead.chHandle = pChid -> handle;
    dirRead.chDataType = htons(dbrXlate[type]);
    dirRead.chNumElem = htons((short)count);
    sendCAQ(msgType, (char *) &dirRead, sizeof(dirRead));
    return (AGNT_NORMAL);
}
