/*dataTypes.c,v 1.1.1.1 1999/08/03 14:42:02 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		DATA TYPE TRANSLATION VECTORS			*/
/*								*/
/*	The following vectors translate from the DBR types	*/
/*	as defined in db_access.h to the newer agent types,	*/
/*	and also have, for each set of embellishments, the	*/
/*	corresponding option bits for dbGetField.		*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#include <dataTypes.h>

/******
	Translation from DBR types to agent types
******/

short dbrXlate[35] =
    {
    AGNT_STRING,					/* DBR_STRING      = 00 */
    AGNT_SHORT,						/* DBR_SHORT       = DBR_INT = 1 */
    AGNT_FLOAT,						/* DBR_FLOAT       = 02 */
    AGNT_ENUM,						/* DBR_ENUM        = 03 */
    AGNT_CHAR,						/* DBR_CHAR        = 04 */
    AGNT_LONG,						/* DBR_LONG        = 05 */
    AGNT_DOUBLE,					/* DBR_DOUBLE      = 06 */

    AGNT_STRING | AGNT_STAT,				/* DBR_STS_STRING  = 07 */
    AGNT_SHORT  | AGNT_STAT,				/* DBR_STS_SHORT   = DBR_STS_INT = 08 */
    AGNT_FLOAT  | AGNT_STAT,				/* DBR_STS_FLOAT   = 09 */
    AGNT_ENUM   | AGNT_STAT,				/* DBR_STS_ENUM    = 10 */
    AGNT_CHAR   | AGNT_STAT,				/* DBR_STS_CHAR    = 11 */
    AGNT_LONG	| AGNT_STAT,				/* DBR_STS_LONG    = 12 */
    AGNT_DOUBLE | AGNT_STAT,				/* DBR_STS_DOUBLE  = 13 */

    AGNT_STRING | AGNT_STAT | AGNT_TIME,		/* DBR_TIME_STRING = 14 */
    AGNT_SHORT  | AGNT_STAT | AGNT_TIME,		/* DBR_TIME_INT    = DBR_TIME_SHORT = 15 */
    AGNT_FLOAT	| AGNT_STAT | AGNT_TIME,		/* DBR_TIME_FLOAT  = 16 */
    AGNT_ENUM   | AGNT_STAT | AGNT_TIME,		/* DBR_TIME_ENUM   = 17 */
    AGNT_CHAR	| AGNT_STAT | AGNT_TIME,		/* DBR_TIME_CHAR   = 18 */
    AGNT_LONG   | AGNT_STAT | AGNT_TIME,		/* DBR_TIME_CHAR   = 19 */
    AGNT_DOUBLE | AGNT_STAT | AGNT_TIME,		/* DBR_TIME_DOUBLE = 20 */

    AGNT_STRING | AGNT_STAT /*| AGNT_GRAPH*/,		/* DBR_GR_STRING   = 21 */
    AGNT_SHORT  | AGNT_STAT | AGNT_GRAPH,		/* DBR_GR_SHORT    = DBR_GR_INT = 22 */
    AGNT_FLOAT  | AGNT_STAT | AGNT_GRAPH,		/* DBR_GR_FLOAT    = 23 */
    AGNT_ENUM   | AGNT_STAT | AGNT_GRAPH,		/* DBR_GR_ENUM     = 24 */
    AGNT_CHAR   | AGNT_STAT | AGNT_GRAPH,		/* DBR_GR_CHAR     = 25 */
    AGNT_LONG   | AGNT_STAT | AGNT_GRAPH,		/* DBR_GR_LONG     = 26 */
    AGNT_DOUBLE | AGNT_STAT | AGNT_GRAPH,		/* DBR_GR_DOUBLE   = 27 */

    AGNT_STRING | AGNT_STAT /*| AGNT_GRAPH*/ | AGNT_CNTRL,	/* DBR_CTRL_STRING = 28 */
    AGNT_SHORT  | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL,	/* DBR_CTRL_SHORT  = DBR_CTRL_INT = 29 */
    AGNT_FLOAT  | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL,	/* DBR_CTRL_FLOAT  = 30 */
    AGNT_ENUM   | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL,	/* DBR_CTRL_ENUM   = 31 */
    AGNT_CHAR   | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL,	/* DBR_CTRL_CHAR   = 32 */
    AGNT_LONG   | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL,	/* DBR_CTRL_LONG   = 33 */
    AGNT_DOUBLE | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL,	/* DBR_CTRL_DOUBLE = 34 */
    };

#ifdef vax

/****************************************************************/
/*								*/
/*	BRAIN DAMAGE ALERT!	BRAIN DAMAGE ALERT!		*/
/*								*/
/*	The VAX C compiler is giving me a fit about compiling	*/
/*	the above array as initialized data. Well, if it don't	*/
/*	work one way, you've got to try another. Thanx, guys.	*/
/*								*/
/****************************************************************/

initXlate()
{
    dbrXlate[0] = AGNT_STRING;						/* DBR_STRING     */
    dbrXlate[1] = AGNT_SHORT;						/* DBR_SHORT      */
    dbrXlate[2] = AGNT_FLOAT;						/* DBR_FLOAT      */
    dbrXlate[3] = AGNT_ENUM;						/* DBR_ENUM       */
    dbrXlate[4] = AGNT_CHAR;						/* DBR_CHAR       */
    dbrXlate[5] = AGNT_LONG;						/* DBR_LONG       */
    dbrXlate[6] = AGNT_DOUBLE;						/* DBR_DOUBLE     */

    dbrXlate[7] = AGNT_STRING | AGNT_STAT;				/* DBR_STS_STRING */
    dbrXlate[8] = AGNT_SHORT  | AGNT_STAT;				/* DBR_STS_SHORT  */
    dbrXlate[9] = AGNT_FLOAT  | AGNT_STAT;				/* DBR_STS_FLOAT  */
    dbrXlate[10] = AGNT_ENUM   | AGNT_STAT;				/* DBR_STS_ENUM   */
    dbrXlate[11] = AGNT_CHAR   | AGNT_STAT;				/* DBR_STS_CHAR   */
    dbrXlate[12] = AGNT_LONG	| AGNT_STAT;				/* DBR_STS_LONG   */
    dbrXlate[13] = AGNT_DOUBLE | AGNT_STAT;				/* DBR_STS_DOUBLE */

    dbrXlate[14] = AGNT_STRING | AGNT_STAT | AGNT_TIME;			/* DBR_TIME_STRING */
    dbrXlate[15] = AGNT_SHORT  | AGNT_STAT | AGNT_TIME;			/* DBR_TIME_INT    */
    dbrXlate[16] = AGNT_FLOAT	| AGNT_STAT | AGNT_TIME;		/* DBR_TIME_FLOAT  */
    dbrXlate[17] = AGNT_ENUM   | AGNT_STAT | AGNT_TIME;			/* DBR_TIME_ENUM   */
    dbrXlate[18] = AGNT_CHAR	| AGNT_STAT | AGNT_TIME;		/* DBR_TIME_CHAR   */
    dbrXlate[19] = AGNT_LONG   | AGNT_STAT | AGNT_TIME;			/* DBR_TIME_CHAR   */
    dbrXlate[20] = AGNT_DOUBLE | AGNT_STAT | AGNT_TIME;			/* DBR_TIME_DOUBLE */

    dbrXlate[21] = AGNT_STRING | AGNT_STAT;				/* DBR_GR_STRING   */
    dbrXlate[22] = AGNT_SHORT  | AGNT_STAT | AGNT_GRAPH;		/* DBR_GR_SHORT    */
    dbrXlate[23] = AGNT_FLOAT  | AGNT_STAT | AGNT_GRAPH;		/* DBR_GR_FLOAT    */
    dbrXlate[24] = AGNT_ENUM   | AGNT_STAT | AGNT_GRAPH;		/* DBR_GR_ENUM     */
    dbrXlate[25] = AGNT_CHAR   | AGNT_STAT | AGNT_GRAPH;		/* DBR_GR_CHAR     */
    dbrXlate[26] = AGNT_LONG   | AGNT_STAT | AGNT_GRAPH;		/* DBR_GR_LONG     */
    dbrXlate[27] = AGNT_DOUBLE | AGNT_STAT | AGNT_GRAPH;		/* DBR_GR_DOUBLE   */

    dbrXlate[28] = AGNT_STRING | AGNT_STAT | AGNT_CNTRL;		/* DBR_CTRL_STRING */
    dbrXlate[29] = AGNT_SHORT  | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL;	/* DBR_CTRL_SHORT  */
    dbrXlate[30] = AGNT_FLOAT  | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL;	/* DBR_CTRL_FLOAT  */
    dbrXlate[31] = AGNT_ENUM   | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL;	/* DBR_CTRL_ENUM   */
    dbrXlate[32] = AGNT_CHAR   | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL;	/* DBR_CTRL_CHAR   */
    dbrXlate[33] = AGNT_LONG   | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL;	/* DBR_CTRL_LONG   */
    dbrXlate[34] = AGNT_DOUBLE | AGNT_STAT | AGNT_GRAPH | AGNT_CNTRL;	/* DBR_CTRL_DOUBLE */
}
#endif vax
