/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		INCREASE SOCKET BUFFER TO 64K			*/
/*								*/
/*	The purpose of this routine is to increase the transmit	*/
/*	buffer size of a socket in 1K increments until we	*/
/*	either reach 40K or can't go any further, whichever	*/
/*	comes first. This procedure is necessary because of	*/
/*	extreme brain damage on the part of SOLARIS 2.x		*/
/*	socket library implementation.				*/
/*								*/
/*	Also, set the rx buffer size to 4096. This is because	*/
/*	SOLARIS getsockopt routines return zero unless the user	*/
/*	explicitly sets the size. This is an acknowledged bug.	*/
/*								*/
/*	Author: Gordon Uchenick					*/
/*								*/
/****************************************************************/

#include <types.h>
#include <socket.h>

sockGrow(fd)
{
    int		txSize;

    for (txSize = 4096; txSize < 40960; txSize += 1024)
	{
	if (setsockopt(fd, SOL_SOCKET, SO_SNDBUF, (const char *)(&txSize), 
							sizeof(txSize)) == -1)
	    break;
	}
    
    txSize = 4096;
    setsockopt(fd, SOL_SOCKET, SO_RCVBUF, (const char *)(&txSize), sizeof(txSize));
    return (0);
}
