/*tokensupport.c,v 1.1.1.1 1999/08/03 14:42:04 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************/
/*								*/
/*		TOKEN SUPPORT FOR 64 BIT ARCHITECTURES		*/
/*								*/
/*	This is a set of routines to provide translation between*/
/*	32 bit 'token's and the machine's memory pointers.	*/
/*								*/
/*	Author: Grant Irani					*/
/*								*/
/****************************************************************/

#include <channelControl.h>

#define MAXTOKENS 5000

/******
	Space for the real pointers, kept in an array.
******/

void *TokenPointers [MAXTOKENS];	/* Maximum tokens */



/******
	Convert a pointer to a token, the hard way.
******/

int TokenFromPointer64 (void *ptr)
{
    int limit;
    unsigned int srchIx = (unsigned int)(((long)ptr / (long)16) % MAXTOKENS);

    for (limit = 0; limit < MAXTOKENS; limit ++)
    {
	if (TokenPointers [srchIx] == 0)
	{
	    TokenPointers [srchIx] = ptr;
	    return (srchIx + 500000);
	}
	else if (TokenPointers [srchIx] == ptr)
	{
	    return (srchIx + 500000);
	}
	else
	{
	    srchIx = (srchIx + 1) % MAXTOKENS;
	}
    }
    /* no room at the Inn, bail out */
    return 0;
}
