/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/**************************************************************************
  contians definitions used by the launch_script utility
**************************************************************************/
#define      PROCESS_SIZE          60
#define      NUM_OPTIONS           10
#define      DOM_SIZE              10
#define      SHELL_SIZE             3
#define      PARAM_SIZE		   25	

/*  scriptdb table */

FIELD4INFO    script_flds[] = {
      /* Field name,            Type,      Width,     Decimals */
      { "SCRIPTID",				'C',	   28,		   0 },
      { "PROCESS",              'C',       60,         0 },
      { "SHELL",                'C',        3,         0 },
      { "DESC",                 'C',       50,         0 },
      { "HOUR",                 'N',        2,         0 },
      { "MINUTE",               'N',        2,         0 }, /* new as of 25-Apr-95 GCT */
      { "DOM",                  'C',        9,         0 },
      { "SUN",                  'L',        1,         0 },
      { "MON",                  'L',        1,         0 },
      { "TU",                   'L',        1,         0 },
      { "WED",                  'L',        1,         0 },
      { "TH",                   'L',        1,         0 },
      { "FRI",                  'L',        1,         0 },
      { "SAT",                  'L',        1,         0 },
      { "JAN",					'L',		1,         0 }, /* JAN - DEC 25-Apr-95 GCT */
      { "FEB",					'L',		1,         0 },
      { "MAR",					'L',		1,         0 },
      { "APR",					'L',		1,         0 },
      { "MAY",					'L',		1,         0 },
      { "JUN",					'L',		1,         0 },
      { "JUL",					'L',		1,         0 },
      { "AUG",					'L',		1,         0 },
      { "SEP",					'L',		1,         0 },
      { "OCT",					'L',		1,         0 },
      { "NOV",					'L',		1,         0 },
      { "DEC",					'L',		1,         0 },
      { "USE",                  'C',       10,         0 },
      { "P0",                   'C',       25,         0 }, 
      { "P1",                   'C',       25,         0 }, 
      { "P2",                   'C',       25,         0 }, 
      { "P3",                   'C',       25,         0 }, 
      { "P4",                   'C',       25,         0 }, 
      { "P5",                   'C',       25,         0 }, 
      { "P6",                   'C',       25,         0 }, 
      { "P7",                   'C',       25,         0 }, 
      { "P8",                   'C',       25,         0 }, 
      { "P9",                   'C',       25,         0 }, 
      { 0, 0, 0, 0 }            /* NULL - record terminator */
};

/*  tag definition for scriptdb table */

T4TAG_INFO    script_tag[] = {
     /* Tag name,      Key Expression,    Filter Expression,     Unique,     Descending */
	 { "SCRIPTID",			"SCRIPTID",			0,					0,					0},
     { "TAG",          "STR(HOUR,2,0)+STR(MINUTE,2,0)+STR(RECNO(),8,0)",       0,                     0,          0 },
     { 0, 0, 0, 0, 0 } /* NULL - record terminator */
};
