#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "choiceAcc.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuAccDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuAccDialogClass, vuCommonDialogClass, "vuAccDialogClass");

/*******************************************************************
*
*    vuAccDialogClass override for constructors init ()
*
*******************************************************************/

void vuAccDialogClass::LoadInit (vresource res)
{
    // load in the acc specific fields
    accContainer = vuAccContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    accContainer -> reference -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> processInput -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> maximizeSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> manual -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> asyncFrzRef -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> prc2 -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> mxs2 -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> asyncFrzValue -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> asyncFrzRef -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> prc3 -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> mxs3 -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> resetGroup -> SetModifiedPtr (&this -> dialogModified);
    accContainer -> resetOnFreeze -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> deltaModeRollover -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> deltaMode -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> useZeroData -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> saveRunTime -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> freezeEvery -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> freezeTime -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> autofreezeMode -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> firstAutoFreezeHours -> SetModifiedPtr (&this -> dialogModified);
    accContainer -> firstAutoFreezeMinutes -> SetModifiedPtr (&this -> dialogModified);
    accContainer -> timeSelect -> vuSetModifiedPtr (&this -> dialogModified);
    accContainer -> monitorDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> archiveDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> totalDisplayLow -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> totalDisplayHigh -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> totalOffset -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> totalSlope -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> totalPrecision -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> totalEguTag -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> displayLow -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> displayHigh -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> offset -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> slope -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> precision -> SetTextModifiedPtr (&this -> dialogModified);
    accContainer -> eguTag -> SetTextModifiedPtr (&this -> dialogModified);

    // store ptr to dialog for vuPvNameButtonClass
    accContainer -> referenceButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    accContainer -> asyncFrzRefButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    accContainer -> asyncResetRefButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuPvNameFilter
    accContainer -> reference -> storeCommonDialog ((vuCommonDialogClass *)this);
    accContainer -> asyncFrzRef -> storeCommonDialog ((vuCommonDialogClass *)this);
    accContainer -> asyncResetRef -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_ACCUM);

    // get the title from the resource file, accTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    accTitle = vresourceGetString (dialogTitles, 
				vunames_vuAccDialogTitle);
    SetTitle (accTitle);

    // load up the alarm details dialog
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource alarmDialogRes = vresourceGet (pointDictRes, vunames_vuAccAlarmDialog);
    alarmDetails = new vuAccAlarmDialogClass (alarmDialogRes);

    // store ptr to acc dialog and alarm dialog in the alarm detail button
    accContainer -> alarmDetailsButton -> storeAccDialog (this);
    accContainer -> alarmDetailsButton -> storeAccAlarmDialog (alarmDetails);

    // save modify pointer in alarm dialog fields

    alarmDetails -> thresholdLimit -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDetails -> thresholdCount -> SetModifiedPtr (&this -> dialogModified);
    alarmDetails -> zeroThreshold -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDetails -> thresholdError -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDetails -> hihiLimit -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDetails -> highLimit -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDetails -> lowLimit -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDetails -> loloLimit -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDetails -> thresholdSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDetails -> hihiSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDetails -> highSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDetails -> lowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDetails -> loloSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDetails -> alarmFieldSelect -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDetails -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDetails -> alarmDelay -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDetails -> alarmDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDetails -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);

    // store ptr to dialog for vuPvNameButtonClass
    alarmDetails -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuPvNameFilter
    alarmDetails -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuAlarmGroupFilter
    alarmDetails -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);
}


/*******************************************************************
*
*    vuAccDialogClass Destroy function
*
*******************************************************************/

void vuAccDialogClass::Destroy (void)
{
    vstrDestroy (accTitle);
    // delete the alarm details dialog
    delete alarmDetails;
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuAccDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuAccDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    int			firstTimeFlag;
    int			inDialogFlag;

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    firstTimeFlag = xrefNode -> getFirstTimeFlag ();
	    // only need to do this once
	    if (firstTimeFlag == vTRUE)
	    {
		xrefNode -> setFirstTimeFlag (vFALSE);
		// find which dialog this field is in
		dialogItem = vuFindContainerItem (accContainer, epics);
		if (dialogItem == NULL)
		{
		    dialogItem = vuFindDialogItem (alarmDetails, epics);
		    if (dialogItem == NULL)
		    {
			xrefNode -> setInDialogFlag (VU_ACC_NOT_IN_DIALOG);
			continue;
		    }
		    else
		    {
			xrefNode -> setInDialogFlag (VU_ACC_ALARM_DIALOG);
		    }
		}
		else
		{
		    xrefNode -> setInDialogFlag (VU_ACC_IN_MAIN_DIALOG);
		}
	    }
	    else
	    {
		inDialogFlag = xrefNode -> getInDialogFlag ();
		dialogItem = NULL;
		switch (inDialogFlag)
		{
		    case VU_ACC_NOT_IN_DIALOG:
			break;

		    case VU_ACC_IN_MAIN_DIALOG:
			dialogItem = vuFindContainerItem (accContainer, epics);
			break;

		    case VU_ACC_ALARM_DIALOG:
			dialogItem = vuFindDialogItem (alarmDetails, epics);
			break;

		    default:
			break;
		}
	    }
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the archive deadband field
		if ( (vcharCompareBounded (epics, "ADEL", FLDNAME_SZ)) == 0)
		{
		    vstr *adel = vresourceGetString (defRes, 
						vunames_vuADELdefault);
		    textItem -> SetText (adel);
		    vstrDestroy (adel);
		}
		else if ( ((vcharCompareBounded (epics, "PREC", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "MPRE", FLDNAME_SZ)) == 0) )
		{
		    vstr *precision = vresourceGetString (defRes, 
						vunames_vuPRECdefault);
		    textItem -> SetText (precision);
		    vstrDestroy (precision);
		}
		else if ( ((vcharCompareBounded (epics, "AOFF", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "ASLO", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "MOFF", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "MSLO", FLDNAME_SZ)) == 0) )
		{
		    vstr *zero = vresourceGetString (defRes, 
						vunames_vuZeroDefault);
		    textItem -> SetText (zero);
		    vstrDestroy (zero);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (spinner -> GetMin());
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuAccDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;

    char		pvName [PVNAME_SZ + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;
    int			inDialogFlag;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT an ACCUM
	if (ptType != VU_ACCUM)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_ACCUM);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
	    {
		sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
	    }
	    lastTable = xrefNode -> xrefTable;
	    inDialogFlag = xrefNode -> getInDialogFlag ();
	    dialogItem = NULL;
	    switch (inDialogFlag)
	    {
		case VU_ACC_NOT_IN_DIALOG:
		    break;

		case VU_ACC_IN_MAIN_DIALOG:
		    dialogItem = vuFindContainerItem (accContainer, epics);
		    break;

		case VU_ACC_ALARM_DIALOG:
		    dialogItem = vuFindDialogItem (alarmDetails, epics);
		    break;

		default:
		    break;
	    }
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (vnum::ParseInt (finalValue, NULL));
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuAccDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;

    char		pvName [PVNAME_SZ + 1];
    DB_FIELD_PTR	putField;
    DB_FIELD_PTR	freezeSeverity, freezeRunSeverity;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;
    int			inDialogFlag;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    lastTable = NULL;
    freezeSeverity = 0;
    freezeRunSeverity = 0;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
	    {
		sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;
	    if (freezeSeverity == 0)
		freezeSeverity = DB_MapField (xrefNode -> xrefTable, FLD_FRZSEVR);
	    if (freezeRunSeverity == 0)
		freezeRunSeverity = DB_MapField (xrefNode -> xrefTable, FLD_FRZRUNSEVR);

	    inDialogFlag = xrefNode -> getInDialogFlag ();
	    dialogItem = NULL;
	    switch (inDialogFlag)
	    {
		case VU_ACC_NOT_IN_DIALOG:
		    break;

		case VU_ACC_IN_MAIN_DIALOG:
		    dialogItem = vuFindContainerItem (accContainer, epics);
		    break;

		case VU_ACC_ALARM_DIALOG:
		    dialogItem = vuFindDialogItem (alarmDetails, epics);
		    break;

		default:
		    break;
	    }
	    if (dialogItem == NULL)
		continue;

	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
		    {
			spinner = (vspinner *)dialogItem;
			// bug fix, spinner may not have proper value
			spinner -> Unfocus ();
			stringValue = spinner -> GetTextAsString ();
		    }
		    else
		    {
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
		    }
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_INLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // if a new record was created (see vuCommonDialogClass::vuCommonApplyButton)
    // we must fill these to choice fields or dbClient will not like them
    // they are prompted fields but not on dataVu
    if ( (vuGetNewRecord ()) == vTRUE)
    {
	if (freezeSeverity)
	    DB_PutFieldValue (pntRecord, freezeSeverity, "NO ALARM");
	if (freezeRunSeverity)
	    DB_PutFieldValue (pntRecord, freezeRunSeverity, "NO ALARM");
    }

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuAccContainerClass, vcontainer, "vuAccContainerClass");

/*******************************************************************
*
*    vuAccContainerClass override for constructor
*
*******************************************************************/

void vuAccContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuAccContainer);


    vcontainer *inpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccINPContainer);
    referenceButton = vuPvNameButtonClass::RequestSubLoad (inpcontainer,
				vunames_vuAccINPButton);
    reference = vuFilteredTextitem::RequestSubLoad (inpcontainer,
				vunames_INP);

    processInput = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCI);

    maximizeSeverity = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MAXS);

    manual = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MODE);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    vcontainer *frzrefcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccAFISContainer);
    asyncFrzRefButton = vuPvNameButtonClass::RequestSubLoad (frzrefcontainer,
				vunames_vuAccAFISButton);
    asyncFrzRef = vuFilteredTextitem::RequestSubLoad (frzrefcontainer,
				vunames_AFIS);

    prc2 = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC2);

    mxs2 = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS2);

    vcontainer *frzvalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccAFIVContainer);
    asyncFrzValue = filteredTextitem::RequestSubLoad (frzvalcontainer,
				vunames_AFIV);

    vcontainer *frzrescontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccARISContainer);
    asyncResetRefButton = vuPvNameButtonClass::RequestSubLoad (frzrescontainer,
				vunames_vuAccARISButton);
    asyncResetRef = vuFilteredTextitem::RequestSubLoad (frzrescontainer,
				vunames_ARIS);

    prc3 = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC3);

    mxs3 = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS3);

    vcontainer *rgrpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccRGRPContainer);
    resetGroup = spinnerClass::RequestSubLoad (rgrpcontainer,
				vunames_RGRP);

    resetOnFreeze = vuCheckBoxClass::RequestSubLoad (this,
				vunames_ROFF);

    vcontainer *rlovcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccRLOVContainer);
    deltaModeRollover = filteredTextitem::RequestSubLoad (rlovcontainer,
				vunames_RLOV);

    deltaMode = vuCheckBoxClass::RequestSubLoad (this,	
				vunames_DMDF);

    useZeroData = vuCheckBoxClass::RequestSubLoad (this,	
				vunames_UZDF);

    vcontainer *srvtcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccSRVTContainer);
    saveRunTime = filteredTextitem::RequestSubLoad (srvtcontainer,
				vunames_SRVT);

    vcontainer *aftmcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccAFTMContainer);
    freezeEvery = filteredTextitem::RequestSubLoad (aftmcontainer,
				vunames_AFTM);

    vcontainer *aftucontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccAFTUContainer);
    freezeTime = vuChoiceRecMenuClass::RequestSubLoad (aftucontainer,
				vunames_AFTU);

    vcontainer *afmdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccAFMDContainer);
    autofreezeMode = vuChoiceRecMenuClass::RequestSubLoad (afmdcontainer,
				vunames_AFMD);

    vcontainer *fafhcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccFAFHContainer);
    firstAutoFreezeHours = spinnerClass::RequestSubLoad (fafhcontainer,
				vunames_FAFH);

    vcontainer *fafmcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccFAFMContainer);
    firstAutoFreezeMinutes = spinnerClass::RequestSubLoad (fafmcontainer,
				vunames_FAFM);

    vcontainer *tselcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccTSELContainer);
    timeSelect = vuChoiceRecMenuClass::RequestSubLoad (tselcontainer,
				vunames_TSEL);

    vcontainer *mdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccMDELContainer);
    monitorDeadband = filteredTextitem::RequestSubLoad (mdelcontainer,
				vunames_MDEL);

    vcontainer *adelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccADELContainer);
    archiveDeadband = filteredTextitem::RequestSubLoad (adelcontainer,
				vunames_ADEL);

    alarmDetailsButton = vuAccAlarmButtonClass::RequestSubLoad (this,
				vunames_vuAccAlarmButton);

    vcontainer *tvalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccTotalValuesContainer);

    vcontainer *loprcontainer = vcontainer::RequestSubLoad (tvalcontainer,
				vunames_vuAccLOPRContainer);
    totalDisplayLow = filteredTextitem::RequestSubLoad (loprcontainer,
				vunames_LOPR);

    vcontainer *hoprcontainer = vcontainer::RequestSubLoad (tvalcontainer,
				vunames_vuAccHOPRContainer);
    totalDisplayHigh = filteredTextitem::RequestSubLoad (hoprcontainer,
				vunames_HOPR);

    vcontainer *aoffcontainer = vcontainer::RequestSubLoad (tvalcontainer,
				vunames_vuAccAOFFContainer);
    totalOffset = filteredTextitem::RequestSubLoad (aoffcontainer,
				vunames_AOFF);

    vcontainer *aslocontainer = vcontainer::RequestSubLoad (tvalcontainer,
				vunames_vuAccASLOContainer);
    totalSlope = filteredTextitem::RequestSubLoad (aslocontainer,
				vunames_ASLO);

    vcontainer *preccontainer = vcontainer::RequestSubLoad (tvalcontainer,
				vunames_vuAccPRECContainer);
    totalPrecision = filteredTextitem::RequestSubLoad (preccontainer,
				vunames_PREC);

    vcontainer *egutagcontainer = vcontainer::RequestSubLoad (tvalcontainer,
				vunames_vuAccEGUContainer);
    totalEguTag = filteredTextitem::RequestSubLoad (egutagcontainer,
				vunames_EGU);

    vcontainer *valscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccValueContainer);

    vcontainer *mlprcontainer = vcontainer::RequestSubLoad (valscontainer,
				vunames_vuAccMLPRContainer);
    displayLow = filteredTextitem::RequestSubLoad (mlprcontainer,
				vunames_MLPR);

    vcontainer *mhprcontainer = vcontainer::RequestSubLoad (valscontainer,
				vunames_vuAccMHPRContainer);
    displayHigh = filteredTextitem::RequestSubLoad (mhprcontainer,
				vunames_MHPR);

    vcontainer *moffcontainer = vcontainer::RequestSubLoad (valscontainer,
				vunames_vuAccMOFFContainer);
    offset = filteredTextitem::RequestSubLoad (moffcontainer,
				vunames_MOFF);

    vcontainer *mslocontainer = vcontainer::RequestSubLoad (valscontainer,
				vunames_vuAccMSLOContainer);
    slope = filteredTextitem::RequestSubLoad (mslocontainer,
				vunames_MSLO);

    vcontainer *mprecontainer = vcontainer::RequestSubLoad (valscontainer,
				vunames_vuAccMPREContainer);
    precision = filteredTextitem::RequestSubLoad (mprecontainer,
				vunames_MPRE);

    vcontainer *megucontainer = vcontainer::RequestSubLoad (valscontainer,
				vunames_vuAccMEGUContainer);
    eguTag = filteredTextitem::RequestSubLoad (megucontainer,
				vunames_MEGU);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvnameButtonClass
    referenceButton -> storePvName (reference);
    asyncFrzRefButton -> storePvName (asyncFrzRef);
    asyncResetRefButton -> storePvName (asyncResetRef);

    // set filters

    reference -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *refText = (filteredText *)reference -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    refText -> SetUserPtr ((void *)reference);

    asyncFrzRef -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *frzrefText = (filteredText *)asyncFrzRef -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    frzrefText -> SetUserPtr ((void *)asyncFrzRef);

    asyncResetRef -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *resrefText = (filteredText *)asyncResetRef -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    resrefText -> SetUserPtr ((void *)asyncResetRef);

    asyncFrzValue -> SetItemFilterFunc (floatFilter);
    deltaModeRollover -> SetItemFilterFunc (floatFilter);
    saveRunTime -> SetItemFilterFunc (floatFilter);
    freezeEvery -> SetItemFilterFunc (numericFilter);
    monitorDeadband -> SetItemFilterFunc (floatFilter);
    archiveDeadband -> SetItemFilterFunc (floatFilter);
    totalDisplayLow -> SetItemFilterFunc (floatFilter);
    totalDisplayHigh -> SetItemFilterFunc (floatFilter);
    totalOffset -> SetItemFilterFunc (floatFilter);
    totalSlope -> SetItemFilterFunc (floatFilter);
    totalPrecision -> SetItemFilterFunc (numericFilter);
    totalEguTag -> SetItemFilterFunc (egutagFilter);
    displayLow -> SetItemFilterFunc (floatFilter);
    displayHigh -> SetItemFilterFunc (floatFilter);
    offset -> SetItemFilterFunc (floatFilter);
    slope -> SetItemFilterFunc (floatFilter);
    precision -> SetItemFilterFunc (numericFilter);
    eguTag -> SetItemFilterFunc (egutagFilter);

    // build popup menus
    freezeTime   -> vuBuildOptionMenu (VU_ACCUM, REC_ACC_AFTU);
    autofreezeMode -> vuBuildOptionMenu (VU_ACCUM, REC_ACC_AFMD);
    timeSelect -> vuBuildOptionMenu (VU_ACCUM, REC_ACC_TSEL);

}

/*******************************************************************
*
*    vuAccContainerClass override for destructor
*
*******************************************************************/

void vuAccContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}


/*******************************************************************
*
*    vuAccAlarmButtonClass observer
*	open the alarm dialog and wait here until finished
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuAccAlarmButtonClass, vbutton, 
					"vuAccAlarmButtonClass");

void vuAccAlarmButtonClass::ObserveDialogItem (vevent *event)
{
    vuAccDialogClass *accDialog = this -> getAccDialog ();
    vuAccAlarmDialogClass *alarmDialog = this -> getAccAlarmDialog ();

    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    alarmDialog -> Place (accDialog, vrectPLACE_CENTER, vrectPLACE_CENTER);
    alarmDialog -> Open();
    MakeTopMostDialog (alarmDialog, NULL);
    vevent::Process ();
}


/*******************************************************************
*
*    vyAccAlarmDialogClass
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuAccAlarmDialogClass, vdialog, 
					"vuAccAlarmDialogClass");

/*******************************************************************
*
*    vuAccDialogClass override for constructors init ()
*
*******************************************************************/

void vuAccAlarmDialogClass::LoadInit (vresource res)
{

    vcontainer *thldcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccTHLDContainer);
    thresholdLimit = filteredTextitem::RequestSubLoad (thldcontainer,
				vunames_THLD);

    vcontainer *thctcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccTHCTContainer);
    thresholdCount = spinnerClass::RequestSubLoad (thctcontainer,
				vunames_THCT);

    vcontainer *zdthcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccZDTHContainer);
    zeroThreshold = filteredTextitem::RequestSubLoad (zdthcontainer,
				vunames_ZDTH);

    vcontainer *terrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccTERRContainer);
    thresholdError = filteredTextitem::RequestSubLoad (terrcontainer,
				vunames_TERR);

    vcontainer *thsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccTHSVContainer);
    thresholdSeverity = vuChoiceGblMenuClass::RequestSubLoad (thsvcontainer,
				vunames_THSV);

    vcontainer *hihicontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccHIHIContainer);
    hihiLimit = filteredTextitem::RequestSubLoad (hihicontainer,
				vunames_HIHI);

    vcontainer *hhsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccHHSVContainer);
    hihiSeverity = vuChoiceGblMenuClass::RequestSubLoad (hhsvcontainer,
				vunames_HHSV);

    vcontainer *highcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccHIGHContainer);
    highLimit = filteredTextitem::RequestSubLoad (highcontainer,
				vunames_HIGH);

    vcontainer *hsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccHSVContainer);
    highSeverity = vuChoiceGblMenuClass::RequestSubLoad (hsvcontainer,
				vunames_HSV);

    vcontainer *lowcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccLOWContainer);
    lowLimit = filteredTextitem::RequestSubLoad (lowcontainer,
				vunames_LOW);

    vcontainer *lsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccLSVContainer);
    lowSeverity = vuChoiceGblMenuClass::RequestSubLoad (lsvcontainer,
				vunames_LSV);

    vcontainer *lolocontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccLOLOContainer);
    loloLimit = filteredTextitem::RequestSubLoad (lolocontainer,
				vunames_LOLO);

    vcontainer *llsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccLLSVContainer);
    loloSeverity = vuChoiceGblMenuClass::RequestSubLoad (llsvcontainer,
				vunames_LLSV);

    vcontainer *afscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccAFSContainer);
    alarmFieldSelect = vuChoiceRecMenuClass::RequestSubLoad (afscontainer,
				vunames_AFS);

    vcontainer *algpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (algpcontainer,
				vunames_ALGP);

    vcontainer *hystcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccHYSTContainer);
    alarmDeadband = filteredTextitem::RequestSubLoad (hystcontainer,
				vunames_HYST);

    vcontainer *aldlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccALDLContainer);
    alarmDelay = filteredTextitem::RequestSubLoad (aldlcontainer,
				vunames_ALDL);

    vcontainer *adiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuAccADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (adiscontainer,
				vunames_vuAccADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (adiscontainer,
				vunames_ADIS);

    dismissButton = vuAccAlarmDialogDismissButtonClass::RequestSubLoad (this,
				vunames_vuAccAlarmDismissButton);

    vdialog::LoadInit (res);

    // store ptr to text field for vuPvNameButtonClass
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *adisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    adisText -> SetUserPtr ((void *)alarmDisable);

    thresholdLimit -> SetItemFilterFunc (floatFilter);
    zeroThreshold -> SetItemFilterFunc (floatFilter);
    thresholdError -> SetItemFilterFunc (floatFilter);
    hihiLimit -> SetItemFilterFunc (floatFilter);
    highLimit -> SetItemFilterFunc (floatFilter);
    lowLimit -> SetItemFilterFunc (floatFilter);
    loloLimit -> SetItemFilterFunc (floatFilter);
    alarmDeadband -> SetItemFilterFunc (floatFilter);
    alarmDelay -> SetItemFilterFunc (numericFilter);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    // build pop-up menus
    thresholdSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    hihiSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    loloSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    alarmFieldSelect -> vuBuildOptionMenu (VU_ACCUM, REC_ACC_AFS);

    // store dialog pointer in dismiss button

    dismissButton -> storeAccAlarmDialog (this);

}


/*******************************************************************
*
*    vuAccAlarmDialogClass notify function
*
*******************************************************************/

void vuAccAlarmDialogClass::ObserveWindow (vevent *event)
{
    if ( event -> GetType () == veventWINDOW_STATE && event -> IsClose ())
    {
	Close ();
	vevent::StopProcessing ();
    }
    else
    {
	MakeTopMostDialog (this, event);
    }
}


/*******************************************************************
*
*    vuAccAlarmDialogClass notify function
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuAccAlarmDialogDismissButtonClass, vbutton, 
					"vuAccAlarmDialogDismissButtonClass");

void vuAccAlarmDialogDismissButtonClass::ObserveDialogItem (vevent *event)
{
    vuAccAlarmDialogClass	*alarmDialog = getAccAlarmDialog ();

    alarmDialog -> Close ();
    vevent::StopProcessing ();
}

