#ifndef vualarminfodialogclassHXX
#define vualarminfodialogclassHXX

class vuAlarmInfoApplyButtonClass;
class vuAlarmInfoDismissButtonClass;
class vuAlarmInfoDeleteButtonClass;

// *** ALARM INFO DIALOG CLASS ***************************************************

class  vuAlarmInfoDialogClass : public vdialog
{
    int			dialogModified;
    vuMainDialogClass	*mainDialog;
    vstr		*dialogTitle;
    vchar		*pvname;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuAlarmInfoDialogClass);

    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuAlarmInfoDialogClass, vdialog);	

    // override to load dialog
    void LoadInit(vresource res);		

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override 
    void Destroy ();

    void vuAlarmInfoOpen(vuMainDialogClass *mainDialog, vchar *pvname);

    // functions to handle dialogModified
    int getDialogModified (void)
	{ return (dialogModified); }
    void setDialogModified (int mod)
	{ dialogModified = mod; }

    // function to handle mainDialog
    vuMainDialogClass *getMainDialog (void)
	{ return (mainDialog); }

    // function to handle pvname
    vchar *getPvName (void)
	{ return (pvname); }

    filteredTextitem			*guidanceText;
    filteredTextitem			*displayText;
    vuAlarmInfoApplyButtonClass		*applyButton;
    vuAlarmInfoDismissButtonClass	*dismissButton;
    vuAlarmInfoDeleteButtonClass	*deleteButton;

    // database field ptrs
    DB_FIELD_PTR	nameField;
    DB_FIELD_PTR	guidanceField;
    DB_FIELD_PTR	displayField;
};


// *** ALARM INFO APPLY BUTTON CLASS *******************************************

class vuAlarmInfoApplyButtonClass : public vbutton
{
    vuAlarmInfoDialogClass	*alarminfoDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAlarmInfoApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAlarmInfoApplyButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle alarminfoDialog
    void setAlarmInfoDialog (vuAlarmInfoDialogClass *dialog)
	{ alarminfoDialog = dialog; }
};


// *** ALARM INFO DELETE BUTTON CLASS ******************************************

class vuAlarmInfoDeleteButtonClass : public vbutton
{
    vuAlarmInfoDialogClass	*alarminfoDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAlarmInfoDeleteButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAlarmInfoDeleteButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle alarminfoDialog
    void setAlarmInfoDialog (vuAlarmInfoDialogClass *dialog)
	{ alarminfoDialog = dialog; }
};


// *** ALARM INFO DISMISS BUTTON CLASS *****************************************

class vuAlarmInfoDismissButtonClass : public vbutton
{
    vuAlarmInfoDialogClass	*alarminfoDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAlarmInfoDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAlarmInfoDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle alarminfoDialog
    void setAlarmInfoDialog (vuAlarmInfoDialogClass *dialog)
	{ alarminfoDialog = dialog; }
};

#endif vualarminfodialogclassHXX
