#ifndef vualmgrpseldialogclassHXX
#define vualmgrpseldialogclassHXX

class vuAlmGrpSelListitem;
class vuAlmGrpSelOKButtonClass;
class vuAlmGrpSelDismissButtonClass;

// *** ALARM SELECTOR DIALOG CLASS ************************************************

class vuAlmGrpSelDialogClass : public vdialog
{
    vuAlmGrpSelListitem			*alarmGrpListitem;
    vuAlmGrpSelOKButtonClass		*okButton;
    vuAlmGrpSelDismissButtonClass	*dismissButton;
    vchar				alarmGroup [ALARMGRP_SZ + 1];

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAlmGrpSelDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAlmGrpSelDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override 
    void Destroy ();

    // overide
    void ObserveSelect (int state);

    // open function
    void vuAlmGrpSelOpen (vuMainDialogClass *mainDialog);

    // function to handle the vlistitem
    vuAlmGrpSelListitem *vuGetAlmGrpListitem (void ) { return (alarmGrpListitem); }

    //function to handle alarmGroup
    vchar *vuGetAlarmGroup (void) { return (alarmGroup); }
};


// *** ALARM SELECTOR LISTITEM **************************************************

class vuAlmGrpSelListitem : public vlistview
{

    vuAlmGrpSelDialogClass *almGrpSelDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAlmGrpSelListitem);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAlmGrpSelListitem, vlistview);

    // override
    void ObserveSelect (int state);

    // functions to handle almGrpSelDialog
    void vuSetAlmGrpSelDialog (vuAlmGrpSelDialogClass *dialog)
	{ almGrpSelDialog = dialog; }
    vuAlmGrpSelDialogClass *vuGetAlmGrpSelDialog (void) { return (almGrpSelDialog); }
};


// *** ALARM SELECTOR OK BUTTON CLASS ***********************************************

class vuAlmGrpSelOKButtonClass : public vbutton
{
    vuAlmGrpSelDialogClass	*almGrpSelDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAlmGrpSelOKButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAlmGrpSelOKButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // functions to handle almGrpDialog
    void vuSetAlmGrpDialog (vuAlmGrpSelDialogClass *dialog) { almGrpSelDialog = dialog; }
    vuAlmGrpSelDialogClass *vuGetAlmGrpDialog (void ) { return (almGrpSelDialog); }
};


// *** ALARM SELECTOR DISMISS BUTTON CLASS ******************************************

class vuAlmGrpSelDismissButtonClass : public vbutton
{
    vuAlmGrpSelDialogClass	*almGrpSelDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuAlmGrpSelDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuAlmGrpSelDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // functions to handle almGrpDialog
    void vuSetAlmGrpDialog (vuAlmGrpSelDialogClass *dialog) { almGrpSelDialog = dialog; }
    vuAlmGrpSelDialogClass *vuGetAlmGrpDialog (void ) { return (almGrpSelDialog); }
};

#endif vualmgrpseldialogclassHXX
