#ifndef vuapicfgdialogclassHXX
#define	vuapicfgdialogclassHXX

class vuApiCfgTablesListClass;
class vuApiCfgValuesListClass;
class vuApiCfgApplyButtonClass;
class vuApiCfgDismissButtonClass;
class vuApiCfgDeleteButtonClass;
class vuApiCfgCompileButtonClass;
class vuApiCfgAddButtonClass;
class vuApiCfgRemoveButtonClass;


//*** API CFG DIALOG CLASS *********************************************

class	vuApiCfgDialogClass : public vdialog
{
    int			dialogModified;
    vuMainDialogClass	*mainDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuApiCfgDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuApiCfgDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void vuApiCfgOpen (vuMainDialogClass *mainDialog);

    // functions to handle dialogModified
    int getDialogModify (void) 
	{ return (dialogModified); }
    void setDialogModify (int val) 
	{ dialogModified = val; }

    // function to handle mainDialog
    void storeMainDialog (vuMainDialogClass *cd)
	{ mainDialog = cd; }
    vuMainDialogClass *getMainDialog (void) 
	{ return (mainDialog); }

    // public so don't need funcs to get at

    vuApiCfgTablesListClass	*tablesList;
    vuApiCfgValuesListClass	*valuesList;
    filteredTextitem		*tableName;
    filteredTextitem		*temperature;
    filteredTextitem		*gravity;
    filteredTextitem		*factor;
    vuApiCfgApplyButtonClass	*applyButton;
    vuApiCfgDismissButtonClass	*dismissButton;
    vuApiCfgDeleteButtonClass	*deleteButton;
    vuApiCfgCompileButtonClass	*compileButton;
    vuApiCfgAddButtonClass	*addButton;
    vuApiCfgRemoveButtonClass	*removeButton;

    DB_FIELD_PTR	nameField;
    DB_FIELD_PTR	tempField;
    DB_FIELD_PTR	gravityField;
    DB_FIELD_PTR	factorField;

};


//*** API CFG TABLES LIST CLASS ***************************************

class	vuApiCfgTablesListClass : public vlistview
{

    vuApiCfgDialogClass	*apiCfgDialog;
    int			lastRowSelected;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuApiCfgTablesListClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuApiCfgTablesListClass, vlistview);

    // virtual member function override
    void ObserveSelect (int state);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuApiCfgDialogClass *cd)
	{ apiCfgDialog = cd; }

    // functions to handle lastRowSelected
    void setLastRowSelected (int row)
	{ lastRowSelected = row; }
    int getLastRowSelected (void)
	{ return (lastRowSelected); }

    // function to build the fields list
    void buildTablesList (void);

};


//*** API CFG VALUES LIST CLASS ***************************************

class	vuApiCfgValuesListClass : public vlistview
{

    vuApiCfgDialogClass	*apiCfgDialog;
    int			calcColumnWidths;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuApiCfgValuesListClass);

    // macros for standard versions of the constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuApiCfgValuesListClass, vlistview);

    // virtual member function override
    void ObserveSelect (int state);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuApiCfgDialogClass *cd)
	{ apiCfgDialog = cd; }

    // function to build the values list
    void buildValuesList (void);

    // function to handle calcColumnWidths
    void setCalcColumnWidths (int val)
	{ calcColumnWidths = val; }

};


//*** API CFG APPLY BUTTON CLASS ***************************************

class	vuApiCfgApplyButtonClass : public vbutton
{

    vuApiCfgDialogClass	*apiCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuApiCfgApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuApiCfgApplyButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuApiCfgDialogClass *cd)
	{ apiCfgDialog = cd; }
};


//*** API CFG DISMISS BUTTON CLASS ***************************************

class	vuApiCfgDismissButtonClass : public vbutton
{

    vuApiCfgDialogClass	*apiCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuApiCfgDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuApiCfgDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuApiCfgDialogClass *cd)
	{ apiCfgDialog = cd; }
};


//*** API CFG DELETE BUTTON CLASS ***************************************

class	vuApiCfgDeleteButtonClass : public vbutton
{

    vuApiCfgDialogClass	*apiCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuApiCfgDeleteButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuApiCfgDeleteButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuApiCfgDialogClass *cd)
	{ apiCfgDialog = cd; }
};


//*** API CFG COMPILE BUTTON CLASS ***************************************

class	vuApiCfgCompileButtonClass : public vbutton
{

    vuApiCfgDialogClass	*apiCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuApiCfgCompileButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuApiCfgCompileButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuApiCfgDialogClass *cd)
	{ apiCfgDialog = cd; }
};


//*** API CFG ADD BUTTON CLASS ***************************************

class	vuApiCfgAddButtonClass : public vbutton
{

    vuApiCfgDialogClass	*apiCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuApiCfgAddButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuApiCfgAddButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuApiCfgDialogClass *cd)
	{ apiCfgDialog = cd; }
};


//*** API CFG REMOVE BUTTON CLASS ***************************************

class	vuApiCfgRemoveButtonClass : public vbutton
{

    vuApiCfgDialogClass	*apiCfgDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuApiCfgRemoveButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuApiCfgRemoveButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle arReducDialog
    void storeApiCfgDialog (vuApiCfgDialogClass *cd)
	{ apiCfgDialog = cd; }
};

#endif	vuapicfgdialogclassHXX

