#ifndef	vuarchinfodialogclassHXX
#define	vuarchinfodialogclassHXX

typedef struct archinfo
    {
	char	archFile[MAXPATHLEN];
	char	archTime[5];
	char	cleanTime[5];
	char	dailyTime[5];
	char	archEnable[10];
	char	cleanEnable[10];
    } VU_ARCH_INFO;

// define the type of archive info
enum
    {
	VU_EDIT_ARCH_TREND_INFO = 0,
	VU_EDIT_ARCH_ALARM_INFO,
	VU_EDIT_ARCH_OPER_INFO,
	VU_MAX_ARCH_EDIT
    };

class	vuArchInfoApplyButtonClass;
class	vuArchInfoDismissButtonClass;

// *** ARCHIVE INFO DIALOG CLASS *********************************

class	vuArchInfoDialogClass : public vdialog
{

    vstr		*archInfoTitle;
    vuMainDialogClass	*mainDialog;
    int			archType;
    int			modified;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuArchInfoDialogClass);

    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuArchInfoDialogClass, vdialog);	

    // override to load dialog
    void LoadInit(vresource res);		

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override 
    void Destroy ();

    void vuArchInfoOpen(int archType, vuMainDialogClass *mainDialog);

    void vuClearArchInfo (void);

    void vuLoadArchInfo (void);

    // functions to handle mainDialog 
    vuMainDialogClass *getMainDialog (void) 
	{ return (mainDialog); }

    // function to handle archType
    int getArchiveType (void)
	{ return (archType); }

    // function to handle modified flag
    int getDialogModify (void)
	{ return (modified); }
    void setDialogModify (int mod)
	{ modified = mod; }

    // public so dont need funcs to get at
    filteredTextitem	*archiveTime;
    vuCheckBoxClass	*enableArchive;
    filteredTextitem	*cleanTime;
    vuCheckBoxClass	*enableClean;
    filteredTextitem	*archiveFile;
    spinnerClass	*dailyTime;
    vuArchInfoApplyButtonClass		*applyButton;
    vuArchInfoDismissButtonClass	*dismissButton;

    VU_ARCH_INFO	archInfo[VU_MAX_ARCH_EDIT];

};


// *** ARCHIVE INFO APPLY BUTTON CLASS ***************************

class	vuArchInfoApplyButtonClass : public vbutton
{
    vuArchInfoDialogClass	*archInfoDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuArchInfoApplyButtonClass);

    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuArchInfoApplyButtonClass, vbutton);
    
    // override this function
    void ObserveDialogItem (vevent *event);

    // functions to handle archInfoDialog
    void storeArchInfoDialog (vuArchInfoDialogClass *dialog)
	{ archInfoDialog = dialog; }
};


// *** ARCHIVE INFO DISMISS BUTTON CLASS ***************************

class	vuArchInfoDismissButtonClass : public vbutton
{
    vuArchInfoDialogClass	*archInfoDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuArchInfoDismissButtonClass);

    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuArchInfoDismissButtonClass, vbutton);	
    
    // override this function
    void ObserveDialogItem (vevent *event);

    // functions to handle archInfoDialog
    void storeArchInfoDialog (vuArchInfoDialogClass *dialog)
	{ archInfoDialog = dialog; }
};

#endif	vuarchinfodialogclassHXX

