#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
int postfix (char *expr, char *rpbuff, short *error_number, int len);
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuCalcDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuCalcDialogClass, vuCommonDialogClass, "vuCalcDialogClass");

/*******************************************************************
*
*    vuCalcDialogClass override for constructors init ()
*
*******************************************************************/

void vuCalcDialogClass::LoadInit (vresource res)
{
    // load in the ai specific fields
    calcContainer = vuCalcContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    calcContainer -> calcExpression -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> precision -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> rocSamples -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> eguTag -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> manual -> vuSetModifiedPtr (&this -> dialogModified);

    calcContainer -> pva -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prca -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsa -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> csta -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pvb -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prcb -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsb -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> cstb -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pvc -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prcc -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsc -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> cstc -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pvd -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prcd -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsd -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> cstd -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pve -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prce -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxse -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> cste -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pvf -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prcf -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsf -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> cstf -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pvg -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prcg -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsg -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> cstg -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pvh -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prch -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsh -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> csth -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pvi -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prci -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsi -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> csti -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pvj -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prcj -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsj -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> cstj -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pvk -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prck -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsk -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> cstk -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> pvl -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> prcl -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> mxsl -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> cstl -> SetTextModifiedPtr (&this -> dialogModified);

    calcContainer -> monitorDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> archiveDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> alarmDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> displayLow -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> displayHigh -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> devSetpoint -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> alarmDelay -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> hihiLimit -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> highLimit -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> lowLimit -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> loloLimit -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> rocLimit -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> devLimit -> SetTextModifiedPtr (&this -> dialogModified);
    calcContainer -> hihiSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> highSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> lowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> loloSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> rocSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    calcContainer -> devSeverity -> vuSetModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    calcContainer -> pvaButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvbButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvcButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvdButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pveButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvfButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvgButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvhButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pviButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvjButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvkButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvlButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    calcContainer -> pva -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvb -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvc -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvd -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pve -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvf -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvg -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvh -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvi -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvj -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvk -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> pvl -> storeCommonDialog ((vuCommonDialogClass *)this);
    calcContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    calcContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_CALC);

    // get the title from the resource file, aiTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    calcTitle = vresourceGetString (dialogTitles, 
				vunames_vuCalcDialogTitle);
    SetTitle (calcTitle);
}


/*******************************************************************
*
*    vuCalcDialogClass Destroy function
*
*******************************************************************/

void vuCalcDialogClass::Destroy (void)
{
    vstrDestroy (calcTitle);
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuCalcDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuCalcDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    dialogItem = vuFindContainerItem (calcContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the archive deadband field
		if ( (vcharCompareBounded (epics, "ADEL", FLDNAME_SZ)) == 0)
		{
		    vstr *adel = vresourceGetString (defRes, 
						vunames_vuADELdefault);
		    textItem -> SetText (adel);
		    vstrDestroy (adel);
		}
		else if ( (vcharCompareBounded (epics, "PREC", FLDNAME_SZ)) == 0)
		{
		    vstr *precision = vresourceGetString (defRes, 
						vunames_vuPRECdefault);
		    textItem -> SetText (precision);
		    vstrDestroy (precision);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuCalcDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT an CALC
	if (ptType != VU_CALC)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_CALC);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed or new xrefOpId
	    if ( (lastTable != xrefNode -> xrefTable) ||
		 (strlen (xrefNode -> xrefOpId) ) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindContainerItem (calcContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuCalcDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    // verify the expression before a save

    if (vuVerifyCalcExpression ())
    {
	return;
    }

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if  ( (lastTable != xrefNode -> xrefTable) ||
		  (strlen (xrefNode -> xrefOpId)) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindContainerItem (calcContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_INLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


/*******************************************************************
*
*    vuVerifyCalcExpression () 
*	NOTE: dbValue defined in base class vuCommonDialogClass
*	      postfix is in .../share/src/libCom and is the same
*		function used by .../share/src/rec/recCalc.c
*
*******************************************************************/

int vuCalcDialogClass::vuVerifyCalcExpression (void)
{
    vstr	*stringValue;
    char	rpbuff [256];
    short	error_number;
    int		status;

    stringValue = calcContainer -> calcExpression -> GetTextAsString ();
    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
    vstrDestroy (stringValue);

    status = postfix ((char *)dbValue, rpbuff, &error_number, CALCEXPR_SZ);
    if (status)
    {
	vuMessageDialogCenter (this, VU_CALCEXPRESSIONERR, error_number);
    }
    return (status);
}


vkindTYPED_FULL_DEFINITION(vuCalcContainerClass, vcontainer, "vuCalcContainerClass");

/*******************************************************************
*
*    vuCalcContainerClass override for constructor
*
*******************************************************************/

void vuCalcContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuCalcContainer);

    vcontainer *expcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCALCContainer);
    calcExpression = filteredTextitem::RequestSubLoad (expcontainer,
				vunames_CALC);

    vcontainer *preccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcPRECContainer);
    precision = filteredTextitem::RequestSubLoad (preccontainer,
				vunames_PREC);

    vcontainer *rocscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcROCNContainer);
    rocSamples = filteredTextitem::RequestSubLoad (rocscontainer,
				vunames_ROCN);

    vcontainer *egutagcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcEGUContainer);
    eguTag = filteredTextitem::RequestSubLoad (egutagcontainer,
				vunames_EGU);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    manual = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MODE);

    vcontainer *pvacontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPAContainer);
    pvaButton = vuPvNameButtonClass::RequestSubLoad (pvacontainer,
				vunames_vuCalcINPAButton);
    pva = vuFilteredTextitem::RequestSubLoad (pvacontainer,
				vunames_INPA);
    prca = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCA);
    mxsa = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSA);
    vcontainer *cstacontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTAContainer);
    csta = filteredTextitem::RequestSubLoad (cstacontainer,
				vunames_CSTA);

    vcontainer *pvbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPBContainer);
    pvbButton = vuPvNameButtonClass::RequestSubLoad (pvbcontainer,
				vunames_vuCalcINPBButton);
    pvb = vuFilteredTextitem::RequestSubLoad (pvbcontainer,
				vunames_INPB);
    prcb = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCB);
    mxsb = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSB);
    vcontainer *cstbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTBContainer);
    cstb = filteredTextitem::RequestSubLoad (cstbcontainer,
				vunames_CSTB);

    vcontainer *pvccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPCContainer);
    pvcButton = vuPvNameButtonClass::RequestSubLoad (pvccontainer,
				vunames_vuCalcINPCButton);
    pvc = vuFilteredTextitem::RequestSubLoad (pvccontainer,
				vunames_INPC);
    prcc = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCC);
    mxsc = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSC);
    vcontainer *cstccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTCContainer);
    cstc = filteredTextitem::RequestSubLoad (cstccontainer,
				vunames_CSTC);

    vcontainer *pvdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPDContainer);
    pvdButton = vuPvNameButtonClass::RequestSubLoad (pvdcontainer,
				vunames_vuCalcINPDButton);
    pvd = vuFilteredTextitem::RequestSubLoad (pvdcontainer,
				vunames_INPD);
    prcd = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCD);
    mxsd = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSD);
    vcontainer *cstdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTDContainer);
    cstd = filteredTextitem::RequestSubLoad (cstdcontainer,
				vunames_CSTD);

    vcontainer *pvecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPEContainer);
    pveButton = vuPvNameButtonClass::RequestSubLoad (pvecontainer,
				vunames_vuCalcINPEButton);
    pve = vuFilteredTextitem::RequestSubLoad (pvecontainer,
				vunames_INPE);
    prce = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCE);
    mxse = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSE);
    vcontainer *cstecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTEContainer);
    cste = filteredTextitem::RequestSubLoad (cstecontainer,
				vunames_CSTE);

    vcontainer *pvfcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPFContainer);
    pvfButton = vuPvNameButtonClass::RequestSubLoad (pvfcontainer,
				vunames_vuCalcINPFButton);
    pvf = vuFilteredTextitem::RequestSubLoad (pvfcontainer,
				vunames_INPF);
    prcf = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCF);
    mxsf = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSF);
    vcontainer *cstfcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTFContainer);
    cstf = filteredTextitem::RequestSubLoad (cstfcontainer,
				vunames_CSTF);

    vcontainer *pvgcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPGContainer);
    pvgButton = vuPvNameButtonClass::RequestSubLoad (pvgcontainer,
				vunames_vuCalcINPGButton);
    pvg = vuFilteredTextitem::RequestSubLoad (pvgcontainer,
				vunames_INPG);
    prcg = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCG);
    mxsg = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSG);
    vcontainer *cstgcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTGContainer);
    cstg = filteredTextitem::RequestSubLoad (cstgcontainer,
				vunames_CSTG);

    vcontainer *pvhcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPHContainer);
    pvhButton = vuPvNameButtonClass::RequestSubLoad (pvhcontainer,
				vunames_vuCalcINPHButton);
    pvh = vuFilteredTextitem::RequestSubLoad (pvhcontainer,
				vunames_INPH);
    prch = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCH);
    mxsh = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSH);
    vcontainer *csthcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTHContainer);
    csth = filteredTextitem::RequestSubLoad (csthcontainer,
				vunames_CSTH);

    vcontainer *pvicontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPIContainer);
    pviButton = vuPvNameButtonClass::RequestSubLoad (pvicontainer,
				vunames_vuCalcINPIButton);
    pvi = vuFilteredTextitem::RequestSubLoad (pvicontainer,
				vunames_INPI);
    prci = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCI);
    mxsi = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSI);
    vcontainer *csticontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTIContainer);
    csti = filteredTextitem::RequestSubLoad (csticontainer,
				vunames_CSTI);

    vcontainer *pvjcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPJContainer);
    pvjButton = vuPvNameButtonClass::RequestSubLoad (pvjcontainer,
				vunames_vuCalcINPJButton);
    pvj = vuFilteredTextitem::RequestSubLoad (pvjcontainer,
				vunames_INPJ);
    prcj = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCJ);
    mxsj = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSJ);
    vcontainer *cstjcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTJContainer);
    cstj = filteredTextitem::RequestSubLoad (cstjcontainer,
				vunames_CSTJ);

    vcontainer *pvkcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPKContainer);
    pvkButton = vuPvNameButtonClass::RequestSubLoad (pvkcontainer,
				vunames_vuCalcINPKButton);
    pvk = vuFilteredTextitem::RequestSubLoad (pvkcontainer,
				vunames_INPK);
    prck = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCK);
    mxsk = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSK);
    vcontainer *cstkcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTKContainer);
    cstk = filteredTextitem::RequestSubLoad (cstkcontainer,
				vunames_CSTK);

    vcontainer *pvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcINPLContainer);
    pvlButton = vuPvNameButtonClass::RequestSubLoad (pvlcontainer,
				vunames_vuCalcINPLButton);
    pvl = vuFilteredTextitem::RequestSubLoad (pvlcontainer,
				vunames_INPL);
    prcl = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCL);
    mxsl = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSL);
    vcontainer *cstlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcCSTLContainer);
    cstl = filteredTextitem::RequestSubLoad (cstlcontainer,
				vunames_CSTL);

    vcontainer *mdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcMDELContainer);
    monitorDeadband = filteredTextitem::RequestSubLoad (mdbcontainer,
				vunames_MDEL);

    vcontainer *archcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcADELContainer);
    archiveDeadband = filteredTextitem::RequestSubLoad (archcontainer,
				vunames_ADEL);

    vcontainer *alarmdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcHYSTContainer);
    alarmDeadband = filteredTextitem::RequestSubLoad (alarmdbcontainer,
				vunames_HYST);

    vcontainer *dsplowcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcLOPRContainer);
    displayLow = filteredTextitem::RequestSubLoad (dsplowcontainer,
				vunames_LOPR);

    vcontainer *dsphicontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcHOPRContainer);
    displayHigh = filteredTextitem::RequestSubLoad (dsphicontainer,
				vunames_HOPR);

    vcontainer *devstpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcDEVSContainer);
    devSetpoint = filteredTextitem::RequestSubLoad (devstpcontainer,
				vunames_DEVS);

    vcontainer *alrmgrpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (alrmgrpcontainer,
				vunames_ALGP);

    vcontainer *alarmdiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (alarmdiscontainer,
				vunames_vuCalcADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (alarmdiscontainer,
				vunames_ADIS);

    vcontainer *alarmdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcALDLContainer);
    alarmDelay = filteredTextitem::RequestSubLoad (alarmdelcontainer,
				vunames_ALDL);

    vcontainer *alarmcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuCalcAlarmContainer);

    vcontainer *hihilimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcHIHIContainer);
    hihiLimit = filteredTextitem::RequestSubLoad (hihilimcontainer,
				vunames_HIHI);
    vcontainer *hihisevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcHHSVContainer);
    hihiSeverity = vuChoiceGblMenuClass::RequestSubLoad (hihisevcontainer,
				vunames_HHSV);

    vcontainer *highlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcHIGHContainer);
    highLimit = filteredTextitem::RequestSubLoad (highlimcontainer,
				vunames_HIGH);
    vcontainer *highsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcHSVContainer);
    highSeverity = vuChoiceGblMenuClass::RequestSubLoad (highsevcontainer,
				vunames_HSV);

    vcontainer *lowlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcLOWContainer);
    lowLimit = filteredTextitem::RequestSubLoad (lowlimcontainer,
				vunames_LOW);
    vcontainer *lowsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcLSVContainer);
    lowSeverity = vuChoiceGblMenuClass::RequestSubLoad (lowsevcontainer,
				vunames_LSV);

    vcontainer *lololimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcLOLOContainer);
    loloLimit = filteredTextitem::RequestSubLoad (lololimcontainer,
				vunames_LOLO);
    vcontainer *lolosevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcLLSVContainer);
    loloSeverity = vuChoiceGblMenuClass::RequestSubLoad (lolosevcontainer,
				vunames_LLSV);

    vcontainer *roclimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcROCContainer);
    rocLimit = filteredTextitem::RequestSubLoad (roclimcontainer,
				vunames_ROC);
    vcontainer *rocsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcRCSVContainer);
    rocSeverity = vuChoiceGblMenuClass::RequestSubLoad (rocsevcontainer,
				vunames_RCSV);

    vcontainer *devlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcDEVLContainer);
    devLimit = filteredTextitem::RequestSubLoad (devlimcontainer,
				vunames_DEVL);
    vcontainer *devsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuCalcDVSVContainer);
    devSeverity = vuChoiceGblMenuClass::RequestSubLoad (devsevcontainer,
				vunames_DVSV);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    pvaButton -> storePvName (pva);
    pvbButton -> storePvName (pvb);
    pvcButton -> storePvName (pvc);
    pvdButton -> storePvName (pvd);
    pveButton -> storePvName (pve);
    pvfButton -> storePvName (pvf);
    pvgButton -> storePvName (pvg);
    pvhButton -> storePvName (pvh);
    pviButton -> storePvName (pvi);
    pvjButton -> storePvName (pvj);
    pvkButton -> storePvName (pvk);
    pvlButton -> storePvName (pvl);
    alarmDisableButton -> storePvName (alarmDisable);


    calcExpression -> SetItemFilterFunc (calcExpressionFilter);
    precision -> SetItemFilterFunc (numericFilter);
    rocSamples -> SetItemFilterFunc (numericFilter);
    eguTag -> SetItemFilterFunc (egutagFilter);

    pva -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvaText = (filteredText *)pva -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvaText -> SetUserPtr ((void *)pva);

    pvb -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvbText = (filteredText *)pvb -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvbText -> SetUserPtr ((void *)pvb);

    pvc -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvcText = (filteredText *)pvc -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvcText -> SetUserPtr ((void *)pvc);

    pvd -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvdText = (filteredText *)pvd -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvdText -> SetUserPtr ((void *)pvd);

    pve -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pveText = (filteredText *)pve -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pveText -> SetUserPtr ((void *)pve);

    pvf -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvfText = (filteredText *)pvf -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvfText -> SetUserPtr ((void *)pvf);

    pvg -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvgText = (filteredText *)pvg -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvgText -> SetUserPtr ((void *)pvg);

    pvh -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvhText = (filteredText *)pvh -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvhText -> SetUserPtr ((void *)pvh);

    pvi -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pviText = (filteredText *)pvi -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pviText -> SetUserPtr ((void *)pvi);

    pvj -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvjText = (filteredText *)pvj -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvjText -> SetUserPtr ((void *)pvj);

    pvk -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvkText = (filteredText *)pvk -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvkText -> SetUserPtr ((void *)pvk);

    pvl -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pvlText = (filteredText *)pvl -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pvlText -> SetUserPtr ((void *)pvl);

    monitorDeadband -> SetItemFilterFunc (floatFilter);
    archiveDeadband -> SetItemFilterFunc (floatFilter);
    alarmDeadband -> SetItemFilterFunc (floatFilter);
    displayLow -> SetItemFilterFunc (floatFilter);
    displayHigh -> SetItemFilterFunc (floatFilter);
    devSetpoint -> SetItemFilterFunc (floatFilter);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *alrmDisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alrmDisText -> SetUserPtr ((void *)alarmDisable);

    alarmDelay -> SetItemFilterFunc (numericFilter);

    hihiLimit -> SetItemFilterFunc (floatFilter);
    highLimit -> SetItemFilterFunc (floatFilter);
    lowLimit -> SetItemFilterFunc (floatFilter);
    loloLimit -> SetItemFilterFunc (floatFilter);
    rocLimit -> SetItemFilterFunc (floatFilter);
    devLimit -> SetItemFilterFunc (floatFilter);

    // build popup menus
    hihiSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    loloSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    rocSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    devSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);

}

/*******************************************************************
*
*    vuCalcContainerClass override for destructor
*
*******************************************************************/

void vuCalcContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}

