#ifndef vudpadialogclassHXX
#define vudpadialogclassHXX

class vuDpaDialogClass;
class vuDpaDtypeMenuClass;
class vuDpaSelectDpaGoToButtonClass;
class vuDpaSelectDpaDismissButtonClass;
class vuDpaSelectDpaListClass;

class vuDpaSelectDpaDialogClass : public vdialog
{
    vuMainDialogClass	*mainDialog;
    vchar		selectedDpa [RESOURCE_SZ + 1];

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaSelectDpaDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaSelectDpaDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void vuDpaSelectOpen (vuMainDialogClass *mainDialog);

    vchar *getSelectedDpa (void)
	{ return (selectedDpa); }

    // function to handle mainDialog
    vuMainDialogClass *getMainDialog (void)
	{ return (mainDialog); }

    // public so dont need funcs to get at
    vuDpaSelectDpaListClass		*dpaList;
    vuDpaSelectDpaGoToButtonClass	*gotoButton;
    vuDpaSelectDpaDismissButtonClass	*dismissButton;
};


class vuDpaSelectDpaGoToButtonClass : public vbutton
{
    vuDpaSelectDpaDialogClass	*selectDpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaSelectDpaGoToButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaSelectDpaGoToButtonClass, vbutton);

    // overide
    void ObserveDialogItem (vevent *event);

    // function to handle selectDpaDialog
    void setSelectDpaDialog (vuDpaSelectDpaDialogClass *dlg)
	{ selectDpaDialog = dlg; }
};


class vuDpaSelectDpaDismissButtonClass : public vbutton
{
    vuDpaSelectDpaDialogClass	*selectDpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaSelectDpaDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaSelectDpaDismissButtonClass, vbutton);

    // overide
    void ObserveDialogItem (vevent *event);

    // function to handle selectDpaDialog
    void setSelectDpaDialog (vuDpaSelectDpaDialogClass *dlg)
	{ selectDpaDialog = dlg; }
};


class vuDpaSelectDpaListClass : public vlistview
{
    vuDpaSelectDpaDialogClass	*selectDpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaSelectDpaListClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaSelectDpaListClass, vlistview);

    // overide
    void ObserveSelect (int state);

    void buildDpaList (void);

    // function to handle selectDpaDialog
    void setSelectDpaDialog (vuDpaSelectDpaDialogClass *dlg)
	{ selectDpaDialog = dlg; }
};


class vuDpaSelectPtGoToButtonClass;
class vuDpaSelectPtDismissButtonClass;
class vuDpaSelectPtListClass;

class vuDpaSelectPtDialogClass : public vdialog
{
    vuDpaDialogClass		*dpaDialog;
    vchar			selectedDpa [PVNAME_SZ + 1];

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaSelectPtDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaSelectPtDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    void vuDpaSelectOpen (vuDpaDialogClass *dpaDialog);

    vchar *getSelectedDpa (void)
	{ return (selectedDpa); }

    // function to handle dpaDialog
    vuDpaDialogClass *getDpaDialog (void)
	{ return (dpaDialog); }

    // public so dont need funcs to get at
    vuDpaSelectPtListClass		*dpaList;
    vuDpaSelectPtGoToButtonClass	*gotoButton;
    vuDpaSelectPtDismissButtonClass	*dismissButton;
};


class vuDpaSelectPtGoToButtonClass : public vbutton
{
    vuDpaSelectPtDialogClass	*selectDpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaSelectPtGoToButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaSelectPtGoToButtonClass, vbutton);

    // overide
    void ObserveDialogItem (vevent *event);

    // function to handle selectDpaDialog
    void setDpaSelectDialog (vuDpaSelectPtDialogClass *dlg)
	{ selectDpaDialog = dlg; }
};


class vuDpaSelectPtDismissButtonClass : public vbutton
{
    vuDpaSelectPtDialogClass	*selectDpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaSelectPtDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaSelectPtDismissButtonClass, vbutton);

    // overide
    void ObserveDialogItem (vevent *event);

    // function to handle selectDpaDialog
    void setDpaSelectDialog (vuDpaSelectPtDialogClass *dlg)
	{ selectDpaDialog = dlg; }
};


class vuDpaSelectPtListClass : public vlistview
{
    vuDpaSelectPtDialogClass	*selectDpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaSelectPtListClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaSelectPtListClass, vlistview);

    // overide
    void ObserveSelect (int state);

    void buildDpaList (void);

    // function to handle selectDpaDialog
    void setDpaSelectDialog (vuDpaSelectPtDialogClass *dlg)
	{ selectDpaDialog = dlg; }
};


class vuDpaApplyButtonClass;
class vuDpaDismissButtonClass;
class vuDpaDeleteButtonClass;
class vuDpaGoToButtonClass;
class vuDpaNextButtonClass;
class vuDpaPrevButtonClass;

class vuDpaDialogClass : public vdialog
{

    vuMainDialogClass		*mainDialog;
    vuDpaSelectPtDialogClass	*selectDpaDialog;
    vchar			selectedDpa[RESOURCE_SZ + 1];
    vchar			selectedDpaPt[PVNAME_SZ + 1];
    DB_TABLE_PTR		dpaTable;
    int				dialogModified;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override
    void Destroy ();

    // function to handle mainDialog;
    vuMainDialogClass *getMainDialog (void)
	{ return (mainDialog); }

    // function to handle selectDpaDialog
    void setSelectDpaDialog (vuDpaSelectPtDialogClass *dlg)
	{ selectDpaDialog = dlg; }
    vuDpaSelectPtDialogClass *getSelectDpaDialog (void)
	{ return (selectDpaDialog); }

    // function to handle dpaTable
    DB_TABLE_PTR getDpaTable (void)
	{ return (dpaTable); }

    // function to handle selectedDpa
    vchar *getSelectedDpa (void)
	{ return (selectedDpa); }

    // function to handle selectDpaPt
    vchar *getSelectedDpaPt (void)
	{ return (selectedDpaPt); }

    // function to handle dialogModified
    int getDialogModify (void)
	{ return (dialogModified); }

    // open function
    void vuDpaOpen (vuMainDialogClass *mainDialog);

    // load dialog function
    void vuDpaLoadConfig (DB_TABLE_PTR table, int);

    // reset dialog function
    void vuDpaResetConfig (void);

    // save dialog function
    void vuDpaSaveConfig (void);

    // public so dont need func to get at
    filteredTextitem		*dpaName;
    filteredTextitem		*description;
    filteredTextitem		*precision;
    filteredTextitem		*elements;
    filteredTextitem		*eguTag;
    vuDpaDtypeMenuClass		*caDataType;
    filteredTextitem		*userData;
    checkBoxClass		*onAlarm;
    checkBoxClass		*onTrend;
    filteredTextitem		*strings[8];
    filteredTextitem		*dspLow;
    filteredTextitem		*dspHigh;
    filteredTextitem		*irLow;
    filteredTextitem		*irHigh;
    filteredTextitem		*hihiLimit;
    filteredTextitem		*highLimit;
    filteredTextitem		*lowLimit;
    filteredTextitem		*loloLimit;
    vuChoiceGblMenuClass	*hihiSeverity;
    vuChoiceGblMenuClass	*highSeverity;
    vuChoiceGblMenuClass	*lowSeverity;
    vuChoiceGblMenuClass	*loloSeverity;
    vuDpaApplyButtonClass	*applyButton;
    vuDpaDismissButtonClass	*dismissButton;
    vuDpaDeleteButtonClass	*deleteButton;
    vuDpaGoToButtonClass	*gotoButton;
    vuDpaNextButtonClass	*nextButton;
    vuDpaPrevButtonClass	*prevButton;

    // mapping to DPA config table fields
    DB_FIELD_PTR	dpaNameField;
    DB_FIELD_PTR	dpaDescField;
    DB_FIELD_PTR	dpaPrecField;
    DB_FIELD_PTR	dpaElemField;
    DB_FIELD_PTR	dpaEguField;
    DB_FIELD_PTR	dpaDtypeField;
    DB_FIELD_PTR	dpaDataField;
    DB_FIELD_PTR	dpaAenbField;
    DB_FIELD_PTR	dpaTenbField;
    DB_FIELD_PTR	dpaNumStrField;
    DB_FIELD_PTR	dpaStrsFields[8];
    DB_FIELD_PTR	dpaLoprField;
    DB_FIELD_PTR	dpaHoprField;
    DB_FIELD_PTR	dpaIrloField;
    DB_FIELD_PTR	dpaIrhiField;
    DB_FIELD_PTR	dpaHihiField;
    DB_FIELD_PTR	dpaHighField;
    DB_FIELD_PTR	dpaLowField;
    DB_FIELD_PTR	dpaLoloField;
    DB_FIELD_PTR	dpaHhsvField;
    DB_FIELD_PTR	dpaHsvField;
    DB_FIELD_PTR	dpaLsvField;
    DB_FIELD_PTR	dpaLlsvField;
};


class vuDpaApplyButtonClass : public vbutton
{
    vuDpaDialogClass	*dpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaApplyButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaApplyButtonClass, vbutton);

    // overide
    void ObserveDialogItem (vevent *event);

    // handle dpaDialog
    void storeDpaDialog (vuDpaDialogClass *dlg)
	{ dpaDialog = dlg; }
};


class vuDpaDismissButtonClass : public vbutton
{
    vuDpaDialogClass	*dpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaDismissButtonClass, vbutton);

    // overide
    void ObserveDialogItem (vevent *event);

    // handle dpaDialog
    void storeDpaDialog (vuDpaDialogClass *dlg)
	{ dpaDialog = dlg; }
};


class vuDpaDeleteButtonClass : public vbutton
{
    vuDpaDialogClass	*dpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaDeleteButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaDeleteButtonClass, vbutton);

    // overide
    void ObserveDialogItem (vevent *event);

    // handle dpaDialog
    void storeDpaDialog (vuDpaDialogClass *dlg)
	{ dpaDialog = dlg; }
};


class vuDpaGoToButtonClass : public vbutton
{
    vuDpaDialogClass	*dpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaGoToButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaGoToButtonClass, vbutton);

    // overide
    void ObserveDialogItem (vevent *event);

    // handle dpaDialog
    void storeDpaDialog (vuDpaDialogClass *dlg)
	{ dpaDialog = dlg; }
};


class vuDpaNextButtonClass : public vbutton
{
    vuDpaDialogClass	*dpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaNextButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaNextButtonClass, vbutton);

    // overide
    void ObserveDialogItem (vevent *event);

    // handle dpaDialog
    void storeDpaDialog (vuDpaDialogClass *dlg)
	{ dpaDialog = dlg; }
};


class vuDpaPrevButtonClass : public vbutton
{
    vuDpaDialogClass	*dpaDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaPrevButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaPrevButtonClass, vbutton);

    // overide
    void ObserveDialogItem (vevent *event);

    // handle dpaDialog
    void storeDpaDialog (vuDpaDialogClass *dlg)
	{ dpaDialog = dlg; }
};


class vuDpaDtypeMenuClass : public optionMenuClass
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuDpaDtypeMenuClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuDpaDtypeMenuClass, optionMenuClass);

    // overide
    void buildMenu (void);
};

#endif vudpadialogclassHXX
