#ifndef vuexportClassHXX
#define vuexportClassHXX 1

class vuExportClass : public tisProgressDialog
{
public:
    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuExportClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuExportClass, tisProgressDialog);

    // class override
    void Destroy (void);
    vbool DoWork (double *percentCompleted);
    void ObserveWindow(vevent *event);

    // class extensions
    void SetList (char **selectedPts);
    void SetParameters (vuDatabaseClass *db, vstr *path);
    void vuExportRecords(char **selectedPoints);

private:
	vuDatabaseClass *dataBase;
	FILE *fp;
	void *dbValue;
	DB_TABLE_PTR lastTable;		// pointer to last table used
	char key [VU_KEY_SIZE + 1];	// key for additional file lookup
	int fieldIndex;			// index for field names in SDR
	int listIndex;			// index into selectedPoints;
	int numPts;			// number of selected points;
	char **selectedPoints;

	void vuExportOneRecord (char *pv,int index,char *typeString);
	void vuExportArReduc (char *pv,int index);
	void vuSetScanType (DB_TABLE_PTR table,DB_RECORD_PTR rec,char *dbvalue);
	void vuProcessFields (xrefNodeClass *xrefNode,char *pv,int index);
};


class ExportProgressEvent : public veventClientEvent
{
public:

    // virtual member function overrides
    int Handle();
};

#endif vuexportClassHXX
