#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vmenuHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vmenubarHEADER
#include vtextitemHEADER
#include vstartupHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vstrHEADER
#include vnoticeHEADER
#include vlimitsHEADER
#include vlistviewHEADER
#include vliststrHEADER
#include vstdargHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER
#include vrulerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "choice.h"
#include "choiceGbl.h"
#include "dbFldTypes.h"
#include "dbDefs.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
#include "dbRecType.h"
#include "OperPriv.h"
#ifndef WIN32
int searchCompare (void *key, void *elt);
#else
int searchCompare(const void *key,const void *elt);
#endif WIN32
}

#include "string.h"
#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuUtils.hxx"
#include "vuDatabaseClass.hxx"
#include "vuImportClass.hxx"
extern FILE *dbLog;
static char	*udbchk[] =
{
    "CK1 ","CK2 ","CK3 ","CK4 ","CK5 ","CK6 ","CK7 ","CK8 ",0
};

vuImportClass::vuImportClass(vuMainDialogClass *md,vuDatabaseClass *db,vstr *path)
{
    char *fileName;
    dataBase = db;
    mainDialog = md;
    first_call = 1;
    found_resn = 0;
    saw_DTYP = 0;
    saw_RLIN = 0;
    saw_INP = 0;
    linenum = 0;
    fileName = (char *)vcharExportAlloc(vcharScribeSystemExport((vchar *)path));
    fp = fopen(fileName,"r");
    strcpy(inputfile,fileName);
    vcharExportFree(fileName);
    vstrDestroy(path);
    firstAlgp = (struct algp_names *)0;
    firstPrivGrp = (struct priv_grps *)0;
    AlarmGroupsPtr = 0;
    vuValuePtr = (char *)0;
    Operidptr = (DB_FIELD_PTR)0;
    importInitError = vFALSE;
    if (dataBase -> vuAlgrListTable == NULL)
    {
	if ((dataBase -> vuAlgrListTable = DB_MapTable(VU_ALGRLISTFILE)) == 0)
	{
	    vuMessageDialogCenter (NULL, VU_ALGRFILEERR);
	    importInitError = vTRUE;
	}
    }
}
vuImportClass::~vuImportClass()
{
    if(AlarmGroupsPtr != NULL)
    {
	vmemFree((void *)AlarmGroupsPtr);
    }
    if (dataBase -> vuAlgrListTable != NULL)
    {
	DB_UnMapTable (dataBase -> vuAlgrListTable, 0);
	dataBase -> vuAlgrListTable = NULL;
    }
    fclose(fp);
}
void vuImportClass::vuImport(void)
{
    char fldbuff[FLDNAME_SZ + 1];
    char tempbuff[FLDNAME_SZ +1];
    char valbuff[128];
    char *pstr;
    IMPORT_STATE state;
    IMPORT_STATE last_state;
    int valid_point = 0;			// 0=no pt yet; 1=valid point data; -1=invalid pt data
    int i;

    state = STARTNEWPT;
    memset (fldbuff, 0,sizeof (fldbuff));
    memset (pvname, 0, sizeof (pvname));
    memset (valbuff, 0, sizeof (valbuff));
    memset (tempbuff, 0, sizeof (tempbuff));

    /* if first call to import, init all xrefImprtStrings for all 
       known point types, only needs to be done once since after
       every point, free_data() is called to reinit the xreImportStrings
       for that point type, also init the array of alarm group names
    */
    if (first_call)
    {
	if(init_AlarmGroups())
	{
	    mainDialog->vuMainMessageCenter(vunames_ImportAlarmGroupError,inputfile);
	    fclose (fp);
	    return;
	}
	first_call = 0;
    }

    if (vuValuePtr == (char *)0)
    {
	if((vuValuePtr = (char *)malloc(VU_KEY_SIZE + 1)) == NULL)
	{
	    mainDialog->vuMainMessageCenter(vunames_ImportMallocError,inputfile);
	    fclose (fp);
	    return;
	}
    }
    memset (tempbuff, 0, sizeof (tempbuff));
    getString (tempbuff, FLDNAME_SZ);
    sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
    while (1)
    {
	if(feof(fp))
	{
	    if (valid_point)
	    {
		if (valid_point > 0)
		    save_data(pt_type);
		free_data();
	    }
	    DB_FlushAll();	/* flush all files */
	    free_algps();
	    free_privgrps();
	    valid_point = 0;
	    fclose (fp);
	    break;
	}
	switch (state)
	{
	    case STARTNEWPT:
		if(valid_point)
		{
		    if(valid_point > 0)
			save_data(pt_type);
		    free_data();
		    vevent::FlushProcessing ();
		}
		valid_point = 0;
		found_resn = 0;
		if(!strcmp(fldbuff, "#PT#"))
		{
		    pt_type = 0;
		    last_state = state;
		    state = GETPTTYPE;
		    memset(valbuff, 0, sizeof(valbuff));
		    getString(valbuff, sizeof(valbuff) - 1);
		    break;
		}
		else if(!strcmp(fldbuff,"!PT!"))
		{
		    last_state = state;
		    state = GETDELPOINT;
		    memset (valbuff, 0, sizeof(valbuff));
		    getString (valbuff, sizeof(valbuff) - 1);
		    break;
		}
		else if(!strcmp(fldbuff,"*PT*"))
		{
		    mainDialog->vuMainMessageCenter(vunames_ImportPausing,linenum);
		    last_state = state;
		    state = GETPAUSEVALUE;
		    memset(valbuff, 0, sizeof(valbuff));
		    getString(valbuff, sizeof(valbuff) - 1);
		    break;
		  }
		else if(!strcmp(fldbuff,">PT>"))
		{
		    last_state = state;
		    state = GETJOURNALSWITCH;
		    memset (valbuff, 0, sizeof(valbuff));
		    getString (valbuff, sizeof(valbuff) - 1);
		    break;
		}
		else if (!strcmp(fldbuff, "#AR#"))
		{
		    last_state = state;
		    state = GETARREDUCT;
		    break;
		}
		else
		{
		    mainDialog->vuMainMessageCenter(vunames_ImportInvalidStart,linenum);
		    goto_nextpt ();
		    memset (tempbuff, 0, sizeof(tempbuff));
		    getString (tempbuff, FLDNAME_SZ);
		    sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
		    break;
		}
	    case GETPTTYPE:
		for (i = 0, pt_type = 1; pt_type < dbRecType->number; pt_type++)
		{
		    pstr = GET_PRECTYPE(pt_type);
		    if (strcmp (pstr, valbuff) == 0)
		    {
			i = 1;
			break;
		    }
		}
		if (i)
		{
		    //this MUST be done because dict array is zero based
		    dict = dataBase->getXrefDict(pt_type-1);
		    strncpy (valbuff, pstr, strlen (pstr));
		    last_state = state;
		    state = GETNAMEFLD;
		    memset(tempbuff, 0, sizeof (tempbuff));
		    getString(tempbuff, FLDNAME_SZ);
		    sprintf(fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
		    valid_point = 1;
		}
		/* illegal point type */
		else
		{
		    mainDialog->vuMainMessageCenter(vunames_ImportInvalidPointType,
						    linenum, valbuff);
		    goto_nextpt ();
		    last_state = state;
		    state = STARTNEWPT;
		    memset (tempbuff, 0, sizeof (tempbuff));
		    getString (tempbuff, FLDNAME_SZ);
		    sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
		    valid_point = 0;
		}
		break;

	    case GETNAMEFLD:
		if (strncmp (fldbuff, "NAME",FLDNAME_SZ) == 0)
		{
		    last_state = state;
		    state = GETFLDVAL;
		    memset (valbuff, 0, sizeof (valbuff));
		    getString (valbuff, sizeof (valbuff) - 1);
		    /* must have a pointname */
		    if ((strlen (valbuff)) == 0)
		    {
		        mainDialog->vuMainMessageCenter(vunames_BlankImportName,
						    linenum);
			goto_nextpt ();
			last_state = state;
			state = STARTNEWPT;
			memset (tempbuff, 0, sizeof (tempbuff));
			getString (tempbuff, FLDNAME_SZ);
			sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
			valid_point = 0;
		    }
		    char  *cPtr;
		    if ((cPtr = strchr (valbuff, ' ')) != NULL)
		    {
		        mainDialog->vuMainMessageCenter(vunames_SpaceImportNameErr,
						    linenum);
			goto_nextpt ();
			last_state = state;
			state = STARTNEWPT;
			memset (tempbuff, 0, sizeof (tempbuff));
			getString (tempbuff, FLDNAME_SZ);
			sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
			valid_point = 0;
		    }
		}
		/* the NAME field must follow the pt type field */
		else
		{
		    mainDialog->vuMainMessageCenter(vunames_ImportNameFollowsType,
						    linenum);
		    goto_nextpt ();
		    last_state = state;
		    state = STARTNEWPT;
		    memset (tempbuff, 0, sizeof (tempbuff));
		    getString (tempbuff, FLDNAME_SZ);
		    sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
		    valid_point = 0;
		}
		break;

	    case GETFLDNAME:
		if (fldbuff[0] == 0)
		{
		    mainDialog->vuMainMessageCenter(vunames_ImportNoNameField,linenum, pvname);
		    goto_nextpt();
		    last_state = state;
		    state = STARTNEWPT;
		    memset (tempbuff, 0, sizeof (tempbuff));
		    getString (tempbuff, FLDNAME_SZ);
		    sprintf (fldbuff, "%-*.*s\0",FLDNAME_SZ,FLDNAME_SZ,tempbuff);
		    valid_point = 0;
		    free_data ();
		}
		else
		{
		    last_state = state;
		    state = GETFLDVAL;
		    memset (valbuff, 0, sizeof (valbuff));
		    getString (valbuff, sizeof (valbuff) - 1);
		}
		break;

	    case GETFLDVAL:
		if (last_state == GETNAMEFLD)
		    strncpy (pvname, valbuff, sizeof (pvname) - 1);
		last_state = state;
		state = STOREFIELD;
		break;

	    case GETPAUSEVALUE:
		if (last_state == STARTNEWPT)
		{
		    int delay;
		    delay = (int)atoi(valbuff);
#ifdef WIN32
		    Sleep(delay*1000);
#else
		    sleep(delay);
#endif WIN32
		    mainDialog->vuMainMessageCenter(vunames_ImportResuming,linenum,delay);
		    goto_nextpt ();
		    memset (tempbuff, 0, sizeof (tempbuff));
		    getString (tempbuff, FLDNAME_SZ);
		    sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
		    state = STARTNEWPT;
		}
		break;
	    case GETJOURNALSWITCH:
/*
		if (last_state == STARTNEWPT)
		{
		    //ON means ON anything else means OFF
		    short msgType;
		    if((dbClientSocket = vuOpenDbClient(dbClientSocket)) != -1)
		    {
			if(!strcmp(valbuff,"ON"))
			{
#ifndef WIN32
			    dbLog = fopen("/tis4000db/dataVuLog.log","w");
#else
			    dbLog = fopen("c:\\tis4000db\\dataVuLog.log","w");
#endif
			    msgType = UTIL_MSG_JOURNAL_ON;
			}
			else
			{
			    if(dbLog) fclose(dbLog);
			    msgType = UTIL_MSG_JOURNAL_OFF;
			}
			send(dbClientSocket,(char *)&msgType,2,0);
			mainDialog->vuMainMessageCenter(vunames_ImportJournaling,
			     linenum,(msgType == UTIL_MSG_JOURNAL_ON ? "ENABLED":"DISABLED"));
		    }
		    goto_nextpt ();
		    memset (tempbuff, 0, sizeof (tempbuff));
		    getString (tempbuff, FLDNAME_SZ);
		    sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
		    state = STARTNEWPT;
		}
*/
		break;
	    case GETDELPOINT:
		if (last_state == STARTNEWPT)
		{
		    DB_RECORD_PTR  rec;
		    DB_FIELD_PTR   field;
		    /* attempt to find record */
	 	    if((rec = DB_Seek(dataBase->vuPvmapTable,valbuff)) != 0)
		    {
			/* get the point type string */
			field = DB_MapField(dataBase->vuPvmapTable,FLD_TYPE);
			/* delete point and tell dbClient */
			vuDeletePoint(mainDialog,(vchar *)valbuff);
			mainDialog->vuMainMessageCenter(vunames_ImportDelete,linenum,valbuff);
		    }
		    goto_nextpt ();
		    memset (tempbuff, 0, sizeof (tempbuff));
		    getString (tempbuff, FLDNAME_SZ);
		    sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
		    state = STARTNEWPT;
		}
		break;
	    case GETARREDUCT:
		while (1)
		{
		    process_arreduc_record ();
		    memset ((void *)&tempbuff[0], 0, sizeof(tempbuff));
		    getString (tempbuff, FLDNAME_SZ);
		    sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
		    if ( (strncmp (fldbuff, "#AR#", FLDNAME_SZ)) == 0)
			continue;
		    else
			break;
		}
		last_state = GETARREDUCT;
		state = STARTNEWPT;
		valid_point = 0;
		break;

	    case STOREFIELD:
		if (last_state != GETPTTYPE)
		{
		    if (!valid_field (fldbuff, valbuff))
		    {
			valid_point = -1;
		    }
		}
		memset (tempbuff, 0, sizeof (tempbuff));
		getString (tempbuff, FLDNAME_SZ);
		sprintf (fldbuff, "%-*.*s\0", FLDNAME_SZ, FLDNAME_SZ, tempbuff);
		state = GETFLDNAME;
		if (!strncmp(fldbuff, "#PT#", FLDNAME_SZ) ||
		    !strncmp(fldbuff, "!PT!", FLDNAME_SZ) ||
		    !strncmp(fldbuff, ">PT>", FLDNAME_SZ) ||
		    !strncmp(fldbuff, "*PT*", FLDNAME_SZ) ||
		    !strncmp(fldbuff, "#AR#", FLDNAME_SZ) )
		    state = STARTNEWPT;
		last_state = STOREFIELD;
		break;
	}
    }
    return;
}
/*
	Private support functions
*/
int	vuImportClass::are_numbers(char *fldname,char *value,int type)
{
    char	*p;
    int		first_char = 1;
    int		num_decpts = 0;

    p = value;
    while ((*p) != (int)NULL)
    {
	if ( ((*p) == '+') || ((*p) == '-') )
	{
	    if (type & VU_SIGNED_NUM)
	    {
		;
	    }
	    else
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportSignedNumberNotValid,
						linenum, pvname, fldname, value);
		return (0);
	    }
	    if(!first_char)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportSignNotFirst,
						linenum, pvname, fldname, value);
		return (0);
	    }
	}
	else if((*p) == '.')
	{
	    if (type & VU_DECIMAL)
	    {
		if (num_decpts > 1)
		{
		    mainDialog->vuMainMessageCenter(vunames_ImportTooManyDecimalPts,
						    linenum, pvname, fldname, value);
		    return (0);
		}
		num_decpts++;
	    }
	    else
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportDecimalNotAllowed,
						linenum, pvname, fldname, value);
		return (0);
	    }
	}
	else if(!(isdigit((*p))))
	{
	    mainDialog->vuMainMessageCenter(vunames_ImportNonDigitInNumber,
					    linenum, pvname, fldname, value);
	    return (0);
	}
	first_char = 0;
	p++;
    }
    return (1);
}
/*
	Skip over comments
*/
void vuImportClass::eat_comment(int putback_newline)
{
    char    next_char;
    int     first_char = 1;

    while (1)
    {
	next_char = getc (fp);
	if (first_char)
	{
	    first_char = 0;
	    if (next_char != '/')
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportInvalidComment,linenum);
	    }
	}
	if (next_char == '\n')
	    break;
    }
    /* for a comment on a data line we do not want to bump
       the line number, since error messages depend on it
       but for a comment on a line by itself, bump the
       line number
    */
    if (putback_newline)
	ungetc (next_char, fp);
    else
	linenum++;

    return;
}
void vuImportClass::eat_spaces(char *ch)
{
    while ( ((*ch) == ' ') || ((*ch) == '\t') || ((*ch) == '='))
    {
	*ch = getc (fp);
    }

    return;
}
void vuImportClass::getString(char *buff,unsigned short maxlen)
{
    char	next_char;
    int		idx = -1;
    int		in_string = 0;

    next_char = getc (fp);
    /* chew up any blank lines and comment lines and spaces 
       that may be left at the end of the last line
    */
    while (1)
    {
	if (next_char == '\n')
	{
	    linenum++;
	    next_char = getc (fp);
	}
	else if (next_char == ' ')
	{
	    next_char = getc (fp);
	}
	else if (next_char == ';')
	{
	    next_char = getc (fp);
	}
	else if (next_char == '/')
	{
	    eat_comment (0);
	    next_char = getc (fp);
	}
	else
	    break;
    }
    /* chew up blanks, tabs and the = */
    eat_spaces (&next_char);
    while (1)
    {
	if (next_char == EOF)
	    break;
	else if (next_char == '\n')
	{
	    ungetc (next_char, fp);
	    if (in_string)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportNonTerminatedQuote,linenum);
	    }
	    break;
	}
	else if (next_char == '/')
	{
	    if (!in_string)
	    {
		eat_comment (1);
		break;
	    }
	}
	else if (next_char == '\t')
	{
	    if (!in_string)
		break;
	}
	else if (next_char == ';')
	{
	    if (!in_string)
		break;
	}
	else if (next_char == '=')
	{
	    if (!in_string)
		break;
	}
	else if (next_char == ' ')
	{
	    if (in_string == 0)
		break;
	}
	else if (next_char == '"')
	{
	    in_string ^= 1;
	    next_char = getc (fp);
	    continue;
	}
	idx++;
	if (idx >= maxlen)
	{
	    mainDialog->vuMainMessageCenter(vunames_ImportFieldToLarge, linenum, buff);
	    return;
	}
	buff[idx] = next_char;
	next_char = getc (fp);
    }

    return;
}
void vuImportClass::goto_nextpt(void)
{
    char    next_char,after_special_char;

    while (1)
    {
	next_char = getc (fp);
	if (next_char == '\n')
	{
	    linenum++;
	    continue;
	}
	if (next_char == EOF)
	    break;
	if (next_char == '#')
	{
	  after_special_char = getc(fp);
	  /* GCT 27-Mar-96 minimum to start new point type is #p */
	  if(after_special_char == 'P')	
	    {
	      ungetc(after_special_char,fp);
	      ungetc (next_char, fp);
	      break;
	    }
	}
	if (next_char == '!')
	{
	  after_special_char = getc(fp);
	  /* GCT 27-Mar-96 minimum to start import DELETE !p */
	  if(after_special_char == 'P')	
	    {
	      ungetc(after_special_char,fp);
	      ungetc (next_char, fp);
	      break;
	    }
	}
	if (next_char == '*')
	{
	    after_special_char = getc(fp);
	    /* GCT 27-Mar-96 minimum to start import PAUSE *p */
	    if(after_special_char == 'P')	
	    {
		ungetc(after_special_char,fp);
		ungetc (next_char, fp);
		break;
	    }
	}
	if (next_char == '>')
	{
	    after_special_char = getc(fp);
	    /* GCT 27-Mar-96 minimum to start import JOURNALING >p */
	    if(after_special_char == 'P')	
	    {
		ungetc(after_special_char,fp);
		ungetc (next_char, fp);
		break;
	    }
	}
    }
    return;
}
void vuImportClass::free_algps (void)
{
    struct algp_names	*curr_algp, *prev_algp;

    if (firstAlgp == (struct algp_names *)0)
	return;
    curr_algp = firstAlgp;
    while (curr_algp)
    {
	prev_algp = curr_algp;
	free ((void *)curr_algp -> algp_name);
	curr_algp = curr_algp -> next_group;
	free ((void *)prev_algp);
    }
    firstAlgp = (struct algp_names *)0;
    return;
}
void vuImportClass::free_data (void)
{
    xrefNodeClass	*xrefnode;
    vdictIterator	iterator;
    DB_FIELD_PTR	pdbField;
    struct arrChoiceSet	*parrChoiceSet;
    struct choiceSet	*pChoiceSet;
    struct fldDes	*pfldDes;
    char		*pChoice;
    char		*typeString;
    char		tf[3] = {'F','T',0};
    int			i;

    saw_DTYP = 0;
    saw_RLIN = 0;
    saw_INP = 0;
    typeString = GET_PRECTYPE(pt_type);

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	xrefnode  = (xrefNodeClass *)iterator.GetValue ();
	pfldDes = xrefnode -> vuFldDes;
	pdbField = xrefnode -> xrefField;
	xrefnode -> xrefImportValid = 0;
	switch (xrefnode -> xrefEPICSFieldType)
	{
	    case DBF_GBLCHOICE:
		/* if the dbase field is a logical, 
		 * can't look it up in choice list
		*/
		if(pdbField -> field_type == 'L')
		{
		    xrefnode -> xrefImportString[0] = tf[xrefnode -> xrefTrue ^ 1 & 1];
		    xrefnode -> xrefImportString[1] = 0;
		    if(!strncmp (typeString, "udb", 3))
		    {
			for (i = 0; udbchk[i]; i++)
			{
			    if (!strncmp (xrefnode -> xrefEpicsName, 
					  udbchk[i], FLDNAME_SZ))
			    {
				strcpy (xrefnode -> xrefImportString, "NO");
				break;
			    }
			}
		    }
		    break;
		}
		if((pChoiceSet = GET_PCHOICE_SET (choiceGbl, pfldDes -> choice_set)) && 
		   (pChoice = GET_CHOICE (pChoiceSet, 0)) )
		{
		    strcpy (xrefnode -> xrefImportString, pChoice);
		}
		else
		    xrefnode -> xrefImportString[0] = 0;
		break;
	    case DBF_CVTCHOICE:
		if(choiceCvt)
		{
		    if (pChoice = GET_CHOICE (choiceCvt, 0))
			strcpy (xrefnode -> xrefImportString, pChoice);
		    else
			xrefnode -> xrefImportString[0] = 0;
		}
		else
		    xrefnode -> xrefImportString[0] = 0;
		break;
	    case DBF_RECCHOICE:
		/* if the dbase field is a logical, can't look it up in choice list */
		if(pdbField -> field_type == 'L')
		{
		    xrefnode -> xrefImportString[0] = tf[xrefnode -> xrefTrue ^ 1 & 1];
			break;
		}
		if ((parrChoiceSet = GET_PARR_CHOICE_SET (choiceRec, pt_type)) &&
		    (pChoiceSet = GET_PCHOICE_SET (parrChoiceSet, pfldDes -> choice_set)) &&
		    (pChoice = GET_CHOICE (pChoiceSet, 0)) )
		{
		    strcpy (xrefnode -> xrefImportString, pChoice);
		}
		else
		    xrefnode -> xrefImportString[0] = 0;
		break;
	    case DBF_DEVCHOICE:
		switch (pt_type)
		{
		    case VU_AI:
		    case VU_AO:
		    case VU_BI:
		    case VU_BO:
		    case VU_MBBI:
		    case VU_MBBO:
		    case VU_STRINGIN:
		    case VU_STRINGOUT:
		    case VU_WAVEFORM:
		    case VU_PTO:
		    case VU_TD:
		    case VU_PAT:
		    case VU_DDC:
			strcpy (xrefnode -> xrefImportString, "CONSTANT");
			break;
		    default:
			xrefnode -> xrefImportString[0] = 0;
			break;
		}
			break;
	    case DBF_SHORT:
		if((!strcmp (typeString, "pto")) && 
		   (!strncmp (xrefnode -> xrefEpicsName, "NBIT", FLDNAME_SZ)) )
		{
		    strcpy (xrefnode -> xrefImportString, "1");
		    break;
		}
	    default:
		xrefnode -> xrefImportString[0] = 0;
		break;
	}
    }
    iterator.Finish();
    return;
}

void vuImportClass::free_privgrps (void)
{
    struct priv_grps	*curr_privgrp, *prev_privgrp;

    if (firstPrivGrp == (struct priv_grps *)0)
		return;
    curr_privgrp = firstPrivGrp;
    while (curr_privgrp)
    {
	prev_privgrp = curr_privgrp;
	free ((void *)curr_privgrp -> privgrp_name);
	curr_privgrp = curr_privgrp -> next_group;
	free ((void *)prev_privgrp);
    }
    firstPrivGrp = (struct priv_grps *)0;
    return;
}
int vuImportClass::init_AlarmGroups()
{
    char		alrmgroup[IOCNAME_SZ+1];
    DB_RECORD_PTR	rec;
    DB_FIELD_PTR	AlrmGrpField;
    int			type;
    int			count;

    AlrmGrpField = DB_MapField (dataBase->vuAlgrListTable, FLD_GROUPNAME);
    if ((AlarmGroupsPtr = (char *)vmemAllocAndClear(dataBase->vuAlgrListTable -> table_records * (AlrmGrpField -> field_size +1))) == NULL)
    {
	return (1);
    }
    rec = DB_Top(dataBase->vuAlgrListTable);
    count = 0;
    while (rec)
    {
	DB_GetFieldValue(rec, AlrmGrpField, alrmgroup, &type);
	strcpy((char *)(AlarmGroupsPtr + count), alrmgroup);
	count += (AlrmGrpField -> field_size  + 1);
	rec = DB_SeekNext(dataBase->vuAlgrListTable);
    }
    return (0);
}
void vuImportClass::output_fields(DB_RECORD_PTR pntRecord,int isNew)
{
    xrefNodeClass	*xrefNode;
//  xrefNodeClass	*savenode;
    vdictIterator	iterator;
    DB_TABLE_PTR	lastTable = dataBase->vuPvmapTable;
    int			logical, i;
//  char		proc, max, *selv;
//  char		piString[VU_KEY_SIZE], msString[VU_KEY_SIZE];
    char		key[VU_KEY_SIZE+1], vuCurrentBoard[VU_KEY_SIZE];
    double		doubleValue;
    char		lin[VU_KEY_SIZE], tempName[PVNAME_SZ+1], resName[RESOURCE_SZ+1];
    char		privGroup[OPERATOR_SZ+PROTECTIONGRP_SZ+1];
//  char		alarmGroup[ALARMGRP_SZ+1];
    char		*typeString;
    DB_FIELD_PTR	xrefConstant, xrefReference, putField, typeField;
	//DB_FIELD_PTR	devTypeField, brdTypeField;
    DB_FIELD_PTR	pntPI, pntMS;
//  DB_FIELD_PTR	pntProcDelRef, irLow, irHigh,
    DB_FIELD_PTR	accFrzSevr, accFrzRunSevr,resField;
//  DB_FIELD_PTR	pntSetPtMS, pntSetPtProc, pntMvMS, pntMvProc, pntCascMS;
//  DB_FIELD_PTR	pntCascProc, pntProcFzSpec;
//  DB_FIELD_PTR	pntMaxFzSpec, pntProcResSpec, pntMaxResSpec;
//  DB_FIELD_PTR	udbPI, udbMS;
    DB_FIELD_PTR	AlrmGrpField;
    DB_RECORD_PTR	pvmapRecord,rec;
    VERIFY_INFO		verify_info;
    IMPORT_INFO		import_info;
//  int			whichLong, whichBit, udbNum,
    int			do_save;



    /* return a ptr to the point type as a string */
    typeString = GET_PRECTYPE (pt_type);

//  savenode = xrefNode;
    pvmapRecord = pntRecord;
    typeField = DB_MapField(dataBase->vuPvmapTable,FLD_TYPE);
/*  devTypeField = DB_MapField(vuPvmapTable,FLD_DEVTYPE); */
    resField = DB_MapField(dataBase->vuResListTable,FLD_RESOURCE);
/*  DB_PutFieldNF(pntRecord,devTypeField,""); */
    accFrzSevr = 0;
    accFrzRunSevr = 0;
    iterator.Start (dict);
    while ( iterator.Next ())
    {
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	do_save = 1;
	putField = xrefNode->xrefField;
	if(!strcmp(typeString,"pto"))
	{
	    strcpy (tempName, pvname);
	    if (!strncmp (xrefNode -> xrefEpicsName, "LINE", FLDNAME_SZ) ||
		!strncmp (xrefNode -> xrefEpicsName, "ADDR", FLDNAME_SZ) ||
		!strncmp (xrefNode -> xrefEpicsName, "CARD", FLDNAME_SZ) ||
		!strncmp (xrefNode -> xrefEpicsName, "SIGN", FLDNAME_SZ))
	    {
		strcat(tempName,"1");
	    }
	    else if (!strncmp (xrefNode -> xrefEpicsName, "LIN2", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "ADR2", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "CRD2", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "SIG2", FLDNAME_SZ))
	    {
		strcat(tempName,"2");
	    }
	}
	if(!strcmp(typeString, "pat"))
	{
	    strcpy (tempName, pvname);
	    if (!strncmp (xrefNode -> xrefEpicsName, "LINE", FLDNAME_SZ) ||
		!strncmp (xrefNode -> xrefEpicsName, "ADDR", FLDNAME_SZ) ||
		!strncmp (xrefNode -> xrefEpicsName, "CARD", FLDNAME_SZ) ||
		!strncmp (xrefNode -> xrefEpicsName, "SIGN", FLDNAME_SZ))
	    {
		strcat(tempName,"1");
	    }
    	    else if (!strncmp (xrefNode -> xrefEpicsName, "LIN2", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "ADR2", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "CRD2", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "SIG2", FLDNAME_SZ))
	    {
		strcat(tempName,"2");
	    }
	    else if (!strncmp (xrefNode -> xrefEpicsName, "LIN3", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "ADR3", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "CRD3", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "SIG3", FLDNAME_SZ))
	    {
		strcat(tempName,"3");
	    }
	    else if (!strncmp (xrefNode -> xrefEpicsName, "LIN4", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "ADR4", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "CRD4", FLDNAME_SZ) ||
		     !strncmp (xrefNode -> xrefEpicsName, "SIG4", FLDNAME_SZ))
	    {
		strcat(tempName, "4");
	    }
	}
	/* read correct one from IOADDR file */
	if ( (!strcmp(typeString,"pto") || !strcmp(typeString,"pat") ) && 
	     (xrefNode->xrefTable == dataBase->vuIOAddrTable) )
	{
	    sprintf(seekBuff,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,tempName);
	    pntRecord	= DB_Seek(xrefNode->xrefTable,seekBuff);
	}
	else
	{
	    if(strlen(xrefNode->xrefOpId))
	    {
		/* construct search key for this file */
		sprintf(key,"%-*.*s%-s\0",PVNAME_SZ,PVNAME_SZ,pvname,xrefNode->xrefOpId);	
		/* get next one with this point name */
		pntRecord = DB_Seek(xrefNode->xrefTable, key);
	    }
	    else
	    {
		sprintf(seekBuff,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,pvname);
		pntRecord = DB_Seek (xrefNode->xrefTable,seekBuff);
	    }
	}
	xrefConstant  = DB_MapField(xrefNode -> xrefTable, FLD_CONSTANT);
	xrefReference = DB_MapField(xrefNode -> xrefTable, FLD_REFERENCE);
	pntPI         = DB_MapField(xrefNode -> xrefTable, FLD_PROCINPUT);
	pntMS         = DB_MapField(xrefNode -> xrefTable, FLD_MAXSEVERITY);

	if(!strcmp(typeString,"accum"))
	{
	    if(accFrzSevr == 0)
		accFrzSevr = DB_MapField(xrefNode -> xrefTable, FLD_FRZSEVR);
	    if(accFrzRunSevr == 0)
		accFrzRunSevr = DB_MapField(xrefNode -> xrefTable, FLD_FRZRUNSEVR);
	}

	/* we only want to apply the field to the database if the record is a
	   new record, see save_data() which sets isNew, or the data was entered 
	   by the import file, which does not have to contain all the fields
	   which means if it is a new record and all the fields are not entered
	   by the import file, the defaults will be taken, see free_data()
	*/
	if ( (!isNew) && (!xrefNode -> xrefImportValid) )
	{
	    continue;
	}
	switch(xrefNode -> xrefEPICSFieldType)
	{
	    case DBF_ENUM:
	    case DBF_USHORT:
	    case DBF_SHORT:
		if( (!strcmp (typeString, "pto")) &&
		    (!strncmp(xrefNode -> xrefEpicsName, "NBIT", FLDNAME_SZ)) )
		{
		    doubleValue = 1.0;
		    if(!strcmp(xrefNode -> xrefImportString, "2"))
			doubleValue = 2.0;
		    DB_PutFieldNF(pntRecord, putField, (char *)&doubleValue);
		    do_save = 0;
		    break;
		}

	    case DBF_LONG:
	    case DBF_ULONG:
	    case DBF_FLOAT:
	    case DBF_DOUBLE:
		doubleValue = atof(xrefNode -> xrefImportString);
	        DB_PutFieldNF(pntRecord, putField, (char *)&doubleValue);
		do_save = 0;
		break;

	    case DBF_STRING:
		strncpy (vuValuePtr, xrefNode -> xrefImportString, VU_KEY_SIZE);

		/* if resource name does not exist, add it to reslist.dbf */
		if(!strncmp(xrefNode->xrefEpicsName,"RESN",FLDNAME_SZ))
		{
		    if(strlen(xrefNode->xrefImportString))
		    {
			sprintf (resName,"%-*.*s\0",
					RESOURCE_SZ,RESOURCE_SZ,xrefNode -> xrefImportString);
			if((DB_Seek(dataBase->vuResListTable,resName)) == 0)
			{
			    rec = (DB_RECORD_PTR)DB_NewRecord(dataBase->vuResListTable,0);
			    DB_PutFieldValue(rec,resField,resName);
			    mainDialog->vuMainMessageCenter(vunames_ImportAddToReslist,
							    xrefNode -> xrefImportString);
			}
		    }
		}
		/* warn if alarm group not in list */
		else if (!strncmp (xrefNode -> xrefEpicsName, "ALGP", FLDNAME_SZ))
		{
		    if (strlen (xrefNode -> xrefImportString))
		    {
			AlrmGrpField = DB_MapField (dataBase->vuAlgrListTable, FLD_GROUPNAME);
			if ((bsearch (xrefNode -> xrefImportString, AlarmGroupsPtr,
				      dataBase->vuAlgrListTable -> table_records,
				      AlrmGrpField -> field_size + 1,
				      searchCompare)) == NULL)
			{
			    warn_algp (xrefNode -> xrefImportString);
			}
		    }
		}
		/* warn if privelage/protection group not in list */
		else if (!strncmp (xrefNode -> xrefEpicsName, "PRIV", FLDNAME_SZ))
		{
		    if (strlen (xrefNode -> xrefImportString))
		    {
			if (Operidptr == 0)
			{
			    GetOperName(OperName);
			    Operidptr = DB_MapField (dataBase->vuPrivTabTable, "OPERATORID");
			}
			sprintf (privGroup, "%-*.*s%s\0", 
					Operidptr -> field_size,
					Operidptr -> field_size,
					OperName,
					xrefNode -> xrefImportString);
			DB_UseKey (dataBase->vuPrivTabTable, "OPERGROUP");
			if ((DB_Seek (dataBase->vuPrivTabTable, privGroup)) == 0)
			{
			    warn_priv (xrefNode -> xrefImportString);
			}
		    }
		}
		break;

	    case DBF_GBLCHOICE:
	    case DBF_DEVCHOICE:
	    case DBF_RECCHOICE:
	    case DBF_CVTCHOICE:
		if(xrefNode->xrefField->field_type == 'L')
		{
		    logical = 0;
		    if (xrefNode -> xrefImportString[0] == 'T')
			logical = 1;
		    *vuValuePtr = (logical ? xrefNode -> xrefTrue : (xrefNode -> xrefTrue ^1));
		    if(!strcmp (typeString,"udb"))
		    {
			for(i = 0; udbchk[i]; i++)
			{
			    if(!strncmp (xrefNode -> xrefEpicsName, udbchk[i], FLDNAME_SZ))
			    {
				if (xrefNode -> xrefImportString[0] == 'Y')
				    *(char*)vuValuePtr = 1;
				else
				    *(char*)vuValuePtr = 0;
				break;
			    }
			}
		    }
		    break;
		}
		strncpy (vuValuePtr, xrefNode -> xrefImportString, VU_KEY_SIZE);
		if ( (!strncmp (xrefNode -> xrefEpicsName, "DTYP", FLDNAME_SZ)) ||
		     ( (pt_type == VU_PAT) &&
		       ( (!strncmp (xrefNode -> xrefEpicsName, "DTYR", FLDNAME_SZ)) ||
			 (!strncmp (xrefNode -> xrefEpicsName, "DTYF", FLDNAME_SZ)) ) ) )
		{
		    strncpy (vuCurrentBoard, vuValuePtr, sizeof (vuCurrentBoard)-1);
		    DB_PutFieldNF (pntRecord, xrefNode->xrefField, vuValuePtr);
		}
		if (!strncmp (xrefNode->xrefEpicsName,"LINR",FLDNAME_SZ))
		{
		    strncpy (lin, vuValuePtr, sizeof (lin)-1);
		}
		if (!strncmp (xrefNode->xrefEpicsName,"SCAN",FLDNAME_SZ))
		{
		    vuGetScanType (xrefNode->xrefTable, pntRecord, vuValuePtr);
		}
		break;

	    case DBF_INLINK:
	    case DBF_OUTLINK:
		if (!strncmp (xrefNode -> xrefEpicsName, "SDIS", FLDNAME_SZ))
		{
		    strncpy (vuValuePtr, xrefNode -> xrefImportString, VU_KEY_SIZE);
		    break;
		}
		if(xrefNode -> xrefHardware)
		    DB_PutFieldNF (pntRecord, xrefNode -> xrefField, vuCurrentBoard);
		if(xrefNode->xrefRefField)
		    DB_PutFieldNF(pntRecord, xrefNode -> xrefRefField, 
				  xrefNode ->xrefImportString);
		else
		    DB_PutFieldNF(pntRecord, xrefNode -> xrefField, 
				  xrefNode -> xrefImportString);
		do_save = 0;
		break;

	    case DBF_FWDLINK:
		strncpy(vuValuePtr, xrefNode -> xrefImportString, VU_KEY_SIZE);
		break;

	    default:
		break;
	}

	/* Save field contents to file. */
	if (do_save)
	    DB_PutFieldNF(pntRecord, putField, vuValuePtr);
    }
    iterator.Finish ();

    if(isNew)
    {
	DB_PutFieldNF (pvmapRecord, typeField, typeString);
	if(accFrzSevr)
	    DB_PutFieldNF (pntRecord, accFrzSevr, "NO ALARM");
	if(accFrzRunSevr)
	    DB_PutFieldNF (pntRecord, accFrzRunSevr, "NO ALARM");
    }
    memset((char *)&verify_info,0,VERIFY_INFO_SIZE);
    memset((char *)&import_info,0,IMPORT_INFO_SIZE);
    verify_info.viTimeStamp = vuSynchTime();	/* set modifcation time */
    DB_PutVerifyInfo(dataBase->vuPvmapTable,pvname,&verify_info,&import_info);
    DB_FlushAll();				/* make sure it's on the disk */
    //vuNotifyDbClient(pvname);			/* then tell dbClient */
}
void vuImportClass::save_data(short)
{
    DB_RECORD_PTR	rec;
    char		nameInFile[PVNAME_SZ + 1];
    int			newRecord;

    if (saw_DTYP != 0)
    {
	mainDialog->vuMainMessageCenter(vunames_ImportDtypWithoutInp,pvname);
	return;
    }
    if (saw_RLIN != 0)
    {
	mainDialog->vuMainMessageCenter(vunames_ImportRlinWithoutDtyr,pvname);
	return;
    }
    if (saw_INP != 0)
    {
	mainDialog->vuMainMessageCenter(vunames_ImportInpWithoutDtyf,pvname);
	return;
    }
    sprintf(nameInFile, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvname);
    newRecord = 0;
    /* see if record already exists */
    if((rec = DB_Seek(dataBase->vuPvmapTable, nameInFile)) == 0)
    {
	/* the point can not be loaded to an ioc without 
	   a resource name if it is a new point, we assume
	   if the point already exists that it has a resource
	   name
	*/
	if (!found_resn)
	{
	    mainDialog->vuMainMessageCenter(vunames_ImportNoRESN,pvname);
	    return;
	}
	newRecord = 1;
	/* no it does'nt, create new records for it in all files */
	dataBase->vuCreateNewRecords(pt_type-1, (vchar *)pvname);
	rec = DB_Seek(dataBase->vuPvmapTable, nameInFile);
    }
    output_fields(rec, newRecord);
    return;
}
int vuImportClass::valid_choice(char *fldname, char *value, xrefNodeClass *pxrefNode)
{
    struct devChoiceSet		*pdevChoiceSet;
    struct arrChoiceSet		*parrChoiceSet;
    struct choiceSet		*pChoiceSet;
    struct fldDes		*pfldDes;	/* ptr to epics field structure */
    DB_FIELD_PTR		pdbField;	/* ptr to dbase field		*/
    char			*pChoice;
    char			*typeString;
    int				found_choice = 0;
    int				i;

    pfldDes = pxrefNode -> vuFldDes;
    pdbField = pxrefNode -> xrefField;
    typeString = GET_PRECTYPE(pt_type);
    switch (pxrefNode -> xrefEPICSFieldType)
    {
	case DBF_GBLCHOICE:
	    /* if the dbase field is a logical, can't look it up in choice list */
	    if (pdbField -> field_type == 'L')
	    {
		if (!strcmp (typeString, "udb"))
		{
		    for (i = 0; udbchk[i]; i++)
		    {
			if (!strncmp (pxrefNode -> xrefEpicsName, udbchk[i], FLDNAME_SZ))
			{
			    if ( (strncmp (value, "YES", 3) == 0) ||
				 (strncmp (value, "NO", 2) == 0) )
				return (1);
			    else
			    {
				mainDialog->vuMainMessageCenter(vunames_ImportLogicalFieldChoice,
								linenum, pvname, udbchk[i], value); 
				return (0);
			    }
			}
		    }
		}
		if ( (value[0] == 'T') || (value[0] == 't') ||
		     (value[0] == 'F') || (value[0] == 'f') )
		{
		    found_choice = 1;
		    /* we only want caps */
		    if (value[0] == 't')
			value[0] = 'T';
		    if (value[0] == 'f')
			value[0] = 'F';
		    break;
		}
		else
		{
		    mainDialog->vuMainMessageCenter(vunames_ImportLogicalFieldChoiceTF,
						    linenum, pvname, fldname, value); 
		    return (0);
		}
	    }
	    if ( (pChoiceSet = GET_PCHOICE_SET (choiceGbl, pfldDes -> choice_set)) == 0)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportNoGblChoiceSet,
						linenum, pvname, fldname,
						pfldDes -> choice_set); 
		return (0);
	    }
	    for (i = 0; i < pChoiceSet -> number; i++)
	    {
		if (!(pChoice = GET_CHOICE (pChoiceSet, i)))
		    continue;
		if (strcmp (value, pChoice) == 0)
		{
		     found_choice = 1;
		     break;
		}
	    }
	    break;

	case DBF_CVTCHOICE:
	    if (choiceCvt == 0)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportNoConvTables,
						linenum, pvname, fldname); 
		return (0);
	    }
	    for (i = 0; i < choiceCvt -> number; i++)
	    {
		if (!(pChoice = GET_CHOICE (choiceCvt, i)))
		    continue;
		if (strcmp (value, pChoice) == 0)
		{
		    found_choice = 1;
		    break;
		}
	    }
	    break;

	case DBF_RECCHOICE:
	    /* if the dbase field is a logical, can't look it up in choice list */
	    if (pdbField -> field_type == 'L')
	    {
		if ( (value[0] == 'T') || (value[0] == 't') ||
		     (value[0] == 'F') || (value[0] == 'f') )
		{
		    found_choice = 1;
		    /* we only want caps */
		    if (value[0] == 't')
			value[0] = 'T';
		    if (value[0] == 'f')
			value[0] = 'F';
		    break;
		}
		else
		{
		    mainDialog->vuMainMessageCenter(vunames_ImportLogicalFieldChoiceTF,
						    linenum, pvname, fldname, value); 
		    return (0);
		}
	    }
	    if ( (parrChoiceSet = GET_PARR_CHOICE_SET (choiceRec, pt_type)) == 0)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportNoChoiceSets,
						linenum, pvname, fldname,
						dbRecType -> papName[pt_type]); 
		return (0);
	    }
	    if ( (pChoiceSet = GET_PCHOICE_SET (parrChoiceSet, pfldDes -> choice_set)) == 0)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportNoChoiceSets,
						linenum, pvname, fldname,
						dbRecType -> papName[pt_type]); 
		return (0);
	    }
	    for (i = 0; i < pChoiceSet -> number; i++)
	    {
		if(!(pChoice = GET_CHOICE (pChoiceSet, i)))
		    continue;
		if (strcmp (value, pChoice) == 0)
		{
		    found_choice = 1;
		    break;
		}
	    }
	    break;

	case DBF_DEVCHOICE:
	    /* REFERENCE is a special case, it is not in the SDR but does
	       appear in the BOARD type choice list
	    */
	    if (strcmp (value, "REFERENCE") == 0)
	    {
		found_choice = 1;
		break;
	    }
	    if ( (pdevChoiceSet = GET_PDEV_CHOICE_SET (choiceDev, pt_type)) == 0)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportNoDevChoices,
						linenum, pvname, fldname, 
						dbRecType -> papName[pt_type]); 
		return (0);
	    }
	    for (i = 0; i < pdevChoiceSet -> number; i++)
	    {
		if (!(pChoice = GET_DEV_CHOICE (pdevChoiceSet, i) -> pchoice))
		    continue;
		if (strcmp (value, pChoice) == 0)
		{
		    found_choice = 1;
		    break;
		}
	    }
	    break;
    }

    if (!found_choice)
    {
	mainDialog->vuMainMessageCenter(vunames_ImportNoChoice,
					linenum, pvname, fldname, value); 
	return (0);
    }

    return (1);
}
int vuImportClass::valid_field(char *fldname, char *value)
{
    xrefNodeClass	*xrefNode;
    DB_FIELD_PTR	pxrefField;	/* ptr to dbase field stuff */
    int			found_fld = 0;
    vname		*nameKey;
    char		key[VU_KEY_SIZE];

    sprintf(key,"%-*.*s\0",FLDNAME_SZ,FLDNAME_SZ,fldname);
    nameKey = (vname *)vnameGetGlobalScribed(vcharScribeSystem(key));
    xrefNode = (xrefNodeClass *)(dict->GetElem(nameKey));

    if (xrefNode == 0)
    {
	mainDialog->vuMainMessageCenter(vunames_ImportNoFieldForType,
					linenum, pvname, fldname,
					dbRecType -> papName[pt_type]);
	return (0);
    }
    pxrefField = xrefNode -> xrefField;
    found_fld = 1;
    switch (xrefNode -> xrefEPICSFieldType)
    {
	case DBF_STRING:
	    if ((strlen(value)) > (unsigned )pxrefField -> field_size)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportStringFieldSizeErr,
						linenum, pvname, fldname, value, 
						pxrefField->field_size);
		return (0);
	    }
	    strncpy (xrefNode -> xrefImportString, value, pxrefField -> field_size);
	    xrefNode -> xrefImportValid = 1;
	    /* a resource name must be imported */
	    if (!strncmp (fldname, "RESN", FLDNAME_SZ))
		found_resn = 1;
	    break;
	case DBF_CHAR:
	case DBF_UCHAR:
	    xrefNode -> xrefImportString[0] = value[0];
	    xrefNode -> xrefImportString[1] = 0;
	    xrefNode -> xrefImportValid = 1;
	    break;
	case DBF_SHORT:
	case DBF_LONG:
	    if ((strlen(value)) > (unsigned )pxrefField -> field_size)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportIntFieldSizeErr,
						linenum, pvname, fldname, value,
						pxrefField -> field_size);
		return (0);
	    }
	    if (are_numbers (fldname, value, VU_SIGNED_NUM))
	    {
		strncpy (xrefNode -> xrefImportString, value, pxrefField -> field_size);
	    	xrefNode -> xrefImportValid = 1;
	    }
	    else
	    {
		return (0);
	    }
	    break;
	case DBF_USHORT:
	case DBF_ENUM:
	case DBF_ULONG:
	    if ((strlen(value)) > (unsigned )pxrefField -> field_size)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportShortFieldSizeErr,
						linenum, pvname, fldname, value, 
						pxrefField -> field_size);
		return (0);
	    }
	    if (are_numbers (fldname, value, VU_UNSIGNED_NO_DEC))
	    {
		strncpy (xrefNode -> xrefImportString, value, pxrefField -> field_size);
	    	xrefNode -> xrefImportValid = 1;
	    }
	    else
	    {
		return (0);
	    }
	    break;

	case DBF_FLOAT:
	case DBF_DOUBLE:
	    if ((strlen(value)) > (unsigned )pxrefField -> field_size)
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportFloatFieldSizeErr,
						linenum, pvname, fldname, value, 
						pxrefField -> field_size);
		return (0);
	    }
	    if (are_numbers (fldname, value, VU_SIGNED_NUM | VU_DECIMAL))
	    {
		strncpy (xrefNode -> xrefImportString, value, pxrefField -> field_size);
	    	xrefNode -> xrefImportValid = 1;
	    }
	    else
	    {
		return (0);
	    }
	    break;

	case DBF_GBLCHOICE:
	case DBF_CVTCHOICE:
	case DBF_RECCHOICE:
	case DBF_DEVCHOICE:
	    if (valid_choice (fldname, value, xrefNode))
	    {
		strncpy (xrefNode -> xrefImportString, value, pxrefField -> field_size);
	    	xrefNode -> xrefImportValid = 1;
		if (xrefNode -> xrefEPICSFieldType == DBF_DEVCHOICE)
		{
		    /* why, because the PAT and PTO and 2 outputs for this 1
		       DTYP
		    */
		    if ( ( (pt_type == VU_PAT) || (pt_type == VU_PTO) ) && 
			 (!strncmp (fldname, "DTYP", FLDNAME_SZ)) )
			saw_DTYP += 2;
		    else
			saw_DTYP++;
		}
	    }
	    else
	    {
		return (0);
	    }
	    break;

	case DBF_INLINK:
	case DBF_OUTLINK:
	case DBF_FWDLINK:
	    if ( (strlen (value)) > (PVNAME_SZ -1) )
	    {
		mainDialog->vuMainMessageCenter(vunames_ImportLinkFieldSizeErr,
						linenum, pvname, fldname, value, 
						PVNAME_SZ - 1);
		return (0);
	    }
	    if ( ((xrefNode -> xrefEPICSFieldType == DBF_INLINK) ||
		  (xrefNode -> xrefEPICSFieldType == DBF_OUTLINK)) &&
		 (xrefNode -> xrefHardware) )
	    {
		if (!saw_DTYP)
		{
		    mainDialog->vuMainMessageCenter(vunames_ImportNoDTYPField,
						    linenum, pvname, fldname, value);
		    return (0);
		}
		else
		    saw_DTYP--;
	    }
	    strncpy (xrefNode -> xrefImportString, value, PVNAME_SZ -1);
	    xrefNode -> xrefImportValid = 1;
	    break;

	default:
	    break;
    } // end of switch
    return (1);
}
void vuImportClass::warn_algp(char *algp_name)
{
    int			do_warning = 1;
    struct algp_names	*curr_algp, *prev_algp, *new_algp;
    char		*new_name;

    curr_algp = firstAlgp;
    while (curr_algp)
    {
	prev_algp = curr_algp;
	if (strcmp (algp_name, curr_algp -> algp_name) == 0)
	{
	    do_warning = 0;
    	break;
	}
	curr_algp = curr_algp -> next_group;
    }
    if (do_warning)
    {
	mainDialog->vuMainMessageCenter(vunames_ImportNoAlgpInList,pvname, algp_name);
	mainDialog->vuMainMessageCenter(vunames_ImportAlgpOnlyOnce, "\n");
	if ( (new_algp = (struct algp_names *)calloc (1, sizeof (struct algp_names))) == 0)
	{
	    mainDialog->vuMainMessageCenter(vunames_ImportWarnAlgpCallocFailed,pvname);
	    return;
	}
	new_algp -> next_group = (struct algp_names *)0;
	if((new_name = (char *)calloc (1, ALARMGRP_SZ + 1)) == 0)
	{
	    mainDialog->vuMainMessageCenter(vunames_ImportWarnAlgpCallocFailed,pvname);
	    return;
	}
	strncpy (new_name, algp_name, ALARMGRP_SZ);
	new_algp -> algp_name = new_name;
	if (firstAlgp == (struct algp_names *)0)
	    firstAlgp = new_algp;
	else
    	    prev_algp -> next_group = new_algp;
    }
    return;
}
void vuImportClass::warn_priv(char *priv_name)
{
    int			do_warning = 1;
    struct priv_grps	*curr_privgrp, *prev_privgrp, *new_privgrp;
    char		*new_name;

    curr_privgrp = firstPrivGrp;
    while (curr_privgrp)
    {
	prev_privgrp = curr_privgrp;
	if(strcmp(priv_name, curr_privgrp -> privgrp_name) == 0)
	{
	    do_warning = 0;
	    break;
	}
	curr_privgrp = curr_privgrp -> next_group;
    }
    if (do_warning)
    {
	mainDialog->vuMainMessageCenter(vunames_ImportNoGrpInList,pvname, priv_name);
	mainDialog->vuMainMessageCenter(vunames_ImportPrivOnlyOnce);
	if((new_privgrp = (struct priv_grps *)calloc (1, sizeof (struct priv_grps))) == 0)
	{
	    mainDialog->vuMainMessageCenter(vunames_ImportWarnPrivCallocFailed,pvname);
	    return;
	}
	new_privgrp -> next_group = (struct priv_grps *)0;
	if((new_name = (char *)calloc (1, PROTECTIONGRP_SZ + 1)) == 0)
	{
	    mainDialog->vuMainMessageCenter(vunames_ImportWarnPrivCallocFailed,pvname);
	    return;
	}
	strncpy (new_name, priv_name, ALARMGRP_SZ);
	new_privgrp -> privgrp_name = new_name;
	if(firstPrivGrp == (struct priv_grps *)0)
	    firstPrivGrp = new_privgrp;
	else
	    prev_privgrp -> next_group = new_privgrp;
    }
    return;
}
void vuImportClass::process_arreduc_record(void)
{
    DATA4	*arreduc;
    DATA4	*pvmap;
    TAG4	*pointmeth;
    FIELD4	*ptnamefld;
    FIELD4	*ratefld;
    FIELD4	*methodfld;
    FIELD4	*archivefld;
    FIELD4	*ontrend;
    char	ptname[PVNAME_SZ + 1];
    char	rate[6];
    char	method[4];
    char	archive[2];
    char	tagname[PVNAME_SZ + 3];
    char	*cPtr;
    int		d4stat;

    arreduc = dataBase->vuArReducTable -> table;
    pvmap = dataBase->vuPvmapTable -> table;
    pointmeth = d4tag (arreduc, "POINTMETH");
    d4tag_select (arreduc, pointmeth);
    ptnamefld  = d4field (arreduc, "POINTNAME");
    ratefld    = d4field (arreduc, "RATE");
    methodfld  = d4field (arreduc, "METHOD");
    archivefld = d4field (arreduc, "ARCHIVE");
    ontrend    = d4field (pvmap, "ONTREND");
    memset (ptname, 0, sizeof (ptname));
    memset (rate, 0, sizeof (rate));
    memset (method, 0, sizeof (method));
    memset (archive, 0, sizeof (archive));

    fscanf (fp, "%s\t%s\t%s\t%s\n", ptname, rate, method, archive);
    linenum++;
    sprintf (tagname, "%-*.*s%-3.3s", PVNAME_SZ, PVNAME_SZ, ptname, method);
    d4stat = d4seek (arreduc, tagname);
    /* record already exists */
    if (d4stat == 0)
    {
	mainDialog->vuMainMessageCenter(vunames_ImportAlreadyInArReduc,tagname);
	f4assign (ptnamefld, ptname);
	f4assign (ratefld, rate);
	f4assign (methodfld, method);
	f4assign_char (archivefld, (int)archive[0]);
	d4flush (arreduc);
    }
    else
    {
	d4append_start (arreduc, 0);
	d4blank (arreduc);
	f4assign (ptnamefld, ptname);
	f4assign (ratefld, rate);
	f4assign (methodfld, method);
	f4assign_char (archivefld, (int)archive[0]);
	d4append (arreduc);
	d4flush (arreduc);
    }
    /* turn on trending for this point */
    /* first lop off field name if it exists */
    if ( (cPtr = strchr (ptname, '.')) != NULL)
	*cPtr = 0;
    memset (tagname, ' ', sizeof (tagname));
    strncpy (tagname, ptname, PVNAME_SZ);
    tagname[strlen(tagname)] = ' ';
    d4stat = d4seek (pvmap, tagname);
    if (d4stat != 0)
    {
	mainDialog->vuMainMessageCenter(vunames_ImportArNotInPvmap,linenum, tagname);
    }
    else
    {
	f4assign_char (ontrend, 'T');
    }
}
void vuImportClass::vuGetScanType (DB_TABLE_PTR table, DB_RECORD_PTR rec, char *ptr)
{
    DB_FIELD_PTR	rateField;
    double		rate;

    rateField = DB_MapField (table, FLD_SCANRATE);
    if(!strcmp (ptr,"100 ms"))
    {
	rate = 0.1;					/* 100 ms */
	DB_PutFieldNF(rec,rateField,&rate);
	strcpy(ptr, "Periodic");
    }
    else if(!strcmp (ptr,"200 ms"))			/* 200 ms */
    {
	rate = 0.2;
	DB_PutFieldNF(rec,rateField,&rate);
    	strcpy(ptr,"Periodic");
    }
    else if(!strcmp (ptr,"500 ms"))			/* 500 ms */
    {
	rate = 0.5;
	DB_PutFieldNF(rec,rateField,&rate);
	strcpy(ptr,"Periodic");
    }
    else if(!strcmp (ptr,"1 second") || 
	    !strcmp(ptr,"2 second")  ||
	    !strcmp(ptr,"5 second")  ||
	    !strcmp(ptr,"10 second") ||
	    !strcmp(ptr,"15 second") ||
	    !strcmp(ptr,"30 second") ||
	    !strcmp(ptr,"60 second") )
    {
	sscanf (ptr, "%lf", &rate);
	DB_PutFieldNF (rec, rateField, &rate);
	strcpy(ptr, "Periodic");
    }
}
#ifndef WIN32
int searchCompare (void *key, void *elt)
#else
int searchCompare(const void *key,const void *elt)
#endif WIN32
{
    return strcmp ((char *)key, (char *)elt);
}
