#ifndef vuimportClassHXX
#define vuimportClassHXX 1

#ifdef	SOLARIS
#    include <sys/param.h>   // for MAXPATHLEN def
#endif	SOLARIS

/************************************************
*
*    define states for reading the import file
*
************************************************/

typedef enum
{
	STARTNEWPT,
	GETPTTYPE,
	GETNAMEFLD,
	GETFLDNAME,
	GETFLDVAL,
	STOREFIELD,
	GETPAUSEVALUE,
	GETDELPOINT,
	GETJOURNALSWITCH,
	GETARREDUCT
} IMPORT_STATE;

/***************************************
*
*   defines for the are_numbers() func
*
***************************************/

#define	VU_UNSIGNED_NO_DEC	0
#define	VU_SIGNED_NUM		1
#define	VU_DECIMAL		2
#define VU_IMPORT_LINE_SIZE 80

class vuImportClass
{
public:
	vuImportClass(vuMainDialogClass *md,vuDatabaseClass *db,vstr *path);
	~vuImportClass();
	// public access functions
	void vuImport(void);
	int GetImportInitError (void)
	    { return (importInitError); }
/****************************************************************
*
*    structures for alarm group names and privelage group names
*
****************************************************************/

	struct algp_names
	{
		struct algp_names	*next_group;
		char		*algp_name;
	};

	struct priv_grps
	{
		struct priv_grps	*next_group;
		char		*privgrp_name;
	};

private:
	vuDatabaseClass *dataBase;
	vuMainDialogClass *mainDialog;
	vdict *dict;
	FILE *fp;
	int importInitError;
#ifdef WIN32
	char inputfile[_MAX_PATH];
#else
	char inputfile[MAXPATHLEN];
#endif WIN32
	char line[VU_IMPORT_LINE_SIZE];
	int linenum;
	char pvname[PVNAME_SZ + 1];
	char *vuValuePtr;
	int found_resn;
	int first_call;
	int saw_DTYP;
	int saw_RLIN;		/* for pat block */
	int saw_INP;		/* for pat block */
	short pt_type;
	//
	// Support functions
	//
	int	are_numbers(char *,char *,int);
	void eat_comment(int);
	void eat_spaces(char *);
	void getString(char *,unsigned short);
	void goto_nextpt(void);
	void free_algps (void);
	void free_data (void);
	void free_privgrps (void);
	int	init_AlarmGroups ();
	void output_fields (DB_RECORD_PTR, int);
	void save_data (short);
	int valid_choice (char *, char *, xrefNodeClass *);
	int valid_field (char *, char *);
	void warn_algp (char *);
	void warn_priv (char *);
	void process_arreduc_record(void);
	void vuGetScanType (DB_TABLE_PTR table, DB_RECORD_PTR rec, char *ptr);
#ifndef WIN32
	//int searchCompare (void *key, void *elt);
#else
	//int searchCompare(const void *key,const void *elt);
#endif WIN32
	struct algp_names	*firstAlgp;
	struct priv_grps	*firstPrivGrp;
	DB_FIELD_PTR	Operidptr;
	char		OperName[OPERATOR_SZ+1];
	char		*AlarmGroupsPtr;
	char		seekBuff[PVNAME_SZ+1];
};
#endif
