#ifndef vuioceditdialogclassHXX
#define vuioceditdialogclassHXX

class vuIocOkButtonClass;
class vuIocDismissButtonClass;
class vuIocDelButtonClass;
class vuIocListClass;

// *** Ioc Editor DIALOG CLASS ***************************************************
//  GCT 2-Sep-1997

class  vuIocEditDialogClass : public vdialog
{
    vresource	ioceditResource;
    int		singleSelect;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuIocEditDialogClass);

    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuIocEditDialogClass, vdialog);

    // override to load dialog
    void LoadInit(vresource res);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override 
    void Destroy ();

    void vuIocEditOpen(vuMainDialogClass *mainDialog);	

private:

    vcontainer			*buttonContainer;
    vuIocOkButtonClass		*okButton;
    vuIocDismissButtonClass	*dismissButton;
    vuIocDelButtonClass		*delButton;
    vuMainDialogClass		*mainDialog;

public:

    DB_FIELD_PTR	pIoc,pOkSync,pIsHost;
    vuDatabaseClass	*db;
    vuIocListClass	*iocList;
    vcontrolToggle	*hostToggle;
    vcontrolToggle	*syncToggle;
    filteredTextitem	*iocName;

};


// *** IocEdit OK BUTTON CLASS ***************************************************

class vuIocOkButtonClass : public vbutton
{
    vuIocEditDialogClass	*ioceditDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuIocOkButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuIocOkButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle ioceditDialog
    void vuSetIocEditDialog (vuIocEditDialogClass *dialog) 
	{ ioceditDialog = dialog; }
};


// *** IocEdit DISMISS BUTTON CLASS **********************************************

class vuIocDismissButtonClass : public vbutton
{
    vuIocEditDialogClass	*ioceditDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuIocDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuIocDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle ioceditDialog
    void vuSetIocEditDialog (vuIocEditDialogClass *dialog) 
	{ ioceditDialog = dialog; }
};


// *** IocEdit DELETE BUTTON CLASS *************************************************

class vuIocDelButtonClass : public vbutton
{
    vuIocEditDialogClass	*ioceditDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuIocDelButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuIocDelButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // function to handle ioceditDialog
    void vuSetIocEditDialog (vuIocEditDialogClass *dialog) 
	{ ioceditDialog = dialog; }
};


//
//sub-class vlistView so we can monitor when a selection has changed
//

class vuIocListClass : public vlistview
{
    vuIocEditDialogClass	*ioceditDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuIocListClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuIocListClass, vlistview);

    // overide this so we can tell when a selection has changed
    void ObserveSelect(int state);

    void vuSetIocEditDialog(vuIocEditDialogClass *dialog) 
	{ioceditDialog = dialog;}
};

#endif vuioceditdialogclassHXX

