#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vmenuHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vmenubarHEADER
#include vtextitemHEADER
#include vstartupHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vstrHEADER
#include vnoticeHEADER
#include vlimitsHEADER
#include vlistviewHEADER
#include vliststrHEADER
#include vstdargHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER
#include vrulerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbRecType.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "OperPriv.h"
}

#include "tisgalaxy.h"
#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuUtils.hxx"
#include "vuDatabaseClass.hxx"
#include "vuExportClass.hxx"
#include "vuImportClass.hxx"
#include "vuiocdialogclass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vunetwork.hxx"

#include "vuAccDialogClass.hxx"
#include "vuAiDialogClass.hxx"
#include "vuAoDialogClass.hxx"
#include "vuBiDialogClass.hxx"
#include "vuBoDialogClass.hxx"
#include "vuCalcDialogClass.hxx"
#include "vuDatamoveDialogClass.hxx"
#include "vuDdcDialogClass.hxx"
#include "vuDeadtimeDialogClass.hxx"
#include "vuFanoutDialogClass.hxx"
#include "vuLdfwDialogClass.hxx"
#include "vuLeadLagDialogClass.hxx"
#include "vuMbbiDialogClass.hxx"
#include "vuMbboDialogClass.hxx"
#include "vuPatDialogClass.hxx"
#include "vuPidDialogClass.hxx"
#include "vuPipeDialogClass.hxx"
#include "vuPotDialogClass.hxx"
#include "vuPtoDialogClass.hxx"
#include "vuPumpDialogClass.hxx"
#include "vuRampDialogClass.hxx"
#include "vuSelDialogClass.hxx"
#include "vuSigDialogClass.hxx"
#include "vuStateDialogClass.hxx"
#include "vuStringinDialogClass.hxx"
#include "vuStringoutDialogClass.hxx"
#include "vuTankDialogClass.hxx"
#include "vuTdDialogClass.hxx"
#include "vuUdbDialogClass.hxx"
#include "vuValveDialogClass.hxx"
#include "vuWaveformDialogClass.hxx"

#include "vuApiCfgDialogClass.hxx"
#include "vuArchInfoDialogClass.hxx"
#include "vuArReducDialogClass.hxx"
#include "vuDpaDialogClass.hxx"
#include "vuIocEditDialogClass.hxx"
#include "vuLaunchCfgDialogClass.hxx"
#include "vuMkPtsDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuResEditDialogClass.hxx"
#include "vuScriptScheduleDialogClass.hxx"
#ifdef WIN32
#include <process.h>
#endif WIN32
static void observeNewPointMenuItem (vmenuItem *menuItem, vevent *event);


vkindTYPED_FULL_DEFINITION(vuMainDialogClass, vdialog, "vuMainDialogClass");

/*******************************************************************
*
*    vuMainDialogClass override for constructors init ()
*
*******************************************************************/

void vuMainDialogClass::LoadInit (vresource res)
{
    int		i, j;

    // clear the usedPointDialogs array
    for (i = 0; i < VU_NUMPOINTS; i++)
    {
	for (j = 0; j < VU_MAX_USED_POINTS; j++)
	{
	    usedPointDialogs[i][j] = NULL;
	}
    }

    // store the main dialog's resource
    mainDialogResource = res;

    // set to NULL
    vuNavigator = NULL;

    // set about ptr to NULL
    tisAbout = NULL;

    // init to false
    loadiniterror = VU_SUCCESS;

    // RequestSubLoad returns ptr to uninited dialog object
    // gets init'd when dialog gets init'd by LoadInit()
    vmenubar *menubar = vmenubar::RequestSubLoad (this,
					vunames_vuMainMenuBar);

    // handle the File menu
    vmenu *fileMenu = vmenu::RequestSubLoad (menubar,
					vunames_vuMainFileMenu);
    vmenuItem *createMenuItem = vmenuItem::RequestSubLoad (fileMenu,
				    	vunames_vuMainFileMenuCreate);
    vmenuItem *exportMenuItem = vmenuItem::RequestSubLoad (fileMenu,
					vunames_vuMainFileMenuExport);
    vmenuItem *importMenuItem = vmenuItem::RequestSubLoad (fileMenu,
					vunames_vuMainFileMenuImport);
    vmenuSubMenuItem *reportMenuItem = vmenuSubMenuItem::RequestSubLoad (fileMenu,
					vunames_vuMainFileMenuReport);
    vmenuItem *reportDestinationMenuItem = vmenuItem::RequestSubLoad (reportMenuItem,
					vunames_vuMainFileMenuRptDest);
    vmenuItem *reportSelectMenuItem = vmenuItem::RequestSubLoad (reportMenuItem,
					vunames_vuMainFileMenuRptSelect);
    vmenuSubMenuItem *printScreenMenuItem = vmenuSubMenuItem::RequestSubLoad (fileMenu,
					vunames_vuMainFileMenuPrint);
    vmenuItem *prtScreenCurrRecMenuItem = vmenuItem::RequestSubLoad (printScreenMenuItem,
					vunames_vuMainFileMenuPrtCurr);
    vmenuItem *prtScreenSelectMenuItem = vmenuItem::RequestSubLoad (printScreenMenuItem,
					vunames_vuMainFileMenuPrtSelect);
    vmenuItem *quitMenuItem = vmenuItem::RequestSubLoad (fileMenu,
					vunames_vuMainFileMenuQuit);
    
    // handle the Record Menu
    vmenu *recordMenu = vmenu::RequestSubLoad (menubar,
					vunames_vuMainRecordMenu);
    newPointSubMenu = vmenuSubMenuItem::RequestSubLoad (recordMenu,
					vunames_vuMainRecordMenuNew);
    vmenuItem *deleteMenuItem = vmenuItem::RequestSubLoad (recordMenu,
					vunames_vuMainRecordMenuDelete);
    vmenuItem *gotoMenuItem = vmenuItem::RequestSubLoad (recordMenu,
					vunames_vuMainRecordMenuGoTo);
    vmenuItem *displayMenuItem = vmenuItem::RequestSubLoad (recordMenu,
					vunames_vuMainRecordMenuDisplay);

    // handle the Edit menu
    vmenu *editMenu = vmenu::RequestSubLoad (menubar,
					vunames_vuMainEditMenu);
    vmenuItem *resListItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuResList);
    vmenuItem *iocListItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuIOCList);
    vmenuItem *scriptItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuScript);
    vmenuItem *launchItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuLaunch);
    vmenuItem *trendArchItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuTrendArch);
    vmenuItem *alarmArchItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuAlarmArch);
    vmenuItem *opArchItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuOpArch);
    vmenuSubMenuItem *trendReducItem = vmenuSubMenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuTrendReduc);
    vmenuItem *trendReducSelectItem = vmenuItem::RequestSubLoad (trendReducItem,
					vunames_vuMainEditMenuTrReducSelect);
    vmenuItem *trendReducSpecificItem = vmenuItem::RequestSubLoad (trendReducItem,
					vunames_vuMainEditMenuTrReducSpec);
    vmenuItem *alarmGroupItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuAlarmGroup);
    vmenuItem *permissionsItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuPermissions);
    vmenuItem *strapTableItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuStrap);
    vmenuItem *apiTableItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuAPI);
    vmenuItem *dpaConfigItem = vmenuItem::RequestSubLoad (editMenu,
					vunames_vuMainEditMenuDPA);

    // handle the Tools menu
    vmenu *toolsMenu = vmenu::RequestSubLoad (menubar,
					vunames_vuMainToolsMenu);
    vmenuItem *markPointsItem = vmenuItem::RequestSubLoad (toolsMenu,
					vunames_vuMainToolsMenuMark);
    vmenuItem *addItem = vmenuItem::RequestSubLoad (toolsMenu,
					vunames_vuMainToolsMenuAdd);
    vmenuItem *deleteItem = vmenuItem::RequestSubLoad (toolsMenu,
					vunames_vuMainToolsMenuDelete);
    vmenuItem *resetItem = vmenuItem::RequestSubLoad (toolsMenu,
					vunames_vuMainToolsMenuReset);
    vmenuItem *dbItem = vmenuItem::RequestSubLoad (toolsMenu,
					vunames_vuMainToolsMenuDB);
    vmenuItem *pvItem = vmenuItem::RequestSubLoad (toolsMenu,
					vunames_vuMainToolsMenuPV);
    vmenuItem *linksItem = vmenuItem::RequestSubLoad (toolsMenu,
					vunames_vuMainToolsMenuLinks);

    // handle the Sync menu
    vmenu *syncMenu = vmenu::RequestSubLoad (menubar,
					vunames_vuMainSyncMenu);
    vmenuItem *configItem = vmenuItem::RequestSubLoad (syncMenu,
					vunames_vuMainSyncMenuConfig);

    // handle the Help Menu
    helpMenu = vmenu::RequestSubLoad (menubar,
					vunames_vuMainHelpMenu);
    vmenuItem *helpItem = vmenuItem::RequestSubLoad (helpMenu,
					vunames_vuMainHelpMenuHelp);

    // load the Main dialogs vlistitem
    mainDialogList = vlistitem::RequestSubLoad (this,
					vunames_vuMainList);

    // init inherited data
    vdialog::LoadInit (res);

    // check on privileges
    int	allDisabled;
    // init privilege checking, see .../share/src/libtis/OperPrvtrk.c
    if ((InitOperPriv (NULL)) != PRIVOK)
    {
	vuMessageDialogCenter (NULL, VU_INIT_OPERPRIV_ERR);
	loadiniterror = VU_ERROR;
	return;
    }

    // do the Files menu
    if ((OperPriv (NULL, "*MMI_DATAVU_FILES_CREATENEW")) == 0)
    {
	createMenuItem -> Disable ();
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_FILES_EXPORT")) == 0)
    {
	exportMenuItem -> Disable ();
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_FILES_IMPORT")) == 0)
    {
	importMenuItem -> Disable ();
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_FILES_REPORT")) == 0)
    {
	reportMenuItem -> Disable ();
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_FILES_PRINTSCREEN")) == 0)
    {
	printScreenMenuItem -> Disable ();
    }
    // do the Record Menu
    allDisabled = 0;
    if ((OperPriv (NULL, "*MMI_DATAVU_RECORD_NEW")) == 0)
    {
	newPointSubMenu -> Disable ();
	// if we can not create a new point, then we can not
	// update or delete a point
	vuUpdatePointPriv = vFALSE;
	vuDeletePointPriv = vFALSE;
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_RECORD_DELETE")) == 0)
    {
	deleteMenuItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_RECORD_GOTO")) == 0)
    {
	gotoMenuItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_RECORD_DISPLAY")) == 0)
    {
	displayMenuItem -> Disable ();
	allDisabled++;
    }
    if (allDisabled == 4)
    {
	recordMenu -> Disable ();
    }
    // do the Edit menu
    allDisabled = 0;
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_RESLIST")) == 0)
    {
	resListItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_IOCLIST")) == 0)
    {
	iocListItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_SCRIPT")) == 0)
    {
	scriptItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_LAUNCH")) == 0)
    {
	launchItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_TRENDARCH")) == 0)
    {
	trendArchItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_ALARMARCH")) == 0)
    {
	alarmArchItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_OPERARCH")) == 0)
    {
	opArchItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_TRENDREDUC")) == 0)
    {
	trendReducItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_ALARMGROUP")) == 0)
    {
	alarmGroupItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_PERMISSIONS")) == 0)
    {
	permissionsItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_STRAPTBL")) == 0)
    {
	strapTableItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_APITBL")) == 0)
    {
	apiTableItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_EDIT_DPA")) == 0)
    {
	dpaConfigItem -> Disable ();
	allDisabled++;
    }
    if (allDisabled == 13)
    {
	editMenu -> Disable ();
    }
    // do the Tools menu
    allDisabled = 0;
    if ((OperPriv (NULL, "*MMI_DATAVU_TOOLS_MARKPTS")) == 0)
    {
	markPointsItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_TOOLS_ONLINEADD")) == 0)
    {
	addItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_TOOLS_ONLINEDELETE")) == 0)
    {
	deleteItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_TOOLS_RESETIOC")) == 0)
    {
	resetItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_TOOLS_DBSTRUCT")) == 0)
    {
	dbItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_TOOLS_PVCROSSREF")) == 0)
    {
	pvItem -> Disable ();
	allDisabled++;
    }
    if ((OperPriv (NULL, "*MMI_DATAVU_TOOLS_FOLLOWLINKS")) == 0)
    {
	linksItem -> Disable ();
	allDisabled++;
    }
    if (allDisabled == 7)
    {
	toolsMenu -> Disable ();
    }
    // close privilege checking, see .../share/src/libtis/OperPrvtrk.c
    CloseOperPriv ();

    // store internal names for the file main menu tags
    commandNames[CREATE_NEW_MENUITEM] = vunames_vuMainFileMenuCreate;
    commandNames[EXPORT_MENUITEM] = vunames_vuMainFileMenuExport;
    commandNames[IMPORT_MENUITEM] = vunames_vuMainFileMenuImport;
    commandNames[REPORT_DEST_MENUITEM] = vunames_vuMainFileMenuRptDest;
    commandNames[REPORT_SELECT_MENUITEM] = vunames_vuMainFileMenuRptSelect;
    commandNames[PRINT_SCREEN_CURRENT_MENUITEM] = vunames_vuMainFileMenuPrtCurr;
    commandNames[PRINT_SCREEN_SELECTED_MENUITEM] = vunames_vuMainFileMenuPrtSelect;
    commandNames[QUIT_MENUITEM] = vunames_vuMainFileMenuQuit;

    // store internal names for the record menu tags
    commandNames[NEW_MENUITEM] = vunames_vuMainRecordMenuNew;
    commandNames[DELETE_MENUITEM] = vunames_vuMainRecordMenuDelete;
    commandNames[GOTO_MENUITEM] = vunames_vuMainRecordMenuGoTo;
    commandNames[DISPLAY_MENUITEM] = vunames_vuMainRecordMenuDisplay;

    // store internal names for the edit menu tags
    commandNames[RESLIST_MENUITEM] = vunames_vuMainEditMenuResList;
    commandNames[IOCLIST_MENUITEM] = vunames_vuMainEditMenuIOCList;
    commandNames[SCRIPT_MENUITEM] = vunames_vuMainEditMenuScript;
    commandNames[LAUNCH_MENUITEM] = vunames_vuMainEditMenuLaunch;
    commandNames[TREND_ARCH_MENUITEM] = vunames_vuMainEditMenuTrendArch;
    commandNames[ALARM_ARCH_MENUITEM] = vunames_vuMainEditMenuAlarmArch;
    commandNames[OP_TRACK_ARCH_MENUITEM] = vunames_vuMainEditMenuOpArch;
    commandNames[TREND_REDUC_SELECTED_MENUITEM] = 
						vunames_vuMainEditMenuTrReducSelect;
    commandNames[TREND_REDUC_SPECIFIC_MENUITEM] = vunames_vuMainEditMenuTrReducSpec;
    commandNames[ALARM_GROUP_MENUITEM] = vunames_vuMainEditMenuAlarmGroup;
    commandNames[PERMISSIONS_MENUITEM] = vunames_vuMainEditMenuPermissions;
    commandNames[STRAP_MENUITEM] = vunames_vuMainEditMenuStrap;
    commandNames[API_MENUITEM] = vunames_vuMainEditMenuAPI;
    commandNames[DPA_MENUITEM] = vunames_vuMainEditMenuDPA;

    // store internal names for the tools menu tags
    commandNames[MARK_POINTS_MENUITEM] = vunames_vuMainToolsMenuMark;
    commandNames[ONLINE_ADD_MENUITEM] = vunames_vuMainToolsMenuAdd;
    commandNames[ONLINE_DELETE_MENUITEM] = vunames_vuMainToolsMenuDelete;
    commandNames[RESET_IOC_MENUITEM] = vunames_vuMainToolsMenuReset;
    commandNames[DB_STRUCT_MENUITEM] = vunames_vuMainToolsMenuDB;
    commandNames[PV_CROSS_REF_MENUITEM] = vunames_vuMainToolsMenuPV;
    commandNames[FOLLOW_LINKS_MENUITEM] = vunames_vuMainToolsMenuLinks;

    // store internal names for the Sync menu tags
    commandNames[SYNC_CONFIG_MENUITEM] = vunames_vuMainSyncMenuConfig;

    // store internal names for the Help menu tags
    commandNames[HELP_MENUITEM] = vunames_vuMainHelpMenuHelp;

    // create a command space
    vcommandSpace *space = new vcommandSpace;

    // create a dictionary with a default hash size and hash function
    vdict *dict = new vdict (vnameHash);

    // populate our dictionary with menu commands
    for (i = CREATE_NEW_MENUITEM; i < MENUITEM_COUNT; i++)
    {
	// get an instance of our subclassed selector command
	vuMainCommand *command = new vuMainCommand;
	// set the commands selector value
	command -> SetSelector(i);
	// store command in the dictionary using the 
	// intern'd tag name
	dict -> SetElem (commandNames[i], command);
    }
    // add dictionary to the command space and give the command
    // space ownership of the dictionary, vname_Command defines
    // the type attribute of the things in the dictionary
    space -> AddDictOwned (vname_Command, dict);

    SetSpaceOwned (space);

    Place (GetRoot (), vrectPLACE_LEFT, vrectPLACE_TOP);
}


/*******************************************************************
*
*    vuMainDialogClass Destroy function
*	first destroy other dialogs if they have been used
*
*******************************************************************/

void vuMainDialogClass::Destroy (void)
{
    int i, j;

    for (i = 0; i < VU_NUMPOINTS; i++)
    {
	for (j = 0; j < VU_MAX_USED_POINTS; j++)
	{
	    if (usedPointDialogs[i][j] == NULL)
		continue;
	    if ( (usedPointDialogs[i][j] -> IsOpen ()) == vTRUE)
		usedPointDialogs[i][j] -> Close ();
	    switch (i)
	    {
		case VU_AI:
		    delete (vuAiDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_AO:
		    delete (vuAoDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_BI:
		    delete (vuBiDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_BO:
		    delete (vuBoDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_CALC:
		    delete (vuCalcDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_FANOUT:
		    delete (vuFanoutDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_MBBI:
		    delete (vuMbbiDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_MBBO:
		    delete (vuMbboDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_PID:
		    delete (vuPidDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_SEL:
		    delete (vuSelDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_STATE:
		    delete (vuStateDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_STRINGIN:
		    delete (vuStringinDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_STRINGOUT:
		    delete (vuStringoutDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_WAVEFORM:
		    delete (vuWaveformDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_LEADLAG:
		    delete (vuLeadLagDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_RAMP:
		    delete (vuRampDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_PIPE:
		    delete (vuPipeDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_TANK:
		    delete (vuTankDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_VALVE:
		    delete (vuValveDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_PUMP:
		    delete (vuPumpDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_POT:
		    delete (vuPotDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_ACCUM:
		    delete (vuAccDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_PTO:
		    delete (vuPtoDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_DEADTIME:
		    delete (vuDeadtimeDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_DATAMOVE:
		    delete (vuDatamoveDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_TD:
		    delete (vuTdDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_SIGCHAR:
		    delete (vuSigDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_UDB:
		    delete (vuUdbDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_PAT:
		    delete (vuPatDialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_LDFW1:
		    delete (vuLdfw1DialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_LDFW2:
		    delete (vuLdfw2DialogClass *)usedPointDialogs[i][j];
		    break;

		case VU_DDC:
		    delete (vuDdcDialogClass *)usedPointDialogs[i][j];
		    break;
	    }
	}
    }

    if (tisAbout != NULL)
    {
	delete tisAbout;
    }
    if (vuNavigator != NULL)
    {
	delete vuNavigator;
    }
    if (IsOpen ())
    {
	Close ();
    }
    vdialog::Destroy ();
}


/*******************************************************************
*
*    vuMainDialogClass notify function
*
*******************************************************************/

void vuMainDialogClass::ObserveWindow (vevent *event)
{
    if ( event -> GetType () == veventWINDOW_STATE && event -> IsClose () )
    {
	vevent::StopProcessing ();
    }
}


/*******************************************************************
*
*    vuMainDialogClass Open function
*
*******************************************************************/

void vuMainDialogClass::Open (void)
{
    buildNewPointMenu ();
    BuildAboutMenu ();
    vdialog::Open ();
}


/*******************************************************************
*
*    vuMainDialogClass newPoint function
*	look for a closed point in the array and return it, else
*	allocate a new one
*	see usedPointsDialogs[][] in class def
*	we are passed a ptr to an array of dialogs for a specific
*	point type
*
*******************************************************************/

void *vuMainDialogClass::newPoint (vdialog **usedPoints, 
				   vresource commonResource,
				   int pointType)
{
    int				i;
    int				foundUsed = 0;
    void			*dialog;
    vdialog			*usedDialog;
    vuCommonResourceClass	*resName;
    vuCommonDialogClass		*commonDialog;

    for (i = 0; i < VU_MAX_USED_POINTS; i++)
    {
	// no closed dialogs but room left for a new one
	if (usedPoints[i] == NULL)
	    break;

	// found a closed one, use it
	if ( (usedPoints[i] -> IsOpen ()) == vFALSE)
	{
	    usedDialog = usedPoints[i];
	    foundUsed = 1;
	    break;
	}
    }
    // no closed and out of space, to many dialogs of this point type open
    // output info msg telling user to many dialogs of pointType
    if (i == VU_MAX_USED_POINTS)
    {
	vuMessageDialogCenter (this, VU_TOMANYSCREENS, pointType);
	return (NULL);
    }
    // build resource list menu always, in case database was updated
    switch (pointType)
    {
	case VU_AI:
	{
	    vuAiDialogClass	*aiDialog;
	    if (foundUsed)
	    {
		aiDialog = (vuAiDialogClass *)usedDialog;
	    }
	    else
	    {
		aiDialog = new vuAiDialogClass (commonResource);
		aiDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)aiDialog;
	    }
	    dialog = (void *)aiDialog;
	    break;
	}

	case VU_AO:
	{
	    vuAoDialogClass	*aoDialog;
	    if (foundUsed)
	    {
		aoDialog = (vuAoDialogClass *)usedDialog;
	    }
	    else
	    {
		aoDialog = new vuAoDialogClass (commonResource);
		aoDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)aoDialog;
	    }
	    dialog = (void *)aoDialog;
	    break;
	}

	case VU_BI:
	{
	    vuBiDialogClass	*biDialog;
	    if (foundUsed)
	    {
		biDialog = (vuBiDialogClass *)usedDialog;
	    }
	    else
	    {
		biDialog = new vuBiDialogClass (commonResource);
		biDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)biDialog;
	    }
	    dialog = (void *)biDialog;
	    break;
	}

	case VU_BO:
	{
	    vuBoDialogClass	*boDialog;
	    if (foundUsed)
	    {
		boDialog = (vuBoDialogClass *)usedDialog;
	    }
	    else
	    {
		boDialog = new vuBoDialogClass (commonResource);
		boDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)boDialog;
	    }
	    dialog = (void *)boDialog;
	    break;
	}

	case VU_CALC:
	{
	    vuCalcDialogClass	*calcDialog;
	    if (foundUsed)
	    {
		calcDialog = (vuCalcDialogClass *)usedDialog;
	    }
	    else
	    {
		calcDialog = new vuCalcDialogClass (commonResource);
		calcDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)calcDialog;
	    }
	    dialog = (void *)calcDialog;
	    break;
	}

	case VU_FANOUT:
	{
	    vuFanoutDialogClass	*fanoutDialog;
	    if (foundUsed)
	    {
		fanoutDialog = (vuFanoutDialogClass *)usedDialog;
	    }
	    else
	    {
		fanoutDialog = new vuFanoutDialogClass (commonResource);
		fanoutDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)fanoutDialog;
	    }
	    dialog = (void *)fanoutDialog;
	    break;
	}

	case VU_MBBI:
	{
	    vuMbbiDialogClass	*mbbiDialog;
	    if (foundUsed)
	    {
		mbbiDialog = (vuMbbiDialogClass *)usedDialog;
	    }
	    else
	    {
		mbbiDialog = new vuMbbiDialogClass (commonResource);
		mbbiDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)mbbiDialog;
	    }
	    dialog = (void *)mbbiDialog;
	    break;
	}

	case VU_MBBO:
	{
	    vuMbboDialogClass	*mbboDialog;
	    if (foundUsed)
	    {
		mbboDialog = (vuMbboDialogClass *)usedDialog;
	    }
	    else
	    {
		mbboDialog = new vuMbboDialogClass (commonResource);
		mbboDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)mbboDialog;
	    }
	    dialog = (void *)mbboDialog;
	    break;
	}

	case VU_PID:
	{
	    vuPidDialogClass	*pidDialog;
	    if (foundUsed)
	    {
		pidDialog = (vuPidDialogClass *)usedDialog;
	    }
	    else
	    {
		pidDialog = new vuPidDialogClass (commonResource);
		pidDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)pidDialog;
	    }
	    dialog = (void *)pidDialog;
	    break;
	}

	case VU_SEL:
	{
	    vuSelDialogClass	*selDialog;
	    if (foundUsed)
	    {
		selDialog = (vuSelDialogClass *)usedDialog;
	    }
	    else
	    {
		selDialog = new vuSelDialogClass (commonResource);
		selDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)selDialog;
	    }
	    dialog = (void *)selDialog;
	    break;
	}

	case VU_STATE:
	{
	    vuStateDialogClass	*stateDialog;
	    if (foundUsed)
	    {
		stateDialog = (vuStateDialogClass *)usedDialog;
	    }
	    else
	    {
		stateDialog = new vuStateDialogClass (commonResource);
		stateDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)stateDialog;
	    }
	    dialog = (void *)stateDialog;
	    break;
	}

	case VU_STRINGIN:
	{
	    vuStringinDialogClass	*stringinDialog;
	    if (foundUsed)
	    {
		stringinDialog = (vuStringinDialogClass *)usedDialog;
	    }
	    else
	    {
		stringinDialog = new vuStringinDialogClass (commonResource);
		stringinDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)stringinDialog;
	    }
	    dialog = (void *)stringinDialog;
	    break;
	}

	case VU_STRINGOUT:
	{
	    vuStringoutDialogClass	*stringoutDialog;
	    if (foundUsed)
	    {
		stringoutDialog = (vuStringoutDialogClass *)usedDialog;
	    }
	    else
	    {
		stringoutDialog = new vuStringoutDialogClass (commonResource);
		stringoutDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)stringoutDialog;
	    }
	    dialog = (void *)stringoutDialog;
	    break;
	}

	case VU_WAVEFORM:
	{
	    vuWaveformDialogClass	*waveformDialog;
	    if (foundUsed)
	    {
		waveformDialog = (vuWaveformDialogClass *)usedDialog;
	    }
	    else
	    {
		waveformDialog = new vuWaveformDialogClass (commonResource);
		waveformDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)waveformDialog;
	    }
	    dialog = (void *)waveformDialog;
	    break;
	}

	case VU_LEADLAG:
	{
	    vuLeadLagDialogClass	*leadlagDialog;
	    if (foundUsed)
	    {
		leadlagDialog = (vuLeadLagDialogClass *)usedDialog;
	    }
	    else
	    {
		leadlagDialog = new vuLeadLagDialogClass (commonResource);
		leadlagDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)leadlagDialog;
	    }
	    dialog = (void *)leadlagDialog;
	    break;
	}

	case VU_RAMP:
	{
	    vuRampDialogClass	*rampDialog;
	    if (foundUsed)
	    {
		rampDialog = (vuRampDialogClass *)usedDialog;
	    }
	    else
	    {
		rampDialog = new vuRampDialogClass (commonResource);
		rampDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)rampDialog;
	    }
	    dialog = (void *)rampDialog;
	    break;
	}

	case VU_PIPE:
	{
	    vuPipeDialogClass	*pipeDialog;
	    if (foundUsed)
	    {
		pipeDialog = (vuPipeDialogClass *)usedDialog;
	    }
	    else
	    {
		pipeDialog = new vuPipeDialogClass (commonResource);
		pipeDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)pipeDialog;
	    }
	    dialog = (void *)pipeDialog;
	    break;
	}

	case VU_TANK:
	{
	    vuTankDialogClass	*tankDialog;
	    if (foundUsed)
	    {
		tankDialog = (vuTankDialogClass *)usedDialog;
	    }
	    else
	    {
		tankDialog = new vuTankDialogClass (commonResource);
		tankDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)tankDialog;
	    }
	    dialog = (void *)tankDialog;
	    break;
	}

	case VU_VALVE:
	{
	    vuValveDialogClass	*valveDialog;
	    if (foundUsed)
	    {
		valveDialog = (vuValveDialogClass *)usedDialog;
	    }
	    else
	    {
		valveDialog = new vuValveDialogClass (commonResource);
		valveDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)valveDialog;
	    }
	    dialog = (void *)valveDialog;
	    break;
	}

	case VU_PUMP:
	{
	    vuPumpDialogClass	*pumpDialog;
	    if (foundUsed)
	    {
		pumpDialog = (vuPumpDialogClass *)usedDialog;
	    }
	    else
	    {
		pumpDialog = new vuPumpDialogClass (commonResource);
		pumpDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)pumpDialog;
	    }
	    dialog = (void *)pumpDialog;
	    break;
	}

	case VU_POT:
	{
	    vuPotDialogClass	*potDialog;
	    if (foundUsed)
	    {
		potDialog = (vuPotDialogClass *)usedDialog;
	    }
	    else
	    {
		potDialog = new vuPotDialogClass (commonResource);
		potDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)potDialog;
	    }
	    dialog = (void *)potDialog;
	    break;
	}

	case VU_ACCUM:
	{
	    vuAccDialogClass	*accDialog;
	    if (foundUsed)
	    {
		accDialog = (vuAccDialogClass *)usedDialog;
	    }
	    else
	    {
		accDialog = new vuAccDialogClass (commonResource);
		accDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)accDialog;
	    }
	    dialog = (void *)accDialog;
	    break;
	}

	case VU_PTO:
	{
	    vuPtoDialogClass	*ptoDialog;
	    if (foundUsed)
	    {
		ptoDialog = (vuPtoDialogClass *)usedDialog;
	    }
	    else
	    {
		ptoDialog = new vuPtoDialogClass (commonResource);
		ptoDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)ptoDialog;
	    }
	    dialog = (void *)ptoDialog;
	    break;
	}

	case VU_DEADTIME:
	{
	    vuDeadtimeDialogClass	*deadtimeDialog;
	    if (foundUsed)
	    {
		deadtimeDialog = (vuDeadtimeDialogClass *)usedDialog;
	    }
	    else
	    {
		deadtimeDialog = new vuDeadtimeDialogClass (commonResource);
		deadtimeDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)deadtimeDialog;
	    }
	    dialog = (void *)deadtimeDialog;
	    break;
	}

	case VU_DATAMOVE:
	{
	    vuDatamoveDialogClass	*datamoveDialog;
	    if (foundUsed)
	    {
		datamoveDialog = (vuDatamoveDialogClass *)usedDialog;
	    }
	    else
	    {
		datamoveDialog = new vuDatamoveDialogClass (commonResource);
		datamoveDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)datamoveDialog;
	    }
	    dialog = (void *)datamoveDialog;
	    break;
	}

	case VU_TD:
	{
	    vuTdDialogClass	*tdDialog;
	    if (foundUsed)
	    {
		tdDialog = (vuTdDialogClass *)usedDialog;
	    }
	    else
	    {
		tdDialog = new vuTdDialogClass (commonResource);
		tdDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)tdDialog;
	    }
	    dialog = (void *)tdDialog;
	    break;
	}

	case VU_SIGCHAR:
	{
	    vuSigDialogClass	*sigDialog;
	    if (foundUsed)
	    {
		sigDialog = (vuSigDialogClass *)usedDialog;
	    }
	    else
	    {
		sigDialog = new vuSigDialogClass (commonResource);
		sigDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)sigDialog;
	    }
	    dialog = (void *)sigDialog;
	    break;
	}

	case VU_UDB:
	{
	    vuUdbDialogClass	*udbDialog;
	    if (foundUsed)
	    {
		udbDialog = (vuUdbDialogClass *)usedDialog;
	    }
	    else
	    {
		udbDialog = new vuUdbDialogClass (commonResource);
		udbDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)udbDialog;
	    }
	    dialog = (void *)udbDialog;
	    break;
	}

	case VU_PAT:
	{
	    vuPatDialogClass	*patDialog;
	    if (foundUsed)
	    {
		patDialog = (vuPatDialogClass *)usedDialog;
	    }
	    else
	    {
		patDialog = new vuPatDialogClass (commonResource);
		patDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)patDialog;
	    }
	    dialog = (void *)patDialog;
	    break;
	}

	case VU_LDFW1:
	{
	    vuLdfw1DialogClass	*ldfw1Dialog;
	    if (foundUsed)
	    {
		ldfw1Dialog = (vuLdfw1DialogClass *)usedDialog;
	    }
	    else
	    {
		ldfw1Dialog = new vuLdfw1DialogClass (commonResource);
		ldfw1Dialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)ldfw1Dialog;
	    }
	    dialog = (void *)ldfw1Dialog;
	    break;
	}

	case VU_LDFW2:
	{
	    vuLdfw2DialogClass	*ldfw2Dialog;
	    if (foundUsed)
	    {
		ldfw2Dialog = (vuLdfw2DialogClass *)usedDialog;
	    }
	    else
	    {
		ldfw2Dialog = new vuLdfw2DialogClass (commonResource);
		ldfw2Dialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)ldfw2Dialog;
	    }
	    dialog = (void *)ldfw2Dialog;
	    break;
	}

	case VU_DDC:
	{
	    vuDdcDialogClass	*ddcDialog;
	    if (foundUsed)
	    {
		ddcDialog = (vuDdcDialogClass *)usedDialog;
	    }
	    else
	    {
		ddcDialog = new vuDdcDialogClass (commonResource);
		ddcDialog -> storeMainDialog (this);
		usedPoints[i] = (vdialog *)ddcDialog;
	    }
	    dialog = (void *)ddcDialog;
	    break;
	}

	default:
	    return (NULL);
    }
    // set all point dialogs to be followers of main, when iconize main
    // others will follow
    ((vdialog *)(dialog)) -> SetLeader (this);
    commonDialog = (vuCommonDialogClass *)dialog;
    commonDialog -> setDialogModify (vFALSE);
    resName = commonDialog -> getResName ();
    resName -> vuBuildResourceMenu ();

    return (dialog);
}


/*******************************************************************
*
*    vuMainDialogClass message function
*
*******************************************************************/

void vuMainDialogClass::vuMainMessageCenter(const vname *msgType, ...)
{
    vstr *format;
    va_list argptr;
    vscribe *msg;
    vscribe *outmsg;
    char *charmsg;

    va_start(argptr,msgType);
    format = vresourceGetString(dialogMessages,msgType);
    msg = vcharScribeFormatScribedVarargs(vstrScribe(format),argptr);
    va_end(argptr);
    vdate *date = new vdate;
    date->SetCurrent ();
    const vdateFormat *df = vdateFormat::GetNormal();			// create date format
    vdateFormat *newdf = new vdateFormat(*((vdateFormat *)df));	// clone it for RemoveComponent
    newdf->RemoveComponent(0);			// get rid of time zone text
    outmsg = vcharScribeFormatLiteral("%S: %S",date->ScribeFormatted(newdf),msg);

    if(vuOutput == VU_CONSOLE_MSG)
    {
	vstr *tmp = vstrCloneScribed(outmsg);
	charmsg = (char *)vcharExportAlloc(vcharScribeSystemExport((vchar *)tmp));
	vstrDestroy(tmp);
	fprintf(stderr,"%s\n",charmsg);
	vmemFree((void *)charmsg);
    }
    else
    {
	mainDialogList->AppendScribed(outmsg);
	mainDialogList->Scroll(1, 0);
    }
    delete date;
    delete newdf;
}


/*******************************************************************
*
*   vuMainDialogClass Build About menu function
*   NOTE: need to get the app and its resource this way because
*	main does not have a ptr to the app at this point
*
*******************************************************************/

void vuMainDialogClass::BuildAboutMenu (void)
{
    vresource appRes = dataVuApp -> getDataVuvresource ();
    vresource msgRes = vresourceGet (appRes, vunames_vuMessagesDictionary);
    vstr *verMsg = vresourceGetString (msgRes, vunames_VersionMsg);
    vresource titleRes = vresourceGet (appRes, vunames_vuDialogTitles);
    vstr *aboutTitle = vresourceGetString (titleRes, vunames_AboutTitle);
    vresource tisGalaxyRes = dataVuApp -> getTisGalaxyvresource ();
    tisAbout = new TisAbout (tisGalaxyRes, verMsg);
    vstrDestroy (verMsg);
    tisAbout -> SetAboutTitle (aboutTitle);
    vstrDestroy (aboutTitle);
    AboutMenuItem *aboutItem = tisAbout -> GetAboutMenuItem ();
    helpMenu -> AppendItem (aboutItem);
}


vkindTYPED_FULL_DEFINITION(vuNewPointMenuItem, vmenuItem, NULL);
/*******************************************************************
*
*    vuMainDialogClass build function to create the New point type
*    menu after the SDR is loaded
*	build the menu of point types and attach it to the 
*	newPointSubMenu which a part of the vuMainDialogClass
*
*******************************************************************/

void vuMainDialogClass::buildNewPointMenu (void)
{
    int		i;
    vmenu	*newMenu = new vmenu;
    char	**ptList = NULL;

    ptList = vuGetPointTypeList ();
    if (ptList != NULL)
    {
	i = 0;
	while (ptList[i])
	{
	    if (ptList[i] != NULL)
	    {
		vuNewPointMenuItem *menuItem = new vuNewPointMenuItem;
		menuItem -> SetTitleScribed (vcharScribeSystem (ptList[i]));
		menuItem -> SetObserveMenuItemProc (observeNewPointMenuItem);
		menuItem -> storeMainDialog (this);
		newMenu -> AppendItem (menuItem);
		vmemFree ((void *)ptList[i]);
	    }
	    i++;
	}
	newPointSubMenu -> SetSubMenu (newMenu);
	vmemFree ((void *)ptList);
    }
}


vkindTYPED_FULL_DEFINITION(vuMainCommand, vcommandSelector, NULL);
/*******************************************************************
*
*    vuMainCommand menu selector commands
*
*******************************************************************/

int vuMainCommand::Issue (vdict *dict)
{
    int			result;
    int			command;
    char cmd[80];

    vuMainDialogClass *mainDialog = (vuMainDialogClass *) dict -> GetElem (vname_Dialog);
    dataVuApplication *dataVuApp = mainDialog -> getApplication ();
    vuDatabaseClass *db = dataVuApp -> getDatabaseClass ();
    vresource vuRes = dataVuApp -> getDataVuvresource ();
    vresource commonResource = vresourceGet (vuRes, vunames_vuCommonDialog);
    vresource titlesRes = mainDialog -> getTitlesResource ();
    vresource msgRes = mainDialog -> getMessagesResource ();

    vfsPath *defaultPath = new vfsPath;
#ifndef WIN32
	defaultPath->Set((const vchar *)"/tis4000db");
#else
	defaultPath->Set((const vchar *)"c:\\tis4000db");
#endif WIN32
    command = GetSelector ();
    switch (command)
    {
	// File menu items

	case CREATE_NEW_MENUITEM:
	{
	    vstr *titleStr = vresourceGetString (titlesRes, vunames_vuCreateTitle);
	    vuFileChooser *fch = new vuFileChooser;
	    fch->SetOptions(vfilechsrOPTION_ONLY_DIRS);
	    fch->SetDirectory(defaultPath);
	    fch->fileChooserOpen(titleStr);
	    if(fch->getSelectedPath() != NULL)
	    {
		db->vuCreateNewDatabase(fch->getSelectedPath());
	    }
	    delete fch;
	    vstrDestroy(titleStr);
	    break;
	}
	case EXPORT_MENUITEM:
	{
	    vstr *titleStr = vresourceGetString (titlesRes,vunames_vuExportTitle);
	    vstr *buttonStr = vresourceGetString(titlesRes,vunames_vuExportButtonTitle);
	    vuFileChooser *fch = new vuFileChooser;
	    // only use native laf
	    fch->SetOverridePreferNative(vTRUE);	    
	    fch->SetDirectory(defaultPath);
	    // add pattern for *.txt extensions
	    vscribe *pattern = vcharScribeLiteral(".+\\.txt$");
	    vscribe *desc = vcharScribeLiteral("Export Text Files");
	    fch->AddFilterByPatternScribed(vnameInternGlobalLiteral("Text"),desc,pattern,vTRUE);
	    pattern = vcharScribeLiteral(".+");
	    desc = vcharScribeLiteral("All Files");
	    fch->AddFilterByPatternScribed(vnameInternGlobalLiteral("All"),desc,pattern,vFALSE);
	    unsigned int options = fch->GetOptions();
	    // turn off this option
	    options &= ~vfilechsrOPTION_FILE_MUST_EXIST;
	    fch -> SetOptions(options);
	    fch->fileChooserOpen(titleStr);
	    if(fch->getSelectedPath() != NULL)
	    {
		vresource tisRes = dataVuApp -> getTisGalaxyvresource ();
		vresource progRes = vresourceGet (tisRes, tisgalaxy_progressDialog);
		vuExportClass *xp = new vuExportClass(progRes);
		xp -> SetLeader (mainDialog);
		xp -> Place (mainDialog -> GetRoot (), vrectPLACE_CENTER, vrectPLACE_CENTER);
		vstr *progTitle = vresourceGetString (msgRes, vunames_ExportingMsg);
		xp -> SetProgressTitle (progTitle);
		vstrDestroy (progTitle);
		xp -> SetParameters (db, fch->getSelectedPath());

		mainDialog -> Block ();

		vuNavigatorDialogClass *navigator = mainDialog -> getNavigator ();
		if (navigator == NULL)
		{
		    vresource findRes = vresourceGet (vuRes, vunames_vuFindDialog);
		    navigator = new vuNavigatorDialogClass(findRes);
		    mainDialog -> storeNavigator(navigator);
		}
		navigator -> vuFindOpen (buttonStr, mainDialog, vFALSE);
		char **ptList = navigator -> getPvNameList();
		if(ptList != NULL)
		{
		    mainDialog -> vuMainMessageCenter(vunames_vuExportStartMsg);
		    xp -> SetList (ptList);
		    // here is where the work of exporting is done, in the
		    xp -> OpenProgress ();
		    mainDialog -> vuMainMessageCenter(vunames_vuExportStopMsg);
		}

		mainDialog -> Unblock ();

		delete xp;
	    }
	    delete fch;
	    vstrDestroy(titleStr);
	    vstrDestroy(buttonStr);
	    break;
	}

	case IMPORT_MENUITEM:
	{
	    vstr *titleStr = vresourceGetString (titlesRes, vunames_vuImportTitle);
	    vuFileChooser *fch = new vuFileChooser;
	    // only use native laf
	    fch->SetOverridePreferNative(vTRUE);
	    fch->SetOptions(vfilechsrOPTION_FILE_MUST_EXIST);
	    // add pattern for *.txt extensions
	    vscribe *pattern = vcharScribeLiteral(".+\\.txt$");
	    vscribe *desc = vcharScribeLiteral("Import Text Files");
	    fch->AddFilterByPatternScribed(vnameInternGlobalLiteral("Text"),desc,pattern,vTRUE);
	    pattern = vcharScribeLiteral(".+");
	    desc = vcharScribeLiteral("All Files");
	    fch->AddFilterByPatternScribed(vnameInternGlobalLiteral("All"),desc,pattern,vFALSE);
	    fch->SetDirectory(defaultPath);
	    fch->fileChooserOpen(titleStr);
	    if(fch->getSelectedPath() != NULL)
	    {
		vresource tisRes = dataVuApp -> getTisGalaxyvresource ();
		vresource waitRes = vresourceGet (tisRes, tisgalaxy_waitDialog);
		vstr *formatStr = vresourceGetString (msgRes, vunames_ImportWaitMsg);
		vstr *msgStr = vstrCloneScribed (vcharScribeFormat (formatStr,
								    fch->getSelectedPath()));
		mainDialog -> Block ();

		tisWaitDialog *waitDialog = new tisWaitDialog (waitRes);
		waitDialog -> SetMsgText (msgStr);
		waitDialog -> OpenWaitDialog ();
		vstrDestroy (formatStr);
		vstrDestroy (msgStr);

		vuImportClass *ip = new vuImportClass(mainDialog,db,fch->getSelectedPath());
		if ((ip -> GetImportInitError ()) == vFALSE)
		{
		    ip->vuImport();
		}

		delete waitDialog;
		delete ip;

		mainDialog -> Unblock ();
	    }
	    delete fch;
	    vstrDestroy(titleStr);
	    break;
	}

	case REPORT_DEST_MENUITEM:
	    break;

	case REPORT_SELECT_MENUITEM:
	    break;

	case PRINT_SCREEN_CURRENT_MENUITEM:
	    break;

	case PRINT_SCREEN_SELECTED_MENUITEM:
	    break;

	case QUIT_MENUITEM:
	    result = vuMessageDialogCenter (mainDialog, VU_QUIT_MSG);
	    if (result == VU_TRUE)
	    {
		vevent::StopProcessing ();
	    }
	    break;

	// Record menu items

	case NEW_MENUITEM:
	    break;

	case DELETE_MENUITEM:
	{
	    vuNavigatorDialogClass *navigator = mainDialog -> getNavigator ();
	    if (navigator == NULL)
	    {
		vresource findRes = vresourceGet (vuRes, vunames_vuFindDialog);
		navigator = new vuNavigatorDialogClass(findRes);
		mainDialog -> storeNavigator (navigator);
	    }
	    vstr *deleteStr = vresourceGetString (titlesRes, vunames_vuDeleteButtonTitle);
	    navigator -> vuFindOpen(deleteStr, mainDialog,vFALSE);
	    char **ptList = navigator -> getPvNameList ();
	    if (ptList != NULL)
	    {
		int deleteThem = vFALSE;
		int result;
		// if more than one to delete
		if (ptList[1] != NULL)
		{
		    result = vuMessageDialogCenter (NULL, VU_DELETE_SELECTED_REQ_MSG);
		}
		else
		{
		    result = vuMessageDialogCenter (NULL, VU_DELETE_REQ_MSG, ptList[0]);
		}
		if (result == VU_TRUE)
		{
		    deleteThem = vTRUE;
		}
		int i = 0;
		vstr *pvName;
		while (ptList[i])
		{
		    if (deleteThem)
		    {
			pvName = vstrCloneScribed (vcharScribeSystem (ptList[i]));
			result = vuDeletePoint (mainDialog, pvName);
			if (result == vTRUE)
			{
			    mainDialog -> vuMainMessageCenter (vunames_vuDeleteMsg, pvName);
			    navigator -> vuRemovePvName (pvName);
			}
			vstrDestroy (pvName);
		    }
		    vmemFree ((void *)ptList[i]);
		    i++;
		}
		vmemFree ((void *)ptList);
		navigator -> setPvNameList (NULL);
	    }
	    vstrDestroy (deleteStr);
	    break;
	}

	case GOTO_MENUITEM:
	{
	    vuGoTo (mainDialog);
	    break;
	}

	case DISPLAY_MENUITEM:
	{
	    vuNavigatorDialogClass *navigator = mainDialog -> getNavigator();
	    if (navigator == NULL)
	    {
		vresource findRes = vresourceGet(vuRes, vunames_vuFindDialog);
		navigator = new vuNavigatorDialogClass(findRes);
		mainDialog -> storeNavigator (navigator);
	    }
	    vstr *ok = vresourceGetString(titlesRes, vunames_vuDisplayButtonTitle);
	    navigator -> vuFindOpen(ok, mainDialog,vTRUE);
	    char **ptList = navigator -> getPvNameList();
	    if (ptList != NULL)
	    {
#ifndef WIN32
		sprintf(cmd,"csh -c \"/home/tis4000/tasks/launchtype %s &\"",*ptList);
		system(cmd);
#else
		static char savedir [200];

		_getcwd (savedir, 200);
		_chdir ("\\tis4000\\graphics");
		_spawnlp (_P_DETACH, "launchtype", "launchtype", *ptList, NULL);
		_chdir (savedir);
#endif WIN32
	    }
	    else
	    {
		vuMessageDialogCenter(NULL, VU_NO_PTNAMES_SELECTED_MSG);
	    }
	    vstrDestroy (ok);
	    break;
	}

	// Edit menu items

	case RESLIST_MENUITEM:
	{
	    vresource resEditRes = vresourceGet(vuRes, vunames_vuResEditDialog);
	    vuResEditDialogClass *resEditDialog = new vuResEditDialogClass(resEditRes);
	    resEditDialog -> vuResEditOpen(mainDialog);
	    delete resEditDialog;
	    break;
	}

	case IOCLIST_MENUITEM:
	{
	    vresource iocEditRes = vresourceGet(vuRes, vunames_vuIocEditDialog);
	    vuIocEditDialogClass *iocEditDialog = new vuIocEditDialogClass(iocEditRes);
	    iocEditDialog -> vuIocEditOpen(mainDialog);
	    delete iocEditDialog;
	    break;
	}

	case SCRIPT_MENUITEM:
	{
	    vresource scrSchRes = vresourceGet (vuRes, vunames_vuScriptScheduleDialog);
	    vuScrSchDialogClass *scrSchDialog = new vuScrSchDialogClass (scrSchRes);
	    scrSchDialog -> vuScrSchOpen (mainDialog);
	    delete scrSchDialog;
	    break;
	}

	case LAUNCH_MENUITEM:
	{
	    vresource launchCfgRes = vresourceGet (vuRes, vunames_vuLaunchCfgDialog);
	    vuLaunchCfgDialogClass *launchCfgDialog = new vuLaunchCfgDialogClass (launchCfgRes);
	    launchCfgDialog -> vuLaunchCfgOpen (mainDialog);
	    delete launchCfgDialog;
	    break;
	}

	case TREND_ARCH_MENUITEM:
	{
	    vresource archInfoRes = vresourceGet(vuRes, vunames_vuArchInfoDialog);
	    vuArchInfoDialogClass *archInfoDialog = new vuArchInfoDialogClass(archInfoRes);
	    archInfoDialog -> vuArchInfoOpen(VU_EDIT_ARCH_TREND_INFO, mainDialog);
	    delete archInfoDialog;
	    break;
	}

	case ALARM_ARCH_MENUITEM:
	{
	    vresource archInfoRes = vresourceGet(vuRes, vunames_vuArchInfoDialog);
	    vuArchInfoDialogClass *archInfoDialog = new vuArchInfoDialogClass(archInfoRes);
	    archInfoDialog -> vuArchInfoOpen(VU_EDIT_ARCH_ALARM_INFO, mainDialog);
	    delete archInfoDialog;
	    break;
	}

	case OP_TRACK_ARCH_MENUITEM:
	{
	    vresource archInfoRes = vresourceGet(vuRes, vunames_vuArchInfoDialog);
	    vuArchInfoDialogClass *archInfoDialog = new vuArchInfoDialogClass(archInfoRes);
	    archInfoDialog -> vuArchInfoOpen(VU_EDIT_ARCH_OPER_INFO, mainDialog);
	    delete archInfoDialog;
	    break;
	}

	case TREND_REDUC_SELECTED_MENUITEM:
	{
	    vuNavigatorDialogClass *navigator = mainDialog -> getNavigator ();
	    if (navigator == NULL)
	    {
		vresource findRes = vresourceGet (vuRes, vunames_vuFindDialog);
		navigator = new vuNavigatorDialogClass(findRes);
		mainDialog -> storeNavigator (navigator);
	    }
	    vstr *ok = vresourceGetString (titlesRes, vunames_vuOKButtonTitle);
	    navigator -> vuFindOpen(ok, mainDialog,vTRUE);
	    char **ptList = navigator -> getPvNameList ();
	    if (ptList != NULL)
	    {
		int	dbaseType;
		char	pointTypeName[POINTTYPE_SZ + 1];
		char	pvname[PVNAME_SZ + 1];

		// find the record in pvmap and get the point type
		sprintf (pvname, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, ptList[0]);
		DB_RECORD_PTR pntRecord = DB_Seek (db -> vuPvmapTable, pvname);
		DB_FIELD_PTR pType = DB_MapField(db -> vuPvmapTable, FLD_TYPE);
		DB_GetFieldValue (pntRecord, pType, (void *)pointTypeName, &dbaseType);

		// convert point type string to an index
		int pointType = vuGetPointTypeIndex (pointTypeName);

		vresource arReducRes = vresourceGet (vuRes, vunames_vuArReducDialog);
		vuArReducDialogClass *arReduc = new vuArReducDialogClass (arReducRes);

		arReduc -> vuArReducOpen (mainDialog, ptList[0], pointType);

		delete arReduc;
		vmemFree ((void *)ptList[0]);
		vmemFree ((void *)ptList);
		navigator -> setPvNameList (NULL);
	    }
	    else
	    {
		vuMessageDialogCenter (NULL, VU_NO_PTNAMES_SELECTED_MSG);
	    }
	    vstrDestroy (ok);
	    break;
	}

	case TREND_REDUC_SPECIFIC_MENUITEM:
	{
	    vresource trendEditRes = vresourceGet (vuRes, vunames_vuTrendEditDialog);
	    vuTrendEditDialogClass *trendEditDialog = new vuTrendEditDialogClass(trendEditRes);
	    trendEditDialog -> vuTrendEditOpen (mainDialog);
	    vchar *pvname = trendEditDialog -> getPvName ();
	    if (pvname[0] != 0)
	    {
		char pointTypeName[VU_KEY_SIZE];
		char pointName[PVNAME_SZ + 1];
		char pv[PVNAME_SZ + 1];
		int  dbaseType;

		vcharExportBounded (vcharScribeSystemExport (pvname),
				    pointName,
				    PVNAME_SZ);
		pointName[PVNAME_SZ] = 0;

		// find the record in pvmap and get the point type
		sprintf (pv, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pointName);
		DB_RECORD_PTR pntRecord = DB_Seek (db -> vuPvmapTable, pv);
		DB_FIELD_PTR pType = DB_MapField(db -> vuPvmapTable, FLD_TYPE);
		DB_GetFieldValue (pntRecord, pType, (void *)pointTypeName, &dbaseType);

		// convert point type string to an index
		int pointType = vuGetPointTypeIndex (pointTypeName);
		
		vresource arReducRes = vresourceGet (vuRes, vunames_vuArReducDialog);
		vuArReducDialogClass *arReduc = new vuArReducDialogClass (arReducRes);

		arReduc -> vuArReducOpen (mainDialog, pointName, pointType);

		delete arReduc;
	    }
	    delete trendEditDialog;
	    break;
	}

	case ALARM_GROUP_MENUITEM:
#ifndef WIN32
	    sprintf(cmd,"/tis4000/tasks/alarmConfig");
	    system(cmd);
#else
	    static char savedir [200];

	    _getcwd (savedir, 200);
	    _chdir ("\\tis4000\\tasks");
	    _spawnlp (_P_WAIT, "alarmConfig", "alarmConfig", NULL, NULL);
	    _chdir (savedir);
#endif WIN32
	    break;

	case PERMISSIONS_MENUITEM:
#ifndef WIN32
	    sprintf(cmd,"/tis4000/tasks/tisPermissions");
	    system(cmd);
#else
	    static char saveddir [200];

	    _getcwd (saveddir, 200);
	    _chdir ("\\tis4000\\tasks");
	    _spawnlp (_P_WAIT, "tisPermissions", "tisPermissions", NULL, NULL);
	    _chdir (saveddir);
#endif WIN32
	    break;

	case STRAP_MENUITEM:
	    break;

	case API_MENUITEM:
	{
	    /*
	    vresource apiRes = vresourceGet(vuRes, vunames_vuApiCfgDialog);
	    vuApiCfgDialogClass *apiDialog = new vuApiCfgDialogClass (apiRes);
	    apiDialog -> vuApiCfgOpen (mainDialog);
	    delete apiDialog;
	    */
	    break;
	}

	case DPA_MENUITEM:
	{
	    vresource dpaRes = vresourceGet(vuRes, vunames_vuDpaEditDialog);
	    vuDpaDialogClass *dpaDialog = new vuDpaDialogClass (dpaRes);
	    dpaDialog -> vuDpaOpen (mainDialog);
	    delete dpaDialog;
	    break;
	}

	case MARK_POINTS_MENUITEM:
	{
	    vresource findRes = vresourceGet (vuRes, vunames_vuFindDialog);
	    vuMkPtsDialogClass *mkptsDialog = new vuMkPtsDialogClass (findRes);
	    mkptsDialog -> vuFindOpen(NULL, mainDialog,vFALSE);
	    delete mkptsDialog;
	    break;
	}

	case ONLINE_ADD_MENUITEM:
	    {
		vstr *addStr = vresourceGetString (titlesRes, vunames_vuAddButtonTitle);
		vresource findRes = vresourceGet (vuRes, vunames_vuIocListDialog);
		vuIocDialogClass *addDialog = new vuIocDialogClass (findRes);
		addDialog -> vuIocOpen(mainDialog,addStr);
		if(strlen(addDialog->getIocName()) != 0)
		{
#ifdef USE_UDP
		    vuNetwork *vn = new vuNetwork(mainDialog,addDialog->getIocName());
		    if(vn->checkError() == vFALSE)
			vn->sendAdd(); // send reset message and wait for reply
		    delete vn; // all done then delete vn (close socket);
#else USE_UDP
		    // send reset message and wait for reply
		    dataVuApp->dbClientNotify->sendAdd (addDialog->getIocName());
#endif USE_UDP
		}
		delete addDialog;
		break;
	    }
	case ONLINE_DELETE_MENUITEM:
	    {
		char paddedName[PVNAME_SZ+1],*cp;
		char delResource[RESOURCE_SZ+1];
		char resIOC1[IOCNAME_SZ+1],resIOC2[IOCNAME_SZ+1];
		DB_RECORD_PTR	delRecord,resRecord;
		DB_FIELD_PTR	ioc1,ioc2,resField,pvmapResField;
		int dtype;
		VERIFY_INFO	local_info;

		vstr *deleteStr = vresourceGetString (titlesRes, vunames_vuDeleteButtonTitle);
		vuNavigatorDialogClass *navigator = mainDialog -> getNavigator ();
		if (navigator == NULL)
		{
		    vresource findRes = vresourceGet (vuRes, vunames_vuFindDialog);
		    navigator = new vuNavigatorDialogClass(findRes);
		    mainDialog -> storeNavigator(navigator);
		}
		navigator->vuFindOpen(deleteStr, mainDialog,vTRUE);
		vstrDestroy(deleteStr);
		char **ptList = navigator -> getPvNameList();
		if (ptList != NULL)
		{
		    if(vuMessageDialogCenter (NULL, VU_DELETE_REQ_MSG, ptList[0]) == VU_TRUE)
		    {
			if((cp = strchr(ptList[0],' ')) != NULL)
			{
	    		    *cp = 0;		/* remove trailing spaces...if any */
			}
			ioc1 = DB_MapField(db->vuResListTable,FLD_IOC1);
			ioc2 = DB_MapField(db->vuResListTable,FLD_IOC2);
			resField = DB_MapField(db->vuResListTable,FLD_RESOURCE);
			pvmapResField = DB_MapField(db->vuPvmapTable,FLD_RESOURCE);
			sprintf(paddedName,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,ptList[0]);
			// use this function to find record and ignore deletion 
			delRecord = (DB_RECORD_PTR)DB_GetVerifyInfo(db->vuPvmapTable,paddedName,&local_info,0); 
			DB_GetFieldValue(delRecord,pvmapResField,delResource,&dtype);
			if((resRecord = DB_Seek(db->vuResListTable,delResource)) != 0)
			{
			    DB_GetFieldValue(resRecord,ioc1,resIOC1,&dtype);
			    DB_GetFieldValue(resRecord,ioc2,resIOC2,&dtype);
#ifdef USE_UDP
			    vuNetwork *vn1 = new vuNetwork(mainDialog,resIOC1);
			    vuNetwork *vn2 = new vuNetwork(mainDialog,resIOC2);
			    if(vn1->checkError() == vFALSE)
				vn1->sendDelete(ptList[0]);
			    delete vn1;
			    if(vn2->checkError() == vFALSE)
				vn2->sendDelete(ptList[0]);
			    delete vn2;
#else USE_UDP
			    dataVuApp->dbClientNotify->sendDelete (resIOC1, ptList[0]);
			    dataVuApp->dbClientNotify->sendDelete (resIOC2, ptList[0]);
#endif USE_UDP
			}
		    }
		    //vstr *pvName = vstrCloneScribed (vcharScribeSystem (ptList[0])); 
		    //mainDialog -> vuMainMessageCenter(vunames_vuDeleteMsg, pvName);
		    //vstrDestroy(pvName);
		    vmemFree((void *)ptList[0]);
		    vmemFree((void *)ptList);
		    navigator -> setPvNameList (NULL);
		}
		break;
	    }
	case RESET_IOC_MENUITEM:
	    {
		vresource findRes = vresourceGet (vuRes, vunames_vuIocListDialog);
		vuIocDialogClass *resetDialog = new vuIocDialogClass (findRes);
		vstr *resetStr = vresourceGetString (titlesRes, vunames_vuResetButtonTitle);
		resetDialog -> vuIocOpen(mainDialog,resetStr);
		if(strlen(resetDialog->getIocName()) != 0)
		{
#ifdef USE_UDP
		    vuNetwork *vn = new vuNetwork(mainDialog,resetDialog->getIocName());
		    if(vn->checkError() == vFALSE)
			vn->sendReset(); // send reset message and wait for reply
		    delete vn;	// all done then delete vn (close socket);
#else USE_UDP
		    // send reset message and wait for reply
		    dataVuApp->dbClientNotify->sendReset (resetDialog->getIocName());
#endif USE_UDP
		}
		delete resetDialog;
		break;
	    }

	case DB_STRUCT_MENUITEM:
#ifndef WIN32
	  sprintf(cmd,"/tis4000/tasks/dbstruct -f%s/Filelist -o%s/dbstruct.txt",
			db->getDbasePath(),db->getDbasePath());
#else
	  sprintf(cmd,"c:\\tis4000\\tasks\\dbstruct -f%s\\Filelist -o%s\\dbstruct.txt",
			db->getDbasePath(),db->getDbasePath());
#endif WIN32
	  system(cmd);
	  break;

	case PV_CROSS_REF_MENUITEM:
#ifndef WIN32
	  sprintf(cmd,"/tis4000/tasks/pvXref -f%s/Linkfields -o%s/pvxref.txt",
			db->getDbasePath(),db->getDbasePath());
#else
	  sprintf(cmd,"c:\\tis4000\\tasks\\pvXref -f%s\\Linkfields -o%s\\pvxref.txt",
			db->getDbasePath(),db->getDbasePath());
#endif WIN32
	  system(cmd);
	  break;

	case FOLLOW_LINKS_MENUITEM:
#ifndef WIN32
	  sprintf(cmd,"/tis4000/tasks/chains -p%s -o%s/chains.txt",
			db->getDbasePath(),db->getDbasePath());
#else
	  sprintf(cmd,"c:\\tis4000\\tasks\\chains -p%s -o%s\\chains.txt",
			db->getDbasePath(),db->getDbasePath());
#endif WIN32
	  system(cmd);
	  break;

	case SYNC_CONFIG_MENUITEM:
	    break;

	case HELP_MENUITEM:
	    break;

	default:
		delete defaultPath;
	    return (vFALSE);
    }
	delete defaultPath;
    return (vTRUE);
}


/*******************************************************************
*
*    Function to give feedback when a new point menu item 
*	is selected
*
*******************************************************************/

static void observeNewPointMenuItem (vmenuItem *menuitem, vevent *event)
{
    vdialog	**dialogs;

    vuNewPointMenuItem *menuItem = (vuNewPointMenuItem *)menuitem;
    vmenuItemList *menuItemList = menuItem -> GetItemListIn ();
    int	index = menuItemList -> GetIndex ((vobjectAttributed *)menuItem);
    vuMainDialogClass *mainDialog = menuItem -> getMainDialog ();
    dataVuApplication *dataVuApp = mainDialog -> getApplication ();
    vresource vuRes = dataVuApp -> getDataVuvresource ();
    vresource commonResource = vresourceGet (vuRes, vunames_vuCommonDialog);

    switch (index)
    {
	case VU_AI:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_AI);
	    vuAiDialogClass *aiDialog = (vuAiDialogClass *)(mainDialog -> newPoint(
					 dialogs,
					 commonResource, 
					 VU_AI));
	    if (aiDialog != NULL)
	    {
		aiDialog -> resetDialog ();
		aiDialog -> Open ();
	    }
	    break;
	}

	case VU_AO:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_AO);
	    vuAoDialogClass *aoDialog = (vuAoDialogClass *)(mainDialog -> newPoint(
					dialogs,
					commonResource, 
					VU_AO));
	    if (aoDialog != NULL)
	    {
		aoDialog -> resetDialog ();
		aoDialog -> Open ();
	    }
	    break;
	}

	case VU_BI:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_BI);
	    vuBiDialogClass *biDialog = (vuBiDialogClass *)(mainDialog -> newPoint(
					dialogs,
					commonResource, 
					VU_BI));
	    if (biDialog != NULL)
	    {
		biDialog -> resetDialog ();
		biDialog -> Open ();
	    }
	    break;
	}

	case VU_BO:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_BO);
	    vuBoDialogClass *boDialog = (vuBoDialogClass *)(mainDialog -> newPoint(
					dialogs,
					commonResource, 
					VU_BO));
	    if (boDialog != NULL)
	    {
		boDialog -> resetDialog ();
		boDialog -> Open ();
	    }
	    break;
	}

	case VU_CALC:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_CALC);
	    vuCalcDialogClass *calcDialog = 
				(vuCalcDialogClass *)(mainDialog -> newPoint(
						      dialogs,
						      commonResource, 
						      VU_CALC));
	    if (calcDialog != NULL)
	    {
		calcDialog -> resetDialog ();
		calcDialog -> Open ();
	    }
	    break;
	}

	case VU_FANOUT:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_FANOUT);
	    vuFanoutDialogClass *fanoutDialog = 
				(vuFanoutDialogClass *)(mainDialog -> newPoint(
						        dialogs,
						        commonResource, 
						        VU_FANOUT));
	    if (fanoutDialog != NULL)
	    {
		fanoutDialog -> resetDialog ();
		fanoutDialog -> Open ();
	    }
	    break;
	}

	case VU_MBBI:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_MBBI);
	    vuMbbiDialogClass *mbbiDialog = 
				(vuMbbiDialogClass *)(mainDialog -> newPoint(
						      dialogs,
						      commonResource, 
						      VU_MBBI));
	    if (mbbiDialog != NULL)
	    {
		mbbiDialog -> resetDialog ();
		mbbiDialog -> Open ();
	    }
	    break;
	}

	case VU_MBBO:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_MBBO);
	    vuMbboDialogClass *mbboDialog = 
				(vuMbboDialogClass *)(mainDialog -> newPoint(
						      dialogs,
						      commonResource, 
						      VU_MBBO));
	    if (mbboDialog != NULL)
	    {
		mbboDialog -> resetDialog ();
		mbboDialog -> Open ();
	    }
	    break;
	}

	case VU_PID:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_PID);
	    vuPidDialogClass *pidDialog = 
				(vuPidDialogClass *)(mainDialog -> newPoint(
						     dialogs,
						     commonResource, 
						     VU_PID));
	    if (pidDialog != NULL)
	    {
		pidDialog -> resetDialog ();
		pidDialog -> Open ();
	    }
	    break;
	}

	case VU_SEL:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_SEL);
	    vuSelDialogClass *selDialog = 
				(vuSelDialogClass *)(mainDialog -> newPoint(
						     dialogs,
						     commonResource, 
						     VU_SEL));
	    if (selDialog != NULL)
	    {
		selDialog -> resetDialog ();
		selDialog -> Open ();
	    }
	    break;
	}

	case VU_STATE:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_STATE);
	    vuStateDialogClass *stateDialog = 
				(vuStateDialogClass *)(mainDialog -> newPoint(
						       dialogs,
						       commonResource, 
						       VU_STATE));
	    if (stateDialog != NULL)
	    {
		stateDialog -> resetDialog ();
		stateDialog -> Open ();
	    }
	    break;
	}

	case VU_STRINGIN:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_STRINGIN);
	    vuStringinDialogClass *stringinDialog = 
			(vuStringinDialogClass *)(mainDialog -> newPoint(
						  dialogs,
						  commonResource, 
						  VU_STRINGIN));
	    if (stringinDialog != NULL)
	    {
		stringinDialog -> resetDialog ();
		stringinDialog -> Open ();
	    }
	    break;
	}

	case VU_STRINGOUT:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_STRINGOUT);
	    vuStringoutDialogClass *stringoutDialog = 
			(vuStringoutDialogClass *)(mainDialog -> newPoint(
						   dialogs,
						   commonResource, 
						   VU_STRINGOUT));
	    if (stringoutDialog != NULL)
	    {
		stringoutDialog -> resetDialog ();
		stringoutDialog -> Open ();
	    }
	    break;
	}

	case VU_WAVEFORM:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_WAVEFORM);
	    vuWaveformDialogClass *waveformDialog = 
				(vuWaveformDialogClass *)(mainDialog -> newPoint(
							  dialogs,
							  commonResource, 
							  VU_WAVEFORM));
	    if (waveformDialog != NULL)
	    {
		waveformDialog -> resetDialog ();
		waveformDialog -> Open ();
	    }
	    break;
	}

	case VU_LEADLAG:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_LEADLAG);
	    vuLeadLagDialogClass *leadlagDialog = 
				(vuLeadLagDialogClass *)(mainDialog -> newPoint(
							 dialogs,
							 commonResource, 
							 VU_LEADLAG));
	    if (leadlagDialog != NULL)
	    {
		leadlagDialog -> resetDialog ();
		leadlagDialog -> Open ();
	    }
	    break;
	}

	case VU_RAMP:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_RAMP);
	    vuRampDialogClass *rampDialog = 
				(vuRampDialogClass *)(mainDialog -> newPoint(
						      dialogs,
						      commonResource, 
						      VU_RAMP));
	    if (rampDialog != NULL)
	    {
		rampDialog -> resetDialog ();
		rampDialog -> Open ();
	    }
	    break;
	}

	case VU_PIPE:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_PIPE);
	    vuPipeDialogClass *pipeDialog = 
				(vuPipeDialogClass *)(mainDialog -> newPoint(
						      dialogs,
						      commonResource, 
						      VU_PIPE));
	    if (pipeDialog != NULL)
	    {
		pipeDialog -> resetDialog ();
		pipeDialog -> Open ();
	    }
	    break;
	}

	case VU_TANK:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_TANK);
	    vuTankDialogClass *tankDialog = 
				(vuTankDialogClass *)(mainDialog -> newPoint(
						      dialogs,
						      commonResource, 
						      VU_TANK));
	    if (tankDialog != NULL)
	    {
		tankDialog -> resetDialog ();
		tankDialog -> Open ();
	    }
	    break;
	}

	case VU_VALVE:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_VALVE);
	    vuValveDialogClass *valveDialog = 
				(vuValveDialogClass *)(mainDialog -> newPoint(
						       dialogs,
						       commonResource, 
						       VU_VALVE));
	    if (valveDialog != NULL)
	    {
		valveDialog -> resetDialog ();
		valveDialog -> Open ();
	    }
	    break;
	}

	case VU_PUMP:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_PUMP);
	    vuPumpDialogClass *pumpDialog = 
				(vuPumpDialogClass *)(mainDialog -> newPoint(
						      dialogs,
						      commonResource, 
						      VU_PUMP));
	    if (pumpDialog != NULL)
	    {
		pumpDialog -> resetDialog ();
		pumpDialog -> Open ();
	    }
	    break;
	}

	case VU_POT:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_POT);
	    vuPotDialogClass *potDialog = 
				(vuPotDialogClass *)(mainDialog -> newPoint(
						     dialogs,
						     commonResource, 
						     VU_POT));
	    if (potDialog != NULL)
	    {
		potDialog -> resetDialog ();
		potDialog -> Open ();
	    }
	    break;
	}

	case VU_ACCUM:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_ACCUM);
	    vuAccDialogClass *accDialog = (vuAccDialogClass *)(mainDialog -> newPoint(
							       dialogs,
							       commonResource, 
							       VU_ACCUM));
	    if (accDialog != NULL)
	    {
		accDialog -> resetDialog ();
		accDialog -> Open ();
	    }
	    break;
	}

	case VU_PTO:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_PTO);
	    vuPtoDialogClass *ptoDialog = 
				(vuPtoDialogClass *)(mainDialog -> newPoint(
						     dialogs,
						     commonResource, 
						     VU_PTO));
	    if (ptoDialog != NULL)
	    {
		ptoDialog -> resetDialog ();
		ptoDialog -> Open ();
	    }
	    break;
	}

	case VU_DEADTIME:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_DEADTIME);
	    vuDeadtimeDialogClass *deadtimeDialog = 
				(vuDeadtimeDialogClass *)(mainDialog -> newPoint(
							  dialogs,
							  commonResource, 
							  VU_DEADTIME));
	    if (deadtimeDialog != NULL)
	    {
		deadtimeDialog -> resetDialog ();
		deadtimeDialog -> Open ();
	    }
	    break;
	}

	case VU_DATAMOVE:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_DATAMOVE);
	    vuDatamoveDialogClass *datamoveDialog = 
				(vuDatamoveDialogClass *)(mainDialog -> newPoint(
							  dialogs,
							  commonResource, 
							  VU_DATAMOVE));
	    if (datamoveDialog != NULL)
	    {
		datamoveDialog -> resetDialog ();
		datamoveDialog -> Open ();
	    }
	    break;
	}

	case VU_TD:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_TD);
	    vuTdDialogClass *tdDialog = 
				(vuTdDialogClass *)(mainDialog -> newPoint(
						    dialogs,
						    commonResource, 
						    VU_TD));
	    if (tdDialog != NULL)
	    {
		tdDialog -> resetDialog ();
		tdDialog -> Open ();
	    }
	    break;
	}

	case VU_SIGCHAR:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_SIGCHAR);
	    vuSigDialogClass *sigDialog = 
				(vuSigDialogClass *)(mainDialog -> newPoint(
						     dialogs,
						     commonResource, 
						     VU_SIGCHAR));
	    if (sigDialog != NULL)
	    {
		sigDialog -> resetDialog ();
		sigDialog -> Open ();
	    }
	    break;
	}

	case VU_UDB:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_UDB);
	    vuUdbDialogClass *udbDialog = 
				(vuUdbDialogClass *)(mainDialog -> newPoint(
						     dialogs,
						     commonResource, 
						     VU_UDB));
	    if (udbDialog != NULL)
	    {
		udbDialog -> resetDialog ();
		udbDialog -> Open ();
	    }
	    break;
	}

	case VU_PAT:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_PAT);
	    vuPatDialogClass *patDialog = 
				(vuPatDialogClass *)(mainDialog -> newPoint(
						     dialogs,
						     commonResource, 
						     VU_PAT));
	    if (patDialog != NULL)
	    {
		patDialog -> resetDialog ();
		patDialog -> Open ();
	    }
	    break;
	}

	case VU_LDFW1:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_LDFW1);
	    vuLdfw1DialogClass *ldfw1Dialog = 
				(vuLdfw1DialogClass *)(mainDialog -> newPoint(
						       dialogs,
						       commonResource, 
						       VU_LDFW1));
	    if (ldfw1Dialog != NULL)
	    {
		ldfw1Dialog -> resetDialog ();
		ldfw1Dialog -> Open ();
	    }
	    break;
	}

	case VU_LDFW2:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_LDFW2);
	    vuLdfw2DialogClass *ldfw2Dialog = 
				(vuLdfw2DialogClass *)(mainDialog -> newPoint(
						       dialogs,
						       commonResource, 
						       VU_LDFW2));
	    if (ldfw2Dialog != NULL)
	    {
		ldfw2Dialog -> resetDialog ();
		ldfw2Dialog -> Open ();
	    }
	    break;
	}

	case VU_DDC:
	{
	    dialogs = mainDialog -> getPointUsedPointDialogs(VU_DDC);
	    vuDdcDialogClass *ddcDialog = 
				(vuDdcDialogClass *)(mainDialog -> newPoint(
						     dialogs,
						     commonResource, 
						     VU_DDC));
	    if (ddcDialog != NULL)
	    {
		ddcDialog -> resetDialog ();
		ddcDialog -> Open ();
	    }
	    break;
	}
    }
}

