#ifndef	vumaindialogclassHXX
#define	vumaindialogclassHXX

class vuNavigatorDialogClass;

//** MAIN DIALOG *******************************************************************

// enum values used for the vcommandSelector::Issue
enum
{
    CREATE_NEW_MENUITEM = 0,
    EXPORT_MENUITEM,
    IMPORT_MENUITEM,
    REPORT_DEST_MENUITEM,
    REPORT_SELECT_MENUITEM,
    PRINT_SCREEN_CURRENT_MENUITEM,
    PRINT_SCREEN_SELECTED_MENUITEM,
    QUIT_MENUITEM,
    NEW_MENUITEM,
    DELETE_MENUITEM,
    GOTO_MENUITEM,
    DISPLAY_MENUITEM,
    RESLIST_MENUITEM,
    IOCLIST_MENUITEM,
    SCRIPT_MENUITEM,
    LAUNCH_MENUITEM,
    TREND_ARCH_MENUITEM,
    ALARM_ARCH_MENUITEM,
    OP_TRACK_ARCH_MENUITEM,
    TREND_REDUC_SELECTED_MENUITEM,
    TREND_REDUC_SPECIFIC_MENUITEM,
    ALARM_GROUP_MENUITEM,
    PERMISSIONS_MENUITEM,
    STRAP_MENUITEM,
    API_MENUITEM,
    DPA_MENUITEM,
    MARK_POINTS_MENUITEM,
    ONLINE_ADD_MENUITEM,
    ONLINE_DELETE_MENUITEM,
    RESET_IOC_MENUITEM,
    DB_STRUCT_MENUITEM,
    PV_CROSS_REF_MENUITEM,
    FOLLOW_LINKS_MENUITEM,
    SYNC_CONFIG_MENUITEM,
    HELP_MENUITEM,
    MENUITEM_COUNT
};


class	vuMainDialogClass : public vdialog
{
    // pointer to application
    dataVuApplication	*dataVuApp;

    // resource for the main dialog
    vresource		mainDialogResource;

    // resource for dialog titles
    vresource		dialogTitles;

    // resource for messages
    vresource		dialogMessages;

    // resource for defaults
    vresource		dialogDefaults;

    // resource for arrays
    vresource		arrays;

    // place to store internal names for main dialog menu items
    const vname		*commandNames[MENUITEM_COUNT];

    // place to store used point dialogs
    vdialog		*usedPointDialogs[VU_NUMPOINTS][VU_MAX_USED_POINTS];

    // the main dialog's vlistitem where we write love notes to the user
    vlistitem	*mainDialogList;

    // the New point type menu
    vmenuSubMenuItem	*newPointSubMenu;

    // remember the navigator to speed up its open
    vuNavigatorDialogClass *vuNavigator;

    // remember the help menu
    vmenu	*helpMenu;
    // the about help menu option
    TisAbout	*tisAbout;
    // private function to build the about menu
    void	BuildAboutMenu (void);

    // init error for operator privileegs
    int	loadiniterror;


public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuMainDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuMainDialogClass, vdialog);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // override
    void Open (void);

    // functions to the application wrapper
    void storeDataVuApp (dataVuApplication *app) 
	{ dataVuApp = app; }
    dataVuApplication *getApplication (void) 
	{ return (dataVuApp); }

    // store resources, mains is set in its LoadInit
    void storeTitlesResource (vresource res) 
	{ dialogTitles = res; }
    void storeMessagesResource (vresource res) 
	{ dialogMessages = res; }
    void storeDefaultsResource (vresource res) 
	{ dialogDefaults = res; }
    void storeArraysResource (vresource res)
	{ arrays = res; }

    // return the resources
    vresource getMainDialogResource (void) 
	{ return (mainDialogResource); }
    vresource getTitlesResource (void) 
	{ return (dialogTitles); }
    vresource getMessagesResource (void) 
	{ return (dialogMessages); }
    vresource getDefaultsResource (void) 
	{ return (dialogDefaults); }
    vresource getArraysResource (void)
	{ return (arrays); }

    // funcs for main dialogs vtextitem
    void storeMainTextItem (vlistitem *mainList) 
	{ mainDialogList = mainList; }
    vlistitem *getMainListItem (void) 
	{ return (mainDialogList); }

    // function to build the new point menu
    void buildNewPointMenu (void);

    // functions for usedPointDialogs
    vdialog **getUsedPointDialogs (void) 
	{ return (usedPointDialogs[0]); }
    vdialog **getPointUsedPointDialogs (int idx) 
	{ return (usedPointDialogs[idx]); }
    vdialog *getDialogPointDialog (int ptidx, int dialogidx)
	{ return (usedPointDialogs[ptidx][dialogidx]); }

    // function to return a point dialog pointer
    void *newPoint (vdialog **usedPoints, vresource commonResource, int pointType);

    // main dialogs message routine
    void vuMainMessageCenter (const vname *msgType, ...);

    // functions to handle the navigator
    void storeNavigator (vuNavigatorDialogClass *nav) 
	{ vuNavigator = nav; }
    vuNavigatorDialogClass *getNavigator (void) 
	{ return (vuNavigator); }

    // handle the loadiniterror
    int GetLoadInitError (void)
	{ return (loadiniterror); }
    //
    // vuNetwork instance for use with Apply & Delete functions to inform dbClient
    // of those events. Closed when this class is destroyed.
    // 
};


// ** CLASS FOR THE MAIN DIALODS MENU COMMANDS *************************************

class  vuMainCommand : public vcommandSelector
{
public:
    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuMainCommand);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuMainCommand, vcommandSelector);

    //override virtual issue function
    int Issue(vdict *);
};


// ** CLASS FOR THE MAIN DIALOGS MENUITEMS *****************************************

class vuNewPointMenuItem : public vmenuItem
{
    vuMainDialogClass	*vuMainDialog;
public:
    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuNewPointMenuItem);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(vuNewPointMenuItem, vmenuItem);

    // function to handle the mainDialog
    void storeMainDialog (vuMainDialogClass *mD) { vuMainDialog = mD; }
    vuMainDialogClass *getMainDialog (void) { return (vuMainDialog); }
};

#endif	vumaindialogclassHXX
