#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuMbboDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuMbboDialogClass, vuCommonDialogClass, "vuMbboDialogClass");

/*******************************************************************
*
*    vuMbboDialogClass override for constructors init ()
*
*******************************************************************/

void vuMbboDialogClass::LoadInit (vresource res)
{
    // load in the ai specific fields
    mbboContainer = vuMbboContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    mbboContainer -> boardType -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> line -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> addr -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> card -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> signal -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> valueLoc -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> output -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> constantValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> nobt -> SetModifiedPtr (&this -> dialogModified);
    mbboContainer -> readback -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> closedLoop -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> outputOnChange -> vuSetModifiedPtr (&this -> dialogModified);

    mbboContainer -> zrvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> zrstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> zrsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> onvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> onstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> onsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> twvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> twstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> twsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> thvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> thstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> thsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> frvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> frstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> frsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> fvvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> fvstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> fvsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> sxvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> sxstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> sxsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> svvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> svstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> svsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> eivlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> eistValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> eisvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> nivlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> nistValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> nisvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> tevlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> testValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> tesvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> elvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> elstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> elsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> tvvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> tvstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> tvsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> ttvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> ttstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> ttsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> ftvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> ftstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> ftsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> ffvlValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> ffstValue -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> ffsvSeverity -> vuSetModifiedPtr (&this -> dialogModified);

    mbboContainer -> cosSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> undefSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    mbboContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> alarmDelay -> SetTextModifiedPtr (&this -> dialogModified);
    mbboContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    mbboContainer -> valueLocButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    mbboContainer -> outputButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    mbboContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    mbboContainer -> valueLoc -> storeCommonDialog ((vuCommonDialogClass *)this);
    mbboContainer -> output -> storeCommonDialog ((vuCommonDialogClass *)this);
    mbboContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    mbboContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_MBBO);

    // get the title from the resource file, aiTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    mbboTitle = vresourceGetString (dialogTitles, 
				vunames_vuMbboDialogTitle);
    SetTitle (mbboTitle);
}


/*******************************************************************
*
*    vuMbboDialogClass Destroy function
*
*******************************************************************/

void vuMbboDialogClass::Destroy (void)
{
    vstrDestroy (mbboTitle);
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuMbboDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuMbboDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    dialogItem = vuFindContainerItem (mbboContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the Mbbo's line field
		if ( ((vcharCompareBounded (epics, "LINE", FLDNAME_SZ)) == 0) ||
		     ((vcharCompareBounded (epics, "ADDR", FLDNAME_SZ)) == 0) ||
		     ((vcharCompareBounded (epics, "CARD", FLDNAME_SZ)) == 0) ||
		     ((vcharCompareBounded (epics, "SIGN", FLDNAME_SZ)) == 0) ||
		     ((vcharCompareBounded (epics, "RBDT", FLDNAME_SZ)) == 0) )
		{
		    vstr *zero = vresourceGetString (defRes, 
						vunames_vuZeroDefault);
		    textItem -> SetText (zero);
		    vstrDestroy (zero);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (spinner -> GetMin());
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuMbboDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;
    DTYP_TYPE		dType;		// device type indicator

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT an MBBO
	if (ptType != VU_MBBO)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_MBBO);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    // since the mbbo can be a hardware point, find what we are for later use
    // by getting the DTYP (device type) dictionary entry
    referenceString = vstrCloneScribed (vcharScribeSystem ("REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("CONSTANT"));
    xrefNode = (xrefNodeClass *)(dict -> GetElem (vnameGetGlobalScribed (vcharScribeSystem ("DTYP"))));
    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
    if ( (vcharCompare ((const vchar *)dbValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare ((const vchar *)dbValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
		{
			sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
			pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindContainerItem (mbboContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    // to output CONSTANT field, device type must be CONSTANT
		    if ( (strncmp (xrefNode -> xrefEpicsName, "CNST", FLDNAME_SZ)) == 0)
		    {
			if (dType != VU_CONSTANT)
			    continue;
		    }
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_OUTLINK:
		    // device type must be REFERENCE to output the reference
		    if (dType == VU_REFERENCE)
		    {
			DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
								dbValue, &dbaseType);
			finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    }
		    else 
		    {
			finalValue = vstrCloneScribed (vcharScribeSystem (""));
		    }
		    break;

		case DBF_INLINK:
		    // works for all ao inputs, see pdbxref
		    DB_GetFieldValue (pntRecord, xrefNode -> xrefRefField, 
								dbValue, &dbaseType);
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (vnum::ParseInt (finalValue, NULL));
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuMbboDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;
    vstr		*referenceString;
    vstr		*constantString;

    char		pvName [PVNAME_SZ + 1];
    char		vuCurrentBoard [VU_KEY_SIZE];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dType;		// device type
    double		doubleValue;
    int			doSave;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    // since the mbbo can be a hardware point, find what we are for later use
    // by getting the DTYP (device type) dictionary entry
    referenceString = vstrCloneScribed (vcharScribeSystem ("REFERENCE"));
    constantString = vstrCloneScribed (vcharScribeSystem ("CONSTANT"));
    vcharCopyScribedBounded (vcharScribeSystem ("DTYP"), epics, FLDNAME_SZ);
    epics[sizeof (epics) - 1] = 0;
    // find the BOARD (DTYP) field and get its value
    dialogItem = vuFindContainerItem (mbboContainer, epics);
    optionMenu = (vcontrolOptionMenu *)dialogItem;
    optionMenuValue = vuGetOptionMenuValue (optionMenu);
    vcharExport (vcharScribeSystemExport (optionMenuValue), (void *)vuCurrentBoard);
    if ( (vcharCompare (optionMenuValue, referenceString)) == 0)
	dType = VU_REFERENCE;
    else if ( (vcharCompare (optionMenuValue, constantString)) == 0)
	dType = VU_CONSTANT;
    else
	dType = VU_HARDWARE;
    vstrDestroy (referenceString);
    vstrDestroy (constantString);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
			pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindContainerItem (mbboContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
		    {
			spinner = (vspinner *)dialogItem;
			// buf fix, spinner mau not have proper value
			spinner -> Unfocus ();
			stringValue = spinner -> GetTextAsString ();
		    }
		    else
		    {
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
		    }
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    if ( (strncmp (xrefNode -> xrefEpicsName, "CNST", FLDNAME_SZ))
										== 0)
		    {
			if (dType != VU_CONSTANT)
			    doubleValue = 0;
		    }
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
							    xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    if ( (strncmp (xrefNode -> xrefEpicsName, "DTYP", FLDNAME_SZ)) == 0)
		    {
			// write to DEVTYPE in pvmap
			DB_PutFieldValue (pntRecord, xrefNode -> xrefField, dbValue);
		    }
		    break;
		}

		case DBF_OUTLINK:
		    // there is only 1 output and that is OUT
		    // always write the boardtype from DTYP into the OUT field
		    DB_PutFieldValue (pntRecord, putField, vuCurrentBoard);
		    // if we are a reference then write OUT into the REFERENCE field
		    if (dType == VU_REFERENCE)
		    {
			putField = xrefNode -> xrefRefField;
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
			vcharExport (vcharScribeSystemExport (stringValue), dbValue);
			vstrDestroy (stringValue);
		    }
		    else
		    {
			// make sure to null out the field
			putField = xrefNode -> xrefRefField;
			vmemSet (dbValue, 0, VU_KEY_SIZE);
		    }
		    break;

		case DBF_INLINK:
		    // for DOL, we must put its value to the OUTPUTREF field
		    // other wise it and other INLINKS are the same 
		    if ( (strncmp (xrefNode -> xrefEpicsName, "DOL ", FLDNAME_SZ)) == 0)
		    {
			putField = xrefNode -> xrefRefField;
		    }
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuMbboContainerClass, vcontainer, "vuMbboContainerClass");

/*******************************************************************
*
*    vuMbboContainerClass override for constructor
*
*******************************************************************/

void vuMbboContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuMbboContainer);

    vcontainer *btcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboDTYPContainer);
    boardType = vuBoardTypeMenuClass::RequestSubLoad (btcontainer,
				vunames_DTYP);

    vcontainer *linecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboLINEContainer);
    line = filteredTextitem::RequestSubLoad (linecontainer,
				vunames_LINE);

    vcontainer *addrcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboADDRContainer);
    addr = filteredTextitem::RequestSubLoad (addrcontainer,
				vunames_ADDR);

    vcontainer *cardcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboCARDContainer);
    card = filteredTextitem::RequestSubLoad (cardcontainer,
				vunames_CARD);

    vcontainer *signalcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboSIGNContainer);
    signal = filteredTextitem::RequestSubLoad (signalcontainer,
				vunames_SIGN);

    vcontainer *valueloccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboDOLContainer);
    valueLocButton = vuPvNameButtonClass::RequestSubLoad (valueloccontainer,
				vunames_vuMbboDOLButton);
    valueLoc = vuFilteredTextitem::RequestSubLoad (valueloccontainer,
				vunames_DOL);

    vcontainer *cnstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboCNSTContainer);
    constantValue = filteredTextitem::RequestSubLoad (cnstcontainer,
				vunames_CNST);

    vcontainer *outputcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboOUTContainer);
    outputButton = vuPvNameButtonClass::RequestSubLoad (outputcontainer,
				vunames_vuMbboOUTButton);
    output = vuFilteredTextitem::RequestSubLoad (outputcontainer,
				vunames_OUT);

    vcontainer *nobtcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboNOBTContainer);
    nobt = spinnerClass::RequestSubLoad (nobtcontainer,
				vunames_NOBT);

    vcontainer *rbdtcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboRBDTContainer);
    readback = filteredTextitem::RequestSubLoad (rbdtcontainer,
				vunames_RBDT);

    closedLoop = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OMSL);
    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);
    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);
    outputOnChange = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OCHG);

    vcontainer *zrvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboZRVLContainer);
    zrvlValue = filteredTextitem::RequestSubLoad (zrvlcontainer,
				vunames_ZRVL);
    vcontainer *zrstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboZRSTContainer);
    zrstValue = filteredTextitem::RequestSubLoad (zrstcontainer,
				vunames_ZRST);
    vcontainer *zrsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboZRSVContainer);
    zrsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (zrsvcontainer,
				vunames_ZRSV);

    vcontainer *onvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboONVLContainer);
    onvlValue = filteredTextitem::RequestSubLoad (onvlcontainer,
				vunames_ONVL);
    vcontainer *onstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboONSTContainer);
    onstValue = filteredTextitem::RequestSubLoad (onstcontainer,
				vunames_ONST);
    vcontainer *onsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboONSVContainer);
    onsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (onsvcontainer,
				vunames_ONSV);

    vcontainer *twvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTWVLContainer);
    twvlValue = filteredTextitem::RequestSubLoad (twvlcontainer,
				vunames_TWVL);
    vcontainer *twstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTWSTContainer);
    twstValue = filteredTextitem::RequestSubLoad (twstcontainer,
				vunames_TWST);
    vcontainer *twsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTWSVContainer);
    twsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (twsvcontainer,
				vunames_TWSV);

    vcontainer *thvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTHVLContainer);
    thvlValue = filteredTextitem::RequestSubLoad (thvlcontainer,
				vunames_THVL);
    vcontainer *thstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTHSTContainer);
    thstValue = filteredTextitem::RequestSubLoad (thstcontainer,
				vunames_THST);
    vcontainer *thsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTHSVContainer);
    thsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (thsvcontainer,
				vunames_THSV);

    vcontainer *frvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFRVLContainer);
    frvlValue = filteredTextitem::RequestSubLoad (frvlcontainer,
				vunames_FRVL);
    vcontainer *frstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFRSTContainer);
    frstValue = filteredTextitem::RequestSubLoad (frstcontainer,
				vunames_FRST);
    vcontainer *frsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFRSVContainer);
    frsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (frsvcontainer,
				vunames_FRSV);

    vcontainer *fvvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFVVLContainer);
    fvvlValue = filteredTextitem::RequestSubLoad (fvvlcontainer,
				vunames_FVVL);
    vcontainer *fvstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFVSTContainer);
    fvstValue = filteredTextitem::RequestSubLoad (fvstcontainer,
				vunames_FVST);
    vcontainer *fvsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFVSVContainer);
    fvsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (fvsvcontainer,
				vunames_FVSV);

    vcontainer *sxvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboSXVLContainer);
    sxvlValue = filteredTextitem::RequestSubLoad (sxvlcontainer,
				vunames_SXVL);
    vcontainer *sxstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboSXSTContainer);
    sxstValue = filteredTextitem::RequestSubLoad (sxstcontainer,
				vunames_SXST);
    vcontainer *sxsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboSXSVContainer);
    sxsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (sxsvcontainer,
				vunames_SXSV);

    vcontainer *svvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboSVVLContainer);
    svvlValue = filteredTextitem::RequestSubLoad (svvlcontainer,
				vunames_SVVL);
    vcontainer *svstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboSVSTContainer);
    svstValue = filteredTextitem::RequestSubLoad (svstcontainer,
				vunames_SVST);
    vcontainer *svsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboSVSVContainer);
    svsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (svsvcontainer,
				vunames_SVSV);

    vcontainer *eivlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboEIVLContainer);
    eivlValue = filteredTextitem::RequestSubLoad (eivlcontainer,
				vunames_EIVL);
    vcontainer *eistcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboEISTContainer);
    eistValue = filteredTextitem::RequestSubLoad (eistcontainer,
				vunames_EIST);
    vcontainer *eisvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboEISVContainer);
    eisvSeverity = vuChoiceGblMenuClass::RequestSubLoad (eisvcontainer,
				vunames_EISV);

    vcontainer *nivlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboNIVLContainer);
    nivlValue = filteredTextitem::RequestSubLoad (nivlcontainer,
				vunames_NIVL);
    vcontainer *nistcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboNISTContainer);
    nistValue = filteredTextitem::RequestSubLoad (nistcontainer,
				vunames_NIST);
    vcontainer *nisvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboNISVContainer);
    nisvSeverity = vuChoiceGblMenuClass::RequestSubLoad (nisvcontainer,
				vunames_NISV);

    vcontainer *tevlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTEVLContainer);
    tevlValue = filteredTextitem::RequestSubLoad (tevlcontainer,
				vunames_TEVL);
    vcontainer *testcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTESTContainer);
    testValue = filteredTextitem::RequestSubLoad (testcontainer,
				vunames_TEST);
    vcontainer *tesvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTESVContainer);
    tesvSeverity = vuChoiceGblMenuClass::RequestSubLoad (tesvcontainer,
				vunames_TESV);

    vcontainer *elvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboELVLContainer);
    elvlValue = filteredTextitem::RequestSubLoad (elvlcontainer,
				vunames_ELVL);
    vcontainer *elstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboELSTContainer);
    elstValue = filteredTextitem::RequestSubLoad (elstcontainer,
				vunames_ELST);
    vcontainer *elsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboELSVContainer);
    elsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (elsvcontainer,
				vunames_ELSV);

    vcontainer *tvvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTVVLContainer);
    tvvlValue = filteredTextitem::RequestSubLoad (tvvlcontainer,
				vunames_TVVL);
    vcontainer *tvstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTVSTContainer);
    tvstValue = filteredTextitem::RequestSubLoad (tvstcontainer,
				vunames_TVST);
    vcontainer *tvsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTVSVContainer);
    tvsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (tvsvcontainer,
				vunames_TVSV);

    vcontainer *ttvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTTVLContainer);
    ttvlValue = filteredTextitem::RequestSubLoad (ttvlcontainer,
				vunames_TTVL);
    vcontainer *ttstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTTSTContainer);
    ttstValue = filteredTextitem::RequestSubLoad (ttstcontainer,
				vunames_TTST);
    vcontainer *ttsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboTTSVContainer);
    ttsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (ttsvcontainer,
				vunames_TTSV);

    vcontainer *ftvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFTVLContainer);
    ftvlValue = filteredTextitem::RequestSubLoad (ftvlcontainer,
				vunames_FTVL);
    vcontainer *ftstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFTSTContainer);
    ftstValue = filteredTextitem::RequestSubLoad (ftstcontainer,
				vunames_FTST);
    vcontainer *ftsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFTSVContainer);
    ftsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (ftsvcontainer,
				vunames_FTSV);

    vcontainer *ffvlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFFVLContainer);
    ffvlValue = filteredTextitem::RequestSubLoad (ffvlcontainer,
				vunames_FFVL);
    vcontainer *ffstcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFFSTContainer);
    ffstValue = filteredTextitem::RequestSubLoad (ffstcontainer,
				vunames_FFST);
    vcontainer *ffsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboFFSVContainer);
    ffsvSeverity = vuChoiceGblMenuClass::RequestSubLoad (ffsvcontainer,
				vunames_FFSV);

    vcontainer *cosvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboCOSVContainer);
    cosSeverity = vuChoiceGblMenuClass::RequestSubLoad (cosvcontainer,
				vunames_COSV);

    vcontainer *unsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboUNSVContainer);
    undefSeverity = vuChoiceGblMenuClass::RequestSubLoad (unsvcontainer,
				vunames_UNSV);

    vcontainer *alrmgrpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (alrmgrpcontainer,
				vunames_ALGP);

    vcontainer *alarmdiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (alarmdiscontainer,
				vunames_vuMbboADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (alarmdiscontainer,
				vunames_ADIS);

    vcontainer *alarmdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuMbboALDLContainer);
    alarmDelay = filteredTextitem::RequestSubLoad (alarmdelcontainer,
				vunames_ALDL);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    valueLocButton -> storePvName (valueLoc);
    outputButton -> storePvName (output);
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters
    line -> SetItemFilterFunc (numericFilter);
    addr -> SetItemFilterFunc (numericFilter);
    card -> SetItemFilterFunc (numericFilter);
    signal -> SetItemFilterFunc (numericFilter);

    valueLoc -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *valueLocText = (filteredText *)valueLoc -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    valueLocText -> SetUserPtr ((void *)valueLoc);

    output -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *outputText = (filteredText *)output -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    outputText -> SetUserPtr ((void *)output);

    constantValue -> SetItemFilterFunc (numericFilter);
    readback -> SetItemFilterFunc (numericFilter);

    zrvlValue -> SetItemFilterFunc (numericFilter);
    zrstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    onvlValue -> SetItemFilterFunc (numericFilter);
    onstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    twvlValue -> SetItemFilterFunc (numericFilter);
    twstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    thvlValue -> SetItemFilterFunc (numericFilter);
    thstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    frvlValue -> SetItemFilterFunc (numericFilter);
    frstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    fvvlValue -> SetItemFilterFunc (numericFilter);
    fvstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    sxvlValue -> SetItemFilterFunc (numericFilter);
    sxstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    svvlValue -> SetItemFilterFunc (numericFilter);
    svstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    eivlValue -> SetItemFilterFunc (numericFilter);
    eistValue -> SetItemFilterFunc (multiDigitalStateFilter);
    nivlValue -> SetItemFilterFunc (numericFilter);
    nistValue -> SetItemFilterFunc (multiDigitalStateFilter);
    tevlValue -> SetItemFilterFunc (numericFilter);
    testValue -> SetItemFilterFunc (multiDigitalStateFilter);
    elvlValue -> SetItemFilterFunc (numericFilter);
    elstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    tvvlValue -> SetItemFilterFunc (numericFilter);
    tvstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    ttvlValue -> SetItemFilterFunc (numericFilter);
    ttstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    ftvlValue -> SetItemFilterFunc (numericFilter);
    ftstValue -> SetItemFilterFunc (multiDigitalStateFilter);
    ffvlValue -> SetItemFilterFunc (numericFilter);
    ffstValue -> SetItemFilterFunc (multiDigitalStateFilter);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *alrmDisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alrmDisText -> SetUserPtr ((void *)alarmDisable);

    alarmDelay -> SetItemFilterFunc (numericFilter);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    // build popup menus
    boardType    -> vuBuildBoardTypeMenu (VU_MBBO);
    zrsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    onsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    twsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    thsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    frsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    fvsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    sxsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    svsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    eisvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    nisvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    tesvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    elsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    tvsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    ttsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    ftsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    ffsvSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    cosSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);
    undefSeverity  -> vuBuildOptionMenu (GBL_ALARM_SEV);

}


/*******************************************************************
*
*    vuMbboContainerClass override for destructor
*
*******************************************************************/

void vuMbboContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}

