#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vlistviewHEADER
#include vliststrHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbDefs.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuOnlineDeleteDialogClass.hxx"
#include "vuUtils.hxx"


/*******************************************************************
*
*	ONLINE ADD DIALOG CLASS
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuOnlineDeleteDialogClass, vdialog, 
						"vuOnlineDeleteDialogClass");

/*******************************************************************
*
*    vuOnlineDeleteDialogClass 
*	LoadInit, constructor
*
*******************************************************************/

void vuOnlineDeleteDialogClass::LoadInit(vresource res)
{

    // call base class loadInit to finish the job
    vdialog::LoadInit(res);

    // set ptrs
    okButton -> setSelectOnlineDeleteDialog (this);
    dismissButton -> setSelectOnlineDeleteDialog (this);

    // set filter for pointName

    pointName -> SetFilterFunc (pvnameFilter);

}


/*******************************************************************
*
*    vuOnlineDeleteDialogClass notify function
*
*******************************************************************/

void vuOnlineDeleteDialogClass::ObserveWindow(vevent *event)
{
    if ( event -> GetType() == veventWINDOW_STATE && event -> IsClose())
    {
	Close();
	vevent::StopProcessing ();
    }
}


/*******************************************************************
*
*    vuOnlineDeleteDialogClass Destroy function
*	if dialog is open, close it and stop its event loop
*
*******************************************************************/

void vuDpaSelectOnlineDeleteDialogClass::Destroy(void)
{
    if (IsOpen())
    {
	Close ();
	vevent::StopProcessing ();
    }

    vdialog::Destroy();
}


/*******************************************************************
*
*    vuOnlineDeleteDialogClas Open function
*
*******************************************************************/

void vuOnlineDeleteDialogClass::vuOnlineDeleteOpen(vuMainDialogClass *mainDialg)
{
    mainDialog = mainDialg;

    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    Place(GetRoot (), vrectPLACE_CENTER, vrectPLACE_CENTER);
    vdialog::Open();
    vevent::Process ();
}


/*******************************************************************
*
*    vuOnlineDeleteOkButtonClass 
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuOnlineDeleteOkButtonClass, vbutton, 
					"vuOnlineDeleteOkButtonClass");

/*******************************************************************
*
*    vuOnlineDeleteOkButtonClass Observer function
*
*******************************************************************/

void vuOnlineDeleteOkButtonClass::ObserveDialogItem (vevent *event)
{
    vevent::StopProcessing ();
}


/*******************************************************************
*
*    vuOnlineDeleteDismissButtonClass 
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuOnlineDeleteDismissButtonClass, vbutton, 
					"vuOnlineDeleteDismissButtonClass");

/*******************************************************************
*
*    vuOnlineDeleteDismissButtonClass Observer function
*
*******************************************************************/

void vuOnlineDeleteDismissButtonClass::ObserveDialogItem (vevent *event)
{
    onlinedeleteDialog -> Close ();
    vevent::StopProcessing ();
}

