#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuPumpDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuPumpDialogClass, vuCommonDialogClass, "vuPumpDialogClass");

/*******************************************************************
*
*    vuPumpDialogClass override for constructors init ()
*
*******************************************************************/

void vuPumpDialogClass::LoadInit (vresource res)
{
    // load in the ai specific fields
    pumpContainer = vuPumpContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    pumpContainer -> startPV -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> stopPV -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> remoteLocalPV -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> temperaturePV -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> vibrationPV -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> pressurePV -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> permissivePV -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> runConfirmPV -> SetTextModifiedPtr (&this -> dialogModified);

    pumpContainer -> processStart -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> msStart -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> processStop -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> msStop -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> processRemoteLocal -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> msRemoteLocal -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> processTemperature -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> msTemperature -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> temperatureTrip -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> processVibration -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> msVibration -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> vibrationTrip -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> processPressure -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> msPressure -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> pressureTrip -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> processPermissive -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> msPermissive -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> processRunConfirm -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> msRunConfirm -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> runConfirmTrip -> vuSetModifiedPtr (&this -> dialogModified);

    pumpContainer -> startCommand -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> stopCommand -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> remoteStatus -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> localStatus -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> runningStatus -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> startingStatus -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> stoppedStatus -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> stoppingStatus -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> faultStatus -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> minOffStatus -> SetTextModifiedPtr (&this -> dialogModified);

    pumpContainer -> mode -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> localTracking -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> learnMode -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> alarmOnAuto -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> autoSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> alarmOnManual -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> manualSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> minOffTime -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> runTimePrecision -> SetModifiedPtr (&this -> dialogModified);
    pumpContainer -> startTime -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> startTimeDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> startTimeSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    pumpContainer -> stopTime -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> stopTimeDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> stopTimeSeverity -> vuSetModifiedPtr (&this -> dialogModified);

    pumpContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);
    pumpContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    pumpContainer -> startPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> stopPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> remoteLocalPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> temperaturePVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> vibrationPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> pressurePVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> permissivePVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> runConfirmPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    pumpContainer -> startPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> stopPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> remoteLocalPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> temperaturePV -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> vibrationPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> pressurePV -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> permissivePV -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> runConfirmPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    pumpContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuAlarmGroupFilter
    pumpContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_PUMP);

    // get the title from the resource file, biTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    pumpTitle = vresourceGetString (dialogTitles, 
				vunames_vuPumpDialogTitle);
    SetTitle (pumpTitle);
}


/*******************************************************************
*
*    vuPumpDialogClass Destroy function
*
*******************************************************************/

void vuPumpDialogClass::Destroy (void)
{
    vstrDestroy (pumpTitle);
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuPumpDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuPumpDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vspinner		*spinner;

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    dialogItem = vuFindContainerItem (pumpContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for these Pumps fields
		if ( (vcharCompareBounded (epics, "MOTM", FLDNAME_SZ)) == 0)
		{
		    vstr *zero = vresourceGetString (defRes, 
						vunames_vuZeroDefault);
		    textItem -> SetText (zero);
		    vstrDestroy (zero);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (spinner -> GetMin());
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuPumpDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;
    vspinner		*spinner;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, pvName);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT a PUMP
	if (ptType != VU_PUMP)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_PUMP);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed or new xrefOpId
	    if ( (lastTable != xrefNode -> xrefTable) ||
		 (strlen (xrefNode -> xrefOpId) ) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;
	    dialogItem = vuFindContainerItem (pumpContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		case DBF_OUTLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (vnum::ParseInt (finalValue, NULL));
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuPumpDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;
    vspinner		*spinner;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if  ( (lastTable != xrefNode -> xrefTable) ||
		  (strlen (xrefNode -> xrefOpId)) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    dialogItem = vuFindContainerItem (pumpContainer, epics);
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
		    {
			spinner = (vspinner *)dialogItem;
			// buf fix, spinner mau not have proper value
			spinner -> Unfocus ();
			stringValue = spinner -> GetTextAsString ();
		    }
		    else
		    {
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
		    }
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_INLINK:
		case DBF_OUTLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuPumpContainerClass, vcontainer, "vuPumpContainerClass");

/*******************************************************************
*
*    vuPumpContainerClass override for constructor
*
*******************************************************************/

void vuPumpContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuPumpContainer);

    vcontainer *startcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpPONPContainer);
    startPVButton = vuPvNameButtonClass::RequestSubLoad (startcontainer,
				vunames_vuPumpPONPButton);
    startPV = vuFilteredTextitem::RequestSubLoad (startcontainer,
				vunames_PONP);
    processStart = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC2);
    msStart = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS2);

    vcontainer *stopcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpPOFPContainer);
    stopPVButton = vuPvNameButtonClass::RequestSubLoad (stopcontainer,
				vunames_vuPumpPOFPButton);
    stopPV = vuFilteredTextitem::RequestSubLoad (stopcontainer,
				vunames_POFP);
    processStop = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC3);
    msStop = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS3);

    vcontainer *rlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpROLPContainer);
    remoteLocalPVButton = vuPvNameButtonClass::RequestSubLoad (rlcontainer,
				vunames_vuPumpROLPButton);
    remoteLocalPV = vuFilteredTextitem::RequestSubLoad (rlcontainer,
				vunames_ROLP);
    processRemoteLocal = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC1);
    msRemoteLocal = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS1);

    vcontainer *tempcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpTMPPContainer);
    temperaturePVButton = vuPvNameButtonClass::RequestSubLoad (tempcontainer,
				vunames_vuPumpTMPPButton);
    temperaturePV = vuFilteredTextitem::RequestSubLoad (tempcontainer,
				vunames_TMPP);
    processTemperature = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC4);
    msTemperature = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS4);
    temperatureTrip = vuCheckBoxClass::RequestSubLoad (this,
				vunames_TTRE);

    vcontainer *vibcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpVIBPContainer);
    vibrationPVButton = vuPvNameButtonClass::RequestSubLoad (vibcontainer,
				vunames_vuPumpVIBPButton);
    vibrationPV = vuFilteredTextitem::RequestSubLoad (vibcontainer,
				vunames_VIBP);
    processVibration = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC5);
    msVibration = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS5);
    vibrationTrip = vuCheckBoxClass::RequestSubLoad (this,
				vunames_VTRE);

    vcontainer *prescontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpPRSPContainer);
    pressurePVButton = vuPvNameButtonClass::RequestSubLoad (prescontainer,
				vunames_vuPumpPRSPButton);
    pressurePV = vuFilteredTextitem::RequestSubLoad (prescontainer,
				vunames_PRSP);
    processPressure = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC6);
    msPressure = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS6);
    pressureTrip = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PTRE);

    vcontainer *permcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpPERPContainer);
    permissivePVButton = vuPvNameButtonClass::RequestSubLoad (permcontainer,
				vunames_vuPumpPERPButton);
    permissivePV = vuFilteredTextitem::RequestSubLoad (permcontainer,
				vunames_PERP);
    processPermissive = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC7);
    msPermissive = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS7);

    vcontainer *rcfcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpRUCPContainer);
    runConfirmPVButton = vuPvNameButtonClass::RequestSubLoad (rcfcontainer,
				vunames_vuPumpRUCPButton);
    runConfirmPV = vuFilteredTextitem::RequestSubLoad (rcfcontainer,
				vunames_RUCP);
    processRunConfirm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC8);
    msRunConfirm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS8);
    runConfirmTrip = vuCheckBoxClass::RequestSubLoad (this,
				vunames_LRCF);

    vcontainer *stcmdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSSTRContainer);
    startCommand = filteredTextitem::RequestSubLoad (stcmdcontainer,
				vunames_SSTR);

    vcontainer *stpcmdcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSSTPContainer);
    stopCommand = filteredTextitem::RequestSubLoad (stpcmdcontainer,
				vunames_SSTP);

    vcontainer *rstscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSWREContainer);
    remoteStatus = filteredTextitem::RequestSubLoad (rstscontainer,
				vunames_SWRE);

    vcontainer *lstscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSWLOContainer);
    localStatus = filteredTextitem::RequestSubLoad (lstscontainer,
				vunames_SWLO);

    vcontainer *rustscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSTONContainer);
    runningStatus = filteredTextitem::RequestSubLoad (rustscontainer,
				vunames_STON);

    vcontainer *ststscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSTSTContainer);
    startingStatus = filteredTextitem::RequestSubLoad (ststscontainer,
				vunames_STST);

    vcontainer *stpstscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSTOFContainer);
    stoppedStatus = filteredTextitem::RequestSubLoad (stpstscontainer,
				vunames_STOF);

    vcontainer *stpngstscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSTSPContainer);
    stoppingStatus = filteredTextitem::RequestSubLoad (stpngstscontainer,
				vunames_STSP);

    vcontainer *fstscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSTFAContainer);
    faultStatus = filteredTextitem::RequestSubLoad (fstscontainer,
				vunames_STFA);

    vcontainer *mostscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSTMOContainer);
    minOffStatus = filteredTextitem::RequestSubLoad (mostscontainer,
				vunames_STMO);

    vcontainer *modecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpMODEContainer);
    mode = vuChoiceGblMenuClass::RequestSubLoad (modecontainer,
				vunames_MODE);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    localTracking = vuCheckBoxClass::RequestSubLoad (this,
				vunames_LTEN);

    learnMode = vuCheckBoxClass::RequestSubLoad (this,
				vunames_LMEN);

    alarmOnAuto = vuCheckBoxClass::RequestSubLoad (this,
				vunames_ALAU);
    vcontainer *ausvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpAUSVContainer);
    autoSeverity = vuChoiceGblMenuClass::RequestSubLoad (ausvcontainer,
				vunames_AUSV);

    alarmOnManual = vuCheckBoxClass::RequestSubLoad (this,
				vunames_ALMA);
    vcontainer *masvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpMASVContainer);
    manualSeverity = vuChoiceGblMenuClass::RequestSubLoad (masvcontainer,
				vunames_MASV);

    vcontainer *motcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpMOTMContainer);
    minOffTime = filteredTextitem::RequestSubLoad (motcontainer,
				vunames_MOTM);

    vcontainer *prrtcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpPRRTContainer);
    runTimePrecision = spinnerClass::RequestSubLoad (prrtcontainer,
				vunames_PRRT);

    vcontainer *exoncontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpEXONContainer);
    startTime = filteredTextitem::RequestSubLoad (exoncontainer,
				vunames_EXON);
    vcontainer *sadbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSADBContainer);
    startTimeDeadband = filteredTextitem::RequestSubLoad (sadbcontainer,
				vunames_SADB);
    vcontainer *stsvcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSTSVContainer);
    startTimeSeverity = vuChoiceGblMenuClass::RequestSubLoad (stsvcontainer,
				vunames_STSV);

    vcontainer *exofcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpEXOFContainer);
    stopTime = filteredTextitem::RequestSubLoad (exofcontainer,
				vunames_EXOF);
    vcontainer *stdbcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSTDBContainer);
    stopTimeDeadband = filteredTextitem::RequestSubLoad (stdbcontainer,
				vunames_STDB);
    vcontainer *spvscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpSPVSContainer);
    stopTimeSeverity = vuChoiceGblMenuClass::RequestSubLoad (spvscontainer,
				vunames_SPVS);

    vcontainer *alarmdiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (alarmdiscontainer,
				vunames_vuPumpADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (alarmdiscontainer,
				vunames_ADIS);

    vcontainer *alrmgrpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuPumpALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (alrmgrpcontainer,
				vunames_ALGP);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    startPVButton -> storePvName (startPV);
    stopPVButton -> storePvName (stopPV);
    remoteLocalPVButton -> storePvName (remoteLocalPV);
    temperaturePVButton -> storePvName (temperaturePV);
    vibrationPVButton -> storePvName (vibrationPV);
    pressurePVButton -> storePvName (pressurePV);
    permissivePVButton -> storePvName (permissivePV);
    runConfirmPVButton -> storePvName (runConfirmPV);
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters
    startCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    stopCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    remoteStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    localStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    runningStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    startingStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    stoppedStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    stoppingStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    faultStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    minOffStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    minOffTime -> SetItemFilterFunc (floatFilter);
    startTime -> SetItemFilterFunc (floatFilter);
    startTimeDeadband -> SetItemFilterFunc (floatFilter);
    stopTime -> SetItemFilterFunc (floatFilter);
    stopTimeDeadband -> SetItemFilterFunc (floatFilter);

    startPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *stpvText = (filteredText *)startPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    stpvText -> SetUserPtr ((void *)startPV);

    stopPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *stppvText = (filteredText *)stopPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    stppvText -> SetUserPtr ((void *)stopPV);

    remoteLocalPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *rlText = (filteredText *)remoteLocalPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    rlText -> SetUserPtr ((void *)remoteLocalPV);

    temperaturePV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *tempText = (filteredText *)temperaturePV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    tempText -> SetUserPtr ((void *)temperaturePV);

    vibrationPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *vibText = (filteredText *)vibrationPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    vibText -> SetUserPtr ((void *)vibrationPV);

    pressurePV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *pressText = (filteredText *)pressurePV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    pressText -> SetUserPtr ((void *)pressurePV);

    permissivePV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *permText = (filteredText *)permissivePV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    permText -> SetUserPtr ((void *)permissivePV);

    runConfirmPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *rcText = (filteredText *)runConfirmPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    rcText -> SetUserPtr ((void *)runConfirmPV);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *alrmDisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alrmDisText -> SetUserPtr ((void *)alarmDisable);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    // build popup menus
    mode -> vuBuildOptionMenu (GBL_TF_AUTO_MAN_LOCK);
    autoSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    manualSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    startTimeSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    stopTimeSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);

}

/*******************************************************************
*
*    vuPumpContainerClass override for destructor
*
*******************************************************************/

void vuPumpContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}
