#ifndef vureseditdialogclassHXX
#define vureseditdialogclassHXX

class vuResOkButtonClass;
class vuResDismissButtonClass;
class vuResDelButtonClass;
class vuResListClass;

// *** Resource Editor DIALOG CLASS *****************************************
//  GCT 11-Aug-1997

class  vuResEditDialogClass : public vdialog
{
    vresource	reseditResource;
    int		singleSelect;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuResEditDialogClass);

    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuResEditDialogClass, vdialog);

    // override to load dialog
    void LoadInit(vresource res);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override 
    void Destroy ();

    void vuResEditOpen(vuMainDialogClass *mainDialog);	

private:

    vuResOkButtonClass		*okButton;
    vuResDismissButtonClass	*dismissButton;
    vuResDelButtonClass		*delButton;

public:

    DB_FIELD_PTR	pRes,pIOC1,pIOC2,pDPA;
    vuDatabaseClass	*db;
    vuMainDialogClass	*mainDialog;
    vuResListClass	*resList;
    vcontrolToggle	*dpaToggle;
    filteredTextitem	*resName;
    filteredTextitem	*resIOC1;
    filteredTextitem	*resIOC2;

};


// *** ResEdit OK BUTTON CLASS ************************************************

class vuResOkButtonClass : public vbutton
{
    vuResEditDialogClass	*reseditDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuResOkButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuResOkButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle almGrpSelDialog
    void vuSetResEditDialog (vuResEditDialogClass *dialog) 
	{ reseditDialog = dialog; }
};


// *** ResEdit DISMISS BUTTON CLASS *******************************************

class vuResDismissButtonClass : public vbutton
{
    vuResEditDialogClass	*reseditDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuResDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuResDismissButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle reseditDialog
    void vuSetResEditDialog (vuResEditDialogClass *dialog) 
	{ reseditDialog = dialog; }
};


// *** Resource Editor DELETE BUTTON CLASS ***********************************

class vuResDelButtonClass : public vbutton
{
    vuResEditDialogClass	*reseditDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuResDelButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuResDelButtonClass, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    // functions to handle reseditDialog
    void vuSetResEditDialog (vuResEditDialogClass *dialog) 
	{ reseditDialog = dialog; }
};


// *** Resource Editor LIST CLASS *******************************************

class vuResListClass : public vlistview
{
    vuResEditDialogClass	*reseditDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuResListClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuResListClass, vlistview);

    // overide this so we can tell when a selection has changed
    void ObserveSelect(int state);

    // function to handle reseditDialog
    void vuSetResEditDialog(vuResEditDialogClass *dialog) 
	{reseditDialog = dialog;}
};

#endif vureseditdialogclassHXX

