#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "choiceAcc.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuSigDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuSigDialogClass, vuCommonDialogClass, "vuSigDialogClass");

/*******************************************************************
*
*    vuSigDialogClass override for constructors init ()
*
*******************************************************************/

void vuSigDialogClass::LoadInit (vresource res)
{
    // load in the acc specific fields
    sigContainer = vuSigContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    sigContainer -> input -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> processInput -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> maximizeSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> precision -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> eguTag -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> rocSamples -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> manual -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> useFixed -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> monitorDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> archiveDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> alarmDeadband -> SetTextModifiedPtr (&this -> dialogModified);

    sigContainer -> x1 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x1 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y2 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y2 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x3 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y3 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x4 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y4 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x5 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y5 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x6 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y6 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x7 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y7 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x8 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y8 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x9 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y9 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x10 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y10 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x11 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y11 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x12 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y12 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x13 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y13 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x14 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y14 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x15 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y15 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> x16 -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> y16 -> SetTextModifiedPtr (&this -> dialogModified);

    sigContainer -> displayLow -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> displayHigh -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> devSetpt -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> numberValues -> SetModifiedPtr (&this -> dialogModified);

    sigContainer -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> alarmDelay -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);

    sigContainer -> hihiLimit -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> highLimit -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> lowLimit -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> loloLimit -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> fixedLowLimit -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> fixedHighLimit -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> rocLimit -> SetTextModifiedPtr (&this -> dialogModified);
    sigContainer -> devLimit -> SetTextModifiedPtr (&this -> dialogModified);

    sigContainer -> hihiSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> highSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> lowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> loloSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> fixedLowSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> fixedHighSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> rocSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    sigContainer -> devSeverity -> vuSetModifiedPtr (&this -> dialogModified);


    // store ptr to dialog for vuPvNameButtonClass
    sigContainer -> inputButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    sigContainer -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuPvNameFilter
    sigContainer -> input -> storeCommonDialog ((vuCommonDialogClass *)this);
    sigContainer -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuAlarmGroupFilter
    sigContainer -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_SIGCHAR);

    // get the title from the resource file, sigTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    sigTitle = vresourceGetString (dialogTitles, 
				vunames_vuSigDialogTitle);
    SetTitle (sigTitle);

    // load up the sig values dialog
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource sigValuesDialogRes = vresourceGet (pointDictRes, 
				vunames_vuSigValDialog);
    valuesDialog = new vuSigValuesDialogClass (sigValuesDialogRes);

    // store ptr to sig values  dialog and sig dialog in the values button
    sigContainer -> valuesButton -> storeSigDialog (this);
    sigContainer -> valuesButton -> storeSigValuesDialog (valuesDialog);

    // save modify pointer in sig values dialog fields

    valuesDialog -> x17 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y17 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x18 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y18 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x19 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y19 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x20 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y20 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x21 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y21 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x22 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y22 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x23 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y23 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x24 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y24 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x25 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y25 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x26 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y26 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x27 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y27 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x28 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y28 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x29 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y29 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x30 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y30 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x31 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y31 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> x32 -> SetTextModifiedPtr (&this -> dialogModified);
    valuesDialog -> y32 -> SetTextModifiedPtr (&this -> dialogModified);
}


/*******************************************************************
*
*    vuSigDialogClass Destroy function
*
*******************************************************************/

void vuSigDialogClass::Destroy (void)
{
    vstrDestroy (sigTitle);
    // delete the sig values dialog
    delete valuesDialog;
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuSigDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuSigDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    int			firstTimeFlag;
    int			inDialogFlag;

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    firstTimeFlag = xrefNode -> getFirstTimeFlag ();
	    // only need to do this once
	    if (firstTimeFlag == vTRUE)
	    {
		xrefNode -> setFirstTimeFlag (vFALSE);
		// find which dialog this field is in
		dialogItem = vuFindContainerItem (sigContainer, epics);
		if (dialogItem == NULL)
		{
		    dialogItem = vuFindDialogItem (valuesDialog, epics);
		    if (dialogItem == NULL)
		    {
			xrefNode -> setInDialogFlag (VU_SIG_NOT_IN_DIALOG);
			continue;
		    }
		    else
		    {
			xrefNode -> setInDialogFlag (VU_SIG_VALUES_DIALOG);
		    }
		}
		else
		{
		    xrefNode -> setInDialogFlag (VU_SIG_IN_MAIN_DIALOG);
		}
	    }
	    else
	    {
		inDialogFlag = xrefNode -> getInDialogFlag ();
		dialogItem = NULL;
		switch (inDialogFlag)
		{
		    case VU_SIG_NOT_IN_DIALOG:
			break;

		    case VU_SIG_IN_MAIN_DIALOG:
			dialogItem = vuFindContainerItem (sigContainer, epics);
			break;

		    case VU_SIG_VALUES_DIALOG:
			dialogItem = vuFindDialogItem (valuesDialog, epics);
			break;

		    default:
			break;
		}
	    }
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;

		// set the default value for the archive deadband field
		if ( (vcharCompareBounded (epics, "ADEL", FLDNAME_SZ)) == 0)
		{
		    vstr *adel = vresourceGetString (defRes, 
						vunames_vuADELdefault);
		    textItem -> SetText (adel);
		    vstrDestroy (adel);
		}
		else if ( (vcharCompareBounded (epics, "PREC", FLDNAME_SZ)) == 0)
		{
		    vstr *precision = vresourceGetString (defRes, 
						vunames_vuPRECdefault);
		    textItem -> SetText (precision);
		    vstrDestroy (precision);
		}
		else if ( ((vcharCompareBounded (epics, "X1  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y1  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X2  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y2  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X3  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y3  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X4  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y4  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X5  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y5  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X6  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y6  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X7  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y7  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X8  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y8  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X9  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y9  ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X10 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y10 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X11 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y11 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X12 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y12 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X13 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y13 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X14 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y14 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X15 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y15 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X16 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y16 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X17 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y17 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X18 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y18 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X19 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y19 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X20 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y20 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X21 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y21 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X22 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y22 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X23 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y23 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X24 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y24 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X25 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y25 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X26 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y26 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X27 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y27 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X28 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y28 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X29 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y29 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X30 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y30 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X31 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y31 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "X32 ", FLDNAME_SZ)) == 0) ||
			  ((vcharCompareBounded (epics, "Y32 ", FLDNAME_SZ)) == 0) )
		{
		    vstr *zero = vresourceGetString (defRes, 
						vunames_vuZeroDefault);
		    textItem -> SetText (zero);
		    vstrDestroy (zero);
		}
		else
		{
		    textItem -> SetTextScribed (vcharScribeSystem (""));
		}
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (spinner -> GetMin());
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function with proper point index
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuSigDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;

    char		pvName [PVNAME_SZ + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;
    int			inDialogFlag;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT an SIG
	if (ptType != VU_SIGCHAR)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_SIGCHAR);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    lastTable = xrefNode -> xrefTable;
	    inDialogFlag = xrefNode -> getInDialogFlag ();
	    dialogItem = NULL;
	    switch (inDialogFlag)
	    {
		case VU_SIG_NOT_IN_DIALOG:
		    break;

		case VU_SIG_IN_MAIN_DIALOG:
		    dialogItem = vuFindContainerItem (sigContainer, epics);
		    break;

		case VU_SIG_VALUES_DIALOG:
		    dialogItem = vuFindDialogItem (valuesDialog, epics);
		    break;

		default:
		    break;
	    }
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
	    {
		spinner = (vspinner *)dialogItem;
		spinner -> SetValue (vnum::ParseInt (finalValue, NULL));
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuSigDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vspinner		*spinner;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;

    char		pvName [PVNAME_SZ + 1];
    DB_FIELD_PTR	putField;
    DB_FIELD_PTR	freezeSeverity, freezeRunSeverity;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;
    int			inDialogFlag;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    lastTable = NULL;
    freezeSeverity = 0;
    freezeRunSeverity = 0;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if (lastTable != xrefNode -> xrefTable)
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
			pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    inDialogFlag = xrefNode -> getInDialogFlag ();
	    dialogItem = NULL;
	    switch (inDialogFlag)
	    {
		case VU_SIG_NOT_IN_DIALOG:
		    break;

		case VU_SIG_IN_MAIN_DIALOG:
		    dialogItem = vuFindContainerItem (sigContainer, epics);
		    break;

		case VU_SIG_VALUES_DIALOG:
		    dialogItem = vuFindDialogItem (valuesDialog, epics);
		    break;

		default:
		    break;
	    }
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    if ( (dialogItem -> IsKindOf (&vspinner::Kind)) == vTRUE)
		    {
			spinner = (vspinner *)dialogItem;
			// buf fix, spinner mau not have proper value
			spinner -> Unfocus ();
			stringValue = spinner -> GetTextAsString ();
		    }
		    else
		    {
			textItem = (vtextitem *)dialogItem;
			stringValue = textItem -> GetTextAsString ();
		    }
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_INLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


vkindTYPED_FULL_DEFINITION(vuSigContainerClass, vcontainer, "vuSigContainerClass");

/*******************************************************************
*
*    vuSigContainerClass override for constructor
*
*******************************************************************/

void vuSigContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuSigCharContainer);


    vcontainer *inpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigINPContainer);
    inputButton = vuPvNameButtonClass::RequestSubLoad (inpcontainer,
				vunames_vuSigINPButton);
    input = vuFilteredTextitem::RequestSubLoad (inpcontainer,
				vunames_INP);

    processInput = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCI);

    maximizeSeverity = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MAXS);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
				vunames_AENB);

    vcontainer *precontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigPRECContainer);
    precision = filteredTextitem::RequestSubLoad (precontainer,
				vunames_PREC);

    vcontainer *egucontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigEGUContainer);
    eguTag = filteredTextitem::RequestSubLoad (egucontainer,
				vunames_EGU);

    vcontainer *roccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigROCNContainer);
    rocSamples = filteredTextitem::RequestSubLoad (roccontainer,
				vunames_ROCN);

    manual = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MODE);

    useFixed = vuCheckBoxClass::RequestSubLoad (this,
				vunames_USEF);

    vcontainer *mdelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigMDELContainer);
    monitorDeadband = filteredTextitem::RequestSubLoad (mdelcontainer,
				vunames_MDEL);

    vcontainer *adelcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigADELContainer);
    archiveDeadband = filteredTextitem::RequestSubLoad (adelcontainer,
				vunames_ADEL);

    vcontainer *hystcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigHYSTContainer);
    alarmDeadband = filteredTextitem::RequestSubLoad (hystcontainer,
				vunames_HYST);

    vcontainer *x1container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX1Container);
    x1 = filteredTextitem::RequestSubLoad (x1container,
				vunames_X1);
    vcontainer *y1container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY1Container);
    y1 = filteredTextitem::RequestSubLoad (y1container,
				vunames_Y1);

    vcontainer *x2container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX2Container);
    x2 = filteredTextitem::RequestSubLoad (x2container,
				vunames_X2);
    vcontainer *y2container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY2Container);
    y2 = filteredTextitem::RequestSubLoad (y2container,
				vunames_Y2);

    vcontainer *x3container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX3Container);
    x3 = filteredTextitem::RequestSubLoad (x3container,
				vunames_X3);
    vcontainer *y3container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY3Container);
    y3 = filteredTextitem::RequestSubLoad (y3container,
				vunames_Y3);

    vcontainer *x4container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX4Container);
    x4 = filteredTextitem::RequestSubLoad (x4container,
				vunames_X4);
    vcontainer *y4container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY4Container);
    y4 = filteredTextitem::RequestSubLoad (y4container,
				vunames_Y4);

    vcontainer *x5container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX5Container);
    x5 = filteredTextitem::RequestSubLoad (x5container,
				vunames_X5);
    vcontainer *y5container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY5Container);
    y5 = filteredTextitem::RequestSubLoad (y5container,
				vunames_Y5);

    vcontainer *x6container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX6Container);
    x6 = filteredTextitem::RequestSubLoad (x6container,
				vunames_X6);
    vcontainer *y6container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY6Container);
    y6 = filteredTextitem::RequestSubLoad (y6container,
				vunames_Y6);

    vcontainer *x7container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX7Container);
    x7 = filteredTextitem::RequestSubLoad (x7container,
				vunames_X7);
    vcontainer *y7container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY7Container);
    y7 = filteredTextitem::RequestSubLoad (y7container,
				vunames_Y7);

    vcontainer *x8container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX8Container);
    x8 = filteredTextitem::RequestSubLoad (x8container,
				vunames_X8);
    vcontainer *y8container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY8Container);
    y8 = filteredTextitem::RequestSubLoad (y8container,
				vunames_Y8);

    vcontainer *x9container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX9Container);
    x9 = filteredTextitem::RequestSubLoad (x9container,
				vunames_X9);
    vcontainer *y9container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY9Container);
    y9 = filteredTextitem::RequestSubLoad (y9container,
				vunames_Y9);

    vcontainer *x10container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX10Container);
    x10 = filteredTextitem::RequestSubLoad (x10container,
				vunames_X10);
    vcontainer *y10container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY10Container);
    y10 = filteredTextitem::RequestSubLoad (y10container,
				vunames_Y10);

    vcontainer *x11container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX11Container);
    x11 = filteredTextitem::RequestSubLoad (x11container,
				vunames_X11);
    vcontainer *y11container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY11Container);
    y11 = filteredTextitem::RequestSubLoad (y11container,
				vunames_Y11);

    vcontainer *x12container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX12Container);
    x12 = filteredTextitem::RequestSubLoad (x12container,
				vunames_X12);
    vcontainer *y12container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY12Container);
    y12 = filteredTextitem::RequestSubLoad (y12container,
				vunames_Y12);

    vcontainer *x13container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX13Container);
    x13 = filteredTextitem::RequestSubLoad (x13container,
				vunames_X13);
    vcontainer *y13container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY13Container);
    y13 = filteredTextitem::RequestSubLoad (y13container,
				vunames_Y13);

    vcontainer *x14container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX14Container);
    x14 = filteredTextitem::RequestSubLoad (x14container,
				vunames_X14);
    vcontainer *y14container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY14Container);
    y14 = filteredTextitem::RequestSubLoad (y14container,
				vunames_Y14);

    vcontainer *x15container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX15Container);
    x15 = filteredTextitem::RequestSubLoad (x15container,
				vunames_X15);
    vcontainer *y15container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY15Container);
    y15 = filteredTextitem::RequestSubLoad (y15container,
				vunames_Y15);

    vcontainer *x16container = vcontainer::RequestSubLoad (this,
				vunames_vuSigX16Container);
    x16 = filteredTextitem::RequestSubLoad (x16container,
				vunames_X16);
    vcontainer *y16container = vcontainer::RequestSubLoad (this,
				vunames_vuSigY16Container);
    y16 = filteredTextitem::RequestSubLoad (y16container,
				vunames_Y16);

    vcontainer *loprcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigLOPRContainer);
    displayLow = filteredTextitem::RequestSubLoad (loprcontainer,
				vunames_LOPR);

    vcontainer *hoprcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigHOPRContainer);
    displayHigh = filteredTextitem::RequestSubLoad (hoprcontainer,
				vunames_HOPR);

    vcontainer *devscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigDEVSContainer);
    devSetpt = filteredTextitem::RequestSubLoad (devscontainer,
				vunames_DEVS);

    vcontainer *numxcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigNUMXContainer);
    numberValues = spinnerClass::RequestSubLoad (numxcontainer,
				vunames_NUMX);

    vcontainer *algpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (algpcontainer,
				vunames_ALGP);

    vcontainer *aldlcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigALDLContainer);
    alarmDelay = filteredTextitem::RequestSubLoad (aldlcontainer,
				vunames_ALDL);

    vcontainer *adiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (adiscontainer,
				vunames_vuSigADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (adiscontainer,
				vunames_ADIS);

    vcontainer *alarmcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuSigAlarmContainer);

    vcontainer *hihicontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigHIHIContainer);
    hihiLimit = filteredTextitem::RequestSubLoad (hihicontainer,
				vunames_HIHI);

    vcontainer *hhsvcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigHHSVContainer);
    hihiSeverity = vuChoiceGblMenuClass::RequestSubLoad (hhsvcontainer,
				vunames_HHSV);

    vcontainer *highcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigHIGHContainer);
    highLimit = filteredTextitem::RequestSubLoad (highcontainer,
				vunames_HIGH);

    vcontainer *hsvcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigHSVContainer);
    highSeverity = vuChoiceGblMenuClass::RequestSubLoad (hsvcontainer,
				vunames_HSV);

    vcontainer *lowcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigLOWContainer);
    lowLimit = filteredTextitem::RequestSubLoad (lowcontainer,
				vunames_LOW);

    vcontainer *lsvcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigLSVContainer);
    lowSeverity = vuChoiceGblMenuClass::RequestSubLoad (lsvcontainer,
				vunames_LSV);

    vcontainer *lolocontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigLOLOContainer);
    loloLimit = filteredTextitem::RequestSubLoad (lolocontainer,
				vunames_LOLO);

    vcontainer *llsvcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigLLSVContainer);
    loloSeverity = vuChoiceGblMenuClass::RequestSubLoad (llsvcontainer,
				vunames_LLSV);

    vcontainer *xlowcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigXLOWContainer);
    fixedLowLimit = filteredTextitem::RequestSubLoad (xlowcontainer,
				vunames_XLOW);
    vcontainer *flsvcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigFLSVContainer);
    fixedLowSeverity = vuChoiceGblMenuClass::RequestSubLoad (flsvcontainer,
				vunames_FLSV);

    vcontainer *xhghcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigXHGHContainer);
    fixedHighLimit = filteredTextitem::RequestSubLoad (xhghcontainer,
				vunames_XHGH);
    vcontainer *fhsvcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigFHSVContainer);
    fixedHighSeverity = vuChoiceGblMenuClass::RequestSubLoad (fhsvcontainer,
				vunames_FHSV);

    vcontainer *roclimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigROCContainer);
    rocLimit = filteredTextitem::RequestSubLoad (roclimcontainer,
				vunames_ROC);
    vcontainer *rocsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigRCSVContainer);
    rocSeverity = vuChoiceGblMenuClass::RequestSubLoad (rocsevcontainer,
				vunames_RCSV);

    vcontainer *devlimcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigDEVLContainer);
    devLimit = filteredTextitem::RequestSubLoad (devlimcontainer,
				vunames_DEVL);
    vcontainer *devsevcontainer = vcontainer::RequestSubLoad (alarmcontainer,
				vunames_vuSigDVSVContainer);
    devSeverity = vuChoiceGblMenuClass::RequestSubLoad (devsevcontainer,
				vunames_DVSV);

    valuesButton = vuSigValuesButtonClass::RequestSubLoad (this,
				vunames_vuSigValuesButton);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvnameButtonClass
    inputButton -> storePvName (input);
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters

    input -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *inpText = (filteredText *)input -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    inpText -> SetUserPtr ((void *)input);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *adisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    adisText -> SetUserPtr ((void *)alarmDisable);

    precision -> SetItemFilterFunc (numericFilter);
    eguTag -> SetItemFilterFunc (egutagFilter);
    rocSamples -> SetItemFilterFunc (numericFilter);
    monitorDeadband -> SetItemFilterFunc (floatFilter);
    archiveDeadband -> SetItemFilterFunc (floatFilter);
    alarmDeadband -> SetItemFilterFunc (floatFilter);
    displayLow -> SetItemFilterFunc (floatFilter);
    displayHigh -> SetItemFilterFunc (floatFilter);
    devSetpt -> SetItemFilterFunc (floatFilter);
    alarmDelay -> SetItemFilterFunc (numericFilter);

    x1 -> SetItemFilterFunc (floatFilter);
    y1 -> SetItemFilterFunc (floatFilter);
    x2 -> SetItemFilterFunc (floatFilter);
    y2 -> SetItemFilterFunc (floatFilter);
    x3 -> SetItemFilterFunc (floatFilter);
    y3 -> SetItemFilterFunc (floatFilter);
    x4 -> SetItemFilterFunc (floatFilter);
    y4 -> SetItemFilterFunc (floatFilter);
    x5 -> SetItemFilterFunc (floatFilter);
    y5 -> SetItemFilterFunc (floatFilter);
    x6 -> SetItemFilterFunc (floatFilter);
    y6 -> SetItemFilterFunc (floatFilter);
    x7 -> SetItemFilterFunc (floatFilter);
    y7 -> SetItemFilterFunc (floatFilter);
    x8 -> SetItemFilterFunc (floatFilter);
    y8 -> SetItemFilterFunc (floatFilter);
    x9 -> SetItemFilterFunc (floatFilter);
    y9 -> SetItemFilterFunc (floatFilter);
    x10 -> SetItemFilterFunc (floatFilter);
    y10 -> SetItemFilterFunc (floatFilter);
    x11 -> SetItemFilterFunc (floatFilter);
    y11 -> SetItemFilterFunc (floatFilter);
    x12 -> SetItemFilterFunc (floatFilter);
    y12 -> SetItemFilterFunc (floatFilter);
    x13 -> SetItemFilterFunc (floatFilter);
    y13 -> SetItemFilterFunc (floatFilter);
    x14 -> SetItemFilterFunc (floatFilter);
    y14 -> SetItemFilterFunc (floatFilter);
    x15 -> SetItemFilterFunc (floatFilter);
    y15 -> SetItemFilterFunc (floatFilter);
    x16 -> SetItemFilterFunc (floatFilter);
    y16 -> SetItemFilterFunc (floatFilter);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    hihiLimit -> SetItemFilterFunc (floatFilter);
    highLimit -> SetItemFilterFunc (floatFilter);
    lowLimit -> SetItemFilterFunc (floatFilter);
    loloLimit -> SetItemFilterFunc (floatFilter);
    fixedLowLimit -> SetItemFilterFunc (floatFilter);
    fixedHighLimit -> SetItemFilterFunc (floatFilter);
    rocLimit -> SetItemFilterFunc (floatFilter);
    devLimit -> SetItemFilterFunc (floatFilter);

    // build pop-up menus
    hihiSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    highSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    lowSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    loloSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    fixedLowSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    fixedHighSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    rocSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    devSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
}

/*******************************************************************
*
*    vuSigContainerClass override for destructor
*
*******************************************************************/

void vuSigContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}


/*******************************************************************
*
*    vuSigValuesButtonClass observer
*	open the values dialog and wait here until finished
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuSigValuesButtonClass, vbutton, 
					"vuSigValuesButtonClass");

void vuSigValuesButtonClass::ObserveDialogItem (vevent *event)
{
    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    sigValuesDialog -> Place (sigDialog, vrectPLACE_CENTER, vrectPLACE_CENTER);
    sigValuesDialog -> Open();
    MakeTopMostDialog (sigValuesDialog, NULL);
    vevent::Process ();
}


/*******************************************************************
*
*    vuSigValuesDialogClass
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuSigValuesDialogClass, vdialog, 
					"vuSigValuesDialogClass");

/*******************************************************************
*
*    vuSigValuesDialogClass override for constructors init ()
*
*******************************************************************/

void vuSigValuesDialogClass::LoadInit (vresource res)
{

    vcontainer *x17container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX17Container);
    x17 = filteredTextitem::RequestSubLoad (x17container,
				vunames_X17);
    vcontainer *y17container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY17Container);
    y17 = filteredTextitem::RequestSubLoad (y17container,
				vunames_Y17);

    vcontainer *x18container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX18Container);
    x18 = filteredTextitem::RequestSubLoad (x18container,
				vunames_X18);
    vcontainer *y18container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY18Container);
    y18 = filteredTextitem::RequestSubLoad (y18container,
				vunames_Y18);

    vcontainer *x19container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX19Container);
    x19 = filteredTextitem::RequestSubLoad (x19container,
				vunames_X19);
    vcontainer *y19container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY19Container);
    y19 = filteredTextitem::RequestSubLoad (y19container,
				vunames_Y19);

    vcontainer *x20container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX20Container);
    x20 = filteredTextitem::RequestSubLoad (x20container,
				vunames_X20);
    vcontainer *y20container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY20Container);
    y20 = filteredTextitem::RequestSubLoad (y20container,
				vunames_Y20);

    vcontainer *x21container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX21Container);
    x21 = filteredTextitem::RequestSubLoad (x21container,
				vunames_X21);
    vcontainer *y21container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY21Container);
    y21 = filteredTextitem::RequestSubLoad (y21container,
				vunames_Y21);

    vcontainer *x22container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX22Container);
    x22 = filteredTextitem::RequestSubLoad (x22container,
				vunames_X22);
    vcontainer *y22container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY22Container);
    y22 = filteredTextitem::RequestSubLoad (y22container,
				vunames_Y22);

    vcontainer *x23container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX23Container);
    x23 = filteredTextitem::RequestSubLoad (x23container,
				vunames_X23);
    vcontainer *y23container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY23Container);
    y23 = filteredTextitem::RequestSubLoad (y23container,
				vunames_Y23);

    vcontainer *x24container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX24Container);
    x24 = filteredTextitem::RequestSubLoad (x24container,
				vunames_X24);
    vcontainer *y24container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY24Container);
    y24 = filteredTextitem::RequestSubLoad (y24container,
				vunames_Y24);

    vcontainer *x25container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX25Container);
    x25 = filteredTextitem::RequestSubLoad (x25container,
				vunames_X25);
    vcontainer *y25container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY25Container);
    y25 = filteredTextitem::RequestSubLoad (y25container,
				vunames_Y25);

    vcontainer *x26container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX26Container);
    x26 = filteredTextitem::RequestSubLoad (x26container,
				vunames_X26);
    vcontainer *y26container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY26Container);
    y26 = filteredTextitem::RequestSubLoad (y26container,
				vunames_Y26);

    vcontainer *x27container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX27Container);
    x27 = filteredTextitem::RequestSubLoad (x27container,
				vunames_X27);
    vcontainer *y27container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY27Container);
    y27 = filteredTextitem::RequestSubLoad (y27container,
				vunames_Y27);

    vcontainer *x28container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX28Container);
    x28 = filteredTextitem::RequestSubLoad (x28container,
				vunames_X28);
    vcontainer *y28container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY28Container);
    y28 = filteredTextitem::RequestSubLoad (y28container,
				vunames_Y28);

    vcontainer *x29container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX29Container);
    x29 = filteredTextitem::RequestSubLoad (x29container,
				vunames_X29);
    vcontainer *y29container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY29Container);
    y29 = filteredTextitem::RequestSubLoad (y29container,
				vunames_Y29);

    vcontainer *x30container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX30Container);
    x30 = filteredTextitem::RequestSubLoad (x30container,
				vunames_X30);
    vcontainer *y30container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY30Container);
    y30 = filteredTextitem::RequestSubLoad (y30container,
				vunames_Y30);

    vcontainer *x31container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX31Container);
    x31 = filteredTextitem::RequestSubLoad (x31container,
				vunames_X31);
    vcontainer *y31container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY31Container);
    y31 = filteredTextitem::RequestSubLoad (y31container,
				vunames_Y31);

    vcontainer *x32container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValX32Container);
    x32 = filteredTextitem::RequestSubLoad (x32container,
				vunames_X32);
    vcontainer *y32container = vcontainer::RequestSubLoad (this,
				vunames_vuSigValY32Container);
    y32 = filteredTextitem::RequestSubLoad (y32container,
				vunames_Y32);

    dismissButton = vuSigValuesDismissButtonClass::RequestSubLoad (this,
				vunames_vuSigValuesDismissButton);

    vdialog::LoadInit (res);


    // set filters
    x17 -> SetItemFilterFunc (floatFilter);
    y17 -> SetItemFilterFunc (floatFilter);
    x18 -> SetItemFilterFunc (floatFilter);
    y18 -> SetItemFilterFunc (floatFilter);
    x19 -> SetItemFilterFunc (floatFilter);
    y19 -> SetItemFilterFunc (floatFilter);
    x20 -> SetItemFilterFunc (floatFilter);
    y20 -> SetItemFilterFunc (floatFilter);
    x21 -> SetItemFilterFunc (floatFilter);
    y21 -> SetItemFilterFunc (floatFilter);
    x22 -> SetItemFilterFunc (floatFilter);
    y22 -> SetItemFilterFunc (floatFilter);
    x23 -> SetItemFilterFunc (floatFilter);
    y23 -> SetItemFilterFunc (floatFilter);
    x24 -> SetItemFilterFunc (floatFilter);
    y24 -> SetItemFilterFunc (floatFilter);
    x25 -> SetItemFilterFunc (floatFilter);
    y25 -> SetItemFilterFunc (floatFilter);
    x26 -> SetItemFilterFunc (floatFilter);
    y26 -> SetItemFilterFunc (floatFilter);
    x27 -> SetItemFilterFunc (floatFilter);
    y27 -> SetItemFilterFunc (floatFilter);
    x28 -> SetItemFilterFunc (floatFilter);
    y28 -> SetItemFilterFunc (floatFilter);
    x29 -> SetItemFilterFunc (floatFilter);
    y29 -> SetItemFilterFunc (floatFilter);
    x30 -> SetItemFilterFunc (floatFilter);
    y30 -> SetItemFilterFunc (floatFilter);
    x31 -> SetItemFilterFunc (floatFilter);
    y31 -> SetItemFilterFunc (floatFilter);
    x32 -> SetItemFilterFunc (floatFilter);
    y32 -> SetItemFilterFunc (floatFilter);

    // store dialog pointer in dismiss button

    dismissButton -> storeSigValuesDialog (this);

}


/*******************************************************************
*
*    vuSigValuesDialogClass notify function
*
*******************************************************************/

void vuSigValuesDialogClass::ObserveWindow (vevent *event)
{
    if ( event -> GetType () == veventWINDOW_STATE && event -> IsClose ())
    {
	Close ();
	vevent::StopProcessing ();
    }
    else
    {
	MakeTopMostDialog (this, event);
    }
}


/*******************************************************************
*
*    vuSigValuesDialogClass notify function
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuSigValuesDismissButtonClass, vbutton, 
					"vuSigValuesDismissButtonClass");

void vuSigValuesDismissButtonClass::ObserveDialogItem (vevent *event)
{
    vuSigValuesDialogClass	*valuesDialog = getSigValuesDialog ();

    valuesDialog -> Close ();
    vevent::StopProcessing ();
}


