#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vstartupHEADER
#include vtextitemHEADER
#include vcontainerHEADER
#include vbuttonHEADER
#include vdictHEADER
#include vlimitsHEADER
#include vmemHEADER
#include vnumHEADER
#include vlistitemHEADER
#include vdateHEADER
#include vspinnerHEADER

extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "dbFldTypes.h"
#include "choiceGbl.h"
#include "choiceValve.h"
#include "DBDefines.h"
#include "DBCVerifyDefs.h"
#include "DBProto.h"
#include "dbRecDes.h"
}

#include "vunames.h"
#include "dataVu.hxx"
#include "vuMainDialogClass.hxx"
#include "vuDatabaseClass.hxx"
#include "vuCommonDialogClass.hxx"
#include "vuValveDialogClass.hxx"
#include "vuNavigatorDialogClass.hxx"
#include "vuUtils.hxx"


vkindTYPED_FULL_DEFINITION(vuValveDialogClass, vuCommonDialogClass, "vuValveDialogClass");

/*******************************************************************
*
*    vuValveDialogClass override for constructors init ()
*
*******************************************************************/

void vuValveDialogClass::LoadInit (vresource res)
{
    // load in the valve specific fields
    valveContainer = vuValveContainerClass::RequestSubLoad (this,
				vunames_vuCommonContainer);
    vuCommonDialogClass::LoadInit (res);

    // store dialog modified flag
    valveContainer -> openPV -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> closePV -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> openLimitPV -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> closeLimitPV -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> openTorquePV -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> closeTorquePV -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> remoteLocalPV -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> positionPV -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> drivePositionPV -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> faultMbbiPV -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> permissivePV -> SetTextModifiedPtr (&this -> dialogModified);

    valveContainer -> processOpen -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msOpen -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> processClose -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msClose -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> processOpenLimit -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msOpenLimit -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> openLimitInd -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> processCloseLimit -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msCloseLimit -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> closeLimitInd -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> processOpenTorque -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msOpenTorque -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> openTorqueInd -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> processCloseTorque -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msCloseTorque -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> closeTorqueInd -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> processRemoteLocal -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msRemoteLocal -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> processPosition -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msPosition -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> processDrivePosition -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msDrivePosition -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> processFaultMbbi -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msFaultMbbi -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> processPermissive -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> msPermissive -> vuSetModifiedPtr (&this -> dialogModified);

    valveContainer -> onScan -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> mode -> vuSetModifiedPtr (&this -> dialogModified);
    valveContainer -> emergencyStopAction -> vuSetModifiedPtr (&this -> dialogModified);

    valveContainer -> openCommand -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> closeCommand -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> jogOpenCommand -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> jogCloseCommand -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> reverseCommand -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> setPosCommand -> SetTextModifiedPtr (&this -> dialogModified);

    valveContainer -> openedStatus -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> closedStatus -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> openingStatus -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> closingStatus -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> faultStatus -> SetTextModifiedPtr (&this -> dialogModified);
    valveContainer -> unknownStatus -> SetTextModifiedPtr (&this -> dialogModified);

    // store dialog ptr for vuPvNameButtonClass
    valveContainer -> openPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> closePVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> openLimitPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> closeLimitPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> openTorquePVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> closeTorquePVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> remoteLocalPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> positionPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> drivePositionPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> faultMbbiPVButton -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> permissivePVButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store dialog ptr for vuPvNameFilter
    valveContainer -> openPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> closePV -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> openLimitPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> closeLimitPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> openTorquePV -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> closeTorquePV -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> remoteLocalPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> positionPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> drivePositionPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> faultMbbiPV -> storeCommonDialog ((vuCommonDialogClass *)this);
    valveContainer -> permissivePV -> storeCommonDialog ((vuCommonDialogClass *)this);

    // set the point type
    setPointType (VU_VALVE);

    // get the title from the resource file, biTitle must be
    // freed by the class destuctor
    vapplication *app = vapplication::GetCurrent ();
    vresource dialogTitles = vresourceGet (app -> GetResources (),
				vunames_vuDialogTitles);
    valveTitle = vresourceGetString (dialogTitles, 
				vunames_vuValveDialogTitle);
    SetTitle (valveTitle);

    // load up the the other VALVE dialogs
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);

    // load the alarm dialog
    vresource alarmDialogRes = vresourceGet (pointDictRes, vunames_vuValveAlarmDialog);
    alarmDialog = new vuValveAlarmDialogClass (alarmDialogRes);

    // store dialog ptr in alarm button
    valveContainer -> alarmButton -> storeValveAlarmDialog (alarmDialog);

    // store dialog modified flag in alarm fields
    alarmDialog -> openTimeLimit -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> openDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> openSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> closeTimeLimit -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> closeDeadband -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> closeSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> limitTorqueLag -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> limitTorqueLagSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> alarmOnAutomatic -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> autoSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> alarmOnManual -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> manualSeverity -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> onAlarm -> vuSetModifiedPtr (&this -> dialogModified);
    alarmDialog -> alarmGroup -> SetTextModifiedPtr (&this -> dialogModified);
    alarmDialog -> alarmDisable -> SetTextModifiedPtr (&this -> dialogModified);

    // store ptr to dialog for vuPvNameButtonClass for alarm dialog
    alarmDialog -> alarmDisableButton -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuPvNameFilter for alarm dialog
    alarmDialog -> alarmDisable -> storeCommonDialog ((vuCommonDialogClass *)this);

    // store ptr to dialog for vuAlarmGroupFilter for alarm dialog
    alarmDialog -> alarmGroup -> storeCommonDialog ((vuCommonDialogClass *)this);

    // load the misc dialog
    vresource miscDialogRes = vresourceGet (pointDictRes, vunames_vuValveMiscDialog);
    miscDialog = new vuValveMiscDialogClass (miscDialogRes);
    // store dialog in misc button
    valveContainer -> miscButton -> storeValveMiscDialog (miscDialog);

    // store dialog modified flag in misc fields
    miscDialog -> remoteStatus -> SetTextModifiedPtr (&this -> dialogModified);
    miscDialog -> localStatus -> SetTextModifiedPtr (&this -> dialogModified);
    miscDialog -> jogOpenTime -> SetTextModifiedPtr (&this -> dialogModified);
    miscDialog -> jogCloseTime -> SetTextModifiedPtr (&this -> dialogModified);
    miscDialog -> driveLow -> SetTextModifiedPtr (&this -> dialogModified);
    miscDialog -> driveHigh -> SetTextModifiedPtr (&this -> dialogModified);
    miscDialog -> displayLow -> SetTextModifiedPtr (&this -> dialogModified);
    miscDialog -> displayHigh -> SetTextModifiedPtr (&this -> dialogModified);
    miscDialog -> localTracking -> vuSetModifiedPtr (&this -> dialogModified);
    miscDialog -> learnMode -> vuSetModifiedPtr (&this -> dialogModified);
}


/*******************************************************************
*
*    vuValveDialogClass Destroy function
*
*******************************************************************/

void vuValveDialogClass::Destroy (void)
{
    vstrDestroy (valveTitle);
    // delete the other valve dialogs
    delete alarmDialog;
    delete miscDialog;
    vuCommonDialogClass::Destroy ();
}


/*******************************************************************
*
*    vuValveDialogClass, reset fields, overrides base class 
*	vuCommonDialogClass
*
*******************************************************************/

void vuValveDialogClass::resetDialog (void)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    int			firstTimeFlag;
    int			inDialogFlag;

    vresource defRes = mainDialog -> getDefaultsResource ();

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0; 
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	// if not a common dialog field
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    firstTimeFlag = xrefNode -> getFirstTimeFlag ();
	    // only need to do this once
	    if (firstTimeFlag == vTRUE)
	    {
		xrefNode -> setFirstTimeFlag (vFALSE);
		// find which dialog this field is in
		dialogItem = vuFindContainerItem (valveContainer, epics);
		if (dialogItem == NULL)
		{
		    dialogItem = vuFindDialogItem (alarmDialog, epics);
		    if (dialogItem == NULL)
		    {
			dialogItem = vuFindDialogItem (miscDialog, epics);
			if (dialogItem == NULL)
			{
			    xrefNode -> setInDialogFlag (VU_VALVE_NOT_IN_DIALOG);
			    continue;
			}
			else
			{
			    xrefNode -> setInDialogFlag (VU_VALVE_IN_MISC_DIALOG);
			}
		    }
		    else
		    {
			xrefNode -> setInDialogFlag (VU_VALVE_IN_ALARM_DIALOG);
		    }
		}
		else
		{
		    xrefNode -> setInDialogFlag (VU_VALVE_IN_MAIN_DIALOG);
		}
	    }
	    else
	    {
		inDialogFlag = xrefNode -> getInDialogFlag ();
		dialogItem = NULL;
		switch (inDialogFlag)
		{
		    case VU_VALVE_NOT_IN_DIALOG:
			break;

		    case VU_VALVE_IN_MAIN_DIALOG:
			dialogItem = vuFindContainerItem (valveContainer, epics);
			break;

		    case VU_VALVE_IN_ALARM_DIALOG:
			dialogItem = vuFindDialogItem (alarmDialog, epics);
			break;

		    case VU_VALVE_IN_MISC_DIALOG:
			dialogItem = vuFindDialogItem (miscDialog, epics);
			break;

		    default:
			break;
		}
	    }
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		toggleItem -> SetValue (0);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		optionMenu -> SetValue (0);
	    }
	}  // end if not in common dialog
    }
    iterator.Finish ();

    // call base class reset function 
    vuCommonDialogClass::resetDialog ();

    dialogModified = vFALSE;
}


/*******************************************************************
*
*    vuLoadDialog 
*
*******************************************************************/

void vuValveDialogClass::vuLoadDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*finalValue;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    int			dbaseType;	// codebase field type
    int			intValue;
    unsigned int	uIntValue;
    long		longValue;
    unsigned long	uLongValue;
    double		doubleValue;
    int			inDialogFlag;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

	sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
    pntRecord = DB_Seek (db -> vuPvmapTable, seekBuff);
    if (pntRecord == (DB_RECORD_PTR)0)
    {
	return;
    }
    else
    {
	int ptType;
	DB_GetFieldValue (pntRecord, db -> pvmapTypeField, dbValue, &dbaseType);
	ptType = vuGetPointTypeIndex ((char *)dbValue);
	// the point name in pvname field is NOT a VALVE
	if (ptType != VU_VALVE)
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTTYPEDIALOGERR,
				   pointName, ptType, VU_VALVE);
	    vuClearPvNameField ();
	    return;
	}
	// the point name entered in pvname field has been deleted
	if (DB_IsDeleted (db -> vuPvmapTable))
	{
	    vuMessageDialogCenter ((vdialog *)this, VU_PTISDELETEDERR, pointName);
	    vuClearPvNameField ();
	    return;
	}
    }
    // call base class vuLoadDialog first
    vuCommonDialogClass::vuLoadDialog (pointName);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    // only seek if table has changed or new xrefOpId
	    if ( (lastTable != xrefNode -> xrefTable) ||
		 (strlen (xrefNode -> xrefOpId) ) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;

	    inDialogFlag = xrefNode -> getInDialogFlag ();
	    dialogItem = NULL;
	    switch (inDialogFlag)
	    {
		case VU_VALVE_NOT_IN_DIALOG:
		    break;

		case VU_VALVE_IN_MAIN_DIALOG:
		    dialogItem = vuFindContainerItem (valveContainer, epics);
		    break;

		case VU_VALVE_IN_ALARM_DIALOG:
		    dialogItem = vuFindDialogItem (alarmDialog, epics);
		    break;

		case VU_VALVE_IN_MISC_DIALOG:
		    dialogItem = vuFindDialogItem (miscDialog, epics);
		    break;

		default:
		    break;
	    }
	
	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    DB_GetFieldValue (pntRecord, xrefNode -> xrefField, dbValue, &dbaseType);
	    doubleValue = 0.0;
	    // GetField actually returns a number in the char array
	    if ( (dbaseType == 'F') || (dbaseType == 'N') )
	    {
		doubleValue = *((double *)dbValue);
	    }
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		    intValue = (int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeInt (intValue));
		    break;

		case DBF_LONG:
		    longValue = (long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeLong (longValue));
		    break;

		case DBF_ENUM:
		case DBF_USHORT:
		    uIntValue = (unsigned int)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeUInt (uIntValue));
		    break;

		case DBF_ULONG:
		    uLongValue = (unsigned long)doubleValue;
		    finalValue = vstrCloneScribed (vnumScribeULong (uLongValue));
		    break;

		case DBF_FLOAT:
		case DBF_DOUBLE:
		    finalValue = vstrCloneScribed (vnumScribeFloat (doubleValue));
		    break;

		case DBF_STRING:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		    if (dbaseType == 'L')
		    {
			int	logical;

			logical = (*((char*)dbValue) ? 
					xrefNode -> xrefTrue : 
					(xrefNode -> xrefTrue ^1));
			finalValue = vstrCloneScribed (vnumScribeInt (logical));
			break;
		    }
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		case DBF_INLINK:
		case DBF_OUTLINK:
		    finalValue = vstrCloneScribed (vcharScribeSystem (dbValue));
		    break;

		default:
		    continue;
	    }
	    if ( (dialogItem -> IsKindOf (&vtextitem::Kind)) == vTRUE)
	    {
		textItem = (vtextitem *)dialogItem;
		textItem -> SetTextScribed (vcharScribeSystem (""));
		textItem -> SetText (finalValue);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolToggle::Kind)) == vTRUE)
	    {
		toggleItem = (vcontrolToggle *)dialogItem;
		if (finalValue[0] == '0')
		    toggleItem -> SetValue (0);
		else
		    toggleItem -> SetValue (1);
		vstrDestroy (finalValue);
	    }
	    else if ( (dialogItem -> IsKindOf (&vcontrolOptionMenu::Kind)) == vTRUE)
	    {
		optionMenu = (vcontrolOptionMenu *)dialogItem;
		vuSetOptionMenuValue (optionMenu, finalValue);
		vstrDestroy (finalValue);
	    }
	}  // end if not in commondialog
    }
    iterator.Finish ();

    setDialogModify (vFALSE);
}


/*******************************************************************
*
*    vuSaveDialog 
*
*******************************************************************/

void vuValveDialogClass::vuSaveDialog (vchar *pointName)
{
    vuMainDialogClass	*mainDialog = getMainDialog ();
    dataVuApplication	*app  = mainDialog -> getApplication ();
    vuDatabaseClass	*db   = app -> getDatabaseClass ();
    vdict		*dict = db -> getXrefDict (pointType);
    vdictIterator	iterator;
    vname		*epicsName;
    xrefNodeClass	*xrefNode;
    vdialogItem		*dialogItem;
    vtextitem		*textItem;
    vcontrolToggle	*toggleItem;
    vcontrolOptionMenu	*optionMenu;
    const vchar 	*optionMenuValue;
    vchar		epics[FLDNAME_SZ + 1];
    vstr		*stringValue;

    char		pvName [PVNAME_SZ + 1];
    char		key [VU_KEY_SIZE + 1];
    DB_FIELD_PTR	putField;
    DB_TABLE_PTR	lastTable;	// pointer to last table used
    DB_RECORD_PTR	pntRecord;	// codebase record ptr
    double		doubleValue;
    int			doSave;
    int			inDialogFlag;

    vcharExportBounded (vcharScribeSystemExport (pointName),
			pvName,
			PVNAME_SZ);

    lastTable = NULL;

    iterator.Start (dict);
    while ( iterator.Next ())
    {
	epicsName = (vname *)iterator.GetKey ();
	vmemSet (epics, ' ', sizeof (epics));
	vcharCopyBounded (epicsName, epics, FLDNAME_SZ);
	epics[sizeof (epics) - 1] = 0;
	xrefNode  = (xrefNodeClass *)iterator.GetValue ();
	if ( (xrefNode -> getInCommonDialog ()) == vFALSE)
	{
	    doSave = vTRUE;
	    // only seek if table has changed
	    if  ( (lastTable != xrefNode -> xrefTable) ||
		  (strlen (xrefNode -> xrefOpId)) )
	    {
		if (strlen (xrefNode -> xrefOpId))
		{
		    sprintf (key, "%-*.*s%-s\0", 
				   PVNAME_SZ, PVNAME_SZ, pvName,
				   xrefNode -> xrefOpId);
		    pntRecord=  DB_Seek (xrefNode -> xrefTable, key);
		}
		else
		{
		    sprintf (seekBuff, "%-*.*s\0", PVNAME_SZ, PVNAME_SZ, pvName);
		    pntRecord = DB_Seek (xrefNode -> xrefTable, seekBuff);
		}
	    }
	    lastTable = xrefNode -> xrefTable;

	    putField = xrefNode -> xrefField;

	    inDialogFlag = xrefNode -> getInDialogFlag ();
	    dialogItem = NULL;
	    switch (inDialogFlag)
	    {
		case VU_VALVE_NOT_IN_DIALOG:
		    break;

		case VU_VALVE_IN_MAIN_DIALOG:
		    dialogItem = vuFindContainerItem (valveContainer, epics);
		    break;

		case VU_VALVE_IN_ALARM_DIALOG:
		    dialogItem = vuFindDialogItem (alarmDialog, epics);
		    break;

		case VU_VALVE_IN_MISC_DIALOG:
		    dialogItem = vuFindDialogItem (miscDialog, epics);
		    break;

		default:
		    break;
	    }
	

	    if (dialogItem == NULL)
		continue;
	    if ( (dialogItem -> IsEnabled ()) == vFALSE)
		continue;
	    switch (xrefNode -> xrefEPICSFieldType)
	    {
		case DBF_SHORT:
		case DBF_LONG:
		case DBF_ENUM:
		case DBF_USHORT:
		case DBF_ULONG:
		case DBF_FLOAT:
		case DBF_DOUBLE:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    doubleValue = atof ((const char *)dbValue);
		    DB_PutFieldValue (pntRecord, putField, (void *)&doubleValue);
		    doSave = vFALSE;
		    break;

		case DBF_STRING:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		case DBF_GBLCHOICE:
		case DBF_RECCHOICE:
		case DBF_CVTCHOICE:
		case DBF_DEVCHOICE:
		{
		    if (xrefNode -> xrefField -> field_type == 'L')
		    {
			int	logical;
			toggleItem = (vcontrolToggle *)dialogItem;
			logical = toggleItem -> GetValue ();
			*((char *)dbValue) = (logical ? xrefNode -> xrefTrue : 
								xrefNode -> xrefTrue ^1);
			break;
		    }
		    optionMenu = (vcontrolOptionMenu *)dialogItem;
		    optionMenuValue = vuGetOptionMenuValue (optionMenu);
		    vcharExport (vcharScribeSystemExport (optionMenuValue), dbValue);
		    break;
		}

		case DBF_INLINK:
		case DBF_OUTLINK:
		    textItem = (vtextitem *)dialogItem;
		    stringValue = textItem -> GetTextAsString ();
		    vcharExport (vcharScribeSystemExport (stringValue), dbValue);
		    vstrDestroy (stringValue);
		    break;

		default:
		    continue;

	    }  // end xrefNode -> xrefEPICSFieldType

	    if (doSave == vTRUE)
	    {
		DB_PutFieldValue (pntRecord, putField, dbValue);
	    }

	}  // end if not in commondialog

    }  // end while iterator

    iterator.Finish ();

    // call base class vuSaveDialog
    vuCommonDialogClass::vuSaveDialog (pointName);
}


/*******************************************************************
*
*	Valve container class
*
********************************************************************/

vkindTYPED_FULL_DEFINITION(vuValveContainerClass, vcontainer, 
						"vuValveContainerClass");

/*******************************************************************
*
*    vuValveContainerClass override for constructor
*
*******************************************************************/

void vuValveContainerClass::LoadInit (vresource res)
{
    vapplication *app = vapplication::GetCurrent ();
    vresource pointDictRes = vresourceGet (app -> GetResources (), 
				vunames_vuPointDictionary);
    vresource realRes = vresourceGet (pointDictRes, vunames_vuValveContainer);

    vcontainer *opencontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveVOPPContainer);
    openPVButton = vuPvNameButtonClass::RequestSubLoad (opencontainer,
				vunames_vuValveVOPPButton);
    openPV = vuFilteredTextitem::RequestSubLoad (opencontainer,
				vunames_VOPP);
    processOpen = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC1);
    msOpen = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS1);

    vcontainer *closecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveVCLPContainer);
    closePVButton = vuPvNameButtonClass::RequestSubLoad (closecontainer,
				vunames_vuValveVCLPButton);
    closePV = vuFilteredTextitem::RequestSubLoad (closecontainer,
				vunames_VCLP);
    processClose = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC2);
    msClose = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS2);

    vcontainer *olspcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveOLSPContainer);
    openLimitPVButton = vuPvNameButtonClass::RequestSubLoad (olspcontainer,
				vunames_vuValveOLSPButton);
    openLimitPV = vuFilteredTextitem::RequestSubLoad (olspcontainer,
				vunames_OLSP);
    processOpenLimit = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC3);
    msOpenLimit = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS3);
    openLimitInd = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OLSI);

    vcontainer *clspcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveCLSPContainer);
    closeLimitPVButton = vuPvNameButtonClass::RequestSubLoad (clspcontainer,
				vunames_vuValveCLSPButton);
    closeLimitPV = vuFilteredTextitem::RequestSubLoad (clspcontainer,
				vunames_CLSP);
    processCloseLimit = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC4);
    msCloseLimit = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS4);
    closeLimitInd = vuCheckBoxClass::RequestSubLoad (this,
				vunames_CLSI);

    vcontainer *otspcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveOTSPContainer);
    openTorquePVButton = vuPvNameButtonClass::RequestSubLoad (otspcontainer,
				vunames_vuValveOTSPButton);
    openTorquePV = vuFilteredTextitem::RequestSubLoad (otspcontainer,
				vunames_OTSP);
    processOpenTorque = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC5);
    msOpenTorque = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS5);
    openTorqueInd = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OTSI);

    vcontainer *ctspcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveCTSPContainer);
    closeTorquePVButton = vuPvNameButtonClass::RequestSubLoad (ctspcontainer,
				vunames_vuValveCTSPButton);
    closeTorquePV = vuFilteredTextitem::RequestSubLoad (ctspcontainer,
				vunames_CTSP);
    processCloseTorque = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC6);
    msCloseTorque = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS6);
    closeTorqueInd = vuCheckBoxClass::RequestSubLoad (this,
				vunames_CTSI);

    vcontainer *rolpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveROLPContainer);
    remoteLocalPVButton = vuPvNameButtonClass::RequestSubLoad (rolpcontainer,
				vunames_vuValveROLPButton);
    remoteLocalPV = vuFilteredTextitem::RequestSubLoad (rolpcontainer,
				vunames_ROLP);
    processRemoteLocal = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC7);
    msRemoteLocal = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS7);

    vcontainer *vpopcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveVPOPContainer);
    positionPVButton = vuPvNameButtonClass::RequestSubLoad (vpopcontainer,
				vunames_vuValveVPOPButton);
    positionPV = vuFilteredTextitem::RequestSubLoad (vpopcontainer,
				vunames_VPOP);
    processPosition = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC8);
    msPosition = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS8);

    vcontainer *dropcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveDROPContainer);
    drivePositionPVButton = vuPvNameButtonClass::RequestSubLoad (dropcontainer,
				vunames_vuValveDROPButton);
    drivePositionPV = vuFilteredTextitem::RequestSubLoad (dropcontainer,
				vunames_DROP);
    processDrivePosition = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRC9);
    msDrivePosition = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXS9);

    vcontainer *fmbpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveFMBPContainer);
    faultMbbiPVButton = vuPvNameButtonClass::RequestSubLoad (fmbpcontainer,
				vunames_vuValveFMBPButton);
    faultMbbiPV = vuFilteredTextitem::RequestSubLoad (fmbpcontainer,
				vunames_FMBP);
    processFaultMbbi = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCA);
    msFaultMbbi = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSA);

    vcontainer *perpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValvePERPContainer);
    permissivePVButton = vuPvNameButtonClass::RequestSubLoad (perpcontainer,
				vunames_vuValvePERPButton);
    permissivePV = vuFilteredTextitem::RequestSubLoad (perpcontainer,
				vunames_PERP);
    processPermissive = vuCheckBoxClass::RequestSubLoad (this,
				vunames_PRCB);
    msPermissive = vuCheckBoxClass::RequestSubLoad (this,
				vunames_MXSB);

    onScan = vuCheckBoxClass::RequestSubLoad (this,
				vunames_OSCN);

    vcontainer *modecontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveMODEContainer);
    mode = vuChoiceGblMenuClass::RequestSubLoad (modecontainer,
				vunames_MODE);

    vcontainer *esaccontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveESACContainer);
    emergencyStopAction = vuChoiceRecMenuClass::RequestSubLoad (esaccontainer,
				vunames_ESAC);

    vcontainer *sopncontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSOPNContainer);
    openCommand = filteredTextitem::RequestSubLoad (sopncontainer,
				vunames_SOPN);

    vcontainer *sclscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSCLSContainer);
    closeCommand = filteredTextitem::RequestSubLoad (sclscontainer,
				vunames_SCLS);

    vcontainer *sjopcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSJOPContainer);
    jogOpenCommand = filteredTextitem::RequestSubLoad (sjopcontainer,
				vunames_SJOP);

    vcontainer *sjclcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSJCLContainer);
    jogCloseCommand = filteredTextitem::RequestSubLoad (sjclcontainer,
				vunames_SJCL);

    vcontainer *srevcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSREVContainer);
    reverseCommand = filteredTextitem::RequestSubLoad (srevcontainer,
				vunames_SREV);

    vcontainer *sposcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSPOSContainer);
    setPosCommand = filteredTextitem::RequestSubLoad (sposcontainer,
				vunames_SPOS);

    vcontainer *stopcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSTOPContainer);
    openedStatus = filteredTextitem::RequestSubLoad (stopcontainer,
				vunames_STOP);

    vcontainer *stclcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSTCLContainer);
    closedStatus = filteredTextitem::RequestSubLoad (stclcontainer,
				vunames_STCL);

    vcontainer *stotcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSTOTContainer);
    openingStatus = filteredTextitem::RequestSubLoad (stotcontainer,
				vunames_STOT);

    vcontainer *stctcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSTCTContainer);
    closingStatus = filteredTextitem::RequestSubLoad (stctcontainer,
				vunames_STCT);

    vcontainer *fstscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSTFAContainer);
    faultStatus = filteredTextitem::RequestSubLoad (fstscontainer,
				vunames_STFA);

    vcontainer *stuncontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveSTUNContainer);
    unknownStatus = filteredTextitem::RequestSubLoad (stuncontainer,
				vunames_STUN);

    alarmButton = vuValveAlarmButtonClass::RequestSubLoad (this,
				vunames_vuValveAlarmButton);

    miscButton = vuValveMiscButtonClass::RequestSubLoad (this,
				vunames_vuValveMiscButton);

    vcontainer::LoadInit (realRes);

    // store ptr to text field for vuPvNameButtonClass
    openPVButton -> storePvName (openPV);
    closePVButton -> storePvName (closePV);
    openLimitPVButton -> storePvName (openLimitPV);
    closeLimitPVButton -> storePvName (closeLimitPV);
    openTorquePVButton -> storePvName (openTorquePV);
    closeTorquePVButton -> storePvName (closeTorquePV);
    remoteLocalPVButton -> storePvName (remoteLocalPV);
    positionPVButton -> storePvName (positionPV);
    drivePositionPVButton -> storePvName (drivePositionPV);
    faultMbbiPVButton -> storePvName (faultMbbiPV);
    permissivePVButton -> storePvName (permissivePV);

    // set filters
    openCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    closeCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    jogOpenCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    jogCloseCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    reverseCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    setPosCommand -> SetItemFilterFunc (tankfarmCmdStsFilter);
    openedStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    closedStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    openingStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    closingStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    faultStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    unknownStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);

    openPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *openText = (filteredText *)openPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    openText -> SetUserPtr ((void *)openPV);

    closePV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *closeText = (filteredText *)closePV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    closeText -> SetUserPtr ((void *)closePV);

    openLimitPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *olText = (filteredText *)openLimitPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    olText -> SetUserPtr ((void *)openLimitPV);

    closeLimitPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *clText = (filteredText *)closeLimitPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    clText -> SetUserPtr ((void *)closeLimitPV);

    openTorquePV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *otText = (filteredText *)openTorquePV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    otText -> SetUserPtr ((void *)openTorquePV);

    closeTorquePV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *ctText = (filteredText *)closeTorquePV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    ctText -> SetUserPtr ((void *)closeTorquePV);

    remoteLocalPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *rlText = (filteredText *)remoteLocalPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    rlText -> SetUserPtr ((void *)remoteLocalPV);

    positionPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *posText = (filteredText *)positionPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    posText -> SetUserPtr ((void *)positionPV);

    drivePositionPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *dpText = (filteredText *)drivePositionPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    dpText -> SetUserPtr ((void *)drivePositionPV);

    faultMbbiPV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *fmText = (filteredText *)faultMbbiPV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    fmText -> SetUserPtr ((void *)faultMbbiPV);

    permissivePV -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *permText = (filteredText *)permissivePV -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    permText -> SetUserPtr ((void *)permissivePV);

    // build popup menus
    mode -> vuBuildOptionMenu (GBL_TF_AUTO_MAN_LOCK);
    emergencyStopAction -> vuBuildOptionMenu (VU_VALVE, REC_VALVE_ES);

}


/*******************************************************************
*
*    vuValveContainerClass override for destructor
*
*******************************************************************/

void vuValveContainerClass::Destroy (void)
{
    vcontainer::Destroy ();
}



/******************************************************************
*
*    vuValveAlarmButtonClass observer
*	open the valve alarm dialog and wait here until finished
*
*******************************************************************/
vkindTYPED_FULL_DEFINITION(vuValveAlarmButtonClass, vbutton, 
					"vuValveAlarmButtonClass");

void vuValveAlarmButtonClass::ObserveDialogItem (vevent *event)
{
    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    alarmDialog -> Place (vwindow::GetRoot (), vrectPLACE_CENTER, vrectPLACE_CENTER);
    alarmDialog -> Open();
    MakeTopMostDialog (alarmDialog, NULL);
    vevent::Process ();
}


/******************************************************************
*
*    vuValveMiscButtonClass observer
*	open the valve misc  dialog and wait here until finished
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuValveMiscButtonClass, vbutton, 
					"vuValveMiscButtonClass");

void vuValveMiscButtonClass::ObserveDialogItem (vevent *event)
{
    // open the dialog and start a sub event loop, halts the caller
    // at the statement after the call to this function
    // allows caller to access the dialog data after dialog is closed
    miscDialog -> Place (vwindow::GetRoot (), vrectPLACE_CENTER, vrectPLACE_CENTER);
    miscDialog -> Open();
    MakeTopMostDialog (miscDialog, NULL);
    vevent::Process ();
}


/******************************************************************
*
*    vuValveAlarmDialogClass
*
******************************************************************/

vkindTYPED_FULL_DEFINITION(vuValveAlarmDialogClass, vdialog,
					"vuValveAlarmDialogClass");

/*******************************************************************
*
*    vuValveAlarmDialogClass override for constructors init ()
*
*******************************************************************/

void vuValveAlarmDialogClass::LoadInit (vresource res)
{

    vcontainer *exopcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveAlarmEXOPContainer);
    openTimeLimit = filteredTextitem::RequestSubLoad (exopcontainer,
					vunames_EXOP);

    vcontainer *opdbcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveAlarmOPDBContainer);
    openDeadband = filteredTextitem::RequestSubLoad (opdbcontainer,
					vunames_OPDB);

    vcontainer *opsvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveAlarmOPSVContainer);
    openSeverity = vuChoiceGblMenuClass::RequestSubLoad (opsvcontainer,
					vunames_OPSV);

    vcontainer *exclcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveAlarmEXCLContainer);
    closeTimeLimit = filteredTextitem::RequestSubLoad (exclcontainer,
					vunames_EXCL);

    vcontainer *cldbcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveAlarmCLDBContainer);
    closeDeadband = filteredTextitem::RequestSubLoad (cldbcontainer,
					vunames_CLDB);

    vcontainer *clsvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveAlarmCLSVContainer);
    closeSeverity = vuChoiceGblMenuClass::RequestSubLoad (clsvcontainer,
					vunames_CLSV);

    vcontainer *mltlcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveAlarmMLTLContainer);
    limitTorqueLag = filteredTextitem::RequestSubLoad (mltlcontainer,
					vunames_MLTL);

    vcontainer *ltsvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveAlarmLTSVContainer);
    limitTorqueLagSeverity = vuChoiceGblMenuClass::RequestSubLoad (ltsvcontainer,
					vunames_LTSV);

    alarmOnAutomatic = vuCheckBoxClass::RequestSubLoad (this,
					vunames_ALAU);

    vcontainer *ausvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveAlarmAUSVContainer);
    autoSeverity = vuChoiceGblMenuClass::RequestSubLoad (ausvcontainer,
					vunames_AUSV);

    alarmOnManual = vuCheckBoxClass::RequestSubLoad (this,
					vunames_ALMA);

    vcontainer *masvcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveAlarmMASVContainer);
    manualSeverity = vuChoiceGblMenuClass::RequestSubLoad (masvcontainer,
					vunames_MASV);

    onAlarm = vuCheckBoxClass::RequestSubLoad (this,
					vunames_AENB);

    vcontainer *algpcontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveAlarmALGPContainer);
    alarmGroup = vuFilteredTextitem::RequestSubLoad (algpcontainer,
				vunames_ALGP);

    vcontainer *adiscontainer = vcontainer::RequestSubLoad (this,
				vunames_vuValveAlarmADISContainer);
    alarmDisableButton = vuPvNameButtonClass::RequestSubLoad (adiscontainer,
				vunames_vuValveAlarmADISButton);
    alarmDisable = vuFilteredTextitem::RequestSubLoad (adiscontainer,
				vunames_ADIS);

    dismissButton = vuValveAlarmDismissButtonClass::RequestSubLoad (this,
				vunames_vuValveAlarmDismissButton);

    vdialog::LoadInit (res);

    // store ptr to text field for vuPvNameButtonClass
    alarmDisableButton -> storePvName (alarmDisable);

    // set filters
    openTimeLimit -> SetItemFilterFunc (floatFilter);
    openDeadband -> SetItemFilterFunc (floatFilter);
    closeTimeLimit -> SetItemFilterFunc (floatFilter);
    closeDeadband -> SetItemFilterFunc (floatFilter);
    limitTorqueLag -> SetItemFilterFunc (floatFilter);

    alarmDisable -> SetItemFilterFunc (vuPvNameFilter);
    filteredText *adisText = (filteredText *)alarmDisable -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    adisText -> SetUserPtr ((void *)alarmDisable);

    alarmGroup -> SetItemFilterFunc (vuAlarmGroupFilter);
    filteredText *alarmText = (filteredText *)alarmGroup -> GetTextData ();
    // remember ptr to textitem for later use by the filter
    alarmText -> SetUserPtr ((void *)alarmGroup);

    // build popup menus
    openSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    closeSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    limitTorqueLagSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    autoSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);
    manualSeverity -> vuBuildOptionMenu (GBL_ALARM_SEV);

    // store dialog pointer in dismiss button
    dismissButton -> storeValveAlarmDialog (this);
}


/*******************************************************************
*
*    vuValveAlarmDialogClass notify function
*
*******************************************************************/

void vuValveAlarmDialogClass::ObserveWindow (vevent *event)
{
    if ( event -> GetType () == veventWINDOW_STATE && event -> IsClose ())
    {
	Close ();
	vevent::StopProcessing ();
    }
    else
    {
	MakeTopMostDialog (this, event);
    }
}


/*******************************************************************
*
*    vuValveAlarmDismissButtonClass notify function
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuValveAlarmDismissButtonClass, vbutton, 
					"vuValveAlarmDismissButtonClass");

void vuValveAlarmDismissButtonClass::ObserveDialogItem (vevent *event)
{
    alarmDialog -> Close ();
    vevent::StopProcessing ();
}


/******************************************************************
*
*    vuValveMiscDialogClass
*
******************************************************************/

vkindTYPED_FULL_DEFINITION(vuValveMiscDialogClass, vdialog,
					"vuValveMiscDialogClass");

/*******************************************************************
*
*    vuValveMiscDialogClass override for constructors init ()
*
*******************************************************************/

void vuValveMiscDialogClass::LoadInit (vresource res)
{

    vcontainer *swrecontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveMiscSWREContainer);
    remoteStatus = filteredTextitem::RequestSubLoad (swrecontainer,
					vunames_SWRE);

    vcontainer *swlocontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveMiscSWLOContainer);
    localStatus = filteredTextitem::RequestSubLoad (swlocontainer,
					vunames_SWLO);

    vcontainer *vjotcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveMiscVJOTContainer);
    jogOpenTime = filteredTextitem::RequestSubLoad (vjotcontainer,
					vunames_VJOT);

    vcontainer *vjctcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveMiscVJCTContainer);
    jogCloseTime = filteredTextitem::RequestSubLoad (vjctcontainer,
					vunames_VJCT);

    vcontainer *loprcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveMiscLOPRContainer);
    driveLow = filteredTextitem::RequestSubLoad (loprcontainer,
					vunames_LOPR);

    vcontainer *hoprcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveMiscHOPRContainer);
    driveHigh = filteredTextitem::RequestSubLoad (hoprcontainer,
					vunames_HOPR);

    vcontainer *dislcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveMiscDISLContainer);
    displayLow = filteredTextitem::RequestSubLoad (dislcontainer,
					vunames_DISL);

    vcontainer *dishcontainer = vcontainer::RequestSubLoad (this,
					vunames_vuValveMiscDISHContainer);
    displayHigh = filteredTextitem::RequestSubLoad (dishcontainer,
					vunames_DISH);

    localTracking = vuCheckBoxClass::RequestSubLoad (this,
					vunames_LTEN);

    learnMode = vuCheckBoxClass::RequestSubLoad (this,
					vunames_LMEN);

    dismissButton = vuValveMiscDismissButtonClass::RequestSubLoad (this,
				vunames_vuValveMiscDismissButton);

    vdialog::LoadInit (res);

    // set filters
    remoteStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    localStatus -> SetItemFilterFunc (tankfarmCmdStsFilter);
    jogOpenTime -> SetItemFilterFunc (floatFilter);
    jogCloseTime -> SetItemFilterFunc (floatFilter);
    driveLow -> SetItemFilterFunc (floatFilter);
    driveHigh -> SetItemFilterFunc (floatFilter);
    displayLow -> SetItemFilterFunc (floatFilter);
    displayHigh -> SetItemFilterFunc (floatFilter);

    // store dialog pointer in dismiss button
    dismissButton -> storeValveMiscDialog (this);
}


/*******************************************************************
*
*    vuValveMiscDialogClass notify function
*
*******************************************************************/

void vuValveMiscDialogClass::ObserveWindow (vevent *event)
{
    if ( event -> GetType () == veventWINDOW_STATE && event -> IsClose ())
    {
	Close ();
	vevent::StopProcessing ();
    }
    else
    {
	MakeTopMostDialog (this, event);
    }
}


/*******************************************************************
*
*    vuValveMiscDismissButtonClass notify function
*
*******************************************************************/

vkindTYPED_FULL_DEFINITION(vuValveMiscDismissButtonClass, vbutton, 
					"vuValveMiscDismissButtonClass");

void vuValveMiscDismissButtonClass::ObserveDialogItem (vevent *event)
{
    miscDialog -> Close ();
    vevent::StopProcessing ();
}

