#ifndef vuvalvedialogclassHXX
#define	vuvalvedialogclassHXX

// define values for the xrefNode inDialog flag

enum {
    VU_VALVE_NOT_IN_DIALOG = 1,
    VU_VALVE_IN_MAIN_DIALOG,
    VU_VALVE_IN_ALARM_DIALOG,
    VU_VALVE_IN_MISC_DIALOG
};

class vuValveAlarmButtonClass;
class vuValveMiscButtonClass;
class vuValveAlarmDialogClass;
class vuValveAlarmDismissButtonClass;
class vuValveMiscDialogClass;
class vuValveMiscDismissButtonClass;


//*** VALVE CONTAINER CLASS *******************************************

class	vuValveContainerClass : public vcontainer
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuValveContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuValveContainerClass, vcontainer);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // pointers to fields in container, public so don't need funcs to
    // get at them from vuValveDialogClass

    vuPvNameButtonClass	*openPVButton;
    vuFilteredTextitem	*openPV;
    vuCheckBoxClass	*processOpen;
    vuCheckBoxClass	*msOpen;
    vuPvNameButtonClass	*closePVButton;
    vuFilteredTextitem	*closePV;
    vuCheckBoxClass	*processClose;
    vuCheckBoxClass	*msClose;
    vuPvNameButtonClass	*openLimitPVButton;
    vuFilteredTextitem	*openLimitPV;
    vuCheckBoxClass	*processOpenLimit;
    vuCheckBoxClass	*msOpenLimit;
    vuCheckBoxClass	*openLimitInd;
    vuPvNameButtonClass	*closeLimitPVButton;
    vuFilteredTextitem	*closeLimitPV;
    vuCheckBoxClass	*processCloseLimit;
    vuCheckBoxClass	*msCloseLimit;
    vuCheckBoxClass	*closeLimitInd;
    vuPvNameButtonClass	*openTorquePVButton;
    vuFilteredTextitem	*openTorquePV;
    vuCheckBoxClass	*processOpenTorque;
    vuCheckBoxClass	*msOpenTorque;
    vuCheckBoxClass	*openTorqueInd;
    vuPvNameButtonClass	*closeTorquePVButton;
    vuFilteredTextitem	*closeTorquePV;
    vuCheckBoxClass	*processCloseTorque;
    vuCheckBoxClass	*msCloseTorque;
    vuCheckBoxClass	*closeTorqueInd;
    vuPvNameButtonClass	*remoteLocalPVButton;
    vuFilteredTextitem	*remoteLocalPV;
    vuCheckBoxClass	*processRemoteLocal;
    vuCheckBoxClass	*msRemoteLocal;
    vuPvNameButtonClass	*positionPVButton;
    vuFilteredTextitem	*positionPV;
    vuCheckBoxClass	*processPosition;
    vuCheckBoxClass	*msPosition;
    vuPvNameButtonClass	*drivePositionPVButton;
    vuFilteredTextitem	*drivePositionPV;
    vuCheckBoxClass	*processDrivePosition;
    vuCheckBoxClass	*msDrivePosition;
    vuPvNameButtonClass	*faultMbbiPVButton;
    vuFilteredTextitem	*faultMbbiPV;
    vuCheckBoxClass	*processFaultMbbi;
    vuCheckBoxClass	*msFaultMbbi;
    vuPvNameButtonClass	*permissivePVButton;
    vuFilteredTextitem	*permissivePV;
    vuCheckBoxClass	*processPermissive;
    vuCheckBoxClass	*msPermissive;

    vuCheckBoxClass		*onScan;
    vuChoiceGblMenuClass	*mode;
    vuChoiceRecMenuClass	*emergencyStopAction;

    filteredTextitem	*openCommand;
    filteredTextitem	*closeCommand;
    filteredTextitem	*jogOpenCommand;
    filteredTextitem	*jogCloseCommand;
    filteredTextitem	*reverseCommand;
    filteredTextitem	*setPosCommand;

    filteredTextitem	*openedStatus;
    filteredTextitem	*closedStatus;
    filteredTextitem	*openingStatus;
    filteredTextitem	*closingStatus;
    filteredTextitem	*faultStatus;
    filteredTextitem	*unknownStatus;

    vuValveAlarmButtonClass	*alarmButton;
    vuValveMiscButtonClass	*miscButton;
};


//*** VALVE ALARM BUTTON CLASS ***************************************

class	vuValveAlarmButtonClass : public vbutton
{
    vuValveAlarmDialogClass	*alarmDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuValveAlarmButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuValveAlarmButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle alarmDialog
    void storeValveAlarmDialog (vuValveAlarmDialogClass *cd)
	{ alarmDialog = cd; }
};


//*** VALVE MISCELLANEOUS DETAILS BUTTON CLASS ***********************

class	vuValveMiscButtonClass : public vbutton
{
    vuValveMiscDialogClass	*miscDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuValveMiscButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuValveMiscButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle miscDialog
    void storeValveMiscDialog (vuValveMiscDialogClass *cd)
	{ miscDialog = cd; }
};


//*** VALVE DIALOG CLASS *********************************************

class	vuValveDialogClass : public vuCommonDialogClass
{
    vuValveContainerClass	*valveContainer;
    vuValveAlarmDialogClass	*alarmDialog;
    vuValveMiscDialogClass	*miscDialog;
    vstr			*valveTitle;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuValveDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuValveDialogClass, vuCommonDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // overide base vuCommonDialogClass
    void resetDialog (void);

    // override base class load and save functions
    void vuLoadDialog (vchar *pointName);
    void vuSaveDialog (vchar *pointName);
};


//*** VALVE ALARM DETAIL DIALOG CLASS ************************************

class	vuValveAlarmDialogClass : public vdialog
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuValveAlarmDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuValveAlarmDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // public so no funcs needed to access
    filteredTextitem		*openTimeLimit;
    filteredTextitem		*openDeadband;
    vuChoiceGblMenuClass	*openSeverity;
    filteredTextitem		*closeTimeLimit;
    filteredTextitem		*closeDeadband;
    vuChoiceGblMenuClass	*closeSeverity;
    filteredTextitem		*limitTorqueLag;
    vuChoiceGblMenuClass	*limitTorqueLagSeverity;
    vuCheckBoxClass		*alarmOnAutomatic;
    vuChoiceGblMenuClass	*autoSeverity;
    vuCheckBoxClass		*alarmOnManual;
    vuChoiceGblMenuClass	*manualSeverity;
    vuCheckBoxClass		*onAlarm;
    vuFilteredTextitem		*alarmGroup;
    vuPvNameButtonClass		*alarmDisableButton;
    vuFilteredTextitem		*alarmDisable;
    vuValveAlarmDismissButtonClass	*dismissButton;
};


//*** VALVE ALARM DISMISS BUTTON CLASS ********************************

class	vuValveAlarmDismissButtonClass : public vbutton
{
    vuValveAlarmDialogClass	*alarmDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuValveAlarmDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuValveAlarmDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle alarmDialog
    void storeValveAlarmDialog (vuValveAlarmDialogClass *cd)
	{ alarmDialog = cd; }
};


//*** VALVE ALARM MISC DIALOG CLASS ************************************

class	vuValveMiscDialogClass : public vdialog
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuValveMiscDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuValveMiscDialogClass, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // vwindow overide
    void ObserveWindow (vevent *event);

    // public so no funcs needed to access
    filteredTextitem	*remoteStatus;
    filteredTextitem	*localStatus;
    filteredTextitem	*jogOpenTime;
    filteredTextitem	*jogCloseTime;
    filteredTextitem	*driveLow;
    filteredTextitem	*driveHigh;
    filteredTextitem	*displayLow;
    filteredTextitem	*displayHigh;
    vuCheckBoxClass	*localTracking;
    vuCheckBoxClass	*learnMode;
    vuValveMiscDismissButtonClass	*dismissButton;
};


//*** VALVE MISC DISMISS BUTTON CLASS ********************************

class	vuValveMiscDismissButtonClass : public vbutton
{
    vuValveMiscDialogClass	*miscDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION (vuValveMiscDismissButtonClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS (vuValveMiscDismissButtonClass, vbutton);

    // virtual member function override
    void ObserveDialogItem (vevent *event);

    // function to handle miscDialog
    void storeValveMiscDialog (vuValveMiscDialogClass *cd)
	{ miscDialog = cd; }
};

#endif	vuvalvedialogclassHXX

