#ifndef vuwaveformdialogclassHXX
#define	vuwaveformdialogclassHXX

class	vuWaveformContainerClass : public vcontainer
{

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuWaveformContainerClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuWaveformContainerClass, vcontainer);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // pointers to fields in container, public so don't need funcs to
    // get at them from vuWaveformDialogClass

    vuBoardTypeMenuClass	*boardType;
    filteredTextitem	*line;
    filteredTextitem	*addr;
    filteredTextitem	*card;
    filteredTextitem	*signal;
    filteredTextitem	*eguTag;
    vuPvNameButtonClass	*referenceButton;
    vuFilteredTextitem	*reference;
    filteredTextitem	*constantValue;
    vuCheckBoxClass	*onScan;
    vuCheckBoxClass	*processInput;
    vuCheckBoxClass	*maximizeSeverity;
    vuCheckBoxClass	*rearm;
    filteredTextitem	*monitorCount;
    filteredTextitem	*elementCount;
    filteredTextitem	*precision;
    filteredTextitem	*displayLow;
    filteredTextitem	*displayHigh;
    vuChoiceGblMenuClass	*valueType;
    vuChoiceRecMenuClass	*triggerCount;
    vuChoiceRecMenuClass	*sampleRate;
};


//*** WAVEFORM DIALOG CLASS ********************************************

class	vuWaveformDialogClass : public vuCommonDialogClass
{
    vuWaveformContainerClass	*waveformContainer;
    vstr			*waveformTitle;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuWaveformDialogClass);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuWaveformDialogClass, vuCommonDialogClass);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // overide base vuCommonDialogClass
    void resetDialog (void);

    // override base class load and save functions
    void vuLoadDialog (vchar *pointName);
    void vuSaveDialog (vchar *pointName);
};

#endif	vuwaveformdialogclassHXX
