/*vucreateall.h,v 1.1.1.1 1999/08/03 14:42:24 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	Include all field & tag definition .h files.
*/

/*
	Info structure for field & tag structure arrays.
*/

typedef struct
	{
	char	*file_name;
	F4FIELD_INFO	*field_array;
	T4TAG_INFO	*tag_array;
	} INFO_ARRAY;

#include "accum.h"
#include "ai.h"
#include "ao.h"
#include "ar_reduc.h"
#include "calc.h"
#include "calcops.h"
#include "datamove.h"
#include "ddc.h"
#include "deadtime.h"
#include "di.h"
#include "do.h"
#include "fanlink.h"
#include "fanout.h"
#include "ioaddr.h"
#include "ioclist.h"
#include "leadlag.h"
#include "mbbi.h"
#include "mbbo.h"
#include "pid.h"
#include "pipe.h"
#include "pipecmds.h"
#include "pipevars.h"
#include "pot.h"
#include "potvars.h"
#include "pto.h"
#include "pump.h"
#include "pumpvars.h"
#include "pvmap.h"
#include "ramp.h"
#include "reslist.h"
#include "sel.h"
#include "sellink.h"
#include "sigchar.h"
#include "state.h"
#include "strngin.h"
#include "strngout.h"
#include "tank1.h"
#include "tank2.h"
#include "tank3.h"
#include "tank4.h"
#include "tankcmds.h"
#include "tankprbs.h"
#include "tankvars.h"
#include "tankvlvs.h"
#include "td.h"
#include "valve.h"
#include "vlvvars.h"
#include "waveform.h"
#include "udb.h"	/* new block as of 19-Jan-95 */
#include "pat.h"	/* new block as of 26-Apr-95 */
#include "alarminfo.h"	/* new file for alarm info 27-Jan-95 GCT */
#include "script.h"	/* for LaunchScript support */
#include "launch.h"	/* for Launch support */
#include "udbcfg.h"	/* GCT 10-Mar-1995 used for User Defined Block label configuration */
#include "straptbl.h"	/* GCT 23-Mar-1995 Strapping Table format */
#include "apitbl.h"	/* GCT 23-Mar-1995 API Table format */
#include "ctrend.h"	/* GCT 28-Mar-96 create Current trend config file */
#include "ldfw1.h"	/* ems 4 Apr 96, new block */
#include "ldfw2.h"	/* ems 14 May 96, new block */
#include "tagvudb.h"	/* ems 26 Jul 96 */
#include "alarmTalkdb.h"	/* ems 18 Sep 96 */

INFO_ARRAY	info_array[] = 
	{
	{"accum",	       	accumFieldInfo,		accumTagInfo},
	{"ai",		       	aiFieldInfo,		aiTagInfo},
	{"ao",		       	aoFieldInfo,		aoTagInfo},
	{"ar_reduc",		ar_reducFieldInfo,	ar_reducTagInfo},
	{"calc",	       	calcFieldInfo,		calcTagInfo},
	{"calcops",	       	calcopsFieldInfo,	calcopsTagInfo},
	{"datamove",		datamoveFieldInfo,	datamoveTagInfo},
	{"deadtime",		deadtimeFieldInfo,	deadtimeTagInfo},
	{"di",		       	diFieldInfo,		diTagInfo},
	{"do",		       	doFieldInfo,		doTagInfo},
	{"fanlink",	       	fanlinkFieldInfo,	fanlinkTagInfo},
	{"fanout",	       	fanoutFieldInfo,	fanoutTagInfo},
	{"ioaddr",	       	ioaddrFieldInfo,	ioaddrTagInfo},
	{"ioclist",	       	ioclistFieldInfo,	ioclistTagInfo},
	{"leadlag",	       	leadlagFieldInfo,	leadlagTagInfo},
	{"mbbi",	       	mbbiFieldInfo,		mbbiTagInfo},
	{"mbbo",	       	mbboFieldInfo,		mbboTagInfo},
	{"pid",		       	pidFieldInfo,		pidTagInfo},
	{"pipe",	       	pipeFieldInfo,		pipeTagInfo},
	{"pipecmds",		pipecmdsFieldInfo,	pipecmdsTagInfo},
	{"pipevars",		pipevarsFieldInfo,	pipevarsTagInfo},
	{"pot",		       	potFieldInfo,		potTagInfo},
	{"potvars",	       	potvarsFieldInfo,	potvarsTagInfo},
	{"pto",		       	ptoFieldInfo,		ptoTagInfo},
	{"pump",	       	pumpFieldInfo,		pumpTagInfo},
	{"pumpvars",		pumpvarsFieldInfo,	pumpvarsTagInfo},
	{"pvmap",	       	pvmapFieldInfo,		pvmapTagInfo},
	{"ramp",	       	rampFieldInfo,		rampTagInfo},
	{"reslist",	       	reslistFieldInfo,	reslistTagInfo},
	{"sel",		       	selFieldInfo,		selTagInfo},
	{"sellink",	       	sellinkFieldInfo,	sellinkTagInfo},
	{"sigchar",	       	sigcharFieldInfo,	sigcharTagInfo},
	{"state",	       	stateFieldInfo,		stateTagInfo},
	{"strngin",	       	strnginFieldInfo,	strnginTagInfo},
	{"strngout",		strngoutFieldInfo,	strngoutTagInfo},
	{"tank1",	       	tank1FieldInfo,		tank1TagInfo},
	{"tank2",	       	tank2FieldInfo,		tank2TagInfo},
	{"tank3",	       	tank3FieldInfo,		tank3TagInfo},
	{"tank4",	       	tank4FieldInfo,		tank4TagInfo},
	{"tankcmds",		tankcmdsFieldInfo,	tankcmdsTagInfo},
	{"tankprbs",		tankprbsFieldInfo,	tankprbsTagInfo},
	{"tankvars",		tankvarsFieldInfo,	tankvarsTagInfo},
	{"tankvlvs",		tankvlvsFieldInfo,	tankvlvsTagInfo},
	{"td",		       	tdFieldInfo,		tdTagInfo},
	{"valve",	       	valveFieldInfo,		valveTagInfo},
	{"vlvvars",	       	vlvvarsFieldInfo,	vlvvarsTagInfo},
	{"waveform",		waveformFieldInfo,	waveformTagInfo},
	{"udb",		       	udbFieldInfo,		udbTagInfo},
	{"pat",		       	patFieldInfo,		patTagInfo},
	{"alarminf",		ainfoFieldInfo,		ainfoTagInfo},
	{"scriptdb",		script_flds,		script_tag},
	{"grphicdb",		graphic_launch_fields,	launch_tag},
	{"udbcfg",	       	udbcfgFieldInfo,       	udbcfgTagInfo},
	{"straptbl",		straptbl_fields,	straptbl_tag},
	{"apitbl",	       	apitbl_fields,		apitbl_tag},
	{"ctrend",	       	ctrendFieldInfo,       	ctrendTagInfo},
	{"ldfw1",		ldfw1FieldInfo,		ldfw1TagInfo},
	{"ldfw2",		ldfw2FieldInfo,		ldfw2TagInfo},
	{"ddc",			ddcFieldInfo,		ddcTagInfo},
	{"tagvu",		tagvuFieldInfo,		tagvuTagInfo},
	{"alarmtlk",		alarmTalkFieldInfo,	alarmTalkTagInfo},
	{0,0,0}
};
