#ifndef vuIocdialogclassHXX
#define vuIocdialogclassHXX

class vuIocOkClass;
class vuIocDismissClass;
class vuIocDialogListClass;

// *** Ioc Editor DIALOG CLASS ***************************************************
//  GCT 2-Sep-1997

class  vuIocDialogClass : public vdialog
{
    vresource	IocResource;
    int		singleSelect;
public:
    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(vuIocDialogClass);
    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(vuIocDialogClass, vdialog);
    // override to load dialog
    void LoadInit(vresource res);
    // override 
    void ObserveWindow (vevent *event);
    // override 
    void Destroy ();
    void vuIocOpen(vuMainDialogClass *mainDialog,vstr *buttonTitle);
    char *getIocName()
	{ return(iocName); }
    void setIocName(const vchar *name)
    {
	vcharExportBounded (vcharScribeSystemExport (name),iocName, IOCNAME_SZ);
	iocName[IOCNAME_SZ] = 0;
    }
    void clearIocName(void)
	{ iocName[0] = 0; }
private:
    vcontainer			*buttonContainer;
    vuIocOkClass		*okButton;
    vuIocDismissClass		*dismissButton;
    vuMainDialogClass		*mainDialog;
    char iocName[IOCNAME_SZ+1];
public:
    vuIocDialogListClass	*iocList;
};

// *** Ioc OK BUTTON CLASS ***************************************************

class vuIocOkClass : public vbutton
{
    vuIocDialogClass	*IocDialog;
public:
    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuIocOkClass);
    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuIocOkClass, vbutton);
    // override
    void ObserveDialogItem (vevent *event);
    // function to handle IocDialog
    void vuSetIocDialog (vuIocDialogClass *dialog) { IocDialog = dialog; }
};
// *** Ioc DISMISS BUTTON CLASS **********************************************
class vuIocDismissClass : public vbutton
{
    vuIocDialogClass	*IocDialog;
public:
    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuIocDismissClass);
    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuIocDismissClass, vbutton);
    // override
    void ObserveDialogItem (vevent *event);
    // function to handle IocDialog
    void vuSetIocDialog (vuIocDialogClass *dialog){ IocDialog = dialog; }
};
//
//sub-class vlistView so we can monitor when a selection has changed
//
class vuIocDialogListClass : public vlistview
{
    vuIocDialogClass	*IocDialog;
public:
    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(vuIocDialogListClass);
    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(vuIocDialogListClass, vlistview);
    // overide this so we can tell when a selection has changed
    void ObserveSelect(int state);
    void vuSetIocDialog(vuIocDialogClass *dialog){IocDialog = dialog;}
};
#endif vuIocdialogclassHXX

									 
