/*DBCFunctions.c,v 1.1.1.1 1999/08/03 14:42:35 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			18-Jan-1993				      */
/*									      */
/*	Module Name:		DBCFunctions.c				      */
/*	Module Description:						      */
/*									      */
/*									      */
/*	Modification History:	First try	18-Jan-1993		      */
/*									      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#include	<stdio.h>
#include	<lstLib.h>
#ifndef WIN32
#include	<sys/types.h>
#include	<sys/socket.h>
#include	<sys/ioctl.h>
#include	<netinet/in.h>
#include	<netinet/tcp.h>
#include	<netdb.h>
#include	<sys/file.h>
#include	<error.h>
#include	<sys/time.h>
#define	DO_TIME_STATS	1
#else
#include	<winsock.h>
typedef char *caddr_t;
#endif
#include	<msgMon.h>
#include	<sdrHeader.h>
#include	<dbDefs.h>
#include	<dbRecType.h>
#include	<dbRecDes.h>
#include	<dbRecords.h>
#include	<dbFldTypes.h>
#include	<devSup.h>
#include	<drvSup.h>
#include	<recSup.h>
#include	<cvtTable.h>
#include	<dbPvd.h>
#include	<choice.h>
#include	<link.h>
#include	<math.h>
#include	<malloc.h>
#define	FLD_POSOUTREF	"POSOUTREF"
#define	FLD_NEGOUTREF	"NEGOUTREF"
#define	PAT_DTYP	0
#define	PAT_DTYR	1
#define	PAT_DTYF	2
#define	PAT_DTYP_REF	3
#define	PAT_DTYR_REF	4
#define	PAT_DTYF_REF	5
#define RES_NAME_KEY	"RESNAMEKEY"
/*
	dbClient specific includes
*/
#include	"DBDefines.h"
#include	"DBCVerifyDefs.h"
#include	"DBCDefines.h"
#include	"DBProto.h"
#include	"redmsgs.h"
#include	"tisByteOrder.h"

#if defined(SOLARIS) || defined(AXP) ||defined(WIN32)
#define bzero(b,n)	memset (b, 0, n)
#define bcopy(s,d,n)	memcpy (d, s, n)
#endif

#ifndef	TRUE
#define	TRUE	1
#endif
#ifndef	FALSE
#define	FALSE	0
#endif
typedef	enum {DEV_CONSTANT=100,DEV_REFERENCE,DEV_HARDWARE} DBC_DEV_TYPES;
typedef	enum {DBC_LINK,DBC_CONSTANT,DBC_HARDWARE} DBC_LINK_TYPES;
double	dbRound();
/*
	Database pointers.
*/
extern	DB_TABLE_PTR	DBC_PvmapTable,DBC_IOAddrTable,DBC_PipeCmdsTable,pidTable,accumTable;
extern	DB_FIELD_PTR	pvmapCRCField,pvmapTypeField,pvmapIOCField[2];
extern	DB_FIELD_PTR	ioaddrName,ioaddrLine,ioaddrAddress,ioaddrCard,ioaddrSignal;
extern	DB_FIELD_PTR	pipeCmdField;
#ifndef WIN32
extern	ERRSYMTAB_ID	errSymTbl;			/* defined in error.h */
#endif WIN32
extern	DBC_XREFHDR_PTR	DBC_XREFTables;
extern	char	DBC_DefaultSDR[MAXPATHLEN];
extern	DBC_IOCINFO	utilIoc[DBC_MAX_HOSTS];
short		pntt;

DBC_RESINFO_PTR	dbcResSearch();
DBC_RESINFO_PTR dbcGetNextResource(DBC_IOCINFO_PTR iocinfo);
DBC_ERROR_CODES	DBC_ProcessChoice();
DBC_ERROR_CODES	DBC_ProcessHdwLink();
DBC_ERROR_CODES	DBC_ProcessHardware();
DBC_ERROR_CODES	DBC_ProcessSpecialLinks();
DBC_ERROR_CODES	DBC_ProcessTankFields(),DBC_OkToUnmark();
DBC_ERROR_CODES DBC_ProcessDbMod(DBC_IOCINFO_PTR);
DBC_ERROR_CODES dbcForwardDbMod(DBC_IOCINFO_PTR iocinfo);
DBC_ERROR_CODES dbcDownloadRequest(DBC_IOCINFO_PTR iocinfo);
DBC_ERROR_CODES dbcOnlineDownloadRequest(DBC_IOCINFO_PTR iocinfo);
TREENODE_PTR	symSearch();
void		updateHardwareLink(),updateCalcOps(),DBC_SendToAllHosts();
void		splitLinkName(),joinLinkName(),checkAndDeleteIOAddr();
void	ackAddToList();
void	ackUnmark();
void	ackCleanList();
void dbSetCRC(char *recPtr,unsigned short crc);
int dbcSendRecords(short mt,DBC_DWNLD_RESP *resp,DBC_IOCINFO_PTR iocinfo);
int dbcFindFirstRecord(char *key,DBC_IOCINFO_PTR iocinfo,DB_FIELD_PTR resfield);
int dbcFindNextRecord(DBC_IOCINFO_PTR iocinfo,DB_FIELD_PTR resfield);
DBC_ERROR_CODES dbcResetAck(DBC_IOCINFO_PTR iocinfo);
DBC_ERROR_CODES dbcDeleteStatus(DBC_IOCINFO_PTR iocinfo);
/*
	Tank farm field lists
*/
char	*tankvlvstats[] =
	{
	"V01S","V02S","V03S","V04S","V05S","V06S","V07S","V08S","V09S","V10S",
	"V01I","V02I","V03I","V04I","V05I","V06I","V07I","V08I","V09I","V10I",
	"V01R","V02R","V03R","V04R","V05R","V06R","V07R","V08R","V09R","V10R",
	"V01N","V02N","V03N","V04N","V05N","V06N","V07N","V08N","V09N","V10N"
	};
char	*tankproblvl[] =
	{
	"T01L","T02L","T03L","T04L","T05L","T06L","T07L","T08L","T09L","T10L"
	};
char	*tankvlvpv[] =
	{
	"V01P","V02P","V03P","V04P","V05P","V06P","V07P","V08P","V09P","V10P"
	};
char	*indicators[] =
	{
	"OLSI","CLSI","OTSI","CTSI",0
	};
char	*trips[] =
	{
	"TTRE","VTRE","PTRE","LRCF",0
	};
extern	DBC_RECDESC	downloadRecDesc[DBC_WINDOW_SIZE];	/* one for each record downloaded */
extern	int			maxRecSize;
#ifdef	DO_TIME_STATS
/*
	Time stats for download
*/
typedef	struct
	{
	int				total_count;
	struct timeval	total_time;
	} BUILD_TIME,*BUILD_TIME_PTR;
static	BUILD_TIME_PTR	time_stats;
void	AddTimes(),SubTimes(),DivTimes();
double	DecimalTimes();
#endif
extern LIST DBC_RESHeader;
/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			15-Jan-1993				      */
/*									      */
/*	Function Name:		DBC_BuildRecord				      */
/*	Function Description:						      */
/*									      */
/*		Build a single record for the supplied point name. This is    */
/*	as follows:							      */
/*									      */
/*		1.	Use name to get point type from PVMAP		      */
/*		2.	Find 'type_index' by searching SDR with GET_PRECTYPE  */
/*		3.	use 'type_index' to loop through SDR fields	      */
/*		4.	XREF SDR field to OV field name via SDBXREF table     */
/*		5.	Fill in buffer with field data from appropriate file  */
/*									      */
/*	Input Parameters:	DBC_Name - name of requested point.	      */
/*				DBC_RecordBuffer - pointer to record buffer   */
/*									      */
/*	Output Parameters:	none.					      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	20-Jan-1993 GCT First Try.		      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
DBC_ERROR_CODES	DBC_BuildRecord(DBC_Name,recdesc,pvmapNameRec)
char		*DBC_Name;
DBC_RECDESC	*recdesc;
DB_RECORD_PTR	pvmapNameRec;
{
DBC_ERROR_CODES	stat;
DBC_XREFTABLE_PTR	xrefNode;
struct recTypDes	*DBC_RecTypDes;
struct link		*DBC_LinkPtr;
int		field_type,i,type_index,udbNum;
DB_RECORD_PTR	pntRecord;
DB_FIELD_PTR	xrefConstant,xrefReference,pntProcInput,pntMaxSeverity,pntScanRate;
DB_FIELD_PTR	pntSetPtMS,pntSetPtProc,pntMvMS,pntMvProc,pntCascMS,pntCascProc,pntProcFzSpec,pntMaxsFzSpec;
char		pvmapString[50],DBC_Value[100];
char		*bptr,*DBC_ValuePtr,tempName[PVNAME_SZ+1];
double		DBC_DoubleValue;
unsigned char	boolean;
char		pvString[100];
DB_TABLE_PTR	lastTable;
short		choiceIndex;
DBC_DEV_TYPES	devtype;

DBC_ValuePtr = DBC_Value;
DB_GetFieldValue(pvmapNameRec,pvmapTypeField,pvmapString,&field_type);	/* get the point type */
lastTable = 0;
type_index = getTypeIndex(pvmapString);
if(!type_index)
	return(DBC_NOTYPE);				/* error exit if type not found */
DBC_RecTypDes = GET_PRECTYPDES(type_index);		/* point to type descriptor in SDR */
recdesc -> recType = type_index;			/* fill in recdesc structure */
recdesc -> recSize = DBC_RecTypDes -> rec_size;		/* size of this record in bytes */
#ifndef	USE_PREALLOC
if((recdesc -> recPtr  = (char *)calloc(1,recdesc->recSize)) == 0)	/* allocate and clear space for record */
	return(DBC_NOTYPE);
#else
bzero(recdesc->recPtr,maxRecSize);	/* space already there... so just zero it GCT 10-Feb-1995 */
#endif
if((xrefNode = (DBC_XREFTABLE_PTR)lstFirst((LIST *)&(((DBC_XREFHDR_PTR)&DBC_XREFTables[type_index])->xrefHdrList))) == 0)	/* get list for this point type */
	return(DBC_NOTYPE);
/*
	New for PID and ACC point support
*/
if(!strcmp(pvmapString,"pid"))
	{
	pntSetPtMS		= DB_MapField(pidTable,FLD_SETPTMS);
	pntSetPtProc	= DB_MapField(pidTable,FLD_SETPTPROC);
	pntMvMS			= DB_MapField(pidTable,FLD_MVMS);
	pntMvProc		= DB_MapField(pidTable,FLD_MVPROC);
	pntCascMS		= DB_MapField(pidTable,FLD_CASCADEMS);
	pntCascProc		= DB_MapField(pidTable,FLD_CASCADEPROC);
	}
if(!strcmp(pvmapString,"accum"))
	{
	pntProcFzSpec	= DB_MapField(accumTable,FLD_PROCFZSPEC);
	pntMaxsFzSpec	= DB_MapField(accumTable,FLD_MAXSFZSPEC);
	}
pntScanRate			= DB_MapField(DBC_PvmapTable,FLD_SCANRATE);	/* scan rate if STYPE = PERIODIC */
while(xrefNode)						/* loop to get all desc's */
	{
	if(xrefNode->xrefTable != lastTable)
		{
		xrefConstant	= DB_MapField(xrefNode->xrefTable,FLD_CONSTANT);	/* for link fields */
		xrefReference	= DB_MapField(xrefNode->xrefTable,FLD_REFERENCE);	/* for link fields */
		pntProcInput	= DB_MapField(xrefNode->xrefTable,FLD_PROCINPUT);
		pntMaxSeverity	= DB_MapField(xrefNode->xrefTable,FLD_MAXSEVERITY);
		sprintf(tempName,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,DBC_Name); /* GCT 21-Nov-1997 space pad for ioaddr search */
		pntRecord	= DB_Seek(xrefNode->xrefTable,tempName);	/* record with this name */
		if(pntRecord == 0)
			{
			tisSysLog(V_INFO,0,"Point %s not found in '%s' file\n",DBC_Name,xrefNode->xrefTable->table_name);
			return(DBC_RNF);
			}
		lastTable	= xrefNode->xrefTable;
		}
/*
	See if this is a UDB point. If so then assign the Process point and Max Severity
	fields
*/
	if(strstr(lastTable->table_name,"udb.dbf"))
		{
		char	tempField[11];
		if((xrefNode->xrefFieldDesc->field_type == DBF_INLINK) && 
			strncmp(xrefNode->xrefFieldDesc->fldname,"SDIS",FLDNAME_SZ))
			{
			sscanf(xrefNode->xrefFieldDesc->fldname,"%*c%*c%*c%d",&udbNum);
			sprintf(tempField,"INPUT%dMS",udbNum);
			pntMaxSeverity = DB_MapField(lastTable,tempField);
			sprintf(tempField,"INPUT%dPP",udbNum);
			pntProcInput = DB_MapField(lastTable,tempField);
			}
		if(xrefNode->xrefFieldDesc->field_type == DBF_OUTLINK)
			{
			sscanf(xrefNode->xrefFieldDesc->fldname,"%*c%*c%*c%d",&udbNum);
			sprintf(tempField,"OUTPUT%dPP",udbNum);
			pntProcInput = DB_MapField(lastTable,tempField);
			pntMaxSeverity = 0;	/* none for output */
			}
		}
/*
	If the point type is PTO then check for the POSOUTREF and NEGOUTREF fields
	map them into the 'xrefReference' field pointer for use later.

	GCT	25-May-94
*/
		if(!strcmp(pvmapString,"pto"))
			{
			if(!strncmp(xrefNode->xrefFieldDesc->fldname,"NOUT",FLDNAME_SZ))
				xrefReference	= DB_MapField(xrefNode->xrefTable,FLD_NEGOUTREF);	/* for link fields in PTO */
			else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"POUT",FLDNAME_SZ))
				xrefReference	= DB_MapField(xrefNode->xrefTable,FLD_POSOUTREF);	/* for link fields in PTO */
			}
/*
	If the point type is PAT then check for the POSOUTREF and NEGOUTREF fields
	map them into the 'xrefReference' field pointer for use later.

	GCT	27-Apr-95
*/
		if(!strcmp(pvmapString,"pat"))
			{
			if(!strncmp(xrefNode->xrefFieldDesc->fldname,"NOUT",FLDNAME_SZ))
				xrefReference	= DB_MapField(xrefNode->xrefTable,FLD_NEGOUTREF);	/* for link fields in PAT */
			else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"POUT",FLDNAME_SZ))
				xrefReference	= DB_MapField(xrefNode->xrefTable,FLD_POSOUTREF);	/* for link fields in PAT */
			else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"RLIN",FLDNAME_SZ))
				xrefReference	= DB_MapField(xrefNode->xrefTable,"RLINPUT");	/* for link fields in PAT */
			else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"INP ",FLDNAME_SZ))
				xrefReference	= DB_MapField(xrefNode->xrefTable,"REFERENCE");	/* for link fields in PAT */
			}
	DB_GetFieldValue(pntRecord,xrefNode->xrefField,DBC_Value,&field_type);	/* get database field contents */
	bptr = recdesc -> recPtr + xrefNode->xrefFieldDesc->offset;	/* point to location in record */
	DBC_LinkPtr = (struct link *)bptr;
/*
	Use field_type from SDR to determine how to copy the data from the .DBF file.
*/
	DBC_DoubleValue = 0.0;
	if(field_type == 'F' || field_type == 'N')
		DBC_DoubleValue = *((double *)DBC_ValuePtr);
	switch(xrefNode->xrefFieldDesc->field_type)
		{
		case DBF_CHAR:
		case DBF_UCHAR:
			*bptr = *DBC_ValuePtr;
			break;
		case DBF_SHORT:
		case DBF_USHORT:
		case DBF_ENUM:
			*((short *)bptr) = (short)DBC_DoubleValue;
			*((short*)bptr) = htons(*((short*)bptr));
			break;
		case DBF_LONG:
		case DBF_ULONG:
		  if(field_type == 'C')
		    {
		      int tempInt;
		      tempInt = atoi(DBC_ValuePtr);
		      *((int *)bptr) = tempInt;
		    }
		  else
		    {
		      *((int *)bptr) = (int)DBC_DoubleValue;
		    }
		  *((int*)bptr) = htonl(*((int*)bptr));
		  break;
		case DBF_STRING:
			for(i = 0;i < 10;i++)
				{
				if(!strncmp(xrefNode->xrefFieldDesc->fldname,tankvlvpv[i],FLDNAME_SZ))
					{
					if(DBC_ProcessTankFields(DBC_Name,xrefNode->xrefOpId,
						DBC_ValuePtr,xrefNode->xrefTable,xrefNode->xrefField) != DBC_SUCCESS)
						return(DBC_NOCMDS);
					break;
					}
				}
			if(!strncmp(xrefNode->xrefFieldDesc->fldname,"STPC",FLDNAME_SZ) ||
			    !strncmp(xrefNode->xrefFieldDesc->fldname,"RECC",FLDNAME_SZ) ||
			    !strncmp(xrefNode->xrefFieldDesc->fldname,"ISSC",FLDNAME_SZ) ||
			    !strncmp(xrefNode->xrefFieldDesc->fldname,"RUNC",FLDNAME_SZ))
				{
				if(DBC_ProcessTankFields(DBC_Name,xrefNode->xrefOpId,
					bptr,xrefNode->xrefTable,xrefNode->xrefField) != DBC_SUCCESS)
					return(DBC_NOCMDS);
				}
			else
				(void)memcpy(bptr,(char*)DBC_ValuePtr,xrefNode->xrefFieldDesc->size);
			break;
		case DBF_FLOAT:
			*((float *)bptr) = (float)DBC_DoubleValue;
			*((unsigned int *)bptr) = htonl(*((unsigned int*)bptr));
			break;
		case DBF_DOUBLE:
			*((double *)bptr) = DBC_DoubleValue; /* just in case */
			for(i = 0;i < 10;i++)
				{
				if(!strncmp(xrefNode->xrefFieldDesc->fldname,tankproblvl[i],FLDNAME_SZ))
					{
					if(DBC_ProcessTankFields(DBC_Name,xrefNode->xrefOpId,
						bptr,xrefNode->xrefTable,xrefNode->xrefField) != DBC_SUCCESS)
						return(DBC_NOCMDS);
					break;	/* search no more */
					}
				}
			htond(*(double *)bptr,*(double *)bptr);	/* new macro see DBCDefines.h */
			break;
		case DBF_INLINK:
		case DBF_OUTLINK:
			memset(DBC_LinkPtr,'\0',sizeof(struct link));   /* clear link union first */
			if((!strcmp(pvmapString,"calc")  ||
			    !strcmp(pvmapString,"sel")   ||
			    !strcmp(pvmapString,"pot")   ||
			    !strcmp(pvmapString,"valve") ||
			    !strcmp(pvmapString,"pump")  ||
			    !strcmp(pvmapString,"pipe")  ||
			    !strcmp(pvmapString,"tank")) &&
			     (strncmp(xrefNode->xrefFieldDesc->fldname,"SDIS",FLDNAME_SZ) &&
			      strncmp(xrefNode->xrefFieldDesc->fldname,"ADIS",FLDNAME_SZ) &&
			      strncmp(xrefNode->xrefFieldDesc->fldname,"NVL ",FLDNAME_SZ)))
				{
				if(DBC_ProcessSpecialLinks(DBC_Name,DBC_LinkPtr,xrefNode->xrefTable,
					xrefNode->xrefOpId,pvmapString) != DBC_SUCCESS)
					return(DBC_LINKERR);
				break;
				}
/*
	Set the correct Maximize Severity & Process Input fields for the PID
	and ACC fields
*/
			if(!strcmp(pvmapString,"accum"))
				{
				if(!strncmp(xrefNode->xrefFieldDesc->fldname,"AFIS",FLDNAME_SZ))
					{
					pntProcInput = pntProcFzSpec;
					pntMaxSeverity = pntMaxsFzSpec;
					}
				}
			if(!strcmp(pvmapString,"pid"))
				{
				if(!strncmp(xrefNode->xrefFieldDesc->fldname,"STPL",FLDNAME_SZ))
					{
					pntProcInput = pntSetPtProc;
					pntMaxSeverity = pntSetPtMS;
					}
				else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"MVL ",FLDNAME_SZ))
					{
					pntProcInput = pntMvProc;
					pntMaxSeverity = pntMvMS;
					}
				else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"DSCS",FLDNAME_SZ))
					{
					pntProcInput = pntCascProc;
					pntMaxSeverity = pntCascMS;
					}
				}
/*
	If field can have hardware (xrefHardware == 1) then process like normal, that is
	use BOARDTYPE field to determine REFERENCE or CONSTANT or actual hardware. If the
	field cannot have hardware (xrefHardware == 0) then use the contents of the
	REFERENCE or CONSTANT fields directly when filling link structure.
*/
			if(xrefNode->xrefHardware)
				{
/*
	DBC_Value is the contents of the appropriate BOARDTYPE field.
*/
				if(!strcmp(DBC_ValuePtr,"CONSTANT") ||
					!strcmp(DBC_ValuePtr,"PAT BO CONSTANT") ||
					!strcmp(DBC_ValuePtr,"PAT BI CONSTANT") ||
					!strcmp(DBC_ValuePtr,"PAT AI CONSTANT"))
					{
					DBC_DoubleValue = 0.0;
					if(xrefConstant)
						DB_GetFieldValue(pntRecord,xrefConstant,&DBC_DoubleValue,&field_type);
					DBC_LinkPtr -> type = CONSTANT;
					DBC_LinkPtr -> value.value = (float)DBC_DoubleValue;
					*((unsigned int *)&DBC_LinkPtr -> value.value) = htonl(*((unsigned int *)&DBC_LinkPtr -> value.value));
					}
				else if(!strcmp(DBC_ValuePtr,"REFERENCE") ||
					!strcmp(DBC_ValuePtr,"PAT BO REFERENCE") ||
					!strcmp(DBC_ValuePtr,"PAT BI REFERENCE") ||
					!strcmp(DBC_ValuePtr,"PAT AI REFERENCE"))
					{
					DBC_LinkPtr -> type = PV_LINK;
					if(pntProcInput)
						{
						DB_GetFieldValue(pntRecord,pntProcInput,&boolean,&field_type);
						DBC_LinkPtr->value.pv_link.process_passive = boolean;
						DBC_LinkPtr->value.pv_link.process_passive = htons(DBC_LinkPtr->value.pv_link.process_passive);
						}
					if(pntMaxSeverity)
						{
						DB_GetFieldValue(pntRecord,pntMaxSeverity,&boolean,&field_type);
						DBC_LinkPtr->value.pv_link.maximize_sevr = boolean;
						DBC_LinkPtr->value.pv_link.maximize_sevr = htons(DBC_LinkPtr->value.pv_link.maximize_sevr);
						}
					DB_GetFieldValue(pntRecord,xrefReference,pvString,&field_type);
					if(!strlen(pvString))
						{
						DBC_DoubleValue = 0.0;
						if(xrefConstant)
							DB_GetFieldValue(pntRecord,xrefConstant,&DBC_DoubleValue,&field_type);
						DBC_LinkPtr -> type = CONSTANT;
						DBC_LinkPtr -> value.value = (float)DBC_DoubleValue;
						*((unsigned int *)&DBC_LinkPtr -> value.value) = htonl(*((unsigned int *)&DBC_LinkPtr -> value.value));
						}
					else
						{
						splitLinkName(DBC_LinkPtr,pvString);
						}
					}
				else			/* BOARDTYPE must contain a board type string to search devSup choice list. */
					{
					sprintf(tempName,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,DBC_Name); /* GCT 21-Nov-1997 space pad for ioaddr search */
/*
	GCT 22-Sep-1993

	For PTO, the entry in the IOADDR file may be duplicated. To avoid this,
	the point name will have a '1' or a '2' appended depending on the EPICS
	field name. For NOUT the name will have a '1' appended. For POUT it will
	have a '2'.
*/
					if(!strcmp(pvmapString,"pto"))
						{
						if(!strncmp(xrefNode->xrefFieldDesc->fldname,"POUT",FLDNAME_SZ))
							sprintf(tempName,"%s1\0",DBC_Name);
						else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"NOUT",FLDNAME_SZ))
							sprintf(tempName,"%s2\0",DBC_Name);
						}
/*
	GCT 27-Apr-1995

	For PAT, the entry in the IOADDR file may be quadruplicated. To avoid this,
	the point name will have a '1','2','3' or '4' appended depending on the EPICS
	field name. For NOUT the name will have a '1' appended. For POUT it will
	have a '2'.
*/
					if(!strcmp(pvmapString,"pat"))
						{
						if(!strncmp(xrefNode->xrefFieldDesc->fldname,"POUT",FLDNAME_SZ))
							sprintf(tempName,"%s1\0",DBC_Name);
						else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"NOUT",FLDNAME_SZ))
							sprintf(tempName,"%s2\0",DBC_Name);
						if(!strncmp(xrefNode->xrefFieldDesc->fldname,"RLIN",FLDNAME_SZ))
							sprintf(tempName,"%s3\0",DBC_Name);
						else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"INP ",FLDNAME_SZ))
							sprintf(tempName,"%s4\0",DBC_Name);
						}
					sprintf(tempName,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,tempName); /* GCT 21-Nov-1997 space pad for ioaddr search */
					if(DBC_ProcessHdwLink(type_index,DBC_LinkPtr,tempName) != DBC_SUCCESS)
					  {
					    tisSysLog(V_INFO,0,"Point %s not found in '%s' file\n",DBC_Name,xrefNode->xrefTable->table_name);
					    return(DBC_RNF);
					  }
					}
				}
			else		/* NO Hardware, use field contents directly this could be the DOL field in output types */
				{
				if(xrefNode->xrefRefField)		/* is there a reference field defined in PDBXREF ? */
					{							/* YES */
					DBC_LinkPtr -> type = PV_LINK;
					if(pntProcInput)
						{
						DB_GetFieldValue(pntRecord,pntProcInput,&boolean,&field_type);
						DBC_LinkPtr->value.pv_link.process_passive = boolean;
						DBC_LinkPtr->value.pv_link.process_passive = htons(DBC_LinkPtr->value.pv_link.process_passive);
						}
					if(pntMaxSeverity)
						{
						DB_GetFieldValue(pntRecord,pntMaxSeverity,&boolean,&field_type);
						DBC_LinkPtr->value.pv_link.maximize_sevr = boolean;
						DBC_LinkPtr->value.pv_link.maximize_sevr = htons(DBC_LinkPtr->value.pv_link.maximize_sevr);
						}
					DB_GetFieldValue(pntRecord,xrefNode->xrefRefField,pvString,&field_type);
					if(!strlen(pvString))
						{
						DBC_DoubleValue = 0.0;			/* default value */
						if(xrefReference)
							DB_GetFieldValue(pntRecord,xrefReference,pvString,&field_type);
						if((xrefNode->xrefConstField) && ((devtype == DEV_REFERENCE) || (devtype == DEV_CONSTANT)) && strlen(pvString))
							DB_GetFieldValue(pntRecord,xrefNode->xrefConstField,&DBC_DoubleValue,&field_type);
						DBC_LinkPtr -> type = CONSTANT;
						DBC_LinkPtr -> value.value = (float)DBC_DoubleValue;
						*((unsigned int *)&DBC_LinkPtr -> value.value) = htonl(*((unsigned int *)&DBC_LinkPtr -> value.value));
						}
					else
						{
						splitLinkName(DBC_LinkPtr,pvString);
						}
					}
				else if(xrefNode->xrefConstField)
					{
					DB_GetFieldValue(pntRecord,xrefNode->xrefConstField,&DBC_DoubleValue,&field_type);
					DBC_LinkPtr -> type = CONSTANT;
					DBC_LinkPtr -> value.value = (float)DBC_DoubleValue;
					*((unsigned int *)&DBC_LinkPtr -> value.value) = htonl(*((unsigned int *)&DBC_LinkPtr -> value.value));
					}
				else									/* neither REFERENCE or CONSTANT default to CONSTANT of 0.0 */
					{
					DBC_DoubleValue = 0.0;
					DBC_LinkPtr -> type = CONSTANT;
					DBC_LinkPtr -> value.value = (float)DBC_DoubleValue;
					*((unsigned int *)&DBC_LinkPtr -> value.value) = htonl(*((unsigned int *)&DBC_LinkPtr -> value.value));
					}
				}
			DBC_LinkPtr -> type = htonl(DBC_LinkPtr -> type);
			break;
		case DBF_FWDLINK:
			memset(DBC_LinkPtr,'\0',sizeof(struct link));	/* clear link union first */
			if(!strcmp(pvmapString,"fanout"))
				{
				if(DBC_ProcessSpecialLinks(DBC_Name,DBC_LinkPtr,xrefNode->xrefTable,
					xrefNode->xrefOpId,pvmapString) != DBC_SUCCESS)
					return(DBC_LINKERR);
				break;
				}
			if(!strlen(DBC_ValuePtr))
				{
				DBC_LinkPtr -> type = htonl(CONSTANT);
				DBC_LinkPtr -> value.value = (float)0.0;
				DBC_LinkPtr->value.pv_link.process_passive =
					htons(DBC_LinkPtr->value.pv_link.process_passive);
				}
			else
				{
				DBC_LinkPtr -> type = htonl(PV_LINK);
				splitLinkName(DBC_LinkPtr,DBC_ValuePtr);
				}
			break;
		case DBF_GBLCHOICE:
/*
	If the database field is a LOGICAL (True or False) then ignore the DBF_GBLCHOICE
	field type and put the value directly into the record.
	
	If the OV field name is STYPE then we must check for "Periodic". If it is
	periodic then we should replace the choice string from the SRATE field in 'pvmap'.

	If the field is one of the indicator fields in a valve record then get the value
	and we're done. GCT 01-JUL-1993
*/
			for(i = 0;indicators[i];i++)
				{
				if(!strncmp(xrefNode->xrefFieldDesc->fldname,indicators[i],FLDNAME_SZ))
					{
					if(DBC_ProcessTankFields(DBC_Name,xrefNode->xrefOpId,
						DBC_ValuePtr,xrefNode->xrefTable,xrefNode->xrefField) != DBC_SUCCESS)
						return(DBC_NOCMDS);
					break;
					}
				}
			for(i = 0;trips[i];i++)
				{
				if(!strncmp(xrefNode->xrefFieldDesc->fldname,trips[i],FLDNAME_SZ))
					{
					if(DBC_ProcessTankFields(DBC_Name,xrefNode->xrefOpId,
						DBC_ValuePtr,xrefNode->xrefTable,xrefNode->xrefField) != DBC_SUCCESS)
						return(DBC_NOCMDS);
					break;
					}
				}
			if(field_type == 'L')
				{
				xrefNode->xrefTrue &= 1;
				*((short *)bptr) = (*DBC_ValuePtr ? xrefNode->xrefTrue : (xrefNode->xrefTrue ^ 1));
				}
			else
				{
				if(!strcmp(DBC_ValuePtr,"Periodic"))
					{
					DB_GetFieldValue(pntRecord,pntScanRate,&DBC_DoubleValue,&field_type);
/*
	The following code was adapted from the export utility. It is needed here
	for the same reason it was needed there.
*/
					if(DBC_DoubleValue > 5.0)
						sprintf(DBC_ValuePtr,"%2.0f second\0",DBC_DoubleValue);
					else if(DBC_DoubleValue > 0.9)
						sprintf(DBC_ValuePtr,"%1.0f second\0",DBC_DoubleValue);
					else if(DBC_DoubleValue < .15)
					strcpy(DBC_ValuePtr,"100 ms");
					else if(DBC_DoubleValue < .25)
						strcpy(DBC_ValuePtr,"200 ms");
					else
						strcpy(DBC_ValuePtr,"500 ms");
					}
				if((stat =  DBC_ProcessChoice(xrefNode->xrefFieldDesc->field_type,
					xrefNode->xrefFieldDesc->choice_set,
					DBC_ValuePtr,type_index,&choiceIndex)) != DBC_SUCCESS)
						return(stat);
				*((short *)bptr) = choiceIndex;
				}
			*((short *)bptr) = htons(*((short *)bptr));
			break;
/*
	So far the only DBF_DEVCHOICE field is DTYP. this field maps to the BOARDTYPE field in points that have hardware. I
	save a pointer to this field for later processing of DBF_INLINK & DBF_OUTLINK fields.

	25-Feb-1994 If the board type field is CONSTANT then the DOL fields (or link structures) in the output block
	types (BO,AO,MBBO etc) should NOT use the CONSTANT field from their respective .DBF files. This is to avoid
	a conflict between the two areas where constants appear.

	30-Oct-1995 So much for only ONE DBF_DEVCHOICE field. Now for "pat" blocks, there are three! The original DTYP, and
	one for the Remote/Local board type and one for the Feedback board. The two new field names are DTYR & DTYF for
	R/L & Feedback.
*/
		case DBF_DEVCHOICE:
			if(!strcmp(DBC_ValuePtr,"REFERENCE") ||
					!strcmp(DBC_ValuePtr,"PAT BO REFERENCE") ||
					!strcmp(DBC_ValuePtr,"PAT BI REFERENCE") ||
					!strcmp(DBC_ValuePtr,"PAT AI REFERENCE")) 
				{
				if(type_index == VU_PAT)
					{
					if(!strncmp(xrefNode->xrefFieldDesc->fldname,"DTYP",FLDNAME_SZ))
						choiceIndex = PAT_DTYP_REF;
					else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"DTYR",FLDNAME_SZ))
						choiceIndex = PAT_DTYR_REF;
					else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"DTYF",FLDNAME_SZ))
						choiceIndex = PAT_DTYF_REF;
					*((short *)bptr) = htons(choiceIndex);
					break;
					}
				devtype = DEV_REFERENCE;
				choiceIndex = PV_LINK;
				*((short *)bptr) = htons(choiceIndex);
				break;
				}
			else if(!strlen(DBC_ValuePtr))
				{
				devtype = DEV_CONSTANT;
				choiceIndex = CONSTANT;
				*((short *)bptr) = htons(choiceIndex);
				break;
				}
			else if(!strcmp(DBC_ValuePtr,"CONSTANT") ||
					!strcmp(DBC_ValuePtr,"PAT BO CONSTANT") ||
					!strcmp(DBC_ValuePtr,"PAT BI CONSTANT") ||
					!strcmp(DBC_ValuePtr,"PAT AI CONSTANT"))
				{
				if(type_index == VU_PAT)
					{
					if(!strncmp(xrefNode->xrefFieldDesc->fldname,"DTYP",FLDNAME_SZ))
						choiceIndex = PAT_DTYP;
					else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"DTYR",FLDNAME_SZ))
						choiceIndex = PAT_DTYR;
					else if(!strncmp(xrefNode->xrefFieldDesc->fldname,"DTYF",FLDNAME_SZ))
						choiceIndex = PAT_DTYF;
					*((short *)bptr) = htons(choiceIndex);
					break;
					}
				devtype = DEV_CONSTANT;
				choiceIndex = CONSTANT;
				*((short *)bptr) = htons(choiceIndex);
				break;
				}
			if((stat = DBC_ProcessChoice(xrefNode->xrefFieldDesc->field_type,xrefNode->xrefFieldDesc->choice_set,
				DBC_ValuePtr,type_index,&choiceIndex)) != DBC_SUCCESS)
					return(stat);	/* stop if ERROR */
			devtype = choiceIndex;
			pntt = choiceIndex;
			*((short *)bptr) = htons(choiceIndex);
			break;
		case DBF_RECCHOICE:
			for(i = 0;i<40;i++)
				{
				if(!strncmp(xrefNode->xrefFieldDesc->fldname,tankvlvstats[i],FLDNAME_SZ))
					{
					if(DBC_ProcessTankFields(DBC_Name,xrefNode->xrefOpId,
						DBC_ValuePtr,xrefNode->xrefTable,xrefNode->xrefField) != DBC_SUCCESS)
						return(DBC_NOCMDS);
					break;
					}
				}
			if((i < 40) && !strlen(DBC_ValuePtr))
				break;
		case DBF_CVTCHOICE:
			if(field_type == 'L')
				{
				xrefNode->xrefTrue &= 1;
				*((short *)bptr) = (*DBC_ValuePtr ? xrefNode->xrefTrue : (xrefNode->xrefTrue ^ 1));
				}
			else
				{
				if((stat = DBC_ProcessChoice(xrefNode->xrefFieldDesc->field_type,
					xrefNode->xrefFieldDesc->choice_set,
					DBC_ValuePtr,type_index,&choiceIndex)) != DBC_SUCCESS)
						return(stat);	/* stop if ERROR */
				*((short *)bptr) = choiceIndex;
				}
			*((short *)bptr) = htons(*((short *)bptr));
			break;
		}
	xrefNode = (DBC_XREFTABLE_PTR)lstNext((NODE *)xrefNode);
	}
return(DBC_SUCCESS);
}
DBC_ERROR_CODES	DBC_ProcessChoice(choice_type,choice_set,value_ptr,type,ci)
short	choice_type,choice_set;
char	*value_ptr;
int	type;
short	*ci;
{
struct choiceSet	*DBC_ChoiceSet;
struct arrChoiceSet	*DBC_ArrChoiceSet;
struct devChoiceSet	*DBC_DevChoiceSet;
int 	i;
char	*pchoice;

switch(choice_type)
	{
	case DBF_GBLCHOICE:
		if(!(DBC_ChoiceSet = GET_PCHOICE_SET(choiceGbl,choice_set)))
			return(DBC_CHOICEERR);
		i = 0;
		while(i < DBC_ChoiceSet->number)
			{
			if((pchoice = GET_CHOICE(DBC_ChoiceSet,i)))
				{
				if(!strcmp(pchoice,(char *)value_ptr))
					{
					*ci = i;
					return(DBC_SUCCESS);
					}
				}
			i++;
			}
		return(DBC_CHOICEERR);
	case DBF_CVTCHOICE:
		if(!choiceCvt)
			return(DBC_CVTCHOICEERR);
		i = 0;
		while(i < choiceCvt->number)
			{
			if((pchoice = GET_CHOICE(choiceCvt,i)))
				{
				if(!strcmp(pchoice,(char *)value_ptr))
					{
					*ci = i;
					return(DBC_SUCCESS);
					}
				}
			i++;
			}
		return(DBC_CVTCHOICEERR);
	case DBF_RECCHOICE:
		if(!(DBC_ArrChoiceSet = GET_PARR_CHOICE_SET(choiceRec,type)))
			return(DBC_ARRCHOICEERR);
		if(!(DBC_ChoiceSet = GET_PCHOICE_SET(DBC_ArrChoiceSet,choice_set)))
			return(DBC_ARRCHOICEERR);
		i = 0;
		while(i < DBC_ChoiceSet->number)
			{
			if((pchoice = GET_CHOICE(DBC_ChoiceSet,i)))
				{
				if(!strcmp(pchoice,(char *)value_ptr))
					{
					*ci = i;
					return(DBC_SUCCESS);
					}
				}
			i++;
			}
		return(DBC_ARRCHOICEERR);
	case DBF_DEVCHOICE:
		if(!(DBC_DevChoiceSet = GET_PDEV_CHOICE_SET(choiceDev,type)))
			return(DBC_DEVCHOICEERR);
		i = 0;
		while(i < DBC_DevChoiceSet->number)
			{
			if((pchoice = (GET_DEV_CHOICE(DBC_DevChoiceSet,i)->pchoice)))
				{
				if(!strcmp(pchoice,(char *)value_ptr))
					{
					*ci = i;
					return(DBC_SUCCESS);
					}
				}
			i++;
			}
		return(DBC_DEVCHOICEERR);
	}
return(DBC_SUCCESS);
}
DBC_ERROR_CODES	DBC_ProcessHdwLink(tindex,lptr,name)
int		tindex;
struct	link	*lptr;
char		*name;
{
int	link_type;
short	line,address,card,signal;
if(DBC_ProcessHardware(name,&line,&address,&card,&signal) != DBC_SUCCESS)
  return(DBC_RNF);
link_type = GET_DEV_CHOICE_LINK_VAL(tindex,pntt);
switch(link_type)
	{
	case VME_IO:
		break;
	case CAMAC_IO:
		break;
	case AB_IO:
		lptr -> type = AB_IO;
		lptr -> value.abio.link		= htons(line);
		lptr -> value.abio.adapter	= htons(address);
		lptr -> value.abio.card		= htons(card);
		lptr -> value.abio.signal	= htons(signal);
		break;
	case GPIB_IO:
		break;
	case BITBUS_IO:
		break;
	case INST_IO:
		break;
	case BBGPIB_IO:
		break;
#ifdef SEP_IO					/* see link.h for DTYP number defs */
	case SAB_IO:
	case SMOD_IO:
	case SMIC_IO:
	case SABRTU_IO:
	case STCS_IO:
	case SAD_IO:
	case SBDX_IO:				/* Bendix I/O 22-Mar-1993 */
	case SBRKS_IO:
	case RES_IO:				/* Resource Status 10-May-1993 */
	case V984_IO:				/* VME MODICON 08-Oct-1993 */
	case TIWAY_IO:				/* following 9 I/O types are new as of 10-Feb-1994 */
	case ARCOM_IO:
	case MDS_IO:
	case ENRAF_IO:
	case DANIELS_IO:
	case QEI_IO:
	case MAPBD_IO:
	case CSI_IO:
	case RTU_IO:
	case VALMET_IO:				/* 23-May-94 GCT support for Valmet driver */
	case TRANE_IO:				/* 26-Aug-94 GCT support for Trane driver */
	case HYUNDAI_IO:			/* 17-Nov-94 GCT support for the HYUNDAI driver */
	case RTP_IO:				/* 17-Jan-95 GCT support for RTP/DAP drivers */
	case GE_IO:
	case HART_IO:				/* these three added 6-Feb-1995 GCT */
	case SV85_IO:
	case BAILEY_IO:				/* 19-Apr-95 GCT support for Bailey Controls driver */
	case SECURITY_IO:			/* 20-Jul-95 GCT Support for SECURITY driver */
	case NETPAC_IO:				/* 31-Jul-95 GCT Support for Netpac driver */
	case EAB_IO:				/* 15-Sep-95 GCT Support for Ethernet AB I/O */
#else
	default:
#endif
		lptr->type = link_type;
		lptr -> value.tateio.link	= htons(line);
		lptr -> value.tateio.adapter	= htons(address);
		lptr -> value.tateio.card	= htons(card);
		lptr -> value.tateio.signal	= htons(signal);
		break;
	}
return(DBC_SUCCESS);
}
DBC_ERROR_CODES	DBC_ProcessHardware(name,line,addr,card,sig)
char	*name;
short	*line,*addr,*card,*sig;
{
int	type;
double	val;
DB_RECORD_PTR	rec;
/*
	Find record with this name and extract hardware info. If seek fails
	then default to zeros
*/
if((rec = DB_Seek(DBC_IOAddrTable,name)) != 0)
	{
	DB_GetFieldValue(rec,ioaddrLine,&val,&type);
	*line = (short)val;
	DB_GetFieldValue(rec,ioaddrAddress,&val,&type);
	*addr = (short)val;
	DB_GetFieldValue(rec,ioaddrCard,&val,&type);
	*card = (short)val;
	DB_GetFieldValue(rec,ioaddrSignal,&val,&type);
	*sig = (short)val;
	return(DBC_SUCCESS);
	}
else
	{
	*line = 0;
	*addr = 0;
	*card = 0;
	*sig  = 0;
	return(DBC_RNF);
	}
return(DBC_SUCCESS);;
}
DBC_ERROR_CODES	DBC_ProcessSpecialLinks(name,lptr,table,id,pt)
char		*name;
struct link	*lptr;
DB_TABLE_PTR	table;
char		*id;
char		*pt;					/* point type string */
{
char	key[DBC_KEY_SIZE];
DB_RECORD_PTR	rec;
DB_FIELD_PTR	xrefConstant,xrefReference,pntProcInput,pntMaxSeverity;
DB_FIELD_PTR	pntVarName,pntProbeName;
char		ref[30],proc,max;
double		Const;
float		floatConst;
int		type;
xrefConstant	= DB_MapField(table,FLD_CONSTANT);	/* for link fields */
xrefReference	= DB_MapField(table,FLD_REFERENCE);	/* for link fields */
pntProcInput	= DB_MapField(table,FLD_PROCINPUT);
pntMaxSeverity	= DB_MapField(table,FLD_MAXSEVERITY);
pntVarName	= DB_MapField(table,FLD_VARNAME);	/* NEW FOR TANK FARM */
pntProbeName	= DB_MapField(table,FLD_PROBENAME);	/* NEW FOR TANK FARM */
sprintf(key,"%-*.*s%s\0",PVNAME_SZ,PVNAME_SZ,name,id);	/* Construct search key for this file */
if(rec = DB_Seek(table,key))				/* get next one with this point name */
	{
	if(xrefReference ||
	   pntVarName ||
	   pntProbeName)				/* is there a reference field? */
		{
		if(xrefReference)
			DB_GetFieldValue(rec,xrefReference,ref,&type);
		else if(pntVarName)
			DB_GetFieldValue(rec,pntVarName,ref,&type);
		else
			DB_GetFieldValue(rec,pntProbeName,ref,&type);
		}
	if(!strlen(ref))
		{
		Const=0.0;
		if(xrefConstant)
			DB_GetFieldValue(rec,xrefConstant,&Const,&type);	/* ref is a Constant */
		lptr -> type = htonl(CONSTANT);
		floatConst = (float)Const;
		*((unsigned int *)&lptr -> value.value) = htonl(*((unsigned int *)&floatConst));
		return(DBC_SUCCESS);
		}
	else
		{
		lptr -> type = htonl(PV_LINK);
		splitLinkName(lptr,ref);
		if(pntProcInput)
			{
			DB_GetFieldValue(rec,pntProcInput,&proc,&type);		/* process passive */
			lptr -> value.pv_link.process_passive = htons(proc);
			}
		if(pntMaxSeverity)
			{
			DB_GetFieldValue(rec,pntMaxSeverity,&max,&type);	/* maximize severity */
			lptr -> value.pv_link.maximize_sevr = htons(max);
			}
		return(DBC_SUCCESS);
		}
	}
return(DBC_LINKERR);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			10-Jun-1993				      */
/*									      */
/*	Function Name:		Process tank fields			      */
/*	Function Description:						      */
/*		This function will handle the following Tank Farm point	      */
/*	types and fields:						      */
/*									      */
/*		PIPE:	Commands					      */
/*		TANK:	Commands,Probe levels,Valve strings		      */
/*		PUMP:	Commands					      */
/*		VALVE:	Commands					      */
/*		POT:	Commands					      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
DBC_ERROR_CODES	DBC_ProcessTankFields(name,cmdstr,rtnstr,table,field)
char		*name,*cmdstr,*rtnstr;
DB_TABLE_PTR	table;
DB_FIELD_PTR	field;
{
char	key[DBC_KEY_SIZE];
DB_RECORD_PTR	rec;
int	type;

sprintf(key,"%-*.*s%s",PVNAME_SZ,PVNAME_SZ,name,cmdstr);
if(rec = DB_Seek(table,key))
	{
	DB_GetFieldValue(rec,field,rtnstr,&type);
	return(DBC_SUCCESS);
	}
return(DBC_NOCMDS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			18-Jan-1993				      */
/*									      */
/*	Function Name:		DBC_DownloadRequest			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*				iocinfo - pointer to DBC_IOCINFO structure    */
/*									      */
/*	Output Parameters:	none.					      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
char targetDL[PVNAME_SZ+1];
DBC_ERROR_CODES	DBC_DownloadRequest(iocinfo)
DBC_IOCINFO_PTR		iocinfo;
{
DBC_DWNLD_REQUEST	msg;
char				DBC_PointName[PVNAME_SZ],DBC_MsgPointName[PVNAME_SZ],DBC_LastPoint[PVNAME_SZ];
DBC_DWNLD_RESP		DBC_DwnldResp;
DBC_RESINFO_PTR		resinfo;
DB_RECORD_PTR		dnldRecord;
DB_FIELD_PTR		dnldField,dnldResField;
char				res[DBC_RESNAMESIZE],crc_string[5],dnldTrue;
int					type,i,stat,iocIndex,breakPoint;
short				numToSend;
unsigned short		crc,msgType;
VERIFY_INFO			verify_info;
#ifdef	DO_TIME_STATS
double	pps;
int total_this_time;
struct timeval	startTime,finishTime,avgTime,totalTime;
#endif
/*
	Start with the record AFTER the one given in the message. If the record
	in the message is NULL then start with the first record in PVMAP.
*/
dnldTrue = TRUE;					/* record has been downloaded */
readTcp(iocinfo,(char *)&msg,DBC_REQSIZE);
dnldResField = DB_MapField(DBC_PvmapTable,FLD_RESOURCE);
dnldField = DB_MapField(DBC_PvmapTable,FLD_NAME);
strcpy(DBC_MsgPointName,msg.msgLastName);
strcpy(DBC_LastPoint,msg.msgLastName);
DB_UseKey(DBC_PvmapTable,FLD_NAME);		/* change to keyed access here */
if(strlen(DBC_MsgPointName))
	{
	dnldRecord = DB_Seek(DBC_PvmapTable,DBC_MsgPointName);
	dnldRecord = DB_SeekNext(DBC_PvmapTable);	/* next record */
	}
else
	{
	iocinfo -> ioc_state = IOC_DOWNLOADING;
	dnldRecord = DB_Top(DBC_PvmapTable);
#ifdef	DO_TIME_STATS
	if(!time_stats)
		time_stats = (BUILD_TIME_PTR)calloc(dbRecType->number,sizeof(BUILD_TIME));	/* create array dynamically */
	else
		memset(time_stats,'\0',dbRecType->number*sizeof(BUILD_TIME));
#endif
	}
DBC_DwnldResp.msgNumberSent = 0;
while(dnldRecord && (DBC_DwnldResp.msgNumberSent < DBC_WINDOW_SIZE))
	{
	DB_GetFieldValue(dnldRecord,dnldResField,res,&type);
	if((resinfo = dbcResSearch(res)) != 0)
		{
/*
	See if the resource in the record is in the IOC requesting the record. If so
	then 'lock and load'. Just compare the pointers.
*/
		if((resinfo -> res_iocinfo[0] != iocinfo) &&
		   (resinfo -> res_iocinfo[1] != iocinfo))
			{
			dnldRecord = DB_SeekNext(DBC_PvmapTable);
			continue;
			}

		if(resinfo -> res_iocinfo[0] == iocinfo)
			iocIndex = 0;
		if(resinfo -> res_iocinfo[1] == iocinfo)
			iocIndex = 1;

		DB_GetFieldValue(dnldRecord,dnldField,DBC_PointName,&type);
/*
	If the point I got is the same as the point I just processed
	then it is duplicate record. Terminate the download for this IOC
	by telling the IOC that there are no more points to send.
*/
		if(!strcmp(DBC_MsgPointName,DBC_PointName))
			{
			fprintf(stderr,"DBC - Duplicate point name detected: %s\n",DBC_PointName);
			fprintf(stderr,"    - Download terminated at: %s\n",DBC_LastPoint);
			msgType = htons(DBC_MSG_DWNLDRESP);
			writeTcp(iocinfo,(char *)&msgType,sizeof(msgType));		/* send message type */
			DBC_DwnldResp.msgNumberSent = 0;
			writeTcp(iocinfo,(char *)&DBC_DwnldResp,DBC_RESPSIZE);		/* send response header */
			return(DBC_SUCCESS);
			}
#ifdef	DO_TIME_STATS
		gettimeofday(&startTime,0);
#endif
		if(!strcmp(targetDL,DBC_PointName))
		  breakPoint = 1;
		stat = DBC_BuildRecord(DBC_PointName,&downloadRecDesc[DBC_DwnldResp.msgNumberSent],dnldRecord);
#ifdef	DO_TIME_STATS
		gettimeofday(&finishTime,0);
		SubTimes(&finishTime,&startTime);
		AddTimes(&time_stats[downloadRecDesc[DBC_DwnldResp.msgNumberSent].recType].total_time,&finishTime);
		time_stats[downloadRecDesc[DBC_DwnldResp.msgNumberSent].recType].total_count++;
#endif
		if(stat == DBC_SUCCESS)
			{
			crc = DBC_CRCRecord(downloadRecDesc[DBC_DwnldResp.msgNumberSent].recPtr,downloadRecDesc[DBC_DwnldResp.msgNumberSent].recType);
			dbSetCRC(downloadRecDesc[DBC_DwnldResp.msgNumberSent].recPtr,crc);	/* GCT 20-Jun-1997 store CRC in download record */
			sprintf(crc_string,"%04.04X",crc);	/* update CRC in PVMAP */
			DB_PutFieldValue(dnldRecord,pvmapCRCField,crc_string);
			DB_GetVerifyInfo(DBC_PvmapTable,DBC_PointName,&verify_info,0);
			verify_info.viPVStatus |= (iocIndex == 0 ? VI_LOADED_1 : VI_LOADED_2);
			DB_PutVerifyInfo(DBC_PvmapTable,DBC_PointName,&verify_info,0);
			DBC_DwnldResp.msgNumberSent++;		/* bump number sent */
			strcpy(&iocinfo -> ioc_lastpt[0],DBC_PointName);
			}
		else
			{
			iocinfo -> ioc_state = IOC_OK;
			tisSysLog(V_INFO,0,"DBC - Unable to download <%s> to <%s>...%s\n",
				DBC_PointName,iocinfo->ioc_name,DBC_ErrorMsg[stat]);
			}

		}
	dnldRecord = DB_SeekNext(DBC_PvmapTable);				/* in alpha order */
	}
/*
	Send the download message NOW! If none to send,then send zero and change
	IOC state from IOC_DOWNLOADING to IOC_OK.
*/
msgType = htons(DBC_MSG_DWNLDRESP);
writeTcp(iocinfo,(char *)&msgType,sizeof(msgType));		/* send message type */
numToSend = DBC_DwnldResp.msgNumberSent;
/* Send header first */
DBC_DwnldResp.msgNumberSent = htons(DBC_DwnldResp.msgNumberSent);
writeTcp(iocinfo,(char *)&DBC_DwnldResp,DBC_RESPSIZE);		/* send response header */
/*
	If numToSend is zero then we are done. Now ask for symbol table
	from IOC.
*/
if(numToSend == 0)
	{
#ifdef	DO_TIME_STATS
	totalTime.tv_sec = 0;
	totalTime.tv_usec = 0;
	total_this_time = 0;
	for(i=0;i < dbRecType->number;i++)
		{
		if(time_stats[i].total_count)
			{
			avgTime.tv_sec = time_stats[i].total_time.tv_sec;
			avgTime.tv_usec = time_stats[i].total_time.tv_usec;
			DivTimes(&avgTime,time_stats[i].total_count);
			tisSysLog(V_DEBUG,0,"Point type: %-12.12s Count: %5d Avg. Time: %7.5f Total time: %7.5f\n",
				GET_PRECTYPE(i),
				time_stats[i].total_count,
				DecimalTimes(&avgTime),
				DecimalTimes(&time_stats[i].total_time));
			total_this_time += time_stats[i].total_count;
			AddTimes(&totalTime,&time_stats[i].total_time);
			}
		}
	pps = total_this_time/DecimalTimes(&totalTime);
	tisSysLog(V_STATUS,0,"Total points for this download %d Total time: %7.5f Points/Sec %7.5f\n\n",
				total_this_time,DecimalTimes(&totalTime),
				pps);
#endif
	DBC_ProcessSymPurge(iocinfo);				/* purge and ask */
	}
else								/* otherwise send the records */
	{
	for(i = 0; i < numToSend; i++)
		{
		downloadRecDesc[i].recType = htons(downloadRecDesc[i].recType);
		writeTcp(iocinfo,(char *)&downloadRecDesc[i].recType,sizeof(downloadRecDesc[i].recType));	/* send type */
		writeTcp(iocinfo,(char *)downloadRecDesc[i].recPtr,downloadRecDesc[i].recSize);	/* send record */
		tisSysLog(V_DEBUG,0,"Downloading <%-28.28s> to IOC <%s>\n",downloadRecDesc[i].recPtr,iocinfo->ioc_name);
		}
	}
return(DBC_SUCCESS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			25-Mar-1993				      */
/*									      */
/*	Function Name:		DBC_OnlineDnldRequest			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*				iocinfo - pointer to DBC_IOCINFO structure    */
/*									      */
/*	Output Parameters:	none.					      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
DBC_ERROR_CODES	DBC_OnlineDnldRequest(iocinfo)
DBC_IOCINFO_PTR		iocinfo;
{
DBC_DWNLD_REQUEST	msg;
char				DBC_PointName[PVNAME_SZ],DBC_MsgPointName[PVNAME_SZ],DBC_LastPoint[PVNAME_SZ];
DBC_DWNLD_RESP		DBC_DwnldResp;
DBC_RESINFO_PTR		resinfo;
DB_RECORD_PTR		dnldRecord;
DB_FIELD_PTR		dnldField,dnldResField;
char				res[DBC_RESNAMESIZE],crc_string[5],dnldTrue;
int					type,i,stat,iocIndex;
short				numToSend;
unsigned short		crc,msgType;
VERIFY_INFO			verify_info;
/*
	Start with the record AFTER the one given in the message. If the record
	in the message is NULL then start with the first record in PVMAP.
*/
readTcp(iocinfo,(char *)&msg,DBC_REQSIZE);
dnldResField = DB_MapField(DBC_PvmapTable,FLD_RESOURCE);
dnldField = DB_MapField(DBC_PvmapTable,FLD_NAME);
strcpy(DBC_MsgPointName,msg.msgLastName);
strcpy(DBC_LastPoint,msg.msgLastName);
DB_UseKey(DBC_PvmapTable,FLD_NAME);			/* change to keyed access here */
if(strlen(DBC_MsgPointName))
	{
	dnldRecord = DB_Seek(DBC_PvmapTable,DBC_MsgPointName);
	dnldRecord = DB_SeekNext(DBC_PvmapTable);	/* next record */
	}
else
	{
	iocinfo -> ioc_state = IOC_DOWNLOADING;
	dnldRecord = DB_Top(DBC_PvmapTable);
	ackCleanList(iocinfo->ioc_ackPending);		/* clean my list for each NEW request */
	iocinfo->ioc_ackPending = 0;
	}
DBC_DwnldResp.msgNumberSent = 0;
while(dnldRecord && (DBC_DwnldResp.msgNumberSent < DBC_WINDOW_SIZE))
	{
	DB_GetFieldValue(dnldRecord,dnldResField,res,&type);
	if((resinfo = dbcResSearch(res)) != 0)
		{
/*
	See if the resource in the record is in the IOC requesting the record. If so
	then 'lock and load'. Just compare the pointers.
*/
		if((resinfo -> res_iocinfo[0] != iocinfo) &&
		   (resinfo -> res_iocinfo[1] != iocinfo))
			{
			dnldRecord = DB_SeekNext(DBC_PvmapTable);
			continue;
			}

		if(resinfo -> res_iocinfo[0] == iocinfo)
			iocIndex = 0;
		if(resinfo -> res_iocinfo[1] == iocinfo)
			iocIndex = 1;

		DB_GetFieldValue(dnldRecord,dnldField,DBC_PointName,&type);
		DB_GetVerifyInfo(DBC_PvmapTable,DBC_PointName,&verify_info,0);
		if((iocIndex == 0 ? !VI_IS_LOADED1(verify_info.viPVStatus) : !VI_IS_LOADED2(verify_info.viPVStatus)))	/* has NOT been downloaded */
			{
/*
	If the point I got is the same as the point I just processed
	then it is duplicate record. Terminate the download for this IOC
	by telling the IOC that there are no more points to send.
*/
			if(!strcmp(DBC_MsgPointName,DBC_PointName))
				{
				fprintf(stderr,"DBC - Duplicate point name detected: %s\n",DBC_PointName);
				fprintf(stderr,"    - Download terminated at: %s\n",DBC_LastPoint);
				msgType = htons(DBC_MSG_DWNLDRESP);
				writeTcp(iocinfo,(char *)&msgType,sizeof(msgType));		/* send message type */
				DBC_DwnldResp.msgNumberSent = 0;
				writeTcp(iocinfo,(char *)&DBC_DwnldResp,DBC_RESPSIZE);		/* send response header */
				return(DBC_SUCCESS);
				}
			stat = DBC_BuildRecord(DBC_PointName,&downloadRecDesc[DBC_DwnldResp.msgNumberSent],dnldRecord);
			if(stat == DBC_SUCCESS)
				{
				crc = DBC_CRCRecord(downloadRecDesc[DBC_DwnldResp.msgNumberSent].recPtr,downloadRecDesc[DBC_DwnldResp.msgNumberSent].recType);
				dbSetCRC(downloadRecDesc[DBC_DwnldResp.msgNumberSent].recPtr,crc);	/* GCT 20-Jun-1997 store CRC in download record */
				sprintf(crc_string,"%04.04X",crc);	/* update CRC in PVMAP */
				DB_PutFieldValue(dnldRecord,pvmapCRCField,crc_string);
				ackAddToList(iocinfo,iocIndex,DBC_PointName);		/* accumulate until ACK from IOC */
				dnldTrue = TRUE;			/* will be downloaded */
				DBC_DwnldResp.msgNumberSent++;		/* bump number sent */
				strcpy(&iocinfo -> ioc_lastpt[0],DBC_PointName);
				}
			else
				{
				iocinfo -> ioc_state = IOC_OK;
				tisSysLog(V_INFO,0,"DBC - Unable to download <%s> to <%s>...%s\n",
					DBC_PointName,iocinfo->ioc_name,DBC_ErrorMsg[stat]);
				}
			}
		}
	dnldRecord = DB_SeekNext(DBC_PvmapTable);		/* in alpha order */
	}
/*
	Send the download message NOW! If none to send,then send zero and change
	IOC state from IOC_DOWNLOADING to IOC_OK.
*/
msgType = htons(DBC_MSG_OLDRESP);
writeTcp(iocinfo,(char *)&msgType,sizeof(msgType));		/* send message type */
numToSend = DBC_DwnldResp.msgNumberSent;
/* Send header first */
DBC_DwnldResp.msgNumberSent = htons(DBC_DwnldResp.msgNumberSent);
writeTcp(iocinfo,(char *)&DBC_DwnldResp,DBC_RESPSIZE);		/* send response header */
for(i = 0; i < numToSend; i++)
	{
	downloadRecDesc[i].recType = htons(downloadRecDesc[i].recType);
	writeTcp(iocinfo,(char *)&downloadRecDesc[i].recType,sizeof(downloadRecDesc[i].recType));	/* send type */
	writeTcp(iocinfo,downloadRecDesc[i].recPtr,downloadRecDesc[i].recSize);	/* send record */
	tisSysLog(V_DEBUG,0,"Downloading <%-28.28s> to IOC <%s>\n",downloadRecDesc[i].recPtr,iocinfo->ioc_name);
	}
if(numToSend == 0)
	iocinfo -> ioc_state = IOC_OK;
return(DBC_SUCCESS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			16-Feb-1993				      */
/*									      */
/*	Function Name:		DBC_CRCResponse				      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:	  					      */
/*				iocinfo - pointer to DBC_IOCINFO structure    */
/*									      */
/*	Output Parameters:	none.					      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:						      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
DBC_ERROR_CODES	DBC_CRCResponse(DBC_IOCINFO_PTR iocinfo)
{
  int		pointID;
  unsigned short	pointCRC;
  TREENODE_PTR		node;
  short			crcCount,msgType;
  /*DBC_SYMREQ		symRequest;*/			/* symbol table request message */
  /*char		dnldTrue,iocNoSync; */
  int			/*dtype,*/iocIndex;
  int			tstamp;				/* 8-Jan-97 time stamp is no in message for each point */
  /*DB_RECORD_PTR	syncRecord;*/
  VERIFY_INFO		verify_info;			/* contains information on download status */
  DBC_CRCINFO		crcInfo;			/* 30-Apr-1999 GCT new CRC information structure see redmsgs.h */
  
  readTcp(iocinfo,(char *)&crcCount,sizeof(crcCount));
  crcCount = ntohs(crcCount);
  if(iocinfo->ioc_treeroot == 0)
    {
      /* No symbol table...dump rest of message and request one */
      iocinfo->ioc_rxCount -= (crcCount * sizeof(DBC_CRCINFO));
      iocinfo->ioc_rxNextChar += (crcCount * sizeof(DBC_CRCINFO));
      DBC_ProcessSymPurge(iocinfo);
    }
  else
    {
      while(crcCount)
	{
	  readTcp(iocinfo,(char *)&crcInfo,sizeof(DBC_CRCINFO));
/* get point ID */
	  pointID = ntohl(crcInfo.crcKey);
/* get time stamp */
	  tstamp = ntohl(crcInfo.crcTimeStamp);
/* get point CRC */
	  pointCRC = ntohs(crcInfo.crcCRC);
/* Search for point */
	  if((node = symSearch(iocinfo->ioc_treeroot,pointID)) != 0)
	    {
	      iocIndex = getIOCIndex(node->treePVName,iocinfo);
	      DB_GetVerifyInfo(DBC_PvmapTable,node->treePVName,&verify_info,0);
	      if(tstamp == verify_info.viTimeStamp)
		{
		  if(node->treeCRC != pointCRC)
		    {
		      tisSysLog(V_STATUS,0,"CRC for <%-*.*s> @%08X from table is <%04X>...from message is <%04X>.\n",
				       PVNAME_SZ,PVNAME_SZ,node->treePVName,pointID,node->treeCRC,pointCRC);
/*
  Mis-matched CRCs...Request the record !
  08-Apr-1993 GCT	Do this ONLY if the point has been downloaded!
  29-Jun-1993 GCT Check these only if IOC in IOCLIST has NO_SYNC false.
  19-Jul-1994 GCT NO_SYNC no longer needed, Interhost verification will cover sync/download sequencing.
*/
		      if(((iocIndex == 0) && VI_IS_LOADED1(verify_info.viPVStatus)) ||
			 ((iocIndex == 1) && VI_IS_LOADED2(verify_info.viPVStatus)))
			{
			  tisSysLog(V_STATUS,0,"Requesting record <%*.*s>\n",PVNAME_SZ,PVNAME_SZ,&node->treePVName[0]);
			  msgType = htons(DBC_MSG_RECREQUEST);
			  writeTcp(iocinfo,(char *)&msgType,sizeof(msgType));
			  writeTcp(iocinfo,&node->treePVName[0],PVNAME_SZ);
			}
		    }
		  else
		    /*
		      GCT 5-Jul-1996 If CRCs are equal then set download flag for this IOC
		      */
		    {
		      verify_info.viPVStatus |= (iocIndex == 0 ? VI_LOADED_1 : VI_LOADED_2);
		      DB_PutVerifyInfo(DBC_PvmapTable,node->treePVName,&verify_info,0);
		    }
		}
	    }
	  crcCount--;
	}
    }
  return(DBC_SUCCESS);
}
/*
  This is a new functions (10-Jan-97) it is designed to handle a field mod from 
  an IOC that I am NOT connected to. This will happen if the command line did NOT
  contain a '-r' argument. That means that I am not really interested in messages
  from any IOC. The reason I got this message is because a host that IS interested
  IOC communications has forwarded it to me. The content of this message is as 
  follows:

  originating IOC name.
  size of forwarded data
  forwarded data

  There is just enough information to create a "dummy" iocinfo structure and pass
  it to the DBC_ProcessDbMod function.
*/
DBC_ERROR_CODES dbcForwardDbMod(DBC_IOCINFO_PTR iocinfo)
{
short mSize;
DBC_IOCINFO_PTR localIOC;
DBC_FWDHDR fwdhdr;
char iocName[DBC_IOCNAMESIZE+1];
char localBuff[DBC_NETMSG_SIZE];

readTcp(iocinfo,(char *)&fwdhdr,DBC_FWDHDRSIZE);			/* get the originating IOC name */
strcpy(&iocName[0],&fwdhdr.fwdName[0]);				/* put name into local IOC container */
mSize = ntohs(fwdhdr.fwdSize);					/* get message size header */
readTcp(iocinfo,&localBuff[0],mSize);				/* get the forwarded message */
/*
   GCT 22-Mar-1997 from Vegas
   If this host can talk to RTUs/IOCs then do NOT overwrite the resident iocinfo
   structure with the data from the originating remote. This was handled better
   on the partner but I don't know who that is (dbClient -r ). The message buffer
   has already been emptied of this message by the above "readTcp" calls.
*/
if(acceptIOC == NO_ACCEPT_IOCS)
  {
    if((localIOC = (DBC_IOCINFO_PTR)dbcIocSearch(iocName)) != 0)
      {
        memcpy(&localIOC->ioc_rxBuffer[0],&localBuff[0],mSize);	/* copy to local buffer */
        localIOC->ioc_rxCount = mSize;				/* set-up buffer pointers */
        localIOC->ioc_rxNextChar = 0;
        return(DBC_ProcessDbMod(localIOC));				/* pass to default message processor */
      }
  }
return(DBC_SUCCESS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			06-Mar-1993				      */
/*									      */
/*	Function Name:		DBC_ProcessDbMod			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	06-Mar-1993				      */
/*				26-May-1993 Modify to handle links	      */
/*
	Links are of three types HARDWARE, REFERENCE and CONSTANT. If the
	new link value in the incomming message is a simple modification of
	a link structure of the same type, then the operation is easy. When
	going from a CONSTANT to a REFERENCE,...			      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
DBC_ERROR_CODES	DBC_ProcessDbMod(iocinfo)
DBC_IOCINFO_PTR		iocinfo;
{
DBC_DBMODHDR	hdr;
DBC_DBFIELD	field;
DB_RECORD_PTR	dbmodRecord,syncRecord;
#ifndef	USE_PREALLOC
DBC_RECDESC	modDesc;
#endif
DB_FIELD_PTR	pntScanRate,modField;
static DBC_XREFTABLE	*xrefNode;
int    	type;
double 	tempDouble;
float  	tempFloat;
short  	type_index,choice_index,msgType,i,iocTypeIndex;
char   	key[DBC_KEY_SIZE],crc_string[5],value[100];
char   	*vPtr,*nVptr,newValue[100],dnldTrue,iocNoSync,pvmapTypeString[16];
unsigned short	crc,pointCRC;
unsigned short	oldcrc;
short  	nFields;
struct choiceSet	*pchoiceSet;
struct arrChoiceSet	*parrChoiceSet;
struct devChoiceSet	*pdevChoiceSet;
char   	*pchoice,boardType[50],DBC_Name[PVNAME_SZ];
int    	pointID,iocIndex;
TREENODE_PTR		node;
VERIFY_INFO			verify_info;
struct	recTypDes	*typeDes;
int    	fieldCount;
short msgSize;
int oneField;
time_t tstamp;
char tempString[20];
char ts1[27],ts2[27];
char nameKey[40];			/* GCT 20-Nov-1997 used to space pad name to avoid partial search problems */

readTcp(iocinfo,(char *)&hdr,DBC_MODHDRSIZE);
msgSize = ntohs(hdr.dbmodSize);		/* size of remaining message */
if(strlen(&hdr.dbmodName[0]) == 0)
	{
	tisSysLog(V_INFO,0,"Received NULL point name from %s...update rejected",iocinfo->ioc_name);
	iocinfo->ioc_rxCount -= msgSize;
	iocinfo->ioc_rxNextChar +=msgSize;
	return(tcpError(iocinfo));
	}
sprintf(nameKey,"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,&hdr.dbmodName[0]);
if((dbmodRecord = DB_Seek(DBC_PvmapTable,nameKey)) == 0)
  {
    tisSysLog(V_INFO,0,"Can't find record <%s>...update rejected.\n",&hdr.dbmodName[0]);
    iocinfo->ioc_rxCount -= msgSize;
    iocinfo->ioc_rxNextChar += msgSize;
    return(tcpError(iocinfo));
  }
strcpy(DBC_Name,&hdr.dbmodName[0]);
if((iocIndex = getIOCIndex(DBC_Name,iocinfo)) < 0)		/* GCT 10-Jul-96 IOC not associated with resource...ignore */
  {
    tisSysLog(V_INFO,0,"IOC %s for point %s is not associated with a resource...update rejected",iocinfo->ioc_name,DBC_Name);
    iocinfo->ioc_rxCount -= msgSize;
    iocinfo->ioc_rxNextChar +=msgSize;
    return(tcpError(iocinfo));
  }
nFields = ntohs(hdr.dbmodNFields);
pointID = ntohl(hdr.dbmodPointId);						/* get point id so we can update tables */
pointCRC = ntohs(hdr.dbmodCRC);
iocTypeIndex = ntohs(hdr.dbmodType);						/* 10-May-1994 GCT extract point type from mod header */
tstamp = ntohl(hdr.dbmodTimeStamp);						/* 8-Jan-97 time stamp now in message */
pntScanRate = DB_MapField(DBC_PvmapTable,FLD_SCANRATE);				/* setup for scan rate */
type_index = iocTypeIndex;
typeDes = GET_PRECTYPDES(type_index);					/* get type descriptor */
DB_GetFieldValue(dbmodRecord,pvmapTypeField,pvmapTypeString,&type);		/* get the point type */
type_index = getTypeIndex(pvmapTypeString);
if(type_index != iocTypeIndex)
  {
    tisSysLog(V_INFO,0,"IOC has different point type for %s...update rejected\n",DBC_Name);
    iocinfo->ioc_rxCount -= msgSize;
    iocinfo->ioc_rxNextChar += msgSize;
    return(tcpError(iocinfo));
  }
/*
  GCT 8-Jan-97

  Check time  in record against one from message. If they are equal then proceed
  else drop the request.
*/
DB_GetVerifyInfo(DBC_PvmapTable,&hdr.dbmodName[0],&verify_info,0);
if(verify_info.viTimeStamp != tstamp)
  {
    strcpy(ts1,(char *)ctime(&tstamp));
    ts1[strlen(ts1)-1] = 0;		/* drop line-feeds */
    strcpy(ts2,(char *)ctime((time_t *)&verify_info.viTimeStamp));
    ts2[strlen(ts2)-1] = 0;
    tisSysLog(V_INFO,0,
		    "IOC has different time stamp for %s...Host <%s> IOC <%s>...update rejected\n",
		    DBC_Name,ts2,ts1);
    iocinfo->ioc_rxCount -= msgSize;
    iocinfo->ioc_rxNextChar += msgSize;
    return(DBC_FIELDMODERR);
  }

oneField = (nFields == 1) ? 1 : 0;
tisSysLog(V_STATUS,0,
		  "Updating <%d> fields in <%s> with a CRC of <%04X> from %s\n",
		  nFields,&hdr.dbmodName[0],pointCRC,iocinfo->ioc_name);
fieldCount = typeDes->no_prompt - typeDes->no_links;
while(nFields--)
	{
	xrefNode = (DBC_XREFTABLE_PTR)lstFirst((LIST *)&(((DBC_XREFHDR_PTR)&DBC_XREFTables[type_index])->xrefHdrList));	/* get list for this point type */
	readTcp(iocinfo,(char *)&field,DBC_FIELDSIZE);	/* read field name */
	msgSize -= DBC_FIELDSIZE;
	while(xrefNode)
		{
		if(!strncmp(field.fieldName,xrefNode->xrefFieldDesc->fldname,FLDNAME_SZ))
			{
			break;
			}
		xrefNode = (DBC_XREFTABLE_PTR)(xrefNode->node.next);
		}
	if(xrefNode == 0)
		{
		tisSysLog(V_INFO,0,"Field name <%s> not in type %s...update rejected",field.fieldName,GET_PRECTYPDES(type_index));
		iocinfo->ioc_rxCount -= msgSize;
		iocinfo->ioc_rxNextChar += msgSize;
		return(DBC_FIELDMODERR);
		}
	if(oneField == 1)
	  {
	    tisSysLog(V_DEBUG,0,"Modifying field \"%4.4s\"\n",field.fieldName);
	  }
       	readTcp(iocinfo,value,xrefNode->xrefFieldDesc->size);	/* get value */
       	msgSize -= xrefNode->xrefFieldDesc->size;
	if((dbmodRecord = DB_Seek(xrefNode->xrefTable,nameKey)) != (DB_RECORD_PTR)1) 	/* get record in appropriate file */	
	{
	  tisSysLog(V_INFO,0,"Can't find record <%s> in <%s>...update rejected.\n",&hdr.dbmodName[0],xrefNode->xrefTable->table_name);
	  iocinfo->ioc_rxCount -= msgSize;
	  iocinfo->ioc_rxNextChar += msgSize;
	  return(DBC_FIELDMODERR);
	}
	nVptr = newValue;
	vPtr = value;
/*
	Use field type to switch endians(if needed) and to resolve
	choice list items.
*/
    modField = xrefNode->xrefField;			/* use from XREF unless told otherwise */
    switch(xrefNode->xrefFieldDesc -> field_type)
      {
      case DBF_CHAR:
      case DBF_UCHAR:
	*nVptr = *vPtr;
	break;
      case DBF_STRING:
	for(i = 0;i < 10;i++)
	  {
	    if(!strncmp(xrefNode->xrefFieldDesc->fldname,tankvlvpv[i],FLDNAME_SZ))
	      {
		sprintf(key,"%-*.*s%s",PVNAME_SZ,PVNAME_SZ,DBC_Name,xrefNode->xrefOpId);
		dbmodRecord = DB_Seek(xrefNode->xrefTable,key);
		modField = xrefNode->xrefField;
		nVptr = vPtr;
		break;
	      }
	  }
	if(!strncmp(xrefNode->xrefFieldDesc->fldname,"STPC",FLDNAME_SZ) ||
	   !strncmp(xrefNode->xrefFieldDesc->fldname,"RECC",FLDNAME_SZ) ||
	   !strncmp(xrefNode->xrefFieldDesc->fldname,"ISSC",FLDNAME_SZ) ||
	   !strncmp(xrefNode->xrefFieldDesc->fldname,"RUNC",FLDNAME_SZ))
	  {
	    sprintf(key,"%-*.*s%s",PVNAME_SZ,PVNAME_SZ,DBC_Name,xrefNode->xrefOpId);
	    dbmodRecord = DB_Seek(xrefNode->xrefTable,key);
	    modField = xrefNode->xrefField;
	    nVptr = vPtr;
	    break;
	  }
	sprintf(nVptr,"%-*.*s",xrefNode->xrefFieldDesc->size,xrefNode->xrefFieldDesc->size,vPtr);
	break;
      case DBF_SHORT:
      case DBF_USHORT:
      case DBF_ENUM:
	tempDouble = ntohs(*((short *)vPtr));
	nVptr = (char *)&tempDouble;
	break;
      case DBF_LONG:
      case DBF_ULONG:
	if(!strncmp(xrefNode->xrefFieldDesc->fldname,"TSTP",FLDNAME_SZ))	/* convert for time stamp only */
	  {
	    sprintf(tempString,"%d\0",ntohl(*((long *)vPtr)));
	    nVptr = &tempString[0];
	  }
	else
	  {
	    tempDouble = ntohl(*((long *)vPtr));
	    nVptr = (char *)&tempDouble;
	  }
	break;
      case DBF_FLOAT:
      case DBF_DOUBLE:
	for(i = 0;i < 10;i++)
	  {
	    if(!strncmp(xrefNode->xrefFieldDesc->fldname,tankproblvl[i],FLDNAME_SZ))
	      {
		sprintf(key,"%-*.*s%s",PVNAME_SZ,PVNAME_SZ,DBC_Name,xrefNode->xrefOpId);
		dbmodRecord = DB_Seek(xrefNode->xrefTable,key);
		modField = xrefNode->xrefField;
		break;
	      }
	  }
	if(xrefNode->xrefFieldDesc -> field_type == DBF_FLOAT)
	  {
	    *((unsigned int *)&tempFloat) = ntohl(*((unsigned int *)vPtr));
	    tempDouble = tempFloat;
	  }
	else
	  {
	    htond (*(double *)vPtr, *(double *)vPtr);
	  }
/*
	Round this here so that we don't get clobbered by dBase later.
*/
/* 	tempDouble = (double)dbRound(tempDouble,xrefNode->xrefFieldDesc->promptflag); */
	nVptr = (char *)&tempDouble;
	break;
      case DBF_GBLCHOICE:
	for(i = 0;i < 4;i++)
	  {
	    if(!strncmp(xrefNode->xrefFieldDesc->fldname,indicators[i],FLDNAME_SZ))
	      {
		sprintf(key,"%-*.*s%s",PVNAME_SZ,PVNAME_SZ,DBC_Name,xrefNode->xrefOpId);
		dbmodRecord = DB_Seek(xrefNode->xrefTable,key);
		modField = xrefNode->xrefField;
		break;
	      }
	  }
	for(i = 0;trips[i];i++)
	  {
	    if(!strncmp(xrefNode->xrefFieldDesc->fldname,trips[i],FLDNAME_SZ))
	      {
		sprintf(key,"%-*.*s%s",PVNAME_SZ,PVNAME_SZ,DBC_Name,xrefNode->xrefOpId);
		dbmodRecord = DB_Seek(xrefNode->xrefTable,key);
		modField = xrefNode->xrefField;
		break;
	      }
	  }
	if(xrefNode->xrefField -> field_type == 'L')
	  {
	    *nVptr = ntohs(*((short *)vPtr)) ? xrefNode->xrefTrue : xrefNode->xrefTrue ^ 1;
	  }
	else
	  {
	    choice_index = ntohs(*((short *)vPtr));
	    pchoiceSet = GET_PCHOICE_SET(choiceGbl,xrefNode->xrefFieldDesc->choice_set);
	    if((pchoice = GET_CHOICE(pchoiceSet,choice_index)))
	      {
		if(!strcmp(pchoice,"100 ms") ||
		   !strcmp(pchoice,"200 ms") ||
		   !strcmp(pchoice,"500 ms") ||
		   !strcmp(pchoice,"1 second") ||
		   !strcmp(pchoice,"2 second") ||
		   !strcmp(pchoice,"5 second") ||
		   !strcmp(pchoice,"10 second") ||
		   !strcmp(pchoice,"15 second") ||
		   !strcmp(pchoice,"30 second") ||
		   !strcmp(pchoice,"60 second"))
		  {
		    strcpy(nVptr,"Periodic");
		    sscanf(pchoice,"%lf",&tempDouble);
		    if(!strcmp(pchoice,"100 ms") ||
		       !strcmp(pchoice,"200 ms") ||
		       !strcmp(pchoice,"500 ms"))
		      tempDouble /= 1000.0;
		    DB_PutFieldValue(dbmodRecord,pntScanRate,&tempDouble);
		  }
		else
		  {
		    nVptr = pchoice;
		  }
	      }
	    else
	      *nVptr = '\0';
	  }
	break;
      case DBF_CVTCHOICE:
	if(xrefNode->xrefField -> field_type == 'L')
	  {
	    *nVptr = ntohs(*((short *)vPtr)) ? xrefNode->xrefTrue : xrefNode->xrefTrue ^ 1;
	  }
	else
	  {
	    choice_index = ntohs(*((short *)vPtr));
	    if((pchoice = GET_CHOICE(choiceCvt,choice_index)))
	      nVptr = pchoice;
	    else
	      *nVptr = '\0';
	  }
	break;
      case DBF_DEVCHOICE:
	choice_index = ntohs(*((short *)vPtr));
	if(xrefNode->xrefField -> field_type == 'L')
	  {
	    *nVptr = ntohs(*((short *)vPtr)) ? xrefNode->xrefTrue : xrefNode->xrefTrue ^ 1;
	  }
	else
	  {
	    if((type_index == VU_PAT) && (!strncmp(xrefNode->xrefFieldDesc->fldname,"DTYR",4) || 
					  !strncmp(xrefNode->xrefFieldDesc->fldname,"DTYF",4)))
	      continue;
	    if(pdevChoiceSet = GET_PDEV_CHOICE_SET(choiceDev,type_index))
	      {
		if((pchoice = GET_DEV_CHOICE(pdevChoiceSet,choice_index)->pchoice))
		  nVptr = pchoice;
		else
		  *nVptr = '\0';
	      }
	    else
	      *nVptr = '\0';
	  }
	strcpy(boardType,nVptr);	/* for link fields later */
	break;
      case DBF_RECCHOICE:
	if(xrefNode->xrefField -> field_type == 'L')
	  {
	    *nVptr = ntohs(*((short *)vPtr)) ? xrefNode->xrefTrue : xrefNode->xrefTrue ^ 1;
	  }
	else
	  {
	    if(parrChoiceSet = GET_PARR_CHOICE_SET(choiceRec,type_index))
	      {
		pchoiceSet = GET_PCHOICE_SET(parrChoiceSet,xrefNode->xrefFieldDesc->choice_set);
		choice_index = ntohs(*((short *)vPtr));
		if((pchoice = GET_CHOICE(pchoiceSet,choice_index)))
		  nVptr = pchoice;
		else
		  *nVptr = '\0';
	      }
	    else
	      *nVptr = '\0';
	  }
	break;
      }
    DB_PutFieldValue(dbmodRecord,modField,nVptr);		/* modify the file */
  }
DBC_BuildRecord(&hdr.dbmodName[0],&downloadRecDesc[0],dbmodRecord);
crc = DBC_CRCRecord(downloadRecDesc[0].recPtr,downloadRecDesc[0].recType);

if (pointCRC == crc)
    oldcrc = crc;
else
    oldcrc = oldDBC_CRCRecord(downloadRecDesc[0].recPtr,downloadRecDesc[0].recType);
tisSysLog(V_STATUS,0,"Re-calculated CRC is %04X\n",crc);
if( (pointCRC != crc) && (pointCRC != oldcrc) )		/* mis-match then get the record again */
  {							/* only if record hasn't been downloaded */
    if(fieldCount != hdr.dbmodNFields)
      {
		dnldTrue = FALSE;
		iocNoSync  = TRUE;	/* default if file absent */
		if((syncRecord = DB_Seek(DBC_IOCListTable,iocinfo->ioc_name)))
		  DB_GetFieldValue(syncRecord,DBC_IOCSyncField,&iocNoSync,&type);
		DB_GetFieldValue(dbmodRecord,pvmapIOCField[iocIndex],&dnldTrue,&type);
		if((iocNoSync == FALSE) || (dnldTrue == TRUE))
		  {
			msgType = htons(DBC_MSG_RECREQUEST);
			writeTcp(iocinfo,(char *)&msgType,sizeof(msgType));
			writeTcp(iocinfo,&hdr.dbmodName[0],PVNAME_SZ);
			tisSysLog(V_STATUS,0,"Requesting record <%*.*s>\n",PVNAME_SZ,PVNAME_SZ,&hdr.dbmodName[0]);
		  }
      }
    else
      {
		tisSysLog(V_STATUS,0,"Can't update point <%s> after CRC mismatch",&hdr.dbmodName[0]);
		return(DBC_FIELDMODERR);
      }
  }
else
  {
    sprintf(crc_string,"%04.04X",crc);			/* update CRC in PVMAP */
    DB_PutFieldValue(dbmodRecord,pvmapCRCField,crc_string);
/*
	Set download flag for this IOC.
*/
    DB_GetVerifyInfo(DBC_PvmapTable,&hdr.dbmodName[0],&verify_info,0);
    verify_info.viPVStatus |= (iocIndex == 0 ? VI_LOADED_1 : VI_LOADED_2);
    DB_PutVerifyInfo(DBC_PvmapTable,&hdr.dbmodName[0],&verify_info,0);
    tisSysLog(V_STATUS,0,"CRC <%04X> updated for <%s>\n",crc,&hdr.dbmodName[0]);
/*
	Search for point so we can update CRC. If point is not in
	symbol table or there is no table then just ignore. This will
	be fixed later through a download or checksum request.
*/
    if((node = symSearch(iocinfo->ioc_treeroot,pointID)) != 0)
      {
	node -> treeCRC = crc;					/* update CRC in tree */
      }
  }
return(DBC_SUCCESS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			08-Apr-1993				      */
/*									      */
/*	Function Name:		DBC_OnlineDelRequest			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:	08-Apr-1993	GCT	First time	      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
DBC_ERROR_CODES	DBC_OnlineDelResponse(iocinfo)
DBC_IOCINFO_PTR	iocinfo;
{
TREENODE_PTR	node;
DB_RECORD_PTR	delRecord;
int		tindex;
char		i,delName[PVNAME_SZ],key[DBC_KEY_SIZE];
DBC_XREFHDR_PTR	xhdr;
DBC_DELRESP	delHdr;
int		pointID;
VERIFY_INFO	local_info;			/* 15-Jul-1994 for new verification functions */
char **arr,*space;
int num;

readTcp(iocinfo,(char *)&delHdr,sizeof(DBC_DELRESP));
pointID = ntohl(delHdr.deletedSym);
if((node = symSearch(iocinfo->ioc_treeroot,pointID)) != 0)
	{
	sprintf(delName,"%-*.*s",PVNAME_SZ,PVNAME_SZ,node->treePVName);
	node -> treeCRC = 0;
	memset(&node->treePVName[0],0,PVNAME_SZ);
	}
else
	sprintf(delName,"%-*.*s",PVNAME_SZ,PVNAME_SZ,delHdr.deletedName);
if((delRecord = DB_Seek(DBC_PvmapTable,delName)))
	{
	DB_GetVerifyInfo(DBC_PvmapTable,delName,&local_info,0);
	local_info.viPVStatus |= VI_DELETED;
	local_info.viTimeStamp = synchTime();
	DB_PutVerifyInfo(DBC_PvmapTable,delName,&local_info,0);
	DBC_SendToAllHosts(&local_info,VI_MSG_IHAVENEWREC);
	tindex = local_info.viTypeIndex;	/* get type index from name */
/*
	Traverse array of related Table handles for this point type. At
	each entry, seek to record with point name and delete it.
*/
	xhdr = DBC_XREFTables+tindex;
	for(i=0;i<DBC_MAX_TABLES;i++)
		{
		if(xhdr->xrefHdrTables[i] == 0) continue;
		if(xhdr->xrefHdrTables[i] == DBC_PvmapTable) continue;
		if((tindex == VU_PTO) && (xhdr->xrefHdrTables[i] == DBC_IOAddrTable))
			{
			sprintf(key,"%s1\0",delName);
			DB_DeleteMulti(xhdr->xrefHdrTables[i],key);
			sprintf(key,"%s2\0",delName);
			DB_DeleteMulti(xhdr->xrefHdrTables[i],key);
			}
		else
			{
			DB_UseKey(xhdr->xrefHdrTables[i],FLD_NAME);
			DB_DeleteMulti(xhdr->xrefHdrTables[i],delName);
			DB_UseKey(xhdr->xrefHdrTables[i],FLD_CALCOP_KEY);
			}
		}
	tisSysLog(V_STATUS,0,"<%s> has been deleted.\n",delName);
/*
	When a point is deleted we must delete ALL occurances
	of it in the trend file.

	GCT 27-Aug-1997 Use new function to return names of all occurances
	of the deleted point and seek for each one and delete it. Also just
	open the file here and close it when we're done.
*/
	if((DBC_ArReducTable = DB_MapTable(DBC_ARREDUC)) == 0)
	  {
	    tisSysLog(V_INFO,0,"Can't open %s\n",DBC_ARREDUC);
	    return(DBC_SUCCESS);
	  }
	if(space = strchr(delName,' ')) *space = 0;	/* stomp on first space if any */
	if((arr = (char **)dbFindInArreduc(DBC_ArReducTable,delName,tindex,&num)) != 0)
	  {
	    int i = 0;
	    while(arr[i])
	      {
		/* seek to record in arr[i] after isolating the point name and delete it */
		strtok(arr[i],",");
		if((delRecord = DB_Seek(DBC_ArReducTable,arr[i])) != 0)
		  DB_DeleteRecord(DBC_ArReducTable,delRecord);
		free(arr[i++]);
	      }
	    free(*arr);
	  }
	DB_UnMapTable(DBC_ArReducTable,0);
	}
return(DBC_SUCCESS);
}

/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			27-May-1993				      */
/*									      */
/*	Function Name:		dbClient Support functions		      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:						      */
/*									      */
/*	Output Parameters:						      */
/*									      */
/*	Return Values or error codes:					      */
/*									      */
/*	Modification History:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/

int	getTypeIndex(typestr)				/* zero is failure */
char	*typestr;
{
int	type_index;
char	*bptr,*typestring;
type_index = 1;
while(typestring = GET_PRECTYPE(type_index))		/* for all possible types */
	{
	bptr = typestr;
	while(*bptr) *bptr++ = tolower(*bptr);
	if(!strcmp(typestring,typestr))			/* get the type index */
		return(type_index);
	type_index++;
	}
return(0);
}

void	splitLinkName(lptr,name)
struct link	*lptr;
char		*name;
{
char	*tk1,*tk2;
tk1 = strtok(name,".");
tk2 = strtok(NULL,".");
lptr->value.pv_link.fldname[0] = '\0';
if(tk2)
	strncpy(lptr->value.pv_link.fldname,tk2,FLDNAME_SZ);
strncpy(lptr->value.pv_link.pvname,tk1,PVNAME_SZ);
}

void	joinLinkName(lptr,name)
struct pv_link	*lptr;
char		*name;
{
sprintf(name,"%s.%s\0",lptr->pvname,lptr->fldname);
}
#ifdef	DBC_MODLINKS
void	updateHardwareLink(name,line,addr,card,sig)
char	*name;
short	line,addr,card,sig;
{
DB_RECORD_PTR	rec;
double	val;

if(rec = DB_Seek(DBC_IOAddrTable,name))
	{
	val = line;
	DB_PutFieldValue(rec,ioaddrLine,&val);
	val = addr;
	DB_PutFieldValue(rec,ioaddrAddress,&val);
	val = card;
	DB_PutFieldValue(rec,ioaddrCard,&val);
	val = sig;
	DB_PutFieldValue(rec,ioaddrSignal,&val);
	}
}
void	updateCalcOps(name,type,lptr,table,id)
char		*name;
int		type;
struct pv_link	*lptr;
DB_TABLE_PTR	table;
char		id;
{
char	key[DBC_KEY_SIZE];
DB_RECORD_PTR	rec;
DB_FIELD_PTR	xrefConstant,xrefReference,pntProcInput,pntMaxSeverity;
char		ref[30],proc,max;
double		Constant;
xrefConstant	= DB_MapField(table,FLD_CONSTANT);			/* for link fields */
xrefReference	= DB_MapField(table,FLD_REFERENCE);			/* for link fields */
pntProcInput	= DB_MapField(table,FLD_PROCINPUT);
pntMaxSeverity	= DB_MapField(table,FLD_MAXSEVERITY);
sprintf(key,"%-*.*s%c\0",PVNAME_SZ,PVNAME_SZ,name,id);			/* Construct search key for this file */
if(rec = DB_Seek(table,key))						/* get next one with this point name */
	{
	if(type == CONSTANT)
		{
		Constant = ntohl(*((float *)lptr));
		DB_PutFieldValue(rec,xrefConstant,&Constant);		/* ref is a Constant */
		}
	else								/* must be reference */
		{
		joinLinkName(lptr,ref);
		proc = ntohs(lptr -> process_passive);
		max = ntohs(lptr -> maximize_sevr);
		DB_PutFieldValue(rec,pntProcInput,&proc);		/* process passive */
		DB_PutFieldValue(rec,pntMaxSeverity,&max);		/* maximize severity */
		}
	}
}

void	checkAndDeleteIOAddr(name)
char	*name;
{
DB_RECORD_PTR	rec;
/*
	If record exists in IOADDR.DBF and the new type is CONSTANT or REFERENCE
	then delete the record in IOADDR.DBF.
*/
if(rec = DB_Seek(DBC_IOAddrTable,name))
	DB_DeleteRecord(DBC_IOAddrTable,rec);
return;
}
#endif
#ifdef	DO_TIME_STATS
void	SubTimes(t1,t2)		/* subtract t2 from t1 result in t1... t1 = t1 - t2 */
struct timeval	*t1,*t2;
{
t1->tv_sec -= t2->tv_sec;
t1->tv_usec -= t2->tv_usec;
if (t1->tv_usec < 0)
	{
	t1->tv_usec += 1000000;
	t1->tv_sec--;
	}
}
void	AddTimes(t1,t2)		/* add t2 to t1 result in t1... t1 = t1 + t2 */
struct timeval	*t1,*t2;
{
t1->tv_usec += t2->tv_usec;
t1->tv_sec += t2->tv_sec;
if(t1->tv_usec > 1000000)
	{
	t1->tv_usec -= 1000000;
	t1->tv_sec++;
	}
}
void	DivTimes(t1,div)	/* divide t1 by div result in t1... t1 = t1 / div */
struct timeval	*t1;
int		div;
{
double	tim,usecs,sec,d;
if(div)
	{
	usecs = t1->tv_usec;
	sec = t1->tv_sec;
	d = div;
	tim = (sec + (usecs / 1e06));				/* convert to micro-seconds */
	tim /= d;									/* perform division */
	t1->tv_sec = (long)tim;							/* integer to seconds */
	t1->tv_usec = (long)((tim - t1->tv_sec) * 1e06);	/* remainder is micro-seconds */
	}
}
double	DecimalTimes(t1)					/* convert 'timeval' to decimal time */
struct timeval	*t1;
{
double	usecs,sec;
usecs = t1->tv_usec;
sec = t1->tv_sec;
return(sec + (usecs / 1e06));				/* convert to seconds */
}
#endif
int	getIOCIndex(name,iocinfo)
char		*name;				/* PV name */
DBC_IOCINFO_PTR	iocinfo;			/* IOC info data */
{
int	type;
char	resname[PVNAME_SZ];
DB_FIELD_PTR	resfield;
DBC_RESINFO_PTR	res;
DB_RECORD_PTR	rec;

resfield = DB_MapField(DBC_PvmapTable,FLD_RESOURCE);
rec = DB_Seek(DBC_PvmapTable,name);
DB_GetFieldValue(rec,resfield,resname,&type);
if((res = dbcResSearch(resname)) != 0)
  {
    if(res -> res_iocinfo[0] == iocinfo)
      return(0);
    if(res -> res_iocinfo[1] == iocinfo)
      return(1);
  }
return(-1);
}
void	ackAddToList(info,idx,name)
DBC_IOCINFO_PTR	info;
int				idx;
char			*name;					/* may be space padded */
{
ACK_PENDING_PTR	list,temp;
if((list = info->ioc_ackPending) == 0)			/* see if this is the first */
	{
	if((info->ioc_ackPending = (ACK_PENDING_PTR)calloc(1,ACK_PEND_SIZE)) == 0)
		{
		tisSysLog(V_INFO,0,"Can't calloc for ACK pending list 1\n");
		return;
		}
	list = info->ioc_ackPending;
	list -> ackNext = 0;
	list -> ackPointsInList = 0;
	}
else
	{
	while(list)
		{
		if(list->ackPointsInList < ACK_MAX_POINTS)
			break;
		temp = list;
		list = list -> ackNext;
		}
	if(list == 0)
		{
		if((list = (ACK_PENDING_PTR)calloc(1,ACK_PEND_SIZE)) == 0)
			{
			tisSysLog(V_INFO,0,"Can't calloc for ACK pending list 2\n");
			return;
			}
		list -> ackNext = 0;
		list -> ackPointsInList = 0;
		temp -> ackNext = list;
		}
	}
sprintf(&list->ackPoint[list->ackPointsInList].ackPVEntry[0],"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,name);
list->ackPoint[list->ackPointsInList].ackIOCIndex = idx;
list->ackPointsInList++;
}
DBC_ERROR_CODES	DBC_OkToUnmark(iocinfo)
DBC_IOCINFO_PTR	iocinfo;
{
int	status;

readTcp(iocinfo,(char *)&status,sizeof(int));		/* get status...ignore for now */
ackUnmark(iocinfo);
return(DBC_SUCCESS);
}
/*
	We got an ACK message from the IOC. Now we can mark all the points as
	downloaded.
*/
void	ackUnmark(info)
DBC_IOCINFO_PTR	info;
{
ACK_PENDING_PTR		list;
VERIFY_INFO			verify_info;
int					i;

list = info->ioc_ackPending;
while(list)
	{
	for(i = 0;i < list->ackPointsInList;i++)
		{
		DB_GetVerifyInfo(DBC_PvmapTable,list->ackPoint[i].ackPVEntry,&verify_info,0);
		verify_info.viPVStatus |= (list->ackPoint[i].ackIOCIndex == 0 ? VI_LOADED_1 : VI_LOADED_2);
		DB_PutVerifyInfo(DBC_PvmapTable,list->ackPoint[i].ackPVEntry,&verify_info,0);
		}
	list = list -> ackNext;
	}
ackCleanList(info->ioc_ackPending);		/* clean up after ourselves */
info->ioc_ackPending = 0;
}
/*
	Recursively traverse list and free memory.
*/
void	ackCleanList(list)
ACK_PENDING_PTR	list;
{
if(list == 0)
	return;
ackCleanList(list->ackNext);
free(list);
}
/*
  GCT 20-Jun-1997

  This function will stuff the CRC into the record pointed to by recPtr. Ths first time
  through, the pointer into the common area will be derived from the SDR field RCRC.
*/
static int fieldOffset;
void dbSetCRC(char *recPtr,unsigned short crc)
{
struct recTypDes *dbRecTypDes;
struct fldDes *dbFldDes;
char *crcPtr = 0;
int fieldIndex;

if(fieldOffset == 0)						/* first time through find pointer to CRC */
  {
    dbRecTypDes = GET_PRECTYPDES(VU_AI);			/* point to type descriptor in SDR I used the "ai" point type */
    fieldIndex = 0;
    while(dbFldDes = GET_PFLDDES(dbRecTypDes,fieldIndex))
      {
	if(!strncmp(dbFldDes->fldname,"RCRC",FLDNAME_SZ))
	  {
	    fieldOffset = dbFldDes->offset;
	    break;
	  }
	fieldIndex++;
      }
  }
crcPtr = (char *)(recPtr + fieldOffset);
crc = htons(crc);					/* GCT 15-Jul-1997 Do that endian thing */
memcpy(crcPtr,(char *)&crc,sizeof(short));		/* store the CRC */
}
/*
  GCT 21-Jul-1997

  New download request response function which will use the Resource name as 
  a key to search for points.

*/
DBC_ERROR_CODES dbcDownloadRequest(DBC_IOCINFO_PTR iocinfo)
{
  DBC_DWNLD_REQUEST msg;
  DBC_DWNLD_RESP DBC_DwnldResp;
  char DBC_PointName[PVNAME_SZ+1],DBC_MsgPointName[PVNAME_SZ+1],crc_string[5];
  char key[PVNAME_SZ+DBC_RESNAMESIZE+1];
  char newName[PVNAME_SZ+1];
  DBC_RESINFO_PTR resinfo;
  DB_RECORD_PTR dnldRecord;
  DB_FIELD_PTR dnldField,dnldResField;
  int type,stat;
  unsigned short crc;
  VERIFY_INFO verify_info;
  /*
    Read the message containing last point I downloaded or blank if this is the first
  */
  iocinfo -> ioc_state = IOC_DOWNLOADING;
  readTcp(iocinfo,(char *)&msg,DBC_REQSIZE);
  dnldResField = DB_MapField(DBC_PvmapTable,FLD_RESOURCE);
  dnldField = DB_MapField(DBC_PvmapTable,FLD_NAME);
  strcpy(DBC_MsgPointName,msg.msgLastName);
  DB_UseKey(DBC_PvmapTable,RES_NAME_KEY);      			/* Seek using resource name + point name */
  if(!strlen(DBC_MsgPointName))
    {
      if((resinfo = dbcGetNextResource(iocinfo)) == 0)
	{
	  DBC_DwnldResp.msgNumberSent = 0;
	  dbcSendRecords(DBC_MSG_DWNLDRESP,&DBC_DwnldResp,iocinfo);
	  iocinfo->ioc_lastResource = 0;
	  iocinfo -> ioc_state = IOC_OK;
	  DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
	  return(DBC_SUCCESS);
	}
    }
  if(iocinfo->ioc_lastResource == (DBC_RESINFO_PTR)-1)
    {
      DBC_DwnldResp.msgNumberSent = 0;
      dbcSendRecords(DBC_MSG_DWNLDRESP,&DBC_DwnldResp,iocinfo);
      iocinfo->ioc_lastResource = 0;
      iocinfo -> ioc_state = IOC_OK;
      DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
      DBC_ProcessSymPurge(iocinfo);		       	/* purge and ask */
      return(DBC_SUCCESS);
    }
  strcpy(newName,DBC_MsgPointName);
  if(iocinfo->ioc_newResource == 1)
    strcpy(newName,"");
  DB_Top(DBC_PvmapTable);
  sprintf(key,"%-*.*s%-*.*s\0",DBC_RESNAMESIZE,DBC_RESNAMESIZE,iocinfo->ioc_lastResource->res_name,PVNAME_SZ,PVNAME_SZ,newName);
  /*
    Attempt to locate the first record containing this resource. If none available then try
    another resource. If there are no more resources then we are done.

    GCT 3-Oct-1997  If "found" record was marked for delete then skip to next record with
    current resource. Do this until all resources are used up for this IOC.
  */
  if((dnldRecord = (DB_RECORD_PTR)dbcFindFirstRecord(key,iocinfo,dnldResField)) == 0)
    {
    if((dnldRecord = (DB_RECORD_PTR)dbcFindNextRecord(iocinfo,dnldResField)) == 0)
      {
	DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
	return(DBC_SUCCESS);
      }
    }
  /*
    Skip to the next record if the last record the IOC sent to me was not empty
  */
  if(strlen(newName))
    if((dnldRecord = (DB_RECORD_PTR)dbcFindNextRecord(iocinfo,dnldResField)) == 0)
      {
	DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
	return(DBC_SUCCESS);
      }
  /* 
     Now we have a record containing the resource name. Prepare it for download
     and see if there are any more.
  */
  DBC_DwnldResp.msgNumberSent = 0;
  while(dnldRecord && (DBC_DwnldResp.msgNumberSent < DBC_WINDOW_SIZE))
    {
      DB_GetFieldValue(dnldRecord,dnldField,DBC_PointName,&type);
      /*
	If the point I got is the same as the point I just processed
	then it is duplicate record. Terminate the download for this IOC
	by telling the IOC that there are no more points to send.
      */
      if(!strcmp(DBC_MsgPointName,DBC_PointName))
	{
	  tisSysLog(V_INFO,0,"Duplicate point name detected: %s...download terminated at: %s\n",DBC_PointName,iocinfo -> ioc_lastpt);
	  DBC_DwnldResp.msgNumberSent = 0;
	  dbcSendRecords(DBC_MSG_DWNLDRESP,&DBC_DwnldResp,iocinfo);
	  iocinfo->ioc_lastResource = 0;
	  iocinfo -> ioc_state = IOC_OK;
	  DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
	  return(DBC_SUCCESS);
	}
      DB_UseKey(DBC_PvmapTable,FLD_NAME);            	       	/* Seek using point name */
      stat = DBC_BuildRecord(DBC_PointName,&downloadRecDesc[DBC_DwnldResp.msgNumberSent],dnldRecord);
      if(stat == DBC_SUCCESS)
	{
	  crc = DBC_CRCRecord(downloadRecDesc[DBC_DwnldResp.msgNumberSent].recPtr,downloadRecDesc[DBC_DwnldResp.msgNumberSent].recType);
	  dbSetCRC(downloadRecDesc[DBC_DwnldResp.msgNumberSent].recPtr,crc);	/* GCT 20-Jun-1997 store CRC in download record */
	  sprintf(crc_string,"%04.04X",crc);			/* update CRC in PVMAP */
	  DB_PutFieldValue(dnldRecord,pvmapCRCField,crc_string);
	  DB_GetVerifyInfo(DBC_PvmapTable,DBC_PointName,&verify_info,0);
	  verify_info.viPVStatus |= (iocinfo->ioc_index == 0 ? VI_LOADED_1 : VI_LOADED_2);
	  DB_PutVerifyInfo(DBC_PvmapTable,DBC_PointName,&verify_info,0);
	  strcpy(&iocinfo -> ioc_lastpt[0],DBC_PointName);
	  tisSysLog(V_DEBUG,0,
			   "Built record <%-*.*s> for IOC <%s>.\n",
			   PVNAME_SZ,PVNAME_SZ,downloadRecDesc[DBC_DwnldResp.msgNumberSent].recPtr,iocinfo->ioc_name);
	  DBC_DwnldResp.msgNumberSent++;			/* bump number sent */
 	  iocinfo->ioc_newResource = 0;
	}
      else
	{
	  iocinfo -> ioc_state = IOC_OK;
	  tisSysLog(V_INFO,0,"Unable to download <%s> to <%s>...%s\n",
			   DBC_PointName,iocinfo->ioc_name,DBC_ErrorMsg[stat]);
	}
      DB_UseKey(DBC_PvmapTable,RES_NAME_KEY);          	/* Seek using resource name + point name */
      if((dnldRecord = (DB_RECORD_PTR)dbcFindNextRecord(iocinfo,dnldResField)) == 0)
	{
	  iocinfo->ioc_lastResource = (DBC_RESINFO_PTR)-1;
	  break;
	}
    }
  if(dbcSendRecords(DBC_MSG_DWNLDRESP,&DBC_DwnldResp,iocinfo) == 0)
    {
      DBC_ProcessSymPurge(iocinfo);		       	/* purge and ask */
      iocinfo->ioc_lastResource = 0;			/* reset for next full download */
    }
  DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
  return(DBC_SUCCESS);
}
/*
  GCT 28-Jul-1997

  New online download request response function which will use the Resource name as 
  a key to search for points.

*/
DBC_ERROR_CODES dbcOnlineDownloadRequest(DBC_IOCINFO_PTR iocinfo)
{
  DBC_DWNLD_REQUEST msg;
  DBC_DWNLD_RESP DBC_DwnldResp;
  char DBC_PointName[PVNAME_SZ+1],DBC_MsgPointName[PVNAME_SZ+1],crc_string[5];
  char key[PVNAME_SZ+DBC_RESNAMESIZE+1];
  char newName[PVNAME_SZ+1];
  DBC_RESINFO_PTR resinfo;
  DB_RECORD_PTR dnldRecord;
  DB_FIELD_PTR dnldField,dnldResField;
  int type,stat;
  unsigned short crc;
  VERIFY_INFO verify_info;
  /*
    Read the message containing last point I downloaded or blank if this is the first
  */
  iocinfo -> ioc_state = IOC_DOWNLOADING;
  readTcp(iocinfo,(char *)&msg,DBC_REQSIZE);
  dnldResField = DB_MapField(DBC_PvmapTable,FLD_RESOURCE);
  dnldField = DB_MapField(DBC_PvmapTable,FLD_NAME);
  strcpy(DBC_MsgPointName,msg.msgLastName);
  DB_UseKey(DBC_PvmapTable,RES_NAME_KEY);      			/* Seek using resource name + point name */
  if(!strlen(DBC_MsgPointName))
    {
      if((resinfo = dbcGetNextResource(iocinfo)) == 0)
	{
	  DBC_DwnldResp.msgNumberSent = 0;
	  dbcSendRecords(DBC_MSG_OLDRESP,&DBC_DwnldResp,iocinfo);
	  iocinfo->ioc_lastResource = 0;
	  iocinfo -> ioc_state = IOC_OK;
	  DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
	  return(DBC_SUCCESS);
	}
      ackCleanList(iocinfo->ioc_ackPending);		/* clean my list for each NEW request */
      iocinfo->ioc_ackPending = 0;
    }
  if(iocinfo->ioc_lastResource == (DBC_RESINFO_PTR)-1)
    {
      DBC_DwnldResp.msgNumberSent = 0;
      dbcSendRecords(DBC_MSG_OLDRESP,&DBC_DwnldResp,iocinfo);
      iocinfo->ioc_lastResource = 0;
      iocinfo -> ioc_state = IOC_OK;
      DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
      return(DBC_SUCCESS);
    }
  strcpy(newName,DBC_MsgPointName);
  if(iocinfo->ioc_newResource == 1)
    strcpy(newName,"");
  DB_Top(DBC_PvmapTable);
  sprintf(key,"%-*.*s%-*.*s\0",DBC_RESNAMESIZE,DBC_RESNAMESIZE,iocinfo->ioc_lastResource->res_name,PVNAME_SZ,PVNAME_SZ,newName);
  /*
    Attempt to locate the first record containing this resource. If none available then try
    another resource. If there are no more resources then we are done.

    GCT 3-Oct-1997  If "found" record was marked for delete then skip to next record with
    current resource. Do this until all resources are used up for this IOC.
  */
  if((dnldRecord = (DB_RECORD_PTR)dbcFindFirstRecord(key,iocinfo,dnldResField)) == 0)
    {
    if((dnldRecord = (DB_RECORD_PTR)dbcFindNextRecord(iocinfo,dnldResField)) == 0)
      {
	DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
	return(DBC_SUCCESS);
      }
    }
  /*
    Skip to the next record if the last record the IOC sent to me was not empty
  */
  if(strlen(newName))
    if((dnldRecord = (DB_RECORD_PTR)dbcFindNextRecord(iocinfo,dnldResField)) == 0)
      {
	DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
	return(DBC_SUCCESS);
      }
  /* 
     Now we have a record containing the resource name. Prepare it for download
     and see if there are any more.
  */
  DBC_DwnldResp.msgNumberSent = 0;
  while(dnldRecord && (DBC_DwnldResp.msgNumberSent < DBC_WINDOW_SIZE))
    {
      DB_GetFieldValue(dnldRecord,dnldField,DBC_PointName,&type);
      DB_UseKey(DBC_PvmapTable,FLD_NAME);            	       	/* Seek using point name */
      DB_GetVerifyInfo(DBC_PvmapTable,DBC_PointName,&verify_info,0);
      DB_UseKey(DBC_PvmapTable,RES_NAME_KEY);          	/* Seek using resource name + point name */
      /*
	If the point I got is the same as the point I just processed
	then it is duplicate record. Terminate the download for this IOC
	by telling the IOC that there are no more points to send.
      */
      if((iocinfo->ioc_index == 0 ? !VI_IS_LOADED1(verify_info.viPVStatus) : !VI_IS_LOADED2(verify_info.viPVStatus)))	/* has NOT been downloaded */
	{
	  if(!strcmp(DBC_MsgPointName,DBC_PointName))
	    {
	      tisSysLog(V_INFO,0,"Duplicate point name detected: %s...download terminated at: %s\n",DBC_PointName,iocinfo -> ioc_lastpt);
	      DBC_DwnldResp.msgNumberSent = 0;
	      dbcSendRecords(DBC_MSG_OLDRESP,&DBC_DwnldResp,iocinfo);
	      iocinfo->ioc_lastResource = 0;
	      iocinfo -> ioc_state = IOC_OK;
	      DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
	      return(DBC_SUCCESS);
	    }
	  DB_UseKey(DBC_PvmapTable,FLD_NAME);            	       	/* Seek using point name */
	  stat = DBC_BuildRecord(DBC_PointName,&downloadRecDesc[DBC_DwnldResp.msgNumberSent],dnldRecord);
	  if(stat == DBC_SUCCESS)
	    {
	      crc = DBC_CRCRecord(downloadRecDesc[DBC_DwnldResp.msgNumberSent].recPtr,downloadRecDesc[DBC_DwnldResp.msgNumberSent].recType);
	      dbSetCRC(downloadRecDesc[DBC_DwnldResp.msgNumberSent].recPtr,crc);	/* GCT 20-Jun-1997 store CRC in download record */
	      sprintf(crc_string,"%04.04X",crc);			/* update CRC in PVMAP */
	      DB_PutFieldValue(dnldRecord,pvmapCRCField,crc_string);
	      ackAddToList(iocinfo,iocinfo->ioc_index,DBC_PointName);		/* accumulate until ACK from IOC */
	      strcpy(&iocinfo -> ioc_lastpt[0],DBC_PointName);
	      tisSysLog(V_DEBUG,0,
			       "Built record <%-*.*s> for IOC <%s>.\n",
			       PVNAME_SZ,PVNAME_SZ,downloadRecDesc[DBC_DwnldResp.msgNumberSent].recPtr,iocinfo->ioc_name);
	      DBC_DwnldResp.msgNumberSent++;			/* bump number sent */
	      iocinfo->ioc_newResource = 0;
	    }
	  else
	    {
	      iocinfo -> ioc_state = IOC_OK;
	      tisSysLog(V_INFO,0,"Unable to download <%s> to <%s>...%s\n",
			      DBC_PointName,iocinfo->ioc_name,DBC_ErrorMsg[stat]);
	    }
	}
      DB_UseKey(DBC_PvmapTable,RES_NAME_KEY);          	/* Seek using resource name + point name */
      if((dnldRecord = (DB_RECORD_PTR)dbcFindNextRecord(iocinfo,dnldResField)) == 0)
	{
	  iocinfo->ioc_lastResource = (DBC_RESINFO_PTR)-1;
	  break;
	}
    }
  if(dbcSendRecords(DBC_MSG_OLDRESP,&DBC_DwnldResp,iocinfo) == 0)
    {
      iocinfo->ioc_lastResource = 0;			/* reset for next full download */
    }
  DB_UseKey(DBC_PvmapTable,FLD_NAME);      		/* restore NAME key */
  return(DBC_SUCCESS);
}
/*
  Get the next resource for the given IOC. If the pointer is null then return the
  first resource encountered for this IOC. Otherwise start the search from the
  pointer after the current one and return the next resinfo pointer for the given IOC.

  The comparisons are made between the pointers to the iocinfo structures
*/
DBC_RESINFO_PTR dbcGetNextResource(DBC_IOCINFO_PTR iocinfo)
{
  DBC_RESINFO_PTR temp;
  if(iocinfo->ioc_lastResource == 0)
    temp = (DBC_RESINFO_PTR)lstFirst((LIST *)&DBC_RESHeader);
  else if(iocinfo->ioc_lastResource == (DBC_RESINFO_PTR)-1)
    return(0);
  else
    {
      temp = iocinfo->ioc_lastResource;
      temp = (DBC_RESINFO_PTR)lstNext((NODE *)temp);
    }
  while(temp)
    {
      if((temp -> res_iocinfo[0] == iocinfo) || (temp -> res_iocinfo[1] == iocinfo))
	{
	  tisSysLog(V_DEBUG,0,"New resource <%s> for IOC <%s>",temp->res_name,iocinfo->ioc_name);
	  iocinfo->ioc_newResource = 1;
	  iocinfo->ioc_index = ((temp->res_iocinfo[0] == iocinfo) ? 0 : 1);
	  iocinfo->ioc_lastResource = temp;
/* 	  DB_Top(DBC_PvmapTable); */
	  break;
	}
      temp = (DBC_RESINFO_PTR)lstNext((NODE *)temp);
    }
  return(temp);
}
/*
  Send as many records as we can
*/
int dbcSendRecords(short mt,DBC_DWNLD_RESP *resp,DBC_IOCINFO_PTR iocinfo)
{
  short msgType;
  short numToSend;
  short i;

  msgType = htons(mt);
  writeTcp(iocinfo,(char *)&msgType,sizeof(msgType));			/* send message type */
  numToSend = resp->msgNumberSent;
  resp->msgNumberSent = htons(resp->msgNumberSent);
  writeTcp(iocinfo,(char *)resp,DBC_RESPSIZE);		/* send response header */
  for(i = 0; i < numToSend; i++)
    {
      downloadRecDesc[i].recType = htons(downloadRecDesc[i].recType);
      writeTcp(iocinfo,(char *)&downloadRecDesc[i].recType,sizeof(downloadRecDesc[i].recType));	/* send type */
      writeTcp(iocinfo,downloadRecDesc[i].recPtr,downloadRecDesc[i].recSize);	/* send record */
    }
  return(numToSend);
}
/*
  Seek to first record with key. If key not found the try another
  until all resources for this IOC are tried then return 0
  else return 1
*/
int dbcFindFirstRecord(char *key,DBC_IOCINFO_PTR iocinfo,DB_FIELD_PTR resfield)
{
  int dbStatus;
  char resname[DBC_RESNAMESIZE+1];
  DB_RECORD_PTR rec;
  int type;
  DBC_RESINFO_PTR resinfo;
  while(1)
    {
      rec = (DB_RECORD_PTR)DB_SeekStatus(DBC_PvmapTable,key,&dbStatus);
      /*
	GCT 3-Oct-1997 Check for deleted records. if record is marked for delete then
	return zero. It will be skipped later.
      */
      if(dbDeleted(DBC_PvmapTable->table))
	{
	  DBC_PvmapTable->current_record = 1;
	  return(0);
	}
      tisSysLog(V_DEBUG,0,"Seeked with key = <%s>..%d..%d.",key,rec,dbStatus);
      DB_GetFieldValue(rec,resfield,resname,&type);
      if(!strcmp(resname,iocinfo->ioc_lastResource->res_name))
	{
	  return(1);
	}
      else
	{
	  if((resinfo = dbcGetNextResource(iocinfo)) == 0)
		return(0);
	  sprintf(key,"%-*.*s%-*.*s\0",DBC_RESNAMESIZE,DBC_RESNAMESIZE,iocinfo->ioc_lastResource->res_name,PVNAME_SZ,PVNAME_SZ,"");
	  tisSysLog(V_DEBUG,0,"New key = <%s>.",key);
	}
    }
}
/*
  Skip to next record with key. If record not found then return zero
  else return one.
*/
int dbcFindNextRecord(DBC_IOCINFO_PTR iocinfo,DB_FIELD_PTR resfield)
{
  char key[PVNAME_SZ+DBC_RESNAMESIZE+1],resname[DBC_RESNAMESIZE+1];
  DB_RECORD_PTR rec;
  DBC_RESINFO_PTR resinfo;
  int type;
  while(1)
    {
      rec = (DB_RECORD_PTR)DB_SeekNext(DBC_PvmapTable);
      DB_GetFieldValue(rec,resfield,resname,&type);
      if(!strcmp(resname,iocinfo->ioc_lastResource->res_name))
	{
	  return(1);
	}
      else
	{
	  if((resinfo = dbcGetNextResource(iocinfo)) == 0)
		return(0);
	  sprintf(key,"%-*.*s%-*.*s\0",DBC_RESNAMESIZE,DBC_RESNAMESIZE,iocinfo->ioc_lastResource->res_name,PVNAME_SZ,PVNAME_SZ,"");
	  tisSysLog(V_DEBUG,0,"New key = <%s>.",key);
	  return(dbcFindFirstRecord(key,iocinfo,resfield));
	}
    }
}
/*
  GCT 4-May-1999

  Handle the reset acknowledge from an IOC/RTU. This is done here now as part of the
  UDP message removal effort. Use the FD stored in the ack message to respond to dataVu.
*/
DBC_ERROR_CODES dbcResetAck(DBC_IOCINFO_PTR iocinfo)
{
  int dataVuFd,i;
  short mtype = DBC_MSG_RESETACK;
  readTcp(iocinfo,(char *)&dataVuFd,sizeof(int));	/* get the dataVu FD */
  for(i = 0;i < DBC_MAX_HOSTS;i++)
    {
      if(utilIoc[i].ioc_socket == dataVuFd)		/* find matching info entry */
	{
	  writeTcp(&utilIoc[i],(char *)&mtype,sizeof(mtype));	/* send message to waiting dataVu */
	  tisSysLog(V_DEBUG,0,"Reset acknowledged from <%*.*s>.",DBC_RESNAMESIZE,DBC_RESNAMESIZE,iocinfo->ioc_name);
	  break;
	}
    }
  return(DBC_SUCCESS);
}
/*
 */
DBC_ERROR_CODES dbcDeleteStatus(DBC_IOCINFO_PTR iocinfo)
{
  DBC_DELSTATUS stat;
  DBC_IOCINFO_PTR dataVuInfo;
  short refs;
  char name[PVNAME_SZ];
  short mtype = htons(DBC_MSG_DELSTATUS);
  int dataVuFd,i;
  readTcp(iocinfo,(char *)&stat,sizeof(DBC_DELSTATUS));	/* read whole DEL_STATUS header */
  refs = ntohs(stat.numRefs);
  dataVuFd = ntohl(stat.originatorFd);
  stat.originatorFd = iocinfo->ioc_addr;		/* send back IOC address */
  for(i = 0;i < DBC_MAX_HOSTS;i++)
    {
      if(utilIoc[i].ioc_socket == dataVuFd)		/* find matching info entry */
	{
	  dataVuInfo = &utilIoc[i];
	  writeTcp(&utilIoc[i],(char *)&mtype,sizeof(mtype));	/* send message to waiting dataVu */
	  writeTcp(&utilIoc[i],(char *)&stat,sizeof(DBC_DELSTATUS));
	  break;
	}
    }
/*
  If dataVu is gone then we still need to empty the IOC input buffer
*/
  if(i >= DBC_MAX_HOSTS)
    {
      i = refs * PVNAME_SZ;		/* compute size of rest of message from number of */
      iocinfo->ioc_rxCount -= i;	/* references (if any) */
      iocinfo->ioc_rxNextChar += i;
      tisSysLog(V_DEBUG,0,"dataVu absent for delete ack");
      return(DBC_SUCCESS);
    }
/*
  If the number of referencing points is non-zero then send them to dataVu as well
*/
  while(refs)
    {
      readTcp(iocinfo,name,PVNAME_SZ);
      writeTcp(dataVuInfo,name,PVNAME_SZ);
      refs--;
    }
  return(DBC_SUCCESS);
}
