/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*============================================================================*/
/*									      */
/*									      */
/*	Tate Integrated Systems, LP					      */
/*									      */
/*									      */
/*	Author:			Greg Tomalesky				      */
/*	Date:			29-Jun-1994				      */
/*									      */
/*	Function Name:		DB_PutVerifyInfo			      */
/*	Function Description:						      */
/*									      */
/*									      */
/*									      */
/*									      */
/*	Input Parameters:	PrimaryKey   - primary key in record.         */
/*				TableHandle  - pointer to table structure.    */
/*				verify_info  - pointer to VERIFY_INFO struct  */
/*									      */
/*	Output Parameters:	none					      */
/*									      */
/*	Return Values or error codes:	error		0 bad record	      */
/*					success:	record handle	      */
/*									      */
/*	Modification History:	29-Jun-1994	First time		      */
/*									      */
/*									      */
/*									      */
/*									      */
/*============================================================================*/
#include <DBDefines.h>
#include <DBCVerifyDefs.h>
#include <DBCDefines.h>

int	DB_PutVerifyInfo(TableHandle,pvName,verify_info,import_info)
DB_TABLE_PTR	TableHandle;
char		*pvName;
VERIFY_INFO_PTR	verify_info;
IMPORT_INFO_PTR	import_info;
{
int		stat;
char		ts[11];
F4FIELD		*timeStamp,*downLoad1,*downLoad2,*deleted,*importName,*importDate,*importDelete;

if (TableHandle == 0)
	return(0);

timeStamp		= d4field(TableHandle->table,VI_FLD_TIMESTAMP);
downLoad1		= d4field(TableHandle->table,VI_FLD_LOAD1FLAG);
downLoad2		= d4field(TableHandle->table,VI_FLD_LOAD2FLAG);
deleted			= d4field(TableHandle->table,VI_FLD_DELETEFLAG);

if(!pvName)
	{
	if((stat = d4skip(TableHandle->table,1)) != 0)
		{
		d4unlock_all(TableHandle->table);
		return(0);
		}
	}
else
	{
	if(strlen(pvName))
		{
		stat = d4seek(TableHandle->table,pvName);
		if(stat != 0)
			{
			d4unlock_all(TableHandle->table);
			return(0);
			}
		}
	else
		stat = d4top(TableHandle->table);
	}
/*
	If the 'verify_info' pointer is not NULL then save the contents
	of the pointer to Pvmap.
*/
if(verify_info)
	{
	sprintf(ts,"%d\0",verify_info->viTimeStamp);
	f4assign(timeStamp,ts);								/* set time in record */
	f4assign_char(downLoad1,(VI_IS_LOADED1(verify_info->viPVStatus) ? 'T' : 'F'));
	f4assign_char(downLoad2,(VI_IS_LOADED2(verify_info->viPVStatus) ? 'T' : 'F'));
	f4assign_char(deleted,(VI_IS_DELETED(verify_info->viPVStatus) ? 'T' : 'F'));
	}
/*
	If the 'import_info' pointer is not NULL then save the contents
	of the pointer to Pvmap.
*/
if(import_info)
	{
	importName		= d4field(TableHandle->table,VI_FLD_IMPORTNODE);
	importDate		= d4field(TableHandle->table,VI_FLD_IMPORTDATE);
	importDelete	= d4field(TableHandle->table,VI_FLD_IMPDELFLAG);
	sprintf(ts,"%d\0",import_info->viImportDate);
	f4assign(importDate,ts);								/* set time in record */
	f4assign(importName,import_info->viImportNode);			/* save node name */
	f4assign_char(importDelete,(import_info->viImpDelFlag ? 'T' : 'F'));				/* save import delete flag */
	}
d4flush_all(TableHandle -> table);
d4unlock_all(TableHandle -> table);
return(1);
}
