#include	<stdio.h>
#include	<string.h>
#ifdef WIN32
#include	<time.h>
#include	<sys/types.h>
#else
#include	<sys/time.h>
#include	<sys/param.h>
#include	<types.h>
#endif WIN32
#include	<memory.h>
#include	<errno.h>
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32
#include	"dbDefs.h"
#include	"special.h"
#include	"descDataTable.h"
#include	"avl.h"
#include	"fieldAttributes.h"
#define BIG_STRING_SIZE 4096
extern AVL_TREE *faTree;
static char bigString[BIG_STRING_SIZE];

int FA_WriteTree(char *filename)
{
  FILE *fp;
  if((fp = fopen(filename,"w")) != 0)
    {
      avl_traverse(faTree,INORDER,(void (*)(void*,void*))FA_WriteNode,(void *)fp);
      fclose(fp);
      return(0);
    }
  return(1);
}
int FA_ReadTree(char *filename)
{
  PTDATA data,*pData;
  FILE *fp;
  char *pvPtr;
  char *tok;
  short i,index;
  char line[80];
  if((fp = fopen(filename,"r")) != 0)
    {
      if(faTree == 0)
	{
	  faTree = avl_init(FA_NameCompare);
	  while(fgets(line,80,fp) != NULL)
	    {
	      memset(&data,0,sizeof(PTDATA));
	      pvPtr = strtok(line," ");
	      sprintf(&data.pvname[0],"%-*.*s\0",PVNAME_SZ,PVNAME_SZ,pvPtr);
	      if((pData = (PTDATA_PTR)FA_AddNode(&data)) != 0)
		 {
		  tok = strtok(NULL," ");		/* get the type index */
		  pData->recType = (short)atoi(tok);
		  tok = strtok(NULL," ");		/* get the CRC */
		  pData->crc = (short)atoi(tok);
		  tok = strtok(NULL," ");		/* get the time stamp */
		  pData->timestamp = atoi(tok);
		  tok = strtok(NULL," ");		/* get number of doubles to follow */
		  pData->numTableSize = atoi(tok);
		  tok = strtok(NULL," ");		/* get number of enum strings */
		  pData->numStrings = atoi(tok);
		  if(pData->numTableSize != 0)
		    {
		      pData->numberTable = (double *)calloc(pData->numTableSize,sizeof(double));
		      for(i = 0;i < pData->numTableSize; i++)
			{
			  fgets(line,80,fp);		/* get the double value */
			  pData->numberTable[i] = atof(line);
			}
		    }
		  if(pData->numStrings != 0)
		    {
		      memset(&bigString[0],0,4096);
		      index = 0;				/* pointer into bigString */
		      for(i = 0;i < pData->numStrings;i++)
			{
			  fgets(line,80,fp);
			  line[strlen(line)-1] = 0;		/* get string and drop the \n */
			  memcpy(&bigString[index],line,strlen(line)+1);	/* copy string and NULL */
			  index += 33/* strlen(line)+1 */;
			  bigString[index]=0;
			}
		      pData->enumTable = (char *)calloc(1,index+1);
		      memcpy(pData->enumTable,&bigString[0],index+1);
		    }
		 }
	    }
	  fclose(fp);
	  return(0);
	}
    }
  return(1);
}
void FA_WriteNode(FILE *fp,PTDATA_PTR node)		/* called during traversal */
{
  int i;
  char *str;
  /* name typeIndex crc timestamp numDoubles numStrings doubles strings */
  fprintf(fp,"%s %d %d %d %d %d\n",
	  node->pvname,
	  node->recType,
	  node->crc,
	  node->timestamp,
	  (node->numberTable != 0 ? node->numTableSize : 0),
	  (node->enumTable != 0 ? node->numStrings : 0));
  if(node->numberTable != 0)
    {
      for(i = 0;i < node->numTableSize;i++)
	{
	  fprintf(fp,"%lf\n",node->numberTable[i]);
	}
    }
  if((str = node->enumTable) != 0)
    {
      for(i = 0;i < node->numStrings;i++)
	{
	  fprintf(fp,"%s\n",str);
	  str += 33/* strlen(str)+1 */;
	}
    }
}
