/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	This function is used to pre-configure the internal data table
	using a dbase file (dpacfg.dbf). Return number of records found.
	or error codes (< 0)

	GCT	20-Oct-1994
*/
#include	<sys/param.h>
#include	<in.h>

#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#include	"dbDefs.h"
#include	"dpa.h"
#include	"dataTypes.h"
extern	LIST	chanInfoTable;
static	C4CODE	cb;
static	char	cbInit = 0;
extern	DPA_INFO	dpaInfo;

int		dpaConfigure(char *appName)
{
D4DATA	*file;
int		i,j,count = 0;
CHANNEL_INFO_PTR	entry;
F4FIELD	*name,*datatype,*disphi,*displo,*drvhi,*drvlo,*prec,*hihi,*hi,*lo,*lolo;
F4FIELD	*hhsever,*hsever,*lsever,*llsever,*string[8];
F4FIELD	*aenb,*egutag,*desc,*numstrs,*tenb,*userdata;
char	pv[PVNAME_SZ+FLDNAME_SZ+20],*app,fileName[MAXPATHLEN],channel[PVNAME_SZ+1],field[FLDNAME_SZ+1];
char	pvName[PVNAME_SZ+FLDNAME_SZ+20],enumStr[50];
/*
	see if codebase should be initialized
*/
if(cbInit++ == 0)
	{
	d4init(&cb);
#ifdef	USECB63
	cb.errOpen = 0;
#else
	cb.open_error = 0;
#endif	USECB63
	}
/*
	Open data file and read sequentially to obtain data
	for each new entry in the table.
*/
sprintf(fileName,"/tis4000db/%s.dbf",appName);
if((file = d4open(&cb,fileName)) == 0)
	return(DPA_OPENERR);
/*
	init field pointers
*/
name		= d4field(file,"NAME");
desc		= d4field(file,"DESC");
datatype	= d4field(file,"DTYPE");
disphi		= d4field(file,"DISPHIGH");
displo		= d4field(file,"DISPLOW");
drvhi		= d4field(file,"IRHIGH");
drvlo		= d4field(file,"IRLOW");
prec		= d4field(file,"PRECISION");
numstrs		= d4field(file,"NUMSTRS");
string[0]		= d4field(file,"STRING1");
string[1]		= d4field(file,"STRING2");
string[2]		= d4field(file,"STRING3");
string[3]		= d4field(file,"STRING4");
string[4]		= d4field(file,"STRING5");
string[5]		= d4field(file,"STRING6");
string[6]		= d4field(file,"STRING7");
string[7]		= d4field(file,"STRING8");
hihi			= d4field(file,"HIHILIMIT");
hi				= d4field(file,"HIGHLIMIT");
lo				= d4field(file,"LOWLIMIT");
lolo			= d4field(file,"LOLOLIMIT");
hhsever			= d4field(file,"HIHISEVER");
hsever			= d4field(file,"HIGHSEVER");
lsever			= d4field(file,"LOWSEVER");
llsever			= d4field(file,"LOLOSEVER");
egutag			= d4field(file,"EGUTAG");
aenb			= d4field(file,"AENB");
tenb			= d4field(file,"TENB");
userdata		= d4field(file,"USERDATA");
/*
	start the loop
*/
for(d4top(file);!d4eof(file);d4skip(file,1))
	{
	if(d4deleted(file))
		continue;
	strcpy(pvName,f4str(name));
	if((app = (char *)strtok(pvName,":")) == 0)
		continue;			       	/* skip to next record if no ':' */
	strcpy(pv,f4str(name));
	dpaSplitName(pv,channel,field);
	if(!field)
	  {
	    strcpy(field,"VAL");
	    strcat(pv,".VAL");
	  }
	if(!strcmp(app,appName))		       /* load only points with this appName */
		{
		if((entry = (CHANNEL_INFO_PTR)dpaGetHandle(channel)) == 0)		/* 0 = not there */
			{
			entry = (CHANNEL_INFO_PTR)calloc(1,sizeof(CHANNEL_INFO));
			lstAdd((LIST *)&chanInfoTable,(NODE *)entry);
			strcpy(&entry->chanName[0],channel);
			}
/*
	Fill in data for new entry here
*/
		strncpy(&entry->chanEgu[0],f4str(egutag),7);
		strncpy(&entry->chanDesc[0],f4str(desc),31);
		strcpy(&entry->chanUserData[0],f4str(userdata));
		entry->chanDispHi	= f4double(disphi);
		entry->chanDispLo	= f4double(displo);
		entry->chanDrvHi	= f4double(drvhi);
		entry->chanDrvLo	= f4double(drvlo);
		entry->chanPrec		= f4int(prec);
		entry->chanDataType	= f4int(datatype);
		entry->chanHiHi		= f4double(hihi);	/* alarm limits */
		entry->chanHi		= f4double(hi);
		entry->chanLo		= f4double(lo);
		entry->chanLoLo		= f4double(lolo);
		entry->chanHHSever	= (short)f4int(hhsever);	/* alarm severity */
		entry->chanHSever	= (short)f4int(hsever);
		entry->chanLSever	= (short)f4int(lsever);
		entry->chanLLSever	= (short)f4int(llsever);
		entry->chanAenb		= (short)f4true(aenb);
		entry->chanTenb		= (short)f4true(tenb);
		entry->chanMask		= 0;
		entry->chanNumStrs	= (short)f4int(numstrs);
		if(entry->chanNumStrs)
			{
			entry->chanEnumList = (char **)calloc(entry->chanNumStrs,sizeof(char *));	/* allocate space for array */
			for(i = 0;i < entry->chanNumStrs;i++)
				{
				strcpy(enumStr,f4str(string[i]));
				for(j=strlen(enumStr)-1;enumStr[j] == ' ';j--);
				enumStr[j+1] = 0;
				entry->chanEnumList[i] = (char *)calloc(1,strlen(enumStr)+1);	/* allocate space for strings */
				strcpy((char *)entry->chanEnumList[i],enumStr);					/* copy strings to new place */
				}
			}
		(void)dpaNameToAddr(field,entry);
		if(dpaInfo.appOpen)
		  (*dpaInfo.appOpen)(pv,entry);	/* call user supplied function to overwrite initial data */
		entry->valid = 1;
		count++;
		}
	}
d4close(file);
return(count);
}
