/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	Field operations

	20-Oct-1995
*/
#include	<in.h>

#include	"dpa.h"
#include	"dataTypes.h"

extern	DPA_INFO	dpaInfo;
extern	LIST		chanInfoTable;
char		respData[DPA_CHAN_DATA_SIZE];

/* ems 4-Apr-99, moved here from dpa.h so dont declar staic data in .h file*/
static	char	*dpaFields[] =
	{
	"VAL",
	"EGU",
	"STAT",
	"SEVR",
	"HOPR",
	"LOPR",
	"DRVH",
	"DRVL",
	"HIHI",
	"HIGH",
	"LOW",
	"LOLO",
	"HHSV",
	"HISV",
	"LOSV",
	"LLSV",
	"PREC",
	"AENB",
	"TENB",
	"ACK",
	"DESC",
	"USER",
	0
	};

int	dpaFieldResponse(void *handle)
{
DPA_ADDR *pAddr;
CHANNEL_INFO_PTR	entry;
DPA_DRRDATA	wMsg;
short	msgType;

if(handle == 0)
	return(DPA_NULLHANDLE);
pAddr = (DPA_ADDR_PTR)handle;
entry = (CHANNEL_INFO_PTR)pAddr->precord;

if(!dpaIsValid(entry))
	return(DPA_NULLHANDLE);
if(!pAddr->init)
	return(DPA_NULLHANDLE);
memset(respData,0,DPA_CHAN_DATA_SIZE);

msgType = htons(CHAN_DRRDATA);
wMsg.drr.chHandle	= (int)pAddr->chHandle;
wMsg.drr.chCaHandle = (int)pAddr->chCaHandle;
wMsg.drr.chDataType	= pAddr->nativeType;
wMsg.appHandle = pAddr->chAppHandle;
if((wMsg.drr.chDataType & 0xff) == AGNT_STRING)
	wMsg.drr.chDataType |= (AGNT_STAT);
else
	wMsg.drr.chDataType |= (AGNT_STAT | AGNT_CNTRL | AGNT_GRAPH);
wMsg.drr.chCount	= pAddr->nativeCount;								/* one element for static fields */
wMsg.drr.chDataLen	= dpaAgentField(respData,wMsg.drr.chDataType,pAddr->nativeCount,0,entry,pAddr); /* get field data and size */
send(dpaInfo.appFd,&msgType,sizeof(msgType),0);		/* send the message type... */
send(dpaInfo.appFd,&wMsg,sizeof(DPA_DRRDATA),0);		/* followed by the message header... */
send(dpaInfo.appFd,respData,wMsg.drr.chDataLen,0);		/* followed by the data */
return(DPA_NORMAL);
}

int	dpaPutField(void *handle,short type,void *value,short size)
{
DPA_ADDR *pAddr = (DPA_ADDR_PTR)handle;
switch(pAddr->field_index)
	{
	case DPA_VAL:
		bcopy((char *)value,(char *)(pAddr->pfield),size);
		pAddr->field_size = size;
		break;
	case DPA_EGU:
	case DPA_DESC:
	case DPA_USER:
		strcpy((char *)(pAddr->pfield),dpaConvertToString(handle,value,type));
		break;
	case DPA_HOPR:
	case DPA_LOPR:
	case DPA_DRVH:
	case DPA_DRVL:
	case DPA_HIHI:
	case DPA_HIGH:
	case DPA_LOW:
	case DPA_LOLO:
		*((double *)(pAddr->pfield)) = dpaConvertToDouble(handle,value,type);
		break;
	case DPA_STAT:
	case DPA_SEVR:
	case DPA_HHSV:
	case DPA_HISV:
	case DPA_LOSV:
	case DPA_LLSV:
	case DPA_PREC:
	case DPA_AENB:
	case DPA_TENB:
	case DPA_ACK:
		*((short *)(pAddr->pfield)) = dpaConvertToInt(handle,value,type);
		break;
	case DPA_USER_DEFINED_FIELD:
		switch(pAddr->nativeType & 0xff)
			{
			case AGNT_ENUM:
				*((short *)(pAddr->pfield)) = dpaConvertToInt(handle,value,type);
				break;
			case AGNT_FLOAT:
				*((float *)(pAddr->pfield)) = dpaConvertToFloat(handle,value,type);
				break;
			case AGNT_DOUBLE:
				*((double *)(pAddr->pfield)) = dpaConvertToDouble(handle,value,type);
				break;
			case AGNT_STRING:
				strcpy((char *)(pAddr->pfield),dpaConvertToString(handle,value,type));
				break;
			case AGNT_INT:
				*((short *)(pAddr->pfield)) = dpaConvertToInt(handle,value,type);
				break;
			case AGNT_LONG:
				*((int *)(pAddr->pfield)) = dpaConvertToLong(handle,value,type);
				break;
			}
		break;
	}
}
/*
	return field select value or -1 if error.
*/
int	dpaWhichField(char *fieldName)
{
char i;
for(i = 0;dpaFields[i];i++)
	{
	if(!strcmp(fieldName,dpaFields[i]))
		return(i);
	}
return(-1);
}
DPA_ADDR_PTR	findField(DPA_ADDR_PTR entry,char *field)
{
while(entry)
	{
	if(!strncmp(entry->fieldName,field,4))
		break;
	entry = (DPA_ADDR_PTR)entry->nextField;
	}
return(entry);
}

/*

	Return the address of the specified field within the original PV entry
	structure. This structure is assigned during a build by stripping off
	field name and allocating memory for the CHANNEL_INFO structure.

	GCT 22-Jan-1996 Modified to allocate the dbAddr structure and add to a linked list.
	This is done only if the entry is new. First search an existing list for the string
	that is the field name (i.e. VAL, HIHI, etc.). If found then just return the pointer
	else malloc a new one and add to the head of the list. This is OK because the order
	does not matter.

*/
DPA_ADDR_PTR	dpaNameToAddr(char *field,CHANNEL_INFO_PTR entry)
{
int	index;
DPA_ADDR_PTR	addr;
char		padField[5];

/*
	find field in linked list from entry->chanFields. if found then use as before
	else create new one and add to list.
*/
sprintf(&padField[0],"%-4.4s",field);	/* store field name too */
if((addr = findField(entry->chanFields,padField)) == 0)
	{
	addr = (DPA_ADDR_PTR)calloc(1,sizeof(DPA_ADDR));
	addr->nextField = (DPA_ADDR_PTR)entry->chanFields;			/* insert at begining */
	entry->chanFields = addr;
	sprintf(&addr->fieldName[0],"%-4.4s",field);	/* store field name too */
	addr->precord = entry;							/* point back to main entry */
/*
	check for the "static" data fields. If the new field is from the statis list
	then fill in the appropriate info. If not the defer filling in the info until
	the build request calls the user-supplied function to get the info.
*/
	if((index = dpaWhichField(field)) < 0)
		return(addr);
	addr->field_index = index;
	addr->nativeCount = 1;			/* ALL static fields have a count of one */
	switch(index)
		{
		case DPA_VAL:
			addr->pfield = (void *)&entry->chanValue;
			addr->nativeType = entry->chanDataType;
			switch(entry->chanDataType)
				{
				case AGNT_FLOAT:
					addr->field_size = sizeof(float);
					break;
				case AGNT_DOUBLE:
					addr->field_size = sizeof(double);
					break;
				case AGNT_INT:
				case AGNT_ENUM:
					addr->field_size = sizeof(short);
					break;
				case AGNT_LONG:
					addr->field_size = sizeof(int);
					break;
				case AGNT_CHAR:
					addr->field_size = sizeof(char);
					break;
				case AGNT_STRING:
					addr->field_size = strlen(addr->pfield);
					break;
				default:
					addr->field_size = 0;
					break;
				}
			break;
		case DPA_EGU:
			addr->field_size = sizeof(entry->chanEgu);
			addr->pfield = (void *)&entry->chanEgu;
			addr->nativeType = AGNT_STRING;
			break;
		case DPA_DESC:
			addr->field_size = sizeof(entry->chanDesc);
			addr->pfield = (void *)&entry->chanDesc;
			addr->nativeType = AGNT_STRING;
			break;
		case DPA_USER:
			addr->field_size = sizeof(entry->chanUserData);
			addr->pfield = (void *)&entry->chanUserData;
			addr->nativeType = AGNT_STRING;
			break;
		case DPA_STAT:
			addr->field_size = sizeof(entry->chanStat);
			addr->pfield = (void *)&entry->chanStat;
			addr->nativeType = AGNT_ENUM;
			break;
		case DPA_SEVR:
			addr->field_size = sizeof(entry->chanSevr);
			addr->pfield = (void *)&entry->chanSevr;
			addr->nativeType = AGNT_ENUM;
			break;
		case DPA_HOPR:
			addr->field_size = sizeof(entry->chanDispHi);
			addr->pfield = (void *)&entry->chanDispHi;
			addr->nativeType = AGNT_DOUBLE;
			break;
		case DPA_LOPR:
			addr->field_size = sizeof(entry->chanDispLo);
			addr->pfield = (void *)&entry->chanDispLo;
			addr->nativeType = AGNT_DOUBLE;
			break;
		case DPA_DRVH:
			addr->field_size = sizeof(entry->chanDrvHi);
			addr->pfield = (void *)&entry->chanDrvHi;
			addr->nativeType = AGNT_DOUBLE;
			break;
		case DPA_DRVL:
			addr->field_size = sizeof(entry->chanDrvLo);
			addr->pfield = (void *)&entry->chanDrvLo;
			addr->nativeType = AGNT_DOUBLE;
			break;
		case DPA_HIHI:
			addr->field_size = sizeof(entry->chanHiHi);
			addr->pfield = (void *)&entry->chanHiHi;
			addr->nativeType = AGNT_DOUBLE;
			break;
		case DPA_HIGH:
			addr->field_size = sizeof(entry->chanHi);
			addr->pfield = (void *)&entry->chanHi;
			addr->nativeType = AGNT_DOUBLE;
			break;
		case DPA_LOW:
			addr->field_size = sizeof(entry->chanLo);
			addr->pfield = (void *)&entry->chanLo;
			addr->nativeType = AGNT_DOUBLE;
			break;
		case DPA_LOLO:
			addr->field_size = sizeof(entry->chanLoLo);
			addr->pfield = (void *)&entry->chanLoLo;
			addr->nativeType = AGNT_DOUBLE;
			break;
		case DPA_HHSV:
			addr->field_size = sizeof(entry->chanHHSever);
			addr->pfield = (void *)&entry->chanHHSever;
			addr->nativeType = AGNT_ENUM;
			break;
		case DPA_HISV:
			addr->field_size = sizeof(entry->chanHSever);
			addr->pfield = (void *)&entry->chanHSever;
			addr->nativeType = AGNT_ENUM;
			break;
		case DPA_LOSV:
			addr->field_size = sizeof(entry->chanLSever);
			addr->pfield = (void *)&entry->chanLSever;
			addr->nativeType = AGNT_ENUM;
			break;
		case DPA_LLSV:
			addr->field_size = sizeof(entry->chanLLSever);
			addr->pfield = (void *)&entry->chanLLSever;
			addr->nativeType = AGNT_ENUM;
			break;
		case DPA_PREC:
			addr->field_size = sizeof(entry->chanPrec);
			addr->pfield = (void *)&entry->chanPrec;
			addr->nativeType = AGNT_SHORT;
			break;
		case DPA_AENB:
			addr->field_size = sizeof(entry->chanAenb);
			addr->pfield = (void *)&entry->chanAenb;
			addr->nativeType = AGNT_ENUM;
			break;
		case DPA_TENB:
			addr->field_size = sizeof(entry->chanTenb);
			addr->pfield = (void *)&entry->chanTenb;
			addr->nativeType = AGNT_ENUM;
			break;
		case DPA_ACK:
			addr->field_size = sizeof(entry->chanAck);
			addr->pfield = (void *)&entry->chanAck;
			addr->nativeType = AGNT_ENUM;
			break;
		}
	}
return(addr);
}
/*
	Function to split incomming channels into channel name
	and field name.
*/
void	dpaSplitName(char *name,char *chan,char *fld)
{
char	*dot,nm[PVNAME_SZ+FLDNAME_SZ+10];

strcpy(nm,(char *)strtok(name," "));
dot = (char *)strchr(nm,'.');
if(dot == 0)
	{
	strcpy(chan,nm);
	strcpy(fld,"VAL ");
	}
else
	{
	dot = (char *)strtok(nm,".");
	strcpy(fld,(char *)strtok(NULL,"."));
	strcpy(chan,dot);
	}
return;
}
