/*cpuLoad.c,v 1.1.1.1 1999/08/03 14:42:53 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File:	cpuLoad.c													
**  Edit: 	08/29/94	WHS: Testing and debugging
*/


#define  startcpuload startcpuload         /* NOTE: change here */
#define  SETDELAYS   setcpuload           /* NOTE: change here */


#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <stdioLib.h>
#include <logLib.h>
#include <tickLib.h>

#include "task_params.h"
#include "cpuLoad.h"

static int		taskId;
static int		delay = 0;
static int		active = 0;
static int		timenow = 0;

static char *tasknames[] = {"CPU LOADER"};


int startcpuload (void)
{
	taskId = taskSpawn (tasknames [0], CPU_PRIORITY, CPU_TASK_OPTIONS, CPU_STACK, (FUNCPTR)cpuload, 0,0,0,0,0,0,0,0,0,0);

	logMsg ("Started the CPU LOADER\n", 0,0,0,0,0,0);

	return (1);
}

/**********
*
*	Set number of cpu ticks to keep busy
*
**********/
void SETDELAYS (unsigned short ticks)
{
	active = ticks;	
}


/**********											*      CPULOAD                                                                      *                                                                                     	*	This task will utilize cpu time to simulate a busy IOC.
*                                                                                     	**********/

void cpuload (void)
{
	delay = (60 - (active % 60));
	while (TRUE)
	{
	    if (active)
	    {
		delay = (60 - (active % 60));
		timenow = (tickGet () + active);
		while (timenow > tickGet ());
	    }
	    delay = (60 - (active % 60));
	    taskDelay (delay);
	}
}

