/*gentimer.c,v 1.1.1.1 1999/08/03 14:42:53 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**	File:	gentimers.c
**	Auth:	John L. Dalesio
**	Edit:	9/27/91	JLD
**
**
**
**	The purpose of this module is to provide a finer resolution timer
**	for the Analog Devices I/O driver
*/

#include <vxWorks.h>
#include <logLib.h>
#include <taskLib.h>

/* #define TEST	1 */
#ifndef	TEST
#include "vxWorks.h"
#include "semLib.h"
#endif

#ifdef	TEST
#include "testmode.h"
#include <dummyos.h>
#include <modbus.h>
#define logMsg	printf
#endif

/*
**	The timer extension will have an array of structures with the
**	following elements:
**			Available	- True if available
**			Time Value	- Non Zero if active
**			SemID		- Semaphore to post
**			pStatus		- Pointer to a Status Varaible
**
*/
typedef	struct {
	unsigned short		avail;
	unsigned short		ticks;
	SEM_ID			semid;
	unsigned short		*status;
		} 	TIMER;

/* task definitions */

#define 	GENTMR_STACK		2000   /* Stack size              */
#define		GENTMR_PRIORITY		151    /* default proirity        */
#define		GENTMR_TASK_OPTIONS	8      /* Floating point	  */

#define	NUM_TIMERS		16

TIMER		timers[NUM_TIMERS];

char	*timername[] = {  "GEN Timers" };

/*
**	Routine to initialize timer array to available
**
*/
void timer_init ()

    {

	unsigned short	id;

	for (id=0; id < NUM_TIMERS; id++)	{
		timers[id].avail = TRUE;
	}

	logMsg(" Timers Initialized \n", 0,0,0,0,0,0);
    }

/*
**	Routine to get a timer id for an available timer
**		returns timer id or (-1) if none available.
**
*/
int gettimer ()

    {

	unsigned short	id;

	for (id=0; id<NUM_TIMERS; id++)	{
	    if (timers[id].avail) {
		timers[id].avail = FALSE;
		return (id);
	    }
	}

	return (-1);
    }

/*
**	Routine to return a timer to available
**
*/
void return_timer (unsigned short id)

    {

	timers[id].avail = TRUE;
	timers[id].ticks = 0;

    }

/*
**	Routine to stop a timer
**
*/
void stop_timer (unsigned short id)

    {

	timers[id].ticks = 0;

    }


/*
**	Routine to start a timer
**
*/
void start_timer ( unsigned short id, unsigned short ticks,
	      SEM_ID *psem, unsigned short *pvalue)
    {


	timers[id].ticks = 0;
	timers[id].semid = *psem;
	timers[id].status = pvalue;
	timers[id].ticks = ticks;

    }
/*
**	Routine to restart a timer
**
*/
void restart_timer ( unsigned short id, unsigned short ticks) {





	timers[id].ticks = ticks;

    }

/*
**	Routine to process ticks
**
*/
void timer_tick ()

    {

	unsigned short	id;



#ifndef	TEST
	timer_init();
	for(;;) {
	taskDelay(2);
#endif

	    for (id=0; id<NUM_TIMERS; id++)	{
		if (!timers[id].avail) {
		    if (timers[id].ticks != 0) {
			timers[id].ticks--;
			if (timers[id].ticks == 0) {
/*			    *(timers[id].status) = IO_TIMEOUT;	*/
			    semGive(timers[id].semid);
			}
		    }
		}
	    }
#ifndef	TEST
	}
#endif
    }


/*
** start_gentimers
**
**	Routine to start timer task
**
*/
int start_gentimers()
{
#ifndef TEST
	taskSpawn(*timername, GENTMR_PRIORITY, GENTMR_TASK_OPTIONS, GENTMR_STACK, (FUNCPTR)timer_tick, 0,0,0,0,0,0,0,0,0,0);
#endif
	return(1);

}
