/*
  Main control structure for the Current Trend DPA (ctr:) along with some
  other stuff.

  GCT 15-Mar-1996

*/
#include <stdio.h>
#include <signal.h>
#include <string.h>
#include <sys/time.h>
#include <sys/stat.h>
#ifdef SOLARIS
#    include <sys/statvfs.h>
#else
#    include <sys/vfs.h>
#endif

#include "dbDefs.h"
#include "dataTypes.h"
#include "DBDefines.h"
#include "DBProto.h"
#include "cadef.h"
#include "avl.h"
#include "alarm.h"
#include "dpa.h"
#include "msgMon.h"


extern AVL_TREE *dskTree;

typedef enum {DSK_FILE,DSK_VOL} PATH_TYPE;
/*
  Structure for file/volume names and handles
*/
typedef struct
{
  char  dskPath[MAXPATHLEN];	/* file name or file system */
  PATH_TYPE  dskPathType;	/* file or volume */
  void  *dskDpaHandle;		/* handle for DPA/CA */
  void  *dskAlarmHandle;	/* handle for alarm messages */
  void  *dskLabelHandle;	/* handle for file label string */
  double  dskSize;		/* %full for DSK_VOL or file size for DSK_FILE */
  double  dskOldSize;		/* used to compare with new size for throttling */
  double  dskDispLow;
  double  dskDispHigh;
  double  dskHighHigh;
  double  dskHigh;
  double  dskLow;
  double  dskLowLow;
  short   dskHighHighSevr;
  short   dskHighSevr;
  short   dskLowSevr;
  short   dskLowLowSevr;
} DSK_ENTRY,*DSK_ENTRY_PTR;
#define DSK_ENTRY_SIZE sizeof(DSK_ENTRY)
/*
  prototypes for dsk functions
*/
void  dskOpen(char *,void *);
void  dskRead(void *);
void  dskClose(void *);
void  sigHandler(int);
int   dskEntryCompare(void *, void *);
void  dskItemSize(DSK_ENTRY_PTR);	/* get size of item in a system independant way */
void  dskDisplay(void *,void *);	/* send size data to CA and DM */
/*
  defines
*/
#define  LOG_OPTIONS (LOG_ALERT|LOG_LOCAL1)
#define  ALWAYS_MASTER 1
#define  DB_PATH "/tis4000db"
#define  ERR_LOG_NAME "dsk"
#define  DSK_APP_NAME "dsk"
