#include <in.h>
#include "dsk.h"
/*
  Called from hsrvTask when a graphic wants to access this point. Store the
  user data associated with the handle, which could be a file name or a disk
  volume, in the tree along with the handle. Also save the initial size/%full
  and the item type.
*/ 
void dskOpen(char *name,void *handle)
{
  char *path,*p;
  DSK_ENTRY entry,*pEntry,*p1;
  struct stat statbuff;
  int st;
  char	*app,*field,*pv;

  app = (char *)strtok(name,":");
  pv = (char *)strtok(NULL,".");
  field = (char *)strtok(NULL,"\0");
  if(field == 0) field = "VAL";
  path = (char *)dpaGetUserData(handle,0);	       	/* then get a pointer to the user data */
  p = strchr(path,' ');					/* drop trailing spaces */
  if(p) *p = 0;
  strcpy(&entry.dskPath[0],path);
  p1 = avl_findsym(dskTree,&entry);
  if(p1 != NULL)
    {
      pEntry = p1;
    }
  else
    {
      if(!(pEntry = avl_newnode(DSK_ENTRY_SIZE)))
	{
	  tisSysLog (0,0,"No memory for tree insert...%s",path);
	  return;
	}
      avl_insert(dskTree,pEntry);
      strcpy(&pEntry->dskPath[0],path);
      pEntry->dskAlarmHandle = handle;
    }
  if(!strcmp(field,"VAL"))
    {
      dpaGetAlarmAttr(handle,&pEntry->dskHighHigh,
		      &pEntry->dskHigh,
		      &pEntry->dskLow,
		      &pEntry->dskLowLow,
		      &pEntry->dskHighHighSevr,
		      &pEntry->dskHighSevr,
		      &pEntry->dskLowSevr,
		      &pEntry->dskLowLowSevr);
      if((st = stat(&pEntry->dskPath[0],&statbuff)) == 0)
	{
	  if(S_ISDIR(statbuff.st_mode))
	    pEntry->dskPathType = DSK_VOL;
	  if(S_ISREG(statbuff.st_mode))
	    pEntry->dskPathType = DSK_FILE;
	  dskItemSize(pEntry);
	  pEntry->dskOldSize = -1.0;
	}
      pEntry->dskDpaHandle = (void *)dpaSetUserField(handle,"VAL",sizeof(double),AGNT_DOUBLE,1,0,0,0,&pEntry->dskSize);
    }
  else if(!strcmp(field,"USER"))
    {
      pEntry->dskLabelHandle = (void *)dpaSetUserField(handle,"USER",strlen(&pEntry->dskPath[0])+1,AGNT_STRING,1,0,0,0,&pEntry->dskPath[0]);
    }
}
void dskRead(void *handle)
{
  dpaFieldResponse(handle);
}
