/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <hsmain.h>
int hsInitNetwork(void)			/* initialize network stuff */
{
int	optval = 1;
struct sockaddr_in setAddr;
/*
	Create TCP socket on which to listen for IOC messages
*/
if((hsListenSocket = socket(AF_INET,SOCK_STREAM,0)) < 0)
  return(-1);

if((setsockopt(hsListenSocket,SOL_SOCKET,SO_REUSEADDR,(caddr_t)&optval,sizeof(optval))) < 0)
  return(-1);
setAddr.sin_family	= AF_INET;
setAddr.sin_addr.s_addr	= htonl(INADDR_ANY);
setAddr.sin_port	= htons(HSYNC_UDP_PORT);
while(bind(hsListenSocket, (struct sockaddr *) &setAddr, sizeof(setAddr)) < 0)
  sleep(5);
if(listen(hsListenSocket,10) < 0)
  return(-1);
if(hsListenSocket > fdInfo.maxFd) fdInfo.maxFd = hsListenSocket;
FD_SET(hsListenSocket,&fdInfo.myFds);
return(1);
}
/*
  GCT 14-Nov-1996
  This is NOT a tree any more. Also host name are specfied on the command line.
  */
int hsInitializeHosts(HOST_NODE node[],int num)
{
char	hostName[MAXHOSTNAMELEN];
struct hostent	*ent;
int    hAddr,myAddr;
int i;

myAddr = 0;
gethostname(hostName,MAXHOSTNAMELEN);		       	/* get my network name */
if(ent = gethostbyname(hostName))		       	/* get my INET address also */
  myAddr = ntohl(*(long *)*ent -> h_addr_list);
for(i=0;i<num;i++)
  {
    if(ent = gethostbyname(node[i].hostName))	       	/* get INET address for this IOC */
      hAddr = ntohl(*(long *)*ent -> h_addr_list);
    else
      hAddr = 0;
    if(myAddr != hAddr)
      {					       	/* skip if it's me ! */
	VERBOSE(V_DEBUG)(0,0,"Found host %s",node[i].hostName);
	node[i].hostState = HOST_NONET;       	/* No network connection for now */
	node[i].hostFD = -1;		       	/* Not connected yet */
	node[i].hostCharCount = 0;	       	/* nothing in buffer yet */
	node[i].hostNextChar = 0;	        /* start of buffer */
	node[i].hostAddr = hAddr;             	/* used to talk to other hosts */
      }
  }
}

int hsBuildFileTree(AVL_TREE *tree)       	/* read file list file...add to tree */
{
  char		name[MAXPATHLEN];
  FILE		*fp;
  FILE_NODE	*pFn,*p1;
  struct stat	stBuff;

  if((fp = fopen(HSYNC_FILE_LIST,"r")) != 0)	/* open source file */
    {
      while(fgets(name,MAXPATHLEN,fp) != NULL)
	{
	  name[strlen(name)-1] = 0;	       	/* drop newline */
	  if(name[0] == '#')			/* this is a 'coment' line so skip to next line */
	    continue;
	  pFn = avl_newnode(FILE_NODE_SIZE);	/* create new node */
	  strcpy(pFn->fileName,name);		/* put in node */
	  if((p1 = avl_insert(tree,pFn)) != NULL)
	    {
	      avl_freenode(pFn);
	      p1->fileStatus = FILE_VALID;
	    }
	  else
	    {
	      pFn->fileRemoteHost[0] = 0;	/* no HOST yet */
	      pFn->fileRecentHost = 0;
	      pFn->fileLocalTime = 0;
	      if(stat(pFn->fileName,&stBuff) != -1)	/* fill in local file time */
		{
		  pFn->fileLocalTime = stBuff.st_mtime;
		}
	      pFn->fileStatus = FILE_VALID;	/* OK to check */
	      sendBuffSize += (sizeof(short) + sizeof(INFO_MSG) + strlen(pFn->fileName)+1);
	    }
	}
    }
  else
    {
      return(-1);
    }
}
