/*errPrint.c,v 1.1.1.1 1999/08/03 14:43:07 tis4000 Exp */

/* errPrint.c */
/* share/src/db  @(#)errPrint.c	1.2     6/7/91 */
/*
 *      Author:          Bob Zieman
 *      Date:            6-1-91
 *
 *      Experimental Physics and Industrial Control System (EPICS)
 *
 *      Copyright 1991, the Regents of the University of California,
 *      and the University of Chicago Board of Governors.
 *
 *      This software was produced under  U.S. Government contracts:
 *      (W-7405-ENG-36) at the Los Alamos National Laboratory,
 *      and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *      Initial development by:
 *              The Controls and Automation Group (AT-8)
 *              Ground Test Accelerator
 *              Accelerator Technology Division
 *              Los Alamos National Laboratory
 *
 *      Co-developed with
 *              The Controls and Computing Group
 *              Accelerator Systems Division
 *              Advanced Photon Source
 *              Argonne National Laboratory
 *
 * Modification Log:
 * -----------------
 * .01  mm-dd-yy        iii     Comment
 */
/* errPrint.c - print error symbol */
#ifdef vxWorks
#include <vxWorks.h>
#include <types.h>
#include <errnoLib.h>
#include <stdio.h>
#include <logLib.h>
#else
#include <stdio.h>
extern int errno;
#endif vxWorks

#include <error.h>

int errPrint(status)
    long status;
{
	char name[80];
	long value;
	int rtnval;

	value = (status? status : MYERRNO );
	if (!value)
	    return(0);
	if ( status < 0 )
		rtnval = status;
	else
		rtnval = errSymFind(value,name);

	if(rtnval) {
#ifdef vxWorks
		logMsg("Error status =0x%8lx not in symbol table\n",status,0,0,0,0,0);
#else
		printf("Error status =0x%8lx not in symbol table\n",status);
#endif vxWorks
		return(-1);
	}
	else {
#ifdef vxWorks
		logMsg("Error Message: %s\n", (int)name,0,0,0,0,0);
#else
		printf("Error Message: %s\n",name);
#endif vxWorks
		return(0);
	}
}
