/*errSymTbl.c,v 1.1.1.1 1999/08/03 14:43:12 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/* status code symbol table */

/* CREATED BY makeStatTbl
 *       FROM /tis/guepics/epics/share/src/libUnix
 *         ON Mon Jan 17 10:17:02 EST 1994
 */

#include "errMdef.h"
#include "error.h"


#define S_arAcc_OK		(M_arAcc|0| 0<<1) /* success */
#define S_arAcc_noMem		(M_arAcc|1| 1<<1) /* couldn't malloc memory */
#define S_arAcc_chanNotFound	(M_arAcc|1| 2<<1) /* couldn't find channel */
#define S_arAcc_ERROR		(M_arAcc|1| 3<<1) /* other error */
#define S_db_notFound 	(M_dbAccess| 1) /*Process Variable Not Found*/
#define S_db_badDbrtype	(M_dbAccess| 3) /*Illegal Database Request Type*/
#define S_db_noMod 	(M_dbAccess| 5) /*Attempt to modify noMod field*/
#define S_db_badLset 	(M_dbAccess| 7) /*Illegal Lock Set*/
#define S_db_precision 	(M_dbAccess| 9) /*get precision failed */
#define S_db_onlyOne 	(M_dbAccess|11) /*Only one element allowed*/
#define S_db_badChoice 	(M_dbAccess|13) /*Illegal choice*/
#define S_db_badField 	(M_dbAccess|15) /*Illegal field value*/
#define S_db_lsetLogic 	(M_dbAccess|17) /*Logic error generating lock sets*/
#define S_db_noRSET 	(M_dbAccess|31) /*missing record support entry table*/
#define S_db_noSupport 	(M_dbAccess|33) /*RSET routine not defined*/
#define S_db_BadSub 	(M_dbAccess|35) /*Subroutine not found*/
#define S_db_noRecType	(M_dbAccess|37) /* can't find record type */
#define S_rectype_noRecs     (M_recType| 3) /*No record types are defined*/
#define S_record_noRecords   (M_record| 1) /*No records */
#define S_dev_noDevSup   (M_devSup| 1) /*SDR_DEVSUP: Device support missing*/
#define S_dev_noDSET     (M_devSup| 3) /*Missing device support entry table*/
#define S_dev_missingSup (M_devSup| 5) /*Missing device support routine*/
#define S_dev_badInpType (M_devSup| 7) /*Bad INP link type*/
#define S_dev_badOutType (M_devSup| 9) /*Bad OUT link type*/
#define S_drv_noDrvSup   (M_drvSup| 1) /*SDR_DRVSUP: Driver support missing*/
#define S_drv_noDrvet    (M_drvSup| 3) /*Missing driver support entry table*/
#define S_rec_noRSET     (M_recSup| 1) /*Missing record support entry table*/
#define S_rec_Alloc      (M_recSup| 3) /* failed m,c alloc */
#define S_rec_dbName     (M_recSup| 5) /* dbNameToAddr failed */
#define S_sdr_notLoaded (M_sdr| 1) /*dbRecType.sdr not loaded*/
#define S_sdr_noOpen	(M_sdr|	3) /*Can't open file*/
#define S_sdr_noRead	(M_sdr| 5) /*read failure*/
#define S_sdr_noMagic	(M_sdr| 7) /*wrong magic number*/
#define S_sdr_noRecDef	(M_sdr| 9) /*undefined record type*/
#define S_sdr_noAlloc	(M_sdr|11) /*malloc error*/
#define S_sdr_noReplace (M_sdr|13) /*Can't replace loaded SDR file*/
#define S_sdr_seqLoad   (M_sdr|15) /*dbRecType.sdr not first*/
#define S_syd_OK		(M_syd|0| 0<<1) /* success */
#define S_syd_noMem		(M_syd|1| 1<<1) /* couldn't malloc memory */
#define S_syd_chanNotFound	(M_syd|1| 2<<1) /* couldn't find channel */
#define S_syd_partial		(M_syd|1| 3<<1) /* partial retrieval set */
#define S_syd_EOF		(M_syd|1| 4<<1) /* end of file */
#define S_syd_ERROR		(M_syd|1| 5<<1) /* other error */
#define S_syd_noDataNow		(M_syd|1| 6<<1) /* no data available now */
#define S_syd_chanNotConn	(M_syd|1| 7<<1) /* chan not connected to CA */
#define S_tank_StTbl_Err         (M_tank | 1)   /* no access to strapping_table */
#define S_tank_TankValve_Err     (M_tank | 3)	/* err defining dbAddr for a tank valve */
#define S_tank_APITbl_Err        (M_tank | 5)   /* no access to API table */
#define S_tank_ROL_Err           (M_tank | 7)   /* unknown ROL value */
#define S_tank_Line_Err          (M_tank | 9)   /* illegal line mode configuration */
#define S_tank_ValveFault        (M_tank | 11)  /* mbbi fault pv returns fault for valve */
#define S_tank_PotDropReady      (M_tank | 13)  /* pot has dropped ready state */
#define S_tank_TankLevel_Err     (M_tank | 15)  /* failed to get level from levelpv */
#define S_ts_OK		     (M_ts|0| 0<<1) /* success */
#define S_ts_sysTimeError    (M_ts|1| 1<<1) /* error getting system time */
#define S_ts_badTextCode     (M_ts|1| 2<<1) /* invalid TS_TEXT_xxx code */
#define S_ts_inputTextError  (M_ts|1| 3<<1) /* error in text date or time */
#define S_ts_timeSkippedDST  (M_ts|1| 4<<1) /* time skipped on switch to DST */


LOCAL ERRSYMBOL symbols[] =
    {
    {" success ", (long) S_arAcc_OK},
    {" couldn't malloc memory ", (long) S_arAcc_noMem},
    {" couldn't find channel ", (long) S_arAcc_chanNotFound},
    {" other error ", (long) S_arAcc_ERROR},
    {"Process Variable Not Found", (long) S_db_notFound},
    {"Illegal Database Request Type", (long) S_db_badDbrtype},
    {"Attempt to modify noMod field", (long) S_db_noMod},
    {"Illegal Lock Set", (long) S_db_badLset},
    {"get precision failed ", (long) S_db_precision},
    {"Only one element allowed", (long) S_db_onlyOne},
    {"Illegal choice", (long) S_db_badChoice},
    {"Illegal field value", (long) S_db_badField},
    {"Logic error generating lock sets", (long) S_db_lsetLogic},
    {"missing record support entry table", (long) S_db_noRSET},
    {"RSET routine not defined", (long) S_db_noSupport},
    {"Subroutine not found", (long) S_db_BadSub},
    {" can't find record type ", (long) S_db_noRecType},
    {"No record types are defined", (long) S_rectype_noRecs},
    {"No records ", (long) S_record_noRecords},
    {"SDR_DEVSUP: Device support missing", (long) S_dev_noDevSup},
    {"Missing device support entry table", (long) S_dev_noDSET},
    {"Missing device support routine", (long) S_dev_missingSup},
    {"Bad INP link type", (long) S_dev_badInpType},
    {"Bad OUT link type", (long) S_dev_badOutType},
    {"SDR_DRVSUP: Driver support missing", (long) S_drv_noDrvSup},
    {"Missing driver support entry table", (long) S_drv_noDrvet},
    {"Missing record support entry table", (long) S_rec_noRSET},
    {" failed m,c alloc ", (long) S_rec_Alloc},
    {" dbNameToAddr failed ", (long) S_rec_dbName},
    {"dbRecType.sdr not loaded", (long) S_sdr_notLoaded},
    {"Can't open file", (long) S_sdr_noOpen},
    {"read failure", (long) S_sdr_noRead},
    {"wrong magic number", (long) S_sdr_noMagic},
    {"undefined record type", (long) S_sdr_noRecDef},
    {"malloc error", (long) S_sdr_noAlloc},
    {"Can't replace loaded SDR file", (long) S_sdr_noReplace},
    {"dbRecType.sdr not first", (long) S_sdr_seqLoad},
    {" success ", (long) S_syd_OK},
    {" couldn't malloc memory ", (long) S_syd_noMem},
    {" couldn't find channel ", (long) S_syd_chanNotFound},
    {" partial retrieval set ", (long) S_syd_partial},
    {" end of file ", (long) S_syd_EOF},
    {" other error ", (long) S_syd_ERROR},
    {" no data available now ", (long) S_syd_noDataNow},
    {" chan not connected to CA ", (long) S_syd_chanNotConn},
    {" no access to strapping_table ", (long) S_tank_StTbl_Err},
    {" err defining dbAddr for a tank valve ", (long) S_tank_TankValve_Err},
    {" no access to API table ", (long) S_tank_APITbl_Err},
    {" unknown ROL value ", (long) S_tank_ROL_Err},
    {" illegal line mode configuration ", (long) S_tank_Line_Err},
    {" mbbi fault pv returns fault for valve ", (long) S_tank_ValveFault},
    {" pot has dropped ready state ", (long) S_tank_PotDropReady},
    {" failed to get level from levelpv ", (long) S_tank_TankLevel_Err},
    {" success ", (long) S_ts_OK},
    {" error getting system time ", (long) S_ts_sysTimeError},
    {" invalid TS_TEXT_xxx code ", (long) S_ts_badTextCode},
    {" error in text date or time ", (long) S_ts_inputTextError},
    {" time skipped on switch to DST ", (long) S_ts_timeSkippedDST},
    };

LOCAL ERRSYMTAB symTbl =
    {
    NELEMENTS (symbols),	/* current number of symbols in table */
    symbols,			/* ptr to symbol array */
    };

ERRSYMTAB_ID errSymTbl = &symTbl;
