/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


static char masker[] =
"'Twas brillig and the slithy toves \
Did gyre and gimble in the wabe. \
All mimsy were the borogoves \
And the mome raths outgabe. \
\"Beware the Jabberwock, my son! \
The jaws that bite, the claws that catch! \
Beware the jubjub bird and shun \
the frumious bandersnatch!";

static void byteShift(unsigned char *block, int blockLen);
void code(unsigned char *block, int blockLen, unsigned char *key, int keyLen);

void code(unsigned char *block, int blockLen, unsigned char *key, int keyLen)
{
    int nshifts = blockLen << 3;
    int	i;

    while (nshifts--)
	{
	byteShift(block, blockLen);
	byteShift(key, keyLen);
	if (key[keyLen - 1] & 1)
	    for (i = 0; i < blockLen; i++)
		block[i] ^= masker[i];
	}
}

static void byteShift(unsigned char *block, int blockLen)
{
    int		i;
    int		carry;
    int		prevCarry = 0;

    for (i = 0; i < blockLen; i++)
	{
	carry = block[i] & 1;
	block[i] >>= 1;
	if (prevCarry)
	    block[i] |= 0x80;
	prevCarry = carry;
	}

    if (prevCarry)
	block[0] |= 0x80;
}
