/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/

/* dBASE (codeBase) related functions */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include <d4all.h>
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#include "OperPrvDefs.h"
#include "msgMon.h"
#include "resolveLinks.h"

#define	 SECS_PER_HOUR	3600
C4CODE	cb;

D4DATA  *source;
F4FIELD *SourceOperatorFld;
F4FIELD *SourceDateFld;
F4FIELD *SourceTimeFld;
F4FIELD *SourceDescFld;
F4FIELD *SourcePointFld;
F4FIELD *SourceFieldFld;
F4FIELD *SourceOldValueFld;
F4FIELD *SourceNewValueFld;
F4FIELD *SourcePrintFld;
F4FIELD *SourceUnixTimeFld;

D4DATA  *destination;
F4FIELD *DestOperatorFld;
F4FIELD *DestDateFld;
F4FIELD *DestTimeFld;
F4FIELD *DestDescFld;
F4FIELD *DestPointFld;
F4FIELD *DestFieldFld;
F4FIELD *DestOldValueFld;
F4FIELD *DestNewValueFld;
F4FIELD *DestPrintFld;
F4FIELD *DestUnixTimeFld;

char	dbError [100];

void	copyFields (void);

/*----------*/
void initCodebase ()

    {
	d4init (&cb);
#if defined(USECB63) || defined(WIN32)
	cb.errOpen = 0;
	cb.errCreate = 0;
        cb.errTagName = 0;
        cb.errFieldName = 0;
        cb.errGo = 0;
        cb.errSkip = 0;
#else
	cb.open_error = 0;
	cb.create_error = 0;
        cb.tag_name_error = 0;
        cb.field_name_error = 0;
        cb.go_error = 0;
        cb.skip_error = 0;
#endif USECB63
    }
/*----------*/
D4DATA	*createDestOpTrak(file)

char		*file;
{
	return d4create(&cb, file, TrakFlds, TrakTag);
}

/*----------*/
	/* Open the optrak database and interesting fields */

D4DATA  *openSourceOpTrak (file)

char		*file;
    {

	char	pathName [200];
	D4DATA  *data;

	resolveLinks (file, pathName);
	data = d4open (&cb, pathName);	
	if (data == NULL)
	    return 0;

	/* Open all the fields */

	SourceOperatorFld = d4field (data, "OPERATOR");
	SourceDateFld = d4field (data, "TRK_DATE");
	SourceTimeFld = d4field (data, "TRK_TIME");
	SourceDescFld = d4field (data, "DESCRIPTOR");
	SourcePointFld = d4field (data, "POINTNAME");
	SourceFieldFld = d4field (data, "FIELDNAME");
	SourceOldValueFld = d4field (data, "OLD_VALUE");
	SourceNewValueFld = d4field (data, "NEW_VALUE");
	SourcePrintFld = d4field (data, "PRINT_FLAG");
	SourceUnixTimeFld = d4field (data, "UNIX_TIME");

	d4tag_select (data, d4tag(data, "UNIXTIME"));
	d4top (data);
	d4unlock_all (data);

	return data;

    }
/*--------------------*/
D4DATA	*openDestOpTrak (file)

char		*file;
    {

	char	pathName [200];
	D4DATA  *data;

	resolveLinks (file, pathName);
	data = d4open (&cb, pathName);	
	if (data == NULL)
	    return 0;

	/* Open all the fields */

	DestOperatorFld = d4field (data, "OPERATOR");
	DestDateFld = d4field (data, "TRK_DATE");
	DestTimeFld = d4field (data, "TRK_TIME");
	DestDescFld = d4field (data, "DESCRIPTOR");
	DestPointFld = d4field (data, "POINTNAME");
	DestFieldFld = d4field (data, "FIELDNAME");
	DestOldValueFld = d4field (data, "OLD_VALUE");
	DestNewValueFld = d4field (data, "NEW_VALUE");
	DestPrintFld = d4field (data, "PRINT_FLAG");
	DestUnixTimeFld = d4field (data, "UNIX_TIME");

	d4tag_select (data, d4tag(data, "UNIXTIME"));
	d4top (data);
	d4unlock_all (data);

	return data;

    }
/*--------------*/
void closeTrak (data)	/* Close Trak database and perform any cleanup */

    D4DATA	*data;

    {
    if (data) {
	d4unlock_all(data);
	d4close (data);
    }

    }

/*----------*/
void UpdateTrak (data)
D4DATA		*data;

    {
	d4unlock_all (data);
	d4flush_all (data);
#ifndef CB51
	data->file_lock = 1;		/* to force d4update_header() to write the num_recs field */
	d4update_header (data, 1, 1); 
	data->file_lock = 0;	/* to force d4unlock() to write the num_recs field */
#endif
	d4unlock_all (data);
    }

/*---------------*/
void	copyFields()

{
	f4assign (DestOperatorFld, f4str (SourceOperatorFld));
	f4assign (DestDateFld, f4str (SourceDateFld));
	f4assign (DestTimeFld, f4str (SourceTimeFld));
	f4assign (DestDescFld, f4str (SourceDescFld));
	f4assign (DestPointFld, f4str (SourcePointFld));
	f4assign (DestFieldFld, f4str (SourceFieldFld));
	f4assign (DestOldValueFld, f4str (SourceOldValueFld));
	f4assign (DestNewValueFld, f4str (SourceNewValueFld));
	f4assign (DestPrintFld, f4str (SourcePrintFld));
	f4assign (DestUnixTimeFld, f4str (SourceUnixTimeFld));
    }

/*---------------*/
int	FindRecord(source, destination)

D4DATA		*source, *destination;
{

char   source_op[31], source_pt[29], source_fld[5];
char   dest_op[31], dest_date[9], dest_time[9], tag_string[20], dest_pt[29], dest_fld[5];
long	srctime, dsttime;

	/* seek to the destination for the source unixtime */

	srctime = f4long (d4field(source, "UNIX_TIME"));
	memset(tag_string, 0, sizeof tag_string);
	sprintf(tag_string, "%10.10d", srctime);

        memset( source_op, 0, sizeof source_op);
        strcpy( source_op, f4str(d4field(source, "OPERATOR")));

        memset( source_pt, 0, sizeof source_pt);
        strcpy( source_pt, f4str(d4field(source, "POINTNAME")));

        memset( source_fld, 0, sizeof source_fld);
        strcpy( source_fld, f4str(d4field(source, "FIELDNAME")));

	d4unlock_all(source);

	if ( d4seek( destination, tag_string ) == 0) {
	
	   memset( dest_date, 0, sizeof dest_date);
	   strcpy( dest_date, f4str(d4field(destination, "TRK_DATE")));

	   memset( dest_time, 0, sizeof dest_time);
	   strcpy( dest_time, f4str(d4field(destination, "TRK_TIME")));

           memset( dest_op, 0, sizeof dest_op);
           strcpy( dest_op, f4str(d4field(destination, "OPERATOR")));

           memset( dest_pt, 0, sizeof dest_pt);
           strcpy( dest_pt, f4str(d4field(destination, "POINTNAME")));

           memset( dest_fld, 0, sizeof dest_fld);
           strcpy( dest_fld, f4str(d4field(destination, "FIELDNAME")));

	   dsttime = f4long (d4field(destination, "UNIX_TIME"));

	   d4unlock_all(destination);

	   while ( srctime == dsttime ){

	      if ( (strcmp(source_op, dest_op) == 0) &&
		   (strcmp(source_pt, dest_pt) == 0) &&
		   (strcmp(source_fld, dest_fld) == 0)) {

	          /* a record is considered to match if the date, time,
	             operator, pointname, and field are the same. */

		  d4unlock_all(source);
		  d4unlock_all(destination);

	          return 1;
             }
             else {
	           d4skip(destination, 1);

	           memset( dest_date, 0, sizeof dest_date);
	           strcpy( dest_date, f4str(d4field(destination, "TRK_DATE")));

	           memset( dest_time, 0, sizeof dest_time);
	           strcpy( dest_time, f4str(d4field(destination, "TRK_TIME")));

                   memset( dest_op, 0, sizeof dest_op);
                   strcpy( dest_op, f4str(d4field(destination, "OPERATOR")));

           	   memset( dest_pt, 0, sizeof dest_pt);
           	   strcpy( dest_pt, f4str(d4field(destination, "POINTNAME")));

           	   memset( dest_fld, 0, sizeof dest_fld);
           	   strcpy( dest_fld, f4str(d4field(destination, "FIELDNAME")));

		   dsttime = f4long (d4field(destination, "UNIX_TIME"));

		   d4unlock_all(source);
		   d4unlock_all(destination);
             }
	  }
       }
       d4unlock_all(source);
       d4unlock_all(destination);

       return 0;
}
/*---------------------*/
int	getTag(data)

D4DATA	*data;
{
	if (data == NULL)
	    return 1;

	if (!d4tag(data,"UNIXTIME"))
		return 0;
	else {
		d4tag_select(data, d4tag(data, "UNIXTIME"));
		d4top(data);
		d4unlock_all(data);
		return 1;
      	}
}
/*---------------------*/
void 	AddToList( destination )
D4DATA		*destination;   /* Codebase file descriptors */
{

	d4top(destination);

	if (d4deleted(destination)) {
		copyFields();
		d4recall(destination);
	}
	else {
		d4append_start( destination, 0 );	/* '0' => no memo fields */
		d4blank( destination );

		copyFields();

		d4append( destination );
		d4flush_all( destination );
#ifndef CB51
		d4update_header( destination, 1, 1 );
#endif
	}
	d4unlock_all(destination);
	return;
}
/*-----------------------*/
long	getCutOffTime( cutOff )
int	cutOff;
{

time_t		CurEpoch;

	/* Get the current time, subtract the number of hours, and generate
	   the cutoff time for archiving. */

	time( &CurEpoch );
	return CurEpoch - ( cutOff * SECS_PER_HOUR );
}
/**********************************************************************/

void	openDataFiles(sourceFile, destinationFile, enableArchive)

char	*sourceFile;
char	*destinationFile;
int	enableArchive;

{
	char		message[200];

	initCodebase();

	if (! (source = openSourceOpTrak(sourceFile)) ) {/* Handles opening of index file as well */
	     sprintf(message, "OP_TRAK : Can not open %s\n", sourceFile);
	     tisSysLog (0, 0, message);
	     exit( 1 );
        }

	if (enableArchive) {
		if( !( destination = openDestOpTrak(destinationFile)))  {	/* Handles opening of index file as well */
			/* Archive snapshot records file must be created. */
#if defined(USECB63) || defined(WIN32)
			cb.errorCode = 0;		/* Clear out the open error */
#else
			cb.error_code = 0;		/* Clear out the open error */
#endif USECB63
			if (! (destination = d4create( &cb, destinationFile, TrakFlds, TrakTag )) ){
		       		sprintf(message, "OP_TRAK : Unable to create destination file %s\n", destinationFile);
	   	       		tisSysLog (0, 0, message);
		       		closeTrak(source);
		       		exit( 1 );
                	}
			closeTrak(destination);
			destination = openDestOpTrak(destinationFile);  /* open fields too */
			e4exit_test( &cb );		/* Make sure it was created okay. */
		}
	}

	if (!getTag (source)) {
	    closeTrak(source);
	    sprintf(message, "OP_TRAK : data file does not contain the correct tag\n");
	    tisSysLog (0, 0, message);
	    exit(1);
        }

	if (enableArchive) {
	    if (!getTag (destination)) {
		closeTrak (destination);
		sprintf(message, "OP_TRAK : data file does not contain the correct tag\n");
	   	tisSysLog (0, 0, message);
		exit(1);
	    }
	}

}
/******************************************************************************/
int CmpRecTime( data, CmpTime )
D4DATA		*data;
long		CmpTime;
{
	if( f4long ( d4field( data, "UNIX_TIME" )) <= CmpTime )
		/* stop time is greater */
		return 1;
	else 
		return 0;
}
