/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* Return the following:
/*		-1 => no arbiter running
/*		0 => slave
/*		1 => master
/*		2 => master with disconnected partner
*/

#include <stdio.h>

#include "msapp.h"
#include "msgMon.h"

main (argc, argv)

    int		argc;
    char	*argv[];

    {

	int	verbose = 0, status, cmd, stat;
	int	myHandle;
	char	appName [50];

	while ((cmd = getopt (argc,argv,"v")) != -1) {
	    switch (cmd) {
		case 'v':
		    verbose = 1;
		    break;
	    }
	}

	/* Connect to the arbiter */

	sprintf (appName, "msArbiterState_%d", getpid ());
	if (!appRegister (appName, &myHandle)) {
	    if (verbose)
		tisSysLog (0,0, "msArbiter not running");
	    exit (-1);
	}

	/* Get the arbiter status */

	appGetStatus (myHandle, &status);
	switch (status) {
	    case SLAVE:
		if (verbose)
		    tisSysLog (0,0, "slave");
		stat = 0;
		break;
	    case MASTER:
		if (verbose)
		    tisSysLog (0,0,"master");
		stat = 1;
		break;
	    case MASTER_NOPARTNER:
		if (verbose)
		    tisSysLog (0,0,"masternp");
		stat = 2;
		break;
	}

	/* Disconnect from the arbiter */

	appUnRegister (&myHandle);

	return stat;

    }

