/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <stdio.h>
#include <signal.h>

#include "msmain.h"

static	void	intHandler ();
static	int	running;

/*----------*/
int main (argc, argv)

    int		argc;
    char	*argv[];

    {

	int	handle, result, state, serNum;
	char	txBuffer [1000], rxBuffer [1000];
	char	hostName [100];
	static char	*msState [] = {"", "SLAVE", "MASTER", "MASTER/NP", "UNKNOWN"};

	result = appRegister (argv [1], &handle);
	if (result != 0)
	    printf ("App %s registered, handle = %d\n", argv [1], handle);
	else {
	    printf ("App register failed\n");
	    exit (-1);
	}

	signal (SIGINT, intHandler);

	gethostname (hostName, sizeof (hostName));

	serNum = 0;
	running = 1;
	while (running) {

	    if (!appGetStatus (handle, &state)) {
		appUnRegister (handle);
		printf ("Arbiter has died.\n");
		exit (-1);
	    }

	    /* Create a message with out app name, host name, and serial number */

	    sprintf (txBuffer, "%s %s %d", argv [1], hostName, serNum++);
	    appSendData (handle, txBuffer, sizeof (txBuffer));
	    printf ("s: %s -- %s\n", txBuffer, msState [state]);

	    while (result = appRecvData (handle, rxBuffer, 1)) {
		if (result == 0) {
		    appUnRegister (handle);
		    printf ("Arbiter has died.\n");
		    exit (-1);
		}
		printf ("r: %s\n", rxBuffer);
	    }
	    sleep (1);
	}

	appUnRegister (handle);


    }

/*----------*/
static void intHandler (sig)

    int		sig;

    {

	running = 0;

    }

