/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#ifndef WIN32
#include <sys/time.h>
#endif WIN32
#include <time.h>

#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#include "mlist.h"
#include "trendDefs.h"
#include "dbRequests.h"
#include "rb.h"

/* Functions defined in this module */

void		rbInit (RingBuf *);
int		rbEmpty (RingBuf *);
int		rbFull (RingBuf *);
int     	rbInsert (RingBuf *, WriteRequest *);
WriteRequest	*rbGet (RingBuf *);
int		rbRemove (RingBuf *);

/*----------*/
void rbInit (rb)

    RingBuf *rb;   

    {

	rb->front = rb->rear = 0;
	memset ((void *)rb, 0, sizeof (RingBuf));

    }

/*----------*/
int rbEmpty (rb)

    RingBuf	*rb;

    {

	return rb->front == rb->rear;

    }

/*----------*/
int rbFull (rb)

    RingBuf	*rb;

    {

	return increment(rb->rear) == rb->front;

    }

/*----------*/
int rbInsert (rb, dat)

    RingBuf		*rb;
    WriteRequest	*dat;

    {

	int	i;

	if (!rbFull (rb)) {
	    i = increment(rb->rear);
	    memcpy (&rb->data [i], dat, sizeof (WriteRequest));
	    rb->rear = i;
	    return 1;
	}
	return 0;

    }

/*----------*/
WriteRequest *rbGet (rb)

    RingBuf	*rb;

    {

	int	i;

	i = increment (rb->front);
	return &rb->data [i];

    }

/*----------*/
int rbRemove (rb)

    RingBuf	*rb;

    {

	rb->front = increment (rb->front);
	return 0;

    }

