/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <time.h>
#include <signal.h>
#include <syslog.h>
#include <assert.h>
#include <sys/ipc.h>
#include <error.h>
#include <cadef.h>
#include <dbDefs.h>
#include <db_access.h>
#include <tsDefs.h>
#include <paramStructs.h>

#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#include "mlist.h"
#include "trendDefs.h"
#include "utils.h"
#include "arSnapRecord.h"
#include "dbase.h"
#include "msgMon.h"

int	myPid;

/*----------*/
int main (argc, argv)

    int		argc;
    char	*argv [];

    {

	PointName	name;
	int		method, interval, archive, records;
	long		size;

	tisOpenLog ("snapSize", 6, 2, NULL, NULL);

	myPid = getpid ();

	initCodebase ();

	openArReduc ();
	    
	size = 0;
	while (getArReducRecord (name, &method, &interval, &archive)) {
	    records = getRecordsPerDay (interval);
	    size += records * sizeof (ArSnapRecord);
	}

	closeArReduc ();
  
	tisSysLog (0,0,"day=%ld, week=%ldk, month=%ldk, year=%ldk\n", 
			size, size/1024 * 7, size/1024 * 30, size/1024 * 365);

    }



