#include "trendDefs.h"

/* Functions defined in this module */

static  void    display (CurrentData *);

int     myPid;

/*----------*/
int main (int argc, char *argv [])

    {

        CurrentData  data;

	myPid = getpid ();

        if (!trendInit ()) {
            printf ("Unable to initialize up-to-date trend access.\n");
	    exit (0);
	}

        /* Insert a few trends to see if the trendProcessor sees them. */
	if(argc <3) 
	{
	    exit(-2);
	}
	trendInsert (argv[1], (int)atoi(argv[2]));
/*	trendInsert ("calc5sec2", TREND_SMP);
	trendInsert ("calc5sec3", TREND_SMP);
	trendInsert ("calc5sec4", TREND_SMP);
	trendInsert ("calc5sec5", TREND_SMP);
*/
/*	trendRemove ("fred", 0);
	trendRemove ("Dougs30s", TREND_MAX);
	trendRemove ("Dougs2s", TREND_AVG);
	trendRemove ("Dougs2s", TREND_AVG);
*/

	for (;;) {
	    if (trendGet (argv[1], (int)atoi(argv[2]), &data)) {
	        display (&data);
	    } else {
	        printf ("No valid data yet!\n");
	    }
	    sleep (1);
	}

	trendTerminate ();

	exit (0);
    }

/*----------*/
static void display (CurrentData *p)

    {

        int    k;

        printf ("\n%s %s %d %d %s %f \'%c\' \'%c\'\n",
                p->pointName,
                int2methodString (p->method),
                p->interval, p->sampleCnt,
                gmTime (p->startTime),
                p->lastValue, p->lastSeverity, p->lastStatus);
        for (k=0 ; k<p->sampleCnt ; k++)
	  {
	    printf ("%02d %10.4f, \'%c\' \'%c\' \'%c\'\n",
		    k,p->value [k], p->quality [k],
		    status2letter (p->status [k]),
		    severity2letter (p->severity [k]));
	  }
    }

