/*
    trendupdatemsgs.h - definitions for the trend update function
    Author: Grant Irani
    Date:   March 21, 1996
*/


#define	    UPDATE_INFO	    1		/* Update information */

/* Note - IOCName will be shotened to a Null terminated string, and data
** will begin immediately after the Null. The array sizes given set the
** maximum size of the message */
typedef struct {
    short   type;	    /* message type */
    short   dataLen;	    /* length of data area (in shorts) */
    long    snapTime;	    /* time of data snapshot */
    short   line;	    /* PLC line number */
    short   address;	    /* PLC address */
    short   data[256];	    /* raw trend data area */
    char    IOCName [IOCNAME_SIZE]; /* IOC name */
} UpdateMsg;

typedef struct {
    short   type;	    /* message type */
    short   value;	    /* response status 0-Unable to save, 1-recorded */
} UpdateRsp;

typedef union {
    UpdateMsg	update;
} UpdateMsgUnion;

typedef union {
    UpdateRsp	updateRsp;
} UpdateRspUnion;

