/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#ifdef	WIN32
#  include <sys/types.h>
#  include <winsock.h>
#  include <time.h>
#else
#  include <sys/time.h>
#  include <sys/socket.h>
#  include <netinet/in.h>
#  ifdef  LINUX
#    include <asm/socket.h>
#    include <netinet/in.h>
#  endif  LINUX
#endif	WIN32

#include <errno.h>

#include "ctype.h"
#include "DBDefines.h"
#include "cadef.h"
#include "msgMon.h"
#include "avmDefs.h"
#include "odssapp.h"
#include "trendDefs.h"
#include "oracleSnap.h"

#ifdef	ORACLESNAP
#include "oracleSnapLib.h"
#else
#include "xbaseSnapLib.h"
#endif	ORACLESNAP
#include "archiveLib.h"

int odssFd;				/* fd for the main class */
int errCode;
char clientBuff[20000];
char xmitBuff[20000];
int clientRev = 0;
int clientBuffIndex = 0;
int clientBuffSize = 0;
int xmitBuffSize = 0;
ODSSCTL *currCtl,*firstCtl;
extern fd_set fdMask;
void addMonitor(ODSSCTL *ctl,ODSS_MONITOR_MSG *odssMonitorMsg);

int appRun(SOCKET fd)
{
  ODSSCTL *cCtl;
  struct timeval maxWait,exitTime,currTime;
#ifdef	WIN32
  time_t    timeNow;
#endif
  int status;
  short msgType;
  ODSS_BUILD_NACK_MSG buildNack;
  ODSS_READ_NACK_MSG readNack;
  ODSS_WRITE_ACK_MSG writeNack;
  odssFd = fd;				/* extract socket from the SERVER structure */
  /*
   * initialize channel access
   */
  if(ca_task_initialize () != AGNT_NORMAL)
    {
      tisSysLog(0,3, "error in channel access init\n");
      errCode = ODSS_ERROR_CA;
      return 0;
    }
#ifdef ORACLESNAP
    if(getenv("ORACLE_HOME") != NULL)
      OpenOracle();					/* start oracle initialization */
#else
	OpenXBase();					/* use XBase (Codebase) */
#endif
  tisSysLog(0,3,"odssServer running\n");
  FD_ZERO(&fdMask);
  while(1)
    {
      maxWait.tv_sec = CA_CHECK_TIME;
      maxWait.tv_usec = 0;
      while((maxWait.tv_sec >= 0) && (maxWait.tv_usec >= 0))
	{
#ifdef	WIN32
	  timeNow = time (0);
	  currTime.tv_sec = timeNow;
	  currTime.tv_usec = 0;
#else
	  gettimeofday(&currTime,0);
#endif	WIN32
	  if(odssFd == INVALID_SOCKET)
	    return(0);
	  FD_ZERO(&fdMask);
	  FD_SET(odssFd, &fdMask);
	  status = select(FD_SETSIZE,&fdMask,0,0,&maxWait);
	  if(status == 0)
	    break;
	  else if(status < 0)
	    {
	      tisSysLog(0,3,"Error from select...%d",status);
	    }
	  /*
	    A socket has something for us to read. Find out which one and
	    read it.
	  */
	  else
	    {
	      if (FD_ISSET(odssFd, &fdMask))
		{
		  if(!handleClientMsgs())		/* Service the client's socket. */
		    return(0);
		}
	    }
#ifdef	WIN32
	  timeNow = time (0);
	  exitTime.tv_sec = timeNow;
	  exitTime.tv_usec = 0;
#else
	  gettimeofday(&exitTime,0);			/* adjust timer */
#endif	WIN32
	  exitTime.tv_sec -= currTime.tv_sec;
	  exitTime.tv_usec -= currTime.tv_usec;
	  if(exitTime.tv_usec < 0)
	    {
	      exitTime.tv_usec += 1000000;
	      exitTime.tv_sec--;
	    }
	  maxWait.tv_sec -= exitTime.tv_sec;
	  maxWait.tv_usec -= exitTime.tv_usec;
	  if(maxWait.tv_usec < 0)
	    {
	      maxWait.tv_usec += 1000000;
	      maxWait.tv_sec--;
	    }
	}/* inner while loop */
      ca_pend_io((float)0.0);			/* allow CA to process */
      flushClient();				/* if anything needs to be sent out then do it here */
      /*
	// check for any timeouts. These could be:
	//
	// 1. Channel build did not succeed. send BUILD_NACK message
	// 2. Read has timed-out send READ_NACK message
	// 3. Write ACK to late
      */
      cCtl = firstCtl;
      while (cCtl)
	{
	  if(cCtl->awaitAck && (time(0) - cCtl->buildAckTimer > CA_ACK_TIME))
	    {
	      buildNack.ODSShandle = htonl(cCtl->handle);
	      msgType = htons(ODSS_BUILD_NACK);
	      writeClient(msgType, (char *) &buildNack, sizeof(ODSS_BUILD_NACK_MSG), NULL, 0);
	      tisSysLog(0,V_INFO,"No response from CA for %08X",buildNack.ODSShandle);
	      cCtl->awaitAck = 0;
	    }
	  if(cCtl->readPending && (time(0) - cCtl->readTimer > cCtl->readTimeout))
	    {
	      readNack.ODSShandle = htonl(cCtl->handle);
	      msgType = htons(ODSS_READ_NACK);
	      writeClient(msgType, (char *) &readNack, sizeof(ODSS_READ_NACK_MSG), NULL, 0);
	      tisSysLog(0,V_INFO,"No response from CA read request for %08X",readNack.ODSShandle);
	      cCtl->readPending = 0;
	    }
	  if(cCtl->writeRdbkPending && (time(0) - cCtl->writeTimer > cCtl->writeRdbkTimeout))
	    {
	      writeNack.ODSShandle = htonl(cCtl->handle);
	      msgType = htons(ODSS_WRITE_NACK);
	      writeNack.status = htons(0);
	      writeClient(msgType, (char *) &writeNack, sizeof(ODSS_WRITE_ACK_MSG), NULL, 0);
	      tisSysLog(0,V_INFO,"No response from CA write request for %08X",writeNack.ODSShandle);
	      cCtl->writeRdbkPending = 0;
	      cCtl->writeRdbkTimeout = 0;
	    }
	  cCtl = cCtl -> nextCtl;
	}
    }/* outer while */
  return 0;
}
int handleClientMsgs()
{
  short msgType;
  ODSS_BOOMERANG_MSG odssBoomerangMsg;
  ODSS_REV_MSG odssRevMsg;
  ODSS_BUILD_MSG odssBuildMsg;
  ODSS_MONITOR_MSG odssMonitorMsg;
  ODSS_READ_MSG	odssReadMsg;
  ODSS_READ_NACK_MSG odssReadNack;
  ODSS_WRITE_MSG odssWriteMsg;
  ODSS_CHAN_CLEAR_MSG odssChanClearMsg;
  ODSS_BUILD_NACK_MSG buildNack;
  ODSS_HIST_READ_MSG odssHistReadMsg;
  ODSS_HIST_DATA_MSG odssHistDataMsg;
  ODSS_WRITE_ACK_MSG writeNack;
  char *reqBuffer;
  char *outputBuff = 0;
  long dbRate;
  char eguTag[32];
  double dispLow;
  double dispHigh;
  int numReturned = 0;
  struct tm *timeCheck;
  char timeString[30];
  ODSSCTL *lookCtl;
  ODSSCTL *prevCtl;
  ODSSCTL *nextCtl;
  int wasDeleted = 0;
  char writeData[1024];
  int typeErr=0;
  char chanName[64];

  if(!fillClientBuffer())
    return(0);
  while(haveCompleteClientMsg())
    {
      readClient((char *) &msgType, sizeof(msgType));	/* Get the message type to see what follows in the stream. */
      msgType = ntohs(msgType);
      switch(msgType)
	{
	case ODSS_BOOMERANG:		/* Boomerang, so he can ping us. Client doesn't have to declare his revision level before using this message. */
	  readClient((char *) &odssBoomerangMsg, sizeof(odssBoomerangMsg));
	  msgType = htons(ODSS_BOOMERANG);
	  if (!writeClient(msgType, (char *) &odssBoomerangMsg, sizeof(odssBoomerangMsg),NULL, 0))
	    {
	      tisSysLog(0,V_INFO,"Can't write boomerang msg... terminating connection.\n",ntohl(odssBoomerangMsg.ODSShandle));
	      closeClientChannels();
#ifdef	WIN32
	      closesocket(odssFd);
#else
	      close (odssFd);
#endif	WIN32
	      odssFd = INVALID_SOCKET;
	    }
	    break;
	case ODSS_REV:			/* User declares his protocol revision level. */
	  readClient((char *) &odssRevMsg, sizeof(odssRevMsg));
	  if(ntohl(odssRevMsg.ODSSRev) != ODSS_CURRENT_REV)
	    {
	      tisSysLog(0,V_INFO,"Unsupported protocol level %d\n",ntohl(odssRevMsg.ODSSRev));
	      msgType = htons(ODSS_REVISION_MISMATCH);
	      writeClient(msgType, (char *) &odssRevMsg, sizeof(ODSS_REV_MSG), NULL, 0);
	      break;
	    }
	  msgType = htons(ODSS_API_OPENED);
	  writeClient(msgType, (char *) &odssRevMsg, sizeof(ODSS_REV_MSG), NULL, 0);
	  clientRev = ntohl(odssRevMsg.ODSSRev);
	  break;
	case ODSS_BUILD:
	  /*
	    Build a channel.
	  */
	  readClient((char *) &odssBuildMsg, sizeof(odssBuildMsg));
	  odssBuildMsg.nameLength = ntohl(odssBuildMsg.nameLength);
	  if((odssBuildMsg.nameLength <= 0) || (odssBuildMsg.nameLength > PVNAME_SZ+FLDNAME_SZ+1))
	    {
	      tisSysLog(0,V_INFO,"Invalid channel name length %d... terminating connection.\n",odssBuildMsg.nameLength);
	      buildNack.ODSShandle = odssBuildMsg.ODSShandle;
	      msgType = htons(ODSS_BUILD_NACK);
	      writeClient(msgType, (char *) &buildNack, sizeof(ODSS_BUILD_NACK_MSG), NULL, 0);
	      break;
	    }
	  /*
	    pad chanName with blanks so we can tell when the name length is wrong.
	    GCT 18-Mar-1998
	  */
	  memset(chanName,' ',63);
	  chanName[63] = 0;
	  readClient(chanName, odssBuildMsg.nameLength);
	  if (!clientRev)
	    continue;
	  /*
	    Compare the length of the string read in by readClient. if nameLength-1 is not EQUAL to
	    strlen(chanName) then announce error and drop socket
	    GCT 18-Mar-1998
	  */
	  if((strlen(chanName) != (size_t)(odssBuildMsg.nameLength-1)))
	    {
	      tisSysLog(0,V_INFO,"Invalid channel name length %d... terminating connection.\n",odssBuildMsg.nameLength);
	      buildNack.ODSShandle = odssBuildMsg.ODSShandle;
	      msgType = htons(ODSS_BUILD_NACK);
	      writeClient(msgType, (char *) &buildNack, sizeof(ODSS_BUILD_NACK_MSG), NULL, 0);
	      break;
	    }
	  /*
	    Allocate a control structure and fill it out.
	  */
	  currCtl = newCtl();
	  currCtl->handle = ntohl(odssBuildMsg.ODSShandle);
	  currCtl->awaitAck = 1;
	  currCtl->nextCtl = firstCtl;
	  currCtl->buildAckTimer = time(0);		/* set timeout for builds. 10 seconds should be enough */
	  firstCtl = currCtl;
	  ca_build_and_connect(chanName, TYPENOTCONN, 0, &(currCtl -> channel), NULL, connectionHandler, currCtl);
	  break;
	case ODSS_MONITOR:
	  /*
	    Establish or clear a monitor.
	  */
	  readClient((char *) &odssMonitorMsg, sizeof(odssMonitorMsg));
	  if (!clientRev)
	    continue;
	  currCtl = findCtl(ntohl(odssMonitorMsg.ODSShandle));
	  if (!currCtl)
	    continue;
	  addMonitor(currCtl,&odssMonitorMsg);
	  break;
	case ODSS_READ:
	  /*
	    Read a channel.
	  */
	  readClient((char *) &odssReadMsg, sizeof(odssReadMsg));
	  if (!clientRev)
	    continue;
	  currCtl = findCtl(ntohl(odssReadMsg.ODSShandle));
	  if (!currCtl)
	    continue;
	  /*
	    Check to see if the point is currently connected.
	  */
	  if (ca_state(currCtl -> channel) != currOpen)
	    {
	      ODSS_READ_DATA_MSG readReply;
	      readReply.ODSShandle = currCtl -> handle;
	      readReply.readState = htons(2);		/* Offline */
	      readReply.dataLength = 0;
	      msgType = htons(ODSS_READ_DATA);
	      writeClient(msgType, (char *) &readReply, sizeof(readReply), NULL, 0);
	      continue;
	    }
	  /*
	    Connected. Issue the read.
	  */
	  odssReadMsg.timeout = ntohs(odssReadMsg.timeout);
	  if (odssReadMsg.timeout <= 0)
	    {
	      tisSysLog(0,V_INFO,"Invalid timeout in ODSS_READ message.\n");
	      odssReadNack.ODSShandle = htonl(currCtl->handle);
	      msgType = htons(ODSS_READ_NACK);
	      writeClient(msgType, (char *) &odssReadNack, sizeof(ODSS_READ_NACK_MSG), NULL, 0);
	      continue;
	    }
	  currCtl->readPending = 1;
	  currCtl->readTimeout = htons(odssReadMsg.timeout);
	  currCtl->readTimer = time(0);
	  ca_array_get_callback(dbf_type_to_DBR_STS(ca_field_type(currCtl -> channel)), 
				ca_element_count(currCtl -> channel), currCtl -> channel, readHandler, currCtl);
	  break;
	case ODSS_WRITE:
	  /*
	    Write a channel.
	  */
	  readClient((char *) &odssWriteMsg, sizeof(odssWriteMsg));
	  odssWriteMsg.dataLength = ntohs(odssWriteMsg.dataLength);
	  odssWriteMsg.dataType = ntohs(odssWriteMsg.dataType);
	  if((odssWriteMsg.dataType < AGNT_STRING) || (odssWriteMsg.dataType >  AGNT_DOUBLE))
	    {
	      tisSysLog(0,V_INFO,"Unknown data type %d in ODSS_WRITE message, terminating connection.\n",odssWriteMsg.dataType);
	      closeClientChannels();
#ifdef	WIN32
	      closesocket(odssFd);
#else
	      close (odssFd);
#endif	WIN32
	      odssFd = INVALID_SOCKET;
	      break;
	    }
	  if (odssWriteMsg.dataLength <= 0)
	    {
	      tisSysLog(0,V_INFO,"Invalid data length %d in ODSS_WRITE message, terminating connection.\n",odssWriteMsg.dataLength);
	      closeClientChannels();
#ifdef	WIN32
	      closesocket(odssFd);
#else
	      close (odssFd);
#endif	WIN32
	      odssFd = INVALID_SOCKET;
	      break;
	    }
	  switch(odssWriteMsg.dataType)
	    {
	    case AGNT_FLOAT:
	      if(odssWriteMsg.dataLength != sizeof(float))
		typeErr = 1;
	      break;
	    case AGNT_DOUBLE:
	      if(odssWriteMsg.dataLength != sizeof(double))
		typeErr = 1;
	      break;
	    case AGNT_SHORT:
	    case AGNT_ENUM:
	      if(odssWriteMsg.dataLength != sizeof(short))
		typeErr = 1;
	      break;
	    case AGNT_LONG:
	      if(odssWriteMsg.dataLength != sizeof(int))
		typeErr = 1;
	      break;
	    case AGNT_CHAR:
	      if(odssWriteMsg.dataLength != sizeof(char))
		typeErr = 1;
	      break;
	    }
	  if(typeErr == 1)
	    {
	      tisSysLog(0,V_INFO,"Invalid data length %d for data type %d, terminating connection.\n",odssWriteMsg.dataType,odssWriteMsg.dataLength);
	      closeClientChannels();
#ifdef	WIN32
	      closesocket(odssFd);
#else
	      close (odssFd);
#endif	WIN32
	      odssFd = INVALID_SOCKET;
	      break;
	    }
	  readClient(writeData, odssWriteMsg.dataLength);
	  if (!clientRev)
	    continue;
	  currCtl = findCtl(ntohl(odssWriteMsg.ODSShandle));
	  if (!currCtl)
	    continue;
	  /*
	    Check to see if the point is currently connected.
	  */
	  if (odssWriteMsg.timeout && (ca_state(currCtl -> channel) != currOpen))
	    {
	      ODSS_WRITE_ACK_MSG	writeReply;
	      
	      writeReply.ODSShandle = currCtl -> handle;
	      writeReply.status = htons(2);
	      msgType = htons(ODSS_WRITE_ACK);
	      writeClient(msgType, (char *) &writeReply, sizeof(writeReply), NULL, 0);
	      continue;
	    }
	  if (ca_state(currCtl -> channel) != currOpen)
	    continue;
	  /*
	    Issue the write, then see if the user wanted a timeout.
	  */
	  ca_array_put(ca_field_type(currCtl -> channel), ca_element_count(currCtl -> channel),currCtl -> channel, writeData);
	  odssWriteMsg.timeout = ntohs(odssWriteMsg.timeout);
	  if (odssWriteMsg.timeout < 0)
	    {
	      writeNack.ODSShandle = htonl(currCtl->handle);
	      msgType = htons(ODSS_WRITE_NACK);
	      writeNack.status = htons(0);
	      writeClient(msgType, (char *) &writeNack, sizeof(ODSS_WRITE_ACK_MSG), NULL, 0);
	      tisSysLog(V_INFO,0,"Invalid timeout in ODSS_WRITE message, terminating connection.\n");
	      break;
	    }
	  if (odssWriteMsg.timeout)
	    {
	      currCtl -> writeRdbkPending = 1;
	      currCtl -> writeRdbkTimeout = odssWriteMsg.timeout;
	      ca_array_get_callback(ca_field_type(currCtl -> channel), 1, currCtl -> channel,writeHandler, currCtl);
	    }
	  break;
	case ODSS_CHAN_CLEAR:
	  /*
	    Close a channel.
	  */
	  readClient((char *) &odssChanClearMsg, sizeof(odssChanClearMsg));
	  if (!clientRev)
	    continue;
	  currCtl = findCtl(ntohl(odssChanClearMsg.ODSShandle));
	  if (!currCtl)
	    {
	      tisSysLog(V_INFO,0,"Attempt to clear unknown channel <%d>\n",odssChanClearMsg.ODSShandle);
	      continue;
	    }
	  /*
	    Now unchain and free the currCtl block for this channel.
	    Close ALL the channels with this handle just in case the
	    user has given us the same handle multiple times.
	  */
	  prevCtl = 0;
	  nextCtl = firstCtl;
	  while ((lookCtl = nextCtl))
	    {
	      nextCtl = lookCtl -> nextCtl;
	      if (lookCtl -> handle == currCtl -> handle)
		{
		  if (prevCtl)
		    prevCtl -> nextCtl = lookCtl -> nextCtl;
		  else
		    firstCtl = lookCtl -> nextCtl;
		  ca_clear_channel(lookCtl -> channel);
		  deleteCtl(lookCtl);
		  wasDeleted = 1;
		}
	      else
		{
		  prevCtl = lookCtl;
		}
	    }
	  if(wasDeleted == 0)
	    {
	      tisSysLog(V_INFO,0,"Attempt to clear unknown channel <%d>\n",odssChanClearMsg.ODSShandle);
	      msgType = htons(ODSS_CHAN_CLEAR_NACK);
	    }
	  else
	    {
	      msgType = htons(ODSS_CHAN_CLEAR_ACK);
	    }
	  writeClient(msgType, (char *) &odssChanClearMsg, sizeof(ODSS_CHAN_CLEAR_MSG), NULL, 0);
	  break;
	case ODSS_HIST_READ:
	  /*
	    Read historical data.
	  */
	  odssHistDataMsg.numReturned = 0;
	  odssHistDataMsg.dataLength = 0;
	  msgType = htons(ODSS_HIST_DATA);

	  readClient((char *) &odssHistReadMsg, sizeof(odssHistReadMsg));
	  odssHistReadMsg.nameLen = ntohs(odssHistReadMsg.nameLen);
	  if((odssHistReadMsg.nameLen <= 0) || (odssHistReadMsg.nameLen > PVNAME_SZ+FLDNAME_SZ+1))
	    {
	      tisSysLog(V_INFO,0,"Invalid channel name length %d... terminating connection.\n",odssHistReadMsg.nameLen);
	      msgType = htons(ODSS_HIST_NACK);
	      writeClient(msgType, (char *) &odssHistDataMsg, sizeof(ODSS_HIST_DATA_MSG), NULL, 0);
	      closeClientChannels();
#ifdef	WIN32
	      closesocket(odssFd);
#else
	      close (odssFd);
#endif	WIN32
	      odssFd = INVALID_SOCKET;
	      break;
	    }
	  /*
	    pad chanName with blanks so we can tell when the name length is wrong.
	    GCT 18-Mar-1998
	  */
	  memset(chanName,' ',63);
	  chanName[63] = 0;
	  readClient(chanName, odssHistReadMsg.nameLen);
	  /*
	    Compare the length of the string read in by readClient. if nameLength-1 is not EQUAL to
	    strlen(chanName) then announce error and drop socket
	    GCT 18-Mar-1998
	  */
	  if((strlen(chanName) != (size_t)(odssHistReadMsg.nameLen-1)))
	    {
	      tisSysLog(V_INFO,0,"Invalid channel name length %d... terminating connection.\n",odssHistReadMsg.nameLen);
	      msgType = htons(ODSS_HIST_NACK);
	      writeClient(msgType, (char *) &odssHistDataMsg, sizeof(ODSS_HIST_DATA_MSG), NULL, 0);
	      closeClientChannels();
#ifdef	WIN32
	      closesocket(odssFd);
#else
	      close (odssFd);
#endif	WIN32
	      odssFd = INVALID_SOCKET;
	      break;
	    }
	  odssHistReadMsg.secsPerSample = ntohl(odssHistReadMsg.secsPerSample);
	  if(odssHistReadMsg.secsPerSample <= 0)
	    {
	      tisSysLog(V_INFO,0,"Invalid number of seconds/sample %d... terminating connection.\n",odssHistReadMsg.secsPerSample);
	      msgType = htons(ODSS_HIST_NACK);
	      writeClient(msgType, (char *) &odssHistDataMsg, sizeof(ODSS_HIST_DATA_MSG), NULL, 0);
	      break;
	    }
	  odssHistReadMsg.startTime = ntohl(odssHistReadMsg.startTime);
	  timeCheck = localtime((time_t *)&odssHistReadMsg.startTime);
	  if(timeCheck->tm_year < 97)
	    {
	      strcpy(timeString,ctime((time_t *)&odssHistReadMsg.startTime));
	      timeString[strlen(timeString)-1] = 0;
	      tisSysLog(V_INFO,0,"Invalid Date/Time %s... terminating connection.\n",timeString);
	      msgType = htons(ODSS_HIST_NACK);
	      writeClient(msgType, (char *) &odssHistDataMsg, sizeof(ODSS_HIST_DATA_MSG), NULL, 0);
	      break;
	    }
	  odssHistReadMsg.numSamples = ntohl(odssHistReadMsg.numSamples);
	  if((odssHistReadMsg.numSamples <= 0) || (odssHistReadMsg.numSamples > 600))
	    {
	      tisSysLog(V_INFO,0,"Invalid number of samples %d... terminating connection.\n",odssHistReadMsg.numSamples);
	      msgType = htons(ODSS_HIST_NACK);
	      writeClient(msgType, (char *) &odssHistDataMsg, sizeof(ODSS_HIST_DATA_MSG), NULL, 0);
	      break;
	    }
	  odssHistReadMsg.collRate = ntohl(odssHistReadMsg.collRate);
	  if(odssHistReadMsg.collRate <= 0)
	    {
	      tisSysLog(V_INFO,0,"Invalid rate %d... terminating connection.\n",odssHistReadMsg.collRate);
	      msgType = htons(ODSS_HIST_NACK);
	      writeClient(msgType, (char *) &odssHistDataMsg, sizeof(ODSS_HIST_DATA_MSG), NULL, 0);
	      break;
	    }
	  if(strncmp(odssHistReadMsg.dataReduc,"SMP",3) &&
	     strncmp(odssHistReadMsg.dataReduc,"AVG",3) &&
	     strncmp(odssHistReadMsg.dataReduc,"MIN",3) &&
	     strncmp(odssHistReadMsg.dataReduc,"MAX",3))
	    {
	      tisSysLog(V_INFO,0,"Invalid desired reduction method %3.3s... terminating connection.\n",odssHistReadMsg.dataReduc);
	      msgType = htons(ODSS_HIST_NACK);
	      writeClient(msgType, (char *) &odssHistDataMsg, sizeof(ODSS_HIST_DATA_MSG), NULL, 0);
	      break;
	    }
	  if(strncmp(odssHistReadMsg.dbReduc,"SMP",3) &&
	     strncmp(odssHistReadMsg.dbReduc,"AVG",3) &&
	     strncmp(odssHistReadMsg.dbReduc,"MIN",3) &&
	     strncmp(odssHistReadMsg.dbReduc,"MAX",3))
	    {
	      tisSysLog(V_INFO,0,"Invalid file reduction method %3.3s... terminating connection.\n",odssHistReadMsg.dbReduc);
	      msgType = htons(ODSS_HIST_NACK);
	      writeClient(msgType, (char *) &odssHistDataMsg, sizeof(ODSS_HIST_DATA_MSG), NULL, 0);
	      break;
	    }
	  /*if(getenv("ORACLE_HOME") == NULL)
	    continue;*/
	  reqBuffer = (char *)malloc(odssHistReadMsg.numSamples * (sizeof(double) + 4 + sizeof(double)));

	  numReturned = GetSnapValues(chanName, 		/* Point.field */
				      odssHistReadMsg.dbReduc, 		/* trend file reduction method */
				      odssHistReadMsg.dataReduc, 	/* Method for further reduction */
				      odssHistReadMsg.secsPerSample, 	/* Seconds per sample */
				      odssHistReadMsg.startTime, 	/* Secs since 1/1/70 */
				      &dbRate, 				/* An output we don't need */
				      eguTag, 				/* also not needed */
				      &dispLow, 			/* also not needed */
				      &dispHigh, 			/* also not needed */
				      odssHistReadMsg.numSamples,	/* Number of samples */
				      (double*)reqBuffer, 			/* The data values */
				      (unsigned char **)(reqBuffer + (sizeof(double) + sizeof(double)) *
							 odssHistReadMsg.numSamples),	/* The status array */
				      (double *)(reqBuffer + sizeof(double) * odssHistReadMsg.numSamples));

	  /* counts for each cell */
	  if (numReturned)
	    outputBuff = reqBuffer;
	  odssHistDataMsg.numReturned = htonl(numReturned);
	  numReturned *= (sizeof(double) + sizeof(double) + 3);
	  odssHistDataMsg.dataLength = htonl(numReturned);
	  msgType = htons(ODSS_HIST_DATA);
	  writeClient(msgType, (char *) &odssHistDataMsg, sizeof(odssHistDataMsg),
		      outputBuff, numReturned);
	  free(reqBuffer);
	  break;
	default:
	  tisSysLog(V_INFO,0,"Unknown message code %d received, terminating connection\n",msgType);
	  closeClientChannels();
#ifdef	WIN32
	      closesocket(odssFd);
#else
	      close (odssFd);
#endif	WIN32
	  odssFd = INVALID_SOCKET;
	  return(0);
	  break;
	}
    }
  return(1);
}
int fillClientBuffer()
{
  int bytesRead;
  /*
    If there is an unprocessed message fragment in the buffer, slide
    it down to the start of the buffer.
  */
  if(clientBuffSize && clientBuffIndex)
    memcpy(clientBuff, clientBuff + clientBuffIndex, clientBuffSize);
  /*
    Read as much additional information as we can.
  */
  bytesRead = recv(odssFd, clientBuff + clientBuffSize, sizeof(clientBuff) - clientBuffSize, 0);
  if (bytesRead <= 0)
    {
      tisSysLog(3,0,"EOF or error reading client socket");
      closeClientChannels();
#ifdef	WIN32
      closesocket(odssFd);
#else
      close (odssFd);
#endif	WIN32
      odssFd = INVALID_SOCKET;
      return (0);
    }
  clientBuffSize += bytesRead;
  clientBuffIndex = 0;
  return (1);
}
void readClient(char *buff,int nbytes)
{
  memcpy(buff, clientBuff + clientBuffIndex, nbytes);
  clientBuffIndex += nbytes;
  clientBuffSize -= nbytes;
}
/****************************************************************/
/*								*/
/*	DETERMINE IF WE HAVE A COMPLETE MSG IN OUR BUFFER	*/
/*								*/
/****************************************************************/

int haveCompleteClientMsg()
{
  short	msgType;
  int32 tempLength;
  ODSS_BUILD_MSG *odssBuildMsg; 
  ODSS_WRITE_MSG *odssWriteMsg;
  ODSS_HIST_READ_MSG *odssHistReadMsg;
  /*
    If the socket is gone, there is no point is processing anything.
  */
  if (odssFd == INVALID_SOCKET)
    return (0);
  /*
    Must have at least a message type.
  */
  if (clientBuffSize < sizeof(short))
    return (0);
  memcpy((char *) &msgType, clientBuff + clientBuffIndex, sizeof(short));
  msgType = htons(msgType);
  switch(msgType)
    {
    case ODSS_BUILD:
      if (clientBuffSize < (sizeof(ODSS_BUILD_MSG) + sizeof(short)))
	return (0);
      odssBuildMsg = (ODSS_BUILD_MSG *)(clientBuff + clientBuffIndex + sizeof(short));
      memcpy((char *) &tempLength, (char *) &(odssBuildMsg -> nameLength), sizeof(tempLength));
      tempLength = ntohl(tempLength);
      if (clientBuffSize < (signed)(sizeof(ODSS_BUILD_MSG) + tempLength + sizeof(short)))
	return (0);
      else
	return (1);
    case ODSS_MONITOR:
      if (clientBuffSize < (sizeof(ODSS_MONITOR_MSG) + sizeof(short)))
	return (0);
      else
	return (1);
    case ODSS_READ:
      if (clientBuffSize < (sizeof(ODSS_READ_MSG) + sizeof(short)))
	return (0);
      else
	return (1);
    case ODSS_WRITE:
      if (clientBuffSize < (sizeof(ODSS_WRITE_MSG) + sizeof(short)))
	return (0);
      odssWriteMsg = (ODSS_WRITE_MSG *) (clientBuff + clientBuffIndex + sizeof(short));
      memcpy((char *) &msgType, (char *) &(odssWriteMsg -> dataLength), sizeof(msgType));
      msgType = ntohs(msgType);
      if (clientBuffSize < (signed)(sizeof(ODSS_WRITE_MSG) + msgType + sizeof(short)))
	return (0);
      else
	return (1);
    case ODSS_HIST_READ:
      if (clientBuffSize < (sizeof(ODSS_HIST_READ_MSG) + sizeof(short)))
	return (0);
      odssHistReadMsg = (ODSS_HIST_READ_MSG *) (clientBuff + clientBuffIndex + sizeof(short));
      memcpy((char *) &msgType, (char *) &(odssHistReadMsg -> nameLen), sizeof(msgType));
      msgType = ntohs(msgType);
      if (clientBuffSize < (signed)(sizeof(ODSS_HIST_READ_MSG) + msgType + sizeof(short)))
	return (0);
      else
	return (1);
    case ODSS_CHAN_CLEAR:
      if (clientBuffSize < (sizeof(ODSS_CHAN_CLEAR_MSG) + sizeof(short)))
	return (0);
      else
	return (1);
    case ODSS_BOOMERANG:
      if (clientBuffSize < (sizeof(ODSS_BOOMERANG_MSG) + sizeof(short)))
	return (0);
      else
	return (1);
    case ODSS_REV:
      if (clientBuffSize < (sizeof(ODSS_REV_MSG) + sizeof(short)))
	return (0);
      else
	return (1);
    default:
      return (1);     /* Unknown message code. Let the higher levels bounce this client. */
    }
}
int writeClient(short msgType,char *buff1,int buff1Size,char *buff2,int buff2Size)
{
  if (odssFd < 0)
    return (0);
  if ((xmitBuffSize + sizeof(msgType) + buff1Size + buff2Size) > sizeof(xmitBuff))
    {
      if (!flushClient())
	return (0);
    }
  memcpy(xmitBuff + xmitBuffSize, (char *) &msgType, sizeof(msgType));
  xmitBuffSize += sizeof(msgType);
  if (buff1 && buff1Size)
    {
      memcpy(xmitBuff + xmitBuffSize, buff1, buff1Size);
      xmitBuffSize += buff1Size;
    }
  if (buff2 && buff2Size)
    {
      memcpy(xmitBuff + xmitBuffSize, buff2, buff2Size);
      xmitBuffSize += buff2Size;
    }
  return (1);
}
int flushClient()
{
  char *buffOut;
  int bytesSent;
  int sockTxBuff;
#ifdef LINUX
  unsigned int sockSize;
#else
  int sockSize;
#endif
  if (odssFd == INVALID_SOCKET)
    return (0);
  buffOut = xmitBuff;
  while (xmitBuffSize)
    {
      bytesSent = send(odssFd, buffOut, xmitBuffSize, 0);
      if (bytesSent <= 0)
	{
	  if (bytesSent == 0)
	    tisSysLog(V_INFO,0,"Zero length write to client, terminating connection.\n");
#ifndef WIN32
	  else if ((errno == EWOULDBLOCK) || (errno == EAGAIN))
#else
	  else if (WSAGetLastError() == WSAEWOULDBLOCK)
#endif WIN32
	      {
		sockSize = sizeof(sockTxBuff);
		getsockopt(odssFd, SOL_SOCKET, SO_SNDBUF, (char *)&sockTxBuff, &sockSize);
		sockTxBuff += xmitBuffSize;
		sockSize = sizeof(sockTxBuff);
		if (setsockopt(odssFd, SOL_SOCKET, SO_SNDBUF, (char *)&sockTxBuff, sockSize) == -1)
		  {
		    tisSysLog(V_INFO,0,"Terminating connection with application because of Tx buffer maxout.\n");
#ifdef	WIN32
		    closesocket(odssFd);
#else
		    close (odssFd);
#endif	WIN32
		    odssFd = INVALID_SOCKET;
		    closeClientChannels();
		    return (0);
		  }
		continue;
	      }
	  else
	    tisSysLog(V_INFO,0,"Terminating client because of I/O error.");
	    /*
	    Do the housekeeping for a transmission failure.
	    */
#ifdef	WIN32
	  closesocket(odssFd);
#else
	  close (odssFd);
#endif	WIN32
	  odssFd = INVALID_SOCKET;
	  closeClientChannels();
	  return (0);
	}
      buffOut += bytesSent;
      xmitBuffSize -= bytesSent;
    }
  return (1);
}
/*
//		ALLOCATE A NEW CONTROL STRUCTURE
*/
static ODSSCTL		*ctlPool = 0;

ODSSCTL *newCtl()
{
  int		index;
  ODSSCTL	*cCtl;

  if (!ctlPool)
    {
      ctlPool = (ODSSCTL *) malloc(sizeof(ODSSCTL) * CTL_ALLOC);
      cCtl = ctlPool;
      index = CTL_ALLOC;
      while (index--)
	{
	  if (index)
	    cCtl -> nextCtl = cCtl + 1;
	  else
	    cCtl -> nextCtl = 0;
	}
    }
  cCtl = ctlPool;
  ctlPool = cCtl -> nextCtl;
  memset((char *) cCtl, 0, sizeof(ODSSCTL));
  return (cCtl);
}


/*
//		FREE AN EXISTING CONTROL STRUCTURE
*/
void deleteCtl(ODSSCTL *oldCtl)
{
  oldCtl -> nextCtl = ctlPool;
  ctlPool = oldCtl;
}
void connectionHandler(struct connection_handler_args connArgs)
{
  ODSS_BUILD_ACK_MSG buildAckMsg;
  ODSS_CHAN_CONN_MSG chanConnMsg;
  ODSSCTL *cCtl;
  short direction;
  short msgType;
  /*
    The channel has just connected or disconnected. Inform the user.
  */
  if (connArgs.op == CA_OP_CONN_UP)
    direction = 1;
  else
    direction = 0;
  cCtl = (ODSSCTL *) ca_puser(connArgs.chid);
  /*
    He might be awaiting an ACK to the original build.
  */
  if (direction && cCtl -> awaitAck)
    {
      buildAckMsg.ODSShandle = htonl(cCtl -> handle);
      cCtl -> nativeType = ca_field_type(connArgs.chid);
      buildAckMsg.nativeType = htons(cCtl -> nativeType);
      cCtl -> nativeCount = ca_element_count(connArgs.chid);
      buildAckMsg.nativeCount = htons(cCtl -> nativeCount);
      msgType = htons(ODSS_BUILD_ACK);
      writeClient(msgType, (char *) &buildAckMsg, sizeof(buildAckMsg), NULL, 0);
      cCtl -> awaitAck = 0;
    }
  msgType = htons(ODSS_CHAN_CONN);
  chanConnMsg.ODSShandle = htonl(cCtl -> handle);
  chanConnMsg.connState = htons(direction);
  writeClient(msgType, (char *) &chanConnMsg, sizeof(chanConnMsg), NULL, 0);
}
/****************************************************************/
/*								*/
/*		MONITOR DATA EVENT CALLBACK HANDLER		*/
/*								*/
/****************************************************************/

void monitorHandler(struct event_handler_args args)
{
  ODSS_MONDATA_MSG odssMondata;
  ODSSCTL *cCtl = (ODSSCTL *) args.usr;
  char *pValue;
  short msgType;
  int size;
  int type;

  odssMondata.ODSShandle = htonl(cCtl -> handle);
    /*
      Stat and sevr are always in the same place in each data structure.
    */
  odssMondata.status = *(short *)args.dbr;
  odssMondata.status = htons(odssMondata.status);
  odssMondata.severity = *(short *)(((char *)args.dbr) + sizeof(short));
  odssMondata.severity = htons(odssMondata.severity);
  type = ca_field_type(cCtl -> channel);
  odssMondata.dataType = type;
  odssMondata.dataType = htons(odssMondata.dataType);
    /*
      Get a pointer to the value.
    */
  pValue = (char *)dbr_value_ptr(args.dbr, args.type);
  if (type == OLD_DBF_STRING)
    size = strlen(pValue) + 1;
  else
    size = dbr_size_n(type, args.count);
  odssMondata.dataLength = size;
  odssMondata.dataLength = htons(odssMondata.dataLength);
  msgType = htons(ODSS_MONDATA);
  writeClient(msgType, (char *) &odssMondata, sizeof(odssMondata),pValue, size);
}
/****************************************************************/
/*								*/
/*		READ EVENT CALLBACK HANDLER			*/
/*								*/
/*	Very similar in concept to the monitor data event	*/
/*	callback handler above. A characteristic of this	*/
/*	code is that if a user specifices a timeout that is	*/
/*	too small, he will be told that his read timed out	*/
/*	and then the data will be delivered later. The		*/
/*	bottom line is that a read timeout does NOT cancel	*/
/*	processing of the data if it should arrive later.	*/
/*								*/
/****************************************************************/

void readHandler(struct event_handler_args args)
{
  ODSS_READ_DATA_MSG odssReaddata;
  ODSSCTL *cCtl = (ODSSCTL *) args.usr;
  char *pValue;
  short msgType;
  int size;
  int type;
  /*
    Stat and sevr are always in the same place in each data structure.
  */
  odssReaddata.ODSShandle = htonl(cCtl -> handle);
  /*
    Stat and sevr are always in the same place in each data structure.
  */
  odssReaddata.status = *(short *)args.dbr;
  odssReaddata.status = htons(odssReaddata.status);
  odssReaddata.severity = *(short *)(((char *)args.dbr) + sizeof(short));
  odssReaddata.severity = htons(odssReaddata.severity);
  type = ca_field_type(cCtl -> channel);
  odssReaddata.dataType = type;
  odssReaddata.dataType = htons(odssReaddata.dataType);
  /*
    Get a pointer to the value.
  */
  pValue = (char *)dbr_value_ptr(args.dbr, args.type);
  if (type == OLD_DBF_STRING)
    size = strlen(pValue) + 1;
  else
    size = dbr_size_n(type, args.count);
  odssReaddata.dataLength = size;
  odssReaddata.dataLength = htons(odssReaddata.dataLength);
  odssReaddata.readState = 0;
  msgType = htons(ODSS_READ_DATA);
  writeClient(msgType, (char *) &odssReaddata, sizeof(odssReaddata),pValue, size);
  cCtl->readPending = 0;
  cCtl->readTimer = 0;
  cCtl->readTimeout = 0;
}

/****************************************************************/
/*								*/
/*		WRITE EVENT CALLBACK HANDLER			*/
/*								*/
/*	To verify a write, we only determine that the write	*/
/*	made it ALL the way down to the IOC/RTU. This is done	*/
/*	by having a read transaction immendiately follow the	*/
/*	right and then catching the read event callback here.	*/
/*	We do NOT verify that the data written is the data	*/
/*	that was sent for two reasons. First, the link layers	*/
/*	all guarantee that the data is accurately transmitted.	*/
/*	Second, there is nothing that prevents any other task	*/
/*	or CA user from writing over the same field immediately	*/
/*	after we have. Another good reason is that the ODSS	*/
/*	protocol has no definition for "Remote node is still	*/
/*	online and data came back, but it wasn't what you	*/
/*	sent" which is about as probable as me hitting the	*/
/*	lotto.							*/
/*								*/
/*	The same comments as for the read data callback		*/
/*	with respect to data arriving AFTER the timeout		*/
/*	apply here.						*/
/*								*/
/****************************************************************/

void writeHandler(struct event_handler_args args)
{
  ODSSCTL *cCtl = (ODSSCTL *)args.usr;
  ODSS_WRITE_ACK_MSG odssWriteAck;
  short msgType;

  odssWriteAck.ODSShandle = htonl(cCtl -> handle);
  odssWriteAck.status = htons(0);
  msgType = htons(ODSS_WRITE_ACK);
  writeClient(msgType, (char *)&odssWriteAck, sizeof(odssWriteAck), NULL, 0);
  cCtl -> writeRdbkPending = 0;
  cCtl -> writeRdbkTimeout = 0;
}
void closeClientChannels()
{
  ODSSCTL *lookCtl;
  ODSSCTL *nextCtl;

  nextCtl = firstCtl;
  while ((lookCtl = nextCtl))
    {
      nextCtl = lookCtl -> nextCtl;
      ca_clear_channel(lookCtl -> channel);
      deleteCtl(lookCtl);
    }
  firstCtl = 0;
}
ODSSCTL *findCtl(int handle)
{
  ODSSCTL *cCtl;

  cCtl = firstCtl;
  while (cCtl)
    {
      if (cCtl -> handle == handle)
	break;
      cCtl = cCtl -> nextCtl;
    }
  return (cCtl);
}
void addMonitor(ODSSCTL *ctl,ODSS_MONITOR_MSG *odssMonitorMsg)
{
  int type;
  int mask = 0;
  evid evID;
  odssMonitorMsg->eventMask = htons(odssMonitorMsg->eventMask);
  if (odssMonitorMsg->eventMask)
    {
      if (odssMonitorMsg->eventMask & 1)
	mask |= DBE_VALUE;
      if (odssMonitorMsg->eventMask & 2)
	mask |= DBE_LOG;
      if (odssMonitorMsg->eventMask & 4)
	mask |= DBE_ALARM;
      type = dbf_type_to_DBR_STS(ca_field_type(ctl -> channel));
      ca_add_masked_array_event(type, ca_element_count(ctl -> channel), 
				ctl -> channel, monitorHandler, ctl, (float)0.0, (float)0.0, (float)0.0, 
				&evID, mask);
      ctl->event = evID;
    }
  else
    {
      ca_clear_event(ctl -> event);
    }
}
