#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#if defined(WIN32) || defined(USECB63)
#include "cb45to63.h"
#endif WIN32
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#ifdef WIN32
#  include <winsock.h>
#  include <fcntl.h>
#else
#  include <sys/socket.h>
#  include <netinet/in.h>
#  ifndef LINUX
#    include <sys/filio.h>
#  endif LINUX
#  include <sys/ioctl.h>
#  include <sys/fcntl.h>
#  include <netinet/in.h>
#  include <netinet/tcp.h>
#  include <netdb.h>
#endif	WIN32

#include "cadef.h"
#include "msgMon.h"
#include "odssapp.h"

fd_set fdMask;
/*******************************************************************
*
*    Main ()
*
*******************************************************************/

void main(int argc, char **argv)
{
  SOCKET	attachFd;
  short		odssPort = ODSS_PORT;
  int		optVal = 1;
  struct sockaddr_in	portAddr;
#ifdef LINUX
  unsigned int	portAddrSize;
#else
  int		portAddrSize;
#endif
  SOCKET	clientFd;

  tisOpenLog("ODSS",3,0,0,0);
  tisBumpLogLevel(3);
  /*
    Create a socket for a user to attach to.
  */
  attachFd = socket(PF_INET, SOCK_STREAM, 0);
  setsockopt(attachFd, SOL_SOCKET, SO_REUSEADDR, (caddr_t) &optVal, sizeof(optVal));
  portAddr.sin_addr.s_addr = htonl(INADDR_ANY);
  portAddr.sin_family = AF_INET;
  portAddr.sin_port = htons(odssPort);
  if (bind(attachFd, (struct sockaddr *) &portAddr, sizeof(portAddr)) == SOCKET_ERROR)
    {
      tisSysLog(0,3,"Can't bind to specified TCP port %d...ODSS may already be active!",odssPort);
      exit(3);
    }
  listen(attachFd, 2);
  FD_ZERO(&fdMask);
  /*
    Someone is trying to connect to us. Create and "condition" his socket.
  */
  portAddrSize = sizeof(portAddr);
  clientFd = accept(attachFd, (struct sockaddr *) &portAddr, &portAddrSize);
#ifndef WIN32
#ifndef SOLARIS
  ioctl(clientFd, FIONBIO, &optVal);
#else
  fcntl(clientFd, F_SETFL, O_NONBLOCK);
#endif SOLARIS
#else
  ioctlsocket(clientFd, FIONBIO, &optVal);
#endif WIN32
  setsockopt(clientFd, IPPROTO_TCP, TCP_NODELAY, (char *)&optVal, sizeof(optVal));
  tisSysLog(0,3,"Connecting to client on port %d.",odssPort);
  appRun(clientFd);
  exit(0);
}
