/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/* Misc routines for login/out */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#include "logutils.h"
#include "msgMon.h"

char	*types [] = {	"Login",
			"Implicit Logout",
			"Explicit Logout",
			"Password Changed by User",
			"Password Change Failed -- Old Password Incorrect",
			"Password Change Failed -- New Passwords Mismatch",
			"New Operator Created",
			"Operator Deleted",
			"Password Changed by Admin",
			"tisUserMaint started",
			"tisUserMaint ended - all changes applied",
			"tisUserMaint canceled - no changes applied",
			"Login Failed",
			"Logged out as part of all"
};

/*----------*/
void makeLogEntry (char *opName, char *location, int logType)
{
  char	timeDate [30];
  time_t	tim;
  FILE	*f;
  /* Create a date/time string */
  tim = time (0);
  strcpy (timeDate, ctime (&tim));
  timeDate [strlen (timeDate) - 1] = '\0';
  /* Open the log file for appending */
  f = fopen ("/tis4000db/tisOperatorLog", "a");
  fprintf (f, "%s %-20s %-20s %s\n", timeDate, opName, location, types [logType]);
  fclose (f);
  /* GCT 18-Oct-1996 Add SYSLOG message support */
  tisSysLog(0,0,"Login Activity: %-20s %-20s %s",opName,location,types[logType]);
}

/*----------*/
char *getDisplayHost (void)

    /* Extract the host name from the DISPLAY environment variable. If DISPLAY */
    /* does not contain a host name, get the host name directly. */

    {

	static	char	hostName [50];
		char	*p;

	/* Get the value of the DISPLAY environment variable and replace the colon */
	/* with a NULL. */

	strcpy (hostName, getenv ("DISPLAY"));
	p = strchr (hostName, ':');
	if (p)
	    *p = '\0';

	/* If the hostName is zero length then get the actual hostname */

	if (strlen (hostName) == 0)
	    gethostname (hostName, sizeof (hostName));

	return hostName;

    }
