/*inits.c,v 1.1.1.1 1999/08/03 14:43:48 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
	
/* this is the set of initialization routines */
#include <stdio.h>
#include <math.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <dldef.h>
#include <cadef.h>
#include <font_table.h>
#include <dl_context.h>
#include <gizmo.h>
#include <dynamic_def.h>

extern void *tisMalloc();
extern void *tisCalloc();
extern void tisFree();

/* 
*    Modification History
*
*    8/9/91	DK	fixed bugs that caused unlabelled indicators not to 
*			udpate correctly when exposed
*   10/30/91	DK	changed indicators to have the same appearance as 
*			valuators
*/

init_rec_l(pdl_context, prec, low_val, high_val, redraw_flag, value,
 			   prectangle, label_flag, chan_str)

struct dl_context *pdl_context;
XRectangle *prec;
struct rectangle *prectangle;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;

{
int i, rec_y, new_height;
int mid_mark, mark, mark2, offset, tick_y, half_tick_y;
float percentage, full_range;
unsigned long saveforegroundcolor;

saveforegroundcolor = pdl_context->gc->values.foreground;
/*************the following code is for a redraw only ************************/
if(redraw_flag) {
	/* fill entire area with background color */
	XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
	if(label_flag != dl_label_none) {
	   /*draw outline with outline color */
		XSetForeground(pdl_context->d, pdl_context->gc,
			prectangle->hdr.foregroundcolor);
		XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec->x, prec->y, prec->width,
			prectangle->new_height+1);
	}
	/* label the object, if necessary */
	if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)){
		/*draw the tick marks */
		XDrawSegments(pdl_context->d, pdl_context->w,pdl_context->gc,
			prectangle->ticks,9);
		/*draw the low limit */
		draw_horizontal_string(pdl_context->d, pdl_context->w,
			 pdl_context->gc,
			&prectangle->leftlimit_rectangle,
			pdl_context->pfont_table, prectangle->left_limit.string,
			prectangle->left_limit.len, box_begin);
		/*draw the high limit */
   		draw_horizontal_string(pdl_context->d, pdl_context->w,
		      pdl_context->gc,
		      &prectangle->rightlimit_rectangle,
		      pdl_context->pfont_table, prectangle->right_limit.string,
			prectangle->right_limit.len, box_end);
		if(label_flag == dl_label_channel) 
			/*draw the channel name */
			 draw_horizontal_string(pdl_context->d, pdl_context->w,
				 pdl_context->gc,
				&prectangle->channel_name_rectangle,
				pdl_context->pfont_table,
				 prectangle->channel_name.string,
				prectangle->channel_name.len, box_begin);

	}
	prectangle->old_x = prec->x;
	/* change foreground color back to original value */
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	/*display data in object */
	FillRecLtToRt(pdl_context, prec, value, low_val, high_val, prectangle);
		return;
}
/******************************************************************************/
/* the following code builds all info into structures */
if(label_flag == dl_label_limits) {
	/* resize to inside bounding box */
	offset = prec->height/3;
	new_height = prec->height - offset - 5;
	rec_y = prec->y + prec->height - offset - 5;
	tick_y = prec->y + new_height + 5;
	half_tick_y = prec->y + new_height + 3;
}
else  
	if(label_flag == dl_label_channel) {
		offset = prec->height/3;
		new_height = prec->height - (offset*2) - 5;
		tick_y = prec->y + new_height + 5;
		half_tick_y = prec->y + new_height + 3;
		rec_y = prec->y + new_height;
	}
else {
	rec_y = prec->y;
	new_height = prec->height;
}

/* fill rectangle with background color */
XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /* draw the outline with outline color */
  	XSetForeground(pdl_context->d, pdl_context->gc,
		prectangle->hdr.foregroundcolor);
	XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, new_height);
}
prectangle->range = high_val - low_val;
prectangle->old_x = prec->x;
prectangle->inside_x = prec->x + 1;
prectangle->inside_y = prec->y + 1;
prectangle->new_height = new_height -1;
prectangle->outofrange = 0;
prectangle->label_flag = label_flag;
	
/* now label the figure, if necessary*/

if((label_flag == dl_label_limits) || (label_flag == dl_label_channel)) { 
    /* for filling a rectangle left to right */
	mid_mark = (prec->width)/2;
	mark = mid_mark/2;
	mark2 = mark/2;
	for(i=0; i<9; i++)
		prectangle->ticks[i].y1 = rec_y;
	for(i=0; i<9; i+=2)
		prectangle->ticks[i].y2 = tick_y;
	for(i=1; i<8; i+=2)
		prectangle->ticks[i].y2 = half_tick_y;
	prectangle->ticks[0].x1 = prectangle->ticks[0].x2 = prec->x;
	prectangle->ticks[8].x1 = prectangle->ticks[8].x2 = prec->x
		 + prec->width;
	prectangle->ticks[4].x1 = prectangle->ticks[4].x2 = prec->x + mid_mark;
	prectangle->ticks[2].x1 = prectangle->ticks[2].x2 = prec->x + mark;
	prectangle->ticks[6].x1 = prectangle->ticks[6].x2 = prec->x +
			mid_mark + mark;
	prectangle->ticks[1].x1 = prectangle->ticks[1].x2 = prec->x + mark2;
	prectangle->ticks[5].x1 = prectangle->ticks[5].x2 = prec->x +
			 mid_mark + mark2;
	prectangle->ticks[3].x1 = prectangle->ticks[3].x2 = prec->x +
			 mark + mark2;
	prectangle->ticks[7].x1 = prectangle->ticks[7].x2 =
			 prec->x+mid_mark+mark2+mark;
	f_to_str(high_val, prectangle->right_limit.string, 
			prectangle->hdr.precision);
	f_to_str(low_val, prectangle->left_limit.string,
			prectangle->hdr.precision);
	strncpy(prectangle->channel_name.string,
			chan_str,14);
	draw_text_rec(pdl_context, offset, prec, 
				 prectangle, label_flag); 
	/* draw extra tick marks */
	XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
			prectangle->ticks,9);
	
}

/* change foreground color back to original value */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);

/* now display data in object */
FillRecLtToRt(pdl_context, prec, value, low_val, high_val, prectangle);
}

draw_text_rec(pdl_context, offset, prec, prectangle, label_flag)

struct dl_context *pdl_context;
XRectangle *prec;
int offset;
short label_flag;
struct rectangle *prectangle;
{


/* Need length for drawing text */
prectangle->left_limit.len = strlen(prectangle->left_limit.string);
prectangle->right_limit.len = strlen(prectangle->right_limit.string);
prectangle->channel_name.len = strlen(prectangle->channel_name.string);

/* output text */
if(label_flag == dl_label_limits) {
   prectangle->leftlimit_rectangle.x = prec->x;
   prectangle->leftlimit_rectangle.y = prec->y + prec->height - offset;
   prectangle->leftlimit_rectangle.width = prec->width/2;
   prectangle->leftlimit_rectangle.height = offset;
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&prectangle->leftlimit_rectangle,
		pdl_context->pfont_table, prectangle->left_limit.string,
		prectangle->left_limit.len, box_begin);
   prectangle->rightlimit_rectangle.x = prec->x + prec->width/2;
   prectangle->rightlimit_rectangle.y = prec->y + prec->height - offset;
   prectangle->rightlimit_rectangle.width = prec->width/2;
   prectangle->rightlimit_rectangle.height = offset;
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&prectangle->rightlimit_rectangle,
		pdl_context->pfont_table, prectangle->right_limit.string,
		prectangle->right_limit.len, box_end);

   }
else
if(label_flag == dl_label_channel) {
   prectangle->leftlimit_rectangle.x = prec->x;
   prectangle->leftlimit_rectangle.y = prec->y + offset;
   prectangle->leftlimit_rectangle.width = prec->width/2;
   prectangle->leftlimit_rectangle.height = offset;
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&prectangle->leftlimit_rectangle,
		pdl_context->pfont_table, prectangle->left_limit.string,
		prectangle->left_limit.len, box_begin);
   prectangle->rightlimit_rectangle.x = prec->x+prec->width/2;
   prectangle->rightlimit_rectangle.y = prec->y + offset;
   prectangle->rightlimit_rectangle.width = prec->width/2;
   prectangle->rightlimit_rectangle.height = offset;
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&prectangle->rightlimit_rectangle,
		pdl_context->pfont_table, prectangle->right_limit.string,
		prectangle->right_limit.len, box_end);
   /* now write in channel name */
   prectangle->channel_name_rectangle.x  = prec->x;
   prectangle->channel_name_rectangle.y = prec->y + prec->height - offset;
   prectangle->channel_name_rectangle.width = prec->width;
   prectangle->channel_name_rectangle.height = offset;
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&prectangle->channel_name_rectangle,
		pdl_context->pfont_table, prectangle->channel_name.string,
		prectangle->channel_name.len, box_begin);
  }
}

label_meter(pdl_context, prec, label_flag, pmeter)
struct dl_context *pdl_context;
XRectangle *prec;
struct meter *pmeter;
short label_flag;

{

/* Need length for both XTextWidth and XDrawString */
pmeter->left_limit.len = strlen(pmeter->left_limit.string);
pmeter->right_limit.len = strlen(pmeter->right_limit.string);
pmeter->channel_name.len = strlen(pmeter->channel_name.string);

/* output text */
pmeter->leftlimit_rectangle.x = pmeter->meter_x;
pmeter->leftlimit_rectangle.y = pmeter->meter_y + pmeter->meter_height;
pmeter->leftlimit_rectangle.width = pmeter->meter_width/2;
pmeter->leftlimit_rectangle.height = pmeter->label_height_meter - 1;
/*draw the low limit */
draw_horizontal_string(pdl_context->d, pdl_context->w,
			 pdl_context->gc,
			&pmeter->leftlimit_rectangle,
			pdl_context->pfont_table, pmeter->left_limit.string,
			pmeter->left_limit.len, box_begin);
/*draw the high limit */
pmeter->rightlimit_rectangle.x = pmeter->meter_x + pmeter->meter_width/2;
pmeter->rightlimit_rectangle.y = pmeter->meter_y + pmeter->meter_height;
pmeter->rightlimit_rectangle.width = pmeter->meter_width/2;
pmeter->rightlimit_rectangle.height = pmeter->label_height_meter - 1;
draw_horizontal_string(pdl_context->d, pdl_context->w,
			 pdl_context->gc,
			&pmeter->rightlimit_rectangle,
			pdl_context->pfont_table, pmeter->right_limit.string,
			pmeter->right_limit.len, box_end);

if(label_flag == dl_label_channel) {
	pmeter->channel_name_rectangle.x = pmeter->meter_x;
	pmeter->channel_name_rectangle.y = pmeter->meter_y+pmeter->meter_height
		+ pmeter->label_height_meter;
	pmeter->channel_name_rectangle.width = pmeter->meter_width;	
	pmeter->channel_name_rectangle.height = pmeter->label_height_meter - 1;
	draw_horizontal_string(pdl_context->d, pdl_context->w,
			 pdl_context->gc,
			&pmeter->channel_name_rectangle,
			pdl_context->pfont_table, pmeter->channel_name.string,
			pmeter->channel_name.len, box_begin);
}
}
				
init_meter(pdl_context, prec, low_val, high_val, redraw_flag, value, pmeter,
			label_flag, chan_str)

struct dl_context *pdl_context;
XRectangle *prec;
struct meter *pmeter;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;
{
int line_y1, line_x2, percentage, whereondiameter;
double radius, a, b, radians, a_squared, b_squared;
double cos_squared_theta, sin_squared_theta;
int inside_x, inside_y, center_x, center_y, inside_width, inside_height;
int adjusted_degree, x1, y1, xx, yy, mirror_x, half_inside_width;
int old_degree, label_height, new_height,degree;
unsigned long saveforegroundcolor;
unsigned short offset;
static float cosine_table[181] = {
1.0,.999,.999,.998,.997,.996,.994,.992,.990,.987,.984,.981,.978,.974,.970,.965,
.961,.956,.951,.945,.939,.933,.927,.920,.913,.906,.898,.891,.882,.874,.866,.857,
.848,.838,.829,.819,.809,.798,.788,.777,.766,.754,.743,.731,.719,.707,.694,.682,.669,.656,.642,.629,.615,.601,.587,.573,.559,.544,.529,.515,.500,.484,.469,.454,.438,.422,.406,.390,.374,.358,.342,.325,.309,.292,.275,.258,.241,.225,.207,
.190,.173,.156,.139,.121,.104,.087,.069,.052,.034,.017,0,-.017,-.034,-.052,
-.069,-.087,-.104,-.121,-.139,-.156,-.173,-.190,-.207,-.225,-.241,-.258,-.275,
-.292,-.309,-.325,-.342,-.358,-.374,-.390,-.406,-.422,-.438,-.454,-.469,-.484,
-.500,-.515,-.529,-.544,-.559,-.573,-.587,-.601,-.615,-.629,-.642,-.656,-.669,
-.682,-.694,-.707,-.719,-.731,-.743,-.754,-.766,-.777,-.788,-.798,-.809,
-.819,-.829,-.838,-.848,-.857,-.866,-.874,-.882,-.891,-.898,-.906,-.913,-.920,
-.927,-.933,-.939,-.945,-.951,-.956,-.961,-.965,-.970,-.974,-.978,-.981,-.984,
-.987,-.990,-.992,-.994,-.996,-.997,-.998,-.999,-.999,-1.0};
static float sine_table[181] = {0,.017,.034,.052,
.069,.087,.104,.121,.139,.156,.173,.190,.207,.225,.241,.258,.275,
.292,.309,.325,.342,.358,.374,.390,.406,.422,.438,.454,.469,.484,
.500,.515,.529,.544,.559,.573,.587,.601,.615,.629,.642,.656,.669,
.682,.694,.707,.719,.731,.743,.754,.766,.777,.788,.798,.809,
.819,.829,.838,.848,.857,.866,.874,.882,.891,.898,.906,.913,.920,
.927,.933,.939,.945,.951,.956,.961,.965,.970,.974,.978,.981,.984,
.987,.990,.992,.994,.996,.997,.998,.999,.999,1.0,.999,.999,.998,.997,.996,.994,.992,.990,.987,.984,.981,.978,.974,.970,.965,
.961,.956,.951,.945,.939,.933,.927,.920,.913,.906,.898,.891,.882,.874,.866,.857,
.848,.838,.829,.819,.809,.798,.788,.777,.766,.754,.743,.731,.719,.707,.694,.682,.669,.656,.642,.629,.615,.601,.587,.573,.559,.544,.529,.515,.500,.484,.469,.454,.438,.422,.406,.390,.374,.358,.342,.325,.309,.292,.275,.258,.241,.225,.207,
.190,.173,.156,.139,.121,.104,.087,.069,.052,.034,.017,0};

if(!redraw_flag) {
	/*calloc memory for meter table */
	pmeter->ppixels = 
		(struct pixels *) tisCalloc(__FILE__, __LINE__, 1, sizeof(struct pixels) * 181);

	if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)) {
		offset = prec->height/3;
		new_height = prec->height - offset;
		if(label_flag == dl_label_limits) 
			pmeter->label_height_meter = offset;
		else
			pmeter->label_height_meter = offset/2;
	}
	else {
		offset = 0;
		new_height = prec->height;
		pmeter->label_height_meter = 0;
	}

	pmeter->meter_x = prec->x;
	pmeter->meter_y = prec->y;	
	pmeter->meter_width = prec->width;
	pmeter->meter_height = new_height;	 

	/*define a half circle just inside of drawn circle so as not
	 	   to erase arc when erasing needle indicator 
  		   and build a table of pixel values of meter arc */
	inside_width = pmeter->meter_width - 4;
	inside_height = pmeter->meter_height - 4;
	inside_x = pmeter->meter_x + 2, inside_y = pmeter->meter_y + 2;
	pmeter->center_x = inside_x + inside_width/2;
	pmeter->center_y = inside_y + inside_height - 2;
	pmeter->full_range = -low_val + high_val;
	pmeter->low_val = low_val;
	pmeter->label_flag = label_flag;

	a = inside_width/2;
	b = inside_height;
	for(degree = 0; degree <= 90; degree++) {
		/*radians = (degree*3.14)/180.0;*/
		half_inside_width = inside_width/2;
		a_squared = half_inside_width * half_inside_width;
		b_squared = (inside_height) * (inside_height);
		/*cos_squared_theta = cos(radians) * cos(radians);*/
		cos_squared_theta = cosine_table[degree] * cosine_table[degree];
		/*sin_squared_theta = sin(radians) * sin(radians);*/
		sin_squared_theta = sine_table[degree] * sine_table[degree];
		radius = sqrt((a_squared * b_squared) /
				((b_squared*cos_squared_theta) +
				 (a_squared*sin_squared_theta)));
		/*xx = radius * cos(radians);*/
		xx = radius * cosine_table[degree];
		/*yy = radius * sin(radians);*/
		yy = radius * sine_table[degree];  
		x1 = inside_x + inside_width/2 + xx;
		adjusted_degree = 180 - degree;
		pmeter->ppixels[adjusted_degree].x1 = x1;
		y1 = inside_y + inside_height - yy;
		pmeter->ppixels[adjusted_degree].y1 = y1;
		if(pmeter->ppixels[adjusted_degree].y1 >
			pmeter->center_y)
			pmeter->ppixels[adjusted_degree].y1 =
			pmeter->center_y;
		/*determine other side of meter: 90 to 180 degrees */
		mirror_x = pmeter->center_x - xx;
		pmeter->ppixels[degree].x1 = mirror_x;
		pmeter->ppixels[degree].y1 = y1;
	} /* end of for */

} /* end if */
saveforegroundcolor = pdl_context->gc->values.foreground;

XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc, prec->x,
		 prec->y, prec->width, prec->height);

if (label_flag != dl_label_none) {
   /* draw the meter outline in outline color */
   XSetForeground(pdl_context->d, pdl_context->gc, pmeter->hdr.foregroundcolor);

   XDrawArc(pdl_context->d, pdl_context->w, pdl_context->gc, pmeter->meter_x,
		pmeter->meter_y, pmeter->meter_width, 
		2*pmeter->meter_height, 0, 11520);
   line_y1 = pmeter->meter_y + pmeter->meter_height;
   line_x2 = pmeter->meter_x + pmeter->meter_width;
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc, 
		pmeter->meter_x, line_y1, line_x2, line_y1);

   /* draw the midpoint tick mark */
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->ppixels[90].x1,pmeter->ppixels[90].y1, 
		pmeter->ppixels[90].x1,pmeter->ppixels[90].y1 + 6);
   /* draw the hi and low values */
   f_to_str(low_val, pmeter->left_limit.string, pmeter->hdr.precision);
   f_to_str(high_val, pmeter->right_limit.string, pmeter->hdr.precision);
   strncpy(pmeter->channel_name.string, chan_str, 14);
   if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)) 
      label_meter(pdl_context, prec, label_flag, pmeter);
   /*draw the extra tick marks */
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
 	pmeter->ppixels[45].x1,
	pmeter->ppixels[45].y1, pmeter->ppixels[45].x1 + 4,
	pmeter->ppixels[45].y1 + 4);
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
	pmeter->ppixels[135].x1,
 	pmeter->ppixels[135].y1, pmeter->ppixels[135].x1 - 4,
	pmeter->ppixels[135].y1 + 4);
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
	pmeter->ppixels[157].x1,
	pmeter->ppixels[157].y1, pmeter->ppixels[157].x1 - 2,
	pmeter->ppixels[157].y1 + 1);
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
	pmeter->ppixels[112].x1,
	pmeter->ppixels[112].y1, pmeter->ppixels[112].x1 - 1,
	pmeter->ppixels[112].y1 + 2);
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
	pmeter->ppixels[67].x1,
	pmeter->ppixels[67].y1, pmeter->ppixels[67].x1 + 1,
	pmeter->ppixels[67].y1 + 2);
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
	pmeter->ppixels[22].x1,
	pmeter->ppixels[22].y1, pmeter->ppixels[22].x1 + 2,
	pmeter->ppixels[22].y1 + 1);
}

/* make first call to update routine to put a value on the display */
/*erase previous line */
if(pmeter->full_range == 0.0) 
	pmeter->old_degree = old_degree = 0;
else {
	pmeter->old_degree = old_degree =
             (value-pmeter->low_val)*180/pmeter->full_range;
	if(pmeter->old_degree > 180)
		pmeter->old_degree = old_degree = 180;
	else
		if(pmeter->old_degree < 0)
			pmeter->old_degree = old_degree = 0;
}
	

/* draw small rectangle at midpoint base of meter in foreground color */
/* reset foreground color to foreground color */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		pmeter->center_x - pmeter->meter_width/8, 
		pmeter->center_y - pmeter->meter_height/8, 
		pmeter->meter_width/4,
		pmeter->meter_height/8);

XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
	pmeter->center_x,
	pmeter->center_y,
        pmeter->ppixels[old_degree].x1,
	pmeter->ppixels[old_degree].y1);

}
			
init_indicatorD(pdl_context, prec, low_val,
			high_val, redraw_flag, value, pindicator,
			label_flag, chan_str)

struct dl_context *pdl_context;
XRectangle *prec;
struct indicator *pindicator;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;		
{
unsigned long saveforegroundcolor;
int offset, rec_y, tick_y, half_tick_y;
int mid_mark, mark, mark2,i;

saveforegroundcolor = pdl_context->gc->values.foreground;
/*****************************************************************************/
/********* the following code is for a redraw only *******/
if(redraw_flag) {
	rec_y = prec->y + prec->height;
	/* fill the rectangle area with background color */
	XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
	XSetForeground(pdl_context->d, pdl_context->gc,
		pindicator->hdr.foregroundcolor);
	if(label_flag != dl_label_none) {
	   /* draw the outline in outline color */
	   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc, prec->x,
		 rec_y, prec->x + prec->width, rec_y);
	   XDrawSegments(pdl_context->d, pdl_context->w,pdl_context->gc,
		pindicator->ticks,9);
	   if((label_flag==dl_label_limits)||(label_flag == dl_label_channel)){             /* label the figure */
 	            draw_horizontal_string(pdl_context->d,
			 pdl_context->w,pdl_context->gc,
			 &pindicator->leftlimit_rectangle,
			 pdl_context->pfont_table,
			 pindicator->left_limit.string,
			 pindicator->left_limit.len, box_begin);
  		    draw_horizontal_string(pdl_context->d, pdl_context->w,
			 pdl_context->gc,
	   		 &pindicator->rightlimit_rectangle,
			 pdl_context->pfont_table,
	  		 pindicator->right_limit.string,
			 pindicator->right_limit.len, box_end);
 
		    if(label_flag == dl_label_channel) 
 	    		draw_horizontal_string(pdl_context->d, pdl_context->w,
		   		pdl_context->gc,
				&pindicator->channel_name_rectangle,
		   		pdl_context->pfont_table,
				pindicator->channel_name.string,
		   		pindicator->channel_name.len, box_begin);
	   }
	}	  		   
	/* put current value on display */
	update_indicatorD(pdl_context, value, pindicator);
	return;
}
/******************************************************************************/

if(label_flag != dl_label_channel) {
	/*resize to inside bounding box */
	offset = prec->height/2;
	pindicator->new_height = prec->height - offset;
	rec_y = prec->y + prec->height;
	tick_y = rec_y - 5;
	half_tick_y = rec_y - 3;
}
else {
	   offset = prec->height/4;
	   pindicator->new_height = prec->height - (offset*2);
	   rec_y = prec->y + prec->height;
	   tick_y = rec_y - 5;
	   half_tick_y = rec_y - 3;
}

/* fill the rectangle area with background color */
XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /* draw the line in outline color */
   XSetForeground(pdl_context->d, pdl_context->gc,
		pindicator->hdr.foregroundcolor);	
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc, prec->x,
		rec_y, prec->x + prec->width, rec_y);
   /* draw the extra tick marks */
   mid_mark = prec->width/2;
   mark = mid_mark/2;
   mark2 = mark/2;


   for(i=0; i<9;i++)
	pindicator->ticks[i].y1 = rec_y;
   for(i=0;i<9;i+=2)
	pindicator->ticks[i].y2 = tick_y;
   for(i=1;i<8;i+=2)
	pindicator->ticks[i].y2 = half_tick_y;

   pindicator->ticks[0].x1 = pindicator->ticks[0].x2 = prec->x;
   pindicator->ticks[8].x1 = pindicator->ticks[8].x2 = prec->x + prec->width;
   pindicator->ticks[4].x1 = pindicator->ticks[4].x2 = prec->x + mid_mark;
   pindicator->ticks[2].x1 = pindicator->ticks[2].x2 = prec->x + mark;
   pindicator->ticks[6].x1 = pindicator->ticks[6].x2 = prec->x+mid_mark+mark;
   pindicator->ticks[1].x1 = pindicator->ticks[1].x2 = prec->x + mark2;
   pindicator->ticks[5].x1 = pindicator->ticks[5].x2 = prec->x+mid_mark+mark2;
   pindicator->ticks[3].x1 = pindicator->ticks[3].x2 = prec->x+mark+mark2;
   pindicator->ticks[7].x1=pindicator->ticks[7].x2=prec->x+mid_mark+mark+mark2;
   XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
			pindicator->ticks,9);
}
/* figure out the proper size of the triangle. Maintain a slope of 3/4 */
pindicator->run = (pindicator->new_height/4)*3;

pindicator->points_array[0].x = prec->x;
pindicator->points_array[0].y = rec_y - 1;
pindicator->points_array[1].x = prec->x - pindicator->run/2;
pindicator->points_array[1].y = rec_y - pindicator->new_height;
pindicator->points_array[2].x = prec->x + pindicator->run/2;
pindicator->points_array[2].y = rec_y - pindicator->new_height;
pindicator->points_array[3].x = prec->x;
pindicator->points_array[3].y = rec_y - 1;
pindicator->origin_x = prec->x, pindicator->origin_y = rec_y;

pindicator->old_x = prec->x;
pindicator->y1 = rec_y - 1;
pindicator->y2 = rec_y - pindicator->new_height;
pindicator->full_range = high_val - low_val;
pindicator->width = prec->width;
pindicator->origin_x = prec->x;
pindicator->origin_y = rec_y;
pindicator->low_val = low_val;
pindicator->space = pindicator->width/8;
pindicator->half_space = pindicator->space/2;
/*pindicator->stipple_pixmap = XCreateBitmapFromData(pdl_context->d,
			pdl_context->w, stripes_bits, stripes_width,
			stripes_height);*/
pindicator->outofrange = 0;
pindicator->label_flag = label_flag;
pindicator->indicator_save_pixmap = pdl_context->gc->values.clip_mask;

if((label_flag == dl_label_limits) || (label_flag == dl_label_channel)) {
/* Draw labels */
/* draw the high and low values */
f_to_str(low_val, pindicator->left_limit.string, pindicator->hdr.precision);
f_to_str(high_val, pindicator->right_limit.string, pindicator->hdr.precision);
pindicator->left_limit.len = strlen(pindicator->left_limit.string);
pindicator->right_limit.len = strlen(pindicator->right_limit.string);

if(label_flag == dl_label_limits) {
   pindicator->leftlimit_rectangle.x = prec->x;
   pindicator->leftlimit_rectangle.y = prec->y;
   pindicator->leftlimit_rectangle.width = prec->width/3;
   pindicator->leftlimit_rectangle.height = offset;
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&pindicator->leftlimit_rectangle, pdl_context->pfont_table,
	pindicator->left_limit.string, pindicator->left_limit.len, box_begin);
   pindicator->rightlimit_rectangle.x = prec->x+2*(prec->width/3);
   pindicator->rightlimit_rectangle.y = prec->y;
   pindicator->rightlimit_rectangle.width = prec->width/3;
   pindicator->rightlimit_rectangle.height = offset;
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&pindicator->rightlimit_rectangle, pdl_context->pfont_table,
	pindicator->right_limit.string, pindicator->right_limit.len, box_end);
}
else {
	if(label_flag == dl_label_channel) {
	   pindicator->leftlimit_rectangle.x = prec->x;
	   pindicator->leftlimit_rectangle.y = prec->y + offset;
	   pindicator->leftlimit_rectangle.width = prec->width/3;
	   pindicator->leftlimit_rectangle.height = offset;
 	   draw_horizontal_string(pdl_context->d, pdl_context->w,
		 pdl_context->gc,&pindicator->leftlimit_rectangle,
		 pdl_context->pfont_table,pindicator->left_limit.string,
		 pindicator->left_limit.len, box_begin);
 	   pindicator->rightlimit_rectangle.x = prec->x+2*(prec->width/3);
	   pindicator->rightlimit_rectangle.y = prec->y + offset;
	   pindicator->rightlimit_rectangle.width = prec->width/3;
	   pindicator->rightlimit_rectangle.height = offset;
   	   draw_horizontal_string(pdl_context->d, pdl_context->w,
		 pdl_context->gc,&pindicator->rightlimit_rectangle,
		 pdl_context->pfont_table,pindicator->right_limit.string,
		 pindicator->right_limit.len, box_end);
	  
	   strncpy(pindicator->channel_name.string,chan_str, 14);
	   pindicator->channel_name.len =
			 strlen(pindicator->channel_name.string);
	   pindicator->channel_name_rectangle.x = prec->x;
	   pindicator->channel_name_rectangle.y = prec->y;
	   pindicator->channel_name_rectangle.width = prec->width;
	   pindicator->channel_name_rectangle.height = offset;
	   draw_horizontal_string(pdl_context->d, pdl_context->w,
		pdl_context->gc, &pindicator->channel_name_rectangle,
		pdl_context->pfont_table, pindicator->channel_name.string,
		pindicator->channel_name.len, box_begin);
	   }
}
}
/* set clipping region.  save clip mask currently in gc */
pindicator->indicator_save_pixmap = pdl_context->gc->values.clip_mask;
pindicator->region = XCreateRegion();
pindicator->indicator_rectangle.x = prec->x;
pindicator->indicator_rectangle.y = rec_y - pindicator->new_height;
pindicator->indicator_rectangle.width = prec->width;
pindicator->indicator_rectangle.height = pindicator->new_height;
XUnionRectWithRegion(&pindicator->indicator_rectangle, pindicator->region,
				pindicator->region);
XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);

/* reset foreground color to foreground color */
/* fill polygon at low value point */
XSetForeground(pdl_context->d, pdl_context->gc,
		saveforegroundcolor);
XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc,
		 pindicator->points_array, 4, Complex, CoordModeOrigin);

/* now call update to put first value on display */
/* first restore clip mask */
XSetClipMask(pdl_context->d, pdl_context->gc,
			 pindicator->indicator_save_pixmap);
update_indicatorD(pdl_context, value, pindicator, pindicator->run, 
			pindicator->new_height);
}

init_indicatorU(pdl_context, prec, low_val,
			 high_val, redraw_flag, value, pindicator,
			 label_flag, chan_str)
/***** initializes an indicator with carot on bottom pointing upward ******/

struct dl_context *pdl_context;
XRectangle *prec;
struct indicator *pindicator;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;
		
{

short i;
unsigned long saveforegroundcolor;
int offset, rec_y, tick_y, half_tick_y;
int  mid_mark, mark, mark2;

saveforegroundcolor = pdl_context->gc->values.foreground;
/*****************************************************************************/
/********* the following code is for a redraw only *******/
if(redraw_flag) {
	/* fill the rectangle area with background color */
	XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
	XSetForeground(pdl_context->d, pdl_context->gc,
		pindicator->hdr.foregroundcolor);
	if(label_flag != dl_label_none) {
	   /* draw the outline in outline color */
	   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc, prec->x,
		 prec->y, prec->x + prec->width, prec->y);
	   XDrawSegments(pdl_context->d, pdl_context->w,pdl_context->gc,
		pindicator->ticks,9);
	 	/* label the figure */
	   if((label_flag == dl_label_limits)||(label_flag ==dl_label_channel)){
		draw_horizontal_string(pdl_context->d,
			pdl_context->w,pdl_context->gc,
			&pindicator->leftlimit_rectangle,
			 pdl_context->pfont_table,
			pindicator->left_limit.string,
			 pindicator->left_limit.len, box_begin);
  		draw_horizontal_string(pdl_context->d, pdl_context->w,
			 pdl_context->gc,
	   		&pindicator->rightlimit_rectangle,
			 pdl_context->pfont_table,
	 		 pindicator->right_limit.string,
			 pindicator->right_limit.len, box_end);
		if(label_flag == dl_label_channel) 
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
		         pdl_context->gc, &pindicator->channel_name_rectangle,
		      pdl_context->pfont_table, pindicator->channel_name.string,
		        pindicator->channel_name.len, box_begin);
	   }
	}
	/* put current value on display */
	update_indicatorU(pdl_context, value, pindicator);
	return;
}
/******************************************************************************/
/****The following code is for a true initialization.  All tables are built***/

/* decide on how much real estate should be reserved for labeling */
if(label_flag != dl_label_channel) {
	offset = prec->height/2;
	pindicator->new_height = prec->height - offset;
}
else{
	offset = prec->height/4;
	pindicator->new_height = prec->height - (offset*2);
}
rec_y = prec->y;
tick_y = prec->y + 5;
half_tick_y = prec->y + 3;

/* fill the rectangle area with background color */
XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /* draw the outline in outline color */
   XSetForeground(pdl_context->d, pdl_context->gc,
		pindicator->hdr.foregroundcolor);
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc, prec->x,
		 prec->y, prec->x + prec->width, prec->y);
   /* draw tick marks.  store placement info in indicator structure. */
   mid_mark = prec->width/2;
   mark = mid_mark/2;
   mark2 = mark/2;

   for(i=0;i<9;i++)
	pindicator->ticks[i].y1 = rec_y;
   for(i=0;i<9;i+=2)
	pindicator->ticks[i].y2 = tick_y;
   for(i=1;i<8;i+=2)
	pindicator->ticks[i].y2 = half_tick_y;

   pindicator->ticks[0].x1 = pindicator->ticks[0].x2 = prec->x;
   pindicator->ticks[8].x1 = pindicator->ticks[8].x2 = prec->x + prec->width;
   pindicator->ticks[4].x1 = pindicator->ticks[4].x2 = prec->x + mid_mark;
   pindicator->ticks[2].x1 = pindicator->ticks[2].x2 = prec->x + mark;
   pindicator->ticks[6].x1 = pindicator->ticks[6].x2 =prec->x + mid_mark + mark;
   pindicator->ticks[1].x1 = pindicator->ticks[1].x2 = prec->x + mark2;
   pindicator->ticks[5].x1=pindicator->ticks[5].x2 = prec->x + mid_mark + mark2;      pindicator->ticks[3].x1 = pindicator->ticks[3].x2 = prec->x + mark + mark2;
   pindicator->ticks[7].x1 = pindicator->ticks[7].x2 =
				prec->x + mid_mark + mark + mark2;
   XDrawSegments(pdl_context->d, pdl_context->w,pdl_context->gc,
		pindicator->ticks,9);
}

/* figure out the proper size of the triangle.  maintain a slope of 3/4) */
pindicator->run = (pindicator->new_height/4)*3;

/* fill in more info in indicator structure */
pindicator->points_array[0].x = prec->x;
pindicator->points_array[0].y = rec_y + 1;
pindicator->points_array[1].x = prec->x - pindicator->run/2;
pindicator->points_array[1].y = rec_y + pindicator->new_height;
pindicator->points_array[2].x = prec->x + pindicator->run/2;
pindicator->points_array[2].y = rec_y + pindicator->new_height;
pindicator->points_array[3].x = prec->x;
pindicator->points_array[3].y =rec_y + 1;
pindicator->origin_x = prec->x, pindicator->origin_y = rec_y;

pindicator->old_x = prec->x;
pindicator->origin_x = prec->x;
pindicator->full_range = high_val - low_val;
pindicator->width = prec->width;
pindicator->low_val = low_val;
pindicator->space = pindicator->width/8;
pindicator->half_space = pindicator->space/2;
pindicator->label_flag = label_flag;
pindicator->outofrange = 0;
/*pindicator->stipple_pixmap = XCreateBitmapFromData(pdl_context->d,
			 pdl_context->w, stripes_bits, stripes_width,
			 stripes_height);*/
pindicator->indicator_save_pixmap = pdl_context->gc->values.clip_mask;
/* decide on whether to draw labels or not */
if((label_flag == dl_label_limits) || (label_flag == dl_label_channel)) {

	/* Draw labels */
	/* draw the high and low values */
	f_to_str(low_val,pindicator->left_limit.string,
			pindicator->hdr.precision);
	f_to_str(high_val,pindicator->right_limit.string,
			pindicator->hdr.precision);
	pindicator->left_limit.len = strlen(pindicator->left_limit.string);
	pindicator->right_limit.len = strlen(pindicator->right_limit.string);
	if(label_flag == dl_label_limits) {
		pindicator->leftlimit_rectangle.x = prec->x;
		pindicator->leftlimit_rectangle.y = 
					prec->y+ prec->height - offset;
		pindicator->leftlimit_rectangle.width = prec->width/3;
		pindicator->leftlimit_rectangle.height = offset;
		draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->leftlimit_rectangle,
			pdl_context->pfont_table, pindicator->left_limit.string,
			pindicator->left_limit.len, box_begin);
		pindicator->rightlimit_rectangle.x = prec->x+2 * (prec->width/3);
		pindicator->rightlimit_rectangle.y = 
					prec->y+ prec->height - offset;
		pindicator->rightlimit_rectangle.width = prec->width/3;
		pindicator->rightlimit_rectangle.height = offset;
		draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->rightlimit_rectangle,
			pdl_context->pfont_table,
			pindicator->right_limit.string,
			pindicator->right_limit.len, box_end);
	}
	else 
		if(label_flag == dl_label_channel) {
		   pindicator->leftlimit_rectangle.x = prec->x;
		   pindicator->leftlimit_rectangle.y = prec->y + (offset * 2);
		   pindicator->leftlimit_rectangle.width = prec->width/3;
		   pindicator->leftlimit_rectangle.height = offset;
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->leftlimit_rectangle,
			pdl_context->pfont_table, pindicator->left_limit.string,
			pindicator->left_limit.len, box_begin);
		   pindicator->rightlimit_rectangle.x = prec->x+2*(prec->width/3);
		   pindicator->rightlimit_rectangle.y = prec->y + offset* 2;
		   pindicator->rightlimit_rectangle.width = prec->width/3;
		   pindicator->rightlimit_rectangle.height = offset ;		
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->rightlimit_rectangle,
			pdl_context->pfont_table,
			pindicator->right_limit.string,
			pindicator->right_limit.len, box_end);
		   strncpy(pindicator->channel_name.string,
				 chan_str, 14);
		   pindicator->channel_name.len = 
				 strlen(pindicator->channel_name.string);
		   pindicator->channel_name_rectangle.x = prec->x;
		   pindicator->channel_name_rectangle.y = prec->y+prec->height -
				offset;
		   pindicator->channel_name_rectangle.width = prec->width;
		   pindicator->channel_name_rectangle.height = offset;
		   draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->channel_name_rectangle,
			pdl_context->pfont_table,
			 pindicator->channel_name.string, 
			 pindicator->channel_name.len, box_begin);
		 }

}
/* set clipping region.  save current clip mask */
pindicator->indicator_save_pixmap = pdl_context->gc->values.clip_mask;
pindicator->region = XCreateRegion();
pindicator->indicator_rectangle.x = prec->x;
pindicator->indicator_rectangle.y = prec->y;
pindicator->indicator_rectangle.width = prec->width;
pindicator->indicator_rectangle.height = pindicator->new_height;
XUnionRectWithRegion(&pindicator->indicator_rectangle, pindicator->region,
				pindicator->region);
XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);

/* reset foreground color to original color */
/* fill polygon at low value point */
XSetForeground(pdl_context->d, pdl_context->gc,
		saveforegroundcolor);
XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc,
		 pindicator->points_array, 4, Complex, CoordModeOrigin);

/* now call update to put first value on display. first restore clip mask */
XSetClipMask(pdl_context->d,pdl_context->gc, pindicator->indicator_save_pixmap);

update_indicatorU(pdl_context, value, pindicator);
}

init_rec_m(pdl_context, prec,
		low_val, high_val, redraw_flag, value, prec_mid,
			label_flag, chan_str)

struct dl_context *pdl_context;
XRectangle *prec;
struct rec_mid *prec_mid;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;

{

int i, zero_point_x, center_y2, high, low, offset, new_height, tick_y;
int zero = 0, mid_mark, mark, mark2, half_tick_y, rec_y;
float percentage, full_range, mid_val;
unsigned long saveforegroundcolor;
int a, b;

/* draw the figure */
saveforegroundcolor = pdl_context->gc->values.foreground;
/****************************************************************************/
/* the following code is for a redraw only */
if(redraw_flag) {
XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /* draw the outline in outline color */
   XSetForeground(pdl_context->d, pdl_context->gc,
		prec_mid->hdr.foregroundcolor);
   XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec_mid->inside_height+1);
}
/*label the object, if necessary */
if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)) {
	/*draw the tick marks */
	XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_mid->ticks,17);
	/*draw the low limit */
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	   &prec_mid->limits_rectangle, pdl_context->pfont_table,
	   prec_mid->left_limit.string, prec_mid->left_limit.len,box_begin);
	/* draw the high value */
        draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	   &prec_mid->limits_rectangle, pdl_context->pfont_table,
	   prec_mid->right_limit.string, prec_mid->right_limit.len, box_end);

        /* draw zero */
        draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	   &prec_mid->limits_rectangle, pdl_context->pfont_table,
	   prec_mid->zero_index.string, prec_mid->zero_index.len, box_center);
	if(label_flag == dl_label_channel)
		/*draw the channel name */
		 draw_horizontal_string(pdl_context->d, pdl_context->w,
		    pdl_context->gc,&prec_mid->channel_name_rectangle,
	    	    pdl_context->pfont_table,prec_mid->channel_name.string,
		    prec_mid->channel_name.len,box_begin);
	}
prec_mid->old_x = prec_mid->zero_point_x;
/* change foreground color back to original value */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);

/* now call update routine to put initial value on screen */
FillRecFromMid(pdl_context, prec, value, low_val, high_val, prec_mid);
return;
}
/*****************************************************************************/
/*  the following code sets up all info in structures */

if(label_flag == dl_label_limits) {
	offset = prec->height/3;
	new_height = prec->height - offset - 5;
	tick_y = prec->y + new_height + 5;
	half_tick_y = prec->y + new_height + 3;
	rec_y = prec->y + new_height;
}
else
   if(label_flag == dl_label_channel) {
	offset = prec->height/3;
	new_height = prec->height - (offset*2) - 5;
	tick_y = prec->y + new_height + 5;
	half_tick_y = prec->y + new_height + 3;
	rec_y = prec->y + new_height;
   }
else {
	rec_y = prec->y;
	new_height = prec->height;
}
XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /* draw the outline in outline color */
   XSetForeground(pdl_context->d, pdl_context->gc,
		prec_mid->hdr.foregroundcolor);
   XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, new_height);
}
/* 0 should always be in the middle. size accordingly */

if(-low_val > high_val)
	high_val = -low_val;
else
   if(-low_val < high_val)
	low_val = -high_val;

full_range = high_val - low_val;
if(full_range == 0.0) 
	return;
percentage = high_val/full_range;
zero_point_x = (prec->x + (unsigned int)(prec->width)) - ((unsigned int)(prec->width)*percentage);
center_y2 = prec->y + new_height;

/* set up fill info in structure */
prec_mid->old_x = zero_point_x;
prec_mid->positive_pixel_width =
	prec->x + prec->width - 1 - zero_point_x;
prec_mid->negative_pixel_width = zero_point_x - prec->x - 1;
prec_mid->pos_x = zero_point_x + 1;
prec_mid->pos_y = prec->y + 1;
prec_mid->inside_height = new_height - 1;
prec_mid->neg_x = prec->x + 1;
prec_mid->neg_y = prec->y + 1;
prec_mid->zero_point_x = zero_point_x;
prec_mid->high_val = high_val;
prec_mid->low_val = low_val;
prec_mid->label_flag = label_flag;
prec_mid->outofrange = 0;
XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
			zero_point_x, prec->y, zero_point_x, center_y2);	
/* now label the figure*/
if((label_flag == dl_label_limits) || (label_flag == dl_label_channel)){
	/*set up tick marks on negative side */
	mid_mark = prec_mid->negative_pixel_width/2;
	mark = mid_mark/2;
	mark2 = mark/2;
	for(i=0;i<18;i++)
		prec_mid->ticks[i].y1 = rec_y;
	for(i=0;i<17; i+=2)
		prec_mid->ticks[i].y2 = tick_y;
	for(i=1;i<16; i+=2)
		prec_mid->ticks[i].y2 = half_tick_y;
	prec_mid->ticks[0].x1 = prec_mid->ticks[0].x2 = prec->x;
	prec_mid->ticks[8].x1 = prec_mid->ticks[8].x2 = prec_mid->zero_point_x;
	prec_mid->ticks[4].x1 = prec_mid->ticks[4].x2 = prec->x + mid_mark;
	prec_mid->ticks[2].x1 = prec_mid->ticks[2].x2 = prec->x + mark;
	prec_mid->ticks[6].x1 = prec_mid->ticks[6].x2 = prec->x+mid_mark+mark;
	prec_mid->ticks[1].x1 = prec_mid->ticks[1].x2 = prec->x+mark2;
	prec_mid->ticks[5].x1 = prec_mid->ticks[5].x2 = prec->x+mid_mark+mark2;
	prec_mid->ticks[3].x1 = prec_mid->ticks[3].x2 = prec->x+mark+mark2;
	prec_mid->ticks[7].x1 = prec_mid->ticks[7].x2 =
					 prec->x+mid_mark+mark+mark2;
	/*now set up tick marks on positive side */
	mid_mark = prec_mid->positive_pixel_width/2;
	mark = mid_mark/2;
	mark2 = mark/2;
	prec_mid->ticks[16].x1 = prec_mid->ticks[16].x2 = prec->x + prec->width;
	prec_mid->ticks[12].x1 = prec_mid->ticks[12].x2 = 
			prec_mid->zero_point_x+mid_mark;
	prec_mid->ticks[10].x1 = prec_mid->ticks[10].x2 = 
			prec_mid->zero_point_x+mark;
	prec_mid->ticks[14].x1 = prec_mid->ticks[14].x2 = 
			prec_mid->zero_point_x+mid_mark+mark;
	prec_mid->ticks[9].x1 = prec_mid->ticks[9].x2 = 
			prec_mid->zero_point_x+mark2;
	prec_mid->ticks[13].x1 = prec_mid->ticks[13].x2 = 
			prec_mid->zero_point_x+mid_mark+mark2;
	prec_mid->ticks[11].x1 = prec_mid->ticks[11].x2 = 
			prec_mid->zero_point_x+mark+mark2;
	prec_mid->ticks[15].x1 = prec_mid->ticks[15].x2 = 
			prec_mid->zero_point_x+mid_mark+mark+mark2;
	XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_mid->ticks,17);
	/* draw the hi and low values */
	f_to_str(low_val, prec_mid->left_limit.string,prec_mid->hdr.precision);
	f_to_str(high_val, prec_mid->right_limit.string,
				prec_mid->hdr.precision);
	sprintf(prec_mid->zero_index.string, "%d", zero);
	strncpy(prec_mid->channel_name.string, chan_str, 14);
	label_rec_mid(pdl_context, offset, prec, prec_mid,
			label_flag,new_height);
	
}

/* change foreground color back to original value */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);

/* now call update routine to put initial value on screen */
FillRecFromMid(pdl_context, prec, value, low_val, high_val, prec_mid);
}

label_rec_mid(pdl_context, offset, prec, 
	prec_mid, label_flag,
	new_height)

struct dl_context *pdl_context;
struct rec_mid *prec_mid;
XRectangle *prec;
int offset, new_height;
short label_flag;

{

/* Need length for both XTextWidth and XDrawString */
prec_mid->left_limit.len = strlen(prec_mid->left_limit.string);    /* low val */
prec_mid->right_limit.len=strlen(prec_mid->right_limit.string);  /* high val */
prec_mid->zero_index.len = strlen(prec_mid->zero_index.string);     /* zero */
prec_mid->channel_name.len = strlen(prec_mid->channel_name.string);

/* output text */
if(label_flag == dl_label_limits) {

   /* draw the low value */
   prec_mid->limits_rectangle.x = prec->x;
   prec_mid->limits_rectangle.y = prec->y + prec->height - offset;
   prec_mid->limits_rectangle.width = prec->width;
   prec_mid->limits_rectangle.height = offset;
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_mid->limits_rectangle, pdl_context->pfont_table,
	prec_mid->left_limit.string, prec_mid->left_limit.len,box_begin);
  /* draw the high value */
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_mid->limits_rectangle, pdl_context->pfont_table,
	prec_mid->right_limit.string, prec_mid->right_limit.len, box_end);

   /* draw zero */
     draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_mid->limits_rectangle, pdl_context->pfont_table,
	prec_mid->zero_index.string, prec_mid->zero_index.len, box_center);
   }
else
if(label_flag == dl_label_channel) {
   prec_mid->limits_rectangle.x = prec->x;
   prec_mid->limits_rectangle.y = prec->y + new_height + 5;
   prec_mid->limits_rectangle.width = prec->width;
   prec_mid->limits_rectangle.height = offset - 5;
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_mid->limits_rectangle, pdl_context->pfont_table,
	prec_mid->left_limit.string, prec_mid->left_limit.len,box_begin);
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_mid->limits_rectangle, pdl_context->pfont_table,
	prec_mid->right_limit.string, prec_mid->right_limit.len, box_end);
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_mid->limits_rectangle, pdl_context->pfont_table,
	prec_mid->zero_index.string, prec_mid->zero_index.len, box_center);
 
   /* now write in channel name */
   prec_mid->channel_name_rectangle.x = prec->x;
   prec_mid->channel_name_rectangle.y = prec->y + prec->height - offset;
   prec_mid->channel_name_rectangle.width = prec->width;
   prec_mid->channel_name_rectangle.height = offset;
   draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_mid->channel_name_rectangle, pdl_context->pfont_table,
	prec_mid->channel_name.string, prec_mid->channel_name.len, box_begin);
    }
}
label_rec_midv(pdl_context, offset, prec, prec_midv, label_flag)

struct dl_context *pdl_context;
XRectangle *prec;
struct rec_midv *prec_midv;
int offset;
short label_flag;

{
int label_height;

/* get the correct font size */
label_height = prec->height/10;

/* Need length for both XTextWidth and XDrawString */
prec_midv->bottom_limit.len =strlen(prec_midv->bottom_limit.string);/*low val*/
prec_midv->top_limit.len = strlen(prec_midv->top_limit.string); /* high val */
prec_midv->zero_index.len = strlen(prec_midv->zero_index.string);
prec_midv->channel_name.len = strlen(prec_midv->channel_name.string);

/* output text */
if(label_flag == dl_label_limits) {
prec_midv->toplimit_rectangle.x = prec->x ;
prec_midv->toplimit_rectangle.y = prec->y;
prec_midv->toplimit_rectangle.width = offset*2;
prec_midv->toplimit_rectangle.height = label_height;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_midv->toplimit_rectangle, pdl_context->pfont_table,
	prec_midv->top_limit.string, prec_midv->top_limit.len, box_end);
prec_midv->bottomlimit_rectangle.x = prec->x;
prec_midv->bottomlimit_rectangle.y = prec->y + prec->height - label_height;
prec_midv->bottomlimit_rectangle.width = offset*2;
prec_midv->bottomlimit_rectangle.height = label_height;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_midv->bottomlimit_rectangle, pdl_context->pfont_table,
	prec_midv->bottom_limit.string, prec_midv->bottom_limit.len, box_end);
/* draw zero */
prec_midv->zeroindex_rectangle.x = prec->x;
prec_midv->zeroindex_rectangle.y = prec->y + prec->height/2 - label_height/2;
prec_midv->zeroindex_rectangle.width = offset*2;
prec_midv->zeroindex_rectangle.height = label_height;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_midv->zeroindex_rectangle, pdl_context->pfont_table,
	prec_midv->zero_index.string, prec_midv->zero_index.len, box_end);
}
else
if(label_flag == dl_label_channel) {
prec_midv->toplimit_rectangle.x = prec->x;
prec_midv->toplimit_rectangle.y = prec->y;
prec_midv->toplimit_rectangle.width = offset*2;
prec_midv->toplimit_rectangle.height = label_height;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_midv->toplimit_rectangle, pdl_context->pfont_table,
	prec_midv->top_limit.string, prec_midv->top_limit.len, box_end);
prec_midv->bottomlimit_rectangle.x = prec->x;
prec_midv->bottomlimit_rectangle.y = prec->y + prec->height - label_height;
prec_midv->bottomlimit_rectangle.width = offset*2;
prec_midv->bottomlimit_rectangle.height = label_height;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_midv->bottomlimit_rectangle, pdl_context->pfont_table,
	prec_midv->bottom_limit.string, prec_midv->bottom_limit.len, box_end);
/* draw zero */
prec_midv->zeroindex_rectangle.x = prec->x;
prec_midv->zeroindex_rectangle.y = prec->y + prec->height/2 - label_height/2;
prec_midv->zeroindex_rectangle.width = offset*2;
prec_midv->zeroindex_rectangle.height = label_height;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_midv->zeroindex_rectangle, pdl_context->pfont_table,
	prec_midv->zero_index.string, prec_midv->zero_index.len, box_end);
}
if(label_flag == dl_label_channel) {
	prec_midv->channel_name_rectangle.x = prec->x;
	prec_midv->channel_name_rectangle.y = prec->y + label_height;
	prec_midv->channel_name_rectangle.width = offset;
	prec_midv->channel_name_rectangle.height=prec->height - label_height*2;
	draw_vertical_string(pdl_context->d, pdl_context->w, pdl_context->gc,
		&prec_midv->channel_name_rectangle, pdl_context->pfont_table,
		prec_midv->channel_name.string, prec_midv->channel_name.len,
		box_center);

 }
}

init_rec_midv(pdl_context,prec,low_val,high_val, redraw_flag, value, prec_midv,
		label_flag, chan_str)

struct dl_context *pdl_context;
XRectangle *prec;
struct rec_midv *prec_midv;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;

{
int i, zero_point_y, offset, new_width, tick_x;
int mid_mark, mark, mark2, half_tick_x, rec_x, zero = 0;
float percentage, full_range, mid_val;
unsigned long saveforegroundcolor;

saveforegroundcolor = pdl_context->gc->values.foreground;
/*****************************************************************************/
/* the following code is for a redraw only */
if(redraw_flag) {
/* fill in area with background color */

XSetForeground(pdl_context->d, pdl_context->gc, 
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /*draw the outline in outline color*/
   XSetForeground(pdl_context->d, pdl_context->gc,
				 prec_midv->hdr.foregroundcolor);
   XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_midv->pos_x - 1, prec->y, prec_midv->inside_width + 1,
		prec->height);
}
/*label the object, if necessary*/
if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)) {
	/*draw the tick marks */
	XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_midv->ticks,17);
	/*draw the low limit */
	draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	   &prec_midv->bottomlimit_rectangle, pdl_context->pfont_table,
	   prec_midv->bottom_limit.string, prec_midv->bottom_limit.len,box_end);
	/* draw the high value */
        draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	   &prec_midv->toplimit_rectangle, pdl_context->pfont_table,
	   prec_midv->top_limit.string, prec_midv->top_limit.len, box_begin);

        /* draw zero */
       draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	   &prec_midv->zeroindex_rectangle, pdl_context->pfont_table,
	   prec_midv->zero_index.string, prec_midv->zero_index.len, box_end);
	if(label_flag == dl_label_channel) 
		/*draw the channel name */
		 draw_vertical_string(pdl_context->d, pdl_context->w,
		    pdl_context->gc,&prec_midv->channel_name_rectangle,
	    	    pdl_context->pfont_table,prec_midv->channel_name.string,
		    prec_midv->channel_name.len,box_center);
	}

prec_midv->old_y = prec_midv->zero_point_y;
/* change foreground color back to original value */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);

/* now call update routine to put initial value on screen */
FillRecFromMidv(pdl_context, prec, value, low_val, high_val, prec_midv);
return;
}
/******************************************************************************/
/* the following code builds all info into structures */
if((label_flag == dl_label_limits) || (label_flag == dl_label_channel)) {
	offset = prec->width/3;
	new_width = offset - 5;
	rec_x = prec->x + offset*2 + 5;
	tick_x = rec_x - 5;
	half_tick_x = rec_x - 3;
}

else {
	rec_x = prec->x;
	new_width = prec->width;
}

/* fill in area with background color */
XSetForeground(pdl_context->d, pdl_context->gc, 
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /*draw the outline in outline color*/
   XSetForeground(pdl_context->d, pdl_context->gc,
				 prec_midv->hdr.foregroundcolor);
   XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		rec_x, prec->y, new_width, prec->height);
}
/* 0 should always be in the middle.  Size accordingly */
if(-low_val > high_val)
	high_val = -low_val;
else
   if(-low_val < high_val)
	low_val = -high_val;

full_range = high_val - low_val;
if(full_range == 0.0)
	return;
percentage = high_val/full_range;
if(percentage < 0.0)
	percentage = 0.0;
else {
   if(percentage > 1.0) 
	percentage = 1.0;
}
zero_point_y = prec->y + (prec->height/2);

/*set up fill info in structure */
prec_midv->old_y = zero_point_y;
prec_midv->positive_pixel_height =  zero_point_y - prec->y  - 1;
prec_midv->negative_pixel_height = prec->y + prec->height - zero_point_y - 1;
prec_midv->pos_x = rec_x + 1;
prec_midv->pos_y = prec->y + 1;
/* the following should be prec_mid->inside_width */
prec_midv->inside_width = new_width - 1;
prec_midv->neg_x = rec_x + 1;
prec_midv->neg_y = zero_point_y + 1;
prec_midv->zero_point_y = zero_point_y;
prec_midv->high_val = high_val;
prec_midv->low_val = low_val;
prec_midv->label_flag = label_flag;
prec_midv->outofrange = 0;
XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
	rec_x, zero_point_y, rec_x + new_width, zero_point_y);

/*now label the figure */
if((label_flag == dl_label_limits) || (label_flag == dl_label_channel)) {
	mid_mark = prec_midv->negative_pixel_height/2;
	mark = mid_mark/2;
	mark2 = mark/2;
	for(i = 0; i < 18; i++)
		prec_midv->ticks[i].x1 = rec_x;
	for(i = 0; i < 17; i+=2)
		prec_midv->ticks[i].x2 = tick_x;
	for(i = 1; i < 16; i+=2)
		prec_midv->ticks[i].x2 = half_tick_x;
	prec_midv->ticks[0].y1 = prec_midv->ticks[0].y2 = prec->y;
	prec_midv->ticks[8].y1=prec_midv->ticks[8].y2 = prec_midv->zero_point_y;
	prec_midv->ticks[4].y1=prec_midv->ticks[4].y2 = prec->y + mid_mark;
	prec_midv->ticks[2].y1=prec_midv->ticks[2].y2 = prec->y + mark;
	prec_midv->ticks[6].y1=prec_midv->ticks[6].y2 = prec->y + mid_mark+mark;
	prec_midv->ticks[1].y1=prec_midv->ticks[1].y2 = prec->y + mark2;
	prec_midv->ticks[5].y1=prec_midv->ticks[5].y2 = prec->y +mid_mark+mark2;
	prec_midv->ticks[3].y1=prec_midv->ticks[3].y2 = prec->y +mark+mark2;
	prec_midv->ticks[7].y1=prec_midv->ticks[7].y2 = 
				prec->y+mid_mark+mark+mark2;
	/* now set up ticks on positive side */
	mid_mark = prec_midv->positive_pixel_height/2;
	mark = mid_mark/2;
	mark2 = mark/2;
	prec_midv->ticks[16].y1=prec_midv->ticks[16].y2=prec->y + prec->height;
	prec_midv->ticks[12].y1=prec_midv->ticks[12].y2 = 
			prec_midv->zero_point_y + mid_mark;
	prec_midv->ticks[10].y1=prec_midv->ticks[10].y2 = 
			prec_midv->zero_point_y + mark;
	prec_midv->ticks[14].y1=prec_midv->ticks[14].y2 = 
			prec_midv->zero_point_y + mid_mark + mark;
	prec_midv->ticks[9].y1=prec_midv->ticks[9].y2 = 
			prec_midv->zero_point_y + mark2;
	prec_midv->ticks[13].y1=prec_midv->ticks[13].y2 = 
			prec_midv->zero_point_y + mid_mark + mark2;
	prec_midv->ticks[11].y1=prec_midv->ticks[11].y2 = 
			prec_midv->zero_point_y + mark + mark2;
	prec_midv->ticks[15].y1=prec_midv->ticks[15].y2 = 
			prec_midv->zero_point_y + mid_mark + mark + mark2;
	XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_midv->ticks, 17);

	/*draw the hi and low values */
	f_to_str(high_val, prec_midv->top_limit.string,
				prec_midv->hdr.precision);
	f_to_str(low_val, prec_midv->bottom_limit.string,
				prec_midv->hdr.precision);
	sprintf(prec_midv->zero_index.string, "%d", zero);
	strncpy(prec_midv->channel_name.string, chan_str, 14);
	label_rec_midv(pdl_context, offset, prec, prec_midv,
			 label_flag);
	
	}

/*change foreground color back to original color */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
/*now call update routine to put initial value on screen*/
FillRecFromMidv(pdl_context, prec, value, low_val, high_val, prec_midv);
}

init_rec_t(pdl_context, prec, low_val, high_val, redraw_flag, value, prec_v,
		label_flag, chan_str)

struct dl_context *pdl_context;
XRectangle *prec;
struct rectangle_v *prec_v;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;

{
int i, offset, tick_x, half_tick_x, rec_x;
int mid_mark, mark, mark2, mark3, new_width;
float percentage, full_range, mid_val;
unsigned long saveforegroundcolor;

saveforegroundcolor = pdl_context->gc->values.foreground;
/***********the following code is for a redraw only ***************************/
if(redraw_flag) {
	XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
	if(label_flag != dl_label_none) {
	   /*draw outline in outline color */
	   XSetForeground(pdl_context->d, pdl_context->gc,
		prec_v->hdr.foregroundcolor);
     	   XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_v->rec_x, prec->y, prec_v->new_width+1, prec->height);
	}
	/*label the object, if necessary */
	if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)){
		/*draw the tick marks */
		XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_v->ticks, 9);
		/*draw the top limit */
		draw_horizontal_string(pdl_context->d, pdl_context->w,
		   pdl_context->gc,
		   &prec_v->toplimit_rectangle, pdl_context->pfont_table,
		   prec_v->top_limit.string, prec_v->top_limit.len, box_end);
		/*draw the bottom limit*/
		draw_horizontal_string(pdl_context->d, pdl_context->w,
		   pdl_context->gc,
		   &prec_v->bottomlimit_rectangle, pdl_context->pfont_table,
		   prec_v->bottom_limit.string, prec_v->bottom_limit.len,
		   box_end);
		if(label_flag == dl_label_channel)
		   /*draw the channel name */
		   	draw_vertical_string(pdl_context->d, pdl_context->w,
				pdl_context->gc,
				&prec_v->channel_name_rectangle,
				pdl_context->pfont_table,
				prec_v->channel_name.string, 
				prec_v->channel_name.len,box_begin);
	}
	prec_v->old_y = prec->y; 
	/*change foreground color back to original color */
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	/* now display data in object */
	fill_rect(pdl_context, prec, value, low_val, high_val, prec_v);
	return;
}
/*****************************************************************************/
/*  the following code build all info into structures */
if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)) {
	offset = prec->width/3;
	new_width = offset - 5;
	rec_x = prec->x + prec->width - offset + 5;
	tick_x = rec_x - 5;
	half_tick_x = rec_x - 3;
}
else {
	rec_x = prec->x;
	new_width = prec->width;
}
XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /*draw outline in outline color */
   XSetForeground(pdl_context->d, pdl_context->gc,
		prec_v->hdr.foregroundcolor);
   XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		rec_x, prec->y, new_width, prec->height);
}
prec_v->full_range = high_val - low_val;
/*prec_v->old_y = prec->y + prec->height;*/
prec_v->old_y = prec->y; 
prec_v->bottom_y = prec->y + prec->height;
prec_v->left_x = rec_x + 1;
prec_v->new_width = new_width - 1;
prec_v->rec_x = rec_x;
prec_v->label_flag = label_flag;
prec_v->outofrange = 0;

/* now label the figure*/
if((label_flag == dl_label_limits) || (label_flag == dl_label_channel)) {
	mid_mark = prec->height/2;
	mark = mid_mark/2;
	mark2 = mark/2;
	mark3 = mark + (mid_mark - mark)/2;
	for(i=0; i<9; i++)
		prec_v->ticks[i].x1 = rec_x;
	for(i=0; i<9; i+=2)
		prec_v->ticks[i].x2 = tick_x;
	for(i=1; i<8; i+=2)
		prec_v->ticks[i].x2 = half_tick_x;
	prec_v->ticks[0].y1 = prec_v->ticks[0].y2 = prec->y;
	prec_v->ticks[8].y1 = prec_v->ticks[8].y2=prec->y+prec->height;
	prec_v->ticks[4].y1 = prec_v->ticks[4].y2=prec->y+mid_mark;
	prec_v->ticks[2].y1 = prec_v->ticks[2].y2=prec->y+mark;
	prec_v->ticks[6].y1 = prec_v->ticks[6].y2=prec->y+mid_mark+mark;
	prec_v->ticks[1].y1 = prec_v->ticks[1].y2=prec->y+mark2;
	prec_v->ticks[5].y1=prec_v->ticks[5].y2=prec->y+mid_mark+mark2;
	prec_v->ticks[3].y1=prec_v->ticks[3].y2=prec->y+mark3;
	prec_v->ticks[7].y1=prec_v->ticks[7].y2=prec->y+mid_mark+mark3;
	XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_v->ticks, 9);
	f_to_str(high_val, prec_v->bottom_limit.string,prec_v->hdr.precision);
	f_to_str(low_val, prec_v->top_limit.string, prec_v->hdr.precision);
	strncpy(prec_v->channel_name.string, chan_str, 14);
	draw_text_recv(pdl_context, offset,prec, prec_v, label_flag);
}

/*change foreground color back to original color */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
 
/* now display data in object */
fill_rect(pdl_context, prec, value, low_val, high_val, prec_v);

}

init_rec_b(pdl_context, prec, low_val, high_val, redraw_flag, value, prec_v,
		label_flag, chan_str)
struct dl_context *pdl_context;
XRectangle *prec;
struct rectangle_v *prec_v;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;

{
XFontStruct *font_info;
XFontStruct *XLoadQueryFont();
int i, offset, tick_x, half_tick_x, rec_x;
int mid_mark, mark, mark2, mark3, new_width;

float percentage, full_range, mid_val;
unsigned long saveforegroundcolor;

saveforegroundcolor = pdl_context->gc->values.foreground;
/********the following code if for a redraw only */
if(redraw_flag) {
	XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
	if(label_flag != dl_label_none) {
      	   /*draw outline in outline color */
   	   XSetForeground(pdl_context->d, pdl_context->gc,
		prec_v->hdr.foregroundcolor);
	   XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_v->rec_x, prec->y, prec_v->new_width+1, prec->height);
	}
	/*label the object, if necessary */
	if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)){
		/*draw the tick marks */
		XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
			prec_v->ticks, 9);
		/*draw the top limit */
		draw_horizontal_string(pdl_context->d, pdl_context->w,
			 pdl_context->gc,
			&prec_v->toplimit_rectangle, pdl_context->pfont_table,
		     prec_v->top_limit.string, prec_v->top_limit.len, box_end);
		/*draw the bottom limit*/
		draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc,
		     &prec_v->bottomlimit_rectangle, pdl_context->pfont_table,
			prec_v->bottom_limit.string, prec_v->bottom_limit.len,
			box_end);
		if(label_flag == dl_label_channel)
		   /*draw the channel name */
		   	draw_vertical_string(pdl_context->d, pdl_context->w,
				pdl_context->gc,
				&prec_v->channel_name_rectangle,
				pdl_context->pfont_table,
				prec_v->channel_name.string, 
				prec_v->channel_name.len,box_begin);
	}
	prec_v->old_y = prec->y + prec->height; 
	/*change foreground color back to original color */
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	/* now display data in object */
	fill_recv(pdl_context, prec, value, low_val, high_val, prec_v);
	return;
}
/****************************************************************************/
/***the following code builds all info into structures */

if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)) {
	offset = prec->width/3;
	new_width = offset - 5;
	rec_x = prec->x + prec->width - offset + 5;
	tick_x = rec_x - 5;
	half_tick_x = rec_x - 3;
}
else {
	rec_x = prec->x;
	new_width = prec->width;
}
XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /*draw outline in outline color */
   XSetForeground(pdl_context->d, pdl_context->gc,
		prec_v->hdr.foregroundcolor);
   XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		rec_x, prec->y, new_width, prec->height);
}
prec_v->full_range = high_val - low_val;
prec_v->old_y = prec->y + prec->height; 
prec_v->bottom_y = prec->y + prec->height;
prec_v->left_x = rec_x + 1;
prec_v->new_width = new_width - 1;
prec_v->rec_x = rec_x;
prec_v->label_flag = label_flag;
prec_v->outofrange = 0;
	
/* now label the figure*/
if((label_flag == dl_label_limits) || (label_flag == dl_label_channel)) {
	mid_mark = prec->height/2;
	mark = mid_mark/2;
	mark2 = mark/2;
	mark3 = mark + (mid_mark - mark)/2;
	for(i=0; i<9; i++)
		prec_v->ticks[i].x1 = rec_x;
	for(i=0; i<9; i+=2)
		prec_v->ticks[i].x2 = tick_x;
	for(i=1; i<8; i+=2)
		prec_v->ticks[i].x2 = half_tick_x;
	prec_v->ticks[0].y1 = prec_v->ticks[0].y2 = prec->y;
	prec_v->ticks[8].y1 = prec_v->ticks[8].y2=prec->y+prec->height;
	prec_v->ticks[4].y1 = prec_v->ticks[4].y2=prec->y+mid_mark;
	prec_v->ticks[2].y1 = prec_v->ticks[2].y2=prec->y+mark;
	prec_v->ticks[6].y1 = prec_v->ticks[6].y2=prec->y+mid_mark+mark;
	prec_v->ticks[1].y1 = prec_v->ticks[1].y2=prec->y+mark2;
	prec_v->ticks[5].y1=prec_v->ticks[5].y2=prec->y+mid_mark+mark2;
	prec_v->ticks[3].y1=prec_v->ticks[3].y2=prec->y+mark3;
	prec_v->ticks[7].y1=prec_v->ticks[7].y2=prec->y+mid_mark+mark3;
	XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec_v->ticks, 9);
	f_to_str(low_val, prec_v->bottom_limit.string, prec_v->hdr.precision);
	f_to_str(high_val, prec_v->top_limit.string, prec_v->hdr.precision);
	strncpy(prec_v->channel_name.string, chan_str, 14);
	draw_text_recv(pdl_context, offset,
			prec, prec_v, label_flag);
}

/*change foreground color back to original color */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
 
/* now display data in object */
fill_recv(pdl_context, prec, value, low_val, high_val, prec_v);
}

draw_text_recv(pdl_context, offset, prec, prec_v, label_flag)

struct dl_context *pdl_context;
struct rectangle_v *prec_v;
XRectangle *prec;
int offset;
short label_flag;
{
XFontStruct *pfont;
XRectangle channel_name_rectangle;
int len1,len2, len3, len4, width1, width2, width3, width4, smallest_height;
int starting_point_x, starting_point_y, new_width, label_height, ycentered;

label_height = prec->height/10;

/* Need length for both XTextWidth and XDrawString */
prec_v->top_limit.len=strlen(prec_v->top_limit.string);/*high val */
prec_v->bottom_limit.len=strlen(prec_v->bottom_limit.string);/*low*/


/* output text */
new_width = prec->width - offset;
prec_v->toplimit_rectangle.x = prec->x;
prec_v->toplimit_rectangle.y = prec->y;
prec_v->toplimit_rectangle.width =  new_width - 3;
prec_v->toplimit_rectangle.height = prec->height/10;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_v->toplimit_rectangle, pdl_context->pfont_table,
	prec_v->top_limit.string, prec_v->top_limit.len, box_end);
prec_v->bottomlimit_rectangle.x = prec->x;
prec_v->bottomlimit_rectangle.y= prec->y + prec->height - prec->height/10;
prec_v->bottomlimit_rectangle.width = new_width - 3;
prec_v->bottomlimit_rectangle.height = prec->height/10;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&prec_v->bottomlimit_rectangle, pdl_context->pfont_table,
	prec_v->bottom_limit.string, prec_v->bottom_limit.len,
	box_end);
if(label_flag == dl_label_channel) {
	prec_v->channel_name.len=strlen(prec_v->channel_name.string);
	prec_v->channel_name_rectangle.x = prec->x + (new_width/2);
	prec_v->channel_name_rectangle.y = prec->y +  label_height;
	prec_v->channel_name_rectangle.width =  new_width/2;
	prec_v->channel_name_rectangle.height = prec->height -
							(label_height*2);

	draw_vertical_string(pdl_context->d, pdl_context->w, pdl_context->gc,
				&prec_v->channel_name_rectangle,
				pdl_context->pfont_table,
				prec_v->channel_name.string, 
				prec_v->channel_name.len,box_begin);
   }
}

init_rec_r(pdl_context, prec, low_val, high_val, redraw_flag, value,
		 prectangle, label_flag, chan_str)

struct dl_context *pdl_context;
XRectangle *prec;
struct rectangle *prectangle;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;

{
XFontStruct *font_info;
XFontStruct *XLoadQueryFont();
int i, zero_point_x, center_y2, high, low, rec_y, new_height, half_offset;
int mid_mark, mark, mark2, offset, quarter_offset, tick_y,half_tick_y;
float percentage, full_range, mid_val;
unsigned long saveforegroundcolor;

saveforegroundcolor = pdl_context->gc->values.foreground;
/*************the following code is for a redraw only ************************/
if(redraw_flag) {
	/* fill entire area with background color */
	XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
	if(label_flag != dl_label_none) {
	   /*draw outline with outline color */
	   XSetForeground(pdl_context->d, pdl_context->gc,
		prectangle->hdr.foregroundcolor);
	   XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prectangle->new_height+1);
	}
	/* label the object, if necessary */
	if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)){
		/*draw the tick marks */
		XDrawSegments(pdl_context->d, pdl_context->w,pdl_context->gc,
			prectangle->ticks,9);
		/*draw the low limit */
		draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc,
			&prectangle->rightlimit_rectangle,
			pdl_context->pfont_table,
			prectangle->right_limit.string,
			prectangle->right_limit.len, box_end);
		/*draw the high limit */
   		draw_horizontal_string(pdl_context->d, pdl_context->w,
			 pdl_context->gc,
			&prectangle->leftlimit_rectangle,
			pdl_context->pfont_table, prectangle->left_limit.string,
			prectangle->left_limit.len, box_begin);
		if(label_flag = dl_label_channel) 
			/*draw the channel name */
			draw_horizontal_string(pdl_context->d, pdl_context->w,
				 pdl_context->gc,
				&prectangle->channel_name_rectangle,
				pdl_context->pfont_table,
				 prectangle->channel_name.string,
				prectangle->channel_name.len, box_begin);

	}
	prectangle->old_x = prec->x + prec->width;
	/* change foreground color back to original value */
	XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);
	/*display data in object */
	FillRecRtToLt(pdl_context, prec, value, low_val, high_val, prectangle);
	return;
}
/******************************************************************************/
/* the following code builds all info into structures */

if(label_flag == dl_label_limits) {
	/* resize to inside bounding box */
	offset = prec->height/3;
	new_height = prec->height - offset - 5;
	rec_y = prec->y + prec->height - offset - 5;
	tick_y = prec->y + new_height + 5;
	half_tick_y = prec->y + new_height + 3;
	/*rec_y = prec->y + new_height;*/
}
else  if(label_flag == dl_label_channel) {
		offset = prec->height/3;
		new_height = prec->height - (offset*2) - 5;
		tick_y = prec->y + new_height + 5;
		half_tick_y = prec->y + new_height + 3;
		rec_y = prec->y + new_height;
     }
else {
	rec_y = prec->y;
	new_height = prec->height;
}
/*fill in rectangle area with background color */
XSetForeground(pdl_context->d, pdl_context->gc,
		pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /* draw the outline in outline color */
   XSetForeground(pdl_context->d, pdl_context->gc,
		prectangle->hdr.foregroundcolor);
   XDrawRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, new_height);
}
prectangle->range = high_val - low_val;
prectangle->old_x = prec->x + prec->width;
prectangle->inside_x = prec->x + 1;
prectangle->inside_y = prec->y + 1;
prectangle->new_height = new_height - 1;
prectangle->label_flag = label_flag;
prectangle->outofrange = 0;
	
/* now label the figure, if needed*/
if((label_flag == dl_label_limits) || (label_flag == dl_label_channel)) {
	mid_mark = prec->width/2;
	mark = mid_mark/2;
	mark2 = mark/2;
	for(i=0; i<9; i++)
		prectangle->ticks[i].y1 = rec_y;
	for(i=0; i<9; i+=2)
		prectangle->ticks[i].y2 = tick_y;
	for(i=1; i<8; i+=2)
		prectangle->ticks[i].y2 = half_tick_y;
	prectangle->ticks[0].x1 = prectangle->ticks[0].x2 = prec->x;
	prectangle->ticks[8].x1 = prectangle->ticks[8].x2 = prec->x
		 + prec->width;
	prectangle->ticks[4].x1 = prectangle->ticks[4].x2 = prec->x + mid_mark;
	prectangle->ticks[2].x1 = prectangle->ticks[2].x2 = prec->x + mark;
	prectangle->ticks[6].x1 = prectangle->ticks[6].x2 = prec->x +
			mid_mark + mark;
	prectangle->ticks[1].x1 = prectangle->ticks[1].x2 = prec->x + mark2;
	prectangle->ticks[5].x1 = prectangle->ticks[5].x2 = prec->x +
			 mid_mark + mark2;
	prectangle->ticks[3].x1 = prectangle->ticks[3].x2 = prec->x +
			 mark + mark2;
	prectangle->ticks[7].x1 = prectangle->ticks[7].x2 =
			 prec->x+mid_mark+mark2+mark;
	f_to_str(low_val,prectangle->right_limit.string,
				 prectangle->hdr.precision);
	f_to_str(high_val,prectangle->left_limit.string,
				prectangle->hdr.precision);
	strncpy(prectangle->channel_name.string, chan_str, 14);
	draw_text_rec(pdl_context,offset, prec, prectangle,
				  label_flag, new_height);
	/* draw extra tick marks */
	XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
			prectangle->ticks,9);
	
}
/*change foreground color back to original color */
XSetForeground(pdl_context->d, pdl_context->gc, saveforegroundcolor);

/* now display data in object */
FillRecRtToLt(pdl_context, prec, value, low_val, high_val, prectangle);
}

init_indicatorR(pdl_context, prec, low_val,
			high_val, redraw_flag, value, pindicator,
			label_flag, chan_str)
struct dl_context *pdl_context;
XRectangle *prec;
struct indicator *pindicator;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;
		
{
int offset, tick_x, half_tick_x, new_width, mid_mark, mark, mark2, rec_x,i;
unsigned long saveforegroundcolor;

saveforegroundcolor = pdl_context->gc->values.foreground;

/*execute the following code only on a redraw */
/****************************************************************************/
if(redraw_flag) {
	rec_x = prec->x + prec->width;
	/* fill background area with background color */
	XSetForeground(pdl_context->d, pdl_context->gc,
			pdl_context->gc->values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
	XSetForeground(pdl_context->d, pdl_context->gc,
 		pindicator->hdr.foregroundcolor);
	if(label_flag != dl_label_none) {
	   /* draw outline in outline color */
	   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		rec_x, prec->y, rec_x, prec->y+prec->height);
	   /*draw the tick marks*/
	   XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->ticks,9);
	   if((label_flag == dl_label_limits)||(label_flag==dl_label_channel)) {
	   /* label the figure appropriately*/
	   /* draw the high and low limits */
		draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->toplimit_rectangle,
			pdl_context->pfont_table, pindicator->top_limit.string,
			pindicator->top_limit.len, box_end);
		draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->bottomlimit_rectangle,
			pdl_context->pfont_table,
			 pindicator->bottom_limit.string,
			pindicator->bottom_limit.len, box_end);
			if(label_flag == dl_label_channel) 
			    /*draw channel name */
			   draw_vertical_string(pdl_context->d, pdl_context->w,
				pdl_context->gc,
				&pindicator->channel_name_rectangle,
				pdl_context->pfont_table,
				pindicator->channel_name.string,
				pindicator->channel_name.len, box_center);
	   }
	}
	  
	/* put newest value on the display. Reset clip mask first */
	update_indicatorR(pdl_context, value, pindicator, new_width);
	return;
}
/******************************************************************************/

offset = prec->width/2;
new_width = offset;
rec_x = prec->x + prec->width;
tick_x = rec_x - 5;
half_tick_x = rec_x - 3;

  
/* fill background area with background color */
XSetForeground(pdl_context->d, pdl_context->gc,
			pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /* draw line in outline color */
   XSetForeground(pdl_context->d, pdl_context->gc,
				 pindicator->hdr.foregroundcolor);
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		rec_x, prec->y, rec_x, prec->y+prec->height);
   /* set up tick marks */
   mid_mark = prec->height/2;
   mark = mid_mark/2;
   mark2 = mark/2;

   for(i=0;i<9;i++)
	pindicator->ticks[i].x1 = rec_x;
   for(i=0;i<9;i+=2)
	pindicator->ticks[i].x2 = tick_x;
   for(i=1;i<8;i+=2)
	pindicator->ticks[i].x2 = half_tick_x;

   pindicator->ticks[0].y1 = pindicator->ticks[0].y2 =  prec->y+prec->height;
   pindicator->ticks[8].y1 = pindicator->ticks[8].y2 = prec->y;
   pindicator->ticks[4].y1 = pindicator->ticks[4].y2 =  prec->y+mid_mark;
   pindicator->ticks[6].y1 = pindicator->ticks[6].y2 = prec->y+mark;
   pindicator->ticks[2].y1 =pindicator->ticks[2].y2 = prec->y + mid_mark + mark;
   pindicator->ticks[7].y1 = pindicator->ticks[7].y2 = prec->y + mark2;
   pindicator->ticks[3].y1=pindicator->ticks[3].y2=prec->y + mid_mark + mark2;
   pindicator->ticks[5].y1 = pindicator->ticks[5].y2 = prec->y + mark + mark2;
   pindicator->ticks[1].y1=pindicator->ticks[1].y2=prec->y+mid_mark+mark+mark2;
   XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->ticks,9);
}
/*determine proper size of triangle.  maintain slope = 3/4 */
   pindicator->run = (new_width/4)*3;
/*determine points of triangle at low_val */
   pindicator->points_array[0].x = rec_x - 1;
   pindicator->points_array[0].y = prec->y + prec->height;
   pindicator->points_array[1].x = rec_x - new_width + 2;
   pindicator->points_array[1].y = prec->y + prec->height - pindicator->run/2;
   pindicator->points_array[2].x = rec_x - new_width + 2;
   pindicator->points_array[2].y = prec->y + prec->height + pindicator->run/2;
   pindicator->points_array[3].x = rec_x - 1;
   pindicator->points_array[3].y = prec->y + prec->height;
   pindicator->origin_x = rec_x - 1;
   pindicator->origin_y = prec->y + prec->height;

/* set various values in indicator structure */
   pindicator->old_x = prec->y + prec->height;   /* old_x should read old_y */
   pindicator->full_range = high_val - low_val;
   pindicator->width = new_width;
   pindicator->low_val = low_val;
   pindicator->indicator_height = prec->height;
   pindicator->space = pindicator->indicator_height/8;
   pindicator->half_space = pindicator->space/2;
   pindicator->label_flag = label_flag;
   pindicator->outofrange = 0;
   pindicator->indicator_save_pixmap = pdl_context->gc->values.clip_mask;

if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)){
	f_to_str(low_val,pindicator->bottom_limit.string,
			pindicator->hdr.precision);
	f_to_str(high_val,pindicator->top_limit.string,
			pindicator->hdr.precision);
	strncpy(pindicator->channel_name.string, chan_str, 14);
	label_indicator_vertR(pdl_context, prec, new_width, label_flag,pindicator);
}

/* set clipping region */
/* save clip_mask in GC */
   pindicator->indicator_save_pixmap = pdl_context->gc->values.clip_mask;
   pindicator->region = XCreateRegion();
   pindicator->indicator_rectangle.x = rec_x - new_width;
   pindicator->indicator_rectangle.y = prec->y+1;
   pindicator->indicator_rectangle.width = new_width;
   pindicator->indicator_rectangle.height = prec->height-1;
   XUnionRectWithRegion(&pindicator->indicator_rectangle, 
			pindicator->region, pindicator->region);
   XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region); 

/* fill the polygon at low_val*/
XSetForeground (pdl_context->d, pdl_context->gc, saveforegroundcolor);
XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->points_array, 4, Complex, CoordModeOrigin);
/*call update routine to put first value on display */
/*restore the clip_mask first*/
XSetClipMask(pdl_context->d, pdl_context->gc,
                                   pindicator->indicator_save_pixmap);
update_indicatorR(pdl_context, value, pindicator, new_width);
}

label_indicator_vertR(pdl_context, prec, offset,
			label_flag, pindicator)
struct dl_context *pdl_context;
struct indicator *pindicator;
XRectangle *prec;
int offset;
short label_flag;

{
int label_height, smallest_height, ycentered, len2, len3, len4, width2, width3;
int starting_point_x, starting_point_y;

label_height = prec->height/10;
/*need length of strings*/
pindicator->bottom_limit.len = strlen(pindicator->bottom_limit.string);  
pindicator->top_limit.len = strlen(pindicator->top_limit.string);

/*output the text */
pindicator->toplimit_rectangle.x = prec->x;
pindicator->toplimit_rectangle.y = prec->y;
pindicator->toplimit_rectangle.width = offset;
pindicator->toplimit_rectangle.height = label_height;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&pindicator->toplimit_rectangle, pdl_context->pfont_table,
	pindicator->top_limit.string, pindicator->top_limit.len, dl_horiz_left);
pindicator->bottomlimit_rectangle.x = prec->x;
pindicator->bottomlimit_rectangle.y = prec->y + prec->height - label_height;
pindicator->bottomlimit_rectangle.width = offset;
pindicator->bottomlimit_rectangle.height = label_height;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&pindicator->bottomlimit_rectangle, pdl_context->pfont_table,
	pindicator->bottom_limit.string, 
	pindicator->bottom_limit.len, dl_horiz_left);
if(label_flag == dl_label_channel) {
	pindicator->channel_name.len = strlen(pindicator->channel_name.string);
	pindicator->channel_name_rectangle.x = prec->x ;
	pindicator->channel_name_rectangle.y = prec->y + label_height;
	pindicator->channel_name_rectangle.width = offset;
	pindicator->channel_name_rectangle.height = 
			prec->height - (label_height*2);
	draw_vertical_string(pdl_context->d, pdl_context->w, pdl_context->gc,
				&pindicator->channel_name_rectangle,
				pdl_context->pfont_table,
				pindicator->channel_name.string,
				 pindicator->channel_name.len,
				dl_vert_center);
}
}	

init_indicatorL(pdl_context, prec, low_val,
			high_val, redraw_flag, value, pindicator,
			label_flag, chan_str)

struct dl_context *pdl_context;
XRectangle *prec;
struct indicator *pindicator;
short redraw_flag, label_flag;
float low_val, high_val, value;
char *chan_str;
		
{

int offset, tick_x, half_tick_x, new_width, mid_mark, mark, mark2,i;
unsigned long saveforegroundcolor;

saveforegroundcolor = pdl_context->gc->values.foreground;
/* execute the following code only on a redraw */
/**************************************************************************/
if(redraw_flag) {
	/* fill background area with background color */
	XSetForeground(pdl_context->d, pdl_context->gc,
			pdl_context->gc->values.background);
	XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
 	XSetForeground(pdl_context->d, pdl_context->gc,
 		pindicator->hdr.foregroundcolor);
	if(label_flag != dl_label_none) {
	   /* draw outline in outline color */
	   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->x, prec->y+prec->height);
	   /*draw the tick marks*/
 	   XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->ticks,9);
  	   if((label_flag==dl_label_limits)||(label_flag == dl_label_channel)) {
	   /* label the figure appropriately*/
		/* draw the high and low limits */
		draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->toplimit_rectangle,
			pdl_context->pfont_table, pindicator->top_limit.string,
			pindicator->top_limit.len, box_begin);
		draw_horizontal_string(pdl_context->d, pdl_context->w,
			pdl_context->gc, &pindicator->bottomlimit_rectangle,
			pdl_context->pfont_table,
			pindicator->bottom_limit.string,
			pindicator->bottom_limit.len, box_begin);
		if(label_flag == dl_label_channel) 
			/*draw channel name */
			draw_vertical_string(pdl_context->d, pdl_context->w,
				pdl_context->gc,
				&pindicator->channel_name_rectangle,
				pdl_context->pfont_table,
				pindicator->channel_name.string,
				pindicator->channel_name.len, box_center);
	   }
	} 
	/* put newest value on the display. Reset clip mask first */
	update_indicatorL(pdl_context, value, pindicator, new_width);
	return;
}
/******************************************************************************/

/*execute the following code on a true initialization.  all tables are built */

tick_x = prec->x + 5;
half_tick_x = prec->x + 3;
offset = prec->width/2;
new_width = offset;
  
/* fill background area with background color */
XSetForeground(pdl_context->d, pdl_context->gc,
			pdl_context->gc->values.background);
XFillRectangle(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->width, prec->height);
if(label_flag != dl_label_none) {
   /* draw outline in outline color */
   XSetForeground(pdl_context->d, pdl_context->gc, 
				pindicator->hdr.foregroundcolor);
   XDrawLine(pdl_context->d, pdl_context->w, pdl_context->gc,
		prec->x, prec->y, prec->x, prec->y+prec->height);

   /* Draw the tick marks in green */
   mid_mark = prec->height/2;
   mark = mid_mark/2;
   mark2 = mark/2;
  
   for(i=0;i<9;i++)
	pindicator->ticks[i].x1 = prec->x;
   for(i=0;i<9;i+=2)
	pindicator->ticks[i].x2 = tick_x;
   for(i=1;i<8;i+=2)
	pindicator->ticks[i].x2 = half_tick_x;

   pindicator->ticks[0].y1 = pindicator->ticks[0].y2 = prec->y + prec->height;
   pindicator->ticks[8].y1 = pindicator->ticks[8].y2 = prec->y;
   pindicator->ticks[4].y1 = pindicator->ticks[4].y2 = prec->y+mid_mark;
   pindicator->ticks[6].y1 = pindicator->ticks[6].y2 = prec->y+mark;
   pindicator->ticks[2].y1 = pindicator->ticks[2].y2 = prec->y+mid_mark+mark;
   pindicator->ticks[7].y1 = pindicator->ticks[7].y2 = prec->y + mark2;
   pindicator->ticks[3].y1 = pindicator->ticks[3].y2 = prec->y+mid_mark+mark2;
   pindicator->ticks[5].y1 = pindicator->ticks[5].y2 = prec->y+mark+mark2;
   pindicator->ticks[1].y1=pindicator->ticks[1].y2=prec->y+mid_mark+mark+mark2; 
   XDrawSegments(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->ticks,9);
}
/*determine proper size of triangle.  maintain slope = 3/4 */
pindicator->run = (new_width/4)*3;

/*determine points of triangle at low_val */
pindicator->points_array[0].x = prec->x+1;
pindicator->points_array[0].y = prec->y + prec->height;
pindicator->points_array[1].x = prec->x + new_width - 2;
pindicator->points_array[1].y = prec->y + prec->height - pindicator->run/2;
pindicator->points_array[2].x = prec->x + new_width - 2;
pindicator->points_array[2].y = prec->y + prec->height + pindicator->run/2;
pindicator->points_array[3].x = prec->x + 1;
pindicator->points_array[3].y = prec->y + prec->height;
pindicator->origin_x = prec->x + 1;
pindicator->origin_y = prec->y + prec->height;

/* set various values in indicator structure */
pindicator->old_x = prec->y + prec->height;  /* old_x should read old_y */ pindicator->full_range = high_val - low_val;
pindicator->width = new_width;
pindicator->low_val = low_val;
pindicator->indicator_height = prec->height;
pindicator->space = pindicator->indicator_height/8;
pindicator->half_space = pindicator->space/2;
pindicator->label_flag = label_flag;
pindicator->outofrange = 0;
pindicator->indicator_save_pixmap = pdl_context->gc->values.clip_mask;

if((label_flag == dl_label_limits)||(label_flag == dl_label_channel)){
	f_to_str(low_val,pindicator->bottom_limit.string,
					pindicator->hdr.precision);
	f_to_str(high_val,pindicator->top_limit.string,
					pindicator->hdr.precision);
	strncpy(pindicator->channel_name.string, chan_str, 14);
	label_indicator_vert(pdl_context, prec, new_width, label_flag, pindicator);
}
/* set clipping region */
/* save clip_mask in GC */
pindicator->indicator_save_pixmap = pdl_context->gc->values.clip_mask;
pindicator->region = XCreateRegion();
pindicator->indicator_rectangle.x = prec->x;
pindicator->indicator_rectangle.y = prec->y+1;
pindicator->indicator_rectangle.width = new_width;
pindicator->indicator_rectangle.height = prec->height-1;
XUnionRectWithRegion(&pindicator->indicator_rectangle, 
			pindicator->region, pindicator->region);
XSetRegion(pdl_context->d, pdl_context->gc, pindicator->region);
/* fill the polygon at low_val*/
XSetForeground (pdl_context->d, pdl_context->gc, saveforegroundcolor);
XFillPolygon(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->points_array, 4, Complex, CoordModeOrigin);
/*call update routine to put first value on display */
/*restore the clip_mask first*/
XSetClipMask(pdl_context->d, pdl_context->gc,
                                   pindicator->indicator_save_pixmap);
update_indicatorL(pdl_context, value, pindicator, new_width);
}

label_indicator_vert(pdl_context, prec, offset, 
			label_flag, pindicator)
struct dl_context *pdl_context;
struct indicator *pindicator;
XRectangle *prec;
int offset;
short label_flag;

{
XFontStruct *pfont;
int label_height, smallest_height, ycentered, len2, len3, len4, width2, width3;
int starting_point_x, starting_point_y;

label_height = prec->height/10;
/*need length  of strings*/
pindicator->bottom_limit.len = strlen(pindicator->bottom_limit.string);  
pindicator->top_limit.len = strlen(pindicator->top_limit.string);

/*output the text */
pindicator->toplimit_rectangle.x = prec->x + offset;
pindicator->toplimit_rectangle.y = prec->y;
pindicator->toplimit_rectangle.width = offset;
pindicator->toplimit_rectangle.height = label_height;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&pindicator->toplimit_rectangle, pdl_context->pfont_table,
	pindicator->top_limit.string, pindicator->top_limit.len, dl_horiz_right);
pindicator->bottomlimit_rectangle.x = prec->x + offset;
pindicator->bottomlimit_rectangle.y = prec->y + prec->height - prec->height/10;
pindicator->bottomlimit_rectangle.width = offset;
pindicator->bottomlimit_rectangle.height = label_height;
draw_horizontal_string(pdl_context->d, pdl_context->w, pdl_context->gc,
	&pindicator->bottomlimit_rectangle, pdl_context->pfont_table,
	pindicator->bottom_limit.string,
	 pindicator->bottom_limit.len, dl_horiz_right);
/*pindicator->high_index.starting_point_x = prec->x + pindicator->width + 3;
pindicator->high_index.starting_point_y = prec->y + pindicator->pfont->ascent;
tisDrawImageString(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->high_index.starting_point_x, 
		pindicator->high_index.starting_point_y, 
		pindicator->high_index.string, pindicator->high_index.len);
pindicator->low_index.starting_point_y = prec->y + prec->height;
pindicator->low_index.starting_point_x = prec->x + pindicator->width + 3;
tisDrawImageString(pdl_context->d, pdl_context->w, pdl_context->gc,
		pindicator->low_index.starting_point_x, 
		pindicator->low_index.starting_point_y, 
		pindicator->low_index.string, 
		pindicator->low_index.len);*/
if(label_flag == dl_label_channel) {
	pindicator->channel_name.len = strlen(pindicator->channel_name.string);
	pindicator->channel_name_rectangle.x = prec->x + offset;
	pindicator->channel_name_rectangle.y = prec->y + label_height;
	pindicator->channel_name_rectangle.width = offset;
	pindicator->channel_name_rectangle.height = 
				prec->height - (label_height*2);
	draw_vertical_string(pdl_context->d, pdl_context->w, pdl_context->gc,
				&pindicator->channel_name_rectangle,
				pdl_context->pfont_table,
				pindicator->channel_name.string,
				 pindicator->channel_name.len, box_center);
}
}



