#include "opiStringDefs.h"
extern	char	*opiStringTab[];
/*t_kill_displays.c,v 1.1.1.1 1999/08/03 14:43:50 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/***********************************************************************
**
**	KILL_DISPLAY.C
**	
**	Stolen from Deb Kerstiens related_displays.c of 12/90
**
**	Modification History:
**
*/
#include <X11/Xlib.h>      			/* the X library 		*/
#ifdef WIN32
#include <X11/XlibXtra.h>
#include <winsock.h>
#endif WIN32
#include <X11/Xutil.h>
#include <db_access.h>
#include <cadef.h>
#include <dldef.h>			/* display list defines 	*/
#include <dlinfo.h>			/* more display list defines 	*/
#include <dl_context.h>			/* defines dl context		*/
#include <gizmo.h>			/* defs for gizmos */
#include <op_gsdl_def.h>
#include <dynamic_def.h>		/* rti dynamic defines		*/

#ifdef AXP
#include <string.h>
#endif

extern void *tisMalloc();
extern void *tisCalloc();
extern void tisFree();

/************************************************************************************
*
*	setup_kill_Displays
*
*	DK 12/16/90
*
*	Setup_kill_displays retrieves the appropriate info from the display list 
*	and sets up the message button gizmo to allow the operator to kill the display. 
*	From this point on, the screen updates will be handled by the gizmo and 
*	the appropriate actions, i.e. new display deletion, will be when the handler 
*	specifed during message gizmo creation is called(when a button is pushed.)
*
*
*/
void setup_kill_displays(pDm_llist_hdr, pDlc, pDm_llist_el, pDl_kill_display, nkd, pdl_index)
struct dm_llist_hdr			*pDm_llist_hdr;
struct dl_context 			*pDlc;
struct dm_llist_el			*pDm_llist_el;
struct dl_kill_display	 		*pDl_kill_display;
short 					nkd;
#ifndef AXP
int					*pdl_index;
#else
unsigned long				*pdl_index;
#endif
	{
	/* set up table of string ptrs for menu gizmo */    
	int							i;
	void						kill_display();
	char						**pDl_str_table	= pDm_llist_el->pdl_strings;
	struct rti_kill_display		*pRti_kill_display;
	struct dl_kill_display		*pDl;
	
	if (nkd <= 0)
		return;
	pDm_llist_el->prti_kill_display = (struct rti_kill_display *)
			tisCalloc(__FILE__, __LINE__, nkd, sizeof (struct rti_kill_display));
	if (pDm_llist_el->prti_kill_display == NULL)
		return;

	/* set up table of string pointers for gizmo in user extension */
	for (pRti_kill_display = pDm_llist_el->prti_kill_display, pDl = pDl_kill_display, i = 0; i < nkd; i++, pRti_kill_display++)
		{
		char	*(tmp_string_list[2]);
		
		/* may not need this one */
		pRti_kill_display->pDl_kill_display	= pDl;
		pRti_kill_display->pDm_llist_hdr	= pDm_llist_hdr;
		pRti_kill_display->pDm_llist_el		= pDm_llist_el;
		tmp_string_list[0] = opiStringTab[STR_Kill_Display                ];
		tmp_string_list[1] = (strlen(pDl_str_table[(int)(pDl->label)]) > 0) ? pDl_str_table[(int)(pDl->label)] : opiStringTab[STR_Kill_Display                ];
		
    	pRti_kill_display->pgz = create_message_gizmo(DefaultScreenOfDisplay(pDlc->d),
									pDlc->w,
									&(pDl->object), 
									ok_to_operate,
									kill_display,
									pRti_kill_display,
									tmp_string_list,
									0, NULL, NULL, 0);

		if(pRti_kill_display->pgz != NULL)
			{
			XMapWindow(pRti_kill_display->pgz->pgg->d, pRti_kill_display->pgz->w);
			set_gizmo_color(pRti_kill_display->pgz, COLOR_LOOKUP(pdl_index, pDl->clr), COLOR_LOOKUP(pdl_index, pDl->bclr));
			}
		pDl = (struct dl_kill_display *)((short *)pDl + ((struct dl_element_hdr *)pDl)->nwords);
		}
	} 

 
/************************************************************************************
*
*	kill_display
*
*
*	kill_display is the handler specifed during message button gizmo creation 
*	to be called when the button is pressed.
*
*
*	Input	: pRti_kill_display 	ptr to kill display struct
*		  pg			ptr to a gizmo
*	Returns	: nothing
*/
void kill_display(pRti_kill_display, pg, depressed, pevent)
struct rti_kill_display	*pRti_kill_display;
gizmo					*pg;
int						depressed;
XEvent					*pevent;
	{
	if (!depressed)
		/*
		 * kill this display just like hitting the exit from the menu
		 */
		dmExit_display(pRti_kill_display->pDm_llist_hdr, pRti_kill_display->pDm_llist_el, pevent);
	}

/***********************************************************************
**
**	Delete_kill_displays
**	
**
**	Purpose : This routine deletes the "gizmos" that have been created
**			for operator control.  Delete_controllers is called
**			when a display (dm_llist_el) is to be deleted to delete 
**			each gizmo that is currently active.  This must be
**			done so that when the parent (display) window is
**			deleted, the child window created for each gizmo will
**			already have been deleted.
**
**	Input :
**	    prti	: ptr to the run-time list for kill displays
**	    nctrl	: count of execute kill displays to delete
**	Output :
**	    none
**	Returns
**	    none
**
**********************************************************************/

void delete_kill_displays(prti, nkd)
struct rti_kill_display 	*prti;
unsigned short				nkd;
	{
 	if (nkd > 0)
		{
		int		i;
 
		for(i = 0; i < nkd; prti++, i++)
			if(prti->pgz != NULL)
				free_gizmo(prti->pgz);
		}
	}
