#include "opiStringDefs.h"
extern	char	*opiStringTab[];
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 *	M E N U _ A C T I O N S . C
 *
 *	Author: Jeffrey O. Hill
 *		hill@luke.lanl.gov
 *		(505) 665-1831
 *
 *
 *	History:
 *
 * 
 * 
 * 
 * 
 * 
 */
#if !(defined(AXP) || defined(WIN32))
#include <wait.h>
#endif
#include <X11/Xlib.h>
#ifdef WIN32
#include <X11/XlibXtra.h>
#endif WIN32
#include <X11/Xutil.h>

#ifdef WIN32
#include <process.h>
#endif WIN32

#include <edd.h>
#include <dlinfo.h>

#ifdef AXP
#include <string.h>
#endif

extern void *tisMalloc();
extern void *tisCalloc();
extern void tisFree();


/*
 *	EM_CREATE()
 *	(see edd_menus.h)
 */
void
em_create(param, pdue, pbe)
void		*param;
due		*pdue;
XButtonEvent	*pbe;
{
	enum dl_elements 	go = (int) param;
	struct dl_anygo		newgo;
	eue			*peue;
	XPoint			p1;
	XPoint			p2;
	XRectangle		rec;
	struct dl_line		newline;
	
	/*
	 *	Normally a popup menu is up prior to this
	 *	call. If the server does not do backing
	 *	store or it does not do it in all instances
	 *	I must search for the expose event for the
	 *	obscured portion of the draw window.
	 *
	 *	The XSync forces the expose event to be
	 *	processed.
	 */
	XSync(pdue->d, False);
	while(TRUE){
		XEvent		ev;
		Bool		status;

		status = XCheckWindowEvent(
				pdue->d, 
				pdue->dlc.w, 
				ExposureMask,
				&ev);
		if(status){
			rec.x = ev.xexpose.x;
			rec.y = ev.xexpose.y;
			rec.width = ev.xexpose.width;
			rec.height = ev.xexpose.height;
			redraw_dl(pdue, &rec);
		}else{
			break;
		}
	}

	p1.x = pbe->x;
	p1.y = pbe->y;
	p2.x = p1.x + mm_to_xpixel(CREATE_DEFAULT_SIZE_MM, pdue->s);
	p2.y = p1.y + mm_to_ypixel(CREATE_DEFAULT_SIZE_MM, pdue->s);
	if (go == dl_line){
		int	i;

		newline.element.type = go;
		newline.element.nwords = WDRND(dl_elements_ginfo[go].size);
		newline.point[0] = *(struct dl_point *)&p1;
		for(i = 1; i < MAX_NPOINTS; i++){
			short	x;
			short	y;
			
			x = newline.point[i].x = newline.point[i-1].x + mm_to_xpixel(CREATE_DEFAULT_SIZE_MM, pdue->s);
			y = newline.point[i].y = newline.point[i-1].y + mm_to_ypixel(CREATE_DEFAULT_SIZE_MM, pdue->s);
			get_2nd_coord(	
				pdue->d, 
				pdue->dlc.w, 
				pdue->invert_GC, 
				&(newline.point[i-1]), 
				&(newline.point[i]),
				pdue->create_cursor);
			if((newline.point[i].x == x) && (newline.point[i].y == y)) {
			   	/*
				 * two hits in a row end the line
				 */
				if (newline.npoints == 0)
				    return;
			   	break;
			}
			p1.x = min(p1.x, newline.point[i].x);
			p1.y = min(p1.y, newline.point[i].y);
			p2.x = max(p2.x, newline.point[i].x);
			p2.y = max(p2.y, newline.point[i].y);
			newline.npoints = i+1;
			rec.x = p1.x;
			rec.y = p1.y;
			rec.width = posdiff(p1.x,p2.x);
			rec.height = posdiff(p1.y,p2.y);
			pdue->dlc.fill_style = dl_fill_outline;
			redraw_dl(pdue, &rec);
			newline.object.x = min(p1.x, p2.x);
			newline.object.y = min(p1.y, p2.y);
			newline.object.width = posdiff(p1.x, p2.x);
			newline.object.height = posdiff(p1.y, p2.y);
			draw_static(
				&(pdue->dlc), 
				&newline.element, 
				newline.element.nwords,
				NULL, TRUE);
		}
	} else
	{
		get_2nd_coord(	
			pdue->d, 
			pdue->dlc.w, 
			pdue->invert_GC, 
			&p1, 
			&p2,
			pdue->create_cursor);
	}

	/*
	 * Initialize
	 * 
	 * default additional fields to nil
	 */
	newgo.element.type	= go;
	newgo.element.nwords	= WDRND(dl_elements_ginfo[go].size);
	newgo.object.x		= min(p1.x, p2.x);
	newgo.object.y		= min(p1.y, p2.y);
	newgo.object.width	= posdiff(p1.x, p2.x);
	newgo.object.height	= posdiff(p1.y, p2.y);
	newgo.groupid		= NO_GROUP;

	peue = create_element(pdue, &newgo, sizeof(newgo));
	open_structure(dl_elements_ginfo[go].sinfo, &peue->elem.dl_anygo.element, pdue);
	if(dl_element_class[go] == dl_class_graphic){
		open_structure(dl_sta_attr_sinfo, &peue->sta, pdue);
		open_structure(dl_dyn_mod_sinfo, &peue->dyn.mod, pdue);
		if(dynamic_graphical_element(peue)){
			open_structure(dl_dyn_param_sinfo, &peue->dyn.param, pdue);
		}
	}

	switch(go)
	    {
	    case dl_line:
	    	{
	    	unsigned int	i;
		double		x_magnification;
		double		y_magnification;
		
		peue->elem.dl_line.npoints = newline.npoints;
		for (i = 0; i < newline.npoints; i++){
			peue->elem.dl_line.point[i]      = newline.point[i];
			if (newline.object.width)
				x_magnification = (double)(1000.0) / newline.object.width;
			else
				x_magnification = (double)1000000.0; /* close to infinity in this coordinate scheme */
			peue->elem.dl_line.orgpoint[i].x =
				(short)(x_magnification * (newline.point[i].x - newline.object.x));
			if (newline.object.height)
				y_magnification = (double)(1000.0) / newline.object.height;
			else
				y_magnification = (double)1000000.0; /* close to infinity in this coordinate scheme */
			peue->elem.dl_line.orgpoint[i].y =
				(short)(y_magnification * (newline.point[i].y - newline.object.y));
		}
	        break;
		}
	    case dl_arc:
		/*
		 * default arcs to 1/4 rev
 		 */
		peue->elem.dl_arc.path = XDEG_PER_REV>>2;
		break;
	    }

	/*
	 * redraw, but only the portion of the screen which changed
 	 */
	compute_bounds(peue, &rec);
	redraw_objects(pdue, peue, &rec);

	/*
	 * display status
	 */
	sprintf(pdue->pmsg, 
		ELEMENT_FORMAT_STRING,
		dl_elements_einfo[go],
		peue->elem.dl_anygo.object.x,
		peue->elem.dl_anygo.object.y,
		peue->elem.dl_anygo.object.width,
		peue->elem.dl_anygo.object.height);
	redraw_msg(pdue);

	/*
	 * they can undo a create
	 */
	push_create_undo(pdue, peue);
}




/*
 *	GM_ACTIVATE()
 *	(see edd_menus.h)
 *
 */
#include <signal.h>

#ifndef WIN32
/* signal handler for dm child status change */
void wait_for_dm()
{
#ifndef AXP
	wait((int *)0);	/* wait() for dm, this cleans up zombies */
#else
	wait((int *)0);	/* wait() for dm, this cleans up zombies */
#endif
}
#endif WIN32

#ifdef WIN32
static char	ppath[] = "\\tis4000\\temp";
#else
static char	ppath[] = "/tmp";
#endif WIN32
static int	dm_pid	= 0;

void gm_activate(param, pdue, pbe)
void		*param;
due		*pdue;
XButtonEvent	*pbe;
	{
	int		buflen						= strlen(ppath)+1+sizeof(pdue->pname)+1+sizeof(TMP_EXTENSION)+1;
	char	/**calloc(),*/ *pdisplay_name	= 
				(char *) tisCalloc(__FILE__, __LINE__, 1, buflen);

	/*	
	 * update temporary disk binary dl
	 */
	if(edd_path_cat(pdue, ppath, pdue->pname, pdisplay_name, buflen) == ERROR)
		return;

#ifdef WIN32
	if (strchr (pdisplay_name, '.'))
	    *strchr (pdisplay_name, '.') = '_';
#endif WIN32
	strncat(pdisplay_name, TMP_EXTENSION, buflen-strlen(pdisplay_name)-1);
	if(save_display(pdue, pdisplay_name) < 0)
	{
	    return;
	}

#ifndef WIN32
	dm_pid = fork();
	if(dm_pid == 0)
		{

		if(execlp("dm", "dm", pdisplay_name, (char *)NULL) < 0)
			{
			sprintf(pdue->pmsg, opiStringTab[STR_Hs_not_in_the_search_pathn  ], "dm");
			redraw_msg(pdue);
			}
		exit(-1);
		}
	else if(dm_pid > 0)
		{
		printf(opiStringTab[STR_edd_Spawned_dm_with_pid_Hdn ], dm_pid);
		signal(SIGCHLD, wait_for_dm);
		}
#else
    _spawnlp (_P_WAIT, "dm", "dm", pdisplay_name, (char *)NULL);
#endif WIN32
	}



/*
 *	GM_QUIT()
 *	(see edd_menus.h)
 *
 */
void gm_quit(param, pdue, pbe)
void		*param;
due		*pdue;
XButtonEvent	*pbe;
{
	enum choices{cancel, quit, terminate, nchoices};
	static char 	*pmsgs[4];
	char 		*pchoices[nchoices];
	char		command_buffer[256];
	char		pdisplay_name[sizeof(pdue->pname)+sizeof(ppath)+1];

	/*
	 *	Did they save changes ?
	 */
	if(pdue->dl_mdt){
		int choice;

		pchoices[quit] = opiStringTab[STR_quit                        ];
		pchoices[cancel] = opiStringTab[STR_cancel                      ];
		pchoices[terminate] = 0;
		pmsgs[0] = opiStringTab[STR_You_have_not_saved_since_you];
		pmsgs[1] = opiStringTab[STR_Quitting_now_will_discard_ch];
		pmsgs[2] = opiStringTab[STR_Do_you_still_want_to_quit   ];
		pmsgs[3] = 0;

		choice = perform_dialog(
			pdue->s, 
			pbe->x_root,
			pbe->y_root,
			pdue->gizmo_height,
			pmsgs, 
			pchoices, 
			pdue->gizmo_height);
		if(choice == cancel)
			return;
	}

	/*
	 * remove any tmp files from activates
	 */
#ifdef WIN32
	strcpy(command_buffer, "del ");
	edd_path_cat(pdue, ppath, "", pdisplay_name, sizeof(pdisplay_name));
	strcat(strcat(command_buffer, pdisplay_name), TMP_EXTENSION);
	strcat(command_buffer, " ");
	edd_path_cat(pdue, ppath, "*", pdisplay_name, sizeof(pdisplay_name));
	strcat(strcat(command_buffer, pdisplay_name), TMP_EXTENSION);
	system(command_buffer);
#else
	strcpy(command_buffer, "rm -f ");
	edd_path_cat(pdue, ppath, "", pdisplay_name, sizeof(pdisplay_name));
	strcat(strcat(strcat(strcat(command_buffer, pdisplay_name), "\'"), TMP_EXTENSION), "\' ");
	edd_path_cat(pdue, ppath, "*", pdisplay_name, sizeof(pdisplay_name));
	strcat(strcat(strcat(strcat(command_buffer, pdisplay_name), "\'"), TMP_EXTENSION), "\'");
	system(command_buffer);
#endif WIN32
	exit(OK);
}


