#include "opiStringDefs.h"
extern	char	*opiStringTab[];
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
 *	M O D I F Y _ C O L O R . C
 *	Author:		Jeffrey O. Hill
 *			hill@luke.lanl.gov
 *			505 665 1831
 *
 *	Form for modifying a color map
 *
 *
 *	History
 *	-------
 *
 */


#include 	<stdio.h>
#include 	<X11/Xlib.h>
#ifdef WIN32
#include <X11/XlibXtra.h>
#endif WIN32
#include 	<X11/Xutil.h>
#include 	<X11/Xatom.h>

#include 	<edd.h>
#include 	<dlinfo.h>
#include 	<gizmo.h>
#include	<einfoString.h>		/* this file was created by einfoStringConv */

#ifdef TOKENPTRS
#include <tokenSupport.h>
#endif

enum column_headers { 	red_adj_col, 
			green_adj_col, 
			blue_adj_col, 
			blink_button_col, 
			color_col, 
			inten_adj_col,
			inten_col,
			last_col};

struct color_valuator_info{
	gizmo 		*pformg;
	unsigned short 	column;
	unsigned short 	row;
	unsigned short 	colorix;
	short		RISC_pad;
};
struct color_button_info{
	gizmo 		*pformg;
	unsigned short 	column;
	unsigned short 	row;
	unsigned short 	colorix;
	short		RISC_pad;
};

static void 	color_valuator_update();
static void 	color_button_update();
static void 	ncolors_update();
static void 	modify_cmap_finish();
static void 	change_color();
static void 	modify_cmap();
static void 	add_valuator();
static void 	add_button();

static char  *modify_color_choices[] =
{       
	0,
	0
};


/*
 *
 *
 * 	WRITE_CMAP
 * 
 *
 */
write_cmap(pcmap, pstream)
struct color_map		*pcmap;
edd_stream			*pstream;
{
	int			status;
	struct dl_color_map	dlcmap;
	int			body_size;
#	define 			NITEMS 1

	if(pcmap->ncolors == 0)
		return 0;

	body_size = pcmap->ncolors * sizeof(struct dl_color);

	dlcmap.element.type	= dl_color_map;
	dlcmap.element.nwords	= WDRND(sizeof dlcmap + body_size);
	dlcmap.ncolors = pcmap->ncolors;
	status = edd_write(pstream, &dlcmap, sizeof dlcmap);
	assert(status != ERROR);

	status = edd_write(pstream, pcmap->pdl_colors, (dlcmap.element.nwords<<1) - sizeof dlcmap);
	assert(status != ERROR);

	return OK;
}






/*
 *
 *
 * 	CHANGE_COLOR
 * 
 *
 */
static void change_color(s, pcmap, pxcolor, index, mapping, pnewpixel)
Screen			*s;
struct color_map	*pcmap;
XColor			*pxcolor;
unsigned		index;
enum mapping 		mapping;
int			*pnewpixel;
{
	unsigned long	oldpixel;
	Display		*d = DisplayOfScreen(s);

	if(mapping == color_mapping)
		oldpixel = pcmap->pcolor_pixels[index];

	else if(mapping == intensity_mapping)
		oldpixel = pcmap->pinten_pixels[index];
	else
		assert(FALSE);

	free_color(d, oldpixel);
	get_color(d, pcmap, pxcolor, index, mapping, dont_reuse_pixel);
#ifdef NeXT
	*pnewpixel = TRUE;	/* pixel doesn't change on the NeXT since these is no color map */
#else
	if(oldpixel == pxcolor->pixel)
		*pnewpixel = FALSE;
	else
		*pnewpixel = TRUE;
#endif
}



/*
 *
 *
 * 	MODIFY_CMAP
 * 
 *
 */
static void modify_cmap(pdue, x_root, y_root)
due		*pdue;
int		x_root;
int		y_root;
{
	gizmo		*pformg;
	gizmo		*pg;
	unsigned	row = 0;
	XRectangle	obj;
	XRectangle	clrobj;
	XRectangle	butobj;
	unsigned	colorix;
	char		*pname;
	unsigned	length;

#ifndef TOKENPTRS
	stringName(&pdue->st, pdue->dl_hdr.cmap, &pname, &length);
#else
	stringName(&pdue->st, dmPointer64fromToken (pdue->dl_hdr.cmap), &pname, &length);
#endif

	if(*pname != 0){
		enum 		choices{share, cancel, copy, terminate, nchoices};
		static char 	*pmsgs[8];
		char 		*pchoices[nchoices];
		int		choice;

		pmsgs[0] = opiStringTab[STR_This_displays_colors_are_imp];
		pmsgs[1] = opiStringTab[STR_Load_that_display_to_make_sh];
		pmsgs[2] = "";
		pmsgs[3] = opiStringTab[STR__You_may_also_receive_a_loca];
		pmsgs[4] = opiStringTab[STR_which_will_belong_to_this_di];
		pmsgs[5] = opiStringTab[STR_this_choice_will_reduce_the_];
		pmsgs[6] = opiStringTab[STR_available_to_others         ];
		pmsgs[7] = 0;

		pchoices[share] = opiStringTab[STR_share                       ];
		pchoices[cancel] = opiStringTab[STR_cancel                      ];
		pchoices[copy] = opiStringTab[STR_copy                        ];
		pchoices[terminate] = 0;

		choice = perform_dialog(
			pdue->s, 
			x_root, 
			y_root, 
			pdue->gizmo_height, 
			pmsgs, 
			pchoices, 
			pdue->gizmo_height);
		if( choice==cancel || choice==share )
			return;

#ifndef TOKENPTRS
		pdue->dl_hdr.cmap = stringInsert(&pdue->st, "");
#else
		pdue->dl_hdr.cmap = dmTokenFromPointer64 (stringInsert(&pdue->st, ""));
#endif
		edd_create_cmap(  pdue, pdue->dlc.pcmap->pdl_colors,   pdue->dlc.pcmap->ncolors,  0);
		edd_create_crules(pdue, pdue->dlc.pcrules->pdl_crules, pdue->dlc.pcrules->nrules, 0);
	}

	/*
	 *	Dont allow two forms at once
 	 *
 	 */
	if(pdue->dlc.pcmap->ppopg){
		move_gizmo(pdue->dlc.pcmap->ppopg, x_root, y_root);
		return;
	}

	modify_color_choices[0] = opiStringTab[STR_quit                        ];
	modify_color_choices[1] = 0;

	pdue->dlc.pcmap->ppopg = create_popup_gizmo(
				pdue->s, 
				pdue->w,
				opiStringTab[STR_Color_Map_Modify            ],
				x_root, 
				y_root,
				pdue->gizmo_height,
				modify_cmap_finish,
				pdue->dlc.pcmap,
				modify_color_choices,
				0);
	set_gizmo_color(	pdue->dlc.pcmap->ppopg, 
				pdue->foreground.pixel,
				pdue->background.pixel);


	pformg = create_form_gizmo(
				pdue->s, 
				pdue->dlc.pcmap->ppopg->w,
				0, 
				0,
				last_col,
				pdue->dlc.pcmap->ncolors+2,
				pdue->gizmo_pad,
				0);

	/* size known, but position tbd */
	obj.x = 0;
	obj.y = 0;
	obj.height = pdue->gizmo_height;
	obj.width = pdue->gizmo_width;
	clrobj.x = 0;
	clrobj.y = 0;
	clrobj.height = pdue->gizmo_height;
	clrobj.width = pdue->gizmo_width/2; 
	butobj.x = 0;
	butobj.y = 0;
	butobj.height = pdue->gizmo_height;
	butobj.width = pdue->gizmo_width/3; 

	/* input the number of colors */
	form_gizmo_add_string(
				pformg, 
				red_adj_col, 
				row, 
				obj.height,
				opiStringTab[STR_number_of_colors            ]);
#define MAXCOLORCHARS 3
	pg = create_textedit_gizmo(
				pdue->s, 
				pformg->w, 
				&obj, 
				ok_to_operate,
				ncolors_update,
				pdue,
				MAXCOLORCHARS,
				0);
	assert(pg != NULL);
	{
	char  ncolors_string[50];
	
	sprintf(ncolors_string, "%d", pdue->dlc.pcmap->ncolors);
	redraw_header(pdue);
	set_textedit_gizmo(pg, ncolors_string);
	}

	form_gizmo_add_gizmo(
				pformg, 
				green_adj_col, 
				row, 
				pg);

	/* move to a new row */
	row++;
	
	/* add column headers */
	form_gizmo_add_string(
				pformg, 
				red_adj_col, 
				row, 
				obj.height,
				opiStringTab[STR_red                         ]);

	form_gizmo_add_string(
				pformg, 
				green_adj_col, 
				row, 
				obj.height,
				opiStringTab[STR_green                       ]);
	
	form_gizmo_add_string(
				pformg, 
				blue_adj_col, 
				row, 
				obj.height,
				opiStringTab[STR_blue                        ]);
	
	form_gizmo_add_string(
				pformg, 
				blink_button_col, 
				row, 
				obj.height,
				opiStringTab[STR_blink                       ]);
#ifdef COLOR_LABELS	
	form_gizmo_add_string(
				pformg, 
				color_col, 
				row, 
				clrobj.height,
				opiStringTab[STR_color_display               ]);
#endif
	form_gizmo_add_string(
				pformg, 
				inten_adj_col, 
				row, 
				obj.height,
				opiStringTab[STR_intensity                   ]);
#ifdef COLOR_LABELS	
	form_gizmo_add_string(
				pformg, 
				inten_col, 
				row, 
				clrobj.height,
				opiStringTab[STR_intensity_display           ]);
#endif
	/* move to a new row */
	row++;

	for(colorix=0; colorix<pdue->dlc.pcmap->ncolors; colorix++){

		add_valuator(pformg, red_adj_col, row, &obj, pdue, colorix);
		add_valuator(pformg, green_adj_col, row, &obj, pdue, colorix);
		add_valuator(pformg, blue_adj_col, row, &obj, pdue, colorix);
		add_button(pformg, blink_button_col, row, &butobj, pdue, colorix);
		form_gizmo_add_color(
				pformg, 
				color_col, 
				row, 
				clrobj.width, 
				clrobj.height,
				pdue->dlc.pcmap->pcolor_pixels[colorix]);
		if (pdue->dlc.pcmap->pinten_pixels){
			add_valuator(pformg, inten_adj_col, row, &obj, pdue, colorix);
			form_gizmo_add_color(
					pformg, 
					inten_col, 
					row, 
					clrobj.width, 
					clrobj.height,
					pdue->dlc.pcmap->pinten_pixels[colorix]);
		}
		row++;
	}

	resize_form_gizmo(pformg);
	popup_gizmo_add_gizmo(pdue->dlc.pcmap->ppopg, pformg);
/* redundant with popup_gizmo_add_gizmo! agi
**	XMapWindow(pdue->dlc.pcmap->ppopg->pgg->d, pdue->dlc.pcmap->ppopg->w);
*/
}



/*
 *
 *
 * 	MODIFY_CMAP_FINISH
 * 
 *
 */
static void modify_cmap_finish(pcmap)
struct color_map	*pcmap;
{
	free_gizmo(pcmap->ppopg);
	pcmap->ppopg = NULL;
}



/*
 *
 *
 * 	ADD_VALUATOR
 * 
 *
 */
static void add_valuator(pformg, column, row, pobj, pdue, colorix)
gizmo			*pformg;
enum column_headers 	column;
unsigned		row;
XRectangle		*pobj;
due			*pdue;
unsigned		colorix;
{
	float 				ll = DL_MINCOLOR;
	float 				ul = DL_MAXCOLOR;
	gizmo				*pg;
	double				value;
	struct dl_color			*pdlc = 
				&pdue->dlc.pcmap->pdl_colors[colorix];
	struct color_valuator_info	*pcvi;

	pg = create_valuator_gizmo(
					pformg->pgg->s, 
					pformg->w, 
					pobj,
					ok_to_operate,
					color_valuator_update,
					pdue,
					ll,
					ul,
					gz_point_down,
					sizeof(struct color_valuator_info));

	if(pg){
		switch(column){
		case red_adj_col:	value = pdlc->r;	break;
		case green_adj_col:	value = pdlc->g;	break;
		case blue_adj_col:	value = pdlc->b;	break;
		case inten_adj_col:	value = pdlc->inten;	break;
		default:		assert(FALSE);
		}

		pcvi = (struct color_valuator_info *) pg->pae;
		pcvi->column = column;
		pcvi->row = row;
		pcvi->colorix = colorix;
		pcvi->pformg = pformg;

		set_valuator_gizmo(	pg, 
					value);	
		form_gizmo_add_gizmo(
				pformg, 
				column, 
				row, 
				pg);
	}

}



/*
 *
 *
 * 	COLOR_VALUATOR_UPDATE
 * 
 *
 */
static void color_valuator_update(pdue, pg, value)
due		*pdue;
gizmo		*pg;
double		value;
{
	Display				*d = pg->pgg->d;
	struct color_valuator_info	*pcvi;
	struct dl_color			*pdlc;
	XColor				xcolor;
	enum mapping 			mapping;
	int				newpixel;
	enum column_headers		update_column;

	pdue->dl_mdt = TRUE;

	pcvi = (struct color_valuator_info *) pg->pae;
	pdlc = &pdue->dlc.pcmap->pdl_colors[pcvi->colorix];

	switch(pcvi->column){
	case red_adj_col:
		pdlc->r = value;
		xcolor.red = pdlc->r << NBBY;
		xcolor.green = pdlc->g << NBBY;
		xcolor.blue = pdlc->b << NBBY;
		mapping = color_mapping;
		update_column = color_col;
		break;
	case green_adj_col:
		pdlc->g = value;
		xcolor.red = pdlc->r << NBBY;
		xcolor.green = pdlc->g << NBBY;
		xcolor.blue = pdlc->b << NBBY;
		mapping = color_mapping;
		update_column = color_col;
		break;
	case blue_adj_col:
		pdlc->b = value;
		xcolor.red = pdlc->r << NBBY;
		xcolor.green = pdlc->g << NBBY;
		xcolor.blue = pdlc->b << NBBY;
		mapping = color_mapping;
		update_column = color_col;
		break;
	case inten_adj_col:
		pdlc->inten = value;
		xcolor.red = xcolor.green = xcolor.blue = pdlc->inten << NBBY;
		mapping = intensity_mapping;
		update_column = inten_col;
		break;
	default:
		assert(FALSE);
	}

	change_color(	pdue->s, 
			pdue->dlc.pcmap, 
			&xcolor, 
			pcvi->colorix, 
			mapping, 
			&newpixel);
	if(newpixel){

		form_gizmo_set_color(
			pcvi->pformg,
			update_column, 
			pcvi->row, 
			xcolor.pixel);

		redraw_form_gz(pcvi->pformg);
		if(pdue->dl_hdr.bclr == pcvi->colorix){
			XSetWindowBackground(
				pdue->d,
				pdue->dlc.w,
				xcolor.pixel);
		}
		if(pdue->dl_hdr.clr == pcvi->colorix){
                	XSetWindowBorder(
                        	pdue->d, 
                        	pdue->dlc.w, 
                        	xcolor.pixel);
		}

		redraw_dl(pdue, NULL);
	}
}



/*
 *
 *
 * 	ADD_BUTTON
 * 
 *
 */
static void add_button(pformg, column, row, pobj, pdue, colorix)
gizmo			*pformg;
enum column_headers 	column;
unsigned		row;
XRectangle		*pobj;
due			*pdue;
unsigned		colorix;
{
	gizmo				*pg;
	int				ival;
	struct dl_color			*pdlc = &pdue->dlc.pcmap->pdl_colors[colorix];
	struct color_button_info	*pcbi;

	pg = create_choice_gizmo(	pformg->pgg->s, 
					pformg->w, 
					pobj,
					ok_to_operate,
					color_button_update,
					pdue,
					dl_on_off_einfo_d,
					gz_stack_row,
					sizeof(struct color_button_info));

	if(pg){
		assert(column == blink_button_col);

		ival = pdlc->blink;

		pcbi		= (struct color_button_info *) pg->pae;
		pcbi->column	= column;
		pcbi->row	= row;
		pcbi->colorix	= colorix;
		pcbi->pformg	= pformg;

		set_choice_gizmo(pg, ival);
		form_gizmo_add_gizmo(pformg, column, row, pg);
	}

}



/*
 *
 *
 * 	COLOR_BUTTON_UPDATE
 * 
 *
 */
static void color_button_update(pdue, pg, value)
due		*pdue;
gizmo		*pg;
int		value;
{
	struct color_button_info	*pcbi = (struct color_button_info *) pg->pae;

	pdue->dl_mdt = TRUE;
	pdue->dlc.pcmap->pdl_colors[pcbi->colorix].blink = value;
}



/*
 *
 *
 * 	NCOLORS_UPDATE
 * 
 *
 */
static void ncolors_update(pdue, pg, pvalue)
due		*pdue;
gizmo		*pg;
char		*pvalue;
{
	Display	*d = pdue->d;
	int	ncolors;
	int	nnewcolors;
	int	status;
	int	x,y;

	status = sscanf(pvalue, "%d", &ncolors);
	if(status != 1)
		return;

	if(ncolors < number_of_default_colors)
		return;

	nnewcolors = ncolors - pdue->dlc.pcmap->ncolors;

	if(nnewcolors == 0)
		return;
	else if(nnewcolors < 0){
		enum 		choices{cancel, decrease, terminate, nchoices};
		static char 	*pmsgs[5];
		char 		*pchoices[nchoices];
		int		choice;
		int		x_root, y_root;
		Window		child;
		int		status;

		pmsgs[0] = opiStringTab[STR__You_are_decreasing_the_size], 
		pmsgs[1] = opiStringTab[STR_Some_colors_at_bottom_of_the], 
		pmsgs[2] = opiStringTab[STR_Some_elements_may_default_to],
		pmsgs[3] = opiStringTab[STR_Do_you_still_want_less_color], 
		pmsgs[4] = 0;

		pchoices[decrease] = opiStringTab[STR_decrease                    ];
		pchoices[cancel] = opiStringTab[STR_cancel                      ];
		pchoices[terminate] = 0;

		status = XTranslateCoordinates(
			pdue->d,
			pg->w,
			RootWindowOfScreen(pg->pgg->s),
			0,
			0,
			&x_root,
			&y_root,
			&child);
		/*
		 * if they are not on the same screen it 
		 * is a fatal error
		 */
		assert(status);

		choice = perform_dialog(
			pdue->s, 
			x_root, 
			y_root, 
			pdue->gizmo_height, 
			pmsgs, 
			pchoices, 
			pdue->gizmo_height);
		if(choice == cancel)
			return;
	}

	pdue->dl_mdt = TRUE;

	/*
	 * free associated gizmo as needed
	 */
	if(pdue->dlc.pcmap->ppopg){
		x = pdue->dlc.pcmap->ppopg->obj.x;
		y = pdue->dlc.pcmap->ppopg->obj.y;
		free_gizmo(pdue->dlc.pcmap->ppopg);
		pdue->dlc.pcmap->ppopg = NULL;
	}else{
		x = 0;
		y = 0;
	}

	if(nnewcolors > 0){
		edd_create_cmap(	pdue, 
					pdue->dlc.pcmap->pdl_colors, 
					ncolors-nnewcolors, 
					nnewcolors);
	}
	else{

		edd_create_cmap(	pdue, 
					pdue->dlc.pcmap->pdl_colors, 
					ncolors, 
					0);
	}

	modify_cmap(
		pdue, 
		x, 
		y);
}


/*
 *	gm_modify_color_map()
 *	(see edd_menus.h)
 */
void gm_modify_color_map(param, pdue, pbe)
void		*param;
due		*pdue;
XButtonEvent	*pbe;
{
	modify_cmap(	pdue, 
			pbe->x_root - pdue->pixel_tolerence, 
			pbe->y_root - pdue->pixel_tolerence);
}


/*
 *	EDD_CREATE_CMAP
 *
 */
void edd_create_cmap(pdue, pdlc, noldcolors, nnewcolors)
due			*pdue;
struct dl_color		*pdlc;
unsigned		noldcolors;
unsigned		nnewcolors;
{
	struct color_map 	*pcmap;

	pcmap = create_cmap(	
			pdue->d, 
			pdlc, 
			noldcolors, 
			nnewcolors,
			TRUE,
			TRUE);
	assert(pcmap);

	edd_install_cmap(pdue, pcmap);

}



/*
 *	EDD_INSTALL_COLOR_MAP
 *
 */
void edd_install_cmap(pdue, pcmap)
due			*pdue;
struct color_map 	*pcmap;
{
	/*
	 * delete any previous color map only after the create incase they
	 * use its colors for the create !
	 */
	if(pdue->dlc.pcmap)
		edd_delete_cmap(pdue);

	/*
	 * safe pixel pointer for palette gizmo
	 */
	if(pdue->dlc.color)
		pdue->ppixels = pcmap->pcolor_pixels;
	else
		pdue->ppixels = pcmap->pinten_pixels;

	pdue->npixels = pcmap->ncolors;

	pdue->dlc.pcmap = pcmap;
	init_blink(pdue);

	/*
	 * fix up the border and background colors
	 * only if the windo exists
	 */
	if(pdue->dlc.w != None){
      		XSetWindowBackground(
        		pdue->d, 
        		pdue->dlc.w, 
        		CLIPCLRIX(pdue, pdue->dl_hdr.bclr));
        	XSetWindowBorder(
               	 	pdue->d, 
                	pdue->dlc.w, 
                	CLIPCLRIX(pdue, pdue->dl_hdr.clr));
		XClearWindow(
			pdue->d, 
			pdue->dlc.w);
	}
}



/*
 *	EDD_DELETE_CMAP
 *
 */
void edd_delete_cmap(pdue)
due	*pdue;
{
	if(pdue->dlc.pcmap == NULL)
		return;

#ifndef WIN32
	alarm(0);		/* cancel blinker signal */
#endif WIN32
	if(pdue->dlc.pcmap->ppopg){
		free_gizmo(pdue->dlc.pcmap->ppopg);
		pdue->dlc.pcmap->ppopg = NULL;
	}
        delete_cmap(pdue->d, pdue->dlc.pcmap);
	pdue->dlc.pcmap = NULL;
	pdue->ppixels = NULL;
	pdue->npixels = 0;
}
