/*GraphApp.h,v 1.1.1.1 1999/08/03 14:43:59 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/**
 ** Application programmer Layer to graphX library
 **
 **   This layer provides easy use of graphX X plotting functions, and
 **   requires no particular familiarity with X.  Display connections
 **   and widget/window creation with some default translations and
 **   callbacks is provided.
 **
 **   Since it would be foolish to do otherwise, the Intrinsics, along
 **   with the Motif widget set, are used.
 **/


#include <stdio.h>

#include <X11/StringDefs.h>
#include <X11/Intrinsic.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/DrawingA.h>


/* 
 *  include the graphX type definitions 
 */
#include "GraphX.h"


#undef XWD_TEMP_FILE_STRING
#define XWD_TEMP_FILE_STRING "./graphApp.xwd"


#define GraphAppInfo(a,b) (a)->display,(a)->screen,((a)->shellInfo[(b)].window)

#define GraphAppDisplay(a) (a)->display


#define MAX_SHELLS	20


typedef enum {
	SEQL_TYPE,
	GRAPH_TYPE,
	STRIP_TYPE,
	GRAPH3D_TYPE,
	SURFACE_TYPE
} GraphXType;


typedef struct {
	Widget    shell;
	Widget    canvas;
	Window    window;
	GraphXType graphType;
	caddr_t   graphicPtr;		/* pointer to arbitrary graphX type */
} ShellInfo;

typedef struct {
	XtAppContext	appContext;
	Display		*display;
	int		screen;
	ShellInfo	shellInfo[MAX_SHELLS];
	int		shellPtr;
} GraphApp;


extern GraphApp *graphAppInit();
extern int graphAppInitShell();
extern void graphAppRegisterGraphic();
extern void graphAppLoop();
extern void graphAppTermShell();
extern void graphAppTerm();
