/*op_unix_macros.h,v 1.1.1.1 1999/08/03 14:44:04 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
******************************************************************
* File:  op_unix_macros.h
*
* These macros are unique to the Sun UNIX environment code versions.
* They use the file descriptor code inplementing events, which allows
* the single threaded single address space operation of the
* Display Manager, the C.A. Communication Manager, and Channel Access.
*----------------------------------------------------------------
* Modification History
* version    date       author        comments
*----------------------------------------------------------------
* 1.0        07/23/90   Gale Slentz   Initial version
*
******************************************************************
*/
#define	gsdl_macro_ca_task_initialize()	\
	void *pfdctx;\
	SEVCHK(ca_task_initialize(), \
		"gsdl_macro_ca_task_initialize: C.A. initialize failure.\n");\
	pfdctx = (void *) fdmgr_init();\
	if(!pfdctx) {\
		printf("gsdl_macro_ca_task_initialize: fdmgr_init failed.\n");\
		abort();\
	}\
	SEVCHK(ca_add_fd_registration(gsdl_fd_register, pfdctx),\
		"gsdl_macro_ca_task_initialize:   Fd registration failed.\n")

#define gsdl_macro_ca_pend_event() \
	{\
		static struct timeval timeout = {0, USEC_TIME_OUT};\
		fdmgr_pend_event(pfdctx, &timeout);\
	}

#define gsdl_macro_clear_mod_bits(A) \
	gsdl_clear_mod_bits(A)



