/*string_table.h,v 1.1.1.1 1999/08/03 14:44:05 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
#ifndef INCstring_tableh
#define INCstring_tableh

#include <lstLib.h>

typedef struct
	{
	NODE	node;
	char	*string;
	int		count;
	} StringItem;

#ifndef AXP /* weak prototypes */

void	stringInitList();
void	stringZeroCounts();
char	*stringInsert();
int		stringCount();
void	stringDeleteList();
int	stringName();
int		stringGetIndex();
int		stringGetIndexAndIncCount();
char	*stringGetPtr();
void	stringTraverse();
void	stringSearchAndExecute();
void	stringPrintList();

#else /* AXP, strong prototypes */

void	stringInitList(LIST *pst);
void	stringZeroCounts(LIST *pst);
char	*stringInsert(LIST *pst, char *ptr);
int	stringCount(LIST *pst);
void	stringDeleteList(LIST *pst);
int	stringName(
		LIST *pst,
		char *ptr,
		char **ppstring,
		unsigned *pstring_len
	);
int	stringGetIndex(LIST *pst, char *ptr);
int	stringGetIndexAndIncCount(LIST *pst, char *ptr);
char	*stringGetPtr(LIST *pst, char *ptr);
void	stringTraverse(LIST *pst, void (*func)(), void *arg);
void	stringSearchAndExecute(LIST *pst, char *ptr, void (*func)(), void *arg);
void	stringPrintList(LIST *pst);

#endif

#endif
