/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <db_access.h>
#include <dbDefs.h>
#include <time.h>
#include <cadef.h>

#define  MAX_MESSAGE          80 
#define  MAX_DESCRIPTION      28
#define  PRINT_MESSAGE       400
#define  MAX_ERROR          1000
#define  DEV_NAME            100 

#define  TRUE                  1
#define  FALSE                 0

struct alarm{
     char          pointname[PVNAME_SZ+1];        /* defined in dbDefs.h */  
     chid          pchid;
     char          message[MAX_MESSAGE + 1];
     char          message_syntax[MAX_MESSAGE +1];
     char          error[MAX_ERROR+1];
     int           area; 
     time_t        time_of_occurance;
     time_t        time_to_page;
     time_t        time_to_print;
     time_t        time_to_signal;
     char          value[MAX_STRING_SIZE + 1];      /* defined in db_access.h */
     char          desc[MAX_DESCRIPTION+1];
     int           critical_alarm_set;
     struct alarm  *prev_page;
     struct alarm  *next_page;
     struct alarm  *prev_print;
     struct alarm  *next_print;
     struct alarm  *prev_signal;
     struct alarm  *next_signal;
     struct alarm  *prev_retry;
     struct alarm  *next_retry;
} ;


void init_alarmlist();


struct alarm *construct();

int get_node_data();

struct alarm *update_status();

struct alarm *update_message();

struct alarm *update_error();

struct alarm *get_page_data();

struct alarm *get_signal_data();

struct alarm *get_print_data();

struct alarm *get_retry_data();

void add_to_page();

struct alarm *remove_from_page();

void add_to_print();

void remove_from_print();

void add_to_signal();

void remove_from_signal();

void add_to_retry();

void remove_from_retry();

int remove_from_list();
