/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/**************************************************************************************************
*    Pager.c
*
*    Purpose :  This is the driver for the actual pager process.
*
*    K.Grimes   4/1992
*
**************************************************************************************************/ 
#include  <stdio.h>
#include  <alarmlist.h>
#include  <db_access.h>
#include  <cadef.h>
#include  <syslog.h>
#include  <sys/types.h>
#include  <sys/time.h>
#include  <errno.h>

#define   MAX_PIN              12
#define   MAX_ERROR          1000
#define   INACTIVITY_TIMEOUT   10    /* currently allows 30 seconds total of inactivity */    

FILE *stream;

/********************************************************************************************/

int  page(alarm_node, modem, error_message)

struct alarm  *alarm_node;
int           modem;
char          error_message[MAX_ERROR+1];

{
int           area, success = TRUE;
char          message[MAX_MESSAGE+1], value[MAX_STRING_SIZE+1], desc[MAX_DESCRIPTION+1],
              pin[MAX_PIN + 1], pointname[PVNAME_SZ + 1], error_string[MAX_ERROR+1],
	      thearea[4], current[50], occured[50], error[MAX_ERROR+1], message_syntax[MAX_MESSAGE + 1];
time_t        time_to_page, time_to_print, time_occured, epoch, time_to_signal;
chid          pchid;

     get_node_data(alarm_node, pointname, &pchid, message, message_syntax, error, 
		   &area, &time_occured, &time_to_page, &time_to_print, 
		   &time_to_signal, value, desc); 
     if (get_current_staff(area, pin, error_string)) {

        if ( !tapixo_protocal(modem, pin, message) ) {

	      time (&epoch);
	      sprintf(current, "%s", ctime(&epoch));
	      sprintf(occured, "%s", ctime(&time_occured));

	      sprintf(error_message, "\n%s     Critical alarm occured for point %s, on %s     Alarm not acknowledged within pager notification timer.\n     CAN NOT PAGE!  Transmission error occured for PIN %s.\n     Page Message : %s", current, pointname, occured, pin, message);

	     success = FALSE;
        }
	else {
if (0) {
	     time(&epoch);
	     stream = fopen("sent.dat", "a");
	     fprintf(stream,"\n     %s     Paged %s\n", ctime(&epoch), pointname);
	     fclose(stream);
}
	     success = TRUE;

        }
   }
     else {

	time(&epoch);
	sprintf(current, "%s", ctime(&epoch));
	sprintf(occured, "%s", ctime(&time_occured));

	sprintf(error_message, "\n%s     Critical alarm occured for point %s, on %s     Alarm not acknowledged within pager notification timer.\n     %s     Page Message : %s", current, pointname, occured, error_string, message); 

	success = FALSE;
     }

     return success;
}
/******************************************************************************/
int alarm_acknowledged(alarmnode)
   struct alarm *alarmnode;
{
char   pointname[PVNAME_SZ+1], message[MAX_MESSAGE+1], value[MAX_STRING_SIZE+1],
       desc[MAX_DESCRIPTION+1], needs_ack[4], error[MAX_ERROR+1],
       message_syntax[MAX_MESSAGE+1], pointfield[PVNAME_SZ+5];
int    area;
time_t time_occured, time_to_page, time_to_print, time_to_signal;
chid   pchid, temp;

   get_node_data(alarmnode, pointname, &temp,  message, message_syntax, error, 
		 &area, &time_occured, &time_to_page, &time_to_print, 
		 &time_to_signal, value, desc);
     sprintf( pointfield,"%s%s", pointname, ".ACK");

     /*  setup channel access for point field */
     
	 if (ca_search(pointfield, &pchid) == ECA_NORMAL) 
	     
	     if (ca_pend_io(3.0) == ECA_NORMAL) 

		 if (ca_get(DBR_STRING, pchid, needs_ack) == ECA_NORMAL) 

		     if (ca_pend_io(3.0) == ECA_NORMAL) 

			 if (strcmp (needs_ack, "NO") == 0) {
			    return TRUE;
                         }
      return FALSE;
}

/******************************************************************************************/
     
main(argc, argv)

int   argc;
char  *argv[];

{
   struct alarm    *alarmnode;
   char            modemdev[DEV_NAME+1], errormessage[MAX_ERROR+1], string[MAX_ERROR+1];
   int             modemfd, area, i, success = FALSE;
   char            message[MAX_MESSAGE+1], value[MAX_STRING_SIZE+1], 
		   desc[MAX_DESCRIPTION+1], pointname[PVNAME_SZ + 1],
		   current[50], occured[50], error[MAX_ERROR+1],
		   error_message[MAX_ERROR+1], message_syntax[MAX_MESSAGE+1];
   time_t          time_to_page, time_to_print, time_occured, epoch, time_to_signal;
   struct timeval  timeout;
   fd_set          chanmask;
   chid            pchid;


     timeout.tv_sec = INACTIVITY_TIMEOUT;
     timeout.tv_usec = 0;

     ca_task_initialize();

     alarmnode = (struct alarm *)malloc(sizeof(struct alarm));

     if (( modemfd = open_modem(argv[1])) > 0 ) 
	   /* modem open */
	  success = TRUE;


       for (;;)  {    

           if ( read(0, alarmnode, sizeof(struct alarm)) == 0) {
              /* the parent process has died */	   
	      syslog(LOG_ALERT | LOG_DAEMON, "PAGER PROCESS HAS EXITED");

	      if (success) close_modem(modemfd, argv[1]);
              exit();
           }
           else {

	      if (success)  {

                if (connect_modem( modemfd , argv[2], error_message) && modem_login(modemfd, error_message) ) { 
		   for ( i=0; i<3;) {

		      /* upto 3 transactions can be sent per phone call */

   	              if (!alarm_acknowledged(alarmnode)) {

                         if (!page(alarmnode, modemfd, errormessage) ) {
  
                            update_error(alarmnode, errormessage); 

	                    write(1, alarmnode, sizeof(struct alarm)); 

			    /* a transmission error occured, which may involve a disconnect,  must
			       reconnect with modem for next transmission */
			    break;

                          } 
                       }   
		       ++i;
		       if ( i < 3 ) {
			  
			  /* if another page is waiting get it and send during the current call */

			  FD_ZERO(&chanmask);
			  FD_SET(0, &chanmask);

			  if (select(0+1, &chanmask, NULL, NULL, &timeout) ) {

			      if (FD_ISSET(0, &chanmask)) {

				 if (read(0, alarmnode, sizeof(struct alarm)) == 0) {

				     /* the parent process died, hangup and close modem */
				     hangup_modem(modemfd);
				     close_modem(modemfd, argv[1]);
				     exit();
                                 }
                              }
                          }
			  else
			    /* inactivity time out has been reached */
			    break;
                       }
                    }
		    modem_logout(modemfd);
                 } 
	         else {
		    get_node_data(alarmnode, pointname, &pchid, message, 
			       message_syntax, error, &area, &time_occured,
			       &time_to_page, &time_to_print, &time_to_signal,
			       value, desc);

                    time(&epoch);
		    sprintf(current, "%s", ctime(&epoch));
		    sprintf(occured, "%s", ctime(&time_occured));

	            sprintf(errormessage, "\n%s     Critical alarm occured for point %s, on %s     Alarm not acknowledged within pager notification timer.\n     CAN NOT PAGE!     %s\n     Page Message : %s", current, pointname, occured, error_message, message);


	            update_error(alarmnode, errormessage);

	            write(1, alarmnode, sizeof(struct alarm)); 
                }

              }
              else {

                get_node_data(alarmnode, pointname, &pchid, message, message_syntax,
		              error, &area, &time_occured, &time_to_page, 
			      &time_to_print, &time_to_signal, value, desc); 

                time(&epoch);
	        sprintf(current, "%s", ctime(&epoch));
	        sprintf(occured, "%s", ctime(&time_occured));

	        sprintf(errormessage, "\n%s     Critical alarm occured for point %s, on %s     Alarm not acknowledged within pager notification timer.\n     CAN NOT PAGE!  Unable to open modem with device name %s.\n     Page Message : %s\n     This alarm cleared from pager system.\n", current, pointname, occured, argv[1], message);

	        update_error(alarmnode, errormessage);

	        write(1, alarmnode, sizeof(struct alarm)); 
             }
         } 
    }  
} 
