/*mv147.c,v 1.1.1.1 1999/08/03 14:44:12 tis4000 Exp */
/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/****************************************************************/
/*								*/
/*	    PLATFORM SPECIFIC STARTUP FOR MOTOROLA MV147	*/
/*								*/
/****************************************************************/

/*  File: mv147.c                                                                       
*  Edit:  11/28/94     GMU: created                                                    
*                         :                                                            
* .01	01/03/95	WEP	 modified for integration with common 
*				watchdog logic        
* .02	06/28/95	ems	move mv147.h afetr vxWorks.h, added
*				conditional compilation
*                         :
*/

/* task definitions */


/*#include <taskLib.h> */
#include <vxWorks.h>
#include "platform.h"

#if (CPU_FAMILY == MC680X0)
#include <../mv147/mv147.h> 

/* prototypes: original routines */
int mv147DisableWatchDog(void);

/* prototypes: new routines      */
int mv147EnableWatchDog(int dummy);
void mv147PetWatchDog(void);


/*****************************************
**      spawn the watchdog task         **
*****************************************/

int start_mv147(void)
{
    /* initialize the VxWorks watchdog */
/*    tisWatchDog ((int(*)(int))mv147EnableWatchDog,
                 (int(*))mv147DisableWatchDog,
                 (void(*))mv147PetWatchDog,
                 0,
                 8);*/
    tisWatchDog (mv147EnableWatchDog,
		 mv147DisableWatchDog,
		 mv147PetWatchDog,
		 0,
		 8);
    return (OK);
}


/*********************************************
**      Enable the 147 WatchDog Hardware    **
*********************************************/

int mv147EnableWatchDog(int dummy)
{
    *WDOG_CSR = 0xfd;
    return (OK);
}



/*********************************************
**     Disable the 147 WatchDog Hardware    **
*********************************************/

int mv147DisableWatchDog()
{
    *WDOG_CSR = 0;
    return(OK);
}


/*********************************************
**       Pet the 147 Watch Dog Hardware     **
*********************************************/

void mv147PetWatchDog()
{
    *WDOG_CSR = 0xfd;
}


/*	End of File:	mv147.c */
#endif
