/*recSigchar.c,v 1.1.1.1 1999/08/03 14:44:22 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/****************************************************************************
 *
 *  MODULE NAME            : recSigchar.c 
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
 *
 *  DESCRIPTION: record support routines for the signal characterization
 *               record
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 02 Mar 94
 *  REVISION: added process stats code
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 29 Mar 94
 *  REVISION:  make forward func def agree with actual func def
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 04 Apr 94
 *  REVISION: init roci to 0, redund cant handle -1, rework bumping of
 *            roci in alarm, make sure does not exceed MAX_ROC_VALEUS
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 May 94
 *  REVISION: rewrite init_record, get_control_double, if field is HYST
 *		high = hopr-lopr and low is 0
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 14 June 94
 *  REVISION:	added support for maximize severity (msev), moved call to
 *		tsLocalTime inside on scan
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 08 Aug 94
 *  REVISION:	added field types to get_graphic_double and get_control_double
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 Oct 94
 *  REVISION:	add TIME to redundancy, fpas chg'd to frps, added fpps
 *		(1st process pass), do time stamp when stat or sevr chg,
 *		see monitor(),and not in process(),set lalm to val when 
 *		stat or sevr chg,in process() if fpps (first process)
 *		init lalm to val and if time stamp is 0, init it also
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 20 Oct 94
 *  REVISION:	chg time to latm (last alarm time)
 *		added lptm (last process time)
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 13 Jan 95
 *  REVISION:	added mlst to redundancy, init latm and lptm in init_record
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 06 Feb 96
 *  REVISION:	added code for deviation alarm
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 07 Feb 96
 *  REVISION:	always update rate of chg buffer as soon as alarms are enabled
 *		so will always have latest data, also check if rate of chg
 *		    value is > 0.0 before process roc alarm
 *		remove return from HIHI and LOLO alarms, so will always check 
 *		    all alarm sevrs
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 03 Apr 96
 *  REVISION:	added code to support alarm delay
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 20 Jun 96
 *  REVISION:	added code for alarm disable ADIS
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 02 Jul 96
 *  REVISION:	alarm(), update rocb if roc > 0.0 or frps is set
 *
****************************************************************************/

/****************************************************************************
 *
 * Programmer's Notes:
 *
 *
****************************************************************************/


#include	<vxWorks.h>
#include	<inetLib.h>
#include	<types.h>
#include	<stdioLib.h>
#include	<lstLib.h>
#include	<string.h>
#include	<memLib.h>
#include	<stdlib.h>

#include	"alarm.h"
#include	"cvtTable.h"
#include	"dbDefs.h"
#include	"dbCommon.h"
#include	"link.h"
#include	"db_field_log.h"
#include	"dbAccess.h"
#include	"dbFldTypes.h"
#include	"dbRecType.h"
#include	"devSup.h"
#include	"errMdef.h"
#include	"recSup.h"
#include	"special.h"
#include	"rec/sigcharRecord.h"
#include	"redflds.h"
#include	"redque.h"
#include	"sigcharredfldidx.h"
#include	"restable.h"
#include	"db_addr.h"
#include	"dbEvent.h"
#include	"recGbl.h"
#include	"okToUse.h"


/* defined as global in .../share/db/iocInit.c */
extern long *process_cnts;
/* defined as global in .../share/src/procstat.c */
extern int process_stats;

/* Create RSET - Record Support Entry Table */

#define report NULL
#define initialize NULL
static long init_record();
static long process();
#define special NULL
static long get_value();
#define cvt_dbaddr NULL
#define get_array_info NULL
#define put_array_info NULL
static long get_units();
static long get_precision();
#define get_enum_str NULL
#define get_enum_strs NULL
#define put_enum_str NULL
static long get_graphic_double();
static long get_control_double();
static long get_alarm_double();

struct rset sigcharRSET = {

	RSETNUMBER,
	report,
	initialize,
	init_record,
	process,
	special,
	get_value,
	cvt_dbaddr,
	get_array_info,
	put_array_info,
	get_units,
	get_precision,
	get_enum_str,
	get_enum_strs,
	put_enum_str,
	get_graphic_double,
	get_control_double,
	get_alarm_double
	};

/* The folowing definitions are for redundancy */
 
static struct fldDes    **mylist = 0;

static	char *namelist [] = {
		"STAT",
		"SEVR",
		"VAL",
                "ROCI",
                "ROCC",
		"LALM",
		"INI2",
		"LATM",
		"MLST",
		"HHLL",
		"HILO",
		"RTCT",
		"LARF",
		"DVCT",
		"SBHL",
		0
		};

static unsigned short    type;

#define  MAX_SIG_TBL_ENTRIES     32

/* defines for some alarm states */

#define  NO_OTHER_ALARMS     0
#define  TABLE_CONFIG        1
#define  HI_RANGE            2
#define  LO_RANGE            3

static void alarm ();
static long compute_val ();
static void monitor ();


/****************************************************************************
 *
 *  MODULE NAME            : init_record 
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
 *          ARGUMENT(S)    : psigchar - ptr to line segment record
 *
 *  DESCRIPTION: initialize a signal characterization record
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 03 Jan 94
 *  REVISION:  set ack to 0
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 28 Feb 94
 *  REVISION: removed ack = 0;
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 20 July 94
 *  REVISION:	errmsg not needed, check if numx > 0 not >= 0 and numx <=
 *		MAX_SIG_TBL_ENTRIES not <
 *
****************************************************************************/

static long init_record (psigchar)
    struct sigcharRecord	*psigchar;

{
    unsigned short	i;
    char		*pstr;
    char		redbuf [256];
    int			ini2_flag = 0;
    double		cinp;
    long		options;
    long		nRequests;
    int			other_alarms = NO_OTHER_ALARMS;

    if (!(mylist))
    {
	for (type = 1, i = 0; type < 100; type++)
	{
	    pstr = GET_PRECTYPE (type);
	    if (strncmp (pstr, "sigchar", 7) == 0)
	    {
		i = 1;
		break;
	    }
	}

	if (!i)
	{
	    recGblRecordError (S_db_noRecType, (struct dbCommon *)psigchar, "sigchar: init_record");
	    return (S_db_noRecType);
	}

	mylist = redFldAlloc (type, NUMSIGCHARFLDS);

	if (!mylist)
	{
	    recGblRecordError (S_rec_Alloc, (struct dbCommon *)psigchar,
			       "sigchar, init_record, mylist failed");
	    return (S_rec_Alloc);
	}

	for (i = 0; i < NUMSIGCHARFLDS; i++) 
	    redFldAdd (type, i, namelist [i]);
    }

      /* allocate rate of change buffer if not already exist */

    if (!(psigchar -> rocb))
    {
	if ((psigchar -> rocb =
	    (void *)calloc (1, (MAX_ROC_VALUES * sizeof (float)))) == NULL)
	{
	    recGblRecordError (S_rec_Alloc, (struct dbCommon *)psigchar, 
                               "sigchar: init_record, rocb calloc fail");
	    return (S_rec_Alloc);
	}
	psigchar -> rocc = 0;
	psigchar -> roci = 0;
    }

    psigchar -> init = TRUE;
    psigchar -> fpps = TRUE;
    psigchar -> frps = TRUE;
    psigchar -> nsta = NO_ALARM;
    psigchar -> nsev = NO_ALARM;
    psigchar -> msev = NO_ALARM;

    /* init alarm delay variables */
    psigchar -> larf = 0;
    psigchar -> hhll = 0;
    psigchar -> hilo = 0;
    psigchar -> dvct = 0;
    psigchar -> sbhl = 0;
    psigchar -> rtct = 0;

    /* init last alarm time and last process time */
    if (psigchar -> latm.secPastEpoch == 0)
	tsLocalTime (&psigchar -> latm);
    if (psigchar -> lptm.secPastEpoch == 0)
	tsLocalTime (&psigchar -> lptm);

    if ( (psigchar -> numx > 0) && (psigchar -> numx <= MAX_SIG_TBL_ENTRIES) )
    {
	if (psigchar -> inp.type == DB_LINK)
	{
	    /* check if input is ok given these conditions, else just init block */
	    if ( (!psigchar -> tagd) && (psigchar -> oscn != OFF_SCAN) &&
		 (psigchar -> mode == NORMAL) )
	    {
		options = 0;
		nRequests = 1;
		if ( ((dbGetLink (&psigchar -> inp.value.db_link, 
				  (struct dbCommon *)psigchar,
				  DBR_DOUBLE, (caddr_t)&cinp, 
				  &options, &nRequests)) == NULL) &&
		     (okToUse (&psigchar -> inp)) )
		{
		    psigchar -> cinp = cinp;
		    compute_val (psigchar, &other_alarms);
		    ini2_flag = 1;
		}
		else
		{
		    psigchar -> nsta = NO_INIT_ALARM;
		    psigchar -> nsev = VALID_ALARM;
		}
	    }
	    else
		ini2_flag = 1;
	}
	else
	{
	    psigchar -> nsta = NO_INIT_ALARM;
	    psigchar -> nsev = VALID_ALARM;
	}
    }
    else
    {
	sprintf (redbuf, "sigchar: init_record num tbl = %d", psigchar -> numx);
	recGblRecordError (S_db_badField, (struct dbCommon *)psigchar, redbuf);
	psigchar -> nsta = NO_INIT_ALARM;
	psigchar -> nsev = VALID_ALARM;
    }

      /* do redundancy if not in slave mode */

    if (resGetCaAnswer (psigchar -> radr, &i) == RES_OK)
    {
	if (i)
	{
	    /* check for maximize severity */

	    if (psigchar -> msev > psigchar -> nsev)
	    {
		psigchar -> nsev = psigchar -> msev;
		psigchar -> nsta = LINK_ALARM;
	    }

	    monitor (psigchar);

	    if (ini2_flag)
	    {
		psigchar -> ini2 = 1;

		redQInit ((struct dbCommon *)psigchar, redbuf, sizeof (redbuf), type);
		redQField (redbuf, mylist [STAT]);
		redQField (redbuf, mylist [SEVR]);
		redQField (redbuf, mylist [VAL]);
		redQField (redbuf, mylist [ROCI]);
		redQField (redbuf, mylist [ROCC]);
		redQField (redbuf, mylist [LALM]);
		redQField (redbuf, mylist [INI2]);

		redQSend (redbuf);
	    }
	}
    }

   return (0);

} /* end func init_record () */



/****************************************************************************
 *
 *  MODULE NAME            : alarm 
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
 *  CALLING MODULE(S)      : process
 *          ARGUMENT(S)    : psigchar - ptr to line segment record
 *                           other_alarms - out of range and table
 *                               configuration alarms
 *
 *  DESCRIPTION: update alarm status for the record
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 11 Mar 94
 *  REVISION:  alarm chgs, if val is past alarm setting, set that
 *             alarm condition, else if val was in that alarm and
 *             it is still in hyst range of alarm value, then stay
 *             in alarm, remove return from high alarm, let user
 *             determine which is more important low or high
 *
****************************************************************************/

static void alarm (psigchar, other_alarms)
   struct   sigcharRecord  *psigchar;
   int                     other_alarms;
{
    double		val = psigchar -> val;
    register float	hval, lval;
    register short	i, inx;
    int			adis = 0;
    ALARM_LIMITS	alarm_limits;

    /* add value to the rate of change buffer, 
       if there is a rate of chg limit or 1st pass is set
    */

    if ( (psigchar -> roc > 0.0) || (psigchar -> frps == FALSE) )
    {
	psigchar -> roci++;
	if (psigchar -> roci >= MAX_ROC_VALUES)
	    psigchar -> roci = 0;

	if (psigchar -> rocc < MAX_ROC_VALUES)
	    psigchar -> rocc++;

	if (psigchar -> frps)
	{
	    psigchar -> frps = FALSE;
	    *(float *) (psigchar -> rocb) = val;
	}

	*(float *) (psigchar -> rocb + (psigchar -> roci * sizeof (float))) = val;
    }

    /* check for alarm inhibit */

    adis = AlarmDisableLink ((void *)psigchar);

    if ( (psigchar -> aenb == ALARM_DISABLED) || (adis != 0) )
    {
	psigchar -> nsta = INHIBIT_ALARM;
	psigchar -> nsev = NO_ALARM;
	return;
    }

    /* check for other alarm conditions first */

    if (other_alarms != NO_OTHER_ALARMS)
    {
	if (other_alarms == TABLE_CONFIG)
	{
	    psigchar -> nsta = PARAMETER;
	    psigchar -> nsev = MAJOR_ALARM;
	}
	if (other_alarms == HI_RANGE)
	{
	    if (psigchar -> fhsv > NO_ALARM)
	    {
		if (psigchar -> aldl > 0)
		{
		    /* if we were counting LO SBAD, 0 first, same
		       counter is used for both HI SBAD and LO SBAD
		    */
		    if (psigchar -> larf & LARF_SBAD_LOW)
			psigchar -> sbhl = 0;
		    if (psigchar -> sbhl < ALDL_MAX)
			psigchar -> sbhl++;
		    psigchar -> larf |= LARF_SBAD_HIGH;
		    if ( (psigchar -> sbhl >= psigchar -> aldl) &&
			 (psigchar -> nsev < psigchar -> fhsv) )
		    {
			psigchar -> nsta = SBAD_ALARM;
			psigchar -> nsev = psigchar -> fhsv;
		    }
		}
		else
		{
		    if (psigchar -> nsev < psigchar -> fhsv)
		    {
			psigchar -> nsta = SBAD_ALARM;
			psigchar -> nsev = psigchar -> fhsv;
		    }
		}
	    }
	}
	else
	{
	    if (psigchar -> aldl > 0)
	    {
		/* remove the SBAD_HIGH alarm bit */
		psigchar -> larf &= ~LARF_SBAD_HIGH;

		/* since sbhl counts both SBAD_HIGH and SBAD_LOW,
		   if SBAD_LOW is not set 0 counter
		*/
		if (!(psigchar -> larf & ((unsigned long)LARF_SBAD_LOW)))
		    psigchar -> sbhl = 0;
	    }
	}
	if (other_alarms == LO_RANGE)
	{
	    if (psigchar -> flsv > NO_ALARM)
	    {
		if (psigchar -> aldl > 0)
		{
		    if (psigchar -> larf & LARF_SBAD_HIGH)
			psigchar -> sbhl = 0;
		    if (psigchar -> sbhl < ALDL_MAX)
			psigchar -> sbhl++;
		    psigchar -> larf |= LARF_SBAD_LOW;
		    if ( (psigchar -> sbhl >= psigchar -> aldl) &&
			 (psigchar -> nsev < psigchar -> flsv) )
		    {
			psigchar -> nsta = SBAD_ALARM;
			psigchar -> nsev = psigchar -> flsv;
		    }
		}
		else
		{
		    if (psigchar -> nsev < psigchar -> flsv)
		    {
			psigchar -> nsta = SBAD_ALARM;
			psigchar -> nsev = psigchar -> flsv;
		    }
		}
	    }
	}
	else
	{
	    if (psigchar -> aldl > 0)
	    {
		psigchar -> larf &= ~LARF_SBAD_LOW;

		if (!(psigchar -> larf & ((unsigned long)LARF_SBAD_HIGH)))
		    psigchar -> sbhl = 0;
	    }
	}
    }
    else
    {
	if (psigchar -> aldl > 0)
	{
	    psigchar -> larf &= ~LARF_SBAD_LOW;
	    psigchar -> larf &= ~LARF_SBAD_HIGH;
	    psigchar -> sbhl = 0;
	}
    }

    /* rate of change alarms */

    if ( (psigchar -> rcsv != NO_ALARM) && (psigchar -> rocb) && 
	 (psigchar -> roc > 0.0) )
    {
	if (psigchar -> rocc >= 2)
	{
	    inx = psigchar -> roci;
	    hval = lval =  *(float *) (psigchar -> rocb + (inx * sizeof (float)));
	    for (i = 0; 
		 i < ((psigchar -> rocc < psigchar -> rocn) ? 
		       psigchar -> rocc : 
		       psigchar -> rocn); 
		 i++)
	    {
		if (--inx < 0)
		    inx = MAX_ROC_VALUES - 1;

		if ((*((float *) (psigchar -> rocb + (inx * sizeof (float))))) > hval)
		    hval = *((float *) (psigchar -> rocb + (inx * sizeof (float))));
      
		if ((*((float *) (psigchar -> rocb + (inx * sizeof (float))))) < lval) 
		    lval = *((float *) (psigchar -> rocb + (inx * sizeof (float))));
      
	    }
	    if ((hval - lval) > psigchar -> roc)
	    {
		psigchar -> nsev = psigchar -> rcsv;
		psigchar -> nsta = ROC_ALARM;
	    }
	}
    }

    /* set up for limit alarms */

    alarm_limits.hihi = psigchar -> hihi;
    alarm_limits.high = psigchar -> high;
    alarm_limits.low  = psigchar -> low;
    alarm_limits.lolo = psigchar -> lolo;
    alarm_limits.devl = psigchar -> devl;
    alarm_limits.devs = psigchar -> devs;
    alarm_limits.hyst = psigchar -> hyst;
    alarm_limits.hhsv = psigchar -> hhsv;
    alarm_limits.hsv  = psigchar -> hsv;
    alarm_limits.lsv  = psigchar -> lsv;
    alarm_limits.llsv = psigchar -> llsv;
    alarm_limits.dvsv = psigchar -> dvsv;

    AlarmLimits (&alarm_limits, val, (void *)psigchar);

    /* do a return to normal, check for alarm delay ALDL only
       on the listed alarms
    */

    if ( ((psigchar -> nsta == NO_ALARM) && (psigchar -> nsev == NO_ALARM)) &&
	 ((psigchar -> stat == HIHI_ALARM) || (psigchar -> stat == HIGH_ALARM) ||
	  (psigchar -> stat == LOW_ALARM)  || (psigchar -> stat == LOLO_ALARM) ||
	  (psigchar -> stat == DEVIATION_ALARM) || (psigchar -> stat == SBAD_ALARM)) )
    {
	if (psigchar -> aldl > 0)
	{
	    if (psigchar -> rtct < ALDL_MAX)
		psigchar -> rtct++;

	    /* delay return to normal so, continue last alarm */
	    if (psigchar -> rtct < psigchar -> aldl)
	    {
		psigchar -> nsta = psigchar -> stat;
		psigchar -> nsev = psigchar -> sevr;
	    }
	}
    }
    else
    {
	if (psigchar -> aldl > 0)
	{
	    psigchar -> rtct = 0;
	}
    }

   return;

} /* end func alarm () */



/****************************************************************************
 *
 *  MODULE NAME            : compute_val 
 *  AUTHOR                 : emsteel
 *  DATE                   : 18 Nov 93
 *
 *  CALLING MODULE(S)      : process
 *          ARGUMENT(S)    : psigchar - ptr to record
 *                           other_alarms - if out of range or table
 *                               configuration alarm
 *
 *  DESCRIPTION: interpolate the input by looking it up in the X table
 *               and finding the corresponding output in the Y table.
 *               use linear interpolation when input falls between 2 X
 *               entries
 *  NOTES:
 *    Formula to interpolate
 *
 *    highx - current input   highy - val
 *    --------------------- = -------------
 *    highx - lowx            highy - lowy
 *
 *                              highx - current input
 *    val = (double) (highy - ((---------------------) * (highy - lowy)))
 *                              highx - lowx
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 11 Jul 94
 *  REVISION:	if highx - lowx == 0, set val to highy to alleviate potential 
 *		divide by zero
 *		set TABLE CONFIG alarm if current x table entry is also = to
 *		previous x table entry not just <
 *
****************************************************************************/

static long compute_val (psigchar, other_alarms)
   struct   sigcharRecord  *psigchar;
   int                     *other_alarms;
{
   long  status = 0;
   float *xtbl = &psigchar -> x1;
   float *ytbl = &psigchar -> y1;
   float highx;      /* high x table value */
   float shighx;     /* save high x value */
   float lowx;       /* low x table value */
   float highy;      /* high y table value */
   float shighy;     /* save high y value */
   float lowy;       /* low y table value */
   int   i;

      /* if current input is < 1st in x table,
         set low range alarm
         if we are to use the fixed values, set VAL
            to it
      */

   if (psigchar -> cinp < (*(xtbl)))
   {
      *other_alarms = LO_RANGE;
      if (psigchar -> usef)
         psigchar -> val = (double)psigchar -> xlow;
      return (status);
   }
      /* if current input is > last element in x table,
         set high range alarm
         if we are to use the fixed values, set VAL
            to it
      */

   if (psigchar -> cinp > (*(xtbl + (psigchar -> numx - 1))))
   {
      *other_alarms = HI_RANGE;
      if (psigchar -> usef)
         psigchar -> val = (double)psigchar -> xhgh;
      return (status);
   }

      /* prevent divide by 0 if current input equals
         1st value in table
      */

   if (psigchar -> cinp == *(xtbl))
   {
      psigchar -> val = (double)(*(ytbl));
      return (status);
   }

   lowx = highx = *xtbl;
   lowy = highy = *ytbl;

      /* find the low and highx table values that bracket
         the current input value CINP
      */

   for (i = 1; i <= psigchar -> numx; i++)
   {
         /* if we are still low */

      if (psigchar -> cinp > highx)
      {
            /* is there another in table */

         if ((i + 1) <= psigchar -> numx)
         {
               /* save off old high values */

            shighx = highx;
            shighy = highy;

               /* get next values in table */

            xtbl++;
            ytbl++;

               /* if the x table is not in ascending order
		  or 2 x table values are the same
                  set alarm flag and get next x in table
               */

            if ((*xtbl) <= shighx)
            {
               *other_alarms = TABLE_CONFIG;
               continue;
            }
            highx = *xtbl;
            highy = *ytbl;

               /* update low values */
            lowx = shighx;
            lowy = shighy;
         }
         else
            break;
      }
      else
         break;
   }

   if ((highx - lowx) == 0)
       psigchar -> val = (double)highy;
   else
       psigchar -> val = (double) (highy - (((highx - psigchar -> cinp) /
                                         (highx - lowx)) * (highy - lowy)));
      
   return (status);

} /* end func compute_val () */



/****************************************************************************
 *
 *  MODULE NAME            : get_control_double
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
****************************************************************************/

static long get_control_double(paddr,pcd)
   struct    dbAddr            *paddr;
   struct    dbr_ctrlDouble    *pcd;
{
    struct sigcharRecord *psigchar = (struct sigcharRecord *) paddr -> precord;

    switch ( ((struct fldDes *)paddr -> pfldDes) -> offset )
    {
	case ( (int)&(((struct sigcharRecord *)0) -> hyst) ):
	case ( (int)&(((struct sigcharRecord *)0) -> roc) ):
	case ( (int)&(((struct sigcharRecord *)0) -> adel) ):
	case ( (int)&(((struct sigcharRecord *)0) -> mdel) ):
	case ( (int)&(((struct sigcharRecord *)0) -> devl) ):
	{
	    float    span;

	    span = psigchar -> hopr - psigchar -> lopr;
	    if (span < 0.0)
	        span = -span;
	    pcd -> upper_ctrl_limit = span;
	    pcd -> lower_ctrl_limit = 0;
	    break;
	}

	case ( (int)&(((struct sigcharRecord *)0) -> rocn) ):
	    pcd -> upper_ctrl_limit = 60;
	    pcd -> lower_ctrl_limit = 0;
	    break;

	case ( (int)&(((struct sigcharRecord *)0) -> numx) ):
	    pcd -> upper_ctrl_limit = 32;
	    pcd -> lower_ctrl_limit = 2;
	    break;

	default:
	    pcd -> upper_ctrl_limit = psigchar -> hopr;
	    pcd -> lower_ctrl_limit = psigchar -> lopr;
	    break;
    }

   return (0);
}


/****************************************************************************
 *
 *  MODULE NAME            : get_graphic_double
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
****************************************************************************/

static long get_graphic_double(paddr,pgd)
    struct  dbAddr         *paddr;
    struct  dbr_grDouble   *pgd;
{
   struct sigcharRecord	*psigchar = (struct sigcharRecord *) paddr -> precord;

    switch ( ((struct fldDes *)paddr -> pfldDes) -> offset )
    {
	case ( (int)&(((struct sigcharRecord *)0) -> hyst) ):
	case ( (int)&(((struct sigcharRecord *)0) -> roc) ):
	case ( (int)&(((struct sigcharRecord *)0) -> adel) ):
	case ( (int)&(((struct sigcharRecord *)0) -> mdel) ):
	case ( (int)&(((struct sigcharRecord *)0) -> devl) ):
	{
	    float    span;

	    span = psigchar -> hopr - psigchar -> lopr;
	    if (span < 0.0)
	        span = -span;
	    pgd -> upper_disp_limit = span;
	    pgd -> lower_disp_limit = 0;
	    break;
	}

	case ( (int)&(((struct sigcharRecord *)0) -> rocn) ):
	    pgd -> upper_disp_limit = 60;
	    pgd -> lower_disp_limit = 0;
	    break;

	case ( (int)&(((struct sigcharRecord *)0) -> numx) ):
	    pgd -> upper_disp_limit = 32;
	    pgd -> lower_disp_limit = 2;
	    break;

	default:
	    pgd -> upper_disp_limit = psigchar -> hopr;
	    pgd -> lower_disp_limit = psigchar -> lopr;
	    break;
    }

   return (0);
}


/****************************************************************************
 *
 *  MODULE NAME            : get_alarm_double
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
****************************************************************************/

static long get_alarm_double (paddr, pad)
   struct   dbAddr          *paddr;
   struct   dbr_alDouble    *pad;
{
   struct sigcharRecord	*psigchar = (struct sigcharRecord *) paddr -> precord;

   pad -> upper_alarm_limit   = psigchar -> hihi;
   pad -> upper_warning_limit = psigchar -> high;
   pad -> lower_warning_limit = psigchar -> low;
   pad -> lower_alarm_limit   = psigchar -> lolo;

   return (0);
}

/****************************************************************************
 *
 *  MODULE NAME            : get_precision 
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
****************************************************************************/

static long get_precision (paddr, precision)
   struct   dbAddr   *paddr;
   long              *precision;
{
   struct sigcharRecord *psigchar = (struct sigcharRecord *) paddr -> precord;

   *precision = psigchar -> prec;

   return (0);
}

/****************************************************************************
 *
 *  MODULE NAME            : get_units
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
****************************************************************************/

static long get_units(paddr,units)
   struct   dbAddr   *paddr;
   char              *units;
{
   struct sigcharRecord *psigchar = (struct sigcharRecord *) paddr -> precord;

   strncpy (units, psigchar -> egu, sizeof (psigchar -> egu));

   return (0);
}

/***************************************************************************
 *
 *  MODULE NAME            : get_value 
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
****************************************************************************/

static long get_value(psigchar, pvdes)
   struct   sigcharRecord    *psigchar;
   struct   valueDes         *pvdes;
{
   pvdes -> field_type = DBF_FLOAT;
   pvdes -> no_elements = 1;
   (float *) (pvdes -> pvalue) = &psigchar -> val;

   return (0);

} /* end func get_value () */


/****************************************************************************
 *
 *  MODULE NAME            : monitor 
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
 *  CALLING MODULE(S)      : process
 *          ARGUMENT(S)    : psigchar - ptr to line segment record
 *
 *  DESCRIPTION: send out monitors for changed values
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 05 Jan 94
 *  REVISION:  check VALID_ALARM before set ACK
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 29 Aug 94
 *  REVISION:	rm DBE_LOG from ack, only archive val if tenb (trending) is
 *		enabled, only set DBE_VALUE on cinp
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 15 Mar 95
 *  REVISION:	do not set ack if sevr is EVENT_ALARM
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 11 Sept 95
 *  REVISION:	archive if stat/sevr also chg's
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 12 Sept 95
 *  REVISION:	chg way handle VALID_ALARM
 *
****************************************************************************/

static void monitor (psigchar)
   struct   sigcharRecord *psigchar;
{
    unsigned short	monitor_mask;
    double   delta;
    short    stat, sevr, nsta, nsev;
    int      set_ack = 1;

      /* get previous stat and sevr and new stat and sevr*/

    stat = psigchar -> stat;
    sevr = psigchar -> sevr;
    nsta = psigchar -> nsta;
    nsev = psigchar -> nsev;

      /* set current stat and sevr */

    psigchar -> stat = nsta;
    psigchar -> sevr = nsev;
    psigchar -> nsta = 0;
    psigchar -> nsev = 0;

    /* if we are coming out of VALID_ALARM and our new stat/sevr are
       the same as when we went into VALID_ALARM, do not set ack
    */
    if ( (nsev != VALID_ALARM) && (sevr == VALID_ALARM) &&
	 (nsta == psigchar -> psta) && (nsev == psigchar -> psev) )
    {
	set_ack = 0;
    }
    /* if we are going into VALID_ALARM, and out previous stat was not
       VALID_ALARM, remember previous non VALID_ALARM stat/sevr
       and we do not want to set ACK,
    */
    if ( (nsev == VALID_ALARM) && (sevr != VALID_ALARM) )
    {
	set_ack = 0;
	psigchar -> psta = stat;
	psigchar -> psev = sevr;
	db_post_events ((struct dbCommon *)psigchar, (caddr_t)&psigchar -> psta, DBE_VALUE);
	db_post_events ((struct dbCommon *)psigchar, (caddr_t)&psigchar -> psev, DBE_VALUE);
    }

    monitor_mask = 0;

      /* alarm condition changed this scan */

    if ((stat != nsta) || (sevr != nsev))
    {
         /* post events for alarm condition change*/

	monitor_mask = DBE_ALARM;

	/* when alarm status chg's, get current time and
	   save VAL in lalm (last value when alarm chg'd)
	*/
	tsLocalTime (&psigchar -> latm);
	psigchar -> lalm = psigchar -> val;

         /* post stat and nsev fields */

	db_post_events ((struct dbCommon *)psigchar, (caddr_t)&psigchar -> stat, DBE_VALUE);
	db_post_events ((struct dbCommon *)psigchar, (caddr_t)&psigchar -> sevr, DBE_VALUE);

	if ((psigchar -> sevr != NO_ALARM) && (set_ack) &&
	    (psigchar -> sevr != EVENT_ALARM) )
	{
	    if (psigchar -> ack == 0)
	    {
		psigchar -> ack = 1;           /* new unacknowledged alarm */
		db_post_events((struct dbCommon *)psigchar, (caddr_t)&psigchar -> ack, DBE_VALUE);
	    }
	}
    }
      /* check for value change */

    delta = psigchar -> mlst - psigchar -> val;
    if (delta < 0.0)
	delta = -delta;

    if (delta > psigchar -> mdel)
    {
         /* post events for value change */

	monitor_mask |= DBE_VALUE;

         /* update last value monitored */

	psigchar -> mlst = psigchar -> val;
    }

      /* check for archive change only if tenb (trending) is enabled */

    if (psigchar -> tenb)
    {
	delta = psigchar -> alst - psigchar -> val;
	if (delta < 0.0) 
	    delta = -delta;

	if ( (delta > psigchar -> adel) || (monitor_mask & DBE_ALARM) )
	{
	    /* post events on value field for archive change */

	    monitor_mask |= DBE_LOG;

	    /* update last archive value monitored */

	    psigchar -> alst = psigchar -> val;
	}
    }

      /* send out monitors connected to the value field
         and the current input value CINP
      */

    if (monitor_mask)
    {
	db_post_events ((struct dbCommon *)psigchar, (caddr_t)&psigchar -> val, monitor_mask);

         /* if change in input value */

	if (psigchar -> pinp != psigchar -> cinp)
	{
	    db_post_events ((struct dbCommon *)psigchar, (caddr_t)&psigchar -> cinp, DBE_VALUE);
	    psigchar -> pinp = psigchar -> cinp;
	}
    }

    return;

} /* end func monitor () */



/****************************************************************************
 *
 *  MODULE NAME            : process 
 *  AUTHOR                 : emsteel
 *  DATE                   : 15 Nov 93
 *
 *          ARGUMENT(S)    : paddr - ptr to record struct packet
 *
 *  DESCRIPTION: process a line segment record
 *
 ***************************** REVISION HISTORY *****************************
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 03 Jan 94
 *  REVISION:  if not init'd, do nothing
 *
 *  REVISED BY             : emsteel
 *  REVISION DATE          : 28 Feb 94
 *  REVISION:  don't have to check for MASTER to do redundancy, if process 
 *	       is called, we have to be MASTER
 *
****************************************************************************/

static long process (paddr)
   struct dbAddr  *paddr;
{
    struct sigcharRecord *psigchar = (struct sigcharRecord *) (paddr -> precord);
    long		status = 0;
    unsigned short	stat   = psigchar -> stat;
    unsigned short	sevr   = psigchar -> sevr;
    short		roci   = psigchar -> roci;
    short		rocc   = psigchar -> rocc;
    double		val    = psigchar -> val;
    double		lalm   = psigchar -> lalm;
    TS_STAMP		latm   = psigchar -> latm;
    double		mlst   = psigchar -> mlst;
    short		hhll   = psigchar -> hhll;
    short		hilo   = psigchar -> hilo;
    short		rtct   = psigchar -> rtct;
    unsigned long	larf   = psigchar -> larf;
    short		dvct   = psigchar -> dvct;
    short		sbhl   = psigchar -> sbhl;
    double		cinp;       /* current input */
    int			other_alarms = NO_OTHER_ALARMS;
    char		redbuf [256];

      /* if not init'd, do nothing */

    if ((!psigchar -> init) || (!psigchar -> ini2))
	return (status);

    /* get time stamp for last time record was processed */

    tsLocalTime (&psigchar -> lptm);

    psigchar -> msev = NO_ALARM;
   
      /* off normal operations (use VAL) */

    if (psigchar -> tagd)
    {
	psigchar -> nsta = TAGGED_ALARM;
	psigchar -> nsev = VALID_ALARM;
    }
    else if (psigchar -> oscn == OFF_SCAN)
    {
	psigchar -> nsta = SCAN_ALARM;
	psigchar -> nsev = VALID_ALARM;
    }
    else
    {
	psigchar -> nsta = NO_ALARM;
	psigchar -> nsev = NO_ALARM;

	/* update number of process times */
	if (process_stats)
	    process_cnts[type]++;	

	if (psigchar -> mode == NORMAL)
	{
	    psigchar -> pact = TRUE;

	    if (psigchar -> inp.type == DB_LINK)
	    {
		long  options   = 0;
		long  nRequests = 1;

		status = dbGetLink (&psigchar -> inp.value.db_link, 
				    (struct dbCommon *)psigchar,
				    DBR_DOUBLE, (caddr_t)&cinp, 
				    &options, &nRequests);
		if (status)
		{
		    if (psigchar -> nsev < VALID_ALARM)
		    {
			psigchar -> nsta = LINK_ALARM;
			psigchar -> nsev = VALID_ALARM;
		    }
		}
		else
		    psigchar -> cinp = cinp;
	    }
	    if (!status)
		status = compute_val (psigchar, &other_alarms);
	}

        /* check for alarms */

	alarm (psigchar, other_alarms);

	/* check for maximize severity */

	if (psigchar -> msev > psigchar -> nsev)
	{
	    psigchar -> nsev = psigchar -> msev;
	    psigchar -> nsta = LINK_ALARM;
	}
    }

    /* if the time stamp is 0, init and post val with
       alarm bit set, this makes sure that proper alarm
       messages are set if IOC was down and alarm status
       may have chg'd
    */
    if (psigchar -> latm.secPastEpoch == 0)
    {
	tsLocalTime (&psigchar -> latm);
	db_post_events ((struct dbCommon *)psigchar, (caddr_t)&psigchar -> val, DBE_VALUE | DBE_ALARM);
    }

    /* if it is the 1st process pass 
       init last value when alarm chg'd (lalm)
    */

    if (psigchar -> fpps)
    {
	psigchar -> fpps = 0;
	psigchar -> lalm = psigchar -> val;
    }

      /* check event list */

    monitor (psigchar);

    psigchar -> pact = FALSE;

      /* update redundancy */

    redQInit ((struct dbCommon *)psigchar, redbuf, sizeof (redbuf), type);

    if (stat != psigchar -> stat) 
	redQField (redbuf, mylist [STAT]);
 
    if (sevr != psigchar -> sevr)
	redQField (redbuf, mylist [SEVR]);

    if (val != psigchar -> val)
	redQField (redbuf, mylist [VAL]);

    if (roci != psigchar -> roci)
    {
	redQField (redbuf, mylist [VAL]);
	redQField (redbuf, mylist [ROCI]);
    }

    if (rocc != psigchar -> rocc)
	redQField (redbuf, mylist [ROCC]);

    if (lalm != psigchar -> lalm)
	redQField (redbuf, mylist [LALM]);

    if (TsCmpStampsNE (&latm, &psigchar -> latm) )
	redQField (redbuf, mylist [LATM]);

    if (mlst != psigchar -> mlst)
	redQField (redbuf, mylist [MLST]);

    if (hhll != psigchar -> hhll)
	redQField (redbuf, mylist [HHLL]);

    if (hilo != psigchar -> hilo)
	redQField (redbuf, mylist [HILO]);

    if (rtct != psigchar -> rtct)
	redQField (redbuf, mylist [RTCT]);

    if (larf != psigchar -> larf)
	redQField (redbuf, mylist [LARF]);

    if (dvct != psigchar -> dvct)
	redQField (redbuf, mylist [DVCT]);

    if (sbhl != psigchar -> sbhl)
	redQField (redbuf, mylist [SBHL]);

    redQSend (redbuf);

      /* process the forward scan link record */

    if (psigchar -> flnk.type == DB_LINK) 
	dbScanPassive ((struct dbAddr *)psigchar -> flnk.value.db_link.pdbAddr);

    return (status);

} /* end func process () */


