/*rsrv_init.c,v 1.1.1.1 1999/08/03 14:44:30 tis4000 Exp */

/*	@(#)rsrv_init.c
 *   @(#)rsrv_init.c	1.5	9/20/91
 *	Author:	Jeffrey O. Hill
 *		hill@luke.lanl.gov
 *		(505) 665 1831
 *	Date:	5-88
 *
 *	Experimental Physics and Industrial Control System (EPICS)
 *
 *	Copyright 1991, the Regents of the University of California,
 *	and the University of Chicago Board of Governors.
 *
 *	This software was produced under  U.S. Government contracts:
 *	(W-7405-ENG-36) at the Los Alamos National Laboratory,
 *	and (W-31-109-ENG-38) at Argonne National Laboratory.
 *
 *	Initial development by:
 *		The Controls and Automation Group (AT-8)
 *		Ground Test Accelerator
 *		Accelerator Technology Division
 *		Los Alamos National Laboratory
 *
 *	Co-developed with
 *		The Controls and Computing Group
 *		Accelerator Systems Division
 *		Advanced Photon Source
 *		Argonne National Laboratory
 *
 * 	Modification Log:
 * 	-----------------
 */
#include <vxWorks.h>
#include <lstLib.h>
#include <taskLib.h>
#include <types.h>
#include <socket.h>
#include <in.h>
#include <db_access.h>
#include <task_params.h>
#include <server.h>

#define SAFE_DELETE_TASK(NAME)\
if( (tid = taskNameToId(NAME)) != ERROR &&\
    TASK_ID_VERIFY(tid) != ERROR ) td(tid)


/*
 * rsrv_init()
 * 
 *
 *
 */
void rsrv_init()
{
	FAST struct client 	*client;

	FASTLOCKINIT(&rsrv_free_addrq_lck);
	FASTLOCKINIT(&rsrv_free_eventq_lck);
	FASTLOCKINIT(&clientQlock);

	/*
	 * the following is based on the assumtion that external variables
	 * are not reloaded when debugging. NOTE: NULL below specifies all
	 * clients
	 */
	free_client(NULL);

	{
	  int tid;
	  SAFE_DELETE_TASK(CAST_SRVR_NAME);
	  SAFE_DELETE_TASK(REQ_SRVR_NAME);
	  SAFE_DELETE_TASK(CA_ONLINE_NAME);
	}

	taskSpawn(REQ_SRVR_NAME,
		  REQ_SRVR_PRI,
		  REQ_SRVR_OPT,
		  REQ_SRVR_STACK,
		  req_server);

	taskSpawn(CAST_SRVR_NAME,
		  CAST_SRVR_PRI,
		  CAST_SRVR_OPT,
		  CAST_SRVR_STACK,
		  cast_server);
}
