/*mon.h,v 1.1.1.1 1999/08/03 14:44:36 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/* Port number used by snlmon */

#ifndef	INCmodH
#define	INCmodH

#define	SNLMON_PORT		8599

/* Various defines and types */

#define	MODULE_NAME_SIZE	50
#define	TASK_NAME_SIZE		20
#define	PARAMETERS_SIZE		20
#define	RESOURCE_NAME_SIZE	20
#define	MAX_MODULES		100
#define	MAX_PROGRAMS		100

typedef	char	MODULE_NAME [MODULE_NAME_SIZE];
typedef	char	TASK_NAME [TASK_NAME_SIZE]
typedef	char	PARAMETERS [PARAMETERS_SIZE];
typedef	char	RESOURCE_NAME [RESOURCE_NAME_SIZE];

/************************************************************************/
/* 			     snlMon messages				*/
/************************************************************************/

typedef struct {
    int		Type;
    int		Length;
    int		Info;		/* Message type dependent */
} MSG_HEADER;

/************************************************************************/
/* PING: Used to ping the server.  Echos the Info field.		*/
/************************************************************************/

#define	PING_MSG_TYPE	1
#define	PING_REPLY_TYPE	(-PING_MSG_TYPE)
/* No message bodies for this message type */

/************************************************************************/
/* LOAD: Load an SNL program into the IOC				*/
/************************************************************************/

#define	LOAD_MSG_TYPE	2
typedef struct {
    MODULE_NAME	ModuleName;
} LOAD_MSG;

#define	LOAD_REPLY_TYPE	(-LOAD_MSG_TYPE)
/* No reply to this message. Info field contains OK or ERROR. */

/************************************************************************/
/* START: Start an SNL program	(maybe multiple state sets)		*/
/************************************************************************/

#define	START_MSG_TYPE	3
typedef struct {
    TASK_NAME		TaskName;
    PARAMETERS		Parameters;
    RESOURCE_NAME	Resource;
    int			StackSize;
} START_MSG;

#define	START_REPLY_TYPE (-START_MSG_TYPE)
typedef struct {
    char	ProgramName [PROGRAM_NAME_SIZE];
} START_REPLY;
/* Info field contains OK or ERROR */

/************************************************************************/
/* TASK STATUS: Get the status of a task				*/
/************************************************************************/

#define	STATUS_MSG_TYPE	4
typedef struct {
    TASK_NAME		TaskName;
} STATUS_MSG;

#define	STATUS_REPLY_TYPE (-STATUS_MSG_TYPE)
#define	STATE_SIZE	50
typedef struct {
    TASK_NAME	TaskName;
    int		Status;		/* ef_wait, delay, etc */
    int		Priority;
    STATE_NAME	InitState;
    STATE_NAME	PrevState;
    STATE_NAME	CurState;
    long	TimeEnt;
    long	TimeIn;
} STATUS_REPLY;
/* Info field contains OK or ERROR */

/************************************************************************/
/* KILL TASK: Kill a currently executing task.				*/
/************************************************************************/

#define	KILL_MSG_TYPE	5
typedef struct {
    PROGRAM_NAME	ProgramName;
    TASK_NAME		TaskName;
} KILL_MSG;-

#define	KILL_REPLY_TYPE (-KILL_MSG_TYPE)
/* Info field contains OK or ERROR */

/************************************************************************/
/* UNLOAD PROGRAM: Unload a program.					*/
/************************************************************************/

#define	UNLOAD_MSG_TYPE	6
typedef struct {
   MODULE_NAME	ModuleName;
} UNLOAD_MSG;

#define	UNLOAD_REPLY_TYPE (-KILL_MSG_TYPE)
/* Info field contains OK or ERROR */

/************************************************************************/
/* TERMINATE SERVER: Terminate the snlMon server			*/
/************************************************************************/

#define	TERMINATE_MSG_TYPE	7
#define	TERMINATE_MSG_REPLY	(-TERMINATE_MSG_TYPE)
/* Info field contains OK or ERROR */

#endif	INCmodH
