# include "stdio.h"

int yylex (void);
int yylook (void);
int yyback (int *p, int m);
int yyinput (void);
void yyoutput (int c);
void yyunput (int c);

# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
# define output(c) putc(c,yyout)
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
# define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng; extern char yytext[];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;
/**************************************************************************
			GTA PROJECT   AT division
	Copyright, 1990, The Regents of the University of California.
		         Los Alamos National Laboratory

	@(#)snc_lex.l	1.6	2/3/92
	ENVIRONMENT: UNIX
	HISTORY:
20nov91,ajk	Added OPTION token.
15jan92,ajk	Fixed to allow "!" as a unary operator.
***************************************************************************/
/* Lexical analyzer for State Notation Compiler (snc).
 *
 * This routine recognizes State Notation Language (SNL) syntax,
 * and passes tokens to yacc().
 * All C code is passed through as a stream, without conversion.
 * Hence, the C compiler may find errors not reported by SNC.
 * Comments are recognized as part of the syntax.
 */

#include	<stdio.h>
#include	<string.h>
#include	"parse.h"
#include	"y.tab.h"	/* output from yacc */
#ifndef	TRUE
#define	TRUE	1
#define	FALSE	0
#endif
/*#define	DEBUG 1*/
#ifdef	DEBUG
#define	RETURN(param)	{ fprintf(stderr, "return(param)\n"); return(param); }
#else
#define	RETURN(param)	return(param);
#endif
#define	STR_BFR_SIZE	500000

extern int	line_num, c_line_num; /* input line number */
extern int	warn_flag; /* compiler warning flag */
char		str_bfr[STR_BFR_SIZE]; /* holding place for strings */
char		*str_next = str_bfr; /* current ptr to str_bfr */
char		*c_str; /* Start of current string in str_bfr */
int		nc;
int		one_line_c_code;

# define SNL 2
# define C_CODE 4
# define COMMENT 6
# define STR 8
# define PP 10
# define PP_STR 12
# define YYNEWLINE 10
int yylex (void)
{
    int nstr; extern int yyprevious;

    while((nstr = yylook()) >= 0)
yyfussy:
    switch(nstr){
	case 0:
#ifdef WIN32
	    return 0;
#else
	    if(yywrap()) return(0); break;
#endif WIN32
	case 1:
	    *str_next++ = yytext[0];
	    break;
	    case 2:
	    {
		*str_next++ = '\n';
		line_num++;
		if (one_line_c_code)
		{
		    *str_next++ = 0;
		    yylval.pchar = c_str;
		    BEGIN SNL;
		    RETURN(C_STMT);
		}
	    }
	    break;
	case 3:
	    {
		*str_next++ = 0;
		yylval.pchar = c_str;
		BEGIN SNL;
		RETURN(C_STMT);
	    }
	    break;
	case 4:
	    line_num++;
	    break;
	case 5:
	    BEGIN SNL;
	    break;
	case 6:
	    ;
	    break;
	case 7:
	    {
		*str_next++ = yytext[0];
		*str_next++ = yytext[1];
	    }
	    break;
	case 8:
	    {
		*str_next++ = 0;
		yylval.pchar = c_str;
		BEGIN SNL;
		RETURN(STRING);
	    }
	    break;
	case 9:
	    { *str_next++ = yytext[0]; }
	    break;
	case 10:
	    {	*str_next++ = '?';
		if (warn_flag)
			fprintf(stderr, "Warning:  newline in string, line %d\n",
			 line_num);
		line_num++;
	    }
	    break;
	case 11:
	    {	nc = strlen(yytext);
		memcpy(str_next, yytext, nc+1);
		yylval.pchar = str_next;
		str_next += nc+1;
		RETURN(NUMBER);
	    }
	    break;
	case 12:
	    { c_str = str_next; BEGIN PP_STR; }
	    break;
	case 13:
	    {
		BEGIN SNL;
		RETURN(CR);
	    }
	    break;
	case 14:
	    /* no action */ ;
	    break;
	case 15:
	    {
	    }
	    break;
	case 16:
	    {
		*str_next++ = 0;
		yylval.pchar = c_str;
		BEGIN PP;
		RETURN(STRING);
	    }
	    break;
	case 17:
	    { *str_next++ = yytext[0]; }
	    break;
	case 18:
	    { *str_next++ = '?'; line_num++; }
	    break;
	case 19:
	    { line_num++; }
	    break;
	case 20:
	    {
		c_str = str_next;
		one_line_c_code = FALSE;
		c_line_num = line_num;
		BEGIN C_CODE;
	    }
	    break;
	case 21:
	    {
		c_str = str_next;
		one_line_c_code = TRUE;
		c_line_num = line_num;
		BEGIN C_CODE;
	    }
	    break;
	case 22:
	    {
		BEGIN PP;
		RETURN(PP_SYMBOL);
	    }
	    break;
	case 23:
	    BEGIN COMMENT;
	    break;
	case 24:
		{ c_str = str_next; BEGIN STR; }
	    break;
	case 25:
	    RETURN(STATE_SET);
	    break;
	case 26:
	    RETURN(STATE);
	    break;
	case 27:
	    RETURN(WHEN);
	    break;
	case 28:
	    RETURN(MONITOR);
	    break;
	case 29:
	    RETURN(ASSIGN);
	    break;
	case 30:
	    RETURN(CHAR);
	    break;
	case 31:
	    RETURN(SHORT);
	    break;
	case 32:
	    RETURN(INT);
	    break;
	case 33:
	    RETURN(LONG);
	    break;
	case 34:
	    RETURN(FLOAT);
	    break;
	case 35:
	    RETURN(DOUBLE);
	    break;
	case 36:
	    RETURN(STRING_DECL);
	    break;
	case 37:
	    RETURN(TO);
	    break;
	case 38:
	    RETURN(PROGRAM);
	    break;
	case 39:
	    RETURN(OPTION);
	    break;
	case 40:
	    RETURN(DEBUG_PRINT);
	    break;
	case 41:
	    RETURN(EVFLAG);
	    break;
	case 42:
	    RETURN(SYNC);
	    break;
	case 43:
	    RETURN(IF);
	    break;
	case 44:
	    RETURN(ELSE);
	    break;
	case 45:
	    RETURN(WHILE);
	    break;
	case 46:
	    RETURN(FOR);
	    break;
	case 47:
	    RETURN(BREAK);
	    break;
	case 48:
	    RETURN(EXIT);
	    break;
	case 49:
	    {
		yylval.pchar = "1";
		RETURN(NUMBER);
	    }
	    break;
	case 50:
	    {
		yylval.pchar = "0";
		RETURN(NUMBER);
	    }
	    break;
	case 51:
	    {
		nc = strlen(yytext);
		memcpy(str_next, yytext, nc+1);
		yylval.pchar = str_next;
		str_next += nc+1;
		RETURN(NAME);
	    }
	    break;
	case 52:
	    RETURN(AUTO_INCR);
	    break;
	case 53:
	    RETURN(AUTO_DECR);
	    break;
	case 54:
	    RETURN(OR);
	    break;
	case 55:
	    RETURN(LEFT_EQUAL);
	    break;
	case 56:
	    RETURN(RIGHT_EQUAL);
	    break;
	case 57:
	    RETURN(AND);
	    break;
	case 58:
	    RETURN(R_SHIFT);
	    break;
	case 59:
	    RETURN(GE);
	    break;
	case 60:
	    RETURN(EQ);
	    break;
	case 61:
	    RETURN(PLUS_EQUAL);
	    break;
	case 62:
	    RETURN(MINUS_EQUAL);
	    break;
	case 63:
	    RETURN(MULT_EQUAL);
	    break;
	case 64:
	    RETURN(DIV_EQUAL);
	    break;
	case 65:
	    RETURN(AND_EQUAL);
	    break;
	case 66:
	    RETURN(OR_EQUAL);
	    break;
	case 67:
	    RETURN(NE);
	    break;
	case 68:
	    RETURN(L_SHIFT);
	    break;
	case 69:
	    RETURN(LE);
	    break;
	case 70:
	    RETURN(MODULO_EQUAL);
	    break;
	case 71:
	    RETURN(CMPL_EQUAL);
	    break;
	case 72:
	    RETURN(POINTER);
	    break;
	case 73:
	    RETURN(PLUS);
	    break;
	case 74:
	    RETURN(MINUS);
	    break;
	case 75:
	    RETURN(NOT);
	    break;
	case 76:
	    RETURN(SLASH);
	    break;
	case 77:
	    RETURN(LT);
	    break;
	case 78:
	    RETURN(GT);
	    break;
	case 79:
	    RETURN(BIT_OR);
	    break;
	case 80:
	    RETURN(BIT_AND);
	    break;
	case 81:
	    RETURN(COMPLEMENT);
	    break;
	case 82:
	    RETURN(MODULO);
	    break;
	case 83:
	    RETURN(EQUAL);
	    break;
	case 84:
	    RETURN(AMPERSAND);
	    break;
	case 85:
	    RETURN(ASTERISK);
	    break;
	case 86:
	    RETURN(L_BRACKET);
	    break;
	case 87:
	    RETURN(R_BRACKET);
	    break;
	case 88:
	    RETURN(L_SQ_BRACKET);
	    break;
	case 89:
	    RETURN(R_SQ_BRACKET);
	    break;
	case 90:
	    RETURN(COLON);
	    break;
	case 91:
	    RETURN(SEMI_COLON);
	    break;
	case 92:
	    RETURN(PERIOD);
	    break;
	case 93:
	    RETURN(L_PAREN);
	    break;
	case 94:
	    RETURN(R_PAREN);
	    break;
	case 95:
	    RETURN(COMMA);
	    break;
	case 96:
	    {
		nc = strlen(yytext);
		memcpy(str_next, yytext, nc+1);
		yylval.pchar = str_next;
		str_next += nc+1;
		RETURN(NUMBER);
	    }
	    break;
	case 97:
	    /* no action */ ;
	    break;
	case 98:
	    RETURN(BAD_CHAR);
	    break;
	case 99:
	    {
		/* somehow "^#" doesn't work if it's first char */
		BEGIN PP;
		RETURN(PP_SYMBOL)
	    }
	    break;
	case 100:
	    {
		line_num = 1; BEGIN SNL; 
#ifndef WIN32
		yyless(0);
#endif WIN32
	    }
	    break;
	case -1:
	    break;
	default:
	    fprintf(yyout,"bad switch yylook %d",nstr);
	}
	return(0);
 }

/* end of yylex */

int yyvstop[] = {
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

14,
97,
0,

100,
0,

99,
100,
0,

98,
100,
0,

97,
98,
100,
0,

19,
100,
0,

75,
98,
100,
0,

24,
98,
100,
0,

98,
99,
100,
0,

82,
98,
100,
0,

80,
84,
98,
100,
0,

93,
98,
100,
0,

94,
98,
100,
0,

85,
98,
100,
0,

73,
98,
100,
0,

95,
98,
100,
0,

74,
98,
100,
0,

92,
98,
100,
0,

76,
98,
100,
0,

96,
98,
100,
0,

90,
98,
100,
0,

91,
98,
100,
0,

77,
98,
100,
0,

83,
98,
100,
0,

78,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

88,
98,
100,
0,

89,
98,
100,
0,

81,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

51,
98,
100,
0,

86,
98,
100,
0,

79,
98,
100,
0,

87,
98,
100,
0,

22,
98,
99,
100,
0,

1,
100,
0,

2,
100,
0,

1,
99,
100,
0,

1,
100,
0,

6,
100,
0,

4,
100,
0,

6,
99,
100,
0,

6,
100,
0,

9,
100,
0,

10,
100,
0,

8,
9,
100,
0,

9,
99,
100,
0,

9,
100,
0,

15,
100,
0,

14,
15,
100,
0,

13,
100,
0,

12,
15,
100,
0,

15,
99,
100,
0,

15,
100,
0,

15,
100,
0,

11,
15,
100,
0,

17,
100,
0,

18,
100,
0,

16,
17,
100,
0,

17,
99,
100,
0,

97,
0,

67,
0,

21,
0,

70,
0,

20,
0,

57,
0,

65,
0,

63,
0,

52,
0,

61,
0,

53,
0,

96,
0,

62,
0,

72,
0,

96,
0,

23,
0,

64,
0,

96,
0,

68,
0,

69,
0,

60,
0,

59,
0,

58,
0,

51,
0,

51,
0,

51,
0,

71,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

43,
51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

25,
51,
0,

51,
0,

51,
0,

37,
51,
0,

51,
0,

66,
0,

54,
0,

3,
0,

5,
0,

7,
0,

14,
0,

11,
0,

11,
0,

11,
0,

55,
0,

56,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

46,
51,
0,

32,
51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

49,
51,
0,

51,
0,

51,
0,

30,
51,
0,

51,
0,

51,
0,

44,
51,
0,

51,
0,

48,
51,
0,

51,
0,

33,
51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

51,
0,

42,
51,
0,

27,
51,
0,

51,
0,

50,
51,
0,

51,
0,

47,
51,
0,

40,
51,
0,

51,
0,

51,
0,

34,
51,
0,

51,
0,

51,
0,

51,
0,

31,
51,
0,

26,
51,
0,

51,
0,

45,
51,
0,

29,
51,
0,

35,
51,
0,

41,
51,
0,

51,
0,

39,
51,
0,

51,
0,

36,
51,
0,

28,
51,
0,

38,
51,
0,
0};
# define YYTYPE int
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,15,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,15,	1,15,	
0,0,	0,0,	3,17,	0,0,	
0,0,	0,0,	0,0,	0,0,	
18,88,	0,0,	3,18,	3,19,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
1,16,	2,16,	14,86,	14,87,	
6,65,	10,73,	10,74,	18,88,	
24,93,	8,69,	3,20,	3,21,	
3,22,	1,15,	3,23,	3,24,	
8,70,	3,25,	3,26,	3,27,	
3,28,	3,29,	3,30,	3,31,	
3,32,	3,33,	0,0,	28,96,	
0,0,	20,89,	1,15,	24,94,	
12,79,	12,80,	23,90,	3,34,	
3,35,	3,36,	3,37,	3,38,	
27,95,	37,108,	3,39,	12,81,	
12,82,	28,97,	32,103,	3,40,	
31,102,	31,102,	31,102,	31,102,	
31,102,	31,102,	31,102,	31,102,	
31,102,	31,102,	23,91,	40,112,	
1,15,	3,41,	41,113,	10,75,	
44,114,	32,104,	36,106,	36,107,	
3,42,	66,139,	3,43,	3,44,	
3,17,	47,117,	3,45,	3,46,	
3,47,	3,48,	3,49,	3,50,	
38,109,	38,110,	3,51,	45,115,	
46,116,	3,52,	3,53,	48,118,	
3,54,	3,55,	52,127,	51,125,	
3,56,	3,57,	6,66,	50,123,	
3,58,	48,119,	50,124,	51,126,	
3,59,	3,60,	3,61,	4,20,	
4,21,	4,62,	53,128,	4,23,	
4,24,	49,120,	4,25,	4,26,	
4,27,	4,28,	4,29,	4,30,	
4,31,	4,32,	54,129,	49,121,	
23,92,	49,122,	55,130,	57,135,	
58,136,	56,131,	5,63,	70,140,	
4,34,	4,35,	4,36,	4,37,	
4,38,	75,141,	5,63,	5,64,	
56,132,	56,133,	83,145,	60,137,	
4,40,	106,146,	56,134,	77,142,	
110,147,	112,148,	113,149,	115,150,	
116,151,	117,152,	7,67,	118,153,	
119,154,	120,155,	4,41,	121,156,	
122,157,	123,158,	7,67,	7,68,	
5,65,	4,42,	124,159,	4,43,	
4,44,	126,160,	77,142,	4,45,	
4,46,	4,47,	4,48,	4,49,	
4,50,	5,63,	127,161,	4,51,	
128,162,	129,163,	4,52,	4,53,	
130,164,	4,54,	4,55,	131,165,	
7,69,	4,56,	4,57,	134,168,	
143,145,	4,58,	5,63,	7,70,	
9,71,	4,59,	4,60,	4,61,	
11,76,	7,67,	13,84,	133,166,	
9,71,	9,72,	60,138,	148,171,	
11,77,	11,78,	13,84,	13,85,	
136,169,	149,172,	150,173,	151,174,	
136,170,	152,175,	7,67,	153,176,	
133,167,	154,177,	155,178,	156,179,	
5,63,	157,180,	158,181,	161,182,	
162,183,	9,73,	9,74,	163,184,	
164,185,	11,79,	11,80,	13,86,	
13,87,	165,186,	166,187,	167,188,	
168,189,	169,190,	170,191,	9,71,	
11,81,	11,82,	171,192,	11,83,	
7,67,	13,84,	173,193,	174,194,	
176,195,	177,196,	5,66,	179,197,	
181,198,	183,199,	184,200,	185,201,	
9,71,	186,202,	187,203,	188,204,	
11,76,	30,98,	13,84,	191,205,	
30,99,	30,99,	30,99,	30,99,	
30,99,	30,99,	30,99,	30,99,	
30,99,	30,99,	193,206,	196,207,	
197,208,	30,100,	30,101,	199,209,	
200,210,	201,211,	204,212,	9,75,	
209,213,	211,214,	9,71,	0,0,	
0,0,	0,0,	11,76,	33,105,	
13,84,	33,99,	33,99,	33,99,	
33,99,	33,99,	33,99,	33,99,	
33,99,	33,99,	33,99,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	0,0,	0,0,	
0,0,	0,0,	39,111,	0,0,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	39,111,	39,111,	
39,111,	39,111,	81,143,	81,143,	
81,143,	81,143,	81,143,	81,143,	
81,143,	81,143,	81,143,	81,143,	
82,144,	82,144,	82,144,	82,144,	
82,144,	82,144,	82,144,	82,144,	
82,144,	82,144,	105,105,	105,105,	
105,105,	105,105,	105,105,	105,105,	
105,105,	105,105,	105,105,	105,105,	
145,145,	145,145,	145,145,	145,145,	
145,145,	145,145,	145,145,	145,145,	
145,145,	145,145,	0,0,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		yyvstop+1,
yycrank+-2,	yysvec+1,	yyvstop+4,
yycrank+-13,	0,		yyvstop+7,
yycrank+-106,	yysvec+3,	yyvstop+10,
yycrank+-161,	0,		yyvstop+13,
yycrank+-5,	yysvec+5,	yyvstop+16,
yycrank+-185,	0,		yyvstop+19,
yycrank+-10,	yysvec+7,	yyvstop+22,
yycrank+-227,	0,		yyvstop+25,
yycrank+-7,	yysvec+9,	yyvstop+28,
yycrank+-231,	0,		yyvstop+31,
yycrank+-34,	yysvec+11,	yyvstop+34,
yycrank+-233,	0,		yyvstop+37,
yycrank+-4,	yysvec+13,	yyvstop+40,
yycrank+0,	0,		yyvstop+43,
yycrank+0,	0,		yyvstop+45,
yycrank+0,	0,		yyvstop+48,
yycrank+11,	0,		yyvstop+51,
yycrank+0,	0,		yyvstop+55,
yycrank+4,	0,		yyvstop+58,
yycrank+0,	0,		yyvstop+62,
yycrank+0,	0,		yyvstop+66,
yycrank+33,	0,		yyvstop+70,
yycrank+6,	0,		yyvstop+74,
yycrank+0,	0,		yyvstop+79,
yycrank+0,	0,		yyvstop+83,
yycrank+15,	0,		yyvstop+87,
yycrank+20,	0,		yyvstop+91,
yycrank+0,	0,		yyvstop+95,
yycrank+252,	0,		yyvstop+99,
yycrank+36,	0,		yyvstop+103,
yycrank+40,	0,		yyvstop+107,
yycrank+281,	0,		yyvstop+111,
yycrank+0,	0,		yyvstop+115,
yycrank+0,	0,		yyvstop+119,
yycrank+42,	0,		yyvstop+123,
yycrank+16,	0,		yyvstop+127,
yycrank+55,	0,		yyvstop+131,
yycrank+291,	0,		yyvstop+135,
yycrank+30,	yysvec+39,	yyvstop+139,
yycrank+16,	yysvec+39,	yyvstop+143,
yycrank+0,	0,		yyvstop+147,
yycrank+0,	0,		yyvstop+151,
yycrank+39,	0,		yyvstop+155,
yycrank+4,	yysvec+39,	yyvstop+159,
yycrank+6,	yysvec+39,	yyvstop+163,
yycrank+5,	yysvec+39,	yyvstop+167,
yycrank+22,	yysvec+39,	yyvstop+171,
yycrank+37,	yysvec+39,	yyvstop+175,
yycrank+23,	yysvec+39,	yyvstop+179,
yycrank+25,	yysvec+39,	yyvstop+183,
yycrank+15,	yysvec+39,	yyvstop+187,
yycrank+31,	yysvec+39,	yyvstop+191,
yycrank+42,	yysvec+39,	yyvstop+195,
yycrank+44,	yysvec+39,	yyvstop+199,
yycrank+57,	yysvec+39,	yyvstop+203,
yycrank+48,	yysvec+39,	yyvstop+207,
yycrank+56,	yysvec+39,	yyvstop+211,
yycrank+0,	0,		yyvstop+215,
yycrank+114,	0,		yyvstop+219,
yycrank+0,	0,		yyvstop+223,
yycrank+0,	0,		yyvstop+227,
yycrank+0,	0,		yyvstop+232,
yycrank+0,	0,		yyvstop+235,
yycrank+0,	0,		yyvstop+238,
yycrank+68,	0,		yyvstop+242,
yycrank+0,	0,		yyvstop+245,
yycrank+0,	0,		yyvstop+248,
yycrank+0,	0,		yyvstop+251,
yycrank+116,	0,		yyvstop+255,
yycrank+0,	0,		yyvstop+258,
yycrank+0,	0,		yyvstop+261,
yycrank+0,	0,		yyvstop+264,
yycrank+0,	0,		yyvstop+268,
yycrank+135,	0,		yyvstop+272,
yycrank+0,	0,		yyvstop+275,
yycrank+170,	0,		yyvstop+278,
yycrank+0,	0,		yyvstop+282,
yycrank+0,	0,		yyvstop+285,
yycrank+0,	0,		yyvstop+289,
yycrank+366,	0,		yyvstop+293,
yycrank+376,	0,		yyvstop+296,
yycrank+128,	yysvec+81,	yyvstop+299,
yycrank+0,	0,		yyvstop+303,
yycrank+0,	0,		yyvstop+306,
yycrank+0,	0,		yyvstop+309,
yycrank+0,	0,		yyvstop+313,
yycrank+0,	yysvec+18,	yyvstop+317,
yycrank+0,	0,		yyvstop+319,
yycrank+0,	0,		yyvstop+321,
yycrank+0,	0,		yyvstop+323,
yycrank+0,	0,		yyvstop+325,
yycrank+0,	0,		yyvstop+327,
yycrank+0,	0,		yyvstop+329,
yycrank+0,	0,		yyvstop+331,
yycrank+0,	0,		yyvstop+333,
yycrank+0,	0,		yyvstop+335,
yycrank+0,	0,		yyvstop+337,
yycrank+0,	yysvec+33,	yyvstop+339,
yycrank+0,	0,		yyvstop+341,
yycrank+0,	0,		yyvstop+343,
yycrank+0,	yysvec+31,	yyvstop+345,
yycrank+0,	0,		yyvstop+347,
yycrank+0,	0,		yyvstop+349,
yycrank+386,	0,		yyvstop+351,
yycrank+116,	0,		yyvstop+353,
yycrank+0,	0,		yyvstop+355,
yycrank+0,	0,		yyvstop+357,
yycrank+0,	0,		yyvstop+359,
yycrank+119,	0,		yyvstop+361,
yycrank+0,	yysvec+39,	yyvstop+363,
yycrank+105,	yysvec+39,	yyvstop+365,
yycrank+97,	yysvec+39,	yyvstop+367,
yycrank+0,	0,		yyvstop+369,
yycrank+68,	yysvec+39,	yyvstop+371,
yycrank+83,	yysvec+39,	yyvstop+373,
yycrank+88,	yysvec+39,	yyvstop+375,
yycrank+89,	yysvec+39,	yyvstop+377,
yycrank+71,	yysvec+39,	yyvstop+379,
yycrank+74,	yysvec+39,	yyvstop+381,
yycrank+89,	yysvec+39,	yyvstop+383,
yycrank+87,	yysvec+39,	yyvstop+385,
yycrank+82,	yysvec+39,	yyvstop+387,
yycrank+84,	yysvec+39,	yyvstop+389,
yycrank+0,	yysvec+39,	yyvstop+391,
yycrank+85,	yysvec+39,	yyvstop+394,
yycrank+100,	yysvec+39,	yyvstop+396,
yycrank+102,	yysvec+39,	yyvstop+398,
yycrank+97,	yysvec+39,	yyvstop+400,
yycrank+105,	yysvec+39,	yyvstop+402,
yycrank+108,	yysvec+39,	yyvstop+404,
yycrank+0,	yysvec+39,	yyvstop+406,
yycrank+138,	yysvec+39,	yyvstop+409,
yycrank+113,	yysvec+39,	yyvstop+411,
yycrank+0,	yysvec+39,	yyvstop+413,
yycrank+143,	yysvec+39,	yyvstop+416,
yycrank+0,	0,		yyvstop+418,
yycrank+0,	0,		yyvstop+420,
yycrank+0,	0,		yyvstop+422,
yycrank+0,	0,		yyvstop+424,
yycrank+0,	0,		yyvstop+426,
yycrank+0,	yysvec+77,	yyvstop+428,
yycrank+178,	yysvec+81,	yyvstop+430,
yycrank+0,	yysvec+82,	yyvstop+432,
yycrank+396,	0,		yyvstop+434,
yycrank+0,	0,		yyvstop+436,
yycrank+0,	0,		yyvstop+438,
yycrank+156,	yysvec+39,	yyvstop+440,
yycrank+176,	yysvec+39,	yyvstop+442,
yycrank+141,	yysvec+39,	yyvstop+444,
yycrank+150,	yysvec+39,	yyvstop+446,
yycrank+135,	yysvec+39,	yyvstop+448,
yycrank+134,	yysvec+39,	yyvstop+450,
yycrank+155,	yysvec+39,	yyvstop+452,
yycrank+153,	yysvec+39,	yyvstop+454,
yycrank+147,	yysvec+39,	yyvstop+456,
yycrank+141,	yysvec+39,	yyvstop+458,
yycrank+161,	yysvec+39,	yyvstop+460,
yycrank+0,	yysvec+39,	yyvstop+462,
yycrank+0,	yysvec+39,	yyvstop+465,
yycrank+156,	yysvec+39,	yyvstop+468,
yycrank+155,	yysvec+39,	yyvstop+470,
yycrank+158,	yysvec+39,	yyvstop+472,
yycrank+161,	yysvec+39,	yyvstop+474,
yycrank+155,	yysvec+39,	yyvstop+476,
yycrank+154,	yysvec+39,	yyvstop+478,
yycrank+166,	yysvec+39,	yyvstop+480,
yycrank+173,	yysvec+39,	yyvstop+482,
yycrank+163,	yysvec+39,	yyvstop+484,
yycrank+166,	yysvec+39,	yyvstop+486,
yycrank+209,	yysvec+39,	yyvstop+488,
yycrank+0,	yysvec+39,	yyvstop+490,
yycrank+179,	yysvec+39,	yyvstop+493,
yycrank+176,	yysvec+39,	yyvstop+495,
yycrank+0,	yysvec+39,	yyvstop+497,
yycrank+181,	yysvec+39,	yyvstop+500,
yycrank+177,	yysvec+39,	yyvstop+502,
yycrank+0,	yysvec+39,	yyvstop+504,
yycrank+190,	yysvec+39,	yyvstop+507,
yycrank+0,	yysvec+39,	yyvstop+509,
yycrank+172,	yysvec+39,	yyvstop+512,
yycrank+0,	yysvec+39,	yyvstop+514,
yycrank+173,	yysvec+39,	yyvstop+517,
yycrank+179,	yysvec+39,	yyvstop+519,
yycrank+177,	yysvec+39,	yyvstop+521,
yycrank+177,	yysvec+39,	yyvstop+523,
yycrank+193,	yysvec+39,	yyvstop+525,
yycrank+185,	yysvec+39,	yyvstop+527,
yycrank+0,	yysvec+39,	yyvstop+529,
yycrank+0,	yysvec+39,	yyvstop+532,
yycrank+198,	yysvec+39,	yyvstop+535,
yycrank+0,	yysvec+39,	yyvstop+537,
yycrank+200,	yysvec+39,	yyvstop+540,
yycrank+0,	yysvec+39,	yyvstop+542,
yycrank+0,	yysvec+39,	yyvstop+545,
yycrank+210,	yysvec+39,	yyvstop+548,
yycrank+209,	yysvec+39,	yyvstop+550,
yycrank+0,	yysvec+39,	yyvstop+552,
yycrank+204,	yysvec+39,	yyvstop+555,
yycrank+206,	yysvec+39,	yyvstop+557,
yycrank+220,	yysvec+39,	yyvstop+559,
yycrank+0,	yysvec+39,	yyvstop+561,
yycrank+0,	yysvec+39,	yyvstop+564,
yycrank+215,	yysvec+39,	yyvstop+567,
yycrank+0,	yysvec+39,	yyvstop+569,
yycrank+0,	yysvec+39,	yyvstop+572,
yycrank+0,	yysvec+39,	yyvstop+575,
yycrank+0,	yysvec+39,	yyvstop+578,
yycrank+206,	yysvec+39,	yyvstop+581,
yycrank+0,	yysvec+39,	yyvstop+583,
yycrank+212,	yysvec+39,	yyvstop+586,
yycrank+0,	yysvec+39,	yyvstop+588,
yycrank+0,	yysvec+39,	yyvstop+591,
yycrank+0,	yysvec+39,	yyvstop+594,
0,	0,	0};
struct yywork *yytop = yycrank+453;
struct yysvf *yybgin = yysvec+1;
char yymatch[] = {
00  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,011 ,012 ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
011 ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,01  ,01  ,01  ,01  ,01  ,01  ,01  ,
'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,'0' ,
'0' ,'0' ,01  ,01  ,01  ,01  ,01  ,01  ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,'_' ,
01  ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,'A' ,
'A' ,'A' ,'A' ,01  ,01  ,01  ,01  ,01  ,
0};
char yyextra[] = {
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,
0};
#ifndef lint
static	char ncform_sccsid[] = "@(#)ncform 1.6 88/02/08 SMI"; /* from S5R2 1.2 */
#endif

int yylineno =1;
# define YYU(x) x
# define NLSTATE yyprevious=YYNEWLINE
char yytext[YYLMAX];
struct yysvf *yylstate [YYLMAX], **yylsp, **yyolsp;
char yysbuf[YYLMAX];
char *yysptr = yysbuf;
int *yyfnd;
extern struct yysvf *yyestate;
int yyprevious = YYNEWLINE;

int yylook (void)
{
    register struct yysvf *yystate, **lsp;
    register struct yywork *yyt;
    struct yysvf *yyz;
    int yych, yyfirst;
    struct yywork *yyr;
# ifdef LEXDEBUG
    int debug;
# endif
    char *yylastch;
	/* start off machines */
# ifdef LEXDEBUG
	debug = 0;
# endif
	yyfirst=1;
	if (!yymorfg)
		yylastch = yytext;
	else {
		yymorfg=0;
		yylastch = yytext+yyleng;
		}
	for(;;){
		lsp = yylstate;
		yyestate = yystate = yybgin;
		if (yyprevious==YYNEWLINE) yystate++;
		for (;;){
# ifdef LEXDEBUG
			if(debug)fprintf(yyout,"state %d\n",yystate-yysvec-1);
# endif
			yyt = yystate->yystoff;
			if(yyt == yycrank && !yyfirst){  /* may not be any transitions */
				yyz = yystate->yyother;
				if(yyz == 0)break;
				if(yyz->yystoff == yycrank)break;
				}
			*yylastch++ = yych = input();
			yyfirst=0;
		tryagain:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"char ");
				allprint(yych);
				putchar('\n');
				}
# endif
			yyr = yyt;
			if ( (int)yyt > (int)yycrank){
				yyt = yyr + yych;
				if (yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
# ifdef YYOPTIM
			else if((int)yyt < (int)yycrank) {		/* r < yycrank */
				yyt = yyr = yycrank+(yycrank-yyt);
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"compressed state\n");
# endif
				yyt = yyt + yych;
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transitions */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				yyt = yyr + YYU(yymatch[yych]);
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"try fall back character ");
					allprint(YYU(yymatch[yych]));
					putchar('\n');
					}
# endif
				if(yyt <= yytop && yyt->verify+yysvec == yystate){
					if(yyt->advance+yysvec == YYLERR)	/* error transition */
						{unput(*--yylastch);break;}
					*lsp++ = yystate = yyt->advance+yysvec;
					goto contin;
					}
				}
			if ((yystate = yystate->yyother) && (yyt= yystate->yystoff) != yycrank){
# ifdef LEXDEBUG
				if(debug)fprintf(yyout,"fall back to state %d\n",yystate-yysvec-1);
# endif
				goto tryagain;
				}
# endif
			else
				{unput(*--yylastch);break;}
		contin:
# ifdef LEXDEBUG
			if(debug){
				fprintf(yyout,"state %d char ",yystate-yysvec-1);
				allprint(yych);
				putchar('\n');
				}
# endif
			;
			}
# ifdef LEXDEBUG
		if(debug){
			fprintf(yyout,"stopped at %d with ",*(lsp-1)-yysvec-1);
			allprint(yych);
			putchar('\n');
			}
# endif
		while (lsp-- > yylstate){
			*yylastch-- = 0;
			if (*lsp != 0 && (yyfnd= (*lsp)->yystops) && *yyfnd > 0){
				yyolsp = lsp;
				if(yyextra[*yyfnd]){		/* must backup */
					while(yyback((*lsp)->yystops,-*yyfnd) != 1 && lsp > yylstate){
						lsp--;
						unput(*yylastch--);
						}
					}
				yyprevious = YYU(*yylastch);
				yylsp = lsp;
				yyleng = yylastch-yytext+1;
				yytext[yyleng] = 0;
# ifdef LEXDEBUG
				if(debug){
					fprintf(yyout,"\nmatch ");
					sprint(yytext);
					fprintf(yyout," action %d\n",*yyfnd);
					}
# endif
				return(*yyfnd++);
				}
			unput(*yylastch);
			}
		if (yytext[0] == 0  /* && feof(yyin) */)
			{
			yysptr=yysbuf;
			return(0);
			}
		yyprevious = yytext[0] = input();
		if (yyprevious>0)
			output(yyprevious);
		yylastch=yytext;
# ifdef LEXDEBUG
		if(debug)putchar('\n');
# endif
		}
	}
int yyback(p, m)
	int *p;
{
    if (p==0) return(0);
    while (*p)
	{
	if (*p++ == m)
		return(1);
	}
    return(0);
}
	/* the following are only used in the lex library */
int yyinput ()
{
    return(input());
}

void yyoutput(c)
  int c;
{
    output(c);
}

void yyunput(c)
   int c;
{
    unput(c);
}
