/*snlrepvars.c,v 1.1.1.1 1999/08/03 14:44:39 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/* Get the variables for a program */

#include <stdio.h>
#include <stdlib.h>
#include <usrseq.h>
#include "mon_defs.h"
#include "msgMon.h"

main (int argc, char *argv[])
{

    REPVARS_REPLY	*repvarsReply, *p;
    int			i, j, NumVars, Length, Count;
    char		*Var, *q;
    long		taskId;

    tisOpenLog ("snlrepvars", 6, 2, NULL, NULL);

    /* Check for proper number of arguments */

    if (argc != 4) {
	printf ("Usage: snlrepvars <host-name> <program_name> <task_id>\n");
	exit (1);
    }

    /* Connect to the server. */

    if (!snlMonConnect (argv [1])) {
	printf ("Unable to connect to snlMon on %s\n", argv [1]);
	exit (1);
    }

    taskId = atol (argv[3]);
    /* Send a message to retrieve all variables */

    snlMon_ReportVariables (argv [2], taskId, &repvarsReply, &NumVars);

    /* Retrieve the value of each variable */

    for (i=0, p=repvarsReply ; i<NumVars ; i++, p++) {
	if (snlMon_ReportVariable (argv [2], taskId, p->Name, &Var, &Length)) {
	    printf ("%s: ", p->Name);
	    if (p->NumElements == 0)
		Count = 1;
	    else
		Count = p->NumElements;
	    q = Var;
	    for (j=0 ; j<Count ; j++) {	
		switch (p->Type) {
		    case V_CHAR:
			printf ("%c", *q);
			break;
		    case V_INT:
			printf ("%d", *((int *)q));
			break;
		    case V_LONG:
			printf ("%ld", *((long *)q));
			break;
		    case V_SHORT:
			printf ("%d", (int)*((short *)q));
			break;
		    case V_FLOAT:
			printf ("%f", *((float *)q));
			break;
 		    case V_DOUBLE:
			printf ("%lf", *((double *)q));
			break;
		    case V_STRING:
			printf ("%s", q);
			break;
	        }
		printf (" ");
		q += p->Size;
	    }
	    printf ("\n");
	    free (Var);
	}
    }

    free (repvarsReply);

    /* Drop the connection to the server */

    snlMonDisconnect ();


    return 0;
}

