#ifndef	INCsnlvueditinstanceHXX
#define	INCsnlvueditinstanceHXX

enum EDITINSTANCE_TYPE
{
    DEFINE_NEW_INSTANCE,
    EDIT_INSTANCE
};

class EditInstanceOkButton;
class EditInstanceCancelButton;

class EditInstanceDialog : public vdialog
{
    MainDialog		*mainDialog;
    EDITINSTANCE_TYPE	type;
    Instance		instance;

    // dialog items
    EditInstanceOkButton	*okButton;
    EditInstanceCancelButton	*cancelButton;

    void BuildTitle (void);
    void InitFields (void);

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(EditInstanceDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(EditInstanceDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // vwindow overide
    void ObserveWindow (vevent *event);

    // open 
    void OpenEditInstance (MainDialog *mainDlg, EDITINSTANCE_TYPE type, 
				Instance *inst);

    Instance *GetInstance (void)
	{ return (&instance); }

    // gain access to data
    void GetInstanceData (Instance *inst)
	{ *inst = instance; }

    // gain access to the main dialog
    MainDialog *GetMainDialog (void)
	{ return (mainDialog); }

    // funcs to update instance
    void SetProgramName (vstr *prog);
    void SetParameters (vstr *params);
    void SetResourceName (vstr *res);

    filteredTextitem		*program;
    filteredTextitem		*parameters;
    filteredTextitem		*resourceName;
};


class  EditInstanceOkButton : public vbutton
{
    EditInstanceDialog	*editinstanceDialog;

public:
    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(EditInstanceOkButton);
    vloadableINLINE_CONSTRUCTORS(EditInstanceOkButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreEditInstanceDialog (EditInstanceDialog *dlg)
	{ editinstanceDialog = dlg; }
};

class  EditInstanceCancelButton : public vbutton
{
    EditInstanceDialog	*editinstanceDialog;

public:
    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(EditInstanceCancelButton);
    vloadableINLINE_CONSTRUCTORS(EditInstanceCancelButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreEditInstanceDialog (EditInstanceDialog *dlg)
	{ editinstanceDialog = dlg; }
};

#endif	INCsnlvueditinstanceHXX
