#ifndef	INCsnlvuenterHXX
#define	INCsnlvuenterHXX

enum ENTER_TYPE
{
    ENTER_MODULE_NAME,
    ENTER_VALUE,
    NEW_IOC
};

#define	ENTERED_DATA_SIZE	100

class EnterOkButton;
class EnterCancelButton;

class EnterDialog : public vdialog
{
    vchar	enteredData[ENTERED_DATA_SIZE + 1];
    MainDialog	*mainDialog;
    ENTER_TYPE	type;

    // dialog items
    filteredTextitem	*text;
    EnterOkButton	*okButton;
    EnterCancelButton	*cancelButton;

    void BuildTitle (char *arg);
    void SetFilter (void);

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(EnterDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(EnterDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // vwindow overide
    void ObserveWindow (vevent *event);

    // open 
    void OpenEnter (MainDialog *mainDlg, ENTER_TYPE type, char *arg);

    // gain access to data
    vchar *GetEnteredData (void)
	{ return (enteredData); }

    // gain access to the main dialog
    MainDialog *GetMainDialog (void)
	{ return (mainDialog); }

    // return the filted text item
    filteredTextitem *GetFilteredText (void)
	{ return (text); }

    ENTER_TYPE GetType (void)
	{ return (type); }
};


class  EnterOkButton : public vbutton
{
    EnterDialog	*enterDialog;

public:
    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(EnterOkButton);
    vloadableINLINE_CONSTRUCTORS(EnterOkButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreEnterDialog (EnterDialog *dlg)
	{ enterDialog = dlg; }
};

class  EnterCancelButton : public vbutton
{
    EnterDialog	*enterDialog;

public:
    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(EnterCancelButton);
    vloadableINLINE_CONSTRUCTORS(EnterCancelButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreEnterDialog (EnterDialog *dlg)
	{ enterDialog = dlg; }
};

#endif	INCsnlvuenterHXX
