#ifndef	INCsnlvustatesetsdialogHXX
#define	INCsnlvustatesetsdialogHXX

class StateSetsListView;
class StateSetsPauseButton;
class StateSetsContinueButton;
class StateSetsExitButton;

class StateSetsDialog : public vdialog
{
    MainDialog			*mainDialog;
    vruler			*stateSetsRuler;
    StateSetsListView		*stateSetsListView;
    StateSetsPauseButton	*pauseButton;
    StateSetsContinueButton	*continueButton;
    StateSetsExitButton		*exitButton;

    void		SetStateSetsTitle (void);

    // remember the current StateSets displayed
    REPSS_REPLY		*PrevStateSets;
    char		programName [PROGRAM_NAME_SIZE + 1];
    long		TaskId;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(StateSetsDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(StateSetsDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override 
    void Destroy ();

    // vwindow overide
    void ObserveWindow (vevent *event);

    // override a dialog reconfigure event
    int HandleConfigure (vevent *event);

    // open 
    void OpenStateSets (MainDialog *dlg, char *progName, long tid);

    void UpdateStateSetsList (void);

    MainDialog *GetMainDialog (void)
	{ return (mainDialog); }

    REPSS_REPLY *GetPrevStateSets (void)
	{ return (PrevStateSets); }

    char *GetProgramName (void)
	{ return (programName); }

    long GetTaskId (void)
	{ return (TaskId); }

    StateSetsListView *GetStateSetsListView (void)
	{ return (stateSetsListView); }

    vruler *GetStateSetsRuler (void)
	{ return (stateSetsRuler); }

    int	InUse;
};


class  StateSetsListView : public vlistview
{
    StateSetsDialog	*stateSetsDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(StateSetsListView);
    vloadableINLINE_CONSTRUCTORS(StateSetsListView, vlistview);

    // override 
    void Destroy ();

    // override
    void DrawCellContents (int row, int col, int selected, vrect *cellRect);

    // override
    void ObserveSelect (int state);

    void BuildList (REPSS_REPLY *StateSets, int numStateSets);

    // set columns width based on current ruler item widths
    void SetColumnsWidths (void);

    void StoreStateSetsDialog (StateSetsDialog *dlg)
	{ stateSetsDialog = dlg; }
};


class  StateSetsPauseButton : public vbutton
{
    StateSetsDialog	*stateSetsDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(StateSetsPauseButton);
    vloadableINLINE_CONSTRUCTORS(StateSetsPauseButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreStateSetsDialog (StateSetsDialog *dlg)
	{ stateSetsDialog = dlg; }
};


class  StateSetsContinueButton : public vbutton
{
    StateSetsDialog	*stateSetsDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(StateSetsContinueButton);
    vloadableINLINE_CONSTRUCTORS(StateSetsContinueButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreStateSetsDialog (StateSetsDialog *dlg)
	{ stateSetsDialog = dlg; }
};


class  StateSetsExitButton : public vbutton
{
    StateSetsDialog	*stateSetsDialog;

public:

    // macros for standard versions of the
    // constructors and destructors

    vkindTYPED_FULL_DECLARATION(StateSetsExitButton);
    vloadableINLINE_CONSTRUCTORS(StateSetsExitButton, vbutton);

    // override
    void ObserveDialogItem (vevent *event);

    void StoreStateSetsDialog (StateSetsDialog *dlg)
	{ stateSetsDialog = dlg; }
};

#endif	INCsnlvustatesetsdialogHXX

