/****
*
*	File name :		l1_tcpx.c
*	Author :		Steve Johnson
*	Creation date :	December 1, 1985
*
*	Copyright (c) 1985,1999 Sigma Six Corporation
*
*	Provide the following entry points
*
*		l1tcp_init
*		l1tcp_connect
*		l1tcp_publish
*		l1tcp_accept
*		l1tcp_write
*		l1tcp_poll
*		l1tcp_read
*		l1tcp_clear
*		l1tcp_shutdown
*		l1tcp_exit
*
*	Entry point stub layer for using TCP/IP to a telnet session
*
****/

#include <sscommon.h>
#include <sstrace.h>
#include <sslevel1.h>
#include <ssl1tcp.h>

/****
*
****/

LEVEL1_STATUS l1tcp_init (void)
{
	TRACE ("l1tcp_init, stub");
	return LEVEL1_NORMAL;
}

/****
*
****/

LEVEL1_STATUS l1tcp_connect (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE ("l1tcp_connect, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1tcp_publish (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE_S ("l1tcp_publish, not supported (%s)", name);
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1tcp_accept (LEVEL1_HANDLE	*client_handle
						  , LEVEL1_HANDLE	server_handle)
{
	ERROR_TRACE ("l1tcp_accept, not supported");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1tcp_write (LEVEL1_HANDLE		user_handle
						 , size_t				buffer_size
						 , void 				*buffer)
{
	ERROR_TRACE ("l1tcp_write, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1tcp_poll (LEVEL1_HANDLE user_handle, size_t *bytes_ready)
{
	ERROR_TRACE ("l1tcp_poll, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1tcp_read (LEVEL1_HANDLE	user_handle
						, size_t		buffer_size
						, void			*buffer
						, size_t		*return_length)
{
	ERROR_TRACE ("l1tcp_read, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1tcp_clear (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("l1tcp_clear, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1tcp_shutdown (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("l1tcp_shutdown, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS l1tcp_exit (void)
{
	TRACE ("digi_exit, stub");
	return LEVEL1_NORMAL;
}
