/****
*
*	File name :		l1_winx.c
*	Author :		Steve Johnson
*	Creation date :	September 28, 1992
*
*	Copyright (c) 1985,1999 Sigma Six Corporation
*
*	Provide the following entry points
*
*		wincom_init
*		wincom_connect
*		wincom_publish
*		wincom_accept
*		wincom_write
*		wincom_poll
*		wincom_read
*		wincom_clear
*		wincom_shutdown
*		wincom_exit
*
*	Entry point stub layer for PC Windows Comm Ports
*
****/

#include <sscommon.h>
#include <sstrace.h>
#include <sslevel1.h>
#include <ssl1win.h>

/****
*
****/

LEVEL1_STATUS wincom_init (void)
{
	TRACE ("wincom_init, stub");
	return LEVEL1_NORMAL;
}

/****
*
****/

LEVEL1_STATUS wincom_connect (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE ("wincom_connect, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS wincom_publish (LEVEL1_HANDLE *user_handle, char *name)
{
	ERROR_TRACE_S ("wincom_publish, not supported (%s)", name);
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS wincom_accept (LEVEL1_HANDLE	*client_handle
						   , LEVEL1_HANDLE	server_handle)
{
	ERROR_TRACE ("wincom_accept, not supported");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS wincom_write (LEVEL1_HANDLE	user_handle
						  , size_t			buffer_size
						  , void			*buffer)
{
	ERROR_TRACE ("wincom_write, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS wincom_poll (LEVEL1_HANDLE user_handle, size_t *bytes_ready)
{
	ERROR_TRACE ("wincom_poll, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS wincom_read (LEVEL1_HANDLE	user_handle
						 , size_t			buffer_size
						 , void				*buffer
						 , size_t			*return_length)
{
	ERROR_TRACE ("wincom_read, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS wincom_clear (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("wincom_clear, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS wincom_shutdown (LEVEL1_HANDLE user_handle)
{
	ERROR_TRACE ("wincom_shutdown, stub");
	return LEVEL1_NOT_IMPLEMENTED;
}

/****
*
****/

LEVEL1_STATUS wincom_exit (void)
{
	TRACE ("wincom_exit, stub");
	return LEVEL1_NORMAL;
}
