/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vmenuHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vmenubarHEADER
#include vbuttonHEADER
#include vtextitemHEADER
#include vstartupHEADER
#include vtimeHEADER
#include vmemHEADER
#include vcontrolHEADER
#include "tagvunames.h"
/*
	This is the definition of the Tag Entry dialog class
*/
class tagvuEntryOKButton;
class tagvuEntryCancelButton;

class tagvuEntryDialogClass : public vdialog
{
private:
	TagValueData	*tagEntryData;
public:
    vkindTYPED_FULL_DECLARATION(tagvuEntryDialogClass);    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(tagvuEntryDialogClass, vdialog);
//
    void LoadInit(vresource res);// override to load dialog
    void Destroy ();
	void Open();					// overide to make modal
	void ObserveWindow(vevent *event);
	tagvuEntryOKButton	*okButton;
	tagvuEntryCancelButton *cancelButton;
	filteredTextitem	*entryName;
	filteredTextitem	*entryReason;
	vcontrolToggle		*entryTagType;
	void setTagData(TagValueData *td){tagEntryData = td;}
	TagValueData *getTagData(){return(tagEntryData);}
};
//
// Button sub-classes
//
class tagvuEntryCancelButton : public vbutton
{
private:
	tagvuEntryDialogClass *parent;
public:
    vkindTYPED_FULL_DECLARATION(tagvuEntryCancelButton);    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(tagvuEntryCancelButton, vbutton);
    void ObserveDialogItem(vevent *event);
	// set/get parent class
	void setParent(tagvuEntryDialogClass *p){parent = p;}
	tagvuEntryDialogClass *getParent(){return(parent);}
};
class tagvuEntryOKButton : public vbutton
{
private:
	tagvuEntryDialogClass *parent;
public:
    vkindTYPED_FULL_DECLARATION(tagvuEntryOKButton);    // macros for standard constructors and desstructors
    vloadableINLINE_CONSTRUCTORS(tagvuEntryOKButton, vbutton);
    void ObserveDialogItem(vevent *event);
	// set/get parent class
	void setParent(tagvuEntryDialogClass *p){parent = p;}
	tagvuEntryDialogClass *getParent(){return(parent);}
};
