/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


#include <vport.h>
/* ANSI headers */
#include vstdlibHEADER	/* for exit(), EXIT_ codes */

/* Galaxy headers */
#include vkindHEADER
#include vloadableHEADER
#include vobjectHEADER
#include vscribeHEADER
#include vrectHEADER
#include vcharHEADER
#include vnameHEADER
#include veventHEADER
#include vresourceHEADER
#include vwindowHEADER
#include vmenuHEADER
#include vapplicationHEADER
#include vdialogHEADER
#include vmenubarHEADER
#include vbuttonHEADER
#include vtextitemHEADER
#include vstartupHEADER
#include vtimeHEADER
#include vmemHEADER
#include vcontrolHEADER
#include vcontainerHEADER
#include "tagvunames.h"
extern "C"
{
#undef INT_MAX
#undef UINT_MAX
#undef USHRT_MAX
#include "cadef.h"
#include "msgMon.h"
}
typedef char *caddr_t;
#include "textFilters.hxx"
#include "tagvu.h"
#include "tagvuRemoveDialogClass.h"

static int reasonFilter (filteredText *text, vtextSelection *sel,
			  const vchar **s, long *len);
/*
	This is the source for the remove tag Remove dialog class
*/
vkindTYPED_FULL_DEFINITION(tagvuRemoveDialogClass, vdialog, "tagvuRemoveDialogClass");
vkindTYPED_FULL_DEFINITION(tagvuRemoveOKButton, vbutton, "tagvuRemoveOKButton");
vkindTYPED_FULL_DEFINITION(tagvuRemoveCancelButton, vbutton, "tagvuRemoveCancelButton");

void tagvuRemoveDialogClass::LoadInit(vresource res)
{
	okButton = tagvuRemoveOKButton::RequestSubLoad(this,tagvunames_removeOK);
 	cancelButton = tagvuRemoveCancelButton::RequestSubLoad(this,tagvunames_removeCancel);
	vcontainer *container = vcontainer::RequestSubLoad(this,tagvunames_nameContainer);
	nameLabel = vdialogLabelItem::RequestSubLoad(container,tagvunames_removeName);
	container = vcontainer::RequestSubLoad(this,tagvunames_reasonContainer);
	reasonText = filteredTextitem::RequestSubLoad(container,tagvunames_removeReason);
	vdialog::LoadInit(res);		// call base class loadInit to finish the job
	okButton->setParent(this);
	cancelButton->setParent(this);

	// set filter function
	reasonText -> SetItemFilterFunc (reasonFilter);
}
void tagvuRemoveDialogClass::Destroy()
{
}
void tagvuRemoveDialogClass::ObserveWindow(vevent *event)
{
    if(event -> GetType() == veventWINDOW_STATE && event -> IsClose())
    {
	Close();
	vevent::StopProcessing();
    }
}
void tagvuRemoveDialogClass::removeOpen(char *name)
{
    vdialog::Open();
    nameLabel->SetTitleScribed(vcharScribeSystem(name));
    vevent::Process();
}
//
// button callbacks
//
void tagvuRemoveOKButton::ObserveDialogItem(vevent *event)
{
	vbutton::ObserveDialogItem(event);
	Close();
	vevent::StopProcessing();
	TagValueData *tagdata;
	vstr *str1;

	if((tagdata = (TagValueData *)vmemAllocAndClear(sizeof(TagValueData))))
	{
		// get reason
	    str1 = getParent()->reasonText->GetTextAsString();
	    vcharExportBounded (vcharScribeSystemExport(str1),&tagdata->reason,REASON_SIZE);
	    vstrDestroy(str1);
		tagdata->type = REMOVE_TAG;
	    getParent()->setTagData(tagdata);
	}
}
void tagvuRemoveCancelButton::ObserveDialogItem(vevent *event)
{
	vbutton::ObserveDialogItem(event);
	Close();
	getParent()->setTagData(NULL);
	vevent::StopProcessing();
}

/*******************************************************************
*
*    Filter function for the reasonEntry field
*
*******************************************************************/

static int reasonFilter (filteredText *text, vtextSelection *sel,
			  const vchar **s, long *len)
{
    return (NCharFilter (text, sel, s, len, REASON_SIZE));
}
