/*
 *	EVOLManager.x:	Evolution Manager task protocols
 */
#ifdef RPC_HDR
%/* NOTE: DO NOT EDIT THIS FILE. This file is created from EVOLManager.x by rpcgen */
%#include	<stdio.h>
%#include	<stdlib.h>
%#include	<string.h>
%#include	<time.h>
%#include	<rpc/rpc.h>
%#include	"lstLib.h"
%#include	"TankFarm.h"
%
%#define	NO_REQUEST_AVAILABLE	(FIRST_SERVER_SPECIFIC_ERROR-0)
%#define	EVOLUTION_NOT_FOUND		(FIRST_SERVER_SPECIFIC_ERROR-1)
%#define	SEGMENT_NOT_FOUND		(FIRST_SERVER_SPECIFIC_ERROR-2)
%#define	IMPROPER_REQUEST		(FIRST_SERVER_SPECIFIC_ERROR-3)
%#define	DATABASE_OPEN_ERROR		(FIRST_SERVER_SPECIFIC_ERROR-4)
%#define	BAD_SEGMENT_STATUS		(FIRST_SERVER_SPECIFIC_ERROR-5)
%#define	LAST_EVOLMANAGER_ERROR	BAD_SEGMENT_STATUS
%
%#define	NO_SEGMENT		-1		/* used to not specify a segment number */
%
%	typedef enum					/* these double as the segment states too */
%		{							/* except for Switching and Idle */
%		Pending,
%		OnHold,
%		MOnHold,
%		Starting,
%		Manual,
%		Completed,
%		MCompleted,
%		Stopped,
%		EStopped,
%		Error,
%		Active,
%		Pausing,
%		Paused,
%		Resuming,
%		Stopping,
%		EStopping,
%		SwingFrom,
%		SwingTo,
%		Switching,
%		Idle,
%		BadState
%		} EvolutionState;
%
%	extern char	*(EvolutionStateText[]);
#endif
#if defined(RPC_SVC) || defined(RPC_CLNT)
%	
%	char	*(EvolutionStateText[]) =	/* should match the EvolutionState enum above! */
%		{
%		"Pending   ",
%		"OnHold    ",
%		"MOnHold   ",
%		"Starting  ",
%		"Manual    ",
%		"Completed ",
%		"MCompleted",
%		"Stopped   ",
%		"EStopped  ",
%		"Error     ",
%		"Active    ",
%		"Pausing   ",
%		"Paused    ",
%		"Resuming  ",
%		"Stopping  ",
%		"EStopping ",
%		"SwingFrom ",
%		"SwingTo   ",
%		"Switching ",
%		"Idle      ",
%		"BadState  "		/* always make this last */
%		};
#endif
#ifdef RPC_HDR
%	typedef enum
%		{
%		NONE,
%		START,
%		STOP,
%		PAUSE,
%		RESUME,
%		ESTOP,
%		MANUAL,
%		SWINGFROM,
%		SWINGTO,
%		GOTOERROR,
%		BADREQ,
%		} EvolutionProcessorRequestType;
%
%	extern char	*(EvolutionProcessorRequestText[]);
#endif
#if defined(RPC_SVC) || defined(RPC_CLNT)
%
%	char	*(EvolutionProcessorRequestText[]) =	/* should match the EvolutionProcessorRequestType enum above! */
%		{
%		"NONE     ",
%		"START    ",
%		"STOP     ",
%		"PAUSE    ",
%		"RESUME   ",
%		"ESTOP    ",
%		"MANUAL   ",
%		"SWINGFROM",
%		"SWINGTO  ",
%		"ERROR    ",
%		"BADREQ   ",
%		};
#endif
#ifdef RPC_SVC
%	
%	int	RequestIsAllowed[][21] =
%		{
%		/*    Pend OnHo MOnH Start Manu Comp MCom Stop EStop Error Active Pausing Paused Resume Stop EStop SwFrom SwTo Swit Idle Bad */
% 	/*NONE  */    {0,   0,   0,   0,    0,   0,   0,   0,   0,    0,    0,     0,      0,     0,     0,   0,    0,     0,   0,   0,   0},
% 	/*START */    {1,   0,   0,   0,    0,   0,   0,   1,   1,    1,    0,     0,      0,     0,     0,   0,    0,     0,   0,   1,   0},
% 	/*STOP  */    {0,   1,   0,   1,    1,   0,   0,   0,   0,    1,    1,     1,      1,     1,     0,   0,    1,     1,   0,   0,   0},
% 	/*PAUSE */    {0,   0,   0,   0,    0,   0,   0,   0,   0,    0,    1,     0,      0,     0,     0,   0,    0,     0,   0,   0,   0},
% 	/*RESUME*/    {0,   0,   0,   0,    0,   0,   0,   0,   0,    0,    0,     0,      1,     0,     0,   0,    0,     0,   0,   0,   0},
% 	/*ESTOP */    {1,   1,   1,   1,    1,   1,   1,   1,   1,    1,    1,     1,      1,     1,     0,   0,    1,     1,   1,   1,   1},
% 	/*MANUAL*/    {1,   0,   0,   0,    0,   0,   0,   1,   1,    1,    0,     0,      0,     0,     0,   0,    0,     0,   0,   1,   0},
% 	/*SWFROM*/    {0,   0,   0,   0,    0,   0,   0,   0,   0,    0,    0,     0,      0,     0,     0,   0,    0,     0,   0,   0,   0},
% 	/*SWTO  */    {0,   0,   0,   0,    0,   0,   0,   0,   0,    0,    0,     0,      0,     0,     0,   0,    0,     0,   0,   0,   0},
% 	/*ERROR */    {1,   1,   1,   1,    1,   1,   1,   1,   1,    1,    1,     1,      1,     1,     1,   1,    1,     1,   1,   1,   1},
%		};
%  extern int	Trace, Debug, Verbose, Redundancy;
%
#endif
#ifdef RPC_HDR
%	typedef enum
%		{
%		NOMODE,
%		EVOLUTION,
%		SEGMENT,
%		} EvolutionMode;
%
%	extern char	*(EvolutionModeText[]);
#endif
#if defined(RPC_SVC) || defined(RPC_CLNT)
%
%	char	*(EvolutionModeText[]) =	/* should match the EvolutionMode enum above! */
%		{
%		"NOMODE    ",
%		"EVOLUTION ",
%		"SEGMENT   ",
%		};
#endif
#ifdef RPC_HDR
%#define	MAX_ENV_STRING_LENGTH	500
%	
%	typedef struct
%		{
%		int	status;
%		char	*statusText;
%		} MakeRequestResult;
%	
%	typedef struct
%		{
%		int				status;
%		EvolutionProcessorRequestType	type;
%		int				evolution;
%		int				segment;
%		time_t				requestTime;
%		char				environmentString[MAX_ENV_STRING_LENGTH];
%		} GetNextRequestResult;
%	
%	int			EVOLManagerAttach();		/* called by a client to get a connection to the monitor */
%	void			EVOLManagerDetach();		/* called by a client before exiting to kill all connections */
%	MakeRequestResult	*EVOLManagerPerformESTOP();	/* called by a client to make an Evolution Processor ESTOP Request */
%	MakeRequestResult	*EVOLManagerMakeRequest();	/* called by a client to make an Evolution Processor Request */
%	GetNextRequestResult	*EVOLManagerGetNextRequest();	/* called by the Evolution Processor to get the next request from the fifo */
#endif

#define	HOSTNAMELEN		20
#define	REQUESTSTATUSLEN	100

typedef string		RequestStatusMessageType<REQUESTSTATUSLEN>;
typedef string		EnvironmentVariableStringType<MAX_ENV_STRING_LENGTH>;

struct evolutionProcessorRequestArg
	{
	int				type;
	int				evolution;
	int				segment;
	long				requestTime;
	EnvironmentVariableStringType	environmentString;
	};

struct makeRequestResult
	{
	int				status;
	RequestStatusMessageType	statusText;
	};

struct getNextRequestResult
	{
	int	status;
	int	type;
	int	evolution;
	int	segment;
	long	requestTime;
	char	environmentString[MAX_ENV_STRING_LENGTH];
	};

program EVOLMANAGERPROG
	{
	version EVOLMANAGERVERS
		{
		int			EVOL_MANAGER_ATTACH(void) = 1;
		makeRequestResult		EVOL_MANAGER_MAKE_REQUEST(evolutionProcessorRequestArg)	= 2;
		getNextRequestResult	EVOL_MANAGER_GET_NEXT_REQUEST(void) = 3;
		} = 1;
	} = EVOL_MANAGER_PROGRAM_NUMBER;

#ifdef RPC_CLNT
%/* NOTE: DO NOT EDIT THIS FILE. This file is created from EVOLManager.x by rpcgen */
%
%	/*
%	 * This is the EVOL Manager client library implementation.  These functions
%	 * are called by the Evolution Manager screen to make the requests.
%	 */
%
%	typedef struct
%		{
%		NODE		node;
%		char		*hostName;
%		CLIENT		*client;
%		} Server;
%	
%	static LIST	serverList;	/* the list of servers */
%
%#define foreachServer(x)	for(x = (Server *)lstFirst(&serverList); x; x = (Server *)lstNext(x))
%
%	static Server *getManagerServer(hostName)
%	char	*hostName;
%		{
%		static int	firstTime = 1;
%		Server		*pServer;
%
%		if (firstTime)
%			{
%			firstTime = 0;
%			lstInit(&serverList);
%			}
%		/*
%		 * search for the named server and return a pointer (or a NULL)
%		 */
%		foreachServer(pServer)
%			if(strcmp(pServer->hostName, hostName) == 0)
%				break;
%		if (!pServer)
%			{
%			/*
%			 * allocate space for the new server and it's name
%			 */
%			pServer = (Server *)calloc(1, sizeof (Server));
%			if (!pServer)
%				return NULL;
%	
%			pServer->hostName = (char *)calloc(strlen(hostName) + 1, sizeof (char));
%			if (!pServer->hostName)
%				return NULL;
%	
%			/*
%			 * initialize the script and add it to the list
%			 */
%			strcpy(pServer->hostName, hostName);
%			pServer->client = clnt_create(hostName, EVOLMANAGERPROG, EVOLMANAGERVERS, "tcp");
%	/*clnt_pcreateerror("EVOLManager");*/
%			lstAdd(&serverList, &pServer->node);
%			}
%
%		return pServer;
%		}
#endif

#ifdef RPC_SVC
%/* NOTE: DO NOT EDIT THIS FILE. This file is created from EVOLManager.x by rpcgen */
%
%	/*
%	 * This is the EVOL Manager server implementation.  These functions handle the
%	 * requests that the Evolution Manager screen makes while running Tank Farm evolutions.
%	 */
%	
%	typedef struct
%		{
%		NODE				node;
%		EvolutionProcessorRequestType	type;
%		int				evolution;
%		int				segment;
%		time_t				requestTime;
%		char				environmentString[MAX_ENV_STRING_LENGTH];
%		} Request;
%	
%	LIST	requestList;		/* the list of requests */
%	
%#define foreachRequest(x)	for(x = (Request *)lstFirst(&requestList); x; x = (Request *)lstNext(x))
%
%	char *makeMallocedString(text)
%	char	*text;
%		{
%		return strcpy(malloc(strlen(text)+1), text);
%		}
#endif

#ifdef RPC_CLNT
%	static char	environmentString[MAX_ENV_STRING_LENGTH] = { 0 };	/* string to collect local environment variables in */
%
%	void	addEnvironmentVariable(variableName)
%	char	*variableName;
%		{
%		char	*getenv(), *s = getenv(variableName);
%		char	buf[100];
%
%		sprintf(buf, "%s=%s;export %s;", variableName, s ? s : "", variableName);
%		if ((strlen(environmentString) + strlen(buf)) < sizeof environmentString)
%			strcat(environmentString, buf);
%		}
%
%	int EVOLManagerAttach(hostName)			/* client calls this to open communications to the server */
%	char	*hostName;
%		{
%		Server	*pServer = getManagerServer(hostName);
%		int	*result = NULL;
%
%		addEnvironmentVariable("USER");
%		addEnvironmentVariable("HOME");
%		addEnvironmentVariable("DISPLAY");
%		if (pServer && pServer->client)
%			result = evol_manager_attach_1(NULL, pServer->client);
%
%		return (result) ? *result : TF_ERROR;
%		}
#endif
#ifdef RPC_SVC
%
%	int *evol_manager_attach_1(dummyArg, rqstp)
%	void			*dummyArg;
%	struct svc_req	*rqstp;
%		{
%		static int	result;
%		static int	firstTime = 1;
%
%		if (firstTime)		/* only the first attacher needs to create the list */
%			{
%			firstTime = 0;
%			lstInit(&requestList);
%			}
%
%		result = TF_OK;
%		return &result;
%		}
#endif

#ifdef RPC_CLNT
%
%	void EVOLManagerDetach()	/* client calls this before exiting to kill all connections */
%		{
%		Server	*pServer;
%
%		/*
%		 * destroy the client connections to ALL of the servers
%		 * NOTE: the server is not notified. Any requests remain to be handled by the server.
%		 */
%		foreachServer(pServer)
%			if (pServer && pServer->client)
%				clnt_destroy(pServer->client);
%
%		lstFree(&serverList);
%		}
#endif
#ifdef RPC_SVC
%
%	/* there is nothing to do in the server for a EVOLManagerDetach() */
%
#endif

#ifdef RPC_CLNT
%
%	MakeRequestResult *EVOLManagerPerformESTOP(hostName)
%	char	*hostName;
%		{
%		Server				*pServer = getManagerServer(hostName);
%		static MakeRequestResult	requestResult;
%
%		if (pServer && !pServer->client)
%			{
%			requestResult.status = TF_ERROR;
%			requestResult.statusText = "no server";
%			return &requestResult;
%			}
%
%		/*
%		 * broadcast the ESTOP to each valid server
%		 */
%		foreachServer(pServer)
%			if (pServer && pServer->client)
%				{
%				static evolutionProcessorRequestArg	arg = {ESTOP, 0, 0, 0, environmentString};
%
%				evol_manager_make_request_1(&arg, pServer->client);
%				}
%		/*
%		 * we can only assume they worked since we can't return the status for each server
%		 */
%		requestResult.status = TF_OK;
%		requestResult.statusText = "ESTOP broadcasted";
%		return &requestResult;
%		}
%
%	MakeRequestResult *EVOLManagerMakeRequest(hostName, type, evolution, segment)
%	char				*hostName;
%	EvolutionProcessorRequestType	type;
%	int				evolution;
%	int				segment;
%		{
%		Server				*pServer;
%		static MakeRequestResult	requestResult;
%
%		if (type == ESTOP)
%			return EVOLManagerPerformESTOP();	/* just in case! */
%
%		requestResult.status = TF_ERROR;	/* assume the worst */
%		requestResult.statusText = "no server";
%
%		pServer	= getManagerServer(hostName);
%		if (pServer && pServer->client)
%			{
%			evolutionProcessorRequestArg	arg;
%			makeRequestResult		*result;
%
%			arg.type = type;
%			arg.evolution = evolution;
%			arg.segment = segment;
%			arg.requestTime = 0;
%			arg.environmentString = environmentString;
%			result = evol_manager_make_request_1(&arg, pServer->client);
%			if (result)
%				{
%				requestResult.status = result->status;
%				requestResult.statusText = result->statusText;
%				}
%			}
%
%		return &requestResult;
%		}
#endif
#ifdef RPC_SVC
%#define	S4UNIX
%#include <d4all.h>
%#include <TFdBASE.h>
%
%	C4CODE		codeBaseDesc;
%	D4DATA		*evolDesc;
%	F4FIELD		*evol_EVOLNUMBER, *evol_EVOLMODE;
%	D4DATA		*evolSegsDesc;
%	F4FIELD		*evolSegs_EVOLNUMBER, *evolSegs_ORDERNUM, *evolSegs_STATUS, *evolSegs_SEGNUMBER;
%
%
%	EvolutionState	findStatus(statusStr)
%	char	*statusStr;
%		{
%		EvolutionState	status;
%	
%		for (status = Pending; status < BadState; status++)
%			if (strncmp(statusStr, EvolutionStateText[status], STATUS_ENTRY_SIZE) == 0)
%				break;
%		return status;
%		}
%	
%	/*----------*/
%	updateDBASEfile (data)
%
%	    D4DATA	*data;
%
%	    {
%
%		d4flush_all (data);
%#ifndef CB51
%		data->file_lock = TRUE;		/* to force d4update_header() to write the num_recs field */
%		d4update_header (data, 1, 1);
%		data->file_lock = FALSE;	/* to force d4unlock_all() to write the num_recs field */
%#endif
%		d4unlock_all (data);
%
%	    }
%
%	verifyRequest(type, evolution, pSegment, presultString)
%	EvolutionProcessorRequestType	type;
%	int	evolution;
%	int	*pSegment;
%	char	**presultString;
%		{
%		long		segNum;
%		EvolutionState	status;
%		static char	buf[100];
%		char		searchString[EVOL_NUMBER_ENTRY_SIZE+1];
%		static int	first_time	= 1;
%
%		if (first_time)
%			{
%			d4init(&codeBaseDesc);
%			codeBaseDesc.read_lock = 0;
%			codeBaseDesc.create_error = 0;
%			codeBaseDesc.field_name_error = 0;
%			codeBaseDesc.go_error = 0;
%			codeBaseDesc.open_error = 0;
%			codeBaseDesc.skip_error = 0;
%			codeBaseDesc.tag_name_error = 0;
%			first_time = 0;
%			}
%
%		if (!(evolDesc = d4open(&codeBaseDesc, evolName))) {
%			*presultString = "cannot open evolution database file";
%			return DATABASE_OPEN_ERROR;
%		}
%		evol_EVOLNUMBER = d4field (evolDesc, "EVOLNUMBER");
%		evol_EVOLMODE = d4field (evolDesc, "EVOLMODE");
%
%		if (!(evolSegsDesc = d4open(&codeBaseDesc, evolSegsName))) {
%			*presultString = "cannot open evolution segments database file";
%			d4close(evolDesc);
%			return DATABASE_OPEN_ERROR;
%		}
%		evolSegs_EVOLNUMBER = d4field (evolSegsDesc, "EVOLNUMBER");
%		evolSegs_ORDERNUM = d4field (evolSegsDesc, "ORDERNUM");
%		evolSegs_STATUS = d4field (evolSegsDesc, "STATUS");
%		evolSegs_SEGNUMBER = d4field (evolSegsDesc, "SEGNUMBER");
%
%		/*
%		 * search the segments:
%		 *	if NO_SEGMENT was given, settle for the first non-complete, non-errored segment
%		 *	if a segment is given, make sure it exists
%		 */
%		sprintf(searchString, "%*d", EVOL_NUMBER_ENTRY_SIZE, evolution);
%		d4tag_select(evolSegsDesc, d4tag(evolSegsDesc, "ORDERTAG"));
%		if (d4seek(evolSegsDesc, searchString) == 0)
%			do
%				{
%				char	statusStr[STATUS_ENTRY_SIZE];
%				long	evolNum = f4long (evolSegs_EVOLNUMBER);
%
%				if (evolNum != evolution)
%					{
%					/* we ran out of segments in the desired evolution and did not find a desirable segment */
%					*presultString = "segment was not found";
%					d4close(evolDesc);
%					d4close(evolSegsDesc);
%					return SEGMENT_NOT_FOUND;
%					}
%				segNum = f4long(evolSegs_ORDERNUM);
%				strncpy(statusStr, f4str(evolSegs_STATUS), STATUS_ENTRY_SIZE);
%				for (status = Pending; status < BadState; status++)
%					if (strncmp(statusStr, EvolutionStateText[status], STATUS_ENTRY_SIZE) == 0)
%						break;
%				if (status == BadState)
%					{
%					*presultString	= "bad segment status";
%					d4close(evolDesc);
%					d4close(evolSegsDesc);
%					return BAD_SEGMENT_STATUS;
%					}
%
%				if (*pSegment == NO_SEGMENT && ((status != Completed) && (status != MCompleted)))
%					{
%					/* found a segment that's not completed */
%					*pSegment = segNum;
%					break;
%					}
%				if (*pSegment != NO_SEGMENT && segNum == *pSegment)
%					/* found the explicit segment */
%					break;
%				}
%			while (d4skip(evolSegsDesc, 1) == 0);
%		else
%			{
%			*presultString = "evolution was not found";
%			d4close(evolDesc);
%			d4close(evolSegsDesc);
%			return EVOLUTION_NOT_FOUND;
%			}
%
%		if (*pSegment != NO_SEGMENT && segNum != *pSegment)
%			{
%			*presultString = "segment was not found";
%			d4close(evolDesc);
%			d4close(evolSegsDesc);
%			return SEGMENT_NOT_FOUND;
%			}
%
%		sprintf(searchString, "%*d", EVOL_NUMBER_ENTRY_SIZE, evolution);
%		d4tag_select(evolDesc, d4tag(evolDesc, "EVOLTAG"));
%		d4seek(evolDesc, searchString);
%
%		if (!RequestIsAllowed[type][(int)(status = findStatus(f4str(evolSegs_STATUS), STATUS_ENTRY_SIZE))])
%			{
%			sprintf(buf, "cannot %s when segment is %s", EvolutionProcessorRequestText[type], EvolutionStateText[(int)status]);
%			*presultString = buf;
%			d4close(evolDesc);
%			d4close(evolSegsDesc);
%			return IMPROPER_REQUEST;
%			}
%
%		*pSegment = f4int (evolSegs_SEGNUMBER);
%		*presultString	= "request queued";
%		d4close(evolDesc);
%		d4close(evolSegsDesc);
%		return TF_OK;
%		}
%
%	setEvolMode(evolution, mode)
%	int	evolution;
%	int	mode;
%		{
%		char	searchString[EVOL_NUMBER_ENTRY_SIZE+1];
%
%		evolDesc = d4open(&codeBaseDesc, evolName);		/* if verifyRequest() could open it, this should too */
%		evol_EVOLNUMBER = d4field (evolDesc, "EVOLNUMBER");
%		evol_EVOLMODE = d4field (evolDesc, "EVOLMODE");
%		d4tag_select(evolDesc, d4tag(evolDesc, "EVOLTAG"));
%		sprintf(searchString, "%*d", EVOL_NUMBER_ENTRY_SIZE, evolution);
%		d4seek(evolDesc, searchString);
%		if (f4int(evol_EVOLNUMBER) == evolution)
%			{
%			f4assign(evol_EVOLMODE, EvolutionModeText[mode]);
%			updateDBASEfile(evolDesc);
%			}
%		d4close(evolDesc);
%		}
%
%	makeRequestResult *evol_manager_make_request_1(arg, rqstp)
%	evolutionProcessorRequestArg	*arg;
%	struct svc_req			*rqstp;
%		{
%		static makeRequestResult	result;
%		Request				*pRequest;
%		char				*resultString;
%
%		xdr_free((xdrproc_t)xdr_makeRequestResult, (char *)&result);
%
%		if ((EvolutionProcessorRequestType)(arg->type) == ESTOP)
%			{
%			static Request	ESTOPrequest;	/* don't calloc for this, it's too important */
%
%			lstFree(&requestList);		/* it's an emergency, dump everything and add this request */
%			pRequest = &ESTOPrequest;
%			result.status = TF_OK;
%			resultString = "";		/* the client lib (above) doesn't use this anyway! */
%			}
%		else
%			{
%			int	originalSegment	= arg->segment;
%
%			/*
%			 * verify the request, determining the segment if it was not given
%			 */
%			result.status = verifyRequest(arg->type, arg->evolution, &(arg->segment), &resultString);
%			if (result.status == TF_OK)
%				{
%				setEvolMode(arg->evolution, (originalSegment == NO_SEGMENT) ? EVOLUTION : SEGMENT);
%
%				/*
%				 * allocate space for the new pRequest
%				 */
%				pRequest = (Request *)calloc(1, sizeof (Request));
%				if (!pRequest)
%					{
%					result.status = TF_ERROR;
%					resultString = "can't get memory to store request";
%					}
%				}
%			}
%		if (result.status == TF_OK)
%			{
%			/*
%			 * initialize this pRequest and add it to the end of the request list
%			 */
%			pRequest->type = arg->type;
%			pRequest->evolution = arg->evolution;
%			pRequest->segment = arg->segment;
%			pRequest->requestTime = time(0);
%			strcpy(pRequest->environmentString, arg->environmentString);
%			lstAdd(&requestList, &pRequest->node);
%			}
%		result.statusText = makeMallocedString(resultString);
%		return &result;
%		}
#endif

#ifdef RPC_CLNT
%
%	GetNextRequestResult *EVOLManagerGetNextRequest()
%		{
%		static GetNextRequestResult	requestResult;
%		Server				*pServer	= getManagerServer("localhost");
%
%		requestResult.status = TF_ERROR;		/* assume the worst */
%
%		if (pServer && pServer->client)
%			{
%			getNextRequestResult	*result = evol_manager_get_next_request_1(NULL, pServer->client);
%
%			if (result)
%				{
%				requestResult.status = result->status;
%				requestResult.type = result->type;
%				requestResult.evolution = result->evolution;
%				requestResult.segment = result->segment;
%				requestResult.requestTime = result->requestTime;
%				strcpy(requestResult.environmentString, result->environmentString);
%				}
%			}
%		return &requestResult;
%		}
#endif
#ifdef RPC_SVC
%
%	getNextRequestResult *evol_manager_get_next_request_1(dummyArg, rqstp)
%	void	*dummyArg;
%	struct svc_req	*rqstp;
%		{
%		static getNextRequestResult	result;
%		Request				*pRequest = (Request *)lstGet(&requestList);
%
%		if (pRequest)
%			{
%			result.status = TF_OK;
%			result.type = pRequest->type;
%			result.evolution = pRequest->evolution;
%			result.segment = pRequest->segment;
%			result.requestTime = pRequest->requestTime;
%			strcpy(result.environmentString, pRequest->environmentString);
%			lstDelete(&requestList, &pRequest->node);
%			if (result.type != ESTOP)
%				free(pRequest);
%			}
%		else
%			result.status = NO_REQUEST_AVAILABLE;
%		return &result;
%		}
#endif
