/*symtab.h,v 1.1.1.1 1999/08/03 14:44:56 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software was developed for DLA by Tate Integrated  */
/*	Systems, L.P. via a contract with Vitro Corporation.	*/
/*	It is designed to work with TIS4000 Release 4.2.	*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*	file:	symtab.h	Symbol table definitions
/*	author:	Douglas P. Dotson
/*	date:	08 Mar 1993
/*	edit:	28 Apr 1993	2200	DPD
*/

/* The symbol table consists of a simple linked list. Nothing more
/* sophisticated seems necessary at this point since the number of
/* likely symbols in a CSL script will probably be relatively small.
*/

typedef struct symentry {
    struct symentry *Next;	/* Pointer to next node in list */
    int		Type;		/* The type of the symbol */
    int		SymNumber;	/* Index of symbol in executable */
    char	*String;	/* The actual symbol */
    int		Address;	/* Address if a label */
    int		AddrList;	/* Liat of forward references */
} Symbol;

/* Symbol types */

#define	DEFUNCT		-1
#define	CHAN		0
#define	VARIABLE	1
#define	TIMER		2
#define	INTCONST	3
#define	REALCONST	4
#define	TIMECONST	5
#define	LITERAL		6
#define	LABEL		7

/* Symbol table support functions */

void	SymTabInit ();	/* Initialize the symbol table to empty */
Symbol	*SymLookUp ();	/* Lookup a symbol */
Symbol	*SymInsert ();	/* Insert a new symbol */
Symbol	*LookUp ();	/* Insert a symbol if not already in the table */
void	SequenceSymTab ();	/* Put sequence number on symbols */
void	CheckLabels ();	/* Check for undefined labels */

