/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	This program will display a MOTIF style message box whose text is keyed
	by the argv[1] value.

	Greg Tomalesky
	10-Jun-1994
*/
#include	<X11/Intrinsic.h>
#include	<Xm/Xm.h>
#include	<Xm/MessageB.h>
#include	<time.h>

void	licByeBye();
Widget	licCreateMessageBox(Widget, char *, char *, unsigned char );
typedef	enum {LIC_TITLE_WARNING,LIC_TITLE_EXPIRED,LIC_TITLE_ERROR} LIC_TITLE_NUM;
char	*licTitle[] =
	{
	"License Warning",
	"License Expired",
	"License Error"
	};
char	*licMessage[] =
	{
	"This program is not licensed for this\n\
node or the license has been corrupted.\n\
Please call Tate Integrated Systems for\n\
assistance: 410-581-0422",

	"The license for this program has expired.\n\
Continued use of this program may constitute\n\
illegal use of protected software.\n\
Please call Tate Integrated Systems for\n\
assistance: 410-581-0422",

	"The license for this program will expire\n\
on %s.\n\
Continued use of this program after\n\
that date may constitute illegal use\n\
of protected software.\n\
Please call Tate Integrated Systems for\n\
assistance: 410-581-0422",

	"This program is not licensed for this\n\
node or the license has been corrupted.\n\
Please call Tate Integrated Systems\n\
immediately for assistance: 410-581-0422",

	"The license for this program has expired.\n\
Continued use of this program may constitute\n\
illegal use of protected software.\n\
Please call Tate Integrated Systems\n\
immediately for assistance: 410-581-0422",

	"The license for this program will expire\n\
on %s.\n\
Continued use of this program after\n\
that date may constitute illegal use\n\
of protected software.\n\
Please call Tate Integrated Systems\n\
immediately for assistance: 410-581-0422",
	};

void main(int argc, char *argv[])
{
    Widget		topLevel,msgBox;
    XtAppContext	app;
    int			msgNum;
    LIC_TITLE_NUM	titleNum;
    char		msgString[512],*tptr;
    unsigned char	type;
    time_t		timer;

    if(argc < 2)			/* must have at least one argument */
	exit(4);
    msgNum = atoi(argv[1]) - 1;
    if((msgNum < 0) || msgNum > 5)	/* check for message range */
	exit(2);
    titleNum = LIC_TITLE_WARNING;
    type = XmDIALOG_ERROR;
    if((msgNum == 2) || (msgNum == 5))	/* and message type */
    {
	if(argc < 3)			/* these two messages require a second argument */
		exit(3);
/*
	New as of 07-Oct-1994
	Ignore message type 3 & 6
*/
	exit(4);
	timer = (time_t)atol(argv[2]);		/* expireation date */
	tptr = (char *)ctime(&timer);
	tptr[strlen(tptr)-1] = 0;			/* don't use the supplied line-feed */
	sprintf(msgString,licMessage[msgNum],tptr);
	titleNum = LIC_TITLE_WARNING;
	type = XmDIALOG_WARNING;
    }
    else
	strcpy(msgString,licMessage[msgNum]);
    if((msgNum == 0) || (msgNum == 3))
	titleNum = LIC_TITLE_ERROR;
    if((msgNum == 1) || (msgNum == 4))
	titleNum = LIC_TITLE_EXPIRED;
    topLevel = XtVaAppInitialize(&app,"tisLdisp",NULL,0,&argc,argv,NULL,
				 XmNallowShellResize,True,
				 NULL);
    /* create the proper message box */
    msgBox = licCreateMessageBox(topLevel,msgString,licTitle[titleNum],type);
    XtManageChild(msgBox);
    XtRealizeWidget(topLevel);
    XtAppMainLoop(app);
}
/*
	generic message box creator
*/
Widget	licCreateMessageBox(Widget parent, char *msgString, char *titleString,
			    unsigned char msgType)
{
    XmString	msg,title;
    Widget		msgbox;

    msg = XmStringCreateLtoR(msgString,XmSTRING_DEFAULT_CHARSET);
    title = XmStringCreateSimple(titleString);
    msgbox = XtVaCreateManagedWidget("Warning",xmMessageBoxWidgetClass,parent,
				     XmNdialogTitle,title,
				     XmNdialogType,msgType,
				     XmNmessageString,msg,
				     NULL);
    XtAddCallback(msgbox,XmNokCallback,licByeBye,0);
    XtUnmanageChild(XmMessageBoxGetChild(msgbox,XmDIALOG_CANCEL_BUTTON));
    XtUnmanageChild(XmMessageBoxGetChild(msgbox,XmDIALOG_HELP_BUTTON));
    XmStringFree(msg);
    XmStringFree(title);
    return(msgbox);
}
/*
	Just quit from this app
*/
void licByeBye(Widget w, int *tag, int reason)
{
    exit(1);
}
