#ifndef tispermappHXX
#define tispermappHXX

#include "textFilters.hxx"
#include "tisgalaxylib.hxx"

//** ENUM DEFINITIONS *****************************************************
enum {
    TISPERM_ERROR = -1,
    TISPERM_SUCCESS,
    TISPERM_INFO_NOTICE,
    TISPERM_CAUTION_NOTICE,
    TISPERM_NUMMISCENUMS
};


class MainDialog;
class TisPermDatabase;
class OptionTree;

class TisPermApp
{
    int		databaseInited;
    int		initErrors;
    int		initedTisGalaxy;
    // database class
    TisPermDatabase	*permDatabase;

    // utility option class
    OptionTree		*optionTree;

    // galaxy application ptr;
    vapplication	*tisPermVapp;

    // resources
    vresource		tisPermResource;
    vresource		titlesResource;
    vresource		messagesResource;
    vresource		mainDlgResource;
    vresource		tisGalaxyResource;

public:

    // class constructor
    TisPermApp (int argCount, char **argList);

    // class destructor
    ~TisPermApp ();

    // application ptr
    vapplication	*tisPermApp;

    // ptr to main dialog
    MainDialog		*mainDialog;

    // some public funcs
    TisPermDatabase *GetDb (void)
	{ return (permDatabase); }
    OptionTree *GetOptionTree (void)
	{ return (optionTree); }
    int GetInitErrors (void)
	{ return (initErrors); }
    vresource GetMainDlgRes (void)
	{ return (mainDlgResource); }
    vresource GetMessagesRes (void)
	{ return (messagesResource); }
    vresource GetPermRes (void)
	{ return (tisPermResource); }
    vresource GetTitlesRes (void)
	{ return (titlesResource); }
    vresource GetTisGalaxyRes (void)
	{ return (tisGalaxyResource); }
};

#endif tispermappHXX

