#ifndef	tispermdbdefsHXX
#define	tispermdbdefsHXX

extern "C"
{
#include "dbDefs.h"
#include "fldprott.h"	// definitions for the field protection database
#include "privtab.h"	// definitions for the privilege table database
}

// Definitions for sysusers table, sysusers.dbf, define users in groups
FIELD4INFO    sysusers_fields[] = 
{
    /* Field name,	    Type,   Width,  Decimals */
    { "NAME",		    'C',    OPERATOR_SZ,    0 },    /* user name */
    { "OPTYPE",		    'C',    GROUPNAME_SZ,   0 },    /* group name */
    { 0, 0, 0, 0 }            // NULL - record terminator
};

//  Tag for sysusers table, sysusers.mdx
TAG4INFO    sysusers_tag[] = 
{
    /* Tag name,	Key Expression,	    Filter Expression,	Unique,	Descending */
    { "NAME",		"NAME",		    0,			0,      0 },
    { 0, 0, 0, 0, 0 } // NULL - record terminator
};

// Definitions for tisusers table, tisusers.dbf, define a user
FIELD4INFO    tisusers_fields[] = 
{
    /* Field name,	    Type,   Width,  Decimals */
    { "NAME",		    'C',    OPERATOR_SZ,    0 },
    { "DESC",		    'C',    DESCRIPTION_SZ, 0 },
    { "ENCRPASSWD",	    'C',    ENCRYPTPASSWD_SZ, 0 },
    { "ALLOWAUTOL",	    'L',    1,		    0 },    /* allow autologout */
    { "AUTOLOGTIM",	    'N',    3,		    0 },    /* auto logout time */
    { 0, 0, 0, 0 }            // NULL - record terminator
};

//  Tag for tisusers table, tisusers.mdx
TAG4INFO    tisusers_tag[] = 
{
    /* Tag name,	Key Expression,	    Filter Expression,	Unique,	Descending */
    { "NAME",		"NAME",		    0,			0,      0 },
    { 0, 0, 0, 0, 0 } // NULL - record terminator
};

// Definitions for tisgroups table, tisgrps.dbf, define a group
FIELD4INFO    tisgroups_fields[] = 
{
    /* Field name,	    Type,   Width,  Decimals */
    { "GROUPNAME",	    'C',    GROUPNAME_SZ,   0 },
    { "DESC",		    'C',    DESCRIPTION_SZ, 0 },
    { 0, 0, 0, 0 }            // NULL - record terminator
};

//  Tag for tisgroups table, tisgrps.mdx
TAG4INFO    tisgroups_tag[] = 
{
    /* Tag name,	Key Expression,	    Filter Expression,	Unique,	Descending */
    { "GROUPNAME",	"GROUPNAME",	    0,			0,      0 },
    { 0, 0, 0, 0, 0 } // NULL - record terminator
};


// Definitions for protection groups table, protgrps.dbf, define a protection group
FIELD4INFO    protgrps_fields[] = 
{
    /* Field name,	    Type,   Width,	    Decimals */
    { "PROT_GROUP",	    'C',    PROTECTIONGRP_SZ,	0 },
    { "DESC",		    'C',    DESCRIPTION_SZ,	0 },
    { 0, 0, 0, 0 }            // NULL - record terminator
};

//  Tag for protection groups table, protgrps.dbf
TAG4INFO    protgrps_tag[] = 
{
    /* Tag name,	Key Expression,	    Filter Expression,	Unique,	Descending */
    { "PROT_GROUP",	"PROT_GROUP",	    0,			0,      0 },
    { 0, 0, 0, 0, 0 } // NULL - record terminator
};

// Deinitions for utility/gui access table, utilacc.dbf
FIELD4INFO	utilaccFieldInfo[] = 
{
    {"GROUPNAME",	'C',	GROUPNAME_SZ,	    0},
    {"PRIVILEGE",	'C',	UTILACCPRIV_SZ,	    0},
    {"PRIV_LEVEL",	'C',	PRIV_LEVEL_SZ,	    0},
    {0, 0, 0, 0}    // NULL - record terminator
};

// tag for privtab.dbf
TAG4INFO	utilaccTagInfo[] = 
{
    /* Tag name,	Key Expression,		Filter Expression,  Unique, Descend */	
    {"GROUPNAME",	"GROUPNAME",		0,		    0,      0},
    {"GROUPPRIV",	"GROUPNAME+PRIVILEGE",	0,		    0,      0},
    {0, 0, 0, 0, 0}	// NULL - record terminator
};

#endif	tispermdbdefsHXX
