#ifndef tispermgroupHXX
#define	tispermgroupHXX

class  GroupOkButton;
class  GroupCancelButton;

// define functionality
enum GroupFunc
{
    GroupAdd = 0,
    GroupModify,
    GroupDelete
};


class GroupDialog : public vdialog
{
    MainDialog	    *mainDialog;
    GroupFunc	    groupFunc;
    void	    UpdateTextFields (void);
    void	    SetDialogTitle (void);
    int		    modifiedFlag;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(GroupDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(GroupDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // override
    void ObserveWindow (vevent *event);

    void OpenGroup (MainDialog *mnDlg, GroupFunc grpFunc);

    // ptrs to some dialog stuff
    filteredTextitem	*groupName;
    filteredTextitem	*description;
    vcomboboxPopdown	*membersList;
    GroupOkButton	*okButton; 
    GroupCancelButton	*cancelButton;
    
    // some public funcs
    GroupFunc GetGroupFunction (void)
	{ return (groupFunc); }
    MainDialog *GetMainDialog (void)
	{ return (mainDialog); }
    int GetModifiedFlag (void)
	{ return (modifiedFlag); }
};


class  GroupOkButton : public vbutton
{
    GroupDialog	    *groupDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(GroupOkButton);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(GroupOkButton, vbutton);

    //override virtual issue function
   void ObserveDialogItem(vevent *event);

   // handle groupDialog
   void SetGroupDialog (GroupDialog *dlg)
    { groupDialog = dlg; }
};


class  GroupCancelButton : public vbutton
{
    GroupDialog	    *groupDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(GroupCancelButton);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(GroupCancelButton, vbutton);

    //override virtual issue function
   void ObserveDialogItem (vevent *event);

   // handle groupDialog
   void SetGroupDialog (GroupDialog *dlg)
    { groupDialog = dlg; }
};
#endif	tispermgroupHXX

