#ifndef tisprotgroupHXX
#define	tisprotgroupHXX

class  ProtGroupOkButton;
class  ProtGroupCancelButton;

// define functionality
enum ProtGroupFunc
{
    ProtGroupAdd = 0,
    ProtGroupModify,
    ProtGroupDelete
};


class ProtGroupDialog : public vdialog
{
    MainDialog	    *mainDialog;
    ProtGroupFunc   protGroupFunc;
    void	    UpdateTextFields (void);
    void	    SetDialogTitle (void);
    int		    modifiedFlag;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(ProtGroupDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(ProtGroupDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // override
    void Destroy ();

    // override
    void ObserveWindow (vevent *event);

    void OpenProtGroup (MainDialog *mnDlg, ProtGroupFunc grpFunc);

    // ptrs to some dialog stuff
    filteredTextitem		*protGroupName;
    filteredTextitem		*description;
    ProtGroupOkButton		*okButton; 
    ProtGroupCancelButton	*cancelButton;
    
    // some public funcs
    ProtGroupFunc GetProtGroupFunction (void)
	{ return (protGroupFunc); }
    MainDialog *GetMainDialog (void)
	{ return (mainDialog); }
    int GetModifiedFlag (void)
	{ return (modifiedFlag); }
};


class  ProtGroupOkButton : public vbutton
{
    ProtGroupDialog	    *protGroupDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(ProtGroupOkButton);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(ProtGroupOkButton, vbutton);

    //override virtual issue function
   void ObserveDialogItem(vevent *event);

   // handle groupDialog
   void SetProtGroupDialog (ProtGroupDialog *dlg)
    { protGroupDialog = dlg; }
};


class  ProtGroupCancelButton : public vbutton
{
    ProtGroupDialog	    *protGroupDialog;

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(ProtGroupCancelButton);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(ProtGroupCancelButton, vbutton);

    //override virtual issue function
   void ObserveDialogItem (vevent *event);

   // handle groupDialog
   void SetProtGroupDialog (ProtGroupDialog *dlg)
    { protGroupDialog = dlg; }
};
#endif	tisprotgroupHXX

