#ifndef	prtgrpmaintdialogH
#define	prtgrpmaintdialogH

class PrtGrpMembersListView;
class PrtGrpUsersListView;
class PrtGrpMaintAddButton;
class PrtGrpMaintRemoveButton;
class PrtGrpMaintPrivLevel;
class PrtGrpMaintOkButton;
class PrtGrpMaintCancelButton;

class PrtGrpMaintDialog : public vdialog
{
    MainDialog	    *mainDialog;
    vchar	    group [PROTECTIONGRP_SZ + 1];

    void	    SetDialogTitle (void);

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(PrtGrpMaintDialog);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(PrtGrpMaintDialog, vdialog);

    // vloadable override
    void LoadInit (vresource resource);

    // overrides 
    void Destroy ();
    void ObserveWindow (vevent *event);

    void OpenPrtGrpMaint (MainDialog *mainDlg, vchar *group);

    PrtGrpMembersListView	*membersListView;
    PrtGrpUsersListView		*usersListView;
    PrtGrpMaintPrivLevel	*privLevel;
    PrtGrpMaintAddButton	*addButton;
    PrtGrpMaintRemoveButton	*removeButton;
    PrtGrpMaintOkButton		*okButton;
    PrtGrpMaintCancelButton	*cancelButton;

    // some public funcs
    vchar *GetGroupName (void)
	{ return (group); }
    MainDialog *GetMainDialog (void)
    { return (mainDialog); }
};


class  PrtGrpMembersListView : public vlistview
{
    vliststr		*list;
    PrtGrpMaintDialog	*prtGrpMaintDialog;
    int			modified;
    int			flag;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(PrtGrpMembersListView);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(PrtGrpMembersListView, vlistview);

    // vloadable override
    void LoadInit (vresource resource);

    void Destroy ();
    void ObserveSelect (int state);
    
    // some publics
    void SetPrtGrpMaintDialog (PrtGrpMaintDialog *dlg)
        { prtGrpMaintDialog = dlg; }

    void BuildList (void);

    int GetFlag (void )
	{ return (flag); }
    void SetFlag (int flg)
	{ flag = flg; }
    void SetModified (int mod)
	{ modified = mod; }
    int GetModified (void)
	{ return (modified); }
};


class  PrtGrpUsersListView : public vlistview
{
    vliststr		*list;
    PrtGrpMaintDialog	*prtGrpMaintDialog;
    int			flag;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(PrtGrpUsersListView);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(PrtGrpUsersListView, vlistview);

    // vloadable override
    void LoadInit (vresource resource);

    void Destroy ();
    void ObserveSelect (int state);

    // some publics
    void SetPrtGrpMaintDialog (PrtGrpMaintDialog *dlg)
        { prtGrpMaintDialog = dlg; }

    void BuildList (void);

    int GetFlag (void)
	{ return (flag); }
    void SetFlag (int flg)
	{ flag = flg; }
};


class  PrtGrpMaintAddButton : public vbutton
{
    PrtGrpMaintDialog	*prtGrpMaintDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(PrtGrpMaintAddButton);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(PrtGrpMaintAddButton, vbutton);

    void ObserveDialogItem (vevent *event);

    // some publics
    void SetPrtGrpMaintDialog (PrtGrpMaintDialog *dlg)
        { prtGrpMaintDialog = dlg; }
};


class  PrtGrpMaintRemoveButton : public vbutton
{
    PrtGrpMaintDialog	*prtGrpMaintDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(PrtGrpMaintRemoveButton);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(PrtGrpMaintRemoveButton, vbutton);

    void ObserveDialogItem (vevent *event);

    // some publics
    void SetPrtGrpMaintDialog (PrtGrpMaintDialog *dlg)
        { prtGrpMaintDialog = dlg; }
};


class PrtGrpMaintPrivLevel : public vcontainerExclusiveGroup
{

public:

    // macros for standard versions of the
    vkindTYPED_FULL_DECLARATION(PrtGrpMaintPrivLevel);

    // constructors and destructors
    vloadableINLINE_CONSTRUCTORS(PrtGrpMaintPrivLevel, vcontainerExclusiveGroup);

    // vloadable override
    void LoadInit (vresource resource);

    // radio button toggles in the container
#ifdef	CALISO
    vcontrolToggle	*fullAccessToggle;
    vcontrolToggle	*viewOnlyToggle;
    vcontrolToggle 	*noAccessToggle;
#else
    vcontrolToggle	*adminToggle;
    vcontrolToggle	*engineerToggle;
    vcontrolToggle	*supervisorToggle;
    vcontrolToggle	*operatorToggle;
    vcontrolToggle	*traineeToggle;
    vcontrolToggle	*viewToggle;
#endif	CALISO

    // some public funcs
    char *GetPrivStr (void);
};


class  PrtGrpMaintOkButton : public vbutton
{
    PrtGrpMaintDialog	*prtGrpMaintDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(PrtGrpMaintOkButton);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(PrtGrpMaintOkButton, vbutton);

    void ObserveDialogItem (vevent *event);

    // some publics
    void SetPrtGrpMaintDialog (PrtGrpMaintDialog *dlg)
        { prtGrpMaintDialog = dlg; }
};


class  PrtGrpMaintCancelButton : public vbutton
{
    PrtGrpMaintDialog	*prtGrpMaintDialog;

public:

    // overrides from vkindTyped
    vkindTYPED_FULL_DECLARATION(PrtGrpMaintCancelButton);

    // the default versions of necessary constructors/destructor
    vloadableINLINE_CONSTRUCTORS(PrtGrpMaintCancelButton, vbutton);

    void ObserveDialogItem (vevent *event);

    // some publics
    void SetPrtGrpMaintDialog (PrtGrpMaintDialog *dlg)
        { prtGrpMaintDialog = dlg; }
};

#endif	prtgrpmaintdialogH
