/* trendcontrols.h,v 1.1.1.1 1999/08/03 14:45:09 tis4000 Exp
 *
 */

/* control button types */
#define tcTIMEDOWN	1
#define tcTIME		2
#define tcTIMEUP	3
#define tcCURSORUP	4
#define tcCURSOR	5
#define tcCURSORDOWN	6
#define tcZOOMDOWN	7
#define tcZOOM		8
#define tcZOOMUP	9

class tcControlButton;

/* toggle button types */
#define tcTEXTTOGGLE	1
#define tcAUTOTOGGLE	2

class tcControlToggle;

/*
 * TrendControls - trend graph continer class
 */
class TrendControls : public vcontainer
{
    public:
	// the default versions of the necessary constructors/destructor
	vloadableINLINE_CONSTRUCTORS(TrendControls, vcontainer);

	// overrides from vkindTyped
	vkindTYPED_FULL_DECLARATION(TrendControls);

	// virtual member function overrides
	// vloadable
	virtual void LoadInit(vresource resource);

	// methods

	// methods
	void SetTrendSet (TrendSet *set);
	void Redisplay () { Inval (0); }
	void SetTextIndicator (int value);
	void SetTheCursor (int pos);
	virtual void ControlClick (int type);
	virtual void ToggleClick (int type, int value);
    private:
	TrendSet	*trendSet;	    // the working document
	tcControlButton *timeDown;
	tcControlButton	*timeSet;
	tcControlButton	*timeUp;
	tcControlButton *cursorDown;
	tcControlButton	*cursorSet;
	tcControlButton *cursorUp;
	tcControlButton *zoomDown;
	tcControlButton	*zoomSet;
	tcControlButton	*zoomUp;
	tcControlToggle	*textToggle;
	tcControlToggle	*autoToggle;
	vtextitem	*spanText;
	vtextitem	*rateText;
	vtextitem	*locationText;
};
