/* trendnotedlg.cxx,v 1.1.1.1 1999/08/03 14:45:10 tis4000 Exp
 *
 */

/*
 * TrendNoteDialog - trend note classes
 */

#include <vport.h>		/* for v*HEADER */
#include vstdlibHEADER		/* for random, exit, EXIT_SUCCESS */
#include vlistHEADER
#include vstartupHEADER
#include vmemHEADER
#include vprefHEADER
#include vtextitemHEADER
#include vbuttonHEADER
#include vcharHEADER
#include vcomboboxHEADER
#include vdialogHEADER

#ifdef WIN32
#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#endif WIN32

extern "C"
{
    #include "oracleSnap.h"
    #include "archiveLib.h"
#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
    #include "CB45to63.h"
    #include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32
    #include "avmDefs.h"
    #include "xbaseSnapLib.h"

    #include "trendutils.h"
    extern char *Months;
}
#include "tisgalaxylib.hxx"
#include "trenddocs.h"
#include "TrendNoteDlg.h"

// Helper functions
class taNoteText : public vtextitem {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(taNoteText);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(taNoteText, vtextitem);
  
  // virtual member function overrides
  int HandleKeyDown (vevent *event);

  void SetParent (TrendNoteReadDialog *p) { parent = p; }
private:
    TrendNoteReadDialog *parent;
};

vkindTYPED_FULL_DEFINITION(taNoteText, vtextitem, NULL);
int taNoteText::HandleKeyDown (vevent *event)
{
    parent->NoteModified ();
    return vtextitem::HandleKeyDown (event);
}

class taAddButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(taAddButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(taAddButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendNoteDialog *p) { parent = p; }
private:
    TrendNoteDialog *parent;
};

vkindTYPED_FULL_DEFINITION(taAddButton, vbutton, NULL);
void taAddButton::ObserveDialogItem (vevent *event)
{
    parent->AddClick();
}

class taCancelButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(taCancelButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(taCancelButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendNoteDialog *p) { parent = p; }
private:
    TrendNoteDialog *parent;
};

vkindTYPED_FULL_DEFINITION(taCancelButton, vbutton, NULL);
void taCancelButton::ObserveDialogItem (vevent *event)
{
    parent->CancelClick();
}

// Helper functions for read dialog
class taCloseButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(taCloseButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(taCloseButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendNoteReadDialog *p) { parent = p; }
private:
    TrendNoteReadDialog *parent;
};

vkindTYPED_FULL_DEFINITION(taCloseButton, vbutton, NULL);
void taCloseButton::ObserveDialogItem (vevent *event)
{
    // Close dialog
}

class taNextButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(taNextButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(taNextButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendNoteReadDialog *p) { parent = p; }
private:
    TrendNoteReadDialog *parent;
};

vkindTYPED_FULL_DEFINITION(taNextButton, vbutton, NULL);
void taNextButton::ObserveDialogItem (vevent *event)
{
    parent->NextClick();
}

class taPrevButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(taPrevButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(taPrevButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendNoteReadDialog *p) { parent = p; }
private:
    TrendNoteReadDialog *parent;
};

vkindTYPED_FULL_DEFINITION(taPrevButton, vbutton, NULL);
void taPrevButton::ObserveDialogItem (vevent *event)
{
    parent->PrevClick();
}

class taDeleteButton : public vbutton {
public:
  // macro for overrides from vkindTyped
  vkindTYPED_FULL_DECLARATION(taDeleteButton);
  
  // macro for the standard versions of the 
  // necessary constructors and destructors
  vloadableINLINE_CONSTRUCTORS(taDeleteButton, vbutton);
  
  // virtual member function overrides
  void ObserveDialogItem(vevent *event);

  void SetParent (TrendNoteReadDialog *p) { parent = p; }
private:
    TrendNoteReadDialog *parent;
};

vkindTYPED_FULL_DEFINITION(taDeleteButton, vbutton, NULL);
void taDeleteButton::ObserveDialogItem (vevent *event)
{
    parent->DeleteClick();
}

// Main Note classes

// Initial Note entry

// macro definitions for vkindtyped overrides
vkindTYPED_FULL_DEFINITION(TrendNoteDialog, vdialog, NULL);

// vloadable
void TrendNoteDialog::LoadInit(vresource resource)
{
    // get handles to interesting elements
    nameText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("NameTag"));
    dateText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("DateTag"));
    timeText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("TimeTag"));
    noteText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("NoteTextTag"));
    add = taAddButton::RequestSubLoad (this, vnameInternGlobalLiteral("AddTag"));
    cancel = taCancelButton::RequestSubLoad (this, vnameInternGlobalLiteral("CancelTag"));

    vdialog::LoadInit(resource);

    add->SetParent (this);
    cancel->SetParent (this);
}

/*********
 *  TrendNoteDialog::ObserveWindow()
 *
 *  The dialog notification procedure gets called whenever any 
 *  major event applies to the dialog as a whole.  We need to
 *  look for the event which tells us that the dialog has
 *  closed.
 *
 **********/
void TrendNoteDialog::ObserveWindow (vevent *event)
{
    result = RESULT_CANCEL;
    if (event->GetType() == veventWINDOW_STATE && event->IsClose ())
	vevent::StopProcessing ();
}

/*********
 *  TrendNoteDialog::AddClick()
 *
 *  The procedure gets called whenever the accept button is clicked 
 *
 **********/
void TrendNoteDialog::AddClick ()
{
    char point [C_PTNMLEN+1];
    char datestr [50];
    time_t notetime;

    nameText->GetText ((unsigned char *)point, sizeof(point));
    dateText->GetText ((unsigned char *)datestr, sizeof(datestr));
    trimblanks (datestr);
    strcat (datestr, " ");
    timeText->GetText ((unsigned char *)&datestr[strlen(datestr)], sizeof(datestr)-strlen(datestr));
    notetime = GmtDateVal (datestr, 0);
    noteText->GetText ((unsigned char *)resultString, sizeof(resultString));
    AddSetNote (point, notetime, resultString);
    result = RESULT_OK;

    if (IsOpen())
    {
	Close ();
	vevent::StopProcessing ();
    }
}

/*********
 *  TrendNoteDialog::CancelClick()
 *
 *  The procedure gets called whenever the cancel button is clicked 
 *
 **********/
void TrendNoteDialog::CancelClick ()
{
    result = RESULT_CANCEL;
    if (IsOpen())
    {
	Close ();
	vevent::StopProcessing ();
    }
}

int TrendNoteDialog::Alert (char *pointname, time_t time)
{
    static char name [C_PTNMLEN];
    static char datestr[15];
    static char epndatestr[15];
    static char timestr[10];

    if (pointname[0] == '>')
        strncpy (name, pointname+1, C_PTNMLEN);
    else
        strncpy (name, pointname, C_PTNMLEN);
    char *cp = strchr (name, '.');
    if (cp)
        *cp = 0;

    nameText->SetText ((unsigned char *)name);
    LocalStrDate (time, datestr);
    sprintf (epndatestr, "%3.3s %u, %u",
                     &Months[(atoi(datestr)-1)*3],
                     atoi(&datestr[3]),
                     atoi(&datestr[6]));
    dateText->SetText ((unsigned char *)epndatestr);
    timeText->SetText ((unsigned char *)LocalStrTime (time, timestr));

    noteText->SetText ((unsigned char *)"");

    // Pop it up and handle events
    Open ();
    // process events
    vevent::Process();

    // return answer
    return result;
}

// Note reading and modification code

// macro definitions for vkindtyped overrides
vkindTYPED_FULL_DEFINITION(TrendNoteReadDialog, vdialog, NULL);

// vloadable
void TrendNoteReadDialog::LoadInit(vresource resource)
{
    // get handles to interesting elements
    nameText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("NameTag"));
    dateText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("DateTag"));
    timeText = vtextitem::RequestSubLoad (this, vnameInternGlobalLiteral("TimeTag"));
    noteText = taNoteText::RequestSubLoad (this, vnameInternGlobalLiteral("NoteTextTag"));
    close = taCloseButton::RequestSubLoad (this, vnameInternGlobalLiteral("CloseTag"));
    next = taNextButton::RequestSubLoad (this, vnameInternGlobalLiteral("NextTag"));
    prev = taPrevButton::RequestSubLoad (this, vnameInternGlobalLiteral("PrevTag"));
    del = taDeleteButton::RequestSubLoad (this, vnameInternGlobalLiteral("DeleteTag"));

    vdialog::LoadInit(resource);

    noteText->SetParent (this);
    close->SetParent (this);
    next->SetParent (this);
    prev->SetParent (this);
    del->SetParent (this);
}

/*********
 *  TrendNoteReadDialog::ObserveWindow()
 *
 *  The dialog notification procedure gets called whenever any 
 *  major event applies to the dialog as a whole.  We need to
 *  look for the event which tells us that the dialog has
 *  closed.
 *
 **********/
void TrendNoteReadDialog::ObserveWindow (vevent *event)
{
    if (event->GetType() == veventWINDOW_STATE && event->IsClose ())
    {
	result = 0;
	if (modified)
	    ProcessModify ();
	vevent::StopProcessing ();
    }
}

/*********
 *  TrendNoteReadDialog::NoteModified()
 *
 *  The procedure gets called whenever the close button is clicked 
 *
 **********/
void TrendNoteReadDialog::NoteModified ()
{
    modified = vTRUE;
}

/*********
 *  TrendNoteReadDialog::CloseClick()
 *
 *  The procedure gets called whenever the close button is clicked 
 *
 **********/
void TrendNoteReadDialog::CloseClick ()
{
    if (modified)
	ProcessModify ();

    noteText->GetText ((unsigned char *)resultString, sizeof(resultString));
    result = 0;
    if (IsOpen())
    {
	Close ();
	vevent::StopProcessing ();
    }
}

/*********
 *  TrendNoteReadDialog::NextClick()
 *
 *  The procedure gets called whenever the next button is clicked 
 *
 **********/
void TrendNoteReadDialog::NextClick ()
{
    if (modified)
	ProcessModify ();

    noteText->GetText ((unsigned char *)resultString, sizeof(resultString));
    result = 1;
    if (IsOpen())
    {
	Close ();
	vevent::StopProcessing ();
    }
}

/*********
 *  TrendNoteReadDialog::PrevClick()
 *
 *  The procedure gets called whenever the prev button is clicked 
 *
 **********/
void TrendNoteReadDialog::PrevClick ()
{
    if (modified)
	ProcessModify ();

    noteText->GetText ((unsigned char *)resultString, sizeof(resultString));
    result = -1;
    if (IsOpen())
    {
	Close ();
	vevent::StopProcessing ();
    }
}

/*********
 *  TrendNoteReadDialog::DeleteClick()
 *
 *  The procedure gets called whenever the delete button is clicked 
 *
 **********/
void TrendNoteReadDialog::DeleteClick ()
{
    char point [C_PTNMLEN+1];
    char datestr [50];
    time_t notetime;

    if (cautionNotice (this, (unsigned char *)"Delete Note?", (unsigned char *)"Are you sure you want to delete this note?"))
    {
	nameText->GetText ((unsigned char *)point, sizeof(point));
	dateText->GetText ((unsigned char *)datestr, sizeof(datestr));
	trimblanks (datestr);
	strcat (datestr, " ");
	timeText->GetText ((unsigned char *)&datestr[strlen(datestr)], sizeof(datestr)-strlen(datestr));
	notetime = GmtDateVal (datestr, 0);
	DeleteSetNote (point, notetime);
    }
    result = 1;
    if (IsOpen())
    {
	Close ();
	vevent::StopProcessing ();
    }
}

int TrendNoteReadDialog::Alert (char *pointname, time_t time, int modifiable, int havePrev, int haveNext)
{
    static char name [C_PTNMLEN];
    static char datestr[15];
    static char epndatestr[15];
    static char timestr[10];

    if (pointname[0] == '>')
        strncpy (name, pointname+1, C_PTNMLEN);
    else
        strncpy (name, pointname, C_PTNMLEN);
    char *cp = strchr (name, '.');
    if (cp)
        *cp = 0;

    nameText->SetText ((unsigned char *)name);
    LocalStrDate (time, datestr);
    sprintf (epndatestr, "%3.3s %u, %u",
                     &Months[(atoi(datestr)-1)*3],
                     atoi(&datestr[3]),
                     atoi(&datestr[6]));
    dateText->SetText ((unsigned char *)epndatestr);
    timeText->SetText ((unsigned char *)LocalStrTime (time, timestr));

    noteText->SetText ((unsigned char *)"");

    modified = vFALSE;

    // adjust enables and permissions
    if (modifiable)
	del->Enable();
    else
	del->Enable();
    noteText->SetModifiable (modifiable);

    if (havePrev)
	prev->Enable();
    else
	prev->Disable();

    if (haveNext)
	next->Enable();
    else
	next->Disable();

    // Pop it up and handle events
    Open ();
    // process events
    vevent::Process();

    // return answer
    return result;
}

/*********
 *  TrendNoteReadDialog::ProcessModify()
 *
 *  The procedure writes the modified note text to the database 
 *
 **********/
void TrendNoteReadDialog::ProcessModify ()
{
    char point [C_PTNMLEN+1];
    char datestr [50];
    time_t notetime;

    if (cautionNotice (this, (unsigned char *)"Save changes?", (unsigned char *)"Note text modified, Save changes?"))
    {
	nameText->GetText ((unsigned char *)point, sizeof(point));
	dateText->GetText ((unsigned char *)datestr, sizeof(datestr));
	trimblanks (datestr);
	strcat (datestr, " ");
	timeText->GetText ((unsigned char *)&datestr[strlen(datestr)], sizeof(datestr)-strlen(datestr));
	notetime = GmtDateVal (datestr, 0);
	noteText->GetText ((unsigned char *)resultString, sizeof(resultString));
	AddSetNote (point, notetime, resultString);
    }
}