/* Utility routines */

#ifdef WIN32
#pragma pack (push, 1)
#endif WIN32
#include "cb45to63.h"
#include "d4all.h"
#ifdef WIN32
#pragma pack (pop)
#endif WIN32

#ifdef WIN32
#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#endif WIN32
#include "time.h"
#include "trendutils.h"
#include "oracleSnap.h"
#include "avmDefs.h"
#include "xbaseSnapLib.h"

char	*sev = "VMmIE";
char	*qual = "*QCqF"; /* in precedence order*/
char	*alms = "FuBEKUXTIRGNcMCSrHhLlW ";

char	*dbreducs [] = { "SMP", "AVG", "MIN", "MAX" };

char	*WeekDays = "sunmontuewedthufrisat";
char	*Months = "janfebmaraprmayjunjulaugsepoctnovdec";
char	* RedStrings [C_NEWRADIOBUTTONS] = { "SMP", "AVG", "MIN", "MAX", "BAR" };

SnapRec	snapRec;

char *symname [MAXSYM];
char *symval [MAXSYM];

int AddSym (name, val)
char *name;
char *val;
{
    unsigned int symlen;
    int i;

    if (strchr(name, ')'))
	symlen = strchr(name, ')') - name;
    else
	symlen = strlen(name);

    for (i = 0; i < MAXSYM && symname[i]; i++)
    {
	if ((strncmp(symname[i], name, symlen) == 0) && strlen(symname[i]) == symlen)
	{
	    free (symname[i]);
	    free (symval[i]);
	    break;
	}
    }

    /* if i < MAXSYM, either a changed value, or we are at free cell */
    if (i < MAXSYM)
    {
	if (symname[i] = malloc (strlen (name)+1))
	{
	    strcpy (symname[i], name);
	    if (symval[i] = malloc (strlen (val)+1))
	    {
		strcpy (symval[i], val);
		return (i);
	    }
	    else
	    {
		free (symname [i]);
		return (-1);
	    }
	}
	else
	    return (-1);
    }
    /* unable to add */
    return (-1);
}

char *LookupSym (name)
char *name;
{
    unsigned int symlen;
    int i;

    if (strchr(name, ')'))
	symlen = strchr(name, ')') - name;
    else
	symlen = strlen(name);

    for (i = 0; i < MAXSYM && symname[i]; i++)
    {
	if ((strncmp(symname[i], name, symlen) == 0) && strlen(symname[i]) == symlen)
	    return (symval [i]);
    }
    return NULL;
}

char *ResolveName (dest, src, destlen)
char *dest;
char *src;
int destlen;
{
    char *macval;
    char *macend;
    char *savedest = dest;

    while (*src && destlen)
    {
	if (*src == '$' && *(src+1) == '(')
	{
	    src = src + 2;
	    macend = strchr (src, ')');
	    if (macend && (macval = LookupSym (src)))
	    {
		while (destlen && *macval)
		{
		    *dest++ = *macval++;
		    destlen--;
		}
		src = macend + 1;
		continue; /* macro has been substituted, continue loop */
	    }
	    else
	    {
		return NULL;
	    }
	}
	/* not a macro, or badly formed, just copy over */
	*dest++ = *src++;
	destlen--;
    }
    *dest = 0;
    return savedest;
}

static char prefstring [132];
char	* Prefs [] = {"t1","t2","t3","t4","t5","t6","t7","t8","trendback","datafile"};

/* read in preference file */
void GetPreference ( pencolor, backcolor, filename )
long pencolor[];
long *backcolor;
char *filename;
{
    FILE *fp;
    char *cp;
    int    r, g, b;

    fp = fopen ("trprefs.ini", "rt");
    if (fp)
    {
        while (!feof (fp))
        {
            int ix = 0;
            while (!feof (fp))
            {
                prefstring [ix] = fgetc(fp);
                if ((prefstring [ix] == 0x0d) || (prefstring [ix] == 0x0a))
                    break;
                ix++;
                if (ix == 80)
		{
		    fclose (fp);
                    return; /* bad string in prefs file. */
		}
            }
            prefstring [ix] = 0;
            if (strlen (prefstring))
            {
                ix = 0;
                while (isalnum (prefstring[ix]))
                {
                    if (isupper (prefstring [ix]))
                        prefstring [ix] = prefstring [ix]+0x20;
                    ix++;
                }
                if (prefstring[ix] == ':')
                {
                    int prix;
                    prefstring [ix] = 0;
                    for (prix = 0; Prefs[prix][0]; prix++)
                    {
                        if (strcmp (Prefs[prix], prefstring) == 0)
                            break;
                    }
                    switch (prix)
                    { 
                        case 0:
                        case 1:
                        case 2:
                        case 3:
                        case 4:
                        case 5:
                        case 6:
                        case 7:
                            r = atoi (&prefstring [ix+1]);
                            cp = strchr (&prefstring [ix+1], ',');
                            if (cp)
                            {
                                g = atoi (cp+1);
                                cp = strchr (cp+1, ',');
                                if (cp)
                                {
                                    b = atoi (cp+1);
                                    pencolor [prix] = Color (r, g, b);
                                }
                            }
                            break;
                        case 8:
                            r = atoi (&prefstring [ix+1]);
                            cp = strchr (&prefstring [ix+1], ',');
                            if (cp)
                            {
                                g = atoi (cp+1);
                                cp = strchr (cp+1, ',');
                                if (cp)
                                {
                                    b = atoi (cp+1);
                                    *backcolor = Color (r, g, b);
                                }
                            }
                            break;
                        case 9:
                            ix++;
                            while (prefstring [ix] == ' ' || prefstring [ix] =='\t')
                                ix++;
                            strcpy (filename, &prefstring [ix]);
                            break;
                        default:
                            break;
                    }
                }
            }
        }
	fclose (fp);
    }
    else /* set to default values */
    {
        pencolor [0] = Color (  0,  0,100);
        pencolor [1] = Color (  0,100,100);
        pencolor [2] = Color (100,  0,  0);
        pencolor [3] = Color (100,  0,100);
        pencolor [4] = Color (100,100,  0);
        pencolor [5] = Color (100,100,100);
        pencolor [6] = Color (  0,  0,175);
        pencolor [7] = Color (  0,175,  0);
        *backcolor   = Color (255,255,255);
        strcpy (filename, "");
    }
}

/* save preference file */
void PutPreference ( pencolor, backcolor, filename )
long pencolor[];
long backcolor;
char *filename;
{
    FILE *fp;

    fp = fopen ("trprefs.ini", "wt");
    if (fp)
    {
        int ix;

        sprintf (prefstring, "datafile: %s\n", filename);
        fwrite (prefstring, strlen (prefstring), 1, fp);
        for (ix = 0; ix < 8; ix++)
        {
            sprintf (prefstring, "t%u: %u, %u, %u\n", ix+1,
                    Red (pencolor[ix]),
                    Green (pencolor[ix]),
                    Blue(pencolor[ix]));
            fwrite (prefstring, strlen (prefstring), 1, fp);
        }

        sprintf (prefstring, "trendback: %u, %u, %u\n",
                Red (backcolor),
                Green (backcolor),
                Blue (backcolor));
        fwrite (prefstring, strlen (prefstring), 1, fp);
        fclose (fp);
    }
}

/* make a trendspec string */
void MakeTSpec ( specstring, epn, dbreduc, reduc, date, off, dl, dh, cl, ch )
CHARSPEC specstring;
char *epn;
int  dbreduc;
int  reduc;
char *date;
char *off;
double dl;
double dh;
double cl;
double ch;
{
    char    *cp;

    trimblanks (epn);
    for (cp = epn; *cp == 0x20; cp++);
    if (*cp == '#')
    {
        sprintf ((char *)specstring, "%s|||||%g|%g|%g|%g", cp, dl, dh, cl, ch);
    }
    else
    {
        sprintf ((char *)specstring, "%s|%3.3s|%3.3s|", cp, RedStrings [dbreduc], RedStrings [reduc]);
        strncat ((char *)specstring, date, C_DATELEN);
        strcat ((char *)specstring, "|");
        strncat ((char *)specstring, off, C_OFFSETLEN);
        sprintf ((char *)specstring+strlen((char *)specstring), "|%g|%g|%g|%g", dl, dh, cl, ch);
    }
}

/* unpack a trendspec string */
void GetTSpec ( spec, epn, dbreduc, reduc, date, off, epntime, dl, dh, cl, ch, z )
CHARSPEC spec;
char *epn;
int  *dbreduc;
int  *reduc;
char *date;
char *off;
long *epntime;
double *dl;
double *dh;
double *cl;
double *ch;
long z;
{
    static CHARSPEC specstring;
    char    *strptr, *endptr;
    int     i;

    strncpy (specstring, spec, sizeof(CHARSPEC));
    
    if ((endptr = strchr (specstring, '|')) != NULL)
    {
        *endptr = 0;
        strcpy (epn, specstring);
        trimblanks (epn);
        strptr = endptr + 1;
        if ((endptr = strchr (strptr, '|')) != NULL)
        {
            *endptr = 0;
            for (i = 0; (i < C_NEWRADIOBUTTONS) && (strcmp (RedStrings[i], strptr) != 0); i++)
                /* all the work is done in the for statement */ ;
            if (i < C_NEWRADIOBUTTONS)
                *dbreduc = i;
            else
                *dbreduc = 0;

            strptr = endptr + 1;

            if ((endptr = strchr (strptr, '|')) != NULL)
            {
                *endptr = 0;
                for (i = 0; (i < C_NEWRADIOBUTTONS) && (strcmp (RedStrings[i], strptr) != 0); i++)
                    /* all the work is done in the for statement */ ;
                if (i < C_NEWRADIOBUTTONS)
                    *reduc = i;
                else
                    *reduc = 0;

                strptr = endptr + 1;
                if ((endptr = strchr (strptr, '|')) != NULL)
                {
                    *endptr = 0;
                    strncpy (date, strptr, C_DATELEN);
                    *epntime = GmtDateVal (strptr, z * C_TRENDSAMPLES);
                    strptr = endptr + 1;
                    if ((endptr = strchr (strptr, '|')) != NULL)
                     {
                        *endptr = 0;
                        strncpy (off, strptr, C_OFFSETLEN);
                        if (SpanVal (strptr))
                        {
                            *epntime += SpanVal (strptr);
                        }
                        strptr = endptr + 1;
                        if ((endptr = strchr (strptr, '|')) != NULL)
                        {
                            *endptr = 0;
                            *dl = atof (strptr);
                            strptr = endptr + 1;
                            if ((endptr = strchr (strptr, '|')) != NULL)
                            {
                                *endptr = 0;
                                *dh = atof (strptr);
                                strptr = endptr + 1;
                                if ((endptr = strchr (strptr, '|')) != NULL)
                                {
                                    *cl = atof (strptr);
                                    strptr = endptr + 1;
                                    *ch = atof (strptr);
                                }
                                else
                                {
                                    *cl = *ch = 0.0;
                                }
                            }
                        }
                    }
                }
            }
        }
    }
}

int GetRecParams ( char *pointname, int dbred, long when, double *dispLo, double *dispHi ) 
{
    if (StartPointSet (pointname, RedStrings[dbred], 0, 0, &snapRec))
    {
	*dispLo = snapRec.disp_low;
	*dispHi = snapRec.disp_high;
	return TRUE;
    }
    else
	return FALSE;
}

int GetTrendNote ( char *pointname, time_t *when, char **text )
{
    return StartNoteSet (pointname, when, text);
}

int NextTrendNote ( time_t *when, char **text )
{
    return NextNoteSet (when, text);
}

long dbsearch ( char *pointname, int dbred, long when, SEARCH *srch )
{
    long	epntime;
    long	valuetime;
    long	dir;
    double	bestvalue;
    long	besttime;
    int		tempsamples;
    double	tempvalue;
    char	tempstatus [4];
    int		sample_ix;

    if (srch->type [1] == 'S')
    {
	epntime = 0; /* forces start at beginning of file (search starts at 0) */
	dir = 1;
    }
    else if (srch->type [1] == 'C')
    {
	epntime = when + 1;
	dir = 1;
    }
    else if (srch->type [1] == 'P')
    {
	epntime = 0;
	dir = -1;
    }
    else
	return (-1);

    if (StartPointSet (pointname, RedStrings[dbred], epntime, 0, &snapRec))
    {
	tempsamples = snapRec.sample_cnt;
	sample_ix = 0;
	while (((valuetime + snapRec.rate) < epntime) && (valuetime != 0x7fffffffL))
	{
	    if (tempsamples--)
	    {
		valuetime += snapRec.rate;
		tempvalue = snapRec.value[sample_ix];
		strncpy(tempstatus, snapRec.status[sample_ix], sizeof(tempstatus));
		sample_ix++;
	    }
	    else
	    {
		if (!NextPointSet (&snapRec, 0))
		    valuetime = 0x7fffffffL; /* somewhere in the far future */
		else
		{
		    tempsamples = snapRec.sample_cnt;
		    sample_ix = 0;
		}
	    }
	}
    }

    if (srch->type [2] == '+')
    {
	bestvalue = tempvalue;
	besttime = valuetime;
	while ((valuetime != 0x7fffffffL)
	  || (dir == -1 && valuetime < when))
	{
	    if (((dir == 1) && (bestvalue < tempvalue))
	      || ((dir == -1) && (bestvalue <= tempvalue)))
	    {
		bestvalue = tempvalue;
		besttime = valuetime;
	    }
	    if (tempsamples--)
	    {
		valuetime += snapRec.rate;
		tempvalue = snapRec.value[sample_ix];
		strncpy(tempstatus, snapRec.status[sample_ix], sizeof(tempstatus));
		sample_ix++;
	    }
	    else
	    {
		if (!NextPointSet (&snapRec, 0))
		    valuetime = 0x7fffffffL; /* somewhere in the far future */
		else
		{
		    tempsamples = snapRec.sample_cnt;
		    sample_ix = 0;
		}
	    }
	}
	return (besttime);
    }
    else if (srch->type [2] == '-')
    {
	bestvalue = tempvalue;
	besttime = valuetime;
	while ((valuetime != 0x7fffffffL)
	  || (dir == -1 && valuetime < when))
	{
	    if (((dir == 1) && (bestvalue > tempvalue))
	      || ((dir == -1) && (bestvalue >= tempvalue)))
	    {
		bestvalue = tempvalue;
		besttime = valuetime;
	    }
	    if (tempsamples--)
	    {
		valuetime += snapRec.rate;
		tempvalue = snapRec.value[sample_ix];
		strncpy(tempstatus, snapRec.status[sample_ix], sizeof(tempstatus));
		sample_ix++;
	    }
	    else
	    {
		if (!NextPointSet (&snapRec, 0))
		    valuetime = 0x7fffffffL; /* somewhere in the far future */
		else
		{
		    tempsamples = snapRec.sample_cnt;
		    sample_ix = 0;
		}
	    }
	}
	return (besttime);
    }
    else
    {
	besttime = -1;
	while ((valuetime != 0x7fffffffL)
	  || (dir == -1 && valuetime < when))
	{
	    if (strchr (srch->severity, tempstatus[1]) || strchr (srch->status, tempstatus[2]))
	    {
		if (dir == 1)
		{
		    return (valuetime);
		}
		else
		{
		    besttime = valuetime;
		}
	    }
	    if (tempsamples--)
	    {
		valuetime += snapRec.rate;
		strncpy(tempstatus, snapRec.status[sample_ix], sizeof(tempstatus));
		sample_ix++;
	    }
	    else
	    {
		if (!NextPointSet (&snapRec, 0))
		    valuetime = 0x7fffffffL; /* somewhere in the far future */
		else
		{
		    tempsamples = snapRec.sample_cnt;
		    sample_ix = 0;
		}
	    }
	}
	return (besttime);
    }
}

void trimblanks (string) 
char *string;
{
    int last;

	/* strip trailing blanks */
	for (last = strlen(string)-1; (last >= 0) && (string[last] == ' '); last--)
	   	string[last] = 0;
}

void padblanks (string, len) 
char *string;
int len;
{
    int last;

	/* add trailing blanks */
	for (last = strlen(string); (last < len - 1); last++)
		string[last] = ' ';
	string[last] = 0;
}

/* this routine returns the local time string for the Unix GMT 0 seconds
**  The output is DOW MON DD, YEAR HH:MM:SS
*/
char * GmtDateString (char *datestr, long timeVal) 
{
    struct tm *tm_struct;

    tm_struct = localtime (&timeVal);
    sprintf (datestr, "%3.3s %3.3s %2.2d, %4.4d %2.2d:%2.2d:%2.2d",
			&WeekDays[tm_struct->tm_wday*3],
			&Months[tm_struct->tm_mon*3],
			tm_struct->tm_mday, tm_struct->tm_year+1900,
			tm_struct->tm_hour, tm_struct->tm_min, tm_struct->tm_sec);
    return datestr;
}

/* this routine returns the seconds since Unix GMT 0 second for local day
**  The input is DOW MON DD, YEAR HH:MM:SS
*/
long GmtDateVal (char *datestr, long span) 
{
	char	teststr [11];
	int	testix;
	char	retdate [11];
	char	*subptr;
	int	dow = 0;
	int	mon = 0;
	int	day = 0;
	int	year = 0;
	int	hour = 0;
	int	min = 0;
	int	sec = 0;
	long	retval; 
	time_t	gmt;
	struct tm * nowblock;
	struct tm * tmblock;

	/* First determine if the date string is abs or relative (relative if
	// mon/day/year aren't all specified.)
	// if first substring is Sun-Sat - it is 1-7 - else 0 */
	while (*datestr == ' ') datestr++;
	testix = 0;
	while (isalpha (*datestr) && (testix < 3))
	{
		teststr [testix++] = (isupper (*datestr)?(*datestr)+0x20:*datestr);
		datestr++;
	}
	teststr[testix] = 0;
	subptr = strstr ( WeekDays, teststr );
	if ((testix == 3) && subptr)
	{
		dow = ((subptr - WeekDays) / 3) + 1;
		testix = 0;
	}

	/* if second substring is Jan-Dec - month is specified - else -1 */
	if (testix == 0)
	{
		while (*datestr == ' ') datestr++;
		testix = 0;
		while (isalpha (*datestr) && (testix < 3))
		{
			teststr [testix++] = (isupper (*datestr)?(*datestr)+0x20:*datestr);
			datestr++;
		}
		teststr[testix] = 0;
	}
	subptr = strstr ( Months, teststr );
	if ((testix == 3) && subptr)
		mon = ((subptr - Months) / 3) + 1;

	/* if numeric value is <=31 - day is specified - else -1 */
	while (*datestr == ' ') datestr++;
	subptr = strchr (datestr, ',');
	if (subptr)
	{
		day = atoi (datestr);
		datestr = subptr + 1;
	}
	while (*datestr == ' ') datestr++;

	/* assume relative and build toward abs */
	gmt = time(NULL) - span;
	nowblock = localtime (&gmt);

	/* if we find a colin in the string, we have a time field */
	subptr = strchr (datestr, ':');
	/*  if we have no time field */
	if (subptr == 0)
	{ 
	    year = atoi (datestr);
	    sec = nowblock->tm_sec;
	    min = nowblock->tm_min;
	    hour = nowblock->tm_hour;
	}
	else
	{
	    /* if we see a blank before the time field,
	    **  we have a year value */
	    if (strchr (datestr, ' '))
	    {    
		year = atoi (datestr);
		datestr = strchr (datestr, ' ') + 1;
	    }
	    /* process time field */
	    hour = atoi (datestr);
	    datestr = strchr (datestr, ':') + 1;
	    min = atoi (datestr);
	    if (datestr = strchr (datestr, ':'))
		sec = atoi (datestr+1);
	}
	if ((day == 0) && (year <= 31)) /* fix up day spec only */
	{
		day = year; year = 0;
	}
	if (year)
		if (mon == 0) mon = 1; /* if year and no month, use 1st month */
	if (mon)
		if (day == 0) day = 1; /* if year or month and no day use 1st day */

	sprintf (retdate, "%02.2d/%02.2d/%04.4d", nowblock->tm_mon+1, nowblock->tm_mday, 1900 + nowblock->tm_year);

	sprintf (teststr, "%02.2d/%02.2d/%04.4d", mon, day, year);
	if (mon)
	{
		if ((year == 0) && (mon > nowblock->tm_mon+1))
		{
			nowblock->tm_year -= 1;
		}
		nowblock->tm_mon = mon-1;
	}
	if (day)
	{
		if ((year == 0) && (mon == 0) && (day > nowblock->tm_mday))
		{
			if (nowblock->tm_mon == 0) {
				nowblock->tm_year -= 1;
				nowblock->tm_mon = 11;
			}
			else
				nowblock->tm_mon -= 1;
		}
		nowblock->tm_mday = day;
	}
	if (year)
	{
		nowblock->tm_year = year - 1900;
	}

	nowblock->tm_sec = sec;
	nowblock->tm_min = min;
	nowblock->tm_hour = hour;
	nowblock->tm_isdst = -1;
#if !(defined(MIPSEL) || defined(SOLARIS) || defined(AXP) || defined(WIN32))
	retval = timelocal (nowblock);
#else
	retval = mktime (nowblock); /* - nowblock->tm_gmtoff; */
#endif
	if (dow) /* move up or back to correct day of week */
	{
		tmblock = localtime ((time_t *)&retval);
		if (tmblock->tm_wday <= (dow - 1))
			retval += (((dow - 1) - tmblock->tm_wday) * C_SECSPERDAY);
		else
			retval += (((dow - 1) + 7 - tmblock->tm_wday) * C_SECSPERDAY);
		/* if we have gone into the future, back up one week */
		/*if (retval + span > time (NULL))
		//	retval -= (C_SECSPERDAY * 7); */
	}
	return retval;
}

long SpanVal (span)     /* span time from string */
char *span;
{
    int	 neg = FALSE;
    long	spanval = 0;
    char	*endp;

    /* scan for sign */
    while ((*span == ' ') || (*span == 0x09))
        span++;

    if (*span == '-')
    {
        neg = TRUE;
        span++;
    }
    else if (*span == '+')
        span++;

    /* scan for days */
    if ((endp = strchr (span, 'd')) != NULL)
    {
        spanval = atoi (span) * C_SECSPERDAY;
        span = endp + 1;		
    }
    /* scan for minutes */
    if ((endp = strchr (span, ':')) != NULL)
    {
        spanval += (atoi (span) * 3600L);
        span = endp + 1;
        spanval += (atoi(span) * 60L);
        if ((endp = strchr (span, ':')) != NULL)
        {
            span = endp + 1;
            spanval += atoi(span);
        }
    }
    else
    {
        spanval += atoi (span) * 60L;
    }
    if (neg)
        spanval = -spanval;
    return (spanval);
}


/* GMT string conversion routines */
char *StrTime (time, timestr) 
long time;
char *timestr;
{
    struct tm *gmt_tm;

	gmt_tm = gmtime((time_t *)&time);
	sprintf (timestr, "%02d:%02d:%02d",
			 gmt_tm->tm_hour, gmt_tm->tm_min, gmt_tm->tm_sec);
	return (timestr);
}

char *StrDate (time, datestr) 
long time;
char *datestr;
{
    struct tm *gmt_tm;

	gmt_tm = gmtime((time_t *)&time);
	sprintf (datestr, "%02d/%02d/%04d",
			 gmt_tm->tm_mon+1, gmt_tm->tm_mday, gmt_tm->tm_year+1900);
	return (datestr);
}

/* Local time string conversion routines */
char *LocalStrTime (time, timestr) 
long time;
char *timestr;
{
    struct tm *loc_tm;

	loc_tm = localtime((time_t *)&time);
	sprintf (timestr, "%02d:%02d:%02d",
			 loc_tm->tm_hour, loc_tm->tm_min, loc_tm->tm_sec);
	return (timestr);
}

char *LocalStrDate (time, datestr) 

long time;
char *datestr;
{
    struct tm *loc_tm;

	loc_tm = localtime((time_t *)&time);
	sprintf (datestr, "%02d/%02d/%04d",
			 loc_tm->tm_mon+1, loc_tm->tm_mday, loc_tm->tm_year+1900);
	return (datestr);
}

char *StrSpan (time, durstr) 
long time;
char *durstr;
{
	char	tmpstring [15];

	if (time < 0)
	{
		if (-time / C_SECSPERDAY)
			sprintf (durstr, "-%ud %-8s", (int)(-time / C_SECSPERDAY),
				StrTime (-time, tmpstring));
		else
			sprintf (durstr, "-%-8s", StrTime (-time, tmpstring));
	}
	else
	{
		if (time / C_SECSPERDAY)
			sprintf (durstr, "%ud %-8s", (int)(time / C_SECSPERDAY),
				StrTime ( time, tmpstring));
		else
			sprintf (durstr, "%-8s", StrTime (time, tmpstring));
	}
	
	return (durstr);
}

