/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/


/*
	This program will display a MOTIF style message box containing the
	cursor when a selected key is pressed.
	Grant Irani
	2 Oct 1995
*/
#include	<X11/Intrinsic.h>
#include	<Xm/Xm.h>
#include	<Xm/MessageB.h>
#include	<time.h>
#define XK_MISCELLANY
#define XK_LATIN1
#include	<X11/keysymdef.h>

void	grabByeBye();
Widget	grabCreateMessageBox();

void	main(int argc, char *argv[])
{
    Widget		topLevel,msgBox;
    XtAppContext	app;
    unsigned char	type;
    XEvent		event;
    int			winLimit, i;

	type = XmDIALOG_INFORMATION;
	topLevel = XtVaAppInitialize(&app,"grabCursor",NULL,0,&argc,argv,NULL,
			XmNallowShellResize,True,
			NULL);
	msgBox = grabCreateMessageBox(topLevel,
			"Press <ctl>right-button to bring cursor here.",
			"Cursor capture",
			type);	/* create the proper message box */
	XtManageChild(msgBox);
	XtRealizeWidget(topLevel);
	if (argc > 1)
		winLimit = atoi (argv[1]);
	else
		winLimit = 1;
	for (i = 0; i < winLimit; i++)
	{
		XGrabButton (  XtDisplay(msgBox),
			    Button3,
			    ControlMask,
			    RootWindow(XtDisplay(msgBox), i),
			    True,
			    ButtonPressMask,
			    GrabModeAsync,
			    GrabModeAsync,
			    None,
			    None);
	}

	while ( 1 )
	{
	    XtAppNextEvent ( app, &event );
	    if (event.type == ButtonPress)
	    {
		/* make pointer disapear */
		for (i = 0; i < winLimit; i++)
		{
			XWarpPointer( XtDisplay(msgBox)	/* display */,
				    None		/* src_w */,
				    RootWindow(XtDisplay(msgBox), i)	/* dest_w */,
				    0			/* src_x */,
				    0			/* src_y */,
				    0			/* src_width */,
				    0			/* src_height */,
				    1500		/* dest_x */,
				    1500		/* dest_y */	);
		}
		XWarpPointer( XtDisplay(msgBox)	/* display */,
			    None		/* src_w */,
			    XtWindow(msgBox)	/* dest_w */,
			    0			/* src_x */,
			    0			/* src_y */,
			    0			/* src_width */,
			    0			/* src_height */,
			    0			/* dest_x */,
			    0			/* dest_y */	);
		continue;
	    }
	    XtDispatchEvent( &event );
	}
}

/*
	generic message box creator
*/
Widget	grabCreateMessageBox(parent,msgString,titleString,msgType)
Widget	parent;
char	*msgString,*titleString;
unsigned char	msgType;
{
    XmString	msg,title;
    Widget	msgbox;

	msg = XmStringCreateLtoR(msgString,XmSTRING_DEFAULT_CHARSET);
	title = XmStringCreateSimple(titleString);
	msgbox = XtVaCreateManagedWidget( "Warning",
				xmMessageBoxWidgetClass, parent,
				XmNdialogTitle, title,
				XmNdialogType, msgType,
				XmNmessageString, msg,
				NULL);
	XtAddCallback(msgbox,XmNokCallback,grabByeBye,0);
	XtUnmanageChild(XmMessageBoxGetChild(msgbox,XmDIALOG_CANCEL_BUTTON));
	XtUnmanageChild(XmMessageBoxGetChild(msgbox,XmDIALOG_HELP_BUTTON));
	XmStringFree(msg);
	XmStringFree(title);
	return(msgbox);
}
/*
	Just quit from this app
*/
int	grabHappened(msgBox, src_w)
Widget msgBox;
Window src_w;
{
}
/*
	Just quit from this app
*/
void	grabByeBye(w,tag,reason)
Widget	w;
int		*tag;
int		reason;
{
	exit(1);
}
