/*$Id */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
/*  File: drvArcom.c                                                                      
/*  Edit:  01/11/94      WEP: created based on drvmodbus.c                                
/*      :  02/17/94      WEP: created and used externally defined shared structures       
/*      :  02/21/94      WEP: take semaphore immediately after its creation.              
/*	:  03/30/94	 WEP: in STARTDRIVER, removed test ln >= 0, as value is unsigned. 
/*			      in msgxfer(), removed cast (char *), not needed.            
/*      :  04/18/94      WEP: tasklocking added to improve IOC terminal message viewing.  
/*                          : implemented Polled Report By Exception Function.            
/*                          : added half duplex RTS control with timing set in call.      
/*                          : modified msgxfer RX logic to timeout on inactivity.         
/*                          : modified AIDRIVER to mask out MSBit of statistics counts.   
/*                          : added string support - SODRIVER & SIDRIVER (see devArcom.c).
/*                          : modified AIDRIVER to support non-block-aligned FLOAT,       
/*                            DOUBLE INTEGER, and DOUBLE FLOAT data types.                
/*                          : modified AODRIVER and AOREAD to support non-block-aligned   
/*                            ASCII FLOAT                                                 
/*      :  05/05/94      WEP: moved while(TRUE) taskDelay logic to while(master) loop.    
/*                          : added taskDelay to while(pstate=slavewant).                 
/*                          : change all failed msgxfer holdflag=FALSE to holdflag=TRUE.  
/*      :  05/06/94      WEP: modified loopback logic to improve performance statistics   
/*      :  06/06/94      WEP: modified msgxfer RX timing logic to handle long responses   
/*      :  06/08/94      WEP: modified rx_int_proc to reject pre-response false input.    
/*      :  06/14/94      WEP: modified register_resource to print pointname causing error.
/*      :  06/22/94      WEP: corrected performance and use of the cmd_force_offline flag.
/*      :  10/27/94      WEP: modified MAIN to pre-null plcs data structure.              
/*                          : modified allocated_plc to wait to write pointer to the plcs 
/*                          : pointer structure until the allocated memory has been       
/*                          : completely initialized.                                     
/*      :  10/31/94      WEP: expanded driver support to a maximum of 32 lines.           
/*      :  11/21/94      WEP: implemented Periodic Scan Function, with history support.   
/*                          : implemented Demand Scan Function.                           
/*                          : implemented Periodic IOC/RTU Time Synchronization Function. 
/*                          : modified driver routines to pass datatime to scantask.      
/*      :  12/09/94      WEP: implemented SLL Download Function.                          
/*      :  12/15/94      WEP: added detailed debug tool set for driver calls.             
/*      :  01/04/95      WEP: implemented calls to watchdog timer logic in platform.      
/*         01/11/95      WEP: Note: project cancelled. changes since november have NOT
/*                          :       been robustly tested. downloading logic was NOT       
/*                          :       completed. Periodic logic seems to work but has NOT   
/*                          :       been tested redundantly of with the Mds radios.       
/*                          :       The watchdog additions were done just to facilitate   
/*                          :       testing during development of watchdog timer function.
/*
*/
/* #define TEST 	1 */

#define SAFANIYAH 1 


#define  MAIN        arcom_driver           /* NOTE: change here */
#define  AIDRIVER    arcom_aidriver         /* NOTE: change here */
#define  AODRIVER    arcom_aodriver         /* NOTE: change here */
#define  AOREAD      arcom_aoread           /* NOTE: change here */
#define  BIDRIVER    arcom_bidriver         /* NOTE: change here */
#define  BODRIVER    arcom_bodriver         /* NOTE: change here */
#define  BOREAD      arcom_boread           /* NOTE: change here */
#define  SIDRIVER    arcom_sidriver         /* NOTE: change here */
#define  SODRIVER    arcom_sodriver         /* NOTE: change here */

#define  TRAFFICON   arcomtrafficon         /* NOTE: change here */
#define  TRAFFICOFF  arcomtrafficoff        /* NOTE: change here */
#define  TRACEON     arcomtraceon           /* NOTE: change here */
#define  TRACEOFF    arcomtraceoff          /* NOTE: change here */
#define  RTRACEON    arcomrestraceon        /* NOTE: change here */
#define  RTRACEOFF   arcomrestraceoff       /* NOTE: change here */
#define  TRACELEVEL  arcomtrlv              /* NOTE: change here */

#define  STOPDRIVER  stoparcom              /* NOTE: change here */
#define  STARTDRIVER startarcom             /* NOTE: change here */
#define  SETCOMM     arcomcomm              /* NOTE: change here */
#define  TABLEINFO   arcomtable             /* NOTE: change here */
#define  LINEINFO    arcomline              /* NOTE: change here */

#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvArcom.h>		          /* NOTE: change here */
#include <drvArcom_proto.h> 		  /* NOTE: change here */
#include <restable.h>

#include  <tsDefs.h>

/* static long	init(); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvArcom={ 2,	NULL, init};


/*
/*      External Line Level Data Structures (declared in drvcommon.c)
/*
*/
extern	unsigned char	resnames[MODLINES][RESNAMELEN];	/* array of resource name strings.		*/

extern	RES_TABLE	*prestable[MODLINES];		/* array of pointers to resource tables 	*/

extern	unsigned short	resresponse[MODLINES];		/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

extern	unsigned short	line_activity[MODLINES];	/* true/false line active flag. calculated	*/
							/* using activity_time below. 			*/
extern	unsigned short	lastactivity[MODLINES];		/* assigned value of line_activity prior to	*/
							/* it's recalculation.   			*/

extern	unsigned short	modtrace[MODLINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/
extern	unsigned short	mltrace[MODLINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/
extern	unsigned short	modrestrace[MODLINES];		/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/

extern	SEM_ID		semids[MODLINES][2];		/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

extern	short		linetimers[MODLINES];		/* except on init (init_line_tabs), all		*/
							/* references are commented out		 	*/

extern	unsigned short	intermsgdelay[MODLINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/
extern	unsigned short	pretxdelay[MODLINES];		/* holds post RTS delay before TX. 		*/
extern	unsigned short	posttxdelay[MODLINES];		/* holds post TX delay before dropping RTS. 	*/

extern	long		activity_time[MODLINES];	/* holds timetick of last activity. used to	*/
							/* set line_activity flag  			*/

extern  SEM_ID		linemux[MODLINES];		/* 1/03/94: mutual-exclusion semaphore for	*/
							/* shared resource of the data link 		*/
							/* controls access to common path shared by	*/
							/* data and diagnostic channels. 		*/
							/* originally designed for use with MDS remote	*/
							/* radio diagnostics. 				*/

extern  unsigned short  halfduplex[MODLINES];           /* store half/full duplex line status           */

/*
/*      Storage for ARCOM Comm Line Structures
/*
*/

static RXLINE          *rxlinetab[MODLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL} ; /* array of pointers to dynamically           */
                                                          /* allocated comm controls/buffers            */

static TXLINE          *txlinetab[MODLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL} ; /* array of pointers to dynamically           */
                                                          /* allocated comm controls/buffers            */

/*
/*      Storage for ARCOM PLC Structures
/*
*/
static LOADINFO		linfo[MODLINES];		/* array of control structures for              */
                                                        /* loading PLC headers 			        */

static MODPLC		*plcs[MODLINES][NUMMODPLCS+1];	/* two dimensional array of pointers to the     */
                                                        /* fixed length dynamically allocated PLC       */
                                                        /* control and data structures. extra pointer   */
                                                        /* is for Query structure used independently    */
							/* of the others. it also allows for the array  */
                                                        /* index to match the mod value.                */

static	unsigned short	trace[MODLINES];		/* controls output of system error messages:	*/
							/* bit mapped controls                          */

static OUTPUTQUE	*oq[MODLINES];			/* array of ptrs to the line output queues and  */
                                                        /* their control structures                     */

static char		user[40],password[40];		/* holds id and password of the user that       */
                                                        /* spawned the driver task required by host to  */
                                                        /* check file read privileges on PLC load files */


static  unsigned short  options[MODLINES];              /* store half/full duplex line status           */

static char    *bools[] = {
	"TRUE ",
	"FALSE"
    };
static int		taskId [MODLINES];
static short        watchdogId [MODLINES];

static char *tasknames[] = {"ARCOM Ch0","ARCOM Ch1","ARCOM Ch2","ARCOM Ch3","ARCOM Ch4",
                            "ARCOM Ch5","ARCOM Ch6","ARCOM Ch7","ARCOM Ch8","ARCOM Ch9",
                            "ARCOM Ch10","ARCOM Ch11","ARCOM Ch12","ARCOM Ch13","ARCOM Ch14",
                            "ARCOM Ch15","ARCOM Ch16","ARCOM Ch17","ARCOM Ch18","ARCOM Ch19",
                            "ARCOM Ch20","ARCOM Ch21","ARCOM Ch22","ARCOM Ch23","ARCOM Ch24",
                            "ARCOM Ch25","ARCOM Ch26","ARCOM Ch27","ARCOM Ch28","ARCOM Ch29",
                            "ARCOM Ch30","ARCOM Ch31"
			   };

static  unsigned short  prbe[MODLINES];      /* Polled Report By Exception   */

static  unsigned long forcescanmask[MODLINES];   /* used in polled report by exception to force  */
                                                 /* all areas of memory to be scanned initially. */

static unsigned long  lastsync[MODLINES];        /* used to manage the 24 hour RTU timesync.     */

static unsigned short demandperiod[MODLINES];    /* stores user set demand period time value.    */

static unsigned short demandinterval[MODLINES];  /* stores user set demand interval time value.  */

static unsigned short sll_loading[MODLINES];     /* 0=normal operation. 0<> sll is doenloading.  */


/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
    {
	return (0);
    }
/********
/*
/*	This routine enables logging of comm trace messages
/*
********/
void TRACEON (unsigned short line)
    {
	modtrace[line] = TRUE;
    }

/********
/*
/*	This routine disables logging of comm trace messages
/*
********/
void TRACEOFF (unsigned short line)
    {
	modtrace[line] = FALSE;
    }

/********
/*
/*	This routine enables detailed display of normal communications traffic
/*
********/
void TRAFFICON (unsigned short line)
    {
	trace[line] = trace[line] | ALLTRAFFICTRACE;
    }

/********
/*
/*	This routine disables detailed display of normal communications traffic
/*
********/
void TRAFFICOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~ALLTRAFFICTRACE;
    }

/********
/*
/*	This routine enables logging of resource trace messages
/*
********/
void RTRACEON (unsigned short line)
    {
	modrestrace[line] = TRUE;
    }

/********
/*
/*	This routine disables logging of resource trace messages
/*
********/
void RTRACEOFF (unsigned short line)
    {
	modrestrace[line] = FALSE;
    }

/********
/*
/*	This routine controls logging of trace messages
/*
********/
void TRACELEVEL (unsigned short line, unsigned short level)
    {
	mltrace[line] = level;
    }

/********
/*
/*	These routines enable and disable tracing of database configuration errors in driver calls
/*
********/
void arcomcontraceon (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }
void arcomcontraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }

/********
/*
/*	These routines enable and disable tracing of runtime errors in driver calls
/*
********/
void arcomruntraceon (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }
void arcomruntraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/********
/*
/*	These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void arcomrejecttraceon (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }
void arcomrejecttraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }


void set_demand (unsigned short line, unsigned short mod)
{
    MODPLC          *pmod;

    pmod = plcs [line] [mod];           /* shorthand pointer 			*/
    if (!pmod->demandscan)
    {
        logMsg ("Arcom: Instigating Demand Mode: line %d, RTU %d\n", line, mod);
        pmod->demandstarttime = tickGet();
        pmod->demandscan = TRUE;
    }
}
 
void clear_demand (unsigned short line, unsigned short mod)
{
    MODPLC          *pmod;

    pmod = plcs [line] [mod];           /* shorthand pointer 			*/
    if (pmod->demandscan)
    {
        logMsg ("Arcom: Terminating Demand Mode: line %d, RTU %d\n", line, mod);
        pmod->demandscan = FALSE;
    }
}

void set_demand_values (unsigned short line, unsigned short period, unsigned short interval)
{
    demandperiod[line] = period*60;
    if (!period) demandperiod[line] = DEMANDPERIODDEFAULT;


    demandinterval[line] = interval*60;
    if (!interval) demandinterval[line] = DEMANDINTERVALDEFAULT;

    logMsg ("Arcom: Demand Scan Values (sec) for line %d: period = %d, interval = %d\n",
             line, period, interval);
}

int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER (unsigned short line,       /* the line number of this driver.                      */
                 char *mode,                /* UART initializations string (comma delimited ascii). */
                 unsigned short delay,      /* intermessage delay value, expressed in ticks.        */
                 unsigned short hdflag,     /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                 unsigned short delay1,     /* half duplex post RTS assert, pre TX delay.           */
                 unsigned short delay2)     /* half duplex post TX, pre RTS drop delay.             */
{
	if (line < MODLINES)
	{
	    taskId [line] = taskSpawn (tasknames[line],
                                     MOD_PRIORITY,
                                     MOD_TASK_OPTIONS,
                                     MOD_STACK,
                                     MAIN,
                                     line,
                                     mode,
                                     delay,
                                     hdflag,
                                     delay1,
                                     delay2);

	    logMsg ("Started the Arcom driver on line %d\n",line);

	    remCurIdGet (user,password);
	    return (1);
	}
	else
	{
	    logMsg ("Invalid line number %d\n", line);
	    return (-1);
	}
}

/********
/*
/* Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void arcomoptions (unsigned short line,
                   unsigned short prbeflag)
    {
	prbe[line]   = prbeflag;   /* 0 = Polled Report By Exception - Disabled                 */
                                   /* 1 = Polled Report By Exception - Enabled                  */
    }
/********
/*
/* Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
    {
	intermsgdelay[line] = tickcount1;  /* at beginning new message/response sequence.               */
	halfduplex[line]    = hdflag;
	pretxdelay[line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay[line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
    }
/*                                                                                     
/*      MOD_driver                                                                      
/*                                                                                     	
/*      The purpose of this task is to scan the modbus plc                             	
/*      lines. It will maintain a configuration list supporting online additions       	
/*      and replacement of modules, and maintain a table of most recently              	
/*      scanned values.                                                                	
/*                                                                                     	
*/                                                                                     	
/* not called from within this driver 						      */

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2)
    {
	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command, i;
        unsigned short  respond, breakout;
	long	        this_time, last_time, temp_time, next_time;
        signed long     elapsed_sync, periodic_scan_time;

	MODPLC          *pmod;
	RXLINE          *rxp;

/*****************/
/* begin testing */
short  *ptable_id;
/* end testing   */
/*****************/


/* Initialize the data structures */

        for (i = 0; i < NUMMODPLCS; i++)
        {
            plcs[line][i] = NULLP;
        }

        demandperiod[line] = DEMANDPERIODDEFAULT;
        demandinterval[line] = DEMANDINTERVALDEFAULT;

        /* force initial scanning all report by exception areas of arcom memory. */
        forcescanmask[line] = PRBEDIGITALBIT |
                              PRBEACCUMBIT |
                              PRBEANALOGBIT |
                              PRBEHARTSTATUS |
                              PRBEHARTPV1;

	intermsgdelay[line] = delay;
	halfduplex[line]  = hdflag;
	pretxdelay[line]  = delay1;
	posttxdelay[line] = delay2;
        
	linfo[line].loading = FALSE;

	resresponse[line] = FALSE;
	resnames[line][0] = 0;
	prestable[line] = NULL;

	modtrace[line] = FALSE;
	mltrace[line] = 0;
	modrestrace[line] = TRUE;
        trace[line] = 0;

        /* debug stuff: turn this stuff off when ready to release */
        arcomtraceon(line);
        arcomtrafficon(line);
        arcomcontraceon(line);
        arcomruntraceon(line);
        arcomrejecttraceon(line);
	mltrace[line] = 21;
        /* end of debug stuff */

	activity_time[line] = tickGet ();
	lastactivity[line] = line_activity[line] = FALSE;

        /* init time sync register. */
        lastsync[line] = tickGet();   /* all RTU's will timesync after 24 hours. normal RTU    */
                                      /*  initialization will result in each RTU's timesync as */
                                      /*  it is brought on line.                               */
#ifndef SAFANIYAH
	prbe[line]   = FALSE;       /* 0 = Polled Report By Exception - Disabled               */
#endif
#ifdef SAFANIYAH
	prbe[line]   = TRUE;       /* 1 = Polled Report By Exception - Enabled                 */
#endif


        /* output queue initialization */
	oq[line] = (OUTPUTQUE *)calloc(1,(sizeof(OUTPUTQUE)));
	if (!oq[line])
	{
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}
        outqueinit (line);

        /* communication initialization */
	rxlinetab[line] = (RXLINE *)calloc(1,(sizeof(RXLINE)));
	if (!rxlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
	    return;
	}
	txlinetab[line] = (TXLINE *)calloc(1,(sizeof(TXLINE)));
	if (!txlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
	    return;
	}

        taskLock();  /* make terminal display easier to read - avoids interleaving of other task data */
	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
        taskUnlock();

	onlinefreq = 1;		/* causes on_line calls to begin on first pass if master */

	/* Initialize the Rx interrupts to receive once for activity check */
	/* enable the receiver interrupt after set to ignore */
	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);

/*													
/* 1/03/94:                                                                                             
/*         initialize mutual-exclusion semaphore logic for diagnostic driver path sharing. The Take/Put
/*         logic implemented below is designed to insure, under heavy diagnostic demand, that scan_rtu	
/*         and the on_line while routine are executed once for every two diagnostic Take/Put sequences. 
/*         Furthermore, diagnostic activities are suspended during master/slave arbitration by Taking  	
/*         the semaphore while the local state is not the master state.                                	
/*
*/   
        taskLock();
        linemux[line]=semBCreate (SEM_Q_PRIORITY, SEM_FULL);
                                                        /* default: semaphore initializes as 'full',    */
                                                        /* ready to be Taken.                           */
	if (!linemux[line])
	{
	    logMsg  ("Not enough memory for line %d data structure (mutual-exclusion semaphore)\n",line);
            taskUnlock();
            return;
        }
/*	logMsg ("Arcom: semShow to follow...\n"); */
/*        semShow(linemux[line],1); */
        if ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)
        {
	      logMsg ("Arcom: Mutual-Exclusion Semaphore Timeout on Line\n",line);
              taskDelay(300);
	}
/*	logMsg ("Arcom: semShow to follow...\n"); */
/*        semShow(linemux[line],1); */
        taskUnlock();
	taskDelay(120);/* short delay for diagnostic readability */

/************************************************************************************************/
/* Wait for resource to be defined via an initial call to 'register_resource' via driver call.  */
	while ( (resnames[line][0] == 0) || (prestable[line] == NULL) )
	{
	    if (mltrace[line] == 1)
	    	logMsg ( "No Resource Defined for line - %d \n", line);
	    taskDelay (600);
	}

/*********************************************************************************************/
/*********************************************************************************************/
/*********************************************************************************************/

/***************************************************************/
/* do this testing BEFORE enabling the watchdog hardware timer */
/***************************************************************/
/*****************/
/* begin testing */
ptable_id = &watchdogId[line];
if (tisWatchDogAttach(taskId[line], 60*60, ptable_id) != OK) /* start with one minute */
{
    logMsg("Test: attempt at watchdog attachment failed.\n");
    tisWatchDogDetach(taskId[line]);
    return;
}
if (tisWatchDogPulse(watchdogId[line]) != OK)
{
    logMsg("Test: 1st attempt at watchdog pulsing failed.\n");
    tisWatchDogDetach(taskId[line]);
    return;
}
/* end testing   */
/*****************/

        /**********************/
	/* Start out as slave */

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

	resClearCaAnswer(prestable[line]);		/* start quiet */
	resPutLocalState(prestable[line], RES_SLV);
	if (modrestrace[line])
		logMsg ("0] Initialized as RES_SLV \n");
	taskDelay(60);
	resGetStates(prestable[line],&lstate,&pstate);
/*	activity = check_line_activity(line,ACTIVITYTIME); */
        for (i = 0; i < ACTIVITYTIME/10; i++)
        {
            taskDelay(10);
           /******************************/
           tisWatchDogPulse(watchdogId[line]);
           /******************************/
        }
	activity = check_line_activity(line, 0);


        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        /******************************************/
       	/* if the partner is not there, be master */
	if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
	{
	    resSetCaAnswer(prestable[line]);
	    resPutLocalState(prestable[line], RES_MSTR);
	    lstate = RES_MSTR;
	    if (modrestrace[line])
	    	logMsg ("1] Became RES_MSTR \n");
	    semGive(linemux[line]);	/* give back semaphore so diagnostics can run   */
	}


	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet(); /* Initialize the time  */

	while (TRUE)
	{

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

	    activity_time[line] = tickGet();
	    lastactivity[line] = line_activity[line] = FALSE;

            /********************************************************************************************/
	    /* we arrive here because we are a slave.                                                   */
	    /* we stay until:   asked to be master by partner. if we can reach PLCs, we become master.  */
            /*                  the partner is not master and there is no activity on the line.         */
            /********************************************************************************************/

	    while (lstate == RES_SLV)
	    {

                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

		if (pstate != RES_SLVWANT)
		{
		    clear_rts(line); 				/* make sure line is left for master 	*/
		}


		resresponse[line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand(prestable[line],0); 		/* clear out commands 			*/
		activity = check_line_activity(line,10); 	/* wait 10 ticks before checking 	*/
		resGetStates(prestable[line],&lstate,&pstate);


                /****************************************************************************************/
		/* see if needed by partner to be master. if yes, do it and break out of slave state.   */
		if (pstate == RES_SLVWANTCA)
		{
		    semGive(linemux[line]);	/* give back semaphore so diagnostics can function      */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line]) logMsg ("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    break;
		}
                /***************************************************************/
		/* If partner is there and wants to give it up, try to take it */
		if (pstate == RES_SLVWANT)
		{
		    execute = FALSE;

		    taskDelay(2); /* Time for switch to occur */

		    /* See if anyone is out there and able to respond to a loopback command */
		    for ( mod=1; (mod <= NUMMODPLCS); mod++)
		    {
			pmod = plcs[line][mod];
			if ((pmod) &&			/* verify pointer validity prior to use */
			    (pmod->was_requested) &&    /* data points have been requested      */
                            (!pmod->cmd_force_offline)) /* user has NOT forced plc offline      */
			{
			    on_line(line, mod);	
                            /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
			    {
				execute = TRUE;
				break;
			    }
			}
		    }
		    /* If someone answered, become master and make sure partner really gave it up */
		    if (execute)
		    {
			resPutLocalState(prestable[line],RES_MSTR);
			lstate = RES_MSTR;
			if (modrestrace[line])
				logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			execute = FALSE;
			activity_time[line] = tickGet();
			lastactivity[line] = line_activity[line] = FALSE;
			for (i=0;(i<60);i++)
			{
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
			    activity = check_line_activity(line,2); /* pause before testing */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ( (pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */
			    resPutLocalState(prestable[line],RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace[line])
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 
			    semGive(linemux[line]);	/* give back semaphore so diagnostics can run   */
			    resSetCaAnswer(prestable[line]);
			    prepresponses(line);
			    break;
			}
		    }
		}

                /********************************************/
		/* if the partner is not talking, be master */
		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
		    semGive(linemux[line]);		/* give back semaphore so diagnostics can run.  */
		    resSetCaAnswer(prestable[line]);    /* tell channel access about the state change.  */
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line])
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
		    prepresponses(line);
		}
	    }

            /****************************************************************************************/
            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is cancelled.         */
	    while (lstate == RES_SLVWANTCA)
	    {

                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

	        taskDelay(2);                   /* Give OS a chance...                  */
		clear_rts(line); 		/* Make sure line is left for master    */
		resresponse[line] = FALSE; 	/* Make Sure driver is not responding   */

		resGetStates(prestable[line],&lstate,&pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace[line])
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    break;
		}
		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    semGive(linemux[line]);		/* give back semaphore so diagnostics can run.  */
		    resSetCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line])
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    prepresponses(line);
		}
	    }

            /****************************************************************************************/
	    /* it doesn't appear that we ever come here in a RES_SLVWANT lstate mode. it happens    */
	    /*  within this loop, but is never seen by the while loop conditional evaluation.       */
            /****************************************************************************************/
	    while (lstate == RES_SLVWANT)
	    {

                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                /* this condition should NEVER occur */
                logMsg (" Diagnostic WEP.0001. Ignore this message. \n");
                taskDelay(200);
            }
            /****************************************************************************************/
            /* we come here because we have gone to, or are looping in, the master state.           */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will:                                                        */
	    /*   1) insure driver response to calls                                                 */
	    /*   2) monitor commands from above.                                                    */
	    /*   3) check for no RTUs responding. when true try to handoff master state to partner. */
	    /*   4) perform Periodic Scan function.                                                 */
	    /*   5) perform Demand Scan function.                                                   */
	    /*   6) perform History Scan function.                                                  */
	    /*   7) perform IOC/RTU Time Sync function.                                             */
	    /*                                                                                      */
            /****************************************************************************************/

            last_time = tickGet ();		/* initialize gap */
            respond = TRUE;                     /* initialize local any_responding flag */
            breakout = FALSE;                   /* initialize local relinquish master flag */
            sll_loading[line] = 0;              /* this may need to be done earlier in init */

if (mltrace[line] == 20) logMsg (" mainloop position 0.0\n");
            while (lstate == RES_MSTR)
            {

                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                /* initial stuff */
if (mltrace[line] == 20) logMsg (" mainloop position 1.0\n");
/* 1 */         resresponse[line] = TRUE; /* Make sure driver is responding. driver won't           */
                                          /* issue commands if not set.                             */

if (mltrace[line] == 20) logMsg (" mainloop position 2.0\n");
/* 2 */         resGetCommand(prestable[line],&command);
                resPutCommand(prestable[line],0);        /* clear out commands */
                /* if relinquish command sent, change state and break out to outer loop */
                if (command == RES_RELINQUISH)
                {
                    /* make sure diagnostics are quiescent */
                    while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)
                    {
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/

                        logMsg (" Waiting for Radio Diagnostics:");
                        printf (" Mutual-Exclusion Semaphore Timeout on Line %d\n",line);
                    }
                    resClearCaAnswer(prestable[line]);
                    resPutLocalState(prestable[line],RES_SLVWANTCA);
                    lstate = RES_SLVWANTCA;
                    if (modrestrace[line])
                       logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n", pstate, activity);
                    break;
                }
if (mltrace[line] == 20) logMsg (" mainloop position 3.0\n");
/* 3 */         /* see if previous test found that no one on the line has been responding. */
                /* if this is true, try to get partner to become master.                   */
                if (respond == FALSE)
                {
if (mltrace[line] == 20) logMsg (" mainloop position 3.1\n");
                    /* See if it is time to let partner try */
                    this_time = tickGet();
                    if ((this_time - last_time) > (3*SLWWINDOW))      /* # of ticks for slave to try */
                    {
if (mltrace[line] == 20) logMsg (" mainloop position 3.2\n");
                        /* make semGet(linemux[line]) call before the state switch to make sure  */
                        /* diagnostic task is quiescent while partner is checking the line with  */
                        /* the loopback command. if local not master, then diagnostic won't try  */
                        /* anyway, for either master or remote radios, but it might have begun a */
                        /* 12 second test sequence just before we got here.                      */
                        while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)
                        {
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/
                            logMsg ("Waiting for Radio Diagnostics: ");
                            printf ("Mutual-Exclusion Semaphore Timeout on Line %d\n", line);
                        }
                        /* we must semGive the semaphore back if and when we go to being the master */

                        /* Switch States to let partner know it's its time to try */
                        resPutLocalState(prestable[line],RES_SLVWANT);
                        lstate = RES_SLVWANT;
                        if (modrestrace[line])
                            logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate,activity);

                        /* Give partner access to the hardware */
                        clear_rts(line);

                        /* Remember the time of this try */
                        last_time = tickGet();
                        lastactivity[line] = line_activity[line] = FALSE;
                        for (i=0; (i<SLWWINDOW); i+=10)
                        {                        /* SLWINDOW is the # of ticks for slave to try */
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/

                            taskDelay(10);
                                                 /* If partner picked up let it have control */
                            activity = check_line_activity(line,0);  /* check immediately */
                            resGetStates(prestable[line],&lstate,&pstate);
                            if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
                            {
                                resClearCaAnswer(prestable[line]);
                                resPutLocalState(prestable[line],RES_SLV);
                                lstate = RES_SLV;
                                if (modrestrace[line])
                                    logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);
                                break;
                            }
                        }
if (mltrace[line] == 20) logMsg (" mainloop position 3.3\n");
                        /* Go Back to being the Master and take control of the hardware */
                        if (lstate != RES_SLV)
                        {
                            semGive(linemux[line]);	/* give back semaphore so diagnostics can run. */
                            resPutLocalState(prestable[line],RES_MSTR);
                            lstate = RES_MSTR;
                            if (modrestrace[line])
                                logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                        }
                    }
                }
if (mltrace[line] == 20) logMsg (" mainloop position 4.0\n");
/* 4 */         /* if previous attempt to voluntarily relinquish master state was successful, leave. */
                if (lstate != RES_MSTR) break;

if (mltrace[line] == 20) logMsg (" mainloop position 4.1\n");
/*   */         /* check for time to resync RTUs to IOC time. */
                elapsed_sync = tickGet() - lastsync[line];
                if (elapsed_sync > SYNC_DEFAULT)
                {
                    lastsync[line] = tickGet();
                    for (mod = 1; (mod <= NUMMODPLCS); mod++ )
                    {
                        pmod = plcs[line][mod];     /* shorthand pointer                     */
                        if ((pmod) &&               /* verify pointer validity prior to use. */
                            (pmod->was_requested))  /* (left to right analysis rules apply)  */
                        {
                            pmod->do_timesync = TRUE;
                        }
                    }
                }

if (mltrace[line] == 20) logMsg (" mainloop position 5.0\n");
/* 5 */         /* start the periodic scan function */
                periodic_scan_time = tickGet();

if (mltrace[line] == 21) logMsg (" mainloop: begin periodic scan....\n");
                /* call 'scan_rtu' for each RTU device, unless user has */
                /* taken it off line or it is not responding.           */
                for (mod = 1; (mod <= NUMMODPLCS); mod++ )
                {
                    pmod = plcs[line][mod];             /* shorthand pointer                     */
                    if ((pmod) &&                       /* verify pointer validity prior to use. */
                        (pmod->was_requested))          /* (left to right analysis rules apply)  */
                    {
if (mltrace[line] == 20) logMsg (" mainloop position 5.1\n");
/* 5.1 */               /* if user put rtu offline via pseudo command, mark it as not responding. */
                        if (pmod->cmd_force_offline)
                        { 
                            pmod->is_responding = FALSE;
                        }
if (mltrace[line] == 20) logMsg (" mainloop position 5.2\n");
/* 5.2 */               /* if actually offline, try to bring online before proceding */
                        if ((!pmod->is_responding) &&
                            (!pmod->cmd_force_offline))
                        {
if (mltrace[line] == 20) logMsg (" mainloop position 5.2.1\n");
                            /* get access to the radio */
                            while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)
                            {
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                logMsg ("Waiting for Radio Diagnostics: ");
                                printf ("Mutual-Exclusion Semaphore Timeout on Line %d\n",line);
                            }
                            on_line(line, mod);	/* loopback testing done here! 	*/
                            semGive(linemux[line]);
                        }
if (mltrace[line] == 20) logMsg (" mainloop position 5.3\n");
/* 5.3 */               /* if its talking, not on Periodic Scan, and not downloading SLL, scan it. */
                        if ((pmod->is_responding) &&
                            (!pmod->demandscan) &&
                            (sll_loading[line] != mod))
                        {
if (mltrace[line] == 20) logMsg (" mainloop position 5.3.1\n");
                            /* get access to the radio */
                            while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)
                            {
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                logMsg ("Waiting for Radio Diagnostics: ");
                                printf( "Mutual-Exclusion Semaphore Timeout.\n");
                            }
if (mltrace[line] == 20) logMsg (" mainloop position 5.3.2\n");
                            scan_rtu(pmod,line,mod);      	/* I/O done here! 		*/
                            semGive(linemux[line]);

                            if (!pmod->is_responding)
                            {
if (mltrace[line] == 20) logMsg (" mainloop position 5.3.2.1\n");
                                mark_not_valid(pmod);
                            }
                        }
if (mltrace[line] == 20) logMsg (" mainloop position 5.4\n");
/* 5.4 */               /* check for download request or in progress. */
                        check_loading(line);

if (mltrace[line] == 20) logMsg (" mainloop position 5.5\n");
/* 5.5 */               /* go process any Demand Scans before doing the next Periodic Scan */
                        scan_demand(line);
                    }
                    /* end of single module action */

                    /* if told to relinquish the master state, stop RTU scanning immediately. */
                    /* don't trash the command, so that we can still read it on the next loop */
                    /* through this while statement.                                          */
                    resGetCommand(prestable[line],&command);
                    if (command == RES_RELINQUISH)
                    {
if (mltrace[line] == 20) logMsg (" mainloop position 5.6.1\n");
                        breakout = TRUE;
                        break;
                    }
                } /* end of scan loop for all RTUs */
if (mltrace[line] == 21) logMsg (" mainloop: end periodic scan....\n");

if (mltrace[line] == 20) logMsg (" mainloop position 6.0\n");
/* 6 */         /* see if time to go */
                if (breakout)
                {
if (mltrace[line] == 20) logMsg (" mainloop position 6.1\n");
                    taskDelay(2);
                    continue; /* resume execution at the top of the master loop */
                }

if (mltrace[line] == 20) logMsg (" mainloop position 7.0\n");
/* 7 */         /* see if anyone on the line has been responding. */
                if (!any_responding(line))
                {
if (mltrace[line] == 20) logMsg (" mainloop position 7.1\n");
                    respond = FALSE;
                    taskDelay(2);
                    continue; /* resume execution at the top of the master loop */
                }
                else
                {
if (mltrace[line] == 20) logMsg (" mainloop position 7.2\n");
                    respond = TRUE;
                }

/* 8 */         taskDelay(2);

if (mltrace[line] == 20) logMsg (" mainloop position 9.0\n");
/* 9 */         /* take plcs off hold status. the plc's data are not to be held off since now master.   */
                /* ***********       this seems to need to be done inside the loop. needs looking into. */
                for ( mod=1; (mod <= NUMMODPLCS); mod++ )
                {
                    pmod = plcs[line][mod];
                    if (pmod)			/* verify pointer validity prior to use */
                    {        
                        pmod->holdflag = FALSE;
                    }
                }
/* note: we have finished the basic periodic scan task stuff. now, lets get the history scan stuff. */

if (mltrace[line] == 20) logMsg (" mainloop position 10.0\n");
if (mltrace[line] == 21) logMsg (" mainloop: begin historical scan period ....\n");
/* 10 */        /* start the periodic scan function */
                next_time = 5*60*60;  /* just so diagnostic message prints on first pass through */
                while (tickGet() < (periodic_scan_time + SCANPERIOD))       /* remainer of five minutes */
                {

                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

if (mltrace[line] == 20) logMsg (" mainloop position 10.0.1 *\n");
/*if (mltrace[line] == 21) logMsg (" mainloop: begin historical scan....\n"); */
                  /* call 'scan_rtu' for each RTU device, unless user has */
                  /* taken it off line or it is not responding.           */
                  for (mod = 1; (mod <= NUMMODPLCS); mod++ )
                  {
                    pmod = plcs[line][mod];             /* shorthand pointer                     */
                    if ((pmod) &&                       /* verify pointer validity prior to use, */
                        (pmod->was_requested) &&        /* data requested, and more to scanned.  */
                        (pmod->moretoscan))             /* (left to right analysis rules apply)  */
                    {
/* 10.1 */              /* if user put rtu offline via pseudo command, mark it as not responding. */
                        if (pmod->cmd_force_offline)
                        { 
if (mltrace[line] == 20) logMsg (" mainloop position 10.1.1\n");
                            pmod->is_responding = FALSE;
                        }
/* 10.2 */              /* if actually offline, we do NOT try to bring online. we already tried once. */
                        /* we will, of course, try again next periodic demand scan.                   */

/* 10.3 */              /* if its talking, not on Periodic Scan, and not downloading SLL, scan it. */
                        if ((pmod->is_responding) &&
                            (!pmod->demandscan) &&
                            (sll_loading[line] != mod))
                        {
if (mltrace[line] == 20) logMsg (" mainloop position 10.3.1\n");
			    modspolled++;
                            /* get access to the radio */
                            while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)
                            {
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                logMsg ("Waiting for Radio Diagnostics: ");
                                printf( "Mutual-Exclusion Semaphore Timeout.\n");
                            }
                            scan_rtu(pmod, line, mod);      	/* I/O done here! 		*/
                            semGive(linemux[line]);

                            if (!pmod->is_responding)
                            {
if (mltrace[line] == 20) logMsg (" mainloop position 10.3.2\n");
                                mark_not_valid(pmod);
                            }
                        }
if (mltrace[line] == 20) logMsg (" mainloop position 10.4\n");
/* 10.4 */              /* check for download request or in progress. */
                        check_loading(line);

if (mltrace[line] == 20) logMsg (" mainloop position 10.5\n");
/* 10.5 */              /* go process any Demand Scans before doing the next Periodic Scan */
                        scan_demand(line);
                    }  /* end of single module action */

                    checkoutputs(line);
if (mltrace[line] == 20) logMsg (" mainloop position 10.6\n");
/* 10.6 */          /* check for download request or in progress. */
                    check_loading(line);

if (mltrace[line] == 20) logMsg (" mainloop position 10.7\n");
/* 10.7 */          /* go process any Demand Scans before doing the next Periodic Scan */
                    scan_demand(line);

/*                    if (tickGet() < (periodic_scan_time + 5*60*60)) /* time for next periodic scan. */
		    /* if told to relinquish the master state, stop RTU scanning immediately. */

		    /* don't trash the command, so that we can still read it on the next loop */
                    /* through this while statement.                                          */
		    resGetCommand(prestable[line],&command);
		    if (command == RES_RELINQUISH)
                    {
if (mltrace[line] == 20) logMsg (" mainloop position 10.8.1\n");
                        breakout = TRUE;
if (mltrace[line] == 21) logMsg (" mainloop:RELINQUISH abort to end historical scan....\n");
                        break;
                    }
                  } /* end of scan loop */
/*if (mltrace[line] == 21) logMsg (" mainloop: end historical scan....\n"); */

if (mltrace[line] == 20) logMsg (" mainloop position 11.0\n");
/* 11 */          /* see if time to go */
                  if (breakout)
                  {
if (mltrace[line] == 21) logMsg (" mainloop: breakout to beginning of Master Loop....\n");
if (mltrace[line] == 20) logMsg (" mainloop position 11.1\n");
                      break; /* resume execution at the top of the master loop */
                  }

if (mltrace[line] == 20) logMsg (" mainloop position 12.0\n");
/* 12 */          /* see if anyone on the line has been responding. */
                  if (!any_responding(line))
                  {
if (mltrace[line] == 20) logMsg (" mainloop position 12.1 *\n");
if (mltrace[line] == 21) logMsg (" mainloop: non responding:  breakout to beginning of Master Loop....\n");
                      respond = FALSE;
                      /* See if it is time to let partner try */
                      this_time = tickGet();
                      if ((this_time - last_time) > (3*SLWWINDOW))  /* this keeps us from thrashing. */
                      {
if (mltrace[line] == 20) logMsg (" mainloop position 12.1.1 *\n");
                          break;                  /* resume execution at the top of the master loop. */
                      }    
                  }
                  else
                  {
if (mltrace[line] == 20) logMsg (" mainloop position 12.2\n");
                      respond = TRUE;
                  }
if (mltrace[line] == 20) logMsg (" mainloop position 13\n");

                  temp_time = SCANPERIOD - (tickGet() - periodic_scan_time);
                  if (next_time > temp_time)
                  {
                      if (mltrace[line] == 21)
                          logMsg ("mainloop: history time remaining (%d:%2d.%1d remaining)....\n",
                                   (temp_time/(60*60)),((temp_time%(60*60))/60), ((temp_time%60)/6));
                      /* print 50% of the way to zero from here. */
                      next_time = temp_time/2 - 30;
                  }
                   
/* 13 */          if (modspolled==0)
                  {
                      /* don't add unnecessary delay */
/*                      if (temp_time > 4) taskDelay((temp_time/10)+4); */
                      if (temp_time > 6)
                      {
                          taskDelay(6);
                      }
                      else
                      {
                          taskDelay(2);
                      }

                  }
                  else
                  {
                      modspolled = 0;
                         taskDelay(2);
                  }
                } /* end of 5 minute wait loop */
	    } /* end of master loop */
	} /* end infinite task loop */
    }


/*                                                        
/* Scan all Demand Scan RTUs whos time has come.          
/*                                             		  
*/                                             	
/* called from MAIN                                     */    	


static void scan_demand (unsigned short line)
{
    MODPLC  *pmod;
    unsigned short mod, command;

    for (mod = 1; (mod <= NUMMODPLCS); mod++ )
    {
        pmod = plcs[line][mod];             /* shorthand pointer                     */
        if ((pmod) &&                       /* verify pointer validity prior to use. */
            (pmod->was_requested))          /* (left to right analysis rules apply)  */
        {
            /* test for demand scan and not downloading SLL. */
            if (!pmod->demandscan)
            {
                continue;                /* skip this RTU. it is not in demand scan mode. */
            }
            else if ((pmod->demandstarttime + demandperiod[line]) < tickGet())
            {
if (mltrace[line] == 21) logMsg (" scan_demand: ending demand scan mode. time's up.\n");
                pmod->demandscan = FALSE;
                continue;       /* skip this RTU. it is not in demand scan mode any more. */
            }
            /* test for time to scan */
            if ((pmod->lastscantime + demandinterval[line]) > tickGet())
            {
                continue;         /* skip this RTU. it is not time yet for a demand scan. */
            }
            /* if user put rtu offline via pseudo command, mark it as not responding. */
            if (pmod->cmd_force_offline)
            { 
                pmod->is_responding = FALSE;
            }
            /* if actually offline, try to bring online before proceding */
            if ((!pmod->is_responding) &&
                (!pmod->cmd_force_offline))
            {
                /* get access to the radio */
                while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/
                    logMsg ("Waiting for Radio Diagnostics: ");
                    printf ("Mutual-Exclusion Semaphore Timeout on Line %d\n",line);
                }
                on_line(line, mod);            /* loopback testing done here! 	*/
                semGive(linemux[line]);
            }
            /* in order to reconnect to a temporarily non-responsive RTU, we will try to go online */
            /* every interval during a demand scan (default 20 seconds). However, to keep from     */
            /* retrying constantly, we must mark the RTU as scanned and therefore not time to be   */
            /* rescanned for another demand interval time. (i'm not keen on this, but it works)    */
            pmod->lastscantime = tickGet();

            /* if its talking, scan it. */
            if (pmod->is_responding)
            {
                /* get access to the radio */
                while ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)
                {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/
                    logMsg ("Waiting for Radio Diagnostics: ");
                    printf( "Mutual-Exclusion Semaphore Timeout.\n");
                }
                scan_rtu(pmod, line, mod);                      /* I/O done here!                  */
                semGive(linemux[line]);
                if (!pmod->is_responding)
                {
                    mark_not_valid(pmod);
                }
            }
        }
        /* end of single module action */
        /* if told to relinquish the master state, stop RTU scanning immediately. */
        /* don't trash the command, so that we can still read it on the next loop */
        /* through this while statement.                                          */
        resGetCommand(prestable[line], &command);
        if (command == RES_RELINQUISH)
        {
            break;
        }
    } /* end of scan loop */
}

/*                                                        
/* Process the currently downloading RTU. we download     
/*  only one RTU at a time.                               
/*                                             		  
*/                                             	
/* called from MAIN                                     */    	


static void check_loading (unsigned short line)
{
    LOADINFO      *plinfo;
    MODPLC        *pmod;
    unsigned short mod;
    unsigned long  thistime;

    plinfo = &linfo[line];	/* establish the pointer */

    thistime = tickGet();
    /* see if it is time to service active and/or pending loads */
    if (thistime > (plinfo->lastloadaction + plinfo->loadinterval))
    {
        plinfo->lastloadaction = thistime;
        while (thistime < (plinfo->lastloadaction + plinfo->loadperiod))
        {

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            thistime = tickGet();
            /* if one in progress, go do a chunk of it. */
            if (plinfo->loading)
            {
                /* NOTE: add logic in loadnextrung to check for forcedoffline and terminte the load */
                loadnextrung(line);
            }
            /* if none in progress, go see if any pending. */
            if (!plinfo->loading)
            {
                for (mod = 1; (mod <= NUMMODPLCS); mod++ )
                {
                    pmod = plcs[line][mod];             /* shorthand pointer                     */
                    if ((pmod) &&                       /* verify pointer validity prior to use, */
                        (pmod->was_requested))          /* data must have been requested.        */
                    {
                        /* if user put rtu offline via pseudo command, mark it as not responding. */
                        if (pmod->cmd_force_offline)
                        { 
                            pmod->is_responding = FALSE;
                        }
                        /* see if it is talking. */
                        if (pmod->is_responding)
                        {
                            /* if load request is pending, start it up */
                            if (pmod->prog_load_stat == PLC_LOAD_REQUESTED)
                            {
                                loadinit(line, pmod, mod);
                            }
                        }
                    }
                }
            }
            /* if nothing loading when here, all loading is completed, or there wasn't any. */
            if (!plinfo->loading)
            {
                return;
            }
            taskDelay(2);       /* give it a rest */
        }
    }
}


/*
/* Try to bring a PLC on line
/*
*/

/* this routine only called from MAIN */


static void on_line (unsigned short line, unsigned short mod)
    {
	MODPLC  *pmod;
	unsigned short i,j;

	pmod = plcs[line][mod];	
	if (pmod)			/* verify pointer prior to use */
	{
		if (mltrace[line] == 1)
		{
			logMsg ( "Bring Online line - %d  mod - %d \n",
				line, mod );
	        }
		/* Use the loop back function to see if the unit is there and responding */

		if (!modloopback(ONERETRY+line, mod, pmod))
			return; /* if no response, get out */

		mark_not_valid(pmod);	/* a PLC that has just been brought online must have    */
                                        /* it's data marked as being not valid.                 */

		pmod->is_responding = TRUE;
                pmod->do_timesync = TRUE;
        }
    }

/*							
/* Mark all plc data elements as not valid     		
/*                                             		
*/                                             	
/* called from on_line and prepresponses      		*/    	


static void mark_not_valid (MODPLC  *pmod)
    {
	unsigned short i,j;

/*
/*      COILS ARE INITIALIZED AS READ WRITE VALUES      
/*              - READ BACK NOT VALID 			
*/

	for (i=0; (i<NUMMODCOILS); i++)
	{
	    pmod->coils[i].data_valid = FALSE;
	}

/*							
/*      DIGITALS ARE INITIALIZED AS NOT VALID		
*/
	for (i=0; (i<NUMMODDIS); i++)
	{
	    pmod->dis[i].data_valid = FALSE;
	}

/*							
/*      ANALOG INS ARE INITIALIZED AS NOT VALID		
*/
	for (i=0; (i<NUMMODAIS); i++)
	{
	    pmod->ais[i].data_valid = FALSE;
	}

/*                                                  		
/*      REGISTERS ARE INITIALIZED AS READ WRITE VALUES		
/*      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS 	
/*              - READ BACK NOT VALID      	               	
*/
	for (i=0; (i<NUMREGISTERS); i++)
	{
	    pmod->regs[i].data_valid = FALSE;
	}
    }
/*                                                           	
/* Scan a ARCOM RTU -  get inputs and set outputs as required   
/*                                                            	
*/
/* this routine only called from MAIN 		*/

static	void scan_rtu (MODPLC *pmod, unsigned short line, unsigned short mod)
    {
	unsigned short  i, j, val, bitaddr, regaddr, readlen, blkix;

	unsigned short  coiladdr;
	unsigned long   coilmask, coilval;
        unsigned short  atleastone;

	unsigned long	tvalue;
        unsigned long   exceptionmask, usedmask;
	LOADINFO	sslinfo;


	checkoutputs(line);

	if (mltrace[line] == 1)
		logMsg ( "Scan  line - %d  mod - %d \n",
				line,mod );

        /* check for sync timeflag: if set, send sync time down */
        if( pmod->do_timesync == TRUE)
        {
            /* convert it to format for Arcom registers */
            if (!(settime(line, mod, pmod)))
            {
                pmod->badoutcnt++;		    
            }
            else
            {
                pmod->do_timesync = FALSE;
            }
        }

        /* read the Polled Report By Exception Coils in the Arcom RTU */
        bitaddr = (((PRBELOWCOIL-1)/BITBLOCK)*BITBLOCK);
        readlen = ((((PRBEHIGHCOIL-1)/BITBLOCK)-((PRBELOWCOIL-1)/BITBLOCK))+1)*BITBLOCK;
        if (!readcoils (line, mod, pmod, bitaddr, readlen))
            return;

        if (prbe[line] == TRUE)
        {
	    /* read the Polled Report By Exception Coils from Memory. Note: */
            /* all values are .data_valid == TRUE (therefore we don't test) */
            blkix = (((PRBELOWCOIL-1)/BITBLOCK));

            if (mltrace[line] == 9)
                logMsg ( "blkix = %d, [0]:0x%x, [1]:0x%x, [2]:0x%x\n",
                         blkix,
                         pmod->coils [blkix+0].last_read,
                         pmod->coils [blkix+1].last_read,
                         pmod->coils [blkix+2].last_read);

            tvalue = (unsigned long) pmod->coils[blkix].last_read;
	    tvalue += (unsigned long) (pmod->coils [blkix+1].last_read) << BITBLOCK;
	    tvalue += (unsigned long) (pmod->coils [blkix+2].last_read) << (BITBLOCK*2);
            tvalue = tvalue >> ((PRBELOWCOIL-1)%BITBLOCK);

            /* combine the forced bits with the exception bits */
            exceptionmask = tvalue  | forcescanmask[line];

            if (mltrace[line] == 9)
                logMsg ( "tvalue = 0x%x, forecescanmask = 0x%x, exceptionmask = 0x%x\n",
                          tvalue, forcescanmask[line], exceptionmask);
        }
        else
        {
            exceptionmask = 0xffffffff; /* turn on all exception bits */
        }

        checkoutputs(line);


        
        usedmask = 0;      /* initially, no bits have been used. */

	/* 'Normal' Coil Outputs: read the coil values to be scanned */
	for (i=((FIRSTCOIL1-1)/BITBLOCK); (i<=((LASTCOIL1-1)/BITBLOCK)); i++)
	{
	    if (pmod->coils[i].was_requested)
	    {
		for (j=1; ((j<MAXDIGBLKSIZE) && ( (i+j)<=((LASTCOIL1-1)/BITBLOCK))); j++)
		{
		    if (!pmod->coils[i+j].was_requested)
		    	break;
		}
		bitaddr = i*BITBLOCK;
		readlen = j*BITBLOCK;
		if (!readcoils (line, mod, pmod, bitaddr, readlen))
			return;
		checkoutputs(line);
		i=(i+j)-1;
	    }
	}

        /* 'SLL' Coil Outputs: if DELTA, read the coil values to be scanned */
        atleastone = 0;
        for (i=((FIRSTSLLCOIL-1)/BITBLOCK); (i<=((LASTSLLCOIL-1)/BITBLOCK)); i++)
        {
            if ((pmod->coils[i].was_requested) &&
                ((exceptionmask & PRBESLLCOILBIT) ||
                 (!pmod->coils[i].data_valid)))
            {
                atleastone++;
                for (j=1; ( (j<MAXDIGBLKSIZE) && ( (i+j)<=((LASTSLLCOIL-1)/BITBLOCK))); j++)
                {
                    if (!pmod->coils[i+j].was_requested)
                         break;
                }
                bitaddr = i*BITBLOCK;
                readlen = j*BITBLOCK;
                if (!readcoils (line, mod, pmod, bitaddr, readlen))
                   return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }
        if (atleastone)
        {
            if (mltrace[line] == 9)
                logMsg ( "clearing coil (505)\n");
            /* set the used mask */
            usedmask = usedmask | PRBESLLCOILBIT;
             /* clear the force first-time scan bit for this group */
            forcescanmask[line] = forcescanmask[line] & ~PRBESLLCOILBIT;
            /* clear the Polled Report By Exception Coil in the Arcom RTU */
            coiladdr = PRBESLLCOIL-1;
            coilmask = 1;
            coilval = 0;
            if (!(setcoil (line, mod, pmod, coiladdr, coilmask, coilval)))
              return;
        }

 	/* 'Normal' Coil Outputs: read the coil values to be scanned */
	for (i=((FIRSTCOIL2-1)/BITBLOCK); (i<=((LASTCOIL2-1)/BITBLOCK)); i++)
	{
	    if (pmod->coils[i].was_requested)
	    {
		for (j=1; ((j<MAXDIGBLKSIZE) && ( (i+j)<=((LASTCOIL2-1)/BITBLOCK))); j++)
		{
		    if (!pmod->coils[i+j].was_requested)
		    	break;
		}
		bitaddr = i*BITBLOCK;
		readlen = j*BITBLOCK;
		if (!readcoils (line, mod, pmod, bitaddr, readlen))
			return;
		checkoutputs(line);
		i=(i+j)-1;
	    }
	}

/* end of coils */

        /* 'Digital' Status Inputs: if DELTA, read the register values to be scanned */
        atleastone = 0;
        for (i=((FIRSTDIGITAL-1)/BITBLOCK); (i<=((LASTDIGITAL-1)/BITBLOCK)); i++)
        {
            if ((pmod->dis[i].was_requested) &&
                ((exceptionmask & PRBEDIGITALBIT) ||
                 (!pmod->dis[i].data_valid)))
            {
                atleastone++;
                for (j=1; ( (j<MAXDIGBLKSIZE) && ( (i+j)<=((LASTDIGITAL-1)/BITBLOCK))); j++)
                {
                    if (!pmod->dis[i+j].was_requested)
                         break;
                }
                bitaddr = i*BITBLOCK;
                readlen = j*BITBLOCK;
                if (!readdis (line, mod, pmod, bitaddr, readlen))
                   return;
                checkoutputs(line);
                i=(i+j)-1;
           }
        }
        if (atleastone)
        {
            if (mltrace[line] == 9)
                logMsg ( "clearing digital (500)\n");
            /* set the used mask */
            usedmask = usedmask | PRBEDIGITALBIT;
            /* clear the force first-time scan bit for this group */
            forcescanmask[line] = forcescanmask[line] & ~PRBEDIGITALBIT;
            /* clear the Polled Report By Exception Coil in the Arcom RTU */
            coiladdr = PRBEDIGITAL-1;
            coilmask = 1;
            coilval = 0;
            if (!(setcoil (line, mod, pmod, coiladdr, coilmask, coilval)))
                  return;
        }

        /* 'Normal' Digital Status Inputs: read the digital values to be scanned */
        for (i=((FIRSTDIGLATCH-1)/BITBLOCK); (i<=((LASTDIGLATCH-1)/BITBLOCK)); i++)
        {
                if (pmod->dis[i].was_requested)
                {
	            for (j=1; ( (j<MAXDIGBLKSIZE) && ((i+j)<=((LASTDIGLATCH-1)/BITBLOCK)) ); j++)
	            {
	                if (!pmod->dis[i+j].was_requested)
	                    break;
	            }
	            bitaddr = i*BITBLOCK;
	            readlen = j*BITBLOCK;
	            if (!readdis (line, mod, pmod, bitaddr, readlen))
                       return;
	            checkoutputs(line);
	            i=(i+j)-1;
                }
        }


/* end of digital inputs */

        /* 'Analog' Inputs: if DELTA, read the register values to be scanned */
        atleastone = 0;
        for (i=((FIRSTANALOGIN-1)/REGBLOCK); (i<=((LASTANALOGIN-1)/REGBLOCK)); i++)
        {
            if ((pmod->ais[i].was_requested) &&
                ((exceptionmask & PRBEANALOGBIT) ||
                 (!pmod->ais[i].data_valid)))
            {
                atleastone++;
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTANALOGIN-1)/REGBLOCK))); j++)
                {
                    if (!pmod->ais[i+j].was_requested)
                        break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readais (line, mod, pmod, regaddr, readlen))
                    return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }
        if (atleastone)
        {
            if (mltrace[line] == 9)
                logMsg ( "clearing analog (502)\n");
            /* set the used mask */
            usedmask = usedmask | PRBEANALOGBIT;
            /* clear the force first-time scan bit for this group */
            forcescanmask[line] = forcescanmask[line] & ~PRBEANALOGBIT;
            /* clear the Polled Report By Exception Coil in the Arcom RTU */
            coiladdr = PRBEANALOG-1;
            coilmask = 1;
            coilval = 0;
            if (!(setcoil (line, mod, pmod, coiladdr, coilmask, coilval)))
                return;
        }

	/* 'Accumulator & Frequency Counter' Inputs: if DELTA, read the register values to be scanned */
        atleastone = 0;
        for (i=((FIRSTACCUM-1)/REGBLOCK); (i<=((LASTFREQUENCY-1)/REGBLOCK)); i++)
        {
            if ((pmod->ais[i].was_requested) &&
                ((exceptionmask & PRBEACCUMBIT) ||
                 (!pmod->ais[i].data_valid)))
            {
                atleastone++;
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTFREQUENCY-1)/REGBLOCK))); j++)
                {
                    if (!pmod->ais[i+j].was_requested)
                        break;
		}
		regaddr = i*REGBLOCK;
		readlen = j*REGBLOCK;
		if (!readais (line, mod, pmod, regaddr, readlen))
		     return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }
        if (atleastone)
        {
            if (mltrace[line] == 9)
                logMsg ( "clearing accum (501)\n");

            /* set the used mask */
            usedmask = usedmask | PRBEACCUMBIT;
            /* clear the force first-time scan bit for this group */
            forcescanmask[line] = forcescanmask[line] & ~PRBEACCUMBIT;
            /* clear the Polled Report By Exception Coil in the Arcom RTU */
            coiladdr = PRBEACCUM-1;
            coilmask = 1;
            coilval = 0;
            if (!(setcoil (line, mod, pmod, coiladdr, coilmask, coilval)))
                return;
        }

	/* 'HART Transmitter STATUS' Inputs: if DELTA, read the register values to be scanned */
        atleastone = 0;
        for (i=((FIRSTHARTSTATUS-1)/REGBLOCK); (i<=((LASTHARTSTATUS-1)/REGBLOCK)); i++)
        {
            if ((pmod->ais[i].was_requested) &&
                ((exceptionmask & PRBEHARTSTATUSBIT) ||
                 (!pmod->ais[i].data_valid)))
            {
                atleastone++;
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTHARTSTATUS-1)/REGBLOCK))); j++)
                {
                    if (!pmod->ais[i+j].was_requested)
                        break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readais (line, mod, pmod, regaddr, readlen))
                     return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }
        if (atleastone)
        {
            if (mltrace[line] == 9)
                logMsg ( "clearing HART status (503)\n");
            /* set the used mask */
            usedmask = usedmask | PRBEHARTSTATUSBIT;
            /* clear the force first-time scan bit for this group */
            forcescanmask[line] = forcescanmask[line] & ~PRBEHARTSTATUSBIT;
            /* clear the Polled Report By Exception Coil in the Arcom RTU */
            coiladdr = PRBEHARTSTATUS-1;
            coilmask = 1;
            coilval = 0;
            if (!(setcoil (line, mod, pmod, coiladdr, coilmask, coilval)))
                  return;
        }

        /* 'Arcom AI' Registers: read the register values to be scanned */
        for (i=((FIRSTAI1-1)/REGBLOCK); (i<=((LASTAI1-1)/REGBLOCK)); i++)
        {
            if (pmod->ais[i].was_requested)
            {
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTAI1-1)/REGBLOCK))); j++)
                {
                    if (!pmod->ais[i+j].was_requested)
                         break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readais (line, mod, pmod, regaddr, readlen))
                     return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }

/* end of ai registers */

	/* 'Analog Output','Clock', and Other Registers: read the register values to be scanned */
        for (i=((FIRSTANALOGOUT-1)/REGBLOCK); (i<=((LASTAO1-1)/REGBLOCK)); i++)
        {
            if (pmod->regs[i].was_requested)
            {
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTAO1-1)/REGBLOCK))); j++)
                {
                    if (!pmod->regs[i+j].was_requested)
                    break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readregs (line, mod, pmod, regaddr, readlen))
                     return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }

	/* 'SLL Holding Register' Outputs: if DELTA, read the register values to be scanned */
        atleastone = 0;
        for (i=((FIRSTSLLHOLD-1)/REGBLOCK); (i<=((LASTSLLHOLD-1)/REGBLOCK)); i++)
        {
            if ((pmod->regs[i].was_requested) &&
                ((exceptionmask & PRBESLLHOLDBIT) ||
                 (!pmod->regs[i].data_valid)))
            {
                atleastone++;
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTSLLHOLD-1)/REGBLOCK))); j++)
                {
                    if (!pmod->regs[i+j].was_requested)
                        break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readregs (line, mod, pmod, regaddr, readlen))
                    return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }
        if (atleastone)
        {
            if (mltrace[line] == 9)
                logMsg ( "clearing SLL Hold (506)\n");
            /* set the used mask */
            usedmask = usedmask | PRBESLLHOLDBIT;
            /* clear the force first-time scan bit for this group */
            forcescanmask[line] = forcescanmask[line] & ~PRBESLLHOLDBIT;
            /* clear the Polled Report By Exception Coil in the Arcom RTU */
            coiladdr = PRBESLLHOLD-1;
            coilmask = 1;
            coilval = 0;
            if (!(setcoil (line, mod, pmod, coiladdr, coilmask, coilval)))
                return;
        }

	/* 'More Analog Output' Registers: read the register values to be scanned */
        for (i=((FIRSTAO2-1)/REGBLOCK); (i<=((LASTHARTFPHR-1)/REGBLOCK)); i++)
        {
            if (pmod->regs[i].was_requested)
            {
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTHARTFPHR-1)/REGBLOCK))); j++)
                {
                    if (!pmod->regs[i+j].was_requested)
                    break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readregs (line, mod, pmod, regaddr, readlen))
                     return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }

	/* 'HART PV1' Outputs: if DELTA, read the register values to be scanned */
        atleastone = 0;
        for (i=((FIRSTHARTFLOAT-1)/REGBLOCK); (i<=((LASTHARTFLOAT-1)/REGBLOCK)); i++)
        {
            if ((pmod->regs[i].was_requested) &&
                ((exceptionmask & PRBEHARTPV1BIT) ||
                 (!pmod->regs[i].data_valid)))
            {
                atleastone++;
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTHARTFLOAT-1)/REGBLOCK))); j++)
                {
                    if (!pmod->regs[i+j].was_requested)
                        break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readregs (line, mod, pmod, regaddr, readlen))
                    return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }
        if (atleastone)
        {
            if (mltrace[line] == 9)
                logMsg ( "clearing HART PV1 (504)\n");
            /* set the used mask */
            usedmask = usedmask | PRBEHARTPV1BIT;
            /* clear the force first-time scan bit for this group */
            forcescanmask[line] = forcescanmask[line] & ~PRBEHARTPV1BIT;
            /* clear the Polled Report By Exception Coil in the Arcom RTU */
            coiladdr = PRBEHARTPV1-1;
            coilmask = 1;
            coilval = 0;
            if (!(setcoil (line, mod, pmod, coiladdr, coilmask, coilval)))
                return;
        }

	/* 'SLL Float' Outputs: if DELTA, read the register values to be scanned */
        atleastone = 0;
        for (i=((FIRSTSLLFLOAT-1)/REGBLOCK); (i<=((LASTSLLFLOAT-1)/REGBLOCK)); i++)
        {
            if ((pmod->regs[i].was_requested) &&
                ((exceptionmask & PRBESLLFLOATBIT) ||
                 (!pmod->regs[i].data_valid)))
            {
                atleastone++;
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTSLLFLOAT-1)/REGBLOCK))); j++)
                {
                    if (!pmod->regs[i+j].was_requested)
                        break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readregs (line, mod, pmod, regaddr, readlen))
                    return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }
        if (atleastone)
        {
            if (mltrace[line] == 9)
                logMsg ( "clearing SLL FLOAT (507)\n");
            /* set the used mask */
            usedmask = usedmask | PRBESLLFLOATBIT;
            /* clear the force first-time scan bit for this group */
            forcescanmask[line] = forcescanmask[line] & ~PRBESLLFLOATBIT;
            /* clear the Polled Report By Exception Coil in the Arcom RTU */
            coiladdr = PRBESLLFLOAT-1;
            coilmask = 1;
            coilval = 0;
            if (!(setcoil (line, mod, pmod, coiladdr, coilmask, coilval)))
                return;
        }

        /* 'General Floating Point' Outputs: read the coil values to be scanned */
        for (i=((FIRSTGENFLOAT-1)/REGBLOCK); (i<=((LASTGENFLOAT-1)/REGBLOCK)); i++)
        {
            if (pmod->regs[i].was_requested)
            {
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTGENFLOAT-1)/REGBLOCK))); j++)
                {
                   if (!pmod->regs[i+j].was_requested)
                   break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readregs (line, mod, pmod, regaddr, readlen))
                    return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }

	/* 'SLL Long' Outputs: if DELTA, read the register values to be scanned */
        atleastone = 0;
        for (i=((FIRSTSLLLONG-1)/REGBLOCK); (i<=((LASTSLLLONG-1)/REGBLOCK)); i++)
        {
            if ((pmod->regs[i].was_requested) &&
                ((exceptionmask & PRBESLLLONGBIT) ||
                 (!pmod->regs[i].data_valid)))
            {
                atleastone++;
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTSLLLONG-1)/REGBLOCK))); j++)
                {
                    if (!pmod->regs[i+j].was_requested)
                        break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readregs (line, mod, pmod, regaddr, readlen))
                    return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }
        if (atleastone)
        {
            if (mltrace[line] == 9)
                logMsg ( "clearing SLL LONG (507)\n");
            /* set the used mask */
            usedmask = usedmask | PRBESLLLONGBIT;
            /* clear the force first-time scan bit for this group */
            forcescanmask[line] = forcescanmask[line] & ~PRBESLLLONGBIT;
            /* clear the Polled Report By Exception Coil in the Arcom RTU */
            coiladdr = PRBESLLLONG-1;
            coilmask = 1;
            coilval = 0;
            if (!(setcoil (line, mod, pmod, coiladdr, coilmask, coilval)))
                return;
        }

        /* 'General Long Integer' Outputs: read the register values to be scanned */
        for (i=((FIRSTGENLONG-1)/REGBLOCK); (i<=((LASTGENLONG-1)/REGBLOCK)); i++)
        {
            if (pmod->regs[i].was_requested)
            {
                for (j=1; ( (j<MAXREGBLKSIZE) && ((i+j)<=((LASTGENLONG-1)/REGBLOCK))); j++)
                {
                    if (!pmod->regs[i+j].was_requested)
                    break;
                }
                regaddr = i*REGBLOCK;
                readlen = j*REGBLOCK;
                if (!readregs (line, mod, pmod, regaddr, readlen))
                    return;
                checkoutputs(line);
                i=(i+j)-1;
            }
        }

        /* finally, re-read the Polled Report By Exception Coils in the Arcom RTU */
        bitaddr = (((PRBELOWCOIL-1)/BITBLOCK)*BITBLOCK);
        readlen = ((((PRBEHIGHCOIL-1)/BITBLOCK)-((PRBELOWCOIL-1)/BITBLOCK))+1)*BITBLOCK;
        if (!readcoils (line, mod, pmod, bitaddr, readlen))
            return;

        if (prbe[line] == TRUE)
        {
	    /* read the Polled Report By Exception Coils from Memory. Note: */
            /* all values are .data_valid == TRUE, therefore we don't test. */
            blkix = (((PRBELOWCOIL-1)/BITBLOCK));

            tvalue = (unsigned long) pmod->coils[blkix].last_read;
	    tvalue += (unsigned long) (pmod->coils [blkix+1].last_read) << BITBLOCK;
	    tvalue += (unsigned long) (pmod->coils [blkix+2].last_read) << (BITBLOCK*2);
            tvalue = tvalue >> ((PRBELOWCOIL-1)%BITBLOCK);

            /* combine the forced bits with the exception bits */
            if (tvalue  & usedmask)
            {
                pmod->moretoscan = TRUE; /* If any of the used RPBE bits are set, do it again */
            }
            else
            {
                pmod->moretoscan = FALSE; /* if none of the used RPBE bits are set, scan no more */
            }
        }
        else
        {
            pmod->moretoscan = TRUE; /* If RPBE is not functional, always get the data */
        }
    }
/*												
/* checkoutputs											
/*      checks output queue and returns if empty.						
/*      if there is something on the queue it attempts to process all                           
/*      pending outputs, doing immediate retries. If attempts fail the request is dropped.      
/*                                                                                              
*/                                                                                              
/* this routine only called from scan_rtu */

static	void checkoutputs (unsigned short line)
    {
	OUTQENT         *optr;
	unsigned short  regaddr, regval, link, adapter, coiladdr, conv;
	unsigned long   coilmask, coilval;
	MODPLC          *pmod;
	double 		dblaovalue;
        unsigned short  stringaddr, stringlen;
	unsigned char	*pstringval;

        if (mltrace[link] == 6)
         logMsg("OUTPUTQUEUE(0): line %d\n", line); 

	while ((optr=ogetnextp(line)) != NULLP)
	{
	    if ((optr->otype)==AOUTTYPE)
	    {
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;
		pmod = plcs[link][adapter];
		if (pmod == NULL)
		{
			if (!allocate_plc(link, adapter))
				return; /* if not allocated, try. if can't allocate, get out. */
        	        pmod = plcs[link][adapter];
		}
		regaddr = optr->out.aonode.aosignal;
		regval = optr->out.aonode.aovalue;
		dblaovalue = optr->out.aonode.dblaovalue;
		conv = optr->out.aonode.conversion;
		if (mltrace[line] == 2) 
			logMsg ( "Analog Output to line %d, address %d, signal  - %d\n",
				link, adapter, regaddr );

		if ((!pmod->cmd_force_offline) && (resresponse[link]))
		{
		    if (!(setreg(link, adapter, pmod, regaddr, regval, dblaovalue, conv )))
		    {
		        pmod->badoutcnt++;		    
		    }
		}
	    }
	    else if ((optr->otype)==BOUTTYPE)
	    {
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;
		pmod = plcs[link][adapter];
		if (pmod == NULL)
		{
			if (!allocate_plc(link, adapter))
				return; /* if not allocated, try. if can't allocate, get out. */
        	        pmod = plcs[link][adapter];
		}
		coiladdr = optr->out.bonode.bosignal;
		coilval = optr->out.bonode.bovalue;
		coilmask = optr->out.bonode.bomask;
		if (mltrace[line] == 2) 
			logMsg ( "Binary Output to line %d, address %d, signal  - %d\n",
				link, adapter, coiladdr );

		if ((!pmod->cmd_force_offline) && (resresponse[link]))
		{
		    if (!(setcoil (link,adapter,pmod,coiladdr,coilmask,coilval)))
		    {
			pmod->badoutcnt++;
		    }
		}
	    }
	    else if ((optr->otype)==SOUTTYPE)
	    {
		link = optr->out.sonode.link;
		adapter = optr->out.sonode.adapter;
/*		card = optr->out.sonode.card; */
		pmod = plcs[link][adapter];
		if (pmod == NULL)
		{
			if (!allocate_plc(link, adapter))
				return; /* if not allocated, try. if can't allocate, get out. */
        	        pmod = plcs[link][adapter];
		}
		stringaddr = optr->out.sonode.sosignal;
		stringlen  = optr->out.sonode.solen;
		pstringval = optr->out.sonode.sovalue;
		if (mltrace[line] == 2)
			logMsg ( "String Output to line %d, address %d,  signal  - %d\n",
				link, adapter, stringaddr );

		if ((!pmod->cmd_force_offline) && (resresponse[link]))
		{
		    if (!(setstring (link, adapter, pmod, stringaddr, pstringval, stringlen)))
		    {
			pmod->badoutcnt++;
		    }
		}
	    }
	    oreleasefull(line);     /* release the output que entry */
	}
    }
/*
/*      AIDRIVER
/*                                                                              	
/*      This routines main purpose is to return the analog input value for the         	
/*      specified module. For a module value                                           	
/*      a (-1) will be returned if there is no valid data ready.                       	
/*                                                                                     	
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname)
    {
	MODPLC  *pmod;
	unsigned short  blkix;
	unsigned short	*pdata;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != MAINS) && (card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmod = plcs[link][adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 2: /* The program Load request */
		*pvalue = pmod->prog_load_stat;
		break;

	    case 3: /* PLC Program Load Block Number */
		*pvalue = pmod->prog_load_page;
		break;

	    case 4: /* Set the program number to Load */
		*pvalue = pmod->prog_load_number;
		break;

	    case 5: /* Output Messages */
		*pvalue = pmod->no_dataout_msgs & 0x7fff;
		break;

	    case 6: /* Input Messages */
		*pvalue = pmod->no_datain_msgs & 0x7fff;
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = pmod->no_rxnoresp & 0x7fff;
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = pmod->no_txnoresp & 0x7fff;
		break;

	    case 9: /* Data Echo Errors */
		*pvalue = pmod->no_dataerr & 0x7fff;
		break;

	    case 10: /* Message Retries */
		*pvalue = pmod->no_retries & 0x7fff;
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = pmod->no_rxhwerrs & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = pmod->no_txhwerrs & 0x7fff;
		break;

	    case 13: /* CRC errors */
		*pvalue = pmod->no_crcerrs & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*pvalue = pmod->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = pmod->badoutcnt & 0x7fff;
		break;

	    case 20: /* What is the program load comp code for the plc? */
		*pvalue = pmod->prog_load_code;
		break;

	    case 23: /*                          */
		*pvalue = pmod->demandscan;
		break;

	    case 24: /*                          */
		*pvalue = pmod->prog_load_interval;
		break;

	    case 25: /*                          */
		*pvalue = pmod->prog_load_window;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
	    }
	    return (0);
	}

	if (card == MAINS)
	{
            if ((signal > MAXAINO) || (signal < MINAINO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d, min=%d\n",
                            pointname, link, adapter, card, signal, MAXAINO, MINAINO);
                return (-1);
            }

            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--; /* Signals are defined as 1 relative */
            blkix = (signal / REGBLOCK);

            /* check for trans-REGBLOCK boundary access */
            if (((conversion == AICNVDOUBLEINT)  ||
                 (conversion == AICNVFLOAT    )) &&
                ((signal % REGBLOCK) == 3      ))
            {
	            if (blkix+1 >= NUMMODAIS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pmod->ais [blkix].was_requested = TRUE;
	            pmod->ais [blkix+1].was_requested = TRUE;
	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if ((!pmod->ais [blkix].data_valid) || (!pmod->ais [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
		    pvalue[1] = pmod->ais [blkix].aivals [3];
		    pvalue[0] = pmod->ais [blkix+1].aivals [0];
                    if (mltrace[link] == 6)
                        logMsg("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* check for trans-REGBLOCK boundary access */
            if ((conversion == AICNVDOUBLEFLT)&
                ((signal % REGBLOCK) != 0      ))
            {
	            if (blkix+1 >= NUMMODAIS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                    /* as soon as the address is confirmed as valid, set requested bits. */
	            pmod->ais [blkix].was_requested = TRUE;
	            pmod->ais [blkix+1].was_requested = TRUE;
	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if ((!pmod->ais [blkix].data_valid) || (!pmod->ais [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
	            }
		    switch (signal % REGBLOCK)
                    {
                        case (1):
                             pvalue[3] = pmod->ais [blkix].aivals [1];
		             pvalue[2] = pmod->ais [blkix].aivals [2];
		             pvalue[1] = pmod->ais [blkix].aivals [3];
		             pvalue[0] = pmod->ais [blkix+1].aivals [0];
                             break;
                        case (2):
                             pvalue[3] = pmod->ais [blkix].aivals [2];
		             pvalue[2] = pmod->ais [blkix].aivals [3];
		             pvalue[1] = pmod->ais [blkix+1].aivals [0];
		             pvalue[0] = pmod->ais [blkix+1].aivals [1];
                             break;
                        case (3):
                             pvalue[3] = pmod->ais [blkix].aivals [3];
		             pvalue[2] = pmod->ais [blkix+1].aivals [0];
		             pvalue[1] = pmod->ais [blkix+1].aivals [1];
		             pvalue[0] = pmod->ais [blkix+1].aivals [2];
                             break;
                        default:
                             return(-1); /* condition can never happen */
                    }
                    if (mltrace[link] == 6)
                        logMsg("AIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* as soon as the address is confirmed as valid, set requested bits. */
	    pmod->ais [blkix].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if (pmod->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-2);
            }
            if (!pmod->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
	    if (!pmod->ais [blkix].data_valid)
            {
               if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Data Not Valid(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
               return (-1);
	    }
	    pdata = ((unsigned short*) &(pmod->ais [blkix].aivals [signal % REGBLOCK]));
	    /* Select the Size and Type of Response based on Conversion */
	    switch (conversion)
	    {
	        case (AICNVDOUBLEINT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVFLOAT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVDOUBLEFLT):
		     pvalue[0] = pdata[3];
		     pvalue[1] = pdata[2];
		     pvalue[2] = pdata[1];
		     pvalue[3] = pdata[0];
		     break;
	        case (AICNVINTEGER):
	        default:
		     *pvalue = *pdata;
		     break;
            }
            if (mltrace[link] == 6)
                logMsg("AIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                        pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
            return(0);
	}


	if (card == MREGS)
	{
            if ((signal > MAXREGNO) || (signal < MINREGNO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }

            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--; /* Signals are defined as 1 relative */
            blkix = (signal / REGBLOCK);

            /* check for trans-REGBLOCK boundary access */
            if (((conversion == AICNVDOUBLEINT)  ||
                 (conversion == AICNVFLOAT    )) &&
                ((signal % REGBLOCK) == 3      ))
            {
	            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pmod->regs [blkix].was_requested = TRUE;
	            pmod->regs [blkix+1].was_requested = TRUE;
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if ((!pmod->regs [blkix].data_valid) || (!pmod->regs [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
		    pvalue[1] = pmod->regs [blkix].ioregs [3];
		    pvalue[0] = pmod->regs [blkix+1].ioregs [0];
                    return(0);
            }
            /* check for trans-REGBLOCK boundary access */
            if ((conversion == AICNVDOUBLEFLT)&
                ((signal % REGBLOCK) != 0      ))
            {
	            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
                    /* as soon as the address is confirmed as valid, set requested bits. */
	            pmod->regs [blkix].was_requested = TRUE;
	            pmod->regs [blkix+1].was_requested = TRUE;
	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if ((!pmod->regs [blkix].data_valid) || (!pmod->regs [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
		    switch (signal % REGBLOCK)
                    {
                        case (1):
                             pvalue[3] = pmod->regs [blkix].ioregs [1];
		             pvalue[2] = pmod->regs [blkix].ioregs [2];
		             pvalue[1] = pmod->regs [blkix].ioregs [3];
		             pvalue[0] = pmod->regs [blkix+1].ioregs [0];
                             break;
                        case (2):
                             pvalue[3] = pmod->regs [blkix].ioregs [2];
		             pvalue[2] = pmod->regs [blkix].ioregs [3];
		             pvalue[1] = pmod->regs [blkix+1].ioregs [0];
		             pvalue[0] = pmod->regs [blkix+1].ioregs [1];
                             break;
                        case (3):
                             pvalue[3] = pmod->regs [blkix].ioregs [3];
		             pvalue[2] = pmod->regs [blkix+1].ioregs [0];
		             pvalue[1] = pmod->regs [blkix+1].ioregs [1];
		             pvalue[0] = pmod->regs [blkix+1].ioregs [2];
                             break;
                        default:
                             return(-1); /* condition can never happen */
                    }
                    if (mltrace[link] == 6)
                        logMsg("AIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* as soon as the address is confirmed as valid, set requested bits. */
	    pmod->regs [blkix].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if (pmod->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-2);
            }
            if (!pmod->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
	    if (!pmod->regs [blkix].data_valid)
            {
               if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Data Not Valid(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
	       return (-1);
	    }
	    pdata = &(pmod->regs [blkix].ioregs [signal % REGBLOCK]);
	    /* Select the Size and Type of Response based on Conversion */
	    switch (conversion)
	    {
	        case (AICNVDOUBLEINT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVFLOAT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVDOUBLEFLT):
		     pvalue[0] = pdata[3];
		     pvalue[1] = pdata[2];
		     pvalue[2] = pdata[1];
		     pvalue[3] = pdata[0];
		     break;
	        case (AICNVINTEGER):
	        default:
		     *pvalue = *pdata;
		     break;
            }
            if (mltrace[link] == 6)
                logMsg("AIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                        pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
            return(0);
	}
	return(-1);
    }

/*  										
/*      AODRIVER                                                                
/*                                                                            	
/*      This routines main purpose is to set requested analog outputs to the  	
/*      specified module.                                                     	
*/                                                                            	
/* this routine not called from within this driver */


int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	    unsigned short signal,double dvalue, unsigned short value,
	    unsigned short conversion, unsigned char *resname)

    {
	MODPLC  *pmod;
	unsigned short  blkix;
	OUTQENT *oqp;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
	if ((card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }


	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmod = plcs[link][adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {

	    case 2: /* Set the program Load request */
		if (value != 0)
		    pmod->prog_load_stat = PLC_LOAD_REQUESTED;
		break;

	    case 4: /* Set the program number to Load */
		pmod->prog_load_number = value;
		break;

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
			initstats(pmod);
		break;

	    case 16: /* Force the PLC online/offline */
		pmod->cmd_force_offline = (value != 0);
                if (value != 0 )
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		break;

	    case 23: /* Demand Scan Start/Stop */
		pmod->demandscan = (value != 0);
                if (pmod->demandscan)
                {
                    pmod->demandstarttime = tickGet();
                }
                break;

	    case 24: /* Program Download Interval */
		pmod->prog_load_interval = value;;
                break;

	    case 25: /* Program Download Window */
		pmod->prog_load_window = value;;
                break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXREGNO) || (signal < MINREGNO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}
	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname,pointname);
	}

	pmod->was_requested = TRUE;

	signal--; /* Signals are defined as 1 relative */
	blkix = (signal / REGBLOCK);

	pmod->regs [blkix].was_requested = TRUE;

        /* check for trans-REGBLOCK boundary access */
        if ((conversion == ASCFLT) && ((signal % REGBLOCK) == 3))
        {
                if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
                {
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg(
                "AODRIVER: Point extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                                pointname, link, adapter, card, signal+1, value);
                    return (-1);
                }

                /* as soon as the address is confirmed as valid, set next block's requested bits. */
	        pmod->regs [blkix+1].was_requested = TRUE;
        }

	if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
            return (-1);
        }

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
            logMsg("AODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal+1, value);
	    pmod->badoutcnt++;
	    return (-1);		/* output que is full */
	}
	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;

	oqp->out.aonode.aovalue = value;

	oqp->out.aonode.dblaovalue = dvalue;
	oqp->out.aonode.conversion = conversion;

	omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 4)
            logMsg("AODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal+1, value);

	return (0);
    }
/*
/*      AOREAD
/*                                                                          	
/*      This routines main purpose is to return the value last read back     	
/*      from the analog output hardware. This is used to initialize analog   	
/*      outputs.                                                             	
*/
/* this routine not called from within this driver */


int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	  unsigned short signal, unsigned short *pvalue,
	  unsigned short conversion, unsigned char *resname)

    {
	MODPLC  *pmod;
	unsigned short  blkix, *pdata;
	
	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
                        return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmod = plcs[link][adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
	    case 2: /* read the most recent program Load request */
		*pvalue = pmod->prog_load_stat;
		break;

	    case 4: /* read the most recent program number to Load */
		*pvalue = pmod->prog_load_number;
		break;

	    case 15: /* read statistics command value */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Read the current PLC offline command status */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 23: /* Demand Scan Status */
		*pvalue = pmod->demandscan;
		break;

	    case 24: /* Program Download Interval */
		*pvalue = pmod->prog_load_interval;
		break;

	    case 25: /* Program Download Window */
		*pvalue = pmod->prog_load_window;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return(-1);
	    }
	    return (0);
	}

	if (card == MREGS)
	{
            if ((signal > MAXREGNO) || (signal < MINREGNO))
	    {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }

            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--; /* Signals are defined as 1 relative */
            blkix = (signal / REGBLOCK);

            /* check for trans-REGBLOCK boundary access */
            if (  (conversion == ASCFLT)  &&
                  ((signal % REGBLOCK) == 3) )
            {
	            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AOREAD: Point extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pmod->regs [blkix].was_requested = TRUE;
	            pmod->regs [blkix+1].was_requested = TRUE;
                    if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                    if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
                    if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if ((!pmod->regs [blkix].data_valid) || (!pmod->regs [blkix+1].data_valid))
                    {
                       if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
		    pvalue[1] = pmod->regs [blkix].ioregs [3];
		    pvalue[0] = pmod->regs [blkix+1].ioregs [0];
                    if (mltrace[link] == 6)
                        logMsg("AOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* as soon as the address is confirmed as valid, set requested bits. */
	    pmod->regs [blkix].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if (pmod->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-2);
            }
            if (!pmod->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
	    if (!pmod->regs [blkix].data_valid)
               {
                   if (trace[link] & CALLREJECTTRACE)
                        logMsg("AOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		   return (-1);
	       }
	    pdata = &(pmod->regs [blkix].ioregs [(signal % REGBLOCK)]);
	    /* Select the Size and Type of Response based on Conversion */
	    switch (conversion)
	    {
	        case (ASCFLT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	       default:
		     *pvalue = *pdata;
		     break;
            }
            if (mltrace[link] == 6)
                logMsg("AOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                        pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
	    return(0);
	}
	return(-1);
    }
/*
/*      BIDRIVER
/*                                                                               	
/*      The main purpose of this routine is to return the request digital input  	
/*      value(s) from the requested card. This routine will return a (-1) if the  	
/*      requested module is the wrong type or the data is not yet valid.          	
/*                                                                                	
*/
/* this routine not called from within this driver */



int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask,unsigned long *pvalue,
		unsigned char *resname)
    {
	MODPLC  *pmod;
	unsigned short blkix;
	unsigned long tvalue;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != MDINS) && (card != MCOILS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmod = plcs[link][adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
		    case 0: /* Were the PLC values requested */
			*pvalue = pmod->was_requested;
			break;

		    case 1: /* Is the PLC responding */
			*pvalue = pmod->is_responding;
			break;

		    case 15: /* reset statistics */
			*pvalue = pmod->cmd_reset_stat;
			break;

		    case 16: /* Force the PLC offline */
			*pvalue = pmod->cmd_force_offline;
			break;


		    case 20: /* What is the selected channel for the line */
			*pvalue = pmod->prog_load_code;
			break;

		    default:
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
			return (-1);
	    }
	    return (0);
	}
						/* mask aligned to 32 bits  */
	tvalue = 0;

	if (card == MDINS)
	{
            if ((signal > MAXDINO) || (signal < MINDINO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--; /* Signals are defined as 1 relative */
            blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */

	    if ( (mask & 0x000000FF) != 0)
	    {
	        pmod->dis [blkix].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->dis [blkix].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue = pmod->dis [blkix].last_read & mask;
	    }
	    if ( (mask & 0x0000FF00) != 0)
	    {
	        pmod->dis [blkix+1].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->dis [blkix+1].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->dis [blkix+1].last_read) << 8;
	    }
	    if ( (mask & 0x00FF0000) != 0)
	    {
	        pmod->dis [blkix+2].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->dis [blkix+2].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->dis [blkix+2].last_read) << 16;
	    }
	    if ( (mask & 0xFF000000) != 0)
	    {
	        pmod->dis [blkix+3].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->dis [blkix+3].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->dis [blkix+3].last_read) << 24;
	    }
	    *pvalue = tvalue & mask;
            if (mltrace[link] == 8)
                logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                        pointname, link, adapter, card, signal+1, pvalue);
	    return (0);
	}

	tvalue = 0;
	if (card == MCOILS)
	{
            if ((signal > MAXCOILNO) || (signal < MINCOILNO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--; /* Signals are defined as 1 relative */
            blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */

	    if ( (mask & 0x000000FF) != 0)
	    {
	        pmod->coils [blkix].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->coils [blkix].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue = pmod->coils [blkix].last_read & mask;
	    }
	    if ( (mask & 0x0000FF00) != 0)
	    {
	        pmod->coils [blkix+1].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->coils [blkix+1].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->coils [blkix+1].last_read) << 8;
	    }
	    if ( (mask & 0x00FF0000) != 0)
	    {
	        pmod->coils [blkix+2].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->coils [blkix+2].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->coils [blkix+2].last_read) << 16;
	    }
	    if ( (mask & 0xFF000000) != 0)
	    {
	        pmod->coils [blkix+3].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->coils [blkix+3].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->coils [blkix+3].last_read) << 24;
	    }
	    *pvalue = tvalue & mask;
            if (mltrace[link] == 8)
                logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                        pointname, link, adapter, card, signal+1, pvalue);
	    return (0);
	}
	return (-1);
    }
/*                                                                                	
/*      BODRIVER
/*                                                                                 	
/*      The main purpose of this routine is to set the request digital output      	
/*      value(s) on the requested card. This routine will return a (-1) if the     	
/*      requested module is the wrong type or not configured yet.                  	
/*                                                                                 	
*/
/* this routine not called from within this driver */


int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long value, unsigned long mask,
		unsigned char *resname)


    {
	MODPLC  *pmod;
	OUTQENT *oqp;
	unsigned short  blkix;

        if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
        if (adapter > NUMMODPLCS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
        if ((card != MCOILS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmod = plcs[link][adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal & 0x1f)
	    {

	    case 2: /* Set the program Load request */
		if (value != 0)
		    pmod->prog_load_stat = PLC_LOAD_REQUESTED;
		break;

	    case 15: /* Reset the accumulated statistics */
		if (value != 0) initstats(pmod);
		break;

	    case 16: /* Force the PLC offline */
		pmod->cmd_force_offline = (value != 0);
                if (value != 0 )
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		break;

	    case 21: /* Start the PLC */
		pmod -> plc_start = (value != 0);
		break;

	    case 22: /* What is the selected channel for the line */
		pmod-> plc_stop = (value != 0);
		break;

	    case 23: /* Demand Scan Start/Stop */
		pmod-> demandscan = (value != 0);
                if (pmod->demandscan)
                {
                    pmod->demandstarttime = tickGet();
                }
                break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXCOILNO) || (signal < MINCOILNO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname,pointname);
	}

        pmod->was_requested = TRUE;

	signal--; /* Signals are defined as 1 relative */
	blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */
						/* masks aligned on 32 bits */

	if ((mask & 0x000000FF) != 0)
	{
	    pmod->coils [blkix].was_requested = TRUE;
	}
	if ((mask & 0x0000FF00) != 0)
	{
	    pmod->coils [blkix+1].was_requested = TRUE;
	}
	if ((mask & 0x00FF0000) != 0)
	{
	    pmod->coils [blkix+2].was_requested = TRUE;
	}
	if ((mask & 0xFF000000) != 0)
	{
	    pmod->coils [blkix+3].was_requested = TRUE;
	}

	if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
            return (-1);
        }

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("BODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
	    pmod->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bovalue = value;

	omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 5)
            logMsg("BODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal+1, value);
	return (0);
    }

/*
/*      BOREAD
/*                                                                           	
/*      This routines main purpose is to return the value last read back      	
/*      from the digital output hardware. This is used to initialize digital  	
/*      outputs. This will return a (-1) if the module is the wrong type or    	
/*      the data is not yet valid                                              	
*/
/* this routine not called from within this driver */


int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)
    {
	MODPLC  *pmod;
	unsigned short  blkix;
	unsigned long	tvalue;

        if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (adapter > NUMMODPLCS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if ((card != MCOILS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmod = plcs[link][adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
	    case 2: /* Set the program Load request */
		*pvalue = 0;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;


	    case 21: /* Start the PLC */
		*pvalue = pmod -> plc_start;
		break;

	    case 22: /* What is the selected channel for the line */
		*pvalue = pmod-> plc_stop;
		break;

	    case 23: /* Demand Scan Status */
		*pvalue = pmod->demandscan;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXCOILNO) || (signal < MINCOILNO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
	    return (-1);
	}

	if (resname != 0)
	{
	     /* under what condition(s) could this ever be false? */
             register_resource(link,pmod,resname,pointname);
	}

        pmod->was_requested = TRUE;

	signal--; /* Signals are defined as 1 relative */
	blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */
						/* masks aligned on 32 bits */
	tvalue = 0;

	if ((mask & 0x000000FF) != 0)
	{
	    pmod->coils [blkix].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
	    if (!pmod->coils [blkix].data_valid)
	    {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
		return (-1);
	    }
	    tvalue = pmod->coils [blkix].last_read & mask;
	}
	if ( (mask & 0x0000FF00) != 0)
	{
	    pmod->coils [blkix+1].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
	    if (!pmod->coils [blkix+1].data_valid)
	    {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
	    }
	    tvalue += (unsigned long) (pmod->coils [blkix+1].last_read) << 8;
	}
	if ( (mask & 0x00FF0000) != 0)
	{
	    pmod->coils [blkix+2].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
	    if (!pmod->coils [blkix+2].data_valid)
	    {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
	    }
	    tvalue += (unsigned long) (pmod->coils [blkix+2].last_read) << 16;
	}
	if ( (mask & 0xFF000000) != 0)
	{
	    pmod->coils [blkix+3].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
	    if (!pmod->coils [blkix+3].data_valid)
	    {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
	    }
	    tvalue += (unsigned long) (pmod->coils [blkix+3].last_read) << 24;
	}
	*pvalue = tvalue & mask;
        if (mltrace[link] == 9)
            logMsg("BOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal+1, pvalue);

	return (0);
    }
/*
/*      SIDRIVER
/*                                                                              	
/*      This routines main purpose is to return the analog input value for the         	
/*      specified module. For a module value                                           	
/*      a (-1) will be returned if there is no valid data ready.                       	
/*                                                                                     	
*/
/* this routine not called from within this driver */

int SIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short len,
		unsigned char *resname)
    {
	MODPLC          *pmod;
	short           oldblkix, blkix, regix;
        unsigned short  reglen;
        int             i;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != MAINS) && (card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmod = plcs[link][adapter];
	}

/********************/
/* no pseudo points */
/*                  */
/*                  */
/*                  */
/*                  */
/********************/

        if (card == MAINS)
	{
            /* ensure string contained entirely within the address space of the allocated region */
            if ((signal > MAXAINO) || (signal < MINAINO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if ((signal+reglen) > MAXAINO)
            {
                if (trace[link] & CONFIGURATIONTRACE)
                  logMsg(
                  "SIDRIVER: String extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                         pointname, link, adapter, card, signal);
                return (-1);
            }
            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--;               /* Signals are defined as 1 relative */
            reglen = (len+1)/2;     /* round up odd length character count string lengths */
            blkix = -1;

            for ( i = 0; i < reglen ; i++)
            {
                oldblkix = blkix;
                blkix = ((signal+i) / REGBLOCK);
                regix = ((signal+i) % REGBLOCK);
                if (oldblkix != blkix)
                {
                    pmod->ais [blkix].was_requested = TRUE;
                    if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                                    return (-1);
                    }
                    if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
                    if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                     pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                    if (!pmod->ais [blkix].data_valid)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                }
                pvalue[i] = pmod->ais [blkix].aivals [regix];
            }
            pvalue[i] = 0; /* null terminate the string */
            return(0);
        }
        if (card == MREGS)
	{
            /* ensure string contained entirely within the address space of the allocated region */
            if ((signal > MAXREGNO) || (signal < MINREGNO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if ((signal+reglen) > MAXREGNO)
            {
                if (trace[link] & CONFIGURATIONTRACE)
                  logMsg(
                  "SIDRIVER: String extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                         pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--;               /* Signals are defined as 1 relative */
            reglen = (len+1)/2;     /* round up odd length character count string lengths */
            blkix = -1;

            for ( i = 0; i < reglen ; i++)
            {
                oldblkix = blkix;
                blkix = ((signal+i) / REGBLOCK);
                regix = ((signal+i) % REGBLOCK);
                if (oldblkix != blkix)
                {
                    if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                                    return (-1);
                    }
                    if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
                    if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                     pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                    if (!pmod->regs [blkix].data_valid)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                            return (-1);
                }
                pvalue[i] = pmod->regs [blkix].ioregs [regix];
            }
            pvalue[i] = 0; /* null terminate the string */
            return(0);
        }
	return(-1);
    }

/*  										
/*      SODRIVER
/*                                                                            	
/*      This routines main purpose is to set requested string outputs to the  	
/*      specified module via the output buffer.                                 
*/                                                                            	
/* this routine not called from within this driver */

int SODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	    unsigned short signal, unsigned char *value, unsigned short len, unsigned char *resname)
    {
	MODPLC  *pmod;
	unsigned short  blkix;
	OUTQENT *oqp;
        unsigned short reglen;
        int            i;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (card != MREGS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmod = plcs[link][adapter];
	}

/********************/
/* no pseudo points */
/*                  */
/*                  */
/*                  */
/*                  */
/********************/

        /* ensure string contained entirely within the address space of the allocated region */
        if ((signal > MAXREGNO) || (signal < MINREGNO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if ((signal+reglen) > MAXREGNO)
        {
            if (trace[link] & CONFIGURATIONTRACE)
              logMsg(
              "SODRIVER: String extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                     pointname, link, adapter, card, signal);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pmod,resname,pointname);
        }

        pmod->was_requested = TRUE;

	signal--;                                       /* Signals are defined as 1 relative */
        reglen = (len+1)/2;            /* round up odd length character count string lengths */
	blkix = (signal / REGBLOCK);

	pmod->regs [blkix].was_requested = TRUE; /* notice we only set one here */

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("SODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
                        return (-1);
        }

        if ((!pmod->is_responding) || (pmod->cmd_force_offline))
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("SODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
            return (-1);
        }

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("SODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
	    pmod->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = SOUTTYPE;
	oqp->out.sonode.link = link;
	oqp->out.sonode.adapter = adapter;
	oqp->out.sonode.card = card;
	oqp->out.sonode.sosignal = signal;
	oqp->out.sonode.solen = len;

	/* Move in the output string (strcpy not used because string content could contain terminators) */
	for (i = 0 ;(i < STRINGMSGLEN) ; i++)
        {
	        oqp->out.sonode.sovalue[i] = value[i];
	}

	omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 4)
            logMsg("SODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%s\n",
                    pointname, link, adapter, card, signal+1, value);
	return (0);
    }
/*
/* register_resource                                                              	
/*                                                                                	
/*	This routine is used to initialize the resource pointers                  	
/*  If this is the first time the resource for this line is being                  	
/*  referenced the pointer to the resource table entry will be set                  	
/*  and the resource name will be saved. If the resource name has                       
/*  already been set, this routine will verify that all other points                 	
/*  for this driver are using the same resource name.
/*                                                                                   	
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
			    BOREAD, SIDRIVER, and SODRIVER.                             
*/                               	

static void  register_resource (unsigned short link, MODPLC *pmod,
                                unsigned char *resname, char *pointname)
    {
	if (resnames[link][0] == 0) /* This is the first reference */
	{
	    if (resGetByName( resname, &prestable[link]) != RES_OK)
	    {
		logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
				resname );
	    }
	    else strcpy(resnames[link], resname);
	}
	else
	{
	    if (strcmp(resnames[link], resname) != 0)
	    {
		logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
				resnames[link],
                                pointname,
				resname );
	    }
	}
    }
/*
/*      Initialize the Queue                                        		
*/                                                                        	
/* not called from within this driver */

static	void outqueinit (unsigned short line)
    {
	oq[line]->ooutix = oq[line]->oinix = 0;
    }


/*                                                                     		
/*  ogetempty - get the next available slot on the output list         		
*/
/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
    {
	if (((oq[line]->oinix + 1) % OUTQSIZE) != oq[line]->ooutix)
	{
	    return (&oq[line]->outque[oq[line]->oinix]);
	}
        if (mltrace[line] == 1)
		logMsg ( "Output Que Full line - %d\n",line);
	return (NULLP);
    }


/*                                                                    		
/* omarkfull                                                          		
/*      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
	{
	    oq[line]->oinix = ((oq[line]->oinix + 1) % OUTQSIZE);
	}


/*                                                                      	
/*  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
    {
	if (oq[line]->ooutix != oq[line]->oinix)
	{
	    return (&oq[line]->outque[oq[line]->ooutix]);
	}
	else return (NULLP);
    }


/*                                                       	               	
/* oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
    {
	if (oq[line]->ooutix == oq[line]->oinix)
		return;
	oq[line]->ooutix = ((oq[line]->ooutix + 1) % OUTQSIZE);
    }
/*                                                          			
/*      link_status                                                           	
/*                                                                            	
/*      The purpose of this routine is to print out the state of each of the  	
/*      analog devices lines and the statistics gathered about them.         	
/*                                                                           	
*/
/* not called from within this driver */

static	void link_status (unsigned short line)
    {
    if (line > MODLINES-1) return;
    }


/*                                                                             	
/*                                                                              
/*	allocate_plc                                                            
/*                                                                              
/*	The purpose of this routine is to allocate the memory for a single      
/*	plc data structure. If not successful, a console error message is  	
/*	printed and an error flag is returned to the caller.                    
/*	If successful, the newly allocated data structures are initialized.     
/*                                                                             	
*/

static int allocate_plc (unsigned short line, unsigned short plc )
   {
	MODPLC    *pmod;

	pmod = (MODPLC *)calloc(1,(sizeof(MODPLC)));
	if (!pmod)
	{
		logMsg ("Unable to allocate memory for MODPLC data structure on line %d, RTU %d\n",
                         line, plc);
		 return(FALSE);
	}

        logMsg ("Allocated memory for MODPLC data structure on line %d, RTU %d\n", line, plc);

        init_plc_tab(line, pmod);	     /*	initialize the data structures. */
	plcs[line][plc] = pmod;
	return(TRUE);
   }



/*                                                                   		
/*      start_rx                                                        	
/*                                                                     	 	
/*      The purpose of this routine is to initialize a line table        	
/*      for receive and to enable the receiver.                           	
/*                                                                        	
*/
/* only called from msgxfer */


static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

    {
	RXLINE                  *rxp;

	rxp=rxlinetab[line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	rxp->rxstate = RXADRST;
        rxp->rxmsglen = rxp->rxmsglenexpected;
    }

/*                                                                           	
/*      stop_rx                                                              	
/*                                                                           	
/*      The purpose of this routine is to initialize a line table            	
/*      for receive and to disable the receiver.                             	
/*                                                                           	
*/
/* only called from msgxfer */


static	void stop_rx (unsigned short line )

    {
	RXLINE                  *rxp;

	rxp=rxlinetab[line];
	rxp->rxstate = RXIGNORE;
    }
/*
/*      NEW rx_int_proc                                                        	
/*                                                                         	
/*      The purpose of this routine is to process a receive character interrupt	
/*      for a given line.                                                     	
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static	void rx_int_proc (unsigned short line )
    {
	unsigned char   rxchar;
	unsigned short  rxstat;
	unsigned short  rx_err_mask;
	RXLINE          *rxp;

	read_rx_hw(line, &rxchar, &rxstat, &rx_err_mask);

	rxp=rxlinetab[line];

	/* Something is sending in data. */
	line_activity[line] = TRUE;

	if (rxp->rxstate==RXIGNORE)
		return;

        /* no matter what the state, errors cause a logical reset of the message processing */
        if ((rxstat & rx_err_mask) != 0)
	{
	    rxp->rxstate=RXADRST;    /* if comm goes bad, assume it was garbage,  */
                                     /* and go wait for the good stuff.           */ 
            rxp->rxix = 0;           /* reset the buffer index/counter            */
            rxp->rxmsglen = rxp->rxmsglenexpected; /* reload decrementing counter.*/
	    return;
	}

	rxp->rxbuf[rxp->rxix++] = rxchar; /* store the character in the buffer and bump the index. */
	rxp->rxmsglen--;                  /* decrement the message length counter. although        */
                                          /* superfluous at the beginning of the fixed length      */
                                          /* messages, it does no harm.                            */
	switch (rxp->rxstate)
	{
	    case RXADRST:    /* Address Field State */
                 /* test for address validity */
                 if (rxchar == rxp->txaddress)
                 {
                        rxp->rxstate = RXFNCST;
                        return;
                 }
                 else
                 {
                        rxp->rxstate=RXADRST;                  /* presume it was a false input.  */
                                                               /* go wait for the real one.      */ 
                        rxp->rxix = 0;                         /* reset the buffer index/counter.*/
                        rxp->rxmsglen = rxp->rxmsglenexpected; /* reload decrementing counter.   */
                        return;
                 }
	    case RXFNCST:    /* Function Field State */
                /* if a NAK response is being returned, convert to fixed length processing */
                if ((rxchar & FNCERRBIT) != 0)
		{
		    rxp->fixedlen = FIXEDRESP;
		    rxp->rxmsglen = NAKMSGLEN;
                    rxp->rxstate = RXDATAST;
                    return;
		}
                if (rxp->fixedlen) /* fixed length, rxmsglen is already setup. just go get the data. */
                {
                    rxp->rxstate = RXDATAST;
                }
                else               /* for variable length, go read the length byte.                  */
                {
                    rxp->rxstate = RXLENST;
                }
		return;
	    case RXLENST:    /* Length Field State */
		rxp->fixedlen = FIXEDRESP;
		rxp->rxmsglen = rxchar+2;       /* Add 2 for crc */
		rxp->rxstate = RXDATAST;
		return;
            case RXDATAST:  /* Data Section State */
	    default:
		if (rxp->rxmsglen == 0)
		{
		    *(rxp->status) = RXGOOD;
		    rxp->rxstate=RXIGNORE;
		    semGive(rxp->semid);
		    return;
		}
	}
	return;
    }
/*
/*      check_line_activity
/*                                                                             	
/*      The purpose of this routine is to process a receive character interrupt	
/*      for a given line.                                                      	
/*                                                                             	
*/
/* only called from MAIN  */


static	int check_line_activity (unsigned short line, unsigned short predelay )

    {
	RXLINE          *rxp;
	long		thistime;
	short		status;

	if (predelay != 0)
		taskDelay(predelay);
	thistime = tickGet();
	if ((thistime-activity_time[line]) < ACTIVITYTIME)
		return (lastactivity[line] || (line_activity[line]));
	lastactivity[line] = status = line_activity[line];
	line_activity[line] = FALSE;
	activity_time[line] = thistime;
	rxp = rxlinetab[line];
	rxp->rxstate = RXIGNORE;

	return (status);
    }
/*                                                                         	
/*      start_tx                                                            	
/*                                                                          	
/*      The purpose of this routine is to initialize a line table           	
/*      for send and to enable the transmitter.                                 
/*                                                                            	
*/
/* only called from msgxfer  */


static	void start_tx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

    {

	TXLINE                  *txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */


	enable_tx_ints(line);

    }

/*
/*      stop_tx                                                                	
/*                                                                             	
/*      The purpose of this routine is to initialize a line table              	
/*      for receive and to disable the receiver.                               	
/*                                                                             	
*/
/* only called from msgxfer  */


static	void stop_tx (unsigned short line )

    {
	TXLINE			*txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txdisable=TRUE;
    }
/*                                                                           	
/*      tx_int_proc                                                           	
/*                                                                            	
/*      The purpose of this routine is to process a transmit character interrupt
/*      for a given line.                                                  	
/*                                                                         	
*/
/* only called from MAIN  */


static	void tx_int_proc (unsigned short line )

    {
	char                    txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

	txp=txlinetab[line];
	if (txp->txdisable)
		return;
	if (txp->txix == txp->txmsglen)
	{
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive(txp->semid);
	    return;
	}
	else
	{
	    txchar = txp->txbuf[txp->txix++];
	    write_tx_hw ( line,txchar,&txstat,&tx_err_mask );
	    if ( (txstat & tx_err_mask) != 0 )
	    {
	 	txp->txdisable=TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive(txp->semid);
	        return;
	    }

	}

	if (txp->txix >= MAXTXMSG)
	{
	    txp->txdisable=TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive(txp->semid);
	    return;
	}

    }

/*                                                                         	
/*      msgxfer                                                              	
/*                                                                           	
/*      The purpose of this routine is to transmit a buffer to the         	
/*      analog devices I/O and to await a response. The transmit and receive	
/*      buffers are in their respective line tables. This routine will retry 	
/*      the message up to a maximum number of times or until a response      	
/*      is received with a proper checksum.                                  	
/*              returns         XFERGOOD if response received                	
/*                              XFERBAD  if no good response is received     	
/*                                                                           	
*/
/* called from modloopback, readcoils, readdis, readais, readregs, setcoil, setreg, */
/*             plc_start, plc_stop, pollfordone, plc_init, plc_getdim, plc_setdim,  */
/*             readmem, writemem, writelogic, and writeascii.                       */


static	unsigned short  msgxfer (unsigned short fline,
                                 unsigned short resplen,
                                 MODPLC *pmod,
                                 unsigned short rxlength)
    {
	unsigned short  retry, txstatus, rxstatus, txlen, rxlen, line, ix, i;
	RXLINE          *rxp;
	TXLINE          *txp;
	unsigned char   csums[2];
        unsigned short  oldrxix;
        unsigned int    tick1, tick2, tick3, tick4;
        unsigned int    delta12, delta23, delta34;
        unsigned int    rxstarttime, rxtimeout;

        tick1 = tick2 = tick3 = tick4 = 0;     /* pre-zero all time keep registers */
        delta12 = delta23 = delta34 = 0;

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

	rxp = rxlinetab[line];
	txp = txlinetab[line];

/* 1 */	for (retry=((fline == line)?0:MAXRETRYS-1); (retry<MAXRETRYS); retry++ )
	{
/* 2 */	    if (intermsgdelay[line] != 0)
	    {
/* 3 */		taskDelay (intermsgdelay[line]);
	    }
/* 2 */	    set_rts(line);

	    if (pretxdelay[line] != 0)
	    {
/* 3 */		taskDelay (pretxdelay[line]);
	    }

/* 2 */	    txstatus = IO_TIMEOUT;
	    rxstatus = IO_TIMEOUT;
	    rxp->fixedlen = resplen;
	    rxp->rxmsglenexpected = rxlength;
	    rxp->txaddress = txp->txbuf[0];       /* rx_int_proc uses info to parse the response */
	    rxp->txfunction = txp->txbuf[1];

	    semTake(semids[line][TXSEM], NO_WAIT);
	    semTake(semids[line][RXSEM], NO_WAIT);

	    txlen = txp->txmsglen;


            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            if (trace[line] & ALLTRAFFICTRACE)
            {
/* 3 */        printf("TX:");
               for (ix = 0; ix < 30 ; ix++) /* 30 is maximum TX message length */
               {
/* 4 */             if (ix < txlen)
                       printf("_%2x", txp->txbuf[ix]);
/*                    else
                       printf("..."); */
               } 
/* 3 */        printf("...\n");
            }

/* 2 */     tick1 = tickGet();
	    start_rx(line, semids[line][RXSEM], &rxstatus);
	    start_tx(line, semids[line][TXSEM], &txstatus); /* this fires off the transmission. */

            if ((semTake(semids[line][TXSEM], TXTIMEOUT)) == ERROR)
		txstatus = IO_TIMEOUT;


            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            tick2 = tickGet();
            delta12 = (tick2-tick1)%10000;

	    stop_tx(line);

	    if (posttxdelay[line] != 0)
	    {
/* 3 */		taskDelay (posttxdelay[line]);
	    }

/* 2 */	    if (halfduplex[line] == TRUE)
                clear_rts(line);

            tick3 = tickGet();
            delta23 = (tick3-tick2)%10000;

            if (txstatus == TXGOOD)
            {

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

/* 3 */         if ((rxp->rxbuf[1] == DIAG_CMD8) &&
                    (rxp->rxbuf[3] == SUBCMD_ROM))
                {
/* 4 */             if (modtrace[line])
                       logMsg("Begin burning program to to Protected ROM/RAM...\n");
                    rxtimeout = ROMTIMEOUT;
                    /* test and send a waiting message every five seconds */
                    while (semTake(semids[line][RXSEM], (int)300) == ERROR)
                    {
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/

/* 5 */                 if ((tickGet() - tick3) >= rxtimeout)
                        {
/* 6 */                     if (modtrace[line])
                               logMsg("RX timeout while burning program to Protected ROM/RAM.\n");
                            rxstatus = IO_TIMEOUT;
                            break;
                        }
/* 5 */                 else
                        {
/* 6 */                     if (mltrace[line] == 4)
                               logMsg("waiting for Protected ROM/RAM program burn completion ...");
                        }
                    }
                }
                /* not special ROM burning code. this is path for normal code. */
                else
                {
/* 4 */             oldrxix = -1;    /* make it pass through timeout loop at least once */
                    while (semTake(semids[line][RXSEM], (int)RXTIMEOUT) == ERROR)
                    {

                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/

/* 5 */                 if (oldrxix == rxp->rxix)
                        {
/* 6 */                     if (modtrace[line])
                            {
/* 7 */                        logMsg("RX: No activity: timeout.\n");
                            }
/* 6 */                            rxstatus = IO_TIMEOUT;
                            break;
                        }
/* 5 */                        else
                        {
/* 6 */                     if (mltrace[line] == 4)
                                logMsg("RX: waiting...\n");
                        }
/* 5 */                 oldrxix = rxp->rxix;
                    }
                }
/* 3 */		stop_rx(line);

                tick4 = tickGet();
                delta34 = (tick4-tick3)%10000;

		rxlen = rxp->rxix;
		if (rxstatus == RXGOOD)
                {

                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

/* 4 */             if (trace[line] & ALLTRAFFICTRACE)
                    {
/* 5 */                printf("RX:");
                       for (ix = 0; ix < 30 ; ix++) /* 30 is maximum RX message length */
                       {
/* 6 */                     if (ix < rxlen)
                                printf("_%2x", rxp->rxbuf[ix]);
/*                            else
                                printf("..."); */
                       } 
/* 5 */                printf("  ");
                       printf(" %3d %3d %3d\n", delta12, delta23, delta34);
                    }
/* 4 */		    if (rxlen < 3)
		    {
/* 5 */                 if (modtrace[line])
                            logMsg("RX: Invalid rxlen... %d\n", rxlen);
		    }
/* 4 */             else
		    {
/* 5 */	                makecrc(&rxp->rxbuf [0], rxlen-2, csums);
		    }
                    /* if the checksum is good... */
/* 4 */		    if ( (csums[0]==rxp->rxbuf[rxp->rxix-2]) &&
			 (csums[1]==rxp->rxbuf[rxp->rxix-1]) )
                    {
/* 5 */                 if ((modtrace[line]) && ((rxp->rxbuf[1] & FNCERRBIT) != 0))
			{
/* 6 */			    switch (rxp->rxbuf[2])
			    {
/* 7 */				case (1):
				    logMsg("RX: Modbus Error Illegal Function \n");
				    break;
				case (2):
				    logMsg("RX: Modbus Error Illegal Data Address \n");
				    break;
				case (3):
				    logMsg("RX: Modbus Error Illegal Data Value \n");
				    break;
				case (4):
				    logMsg("RX: Modbus Error Device Failure \n");
				    break;
				case (5):
				    logMsg("RX: Modbus Error Acknowledgement \n");
				    break;
				case (6):
				    logMsg("RX: Modbus Error Busy/Rejected Message \n");
				    break;
				case (7):
				    logMsg("RX: Modbus Error Negative Ack \n");
				    break;
				default:
				    logMsg("RX: Unknown Modbus Error (%d) \n", rxp->rxbuf[2]);
				    break;
			    }
			}
/* 5 */                 return (XFERGOOD);
		    }
                    /* else the checksum is bad... */
/* 4 */		    else
		    {
/* 5 */                 pmod->no_crcerrs++;
			if (modtrace[line])
				logMsg ("RX: CRC Message Length = %d\n", rxlen);
			if (modtrace[line])
				logMsg ("RX: %x%x%x%x Bad CRC\n",
					rxp->rxbuf[rxp->rxix-2],rxp->rxbuf[rxp->rxix-1],
					csums [0], csums [1]
					);
			for (ix = 0; ix < rxlen; ix++)
			{
			    if (modtrace[line])
			    	logMsg("%x\n", rxp->rxbuf[ix]);
			}
		    }
                }
                /* else RX was not good */
/* 3 */         else
                {

                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

/* 4 */             if (rxstatus == IO_TIMEOUT)
                    {
/* 5 */                 if (modtrace[line])
                        {
/* 4 */                     logMsg ("RX: Receive Timeout... Length: %d\n", rxlen);
                        }
/* 5 */                 if (trace[line] & ALLTRAFFICTRACE)
                        {
/* 6 */                    printf("RX(INCOMPLETE):");
                           for (ix = 0; ix < 30 ; ix++) /* 30 is maximum RX message length */
                           {
/* 7 */                         if (ix < rxlen)
                                    printf("_%2x", rxp->rxbuf[ix]);
/*                                else
                                    printf("..."); */
                           } 
/* 6 */                    printf("   ");
                           printf("%3d %3d %3d\n", delta12, delta23, delta34);
                        }
/* 5 */                 pmod->no_rxnoresp++;
                    }
/* 4 */             else
		    {
/* 5 */                 if (modtrace[line])
		            logMsg ("RX: Receive Error\n");

                        if (modtrace[line])
                            logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
				 rxp->rxbuf[100],
				 rxp->rxbuf[101],
				 rxp->rxix);
                        if (trace[line] & ALLTRAFFICTRACE)
                        {
/* 6 */                    printf("RX(ERROR):");
                           for (ix = 0; ix < 30 ; ix++) /* 30 is maximum RX message length */
                           {
/* 7 */                         if (ix < rxlen)
                                    printf("_%2x", rxp->rxbuf[ix]);
/*                                else
                                    printf("..."); */
                           } 
/* 6 */                    printf("  ");
                           printf("%3d %3d %3d\n", delta12, delta23, delta34);
                        }
/* 5 */                 pmod->no_rxhwerrs++;
		    }
                }
	    } /* end of (TX == GOOD) */

/* 2 */     else
            {
/* 3 */         if (txstatus == IO_TIMEOUT)
                {

                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

/* 4 */             if (modtrace[line])
                    {
                        logMsg ("TX: Transmit Timeout\n");
                    }
                    if (trace[line] & ALLTRAFFICTRACE)
                    {
                        printf("%3d %3d %3d\n", delta12, delta23, delta34);
                    }
	            pmod->no_txnoresp++;
                }
/* 3 */         else
                {
/* 4 */             if (modtrace[line])
			logMsg ("TX: Transmit Error\n");
		    pmod->no_txhwerrs++;
	        }
            }
/* 2 */     if (retry != MAXRETRYS)
                pmod->no_retries++;
	}
/* 1 */	if (modtrace[line])
		logMsg ("Xfer Bad\n");
	return (XFERBAD);

    }
/*
/*      init_plc_tab
/*
/*      The purpose of this routine is to initialize the line tables for the
/*      analog devices I/O
/*
*/
/* only called from allocate_plc  */


static	void init_plc_tab (unsigned short line, MODPLC  *pmod)
    {
	pmod->is_responding = FALSE;
	pmod->holdflag = FALSE;
	pmod->was_requested = FALSE;
	pmod->cmd_force_offline = FALSE;
	pmod->prog_load_stat = PLC_NOT_LOADING;
	pmod->prog_load_number = 0;
	pmod->prog_load_page = 0;
	pmod->plc_start = FALSE;
	pmod->plc_stop = FALSE;

	initplc(pmod);
	initstats(pmod);

	linetimers[line] = gettimer();
	if (linetimers[line] == -1)
	{
		/*  put an error message in here */
	}

	/* Initialize this tasks semaphore*/
	semids[line][0]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
	semids[line][1]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
    }





/*
/* Cold Init a PLC
/*
*/
/* only called from init_line_tabs  */


static void initplc (MODPLC  *pmod)

    {

	unsigned short i,j;

                                                                	
/*                                                              	
/*      COILS ARE INITIALIZED AS READ WRITE VALUES              	
/*      WRITES ARE TREATED BY INDIVIDUAL BITS NOT GROUPS       		
/*              - NOT REQUESTED                                		
/*              - READ BACK NOT VALID                             	
/*              - NO NEW VALUES TO GO                                	
*/

	for (i=0; (i<NUMMODCOILS); i++)
	{
	    pmod->coils[i].was_requested = FALSE;
	    pmod->coils[i].data_valid = FALSE;
	    pmod->coils[i].last_read = 0;
	}

/*                                                                 	
/*      DIGITALS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID		
*/
	for (i=0; (i<NUMMODDIS); i++)
	{
	    pmod->dis[i].was_requested = FALSE;
	    pmod->dis[i].data_valid = FALSE;
	}

/*                                                                 	
/*      ANALOG INS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID    	
*/
	for (i=0; (i<NUMMODAIS); i++)
	{
	    pmod->ais[i].was_requested = FALSE;
	    pmod->ais[i].data_valid = FALSE;
	}

/*                                                             		
/*      REGISTERS ARE INITIALIZED AS READ WRITE VALUES             	
/*      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS      	
/*              - NOT REQUESTED                                    	
/*              - READ BACK NOT VALID                              	
/*              - NO NEW VALUES TO GO                               	
*/                                                                  	
	for (i=0; (i<NUMREGISTERS); i++)
	{
	    pmod->regs[i].was_requested = FALSE;
	    pmod->regs[i].data_valid = FALSE;
	}

    }

/*                                                            		
/*                                                              	
/* initialize the statistics for a modicon PLC                  	
/*                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_line_tabs  */


static	void initstats (MODPLC *pmod)

    {
	pmod->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
	pmod->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
	pmod->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
	pmod->no_txnoresp = 0;      /* 8  Count No Responses 		*/
	pmod->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
	pmod->no_retries = 0;       /* 10 Count Retries 		*/          	
	pmod->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
	pmod->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
	pmod->no_crcerrs = 0;       /* 13 Count CRC Errors 		*/
	pmod->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
	pmod->badoutcnt = 0;	    /* 17 Count failed output commands 	*/
    }
/*                                                                       
/* modloopback                                                            
/*                                                                        
*/                                                                          	
/* only called from on_line */


static	unsigned short modloopback (unsigned short line, unsigned short mod,
			 MODPLC *pmod)

    {
	TXLINE  *txp;
	RXLINE  *rxp;
	long    buildreg;
	unsigned short  i;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[1] =  MODLOOPBACK;
	txp->txbuf[2] =  0;
	txp->txbuf[3] =  0;
	txp->txbuf[4] =  0xA5;
	txp->txbuf[5] =  0x37;

	makecrc(&(txp->txbuf[0]),MODLOOPBACKLEN,&(txp->txbuf[MODLOOPBACKLEN]));

	txp->txmsglen = MODLOOPBACKLEN+MODCRCLEN;


	pmod->no_datain_msgs++;

	/* Send out the message */

	if (msgxfer(line,FIXEDRESP,pmod,MODLOOPBACKRESPLEN) == XFERBAD)
	{
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	return(TRUE);
    }
/*                                                                           	
/*     prepresponses                                                            
/*                                                                             	
/*      The purpose of this routine is to mark the PLCs as on hold and the    	
/*	data as not valid until read again from the PLC                       	
/*                                                                           	
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)

    {
	unsigned short  mod;
	MODPLC  *pmod;

	for (mod = 1; (mod <= NUMMODPLCS); mod++)
	{
            pmod = plcs[line][mod];
	    if (pmod)				/* verify pointer validity prior to use */
	    {
	    	pmod->holdflag = TRUE;
		mark_not_valid(pmod);
            }
	}
    }



/*                                                                  	
/*      any_responding                                               	
/*                                                                   	
/*      The purpose of this routine is to see if any units are       	
/*	responding on this line                                      	
/*                                                                   	
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)

    {
	unsigned short  mod;
	MODPLC  *pmod;

	for (mod = 1; (mod <= NUMMODPLCS); mod++)
	{
	    pmod = plcs[line][mod];
	    if (pmod)			/* verify pointer validity prior to use */
	    {
                /* check cmd_force_offline flag because it is set in an asynchronous task */
                if ((pmod->is_responding) && (!pmod->cmd_force_offline))
			 return(TRUE);
	    }
	}
	return(FALSE);
    }


/*                                                                	
/* Readcoils                                                       	
/*                                                                  	
*/
static	unsigned short readcoils (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned short readlen)

/* only called from scan_rtu */

    {
	TXLINE  *txp;
	RXLINE  *rxp;

	unsigned short  i;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[1] =  MODCOILREAD;
	txp->txbuf[2] =  (bitaddr >> 8);
	txp->txbuf[3] =  (bitaddr & 0xFF);
	txp->txbuf[4] =  (readlen >> 8);
	txp->txbuf[5] =  (readlen & 0xFF);

	makecrc(&(txp->txbuf[0]),MODREADMSGLEN,&(txp->txbuf[MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN+MODCRCLEN;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != mod) ||
	    (rxp->rxbuf[1] != MODCOILREAD) ||
	    (rxp->rxbuf[2] != ((readlen+7)/8)) )
	{
	    pmod->no_dataerr++;
	    return(FALSE);

	}

	/* Store the returned data                      */
	/*  data is aligned by 8 pseudo register        */
	/*  and a multiple of 8 bits long               */

	for ( i=0; (i<rxp->rxbuf[2]); i++ )
	{
	    pmod->coils[(bitaddr/8)+i].last_read = rxp->rxbuf[3+i];
	    pmod->coils[(bitaddr/8)+i].data_valid = TRUE;
	}

	return(TRUE);

    }
/*                                                             	
/* Readdis                                                      	
/*                                                              	
*/
static	unsigned short readdis (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned short readlen)

/* only called from scan_rtu */

    {
	TXLINE  *txp;
	RXLINE  *rxp;

	unsigned short  i;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[1] =  MODDIREAD;
	txp->txbuf[2] =  (bitaddr >> 8);
	txp->txbuf[3] =  (bitaddr & 0xFF);
	txp->txbuf[4] =  (readlen >> 8);
	txp->txbuf[5] =  (readlen & 0xFF);

	makecrc(&(txp->txbuf[0]),MODREADMSGLEN,&(txp->txbuf[MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN+MODCRCLEN;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != mod) ||
	    (rxp->rxbuf[1] != MODDIREAD) ||
	    (rxp->rxbuf[2] != ((readlen+7)/8)))
	{
	    pmod->no_dataerr++;
	    return(FALSE);
	}

	/* Store the returned data                      */
	/*  data is aligned by 8 pseudo register        */
	/*  and a multiple of 8 bits long               */

	for ( i=0; (i<rxp->rxbuf[2]); i++ )
	{
	    pmod->dis[(bitaddr/8)+i].last_read = rxp->rxbuf[3+i];
	    pmod->dis[(bitaddr/8)+i].data_valid = TRUE;
	}

	return(TRUE);

    }
/*                                                               	
/* Readais                                                        	
/*                                                                	
*/
static	unsigned short readais (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short reglen)

/* only called from scan_rtu */

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  buildreg;
	unsigned short  i,j;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[1] =  MODAIREAD;
	txp->txbuf[2] =  (regaddr >> 8);
	txp->txbuf[3] =  (regaddr & 0xFF);
	txp->txbuf[4] =  (reglen >> 8);
	txp->txbuf[5] =  (reglen & 0xFF);

	makecrc(&(txp->txbuf[0]),MODREADMSGLEN,&(txp->txbuf[MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN+MODCRCLEN;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != mod) ||
	    (rxp->rxbuf[1] != MODAIREAD) ||
	    (rxp->rxbuf[2] != (reglen*2)) )
	{
	    pmod->no_dataerr++;
	    return(FALSE);
	}

	/* Store the returned data                      */
	/*  data is aligned by 4 register sets          */
	/*  and a multiple of 4 registers long          */

	for ( i=0; (i<rxp->rxbuf[2]); i+=8 )
	{
	    for (j=0; (j<4); j++)
	    {
		buildreg = rxp->rxbuf[3+i+(j*2)];
		buildreg = (buildreg << 8) + rxp->rxbuf[3+i+(j*2)+1];
		pmod->ais[(regaddr/4)+(i/8)].aivals[j] = buildreg;
	    }
	    pmod->ais[(regaddr/4)+(i/8)].data_valid = TRUE;
	}

	return(TRUE);

    }
/*                                                                      	
/* Readregs                                                                	
/*                                                                            	
*/
static	unsigned short readregs (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short reglen)

/* only called from scan_rtu */

    {

	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  buildreg;
	unsigned short  i,j;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[1] =  MODREGREAD;
	txp->txbuf[2] =  (regaddr >> 8);
	txp->txbuf[3] =  (regaddr & 0xFF);
	txp->txbuf[4] =  (reglen >> 8);
	txp->txbuf[5] =  (reglen & 0xFF);

	makecrc(&(txp->txbuf[0]),MODREADMSGLEN,&(txp->txbuf[MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN+MODCRCLEN;

	/* Send out the message */

	if (msgxfer(line,VARRESP,pmod,0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != mod) ||
	    (rxp->rxbuf[1] != MODREGREAD) ||
	    (rxp->rxbuf[2] != (reglen*2)) )
	{
	    pmod->no_dataerr++;
	    return(FALSE);
	}

	/* Store the returned data                      */
	/*  data is aligned by 4 register sets          */
	/*  and a multiple of 4 registers long          */

	for ( i=0; (i<rxp->rxbuf[2]); i+=8 )
	{
	    for (j=0; (j<4); j++)
	    {
		buildreg = rxp->rxbuf[3+i+(j*2)];
		buildreg = (buildreg << 8) + rxp->rxbuf[3+i+(j*2)+1];
		pmod->regs[(regaddr/4)+(i/8)].ioregs[j] = buildreg;
	    }
	    pmod->regs[(regaddr/4)+(i/8)].data_valid = TRUE;
	}

	return(TRUE);

    }
/*                                                           		
/* Setcoil                                                        	
/*                                                                 	
*/
static	unsigned short setcoil (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned long mask, unsigned long val)

/* only called from checkoutputs */

    {
	TXLINE  *txp;
	RXLINE  *rxp;
	unsigned short  i, ix, lsignal;
	unsigned long lmask, lval, tmask ,tval;


	if (mask == 0)
		return(TRUE);

	tmask = lmask = mask;
	tval = lval = val;
	lsignal = bitaddr;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	 /* adjust the bits to the low order bit */

	while ((tmask & 1) == 0)
	{
	    tval = tval >> 1;          /* adjust the value */
	    tmask = tmask >> 1;         /* adjust the mask */
	}

	/* Is it a single coil output */

	if ((tmask & 2) == 0)
	{
	    /* Format the output message */

	    txp->txbuf[0] =  mod;
	    txp->txbuf[1] =  MODCOILWRITE;
	    txp->txbuf[2] =  (lsignal >> 8);
	    txp->txbuf[3] =  (lsignal & 0xFF);
	    txp->txbuf[4] =  (lval==0)?0:0xFF;  /* 0 => off  0xFF => on */
	    txp->txbuf[5] =  0;

	    makecrc(&(txp->txbuf[0]),MODSETCOILLEN,&(txp->txbuf[MODSETCOILLEN]));

	    txp->txmsglen = MODSETCOILLEN+MODCRCLEN;


	    /* Send out the message */

	    if (msgxfer(line,FIXEDRESP,pmod,MODWRITERESPLEN) == XFERBAD)
	    {
		pmod->no_offlines++;
	        pmod->holdflag = TRUE;
		pmod->is_responding = FALSE;
		return(FALSE);
	    }

	    /* Verify the response - the message is repeated back*/
	    for ( i=0; (i<MODSETCOILLEN); i++)
	    {
		if (txp->txbuf[i] != rxp->rxbuf[i])
		{
		    pmod->no_dataerr++;
		    return (FALSE);
		}
	    }
	    return(TRUE);
	}


	/* Must be a multiple coil output */

	else
	{
	    lmask = tmask;
	    lval = tval;

	    /* count the number of coils to output */
	    for ( i=0,tmask=1; ((tmask & lmask)!=0); i++)
	    	tmask = tmask << 1;

	    /* Format the output message */

	    txp->txbuf[0] =  mod;
	    txp->txbuf[1] =  MODMCOILWRITE;
	    txp->txbuf[2] =  (lsignal >> 8);
	    txp->txbuf[3] =  (lsignal & 0xFF);
	    txp->txbuf[4] =  (i >> 8);          /* number of coils */
	    txp->txbuf[5] =  (i & 0xFF );
	    txp->txbuf[6] =  (((i+7)/8) & 0xFF); /* number of data bytes */
	    txp->txbuf[7] =  (lval & 0xFF );
	    ix = 8;
	    if (i>8)
	    {
		txp->txbuf[ix++] =  ((lval >> 8) & 0xFF );
		if (i>16)
		{
		    txp->txbuf[ix++] =  ((lval >> 16) & 0xFF );
		    if (i>24)
		    {
			txp->txbuf[ix++] =  ((lval >> 24) & 0xFF );
		    }
		}
	    }

	    makecrc(&(txp->txbuf[0]),ix,&(txp->txbuf[ix]));

	    txp->txmsglen = ix+MODCRCLEN;


	    /* Send out the message */

	    if (msgxfer(line,FIXEDRESP,pmod,MODWRITERESPLEN) == XFERBAD)
	    {
		pmod->no_offlines++;
	        pmod->holdflag = TRUE;
		pmod->is_responding = FALSE;
		return(FALSE);
	    }

	    /* Verify the response - first part of the message is repeated back*/
	    for ( i=0; (i<MODMSETCOILRESPLEN); i++)
	    {
		if (txp->txbuf[i] != rxp->rxbuf[i])
		{
		    pmod->no_dataerr++;
		    return (FALSE);
		}
	    }
	    return(TRUE);
	}
    }
/*
/* Setreg                                                       	
/*                                                                  	
*/
static	unsigned short setreg (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short val,double dblval, unsigned short conv)

/* only called from checkoutputs */

    {
	TXLINE 		 *txp;
	RXLINE 		 *rxp;
	unsigned short  i;
   	union 	u_value {
		    short		ivalue;
		    long		lvalue;
		    float		fvalue;
		    double		dvalue;
		    char		afvalue[100];
		}  uval;

	/* Set up pointers for comm buffers */

	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	uval.fvalue = dblval;

	/* Format the output message */

	txp->txbuf[0] =  mod;
	txp->txbuf[2] =  (regaddr >> 8);
	txp->txbuf[3] =  (regaddr & 0xFF);

	if (conv != ASCFLT)
	{
	    txp->txbuf[1] =  MODREGWRITE;
	    txp->txbuf[4] =  (val >> 8);
	    txp->txbuf[5] =  (val & 0xFF);

	    makecrc(&(txp->txbuf[0]),MODSETREGLEN,&(txp->txbuf[MODSETREGLEN]));

	    txp->txmsglen = MODSETREGLEN+MODCRCLEN;

	    /* Send out the message */

	    if (msgxfer(line,FIXEDRESP,pmod, MODWRITERESPLEN) == XFERBAD)
	    {
	        pmod->no_offlines++;
	        pmod->holdflag = TRUE;
	        pmod->is_responding = FALSE;
	        return(FALSE);
	    }

	    /* Verify the response - the message is repeated back*/
	    for ( i=0; (i<MODSETREGLEN); i++)
	    {
		if (txp->txbuf[i] != rxp->rxbuf[i])
		{
		    pmod->no_dataerr++;
		    return (FALSE);
	        }
	    }

	    return(TRUE);
	}
	else
	{ /* Send out float as multiple register write */

	    txp->txbuf[1] =  MODMREGWRITE;
	    txp->txbuf[4] = 0x00;
	    txp->txbuf[5] = 0x02;	/* Number of registers */
	    txp->txbuf[6] = 0x04;	/* Number of bytes */

	    txp->txbuf[7] = (uval.lvalue >> 8) & 0xFF;
	    txp->txbuf[8] =  uval.lvalue & 0xFF;
	    txp->txbuf[9] = (uval.lvalue >> 24) & 0xFF;
	    txp->txbuf[10] = (uval.lvalue >> 16) & 0xFF;


	    makecrc(&(txp->txbuf[0]),MODSET2REGLEN,&(txp->txbuf[MODSET2REGLEN]));

	    txp->txmsglen = MODSET2REGLEN+MODCRCLEN;

	    /* Send out the message */

	    if (msgxfer(line,FIXEDRESP,pmod, MODWRITERESPLEN) == XFERBAD)
	    {
	        pmod->no_offlines++;
	        pmod->holdflag = TRUE;
	        pmod->is_responding = FALSE;
	        return(FALSE);
	    }

	    /* Verify the response - the message is repeated back*/
	    for ( i=0; (i<MODSETMREGRESPLEN); i++)
	    {
		if (txp->txbuf[i] != rxp->rxbuf[i])
		{
		    pmod->no_dataerr++;
		    return (FALSE);
	        }
	    }
	    return(TRUE);
	}
	return(FALSE);
    }
/*
/* Setstring                                                       	
/*                                                                  	
*/
static	unsigned short setstring (unsigned short line, unsigned short mod,
			          MODPLC *pmod, unsigned short signal,
			          unsigned char *buf, unsigned short olen)
/*  if (!(setstring (link, adapter, pmod, stringaddr, pstringval, stringlen))) */
/* only called from checkoutputs */
    {
	TXLINE 		 *txp;
	RXLINE 		 *rxp;
	unsigned short  i, slen, tlen, saveseqno, temp, base;

   	union 	u_value {
		    short		ivalue;
		    long		lvalue;
		    float		fvalue;
		    double		dvalue;
		    char		afvalue[100];
		}  uval;

	/* Set up pointers for comm buffers */
	txp = txlinetab[line & (~ONERETRY)];
	rxp = rxlinetab[line & (~ONERETRY)];

	/* Count number of data request messages */
	pmod->no_dataout_msgs++;

	/* Format the output message */
	txp->txbuf[0] =  mod;
        txp->txbuf[1] =  MODMREGWRITE;
        txp->txbuf[2] =  (signal >> 8);
        txp->txbuf[3] =  (signal & 0xFF);
	/* Store the transmit data                      */
	base = 7;
        i=0;
	slen = olen;
	while  ( i < STRINGMSGLEN )
        {
	    if ((slen != 0) && (i >= slen))
               break;
	    txp->txbuf[base+i] = buf[i];

	    if ((slen == 0) && ((buf[i] == CR) || (buf[i] == 0)))
            {
                i++;
                break;
            }
	    i++;
	}
        if ((i%2) == 1) /* convert all odd length strings to even length strings */
        {
            txp->txbuf[base+i] = buf[i];
            i++;
        }
 	slen = i;
        tlen = base + slen;

	txp->txbuf[4] = ((slen/2) / 256);
	txp->txbuf[5] = ((slen/2) & 0xFF);
        txp->txbuf[6] =   slen;

	makecrc(&(txp->txbuf[0]),tlen,&(txp->txbuf[tlen]));
        txp->txmsglen = tlen+MODCRCLEN;

        /* Send out the message */
        if (msgxfer(line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
        {
                pmod->no_offlines++;
                pmod->holdflag = TRUE;
                pmod->is_responding = FALSE;
	        return (FALSE);
        }

        /* Verify the response - the message is repeated back*/
        for ( i=0; (i<MODSETMREGRESPLEN); i++)
        {
	        if (txp->txbuf[i] != rxp->rxbuf[i])
                {
                    pmod->no_dataerr++;
                    return (FALSE);
                }
        }
        return(TRUE);
    }
/*
/* Settime                                                       	
/*                                                                  	
*/
static	unsigned short settime (unsigned short line, unsigned short mod, MODPLC *pmod)

/* only called from scan_rtu */

{
    TXLINE          *txp;
    RXLINE          *rxp;
    unsigned short  i;
    TS_STAMP        timenow;
    struct tsDetail tsD;
    unsigned long time;


    /* get time */
    tsLocalTime(&timenow);                 /* get seconds since 12:00 am on 1-1-90 */
    time = timenow.secPastEpoch;

    /* if time has been initalized from the workstation, proceed. */
    if (time > 110000)
    {
        if (trace[line] & TIMESYNCTRACE)
            logMsg("settime: L=%d, A=%d\n", line, mod);
	tsStampToLocal (timenow, &tsD);
    }
    else
    {
        if (trace[line] & TIMESYNCTRACE)
            logMsg("settime: time not yet valid. L=%d, A=%d\n", line, mod);
        return(FALSE); /* wait on time sync until IOC time is valid. */
    }

    /* Set up pointers for comm buffers */
    txp = txlinetab[line & (~ONERETRY)];
    rxp = rxlinetab[line & (~ONERETRY)];

/******************************************/
/* Stop the time registers from updating. */
/******************************************/

    /* Count number of data output messages */
    pmod->no_dataout_msgs++;

    /* Format the output message */
    txp->txbuf[0] =  mod;
    txp->txbuf[2] =  ((RTC_HOLDFLAG-1) >> 8);
    txp->txbuf[3] =  ((RTC_HOLDFLAG-1) & 0xFF);

    txp->txbuf[1] =  MODREGWRITE;
    txp->txbuf[4] =  0;          /* non-zero value */
    txp->txbuf[5] =  1;

    makecrc(&(txp->txbuf[0]),MODSETREGLEN,&(txp->txbuf[MODSETREGLEN]));

    txp->txmsglen = MODSETREGLEN+MODCRCLEN;

    /* Send out the Hold RTC update message */

    if (msgxfer(line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return(FALSE);
    }

    /* Verify the response - the message is repeated back*/
    for ( i=0; (i<MODSETREGLEN); i++)
    {
        if (txp->txbuf[i] != rxp->rxbuf[i])
        {
            pmod->no_dataerr++;
            return (FALSE);
        }
    }

/******************************************/
/* Output time to the RTC registers.      */
/******************************************/

    /* Count number of data output messages */
    pmod->no_dataout_msgs++;

    /* Send out time registers as multiple register write */

    txp->txbuf[0] =  mod;
    txp->txbuf[1]  =  MODMREGWRITE;
    txp->txbuf[2] =  ((RTC_START-1) >> 8);
    txp->txbuf[3] =  ((RTC_START-1) & 0xFF);
    txp->txbuf[4]  = 0x00;
    txp->txbuf[5]  = 0x06;	/* Number of registers */
    txp->txbuf[6]  = 0x0c;	/* Number of bytes */

    txp->txbuf[7]  = 0;      /* seconds */
    txp->txbuf[8]  = tsD.seconds;
    txp->txbuf[9]  = 0;      /* minutes */
    txp->txbuf[10] = tsD.minutes;
    txp->txbuf[11] = 0;      /* hours */
    txp->txbuf[12] = tsD.hours; 
    txp->txbuf[13] = 0;      /* day of the month */
    txp->txbuf[14] = tsD.dayMonth + 1;
    txp->txbuf[15] = 0;      /* month of the year */
    txp->txbuf[16] = tsD.monthNum + 1;
    txp->txbuf[17] = 0;      /* years since 1900 */
    txp->txbuf[18] = tsD.year - 1900;

    makecrc(&(txp->txbuf[0]), MODSETTIMELEN, &(txp->txbuf[MODSETTIMELEN]));

    txp->txmsglen = MODSETTIMELEN+MODCRCLEN;

    /* Send out the message */
    if (msgxfer(line,FIXEDRESP,pmod, MODWRITERESPLEN) == XFERBAD)
    {
       pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return(FALSE);
    }

    /* Verify the response - the message is repeated back*/
    for ( i=0; (i<MODSETMREGRESPLEN); i++)
    {
	if (txp->txbuf[i] != rxp->rxbuf[i])
	{
	    pmod->no_dataerr++;
	    return (FALSE);
        }
    }
/******************************************/
/* Latch RTC time registers into the RTC. */
/******************************************/

    /* Count number of data output messages */
    pmod->no_dataout_msgs++;

    /* Format the output message */
    txp->txbuf[0] =  mod;
    txp->txbuf[2] =  ((RTC_SETFLAG-1) >> 8);
    txp->txbuf[3] =  ((RTC_SETFLAG-1) & 0xFF);

    txp->txbuf[1] =  MODREGWRITE;
    txp->txbuf[4] =  0;          /* non-zero value */
    txp->txbuf[5] =  1;
    
    makecrc(&(txp->txbuf[0]),MODSETREGLEN,&(txp->txbuf[MODSETREGLEN]));

    txp->txmsglen = MODSETREGLEN+MODCRCLEN;

    /* Send out the Set RTC update message */

    if (msgxfer(line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        return(FALSE);
    }

    /* Verify the response - the message is repeated back*/
    for ( i=0; (i<MODSETREGLEN); i++)
    {
        if (txp->txbuf[i] != rxp->rxbuf[i])
        {
            pmod->no_dataerr++;
            return (FALSE);
        }
    }

/* it all went well. time has been updated. */
    return(TRUE);
}
/*
/*	loadinit                                		
*/                                                                 	
/* only called from check_loading */

static int loadinit (unsigned short line, MODPLC *pmod, unsigned short mod)
    {
	LOADINFO	*plinfo;
	char		filename[30];
	char		addr[8];
        int 		status;
	long		pos;
	unsigned short	prognum;

	plinfo = &linfo[line];	/* establish the pointer */

	/* This condition should never occur. therefore, should we bother to check it? */
	if (plinfo->loading)
		return(0);

	plinfo->line = line;	/* easy way to find it */
	plinfo->loading = TRUE;
	pmod->loading = TRUE;
	plinfo->pmod = pmod;
	plinfo->mod = mod;
        sll_loading[line] = mod;
	prognum = pmod->prog_load_number;

	/* Make File Name	*/
	strcpy(plinfo->filename,"P");
	addr[0] = 'L';			/* Line Number */
	addr[1] = '0'+(line/10);
	addr[2] = '0' + (line % 10);
	addr[3] = 'A';			/* Address */
	addr[4] = '0'+(mod/10);
	addr[5] = '0' + (mod % 10);
	addr[6]	= '0' + (prognum % 10);
	addr[7] = 0;
	strcat(plinfo->filename,addr);
	strcat(plinfo->filename,".prg");

	/* Open File	*/
	iam(user,password);
	if ((plinfo->loadfile = fopen(&plinfo->filename[0], "r")) == NULL)
	{
	    terminateload(plinfo, line, FALSE, CANNOTOPENFILE);
	    return(-1);
	}

	/* Seek to Beginning of File */
	plinfo->fileaddr = 0;
	if (pos = fseek(plinfo->loadfile, plinfo->fileaddr, 0) !=
		OK)
	{
	    terminateload(plinfo, line, FALSE, CANNOTSEEKTO);
	    return(-1);
	}


        /* now halt the program. */
        if (!halt_rtu(line, pmod, mod))
	{
	    terminateload(plinfo, line, FALSE, CANNOTHALTRTU);
	    return(-1);
	}

	/* Initialize the Load Pointer to the first area */
        plinfo->rung = 0;
	plinfo->ldblock = 0;
	plinfo->ldarea = 0;
        plinfo->pgmoffset = 0;

	/* Set The Load State Variables */
	plinfo->pmod->prog_load_stat = PLC_LOAD_IN_PROGRESS;
	plinfo->pmod->prog_load_page = 0;

        /* send out the first rung */
        loadnextrung(line);

	return(0);
    }

/*
/*	Halt RTU                                         		
*/

/* only called from loadinit */


static int halt_rtu (unsigned short line, MODPLC *pmod, unsigned short mod)
    {
        LOADINFO *plinfo;
	TXLINE  *txp;
	RXLINE  *rxp;

        plinfo = &linfo[line];          /* establish the pointer */

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

	/* Format the output message */

	txp->txbuf[0] =  plinfo->mod;	/* Address                      */
	txp->txbuf[1] =  DIAG_CMD8;	/* Function Code                */
	txp->txbuf[2] =  0;		/* unused byte                  */
	txp->txbuf[3] =  SUBCMD_BRK;	/* Subfunction Code             */
	txp->txbuf[4] =  0;		/* Rung zero Break point        */
	txp->txbuf[5] =  0;		/* Rung zero Break point        */

	makecrc(&(txp->txbuf[0]),6,&(txp->txbuf[6]));

	txp->txmsglen = 8;

	/* Send out the message */

	if (msgxfer(plinfo->line, FIXEDRESP, plinfo->pmod, RTUDIAGCMDRESPLEN) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return(FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf[0] != plinfo->mod) ||
	    ((rxp->rxbuf[1] & 0x7F) != DIAG_CMD8) )
	{
	    plinfo->pmod->no_dataerr++;
	    return(FALSE);
	}

	/* Is it a command done? */
	if ((rxp->rxbuf[1] == DIAG_CMD8) &&
	    (rxp->rxbuf[3] == SUBCMD_BRK))
	{
	    return(TRUE);
	}
	return(FALSE);
    }
/*
/*	Load The Next Rung                               		
*/
/* only called from check_loading and loadinit */

static int loadnextrung (unsigned short line)
    {
        LOADINFO        *plinfo;
        FILE            *handle;
        char            nextchar, buffer[256];
        short           count;
        int             length;

        plinfo = &linfo[line];	/* establish the pointer */
        handle = plinfo->loadfile;

        count = 0;
        nextchar = getc(handle);

        /* eat blank lines */
        while ((nextchar) == '\n')
        {
            nextchar = getc(handle);
        }

        /* put this rung's boolean definition into the buffer */
        while (((nextchar) != '\n') &&
               ((nextchar) != EOF))
        {
            /* put the boolean rung definition line into the buffer in preparation for output */
            buffer[count++] = nextchar;
            if (count == 255)
            {
                terminateload(plinfo, line, FALSE, BOOLEANLINETOOLONG);
                return(-1);
            }
            nextchar = getc(handle);
        }

        /* bump the rung counter. this allows the user to monitor the status of the download. */
        plinfo->rung++;

        /* normal rung handler: process the boolean buffer. */
        if (count != 0)                /* only reason this fails is if line-> LF-> EOF */
        {
            /* the boolean data must be converted to binary format prior to sending the */
            /* rung setup command, as the binary length is specified in that command.   */
            length = bool2binary(buffer, count);
            plinfo->length = length;
            plinfo->pgmoffset += length;
            /* send rung setup (six retries) */
            if (!send_rung(plinfo))
            {
                terminateload(plinfo, line, FALSE, CANNOTSETUPLOADMODE);
                return(-1);
            }

            /* send rung data packet */
            if (!send_rungpacket(plinfo, buffer))
            {
                terminateload(plinfo, line, FALSE, CANNOTSENDRUNGDATA);
                return(-1);
            }
        }

        /* handle the end-of-file termination.  */
        if (nextchar == EOF)
        {
            /* When we reach the end clean up and enable the next load */
            terminateload(plinfo, line, TRUE, LOADOK);
            return(0);
        }
    }
/*
/*	Send Rung                                         		
*/

/* called from loadnextrung */

static int send_rung (LOADINFO *plinfo)
    {
	TXLINE  *txp;
	RXLINE  *rxp;
        unsigned short i;


	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

        for (i = 0; i < 6; i++)
        {
            /* Format the output message */

            txp->txbuf[0] =  plinfo->mod;           /* Address                      */
            txp->txbuf[1] =  DIAG_CMD8;             /* Function Code                */
            txp->txbuf[2] =  0;                     /* unused byte                  */
            txp->txbuf[3] =  SUBCMD_PGM;            /* Subfunction Code             */
            txp->txbuf[4] =  SENDINGPROGRAMLOGIC;   /* type of data to follow       */
            txp->txbuf[5] =  plinfo->length;        /* program logic byte count     */

            makecrc(&(txp->txbuf[0]),6,&(txp->txbuf[6]));

            txp->txmsglen = 8;

            /* Send out the message */

            if (msgxfer(ONERETRY+plinfo->line, FIXEDRESP, plinfo->pmod, RTUDIAGCMDRESPLEN) == XFERBAD)
            {
                if (i == 5)
                {
                    plinfo->pmod->no_offlines++;
                    plinfo->pmod->holdflag = TRUE;
                    plinfo->pmod->is_responding = FALSE;
                    return(FALSE);
                }
            }

            /* Verify the response */
            if ((rxp->rxbuf[0] != plinfo->mod) ||
                ((rxp->rxbuf[1] & 0x7F) != DIAG_CMD8) )
            {
                plinfo->pmod->no_dataerr++;
                if (i == 5)
                {
                    return(FALSE);
                }
            }

            /* Is it a command done? */
            if ((rxp->rxbuf[1] == DIAG_CMD8) &&
                (rxp->rxbuf[3] == SUBCMD_PGM))
            {
                return(TRUE);
            }
        }
        return(FALSE);
   }
/*
/*	Send RungPacket                                         		
*/

/* called from loadnextrung */

static int send_rungpacket (LOADINFO *plinfo, char *buffer)
    {
        TXLINE  *txp;
        RXLINE  *rxp;
        int msglength;

        /* Set up pointers for comm buffers */

        txp = txlinetab[plinfo->line];
        rxp = rxlinetab[plinfo->line];

        /* Format the output message */

        txp->txbuf[0] =  plinfo->mod;           /* Address                      */
        txp->txbuf[1] =  SUBCMD_PGM;            /* Subfunction Code             */
        txp->txbuf[2] =  0;                     /* Halt/Execute flag            */
        txp->txbuf[3] =  plinfo->length;        /* program logic byte count     */
        txp->txbuf[4] =  0;                     /* MSB of program buffer offset */
        txp->txbuf[5] =  0;                     /* LSB of program buffer offset */
        txp->txbuf[6] =  0xff & (plinfo->pgmoffset >> 8);
        txp->txbuf[7] =  0xff & (plinfo->pgmoffset);
        /* transfer the rung packet binary data into the transmit buffer */
        memcpy( &(txp->txbuf[8]), &(buffer[0]), plinfo->length );

        msglength = 6 + plinfo->length;
        makecrc(&(txp->txbuf[0]),msglength,&(txp->txbuf[msglength]));

	txp->txmsglen = msglength+2;

        /* Send out the message. This message will only be sent ONCE from the driver. no retries */

        if (msgxfer(ONERETRY+plinfo->line, FIXEDRESP, plinfo->pmod, RTUDIAGCMDRESPLEN) == XFERBAD)
        {
            plinfo->pmod->no_offlines++;
            plinfo->pmod->holdflag = TRUE;
            plinfo->pmod->is_responding = FALSE;
            return(FALSE);
        }

        /* Verify the response */

        if ((rxp->rxbuf[0] != plinfo->mod) ||
            ((rxp->rxbuf[1] & 0x7F) != SUBCMD_PGM) )
        {
            plinfo->pmod->no_dataerr++;
            return(FALSE);
        }

        /* Is it a command done? */
        if (rxp->rxbuf[1] == SUBCMD_PGM)
        {
            return(TRUE);
        }
        return(FALSE);
    }
/*
/*	End The Load Sequence                                      	
*/
/* called from loadinit and loadnextrung */

static terminateload (LOADINFO *plinfo, unsigned short line,
                      unsigned short success, unsigned short code)
    {
        /* Close The File		*/
        fclose(plinfo->loadfile);

        if (!success)
        {
           /* Set Pmod status back to no loading */
            plinfo->pmod->loading = FALSE;
            plinfo->pmod->prog_load_stat = PLC_LOAD_FAILED;
            plinfo->pmod->prog_load_code = code;

            /* Release for another PLC */
            plinfo->loading = FALSE;
            sll_loading[line] = 0;
            return;
        }

        /* send the program name */
        if (!send_progname (plinfo))
        {
            terminateload(plinfo, line, FALSE, CANNOTSENDNAME);
            return(-1);
        }

        /* send the program name data */
        if (!send_prognamedata (plinfo))
        {
            terminateload(plinfo, line, FALSE, CANNOTSENDNAME);
            return(-1);
        }

        /* start program execution */
        if (!send_progstart(plinfo))
        {
            terminateload(plinfo, line, FALSE, CANNOTSENDSTART);
            return(-1);
        }

        /* force program to protected area */
        if (!send_progsave(plinfo))
        {
            terminateload(plinfo, line, FALSE, CANNOTSENDSAVE);
            return(-1);
        }

        /* Set Pmod status back to no loading */
        plinfo->pmod->loading = FALSE;
        plinfo->pmod->prog_load_stat = PLC_NOT_LOADING;
        plinfo->pmod->prog_load_code = code;

        /* Release for another PLC */
        plinfo->loading = FALSE;
        sll_loading[line] = 0;

        return;
    }

/*
/*	Send Program Name                             		
*/

/* called from terminateload */

static int send_progname (LOADINFO *plinfo)
    {
	TXLINE  *txp;
	RXLINE  *rxp;
        unsigned short i;


	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

        for (i = 0; i < 6; i++)
        {
            /* Format the output message */

            txp->txbuf[0] =  plinfo->mod;           /* Address                      */
            txp->txbuf[1] =  DIAG_CMD8;             /* Function Code                */
            txp->txbuf[2] =  0;                     /* unused byte                  */
            txp->txbuf[3] =  SUBCMD_PGM;            /* Subfunction Code             */
            txp->txbuf[4] =  SENDINGPROGRAMNAME ;   /* program name to follow       */
            txp->txbuf[5] =  PROGNAMELENGTH;        /* program name byte count      */

            makecrc(&(txp->txbuf[0]),6,&(txp->txbuf[6]));

            txp->txmsglen = 8;

            /* Send out the message */

            if (msgxfer(ONERETRY+plinfo->line, FIXEDRESP, plinfo->pmod, RTUDIAGCMDRESPLEN) == XFERBAD)
            {
                if (i == 5)
                {
                    plinfo->pmod->no_offlines++;
                    plinfo->pmod->holdflag = TRUE;
                    plinfo->pmod->is_responding = FALSE;
                    return(FALSE);
                }
            }

            /* Verify the response */
            if ((rxp->rxbuf[0] != plinfo->mod) ||
                ((rxp->rxbuf[1] & 0x7F) != DIAG_CMD8) )
            {
                plinfo->pmod->no_dataerr++;
                if (i == 5)
                {
                    return(FALSE);
                }
            }

            /* Is it a command done? */
            if ((rxp->rxbuf[1] == DIAG_CMD8) &&
                (rxp->rxbuf[3] == SUBCMD_PGM))
            {
                return(TRUE);
            }
        }
        return(FALSE);
   }
/*
/*	Send Program Name Data                            		
*/

/* called from terminateload */
static int send_prognamedata (LOADINFO *plinfo)
    {
        TXLINE  *txp;
        RXLINE  *rxp;
        int msglength;

        /* Set up pointers for comm buffers */

        txp = txlinetab[plinfo->line];
        rxp = rxlinetab[plinfo->line];

        /* Format the output message */

        txp->txbuf[0] =  plinfo->mod;           /* Address                      */
        txp->txbuf[1] =  SUBCMD_PGM;            /* Subfunction Code             */
        txp->txbuf[2] =  0;                     /* Halt/Execute flag            */
        txp->txbuf[3] =  PROGNAMELENGTH;        /* program name byte count      */
        txp->txbuf[4] =  SENDINGPROGRAMNAME;    /*                              */
        txp->txbuf[5] =  PROGNAMELENGTH;        /*                              */
        txp->txbuf[6] =  0xff & (plinfo->pgmoffset >> 8);
        txp->txbuf[7] =  0xff & (plinfo->pgmoffset);

        /* transfer the rung packet binary data into the transmit buffer */
        memcpy( &(txp->txbuf[8]), plinfo->filename, PROGNAMELENGTH );

        msglength = 8 + plinfo->length;
        makecrc(&(txp->txbuf[0]), msglength, &(txp->txbuf[msglength]));

	txp->txmsglen = msglength+2;

        /* Send out the message. This message will only be sent ONCE from the driver. no retries */

        if (msgxfer(ONERETRY+plinfo->line, FIXEDRESP, plinfo->pmod, RTUDIAGCMDRESPLEN) == XFERBAD)
        {
            plinfo->pmod->no_offlines++;
            plinfo->pmod->holdflag = TRUE;
            plinfo->pmod->is_responding = FALSE;
            return(FALSE);
        }

        /* Verify the response */

        if ((rxp->rxbuf[0] != plinfo->mod) ||
            ((rxp->rxbuf[1] & 0x7F) != SUBCMD_PGM))
        {
            plinfo->pmod->no_dataerr++;
            return(FALSE);
        }

        /* Is it a command done? */
        if (rxp->rxbuf[1] == SUBCMD_PGM)
        {
            return(TRUE);
        }
        return(FALSE);
    }

/*
/*	Send Program START                             		
*/

/* called from terminateload */

static int send_progstart (LOADINFO *plinfo)
    {
	TXLINE  *txp;
	RXLINE  *rxp;
        unsigned short i;


	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

        /* only try this once */

        /* Format the output message */

        txp->txbuf[0] =  plinfo->mod;           /* Address                      */
        txp->txbuf[1] =  DIAG_CMD8;             /* Function Code                */
        txp->txbuf[2] =  0;                     /* unused byte                  */
        txp->txbuf[3] =  SUBCMD_RUN;            /* Subfunction Code             */
        txp->txbuf[4] =  0;                     /* always zero                  */
        txp->txbuf[5] =  0;                     /* always zero                  */

        makecrc(&(txp->txbuf[0]), 6, &(txp->txbuf[6]));

        txp->txmsglen = 8;

        /* Send out the message */

        if (msgxfer(ONERETRY+plinfo->line, FIXEDRESP, plinfo->pmod, RTUDIAGCMDRESPLEN) == XFERBAD)
        {
            plinfo->pmod->no_offlines++;
            plinfo->pmod->holdflag = TRUE;
            plinfo->pmod->is_responding = FALSE;
            return(FALSE);
        }

        /* Verify the response */
        if ((rxp->rxbuf[0] != plinfo->mod) ||
            ((rxp->rxbuf[1] & 0x7F) != DIAG_CMD8) )
        {
            plinfo->pmod->no_dataerr++;
                return(FALSE);
        }

        /* Is it a command done? */
        if ((rxp->rxbuf[1] == DIAG_CMD8) &&
            (rxp->rxbuf[3] == SUBCMD_RUN))
        {
            return(TRUE);
        }
        return(FALSE);
   }

/*
/*	Send Program SAVE                             		
*/

/* called from terminateload */

static int send_progsave (LOADINFO *plinfo)
    {
	TXLINE  *txp;
	RXLINE  *rxp;
        unsigned short i;

	/* Set up pointers for comm buffers */

	txp = txlinetab[plinfo->line];
	rxp = rxlinetab[plinfo->line];

        /* only try this once */

        /* Format the output message */

        txp->txbuf[0] =  plinfo->mod;           /* Address                      */
        txp->txbuf[1] =  DIAG_CMD8;             /* Function Code                */
        txp->txbuf[2] =  0;                     /* unused byte                  */
        txp->txbuf[3] =  SUBCMD_ROM;            /* Subfunction Code             */
        txp->txbuf[4] =  0;                     /* always zero                  */
        txp->txbuf[5] =  0;                     /* always zero                  */

        makecrc(&(txp->txbuf[0]), 6, &(txp->txbuf[6]));

        txp->txmsglen = 8;

        /* Send out the message */

        if (msgxfer(ONERETRY+plinfo->line, FIXEDRESP, plinfo->pmod, RTUDIAGCMDRESPLEN) == XFERBAD)
        {
            plinfo->pmod->no_offlines++;
            plinfo->pmod->holdflag = TRUE;
            plinfo->pmod->is_responding = FALSE;
            return(FALSE);
        }

        /* Verify the response */
        if ((rxp->rxbuf[0] != plinfo->mod) ||
            ((rxp->rxbuf[1] & 0x7F) != DIAG_CMD8) )
        {
            plinfo->pmod->no_dataerr++;
                return(FALSE);
        }

        /* Is it a command done successfuly? */
        if (rxp->rxbuf[2] == 0)
        {
            return(TRUE);
        }
        return(FALSE);
   }

/***************************************************************************
FUNCTION: bool2binary (*linebuffer, count)                                  
DESCRIPT: This function converts an ASCII string containing one rung's      
          equation to its binary single byte tokens and binary              
          double byte words for addresses and functions.  It then           
          saves the binary image into the original buffer except            
          ofset a few bytes leaving room for header information controlled  
          by the calling function.  By the way the program is saved         
          in reverse order just like in the RTU.                            
INPUTS:   char *line;    ASCII string coming from a single line from        
                         BOOLEAN.OUT file.                                  
          int shift_pos; starting byte position to place the binary image.  
RETURNS:  number of bytes in binary image or -1 if incomplete rung          
HISTORY:  03/16/92 Creation date.                                           
***************************************************************************/

static int bool2binary (char *linebuffer, short count)
{
    int k, m, rung, i, ch, decode;
    int x1,x2,x3,x4,x5;
    char Logic[ 256 ];
    int lincnt;
    int save_2_lgc;
    signed char *lgcptr;

    lgcptr = Logic;                     /* point to beginning of binary buffer */
    lgcptr += sizeof(Logic);            /* point one byte past binary buffer   */

    lincnt=0;                           /* prepare to count number of bytes in string     */
    do
    {                                   /* make certain we have an END_RUNG or END_CIRCUIT.        */
        ch = linebuffer[ lincnt ++ ];   /* scan chars in string, including END_RUNG and ENDLADDER. */
    }
    while( (ch != 'E') && (ch !='Z') &&
           (lincnt < count) );  /* wait for ENDRUNG, ENDLADDER*/

    if( lincnt == count)
        return( -1 );                   /* error Could not find END RUNG, END LADDER */

                                        /** prepare to parse the boolean string */
    for( i=0; i < lincnt; i++)
    {
        save_2_lgc = 1;                 /* assume that data goes into program buffer*/
        switch(linebuffer[ i ])
        {
            case 'C':                   /* constant expression follows          */
                decode = CONSTANT_C;
                * (--lgcptr) = decode;  /* only save a byte of data */
                save_2_lgc = 2;         /* save two bytes of a constant */
                i ++;
                                        /* just fall thru to atoi       */
            case '0':
            case '1':
            case '2':
            case '3':
            case '4':
            case '5':
            case '6':
            case '7':
            case '8':
            case '9':
        	m = 1;                  /* this keeps the sign of the value     */
          	for(k=0,decode=0; ( (linebuffer[ i + k ] <= '9')
                                 && (linebuffer[ i + k ] >= '0') )
                                 || (linebuffer[ i + k ] == ' ')
                                 || (linebuffer[ i + k ] == '-'); k++)
                {
           	    if( linebuffer[ i + k ] == ' ')
                    {
                        break;
              	    }
          	    if( linebuffer[ i + k ] == '-')
                    {
                        m = - 1;
                        continue;
              	    }
                    decode = decode * 10 + linebuffer [ i + k ] - '0';
                }
        	decode *= m;
        	i += k - 1;
        	break;

            case ' ':                   /* WHITE SPACE */
                save_2_lgc = 0;         /* don't save */
                break;

            case '|':                   /* OR expression                        */
                decode = OR_C;
                break;

            case '&':                   /* AND expression       */
                decode = AND_C;
                break;

            case '=':                   /* OUTPUT RESULT OF LOGIC               */
                decode = OUTPUT_C;
                break;

            case '#':                   /* invert this guy or expression        */
                decode = INVERT_C;
                break;

            case 'E':                   /* END of rung              */
                save_2_lgc = 0;         /* don't save this token */
                break;

            case '+':                   /* ADD two sixteen bit values           */
                decode = ADD_C;
                break;

            case '-':                   /* SUBTRACT two sixteen bit values      */
                decode = SUBTRACT_C;
                break;

            case '*':                   /* MULTIPLY two sixteen bit value       */
                decode = MULTIPLY_C;
                break;

            case '/':                   /* DIVIDE two sixteen bit values        */
                decode = DIVIDE_C;
        	break;

            case '>':                   /* IS result GREATER than this value    */
                decode = GREATER_C;
                break;

            case '<':                   /* IS result LESS than this value       */
                decode = LESS_C;
                break;

            case '?':                   /* IS result EQUAL to this value        */
                decode = EQUAL_C;
                break;

            case 'S':                   /* SKIP RUNGS                           */
                decode = SKIP_RUNGS;
                break;

            case 'R':                   /* ROOT (square root) of integer        */
                decode = ROOT_C;
                break;

            case 'Z':                   /* end of logic circuit     */
                decode = END_CIRCUIT;
                break;

            default:
                save_2_lgc = 0;        /* don't save into program buffer */
        } 

        if( save_2_lgc )
        {
            if( (decode < 0 ) && (save_2_lgc == 1 ) )
            {
                /* we just decoded a token, so only save a byte */
                * (--lgcptr) = decode;
            }
            else
            {
                /* variable/function address, so save two bytes */
                *(--lgcptr) = 0x0ff & (decode >> 8); /* store MSB then LSB */
                *(--lgcptr) = 0x0ff & decode;
            }
        }
    }

    /* actual program size in bytes */
    rung = (sizeof(Logic) - ((int)lgcptr - (int)Logic));

    /* put binary image into original buffer, with no offset. */
    memcpy( &linebuffer[0], lgcptr, rung );
    return( rung );
}

/*
/* makecrc 									
/*                                                                        	
*/
/* called from msgxfer, modloopback, readcoils, readdis, readais, readregs, setcoil, setreg,  */
/*             plc_logout, plc_login, plc_start, plc_stop, pollfordone, plc_init, plc_getdim, */
/*             plc_setdim, readmem, writemem, writelogic, and writeascii */

static	void makecrc (unsigned char *chkbuf, int len,char unsigned *retbuf)

    {
	unsigned short checksum;
	unsigned int     i, j;
	unsigned short   flag;
	unsigned char   tempch;

	checksum = 0x0ffff;
	for (j = 0; j < len; j++)
	{
	    tempch = chkbuf [j];
	    checksum ^= tempch;
	    for (i = 0; i < 8; i++)
	    {
		flag = checksum & 1;
		checksum >>= 1;
		if (flag)
		{
		    checksum ^= (unsigned short) 0x0a001;
		}
	    }
	}
	retbuf[1] = ((checksum >> 8) & 0xff);
	retbuf[0] = (checksum & 0xff);
}/*                                                                        	
/*      hexascii                                                            	
/*                                                                          	
/*      The purpose of this routine is to convert the hex byte to 2 ascii   	
/*      characters and to place them into the buffer.                       	
/*                                                                          	
*/
/* not called from within this driver */


static	void hexascii (unsigned short val,char *buf)

    {
	char    hi,lo;

	hi = ((val & 0x0f0) >> 4);
	lo = (val & 0x0f);

	if (hi<=9)
		hi+='0';
	else
		hi+=('A'-10);
	if (lo<=9)
		lo+='0';
	else
		lo+=('A'-10);

	buf[0] = hi;
	buf[1] = lo;

    }

/*                                                                         	
/*      asciihex                                                    	   	
/*                                                                         	
/*      The purpose of this routine is to convert the next 2 ascii         	
/*      characters in the buffer to hex and return them in val. It         	
/*      will return TRUE if good conversion of FALSE if bad.               	
*/                                                                         	
/* not called from within this driver */


static	short asciihex (unsigned short *val,char *buf)

    {
	if ((buf[0] < '0') || (buf[0] > 'F')) return (FALSE);
	if ( buf[0] <= '9') *val = ((buf[0] & 0x0f) << 4);
	else
	{
	    if (buf[0] < 'A') return (FALSE);
	    else *val = ((buf[0] - 'A' + 10) << 4);
	}
	if ((buf[1] < '0') || (buf[1] > 'F')) return (FALSE);
	if ( buf[1] <= '9') *val += (buf[1] & 0x0f);
	else
	{
	    if (buf[1] < 'A') return (FALSE);
	    else *val += (buf[1] - 'A' + 10);
	}
	return (TRUE);
    }

/*                                                                          	
/*      dump_mod_table                                                       	
/*                                                                           	
/*      The purpose of this routine is to dump the module description        	
/*      portion of the analog devices driver tables for the selected line.   	
/*      It will print out two lines for each module which is responding.     	
/*      The first line will give the general module header, the second line 	
/*      will give module type specific info.                                	
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)

    {
	MODPLC  *pmod;
	short           ix;
	unsigned	short	i, n, j; 

	MODCOILS	*coilptr;
	MODDIS		*diptr;
	REGISTERS	*regptr;
	MODAIS		*aiptr;
	unsigned	short   req, val, value, addr, firstaiinblk, firstreginblk, linecnt;
	unsigned	long	bigvalue;
	unsigned	char	buffer[200];


	pmod = plcs[line][maddr];
	if (!pmod)
	{
	    logMsg("Line/ModbusAddress Not Defined \n");
	    return;
	}

	printf (" Was requested = %d \n", pmod->was_requested);
	printf (" Is responding = %d \n", pmod->is_responding);
	printf (" Prog Load State = %d \n", pmod->prog_load_stat);
	printf (" Prog Load Page = %d \n",  pmod->prog_load_page);
	printf (" Prog Number = %d \n", pmod->prog_load_number);
	printf (" # Output messages = %d \n", pmod->no_dataout_msgs & 0x7fff);
	printf (" # Data in messages = %d \n", pmod->no_datain_msgs & 0x7fff);
	printf (" #No Rx Response = %d \n", pmod->no_rxnoresp & 0x7fff);
	printf (" #No Tx Responses = %d \n", pmod->no_txnoresp & 0x7fff);
	printf (" #Data Errors = %d \n", pmod->no_dataerr & 0x7fff);
	printf (" #Retries = %d \n", pmod->no_retries & 0x7fff);
	printf (" #Rx Hw Errors = %d \n", pmod->no_rxhwerrs & 0x7fff);
	printf (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs & 0x7fff);
	printf (" #Crc Errors = %d \n", pmod->no_crcerrs & 0x7fff);
	printf (" #Off Lines = %d \n", pmod->no_offlines & 0x7fff);
	printf (" Reset Statistics = %d \n", pmod->cmd_reset_stat);
	printf (" Force Offline = %d \n", pmod->cmd_force_offline);
	printf (" #Failed Outputs = %d \n", pmod->badoutcnt & 0x7fff);


	printf (" Resource Responding = %d \n", resresponse[line]);
	printf (" Module Is Responding = %d \n", pmod->is_responding );
	printf (" Hold flag  = %d \n", pmod->holdflag );


	linecnt = 1;
	printcoilhdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < (MAXCOILNO / 8); i += 4)
	{
		printf("  %4d    ", addr);
		for (n = 0; n < 4; n++)
		{		
		        coilptr = &pmod->coils[i+n];
			printf("%1x,  %1x,         %lx,\t",
                                      coilptr->was_requested,
                                      coilptr->data_valid,
                                      coilptr->last_read);
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + 4)  < (MAXCOILNO/8)) )
		{
			linecnt = 1;
			printcoilhdr(buffer, linecnt);
		}
		addr += 32;		
	}

	linecnt = 1;
	printdihdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < (MAXDINO / 8); i += 4)
	{
		printf("  %4d    ", addr);
		for (n = 0; n < 4; n++)
		{		
 			diptr = &pmod->dis[i+n];
			printf("%1x,  %1x,         %lx,\t",
                               diptr->was_requested,
                               diptr->data_valid,
                               diptr->last_read);
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + 4)  < (MAXDINO/8)) )
		{
			linecnt = 1;
			printdihdr(buffer, linecnt);
		}
		addr += 32;		
	}


	linecnt = 1;
	printaihdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < MAXAINO; i += 8)
	{

		printf("  %4d\t", addr);
				   
		for (n = 0; n < 2; n++ )
		{		
		    aiptr = &pmod->ais[(i/4)+n];
		    printf("\t%1x, %1x,\t", aiptr->was_requested, aiptr->data_valid);
		    for (j = 0; j < 4; j++)
		    {
			printf("%6d,\t",  aiptr->aivals[j]);
		    }
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + 8)  < MAXAINO) )
		{
			linecnt = 1;
			printaihdr(buffer, linecnt);
		}
		addr += 8;		
	}

	linecnt = 1;
	printreghdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < MAXREGNO; i += 8)
	{
		printf("  %4d\t", addr);

		for (n = 0; n < 2; n++)
		{		
		    regptr = &pmod->regs[(i/4)+n];
		    printf("\t%1x, %1x,\t", regptr->was_requested, regptr->data_valid);
		    for (j = 0; j < 4; j++)
		    {
			printf("%6d,\t",regptr->ioregs[j]);
		    }
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + 8)  < MAXREGNO) )
		{
			linecnt = 1;
			printreghdr(buffer, linecnt);
		}
		addr += 8;		
	}
    }

/*
/* only called from dump_mod_table 
*/


static void printcoilhdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay(60);
	printf("\n");
	sprintf(buffer,"                                                    RTU REPORT         ");
	printf( "%s\n", buffer);
	cnt += 1;
	printf("\n");
	cnt += 1;
        sprintf(buffer,"                                                   ARCOM COILS        ");
	printf( "%s\n", buffer);
	cnt += 1;
        sprintf(buffer,
               "          R   V      Value\tR   V      Value\tR   V      Value\tR   V      Value");
 	printf( "%s\n", buffer);
 	cnt += 1;
}
/*
/* only called from dump_mod_table
*/


static void printdihdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay(60);
	printf("\n");
	sprintf(buffer,"                                                    RTU REPORT         ");
	printf( "%s\n", buffer);
	cnt += 1;
	printf("\n");
	cnt += 1;
        sprintf(buffer,"                                              ARCOM DIGITAL INPUTS        ");
	printf( "%s\n", buffer);
	cnt += 1;
        sprintf(buffer,
                "          R   V      Value\tR   V      Value\tR   V      Value\tR   V      Value");
	printf( "%s\n", buffer);
 	cnt += 1;
}
/*
/* only called from dump_mod_table
*/


static void printaihdr(unsigned char *buffer, unsigned short cnt)
{
	taskDelay(60);
	printf("\n");
	sprintf(buffer,"                                               RTU REPORT         ");
	printf( "%s\n", buffer);
	cnt += 1;
	printf("\n");
	cnt += 1;
       sprintf(buffer,"                                            ARCOM ANALOG INPUTS        ");
	printf( "%s\n", buffer);
	cnt += 1;
       sprintf(buffer,"\t\tR  V\tValue\tValue\tValue\tValue\t\tR  V\tValue\tValue\tValue\tValue");
 	printf( "%s\n", buffer);
	cnt += 1;
}

/*
/* only called from dump_mod_table
*/


static void printreghdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay(60);
	printf("\n");
	sprintf(buffer,"                                               RTU REPORT         ");
	printf( "%s\n", buffer);
	cnt += 1;
	printf("\n");
	cnt += 1;
       sprintf(buffer,"                                             ARCOM REGISTERS        ");
	printf( "%s\n", buffer);
	cnt += 1;
       sprintf(buffer,"\t\tR  V\tValue\tValue\tValue\tValue\t\tR  V\tValue\tValue\tValue\tValue");
 	printf( "%s\n", buffer);
 	cnt += 1;

}
/*                                                               		
**                                                                	 	
**	The purpose of this routine is to display the contents            	
**	of the static variables contained within this driver.             	
**                                                                        	
*/

/* this routine not called from within this driver */


LINEINFO ()
{
	short	i;
	char	buffer[132];
	char	*resrsp;
	char	*lineact;


        printf("                                 Arcom Line Information Table           \n");
        printf("\n");
        printf(" Line        Pointer to        Resource      Resource");
        printf ("       Line        Delay Times:       Activity\n");
        printf("Number      MODPLC Table         Name        Response");
        printf ("     Activity      IM  .TX  TX.         Time\n");
	printf("\n");

	for (i=0; i < MODLINES; i++)
	{
		if(plcs[i] == NULL)
		{
			continue;
		}
		if (resresponse[i] == 0)
		{
			resrsp = "FALSE";
		}
		else
		{
			resrsp = "TRUE";
		}
		if (line_activity[i] == 0)
		{
			lineact = "FALSE";
		}
		else
		{
			lineact = "TRUE";
		}
		sprintf(buffer,
                       "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
			i,plcs[i],&resnames[i],
			&resrsp[0],
			&lineact[0],
			intermsgdelay[i],
			pretxdelay[i],
			posttxdelay[i],
			activity_time[i]);
		printf( "%s\n", buffer);
	}
	return 0;
}

/*	End of File:	drvArcom.c */
