/*drvNwmod.c,v 1.1.1.1 1999/08/03 14:43:32 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*                                                                                   
/*  File: drvNwmod.c                                                                 
/*  Edit: 08/05/97      WEP:                                                         
/*      : 02/16/98      WEP: modified ht logic to not only detect unexpected invalid 
/*                         : 40010 and 40011 data, but to re-mark the block for scan.
/*
*/

#define  VERSIONNUM     92                     /* NOTE: change here */

#define  MAIN           nwmod_driver           /* NOTE: change here */
#define  AIDRIVER       nwmod_aidriver         /* NOTE: change here */
#define  AODRIVER       nwmod_aodriver         /* NOTE: change here */
#define  AOREAD         nwmod_aoread           /* NOTE: change here */
#define  BIDRIVER       nwmod_bidriver         /* NOTE: change here */
#define  BODRIVER       nwmod_bodriver         /* NOTE: change here */
#define  BOREAD         nwmod_boread           /* NOTE: change here */
#define  SIDRIVER       nwmod_sidriver         /* NOTE: change here */
#define  SODRIVER       nwmod_sodriver         /* NOTE: change here */

#define  TRAFFICON      nwmodtrafficon         /* NOTE: change here */
#define  TRAFFICOFF     nwmodtrafficoff        /* NOTE: change here */
#define  TRAFFIC        nwmodtraffic           /* NOTE: change here */
#define  TRACEON        nwmodtraceon           /* NOTE: change here */
#define  TRACEOFF       nwmodtraceoff          /* NOTE: change here */
#define  RTRACE         nwmodrestrlv           /* NOTE: change here */
#define  RTRACEON       nwmodrestraceon        /* NOTE: change here */
#define  RTRACEOFF      nwmodrestraceoff       /* NOTE: change here */
#define  TRACELEVEL     nwmodtrlv              /* NOTE: change here */
#define  CONTRACEON     nwmodcontraceon        /* NOTE: change here */
#define  CONTRACEOFF    nwmodcontraceoff       /* NOTE: change here */
#define  RUNTRACEON     nwmodruntraceon        /* NOTE: change here */
#define  RUNTRACEOFF    nwmodruntraceoff       /* NOTE: change here */
#define  REJECTTRACEON  nwmodrejecttraceon     /* NOTE: change here */
#define  REJECTTRACEOFF nwmodrejecttraceoff    /* NOTE: change here */
#define  NACKTRACEON    nwmodnacktraceon       /* NOTE: change here */
#define  NACKTRACEOFF   nwmodnacktraceoff      /* NOTE: change here */
#define  FILETRACEON    nwmodfiletraceon       /* NOTE: change here */
#define  FILETRACEOFF   nwmodfiletraceoff      /* NOTE: change here */
#define  ERRORTRACE     nwmoderrortrace        /* NOTE: change here */
#define  DEFAULTTRACE   nwmoddefaulttrace      /* NOTE: change here */

#define  HELP           nwmodhelp              /* NOTE: change here */
#define  SIMON          nwmodsimon             /* NOTE: change here */
#define  SIMOFF         nwmodsimoff            /* NOTE: change here */

#define  STOPDRIVER     stopnwmod              /* NOTE: change here */
#define  STARTDRIVER    startnwmod             /* NOTE: change here */
#define  SETCOMM        nwmodcomm              /* NOTE: change here */
#define  SHOWINFO       nwmodinfo              /* NOTE: change here */

#define  DUMPMSGCNTS    nwmoddumpmsgcnts       /* NOTE: change here */
#define  CLEARMSGCNTS   nwmodclearmsgcnts      /* NOTE: change here */
#define  DUMPPLCSTATS   nwmoddumpplcstats      /* NOTE: change here */
#define  CLEARPLCSTATS  nwmodclearplcstats     /* NOTE: change here */

#define  TABLEINFO      nwmodtable             /* NOTE: change here */
#define  LINEINFO       showlineinfo           /* NOTE: change here */

#define  ASSIGNGROUP    nwmodResGroup          /* NOTE: change here */

#include <ctype.h>
#include <tsDefs.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>

#include <dbDefs.h>
#include <drvSup.h>
#include <module_types.h>
#include <drvNwmod.h>			  /* NOTE: change here */
#include <drvNwmod_proto.h> 		  /* NOTE: change here */
#include <restable.h>


/* static long	init(); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvNwmod={ 2,	NULL, init};

/*
/*      External Line Level Data Structures (declared in drvcommon.c)
/*
*/
extern	unsigned char	resnames [MODLINES] [RESNAMELEN]; /* array of resource name strings.		*/

extern	RES_TABLE	*prestable [MODLINES];		/* array of pointers to resource tables 	*/

extern	unsigned short	resresponse [MODLINES];		/* array of resource response flags. 		*/
							/* False=not active resource(slave),		*/
							/* True= active resource(master) 		*/

extern	unsigned short	line_activity [MODLINES];	/* true/false line active flag. calculated	*/
							/* using activity_time below. 			*/
extern	unsigned short	lastactivity [MODLINES];	/* assigned value of line_activity prior to	*/
							/* it's recalculation.   			*/

extern	unsigned short	modtrace [MODLINES];		/* controls output of communication error log	*/
							/* messages (true/false) 			*/
extern	unsigned short	mltrace [MODLINES];		/* controls output of certain resource related	*/
							/* log messages (level) 			*/
extern	unsigned short	modrestrace [MODLINES];		/* controls output of MASTER/SLAVE arbitration	*/
							/* log messages (binary) 			*/

extern	SEM_ID		semids [MODLINES] [2];		/* 'new' semaphore logic. the old SEMAPHORE is	*/
							/* still used. 					*/

extern	unsigned short	intermsgdelay [MODLINES];	/* holds value passed in task spawn. used for	*/
							/* each msgxfer attempt 			*/
extern	unsigned short	pretxdelay [MODLINES];		/* holds post RTS delay before TX. 		*/
extern	unsigned short	posttxdelay [MODLINES];		/* holds post TX delay before dropping RTS. 	*/

extern	long		activity_time [MODLINES];	/* holds timetick of last activity. used to	*/
							/* set line_activity flag  			*/

extern  unsigned short  halfduplex [MODLINES];          /* store half/full duplex line status           */

extern  unsigned short  pstatewait [MODLINES];          /* holds max time in seconds that driver will   */
                                                        /* wait to obtain partner state on first        */
                                                        /* attempting to decide if it should be master. */

/* extern  short           resGroupLock [];                /* holds line driver group lock flags.          */
/* extern  char           *resGroupTripName [];            /* holds line driver trip name.                 */


extern  unsigned char  iocName[];



/*
/*      Storage for MODBUS Comm Line Structures
/*
*/

static RXLINE          *rxlinetab [MODLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL,} ; /* array of pointers to dynamically           */
                                        /* allocated comm controls/buffers            */

static TXLINE          *txlinetab [MODLINES] = 
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL,} ; /* array of pointers to dynamically           */
                                        /* allocated comm controls/buffers            */

/*
/*      Storage for MODBUS PLC Structures
/*
*/
static unsigned short   pryvate [MODLINES];              /* 0 = redundant mode,   !0=private mode      */

static unsigned int     modsim [MODLINES];               /* 0 = normal operation, 1 = plc simulation.  */

static unsigned int	simdelay [MODLINES];

static 		int	simlow [MODLINES];

static 		int	simhigh [MODLINES];

static		int	simdigon [MODLINES];

static unsigned int     tick [MODLINES][5];

static unsigned int     lastscan [MODLINES];            /* holds timestamp of beginning of major loop.  */

static unsigned int     scantime [MODLINES];            /* holds actual time used to scan plcs.         */

static unsigned int     loopoutmsgs [MODLINES];

static unsigned int     loopmsgs [MODLINES];

static LINESTATS	linestats [MODLINES];		/* array of line level statistics.              */

static LOADINFO		linfo [MODLINES];		/* array of control structures for              */
                                                        /* loading PLC headers 			        */

static LOADID		idtable [MODLINES];		/* array of control structures for              */
                                                        /* loading user ID code file		        */

static LOADHT		httable [MODLINES];		/* array of control structures for              */
                                                        /* loading historic trend format file           */

static LOADHTMAP        *htmaptable [MODLINES];         /* array of pointers to control structures for  */
                                                        /* loading historic trend map file              */

static MODPLC		*plcs [MODLINES] [NUMMODPLCS + 1];/* two dimensional array of pointers to the   */
                                                        /* fixed length dynamically allocated PLC       */
                                                        /* control and data structures. extra pointer   */
                                                        /* is for Query structure used independently    */
							/* of the others. it also allows for the array  */
                                                        /* index to match the mod value.                */

static	unsigned short	trace [MODLINES];		/* controls output of system error messages:	*/
							/* bit mapped controls                          */
static  unsigned char   traceadr [MODLINES];
static  unsigned char   tracetype [MODLINES];

static OUTPUTQUE	*oq [MODLINES];			/* array of ptrs to the line output queues and  */
                                                        /* their control structures                     */

/*
static unsigned long	outagain [MODLINES];
*/

static char		user [40], password [40];	/* holds id and password of the user that       */
                                                        /* spawned the driver task required by host to  */
                                                        /* check file read privileges on PLC load files */


static unsigned short   snag [MODLINES];

static  unsigned short  options [MODLINES];             /* store half/full duplex line status           */

static  unsigned short  maxhtread [MODLINES];           /*            */

static  unsigned short  maxidwrite [MODLINES];          /*            */

static  unsigned short  secondspernickel;               /* initialized to 60*5 (5 min). this variable   */
                                                        /* was created for testing purposes only.       */

static  unsigned short  htdebug [MODLINES];             /* initialized to 2, this variable was created  */
                                                        /* for testing purposes only.                   */

static  unsigned short  reddebug [MODLINES];            /* initialized to 2, this variable was created  */
                                                        /* for testing purposes only.                   */

static  unsigned short  loopdebug [MODLINES];           /* initialized to 0, this variable was created  */
                                                        /* for testing purposes only.                   */

static  unsigned short  fakeSinbad [MODLINES];          /* Pseudo Trending Flag used for testing.       */

static  unsigned short  trendactive [MODLINES];         /* fake trend active flag used for testing.     */

static  unsigned short  threetryflag [MODLINES];        /* if true online uses 'normal' three retrys    */


static unsigned int     maxonlinetime [MODLINES];       /* holds maximum allowed time to start online attempt.  */
static unsigned int     maxtrendtime [MODLINES];        /* holds maximum allowed time to start id or ht action. */
static unsigned int     totaloffset [MODLINES];         /* holds actual time elapsed after bringing plcs online.*/
static unsigned int     onlineoffset [MODLINES];        /* holds actual time elapsed after bringing plcs online.*/
static unsigned int     scanoffset [MODLINES];          /* holds actual time elapsed after scanning plcs.       */
static unsigned int     idoffset [MODLINES];            /* holds actual time elapsed after downloading id lists.*/
static unsigned int     htoffset [MODLINES];            /* holds actual time elapsed after retrieving HT data.  */

static unsigned int     baudrate [MODLINES];            /*  */

static unsigned int     maptogo  [MODLINES];            /*  */


static char    *bools [] = {
	"TRUE ",
	"FALSE"
    };

static int		taskId [MODLINES];

static	TS_STAMP	timenow [MODLINES];


static char *tasknames [] = {"NWMOD Ch0", "NWMOD Ch1", "NWMOD Ch2", "NWMOD Ch3",
                             "NWMOD Ch4", "NWMOD Ch5", "NWMOD Ch6", "NWMOD Ch7",
                             "NWMOD Ch8", "NWMOD Ch9", "NWMOD Ch10","NWMOD Ch11",
                             "NWMOD Ch12","NWMOD Ch13","NWMOD Ch14","NWMOD Ch15",
                             "NWMOD Ch16","NWMOD Ch17","NWMOD Ch18","NWMOD Ch19",
                             "NWMOD Ch20","NWMOD Ch21","NWMOD Ch22","NWMOD Ch23",
                             "NWMOD Ch24","NWMOD Ch25","NWMOD Ch26","NWMOD Ch27",
                             "NWMOD Ch28","NWMOD Ch29","NWMOD Ch30","NWMOD Ch31"
                           };

static char *maptasknames [] = {"NWMAP Ch0", "NWMAP Ch1", "NWMAP Ch2", "NWMAP Ch3",
                             "NWMAP Ch4", "NWMAP Ch5", "NWMAP Ch6", "NWMAP Ch7",
                             "NWMAP Ch8", "NWMAP Ch9", "NWMAP Ch10","NWMAP Ch11",
                             "NWMAP Ch12","NWMAP Ch13","NWMAP Ch14","NWMAP Ch15",
                             "NWMAP Ch16","NWMAP Ch17","NWMAP Ch18","NWMAP Ch19",
                             "NWMAP Ch20","NWMAP Ch21","NWMAP Ch22","NWMAP Ch23",
                             "NWMAP Ch24","NWMAP Ch25","NWMAP Ch26","NWMAP Ch27",
                             "NWMAP Ch28","NWMAP Ch29","NWMAP Ch30","NWMAP Ch31"
                           };

static unsigned short nwmodResGroups [MODLINES] =
			{0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0,
                         0, 0, 0, 0, 0, 0, 0, 0} ; /* line driver group assignments   */


/* this is here until rnd gets the correct hooks */
static  short           resGroupLock [32];                /* holds line driver group lock flags.          */
static  char           *resGroupTripName [32];            /* holds line driver trip name.                 */



/*
/*      Storage for NWMOD Redundantly Updated Structures
/*
*/

static SEM_ID           redsemids      [MODLINES] [NUMRED+1];
static int		redsize        [MODLINES] [NUMRED+1];
static int		Nwmodredport   [MODLINES] [NUMRED+1];
static int		Nwmodredperiod [MODLINES] [NUMRED+1];

static NWMODREDUPD	*redund        [MODLINES] [NUMRED];

static NWMODREDIDUPD	*redundid      [MODLINES];

void nwmodredinfo (unsigned short l)
{
    unsigned short i;

    for (i = 0; i < NUMRED; i++)
    {
        printf (" i=%d, redsemids=%d, redsize=%d, Nwmodredport=%d, Nwmodredperiod=%d, redund=%d, sizeof (redund)=%d\n",
                  i, redsemids[l][i], redsize[l][i], Nwmodredport[l][i], Nwmodredperiod[l][i], redund[l][i], sizeof (NWMODREDUPD));
    }
    printf (" i=%d, redsemids=%d, redsize=%d, Nwmodredport=%d, Nwmodredperiod=%d, redundid=%d, sizeof (redund)=%d\n",
              i, redsemids[l][i], redsize[l][i], Nwmodredport[l][i], Nwmodredperiod[l][i], redundid[l], sizeof (NWMODREDIDUPD));
}
/************************************************************/
/************************************************************/
/************************************************************/
/************************************************************/
/************************************************************/
/************************************************************/
/************************************************************/
/************************************************************/

/* fake out Sinbad's code till I am ready to run in rnd */


int PseudoQueueTrendUpdate (long time, long line, long address, char *data, long datalen, char *statPtr, char statBit)
{
    unsigned char  temp;

    if (htdebug [line] >= 11)
    {
        printf ("PseudoQueueTrendUpdate: (time=%d, line=%d, address=%d, dataPtr=%d, datalen=%d, statPtr=%d, statBit=0x%x\n",
                                          time,    line,    address,    data,       datalen,    statPtr,    statBit);
    }

    if (fakeSinbad [line] > 1)
    {
        /* if data queued successfully, mark the data as read. */
        temp = *statPtr | statBit; /* set bit to valid */
        *statPtr = temp;
        if (htdebug [line] >= 11)
        {
            printf ("PseudoQueueTrendUpdate: Saved Mask Bit Updated. Mask Byte Value = %d\n", temp);
        }
    }

    return (TRUE);
}


/********
********/
void nwmodpseudo (unsigned short line)
{
    if (fakeSinbad [line])
    {
        logMsg ("Driver is currently in Level %d Pseudo Trending Mode.\n", fakeSinbad [line]);
    }
    else
    {
        logMsg ("Driver is currently in Real Trending Mode.\n");
    }
}

/********
********/
void nwmodsetpseudo (unsigned short line, unsigned short level)
{
    if (level)
    {
        fakeSinbad [line] = level;
        logMsg ("Driver is now in Level %d Pseudo Trending Mode.\n", fakeSinbad [line]);
    }
    else
    {
        if (fakeSinbad [line])
        {
            logMsg ("Driver is currently in Level %d Pseudo Trending Mode.\n", fakeSinbad [line]);
        }
        else
        {
            logMsg ("Driver is currently in Real Trending Mode.\n");
        }
    }
}

/********
********/
void nwmodclearpseudo (unsigned short line)
{
    fakeSinbad [line] = 0;
    logMsg ("Driver is now in Real Trending Mode.\n");
}


/********
********/
void nwmodsettrending (unsigned short line, unsigned short state)
{
    trendactive [line] = state;
    logMsg ("trendactive [%d] = %d\n", line, state);
}


int PseudoTrendingActive (unsigned short line)
{
    if (trendactive [line])
    {
        return (TRUE);
    }
    else
    {
        return (FALSE);
    }
}

int nwmodonlineretryon (unsigned short line)
{
    threetryflag [line] = TRUE;
}

int nwmodonlineretryoff (unsigned short line)
{
    threetryflag [line] = FALSE;
}

/****************/
void nwmodonlinetime (unsigned short line, unsigned short seconds)
{
    /* value must be between 15 and 120 seconds */
    if ((seconds >= MINONLINETIME) && (seconds <= MAXONLINETIME))
    {
        /* set max # of HT regs we request from PLC */
        maxonlinetime [line] = seconds*60;
    }
    else
    {
        if (seconds)
        {
            logMsg ("Maximum Online Time: Lowest Valid Value is %d seconds. Highest Valid Value is %d seconds.\n",
                     MINONLINETIME, MAXONLINETIME);

        }
    }
    logMsg ("Maximum Online Time for Line %d is %d seconds\n",
           line, (maxonlinetime [line])/60);
}


/****************/
void nwmodtrendtime (unsigned short line, unsigned short seconds)
{
    /* value must be between 15 and 120 seconds */
    if ((seconds >= MINTRENDTIME) && (seconds <= MAXTRENDTIME))
    {
        /* set max # of HT regs we request from PLC */
        maxtrendtime [line] = seconds*60;
    }
    else
    {
        if (seconds)
        {
            logMsg ("Maximum ID Download and Trend Retrieval Time: \n");
            logMsg ("   Lowest Valid Value is %d seconds.\n", MINTRENDTIME);
            logMsg ("   Highest Valid Value is %d seconds.\n", MAXTRENDTIME);
        }
    }
    logMsg ("Maximum ID Download and Trend Retrieval Time for Line %d is %d seconds\n",
           line, (maxtrendtime [line])/60);
}


/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
{
	return (0);
}


/* this is here until rnd gets the correct hooks */
int  assignLockGroup (int group, char *resource)
{
    return (12345); /* not error */ 
}


/*
/*      Rountines for NWMOD Redundant Update Function
/*
*/
static	void    master_updateredimage (unsigned short line, unsigned short section)
{
    NWMODREDUPD  *predund;
    LOADHTMAP     *pmap;
    MODPLC        *pmod;
    unsigned short  mod;
    unsigned short  i;
    unsigned short  plcnum;

    if (reddebug [line] >= 6)
    {
        printf ("master_updateredimage[%d]: ENTRY ......\n", section);
    }

    predund = redund [line][section];
    if (!(predund))
    {
        if (reddebug [line] >= 2)
        {
            printf ("master_updateredimage[%d]: ....... redund error EXIT\n", section);
        }
        return;
    }

    drvRedTake (redsemids [line][section]);

    predund->sequencenumber++;
    if (reddebug [line] == 4)
    {
        printf ("master_updateredimage[%d]: Called. Sequence Number %d\n", section, predund->sequencenumber);
    }

    /* Fill in the header */
    predund->line = line;

    pmap = htmaptable [line];

    if (pmap)
    {
        /* common variables needed to keep slave from reloading data when going to master. */
/*
        predund->lastindex  = pmap->lastindex;
        predund->lastmask   = pmap->lastmask;
*/
        predund->lastnickel = pmap->lastnickel;
        predund->thisnickel = pmap->thisnickel;

        for (mod = 1; (mod <= (NUMREDPLCS)); mod++)
        {
            plcnum = mod + (section * NUMREDPLCS);
            pmod = plcs [line] [plcnum];
            if (reddebug [line] >= 8)
            {
                printf ("master_updateredimage[%d]: ....... i = %d,  plc = %d,  pmod = %d,  pmap->htmasks[%d].data_valid = %d... \n",
                         section, mod, plcnum, pmod, mod, pmap->htmasks[mod].data_valid);
            }
            if (pmod)
            {
                predund->plcexists   [mod] = TRUE;
                predund->plcisrespon [mod] = pmod->is_responding;
                predund->plcforceoff [mod] = pmod->cmd_force_offline;
                predund->plcidpend   [mod] = pmod->id_pending;
            }
            predund->htmasks [mod].data_valid = pmap->htmasks[plcnum].data_valid;
            if (pmap->htmasks[mod].data_valid == TRUE)
            {
                predund->htmasks [mod].line       = pmap->htmasks[plcnum].line;
                predund->htmasks [mod].address    = pmap->htmasks[plcnum].address;
                predund->htmasks [mod].index      = pmap->htmasks[plcnum].index;
                predund->htmasks [mod].mask       = pmap->htmasks[plcnum].mask;
                predund->htmasks [mod].worknickel = pmap->htmasks[plcnum].worknickel;
                predund->htmasks [mod].lastnickel = pmap->htmasks[plcnum].lastnickel;
                predund->htmasks [mod].thisnickel = pmap->htmasks[plcnum].thisnickel;
                predund->htmasks [mod].lastnickelcount = pmap->htmasks[plcnum].lastnickelcount;
                predund->htmasks [mod].thisnickelcount = pmap->htmasks[plcnum].thisnickelcount;
                for (i = 0; i < MASKBYTES; i++)
                {
                    predund->htmasks [mod].archivedmask[i] = pmap->htmasks[plcnum].savedmask[i];
                }
            }
        }
    }
    drvRedGive (redsemids [line][section]);
    if (reddebug [line] >= 6)
    {
        printf ("master_updateredimage[%d]:    ....... NORMAL EXIT\n", section);
    }
}
/*
/*      Rountines for NWMOD Redundant Update Function
/*
*/
static	void    master_updateredidimage (unsigned short line)
{
    NWMODREDIDUPD  *predund;
    unsigned short  i, section;

    if (reddebug [line] >= 6)
    {
        printf ("master_updateredidimage:    ENTRY ......\n");
    }

    predund = redundid [line];
    if (!(predund))
    {
        if (reddebug [line] >= 2)
        {
            printf ("master_updateredidimage:    ....... redund error EXIT\n");
        }
        return;
    }

    predund->sequencenumber++;
    if (reddebug [line] == 4)
    {
        printf ("master_updateredidimage:  Called. Sequence Number %d\n", predund->sequencenumber);
    }

    drvRedTake (redsemids [line][section]);

    /* Fill in the header */
    predund->line           = line;
    predund->was_requested  = idtable[line].was_requested;
    predund->data_valid     = idtable[line].data_valid;
    predund->maxid          = idtable[line].maxid;
    predund->start_register = idtable[line].start_register;

    for (i = 0; i < MAXUSERNUM; i++)
    {		
        predund->idcodes [i] = idtable [line].idcodes [i];
    }

    drvRedGive (redsemids [line][section]);
    if (reddebug [line] >= 6)
    {
        printf ("master_updateredidimage:    ....... NORMAL EXIT\n");
    }
}

static	void    master_updateredimages (unsigned short line)
{
    unsigned short i;
    for (i = 0; i < NUMRED; i++)
    {
        master_updateredimage (line, i);
    }
    master_updateredidimage (line);
}


static	void    slave_updateredimage0 (unsigned short line, NWMODREDUPD *redbuf, int size)
{
    unsigned short section;

    /* define zero vs one */
    section = 0;
    if (!(redbuf))
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredimage[%d]: ....... redund error EXIT\n", section);
        }
        return;
    }

     if (line != redbuf->line)
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredimage[%d]: ....... redbuf->line error EXIT line=%d, redbuf->line =%d\n", section, line, redbuf->line);
        }
        return;
    }

    slave_updateredimage (line, redbuf, size, section);
    return;
}

static	void    slave_updateredimage1 (unsigned short line, NWMODREDUPD *redbuf, int size)
{
    unsigned short section;

    /* define zero vs one */
    section = 1;
    if (!(redbuf))
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredimage[%d]: ....... redund error EXIT\n", section);
        }
        return;
    }

    if (line != redbuf->line)
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredimage[%d]: ....... redbuf->line error EXIT line=%d, redbuf->line =%d\n", section, line, redbuf->line);
        }
        return;
    }

    slave_updateredimage (line, redbuf, size, section);
    return;
}

static	void    slave_updateredimage2 (unsigned short line, NWMODREDUPD *redbuf, int size)
{
    unsigned short section;

    /* define zero vs one */
    section = 2;
    if (!(redbuf))
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredimage[%d]: ....... redund error EXIT\n", section);
        }
        return;
    }

    if (line != redbuf->line)
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredimage[%d]: ....... redbuf->line error EXIT line=%d, redbuf->line =%d\n", section, line, redbuf->line);
        }
        return;
    }

    slave_updateredimage (line, redbuf, size, section);
    return;
}

static	void    slave_updateredimage3 (unsigned short line, NWMODREDUPD *redbuf, int size)
{
    unsigned short section;

    /* define zero vs one */
    section = 3;
    if (!(redbuf))
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredimage[%d]: ....... redund error EXIT\n", section);
        }
        return;
    }

    if (line != redbuf->line)
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredimage[%d]: ....... redbuf->line error EXIT line=%d, redbuf->line =%d\n", section, line, redbuf->line);
        }
        return;
    }

    slave_updateredimage (line, redbuf, size, section);
    return;
}


static	void    slave_updateredimage (unsigned short line, NWMODREDUPD *redbuf, int size, unsigned short section)
{
    NWMODREDUPD    *predund;
    LOADHTMAP      *pmap;
    MODPLC         *pmod;
    int             lock;
    unsigned short  mod;
    unsigned short  i;
    unsigned short  plcnum;

    if (reddebug [line] >= 6)
    {
        printf ("slave_updateredimage[%d]: ENTRY ...... line = %d, redbuf = 0x%x, size = %d\n", section, line, redbuf, size);
    }

    if (line != redbuf->line)
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredimage[%d]: ....... redbuf->line error EXIT line=%d, redbuf->line =%d\n", section, line, redbuf->line);
        }
        return;
    }

    lock = taskLock ();

    predund = redbuf;

    if (!(predund))
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredimage[%d]: ....... redund error EXIT\n", section);
        }
        return;
    }

    if (reddebug [line] == 4)
    {
/*        printf ("slave_updateredimage[%d]:  redbuf = 0x%x, &redbuf = 0x%x, *redbuf = 0x%x\n", section, redbuf, &redbuf, *redbuf); */
        printf ("slave_updateredimage[%d]: Called. Sequence Number %d\n", section, predund->sequencenumber);
    }

    pmap = htmaptable [line];

    if (pmap)
    {
        /* common variables needed to keep slave from reloading data when going to master. */
/*
        pmap->lastindex   = predund->lastindex;
        pmap->lastmask    = predund->lastmask;
*/
        pmap->lastnickel  = predund->lastnickel;
        pmap->thisnickel  = predund->thisnickel;

        if (reddebug [line] == 4)
        {
            printf ("slave_updateredimage[%d]:         pmap->thisnickel = %d\n", section, pmap->thisnickel);
        }
        for (mod = 1; (mod <= (NUMREDPLCS)); mod++)
        {
            plcnum = mod + (section * NUMREDPLCS);
            /* if it doesn't exist on the master, don't waste space allocating it here. */
            if (predund->plcexists [mod])
            {
                if (reddebug [line] >= 8)
                {
                    printf ("slave_updateredimage[%d]: ....... i = %d,  plcnum # %d exists....\n", section, mod, plcnum);
                }
                pmod = plcs [line] [plcnum];
                if (pmod == NULL)
                {
                    /* if not allocated, do it now */
                    if (!allocate_plc (line, plcnum))
                    {
                        break;
                    }
                    pmod = plcs [line] [plcnum];
                }
                pmod->is_responding      = predund->plcisrespon [mod];
                pmod->cmd_force_offline  = predund->plcforceoff [mod];
                pmod->id_pending         = predund->plcidpend   [mod];
            }
            else
            {
                if (reddebug [line] >= 8)
                {
                    printf ("slave_updateredimage[%d]: ....... i = %d,  plcnum # %d does not exist....\n", section, mod, plcnum);
                }
            }

            pmap->htmasks[plcnum].data_valid = predund->htmasks [mod].data_valid;
            if (pmap->htmasks[plcnum].data_valid == TRUE)
            {
                if (reddebug [line] >= 8)
                {
                    printf ("slave_updateredimage[%d]: .......          plcnum # %d htmasks are valid. transferring ....\n", section, plcnum);
                }
                pmap->htmasks[plcnum].line       = predund->htmasks [mod].line;
                pmap->htmasks[plcnum].address    = predund->htmasks [mod].address;
                pmap->htmasks[plcnum].index      = predund->htmasks [mod].index;
                pmap->htmasks[plcnum].mask       = predund->htmasks [mod].mask;
                pmap->htmasks[plcnum].worknickel = predund->htmasks [mod].worknickel;
                pmap->htmasks[plcnum].lastnickel = predund->htmasks [mod].lastnickel;
                pmap->htmasks[plcnum].thisnickel = predund->htmasks [mod].thisnickel;
                pmap->htmasks[plcnum].lastnickelcount = predund->htmasks [mod].lastnickelcount;
                pmap->htmasks[plcnum].thisnickelcount = predund->htmasks [mod].thisnickelcount;
                for (i = 0; i < MASKBYTES; i++)
                {
                    pmap->htmasks[plcnum].validmask[i] = predund->htmasks [mod].archivedmask[i];
                    pmap->htmasks[plcnum].savedmask[i] = predund->htmasks [mod].archivedmask[i];
                }
            }
            else
            {
                if (reddebug [line] >= 8)
                {
                    printf ("slave_updateredimage[%d]: .......          plcnum # %d htmasks are not valid. \n", section, plcnum);
                }
            }
        }
    }
    taskUnlock ();
    if (reddebug [line] >= 6)
    {
        printf ("slave_updateredimage[%d]: ....... NORMAL EXIT\n", section);
    }
}



static	void    slave_updateredidimage (unsigned short line, NWMODREDIDUPD *redbuf, int size)
{
    NWMODREDIDUPD  *predund;
    int             lock;
    unsigned short  i;

    if (!(redbuf))
    {
        if (reddebug [line] >= 2)
        {
            printf ("slave_updateredidimage:    ....... redund error EXIT\n");
        }
        return;
    }

    if (reddebug [line] >= 6)
    {
        printf ("slave_updateredidimage:    ENTRY ...... line = %d, redbuf = 0x%x, size = %d\n", line, redbuf, size);
    }

    lock = taskLock ();

    predund = redbuf;

    if (reddebug [line] == 4)
    {
/*        printf ("slave_updateredidimage:  redbuf = 0x%x, &redbuf = 0x%x, *redbuf = 0x%x\n", redbuf, &redbuf, *redbuf); */
        printf ("slave_updateredidimage:  Called. Sequence Number %d\n", predund->sequencenumber);
    }

    idtable [line].line           = predund->line;
    idtable [line].was_requested  = predund->was_requested;
    idtable [line].data_valid     = predund->data_valid;
    idtable [line].maxid          = predund->maxid;
    idtable [line].start_register = predund->start_register;

    for (i = 0; i < MAXUSERNUM; i++)
    {		
        idtable [line].idcodes[i] = predund->idcodes [i];
    }

    taskUnlock ();

    if (reddebug [line] >= 6)
    {
        printf ("slave_updateredimage:    ....... NORMAL EXIT\n");
    }
}


void testmaster (unsigned short line)
{
    printf ("<<<<<<<<<<<<<<<<\n");
    master_updateredimage (line, 0);
    master_updateredimage (line, 1);
    master_updateredimage (line, 2);
    master_updateredimage (line, 3);
    printf (">>>>>>>>>>>>>>>>\n");
}


static void fixmaptable (unsigned short line)
{
    LOADHTMAP      *pmap;
    MODPLC         *pmod;
    unsigned short  mod;
    unsigned short  i;

    pmap = htmaptable [line];

    if (pmap)
    {
        for (mod = 1; (mod <= NUMMODPLCS); mod++)
        {
            for (i = 0; i < MASKBYTES; i++)
            {
                pmap->htmasks[mod].validmask[i] = pmap->htmasks[mod].savedmask[i];
            }
        }
    }
    else
    {
        logMsg ("fixmaptable error. table not allocated.\n");
    }
}



void fixmaptabletest (unsigned short line)
{
    fixmaptable(line);
}




void  nwmodjustone (unsigned short line, unsigned short address)
{
    MODPLC         *pmod;
    unsigned short  mod;

    for (mod = 1; (mod <= NUMMODPLCS); mod++)
    {
        pmod = plcs [line] [mod];
        if (pmod == NULL)
        {
            continue;
        }
        pmod->cmd_force_offline = TRUE;
        if (mod == address) pmod->cmd_force_offline = FALSE;
    }
}


void  nwmodoffline (unsigned short line)
{
    MODPLC         *pmod;
    unsigned short  mod;

    for (mod = 1; (mod <= NUMMODPLCS); mod++)
    {
        pmod = plcs [line] [mod];
        if (pmod == NULL)
        {
            continue;
        }
        pmod->cmd_force_offline = TRUE;
        if (mod ==  1) pmod->cmd_force_offline = FALSE;
        if (mod ==  2) pmod->cmd_force_offline = FALSE;
        if (mod == 14) pmod->cmd_force_offline = FALSE;
    }
}


void mapbyteinit (unsigned short line, unsigned short plc, unsigned short bite)
{
    LOADHTMAP     *pmap;
    MODPLC        *pmod;
    unsigned short  i, bitindex, arrayindex;
    unsigned char   arraymask;
    unsigned long   thisnickel, lastnickel;

    /* 'thisnickel' is the absolute # of 5 minute intervals since the universe began. */
    tsLocalTime (&timenow [line]);
    thisnickel = (timenow [line].secPastEpoch)/secondspernickel + 1;
    lastnickel = thisnickel - 1;

    /* generate bit index */
    bitindex = lastnickel%MASKBITS;
    /* generate array index */
    arrayindex = bitindex/8;
    /* generate array mask */
    arraymask = 0x01 << (bitindex%8);

    pmap = htmaptable [line];
    if (pmap)
    {
        if ((plc > 0) && (plc <= NUMMODPLCS))
        {
            if (bite < MASKBYTES)
            {
                /* clear all map entries */
                pmap->htmasks[plc].validmask[bite] = 0x00;
                pmap->htmasks[plc].savedmask[bite] = 0x00;
                pmap->htmasks[plc].gotitmask[bite] = 0x00;
                printf ("mapbyteinit:  Byte Cleared: line = %d, plc = %d, bite = %d\n",
                            line, plc, bite);
                return;
            }
            printf ("mapbyteinit: Bad Byte Value: line = %d, plc = %d, bite = %d\n",
                        line, plc, bite);
            return;
        }
        printf ("mapbyteinit: Bad PLC Value: line = %d, plc = %d, bite = %d\n",
                    line, plc, bite);
        return;
    }
    printf ("mapbyteinit: Bad pmap pointer: line = %d, plc = %d, bite = %d\n",
                line, plc, bite);
    return;
}

void maptableinit (unsigned short line, unsigned short plc)
{
    LOADHTMAP     *pmap;
    MODPLC        *pmod;
    unsigned short  mod;
    unsigned short  i, bitindex, arrayindex;
    unsigned char   arraymask;
    unsigned long   thisnickel, lastnickel;

    /* 'thisnickel' is the absolute # of 5 minute intervals since the universe began. */
    tsLocalTime (&timenow [line]);
    thisnickel = (timenow [line].secPastEpoch)/secondspernickel + 1;
    lastnickel = thisnickel - 1;

    printf ("maptableinit:  plc=%d, thisnickel = %d, lastnickel = %d\n",
                            plc,    thisnickel,      lastnickel);

    /* generate bit index */
    bitindex = lastnickel%MASKBITS;
    /* generate array index */
    arrayindex = bitindex/8;
    /* generate array mask */
    arraymask = 0x01 << (bitindex%8);

    pmap = htmaptable [line];
    if (pmap)
    {
        pmap->data_valid = TRUE;
        pmap->line = 0;
        pmap->loading = 0;
        pmap->map_load_status = 0;
        pmap->map_load_code = 0;
        pmap->storing = 0;
        pmap->map_store_status = 0;
        pmap->map_store_code = 0;
        pmap->mapfile = 0;
        pmap->filename[0] = 0;

        pmap->lastindex  = arrayindex;
        pmap->lastmask   = arraymask;
        pmap->lastnickel = lastnickel;
        pmap->thisnickel = thisnickel;

        if ((plc > 0) && (plc <= NUMMODPLCS))
        {
            mod = plc;
            pmap->htmasks[mod].data_valid = TRUE;
            pmap->htmasks[mod].line       = line;
            pmap->htmasks[mod].address    = mod;

            pmap->htmasks[mod].index      = arrayindex;
            pmap->htmasks[mod].mask       = arraymask;

            pmap->htmasks[mod].worknickel = 0;
            pmap->htmasks[mod].lastnickel = lastnickel;
            pmap->htmasks[mod].thisnickel = thisnickel;
            pmap->htmasks[mod].lastnickelcount = 0;
            pmap->htmasks[mod].thisnickelcount = 0;

            for (i = 0; i < MASKBYTES; i++)
            {
                /* clear all map entries */
                pmap->htmasks[mod].validmask[i] = 0x00;
                pmap->htmasks[mod].savedmask[i] = 0x00;
                pmap->htmasks[mod].gotitmask[i] = 0x00;
            }
            return;
        }
        else
        {
            for (mod = 1; (mod <= NUMMODPLCS); mod++)
            {
                pmap->htmasks[mod].data_valid = TRUE;
                pmap->htmasks[mod].line       = line;
                pmap->htmasks[mod].address    = mod;

                pmap->htmasks[mod].index      = arrayindex;
                pmap->htmasks[mod].mask       = arraymask;

                pmap->htmasks[mod].worknickel = 0;
                pmap->htmasks[mod].lastnickel = lastnickel;
                pmap->htmasks[mod].thisnickel = thisnickel;
                pmap->htmasks[mod].lastnickelcount = 0;
                pmap->htmasks[mod].thisnickelcount = 0;

                for (i = 0; i < MASKBYTES; i++)
                {
                    /* clear all map entries */
                    pmap->htmasks[mod].validmask[i] = 0x00;
                    pmap->htmasks[mod].savedmask[i] = 0x00;
                    pmap->htmasks[mod].gotitmask[i] = 0x00;
                }
            }
            return;
        }
    }
}

void htmaptableinit (unsigned short line)
{
    maptableinit (line, 0);
}


void maptableset (unsigned short line, unsigned short plc)
{
    LOADHTMAP     *pmap;
    MODPLC        *pmod;
    unsigned short  mod;
    unsigned short  i, bitindex, arrayindex;
    unsigned char   arraymask;
    unsigned long   thisnickel, lastnickel;

    /* 'thisnickel' is the absolute # of 5 minute intervals since the universe began. */
    tsLocalTime (&timenow [line]);
    thisnickel = (timenow [line].secPastEpoch)/secondspernickel + 1;
    lastnickel = thisnickel - 1;

    printf ("maptableset:  plc=%d, thisnickel = %d, lastnickel = %d\n",
                            plc,    thisnickel,      lastnickel);

    /* generate bit index */
    bitindex = lastnickel%MASKBITS;
    /* generate array index */
    arrayindex = bitindex/8;
    /* generate array mask */
    arraymask = 0x01 << (bitindex%8);

    pmap = htmaptable [line];
    if (pmap)
    {
        if ((plc > 0) && (plc <= NUMMODPLCS))
        {
            for (i = 0; i < MASKBYTES; i++)
            {
                /* set all map entries */
                pmap->htmasks[plc].validmask[i] = 0xFF;
                pmap->htmasks[plc].savedmask[i] = 0xFF;
            }
            return;
        }
        else
        {
            for (mod = 1; (mod <= NUMMODPLCS); mod++)
            {
                for (i = 0; i < MASKBYTES; i++)
                {
                    /* set all map entries */
                    pmap->htmasks[mod].validmask[i] = 0xFF;
                    pmap->htmasks[mod].savedmask[i] = 0xFF;
                }
            }
            return;
        }
    }
}


void htmaptableset (unsigned short line)
{
    maptableset (line, 0);
}

/********
/*
/*	This routine outputs information to help with debugging.
/*
********/
void HELP (unsigned short level)
{
    switch (level)
    {
        case 0:
            printf ("North Wales Special Modicon Driver: Configuration Commands:\n");
            printf ("\n");
            printf (" nwmodmaxhtread (N,X)    Set/Display max # of HT regs we request from each PLC in a    \n");
            printf ("                           single Modbus request.  Min = %d. Max = %d. Default = %d    \n",
                                                MINFETCHCOUNT, MAXFETCHCOUNT, DEFAULTFETCHCOUNT);
            printf (" nwmodmaxidwrite (N,X)   Set/Display max # of sequential ID List entries to send to each\n");
            printf ("                           PLC in a single Modbus command.  Min = %d. Max = %d. Default = %d\n",
                                                MINIDREGCOUNT, MAXIDREGCOUNT, DEFAULTIDREGCOUNT);
            printf (" nwmodonlineretryon (N)  Set the line N online retry flag.                             \n");
            printf (" nwmodonlineretryoff (N) Clear the line N online retry flag.                           \n");
            printf (" nwmodonlinetime (N,X)   Set maximum elaped cycle time (sec) for bringing plcs online. \n");
            printf ("                            Min = %d, Max = %d, Default = %d.\n", MINONLINETIME, MAXONLINETIME, DEFAULTONLINETIME);
            printf (" nwmodtrendtime (N,X)    Set maximum elaped cycle time (sec) for retrieving HT data.   \n");
            printf ("                            Min = %d, Max = %d, Default = %d.\n", MINTRENDTIME, MAXTRENDTIME, DEFAULTTRENDTIME);
            printf ("                                                                                       \n");
            printf ("  (v%d)                                                                                \n", VERSIONNUM);
            break;

        case  99:
            printf (" North Wales Special Modbus Driver: Help Categories:                                   \n");
            printf ("                                                                                       \n");
            printf (" nwmodhelp       Display Startup and Configuration Information.                        \n");
            printf (" nwmodhelp (X)   Display a Specific Help Category:                                     \n");
            printf ("                   X=  0, Display Startup and Configuration Information.               \n");
            printf ("                   X= 99, Display Help Categories                                      \n");
            printf ("                   X=100, Display Command Line Parameter Descriptions.                 \n");
            printf ("                   X=200, Display Driver Trace Functions.                              \n");
            printf ("                   X=300, Display Scantask Trace Functions.                            \n");
            printf ("                   X=400, Display Communication Traffic Trace Functions.               \n");
            printf ("                   X=500, Display Internal Statistics and Data Dump Functions.         \n");
            printf ("                   X=600, Display Special Information Functions.                       \n");
            printf ("                   X=700, Display Special Dangerous Functions.                         \n");
            break;

        case 100:
            printf ("North Wales Special Modicon Driver: Command Line Parameter Descriptions:               \n");
            printf ("                                                                                       \n");
            printf (" startnwmod(N,p,C,t1,f,t2,t3,P)                                                        \n");
            printf ("                     N:  start the driver on line N.                                   \n");
            printf ("                     p:  base port for the 5 Partner Redundant Update functions.       \n");
            printf ("                     C:  communications parameter string (comma delimited ascii)       \n");
            printf ("                     t1: intermessage delay (in ticks)                                 \n");
            printf ("                     f:  half duplex flag. 1=half duplex mode, 1!=full duplex          \n");
            printf ("                     t2: post RTS assert, pre TX delay (in ticks)                      \n");
            printf ("                     t3: post TX, pre RTS drop delay (in ticks)                        \n");
            printf ("                     P:  Private flag.  0 = Redundant, 1 = Non-Redundant               \n");
            printf ("                                                                                       \n");
            printf (" Example: startnwmod(2,7000,\"9600,N,8,1\", 2,1,4,0)                                   \n");
            printf ("                                                                                       \n");
            printf ("                                                                                       \n");
            printf (" nwmodcomm(N,t1,f,t2,t3) Set communication timing parameters for line N as follows:    \n");
            printf ("                           t1: intermessage delay (in ticks).                          \n");
            printf ("                            f: 0 = full duplex, 1 = half duplex.                       \n");
            printf ("                           t2: post RTS assert, pre TX delay (in ticks).               \n");
            printf ("                           t3: post TX, pre RTS drop delay (in ticks).                 \n");
            break;

        case 200:
            printf (" North Wales Special Modbus Driver: Driver Trace Functions (* = default)               \n");
            printf ("                                                                                       \n");
            printf (" nwmodtraceon(N)         Enable the following debug messages for line N:               \n");
            printf ("                           1) Major Scan loop Info:                                    \n");
            printf ("                             scan time, total output messages, and total messages.     \n");
            printf ("                           2) Output Queue Overflow.                                   \n");
            printf ("                           3) All communication errors encountered in msgxfer.         \n");
            printf ("*nwmodtraceoff(N)        Disable all of the nwmodtraceon debug messages for line N.    \n");
            printf ("                                                                                       \n");
            printf (" nwmodrestrace(N,X)      Resource Trace Level: 0 = off. 1 = state change; 2 = delay.   \n");
            printf ("*nwmodrestraceon(N)      Enable display of master/slave/etc state changes in MAIN.     \n");
            printf (" nwmodrestraceoff(N)     Disable display of master/slave/etc state changes in MAIN.    \n");
            printf ("                                                                                       \n");
            printf (" nwmodfiletraceon(N)     Enable display of file loading status and error messages.     \n");
            printf ("*nwmodfiletraceoff(N)    Disable display of file loading status and error messages.    \n");
            printf ("                                                                                       \n");
            printf (" nwmodtrlv(N,X)          Enable the following message for line N:                      \n");
            printf ("*                          X=0,  display none of the messages below.                   \n");
            printf ("                           X=1,  beginning of plc scan loop, bringing plcs online.     \n");
            printf ("                           X=2,  beginning of plc scan.                                \n");
            printf ("                           X=3,  AO queue actions (normal: AODRIVER & checkoutputs)    \n");
            printf ("                           X=4,  BO queue actions (normal: BODRIVER & checkoutputs)    \n");
            printf ("                           X=5,  SO queue actions (normal: SODRIVER & checkoutputs)    \n");
            printf ("                           X=6,  calls to checkoutputs.                                \n");
            printf ("                           X=7,  checkoutputs: trace each queue entry read.            \n");
            printf ("                           X=20, Msg Transfer TX tick delay message.                   \n");
            break;

        case 300:
            printf (" North Wales Special Modbus Driver: Scantask Trace Functions (* = default)             \n");
            printf ("                                                                                       \n");
            printf (" nwmodcontraceon(N)      Enable display of configuration errors in driver calls.       \n");
            printf ("*nwmodcontraceoff(N)     Disable display of configuration errors in driver calls.      \n");
            printf (" nwmodruntraceon(N)      Enable display of runtime errors (queue overflow).            \n");
            printf ("*nwmodruntraceoff(N)     Disable display of runtime errors (queue overflow).           \n");
            printf (" nwmodrejecttraceon(N)   Enable display of driver call rejections in driver calls.     \n");
            printf ("*nwmodrejecttraceoff(N)  Disable display of driver call rejections in driver calls.    \n");
            printf (" nwmodnacktraceon(N)     Enable display of point deselection on MODBUS command NACK.   \n");
            printf ("*nwmodnacktraceoff(N)    Disable display of point deselection on MODBUS command NACK.  \n");
            printf (" nwmodfiletraceon(N)     Enable display of file loading status and error messages.     \n");
            printf ("*nwmodfiletraceoff(N)    Disable display of file loading status and error messages.    \n");
            printf ("                                                                                       \n");
            printf (" nwmodtrlv(N,X)          Enable the following message for line N:                      \n");
            printf ("*                          X=0,  display none of the messages below.                   \n");
            printf ("                           X=3,  AO queue actions (normal: AODRIVER & checkoutputs)    \n");
            printf ("                           X=4,  BO queue actions (normal: BODRIVER & checkoutputs)    \n");
            printf ("                           X=5,  SO queue actions (normal: SODRIVER & checkoutputs)    \n");
            printf ("                           X=6,  calls to checkoutputs.                                \n");
            printf ("                           X=7,  checkoutputs: trace each queue entry read.            \n");
            printf ("                           X=8,  AIDRIVER, AOREAD: normal call return.                 \n");
            printf ("                           X=9,  BIDRIVER, BOREAD: normal call return.                 \n");
            printf ("                           X=10, SIDRIVER: normal call return.                         \n");
            break;

        case 400:
            printf (" North Wales Special Modbus Driver: Communication Traffic Trace Functions (* = default)\n");
            printf ("                                                                                       \n");
            printf (" nwmodtrafficon(N)       Enable traffic tracing for all plc addresses                  \n");
            printf ("                           and all modbus functions on line N.                         \n");
            printf ("*nwmodtrafficoff(N)      Disable all traffic tracing on line N.                        \n");
            printf (" nwmodtraffic(N,X,Y)     Modifies line N traffic tracing as follows:                   \n");
            printf ("                           X=0   disables tracing of all addresses.                    \n");
            printf ("                           X=255 enables tracing of all addresses.                     \n");
            printf ("                           0 < X < 255 enables tracing of address X traffic.           \n");
            printf ("                           Y=0   disables tracing of all modbus functions.             \n");
            printf ("                           Y=255 enables tracing of all modbus functions.              \n");
            printf ("                           0 < Y < 255 enables tracing of function Y traffic.          \n");
            printf ("                                                                                       \n");
            printf (" nwmodtrlv(N,X)          Enable the following message for line N:                      \n");
            printf ("                           X=0,  display none of the messages below.                   \n");
            printf ("                           X=20, Msg Transfer TX tick delay message.                   \n");
            printf ("                                                                                       \n");
            printf (" nwmoddefaulttrace(N)    Restores default setting for all traces.                      \n");
            break;

        case 500:
            printf (" North Wales Special Modbus Driver: Internal Statistics and Data Display Functions     \n");
            printf ("                                                                                       \n");
            printf (" nwmodinfo(N)            Display startup and current state information.                \n");
            printf (" nwmoddumpmsgcnts(N)     Display line N communication statistics.                      \n");
            printf (" nwmodclearmsgcnts(N)    Display and clear line N communication statistics.            \n");
            printf (" nwmoddumpplcstats(N,X)  Display line N, plc X, communication statistics.              \n");
            printf (" nwmodclearplcstats(N,X) Display and clear line N, plc X, xfers, status & errors.      \n");
            printf (" nwmodtable(N,X)         Display line N, plc X, xfers, status, errors and input data.  \n");
            printf ("                                                                                       \n");
            printf (" North Wales Special Modbus Driver: Miscellaneous Functions                            \n");
            printf ("                                                                                       \n");
            printf (" nwmodResGroup(N,G)      Assign line N to group G (valid G range is 1 to 16)           \n");
            printf (" nwmoddefaulttrace(N)    Restores default setting for all traces.                      \n");
            break;

        case 600:
            printf ("North Wales Special Modicon Driver: Special Information Functions                     \n");
            printf ("                                                                                      \n");
            printf (" nwmodloopdebug (N,X)    Set the MAIN Master Loop debug trace level  (default: X=0)   \n");
            printf ("                           (Min = 0, Max = 12)                                        \n");
            printf (" nwmodhtdebug (N,X)      Set the HT function debug trace level  (default: X=2)        \n");
            printf ("                           (Min = 0, Max = 30)  12 = max 'hit only' details           \n");
            printf (" nwmodreddebug (N,X)     Set the Redundant function debug trace level  (default: X=2) \n");
            printf ("                           (0 <= X <= 8)  2: errors, 4: single, 6: entry/exit, 8: plcs\n");
            printf (" nwmodverbose (N)        Enable special diagnostics and comm tracing:                 \n");
            printf ("                            nwmodloopdebug (N,10), nwmodhtdebug (N,12),               \n");
            printf ("                            nwmodreddebug (no change), and nwmodtrafficon (N)         \n");
            printf (" nwmodmute (N)           Disable special diagnostics and comm tracing:                \n");
            printf (" nwmodtrlv (N,X)         Enable the following reserved message for line N:            \n");
            printf ("                           X=20, Msg Transfer TX tick delay message.                  \n");
            printf (" nwmoddumpmap (N,X)      line, mod  (if mod==0, then dump all)                        \n");
            printf (" dumpidtable (N)                                                                      \n");
            printf (" dumpidred (N)                                                                        \n");
            printf (" dumphttable (N)                                                                      \n");
            break;

        case 700:
            printf ("North Wales Special Modicon Driver: Special Dangerous Functions                       \n");
            printf ("                                                                                      \n");
            printf (" testidfile (N)          Call the loadidtable routine.                                \n");
            printf (" setidpending (N,X)      Set the line N, plc X ID list download flag.                 \n");
            printf (" clearidpending (N,X)    Clear the line N, plc X ID list download flag.               \n");
            printf ("                                                                                      \n");
            printf (" testhtfile (N)          Call the loadhtfile routine.                                 \n");
            printf ("                                                                                      \n");
            printf (" writemapfiletest (N)    Call the storemapfile routine.                               \n");
            printf (" loadmapfiletest (N)     Call the loadmapfile routine.                                \n");
            printf (" fixmaptabletest (N)     Call the fixmaptable routine. this transfers                 \n");
            printf ("                           the savedmask bits to the readmask bits.                   \n");
            printf (" mapbyteinit (N,X,Y)     Clear out byte Y of the PLC X map table.                     \n");
            printf (" maptableinit (N,X)      Clear out entire map table for PLC X.                        \n");
            printf (" maptableset (N,X)       Set entire map table for PLC X. if X==0, set all PLC map     \n");
            printf ("                                                                                      \n");
            printf (" nwmodpseudo (N)         Display current status of the pseudo test mode.              \n");
            printf (" nwmodclearpseudo (N)    Disable pseudo test mode, which enables Real mode.           \n");
            printf (" nwmodsetpseudo (N,X)    Set pseudo test mode to level X: if X=0, display test level. \n");
            printf (" nwmodsettrending (N,X)  Set the fake trending flag to X: 0=inactive, 0!=active. def=0\n");
            printf (" nwmodtesting (N)        Call nwmodverbose, one online retry, min online time, etc.   \n");
            printf (" nwmodoffline (N)        force all PLCs except 1,2 & 14 offline.                      \n");
            printf (" nwmodjustone (N,X)      force all PLCs except PLC X offline.                         \n");
            printf (" nwmodredinfo (N)                                                                     \n");
            break;


        case 999:
            HELP (99);
            taskDelay (60);
            HELP (0);
            taskDelay (60);
            HELP (100);
            taskDelay (60);
            HELP (200);
            taskDelay (60);
            HELP (300);
            taskDelay (60);
            HELP (400);
            taskDelay (60);
            HELP (500);
            taskDelay (60);
            HELP (600);
            taskDelay (60);
            HELP (700);
            break;
    }
}

/********
/*
/*	This routine enables logging of comm trace messages
/*
********/
void TRACEON (unsigned short line)
{
	modtrace [line] = TRUE;
}

/********
/*
/*	This routine disables logging of comm trace messages
/*
********/
void TRACEOFF (unsigned short line)
{
	modtrace [line] = FALSE;
}

/********
/*
/*	This routine enables detailed display of normal communications traffic
/*
********/
void TRAFFIC (unsigned short line, unsigned char add, unsigned type)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = add;
        tracetype [line] = type;
        return;
}

/********
/*
/*	This routine enables detailed display of normal communications traffic
/*
********/
void TRAFFICON (unsigned short line)
{
	trace [line] = trace [line] | ALLTRAFFICTRACE;
        traceadr [line] = 255;  /* every address */
        tracetype [line] = 255; /* every message type */
}

/********
/*
/*	This routine disables detailed display of normal communications traffic
/*
********/
void TRAFFICOFF (unsigned short line)
{
	trace [line] = trace [line] & ~ALLTRAFFICTRACE;
}

/********
/*
/*	This routine enables logging of resource trace messages
/*
********/
void RTRACE (unsigned short line, unsigned short level)
{
	modrestrace [line] = level;
}

/********
/*
/*	This routine enables logging of resource trace messages
/*
********/
void RTRACEON (unsigned short line)
{
	modrestrace [line] = 1;
}

/********
/*
/*	This routine disables logging of resource trace messages
/*
********/
void RTRACEOFF (unsigned short line)
{
	modrestrace [line] = 0;
}

/********
/*
/*	This routine controls logging of trace messages
/*
********/
void TRACELEVEL (unsigned short line, unsigned short level)
{
	mltrace [line] = level;
}


/********
/*
/*	This routine enables the simulation of responding plcs, reading all input values as zero.
/*
********/
void SIMON (unsigned short line, unsigned short delay, int low, int high, int digenable)
{
	if ((delay < 1) || (delay > 60))
	{
	    simdelay [line] = 60;
	}
	else
	{
	    simdelay [line] = delay;
	}
	if (low > high)
	{
	    simhigh [line] = low;
	    simlow [line] = high;
	}
	else
	{
	    simlow [line] = low;
	    simhigh [line] = high;
	}
	modsim [line] = TRUE;
	simdigon [line] = digenable;
}

/********
/*
/*	This routine disables simulation, thus enabling normal driver function.
/*
********/
void SIMOFF (unsigned short line)
{
	modsim [line] = FALSE;
}

/********
/*
/*	These routines enable and disable tracing of database configuration errors in driver calls
/*
********/
void CONTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }
void CONTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }

/********
/*
/*	These routines enable and disable tracing of runtime errors in driver calls
/*
********/
void RUNTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }
void RUNTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }

/********
/*
/*	These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void REJECTTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }
void REJECTTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }


/********
/*
/*	These routines enable and disable tracing of call rejection errors in driver calls
/*
********/
void NACKTRACEON (unsigned short line)
    {
	trace[line] = trace[line] | MODBUSNACKTRACE;
    }
void NACKTRACEOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~MODBUSNACKTRACE;
    }

/********
/*
/*	These routines enable and disable tracing of file access status & errors
/*
********/
void FILETRACEON (unsigned short line)
{
    trace[line] = trace[line] | HTFORMATFILETRACE;
    trace[line] = trace[line] | HTMAPFILETRACE;
    trace[line] = trace[line] | USERIDFILETRACE;
}
void FILETRACEOFF (unsigned short line)
{
    trace[line] = trace[line] & ~HTFORMATFILETRACE;
    trace[line] = trace[line] & ~HTMAPFILETRACE;
    trace[line] = trace[line] & ~USERIDFILETRACE;
}

/*********/
/*********/
void setnickel (unsigned short seconds)
{
    /* value must be between 5 seconds and 5 minutes */
    if ((seconds > 4) && (seconds < ((60*5)+1)))
    {
        /* set time base for historical trending */
        secondspernickel = seconds;
    }
    logMsg ("secondspernickel = %d\n", secondspernickel);
}
/******************/
void nwmodhtdebug (unsigned short line, unsigned short level)
{
    /* set historical trending debug level */
    htdebug [line] = level;
    logMsg ("htdebug [%d] = %d\n", line, htdebug [line]);
}

/******************/
void nwmodreddebug (unsigned short line, unsigned short level)
{
    /* set redundant update debug level */
    reddebug [line] = level;
    logMsg ("reddebug [%d] = %d\n", line, reddebug [line]);
}

/******************/
void nwmodloopdebug (unsigned short line, unsigned short level)
{
    /* set time base for historical trending */
    loopdebug [line] = level;
    logMsg ("loopdebug [%d] = %d\n", line, loopdebug [line]);
}


/****************/
void nwmodmaxidwrite (unsigned short line, unsigned short wordcount)
{
    /* value must be between 20 and 125 registers */
    if ((wordcount >= MINIDREGCOUNT) && (wordcount <= MAXIDREGCOUNT))
    {
        /* set max # of HT regs we request from PLC */
        maxidwrite [line] = wordcount;
    }
    else
    {
        if (wordcount)
        {
            logMsg ("Maximum Word Count: Lowest Valid Value is %d. Highest Valid Value is %d.\n",
                     MINIDREGCOUNT, MAXIDREGCOUNT);

        }
    }
    logMsg ("Maximum Word Count for Line %d Historic Trend Retrieval = %d\n",
           line, (maxidwrite [line]));
}

/****************/
void nwmodmaxhtread (unsigned short line, unsigned short wordcount)
{
    /* value must be between 10 and 125 registers */
    if ((wordcount >= MINFETCHCOUNT) && (wordcount <= MAXFETCHCOUNT))
    {
        /* set max # of HT regs we request from PLC */
        maxhtread [line] = wordcount;
    }
    else
    {
        if (wordcount)
        {
            logMsg ("Maximum Word Count: Lowest Valid Value is %d. Highest Valid Value is %d.\n",
                     MINFETCHCOUNT, MAXFETCHCOUNT);

        }
    }
    logMsg ("Maximum Word Count for Line %d Historic Trend Retrieval = %d\n",
           line, (maxhtread [line]));
}


/********
/*
/*	This routine restores default setting for all traces.
/*
********/
void DEFAULTTRACE (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = FALSE;
	mltrace [line] = 0;
	modrestrace [line] = 1;
        trace [line] = 0;
        traceadr [line] = 255;  /* every address      */
        tracetype [line] = 255; /* every message type */
    }
/********
/*
/*	This routine turns on all error tracing.
/*
********/
void ERRORTRACE (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = TRUE;
	modrestrace [line] = 2;
	trace[line] = MODBUSNACKTRACE |
                      CONFIGURATIONTRACE |
                      RUNTIMEERRORTRACE |
                      CALLREJECTTRACE |
                      HTFORMATFILETRACE |
                      HTMAPFILETRACE |
                      USERIDFILETRACE |
                      0;
        traceadr [line]  = 255; /* every address      */
        tracetype [line] = 255; /* every message type */
    }


void HTERRORTRACE (unsigned short line)
    {
        /* debug structures */
	modtrace [line] = TRUE;
	modrestrace [line] = 2;
	trace[line] = MODBUSNACKTRACE |
                      CONFIGURATIONTRACE |
                      RUNTIMEERRORTRACE |
                      HTFORMATFILETRACE |
                      HTMAPFILETRACE |
                      USERIDFILETRACE |
                      0;
        traceadr [line]  = 255; /* every address      */
        tracetype [line] = 255; /* every message type */
    }


void nwmodverbose (unsigned short line)
{
    /* turn on all debug tracing */
    nwmodhtdebug   (line, 10);
    nwmodloopdebug (line, 12);

    /* watch the communications */
    nwmodtrafficon (line);
}


void nwmodtesting (unsigned short line)
{
    /* turn on debug tracing */
    nwmodverbose (line);

    /* set min number of words to send on each download of the User ID List */
    nwmodmaxidwrite (line, MINIDREGCOUNT);

    /* initialize to max maximum number of HT regs requested from PLC */
    nwmodmaxhtread (line, MAXFETCHCOUNT);

    /* initialize Historic Trend Retrieval Function into Real Mode */
    nwmodclearpseudo (line);
    nwmodsettrending (line, 1);

    /* never retry online attempts */
    nwmodonlineretryoff (line);

    /* intialize the max online retry window length */
    nwmodonlinetime (line, MINONLINETIME);

    /* intialize the max historic trend and ID list download window length */
    nwmodtrendtime (line, MINTRENDTIME);
}


void nwmodmute (unsigned short line)
{
    /* debug structures */
    DEFAULTTRACE (line);

    /* turn off all debug tracing */
    nwmodhtdebug   (line, 2);
    nwmodreddebug  (line, 2);
    nwmodloopdebug (line, 0);

    /* stop watching the communications */
    nwmodtrafficoff (line);
}


void nwmodsnag(unsigned short line)
{
    snag [line] = TRUE;
    while (snag [line])
    {
        logMsg ( "Debug Snag Active. Execute nwmodunsnag(line) to release.\n");
        taskDelay (600);
    }
    logMsg ( "............... Debug Snag Released.\n");
}


void nwmodunsnag(unsigned short line)
{
    snag [line] = FALSE;
}



int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
	    resPutLocalState (prestable [ln], 0); /* free up state to allow partner to take over */
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER  (unsigned short line,      /* the line number of this driver.                      */
                  unsigned short port,      /* the port used by the redundant memory sharing logic. */
                  char *mode,               /* UART initializations string (comma delimited ascii). */
                  unsigned short delay,     /* intermessage delay value, expressed in ticks.        */
                  unsigned short hdflag,    /* half duplex flag. 1=half duplex mode, 1!=full duplex */
                  unsigned short delay1,    /* half duplex post RTS assert, pre TX delay.           */
                  unsigned short delay2,    /* half duplex post TX, pre RTS drop delay.             */
                  unsigned short private)   /* private flag. if 0, normal. if !0, no partner driver.*/

{
	if (line < MODLINES)
	{
	    taskId [line] = taskSpawn (tasknames [line],
                                     MOD_PRIORITY,
                                     MOD_TASK_OPTIONS,
                                     MOD_STACK,
                                     MAIN,
                                     line,
                                     port,
                                     mode,
                                     delay,
                                     hdflag,
                                     delay1,
                                     delay2,
                                     private);

	    logMsg ("Started the North Wales Special Modicon driver on line %d\n",line);

	    remCurIdGet (user,password);
	    return (1);
	}
	else
	{

	    logMsg ("Invalid line number %d\n", line);
	    return (-1);
	}
}

/********
/*
/* Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1,
              unsigned short hdflag,
              unsigned short tickcount2,
              unsigned short tickcount3)
{
	intermsgdelay [line] = tickcount1;  /* at beginning new message/response sequence.               */
	halfduplex [line]    = hdflag;
	pretxdelay [line]    = tickcount2;  /* after asserting RTS but before beginning transmission.    */
	posttxdelay [line]   = tickcount3;  /* after sending last character but before dropping RTS.     */
}

int ASSIGNGROUP (unsigned short line, unsigned short group)
{
    if (line < MODLINES)
    {
        if (group <= MAXGROUPNUM)
        {
            nwmodResGroups [line] = group;
            logMsg ("Assigned Line %d to Group %d\n", line, group);
            return (1);
        }
        else
        {
            logMsg ("Invalid Group Assignment: line %d: group number must be less than %d.\n", line, MAXGROUPNUM+1);
            return (-1);
        }
    }
    else
    {
        logMsg ("Invalid Group Assignment: line %d: line number must be less than %d\n", line, MODLINES);
        return (-1);
    }
}

void nwmodgrouptable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager:  North Wales Modbus Driver Line to Group Map Table\n");
    printf (" -----------------------------------------------------------------------\n");
    printf ("  Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp   Ln:Grp \n");

    x = 8;
    y = MODLINES/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d  ",
                    index/10,
                    index%10,
                    nwmodResGroups [index]/10,
                    nwmodResGroups [index]%10);
        }
        printf ("\n");
    }
}

void nwmodlocktable (void)
{
    unsigned short x, y, i, j, index;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Grp:Flg   Grp:Flg   Grp:Flg   Grp:Flg\n");

    x = 4;
    y = MAXGROUPNUM/x;

    for (i = 0; i < y; i++)
    {
        for (j = 0; j < x; j++)
        {
            index = i + j*y;
            printf ("  %d%d:%d%d   ",
                    (index+1)/10,
                    (index+1)%10,
                    resGroupLock [index]/10,
                    resGroupLock [index]%10);
        }
        printf ("\n");
    }
}

void nwmodlockall (void)
{
    unsigned short i;

    printf (" Resource Group Lock Manager Global Array\n");
    printf (" ----------------------------------------\n");
    printf ("  Group  Flag  Trip Name\n");
    for (i = 0; i < MAXGROUPNUM; i++)
    {
        printf ("   %d%d     %d%d",
                    (i+1)/10,
                    (i+1)%10,
                    resGroupLock [i]/10,
                    resGroupLock [i]%10);
        if (resGroupTripName[i])
        {
            printf ("   %s\n", *resGroupTripName[i]);
        }
        else
        {
            printf ("\n");
        }
    }
}

void nwmodsetlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Setting Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 1;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1);
    }
}

void nwmodclrlock (unsigned short group)
{
    if (group <= MAXGROUPNUM)
    {
        printf ("Clearing Resource Lock Flag for Group %d.\n", group);
        taskDelay(60);
        resGroupLock [group -1] = 0;
    }
    else
    {
        logMsg ("Invalid Group %d: group number must be less than %d.\n", group, MAXGROUPNUM+1);
    }
}

void nwmodgrouphelp (void)
{
    printf (" North Wales Modicon Driver Group Related Functions\n");
    printf ("\n");
    printf (" nwmodResGroup(N, G)     Assign line N to group G (valid G range is 1 to 16)         \n");
    printf (" nwmodgrouptable         Display the Nwmos's line to group assignment table.    \n");
    printf (" nwmodlocktable          Display the resource group lock Global Array.               \n");
    printf (" nwmodlockall            Display the resource group lock and trip name Global Array. \n");
    printf (" nwmodsetlock (G)        Set the resource group lock for group G. (1 to 16)          \n");
    printf (" nwmodclrlock (G)        Clear the resource group lock for group G. (1 to 16)        \n");
    printf (" nwmodgrouphelp          Display this help message.                                  \n");
    printf ("\n");
}


/********
/*
/* Show Driver Info and Current State Information */ 
/*
********/
void SHOWINFO (unsigned short line)
{
    printf ("intermsgdelay [%d]  = %d\n", line, intermsgdelay[line]);
    printf ("halfduplex [%d]     = %d\n", line, halfduplex[line]);
    printf ("pretxdelay [%d]     = %d\n", line, pretxdelay[line]);
    printf ("posttxdelay [%d]    = %d\n", line, posttxdelay[line]);
    printf ("pryvate [%d]        = %d\n", line, pryvate[line]);
    printf ("resresponse [%d]    = %d\n", line, resresponse[line]);
    printf ("activity_time [%d]  = %d\n", line, activity_time[line]);
    printf ("line_activity [%d]  = %d\n", line, line_activity[line]);
    printf ("lastactivity [%d]   = %d\n", line, lastactivity[line]);
    printf ("modtrace [%d]       = %d\n", line, modtrace[line]);
    printf ("mltrace [%d]        = %d\n", line, mltrace[line]);
    printf ("modrestrace [%d]    = %d\n", line, modrestrace[line]);
    printf ("trace [%d]          = %d\n", line, trace[line]);
    printf ("\n");
    printf ("maxhtread [%d]      = %d\n", line, maxhtread[line]);
    printf ("maxidwrite [%d]     = %d\n", line, maxidwrite[line]);
    printf ("threetryflag  [%d]  = %d\n", line, threetryflag);
    printf ("\n");
    printf ("htdebug [%d]        = %d\n", line, htdebug [line]);
    printf ("fakeSinbad [%d]     = %d\n", line, fakeSinbad [line]);
    printf ("trendactive [%d]    = %d\n", line, trendactive [line]);
    printf ("\n");
    printf ("maxonlinetime [%d]  = %d\n", line, maxonlinetime[line]);
    printf ("maxtrendtime [%d]   = %d\n", line, maxtrendtime[line]);
    printf ("totaloffset [%d]    = %d\n", line, totaloffset[line]);
    printf ("onlineoffset [%d]   = %d\n", line, onlineoffset[line]);
    printf ("scanoffset [%d]     = %d\n", line, scanoffset[line]);
    printf ("idoffset [%d]       = %d\n", line, idoffset[line]);
    printf ("htoffset [%d]       = %d\n", line, htoffset[line]);
}


/*
/*      MOD_driver
/*
/*      The purpose of this task is to scan the modbus plc
/*      lines. It will maintain a configuration list supporting online additions
/*      and replacement of modules, and maintain a table of most recently
/*      scanned values.
/*
*/                                                                                     	
/* not called from within this driver 	*/

void MAIN (unsigned short line,
           unsigned short port,
           unsigned char *mode,
           unsigned short delay,
           unsigned short hdflag,
           unsigned short delay1,
           unsigned short delay2,
           unsigned short private)
{
	unsigned short  mod, cfgchk, cnt, modspolled, onlinefreq;
	unsigned short  activity, pstate, lstate, execute, command, i;
        unsigned short  iddownloadcount;
	long	        this_time, last_time;
	MODPLC          *pmod;
	RXLINE          *rxp;
        unsigned int    temptick, tempdiff, elapsestart, elapsetick, elapsediff;
        int             temp;
        unsigned short  group;
        unsigned char  *modestring;

        /* Initialize the data structures */
        intermsgdelay [line] = delay;

	halfduplex [line]  = hdflag;
	pretxdelay [line]  = delay1;
	posttxdelay [line] = delay2;
        pryvate [line]     = private;

	linfo [line].loading = FALSE;

	resresponse [line] = FALSE;
	resnames [line] [0] = 0;
	prestable [line] = NULL;

	activity_time [line] = tickGet ();
	lastactivity [line] = line_activity [line] = FALSE;

        pstatewait[line] = 60;      /* will wait up to one minute for partner to become valid */

        /* initialize default time base for historical trending */
        secondspernickel = SECONDSPERNICKEL;

        /* set maximum number of words to send on each download of the User ID List */
        nwmodmaxidwrite (line, DEFAULTIDREGCOUNT);

        /* initialize default maximum number of HT regs requested from PLC */
        nwmodmaxhtread (line, DEFAULTFETCHCOUNT);

        /* initialize Historic Trend Retrieval Function into Real Mode */
        nwmodclearpseudo (line);
        nwmodsettrending (line, 0);

        /* debug structures */
        DEFAULTTRACE (line);

        /* turn off all debug tracing */
        nwmodhtdebug   (line, 2);
        nwmodreddebug  (line, 2);
        nwmodloopdebug (line, 0);

        /* always retry online attempts */
        nwmodonlineretryon (line);

        /* intialize the max online retry window length */
        nwmodonlinetime (line, DEFAULTONLINETIME);

        /* intialize the max historic trend and ID list download window length */
        nwmodtrendtime (line, DEFAULTTRENDTIME);

        tick [line] [0] = tick [line] [1] = tick [line] [2] = tick [line] [3] = 0;

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].RXbadcount = 0;
	linestats [line].msgxfercount = 0;
        linestats [line].startingtick = tickGet ();

        modsim [line] = FALSE;              /* start with normal operation. */

        /* output queue initialization */
	oq [line] = (OUTPUTQUE *) calloc (1, (sizeof (OUTPUTQUE)));
	if (!oq [line])
	{
	    logMsg ("Not enough memory for data structure (data output queue)\n");
	    return;
	}
        outqueinit (line);

        /* communication initialization */
	rxlinetab [line] = (RXLINE *) calloc (1, (sizeof (RXLINE)));
	if (!rxlinetab [line])
	{
	    logMsg ("Not enough memory for data structure (comm: rx)\n");
	    return;
	}
	txlinetab [line] = (TXLINE *) calloc (1, (sizeof (TXLINE)));
	if (!txlinetab [line])
	{
	    logMsg ("Not enough memory for data structure (comm: tx)\n");
	    return;
	}

        /*******************************************************************/
        /* modestring used to avoid messing with the original mode pointer */
        logMsg ( "Comm Mode String = '%s'\n", mode);
        modestring = mode;

        taskLock ();  /* make terminal display easier to read - avoids interleaving of other task data */
	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
        taskUnlock ();

        /*******************************************************************/
        /* modestring used to avoid messing with the original mode pointer */
        logMsg ( "Comm Mode String = '%s'\n", mode);
        baudrate[line] = 0;
        modestring = mode;
        for (i = 0; i < 6; i++)
        {
            if (*modestring == ',') break;
            if ((*modestring < '0') || (*modestring > '9'))
            {
                modestring++;
                continue;
            }
            baudrate [line] = (baudrate [line] * 10) + (*modestring++ - '0');
        }

	/* Initialize the Rx interrupts to receive once for activity check         */
	/* enable the receiver interrupt after set to ignore                       */
	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
	enable_rx_ints (line);

        /* Initialize the line communication semaphores */
        semids [line] [0] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);
        semids [line] [1] = semBCreate (SEM_Q_PRIORITY, SEM_EMPTY);

        tsLocalTime (&timenow [line]);
	/* Wait for epics time to be initialized.  */
	while (timenow [line].secPastEpoch < 100000)
	{
            if (modrestrace [line] > 1)
	    {
	    	logMsg ( "Waiting for EPICS Time to initialize.....\n");
	    }
	    taskDelay (600);
            tsLocalTime (&timenow [line]);
	}

        /*****************************************************/
        /* open the idlist.txt file and build download table */
        logMsg("Beginning idlist loading....\n");
        taskDelay (60);
        if (!loadidfile(line))
        {
            logMsg("Warning: Error Loading User ID File.\n");
            taskDelay (10*60);
        }
        else
        {
            logMsg("......... idlist loading completed.\n");
            taskDelay (2*60);
        }
        taskDelay (60);

        /****************************************************************************/
        /* open the historic trend configuration file and build configuration table */
        logMsg("Beginning Historic Trend Configuration File loading....\n");
        taskDelay (60);
        if (!loadhtfile(line))
        {
            logMsg("Warning: Error Loading Historic Trend Configuration File.\n");
            taskDelay (10*60);
        }
        else
        {
            logMsg("......... Historic Trend Configuration File completed.\n");
            taskDelay (2*60);
        }

        /**********************************/
        /* htmap structure initialization */
	htmaptable [line] = (LOADHTMAP *) calloc (1, (sizeof (LOADHTMAP)));
	if (!htmaptable [line])
	{
	    logMsg ("Not enough memory for data structure (htmap)\n");
	    return;
	}
        htmaptableinit (line);


        maptogo [line] = FALSE;
        /************************************************/
        /* start the historic trend map file write task */
        taskId [line] = taskSpawn (maptasknames [line],
                                  MOD_PRIORITY,
                                  MOD_TASK_OPTIONS,
                                  MOD_STACK,
                                  nwmod_mapmon,
                                  line);

        logMsg ("Started the North Wales Special Map Monitor for line %d\n",line);


        /********************************************************/
        /* open the historic trend map file and fill in the map */
        logMsg("Beginning Historic Trend Map File loading....\n");
        taskDelay (60);
        if (!loadmapfile(line))
        {
            logMsg("Warning: Error Loading Historic Trend Map File.\n");
            logMsg("Warning: A New Trend Map File will now be written.\n");
            taskDelay (1*60);
            htmaptableinit (line);
            storemapfile (line); 
            taskDelay (2*60);
        }
        else
        {
            fixmaptable (line);
            logMsg("......... Historic Trend Map File loading completed.\n");
            taskDelay (2*60);
        }

        htrendupdate (line); /* keep HT map structure current */

        /********************************************************************************/
	/* Wait for resource to be defined via an initial call to 'register_resource'.  */
	while ((resnames [line] [0] == 0) || (prestable [line] == NULL))
	{
            if (modrestrace [line] > 1)
	    {
	    	logMsg ( "Waiting for resource to be defined ....\n");
	    }
	    taskDelay (600);
	}

        /********************************************************/
        /*******************************************************************************/
        /* Register the redundant slave update routine and initialize data structures. */
        /*******************************************************************************/
        for (i = 0; i < NUMRED; i++)
        {
            /**************************************/
            /* redundant structure initialization */
            redund [line][i] = (NWMODREDUPD *) calloc (1, (sizeof (NWMODREDUPD)));
            if (!redund [line][i])
            {
                logMsg ("Not enough memory for data structure (redund[%d][%d])\n", line, i);
                return;
            }
            /* no initialization done for redund table */

            redsize [line][i]        = sizeof (NWMODREDUPD);
            Nwmodredport [line][i]   = port+i;
            Nwmodredperiod [line][i] = 60*60; /* 60 seconds */

            switch (i)
            {
                case 0:
                    initRedDriverData (&resnames [line], redund [line][i],
                                       &redsize [line][i], (FUNCPTR) slave_updateredimage0,
                                       line, Nwmodredperiod [line][i], Nwmodredport[line][i],
                                       &redsemids [line][i]);
                    break;
                case 1:
                    initRedDriverData (&resnames [line], redund [line][i],
                                       &redsize [line][i], (FUNCPTR) slave_updateredimage1,
                                       line, Nwmodredperiod [line][i], Nwmodredport[line][i],
                                       &redsemids [line][i]);
                    break;
                case 2:
                    initRedDriverData (&resnames [line], redund [line][i],
                                       &redsize [line][i], (FUNCPTR) slave_updateredimage2,
                                       line, Nwmodredperiod [line][i], Nwmodredport[line][i],
                                       &redsemids [line][i]);
                    break;

                case 3:
                    initRedDriverData (&resnames [line], redund [line][i],
                                       &redsize [line][i], (FUNCPTR) slave_updateredimage3,
                                       line, Nwmodredperiod [line][i], Nwmodredport[line][i],
                                       &redsemids [line][i]);
                    break;

            }
        }

        /************************************/
        /************************************/
        /* redundant structure for id table */
        i = NUMRED;

        redundid [line] = (NWMODREDIDUPD *) calloc (1, (sizeof (NWMODREDIDUPD)));
        if (!redundid [line])
        {
            logMsg ("Not enough memory for data structure (redundid[%d])\n", line);
            return;
        }

        redsize [line][i]        = sizeof (NWMODREDIDUPD);
        Nwmodredport [line][i]   = port+i;
        Nwmodredperiod [line][i] = 60*60; /* 60 seconds */

        initRedDriverData (&resnames [line], redundid [line],
                           &redsize [line][i], (FUNCPTR) slave_updateredidimage,
                           line, Nwmodredperiod [line][i], Nwmodredport[line][i],
                           &redsemids [line][i]);

        /************************************/
        /************************************/


        if (pryvate [line])
        {
            /*****************************/
	    /* Immediately become master */
            /*****************************/

	    resSetCaAnswer (prestable [line]);
	    resPutLocalState (prestable [line], RES_MSTR);

            lastscan [line] = tickGet ();
            scantime [line]   = 0;
            totaloffset [line]  = 0;
            onlineoffset [line] = 0;
            scanoffset [line]   = 0;
            idoffset [line]     = 0;
            htoffset [line]     = 0;

	    lstate = RES_MSTR;
	    if (modrestrace [line])
	    {
	    	logMsg ("0] Private: Initialize as RES_MSTR\n");
	    }
        }
        else /* this is the 'normal' path */
        {
            /**********************/
            /* Start out as slave */

            resClearCaAnswer (prestable [line]);		/* start quiet */
            resPutLocalState (prestable [line], RES_SLV);

            if (modrestrace [line])
            {
                logMsg ("1] Initialized as RES_SLV\n");
            }

            /* wait finite time for pstate to be resolved */
            logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
            for (i = 0; i <= pstatewait [line]; i++)
            {
                resGetStates (prestable [line], &lstate, &pstate);
                if (pstate != 0)
                {
	            break;
                }
                taskDelay (60);
            }
            if (pstate == 0)
            {
                logMsg ("Timeout of pstate wait.\n");
            }
            else
            {
                logMsg ("Completion of pstate wait.\n");
            }

            for (i = 0; i < ACTIVITYTIME/10; i++) ;  /* ten seconds */
            {
                taskDelay(10);
            }

            activity = check_line_activity(line, 0);
            resGetStates (prestable [line], &lstate, &pstate);

            /******************************************/
            /* if the partner is not there, be master */

            if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
            {
                resSetCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_MSTR);
                lastscan [line] = tickGet ();
                scantime [line]   = 0;
                totaloffset [line]  = 0;
                onlineoffset [line] = 0;
                scanoffset [line]   = 0;
                idoffset [line]     = 0;
                htoffset [line]     = 0;

                lstate = RES_MSTR;
                if (modrestrace [line])
                {
                    logMsg ("2] Became RES_MSTR   P= %x A= %d \n", pstate, activity);
                }
            }
        }

	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet (); /* Initialize the time  */


	while (TRUE)
	{
	    activity_time [line] = tickGet ();
	    lastactivity [line] = line_activity [line] = FALSE;

            /************************************/
            /* check for line group disablement */
            /************************************/
            group = nwmodResGroups [line];
            if ((group) && (resGroupLock [group-1]))
            {
                if (modrestrace [line])
                {
                    logMsg ("13] Forced to RES_SLV.\n");
                }
                resClearCaAnswer (prestable [line]);
                resPutLocalState (prestable [line], RES_SLV);
                lstate = RES_SLV;
                resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */
                if (modrestrace [line])
                {
                    logMsg ("14] Resource Group Locked     P= %x A= %d \n", pstate, activity);
                }
                while (resGroupLock [group-1])
                {
                    group = nwmodResGroups [line];
                    if (group)
                    {
                        clear_rts (line); 		/* Make sure line is left for master    */
                        taskDelay (2);
                    }
                    else /* the line has been taken out of the group */
                    {
                        break;
                    }
                }
                if (modrestrace [line])
                {
                    logMsg ("15] Resource Group Unlocked   P= %x A= %d \n", pstate, activity);
                    logMsg ("16] Released to RES_SLV.\n");
                }
            }

            /********************************************************************************************/
	    /* we arrive here because we are a slave.                                                   */
	    /* we stay until:   asked to be master by partner. if we can reach PLCs, we become master.  */
            /*                  the partner is not master and there is no activity on the line.         */
            /********************************************************************************************/

	    while (lstate == RES_SLV)
	    {
                /* check for plc simulated mode. */
                if (modsim [line])
                {
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line]   = 0;
                    totaloffset [line]  = 0;
                    onlineoffset [line] = 0;
                    scanoffset [line]   = 0;
                    idoffset [line]     = 0;
                    htoffset [line]     = 0;

		    if (modrestrace [line])
		    {
                        logMsg ("Simulation Mode] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
		    break;
                }

		if (pstate != RES_SLVWANT)
		{
		    clear_rts (line); 				/* make sure line is left for master 	*/
		}
		resresponse [line] = FALSE; 			/* make sure driver is not responding 	*/
		resPutCommand (prestable [line], 0); 		/* clear out commands 			*/
		activity = check_line_activity (line, 10); 	/* wait 10 seconds before checking 	*/
		resGetStates (prestable [line], &lstate, &pstate);

                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 17)) break;

                /****************************************************************************************/
		/* see if needed by partner to be master. if yes, do it and break out of slave state.   */
		if (pstate == RES_SLVWANTCA)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line]     = tickGet ();
                    scantime [line]     = 0;
                    totaloffset [line]  = 0;
                    onlineoffset [line] = 0;
                    scanoffset [line]   = 0;
                    idoffset [line]     = 0;
                    htoffset [line]     = 0;

		    if (modrestrace [line])
		    {
			logMsg ("3] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
		    }
		    break;
		}
                /***************************************************************/
		/* If partner is there and wants to give it up, try to take it */

		if (pstate == RES_SLVWANT)
		{
		    execute = FALSE;
		    taskDelay (2); /* Time for switch to occur */

		    /* See if anyone is out there and able to respond to a loopback command */
		    for (mod = 1; (mod <= NUMMODPLCS); mod++)
		    {
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 18)) break;

                        resGetStates (prestable [line], &lstate, &pstate);
                        if (pstate != RES_SLVWANT) break;

			pmod = plcs [line] [mod];
			if ((pmod) &&			/* verify pointer validity prior to use */
			    (pmod->was_requested) &&    /* data points have been requested      */
                            (!pmod->cmd_force_offline)) /* user has NOT forced plc offline      */
			{
			    slave_on_line (line, mod);
                            /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                            if ((pmod->is_responding) && (!pmod->cmd_force_offline))
			    {
				execute = TRUE;
				break;
			    }
			}
		    }
                    /************************************/
                    /* check for line group disablement */
                    if (checkgroup (line, &lstate, 19)) break;

		    /* If someone answered, become master and make sure partner really gave it up */
		    if (execute)
		    {
			resPutLocalState (prestable [line], RES_MSTR);
			lstate = RES_MSTR;

                        lastscan [line] = tickGet ();
                        scantime [line]   = 0;
                        totaloffset [line]  = 0;
                        onlineoffset [line] = 0;
                        scanoffset [line]   = 0;
                        idoffset [line]     = 0;
                        htoffset [line]     = 0;

			if (modrestrace [line])
			{
				logMsg ("4] Became RES_MSTR  P= %x A= %d \n", pstate, activity);
			}
                        execute = FALSE;
			activity_time [line] = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;

                        /* 1-13-98: delay added to keep the master/slave transition from bouncing. */
                        activity = check_line_activity (line, 3*60);
                        resGetStates (prestable [line], &lstate, &pstate);
			if (modrestrace [line])
			{
				logMsg ("4] Confirming RES_MSTR  P= %x A= %d \n", pstate, activity);
			}

			for (i = 0; (i < 60); i++)
			{
			    activity = check_line_activity (line, 2); /* pause before testing */
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
			    {
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up go back to slave */
			    resPutLocalState (prestable [line], RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace [line])
			    {
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
			    }
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 
			    resSetCaAnswer (prestable [line]);
			    prepresponses (line);
			    break;
			}
		    }
		}

                /********************************************/
		/* if the partner is not talking, be master */

		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;

                    lastscan [line] = tickGet ();
                    scantime [line]   = 0;
                    totaloffset [line]  = 0;
                    onlineoffset [line] = 0;
                    scanoffset [line]   = 0;
                    idoffset [line]     = 0;
                    htoffset [line]     = 0;

		    if (modrestrace [line])
		    {
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n",pstate,activity);
		    }
		    prepresponses (line);
		}
	    }

            /****************************************************************************************/
            /* to arrive here, we used to be master, and had been told to relinquish master status. */
	    /* stay in this loop until the partner takes over, or the command is canceled */
	    while (lstate == RES_SLVWANTCA)
	    {
	        taskDelay (2);                   /* Give OS a chance...  */

                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 20)) break;

		clear_rts (line); 		/* Make sure line is left for master    */
		resresponse [line] = FALSE; 	/* Make Sure driver is not responding   */

		resGetStates (prestable [line], &lstate, &pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace [line])
		    {
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}
		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
		    resSetCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace [line])
		    {
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
		    }
		    prepresponses (line);
		}
	    }

            /****************************************************************************************/
	    /* in normal operation this code should never execute. it has, however, been seen to    */
            /* execute when the database has been inadvertently configured with the same resource   */
	    /* assigned to two different drivers in the same IOC. The state does funny things.      */
            /****************************************************************************************/
	    while (lstate == RES_SLVWANT)
	    {
                /************************************/
                /* check for line group disablement */
                if (checkgroup (line, &lstate, 21)) break;

                if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))
		{
                    /* condition should NEVER occur. print error message every 5 seconds. */
                    logMsg ("Illegal Local Resource State.\n");
                    if (trace[line] & CONFIGURATIONTRACE)
                    {
                        logMsg ("  Possible Resource Configuration Error:\n");
                        logMsg ("   Check for multiple drivers sharing single Resource.\n");
                    }
                    taskDelay (600);
                }
                taskDelay (2);
            }
            /****************************************************************************************/
            /* we come here because we have gone to, or are looping in, the master state.           */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner.  */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
	    /* It will then try to configure requested non-responding modules.                      */
            /****************************************************************************************/

	    last_time = tickGet ();		/* initialize gap */
	    while (lstate == RES_MSTR)
	    {

		if (mltrace [line] == 1)
		{
			logMsg ( "Top of Master Loop... \n");
	        }

		/* initial stuff */
		resresponse [line] = TRUE; /* Make sure driver is responding. driver won't           */
                                           /* issue commands if not set.                             */
                elapsetick = tickGet ();
                elapsediff = elapsetick - elapsestart;

/************************************/
/* Action Minus Two: Simulate Mode. */
/************************************/
if (loopdebug [line] >= 14)
{
    printf ("*********************************************************************\n");
    printf ("Main: Action Minus Two: Simulate Mode............................... Elapsed Time: %d:%1d%1d\n",
             elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
    printf ("**********************************************************************\n");
}


                /* check for plc simulated mode. */
                while (modsim [line])
                {
                    htrendupdate (line); /* keep HT map structure current */

		    resresponse [line] = TRUE; /* Make sure driver is responding. driver won't         */
		    for (mod = 1; (mod <= NUMMODPLCS); mod++)
		    {
		        pmod = plcs [line] [mod];	/* shorthand pointer 			*/
		        if (pmod)			/* verify pointer validity prior to use */
		        {
                            /************************************/
                            /* check for line group disablement */
                            if (checkgroup (line, &lstate, 22)) break;

			    if (pmod->cmd_force_offline)
			    { 
				/* if user has turned this plc offline via pseudo commands,     */
                                /* mark it as not responding.                                   */
 				pmod->is_responding = FALSE;
	    		    }
			    else
			    {
				sim_plc (pmod, line, mod);      /* I/O done here! 		*/
		   		taskDelay (simdelay [line]);			    }
			}
		    }
                    /************************************/
                    /* test for line group disablement. */
                    if (lstate == RES_LOCKED) break;
                }

                elapsetick = tickGet ();
                elapsediff = elapsetick - elapsestart;

/********************************************/
/* Action Minus One: Check Exit Conditions. */
/********************************************/
if (loopdebug [line] >= 14)
{
    printf ("*********************************************************************\n");
    printf ("Main: Action Minus One: Check Exit Conditions....................... Elapsed Time: %d:%1d%1d\n",
             elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
    printf ("*********************************************************************\n");
}


                /* test for line group disablement. */
                if (lstate == RES_LOCKED) break;

		resGetCommand (prestable [line], &command);
		resPutCommand (prestable [line], 0);        /* clear out commands */

                /************************************************************************/
		/* if relinquish command sent, change state and break out to outer loop */
		if (command == RES_RELINQUISH)
		{
		    resClearCaAnswer (prestable [line]);
		    resPutLocalState (prestable [line], RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace [line])
		    {
                       logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
		    }
		    break;
		}

                elapsetick = tickGet ();
                elapsediff = elapsetick - elapsestart;

/***********************************************************/
/***********************************************************/
/* Action Zero: Initialize Variables and Print Diagnostics */
/***********************************************************/
/***********************************************************/
if (loopdebug [line] >= 14)
{
    printf ("*********************************************************************\n");
    printf ("Main: Action Zero: Initialize Variables and Print Diagnostics....... Elapsed Time: %d:%1d%1d\n",
             elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
    printf ("*********************************************************************\n");
}

                if (modtrace [line])
		{
                    logMsg ("Scan Time:%4d, # OutputMsgs =%5d, # TotalMsgs =%3d\n",
                            scantime [line], loopoutmsgs[line], loopmsgs[line]);
		}

                totaloffset[line] =  onlineoffset [line] + scanoffset [line] + idoffset [line] + htoffset [line];

                if (modtrace [line])
		{
                    logMsg ("OnlineDel:%4d,   ScanDel:%4d,   IDDel:%4d,   HTDel:%4d\n",
                            onlineoffset [line],
                             scanoffset [line] - onlineoffset [line],
                             idoffset [line] - scanoffset [line],
                             htoffset [line] - idoffset [line]);
                    logMsg ("OnlineOff:%4d,   ScanOff:%4d,   IDOff:%4d,   HTOff:%4d\n",
                            onlineoffset [line],
                            scanoffset [line],
                            idoffset [line],
                            htoffset [line]);
		}

                loopoutmsgs [line] = 0;
                loopmsgs [line] = 0;
                lastscan [line] = temptick;

                elapsestart = tickGet ();
                elapsediff = 0;

/*********************************/
/* Action One: Bring PLCs OnLine */
/*********************************/
if (loopdebug [line] >= 10)
{
    printf ("*********************************************************************\n");
    printf ("Main: Action One: Bring PLCs OnLine................................. Elapsed Time: %d:%1d%1d\n",
             elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
    printf ("*********************************************************************\n");
}
		/* try and bring all nonresponding plcs on line, but only once. */
                for (mod = 1; (mod <= NUMMODPLCS); mod++)
                {
                    /************************************/
                    /* check for line group disablement */
                    if (checkgroup (line, &lstate, 24)) break;

                    cfgchk++;		/* manage plc index */
                    if (cfgchk == NUMMODPLCS + 1)
                    {
                        cfgchk=1;	/* wrap plc index */
                    }
                    pmod = plcs [line] [cfgchk];
                    if ((pmod) &&		/* verify pointer validity prior to use*/
                        (!pmod->is_responding) &&
                        (pmod->was_requested) &&
                        (!pmod->cmd_force_offline))
                    {
                        /* calculate intermediate elapsed time */
                        elapsetick = tickGet ();
                        elapsediff = elapsetick - elapsestart;
                        if (loopdebug [line] >= 12)
                        {
                            printf ("*********************************************************************\n");
                            printf ("Main: Action One: Trying PLC %2d..................................... Elapsed Time: %d:%1d%1d\n", cfgchk,
                                     elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
                            printf ("*********************************************************************\n");
                        }
                        on_line (line, cfgchk);	/* loopback testing done here! 	 */
                    }
                    /* local/partner lockstep recovery */
                    resGetStates (prestable [line], &lstate, &pstate);
                    if ((pstate == RES_MSTR) && (!pryvate[line]))
                    {
                        resClearCaAnswer (prestable [line]);
                        resPutLocalState (prestable [line], RES_SLV);
                        lstate = RES_SLV;
                        clear_rts (line); 		/* Make sure line is left for master */
                        if (modrestrace [line])
                        {
                            logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                        }
                        temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                        for ( i = 0; i < temp; i++)
                        {
                            taskDelay(60);
                        }
                        break;
                    }
                    /******************/
                    checkoutputs (line);
                    /**************************************************************************/
                    /* measure time from top of loop, and stop online efforts if out of time. */
                    elapsetick = tickGet ();
                    elapsediff = elapsetick - elapsestart;
                    if (elapsediff >= maxonlinetime [line])
                    {
                        if (loopdebug [line] >= 6)
                        {
                            printf ("*********************************************************************\n");
                            printf ("Main: Action One: Out Of Time ....... Stopping...................... Elapsed Time: %d:%1d%1d   MaxOnlineTime: %d\n",
                                     elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10), maxonlinetime [line];
                            printf ("*********************************************************************\n");
                        }
                        break;
                    }
                }
                /* preserve the time through the online routine. */
                onlineoffset[line] = elapsediff;

                /* test for lockstep detection. */
                if (lstate == RES_SLV) break;
                /* test for line group disablement. */
                if (lstate == RES_LOCKED) break;


                /* measure time between scans of the entire set of plcs. display if requested. */ 
                temptick = tickGet ();
                tempdiff = temptick - lastscan [line];

/*************************/
/* Action Two: Scan PLCs */
/*************************/
if (loopdebug [line] >= 10)
{
    printf ("*********************************************************************\n");
    printf ("Main: Action Two: Scan PLCs......................................... Elapsed Time: %d:%1d%1d\n",
             elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
    printf ("*********************************************************************\n");
}

		/* call 'scan_plc' for each PLC device, unless user has */
                /* taken it off line or it is not responding.           */
		for (mod = 1; (mod <= NUMMODPLCS); mod++)
		{
		    pmod = plcs [line] [mod];		/* shorthand pointer 			*/
		    if (pmod)				/* verify pointer validity prior to use */
		    {
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 23)) break;

			if (pmod->cmd_force_offline)
			{ 
			    /* if user has turned this plc offline via pseudo commands,     */
                            /* mark it as not responding.                                   */
 			    pmod->is_responding = FALSE;
	    		}
			else if (pmod->is_responding)
			{
                            /* local/partner lockstep recovery */
                            resGetStates (prestable [line], &lstate, &pstate);
                            if ((pstate == RES_MSTR) && (!pryvate[line]))
                            {
                                resClearCaAnswer (prestable [line]);
                                resPutLocalState (prestable [line], RES_SLV);
                                lstate = RES_SLV;
                                clear_rts (line); 		/* Make sure line is left for master */
                                if (modrestrace [line])
				{
                                    logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
				}
                                temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                                for ( i = 0; i < temp; i++)
                                {
                                   taskDelay(60);
                                }
                                break;
                            }
                            /* calculate intermediate elapsed time */
                            elapsetick = tickGet ();
                            elapsediff = elapsetick - elapsestart;
                            if (loopdebug [line] >= 12)
                            {
                                printf ("*********************************************************************\n");
                                printf ("Main: Action Two: Scanning PLC %2d................................... Elapsed Time: %d:%1d%1d\n", mod,
                                         elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
                                printf ("*********************************************************************\n");
                            }

                            htrendupdate (line);               /* keep HT map structure current    */
			    scan_plc (pmod, line, mod);        /* I/O done here! 	           */

                            /* update image to be sent to redundant (slave) partner. */
                            master_updateredimages (line);

			    if (!pmod->is_responding)
			    {
				mark_not_valid (pmod);
                            }
                            else
                            {
                                /* North Wales Special: BOREAD related valdity is transitory */
                                manage_coil_validity (pmod);
                            }
			}
		    }
		    /* end of single module action */

		    /* if told to relinquish our master state, stop plc scanning immediately. */
		    /* don't trash the command, so that we can still read it on the next loop */
                    /* through this while statement.                                          */
		    resGetCommand (prestable [line], &command);
		    if (command == RES_RELINQUISH)
		    {
			break;
		    }
		} /* end of scan loop */

                /* test for lockstep detection. */
                if (lstate == RES_SLV) break;
                /* test for line group disablement. */
                if (lstate == RES_LOCKED) break;

                /* measure how long the scan took. to be displayed at beginning of next loop. */
                temptick = tickGet ();
                scantime [line] = temptick - lastscan [line];

                /* update image to be sent to redundant (slave) partner. */
                master_updateredimages (line);

                /**************************************************************************/
                /* measure time from top of loop, and stop online efforts if out of time. */
                elapsetick = tickGet ();
                elapsediff = elapsetick - elapsestart;
                /* preserve the time through the online and scanplc routines. */
                scanoffset[line] = elapsediff;


/**********************************/
/* Action Three: ID List Download */
/**********************************/
if (loopdebug [line] >= 10)
{
    printf ("*********************************************************************\n");
    printf ("Main: Action Three: Check ID List Download.......................... Elapsed Time: %d:%1d%1d\n",
             elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
    printf ("*********************************************************************\n");
}

                /* Test to see if the User ID file needs to be reloaded, and if so, reload it. */
                checkidfile (line);

                iddownloadcount = 0;
		for (mod = 1; (mod <= NUMMODPLCS); mod++)
		{
		    pmod = plcs [line] [mod];		/* shorthand pointer 			*/
		    if (pmod)				/* verify pointer validity prior to use */
		    {
                        /************************************/
                        /* check for line group disablement */
                        if (checkgroup (line, &lstate, 23)) break;

			if (pmod->cmd_force_offline)
			{ 
			    /* if user has turned this plc offline via pseudo commands,     */
                            /* mark it as not responding.                                   */
 			    pmod->is_responding = FALSE;
	    		}
			else if (pmod->is_responding)
			{
                            /* local/partner lockstep recovery */
                            resGetStates (prestable [line], &lstate, &pstate);
                            if ((pstate == RES_MSTR) && (!pryvate[line]))
                            {
                                resClearCaAnswer (prestable [line]);
                                resPutLocalState (prestable [line], RES_SLV);
                                lstate = RES_SLV;
                                clear_rts (line); 		/* Make sure line is left for master */
                                if (modrestrace [line])
				{
                                    logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
				}
                                temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                                for ( i = 0; i < temp; i++)
                                {
                                   taskDelay(60);
                                }
                                break;
                            }
                            /* North Wales Special: Check for pending User ID List download. */
                            if (checkiddownload (line, mod, pmod))
                            {
                                /* calculate intermediate elapsed time */
                                elapsetick = tickGet ();
                                elapsediff = elapsetick - elapsestart;
                                if (loopdebug [line] >= 12)
                                {
                                    printf ("*********************************************************************\n");
                                    printf ("Main: Action Three: Finished Loading PLC %2d ID List................. Elapsed Time: %d:%1d%1d\n", mod,
                                             elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
                                    printf ("*********************************************************************\n");
                                }
                                iddownloadcount++;
                            }
			    if (!pmod->is_responding)
			    {
				mark_not_valid (pmod);
                            }
			}
		    }
		    /* end of single module action */

		    /* if told to relinquish our master state, stop id downloading immediately. */
		    /* don't trash the command, so that we can still read it on the next loop   */
                    /* through this while statement.                                            */
		    resGetCommand (prestable [line], &command);
		    if (command == RES_RELINQUISH)
		    {
			break;
		    }

                    /******************/
                    checkoutputs (line);

                    /* only look for early out if at least one has been done */
                    if (iddownloadcount)
                    {
                        /************************************************************************************/
                        /* measure time from top of loop, and stop id list download efforts if out of time. */
                        elapsetick = tickGet ();
                        elapsediff = elapsetick - elapsestart;
                        if (elapsediff >= maxtrendtime [line])
                        {
                            if (loopdebug [line] >= 6)
                            {
                                printf ("*********************************************************************\n");
                                printf ("Main: Action Three: Out Of Time ....... Stopping.................... Elapsed Time: %d:%1d%1d   MaxTrendTime: %d\n",
                                         elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10), maxtrendtime [line];
                                printf ("*********************************************************************\n");
                            }
                            break;
                        }
                    }
                }
                /* preserve the time through the online, scan, and id list download routines. */
                idoffset[line] = elapsediff;

                /* test for lockstep detection. */
                if (lstate == RES_SLV) break;
                /* test for line group disablement. */
                if (lstate == RES_LOCKED) break;


/*****************************************/
/* Action Four: Historic Trend Retrieval */
/*****************************************/
if (loopdebug [line] >= 10)
{
    printf ("*********************************************************************\n");
    printf ("Main: Action Four: Check Historic Trend Retrieval.................... Elapsed Time: %d:%1d%1d\n",
             elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
    printf ("*********************************************************************\n");
}

                htrendupdate (line);         /* keep HT map structure current */


                while (htrendcheck (line))   /**********************************************/
                {                            /* see if there is anything to be retrieved.  */
                                             /* if there is, htrendcheck will retrieve it. */
                                             /**********************************************/

                    taskDelay(1);
                    htrendupdate (line);     /* keep HT map structure current */

                    /******************/
                    checkoutputs (line);
                    /************************************************************************************/
                    /* measure time from top of loop, and stop id list download efforts if out of time. */
                    elapsetick = tickGet ();
                    elapsediff = elapsetick - elapsestart;
                    if (elapsediff >= maxtrendtime [line])
                    {
                        if (loopdebug [line] >= 6)
                        {
                            printf ("*********************************************************************\n");
                            printf ("Main: Action Four: Out Of Time ....... Stopping..................... Elapsed Time: %d:%1d%1d   MaxTrendTime: %d\n",
                                     elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10), maxtrendtime [line];
                            printf ("*********************************************************************\n");
                        }
                        break;
                    }
                    else
                    {
                        /* calculate intermediate elapsed time */
                        if (loopdebug [line] >= 12)
                        {
                             printf ("*********************************************************************\n");
                             printf ("Main: Action Four: Finished HT Fetch Attempt........................ Elapsed Time: %d:%1d%1d\n",
                                      elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
                             printf ("*********************************************************************\n");
                        }
                    }
                }
                /* preserve the time through the online, scan, id list download, and historical trend retrieval routines. */
                htoffset[line] = elapsediff;

                /************************************/
                /* test for line group disablement. */
                if (lstate == RES_LOCKED) break;


/*******************************************/
/* Action Five: Test For No One Responding */
/*******************************************/
if (loopdebug [line] >= 14)
{
    printf ("*********************************************************************\n");
    printf ("Main: Action Five: Test For No One Responding....................... Elapsed Time: %d:%1d%1d\n",
             elapsediff/(60*60), ((elapsediff%(60*60))/60)/10, ((elapsediff%(60*60))/60)%10);
    printf ("*********************************************************************\n");
}

		/* see if anyone on the line has been responding. */
                /* if not, try to get partner to become slave.    */
		/* Check for no one responding */

		if (!any_responding (line) && (!pryvate[line]))
		{
		    /* See if it is time to let partner try */

		    this_time = tickGet ();
		    if ((this_time - last_time) > (4 * SLWWINDOW)) /*  ((5-2) * 15) = 45 sec */
		    {   /* #ticks for slave to try */

			/* Switch States to let partner know it's its time to try */
			resPutLocalState (prestable [line], RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace [line])
			{
			    logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate, activity);
			}
			/* Give partner access to the hardware */
			clear_rts (line);

			/* Remember the time of this try */
			last_time = tickGet ();
			lastactivity [line] = line_activity [line] = FALSE;
			for (i = 0; (i < (SLWWINDOW * 2)); i += 10)
			{       		/* SLWINDOW is the # of ticks for slave to try */

                            /************************************/
                            /* check for line group disablement */
                            if (checkgroup (line, &lstate, 25)) break;

			    taskDelay (10);
		    				/* If partner picked up let it have control */
			    activity = check_line_activity (line, 0);  /* check immediately */
			    resGetStates (prestable [line], &lstate, &pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
			    {
				resClearCaAnswer (prestable [line]);
				resPutLocalState (prestable [line], RES_SLV);
				lstate = RES_SLV;
				if (modrestrace [line])
				{
				    logMsg ("11] Became RES_SLV  P= %x A= %d \n", pstate, activity);
				}
                                taskDelay(60);
                                taskDelay(60);
                                taskDelay(60);
                                taskDelay(60);
                                taskDelay(60);
				break;
			    }
			}

                        /************************************/
                        /* test for line group disablement. */
                        if (lstate == RES_LOCKED) break;

			/* Go Back to being the Master and take control of the hardware */
			if (lstate != RES_SLV)
			{
                            resSetCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace [line])
			    {
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
			    }
			}
		    }
		}

/*****************************************/
/* Action Six: Take PLCs Off Hold Status */
/*****************************************/


		/* take plcs off hold status. the plc's data are not to be held off since now master. */
		for (mod = 1; (mod <= NUMMODPLCS); mod++ )
		{
		    pmod = plcs [line] [mod];
		    if (pmod)			/* verify pointer validity prior to use */
		    {        
			pmod->holdflag = FALSE;
                    }
		}
                if (modspolled == 0)
		{
                   taskDelay(6);
		}
                else
		{
		    taskDelay(2);
		}
	    }
	} /* end infinite task loop */
}

/************************************/
/* check for line group disablement */
/************************************/
static int checkgroup (unsigned short line, unsigned short *lstate, unsigned short tracenum)
{
    unsigned short group;

    group = nwmodResGroups [line];
    if ((group) && (resGroupLock [group-1]))
    {
        *lstate = RES_LOCKED;
        if (modrestrace [line])
        {
            logMsg ("%d] Resource Group Lock Detected.\n", tracenum);
        }
        return (TRUE);
    }
    return (FALSE);
}


/*
/* Try to bring a PLC on line
/*
*/

static void slave_on_line (unsigned short line, unsigned short mod)
{
    MODPLC   *pmod;
    unsigned  short i, j;

    pmod = plcs [line] [mod];	
    if (pmod)			/* verify pointer prior to use */
    {
        if (mltrace [line] == 1)
        {
            logMsg ( "While Slave, Bring Online PLC %d\n", mod );
        }
        if (!modloopback (ONERETRY + line, mod, pmod))
            return; /* if no response, get out */

        mark_not_valid (pmod);	/* a PLC that has just been brought online must have    */
                                /* it's data marked as being not valid.                 */

        pmod->is_responding = TRUE;
    }
}
static void on_line (unsigned short line, unsigned short mod)
   {
	MODPLC		*pmod;
	unsigned	short i, j;

	pmod = plcs [line] [mod];	
	if (pmod)			/* verify pointer prior to use */
	{
		if (mltrace [line] == 1)
		{
			logMsg ( "Bring Online PLC %d\n", mod );
	        }
                if (threetryflag [line])
                {
                    if (!modloopback (line, mod, pmod))
                        return; /* if no response, get out */
                }
                else
                {
                    if (!modloopback (ONERETRY + line, mod, pmod))
                        return; /* if no response, get out */
                }



		mark_not_valid (pmod);	/* a PLC that has just been brought online must have    */
                                        /* it's data marked as being not valid.                 */

		pmod->is_responding = TRUE;
        }
}
/*
/* Mark all plc data elements as not valid     		
/*                                             		
*/                                             	
/* called from on_line and prepresponses      		*/    	

static void mark_not_valid (MODPLC  *pmod)
{
	unsigned	short i, j;

/*
/*      COILS ARE INITIALIZED AS READ WRITE VALUES      
/*              - READ BACK NOT VALID 			
*/
	for (i = 0; (i < NUMMODCOILS); i++)
	{
	    pmod->coils [i].data_valid = FALSE;
	}

/*
/*      DIGITALS ARE INITIALIZED AS NOT VALID		
*/
	for (i = 0; (i < NUMMODDIS); i++)
	{
	    pmod->dis [i].data_valid = FALSE;
	}

/*
/*      ANALOG INS ARE INITIALIZED AS NOT VALID		
*/
	for (i = 0; (i < NUMMODAIS); i++)
	{
	    pmod->ais [i].data_valid = FALSE;
	}

/*
/*      REGISTERS ARE INITIALIZED AS READ WRITE VALUES		
/*      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS 	
/*              - READ BACK NOT VALID      	               	
*/
	for (i = 0; (i < NUMREGISTERS); i++)
	{
	    pmod->regs [i].data_valid = FALSE;
	}
}
/*                                                                        
/* Manage BOREAD Coil Validity -  coil read data is only valid for a      
/*                                short time. after that time, the data   
/*                                is invalidated and must be re-read.     
/*                                                                        
*/                                             	
/* called from on_line and prepresponses      		*/    	

static void manage_coil_validity (MODPLC  *pmod)
{
    unsigned short   i;
    unsigned long    currenttick;
      signed long    deltatick;

    currenttick = tickGet();
    for (i = 0; (i < NUMMODCOILS); i++)
    {
        if (pmod->coils [i].data_valid == TRUE)
        {
            if (pmod->coils [i].was_requested == FALSE)
            {
                if (currenttick >= pmod->coils [i].readtick)
                {
                    deltatick = currenttick - pmod->coils [i].readtick;
                    if (deltatick > EXPIRATIONTICKS)
                    {
                        pmod->coils [i].data_valid = FALSE;
                    }
                }
                else
                {
                    pmod->coils [i].data_valid = FALSE;
                }
            }
        }
    }
}


/*
/* Check for User ID List Download Pending for this PLC.    
/*                                                          
*/
static int checkiddownload (unsigned short line, unsigned short mod, MODPLC *pmod)
{
    unsigned short  temp;
    LOADID         *idinfo;

    idinfo = &idtable[line];	  /* establish the pointer.   */

    if (idinfo->data_valid)
    {
        if (pmod->id_pending)
        {
            temp = sendidtable (line, mod, pmod);
            if (temp == CMDFAIL)
            {
                return (FALSE);
            }
            else
            {
                pmod->id_pending = FALSE;
                return (TRUE);
            }
        }
    }
    return (FALSE);
}
/*
/* Scan a MODBUS PLC -  get inputs and set outputs as required	
/*                                                            	
*/
/* this routine only called from MAIN 		*/

static	void scan_plc (MODPLC *pmod, unsigned short line, unsigned short mod)
{
	unsigned short	i, j, k, val, bitaddr, regaddr, readlen;
	unsigned long   bitmask;
	LOADINFO	sslinfo;
        unsigned short  temp, cmd;

	pmod->tscanpass++;

	if (mltrace [line] == 2)
	{
	    logMsg ( "Scanning PLC - %d.\n", mod );
	}
	checkoutputs (line);

	/* Test to see if load requested or in progress */
	if (pmod->prog_load_stat == PLC_LOAD_REQUESTED)
	{
	    loadinit (line, pmod, mod);
	    return;
	}
	if (pmod->prog_load_stat == PLC_LOAD_IN_PROGRESS)
	{
	    loadnextblock (line);
	    return;
	}
	/* Test to see if a start or stop is requested */
	if (pmod->plc_stop)
	{
	    sslinfo.line = line;
	    sslinfo.mod = mod;
	    sslinfo.pmod = pmod;
	    if (plc_login (&sslinfo))
	    {
		plc_stop (&sslinfo);
	    }
	    plc_logout (&sslinfo);
	    pmod->plc_stop = FALSE;
	}
	if (pmod->plc_start)
	{
	    sslinfo.line = line;
	    sslinfo.mod = mod;
	    sslinfo.pmod = pmod;
	    if (plc_login (&sslinfo))
	    {
		plc_start (&sslinfo);
	    }
	    plc_logout (&sslinfo);
	    pmod->plc_start = FALSE;
	}

	/* read the coil values to be scanned */
	for (i = 0; (i < NUMMODCOILS); i++)
	{
	    if ((pmod->coils [i].was_requested) || (pmod->coils [i].init_writeflag))
	    {
		for (j = 1; ((j < MAXDIGBLKSIZE) && ((i + j) < NUMMODCOILS )); j++)
		{
		    if (!((pmod->coils [i+j].was_requested) || (pmod->coils [i+j].init_writeflag)))
		    {
		    	break;
		    }
		}
		bitaddr = (i * 8);
		readlen = j * 8;
		temp = readcoils (line, mod, pmod, bitaddr, readlen);
                if (temp == CMDFAIL)
		{
		    return;
		}
                if ((temp == CMDNACK) || (temp == CMDREJECT))
                {
                    /* disable the entire range of NACKed points */
                    cmd = MCOILS;
                    if (trace[line] & MODBUSNACKTRACE)
                        logMsg (
                          "Modbus Command NACK: Disabling %d Points starting at L=%d,A=%d,C=%d,S=%d\n",
                           readlen, line, mod, cmd, bitaddr+1);
                    for (k = 0 ; k < j ; k++)
                    {
                        pmod->coils [i + k].init_writeflag = FALSE;
                        pmod->coils [i + k].was_requested = FALSE;
                        pmod->coils [i + k].data_valid = FALSE;
                    }
                }
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* read the di values to be scanned */
	for (i = 0; (i < NUMMODDIS); i++)
	{
	    if (pmod->dis [i].was_requested)
	    {
		for (j = 1; ((j < MAXDIGBLKSIZE) && ((i + j) < NUMMODDIS )); j++)
		{
		    if (!pmod->dis [i + j].was_requested)
		    {
		    	break;
		    }
		}
		bitaddr = (i * 8);
		readlen = j * 8;
		temp = readdis (line, mod, pmod, bitaddr, readlen);
                if (temp == CMDFAIL)
		{
		    return;
		}
                if ((temp == CMDNACK) || (temp == CMDREJECT))
                {
                    /* disable the entire range of NACKed points */
                    cmd = MDINS;
                    if (trace[line] & MODBUSNACKTRACE)
                        logMsg (
                          "Modbus Command NACK: Disabling %d Points starting at L=%d,A=%d,C=%d,S=%d\n",
                           readlen, line, mod, cmd, bitaddr+1);
                    for (k = 0; k < j; k++)
                    {
                        pmod->dis [i + k].was_requested = FALSE;
                        pmod->dis [i + k].data_valid = FALSE;
                    }
                }
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* read the ai values to be scanned */
	for (i = 0; (i < NUMMODAIS); i++)
	{
	    if (pmod->ais [i].was_requested)
	    {
		for (j = 1; ((j < MAXREGBLKSIZE) && ((i + j) < NUMMODAIS)); j++)
		{
		    if (!pmod->ais [i + j].was_requested)
		    	break;
		}
		regaddr = i * REGBLOCK;
		readlen = j * REGBLOCK;
		temp = readais (line, mod, pmod, regaddr, readlen);
                if (temp == CMDFAIL)
		{
		    return;
		}
                if ((temp == CMDNACK) || (temp == CMDREJECT))
                {
                    /* disable the entire range of NACKed points */
                    cmd = MAINS;
                    if (trace[line] & MODBUSNACKTRACE)
                        logMsg (
                          "Modbus Command NACK: Disabling %d Points starting at L=%d,A=%d,C=%d,S=%d\n",
                           readlen, line, mod, cmd, bitaddr+1);
                    for (k = 0; k < j; k++)
                    {
                        pmod->ais [i + k].was_requested = FALSE;
                        pmod->ais [i + k].data_valid = FALSE;
                    }
                }
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}

	/* read the reg values to be scanned */
	for (i = 0; (i < NUMREGISTERS); i++)
	{
	    if (pmod->regs [i].was_requested)
	    {
		for (j = 1; ((j < MAXREGBLKSIZE) && ((i + j) < NUMREGISTERS)); j++)
		{
		    if (!pmod->regs [i + j].was_requested)
		    {
		    	break;
		    }
		}
		regaddr = i * REGBLOCK;
		readlen = j * REGBLOCK;
		temp = readregs (line, mod, pmod, regaddr, readlen);
                if (temp == CMDFAIL)
		{
		    return;
		}
                if ((temp == CMDNACK) || (temp == CMDREJECT))
                {
                    /* disable the entire range of NACKed points */
                    cmd = MREGS;
                    if (trace[line] & MODBUSNACKTRACE)
                        logMsg (
                          "Modbus Command NACK: Disabling %d Points starting at L=%d,A=%d,C=%d,S=%d\n",
                           readlen, line, mod, cmd, bitaddr+1);
                    for (k = 0; k < j; k++)
                    {
                        pmod->regs [i + k].was_requested = FALSE;
                        pmod->regs [i + k].data_valid = FALSE;
                    }
                }
		checkoutputs (line);
		i = (i + j) - 1;
	    }
	}
        htrendmarkvalid (line, mod, pmod); /* if plc can be polled, mark valid */
}


/********************************************************************/
/* this routine will advance the pointer for time, making sure we   */
/* know what cell we are working with during normal plc polling.    */
/*                                                                  */
/* Note: the basic action taking place here is pointer management.  */
/********************************************************************/

void htrendupdate (unsigned short line)
{
    LOADHTMAP      *pmap;
    MODPLC         *pmod;
    TS_STAMP        temptime;
    unsigned short  mod;
    unsigned short  i, bitindex, arrayindex;
    unsigned char   arraymask, temp;
    unsigned long   coldnickel, lastnickel, thisnickel, diffnickel;
    unsigned long   updatetime;
    unsigned char   dummybuffer[1000];

    if (htdebug [line] >= 14)
    {
        printf ("htrendupdate: ENTRY ......\n");
    }

    pmap = htmaptable [line];   /* establish the pointer.   */
    if (!(pmap))
    {
        /* This should never happen, but if it does, exit. */
        if (htdebug [line] >= 2)
        {
            printf ("htrendupdate: htmaptable pointer unexpectedly invalid (zero). exiting.\n");
            taskDelay(60);
        }
        return;
    }

    /* 'thisnickel' is the absolute # of 5 minute intervals since the universe began. */
    tsLocalTime (&timenow [line]);
    thisnickel = (timenow [line].secPastEpoch)/secondspernickel + 1;

    /* see if we are on target */
    coldnickel = pmap->thisnickel;
    diffnickel = thisnickel - coldnickel;

    if (diffnickel == 0)
    {
        pmap->lastnickel = coldnickel-1;
        pmap->thisnickel = coldnickel;
        if (htdebug [line] >= 14)
        {
            printf ("htrendupdate: ...... EXIT\n");
        }
        return;
    }

    if (diffnickel > 4)
    {
        if (trace[line] & HTSTATETRACE)
        {
            printf ("htrendupdate: Time Gap of %d elements detected.\n", diffnickel);
            taskDelay(60);
        }
    }

    if (diffnickel > MASKBITS)
    {
        coldnickel = thisnickel - MASKBITS;
        if (htdebug [line] >= 8)
        {
            /* print the current nickel and actual times */
            printf ("**************************************************************\n");
            printf ("htrendupdate: Truncating diffnickel %s\n",
                     tsStampToText(&timenow[line], TS_TEXT_MONDDYYYY, dummybuffer));
        }
    }


    /* if 5 minute boundary has been crossed, bump the indices. */
    /* (under normal conditions, while should only execute once.*/
    /* this should only come into play when the IOC has been    */
    /* powered off for more than 5 minutes and no partner has   */
    /* been running. After the file is loaded, the old copy of  */
    /* "thisnickel" will be in memory, but will be 'old'. When  */
    /* this is detected, we will iterate through the bits until */
    /* we catch up to the present time.)                        */

    while (thisnickel > coldnickel)
    {
        /* process what was the current nickel, and is now the previous nickel */
        if (htdebug [line] >= 6)
        {
            printf ("htrendupdate: Nickel Time interval transition has occurred.(%d, %d)\n", thisnickel, coldnickel);
        }

        /* generate bit index */
        bitindex = coldnickel%MASKBITS;

        /* generate array index */
        arrayindex = bitindex/8;

        /* generate array mask */
        arraymask = 0x01 << (bitindex%8);

        if (htdebug [line] >= 8)
        {
            /* print the current nickel and actual times */
            printf ("**************************************************************\n");
            printf ("htrendupdate: Current Real Time:       %s\n",
                     tsStampToText(&timenow[line], TS_TEXT_MONDDYYYY, dummybuffer));
/*            /* 12-12-97: reference time at the end of the nickel instead of the beginning. */
/*            updatetime = (coldnickel+1) * secondspernickel; /* this is in seconds */
            updatetime = coldnickel * secondspernickel; /* this is in seconds */

            temptime.secPastEpoch = updatetime;
            temptime.nsec = 0;
            printf ("htrendupdate: Cold Nickel Time End:    %s\n",
                     tsStampToText(&temptime, TS_TEXT_MONDDYYYY, dummybuffer));
            printf ("**************************************************************\n");
            printf ("htrendupdate: coldnickel=%d, diffnickel=%d, bitindex=%d, arrayindex=%d. arraymask=%x\n",
                                   coldnickel,    diffnickel,    bitindex,    arrayindex,    arraymask);
        }
        /* update all masks for all valid plcs. */
        for (mod = 1; (mod <= NUMMODPLCS); mod++)
        {
            if (pmod)
            {
                if (pmap->htmasks[mod].data_valid)
                {
                   if (pmap->htmasks[mod].thisnickelcount)
                   {
                       temp = pmap->htmasks[mod].validmask[arrayindex] | arraymask; /* set bit to valid */
                       pmap->htmasks[mod].validmask[arrayindex] = temp;

                       temp = pmap->htmasks[mod].savedmask[arrayindex] | arraymask; /* set bit to valid */
                       pmap->htmasks[mod].savedmask[arrayindex] = temp;

                       temp = pmap->htmasks[mod].gotitmask[arrayindex] | arraymask; /* set bit to valid */
                       pmap->htmasks[mod].gotitmask[arrayindex] = temp;
                       if (htdebug [line] >= 10)
                       {
                           printf ("htrendupdate: PLC %2d Marked As VALID.     lastnickelcount = %d, thisnickelcount = %d\n",
                                                  mod, pmap->htmasks[mod].lastnickelcount, pmap->htmasks[mod].thisnickelcount);
                       }
                   }
                   else
                   {
                       temp = pmap->htmasks[mod].validmask[arrayindex] & ~arraymask; /* set bit to invalid */
                       pmap->htmasks[mod].validmask[arrayindex] = temp;

                       temp = pmap->htmasks[mod].savedmask[arrayindex] & ~arraymask; /* set bit to invalid */
                       pmap->htmasks[mod].savedmask[arrayindex] = temp;

                       temp = pmap->htmasks[mod].gotitmask[arrayindex] & ~arraymask; /* set bit to invalid */
                       pmap->htmasks[mod].gotitmask[arrayindex] = temp;
                       if (htdebug [line] >= 10)
                       {
                           printf ("htrendupdate: PLC %2d Marked As NOT VALID. lastnickelcount = %d\n",
                                                  mod, pmap->htmasks[mod].lastnickelcount);
                       }
                   }
                   pmap->htmasks[mod].index      = arrayindex;
                   pmap->htmasks[mod].mask       = arraymask;
                   pmap->htmasks[mod].lastnickel = coldnickel;
/* commented out 12/17/97                   pmap->htmasks[mod].thisnickel = coldnickel+1; */
                   pmap->htmasks[mod].thisnickel = coldnickel;

                   pmap->htmasks[mod].lastnickelcount = pmap->htmasks[mod].thisnickelcount;
                   pmap->htmasks[mod].thisnickelcount = 0;
                }
                else
                {
                    if (htdebug [line] >= 10)
                    {
                        printf ("htrendupdate: PLC %2d: PLC configured but htmasks not valid.\n", mod);
                    }
                    if (htdebug [line] >= 4)
                    {
                        printf ("htrendupdate: PLC %2d: initializing htmasks data structure.\n", mod);
                    }
                    maptableinit (line, mod);
                }
            }
        }
        coldnickel++;
/*
        if (htdebug [line] >= 32)
        {
            printf ("END   htrendupdate: thisnickel=%d, coldnickel=%d, diffnickel=%d, bitindex=%d, arrayindex=%d. arraymask=%x\n",
                                         thisnickel,    coldnickel,    diffnickel,    bitindex,    arrayindex,    arraymask);
        }
*/
    }
    /* after all has been updated, save it to disk. */
    if (htdebug [line] >= 6)
    {
        printf ("htrendupdate: Storing Map File.\n");
    }
    storemapfile (line);

    pmap->lastnickel = coldnickel-1;
    pmap->thisnickel = coldnickel;
    if (htdebug [line] >= 14)
    {
        printf ("htrendupdate: ...... EXIT\n");
    }
}

/********************************************************************/
/* this routine will, using the current pointer, set the 'valid'    */
/* 'mask' bits true for the specified PLC. This routine is called   */
/* immediately after a successful read of a PLC.                    */
/*                                                                  */
/* Note: the basic action taking place here is setting mask bits.   */
/********************************************************************/

void htrendmarkvalid (unsigned short line,  unsigned short mod, MODPLC *pmod)
{
    LOADHTMAP     *pmap;

    /******************************************************************************/
    /* now that all i/o has been completed sucessfully, bump the activity counter */
    pmap = htmaptable [line];   /* establish the pointer.   */
    if (!(pmap))
    {
        /* This should never happen, but if it does, exit. */
        if (htdebug [line] >= 2)
        {
            printf ("htrendmarkvalid: htmaptable pointer unexpectedly invalid (zero). return.\n");
            taskDelay(60);
        }
        return;
    }
    /* Verify that this IOC is connected to the workstation and is    */
    /* trending data. this is neccessary to expect that any retrieved */
    /* data can be stored in the historical trend database.           */
    if (fakeSinbad [line])
    {
        if (!(PseudoTrendingActive (line)))
        {
            if (htdebug [line] >= 4)
            {
                printf ("htrendmarkvalid: Pseudo Trending Not Active. return.\n");
                taskDelay(60);
            }
            return;
        }
    }
    else
    {
        if (!(TrendingActive()))
        {
            if (htdebug [line] >= 4)
            {
                printf ("htrendmarkvalid: Trending Not Active. return.\n");
                taskDelay(60);
            }
            return;
        }
    }

    pmap->htmasks[mod].thisnickelcount++;
    if (htdebug [line] >= 12)
    {
        printf ("htrendmarkvalid: PLC %2d, lastnickelcount = %d, thisnickelcount = %d\n",
                 mod, pmap->htmasks[mod].lastnickelcount, pmap->htmasks[mod].thisnickelcount);
    }
    /******************************************************************************/
    return;
}


static int  htrendcheck (unsigned short line)
{
    LOADHT        *htinfo;
    LOADHTMAP     *pmap;
    MODPLC        *pmod;
    unsigned short  mod;
    unsigned short  i, j, k, bitindex, arrayindex;
    unsigned char   arraymask, temp, temp1, temp2;
    unsigned char   savedmask, validmask;
    unsigned short  validrecordcount, lastvalidrecord;
    /* the term 'nickel' refers to a five minute interval of time. */

    unsigned long   lastnickel;        /* the current time, expressed in Nickels Since The Big Bang [NSTBB).  */
    unsigned long   nickel;            /* the time currently under inspection. expressed in NSTBB.            */
    unsigned long   oldestnickel;      /* the time of the oldest data in the historical trend buffer in NSTBB */
                                       /* (this is always 48 hours previous to the current time, lastnickel)  */
    unsigned long   diffnickel;        /* a calculated number of nickels.                                     */

    unsigned short  thisreg;           /* the register number of the record for the time currently under inspection.   */
    unsigned short  startreg;          /* the register number of the 1st element of the PLCs Historical Trend Buffer   */
    unsigned short  endreg;            /* the register number of the 576th element of the PLCs Historical Trend Buffer */
    unsigned short  nickelreg;         /* the register number corresponding to the current time record in the PLC      */
    unsigned short  fetchreg;          /* the register number from which the data fetch will start in the PLC.         */

    unsigned short  regcount;          /* the number of registers per record in the PLCs Historical Trend Buffer       */
                                      
    unsigned short  maxfetch;          /* the max number of whole HT records readable in a single Modbus command       */
    unsigned short  fetchrecordcount;  /* the number of whole HT records to be read from the PLC                       */
    unsigned short  fetchregistercount;/* the number of registers to be read from the PLC (fetchrecordcount*regcount)  */
    unsigned long   fetchnickel;       /* the beginning time for which HT data will be read, expressed in NSTBB.       */

    unsigned long   updatetime;        /* the UNIX time represented by the data being sent to the TrendUpdate routine. */
    unsigned long   dataoffset;        /* the offset into the retrieved HT data of the data represented by updatetime. */ 

    TS_STAMP        archivetime;
    unsigned char   dummybuffer[1000];

    if (htdebug [line] >= 14)
    {
        printf ("htrendcheck: ENTRY ......\n");
    }

    pmap = htmaptable [line];   /* establish the pointer.   */
    if (!(pmap))
    {
        /* This should never happen, but if it does, exit. */
        if (htdebug [line] >= 2)
        {
            printf ("htrendcheck: htmaptable pointer unexpectedly invalid (zero). exiting.\n");
            taskDelay(60);
        }
        return (FALSE);
    }

    htinfo = &httable[line];    /* establish the pointer.   */
    if (htinfo->data_valid != TRUE)
    {
        /* This should never happen, but if it does, exit. */
        if (htdebug [line] >= 2)
        {
            printf ("htrendcheck: httable data structure unexpectedly invalid. exiting.\n");
            taskDelay(60);
        }
        return (FALSE);
    }

    /* Verify that this IOC is connected to the workstation and is    */
    /* trending data. this is neccessary to expect that any retrieved */
    /* data can be stored in the historical trend database.           */
    if (fakeSinbad [line])
    {
        if (!(PseudoTrendingActive (line)))
        {
            if (htdebug [line] >= 4)
            {
                printf ("htrendcheck: Pseudo Trending Not Active. exiting.\n");
                taskDelay(60);
            }
            return (FALSE);
        }
    }
    else
    {
        if (!(TrendingActive()))
        {
            if (htdebug [line] >= 4)
            {
                printf ("htrendcheck: Trending Not Active. exiting.\n");
                taskDelay(60);
            }
            return (FALSE);
        }
    }


    /* 'lastnickel' is the NSTBB of the most recently processed record. */
    lastnickel = pmap->lastnickel;
    oldestnickel = lastnickel - MASKBITS + 1;

    if (htdebug [line] >= 16)
    {
        printf ("htrendcheck: lastnickel=%d,  oldestnickel=%d.\n",
                 lastnickel, oldestnickel);
    }
    if (htdebug [line] >= 16)
    {
        printf ("htrendcheck: data_valid=%d,  lastindex=%d,  lastmask=%x%x.\n",
                 pmap->data_valid, pmap->lastindex, pmap->lastmask/16, pmap->lastmask%16);
    }

    /* always attempt to bring back the oldest data first for all PLCs. */
    for (nickel = oldestnickel; nickel <= lastnickel; nickel++)
    {
        /* for now, don't do very last record */
        if (nickel == oldestnickel) continue;
        /* for now, don't do next to last record */
/*        if (nickel == oldestnickel+1) continue; */

        if (htdebug [line] >= 18)
        {
            printf ("htrendcheck: Checking Each Bit: nickel=%d, diffnickel=%d.\n", nickel, diffnickel);
        }

        /* generate bit index */
        bitindex = nickel%MASKBITS;

        /* generate array index */
        arrayindex = bitindex/8;

        /* generate array mask */
        arraymask = 0x01 << (bitindex%8);

        /* number of nickels deep into the PLC HT buffers we are reaching */
        diffnickel = lastnickel - nickel;

        if (htdebug [line] >= 20)
        {
            printf ("htrendcheck: oldestnickel=%d, lastnickel=%d, bitindex=%d, arrayindex=%d, arraymask=%x%x\n",
                     oldestnickel, lastnickel, bitindex, arrayindex, arraymask/16, arraymask%16);
        }
        /* check each PLC. */
        for (mod = 1; (mod <= NUMMODPLCS); mod++)
        {
            if (htdebug [line] >= 22)
            {
                printf ("htrendcheck: PLC %d: Top Of The Loop........\n", mod);
            }

            pmod = plcs [line] [mod];
            if (!(pmod))
            {
                /* conditionally print skip message and continue on with next PLC */
                if (htdebug [line] >= 28)
                {
                    printf ("htrendcheck: PLC %d: Not configured. Skipping this PLC...\n", mod);
                }
                continue;
            }
            if (!(pmod->is_responding))
            {
                /* conditionally print skip message and continue on with next PLC */
                if (htdebug [line] >= 26)
                {
                    printf ("htrendcheck: PLC %d: Not Responding. Skipping this PLC...\n", mod);
                }
                continue;
            }
            if (pmod->holdflag)
            {
                /* conditionally print skip message and continue on with next PLC */
                if (htdebug [line] >= 24)
                {
                    printf ("htrendcheck: PLC %d: On Hold. Skipping this PLC...\n", mod);
                }
                continue;
            }
            if (pmod->regs [2].data_valid != TRUE)
            {
                /* only print this on the last pass through the bit table. this keeps us   */
                /* from cluttering up the display with 576 messages saying the same thing. */
                if (nickel == lastnickel)
                {
                    /* print error message and continue on with next PLC */
                    if (htdebug [line] >= 2)
                    {
                        printf ("htrendcheck: PLC %d: Error. PLC's data_valid is TRUE, and its holdflag is FALSE, \n", mod);
                        printf ("htrendcheck:                but the 40010 & 40011 data is not valid!!  Re-marking \n");
                        printf ("htrendcheck:                the 40010 & 40011 was_requested bit.  Skipping this PLC...\n");
                        taskDelay(60);
                    }
                }
                /* North Wales: (Re-)Mark Dedicated Historic Trend Registers (40010 & 40011) for Read */
                pmod->was_requested = TRUE;
                pmod->regs [2].was_requested = TRUE;
                continue;
            }

/******************************************************************************/
/* we may put logic here to speed up the process of working through all of    */
/* memory for each PLC, but for now it doesn't work, so its commented out.    */
/******************************************************************************/
/*            if (pmap->htmasks[mod].worknickel > nickel)
/*            {
/*                /* print indication that we don't need to look in here. */
/*                continue;
/*            }
*/
            validrecordcount = pmod->regs [2].ioregs [1];   /* Register 40010 */
            lastvalidrecord  = pmod->regs [2].ioregs [2];   /* Register 40011 */

            if (htdebug [line] >= 30)
            {
                printf ("htrendcheck: PLC %d: validrecordcount=%d, lastvalidrecord=%d\n",
                         mod, validrecordcount, lastvalidrecord);
            }

            /* lastvalidrecord points to the previous 5 minute record. the    */
            /* current 5 minute record is in process and is not available to  */
            /* the driver.                                                    */

            /* verify that the HT control data is valid.                      */
            if (!(pmap->htmasks[mod].data_valid))
            {
                /* This should never happen, but if it does, exit. */
                if (htdebug [line] >= 2)
                {
                    printf ("htrendcheck: PLC %d: htmasks data structure unexpectedly invalid. exiting.\n", mod);
                    taskDelay(60);
                }
                return (TRUE);
            }

            /***************************************/
            /***************************************/
            /***** Why are these being saved? ******/
            /***************************************/
            /***************************************/
            pmap->htmasks[mod].index      = arrayindex;
            pmap->htmasks[mod].mask       = arraymask;
            pmap->htmasks[mod].worknickel = nickel;

            /* get configuration info on the PLC */
            startreg = htinfo->startreg [mod];
            regcount = htinfo->regcount [mod];

            if (htdebug [line] >= 30)
            {
                printf ("htrendcheck: PLC %d: Config Info: startreg=%d, regcount=%d\n",
                         mod, startreg, regcount);
            }

            if (regcount == 0)
            {
                /* if data not being trended, it can't be fetched. */
                /* instead, unconditionally mark the map bit to    */
                /* indicate the the data is already valid and      */
                /* saved, and then continue with the next PLC.     */
                if (htdebug [line] >= 30)
                {
                    printf ("htrendcheck: PLC %d: Data Not Being Trended on PLC. Unconditionally Mark \n", mod);
                    printf ("htrendcheck:         Bits as both Valid and Saved. Continue processing ....\n");
                }
                temp = pmap->htmasks[mod].validmask[arrayindex] | arraymask; /* set bit to valid */
                pmap->htmasks[mod].validmask[arrayindex] = temp;
                temp = pmap->htmasks[mod].savedmask[arrayindex] | arraymask; /* set bit to valid */
                pmap->htmasks[mod].savedmask[arrayindex] = temp;
                continue;
            }

            /* see if potentially fetched data exists in the PLC */
/* 12/17/97: not sure about changing this, so not now. */
            if (validrecordcount < (diffnickel + 1))
            {
                /* if data does not exist, it can't be fetched. */
                /* instead, unconditionally mark the map bit to */
                /* indicate the the data is already valid and   */
                /* saved, and then continue with the next PLC.  */
                if (htdebug [line] >= 30)
                {
                    printf ("htrendcheck: PLC %d: Data Does Not Exist on PLC. Unconditionally Mark \n", mod);
                    printf ("htrendcheck:         Bits as both Valid and Saved. Continue processing ....\n");
                }
                temp = pmap->htmasks[mod].validmask[arrayindex] | arraymask; /* set bit to valid */
                pmap->htmasks[mod].validmask[arrayindex] = temp;
                temp = pmap->htmasks[mod].savedmask[arrayindex] | arraymask; /* set bit to valid */
                pmap->htmasks[mod].savedmask[arrayindex] = temp;
                continue;
            }

            /* calculate the address of the last record in the allocated buffer space */
            endreg = startreg + ((MASKBITS - 1) * regcount);

            /* calculate the address of the 'nickel' record */
            nickelreg = startreg + (((lastvalidrecord-1) - diffnickel + MASKBITS)%MASKBITS) * regcount;

            /* calculate the maximum number of sets which could be fetched. */
            maxfetch = maxhtread [line]/regcount;

            fetchnickel = nickel;             /* this relates to absolute time          */
            fetchreg = nickelreg;             /* this is what register to start reading */
            fetchrecordcount = 0;             /* this is how many registers to read.    */

            /* see if this block/record needs to be fetched. */
            savedmask = pmap->htmasks[mod].validmask[arrayindex];
            validmask = pmap->htmasks[mod].savedmask[arrayindex];
            temp1 = pmap->htmasks[mod].validmask[arrayindex] & arraymask;
            temp2 = pmap->htmasks[mod].savedmask[arrayindex] & arraymask;

            if (htdebug [line] >= 30)
            {
                printf ("htrendcheck: PLC %d: Config Info: endreg=%d, nickelreg=%d, maxfetch=%d\n",
                         mod, endreg, nickelreg, maxfetch);
            }

            if (htdebug [line] >= 30)
            {
                printf ("htrendcheck: PLC %d: Mask Info: savedmask=%x, validmask=%x, arraymask=%x\n",
                         mod, savedmask, validmask, arraymask);
                printf ("htrendcheck: PLC %d: Mask Info: savedbit=%x, validbit=%x\n",
                         mod, temp2, temp1);
            }

            if (temp1) /* data IS valid ... */
            {
                if (temp2) /* ... AND data HAS been saved */
                {
                    /* This is just as we expect. There are three ways that this happens:   */
                    /* Both bits have been set due to normal data acquisition.              */
                    /* Both bits have been set after trend retrieval has been accomplished. */
                    /* Both bits have been set after trend retrieval logic has determined   */
                    /*  that the 'missing' data does not exist in the PLC.                  */
                    /* Either way, continue looping looking for the next bit to retrieve.   */
                    if (htdebug [line] >= 30)
                    {
                        printf ("htrendcheck: PLC %d: Normal Bit Hit (No fetch required): index=%d, mask=%d\n",
                                 mod, arrayindex, arraymask);
                    }
                }
                else       /* ... BUT data HAS NOT been saved */
                {
                    /* Sinbad's code isn't finished processing.                   */
                    /* THIS IS A POSSIBLE BUT UNWANTED OCCURENCE.                 */
                    if (htdebug [line] >= 30)
                    {
                        printf ("htrendcheck: PLC %d: Abnormal Bit Hit: Unexpected Sinbad Delay: index=%d, mask=%d\n",
                                 mod, arrayindex, arraymask);
                    }
                }
            }
            else /* data IS NOT valid ... */
            {
                if (temp2) /* ... AND data HAS been saved */
                {
                    /* THIS IS AN UNEXPECTED OCCURENCE. IT SHOULD NEVER HAPPEN. */
                    /* for now, inset a diagnostic statement here and go on.    */
                    if (htdebug [line] >= 10)
                    {
                        printf ("htrendcheck: PLC %d: Unexpected Abnormal No Bit Hit: index=%d, mask=%d\n",
                                 mod, arrayindex, arraymask);
                    }
                    if (htdebug [line] >= 2)
                    {
                        printf ("htrendcheck: PLC %d: Unexpected Map Error: valid=0 but saved=1.\n", mod);
                        taskDelay(60);
                    }
                }
                else  /* ... AND data HAS NOT been saved */
                {
                    /****************************************************************************/
                    /* this is the classic no hit hit, which means we need to go fetch the data */
                    /****************************************************************************/
                    if (htdebug [line] >= 10)
                    {
                        printf ("htrendcheck: PLC %d: Normal No Bit Hit: index=%d, mask=%d\n",
                                 mod, arrayindex, arraymask);
                    }
                }

                /***************************************************************************/
                /* FETCH NEEDED. WE HAVE AT LEAST ONE RECORD TO FETCH. NOW LOOK FOR MORE.  */
                /* Now step through this PLCs map, building a list of records to fetch.    */
                /* (For now, don't look ahead skipping over small holes. That refinement   */
                /* may help efficiency in some cases, but it is not necessary, and the     */
                /* efficiency gain varies with baud, 'hole' distribution, and record size, */
                /* and can even be negative)                                               */
                /***************************************************************************/

                if (htdebug [line] >= 6)
                {
                    printf ("htrendcheck: PLC %d: Fetch Need Detected. Config Info: startreg=%d, nickelreg=%d, endreg=%d, regcount=%d\n",
                             mod, startreg, nickelreg, endreg, regcount);
                    printf ("htrendcheck: PLC %d: validrecordcount=%d, lastvalidrecord=%d\n",
                           mod, validrecordcount, lastvalidrecord);
                }

                fetchrecordcount++;

                for (j = 0; j < (maxfetch -1); j++)
                {
                    /* calculate the address of this most recently included record */
                    thisreg = fetchreg + (j * regcount);
                    /* calculate the address of this most recently included record */
/*                    thisreg = startreg + ((lastvalidrecord - diffnickel + j + MASKBITS)%MASKBITS) * regcount; */


                    if (htdebug [line] >= 12)
                    {
                        printf ("htrendcheck: PLC %d: Top of Fetch Loop: fetchrecordcount=%d\n",
                                 mod, fetchrecordcount);
                        printf ("htrendcheck:          index=%d, mask=%d, thisreg=%d, endreg=%d\n",
                                 arrayindex, arraymask, thisreg, endreg);
                    }

                    /* next, check to see if we are at the end of the PLC's register buffer. if */
                    /* we are, exit this 'for' loop and proceed with the fetching of the data.  */
                    if (thisreg >= endreg)
                    {
                        if (htdebug [line] >= 10)
                        {
                            printf ("htrendcheck: PLC %d: At End of PLC Record Buffer: stop searching.\n", mod);
                        }
                        break;
                    }

                    /* next, check to see if we are at the end of the PLC's register buffer. if */
                    /* we are, exit this 'for' loop and proceed with the fetching of the data.  */
                    if ((nickel+j) >= lastnickel)
                    {
                        if (htdebug [line] >= 10)
                        {
                            printf ("htrendcheck: PLC %d: Most Recent Bit has been reached. stop searching.\n", mod);
                        }
                        break;
                    }

                    /* since there are more potential records to examine, */
                    /*  calculate the next bit index & mask.              */
                    bitindex = (nickel+(j+1))%MASKBITS;
                    arrayindex = bitindex/8;
                    arraymask = 0x01 << (bitindex%8);

                    /* number of nickels deep into the PLC HT buffers we are reaching */
                    diffnickel = lastnickel - nickel + (j+1);

                    /* see if this next record needs to be fetched. */
                    savedmask = pmap->htmasks[mod].validmask[arrayindex];
                    validmask = pmap->htmasks[mod].savedmask[arrayindex];
                    temp1 = pmap->htmasks[mod].validmask[arrayindex] & arraymask;
                    temp2 = pmap->htmasks[mod].savedmask[arrayindex] & arraymask;

                    if (htdebug [line] >= 13)
                    {
                        printf ("htrendcheck: PLC %d: More Bits?: Mask Info: savedmask=%x, validmask=%x, arraymask=%x\n",
                                 mod, savedmask, validmask, arraymask);
                        printf ("htrendcheck: PLC %d: More Bits?: Mask Info: savedbit=%x, validbit=%x\n",
                                 mod, temp2, temp1);
                    }

                    if (temp1) /* data IS valid ... */
                    {
                        if (temp2) /* ... AND data HAS been saved */
                        {
                            /*******************************************************************/
                            /* the data is valid and saved, so it doesn't need to be fetched.  */
                            /* therefore, we can proceed with the fetching of the records      */
                            /* already determined to be in need of fetching.                   */ 
                            /*******************************************************************/
                            if (htdebug [line] >= 10)
                            {
                                printf ("htrendcheck: PLC %d: No More Bits: Normal No Bit Hit: index=%d, mask=%d. stop searching.\n",
                                         mod, arrayindex, arraymask);
                            }
                        }
                        else       /* ... BUT data HAS NOT been saved */
                        {
                            /**************************************************************/
                            /* Sinbad's code isn't finished processing.                   */
                            /* THIS IS A POSSIBLE BUT UNWANTED OCCURENCE.                 */
                            /* for now, inset a diagnostic statement here and get out.    */
                            /* 'get out', in this context, means to ignore this record,   */
                            /*  but to retrieve the records thus far encountered.         */
                            /**************************************************************/
                            if (htdebug [line] >= 10)
                            {
                                printf ("htrendcheck: PLC %d: Abnormal Bit Hit: Unexpected Sinbad Delay: index=%d, mask=%d. stop searching.\n",
                                         mod, arrayindex, arraymask);
                            }
                        }
                        /**************************************************************************/
                        /* there are no more bits to fetch. go fetch the list you currently have. */
                        /**************************************************************************/
                        break;
                    }
                    else /* data IS NOT valid ... */
                    {
                        if (temp2) /* ... BUT data HAS been saved */
                        {
                            /************************************************************/
                            /* THIS IS AN UNEXPECTED OCCURENCE. IT SHOULD NEVER HAPPEN. */
                            /* for now, inset a diagnostic statement here and go on.    */
                            /* 'go on', in this context, means to ignore this record,   */
                            /*  and keep looking for the end of the current 0 bits run. */
                            /************************************************************/
                            if (htdebug [line] >= 11)
                            {
                                printf ("htrendcheck: PLC %d: Unexpected Abnormal No Bit Hit: index=%d, mask=%d\n",
                                         mod, arrayindex, arraymask);
                            }
                            if (htdebug [line] >= 2)
                            {
                                printf ("htrendcheck: PLC %d: Unexpected Map Error: valid=0 but saved=1.\n", mod);
                                taskDelay(60);
                            }
                        }
                        else  /* ... AND data HAS NOT been saved */
                        {
                            /************************************************************/
                            /* this is the classic no hit hit, which means keep looking */
                            /************************************************************/
                            if (htdebug [line] >= 11)
                            {
                                printf ("htrendcheck: PLC %d: Normal No Bit Hit: index=%d, mask=%d\n",
                                         mod, arrayindex, arraymask);
                            }
                        }
                        /*****************************************************************/
                        /* THIS IS A HIT. WE NEED TO FETCH THIS DATA.                    */
                        /* this is done by bumping the record count and allowing the     */
                        /* code to fall through to the top of the for loop again, where  */
                        /* we check again for the PLC buffer wrap and htmap saved status.*/
                        /*****************************************************************/
                        fetchrecordcount++;
                    }
                    /* test for max fetch size reached */
                    if (j == (maxfetch - 2))
                    {
                        if (htdebug [line] >= 10)
                        {
                            printf ("htrendcheck: PLC %d: Record Fetch Length Limit has been reached. stop searching\n", mod);
                        }
                    }
                }

                /*****************************************************************/
                /* we arrive here when we have determined the largest contiguous */
                /* group of registers to be read, and are ready to do the read.  */

                if (htdebug [line] >= 8)
                {
                    printf ("**************************************************************\n");
                    printf ("htrendcheck: PLC %d: Current Real Time:       %s\n",
                             mod, tsStampToText(&timenow[line], TS_TEXT_MONDDYYYY, dummybuffer));
                    /* 12-12-97: reference time at the end of the nickel instead of the beginning. */
/* 12-17-97                    updatetime = (lastnickel+1) * secondspernickel; /* this is in seconds */
                    updatetime = lastnickel * secondspernickel; /* this is in seconds */
                    archivetime.secPastEpoch = updatetime;
                    archivetime.nsec = 0;
                    printf ("htrendcheck: PLC %d: Last Nickel Time End:    %s\n",
                             mod, tsStampToText(&archivetime, TS_TEXT_MONDDYYYY, dummybuffer));
                    /* 12-12-97: reference time at the end of the nickel instead of the beginning. */
/* 12-17-97                    updatetime = (oldestnickel+1) * secondspernickel; /* this is in seconds */
                    updatetime = oldestnickel * secondspernickel; /* this is in seconds */
                    archivetime.secPastEpoch = updatetime;
                    archivetime.nsec = 0;
                    printf ("htrendcheck: PLC %d: Oldest Nickel Time End:  %s\n",
                             mod, tsStampToText(&archivetime, TS_TEXT_MONDDYYYY, dummybuffer));
                    printf ("**************************************************************\n");
                }

                fetchregistercount = fetchrecordcount * regcount;
                if (htdebug [line] >= 6)
                {
                    printf ("htrendcheck: PLC %d: Fetching Data: fetchrecordcount=%d, fetchreg=%d, fetchregistercount=%d\n",
                                          mod,                   fetchrecordcount,    fetchreg,    fetchregistercount);
                }

                temp = readhtregs (line, mod, pmod, fetchreg-1, fetchregistercount);
                if (temp == CMDFAIL)
                {
                    /* what do we do here? The unit has been set to offline. The first thought */
                    /* is to do is nothing - that is move on to the next PLC - but what about  */
                    /* the time factor - maybe we should just print an error message and go on.*/
                    /* after all, if we keep trying forever with subsequent PLCs, then we will */
                    /* miss the next normal scan window. or, more intelligently, go on and try */
                    /* again, but let the code that checks for the time since the last plcscan */
                    /* was completed determine if we should try again.                         */
                    if (htdebug [line] >= 4)
                    {
                        printf ("htrendcheck: PLC %d: htreadregs error: CMDFAIL: fetchreg=%d, fetchregistercount=%d. exiting.\n",
                                 mod, fetchreg, fetchregistercount);
                    }
                    return (TRUE);
                }
                if ((temp == CMDNACK) || (temp == CMDREJECT))
                {
                    /* what do we do here? Something is wrong, but the unit is still online.   */
                    /* Should we do nothing - that is move on to the next PLC - but what about */
                    /* the time factor - maybe we should just print an error message and go on.*/
                    /* after all, if we keep trying forever with subsequent PLCs, then we will */
                    /* miss the next normal scan window. or, more intelligently, go on and try */
                    /* again, but let the code that checks for the time since the last plcscan */
                    /* was completed determine if we should try again.                         */
                    if (htdebug [line] >= 4)
                    {
                        printf ("htrendcheck: PLC %d: htreadregs error: CMDNACK or CMDREJECT: fetchreg=%d, fetchregistercount=%d. exiting.\n",
                                 mod, fetchreg, fetchregistercount);
                    }
                    return (TRUE);
                }
                if ((pmod->htregs.data_valid != TRUE) || (pmod->htregs.validcount != fetchregistercount))
                {
                    /* this is for testing only. if the previous call to readhtregs was good,   */
                    /* then data_valid should always be TRUE, and the length should be correct. */
                    if (htdebug [line] >= 4)
                    {
                        printf ("htrendcheck: PLC %d: htreadregs error: data not valid: fetchreg=%d, fetchregistercount=%d. exiting.\n",
                                 mod, fetchreg, fetchregistercount);
                    }
                    return (TRUE);
                }
                /* to arrive here means that everything with the data acquisition went ok,     */
                /* and the data is sitting in the buffer. waiting to be sent to Sinbad.        */
                for (i = 0 ; i < fetchrecordcount; i++)
                {
                    /* prepare to mark the data as read. */
                    bitindex = (fetchnickel+i)%MASKBITS;
                    arrayindex = bitindex/8;
                    arraymask = 0x01 << (bitindex%8);

                    /* build the message to send to Sinbad */
                    /* 12-12-97: reference time at the end of the nickel instead of the beginning. */
/* 12/17/97                    updatetime = (fetchnickel+i+1) * secondspernickel; /* this is in seconds */
                    updatetime = (fetchnickel+i) * secondspernickel; /* this is in seconds */
                    dataoffset = i * regcount;

                    archivetime.secPastEpoch = updatetime;
                    archivetime.nsec = 0;

                    if (fakeSinbad [line])
                    {
                        if (htdebug [line] >= 8)
                        {
                            printf ("htrendcheck: PLC %d: PseudoQueueTrendUpdate: %s, index=%d, mask=%x%x, regcount=%d ",
                                     mod,
                                     tsStampToText(&archivetime, TS_TEXT_MONDDYYYY, dummybuffer),
                                     arrayindex,
                                     arraymask/16, arraymask%16,
                                     regcount);

                            if (htdebug [line] >= 10)
                            {
                                printf (": %5d", pmod->htregs.ioregs[dataoffset]);
                                for (k = 1; k < regcount; k++)
                                {
                                    printf (", %5d", pmod->htregs.ioregs[dataoffset+k]);
                                }
                            }
                            printf ("\n");
                        }
                        temp = PseudoQueueTrendUpdate (updatetime,
                                                (long)   line,
                                                (long)   mod,
                                                (char *) &pmod->htregs.ioregs[dataoffset],
                                                (long)    regcount,
                                                (char *) &pmap->htmasks[mod].savedmask[arrayindex],
                                                (char)    arraymask);
                    }
                    else
                    {
                        if (htdebug [line] >= 8)
                        {
                            printf ("htrendcheck: PLC %d: QueueTrendUpdate: %s, index=%d, mask=%x%x, regcount=%d ",
                                     mod,
                                     tsStampToText(&archivetime, TS_TEXT_MONDDYYYY, dummybuffer),
                                     arrayindex,
                                     arraymask/16, arraymask%16,
                                     regcount);

                            if (htdebug [line] >= 10)
                            {
                                printf (": %5d", pmod->htregs.ioregs[dataoffset]);
                                for (k = 1; k < regcount; k++)
                                {
                                    printf (", %5d", pmod->htregs.ioregs[dataoffset+k]);
                                }
                            }
                            printf ("\n");
                        }
                        temp = QueueTrendUpdate (updatetime,
                                                (long)   line,
                                                (long)   mod,
                                                (char *) &pmod->htregs.ioregs[dataoffset],
                                                (long)    regcount,
                                                (char *) &pmap->htmasks[mod].savedmask[arrayindex],
                                                (char)    arraymask);
                    }




                    if (temp == FALSE)
                    {
                        /* if Sinbad's code cannot queue the data, the link to the   */
                        /* host is probably down. Do NOT mark validmask bit as TRUE. */
                        /* Abandon all remaining fetched but unqueued data. Stop     */
                        /* trying to queue data for now. After leaving here, the     */
                        /* driver will resume polling. Later, when this routine is   */
                        /* reached again, the program will end up refetching this    */
                        /* same set of remaining data. C'est la guerre.              */
                        if (htdebug [line] >= 4)
                        {
                            printf ("htrendcheck: PLC %d: QueueTrendUpdate returned error status. exiting. \n");
                            if (htdebug [line] >= 8)
                            {
                                printf ("htrendcheck:         updatetime=%d, dataoffset=%d, regcount=%d arrayindex=%d, arraymask=%x%x.\n",
                                                              updatetime, dataoffset, regcount, arrayindex, arraymask/16, arraymask%16);
                            }
                        }
                        return (FALSE);
                    }
                    /* if data queued successfully, mark the data as read. */
                    temp = pmap->htmasks[mod].validmask[arrayindex] | arraymask; /* set bit to valid */
                    pmap->htmasks[mod].validmask[arrayindex] = temp;
                }
                /* on entry and exit */
                if (htdebug [line] >= 12)
                {
                    nwmoddumpmap(line, mod);
                }
                if (htdebug [line] >= 6)
                {
                    printf ("htrendcheck: PLC %d: Bottom Of Fetch Completed Logic. exiting.\n", mod);
                }
                return (TRUE);
            }
        }
    }
    if (htdebug [line] >= 14)
    {
        printf ("htrendcheck: EXIT: end reached without finding missing data to retrieve. exiting.\n");
    }
    return (FALSE);
}


static	void sim_plc (MODPLC *pmod, unsigned short line, unsigned short mod)
    {
	unsigned short	i, j, k, val, bitaddr, regaddr, readlen;
	unsigned long   bitmask;
	LOADINFO	sslinfo;
        unsigned short  temp, cmd;

	pmod->is_responding = pmod->was_requested;

	/* read the coil values to be scanned */

	for (i = 0; (i < NUMMODCOILS); i++)
	{
	    pmod->coils [i].data_valid = pmod->coils [i].was_requested;
	    if (simdigon [line])
	    {
		pmod->coils [i].last_read = ~pmod->coils [i].last_read;
	    }
	}

	/* read the di values to be scanned */

	for (i = 0; (i < NUMMODDIS); i++)
	{
	    pmod->dis [i].data_valid = pmod->coils [i].was_requested;
	    if (simdigon [line])
	    {
	        pmod->dis [i].last_read = ~pmod->dis [i].last_read;
	    }
	}

	/* read the ai values to be scanned */

	for (i = 0; (i < NUMMODAIS); i++)
	{
	    pmod->ais [i].data_valid = pmod->ais [i].was_requested;
	    for (j = 0; j < REGBLOCK; j++)
	    {
		if ((pmod->ais [i].aivals [j] < simlow [line]) ||
		    (pmod->ais [i].aivals [j] >= simhigh [line]))
		{
		    pmod->ais [i].aivals [j] = simlow [line];
		}
		else
		{
                    pmod->ais [i].aivals [j] += 1;
		}
	    }
	}

	/* read the reg values to be scanned */

	for (i = 0; (i < NUMREGISTERS); i++)
	{
	    pmod->regs [i].data_valid = pmod->regs [i].was_requested;
	    for (j = 0; j < REGBLOCK; j++)
	    {
		if ((pmod->regs [i].ioregs [j] < simlow [line]) ||
		    (pmod->regs [i].ioregs [j] >= simhigh [line]))
		{
		    pmod->regs [i].ioregs [j] = simlow [line];
		}
		else
		{
                    pmod->regs [i].ioregs [j] += 1;
		}
	    }
	}
}
/*
/* checkoutputs
/*      checks output que and returns if empty.
/*      if there is something on the queue it attempts to process all
/*      pending outputs, doing immediate retries. If attempts fail the request is dropped.      
/*
*/                                                                                              
/* this routine only called from scan_plc */

static	void checkoutputs (unsigned short line)
{
	OUTQENT         *optr;
	unsigned short  regaddr, regval, link, adapter, coiladdr, conv;
	unsigned long   coilmask, coilval;
	MODPLC          *pmod;
	double 		dblaovalue;
        unsigned short  stringaddr, stringlen;
	unsigned char	*pstringval;
	unsigned short	write_status;

        if (mltrace [line] == 6)
	{
            logMsg ("Checking Output Queue ...\n"); 
	}

	while ((optr = ogetnextp (line)) != NULLP)
	{
	    if ((optr->otype) == AOUTTYPE)
	    {
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;
		pmod = plcs [link] [adapter];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, adapter))
		    {
			return; /* if not allocated, try. if can't allocate, get out. */
		    }
        	    pmod = plcs [link] [adapter];
		}
		regaddr = optr->out.aonode.aosignal;
		regval = optr->out.aonode.aovalue;
		dblaovalue = optr->out.aonode.dblaovalue;
		conv = optr->out.aonode.conversion;
                if (mltrace [link] == 7)
                {
                    logMsg("AO IN QUEUE: L=%d, A=%d,       S=%d, Value=%d\n",
                           link, adapter, regaddr, regval);
                } 

		if ((!pmod->cmd_force_offline) &&
                    (resresponse [link]) &&
                    (pmod->is_responding))
		{
                    loopoutmsgs [line]++;
		    write_status = setreg (link, adapter, pmod, regaddr, regval, dblaovalue, conv);
		    if (write_status != CMDDONE)
		    {
		        pmod->badoutcnt++;
                        if (mltrace [link] == 3)
			{
                            logMsg("AO DEQUEUE: Output failed: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, regaddr, regval);
			} 
		    }
                    else
		    {
                        if (mltrace [link] == 3)
			{
                            logMsg ("AO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, regaddr, regval);
			} 
		    }

		}
	    }
	    else if ((optr->otype) == BOUTTYPE)
	    {
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;
		pmod = plcs [link] [adapter];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, adapter))
		    {
			return; /* if not allocated, try. if can't allocate, get out. */
		    }
        	    pmod = plcs [link] [adapter];
		}
		coiladdr = optr->out.bonode.bosignal;
		coilval = optr->out.bonode.bovalue;
		coilmask = optr->out.bonode.bomask;
                if (mltrace [link] == 7)
                {
                    logMsg("BO IN QUEUE: L=%d, A=%d,       S=%d, Value=%d\n",
                           link, adapter, coiladdr, coilval);
                }

		if ((!pmod->cmd_force_offline) &&
                    (resresponse [link]) &&
                    (pmod->is_responding))
		{
                    loopoutmsgs [line]++;
		    write_status = setcoil (link, adapter, pmod, coiladdr, coilmask, coilval);
		    if (write_status != CMDDONE)
		    {
			pmod->badoutcnt++;
                        if (mltrace [link] == 4)
			{
                            logMsg("BO DEQUEUE: Output failed: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, coiladdr, coilval);
			}
		    }
                    else
		    {
                        if (mltrace [link] == 4)
			{
                            logMsg("BO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d, Value=%d\n",
                                   link, adapter, coiladdr, coilval);
			}
		    }
		}
	    }
	    else if ((optr->otype) == SOUTTYPE)
	    {
		link = optr->out.sonode.link;
		adapter = optr->out.sonode.adapter;
/*		card = optr->out.sonode.card; */
		pmod = plcs [link] [adapter];
		if (pmod == NULL)
		{
		    if (!allocate_plc (link, adapter))
		    {
			return; /* if not allocated, try. if can't allocate, get out. */
		    }
        	    pmod = plcs [link] [adapter];
		}
		stringaddr = optr->out.sonode.sosignal;
		stringlen  = optr->out.sonode.solen;
		pstringval = optr->out.sonode.sovalue;
		if (mltrace [line] == 7)
		{
                    logMsg("SO IN QUEUE: L=%d, A=%d,       S=%d\n",
                           link, adapter, stringaddr);
		}

		if ((!pmod->cmd_force_offline) &&
                    (resresponse [link]) &&
                    (pmod->is_responding))
		{
                    loopoutmsgs [line]++;
		    if ((setstring (link, adapter, pmod, stringaddr, pstringval, stringlen)) != CMDDONE)
		    {
			pmod->badoutcnt++;
                        if (mltrace [link] == 5)
			{
                            logMsg ("SO DEQUEUE: Output failed: L=%d, A=%d,       S=%d\n",
                                   link,adapter,stringaddr);
			}
		    }
                    else
		    {
                        if (mltrace [link] == 5)
			{
                            logMsg ("SO DEQUEUE: Output succeeded: L=%d, A=%d,       S=%d\n",
                                   link, adapter, stringaddr);
			}
		    }
		}
	    }
	    oreleasefull (line);     /* release the output que entry */
	}
}

/*                                                                                     
/*      AIDRIVER                                                                       
/*                                                                                     
/*      This routines main purpose is to return the analog input value for the         
/*      specified module. For a module value                                           
/*      a (-1) will be returned if there is no valid data ready.                       
/*
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname)
    {
	MODPLC		*pmod;
	unsigned short  blkix;
	unsigned short	*pdata;
        LOADID         *idinfo;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != MAINS) && (card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pmod->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pmod->is_responding;
		break;

	    case 2: /* The program Load request */
		*pvalue = pmod->prog_load_stat;
		break;

	    case 3: /* PLC Program Load Block Number */
		*pvalue = pmod->prog_load_page;
		break;

	    case 4: /* Set the program number to Load */
		*pvalue = pmod->prog_load_number;
		break;

	    case 5: /* Output Messages */
		*pvalue = pmod->no_dataout_msgs & 0x7fff;
		break;

	    case 6: /* Input Messages */
		*pvalue = pmod->no_datain_msgs & 0x7fff;
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = pmod->no_rxnoresp & 0x7fff;
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = pmod->no_txnoresp & 0x7fff;
		break;

	    case 9: /* Data Echo Errors */
		*pvalue = pmod->no_dataerr & 0x7fff;
		break;

	    case 10: /* Message Retries */
		*pvalue = pmod->no_retries & 0x7fff;
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = pmod->no_rxhwerrs & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = pmod->no_txhwerrs & 0x7fff;
		break;

	    case 13: /* CRC errors */
		*pvalue = pmod->no_crcerrs & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*pvalue = pmod->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = pmod->badoutcnt & 0x7fff;
		break;

	    case 20: /* What is the program load comp code for the plc? */
		*pvalue = pmod->prog_load_code;
		break;

            case 23: /* User ID Download Pending flag */
                *pvalue = pmod->id_pending;
                break;

            case 24: /* User ID File Load Request */
                idinfo = &idtable[link];
                *pvalue = idinfo->was_requested;
                break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }
	    return (0);
	}

	if (card == MAINS)
	{
            if ((signal > MAXAINO) || (signal < MINAINO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d,: max=%d, min=%d\n",
                            pointname, link, adapter, card, signal, MAXAINO, MINAINO);
                return (-1);
            }

            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--; /* Signals are defined as 1 relative */
            blkix = (signal / REGBLOCK);

            /* check for trans-REGBLOCK boundary access */
            if (((conversion == AICNVDOUBLEINT)  ||
                 (conversion == AICNVFLOAT    )) &&
                ((signal % REGBLOCK) == 3      ))
            {
	            if (blkix+1 >= NUMMODAIS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pmod->ais [blkix].was_requested = TRUE;
	            pmod->ais [blkix+1].was_requested = TRUE;
	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if ((!pmod->ais [blkix].data_valid) || (!pmod->ais [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
		    pvalue[1] = pmod->ais [blkix].aivals [3];
		    pvalue[0] = pmod->ais [blkix+1].aivals [0];
                    if (mltrace[link] == 8)
                        logMsg("AIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* check for trans-REGBLOCK boundary access */
            if ((conversion == AICNVDOUBLEFLT) &&
                ((signal % REGBLOCK) != 0      ))
            {
	            if (blkix+1 >= NUMMODAIS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                    /* as soon as the address is confirmed as valid, set requested bits. */
	            pmod->ais [blkix].was_requested = TRUE;
	            pmod->ais [blkix+1].was_requested = TRUE;
	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if ((!pmod->ais [blkix].data_valid) || (!pmod->ais [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
	            }
		    switch (signal % REGBLOCK)
                    {
                        case (1):
                             pvalue[3] = pmod->ais [blkix].aivals [1];
		             pvalue[2] = pmod->ais [blkix].aivals [2];
		             pvalue[1] = pmod->ais [blkix].aivals [3];
		             pvalue[0] = pmod->ais [blkix+1].aivals [0];
                             break;
                        case (2):
                             pvalue[3] = pmod->ais [blkix].aivals [2];
		             pvalue[2] = pmod->ais [blkix].aivals [3];
		             pvalue[1] = pmod->ais [blkix+1].aivals [0];
		             pvalue[0] = pmod->ais [blkix+1].aivals [1];
                             break;
                        case (3):
                             pvalue[3] = pmod->ais [blkix].aivals [3];
		             pvalue[2] = pmod->ais [blkix+1].aivals [0];
		             pvalue[1] = pmod->ais [blkix+1].aivals [1];
		             pvalue[0] = pmod->ais [blkix+1].aivals [2];
                             break;
                        default:
                             return(-1); /* condition can never happen */
                    }
                    if (mltrace[link] == 8)
                        logMsg("AIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* as soon as the address is confirmed as valid, set requested bits. */
	    pmod->ais [blkix].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if (pmod->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-2);
            }
            if (!pmod->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
	    if (!pmod->ais [blkix].data_valid)
            {
               if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Data Not Valid(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
               return (-1);
	    }
            pdata = ((unsigned short*) &(pmod->ais [blkix].aivals [signal % REGBLOCK]));

	    /* Select the Size and Type of Response based on Conversion */
	    switch (conversion)
	    {
	        case (AICNVDOUBLEINT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVFLOAT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVDOUBLEFLT):
		     pvalue[0] = pdata[3];
		     pvalue[1] = pdata[2];
		     pvalue[2] = pdata[1];
		     pvalue[3] = pdata[0];
		     break;
	        case (AICNVINTEGER):
	        default:
		     *pvalue = *pdata;
		     break;
            }
            if (mltrace[link] == 8)
                logMsg("AIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                        pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
            return(0);
	}

	if (card == MREGS)
	{
            if ((signal > MAXREGNO) || (signal < MINREGNO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal signal(0):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }

            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--; /* Signals are defined as 1 relative */
            blkix = (signal / REGBLOCK);

            /* check for trans-REGBLOCK boundary access */
            if (((conversion == AICNVDOUBLEINT)  ||
                 (conversion == AICNVFLOAT    )) &&
                ((signal % REGBLOCK) == 3      ))
            {
	            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pmod->regs [blkix].was_requested = TRUE;
	            pmod->regs [blkix+1].was_requested = TRUE;
	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if ((!pmod->regs [blkix].data_valid) || (!pmod->regs [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(1):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
		    pvalue[1] = pmod->regs [blkix].ioregs [3];
		    pvalue[0] = pmod->regs [blkix+1].ioregs [0];
                    if (mltrace[link] == 8)
                        logMsg("AIDRIVER: Data Returned(4):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* check for trans-REGBLOCK boundary access */
            if ((conversion == AICNVDOUBLEFLT) &&
                ((signal % REGBLOCK) != 0      ))
            {
	            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AIDRIVER: Point extends beyond legal signal range(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
                    /* as soon as the address is confirmed as valid, set requested bits. */
	            pmod->regs [blkix].was_requested = TRUE;
	            pmod->regs [blkix+1].was_requested = TRUE;
	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
	            if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if ((!pmod->regs [blkix].data_valid) || (!pmod->regs [blkix+1].data_valid))
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid(2):[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
		    switch (signal % REGBLOCK)
                    {
                        case (1):
                             pvalue[3] = pmod->regs [blkix].ioregs [1];
		             pvalue[2] = pmod->regs [blkix].ioregs [2];
		             pvalue[1] = pmod->regs [blkix].ioregs [3];
		             pvalue[0] = pmod->regs [blkix+1].ioregs [0];
                             break;
                        case (2):
                             pvalue[3] = pmod->regs [blkix].ioregs [2];
		             pvalue[2] = pmod->regs [blkix].ioregs [3];
		             pvalue[1] = pmod->regs [blkix+1].ioregs [0];
		             pvalue[0] = pmod->regs [blkix+1].ioregs [1];
                             break;
                        case (3):
                             pvalue[3] = pmod->regs [blkix].ioregs [3];
		             pvalue[2] = pmod->regs [blkix+1].ioregs [0];
		             pvalue[1] = pmod->regs [blkix+1].ioregs [1];
		             pvalue[0] = pmod->regs [blkix+1].ioregs [2];
                             break;
                        default:
                             return(-1); /* condition can never happen */
                    }
                    if (mltrace[link] == 8)
                        logMsg("AIDRIVER: Data Returned(5):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* as soon as the address is confirmed as valid, set requested bits. */
	    pmod->regs [blkix].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Driver Offline(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if (pmod->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: On Hold(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-2);
            }
            if (!pmod->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Not Responding(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
	    if (!pmod->regs [blkix].data_valid)
            {
               if (trace[link] & CALLREJECTTRACE)
                    logMsg("AIDRIVER: Data Not Valid(3):[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
	       return (-1);
	    }
            pdata = &(pmod->regs [blkix].ioregs [signal % REGBLOCK]);

	    /* Select the Size and Type of Response based on Conversion */
	    switch (conversion)
	    {
	        case (AICNVDOUBLEINT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVFLOAT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	        case (AICNVDOUBLEFLT):
		     pvalue[0] = pdata[3];
		     pvalue[1] = pdata[2];
		     pvalue[2] = pdata[1];
		     pvalue[3] = pdata[0];
		     break;
	        case (AICNVINTEGER):
	        default:
		     *pvalue = *pdata;
		     break;
            }
            if (mltrace[link] == 8)
                logMsg("AIDRIVER: Data Returned(6):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                        pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
            return(0);
	}
	return(-1);
    }

/*  										
/*      AODRIVER                                                                
/*                                                                            	
/*      This routines main purpose is to set requested analog outputs to the  	
/*      specified module.                                                     	
*/                                                                            	
/* this routine not called from within this driver */


int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	    unsigned short signal,double dvalue, unsigned short value,
	    unsigned short conversion, unsigned char *resname)

{
	MODPLC		*pmod;
	unsigned	short  blkix;
	OUTQENT		*oqp;
        LOADID         *idinfo;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
	if ((card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}
	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
	    case 2: /* Set the program Load request */
		if (value != 0)
		{
		    pmod->prog_load_stat = PLC_LOAD_REQUESTED;
		}
		break;

	    case 4: /* Set the program number to Load */
		pmod->prog_load_number = value;
		break;

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats(pmod);
		}
		break;

	    case 16: /* Force the PLC online/offline */
		pmod->cmd_force_offline = (value != 0);
                if (value != 0)
		{
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		}
		break;

	    case 23: /* Set User ID Download Pending flag */
		if (value != 0)
		{
                    pmod->id_pending = TRUE;
                }
		break;

	    case 24: /* Set User ID File Load Request */
		if (value != 0)
		{
                    idinfo = &idtable[link];
                    idinfo->was_requested = TRUE;
                }
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXREGNO) || (signal < MINREGNO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}
	if (resname != 0)
	{ 
	    register_resource (link, pmod, resname, pointname);
	}

	pmod->was_requested = TRUE;

	signal--; /* Signals are defined as 1 relative */
	blkix = (signal / REGBLOCK);

	pmod->regs [blkix].was_requested = TRUE;

        /* check for trans-REGBLOCK boundary access */
        if ((conversion == ASCFLT) && ((signal % REGBLOCK) == 3))
        {
            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg(
                "AODRIVER: Point extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal+1, value);
                return (-1);
            }
            /* as soon as the address is confirmed as valid, set next block's requested bits. */
            pmod->regs [blkix+1].was_requested = TRUE;
        }

	if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
            return (-1);
        }

        /* check for plc simulated mode. */
        if (modsim [link])
        {
            if (mltrace [link] == 3)
	    {
                logMsg("AODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
	    }
            return (0);
        }

	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
            if (trace[link] & RUNTIMEERRORTRACE)
            {
                logMsg("AODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
	    }
	    pmod->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;

        oqp->out.aonode.aovalue = value;

	oqp->out.aonode.dblaovalue = dvalue;
	oqp->out.aonode.conversion = conversion;

	omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace [link] == 3)
	{
            logMsg("AODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal+1, value);
	}
	return (0);
}

/*                                                                             
/*      AOREAD                                                                  
/*                                                                          	
/*      This routines main purpose is to return the value last read back     	
/*      from the analog output hardware. This is used to initialize analog   	
/*      outputs.                                                             	
*/
/* this routine not called from within this driver */


int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	  unsigned short signal, unsigned short *pvalue,
	  unsigned short conversion, unsigned char *resname)

    {
	MODPLC		*pmod;
	unsigned short  blkix, *pdata;
        LOADID         *idinfo;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
                return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
	    case 2: /* read the most recent program Load request */
		*pvalue = pmod->prog_load_stat;
		break;

	    case 4: /* read the most recent program number to Load */
		*pvalue = pmod->prog_load_number;
		break;

	    case 15: /* read statistics command value */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Read the current PLC offline command status */
		*pvalue = pmod->cmd_force_offline;
		break;

            case 23: /* User ID Download Pending flag */
                *pvalue = pmod->id_pending;
                break;

            case 24: /* User ID File Load Request */
                idinfo = &idtable[link];
                *pvalue = idinfo->was_requested;
                break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return(-1);
	    }
	    return (0);
	}

	if (card == MREGS)
	{
            if ((signal > MAXREGNO) || (signal < MINREGNO))
	    {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }

            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--; /* Signals are defined as 1 relative */
            blkix = (signal / REGBLOCK);

            /* check for trans-REGBLOCK boundary access */
            if (  (conversion == ASCFLT)  &&
                  ((signal % REGBLOCK) == 3) )
            {
	            if (blkix+1 >= NUMREGISTERS)   /* if at top of register space, give up */
                    {
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg(
                    "AOREAD: Point extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pmod->regs [blkix].was_requested = TRUE;
	            pmod->regs [blkix+1].was_requested = TRUE;
                    if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                    if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
                    if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
	            if ((!pmod->regs [blkix].data_valid) || (!pmod->regs [blkix+1].data_valid))
                    {
                       if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
		        return (-1);
	            }
		    pvalue[1] = pmod->regs [blkix].ioregs [3];
		    pvalue[0] = pmod->regs [blkix+1].ioregs [0];
                    if (mltrace[link] == 8)
                        logMsg("AOREAD: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
                    return(0);
            }
            /* as soon as the address is confirmed as valid, set requested bits. */
	    pmod->regs [blkix].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if (pmod->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-2);
            }
            if (!pmod->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
	    if (!pmod->regs [blkix].data_valid)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("AOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            pdata = &(pmod->regs [blkix].ioregs [signal % REGBLOCK]);

	    /* Select the Size and Type of Response based on Conversion */
	    switch (conversion)
	    {
	        case (ASCFLT):
		     pvalue[0] = pdata[1];
		     pvalue[1] = pdata[0];
		     break;
	       default:
		     *pvalue = *pdata;
		     break;
            }
            if (mltrace[link] == 8)
                logMsg("AOREAD: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                        pointname, link, adapter, card, signal+1, pvalue[0], pvalue[1]);
	    return(0);
	}
	return(-1);
    }

/*                                                                                     
/*      BIDRIVER                                                                        
/*                                                                               	
/*      The main purpose of this routine is to return the request digital input  	
/*      value(s) from the requested card. This routine will return a (-1) if the  	
/*      requested module is the wrong type or the data is not yet valid.          	
/*                                                                                	
*/
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask, unsigned long *pvalue,
		unsigned char *resname)
    {
	MODPLC 		*pmod;
	unsigned short	blkix, blkoff;
	         int    mincard, zzzz, i;
        unsigned long	straight, reverse;
        unsigned long	tvalue;
        LOADID         *idinfo;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        /* North Wales Special: Registers can be read a BI points */
	if ((card != MDINS) &&
            (card != MCOILS) &&
            (card != MPSEUDO) &&
            (!((card >= MINSTATUSCARD) && (card <= MAXSTATUSCARD)))
           )
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return (-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	pmod->was_requested = TRUE;

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
                case 0: /* Were the PLC values requested */
                    *pvalue = pmod->was_requested;
                    break;

                case 1: /* Is the PLC responding */
                    *pvalue = pmod->is_responding;
                    break;

                case 15: /* reset statistics */
                    *pvalue = pmod->cmd_reset_stat;
                    break;

                case 16: /* Force the PLC offline */
                    *pvalue = pmod->cmd_force_offline;
                    break;

                case 20: /* What is the selected channel for the line */
                    *pvalue = pmod->prog_load_code;
                    break;

                case 23: /* User ID Download Pending flag */
                    *pvalue = pmod->id_pending;
                    break;

	        case 24: /* User ID File Load Request */
                    idinfo = &idtable[link];
                    *pvalue = idinfo->was_requested;
		    break;

                default:
                    if (trace[link] & CONFIGURATIONTRACE)
                        logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal);
                    return (-1);
            }
            return (0);
        }

	tvalue = 0;

        /* North Wales Special: the card number range indicates 'status' registers */
        /*****************/
        if ((card >= MINSTATUSCARD) && (card <= MAXSTATUSCARD))
        {
            if ((signal > MAXSTATUSNO) || (signal < MINSTATUSNO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }

            if ( (mask & 0xFFFF0000) != 0)
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal mbbi bit range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (resname != 0)
            { 
                register_resource(link, pmod, resname, pointname);
            }

            pmod->was_requested = TRUE;
            signal--;                   /* Signals are defined as 1 relative */

            mincard = MINSTATUSCARD;
            zzzz = (int)card - mincard;

            /* North Wales Special: the card number holds the register number */
            blkix  = ((int)card - mincard)/REGBLOCK;
            blkoff = ((int)card - mincard)%REGBLOCK;

            pmod->regs [blkix].was_requested = TRUE;
            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if (pmod->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-2);
            }
            if (!pmod->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if (!pmod->regs [blkix].data_valid)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }

            /*  North Wales Special: reverse the bit order of the data */
            straight = (unsigned long) pmod->regs [blkix].ioregs[blkoff];
            reverse = 0;
            /* do first 15 in loop with shift */
            for (i = 0; i < 15; i++)
            {
                if (straight & 1) reverse = reverse | 1;
                straight = straight >> 1;
                reverse = reverse << 1;
            }
            /* do last bit without shift */
            if (straight & 1) reverse = reverse | 1;

            tvalue = reverse;
	    *pvalue = tvalue & mask;

/* ****************************** */
/* remove this in production code */
            if (mltrace[link] == 9)
                logMsg("BIDRIVER: Reg Number=%d, Reg Block=%d, Reg Offset=%d, mask=0x%x\n",
                        zzzz, blkix, blkoff, mask);
            if (mltrace[link] == 9)
                logMsg("BIDRIVER: Straight Data=0x%x, Reverse Data=0x%x\n",
                        straight, reverse);
/* ****************************** */


            if (mltrace[link] == 9)
                logMsg("BIDRIVER: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                        pointname, link, adapter, card, signal+1, *pvalue);
            return (0);
	}




        /*****************/
	if (card == MDINS)
	{
            if ((signal > MAXDINO) || (signal < MINDINO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--; /* Signals are defined as 1 relative */
            blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */

	    if ( (mask & 0x000000FF) != 0)
	    {
	        pmod->dis [blkix].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->dis [blkix].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue = pmod->dis [blkix].last_read & mask;
	    }
	    if ( (mask & 0x0000FF00) != 0)
	    {
	        pmod->dis [blkix+1].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->dis [blkix+1].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->dis [blkix+1].last_read) << 8;
	    }
	    if ( (mask & 0x00FF0000) != 0)
	    {
	        pmod->dis [blkix+2].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->dis [blkix+2].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->dis [blkix+2].last_read) << 16;
	    }
	    if ( (mask & 0xFF000000) != 0)
	    {
	        pmod->dis [blkix+3].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->dis [blkix+3].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->dis [blkix+3].last_read) << 24;
	    }
	    *pvalue = tvalue & mask;
            if (mltrace[link] == 9)
                logMsg("BIDRIVER: Data Returned(2):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                        pointname, link, adapter, card, signal+1, *pvalue);
	    return (0);
	}

        /*****************/
	if (card == MCOILS)
	{
            if ((signal > MAXCOILNO) || (signal < MINCOILNO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--; /* Signals are defined as 1 relative */
            blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */

	    if ( (mask & 0x000000FF) != 0)
	    {
	        pmod->coils [blkix].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->coils [blkix].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue = pmod->coils [blkix].last_read & mask;
	    }
	    if ( (mask & 0x0000FF00) != 0)
	    {
	        pmod->coils [blkix+1].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->coils [blkix+1].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->coils [blkix+1].last_read) << 8;
	    }
	    if ( (mask & 0x00FF0000) != 0)
	    {
	        pmod->coils [blkix+2].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->coils [blkix+2].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->coils [blkix+2].last_read) << 16;
	    }
	    if ( (mask & 0xFF000000) != 0)
	    {
	        pmod->coils [blkix+3].was_requested = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
		if (!pmod->coils [blkix+3].data_valid)
		{
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
		    return (-1);
		}
	        tvalue += (unsigned long) (pmod->coils [blkix+3].last_read) << 24;
	    }
	    *pvalue = tvalue & mask;
            if (mltrace[link] == 9)
                logMsg("BIDRIVER: Data Returned(3):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                        pointname, link, adapter, card, signal+1, *pvalue);
	    return (0);
	}
	return (-1);
    }
/*                                                                                     
/*      BODRIVER                                                                        
/*                                                                                 	
/*      The main purpose of this routine is to set the request digital output      	
/*      value(s) on the requested card. This routine will return a (-1) if the     	
/*      requested module is the wrong type or not configured yet.                  	
/*                                                                                 	
*/
/* this routine not called from within this driver */

int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long value, unsigned long mask,
		unsigned char *resname)
    {
	MODPLC 		*pmod;
	OUTQENT		*oqp;
	unsigned short  blkix;
        LOADID         *idinfo;

        if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
        if (adapter > NUMMODPLCS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }
        if ((card != MCOILS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return(-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal & 0x1f)
	    {

	    case 2: /* Set the program Load request */
		if (value != 0)
		{
		    pmod->prog_load_stat = PLC_LOAD_REQUESTED;
		}
		break;

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
		{
		    initstats (pmod);
		}
		break;

	    case 16: /* Force the PLC offline */
		pmod->cmd_force_offline = (value != 0);
                if (value != 0)
		{
                    pmod->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		}
		break;

	    case 21: /* Start the PLC */
		pmod -> plc_start = (value != 0);
		break;

	    case 22: /* What is the selected channel for the line */
		pmod-> plc_stop = (value != 0);
		break;

	    case 23: /* Set User ID Download Pending flag */
		pmod->id_pending = TRUE;
		break;

	    case 24: /* Set User ID File Load Request */
                idinfo = &idtable[link];
                idinfo->was_requested = TRUE;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXCOILNO) || (signal < MINCOILNO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}

	if (resname != 0)
	{ 
	    register_resource(link,pmod,resname,pointname);
	}

        pmod->was_requested = TRUE;

	signal--; /* Signals are defined as 1 relative */
	blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */
						/* masks aligned on 32 bits */

/*      North Wales Special: BODRIVER does not set was_requested flag */
/*
	if ((mask & 0x000000FF) != 0)
	{
	    pmod->coils [blkix].was_requested = TRUE;
	}
	if ((mask & 0x0000FF00) != 0)
	{
	    pmod->coils [blkix+1].was_requested = TRUE;
	}
	if ((mask & 0x00FF0000) != 0)
	{
	    pmod->coils [blkix+2].was_requested = TRUE;
	}
	if ((mask & 0xFF000000) != 0)
	{
	    pmod->coils [blkix+3].was_requested = TRUE;
	}
*/
	if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
            return (-1);
        }

        if (modsim [link])
        {
            if (mltrace [link] == 4)
	    {
                logMsg("BODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
	    }
            return (0);
        }
	if ((!pmod->is_responding) || (pmod->cmd_force_offline))
	{
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("BODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal+1, value);
	    pmod->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bovalue = value;

	omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 4)
            logMsg("BODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal+1, value);
	return (0);
    }
/*
/*      BOREAD                                                                  
/*                                                                              
/*      This routines main purpose is to return the value last read back      	
/*      from the digital output hardware. This is used to initialize digital  	
/*      outputs. This will return a (-1) if the module is the wrong type or    	
/*      the data is not yet valid                                              	
*/
/* this routine not called from within this driver */


int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)
{
	MODPLC		*pmod;
	unsigned short  blkix;
	unsigned long	tvalue;
        LOADID         *idinfo;

        if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if (adapter > NUMMODPLCS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
        if ((card != MCOILS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs [link] [adapter];
	if (pmod == NULL)
	{
	    if (!allocate_plc (link, adapter))
	    {
		return(-1); /* if not allocated, try. if can't allocate, get out. */
	    }
	    pmod = plcs [link] [adapter];
	}

	if (card == MPSEUDO)
	{
	    switch (signal)
	    {
	    case 2: /* Set the program Load request */
		*pvalue = 0;
		break;

	    case 15: /* reset statistics */
		*pvalue = pmod->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pmod->cmd_force_offline;
		break;

	    case 21: /* Start the PLC */
		*pvalue = pmod -> plc_start; 
		break;

	    case 22: /* What is the selected channel for the line */
		*pvalue = pmod-> plc_stop;
		break;

	    case 23: /* User ID Download Pending flag */
		*pvalue = pmod->id_pending;
		break;

	    case 24: /* User ID File Load Request */
                idinfo = &idtable[link];
                *pvalue = idinfo->was_requested;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXCOILNO) || (signal < MINCOILNO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
	    return (-1);
	}

	if (resname != 0)
	{
             register_resource (link, pmod, resname, pointname);
	}

        pmod->was_requested = TRUE;

	signal--; /* Signals are defined as 1 relative */
	blkix = ((signal / 8) & 0xFFFC);	/* 8 bits per digital BLOCK */
						/* masks aligned on 32 bits */
	tvalue = 0;

	if ((mask & 0x000000FF) != 0)
	{
            /* North Wales Special: BODRIVER does not set was_requested flag */
	    pmod->coils [blkix].init_writeflag = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
	    if (!pmod->coils [blkix].data_valid)
	    {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
		return (-1);
	    }
	    tvalue = pmod->coils [blkix].last_read & mask;
	}
	if ( (mask & 0x0000FF00) != 0)
	{
            /* North Wales Special: BODRIVER does not set was_requested flag */
	    pmod->coils [blkix+1].init_writeflag = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
	    if (!pmod->coils [blkix+1].data_valid)
	    {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
	    }
	    tvalue += (unsigned long) (pmod->coils [blkix+1].last_read) << 8;
	}
	if ( (mask & 0x00FF0000) != 0)
	{
            /* North Wales Special: BODRIVER does not set was_requested flag */
	    pmod->coils [blkix+2].init_writeflag = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
	    if (!pmod->coils [blkix+2].data_valid)
	    {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
	    }
	    tvalue += (unsigned long) (pmod->coils [blkix+2].last_read) << 16;
	}
	if ( (mask & 0xFF000000) != 0)
	{
            /* North Wales Special: BODRIVER does not set was_requested flag */
	    pmod->coils [blkix+3].init_writeflag = TRUE;
                if (!resresponse[link])
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
                if (pmod->holdflag)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-2);
                }
                if (!pmod->is_responding)
                {
                    if (trace[link] & CALLREJECTTRACE)
                        logMsg("BOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                pointname, link, adapter, card, signal+1);
                    return (-1);
                }
	    if (!pmod->coils [blkix+3].data_valid)
	    {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
	    }
	    tvalue += (unsigned long) (pmod->coils [blkix+3].last_read) << 24;
	}
	*pvalue = tvalue & mask;
        if (mltrace[link] == 9)
            logMsg("BOREAD: Data Returned(1):[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                    pointname, link, adapter, card, signal+1, *pvalue);

	return (0);
}
/*                                                                                     
/*      SIDRIVER                                                                        
/*                                                                              	
/*      This routines main purpose is to return the analog input value for the         	
/*      specified module. For a module value                                           	
/*      a (-1) will be returned if there is no valid data ready.                       	
/*                                                                                     	
*/
/* this routine not called from within this driver */

int SIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short len,
		unsigned char *resname)
    {
	MODPLC          *pmod;
	short           oldblkix, blkix, regix;
        unsigned short  reglen;
        int             i;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != MAINS) && (card != MREGS) && (card != MPSEUDO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmod = plcs[link][adapter];
	}

/********************/
/* no pseudo points */
/*                  */
/*                  */
/*                  */
/*                  */
/********************/

        if (card == MAINS)
	{
            /* ensure string contained entirely within the address space of the allocated region */
            if ((signal > MAXAINO) || (signal < MINAINO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if ((signal+reglen) > MAXAINO)
            {
                if (trace[link] & CONFIGURATIONTRACE)
                  logMsg(
                  "SIDRIVER: String extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                         pointname, link, adapter, card, signal);
                return (-1);
            }
            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--;               /* Signals are defined as 1 relative */
            reglen = (len+1)/2;     /* round up odd length character count string lengths */
            blkix = -1;

            for ( i = 0; i < reglen ; i++)
            {
                oldblkix = blkix;
                blkix = ((signal+i) / REGBLOCK);
                regix = ((signal+i) % REGBLOCK);
                if (oldblkix != blkix)
                {
                    pmod->ais [blkix].was_requested = TRUE;
                    if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                                    return (-1);
                    }
                    if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
                    /* check for plc simulated mode. */
                    if (modsim [link])
                    {
                        *pvalue = 0;
                        if (mltrace [link] == 10)
                        {
                            logMsg("BODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        }
                        return (0);
                    }
                    if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                     pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                    if (!pmod->ais [blkix].data_valid)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                }
                pvalue[i] = pmod->ais [blkix].aivals [regix];
            }
            pvalue[i] = 0; /* null terminate the string */
            return(0);
        }
        if (card == MREGS)
	{
            /* ensure string contained entirely within the address space of the allocated region */
            if ((signal > MAXREGNO) || (signal < MINREGNO))
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("SIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if ((signal+reglen) > MAXREGNO)
            {
                if (trace[link] & CONFIGURATIONTRACE)
                  logMsg(
                  "SIDRIVER: String extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                         pointname, link, adapter, card, signal+1);
                return (-1);
            }
            if (resname != 0)
            { 
                register_resource(link,pmod,resname,pointname);
            }

            pmod->was_requested = TRUE;

            signal--;               /* Signals are defined as 1 relative */
            reglen = (len+1)/2;     /* round up odd length character count string lengths */
            blkix = -1;

            for ( i = 0; i < reglen ; i++)
            {
                oldblkix = blkix;
                blkix = ((signal+i) / REGBLOCK);
                regix = ((signal+i) % REGBLOCK);
                if (oldblkix != blkix)
                {
                    if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                                    return (-1);
                    }
                    if (pmod->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-2);
                    }
                    /* check for plc simulated mode. */
                    if (modsim [link])
                    {
                        *pvalue = 0;
                        if (mltrace [link] == 10)
                        {
                            logMsg("SIDRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        }
                        return (0);
                    }
                    if (!pmod->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                     pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                    if (!pmod->regs [blkix].data_valid)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("SIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal+1);
                        return (-1);
                    }
                            return (-1);
                }
                pvalue[i] = pmod->regs [blkix].ioregs [regix];
            }
            pvalue[i] = 0; /* null terminate the string */
            return(0);
        }
	return(-1);
    }


/*  										
/*      SODRIVER                                                                
/*                                                                            	
/*      This routines main purpose is to set requested string outputs to the  	
/*      specified module via the output buffer.                                 
*/                                                                            	
/* this routine not called from within this driver */

int SODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	    unsigned short signal, unsigned char *value, unsigned short len, unsigned char *resname)
    {
	MODPLC  *pmod;
	unsigned short  blkix;
	OUTQENT *oqp;
        unsigned short reglen;
        int            i;

	if (link > MODLINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMMODPLCS)
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (card != MREGS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pmod = plcs[link][adapter];
	if (pmod == NULL)
	{
		if (!allocate_plc(link, adapter))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pmod = plcs[link][adapter];
	}

/********************/
/* no pseudo points */
/*                  */
/*                  */
/*                  */
/*                  */
/********************/

        /* ensure string contained entirely within the address space of the allocated region */
        if ((signal > MAXREGNO) || (signal < MINREGNO))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("SODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

        if ((signal+reglen) > MAXREGNO)
        {
            if (trace[link] & CONFIGURATIONTRACE)
              logMsg(
              "SODRIVER: String extends beyond legal signal range:[%s] L=%d, A=%d, C=%d, S=%d\n",
                     pointname, link, adapter, card, signal);
            return (-1);
        }

        if (resname != 0)
        { 
            register_resource(link,pmod,resname,pointname);
        }

        pmod->was_requested = TRUE;

	signal--;                                       /* Signals are defined as 1 relative */
        reglen = (len+1)/2;            /* round up odd length character count string lengths */
	blkix = (signal / REGBLOCK);

	pmod->regs [blkix].was_requested = TRUE; /* notice we only set one here */

        if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("SODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
                        return (-1);
        }

        /* check for plc simulated mode. */
        if (modsim [link])
        {
            if (mltrace [link] == 5)
            {
                logMsg("SODRIVER: SimReturn:[%s] L=%d, A=%d, C=%d, S=%d\n",
                       pointname, link, adapter, card, signal+1);
            }
            return (0);
        }
        if ((!pmod->is_responding) || (pmod->cmd_force_offline))
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("SODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
            return (-1);
        }

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("SODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal+1);
	    pmod->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = SOUTTYPE;
	oqp->out.sonode.link = link;
	oqp->out.sonode.adapter = adapter;
	oqp->out.sonode.card = card;
	oqp->out.sonode.sosignal = signal;
	oqp->out.sonode.solen = len;

	/* Move in the output string (strcpy not used because */
        /*  string content could contain terminators)         */
	for (i = 0 ;(i < STRINGMSGLEN) ; i++)
        {
	        oqp->out.sonode.sovalue[i] = value[i];
	}

	omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 5)
            logMsg("SODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%s\n",
                    pointname, link, adapter, card, signal+1, value);
	return (0);
    }

/*
/* register_resource
/*
/*	This routine is used to initialize the resource pointers
/*  If this is the first time the resource for this line is being
/*  referenced the pointer to the resource table entry will be set
/*  and the resource name will be saved. If the resource name has
/*  already been set, this routine will verify that all other points
/*  for this driver are using the same resource name.
/*
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
			    BOREAD, SIDRIVER, and SODRIVER.                             
*/                               	

static void  register_resource (unsigned short link, MODPLC *pmod,
                                unsigned char *resname, char *pointname)
{
        int group;

	if (resnames [link] [0] == 0) /* This is the first reference */
	{
	    if (resGetByName (resname, &prestable [link]) != RES_OK)
	    {
		logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
				resname );
	    }
	    else
	    {
		strcpy (resnames [link], resname);
                group = nwmodResGroups [link];
                if (group)
                {
                    if (assignLockGroup (group, resname) == ERROR)
                    {
                        logMsg ("assignLockGroup error: Line = %d, Group = %d, Point Name = %s, Resource Name = %s\n",
                                 link, group, pointname, resname);
                    }
                }
	    }
	}
	else
	{
	    if (strcmp (resnames [link], resname) != 0)
	    {
		logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
				resnames[link],
                                pointname,
				resname );
	    }
	}
}

/*
/*      Initialize the Queue                                        		
*/                                                                        	
/* not called from within this driver */

static	void outqueinit (unsigned short line)
{
	oq [line]->ooutix = oq [line]->oinix = 0;
}


/*                                                                     		
/*  ogetempty - get the next available slot on the output list         		
*/
/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
{
	if (((oq [line]->oinix + 1) % OUTQSIZE) != oq [line]->ooutix)
	{
	    return (&oq [line]->outque[oq [line]->oinix]);
	}
        if (mltrace [line] == 11)
	{
	    logMsg ( "Output Queue Full\n");
	}
	return (NULLP);
}


/*                                                                    		
/* omarkfull                                                          		
/*      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
{
	oq [line]->oinix = ((oq [line]->oinix + 1) % OUTQSIZE);
}


/*                                                                      	
/*  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
{
	if (oq [line]->ooutix != oq [line]->oinix)
	{
	    return (&oq [line]->outque[oq [line]->ooutix]);
	}
	else
	{
	    return (NULLP);
	}
}


/*                                                       	               	
/* oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
{
	if (oq [line]->ooutix == oq [line]->oinix)
	{
	    return;
	}
	oq [line]->ooutix = ((oq [line]->ooutix + 1) % OUTQSIZE);
}
/*                                                          			
/*      link_status                                                           	
/*                                                                            	
/*      The purpose of this routine is to print out the state of each of the  	
/*      analog devices lines and the statistics gathered about them.         	
/*                                                                           	
*/
/* not called from within this driver */

static	void link_status (unsigned short line)
{
	if (line > MODLINES-1)
	{
	    return;
	}
}

/*                                                                             	
/*                                                                              
/*	allocate_plc                                                            
/*                                                                              
/*	The purpose of this routine is to allocate the memory for a single      
/*	plc data structure. If not successful, a console error message is  	
/*	printed and an error flag is returned to the caller.                    
/*	If successful, the newly allocated data structures are initialized.     
/*                                                                             	
*/

static int allocate_plc (unsigned short line, unsigned short plc )
{
	plcs [line] [plc] = (MODPLC *) calloc (1, (sizeof (MODPLC)));
	if (!plcs [line] [plc])
	{
	    logMsg ("Unable to allocate memory");
            printf (" for NWMOD data structure on line %d, plc %d\n", line, plc);
	    return(FALSE);
	}
	else
	{
	    logMsg ("Allocated memory for NWMOD data structure on line %d, plc %d\n", line, plc);
	    init_plc_tab (line, plc);	     /*	initialize the data structures. */
	}

	return (TRUE);
}


/*                                                                   		
/*      start_rx                                                        	
/*                                                                     	 	
/*      The purpose of this routine is to initialize a line table        	
/*      for receive and to enable the receiver.                           	
/*                                                                        	
*/
/* only called from msgxfer */


static	void start_rx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

{
	RXLINE		*rxp;

	rxp = rxlinetab [line];
	rxp->rxix = 0;
	rxp->semid = semid;
	rxp->status = pstatus;
	rxp->rxstate = RXADRST;
        rxp->rxmsglen = rxp->rxmsglenexpected;
}

/*                                                                           	
/*      stop_rx                                                              	
/*                                                                           	
/*      The purpose of this routine is to initialize a line table            	
/*      for receive and to disable the receiver.                             	
/*                                                                           	
*/
/* only called from msgxfer */


static	void stop_rx (unsigned short line )

    {
	RXLINE		*rxp;

	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;
    }

/*                                                                        	
/*      NEW rx_int_proc                                                        	
/*                                                                         	
/*      The purpose of this routine is to process a receive character interrupt	
/*      for a given line.                                                     	
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static	void rx_int_proc (unsigned short line )
    {
	unsigned char   rxchar;
	unsigned short  rxstat;
	unsigned short  rx_err_mask;
	RXLINE          *rxp;

	read_rx_hw (line, &rxchar, &rxstat, &rx_err_mask);

        /* only execute if no comm error */
        if ((rxstat & rx_err_mask) == 0)
        {
            /* Something is sending in data. */
            line_activity [line] = TRUE;
            linestats [line].RXintcount++;
        }
        else
        {
            linestats [line].RXbadcount++;
        }

	rxp = rxlinetab [line];

	if (rxp->rxstate == RXIGNORE)
	{
	    return;
	}
        /* no matter what the state, errors cause a logical reset of the message processing */
        if ((rxstat & rx_err_mask) != 0)
	{
	    rxp->rxstate = RXADRST;    /* if comm goes bad, assume it was garbage,  */
                                     /* and go wait for the good stuff.           */ 
            rxp->rxix = 0;           /* reset the buffer index/counter            */
            rxp->rxmsglen = rxp->rxmsglenexpected; /* reload decrementing counter.*/
	    return;
	}

	rxp->rxbuf [rxp->rxix++] = rxchar; /* store the character in the buffer and bump the index.*/
	rxp->rxmsglen--;                  /* decrement the message length counter. although        */
                                          /* superfluous at the beginning of the fixed length      */
                                          /* messages, it does no harm.                            */
	switch (rxp->rxstate)
	{
	case RXADRST:    /* Address Field State */
             /* test for address validity */
             if (rxchar == rxp->txaddress)
             {
        	rxp->rxstate = RXFNCST;
                return;
             }
             else
             {
                rxp->rxstate = RXADRST;                  /* presume it was a false input.  */
                                                               /* go wait for the real one.      */ 
                rxp->rxix = 0;                         /* reset the buffer index/counter.*/
                rxp->rxmsglen = rxp->rxmsglenexpected; /* reload decrementing counter.   */
                return;
             }

	case RXFNCST:    /* Function Field State */
            /* if a NAK response is being returned, convert to fixed length processing */
            if ((rxchar & FNCERRBIT) != 0)
	    {
		rxp->fixedlen = FIXEDRESP;
		rxp->rxmsglen = NAKMSGLEN;
                rxp->rxstate = RXDATAST;
                return;
	    }
            if (rxp->fixedlen) /* fixed length, rxmsglen is already setup. just go get the data. */
            {
                rxp->rxstate = RXDATAST;
            }
            else               /* for variable length, go read the length byte.                  */
            {
                rxp->rxstate = RXLENST;
            }
	    return;

	case RXLENST:    /* Length Field State */
	    rxp->fixedlen = FIXEDRESP;
	    rxp->rxmsglen = rxchar + 2;       /* Add 2 for crc */
	    rxp->rxstate = RXDATAST;
	    return;

        case RXDATAST:  /* Data Section State */
	default:
	    if (rxp->rxmsglen == 0)
	    {
		*(rxp->status) = RXGOOD;
		rxp->rxstate = RXIGNORE;
		semGive (rxp->semid);
		return;
	    }
	}
	return;
}

/*                                                                             
/*      check_line_activity                                                     
/*                                                                             	
*/
/* only called from MAIN  */


static	int check_line_activity (unsigned short line, unsigned short predelay )

    {
	RXLINE          *rxp;
	long		thistime;
	short		status;

	if (predelay != 0)
	{
	    taskDelay (predelay);
	}
	thistime = tickGet ();
	if ((thistime - activity_time [line]) < ACTIVITYTIME)
	{
	    return (lastactivity [line] || (line_activity [line]));
	}
	lastactivity [line] = status = line_activity [line];
	line_activity [line] = FALSE;
	activity_time [line] = thistime;
	rxp = rxlinetab [line];
	rxp->rxstate = RXIGNORE;

	return (status);
}

/*                                                                         	
/*      start_tx                                                            	
/*                                                                          	
/*      The purpose of this routine is to initialize a line table           	
/*      for send and to enable the transmitter.                              	
/*                                                                            	
*/
/* only called from msgxfer  */


static	void start_tx (unsigned short line,SEMAPHORE *semid,unsigned short *pstatus )

{

	TXLINE		*txp;

	disable_tx_ints (line);
	txp = txlinetab [line];
	txp->txix = 0;
	txp->semid = semid;
	txp->status = pstatus;
	txp->txdisable = FALSE;

	/* Might have to output the first character here */


	enable_tx_ints (line);

}


/*
/*      stop_tx                                                                	
/*                                                                             	
/*      The purpose of this routine is to initialize a line table              	
/*      for receive and to disable the receiver.                               	
/*                                                                             	
*/
/* only called from msgxfer  */


static	void stop_tx (unsigned short line )

    {
	TXLINE		*txp;

	disable_tx_ints (line);
	txp = txlinetab [line];
	txp->txdisable = TRUE;
    }

/*                                                                           	
/*      tx_int_proc                                                           	
/*                                                                            	
/*      The purpose of this routine is to process a transmit character interrupt
/*      for a given line.                                                  	
/*                                                                         	
*/
/* only called from MAIN  */


static	void tx_int_proc (unsigned short line )

{
	char                    txchar;
	unsigned short          txstat;
	unsigned short          tx_err_mask;
	TXLINE                  *txp;

        linestats [line].TXintcount++;

	txp = txlinetab [line];
	if (txp->txdisable)
	{
	    return;
	}
	if (txp->txix == txp->txmsglen)
	{
	    txp->txdisable = TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXGOOD;
	    semGive (txp->semid);
	    return;
	}
	else
	{
	    txchar = txp->txbuf [txp->txix++];
	    write_tx_hw (line, txchar, &txstat, &tx_err_mask);
	    if ((txstat & tx_err_mask) != 0 )
	    {
	 	txp->txdisable = TRUE;
	        disable_tx_ints (line);
	        *(txp->status) = TXBAD;
	        semGive (txp->semid);
	        return;
	    }
	}

	if (txp->txix >= MAXTXMSG)
	{
	    txp->txdisable = TRUE;
	    disable_tx_ints (line);
	    *(txp->status) = TXBAD;
	    semGive (txp->semid);
	    return;
	}
}


/*                                                                         	
/*      msgxfer                                                              	
/*                                                                           	
/*      The purpose of this routine is to transmit a buffer to the         	
/*      analog devices I/O and to await a response. The transmit and receive	
/*      buffers are in their respective line tables. This routine will retry 	
/*      the message up to a maximum number of times or until a response      	
/*      is received with a proper checksum.                                  	
/*              returns         XFERGOOD if response received                	
/*                              XFERBAD  if no good response is received     	
/*                                                                           	
*/
/* called from modloopback, readcoils, readdis, readais, readregs, setcoil, setreg, */
/*             plc_start, plc_stop, pollfordone, plc_init, plc_getdim, plc_setdim,  */
/*             readmem, writemem, writelogic, and writeascii.                       */

static	unsigned short  msgxfer (unsigned short fline,
                                 unsigned short resplen,
                                 MODPLC *pmod,
                                 unsigned short rxlength)
{
	unsigned short  retry, txstatus, rxstatus, txlen, rxlen, line, ix, i;
	RXLINE          *rxp;
	TXLINE          *txp;
	unsigned char   csums [2];
        unsigned short  oldrxix;
        unsigned int    tick1, tick2, tick3, tick4;
        unsigned int    delta40, delta01, delta12, delta23, delta34;
        unsigned long   msgstart;
        unsigned long   addedticks;


	msgstart = tickGet();

	line = (fline & (~ONERETRY));          /* strip off the no retry flag*/

        delta40 = delta01 = delta12 = delta23 = delta34 = 0;

	rxp = rxlinetab [line];
	txp = txlinetab [line];

	for (retry = ((fline == line) ? 0 : MAXRETRYS - 1); (retry < MAXRETRYS); retry++)
	{
            linestats [line].msgxfercount++;
            loopmsgs [line]++;

            /* time since end of last msgxfer */

            tick [line] [0] = tickGet ();
            delta40 = (tick [line] [0] - tick [line] [4]);

	    if (intermsgdelay [line] != 0)
	    {
		taskDelay (intermsgdelay [line]);
	    }
	    set_rts (line);

	    if (pretxdelay [line] != 0)
	    {
		taskDelay (pretxdelay [line]);
	    }

	    txstatus = IO_TIMEOUT;
	    rxstatus = IO_TIMEOUT;
	    rxp->fixedlen = resplen;
	    rxp->rxmsglenexpected = rxlength;
	    rxp->txaddress = txp->txbuf [0];       /* rx_int_proc uses info to parse the response */
	    rxp->txfunction = txp->txbuf [1];

	    semTake (semids [line] [TXSEM], NO_WAIT);
	    semTake (semids [line] [RXSEM], NO_WAIT);

	    txlen = txp->txmsglen;

            addedticks = 0;
            if (baudrate [line])
            {
                addedticks = (txlen * 10 * 60) / baudrate [line];
		if (mltrace [line] == 20)
		{
                    printf("baudrate [%d] = %d, txlen = %d, addedticks = %d\n",
                            line, baudrate [line], txlen, addedticks);
	        }
            }

            if ((trace [line] & ALLTRAFFICTRACE) &&
                ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
            {
               printf ("TX:");
               for (ix = 0; ix < 36 ; ix++) /* 36 is maximum TX message length supported */
               {
                    if (ix < txlen)
		    {
                       printf("_%2x", txp->txbuf [ix]);
		    }
                    else
		    {
                       printf ("...");
		    }
               } 
               printf ("\n");
            }

            /* time from entering msgxfer to starting transmission. (including delays & diags) */ 
            tick [line] [1] = tickGet ();
            delta01 = (tick [line] [1] - tick [line] [0]);

            start_rx (line, semids [line] [RXSEM], &rxstatus);
	    start_tx (line, semids [line] [TXSEM], &txstatus); /* this fires off the transmission. */

            /*****************************************************/
            /* delay while TX characters are actually being sent */
            /*****************************************************/
            if (addedticks) taskDelay(addedticks);


	    if ((semTake (semids [line] [TXSEM], TXTIMEOUT)) == ERROR)
	    {
		txstatus = IO_TIMEOUT;
	    }

            /* time to transmit message. */

            tick [line] [2] = tickGet ();
            delta12 = (tick [line] [2] - tick [line] [1]);

	    stop_tx (line);

	    if (posttxdelay [line] != 0)
	    {
		taskDelay (posttxdelay [line]);
	    }

	    if (halfduplex [line] == TRUE)
	    {
	       clear_rts (line);
	    }
            /* intermessage wait time. */

            tick [line] [3] = tickGet ();
            delta23 = (tick [line] [3] - tick [line] [2]);

	    if (txstatus == TXGOOD)
	    {
                oldrxix = -1;    /* make it pass through timeout loop at least once */
                while ((semTake (semids [line] [RXSEM], (int) (RXTIMEOUT))) == ERROR)
                {
                    if (oldrxix == rxp->rxix)
                    {
                        if (modtrace [line])
			{
                            logMsg("RX timeout\n");
			}
                        rxstatus = IO_TIMEOUT;
                        break;
                    }
                    else
                    {
                        if ((modtrace [line]) || (mltrace[line] == 12))
			{
                             logMsg("waiting...");
			}
                    }
                    oldrxix = rxp->rxix;
                }
		stop_rx (line);

                /* time to receive message. */

                tick [line] [4] = tickGet();
                delta34 = (tick [line] [4] - tick [line] [3]);

		rxlen = rxp->rxix;
		if (rxstatus == RXGOOD)
		{
                    if ((trace [line] & ALLTRAFFICTRACE) &&
                        ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                        ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                    {
                        printf("RX:");
                        for (ix = 0; ix < 36; ix++) /* 36 is maximum RX message length */
                        {
                            if (ix < rxlen)
			    {
                                printf("_%2x", rxp->rxbuf [ix]);
			    }
                            else
			    {
                                printf("...");
			    }
                        } 
	                printf("\n");
                        printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                    }
		    if (rxlen < 3)
		    {
			if (modtrace [line])
			{
			    logMsg("Invalid rxlen... %d\n", rxlen);
			}
		    }
		    else
		    {
		        makecrc (&rxp->rxbuf [0], rxlen-2, csums);
		    }
		    if ((csums [0] == rxp->rxbuf [rxp->rxix - 2]) &&
			 (csums [1] == rxp->rxbuf [rxp->rxix - 1]))
		    {
			if ((modtrace [line]) && ((rxp->rxbuf[ 1] & FNCERRBIT) != 0))
			{
			    switch (rxp->rxbuf [2])
			    {
			    case (1):
				logMsg("Modbus Error Illegal Function \n");
				break;

			    case (2):
				logMsg("Modbus Error Illegal Data Address \n");
				break;

			    case (3):
				logMsg("Modbus Error Illegal Data Value \n");
				break;

			    case (4):
				logMsg("Modbus Error Device Failure \n");
				break;

			    case (5):
				logMsg("Modbus Error Acknowledgement \n");
				break;

			    case (6):
				logMsg("Modbus Error Busy/Rejected Message \n");
				break;

			    case (7):
				logMsg("Modbus Error Negative Ack \n");
				break;
			    }
			}

                        pmod->msgs++;
                        pmod->responsetime += (tickGet() - msgstart);
			return (XFERGOOD);
		    }
		    else
		    {
			pmod->no_crcerrs++;
			if (modtrace [line])
			{
			    logMsg ("CRC Message Length = %d\n", rxlen);
			}
			if (modtrace [line])
			{
			    logMsg ("%x%x%x%x Bad CRC\n",
					rxp->rxbuf [rxp->rxix - 2], rxp->rxbuf [rxp->rxix - 1],
					csums [0], csums [1]
					);
			}
			for (ix = 0; ix < rxlen; ix++)
			{
			    if (modtrace [line])
			    {
			    	logMsg ("%x\n", rxp->rxbuf [ix]);
			    }
			}
		    }
		}
		else if (rxstatus == IO_TIMEOUT)
		{
                    if (modtrace [line])
                    {
		    	logMsg ("Receive Timeout... Length: %d\n", rxlen);
                    }
                    if ((trace [line] & ALLTRAFFICTRACE) &&
                        ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                        ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                    {
                        printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                    }
		    pmod->no_rxnoresp++;
		}
		else
		{
		    if (modtrace [line])
		    {
		    	logMsg ("Receive Error\n");
		    }
		    if (modtrace [line])
		    {
		    	logMsg ( "RXHWERR: %2x, RXCHR: %2x, RXCNT: %2x\n",
				 rxp->rxbuf[100],
				 rxp->rxbuf[101],
				 rxp->rxix);
		    }
		    pmod->no_rxhwerrs++;
		}
	    }
	    else if (txstatus == IO_TIMEOUT)
	    {
		if (modtrace [line])
                {
			logMsg ("Transmit Timeout\n");
                }
                if ((trace [line] & ALLTRAFFICTRACE) &&
                    ((traceadr [line] == txp->txbuf [0]) || (traceadr [line] == 255)) &&
                    ((tracetype [line] == txp->txbuf [1]) || (tracetype [line] == 255)))
                {
                    printf("DELTA: %3d %3d %3d %3d %3d\n", delta40, delta01, delta12, delta23, delta34);
                }
		pmod->no_txnoresp++;
	    }
	    else
	    {
		if (modtrace [line])
		{
		    logMsg ("Transmit Error\n");
		}
		pmod->no_txhwerrs++;
	    }
	if (retry != MAXRETRYS)
		pmod->no_retries++;
	}
	if (modtrace [line])
	{
	    logMsg ("Xfer Bad\n");
	}
	return (XFERBAD);

}

/*
/*      init_plc_tab
/*
/*      The purpose of this routine is to initialize the line tables for the
/*      analog devices I/O
/*
*/
/* only called from allocate_plc  */


static	void init_plc_tab (unsigned short line, unsigned short mod)

{
	MODPLC  *pmod;

	pmod = plcs [line] [mod];
	if (!pmod)
	{
		return;
	}
	pmod->is_responding = FALSE;
	pmod->holdflag = FALSE;
	pmod->was_requested = FALSE;
	pmod->cmd_force_offline = FALSE;
	pmod->prog_load_stat = PLC_NOT_LOADING;
	pmod->prog_load_number = 0;
	pmod->prog_load_page = 0;
	pmod->plc_start = FALSE;
	pmod->plc_stop = FALSE;

        /* North Wales Special: when allocated, new id list must be transfered. */
/*	pmod->id_pending = TRUE; /* 12-03-97: Dennis wants this to NOT happen automatically */

	initplc (pmod);
	initstats (pmod);

        /* North Wales: Mark Dedicated Historic Trend Registers (40010 & 40011) for Read */
        pmod->regs [2].was_requested = TRUE;
	pmod->was_requested = TRUE;
}
/*
/* Cold Init a PLC
/*
*/
/* only called from init_plc_tabs  */


static void initplc (MODPLC  *pmod)
{
	unsigned short	i,j;

/*                                                              	
/*      COILS ARE INITIALIZED AS READ WRITE VALUES              	
/*      WRITES ARE TREATED BY INDIVIDUAL BITS NOT GROUPS       		
/*              - NOT REQUESTED                                		
/*              - READ BACK NOT VALID                             	
/*              - NO NEW VALUES TO GO                                	
*/

	for (i = 0; (i < NUMMODCOILS); i++)
	{
	    pmod->coils [i].init_writeflag = FALSE;
	    pmod->coils [i].was_requested = FALSE;
	    pmod->coils [i].data_valid = FALSE;
	    pmod->coils [i].last_read = 0;
	}

/*                                                                 	
/*      DIGITALS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID		
*/
	for (i = 0; (i < NUMMODDIS); i++)
	{
	    pmod->dis [i].was_requested = FALSE;
	    pmod->dis [i].data_valid = FALSE;
	    pmod->dis [i].last_read = 0;
	}

/*                                                                 	
/*      ANALOG INS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID    	
*/
	for (i = 0; (i < NUMMODAIS); i++)
	{
	    pmod->ais [i].was_requested = FALSE;
	    pmod->ais [i].data_valid = FALSE;
	    for (j = 0; j < REGBLOCK; j++)
	    {
		pmod->ais [i].aivals [j] = 0;
	    }
	}

/*                                                             		
/*      REGISTERS ARE INITIALIZED AS READ WRITE VALUES             	
/*      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS      	
/*              - NOT REQUESTED                                    	
/*              - READ BACK NOT VALID                              	
*/
	for (i = 0; (i < NUMREGISTERS); i++)
	{
	    pmod->regs [i].was_requested = FALSE;
	    pmod->regs [i].data_valid = FALSE;
	    for (j = 0; j < REGBLOCK; j++)
	    {
		pmod->regs [i].ioregs [j] = 0;
	    }
	}

}

/*                                                            		
/*                                                              	
/* initialize the statistics for a modicon PLC                  	
/*                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_line_tabs  */


static	void initstats (MODPLC *pmod)

{
	pmod->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
	pmod->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
	pmod->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
	pmod->no_txnoresp = 0;      /* 8  Count No Responses 		*/
	pmod->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
	pmod->no_retries = 0;       /* 10 Count Retries 		*/          	
	pmod->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
	pmod->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
	pmod->no_crcerrs = 0;       /* 13 Count CRC Errors 		*/
	pmod->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
	pmod->badoutcnt = 0;	    /* 17 Count failed output commands 	*/

        pmod->tscanpass = 0;        /* plc scan pass counter            */
        pmod->msgs = 0;             /* good response message counts     */
        pmod->responsetime = 0;     /* total wait time for good messages*/
}



/*
/* hiamodloopback                                                            
/*                                                                        
*/                                                                          	
/* only called from on_line */

static	unsigned short hiamodloopback (unsigned short line, unsigned short mod, MODPLC *pmod)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  i;
    unsigned short  bitaddr;
    unsigned short  readlen;

    bitaddr = 0;
    readlen = 1;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    pmod->no_datain_msgs++;

    /* Format the output message */

    txp->txbuf [0] =  mod;
    txp->txbuf [1] =  MODDIREAD;
    txp->txbuf [2] =  (bitaddr >> 8);
    txp->txbuf [3] =  (bitaddr & 0xFF);
    txp->txbuf [4] =  (readlen >> 8);
    txp->txbuf [5] =  (readlen & 0xFF);

    makecrc (&(txp->txbuf [0]), MODREADMSGLEN, &(txp->txbuf [MODREADMSGLEN]));

    txp->txmsglen = MODREADMSGLEN + MODCRCLEN;

    /* Send out the message */
    if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
    {
        pmod->is_responding = FALSE;
        return (FALSE);
    }
    return (TRUE);
}


/*                                                                       
/* modloopback                                                            
/*                                                                        
*/                                                                          	
/* only called from on_line */

static	unsigned short modloopback (unsigned short line, unsigned short mod,
			 MODPLC *pmod)
{
	TXLINE 		*txp;
	RXLINE		*rxp;
	long		buildreg;
	unsigned short  i;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Format the output message */

	txp->txbuf [0] =  mod;
	txp->txbuf [1] =  MODLOOPBACK;
	txp->txbuf [2] =  0;
	txp->txbuf [3] =  0;
	txp->txbuf [4] =  0xA5;
	txp->txbuf [5] =  0x37;

	makecrc (&(txp->txbuf [0]), MODLOOPBACKLEN, &(txp->txbuf [MODLOOPBACKLEN]));

	txp->txmsglen = MODLOOPBACKLEN+MODCRCLEN;


	pmod->no_datain_msgs++;

	/* Send out the message */

	if (msgxfer (line, FIXEDRESP, pmod, MODLOOPBACKRESPLEN) == XFERBAD)
	{
	    pmod->is_responding = FALSE;
	    return (FALSE);
	}

	return (TRUE);
}

/*                                                                           	
/*     prepresponses
/*                                                                             	
/*      The purpose of this routine is to mark the PLCs as on hold and the    	
/*	data as not valid until read again from the PLC                       	
/*                                                                           	
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)

{
	unsigned short	mod;
	MODPLC		*pmod;

	for (mod = 1; (mod <= NUMMODPLCS); mod++)
	{
            pmod = plcs [line] [mod];
	    if (pmod)				/* verify pointer validity prior to use */
	    {
	    	pmod->holdflag = TRUE;
		mark_not_valid (pmod);
            }
	}
}




/*                                                                  	
/*      any_responding                                               	
/*                                                                   	
/*      The purpose of this routine is to see if any units are       	
/*	responding on this line                                      	
/*                                                                   	
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)

{
	unsigned short  mod;
	MODPLC		*pmod;

	for (mod = 1; (mod <= NUMMODPLCS); mod++)
	{
	    pmod = plcs [line] [mod];
	    if (pmod)			/* verify pointer validity prior to use */
	    {
                /* check cmd_force_offline flag because it is set in an asynchronous task */
                if ((pmod->is_responding) && (!pmod->cmd_force_offline))
		{
		    return (TRUE);
		}
	    }
	}
	return (FALSE);
}



/*                                                                	
/* Readcoils                                                       	
/*                                                                  	
*/
static	unsigned short readcoils (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned short readlen)

/* only called from scan_plc */

{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i;
        unsigned long   currenttick;

	/* Set up pointers for comm buffers */
	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */
	pmod->no_datain_msgs++;

	/* Format the output message */
	txp->txbuf [0] =  mod;
	txp->txbuf [1] =  MODCOILREAD;
	txp->txbuf [2] =  (bitaddr >> 8);
	txp->txbuf [3] =  (bitaddr & 0xFF);
	txp->txbuf [4] =  (readlen >> 8);
	txp->txbuf [5] =  (readlen & 0xFF);

	makecrc (&(txp->txbuf [0]), MODREADMSGLEN, &(txp->txbuf [MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN + MODCRCLEN;

	/* Send out the message */
	if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */
	if ((rxp->rxbuf [0] != mod) ||
	    (rxp->rxbuf [1] != MODCOILREAD) ||
	    (rxp->rxbuf [2] != ((readlen+7)/8)))
	{
	    pmod->no_dataerr++;
	    return (CMDNACK);
	}

        currenttick = tickGet();

	/* Store the returned data                      */
	/*  data is aligned by 8 pseudo register        */
	/*  and a multiple of 8 bits long               */
	for (i = 0; (i < rxp->rxbuf [2]); i++)
	{
	    pmod->coils [(bitaddr / 8) + i].last_read = rxp->rxbuf [3 + i];
	    pmod->coils [(bitaddr / 8) + i].data_valid = TRUE;
            /* North Wales Special: only read once per BOREAD request, not forever. */
	    pmod->coils [(bitaddr / 8) + i].init_writeflag = FALSE;
            /* North Wales Special: store time for data validity expiration testing. */
	    pmod->coils [(bitaddr / 8) + i].readtick = currenttick;
	}

	return (CMDDONE);
}

/*                                                             	
/* Readdis                                                      	
/*                                                              	
*/
static	unsigned short readdis (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned short readlen)

/* only called from scan_plc */

{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf [0] =  mod;
	txp->txbuf [1] =  MODDIREAD;
	txp->txbuf [2] =  (bitaddr >> 8);
	txp->txbuf [3] =  (bitaddr & 0xFF);
	txp->txbuf [4] =  (readlen >> 8);
	txp->txbuf [5] =  (readlen & 0xFF);

	makecrc (&(txp->txbuf [0]), MODREADMSGLEN, &(txp->txbuf [MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN + MODCRCLEN;

	/* Send out the message */

	if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != mod) ||
	    (rxp->rxbuf [1] != MODDIREAD) ||
	    (rxp->rxbuf [2] != ((readlen + 7) / 8)))
	{
	    pmod->no_dataerr++;
	    return (CMDNACK);
	}

	/* Store the returned data                      */
	/*  data is aligned by 8 pseudo register        */
	/*  and a multiple of 8 bits long               */

	for (i = 0; (i < rxp->rxbuf [2]); i++)
	{
	    pmod->dis [(bitaddr / 8) + i].last_read = rxp->rxbuf[3+i];
	    pmod->dis [(bitaddr / 8) + i].data_valid = TRUE;
	}

	return (CMDDONE);
}

/*                                                               	
/* Readais                                                        	
/*                                                                	
*/
static	unsigned short readais (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short reglen)

/* only called from scan_plc */

    {

	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  buildreg;
	unsigned short  i, j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf [0] =  mod;
	txp->txbuf [1] =  MODAIREAD;
	txp->txbuf [2] =  (regaddr >> 8);
	txp->txbuf [3] =  (regaddr & 0xFF);
	txp->txbuf [4] =  (reglen >> 8);
	txp->txbuf [5] =  (reglen & 0xFF);

	makecrc (&(txp->txbuf [0]), MODREADMSGLEN, &(txp->txbuf [MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN + MODCRCLEN;

	/* Send out the message */

	if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != mod) ||
	    (rxp->rxbuf [1] != MODAIREAD) ||
	    (rxp->rxbuf [2] != (reglen * 2)))
	{
	    pmod->no_dataerr++;
	    return (CMDNACK);
	}

	/* Store the returned data                      */
	/*  data is aligned by 4 register sets          */
	/*  and a multiple of 4 registers long          */

	for (i = 0; (i < rxp->rxbuf [2]); i += 8)
	{
	    for (j = 0; (j < 4); j++)
	    {
		buildreg = rxp->rxbuf [3 + i + (j * 2)];
		buildreg = (buildreg << 8) + rxp->rxbuf [3 + i + (j * 2) + 1];
		pmod->ais [(regaddr / 4) + (i / 8)].aivals [j] = buildreg;
	    }
	    pmod->ais [(regaddr / 4) + (i / 8)].data_valid = TRUE;
	}
	return (CMDDONE);
}

/*                                                                      	
/* Readregs                                                                	
/*                                                                            	
*/
static	unsigned short readregs (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short reglen)

/* only called from scan_plc */

{

	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  buildreg;
	unsigned short  i, j;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_datain_msgs++;

	/* Format the output message */

	txp->txbuf [0] =  mod;
	txp->txbuf [1] =  MODREGREAD;
	txp->txbuf [2] =  (regaddr >> 8);
	txp->txbuf [3] =  (regaddr & 0xFF);
	txp->txbuf [4] =  (reglen >> 8);
	txp->txbuf [5] =  (reglen & 0xFF);

	makecrc (&(txp->txbuf [0]), MODREADMSGLEN, &(txp->txbuf [MODREADMSGLEN]));

	txp->txmsglen = MODREADMSGLEN + MODCRCLEN;

	/* Send out the message */

	if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
	{
	    pmod->no_offlines++;
	    pmod->holdflag = TRUE;
	    pmod->is_responding = FALSE;
	    return (CMDFAIL);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != mod) ||
	    (rxp->rxbuf [1] != MODREGREAD) ||
	    (rxp->rxbuf [2] != (reglen * 2)) )
	{
	    pmod->no_dataerr++;
	    return (CMDNACK);
	}

	/* Store the returned data                      */
	/*  data is aligned by 4 register sets          */
	/*  and a multiple of 4 registers long          */

	for (i = 0; (i < rxp->rxbuf [2]); i += 8)
	{
	    for (j = 0; (j < 4); j++)
	    {
		buildreg = rxp->rxbuf [3 + i + (j * 2)];
		buildreg = (buildreg << 8) + rxp->rxbuf [3 + i + (j * 2) + 1];
		pmod->regs [(regaddr / 4) + (i / 8)].ioregs [j] = buildreg;
	    }
	    pmod->regs [(regaddr / 4) + (i / 8)].data_valid = TRUE;
	}
	return (CMDDONE);
}

/*                                                                              
/* Readhtregs - store all retrieved data in special historical trend registers  
/*                                                                            	
*/
static	unsigned short readhtregs (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short reglen)
{
    TXLINE         *txp;
    RXLINE         *rxp;
    unsigned short  buildreg;
    unsigned short  i, j;

    /* Set up pointers for comm buffers */
    txp = txlinetab [line & (~ONERETRY)];
    rxp = rxlinetab [line & (~ONERETRY)];

    /* Count number of data request messages */
    pmod->no_datain_msgs++;

    /* Format the output message */
    txp->txbuf [0] =  mod;
    txp->txbuf [1] =  MODREGREAD;
    txp->txbuf [2] =  (regaddr >> 8);
    txp->txbuf [3] =  (regaddr & 0xFF);
    txp->txbuf [4] =  (reglen >> 8);
    txp->txbuf [5] =  (reglen & 0xFF);

    makecrc (&(txp->txbuf [0]), MODREADMSGLEN, &(txp->txbuf [MODREADMSGLEN]));

    txp->txmsglen = MODREADMSGLEN + MODCRCLEN;

    /* Send out the message */
    if (msgxfer (line, VARRESP, pmod, 0) == XFERBAD)
    {
        pmod->no_offlines++;
        pmod->holdflag = TRUE;
        pmod->is_responding = FALSE;
        pmod->htregs.data_valid = FALSE;
        return (CMDFAIL);
    }

    /* Verify the response */
    if ((rxp->rxbuf [0] != mod) ||
        (rxp->rxbuf [1] != MODREGREAD) ||
        (rxp->rxbuf [2] != (reglen * 2)) )
    {
        pmod->no_dataerr++;
        pmod->htregs.data_valid = FALSE;
        return (CMDNACK);
    }

    pmod->htregs.validcount = 0;

    /* Store the returned data in special HT register block */
    for (i = 0; (i < rxp->rxbuf [2]); i += 2)
    {
        buildreg = rxp->rxbuf [3 + i];
        buildreg = (buildreg << 8) + rxp->rxbuf [3 + i + 1];
        pmod->htregs.ioregs [i/2] = buildreg;
        pmod->htregs.validcount++;
    }
    pmod->htregs.data_valid = TRUE;

    return (CMDDONE);
}


/*                                                           		
/* Setcoil                                                        	
/*                                                                 	
*/
static	unsigned short setcoil (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short bitaddr,
			 unsigned long mask, unsigned long val)

/* only called from checkoutputs */

{
	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short  i, ix, lsignal;
	unsigned long	lmask, lval, tmask ,tval;


	if (mask == 0)
	{
	    return (CMDREJECT);
	}
	tmask = lmask = mask;
	tval = lval = val;
	lsignal = bitaddr;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	 /* adjust the bits to the low order bit */

	while ((tmask & 1) == 0)
	{
	    tval = tval >> 1;          /* adjust the value */
	    tmask = tmask >> 1;         /* adjust the mask */
	}

	/* Is it a single coil output */

	if ((tmask & 2) == 0)
	{
	    /* Format the output message */

	    txp->txbuf [0] =  mod;
	    txp->txbuf [1] =  MODCOILWRITE;
	    txp->txbuf [2] =  (lsignal >> 8);
	    txp->txbuf [3] =  (lsignal & 0xFF);
	    txp->txbuf [4] =  (lval==0)?0:0xFF;  /* 0 => off  0xFF => on */
	    txp->txbuf [5] =  0;

	    makecrc (&(txp->txbuf [0]), MODSETCOILLEN, &(txp->txbuf [MODSETCOILLEN]));

	    txp->txmsglen = MODSETCOILLEN + MODCRCLEN;


	    /* Send out the message */

	    if (msgxfer (line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
	    {
		pmod->no_offlines++;
	        pmod->holdflag = TRUE;
		pmod->is_responding = FALSE;
		return (CMDFAIL);
	    }

	    /* Verify the response - the message is repeated back*/
	    for (i = 0; (i < MODSETCOILLEN); i++)
	    {
		if (txp->txbuf [i] != rxp->rxbuf [i])
		{
		    if (rxp->rxbuf [1] & FNCERRBIT)
		    {
			if (rxp->rxbuf [2] == MODEXCEPTBUSY)
			{
			    return (CMDBUSY);
			}
		    }
		    pmod->no_dataerr++;
		    return (CMDNACK);
		}
	    }
	    return (CMDDONE);
	}


	/* Must be a multiple coil output */

	else
	{
	    lmask = tmask;
	    lval = tval;

	    /* count the number of coils to output */

	    for (i = 0,tmask = 1; ((tmask & lmask) != 0); i++)
	    	tmask = tmask << 1;

	    /* Format the output message */

	    txp->txbuf [0] =  mod;
	    txp->txbuf [1] =  MODMCOILWRITE;
	    txp->txbuf [2] =  (lsignal >> 8);
	    txp->txbuf [3] =  (lsignal & 0xFF);
	    txp->txbuf [4] =  (i >> 8);          /* number of coils */
	    txp->txbuf [5] =  (i & 0xFF );
	    txp->txbuf [6] =  (((i + 7) / 8) & 0xFF); /* number of data bytes */
	    txp->txbuf [7] =  (lval & 0xFF );
	    ix = 8;
	    if (i > 8)
	    {
		txp->txbuf [ix++] =  ((lval >> 8) & 0xFF );
		if (i > 16)
		{
		    txp->txbuf [ix++] =  ((lval >> 16) & 0xFF );
		    if (i > 24)
		    {
			txp->txbuf [ix++] =  ((lval >> 24) & 0xFF );
		    }
		}
	    }

	    makecrc (&(txp->txbuf [0]), ix, &(txp->txbuf [ix]));

	    txp->txmsglen = ix+MODCRCLEN;

	    /* Send out the message */

	    if (msgxfer (line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
	    {
		pmod->no_offlines++;
	        pmod->holdflag = TRUE;
		pmod->is_responding = FALSE;
		return (CMDFAIL);
	    }

	    /* Verify the response - first part of the message is repeated back*/

	    for (i = 0; (i < MODMSETCOILRESPLEN); i++)
	    {
		if (txp->txbuf [i] != rxp->rxbuf [i])
		{
		    if (rxp->rxbuf [1] & FNCERRBIT)
		    {
			if (rxp->rxbuf [2] == MODEXCEPTBUSY)
			{
			    return (CMDBUSY);
			}
		    }
		    pmod->no_dataerr++;
		    return (CMDNACK);
		}
	    }
	    return (CMDDONE);
	}
}

/*
/* Setreg                                                       	
/*                                                                  	
*/
static	unsigned short setreg (unsigned short line, unsigned short mod,
			 MODPLC *pmod, unsigned short regaddr,
			 unsigned short val,double dblval, unsigned short conv)

/* only called from checkoutputs */

{
	TXLINE 		*txp;
	RXLINE 		*rxp;
	unsigned short	i;
   	union 	u_value {
		    short		ivalue;
		    long		lvalue;
		    float		fvalue;
		    double		dvalue;
		    char		afvalue[100];
		}  uval;

	unsigned short	msglen [] =
			{
					0,
					MODSET1REGLEN,
					MODSET2REGLEN,
					MODSET3REGLEN,
					MODSET4REGLEN,
			};

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	uval.fvalue = dblval;

	/* Format the output message */

	txp->txbuf [0] =  mod;
	txp->txbuf [2] =  (regaddr >> 8);
	txp->txbuf [3] =  (regaddr & 0xFF);

	if (conv != ASCFLT)
	{
	    txp->txbuf [1] =  MODREGWRITE;
	    txp->txbuf [4] =  (val >> 8);
	    txp->txbuf [5] =  (val & 0xFF);

	    makecrc (&(txp->txbuf [0]), MODSETREGLEN, &(txp->txbuf [MODSETREGLEN]));

	    txp->txmsglen = MODSETREGLEN + MODCRCLEN;

	    /* Send out the message */

	    if (msgxfer (line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
	    {
	        pmod->no_offlines++;
	        pmod->holdflag = TRUE;
	        pmod->is_responding = FALSE;
	        return (CMDFAIL);
	    }

	    /* Verify the response - the message is repeated back*/

	    for (i = 0; (i < MODSETREGLEN); i++)
	    {
		if (txp->txbuf [i] != rxp->rxbuf [i])
		{
		    pmod->no_dataerr++;
		    return (CMDNACK);
	        }
	    }
	    return (CMDDONE);
	}
	else
	{ /* Send out float as multiple register write */

	    txp->txbuf [1] =  MODMREGWRITE;
	    txp->txbuf [4] = 0x00;
	    txp->txbuf [5] = 0x02;	/* Number of registers */
	    txp->txbuf [6] = 0x04;	/* Number of bytes */

	    txp->txbuf [7] = (uval.lvalue >> 8) & 0xFF;
	    txp->txbuf [8] =  uval.lvalue & 0xFF;
	    txp->txbuf [9] = (uval.lvalue >> 24) & 0xFF;
	    txp->txbuf [10] = (uval.lvalue >> 16) & 0xFF;


	    makecrc (&(txp->txbuf [0]), MODSET2REGLEN, &(txp->txbuf [MODSET2REGLEN]));

	    txp->txmsglen = MODSET2REGLEN + MODCRCLEN;

	    /* Send out the message */

	    if (msgxfer (line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
	    {
	        pmod->no_offlines++;
	        pmod->holdflag = TRUE;
	        pmod->is_responding = FALSE;
	        return (CMDFAIL);
	    }

	    /* Verify the response - the message is repeated back*/

	    for (i = 0; (i < MODSETMREGRESPLEN); i++)
	    {
		if (txp->txbuf [i] != rxp->rxbuf [i])
		{
		    pmod->no_dataerr++;
		    return (CMDNACK);
	        }
	    }
	    return (CMDDONE);
	}
}


/*
/* Setstring                                                       	
/*                                                                  	
*/
static	unsigned short setstring (unsigned short line, unsigned short mod,
			          MODPLC *pmod, unsigned short signal,
			          unsigned char *buf, unsigned short olen)
/*  if (!(setstring (link, adapter, pmod, stringaddr, pstringval, stringlen))) */
/* only called from checkoutputs */
{
	TXLINE 		*txp;
	RXLINE 		*rxp;
	unsigned short  i, slen, tlen, saveseqno, temp, base;

   	union 	u_value {
		    short		ivalue;
		    long		lvalue;
		    float		fvalue;
		    double		dvalue;
		    char		afvalue[100];
		}  uval;

	/* Set up pointers for comm buffers */

	txp = txlinetab [line & (~ONERETRY)];
	rxp = rxlinetab [line & (~ONERETRY)];

	/* Count number of data request messages */

	pmod->no_dataout_msgs++;

	/* Format the output message */

	txp->txbuf [0] =  mod;
        txp->txbuf [1] =  MODMREGWRITE;
        txp->txbuf [2] =  (signal >> 8);
        txp->txbuf [3] =  (signal & 0xFF);

	/* Store the transmit data                      */

	base = 7;
        i = 0;
	slen = olen;
	while  (i < STRINGMSGLEN)
        {
	    if ((slen != 0) && (i >= slen))
	    {
               break;
	    }
	    txp->txbuf [base+i] = buf [i];

	    if ((slen == 0) && ((buf [i] == CR) || (buf [i] == 0)))
            {
                i++;
                break;
            }
	    i++;
	}
        if ((i % 2) == 1) /* convert all odd length strings to even length strings */
        {
            txp->txbuf [base + i] = buf [i];
            i++;
        }
 	slen = i;
        tlen = base + slen;

	txp->txbuf [4] = ((slen / 2) / 256);
	txp->txbuf [5] = ((slen / 2) & 0xFF);
        txp->txbuf [6] = slen;

	makecrc (&(txp->txbuf [0]), tlen, &(txp->txbuf [tlen]));
        txp->txmsglen = tlen + MODCRCLEN;

        /* Send out the message */

        if (msgxfer (line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
        {
            pmod->no_offlines++;
            pmod->holdflag = TRUE;
            pmod->is_responding = FALSE;
	    return (CMDFAIL);
        }

        /* Verify the response - the message is repeated back*/

        for (i = 0; (i < MODSETMREGRESPLEN); i++)
        {
	    if (txp->txbuf [i] != rxp->rxbuf [i])
            {
                pmod->no_dataerr++;
                return (CMDNACK);
            }
        }
        return (CMDDONE);
}

/*
/*	Read Area Descriptors                                		
*/                                                                 	
/* only called from scan_plc */

static int loadinit (unsigned short line,MODPLC *pmod,unsigned short mod)
    {

	LOADINFO	*plinfo;
	char		filename [30];
	char		addr [8];
        int 		status;
	long		pos;
	unsigned short	prognum;

	plinfo = &linfo [line];		/* establish the pointer */

	/* If already one being loaded wait else claim it */

	if (plinfo->loading)
	{
	    return(0);
	}
	plinfo->line = line;	/* easy way to find it */
	plinfo->loading = TRUE;
	plinfo->pmod = pmod;
	plinfo->mod = mod;
	prognum = pmod->prog_load_number;

	/* Make File Name	*/

	strcpy (plinfo->filename, "P");
	addr [0] = 'L';			/* Line Number */
	addr [1] = '0' + (line / 10);
	addr [2] = '0' + (line % 10);
	addr [3] = 'A';			/* Address */
	addr [4] = '0' + (mod / 10);
	addr [5] = '0' + (mod % 10);
	addr [6] = '0' + (prognum % 10);
	addr [7] = 0;
	strcat (plinfo->filename, addr);
	strcat (plinfo->filename, ".prg");

	/* Open File	*/

	iam (user, password);
	if ((plinfo->loadfile = fopen (&plinfo->filename [0], "r")) == NULL)
	{
	    terminateload (plinfo, line, FALSE, CANNOTOPENFILE);
	    return (-1);
	}

	/* Seek to First Area */

	plinfo->fileaddr = (PAGE0 * WORDLEN);
	if (pos = fseek (plinfo->loadfile, plinfo->fileaddr, 0) != OK)
	{
	    terminateload (plinfo, line, FALSE, CANNOTSEEKTO);
	    return (-1);
	}

	/* Read First Dump Block */

	if (fread (&plinfo->dadesc [0], 1, DUMPAREASIZE, plinfo->loadfile) != DUMPAREASIZE)
	{
	    terminateload (plinfo, line, FALSE, CANNOTREAD);
	    return (-1);
	}

	/* Seek to Next Area */

	plinfo->fileaddr = (PAGEF * WORDLEN);
	if (pos = fseek (plinfo->loadfile, plinfo->fileaddr, 0) != OK)
	{
	    terminateload (plinfo, line, FALSE, CANNOTSEEKTO);
	    return (-1);
	}

	/* Read Next Dump Block */

	if (fread (&plinfo->dadesc [1], 1, DUMPAREASIZE, plinfo->loadfile) != DUMPAREASIZE)
	{
	    terminateload (plinfo, line, FALSE, CANNOTREAD);
	    return (-1);
	}

	/* Seek to Next Area */

	plinfo->fileaddr = (ASCII * WORDLEN);
	if (pos = fseek (plinfo->loadfile, plinfo->fileaddr, 0) != OK)
	{
	    terminateload (plinfo, line, FALSE, CANNOTSEEKTO);
	    return (-1);
	}

	/* Read Next Dump Block */

	if (fread (&plinfo->dadesc [2], 1, DUMPAREASIZE, plinfo->loadfile) != DUMPAREASIZE)
	{
	    terminateload (plinfo, line, FALSE, CANNOTREAD);
	    return (-1);
	}

	/* Seek to Last Area */

	plinfo->fileaddr = (FUTURE * WORDLEN);
	if (pos = fseek (plinfo->loadfile, plinfo->fileaddr, 0) != OK)
	{
	    terminateload (plinfo, line, FALSE, CANNOTSEEKTO);
	    return (-1);
	}

	/* Read Last Dump Block */

	if (fread (&plinfo->dadesc [3], 1, DUMPAREASIZE, plinfo->loadfile) != DUMPAREASIZE)
	{
	    terminateload (plinfo, line, FALSE, CANNOTREAD);
	    return (-1);
	}

	/* Seek to The First Area in the File */

	plinfo->fileaddr = ((plinfo->dadesc [0].areas [0].strtaddr) * WORDLEN);
	if (pos = fseek (plinfo->loadfile, plinfo->fileaddr, 0) != OK)
	{
	    terminateload (plinfo, line, FALSE, CANNOTSEEKTO);
	    return (-1);
	}

	/* LogOut on PLC	*/

	if (!plc_logout (plinfo))
	{
	    terminateload (plinfo, line, FALSE, CANNOTLOGOUT);
	    return (-1);
	}

	/* LogIn on PLC	*/

	if (!plc_login (plinfo))
	{
	    terminateload (plinfo, line, FALSE, CANNOTLOGIN);
	    return (-1);
	}

	/* Read The Machine State	*/

	if (!get_plc_state (plinfo, &plinfo->machstate))
	{
	    terminateload (plinfo, line, FALSE, CANNOTREAD);
	    return (-1);
	}

	/* If Memory Protect Abort */

	if ((plinfo->machstate & MEMPROTECT) == 0)
	{
	    terminateload (plinfo, line, FALSE, MEMORYPROTECT);
	    return (-1);
	}

	/* If Running Stop The Controller */

	if ((plinfo->machstate & RUNNINGSTATE) == 0)
	{
	    if(!plc_stop (plinfo))
	    {
		terminateload (plinfo, line, FALSE, PLCWONTSTOP);
		return (-1);
	    }
	}

	/* Check for dim Awareness */

	status = plc_getdim (plinfo);
	if (status < 0)
	{
	    terminateload (plinfo, line, FALSE, PLCWONTGETDIM);
	    return (-1);
	}

	/* If not in dim awareness */

	if (status == 0)
	{
	    /* Send to dim awareness */

	    if (!plc_setdim (plinfo))
	    {
		terminateload (plinfo, line, FALSE, PLCWONTSETDIM);
		return (-1);
	    }
	    /* Verify dim awareness */

	    status = plc_getdim (plinfo);
	    if (status != 1)
	    {
		terminateload (plinfo, line, FALSE, PLCWONTBEDIM);
		return (-1);
	    }
	}

	/* Initialize the Load Pointer to the first area */

	plinfo->ldblock = 0;
	plinfo->ldarea = 0;

	/* Set The Load State Variables */

	plinfo->pmod->prog_load_stat = PLC_LOAD_IN_PROGRESS;
	plinfo->pmod->prog_load_page = 0;

	return (0);
}


/*                                                              	
/*	Load The Next Dump Block                               		
*/
/* only called from scan_plc */

static int loadnextblock (unsigned short line)
{
	LOADINFO	*plinfo;
	unsigned short	type_mask, currarea;
	int		status;

	plinfo = &linfo [line];	/* establish the pointer */

	type_mask = ((plinfo->dadesc [plinfo->ldblock].areaspec << plinfo->ldarea) & AREATYPEMASK);
	switch (type_mask)
	{
	case LOGICAREATYPE:
	    status = loadlogic (plinfo);
	    break;

	case ASCIIAREATYPE:
	    status = loadmemory( plinfo, ASCIIAREATYPE);
	    break;

	case MEMORYAREATYPE:
	default:
	    status = loadmemory (plinfo, MEMORYAREATYPE);
	    break;
	}

	if (status != 0)
	{
	    return(-1);
	}
	currarea = ((plinfo->ldblock * AREASPERBLK) + plinfo->ldarea);
	if (currarea == CONFIGAREA)
	{
	    /* Exit Dim Arareness with a start command*/

	    if (!plc_start (plinfo))
	    {
		terminateload (plinfo, line, FALSE, PLCWONTSTART);
		return (-1);
	    }

	    /* !!Three messages were issued here: 	*/
	    /*	 sf=0x31				*/
	    /*	 sf=0x34				*/
	    /*	confirm dim awareness			*/

	    /* Init PLC (Special Message Issued Here) initialize msg*/

	    status = plc_init (plinfo);
	    if (!status)
	    {
		terminateload (plinfo, line, FALSE, PLCWONTINIT);
		return (-1);
	    }

	    /* Read and Save the Run Load Switch from the PLC */

	    if (!getrunmode (plinfo, &plinfo->rlmode))
	    {
		terminateload (plinfo, line, FALSE, CANTGETMODE);
		return (-1);
	    }

	    /* Set the Run Load Switch to Load */

	    if (!setrunmode (plinfo, LOADSWITCH))
	    {
		terminateload (plinfo, line, FALSE, CANTSETLOADMODE);
		return (-1);
	    }

	}

	/* Advance the block and area pointers for the next load operation */

	plinfo->ldarea = ((plinfo->ldarea + 1) % AREASPERBLK);
	if (plinfo->ldarea == 0)
	{
	    plinfo->ldblock++;
	}
	plinfo->pmod->prog_load_page = currarea + 1;

	/* When we reach the end clean up and enable the next load */

	if (plinfo->ldblock >= NUMDUMPAREAS)
	{
	    terminateload (plinfo, line, TRUE, LOADOK);
	}

	return (0);

}

/*                                                                      	
/*	Load a Logic Area                                                	
*/                                                                        	
/* only called from loadnextblock */

static int loadlogic (LOADINFO *plinfo)
    {
	long		pos;
	short		length, page, startaddr, startnode, endnode, dbix, status;
	short		dowrite, endwritten, thisnodecount;
	unsigned char	databuf [MAXTXMSG];

	page = plinfo->dadesc [plinfo->ldblock].page;
	startaddr = plinfo->dadesc [plinfo->ldblock].areas [plinfo->ldarea].strtaddr;
	length = plinfo->dadesc [plinfo->ldblock].areas [plinfo->ldarea].length * NODELEN;
	startnode = FALSE;
	endnode = FALSE;
	endwritten = FALSE;
	dowrite = FALSE;
	dbix = 0;
	thisnodecount = 0;

	while (length)
	{
	    /* While there are nodes to read */
	    /* Read a node (3 Bytes) if error abort */

	    status = fread (&databuf [dbix], 1, NODELEN, plinfo->loadfile);
	    if (status == 0)
	    {
		terminateload (plinfo, plinfo->line, FALSE, UNEXPECTDEOF);
		return (-1);
	    }
	    thisnodecount++;
	    length -= NODELEN;

	    /* If 5X0 set Endnode found */

	    if ((databuf [dbix] == EOLNODE) && (databuf [dbix + 2] == 0))
	    {
		endnode = TRUE;
	    }
	    /* If (<5)XX (this is a start) and I already have one */
	    /*   backup and write what We have so far and resume */

	    if ( (databuf [dbix] <= BOCNODE) && (startnode) )
	    {
		/* Back up over start node from current position */

		pos = fseek (plinfo->loadfile, (long) -NODELEN, 1);
		thisnodecount--;
		length += NODELEN;
		dowrite = TRUE;
		dbix -= NODELEN;
	    }

	    /* If this is the first start node set the flag */

	    if ((databuf [dbix] < BOCNODE) && (!startnode))
	    {
	        startnode = TRUE;
	    }

	    dbix += NODELEN;

	    if ((length == 0) ||
		 (dowrite) || 
		 ((!startnode) && (thisnodecount > 4) ) ||
		 (thisnodecount >= MAXMSGNODES))
	    {
		if (!endwritten)
		{   /* Continue to read but don't write */
		    /* Write logic load message out */
		    status = writelogic (
		    plinfo,
		    page,
		    startaddr,
		    dbix,
		    (char*) databuf);  /* databuf); ###*/
                                      /* cast because the local array is unsigned char */

		    /* Abort on error */
		    if (!status)
		    {
			terminateload (plinfo, plinfo->line, FALSE, LOGICWRITEERROR);
			return (-1);
		    }
		}
		dowrite = FALSE;
		startaddr += thisnodecount; /* Set Start for next block */
		thisnodecount = 0;
		startnode = FALSE;
		endwritten = endnode; 
		dbix = 0;		   /* Set index for next block */
 	    }
	}
	return (0);
}

/*                                                       		
/*	Load A Memory or ASCII Area                                  	
*/
/* only called from loadnextblock */

static int loadmemory (LOADINFO *plinfo, unsigned short type)

{
	short		length, page, startaddr, dbix, status, thislength;
	char		databuf [MAXTXMSG];

	page = plinfo->dadesc [plinfo->ldblock].page;
	startaddr = plinfo->dadesc [plinfo->ldblock].areas [plinfo->ldarea].strtaddr;
	length = plinfo->dadesc [plinfo->ldblock].areas [plinfo->ldarea].length * WORDLEN;

	while (length)
	{
	    /* While there are nodes to read */
	    /* Read a block of data if error abort */

	    thislength = (length > MAXWORDMSGLEN) ? MAXWORDMSGLEN : length;
	    status = fread (databuf, 1, thislength, plinfo->loadfile);
	    if (status == 0)
	    {
		terminateload (plinfo, plinfo->line, FALSE, UNEXPECTDEOF);
		return (-1);
	    }
	    length -= thislength;
	    if (type == MEMORYAREATYPE)
	    {
		status = writemem (plinfo, page, startaddr, thislength, databuf);
	    }
	    else
	    {
		status = writeascii (plinfo, page, startaddr, thislength, databuf);
	    }
	    /* Abort on error */
	    if (!status)
	    {
		terminateload (plinfo, plinfo->line, FALSE, MEMORYWRITEERROR);
		return (-1);
	    }
	    startaddr += thislength / 2;
	}
	return (0);
}


/*                                                             	
/*	End The Load Sequence                                      	
*/
/* called from loadinit, loadnextblock, loadlogic, loadmemory */

static terminateload (LOADINFO *plinfo,unsigned short line,
	       unsigned short success,unsigned short code)
{
	/* Close The File		*/
	fclose (plinfo->loadfile);

	/* Release for another PLC */
	plinfo->loading = FALSE;

	if (!success)
	{
	    plinfo->pmod->prog_load_stat = PLC_LOAD_FAILED;
	    plinfo->pmod->prog_load_code = code;
	    return;
	}

	/* Switch The Controller from Load to Run */

	if (!setrunmode (plinfo, RUNSWITCH))
	{
	    terminateload (plinfo, line, FALSE, CANTSETRUNMODE);
	    return (-1);
	}

	/* Set The Controller to the mode stored in the file */
	/* Which was read back from the controller after config area loaded */

	if (!setrunmode (plinfo, plinfo->rlmode))
	{
	    terminateload (plinfo, line, FALSE, CANTSETLOADEDMODE);
	    return (-1);
	}

	/* !!Two messages were issued here: 		*/
	/*	 sf=0x31				*/
	/*	 sf=0x34				*/

	if (!plc_logout (plinfo))
	{
	    terminateload (plinfo, line, FALSE, CANNOTLOGOUT);
	    return (-1);
	}

	/* Set Pmod status back to no loading */

	plinfo->pmod->prog_load_stat = PLC_NOT_LOADING;
	plinfo->pmod->prog_load_code = code;
	return;
}


/*                                                            		
/*	PLC Logout                                                	
*/

/* called from scan_plc, loadinit, and terminateload  */


static int plc_logout (LOADINFO *plinfo)

    {
	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;	/* Address		*/
	txp->txbuf [1] =  MODLOAD;	/* Function Code	*/
	txp->txbuf [2] =  1;		/* Length		*/
	txp->txbuf [3] =  MODSFLOGOUT;	/* Subfunction Code 	*/

	makecrc (&(txp->txbuf [0]), 4, &(txp->txbuf [4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != plinfo->mod) ||
	    (rxp->rxbuf [1] != MODLOAD) ||
	    (rxp->rxbuf [2] != 2 ) ||
	    (rxp->rxbuf [3] != MODSFLOGOUT) ||
	    (rxp->rxbuf [4] != MODCMDDONE) )
	{
	    plinfo->pmod->no_dataerr++;
	    return (FALSE);
	}
	return (TRUE);
}

/*                                                               	
/*	PLC Login                                                 	
*/

/* called from scan_plc and loadinit  */


static int plc_login (LOADINFO *plinfo)
{
	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;	/* Address	        */
	txp->txbuf [1] =  MODLOAD;	/* Function Code	*/
	txp->txbuf [2] =  1;		/* Length	        */
	txp->txbuf [3] =  MODSFLOGIN;	/* Subfunction Code     */

	makecrc (&(txp->txbuf [0]), 4, &(txp->txbuf [4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != plinfo->mod) ||
	    (rxp->rxbuf [1] != MODLOAD) ||
	    (rxp->rxbuf [2] != 2 ) ||
	    (rxp->rxbuf [3] != MODSFLOGIN) ||
	    ((rxp->rxbuf [4] & 0x80) != 0) )
	{
	    plinfo->pmod->no_dataerr++;
	    return (FALSE);
	}

	return (TRUE);
}

/*                                                          		
/*	PLC Start                                                 	
*/
/* called from scan_plc and loadnextblock  */


static int plc_start (LOADINFO *plinfo)
    {
  	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;	/* Address	        */
	txp->txbuf [1] =  MODLOAD;	/* Function Code	*/
	txp->txbuf [2] =  1;		/* Length	        */
	txp->txbuf [3] =  MODSFSTART;	/* Subfunction Code     */

	makecrc (&(txp->txbuf [0]), 4, &(txp->txbuf [4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != plinfo->mod) ||
	    ((rxp->rxbuf [1] & 0x7F) != MODLOAD) )
	{
	    plinfo->pmod->no_dataerr++;
	    return (FALSE);
	}

	/* Is it a command done */

	if ((rxp->rxbuf [1] == MODLOAD) &&
	    (rxp->rxbuf [3] == MODSFSTART) &&
	    (rxp->rxbuf [4] == MODCMDDONE) )
	{
	    return (TRUE);
	}

	/* Is it an ACK done */

	if ((rxp->rxbuf [1] == (0x80 + MODLOAD) )&&
	    (rxp->rxbuf [2] == MODCMDSTARTED) )
	{
	    return (pollfordone (plinfo, MODSFSTART, FALSE));
	}
	return (FALSE);
}


/*                                                                	
/*	PLC Stop                                         		
*/

/* called from loadinit and scan_plc */


static int plc_stop (LOADINFO *plinfo)
    {
	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;	/* Address	        */
	txp->txbuf [1] =  MODLOAD;	/* Function Code	*/
	txp->txbuf [2] =  1;		/* Length	        */
	txp->txbuf [3] =  MODSFSTOP;	/* Subfunction Code     */

	makecrc (&(txp->txbuf [0]), 4, &(txp->txbuf [4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != plinfo->mod) ||
	    ((rxp->rxbuf [1] & 0x7F) != MODLOAD) )
	{
	    plinfo->pmod->no_dataerr++;
	    return (FALSE);
	}

	/* Is it a command done */

	if ((rxp->rxbuf [1] == MODLOAD) &&
	    (rxp->rxbuf [3] == MODSFSTOP) &&
	    (rxp->rxbuf [4] == MODCMDDONE) )
	{
	    return (TRUE);
	}

	/* Is it an ACK done */

	if ( (rxp->rxbuf [1] == (0x80 + MODLOAD)) /*&&
	     (rxp->rxbuf [2] == MODCMDSTARTED) */ )
	{
	    return (pollfordone (plinfo, MODSFSTOP, FALSE));
	}
	return (FALSE);
}

/*    									
/* pollfordone                                                     	
/*	subfunction                                                 	
/*                                                                  	
*/
/* called from plc_start, plc_stop, and writelogic  */


static int pollfordone (LOADINFO *plinfo, int subfunction, unsigned short geterrcode)
    {
	unsigned short	i;
	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	for (i = 0;i < MAXPOLLSFORDONE; i++)
	{

	    /* Format the output message */

	    txp->txbuf [0] =  plinfo->mod;	/* Address	        */
	    txp->txbuf [1] =  MODPOLL;		/* Function Code	*/

	    makecrc (&(txp->txbuf [0]), 2, &(txp->txbuf [2]));

	    txp->txmsglen = 4;

	    /* Send out the message */

	    if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	    {
		plinfo->pmod->no_offlines++;
	    	plinfo->pmod->holdflag = TRUE;
		plinfo->pmod->is_responding = FALSE;
		return (FALSE);
	    }

	    /* May be used to fetch error code only */

	    if (geterrcode)
	    {
	    	return (TRUE);
	    }
	    /* Verify the response */

	    if ((rxp->rxbuf [0] == plinfo->mod) &&
		(rxp->rxbuf [1] == MODPOLL) &&
		(rxp->rxbuf [2] == 2 ) &&
		(rxp->rxbuf [3] == subfunction) &&
		(rxp->rxbuf [4] == MODCMDDONE) )
	    {
		return (TRUE);
	    }
	}
	return (FALSE);
}

/* 										
/*	PLC Init                                                     		
*/                                                                      	
/* only called from loadnextblock  */

static int plc_init (LOADINFO *plinfo)
{
	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;		/* Address		*/
	txp->txbuf [1] =  MODLOAD;		/* Function Code	*/
	txp->txbuf [2] =  1;			/* Length		*/
	txp->txbuf [3] =  MODSFINITIALIZE;	/* Subfunction Code 	*/

	makecrc (&(txp->txbuf [0]), 4, &(txp->txbuf [4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != plinfo->mod) ||
	    (rxp->rxbuf [1] != MODLOAD) ||
	    (rxp->rxbuf [2] != 2 ) ||
	    (rxp->rxbuf [3] != MODSFINITIALIZE) ||
	    (rxp->rxbuf [4] != MODCMDDONE) )
	{
	    plinfo->pmod->no_dataerr++;
	    return (FALSE);
	}
	return (TRUE);
}

/*                    								
/*	Get Dim Awareness
/*		-1 => error    0 => not dim   1=> dim                       	
*/
/* only called from loadinit  */

static int plc_getdim (LOADINFO *plinfo)
    {
	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;	/* Address	        */
	txp->txbuf [1] =  MODLOAD;	/* Function Code	*/
	txp->txbuf [2] =  1;		/* Length	        */
	txp->txbuf [3] =  MODSFCHKDIM;	/* Subfunction Code     */

	makecrc (&(txp->txbuf [0]), 4, &(txp->txbuf [4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (-1);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != plinfo->mod) ||
	    (rxp->rxbuf [1] != MODLOAD) ||
	    (rxp->rxbuf [3] != MODSFCHKDIM) )
	{
	    plinfo->pmod->no_dataerr++;
	    return (-1);
	}

	if  (rxp->rxbuf [4] == 0)
	{
	    return(0); /* Not in Dim Awareness */
	}
	return (1); /* Am in Dim Awareness */
}


/*          									
/*	Set Dim Awareness                                                   	
*/
/* only called from loadinit  */

static int plc_setdim (LOADINFO *plinfo)
    {
	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;	/* Address	        */
	txp->txbuf [1] =  MODLOAD;	/* Function Code	*/
	txp->txbuf [2] =  1;		/* Length	        */
	txp->txbuf [3] =  MODSFENTERDIM;	/* Subfunction Code     */

	makecrc (&(txp->txbuf [0]), 4, &(txp->txbuf [4]));

	txp->txmsglen = 6;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != plinfo->mod) ||
	    (rxp->rxbuf [1] != MODLOAD) ||
	    (rxp->rxbuf [3] != MODSFENTERDIM) ||
	    (rxp->rxbuf [4] != MODCMDDONE))
	{
	    plinfo->pmod->no_dataerr++;
	    return (FALSE);
	}
	return (TRUE);
}

/*                                                			
/*	Set Run Mode                                                	
*/
/* called from loadnextblock and terminateload  */

static int setrunmode (LOADINFO *plinfo, short value)
    {
	return (writemem (
		plinfo,
		0,
	 	RUNLOADSWITCHADDR,
	 	2,
		(char*) &value));  /* &value)); ### */
			   /* (wep: cast required when prototyping was performed. */
}

/*                                            				
/*	Get Run Mode                                               	
*/
/* only called from loadnextblock  */

static int getrunmode (LOADINFO *plinfo, short *pvalue)
{
	return (readmem(
		plinfo,
		0,
		RUNLOADSWITCHADDR,
		2,
		(char*) pvalue)); /* pvalue)); ###*/
}

/*                                                                 	
/*	Get Machine State                                          	
*/
/* only called from loadinit  */

static int get_plc_state (LOADINFO *plinfo, short *pvalue)
{
	return (readmem (
		plinfo,
		0,
		MACHINESTATEADDR,
		2,
		(char*) pvalue));  /* pvalue)); ###*/
}


/*                                                                	
/*	Read Memory (Page,Address,datalength,buffer)               	
*/
/* called from getrunmode and get_plc_state */

static int readmem (LOADINFO *plinfo, unsigned short page, unsigned short address,
	     unsigned short datalen, char *databuf)
{

	TXLINE		*txp;
	RXLINE		*rxp;
	unsigned short	i;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;		/* Address		*/
	txp->txbuf [1] =  MODLOAD;		/* Function Code	*/
	txp->txbuf [2] =  5;			/* Length		*/
	txp->txbuf [3] =  MODSFREADMEM;		/* Subfunction Code 	*/
	txp->txbuf [4] =  (datalen / 2);	/* Count of elements 	*/
	txp->txbuf [5] =  page;			/* Memory Page 		*/
	txp->txbuf [6] =  (address >> 8);	/* Address High 	*/
	txp->txbuf [7] =  (address & 0xFF);	/* Address Low 		*/

	makecrc (&(txp->txbuf [0]), 8, &(txp->txbuf [8]));

	txp->txmsglen = 10;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Verify the response */

	if ((rxp->rxbuf [0] != plinfo->mod) ||
	    (rxp->rxbuf [1] != MODLOAD) ||
	    (rxp->rxbuf [2] != datalen + 5) ||
	    (rxp->rxbuf [3] != MODSFREADMEM) ||
	    (rxp->rxbuf [4] != (datalen / 2)) ||
	    (rxp->rxbuf [5] != page) ||
	    (rxp->rxbuf [6] != (unsigned char) (address >> 8)) ||
	    (rxp->rxbuf [7] != (unsigned char) (address & 0xFF))  )
	{
	    plinfo->pmod->no_dataerr++;
	    return (FALSE);
	}
	/* move in the data */
	for (i = 0;(i < datalen); i++)
	{
	    databuf [i] = rxp->rxbuf [8 + i];
	}
	return (TRUE);
}
/*                                                            		
/*	Write Memory (Page,Address,datalength,buffer)              	
*/
/* called from loadmemory and setrunmode */

static int writemem (LOADINFO *plinfo, unsigned short page, unsigned short address,
	     unsigned short datalen, char *databuf)
    {
	unsigned short	i;
	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;	/* Address	        */
	txp->txbuf [1] =  MODLOAD;	/* Function Code	*/
	txp->txbuf [2] =  5 + datalen;	/* Length	        */
	txp->txbuf [3] =  MODSFWRITEMEM;	/* Subfunction Code     */
	txp->txbuf [4] =  (datalen  /2);	/* Count of elements    */
	txp->txbuf [5] =  page;		/* Memory Page */
	txp->txbuf [6] =  (address >> 8);	/* Address High */
	txp->txbuf [7] =  (address & 0xFF);	/* Address Low  */

	/* move in the data */
	for (i = 0;(i < datalen); i++)
	{
	    txp->txbuf [8 + i] = databuf [i];
	}
	makecrc (&(txp->txbuf [0]), 8 + datalen, &(txp->txbuf [8 + datalen]));

	txp->txmsglen = 10 + datalen;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Verify the response is command done*/

	if ((rxp->rxbuf [0] != plinfo->mod) ||
	    (rxp->rxbuf [1] != MODLOAD) ||
	    (rxp->rxbuf [2] != 2) ||
	    (rxp->rxbuf [3] != MODSFWRITEMEM) ||
	    (rxp->rxbuf [4] != MODCMDDONE)  )
	{
	    plinfo->pmod->no_dataerr++;
	    return (FALSE);
	}
	return (TRUE);
}

/*                                                                	
/*	Write Logic (Page,Address,datalength,buffer)               	
*/
/* only called from loadlogic */

static int writelogic (LOADINFO *plinfo, unsigned short page, unsigned short address,
	     unsigned short datalen, char *databuf)
    {
	unsigned short	i;
	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;		/* Address		*/
	txp->txbuf [1] =  MODLOAD;		/* Function Code	*/
	txp->txbuf [2] =  5 + datalen;		/* Length		*/
	txp->txbuf [3] =  MODSFWRITENODE;	/* Subfunction Code 	*/
	txp->txbuf [4] =  (datalen / 3);		/* Count of elements 	*/
	txp->txbuf [5] =  page;			/* Memory Page 		*/
	txp->txbuf [6] =  (address >> 8);	/* Address High 	*/
	txp->txbuf [7] =  (address & 0xFF);	/* Address Low 		*/

	/* move in the data */
	for (i = 0; (i < datalen); i++)
	{
	    txp->txbuf [8 + i] = databuf [i];
	}
	makecrc (&(txp->txbuf [0]), 8 + datalen, &(txp->txbuf [8 + datalen]));

	txp->txmsglen = 10 + datalen;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (FALSE);
	}


	/* Verify the response is command done*/

	if ((rxp->rxbuf [0] == plinfo->mod) &&
	    (rxp->rxbuf [1] == MODLOAD) &&
	    (rxp->rxbuf [2] == 2) &&
	    (rxp->rxbuf [3] == MODSFWRITENODE) &&
	    (rxp->rxbuf [4] == MODCMDDONE)  )
	{
	    return (TRUE);
	}

	/* Is it an ACK done */

	if ((rxp->rxbuf [1] == (0x80 + MODLOAD)) &&
	    (rxp->rxbuf [2] == MODCMDSTARTED))
	{
	    return (pollfordone (plinfo, MODSFWRITENODE, FALSE));
	}
	pollfordone (plinfo, MODSFWRITENODE, TRUE);
	return (FALSE);
}

/*                                                            		
/*	Write Ascii (Page,Address,datalength,buffer)              	
*/
/* only called from loadmemory */

static int writeascii (LOADINFO *plinfo, unsigned short page, unsigned short address,
	     unsigned short datalen, char *databuf)
    {
	unsigned short	i;
	TXLINE		*txp;
	RXLINE		*rxp;

	/* Set up pointers for comm buffers */

	txp = txlinetab [plinfo->line];
	rxp = rxlinetab [plinfo->line];

	/* Format the output message */

	txp->txbuf [0] =  plinfo->mod;		/* Address		*/
	txp->txbuf [1] =  MODLOAD;		/* Function Code	*/
	txp->txbuf [2] =  5 + datalen;		/* Length		*/
	txp->txbuf [3] =  MODSFWRITEASCII;	/* Subfunction Code 	*/
	txp->txbuf [4] =  (datalen / 2);		/* Count of elements 	*/
	txp->txbuf [5] =  page;			/* Memory Page 		*/
	txp->txbuf [6] =  (address >> 8);	/* Address High 	*/
	txp->txbuf [7] =  (address & 0xFF);	/* Address Low 		*/

	/* move in the data */
	for (i = 0; (i < datalen); i++)
	{
	    txp->txbuf [8 + i] = databuf [i];
	}
	makecrc (&(txp->txbuf [0]), 8 + datalen, &(txp->txbuf [8 + datalen]));

	txp->txmsglen = 10 + datalen;

	/* Send out the message */

	if (msgxfer (plinfo->line, VARRESP, plinfo->pmod, 0) == XFERBAD)
	{
	    plinfo->pmod->no_offlines++;
	    plinfo->pmod->holdflag = TRUE;
	    plinfo->pmod->is_responding = FALSE;
	    return (FALSE);
	}

	/* Verify the response is command done*/

	if ((rxp->rxbuf [0] != plinfo->mod) ||
	    (rxp->rxbuf [1] != MODLOAD) ||
	    (rxp->rxbuf [2] != 2) ||
	    (rxp->rxbuf [3] != MODSFWRITEASCII) ||
	    (rxp->rxbuf [4] != MODCMDDONE)  )
	{
	    plinfo->pmod->no_dataerr++;
	    return (FALSE);
	}
	return (TRUE);
}


/*
/* Send ID Table                                                      	
/*                                                                  	
*/
static	int sendidtable (unsigned short line, unsigned short mod, MODPLC *pmod)
{
    TXLINE           *txp;
    RXLINE           *rxp;
    unsigned short    i, j, base, startaddress, listlength, idcode, msglength;
    LOADID           *idinfo;
    unsigned short    k, l, maxwrite, totallistlength;

    idinfo = &idtable[line]; /* establish the pointer.   */
    startaddress = idinfo->start_register - 1;
    totallistlength = idinfo->maxid;

    maxwrite = maxidwrite [line];

    l = 0;

    while (totallistlength)
    {
        /* calculate the list length for this send */
        if (totallistlength > maxwrite)
        {
            listlength = maxwrite;
            totallistlength = totallistlength - maxwrite;
        }
        else
        {
            listlength = totallistlength;
            totallistlength = 0;
        }

        /* Set up pointers for comm buffers */
        txp = txlinetab [line & (~ONERETRY)];
        rxp = rxlinetab [line & (~ONERETRY)];

        /* Count number of data output messages */
        pmod->no_dataout_msgs++;

        /* Format the output message */
        txp->txbuf [0] =  mod;
        txp->txbuf [1] =  MODMREGWRITE;
        txp->txbuf [2] =  (startaddress >> 8);
        txp->txbuf [3] =  (startaddress & 0xFF);
        txp->txbuf [4] =  listlength / 256;
        txp->txbuf [5] =  listlength % 256;
        txp->txbuf [6] =  listlength * 2;

        /* Store the transmit data */
        base = 7;
        i = 0;
        j = 0;
        for (i = 0; i < listlength; i++)
        {
            idcode = idinfo->idcodes[i+l];
            txp->txbuf [base+j++] = idcode/256;
            txp->txbuf [base+j++] = idcode%256;
        }
        msglength = base + listlength * 2;

        makecrc (&(txp->txbuf [0]), msglength, &(txp->txbuf [msglength]));
        txp->txmsglen = msglength + MODCRCLEN;

        /* Send out the message */
        if (msgxfer (line, FIXEDRESP, pmod, MODWRITERESPLEN) == XFERBAD)
        {
            pmod->no_offlines++;
            pmod->holdflag = TRUE;
            pmod->is_responding = FALSE;
            return (CMDFAIL);
        }

        /* Verify the response - the first six characters of the message are echoed */
        for (i = 0; (i < MODSETMREGRESPLEN); i++)
        {
            if (txp->txbuf [i] != rxp->rxbuf [i])
            {
                pmod->no_dataerr++;
                return (CMDNACK);
            }
        }
        /* re-calculate where to start reading data in the idtable buffer on the next write. */
        l = l + listlength;
        /* re-calculate where to store data in the PLC on the next write. */
        startaddress = startaddress + listlength;
    }
    return (CMDDONE);
}

/*
/* makecrc 									
/*                                                                        	
*/
/* called from msgxfer, modloopback, readcoils, readdis, readais, readregs, setcoil, setreg,  */
/*             plc_logout, plc_login, plc_start, plc_stop, pollfordone, plc_init, plc_getdim, */
/*             plc_setdim, readmem, writemem, writelogic, and writeascii.                     */

static	void makecrc (unsigned char *chkbuf, int len,char unsigned *retbuf)

    {
	unsigned short	checksum;
	unsigned int    i, j;
	unsigned short  flag;
	unsigned char   tempch;

	checksum = 0x0ffff;
	for (j = 0; j < len; j++)
	{
	    tempch = chkbuf [j];
	    checksum ^= tempch;
	    for (i = 0; i < 8; i++)
	    {
		flag = checksum & 1;
		checksum >>= 1;
		if (flag)
		{
		    checksum ^= (unsigned short) 0x0a001;
		}
	    }
	}
	retbuf [1] = ((checksum >> 8) & 0xff);
	retbuf [0] = (checksum & 0xff);
}
/*                                                                        	
/*      hexascii                                                            	
/*                                                                          	
/*      The purpose of this routine is to convert the hex byte to 2 ascii   	
/*      characters and to place them into the buffer.                       	
/*                                                                          	
*/
/* not called from within this driver */


static	void hexascii (unsigned short val,char *buf)

{
	char    hi, lo;

	hi = ((val & 0x0f0) >> 4);
	lo = (val & 0x0f);

	if (hi <= 9)
	{
	    hi+='0';
	}
	else
	{
	    hi += ('A' - 10);
	}
	if (lo <= 9)
	{
	    lo += '0';
	}
	else
	{
	    lo += ('A' - 10);
	}
	buf [0] = hi;
	buf [1] = lo;

}

/*                                                                         	
/*      asciihex                                                    	   	
/*                                                                         	
/*      The purpose of this routine is to convert the next 2 ascii         	
/*      characters in the buffer to hex and return them in val. It         	
/*      will return TRUE if good conversion of FALSE if bad.               	
*/                                                                         	
/* not called from within this driver */


static	short asciihex (unsigned short *val,char *buf)

{
	if ((buf [0] < '0') || (buf [0] > 'F'))
	{
	    return (FALSE);
	}
	if (buf [0] <= '9')
	{
	    *val = ((buf [0] & 0x0f) << 4);
	}
	else
	{
	    if (buf [0] < 'A')
	    {
		return (FALSE);
	    }
	    else
	    {
		*val = ((buf [0] - 'A' + 10) << 4);
	    }
	}
	if ((buf [1] < '0') || (buf [1] > 'F'))
	{
	    return (FALSE);
	}
	if ( buf [1] <= '9')
	{
	    *val += (buf [1] & 0x0f);
	}
	else
	{
	    if (buf [1] < 'A')
	    {
		return (FALSE);
	    }
	    else
	    {
		*val += (buf [1] - 'A' + 10);
	    }
	}
	return (TRUE);
}

/*****************************************************************************************/
/*****************************************************************************************/
/*****************************************************************************************/
/*                                                                                         
/*      terminatehtload                                                                    
 /*	Abort the Historical Trend Format Load and Report Errors                           
/*                                                                                         
*/                                                                                              
/* called from loadhtfile */

static void terminatehtload (LOADHT *htinfo, unsigned short line, unsigned short success,
                                             unsigned short code, unsigned short entry_count)
{
    /* Close The File		*/
    fclose(htinfo->htfile);

    htinfo->loading = FALSE;
    htinfo->ht_load_status = success;
    htinfo->ht_load_code = code;
    if (trace[line] & HTFORMATFILETRACE)
    {
        switch (code)
        {
            case LOADFILEOK:
                logMsg("Historical Trend file read was successful, and contained %d entries.\n", entry_count);
                break;

            case SYNTAXERROR1:
            case SYNTAXERROR2:
            case SYNTAXERROR3:
            case SYNTAXERROR4:
            case SYNTAXERROR5:
                logMsg("Historical Trend file read was not successful, due to syntax error on entry %d.\n", entry_count+1);
                break;

            case CANNOTOPENIDFILE:
                logMsg("Historical Trend file read was not successful, because the file could not be read.\n", entry_count+1);
                break;

            case TRIVIALFILE:
                logMsg("Historical Trend file read was not successful, because the file had no entries\n", entry_count+1);
                break;

            case BADBASEREGISTER:
                logMsg("Historical Trend file read was not successful, due to an illegal base register value on entry %d.\n", entry_count+1);
                break;

            case BADUSERNUMBER:
                logMsg("Historical Trend file read was not successful, due to an illegal PLC address on entry %d.\n", entry_count+1);
                break;

            case BADPINNUMBER:
                logMsg("Historical Trend file read was not successful, due to an illegal register count value on entry %d.\n", entry_count+1);
                break;
        }
    }

    return;
}
/* end of terminatehtload */

/*****************************************************************************************/
/*****************************************************************************************/
/*****************************************************************************************/
/*
/*      terminateidload
/*	Abort the Address Translation Map Load and Report Errors                
/*                                                                          
*/                                                                                              
/* called from loadidfile */

static void terminateidload (LOADID *idinfo, unsigned short line, unsigned short success,
                                             unsigned short code, unsigned short entry_count)
{
    /* Close The File		*/
    fclose(idinfo->idfile);
    idinfo->loading = FALSE;
    idinfo->id_load_status = success;
    idinfo->id_load_code = code;
    if (trace[line] & USERIDFILETRACE)
    {
        switch (code)
        {
            case LOADFILEOK:
                logMsg("User ID file read was successful, and contained %d entries.\n", entry_count);
                break;

            case SYNTAXERROR1:
            case SYNTAXERROR2:
            case SYNTAXERROR3:
            case SYNTAXERROR4:
            case SYNTAXERROR5:
                logMsg("User ID file read was not successful, due to syntax error on entry %d.\n", entry_count+1);
                break;

            case CANNOTOPENIDFILE:
                logMsg("User ID file read was not successful, because the file could not be read.\n", entry_count+1);
                break;

            case TRIVIALFILE:
                logMsg("User ID file read was not successful, because the file had no entries\n", entry_count+1);
                break;

            case BADSTARTREGISTER:
                logMsg("User ID file read was not successful, due to an illegal register value.\n", entry_count+1);
                break;

            case BADUSERNUMBER:
                logMsg("User ID file read was not successful, due to an illegal user number on entry %d.\n", entry_count+1);
                break;

            case BADPINNUMBER:
                logMsg("User ID file read was not successful, due to an illegal pin number on entry %d.\n", entry_count+1);
                break;
        }
    }

    return;
}
/* end of terminateidload */

/*
/* eatspaces                                                                
/*        entered with ch containing first character under consideration    
/*        exit with ch pointing to next character to be considered.         
/*                                                                          
 */
/* only called from readidfile */

static void eatspaces(char *ch, FILE *handle)
{
    while ((*ch == ' ') || (*ch == '\t') || (*ch == ','))
    {
        *ch = getc(handle);
    }
    return;  /* only leave when non-space, non-comma character encountered */
}



/*                                                                          
/* eatline                                                                  
/*        entered with ch containing first character under consideration    
/*        exit with ch pointing to next character to be considered.         
/*                                                                          
 */
/* only called from readidfile */

static void eatline(char *ch, FILE *handle)
{
    while ((*ch != '\n') && (*ch != EOF))
    {
        *ch = getc(handle);
    }
    while (*ch == '\n') 
    {
        *ch = getc(handle);
    }
    return; /* only leave when non-end-of-line or end-of-file encountered */
}


/* static void  */ 



/*                                              
/*	North Wales Special: test tools         
/*                                              
*/                                                                 	                
/* only called from MAIN */
 void newidfile (unsigned short line)
{
    LOADID         *idinfo;
    MODPLC         *pmod;
    unsigned short  mod;

    idinfo = &idtable[line];
    idinfo->was_requested = TRUE;
/*   master_updateredimages (line); */
}


 void setidpending (unsigned short line, unsigned short mod)
{
    MODPLC         *pmod;

    pmod = plcs [line] [mod];       /* shorthand pointer                       */
    if (pmod)                       /* verify pointer validity prior to use    */
    {
        pmod->id_pending = TRUE;
    }
}


void clearidpending (unsigned short line, unsigned short mod)
{
    MODPLC         *pmod;

    pmod = plcs [line] [mod];       /* shorthand pointer                       */
    if (pmod)                       /* verify pointer validity prior to use    */
    {
        pmod->id_pending = FALSE;
    }
}




/*
/*	North Wales Special: Check for reload of ID Code List from idlist.txt File         
/*                                                                                         
*/                                                                 	                
/* only called from MAIN */
static int checkidfile (unsigned short line)
{
    LOADID         *idinfo;
    MODPLC         *pmod;
    unsigned short  mod;

    idinfo = &idtable[line];	  /* establish the pointer.   */

    if (idinfo->was_requested)
    {
        /* clear the flag first. we are only going to try this once, no matter what happens. */
        idinfo->was_requested = FALSE;
        /* load new copy of file. */
        if (loadidfile(line))
        {
/********************************************************************/
/* 12-03-97: Dennis wants this to NOT happen automatically anymore. */
return;
            /* if loaded without error, mark all plcs to be sent the new copy */
            for (mod = 1; (mod <= NUMMODPLCS); mod++)
            {
                pmod = plcs [line] [mod];       /* shorthand pointer 			*/
                if (pmod)                       /* verify pointer validity prior to use */
                {
                    pmod->id_pending = TRUE;
                }
            }
        }
    }
}

/*
/*	North Wales Special: Load ID Code List from idlist.txt File                        
/*                                                                                         
*/                                                                 	                
/* only called from MAIN */

static int loadidfile (unsigned short line)
{
    FILE           *handle;
    LOADID         *idinfo;
    char            filename[30];
    int             status;
    char            nextchar, *pnextchar;
    unsigned short  i, state;
    unsigned int    user_number, pin_number, start_register;
    unsigned short  entry_count;

    pnextchar = &nextchar;

    idinfo = &idtable[line];	  /* establish the pointer.   */

    /* If already one being loaded, something is wrong.       */
    if (idinfo->loading)
        return(FALSE);

    idinfo->loading = TRUE;

    /* first, initialize the array to all null/invalid values */
    idinfo->maxid = 0;
    idinfo->data_valid = FALSE;

    for (i = 0; i <= MAXUSERNUM; i++)
    {
        idinfo->idcodes[i] = 0;
    }

    /* Make File Name	*/
    strcpy (idinfo->filename, "idlist.txt");

    /* Open File existing file for Read Only */
    iam(user, password);
    if ((idinfo->idfile = fopen(&idinfo->filename[0],"r")) == NULL)
    {
        terminateidload(idinfo, line ,FALSE, CANNOTOPENIDFILE,0);
        return(FALSE);
    }

    entry_count = 0; /* only used fore diagnostic messages */

    /* initialize starting register */
    idinfo->start_register = DEFAULTREGISTER;

    handle = idinfo->idfile;
    state = START;
    nextchar = getc(handle);    /* get first character in file */

    while (TRUE)
    {
        switch (state)
        {
            case START:
                /* ignore spaces & tabs at beginning of line */
                eatspaces(pnextchar, idinfo->idfile);
                switch (nextchar)
                {
                    /* handle blank lines and comments */
                    case '\n':
                    case '#':
                        eatline(pnextchar, idinfo->idfile);
                        break;

                    /* handle optional starting address for list download */
                    case '@':
                        nextchar = getc(handle);              /* eat the 'at'              */
                        eatspaces(pnextchar, idinfo->idfile); /* eat any spaces after 'at' */
                        state = STARTREGISTER;
                        break;
                    /* handle end of file */
                    case 0x0d:
                    case EOF:
                        state = WRAPUP;
                        break;

                    default:
                        /* if numeric, proceed to process */
                        if ((nextchar >= '0') && (nextchar <= '9'))
                        {
                            state = FIRSTPARAM;
                            break;
                        }
                        terminateidload(idinfo, line, FALSE, SYNTAXERROR1, entry_count);
                        return(FALSE);     /* syntax error */
                        break;
                }
                break;


            case STARTREGISTER:
                start_register = 0;
                if (!((nextchar >= '0') && (nextchar <= '9')))
                {
                     terminateidload(idinfo,line,FALSE,SYNTAXERROR2, entry_count);
                     return(FALSE);         /* syntax error */
                }
                while ((nextchar >= '0') && (nextchar <= '9'))
                {
                    start_register = start_register*10 + (nextchar-'0');
                    if (start_register < MINSTARTREGISTER)
                    {
                       terminateidload(idinfo,line,FALSE,BADSTARTREGISTER, entry_count);
                       return(FALSE);         /* starting register number less than min value */
                    }
                    if (start_register > MAXSTARTREGISTER)
                    {
                       terminateidload(idinfo,line,FALSE,BADSTARTREGISTER, entry_count);
                       return(FALSE);         /* starting register number exceeded max value */
                    }
                    nextchar = getc(handle);  /* eat that digit, get the next */
                }
                eatline(pnextchar, idinfo->idfile); /* eat up the rest of the line */
                state = STOREREGISTER;
                break;

            case STOREREGISTER:
                idinfo->start_register = start_register;
                state = START;   /* process next line of input, if there is one. */
                break;

            case FIRSTPARAM:
                user_number = 0;
                if (!((nextchar >= '0') && (nextchar <= '9')))
                {
                     terminateidload(idinfo, line, FALSE, SYNTAXERROR3, entry_count);
                     return(FALSE);         /* syntax error */
                }
                while ((nextchar >= '0') && (nextchar <= '9'))
                {
                    user_number = user_number*10 + (nextchar-'0');
                    if (user_number < MINUSERNUM)
                    {
                       terminateidload(idinfo, line, FALSE, BADUSERNUMBER, entry_count);
                       return(FALSE);         /* user number exceeded max value */
                    }
                    if (user_number > MAXUSERNUM)
                    {
                       terminateidload(idinfo, line, FALSE, BADUSERNUMBER, entry_count);
                       return(FALSE);         /* user number exceeded max value */
                    }
                    nextchar = getc(handle);  /* eat that digit, get the next */
                }
                eatspaces(pnextchar, idinfo->idfile);
                state = SECONDPARAM;
                break;

            case SECONDPARAM:
                pin_number = 0;
                if (!((nextchar >= '0') && (nextchar <= '9')))
                {
                     terminateidload(idinfo,line,FALSE,SYNTAXERROR4, entry_count);
                     return(FALSE);         /* syntax error */
                }
                while ((nextchar >= '0') && (nextchar <= '9'))
                {
                    pin_number = pin_number*10 + (nextchar-'0');
                    if (pin_number > MAXPINNUM)
                    {
                       terminateidload(idinfo,line,FALSE,BADPINNUMBER, entry_count);
                       return(FALSE);         /* PIN number exceeded max value */
                    }
                    nextchar = getc(handle);  /* eat that digit, get the next */
                }
                eatline(pnextchar, idinfo->idfile); /* eat up the rest of the line */
                state = STOREVALUE;
                break;

            case STOREVALUE:
                entry_count++;
                if (idinfo->maxid < user_number) idinfo->maxid = user_number;
                idinfo->idcodes [user_number-1] = pin_number;
                state = START;   /* process next line of input, if there is one. */
                break;

            case WRAPUP:
                if (entry_count)
                {
                    idinfo->data_valid = TRUE;
                    terminateidload(idinfo,line,TRUE,LOADFILEOK, entry_count);
                    return(TRUE);
                }
                else
                {
                    terminateidload(idinfo,line,FALSE,TRIVIALFILE, entry_count);
                    return(FALSE);
                }
                break;

            default:
                terminateidload(idinfo,line,FALSE, SYNTAXERROR5, entry_count);
                return(FALSE);                /* syntax error */
                break;
        }
    }
}
/* end of loadidfile */

void testidfile (unsigned short line)
{
     loadidfile (line);
/*     master_updateredimages (line); */
}

void dumpidtable (unsigned short line)
{
    LOADID         *idinfo;
    unsigned short  i, j, k, x;

    idinfo = &idtable[line];	  /* establish the pointer.   */

    printf ("loading    = %d\n", idinfo->loading);
    printf ("idl status = %d\n", idinfo->id_load_status);
    printf ("idl code   = %d\n", idinfo->id_load_code);
    printf ("filename   = %s\n", idinfo->filename);
    printf ("start reg  = %d\n", idinfo->start_register);
    printf ("maximum id = %d\n", idinfo->maxid);

    printf ("\n");
    printf ("Usr#   ID Code      Usr#   ID Code      Usr#   ID Code      Usr#   ID Code \n");
    printf ("----   -------      ----   -------      ----   -------      ----   ------- \n");

    for (j = 1; j <= (MAXUSERNUM/4); j++)
    {
        for (k = 0; k < 4; k++)
        {
            i = k*(MAXUSERNUM/4) + j;
            x = idinfo->idcodes [i-1];
            printf (" %d%d     %d%d%d%d        ", i/10, i%10, (x/1000)%10, (x/100)%10, (x/10)%10, (x/1)%10);
        }
        printf ("\n");
    }
}

void dumpidred (unsigned short line)
{
    NWMODREDIDUPD  *idinfo;
    unsigned short  i, j, k, x;

    idinfo = redundid [line];
    if (idinfo)
    {
        printf ("start reg  = %d\n", idinfo->start_register);
        printf ("maximum id = %d\n", idinfo->maxid);

        printf ("\n");
        printf ("Usr#   ID Code      Usr#   ID Code      Usr#   ID Code      Usr#   ID Code \n");
        printf ("----   -------      ----   -------      ----   -------      ----   ------- \n");

        for (j = 1; j <= (MAXUSERNUM/4); j++)
        {
            for (k = 0; k < 4; k++)
            {
                i = k*(MAXUSERNUM/4) + j;
                x = idinfo->idcodes [i-1];
                printf (" %d%d     %d%d%d%d        ", i/10, i%10, (x/1000)%10, (x/100)%10, (x/10)%10, (x/1)%10);
            }
            printf ("\n");
        }
    }
    else
    {
        printf ("Invalid redundid pointer for line %d\n", line);
    }
}

void clearidtable (unsigned short line)
{
    LOADID         *idinfo;
    unsigned short  i, x;

    idinfo = &idtable[line];	  /* establish the pointer.   */

    idinfo->loading = 777;
    idinfo->id_load_status = 777;
    idinfo->id_load_code = 777;
    idinfo->filename[0] = 0;
    idinfo->start_register = 777;
    idinfo->maxid = 60;

    for (i = 1; i < MAXUSERNUM+1; i++)
    {
        idinfo->idcodes [i-1] = 7777;
    }
}



/*                                                                              
/*	North Wales Special: Load Historical Trend Format File trendXX.txt      
/*                                                                              
*/                                                                 	                
/* only called from MAIN */

static int loadhtfile (unsigned short line)
{
    FILE           *handle;
    LOADHT         *htinfo;
    char            filename[30];
    int             status;
    char            nextchar, *pnextchar;
    unsigned short  i, state;
    unsigned int    linenumber, plcaddress, startregister, numregisters;
    unsigned short  entry_count;
    unsigned char   iocname[20];
    char            rtuName[64];


/*    strcpy (rtuName, sysBootParams.targetName); */

   /* this one gets Sinbad's initialized name. */
    strcpy (rtuName, iocName);

    pnextchar = &nextchar;

    htinfo = &httable[line];	  /* establish the pointer.   */

    /* if already one being loaded, something is wrong.       */
    if (htinfo->loading)
        return(FALSE);

    htinfo->loading = TRUE;

    /* first, initialize the array to all null/invalid values */
    htinfo->data_valid = FALSE;

    for (i = 0; i <= NUMMODPLCS; i++)
    {
        htinfo->startreg [i] = 0;
        htinfo->regcount [i] = 0;
    }

    /* Make File Name	*/
    strcpy (htinfo->filename,"PLCTREND.TXT");

    /* Open File for Read Only */
    iam(user, password);
    if ((htinfo->htfile = fopen(&htinfo->filename[0],"r")) == NULL)
    {
        terminatehtload(htinfo, line, FALSE, CANNOTOPENHTFILE,0);
        return(FALSE);
    }

    entry_count = 0; /* only used for diagnostic messages */

    handle = htinfo->htfile;
    state = START;
    nextchar = getc(handle);    /* get first character in file */

    while (TRUE)
    {
/*        printf ("\nState = %x, Line = %x, Character = %c  ", state, entry_count, nextchar); */
        switch (state)
        {
            case START:
                /* ignore spaces & tabs at beginning of line */
                eatspaces(pnextchar, htinfo->htfile);
                switch (nextchar)
                {
                    /* handle blank lines and comments */
                    case '\n':
                    case '#':
                        eatline(pnextchar, htinfo->htfile);
                        break;

                    /* handle end of file */
                    case 0x0d:
                    case EOF:
                        state = WRAPUP;
                        break;

                    /* handle the plc trending configuration definition */
                    case '@':
                        nextchar = getc(handle);              /* eat the 'at'              */
                        eatspaces(pnextchar, htinfo->htfile); /* eat any spaces after 'at' */
                        state = IOCNAME;
                        break;

                    default:
                        nextchar = getc(handle);  /* skip this character, get the next */
                        break;
                }
                break;

            case IOCNAME:
                if (! ((nextchar >= '0') && (nextchar <= '9')) &&
                    ! ((nextchar >= 'A') && (nextchar <= 'Z')) &&
                    ! ((nextchar >= 'a') && (nextchar <= 'z')) )
                {
                    /* if 1st character not alphanumeric, ignore the rest of this line. */
                    printf ("\nIOC_name Syntax Error: illegal 1st character (%c).", nextchar);
                    eatline(pnextchar, htinfo->htfile);
                    state = START;
                    break;
                }

                /* start building the IOC name string. */
                for (i = 0; i < 19; i++)
                {
                    if (((nextchar >= '0') && (nextchar <= '9')) ||
                        ((nextchar >= 'A') && (nextchar <= 'Z')) ||
                        ((nextchar >= 'a') && (nextchar <= 'z')) ||
                         (nextchar == '-') ||
                         (nextchar == '_'))
                    {
                        iocname[i] = nextchar;
                        nextchar = getc(handle);  /* eat that digit, get the next */
                    }
                    else
                    {
                        /* terminate the string */
                        iocname[i] = 0;
                        eatspaces(pnextchar, htinfo->htfile);
                        state = LINENUMBER;
                        break;
                    }
                }
                if (state != IOCNAME) break;
                /* if string is too long, ignore the rest of this line. */
                printf ("\nIOC_name Syntax Error: string too long (%s).", iocname);
                eatline(pnextchar, htinfo->htfile);
                state = START;
                break;

           case LINENUMBER:
                linenumber = 0;
                if (!((nextchar >= '0') && (nextchar <= '9')))
                {
                    /* if not numeric, ignore the rest of this line. */
                    printf ("\nIOC_name (%s), Line Number Syntax Error: non-numeric character (%c).",
                             iocname, nextchar);
                    eatline(pnextchar, htinfo->htfile);
                    state = START;
                    break;
                }
                while ((nextchar >= '0') && (nextchar <= '9'))
                {
                    linenumber = linenumber*10 + (nextchar-'0');
                    if (linenumber > MODLINES-1)
                    {
                        /* if value too large, ignore the rest of this line. */
                        printf ("\nIOC_name (%s) Line Number Size Error: max line number exceeded (%c).",
                                 iocname, linenumber);
                        eatline(pnextchar, htinfo->htfile);
                        state = START;
                        break;
                    }
                    nextchar = getc(handle);  /* eat that digit, get the next */
                }
                if (state != LINENUMBER) break;
                eatspaces(pnextchar, htinfo->htfile);
                state = PLCADDRESS;
                break;

           case PLCADDRESS:
                plcaddress = 0;
                if (!((nextchar >= '0') && (nextchar <= '9')))
                {
                    /* if not numeric, ignore the rest of this line. */
                    printf ("\nIOC_name (%s), Line number (%d), PLC Address Syntax Error: non-numeric character (%c).",
                             iocname, linenumber, nextchar);
                    eatline(pnextchar, htinfo->htfile);
                    state = START;
                    break;
                }
                while ((nextchar >= '0') && (nextchar <= '9'))
                {
                    plcaddress = plcaddress*10 + (nextchar-'0');
                    if (plcaddress > MAXPLCADD)
                    {
                        /* if value too large, ignore the rest of this line. */
                        printf ("\nIOC_name (%s) Line Number(%d), PLC Address Error: above max address (%d).",
                                 iocname, linenumber, plcaddress);
                    }
                    nextchar = getc(handle);  /* eat that digit, get the next */
                }
                if (plcaddress < MINPLCADD)
                {
                    /* if value too small, ignore the rest of this line. */
                    printf ("\nIOC_name (%s) Line Number(%d), PLC Address Error: below min address (%d).",
                             iocname, linenumber, plcaddress);
                }
                if (state != PLCADDRESS) break;
                eatspaces(pnextchar, htinfo->htfile);
                state = TTSTARTREGISTER;
                break;


            case TTSTARTREGISTER:
                startregister = 0;
                if (!((nextchar >= '0') && (nextchar <= '9')))
                {
                    /* if not numeric, ignore the rest of this line. */
                    printf ("\nIOC_name (%s), Line (%d), PLC (%d), TTSR Syntax Error: non-numeric character (%c).",
                             iocname, linenumber, plcaddress, nextchar);
                    eatline(pnextchar, htinfo->htfile);
                    state = START;
                    break;
                }
                while ((nextchar >= '0') && (nextchar <= '9'))
                {
                    startregister = startregister*10 + (nextchar-'0');
                    if (startregister > MAXBASEREG)
                    {
                        /* if value too large, ignore the rest of this line. */
                        printf ("\nIOC_name (%s), Line (%d), PLC (%d), TTSR Error: above max address (%d).",
                                 iocname, linenumber, plcaddress, startregister);
                        eatline(pnextchar, htinfo->htfile);
                        state = START;
                        break;
                    }
                    nextchar = getc(handle);  /* eat that digit, get the next */
                }
                if (startregister < MINBASEREG)
                {
                    /* if value too small, ignore the rest of this line. */
                    printf ("\nIOC_name (%s), Line (%d), PLC (%d), TTSR Error: below min address (%d).",
                             iocname, linenumber, plcaddress, startregister);
                    eatline(pnextchar, htinfo->htfile);
                    state = START;
                    break;
                }
                if (state != TTSTARTREGISTER) break;
                eatspaces(pnextchar, htinfo->htfile);
                state = TTREGISTERCOUNT;
                break;

            case TTREGISTERCOUNT:
                numregisters = 0;
                if (!((nextchar >= '0') && (nextchar <= '9')))
                {
                    /* if not numeric, ignore the rest of this line. */
                    printf ("\nIOC_name (%s), Line (%d), PLC (%d), TTSR (%d), TTRC Syntax Error: non-numeric character (%c).",
                             iocname, linenumber, plcaddress, startregister, nextchar);
                    eatline(pnextchar, htinfo->htfile);
                    state = START;
                    break;
                }
                while ((nextchar >= '0') && (nextchar <= '9'))
                {
                    numregisters = numregisters*10 + (nextchar-'0');
                    if (numregisters > MAXNUMREG)
                    {
                        /* if value too large, ignore the rest of this line. */
                        printf ("\nIOC_name (%s), Line (%d), PLC (%d), TTSR (%d), TTRC Error: above max address (%d).",
                                 iocname, linenumber, plcaddress, startregister, numregisters);
                        eatline(pnextchar, htinfo->htfile);
                        state = START;
                        break;
                    }
                    nextchar = getc(handle);  /* eat that digit, get the next */
                }
                if (numregisters < MINNUMREG)
                {
                    /* if value too small, ignore the rest of this line. */
                    printf ("\nIOC_name (%s), Line (%d), PLC (%d), TTSR (%d), TTRC Error: below min address (%d).",
                             iocname, linenumber, plcaddress, startregister, numregisters);
                    eatline(pnextchar, htinfo->htfile);
                    state = START;
                    break;
                }
                if (state != TTREGISTERCOUNT) break;
                eatline(pnextchar, htinfo->htfile); /* eat up the rest of the line */
                state = STOREVALUE;
                break;

            case STOREVALUE:
                entry_count++;
                /* if this is the right IOC, and this is the right line, ... */
                printf ("\nEntry (%d), IOC_name (%s), Line (%d), PLC (%d), TTSR (%d), TTRC (%d).",
                         entry_count, iocname, linenumber, plcaddress, startregister, numregisters);
                if (strcmp(iocname, rtuName) == 0)
                {
                    if (linenumber == line)
                    {
                        printf ("\nEntry (%d) Stored.", entry_count);
                        htinfo->startreg [plcaddress] = startregister;
                        htinfo->regcount [plcaddress] = numregisters;
                        eatline(pnextchar, htinfo->htfile);
                        state = START;   /* process next line of input, if there is one. */
                        break;
                    }
                    else
                    {
                        printf ("\nWrong Line - Entry (%d) NOT Stored. (current line is %d)",
                                  entry_count, line);
                    }
                }
                else
                {
                    printf ("\nWrong IOC - Entry (%d) for name '%s' NOT Stored. (current IOC name is '%s')",
                              entry_count, iocname, rtuName);
                }
                eatline(pnextchar, htinfo->htfile);
                state = START;   /* process next line of input, if there is one. */
                break;

            case WRAPUP:
                if (entry_count)
                {
                    htinfo->data_valid = TRUE;
                    terminatehtload(htinfo,line,TRUE,LOADFILEOK, entry_count);
                    return(TRUE);
                }
                else
                {
                    terminatehtload(htinfo,line,FALSE,TRIVIALFILE, entry_count);
                    return(FALSE);
                }
                break;

            default:
                terminatehtload(htinfo,line,FALSE, SYNTAXERROR5, entry_count);
                return(FALSE);                /* syntax error */
                break;
        }
    }
}
/* end of loadhtfile */

void testhtfile (unsigned short line)
{
     loadhtfile (line);
}

void dumphttable (unsigned short line)
{
    LOADHT         *htinfo;
    unsigned short  i, x, y;

    htinfo = &httable[line];	  /* establish the pointer.   */

    printf ("loading    = %d\n", htinfo->loading);
    printf ("htl status = %d\n", htinfo->ht_load_status);
    printf ("htl code   = %d\n", htinfo->ht_load_code);
    printf ("filename   = %s\n", htinfo->filename);

    printf ("\n");
    printf ("PLC Address   BaseRegister  #Registers\n");
    printf ("-----------   -----------   ----------\n");

    for (i = 1; i <= NUMMODPLCS; i++)
    {
        x = htinfo->startreg [i];
        y = htinfo->regcount [i];
        printf ("    %d%d           4%d%d%d%d           %2d\n", i/10, i%10,
                                        (x/1000)%10, (x/100)%10, (x/10)%10, (x/1)%10, y);
    }
}


/*****************************************************************************************/
/*****************************************************************************************/
/*****************************************************************************************/
/*                                                                                         
/*      terminatemapload
/*	Abort the Historical Trend Format Load and Report Errors                           
/*                                                                                         
*/                                                                                              
/* called from loadmapfile */

static void terminatemapload (LOADHTMAP *mapinfo, unsigned short line, unsigned short success,
                                             unsigned short code, unsigned short entry_count)
{
    /* Close The File		*/
    fclose(mapinfo->mapfile);

    mapinfo->loading = FALSE;
    mapinfo->map_load_status = success;
    mapinfo->map_load_code = code;
    if (trace[line] & HTMAPFILETRACE)
    {
        switch (code)
        {
            case LOADFILEOK:
                logMsg("Historical Trend Map File Read was successful.\n");
                break;

            case CANNOTOPENMAPFILE:
                logMsg("Historical Trend Map File Read was not successful: could not open file.\n");
                break;

            case FILESIZEERROR:
                logMsg("Historical Trend Map File Read was not successful: file too small.\n");
                break;

            case FILEREADERROR:
                logMsg("Historical Trend Map File Read was not successful: read error.\n");
                break;

            case BADCHKSUM:
                logMsg("Historical Trend Map File Read was not successful: bad checksum.\n");
                break;
        }
    }

    return;
}
/* end of terminateidload */



/*                                                                              
/*	North Wales Special: Load Historical Trend Format File mapfileXX.bin    
/*                                                                              
*/                                                                 	                
/* only called from MAIN */

static int loadmapfile (unsigned short line)
{
    FILE           *handle;
    LOADHTMAP      *mapinfo;
    char           *maparray;
    char            addr[8];
    int             status;
    char            nextchar, *pnextchar;
    unsigned short  i, state;
    unsigned int    plc_address, base_register, num_registers;
    unsigned short  entry_count;
    unsigned short  expectedsize1, expectedsize2;
    unsigned char   chksumhigh, chksumlow;
    unsigned short  chksumread, chksumword;

    pnextchar = &nextchar;

    mapinfo = htmaptable[line];                  /* establish the pointer.   */
    if (!(mapinfo))
    {
        return (FALSE);
    }

    /* if already one being loaded, something is wrong.       */
    if (mapinfo->loading)
        return(FALSE);

    mapinfo->loading = TRUE;

    /* first, initialize the data null/invalid values */
    mapinfo->data_valid = FALSE;

    /* Make File Name	*/
    strcpy (mapinfo->filename, iocName);
    addr[0] = '0' + (line / 10);   /* append two digit line number */
    addr[1] = '0' + (line % 10);
    addr[2] = 0;
    strcat(mapinfo->filename,addr);
    strcat(mapinfo->filename,".bin");

    /*******************************************************************/
/*  logMsg("Historical Trend map file: just before read, dump table.\n");
    nwmoddumpmap (line,1);
    taskDelay(300);
*/
    /* Open File for Read Only, Binary File Mode  */
    iam(user, password);
    if ((mapinfo->mapfile = fopen(&mapinfo->filename[0],"rb")) == NULL)
    {

        /* if can't open it, get out. */
        terminatemapload(mapinfo, line, FALSE, CANNOTOPENMAPFILE,0);
        return (FALSE);
    }
    else /* we opened the file successfully */
    {
        /* read the entire structure */
        expectedsize1 = sizeof (mapinfo->htmasks);
        logMsg("Historical Trend Map File Read: expected read size was %d.\n", expectedsize1);
/*        fread (maparray, expectedsize1, 1, mapinfo->mapfile); */
        fread (&mapinfo->htmasks, sizeof (mapinfo->htmasks), 1, mapinfo->mapfile);

        if (feof(mapinfo->mapfile))
        {
            terminatemapstore (mapinfo, line, FALSE, FILESIZEERROR, entry_count);
            return (FALSE);
        }
        if (ferror(mapinfo->mapfile))
        {
            terminatemapstore (mapinfo, line, FALSE, FILEREADERROR, entry_count);
            return (FALSE);
        }

        /* compute the checksum value */
        chksumword = 0;
        maparray = (char *) &mapinfo->htmasks[0];    /* establish the pointer.   */
        for (i = 0; i < expectedsize1; i++)
        {
             nextchar = *maparray;     /* get next character which was read from the file */
             chksumword += nextchar;   /* build checksum word */
             maparray++;
        }

        /* read the checksum */
        expectedsize2 = sizeof (chksumread);
        fread (&chksumread, expectedsize2, 1, mapinfo->mapfile);

        if (feof(mapinfo->mapfile))
        {
            terminatemapstore (mapinfo, line, FALSE, FILESIZEERROR, entry_count);
            return (FALSE);
        }
        if (ferror(mapinfo->mapfile))
        {
            terminatemapstore (mapinfo, line, FALSE, FILEREADERROR, entry_count);
            return (FALSE);
        }
    }
    if (trace[line] & HTMAPFILETRACE)
    {
        logMsg("Historical Trend Map File Read: expectedsize1=%d, chksumread=0x%x, chksumword=0x%x\n",
                expectedsize1, chksumread, chksumword);
    }
    /*******************************************************************/
/*  logMsg("Historical Trend map file: just after read, but before smuggle fix.\n");
    nwmoddumpmap (line,1);
    taskDelay(300);
*/
    /***********************************/
    /* now see if the data is any good */
    if (chksumread == chksumword)
    {
        /* unpack the smuggled top level parameters */
        mapinfo->lastindex  = mapinfo->htmasks[0].index;
        mapinfo->lastmask   = mapinfo->htmasks[0].mask;
        mapinfo->lastnickel = mapinfo->htmasks[0].lastnickel;
        mapinfo->thisnickel = mapinfo->htmasks[0].thisnickel;
        mapinfo->htmasks[0].index      = 0;
        mapinfo->htmasks[0].mask       = 0;
        mapinfo->htmasks[0].lastnickel = 0;
        mapinfo->htmasks[0].thisnickel = 0;

        /*******************************************************************/
/*        logMsg("Historical Trend map file: just after smuggle fix.\n");
        nwmoddumpmap (line,1);
        taskDelay(300);
*/
        terminatemapload (mapinfo, line, TRUE, LOADFILEOK, entry_count);
        /* let application know that the data is valid */
        mapinfo->data_valid = TRUE;
    }
    else
    {
        /* if bad checksum, get out */
        terminatemapload (mapinfo, line, FALSE, BADCHKSUM, entry_count);
        return (FALSE);
    }
    return (TRUE);
}
/* end of loadmapfile */



void loadmapfiletest (unsigned short line)
{
     loadmapfile (line);
}


/*****************************************************************************************/
/*****************************************************************************************/
/*****************************************************************************************/
/*                                                                                         
/*      terminatemapstore
/*
*/                                                                                              
/* called from loadmapfile */

static void terminatemapstore (LOADHTMAP *mapinfo, unsigned short line, unsigned short success,
                               unsigned short code, unsigned short entry_count)
{
    /* Close The File		*/
    fclose(mapinfo->mapfile);

    mapinfo->storing = FALSE;
    mapinfo->map_store_status = success;
    mapinfo->map_store_code = code;
    if (trace[line] & HTMAPFILETRACE)
    {
        switch (code)
        {
            case STOREFILEOK:
                logMsg("Historical Trend Map File Write was successful.\n");
                break;

            case CANNOTOPENMAPFILE:
                logMsg("Historical Trend Map File Write was not successful: could not open file.\n");
                break;

            case FILEWRITEERROR:
                logMsg("Historical Trend Map File Write was not successful: unknown error.\n");
                break;
        }
    }

    return;
}
/* end of terminateidstore */

void writemapfiletest (unsigned short line)
{
     storemapfile (line);
}


/*                                                                              
/*	North Wales Special: Store Historical Trend Format File mapfileXX.bin   
/*                                                                              
*/                                                                 	                
/* only called from MAIN */

static int writemapfile (unsigned short line)
{
    FILE           *handle;
    LOADHTMAP      *mapinfo;
    char           *maparray;
    char            addr[8];
    int             status;
    char            nextchar;
    unsigned short  i, state;
    unsigned int    plc_address, base_register, num_registers;
    unsigned short  entry_count;
    unsigned short  expectedsize1, expectedsize2;
    unsigned char   chksumhigh, chksumlow;
    unsigned short  chksumread, chksumword;

    mapinfo = htmaptable[line];                /* establish the pointer.   */
    if (!(mapinfo))
    {
        return (FALSE);
    }

    /* if already one being stored, something is wrong.       */
    if (mapinfo->storing)
        return(FALSE);

    mapinfo->storing = TRUE;

/*    /* first, initialize the data null/invalid values */
/*    mapinfo->data_valid = FALSE;
*/
    /* Make File Name	*/
    strcpy (mapinfo->filename, iocName);
    addr[0] = '0' + (line / 10);   /* append two digit line number */
    addr[1] = '0' + (line % 10);
    addr[2] = 0;
    strcat(mapinfo->filename,addr);
    strcat(mapinfo->filename,".bin");

    /* Open File for WriteRead Only, Binary File Mode  */
    iam(user, password);
    if ((mapinfo->mapfile = fopen(&mapinfo->filename[0],"w+b")) == NULL)
    {
        terminatemapstore(mapinfo, line, FALSE, CANNOTOPENMAPFILE,0);
        return(FALSE);
    }
    else /* we opened the file successfully */
    {
        /* smuggle across the top level parameters */
        mapinfo->htmasks[0].index      = mapinfo->lastindex;
        mapinfo->htmasks[0].mask       = mapinfo->lastmask;
        mapinfo->htmasks[0].lastnickel = mapinfo->lastnickel;
        mapinfo->htmasks[0].thisnickel = mapinfo->thisnickel;

        /* write the entire structure */
        expectedsize1 = sizeof (mapinfo->htmasks);

/*        fwrite (maparray, expectedsize1, 1, mapinfo->mapfile); */
        fwrite (&mapinfo->htmasks, sizeof (mapinfo->htmasks), 1, mapinfo->mapfile);
        if (ferror(mapinfo->mapfile))
        {
            /* clear out the smuggled parameters */
            mapinfo->htmasks[0].index      = 0;
            mapinfo->htmasks[0].mask       = 0;
            mapinfo->htmasks[0].lastnickel = 0;
            mapinfo->htmasks[0].thisnickel = 0;

            terminatemapstore (mapinfo, line, FALSE, FILEWRITEERROR, entry_count);
            return (FALSE);
        }
        /* compute the checksum value */
        chksumword = 0;
        maparray = (char *) &mapinfo->htmasks[0];  /* establish the pointer.   */
        for (i = 0; i < expectedsize1; i++)
        {
            nextchar = *maparray;     /* get next character in the structure */
            chksumword += nextchar;   /* build checksum word */
            maparray++;
        }

        /* clear out the smuggled parameters */
        mapinfo->htmasks[0].index      = 0;
        mapinfo->htmasks[0].mask       = 0;
        mapinfo->htmasks[0].lastnickel = 0;
        mapinfo->htmasks[0].thisnickel = 0;

        if (trace[line] & HTMAPFILETRACE)
        {
            logMsg("Historical Trend Map File Write: filelength=%d, chksumword=0x%x\n",
                    expectedsize1, chksumword);
        }
        /* write the checksum */
        expectedsize2 = sizeof (chksumword);
        fwrite (&chksumword, expectedsize2, 1, mapinfo->mapfile);
        if (ferror(mapinfo->mapfile))
        {
            terminatemapstore (mapinfo, line, FALSE, FILEWRITEERROR, entry_count);
            return (FALSE);
        }
    }
    terminatemapstore (mapinfo, line, TRUE, STOREFILEOK, entry_count);
    return (TRUE);
}


static int storemapfile (unsigned short line)
{
    maptogo [line] = TRUE;
}
/* end of storemapfile */


void nwmod_mapmon  (unsigned short line)      /* the line number of this driver.                      */
{
    while (1)
    {
        if (maptogo[line])
        {        
            writemapfile (line);
            maptogo [line] = FALSE;
        }
        taskDelay(6);
    }
}



#define MAPLINECOUNT 4

void dumpmapmodtable (unsigned short line, unsigned short mod)
{
    LOADHTMAP      *mapinfo;
    unsigned short  i, j, k;
    unsigned short  x;
    unsigned char   y;
    unsigned short  length;

    length = MASKBYTES/MAPLINECOUNT;

    mapinfo = htmaptable[line];  /* establish the pointer.   */

    /* check for validity */
    if (mapinfo == 0)
    {
        printf ("Terminating Entire Data Dump: Map Table Not Allocated for line %d.\n", line);
        return;
    }

    if (!(mapinfo->data_valid))
    {
        printf ("Terminating Entire Data Dump: Entire Map Data Not Valid for line %d\n", line);
        return;
    }

    printf ("**********************  data_valid  =%3d  ",       mapinfo->htmasks[mod].data_valid);
    printf (                    "    worknickel      =%7d\n",   mapinfo->htmasks[mod].worknickel);
    printf ("*                    *  line        =%3d  ",       mapinfo->htmasks[mod].line);
    printf (                    "    lastnickel      =%7d\n",   mapinfo->htmasks[mod].lastnickel);
    printf ("* PLC Address = %2d   *  address     =%3d  ", mod,  mapinfo->htmasks[mod].address);
    printf (                    "    thisnickel      =%7d\n",   mapinfo->htmasks[mod].thisnickel);
    printf ("*                    *  index       =%3d  ",       mapinfo->htmasks[mod].index);
    printf (                    "    thisnickelcount =%7d, lastnickelcount =%7d\n",
                                                                mapinfo->htmasks[mod].thisnickelcount,
                                                                mapinfo->htmasks[mod].lastnickelcount);
    printf ("**********************  mask = 0x%x%x\n",(mapinfo->htmasks[mod].mask)/16,
                                             (mapinfo->htmasks[mod].mask)%16);
    if (!(mapinfo->data_valid))
    {
        printf ("Line %d PLC %d Data Dump: PLC Map Data Not Valid.\n", line, mod);
        return;
    }
    else
    {
        for (j = 0; j < MAPLINECOUNT; j++)
        {
            printf ("PLC %2d:                    :", mod);
            for (k = 0; k < length; k++)
            {
                x = (j*length)+k;
                printf ("%d%d:", (x/10)%10, x%10);
            }
            printf ("\n");
            printf ("         validmask[%3d-%3d]:", j*length, (j+1)*length - 1);
            for (k = 0; k < length; k++)
            {
                y = mapinfo->htmasks[mod].validmask[(j*length)+k];
                if (y)
                {
                    printf ("%x%x ", y/16, y%16);
                }
                else
                {
                    printf ("-- ");
                }
            }
            printf ("\n");
            printf ("         savedmask[%3d-%3d]:", j*length, (j+1)*length - 1);
            for (k = 0; k < length; k++)
            {
                y = mapinfo->htmasks[mod].savedmask[j*(length)+k];
                if (y)
                {
                    printf ("%x%x ", y/16, y%16);
                }
                else
                {
                    printf ("-- ");
                }
            }
            printf ("\n");
            printf ("         gotitmask[%3d-%3d]:", j*length, (j+1)*length - 1);
            for (k = 0; k < length; k++)
            {
                y = mapinfo->htmasks[mod].gotitmask[j*(length)+k];
                if (y)
                {
                    printf ("%x%x ", y/16, y%16);
                }
                else
                {
                    printf ("-- ");
                }
            }
            printf ("\n");
        }
    }
}

void nwmoddumpmap (unsigned short line, unsigned short mod)
{
    LOADHTMAP      *mapinfo;
    TS_STAMP        temptime;
    unsigned short  i, j, k;
    unsigned short  x;
    unsigned short  length;
    unsigned long   updatetime;
    unsigned char   dummybuffer[1000];

    length = MASKBYTES/MAPLINECOUNT;

    mapinfo = htmaptable[line];  /* establish the pointer.   */

    /* check for validity */
    if (mapinfo == 0)
    {
        printf ("Terminating Entire Data Dump: Map Table Not Allocated for line %d.\n", line);
        return;
    }

    tsLocalTime (&timenow [line]);
    /* print the current nickel and actual times */
    printf ("**************************************************************\n");
    printf ("Current Real Time:       %s\n",
             tsStampToText(&timenow[line], TS_TEXT_MONDDYYYY, dummybuffer));
    /* 12-12-97: reference time at the end of the nickel instead of the beginning. */
    updatetime = mapinfo->lastnickel * secondspernickel; /* this is in seconds */
    temptime.secPastEpoch = updatetime;
    temptime.nsec = 0;
    printf ("Last Nickel Time End:    %s\n",
             tsStampToText(&temptime, TS_TEXT_MONDDYYYY, dummybuffer));

    updatetime = mapinfo->thisnickel * secondspernickel; /* this is in seconds */
    temptime.secPastEpoch = updatetime;
    temptime.nsec = 0;
    printf ("This Nickel Time End:    %s\n",
             tsStampToText(&temptime, TS_TEXT_MONDDYYYY, dummybuffer));
    printf ("\n**************************************************************************************\n");
    printf ("data_valid    =%3d     ", mapinfo->data_valid);
    printf     ("loading       =%3d     ", mapinfo->loading);
    printf         ("storing       =%3d   \n", mapinfo->storing);
    printf ("
                     ");
    printf     ("mapl status   =%3d     ", mapinfo->map_load_status);
    printf         ("maps status   =%3d   \n", mapinfo->map_store_status);
    printf ("line          =%3d     ", mapinfo->line);
    printf     ("mapl code     =%3d     ", mapinfo->map_load_code);
    printf         ("maps code     =%3d   \n", mapinfo->map_store_code);
    printf ("filename      = %s      \n", mapinfo->filename);

    printf ("lastindex   =%7d   ", mapinfo->lastindex);
    printf ("lastmask    =%3x   \n", mapinfo->lastmask);
    printf ("lastnickel  =%7d    ", mapinfo->lastnickel);
    printf ("thisnickel  =%7d   \n", mapinfo->thisnickel);

    printf ("**************************************************************************************\n");
    if (!(mapinfo->data_valid))
    {
        printf ("Terminating Entire Data Dump: Entire Map Data Not Valid for line %d\n", line);
        return;
    }

    if (mod)
    {
        dumpmapmodtable (line, mod);
        return;
    }

    /* Dennis: just the three we are testing with */
/*    dumpmapmodtable (line, 1);
    dumpmapmodtable (line, 2);
    dumpmapmodtable (line, 14);
    return;
*/
    for (i = 1; i <= NUMMODPLCS; i++)
    {
        dumpmapmodtable (line, i);
    }
}



/*
/*      DUMPMSGCNTS
/*
/*      The purpose of this routine is to dump the line level statistics for this driver. 
/*
*/
/* called from TABLEINFO */

void DUMPMSGCNTS (unsigned short line)

    {
        unsigned long	temp, t, x, y, e, z;

        temp = tickGet ();
        t = (temp - linestats [line].startingtick);

 	x = linestats [line].TXintcount;
	y = linestats [line].RXintcount;
	e = linestats [line].RXbadcount;
	z = linestats [line].msgxfercount;

        if (z == 0)
        {
            printf ("TX Interrupt Count    = %10d\n", x);
            printf ("RX Interrupt Count    = %10d\n", y);
            printf ("BadRX Intrpt Count    = %10d\n", e);
            printf (" ******  No Messages Transferred ****** \n");
            return;
        }

        if (t == 0)
        {
            printf (" ******  No Time Has Transpired ****** \n");
            return;
        }

 	printf ("\n");
	printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
 	printf ("\n");
 	printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
 	printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
 	printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
 	printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
        printf ("BadRX Intrpt Count    = %10d\n", e);
 	printf ("\n");
 	printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
 	printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
 	printf ("\n");
	printf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
	printf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
 	printf ("\n");
        return;
}

/*
/*      CLEARMSGCNTS
/*
/*      The purpose of this routine is to dump and clear the line level statistics
/*      for this driver.
/*
*/
/* called from TABLEINFO */

void CLEARMSGCNTS (unsigned short line)

{
        DUMPMSGCNTS (line);

	linestats [line].TXintcount = 0;
	linestats [line].RXintcount = 0;
	linestats [line].RXbadcount = 0;
	linestats [line].msgxfercount = 0;

        linestats [line].startingtick = tickGet ();
	printf (" ******  All Counts Cleared  ****** \n", linestats [line].msgxfercount);
 	printf ("\n");
        return;
}


/*
/*      DUMPPLCSTATS
/*
/*      The purpose of this routine is to dump the plc level statistics for this driver.  
/*
*/
/* called from TABLEINFO */

void DUMPPLCSTATS (unsigned short line, unsigned short maddr)
{
    MODPLC		*pmod;
    unsigned long   microsecs;

    pmod = plcs [line] [maddr];
    if (!pmod)
    {
        logMsg ("Line/ModbusAddress Not Defined \n");
        return;
    }

    printf (" Was requested = %d \n", pmod->was_requested);
    printf (" Is responding = %d \n", pmod->is_responding);
    printf (" Prog Load State = %d \n", pmod->prog_load_stat);
    printf (" Prog Load Page = %d \n",  pmod->prog_load_page);
    printf (" Prog Number = %d \n", pmod->prog_load_number);
    printf (" # Output messages = %d \n", pmod->no_dataout_msgs & 0x7fff);
    printf (" # Data in messages = %d \n", pmod->no_datain_msgs & 0x7fff);
    printf (" #No Rx Response = %d \n", pmod->no_rxnoresp & 0x7fff);
    printf (" #No Tx Responses = %d \n", pmod->no_txnoresp & 0x7fff);
    printf (" #Data Errors = %d \n", pmod->no_dataerr & 0x7fff);
    printf (" #Retries = %d \n", pmod->no_retries & 0x7fff);
    printf (" #Rx Hw Errors = %d \n", pmod->no_rxhwerrs & 0x7fff);
    printf (" #Tx Hw Errors = %d \n", pmod->no_txhwerrs & 0x7fff);
    printf (" #Crc Errors = %d \n", pmod->no_crcerrs & 0x7fff);
    printf (" #Off Lines = %d \n", pmod->no_offlines & 0x7fff);
    printf (" Reset Statistics = %d \n", pmod->cmd_reset_stat);
    printf (" Force Offline = %d \n", pmod->cmd_force_offline);
    printf (" #Failed Outputs = %d \n", pmod->badoutcnt & 0x7fff);



    /* North Wales Special: flag for downloading new id list. */
    printf ("\n");
    printf (" ID Download Pending Flag = %d \n", pmod->id_pending);

    printf ("\n");
    printf (" # of Messages %d \n", pmod->msgs);
    printf (" # Total response time (ticks) = %lu \n", pmod->responsetime);
    if (pmod->msgs)
    {
        printf ("   Average response time (ticks) = %d \n", (pmod->responsetime/pmod->msgs));
        microsecs = (16667*pmod->responsetime)/pmod->msgs;
        printf ("   Average response time (msec) = %d.%1d \n", microsecs/1000, (microsecs%1000)/100);
    }
    printf (" # of scan passes = %d \n", pmod->tscanpass);
    printf ("\n");

    printf (" Resource Responding = %d \n", resresponse[line]);
    printf (" Hold flag  = %d \n", pmod->holdflag );
    return;
}

/*
/*      CLEARPLCSTATS
/*
/*      The purpose of this routine is to clear the plc level statistics for this driver. 
/*
*/
/* called from TABLEINFO */

void CLEARPLCSTATS (unsigned short line, unsigned short maddr)

    {
	MODPLC		*pmod;

	pmod = plcs [line] [maddr];
	if (!pmod)
	{
	    logMsg ("Line/ModbusAddress Not Defined \n");
	    return;
	}

	initstats (pmod); /* use existing procedure */

        return;
    }


/*
/*      dump_mod_table                                                       	
/*                                                                           	
/*      The purpose of this routine is twofold:                                 
/*         1) dump the plc level statistics for the modbus driver.              
/*         2) dump the data for the specified modbus plc.                       
/*                                                                              
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line, unsigned short maddr)

    {
	MODPLC		*pmod;
	short           ix;
	unsigned	short	i, n, j; 

	MODCOILS	*coilptr;
	MODDIS		*diptr;
	REGISTERS	*regptr;
	MODAIS		*aiptr;
	unsigned	short req, val, value, addr, firstaiinblk, firstreginblk, linecnt;
	unsigned	long	bigvalue;
	unsigned	char	buffer [200];


	pmod = plcs [line] [maddr];
	if (!pmod)
	{
	    logMsg("Line/ModbusAddress Not Defined \n");
	    return;
	}

        /* previously integral code moved to seperate procedure for debugging convenience */
        DUMPPLCSTATS (line, maddr);

	linecnt = 1;
	printcoilhdr (buffer, linecnt);
	addr = 1;
	for (i = 0; i < (MAXCOILNO / 8); i += 4)
	{
	    printf("  %4d    ", addr);
	    for (n = 0; n < 4; n++)
	    {		
		coilptr = &pmod->coils[i+n];
		printf("%1x,%1x,  %1x,      0x%2x,\t",
                          coilptr->init_writeflag,
                          coilptr->was_requested,
                          coilptr->data_valid,
                          coilptr->last_read);
	    }
	    printf ("\n");
	    linecnt += 1;
	    if ( (linecnt >= 17) && ((i + 4)  < (MAXCOILNO /8)) )
	    {
		linecnt = 1;
		printcoilhdr(buffer, linecnt);
	    }
	    addr += 32;		
	}

	linecnt = 1;
	printdihdr (buffer, linecnt);
	addr = 1;
	for (i = 0; i < (MAXDINO / 8); i += 4)
	{
	    printf ("  %4d    ", addr);
	    for (n = 0; n < 4; n++)
	    {		
 		diptr = &pmod->dis[i+n];
		printf("%1x,  %1x,         %lx,\t",
                           diptr->was_requested,
                           diptr->data_valid,
                           diptr->last_read);
	    }
	    printf ("\n");
	    linecnt += 1;
	    if ((linecnt >= 17) && ((i + 4)  < (MAXDINO / 8)) )
	    {
		linecnt = 1;
		printdihdr (buffer, linecnt);
	    }
	    addr += 32;		
	}


	linecnt = 1;
	printaihdr(buffer, linecnt);
	addr = 1;
	for (i = 0; i < MAXAINO; i += 8)
	{

	    printf ("  %4d\t", addr);
				   
	    for (n = 0; n < 2; n++ )
	    {		
		aiptr = &pmod->ais [(i / 4) + n];
		printf ("\t%1x, %1x,\t", aiptr->was_requested, aiptr->data_valid);
		for (j = 0; j < 4; j++)
		{
		    printf("%6d,\t",  aiptr->aivals[j]);
		}
	    }
	    printf("\n");
	    linecnt += 1;
	    if ((linecnt >= 17) && ((i + 8)  < NUMMODAIS) )
	    {
		linecnt = 1;
		printaihdr (buffer, linecnt);
	    }
	    addr += 8;		
	}

	linecnt = 1;
	printreghdr (buffer, linecnt);
	addr = 1;
	for (i = 0; i < MAXREGNO; i += 8)
	{
	    printf("  %4d\t", addr);

	    for (n = 0; n < 2; n++)
	    {		
		regptr = &pmod->regs[(i/4)+n];
		printf("\t%1x, %1x,\t", regptr->was_requested, regptr->data_valid);
		for (j = 0; j < 4; j++)
		{
		    printf("%6d,\t",regptr->ioregs[j]);
		}
	    }
	    printf ("\n");
	    linecnt += 1;
	    if ((linecnt >= 17) && ((i + 8)  < NUMREGISTERS) )
	    {
		linecnt = 1;
		printreghdr (buffer, linecnt);
	    }
	    addr += 8;		
	}
}

/*
/* only called from nwmodtable 
*/


static void printcoilhdr (unsigned char *buffer, unsigned short cnt)
{	
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                                    PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
        sprintf (buffer,"                                                   MODBUS COILS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
        sprintf (buffer,
               "          I R   V      Value\tI R   V      Value\tI R   V      Value\tI R   V      Value");
 	printf ( "%s\n", buffer);
 	cnt += 1;
}
/*
/* only called from nwmodtable
*/


static void printdihdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                                    PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
        sprintf (buffer,"                                              MODBUS DIGITAL INPUTS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
        sprintf (buffer,
                "          R   V      Value\tR   V      Value\tR   V      Value\tR   V      Value");
	printf ( "%s\n", buffer);
 	cnt += 1;
}
/*
/* only called from nwmodtable
*/


static void printaihdr(unsigned char *buffer, unsigned short cnt)
{
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                               PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
       sprintf (buffer,"                                            MODBUS ANALOG INPUTS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
       sprintf (buffer,"\t\tR  V\tValue\tValue\tValue\tValue\t\tR  V\tValue\tValue\tValue\tValue");
 	printf ( "%s\n", buffer);
 	cnt += 1;
}

/*
/* only called from nwmodtable
*/


static void printreghdr (unsigned char *buffer, unsigned short cnt)
{
	taskDelay (120);
	printf ("\n");
	sprintf (buffer,"                                               PLC REPORT         ");
	printf ( "%s\n", buffer);
	cnt += 1;
	printf ("\n");
	cnt += 1;
       sprintf (buffer,"                                             MODBUS REGISTERS        ");
	printf ( "%s\n", buffer);
	cnt += 1;
       sprintf (buffer,"\t\tR  V\tValue\tValue\tValue\tValue\t\tR  V\tValue\tValue\tValue\tValue");
 	printf ( "%s\n", buffer);
 	cnt += 1;

}
/*                                                               		
**                                                                	 	
**	The purpose of this routine is to display the contents            	
**	of the static variables contained within this driver.             	
**                                                                        	
*/

/* this routine not called from within this driver */


LINEINFO ()
{
	short	i;
	char	buffer [132];
	char	*resrsp;
	char	*lineact;


        printf ("                                 Modbus Line Information Table          \n");
        printf ("\n");
        printf (" Line        Pointer to        Resource      Resource");
        printf ("       Line        Delay Times:       Activity\n");
        printf ("Number      MODPLC Table         Name        Response");
        printf ("     Activity      IM  .TX  TX.         Time\n");
	printf ("\n");

	for (i = 0; i < MODLINES; i++)
	{
	    if(plcs [i] == NULL)
	    {
		continue;
	    }
	    if (resresponse [i] == 0)
	    {
		resrsp = "FALSE";
	    }
	    else
	    {
		resrsp = "TRUE";
	    }
	    if (line_activity [i] == 0)
	    {
		lineact = "FALSE";
	    }
	    else
	    {
		lineact = "TRUE";
	    }
	    sprintf (buffer,
                       "  %2d         %4x   %16s        %5s        %5s        %2d   %2d   %2d        %4d\n",
			i,plcs[i],&resnames[i],
			&resrsp[0],
			&lineact[0],
			intermsgdelay[i],
			pretxdelay[i],
			posttxdelay[i],
			activity_time[i]);
	    printf ( "%s\n", buffer);
	}
	return 0;
}

/*	End of File:	drvmodbus.c */
