/*drvTrane.c,v 1.1.1.1 1999/08/03 14:45:08 tis4000 Exp */

/****************************************************************/
/*								*/
/*	This software is the proprietary property of Tate	*/
/*	Integrated Systems, L.P.  Patents and copyrights are	*/
/*	pending.						*/
/*								*/
/*	This software is furnished under a license and may	*/
/*	be used and copied only in accordance with the terms	*/
/*	of such license and with the inclusion of the above	*/
/*	notice. This software or any other copies thereof	*/
/*	may not be provided or otherwise made available to	*/
/*	any other person. No title to and ownership of the	*/
/*	software is hereby transferred.				*/
/*								*/
/*	The information in this software is subject to		*/
/*	change without notice and should not be construed 	*/
/*	as a commitment by Tate Integrated Systems L.P. or	*/
/*	its third party suppliers.				*/
/*								*/
/*	Tate Integrated Systems, L.P. (TIS) and its third	*/
/*	party suppliers assume no responsibility for the	*/
/*	use or inability to use any of its software. TIS	*/
/*	software is provided "as is" without warranty of	*/
/*	any kind and TIS expressly disclaims all implied	*/
/*	warranties, including but not limited to the implied	*/
/*	warranties of merchantability and fitness for a		*/
/*	particular purpose.					*/
/*								*/
/*	Notice: Notwithstanding any other lease or license	*/
/*	that may pertain to or accompany the delivery of this	*/
/*	computer software, the rights of the Government		*/
/*	regarding its use, reproduction, and disclosure are	*/
/*	as set forth in Section 52.227-19 of the FARS		*/
/*	Computer Software-Restricted Rights clause.		*/
/*								*/
/****************************************************************/
/*
**  File: drvTrane.c
**  Edit:  6/28/94      WEP: created                                                                  
**                         :                                                                          
** 12/16/94             WEP: fixed response reject error debug message bug. [s] vs [%s]               
** 12/23/94             WEP: initialized pstatewait to 60 seconds                                     
** 01/10/95             WEP: fixed bug in 'readbinaryoutputs' et al. re-init tsmp->state on loop.     
** 01/11/95             WEP: implemented calls to watchdog timer logic in platform.                   
** 01/17/95             WEP: define watchdog timeout constant.                                        
** 02/02/95             WEP: created conditionally compiled FAKEWATCHDOG logic so that this driver,   
**                         : having already been modified to run with the watchdog timer in iocCore,  
**                         : can be easily modified to fakeout the calls to the watchdog functions,   
                           : and thus run with the current (non-watchdog) version of iocCore in t43.  
** 02/08/95             WEP: added taskDelay(1) to launch_read & launch write (reduce cpu drain)      
** 02/13/95             WEP: clarified and made conditional the illegal lstate message.               
** 02/13/95             WEP: corrected pstatewait logic.                                              
** 04/20/95             WEP: enable real watchdog logic.                                              
** 05/22/95             WEP: modified master loop logic to exit when local state is not               
**                         : master. This causes lockstep logic to function correctly.                
**                         : test for and conditionally display an illegal lstate message.            
**
*/                                                                                                                      

#define  MAIN        trane_driver           /* NOTE: change here */
#define  AIDRIVER    trane_aidriver         /* NOTE: change here */
#define  AODRIVER    trane_aodriver         /* NOTE: change here */
#define  AOREAD      trane_aoread           /* NOTE: change here */
#define  BIDRIVER    trane_bidriver         /* NOTE: change here */
#define  BODRIVER    trane_bodriver         /* NOTE: change here */
#define  BOREAD      trane_boread           /* NOTE: change here */

#define  TRAFFICON   tranetrafficon         /* NOTE: change here */
#define  TRAFFICOFF  tranetrafficoff        /* NOTE: change here */
#define  TRACEON     tranetraceon           /* NOTE: change here */
#define  TRACEOFF    tranetraceoff          /* NOTE: change here */
#define  RTRACELEVEL tranerestrlv           /* NOTE: change here */
#define  RTRACEON    tranerestraceon        /* NOTE: change here */
#define  RTRACEOFF   tranerestraceoff       /* NOTE: change here */
#define  TRACELEVEL  tranetrlv              /* NOTE: change here */

#define  STOPDRIVER  stoptrane              /* NOTE: change here */
#define  STARTDRIVER starttrane             /* NOTE: change here */
#define  SETCOMM     tranecomm              /* NOTE: change here */
#define  TABLEINFO   tranetable             /* NOTE: change here */
#define  LINEINFO    traneline              /* NOTE: change here */
#define  HELP        tranehelp

#include <ctype.h>

#include <vxWorks.h>
#include <sysLib.h>
#include <semLib.h>
#include <wdLib.h>
#include <rngLib.h>
#include <task_params.h>
#include <stdioLib.h>
#include <tickLib.h>
#include <string.h>

#include <dbDefs.h>
#include <drvSup.h>
/*#include <module_types.h>*/
#include <drvTrane.h>			  /* NOTE: change here */
#include <drvTrane_proto.h> 		  /* NOTE: change here */
#include <restable.h>


/* static long	init(); */

struct	{
		long		number;
		DRVSUPFUN	report;
		DRVSUPFUN	init;
	}
	drvTrane={ 2, NULL, init};


/*******************************************************************/
/*******************************************************************/
/*******************************************************************/

/* #define FAKEWATCHDOG 1 */

#ifdef FAKEWATCHDOG
int  tisWatchDogAttach(int task_id, short interval, short *wdId);
int  tisWatchDogPulse(short wdId);
int  tisWatchDogDetach(int task_id);

int  tisWatchDogAttach(int task_id, short interval, short *wdId)
{
    *wdId = 1;
    return(OK);
}

int  tisWatchDogPulse(short wdId)
{
    return(OK);
}

int  tisWatchDogDetach(int task_id)
{
    return(OK);
}
#endif
/*******************************************************************/
/*******************************************************************/
/*******************************************************************/


/***********************************************************************/
/*      External Line Level Data Structures (declared in drvcommon.c)  */
/***********************************************************************/

extern	unsigned char	resnames[BCULINES][RESNAMELEN];	/* array of resource name strings.            */

extern	RES_TABLE	*prestable[BCULINES];		/* array of pointers to resource tables       */

extern	unsigned short	resresponse[BCULINES];		/* array of resource response flags. 	      */
							/* False=not active resource(slave),	      */
							/* True= active resource(master)              */

extern	unsigned short	line_activity[BCULINES];	/* true/false line active flag. calculated    */
							/* using activity_time below. 	              */
extern	unsigned short	lastactivity[BCULINES];		/* assigned value of line_activity prior to   */
							/* it's recalculation.                        */

extern	unsigned short	modtrace[BCULINES];           /* controls output of communication error log   */
						      /* messages (true/false)                        */
extern	unsigned short	mltrace[BCULINES];	      /* controls output of certain resource related  */
						      /* log messages (level)                         */
extern	unsigned short	modrestrace[BCULINES];	      /* controls output of MASTER/SLAVE arbitration  */
						      /* log messages (level)                         */

extern	SEM_ID		semids[BCULINES][2];          /* 'new' semaphore logic. the old SEMAPHORE is  */
                                                      /* still used.                                  */

extern	unsigned short	intermsgdelay[BCULINES];      /* holds value passed in task spawn. used for   */
                                                      /* each msgxfer attempt                         */
extern	unsigned short	pretxdelay[BCULINES];         /* holds post RTS delay before TX.              */
extern	unsigned short	posttxdelay[BCULINES];        /* holds post TX delay before dropping RTS.     */

extern	long		activity_time[BCULINES];      /* holds timetick of last activity. used to     */
                                                      /* set line_activity flag                       */

extern  SEM_ID		linemux[BCULINES];            /* 1/03/94: mutual-exclusion semaphore for      */
                                                      /* shared resource of the data link             */
                                                      /* controls access to common path shared by     */
                                                      /* data and diagnostic channels.                */
                                                      /* originally designed for use with MDS remote  */
                                                      /* radio diagnostics.                           */

extern  unsigned short  halfduplex[BCULINES];         /* store half/full duplex line status           */

extern  unsigned short  pstatewait[BCULINES];         /* holds max time in seconds that driver will   */
                                                      /* wait to obtain partner state on first        */
                                                      /* attempting to decide if it should be master. */


/*******************************************************/
/*      Storage for BCU Comm Line Structures           */
/*******************************************************/

static TX_FRAME          *txlinetab[BCULINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL}  ; /* array of pointers to dynamically         */
                                                          /* allocated comm controls/buffers          */
static RX_FRAME          *rxlinetab[BCULINES] =
			{NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL,
			 NULL, NULL, NULL, NULL, NULL}  ; /* array of pointers to dynamically         */
                                                          /* allocated comm controls/buffers          */

/*****************************************/
/*      Storage for BCU Data Structures  */
/*****************************************/

static unsigned char initstring[] = {'B','A','C','n','e','t', CR, 0};

static unsigned char    sourceNET[BCULINES][2];       /* holds TIS Half-Router's BACnet Network #.    */
static unsigned char    destinationNET[BCULINES][2];  /* holds Trane Half-Router's BACnet Network #.  */

static unsigned char    sourceMAC[BCULINES];          /* holds TIS Half-Router's BACnet MAC address.  */
static unsigned char    destinationMAC[BCULINES];     /* holds Trane Half-Router's BACnet MAC address.*/

static unsigned char    InvokeID[BCULINES];           /* holds next invoke ID value to be used.       */

static BCU		*bcus[BCULINES];              /* one dimensional array of pointers to the     */
                                                      /* fixed length dynamically allocated BCU       */
                                                      /* control and data structures.                 */

static	unsigned short	trace[BCULINES];	      /* controls output of system error messages:    */
                                                      /* bit mapped controls                          */

static	unsigned short	skip[BCULINES];               /* selective disable for 4 scan routines.       */
                                                      /* 0=skip none; 1=ao, 2=ai, 4=bo, 8=bi, 16=outs */

static OUTPUTQUE	*oq[BCULINES];                /* array of ptrs to the line output queues and  */
                                                      /* their control structures                     */

static RXRAWQUE         *rxrawq[BCULINES];            /* array of ptrs to the raw rx input queues and */
                                                      /* their control structures                     */

static  unsigned short  options[BCULINES];            /* store half/full duplex line status           */

static  unsigned short  rxsave[BCULINES];             /* 0 = do not buffer rx input. 0 != buffer it.  */
  
static char    *bools[] = {
	"TRUE ",
	"FALSE"
    };
static int		taskId [BCULINES];
static short        watchdogId [BCULINES];


static char *tasknames[] = {"TRANE Ch0","TRANE Ch1","TRANE Ch2","TRANE Ch3",
                            "TRANE Ch4","TRANE Ch5","TRANE Ch6","TRANE Ch7",
                            "TRANE Ch8","TRANE Ch9","TRANE Ch10","TRANE Ch11",
                            "TRANE Ch12","TRANE Ch13","TRANE Ch14",
                            "TRANE Ch15","TRANE Ch16","TRANE Ch17",
                            "TRANE Ch18","TRANE Ch19","TRANE Ch20"
			    };


/**********
*
*	This routine is required by iocinit in the EPICS system.
*
**********/
static long init ()
    {
	return (0);
    }
/********
**
**	This routine outputs information to help with debugging.
**
********/
void HELP (void)
{
    printf (" Trane Driver Control & Display Functions \n");
    printf ("\n");
    printf (" tranecomm(N,t1)       Set communication timing parameters for line N as follows:  \n");
    printf ("                         t1: intermessage delay (in ticks).                        \n");
    printf ("\n");
    printf (" tranetrafficon(N)     Enable traffic tracing for all plc addresses                \n");
    printf ("                         and all modbus functions on line N.                       \n");
    printf (" tranetrafficoff(N)    Disable all traffic tracing on line N.                      \n");
    printf (" tranetraceon(N)       Enable the following debug messages for line N:             \n");
    printf ("                         1) All configuration errors in driver calls.              \n");
    printf ("                         2) All runtime errors in driver calls.                    \n");
    printf ("                         3) All non-error rejections of driver calls.              \n");
    printf ("                         4) All communication errors encountered in msgxfer.       \n");
    printf (" tranetraceoff(N)      Disable all of the tranetraceon debug messages for line N.  \n");
    printf ("\n");
    printf (" tranecontraceon(N)    Enable display of configuration errors in driver calls.     \n");
    printf ("                         1) Invalid line.                                          \n");
    printf ("                         2) Invalid adapter.                                       \n");
    printf ("                         3) Invalid card.                                          \n");
    printf ("                         4) Invalid signal.                                        \n");
    printf ("                         5) Invalid conversion type.                               \n");
    printf (" tranecontraceoff(N)   Disable display of configuration errors in driver calls.    \n");
    printf ("\n");

    taskDelay(1*60); /* Time for operator to see it and pause the output */

    printf (" traneruntraceon(N)    Enable display of runtime errors in driver calls.           \n");
    printf ("                         1) Output Queue Overflow.                                 \n");
    printf (" traneruntraceoff(N)   Disable display of runtime errors in driver calls.          \n");
    printf ("\n");
    printf (" tranerejecttraceon(N) Enable display of non-error rejections of driver calls.     \n");
    printf ("                         1) Driver offline.                                        \n");
    printf ("                         2) Driver forced offline.                                 \n");
    printf ("                         3) Driver on hold.                                        \n");
    printf ("                         4) Device not responding.                                 \n");
    printf ("                         5) Data not valid.                                        \n");
    printf (" tranerejecttraceoff(N)Disable display of configuration errors in driver calls.    \n");
    printf ("\n");
    printf (" traneapplicationon(N) Enable display of BACnet application level errors.          \n");
    printf (" tranenetworkon(N)     Enable display of BACnet network level errors.              \n");
    printf (" tranedatalinkon(N)    Enable display of BACnet data link level errors.            \n");
    printf (" tranedebugon(N)       Enable display of BACnet errors.                            \n");
    printf (" tranedebugoff(N)      Disable display of BACnet errors.                           \n");
    printf (" traneallon(N)         Enable display of all BACnet errors and all traffic trace.  \n");
    printf (" tranealloff(N)        Disable display of all BACnet errors and all traffic trace. \n");
    printf ("\n");

    taskDelay(1*60); /* Time for operator to see it and pause the output */

    printf (" traneapplicationon(N) Enable display of BACnet application level errors.          \n");
    printf (" tranenetworkon(N)     Enable display of BACnet network level errors.              \n");
    printf (" tranedatalinkon(N)    Enable display of BACnet data link level errors.            \n");
    printf (" tranedebugon(N)       Enable display of BACnet errors.                            \n");
    printf (" tranedebugoff(N)      Disable display of BACnet errors.                           \n");
    printf ("\n");
    printf (" traneallon(N)         Enable display of all BACnet errors and all traffic trace.  \n");
    printf (" tranealloff(N)        Disable display of all BACnet errors and all traffic trace. \n");
    printf (" traneskipai(N)        Cause scanning of AI points to be skipped.                  \n");
    printf (" traneskipao(N)        Cause scanning of AO points to be skipped.                  \n");
    printf (" traneskipbi(N)        Cause scanning of BI points to be skipped.                  \n");
    printf (" traneskipbo(N)        Cause scanning of BO points to be skipped.                  \n");
    printf (" traneskipout(N)       Cause checking of output queue to be skipped.               \n");
    printf (" tranedoai(N)          Cause scanning of AI points to be done.                     \n");
    printf (" tranedoao(N)          Cause scanning of AO points to be done.                     \n");
    printf (" tranedobi(N)          Cause scanning of BI points to be done.                     \n");
    printf (" tranedobo(N)          Cause scanning of BO points to be done.                     \n");
    printf (" tranedoout(N)         Cause checking of output queue to be skipped.               \n");
    printf (" tranedobo(N)          Cause scanning of AI,AO,BI,BO points, and outputqueue.      \n");
    printf ("\n");

    taskDelay(1*60); /* Time for operator to see it and pause the output */

    printf (" tranetrlv(N,X)        Enable the following message for line N:                    \n");
    printf ("                         if X=0, display none of the messages below.               \n");
    printf ("                            X=1,                                                   \n");
    printf ("                                1) resource definition error in MAIN.              \n");
    printf ("                                2) attempts to bring the BCU online.               \n");
    printf ("                                3) output queue full.                              \n");
    printf ("                            X=2, Scan Loop phase tracing.                          \n");
    printf ("                            X=3, SubScan Loop phase tracing.                       \n");
    printf ("                            X=4, AO queue, process, and dequeue actions.           \n");
    printf ("                            X=5, BO queue, process, and dequeue actions.           \n");
    printf ("                            X=6, AI read results.                                  \n");
    printf ("                            X=7, AO read results.                                  \n");
    printf ("                            X=8, BI read results.                                  \n");
    printf ("                            X=9, BO read results.                                  \n");
    printf ("                            X=10 to 254,  reserved.                                \n");
    printf (" tranerestrlv(N,X)     Enable display of detailed resource state logic in MAIN.(2) \n");
    printf (" tranerestraceon(N)    Enable display of master/slave/etc state changes in MAIN.   \n");
    printf (" tranerestraceoff(N)   Disable display of master/slave/etc state changes in MAIN.  \n");
    printf ("\n");
    printf (" dumptranestats(N)     Display line N communication statistics.                    \n");
    printf (" cleartranestats(N)    Display and clear line N communication statistics.          \n");
    printf (" tranetable(N)         Display line N xfers, status, errors and input data.        \n");
    printf (" tranetools(N)         Display state of variables set by above commands.          \n");
}

/********
**
**	This routine enables logging of comm trace messages
**
********/
void TRACEON (unsigned short line)
    {
	modtrace[line] = TRUE;
    }

/********
**
**	This routine disables logging of comm trace messages
**
********/
void TRACEOFF (unsigned short line)
    {
	modtrace[line] = FALSE;
    }

/********
**
**	This routine enables detailed display of normal communications traffic
**
********/
void TRAFFICON (unsigned short line)
    {
	trace[line] = trace[line] | ALLTRAFFICTRACE;
    }

/********
**
**	This routine disables detailed display of normal communications traffic
**
********/
void TRAFFICOFF (unsigned short line)
    {
	trace[line] = trace[line] & ~ALLTRAFFICTRACE;
    }

void tranecontraceon (unsigned short line)
    {
	trace[line] = trace[line] | CONFIGURATIONTRACE;
    }
void tranecontraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~CONFIGURATIONTRACE;
    }
void traneruntraceon (unsigned short line)
    {
	trace[line] = trace[line] | RUNTIMEERRORTRACE;
    }
void traneruntraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~RUNTIMEERRORTRACE;
    }
void tranerejecttraceon (unsigned short line)
    {
	trace[line] = trace[line] | CALLREJECTTRACE;
    }
void tranerejecttraceoff (unsigned short line)
    {
	trace[line] = trace[line] & ~CALLREJECTTRACE;
    }

/********
**
**	This routine enables detailed display of all levels of BACnet info
**
********/
void tranedebugon (unsigned short line)
    {
	trace[line] = trace[line] |
          DATALINKTRACE |
          NETWORKTRACE |
          APPLICATIONTRACE;
    }

/********
**
**	This routine disables detailed display of all levels of BACnet info
**
********/
void tranedebugoff (unsigned short line)
    {
	trace[line] = trace[line] &
         ~DATALINKTRACE &
         ~NETWORKTRACE &
         ~APPLICATIONTRACE;
    }

/********
**
**	This routine enables detailed display of all levels of BACnet info
**
********/
void traneallon (unsigned short line)
    {
	trace[line] = trace[line] |
          ALLTRAFFICTRACE |
          DATALINKTRACE |
          NETWORKTRACE |
          APPLICATIONTRACE;
    }

void traneaapplicationon (unsigned short line)
    {
	trace[line] = trace[line] |
          APPLICATIONTRACE;
    }

void tranenetworkon (unsigned short line)
    {
	trace[line] = trace[line] |
          NETWORKTRACE;
    }

void tranedatalinkon (unsigned short line)
    {
	trace[line] = trace[line] |
          DATALINKTRACE;
    }

/********
**
**	This routine disables detailed display of all levels of BACnet info
**
********/
void tranealloff (unsigned short line)
    {
	trace[line] = trace[line] &
         ~ALLTRAFFICTRACE &
         ~DATALINKTRACE &
         ~NETWORKTRACE &
         ~APPLICATIONTRACE;
    }

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACELEVEL (unsigned short line, unsigned short level)
    {
	modrestrace[line] = level;
    }

/********
**
**	This routine enables logging of resource trace messages
**
********/
void RTRACEON (unsigned short line)
    {
	modrestrace[line] = 1;
    }

/********
**
**	This routine disables logging of resource trace messages
**
********/
void RTRACEOFF (unsigned short line)
    {
	modrestrace[line] = 0;
    }

/********
**
**	This routine controls logging of trace messages
**
********/
void TRACELEVEL (unsigned short line, unsigned short level)
    {
	mltrace[line] = level;
    }


void traneskipao (unsigned short line)
    {
	skip[line] = skip[line] | SKIPAO;
    }
void traneskipai (unsigned short line)
    {
	skip[line] = skip[line] | SKIPAI;
    }
void traneskipbo (unsigned short line)
    {
	skip[line] = skip[line] | SKIPBO;
    }
void traneskipbi (unsigned short line)
    {
	skip[line] = skip[line] | SKIPBI;
    }
void traneskipout (unsigned short line)
    {
	skip[line] = skip[line] | SKIPOUT;
    }

void tranedoao (unsigned short line)
    {
	skip[line] = skip[line] & ~SKIPAO;
    }
void tranedoai (unsigned short line)
    {
	skip[line] = skip[line] & ~SKIPAI;
    }
void tranedobo (unsigned short line)
    {
	skip[line] = skip[line] & ~SKIPBO;
    }
void tranedobi (unsigned short line)
    {
	skip[line] = skip[line] & ~SKIPBI;
    }
void tranedoout (unsigned short line)
    {
	skip[line] = skip[line] & ~SKIPOUT;
    }
void tranedoall (unsigned short line)
    {
	skip[line] = 0;
    }

void tranetools (unsigned short line)
{
        printf("modtrace[%d]    = 0x%x\n", line, modtrace[line]);
        printf("mltrace[%d]     = 0x%x\n", line, mltrace[line]);
        printf("modrestrace[%d] = 0x%x\n", line, modrestrace[line]);
        printf("trace[%d]       = 0x%x\n", line, trace[line]);
        printf("skip[%d]        = 0x%x\n", line, skip[line]);
}

int STOPDRIVER (short ln)
{
	if (comm_disconnect (ln) != -1)
	{
            /* if watchdog timer has been attached, detach it before deleting the task */
            if (taskId[ln])
            {
                tisWatchDogDetach(taskId[ln]);
            }
	    taskDelete (taskId [ln]);
	    return (1);
	}
	else
	{
	    return (-1);
	}
}

int STARTDRIVER  (unsigned short line,       /* the line number of this driver.                 */
                  char *mode,                /* UART initializations string.                    */
                  unsigned short delay,      /* intermessage delay value, expressed in ticks.   */
                  unsigned char driver_net,  /* unique value used to identify both the local    */
                                             /* driver's BACnet network number and its local    */
                                             /* MAC address on this same network.               */
                  unsigned char BCU_net)     /* unique value, configured in the BCU, which is   */
                                             /* used to identify both the BCU's BACnet network  */
                                             /* number and its local MAC address.               */
{
	if (line < BCULINES)
	{
	    taskId [line] = taskSpawn (tasknames[line],
                                     BCU_PRIORITY,
                                     BCU_TASK_OPTIONS,
                                     BCU_STACK,
                                     MAIN,
                                     line,
                                     mode,
                                     delay,
                                     driver_net,
                                     BCU_net);

	    logMsg("\nStarted Trane BCU driver on line %d, with Driver NET = %d, and BCU NET = %d.\n\n",
                     line, driver_net, BCU_net);
	    return (1);
	}
	else
	{
	    logMsg ("Invalid line number %d\n", line);
	    return (-1);
	}
}

/********
**
** Set communication logic time delays to handle half/full duplex, radio delays, etc */ 
/*
********/
void SETCOMM (unsigned short line,
              unsigned short tickcount1)
    {
	intermsgdelay[line] = tickcount1;  /* at beginning new message/response sequence. */
    }
/*
**      bcu_driver                                                                      
**                                                                                     	
**      The purpose of this task is to scan the Trane BCU                       	
**      lines. It will maintain a configuration list supporting online additions       	
**      and replacement of modules, and maintain a table of most recently              	
**      scanned values.                                                                	
**                                                                                     	
*/                                                                                     	
/* not called from within this driver 						      */

void MAIN (unsigned short line,
           unsigned char *mode,
           unsigned short delay,
           unsigned char driver_net,  /* unique value used to identify both the local    */
                                      /* driver's BACnet network number and its local    */
                                      /* MAC address on this same network.               */
           unsigned char BCU_net)     /* unique value, configured in the BCU, which is   */
                                      /* used to identify both the BCU's BACnet network  */
                                      /* number and its local MAC address.               */
    {
	unsigned short  cfgchk;
	unsigned short  activity, pstate, lstate, execute, command, i;
	         long   this_time, last_time;
                 int    temp;

	BCU            *pbcu;

                 short *ptable_id;


/* Initialize the data structures */

	intermsgdelay[line] = delay;

	halfduplex[line]  = 0;      /* not specified on the command line. set to zero. */
	pretxdelay[line]  = 0;
	posttxdelay[line] = 0;

        /* Trane currently uses the same value (range: 0 to 255) for both the network and MAC  */
        /* address. We will do the same. Both values are specified on the driver call, and are */
        /* not subject to change during the life of the driver task. We will NOT use the WHOIS */
        /* command to establish the Trane Chiller's network and MAC address.                   */

        sourceNET[line][0] = 0;
        sourceNET[line][1] = driver_net;
        sourceMAC[line]    = driver_net;

        destinationNET[line][0] = 0;
        destinationNET[line][1] = BCU_net;
        destinationMAC[line]    = BCU_net;

	resresponse[line] = FALSE;
	resnames[line][0] = 0;
	prestable[line] = NULL;

	modtrace[line]    = FALSE;
	mltrace[line]     = 0;
	modrestrace[line] = 1;
        trace[line]       = 0;


/* debug tracing stuff. turn off for released driver version. */
/*        tranedebugon(line);       ** trace all BACnet errors */
/*        tranedoall(line);
**        tranecontraceon(line);    ** trace all database configuration errors */
/*        traneruntraceon(line);    ** trace all runtime driver call errors (outqueue overflow) */
/*        tranerestrlv(line,2);     ** detailed resource switch tracing. */

	activity_time[line] = tickGet ();
	lastactivity[line] = line_activity[line] = FALSE;

        pstatewait[line] = 60;

        /* output queue initialization */
	oq[line] = (OUTPUTQUE *)calloc(1,(sizeof(OUTPUTQUE)));
	if (!oq[line])
	{
	    logMsg ("Not enough memory for line %d data structure (data output queue)\n",line);
	    return;
	}
        outqueinit (line);

        /* communication initialization: Raw RX Queue */
	rxrawq[line] = (RXRAWQUE *)calloc(1,(sizeof(RXRAWQUE)));
	if (!rxrawq[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: raw RX queue)\n",line);
	    return;
	}
        rxrawqueinit (line);

        /* communication initialization: RX Buffer */
	rxlinetab[line] = (RX_FRAME *)calloc(1,(sizeof(RX_FRAME)));
	if (!rxlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: rx)\n",line);
	    return;
	}

        /* communication initialization: TX Buffer */
	txlinetab[line] = (TX_FRAME *)calloc(1,(sizeof(TX_FRAME)));
	if (!txlinetab[line])
	{
	    logMsg ("Not enough memory for line %d data structure (comm: tx)\n",line);
	    return;
	}

        bcus[line] = NULLP;

        /* all other structures will be allocated per BCU, of which there is only one per line. */
	if (bcus[line] == NULLP)
	{
            pbcu = (BCU *)calloc(1,(sizeof(BCU)));
            if (!pbcu)
            {
                logMsg ("Not enough memory for line %d BCU data structure \n",line);
                return;
            }
            /* only initialize these now if not already initialized by driver call. */
            init_bcu_tab(line, pbcu);	     /*	initialize the data structures. */
            bcus[line] = pbcu;
        }

        /*******************************************/
        /* Initialize communications hardware.     */
        /*******************************************/

        taskLock();  /* make terminal display easier to read - avoids interleaving of other task data */
	comm_init (line, mode, &tx_int_proc, &rx_int_proc);
	clear_rts (line);
        taskUnlock();

        /*******************************************/
        /*  Initialize RX interrupts. (forever)    */
        /*******************************************/

	/* Initialize the Rx Input Buffer to receive data */
	start_rx(line);

	/* Initialize the Rx interrupts to receive for activity check */
	/* enable the receiver interrupt after set to ignore */
	enable_rx_ints(line);
        /* don't bother to save the input. */
        rxsave[line] = FALSE;


/*                                                                                                      
** 1/03/94:                                                                                             
**         initialize mutual-exclusion semaphore logic for diagnostic driver path sharing. The Take/Put 
**         logic implemented below is designed to insure, under heavy diagnostic demand, that scan_bcu	
**         and the on_line while routine are executed once for every two diagnostic Take/Put sequences. 
**         Furthermore, diagnostic activities are suspended during master/slave arbitration by Taking  	
**         the semaphore while the local state is not the master state.                                	
**
*/   
        taskLock();
	linemux[line]=semMCreate (SEM_Q_PRIORITY); /* default: semaphore initializes as 'full',       */
                                                   /* ready to be Taken.                              */
	if (!linemux[line])
	{
	    logMsg ("Not enough memory for line %d data structure (mutual-exclusion semaphore)\n",line);
            taskUnlock();
	    return;
        }

        if ((semTake(linemux[line], MUXTIMEOUT)) == ERROR)
        {
	      logMsg ("BCU: Mutual-Exclusion Semaphore Timeout on Line\n",line);
              taskDelay(300);
	}

        taskUnlock();
	taskDelay(120);/* short delay for diagnostic readability */

	/* Wait for resource to be defined via an initial call to 'register_resource' via driver call.*/
	while ( (resnames[line][0] == 0) || (prestable[line] == NULL) )
	{
	    if (mltrace[line] == 1)
	    	logMsg ( "No Resource Defined for line - %d \n", line);
	    taskDelay (600);
	}

        /**********************************************************************/
        /* attach this driver task to the watchdog timer monitoring function. */
        /**********************************************************************/
        ptable_id = &watchdogId[line];
        if (tisWatchDogAttach(taskId[line], WATCHDOGTIMEOUT, ptable_id) != OK)
        {
            logMsg("Attempt at watchdog attachment failed.\n");
            tisWatchDogDetach(taskId[line]);
            return;
        }
        if (tisWatchDogPulse(watchdogId[line]) != OK)
        {
            logMsg("First attempt at watchdog pulsing failed.\n");
            tisWatchDogDetach(taskId[line]);
            return;
        }
        /**********************************************************************/
        /**********************************************************************/
        /**********************************************************************/


        /**********************/
	/* Start out as slave */

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

	resClearCaAnswer(prestable[line]);		/* start quiet */
	resPutLocalState(prestable[line], RES_SLV);
	if (modrestrace[line])
		logMsg ("1] Initialized as RES_SLV \n");

        /* wait finite time for pstate to be resolved */
        logMsg ("Begin wait for pstate [%d] to become valid.\n", pstatewait [line]);
        for (i=0; i <= pstatewait[line]; i++)
        {
            resGetStates(prestable[line], &lstate, &pstate);
	    if (pstate != 0)
            {
                break;
            }
            taskDelay(60);
           /******************************/
           tisWatchDogPulse(watchdogId[line]);
           /******************************/
        }
        if (pstate == 0)
        logMsg ("Timeout of pstate wait.\n");
        else
        logMsg ("Completion of pstate wait.\n");

/*	activity = check_line_activity(line,ACTIVITYTIME);  ** ten seconds */
        for (i = 0; i < ACTIVITYTIME/10; i++)
        {
            taskDelay(10);
           /******************************/
           tisWatchDogPulse(watchdogId[line]);
           /******************************/
        }
	activity = check_line_activity(line, 0);  /* ten seconds */
	resGetStates(prestable[line],&lstate,&pstate);

        /******************************************/
	/* if the partner is not there, be master */
	if ((pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity))
	{
            resSetCaAnswer(prestable[line]); /* tell ChanAccess about the state change. */
	    resPutLocalState(prestable[line], RES_MSTR);
	    lstate = RES_MSTR;
	    if (modrestrace[line])
	    	logMsg ("2] Became RES_MSTR \n");
	    semGive(linemux[line]);	/* give back semaphore so diagnostics can run   */
            /* flush the input queue */
            disable_rx_ints(line);
            rxrawqueinit(line);
            enable_rx_ints(line);
            /* start saving the input. */
            rxsave[line] = TRUE;
	}

	cfgchk = 0;     /* Init the new config pointer */
	last_time = tickGet(); /* Initialize the time  */

	while (TRUE)
	{
            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

	    activity_time[line] = tickGet();
	    lastactivity[line] = line_activity[line] = FALSE;

            /************************************************************************************/
	    /* we arrive here because we are a slave.                                           */
	    /* we stay until:   1) asked to be master by partner.                               */
            /*                         if we can reach the BCU, we become master.               */
            /*                  2) the partner is determined to be out of commission:           */
            /*                         a) the partner is not master,                            */
            /*                         b) the partner is not asking to be slave,                */
            /*                         c) and there is no activity on the line for 1/6 sec.     */
            /************************************************************************************/

	    while (lstate == RES_SLV)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

		if (pstate != RES_SLVWANT)
		{
		    clear_rts(line); 				/* make sure line is left for master  */
		}

                /* trash all input characters while in 'normal' slave mode. */
                rxsave[line] = FALSE;
                taskDelay(4);
		resresponse[line] = FALSE; 			/* make sure driver is not responding */
		resPutCommand(prestable[line], 0); 		/* clear out commands 		      */
		activity = check_line_activity(line, 10); 	/* wait 1/6 second before checking    */
		resGetStates(prestable[line],&lstate,&pstate);

                /**************************************************************************************/
		/* see if needed by partner to be master. if yes, do it and break out of slave state. */
		if (pstate == RES_SLVWANTCA)
		{
                    if (modrestrace[line] > 1)
                      logMsg ("Partner being forced to become Slave. Lets do it...\n");

                    rxsave[line] = TRUE;
                    if (!pbcu->cmd_force_offline)    /* user has forced it offline */
                    { 
                        forced_bcu_disconnect(line);
                    }
		    semGive(linemux[line]);	     /* give back semaphore so diags can function. */
                    resSetCaAnswer(prestable[line]); /* tell ChanAccess about the state change.    */
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line])
                        logMsg("3] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                    /* flush the input queue */
                    disable_rx_ints(line);
                    rxrawqueinit(line);
                    enable_rx_ints(line);
                    /* start saving the input */
                    rxsave[line] = TRUE;
		    break;
		}
                /***************************************************************/
		/* If partner is there and wants to give it up, try to take it */
		if (pstate == RES_SLVWANT)
		{
		  taskDelay(6); /* Time for switch to occur */
		  if (modrestrace[line] > 1)
                      logMsg ("Partner wants to become Slave. Lets try to oblige...\n");

		  /* Remember the time of this try */
                  last_time = tickGet();
                  this_time = tickGet();
		  while ((this_time - last_time) < SLAVETRYTIME) /* just try for a limited time */
                  {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

                    taskDelay(6);
                    resresponse[line] = FALSE;               /* make sure driver is not responding */
                    resPutCommand(prestable[line], 0);       /* clear out commands 		   */
                    activity = check_line_activity(line,10); /* wait 1/6 second before checking    */
                    resGetStates(prestable[line],&lstate,&pstate);
                    /* if partner leaves slave want mode, get out */
                    if (pstate != RES_SLVWANT)
                    {
                       if (modrestrace[line] > 1)
                           logMsg ("Partner is no longer Slave Want. lets get out.\n");
                       if (!pbcu->cmd_force_offline)    /* user has forced it offline */
                       { 
                           forced_bcu_disconnect(line);
                       }
                       break;
                    }
		    /* See if anyone is out there and able to respond to a BACnet command */
		    execute = FALSE;
                    pbcu = bcus[line];
		    if ((pbcu) &&		    /* verify pointer validity prior to use */
			(pbcu->was_requested) &&    /* data points have been requested      */
                        (!pbcu->cmd_force_offline)) /* user has NOT forced bcu offline      */
                    {
                        rxsave[line] = TRUE;
                        forced_bcu_disconnect(line);
			lastactivity[line] = line_activity[line] = FALSE;
			on_line(line);        /* after connection established, heartbeat will follow. */
                        taskDelay(60);        /* give time for HeartbeatXON to occur. */
                        rxsave[line] = FALSE; /* discard all other input for now. (none should occur) */

                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/

                        /* check cmd_force_offline flag before AND after due to asynchronous tasks */
                        if ((pbcu->is_responding) && (!pbcu->cmd_force_offline))
			{
			    execute = TRUE;
			}
		    }
		    /* If someone answered, become master and make sure partner really gave it up */
		    if (execute)
		    {
                        if (modrestrace[line] > 1)
                          logMsg ("Someone responded on the BACnet message..\n");
                        resSetCaAnswer(prestable[line]); /* tell ChanAccess about the state change.    */
			resPutLocalState(prestable[line],RES_MSTR);
			lstate = RES_MSTR;
			if (modrestrace[line])
				logMsg ("4] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                        /* flush the input queue */
                        disable_rx_ints(line);
                        rxrawqueinit(line);
                        enable_rx_ints(line);

			execute = FALSE;
			activity_time[line] = tickGet();
			lastactivity[line] = line_activity[line] = FALSE;

                        if (modrestrace[line] > 1)
                          logMsg ("Wait to make sure partner gave it up and there is no activity...\n");

                        /* look for proper partner state and inactivity for 2 seconds */
			for (i=0;(i<60);i++)
			{
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/

			    activity = check_line_activity(line, 2); /* pause before testing */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ( (pstate != RES_MSTR) && (pstate != RES_SLVWANT) && (!activity) )
			    {
                                if (modrestrace[line] > 1)
                                  logMsg ("Partner gave it up, and there is no activity. Stay Master.\n");
				execute = TRUE; /* Partner Gave It Up so take CA */
				break;
			    }
			}
			if (!execute)
			{   /* Partner did not give it up, go back to slave */
                            if (modrestrace[line] > 1)
                            {
                                if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
                                    logMsg ("Partner did not give up Master.\n");
                                if (activity)
                                    logMsg ("Unexpected activity detected. Must be partner.\n");
                            }
                            resClearCaAnswer(prestable[line]);
			    resPutLocalState(prestable[line],RES_SLV);
			    lstate = RES_SLV;
			    if (modrestrace[line])
			    	logMsg ("5] Became RES_SLV  P= %x A= %d \n",pstate,activity);
                            rxsave[line] = FALSE;
			}
			else
			{ /* Assume control by taking the CA responsibilities */ 
			    semGive(linemux[line]);	/* give back semaphore so diagnostics can run */
                            resSetCaAnswer(prestable[line]); /* tell ChanAccess about state change.   */
			    prepresponses(line);
                            /* start saving the input */
                            rxsave[line] = TRUE;
			    break; /* see test XXYYZZ below. this break doesn't get us totally out.   */
			}
		    }
                    this_time = tickGet();
                  }
                  /* the 'active' while loop has completed. */

                  /* test XXYYZZ. if we broke out to master state, don't wait here. */
                  if (lstate != RES_SLV)
                  {
                     break;
                  }
                  if (modrestrace[line] > 1)
                      logMsg ("Failed to make connection. waiting for partner to become Master...\n");

                  last_time = tickGet();
                  this_time = tickGet();
		  while ((this_time - last_time) < SLAVEWAITTIME) /* just wait a while.  */
                  {
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

                    taskDelay(6);
                    resresponse[line] = FALSE;               /* make sure driver is not responding */
                    resPutCommand(prestable[line], 0);       /* clear out commands                 */
                    activity = check_line_activity(line,10); /* wait 1/6 second before checking    */
                    resGetStates(prestable[line],&lstate,&pstate);
                    /* if partner leaves slave want mode, get out */
                    if (pstate != RES_SLVWANT)
                    {
                    if (modrestrace[line] > 1)
                        logMsg ("Partner became Master.\n");
                       break;
                    }
                    this_time = tickGet();
                  }

		}

                /********************************************/
		/* if the partner is not talking, be master */
		if ((pstate != RES_MSTR) &&  (pstate != RES_SLVWANT) && (!activity))
		{
                    rxsave[line] = TRUE;
                    if (modrestrace[line] > 1)
                        logMsg ("Partner is not master, and no activity is detected.\n");
                    if (!pbcu->cmd_force_offline)    /* user has forced it offline */
                    { 
                        forced_bcu_disconnect(line);
                    }

		    semGive(linemux[line]);		/* give back semaphore so diags can run. */
                    resSetCaAnswer(prestable[line]); /* tell ChanAccess about the state change.  */
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line])
		    	logMsg ("6] Became RES_MSTR P= %x A= %d \n", pstate, activity);
                    /* flush the input queue, enable interrupts. */
                    disable_rx_ints(line);
                    rxrawqueinit(line);
                    enable_rx_ints(line);
                    /* start saving the input */
                    rxsave[line] = TRUE;

		    prepresponses(line);
		}
	    }

            /************************************************************************************/
	    /* we arrive here because we have been told to relinquish master state.             */
	    /* we stay until:   1) partner takes over.                                          */
            /*                  2) the command is cancelled.                                    */
            /************************************************************************************/
	    while (lstate == RES_SLVWANTCA)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

                rxsave[line] = FALSE;
	        taskDelay(2);                   /* Give OS a chance...                  */
		clear_rts(line); 		/* Make sure line is left for master    */
		resresponse[line] = FALSE; 	/* Make Sure driver is not responding   */

		resGetStates(prestable[line],&lstate,&pstate);
		if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT))
		{
                    if (modrestrace[line] > 1)
                    {
                        if (pstate == RES_MSTR)
                            logMsg ("Partner became Master(MSTR), reluctantly or otherwise.\n");
                        if (pstate == RES_SLVWANT)
                            logMsg ("Partner became Master(SLVWANT), reluctantly or otherwise.\n");
                    }
		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLV);
		    lstate = RES_SLV;
		    if (modrestrace[line])
		    	logMsg ("7] Became RES_SLV  P= %x A= %d \n",pstate,activity);
		    break;
		}
		resGetCommand(prestable[line],&command);
		resPutCommand(prestable[line],0); /* clear out commands */
		if (command == RES_CANCELREL)
		{
                    if (modrestrace[line] > 1)
                        logMsg ("Relinquish Control command was cancelled.\n");
		    semGive(linemux[line]);          /* give back semaphore so diagnostics can run. */
                    resSetCaAnswer(prestable[line]); /* tell ChanAccess about the state change.     */
		    resPutLocalState(prestable[line],RES_MSTR);
		    lstate = RES_MSTR;
		    if (modrestrace[line])
		    	logMsg ("8] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                    /* flush the input queue */
                    disable_rx_ints(line);
                    rxrawqueinit(line);
                    enable_rx_ints(line);
                    /* start saving the input */
                    rxsave[line] = TRUE;

		    prepresponses(line);
		}
	    }

            /****************************************************************************************/
	    /* in normal operation this code should never execute. it has, however, been seen to    */
            /* execute when the database has been inadvertently configured with the same resource   */
	    /* assigned to two different drivers in the same IOC. The state does funny things.      */
            /****************************************************************************************/
	    while (lstate == RES_SLVWANT)
	    {
                if ((modrestrace [line]) || (trace[line] & CONFIGURATIONTRACE))

		{
                    /* condition should NEVER occur. print error message every 5 seconds. */
                    logMsg ("Illegal Local Resource State.\n");
                    if (trace[line] & CONFIGURATIONTRACE)
                    {
                        logMsg ("  Possible Resource Configuration Error:\n");
                        logMsg ("   Check for multiple drivers sharing single Resource.\n");
                    }
                    taskDelay (600);
                }
                taskDelay (2);
            }
            /****************************************************************************************/
            /* we arrive here because we have gone to, or are looping in, the master state.         */
	    /* we stay in this loop until:    we have been told to give master state to the partner.*/
	    /*                                we break out to RES_SLVWANTCA.                        */
	    /*                                we have successfully handed master state to partner,  */
            /*                                 after having lost commnications with the BCU.        */
	    /* While master, this task will process all modules sending outputs and getting inputs. */
            /****************************************************************************************/

	    last_time = tickGet ();		/* initialize gap */
	    while (lstate == RES_MSTR)
	    {
                /******************************/
                tisWatchDogPulse(watchdogId[line]);
                /******************************/

		/* initial stuff */
		resresponse[line] = TRUE; /* Make sure driver is responding. driver won't           */
                                          /* issue commands if not set.                             */

                rxsave[line] = TRUE;

		resGetCommand(prestable[line], &command);
		resPutCommand(prestable[line], 0);        /* clear out commands */

                /************************************************************************/
		/* if relinquish command sent, change state and break out to outer loop */
		if (command == RES_RELINQUISH)
		{
                    if (modrestrace[line] > 1)
                        logMsg ("Relinquish Control command received. give up Master mode.\n");
		    
                    getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                    if (!pbcu->cmd_force_offline)    /* user has forced it offline */
                    { 
                        forced_bcu_disconnect(line);
                    }
                    pbcu->is_responding = FALSE;

		    resClearCaAnswer(prestable[line]);
		    resPutLocalState(prestable[line],RES_SLVWANTCA);
		    lstate = RES_SLVWANTCA;
		    if (modrestrace[line])
                       logMsg ("9] Became RES_SLVWANTCA  P= %x A= %d \n",pstate,activity);
		    break;
		}

		/* scan BCU for requested data. */
                pbcu = bcus[line];
                if (pbcu->cmd_force_offline)    /* user has forced it offline */
                { 
                    /* if user has turned this bcu offline via pseudo commands,     */
                    /* mark it as not responding.                                   */
                    pbcu->is_responding = FALSE;
	    	}
		else if (pbcu->is_responding)
		{
                    /* local/partner lockstep recovery */
                    resGetStates(prestable[line], &lstate, &pstate);
                    if (pstate == RES_MSTR)
                    {
                        if (modrestrace[line] > 1)
                            logMsg ("Partner is unexpectedly Master. Begin Lockstep Recovery.\n");

                        getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                        if (!pbcu->cmd_force_offline)    /* user has forced it offline */
                        { 
                            forced_bcu_disconnect(line);
                        }
                        pbcu->is_responding = FALSE;
                        resClearCaAnswer(prestable[line]);
                        resPutLocalState(prestable[line], RES_SLV);
                        lstate = RES_SLV;
                        clear_rts(line); 		/* Make sure line is left for master */
                        if (modrestrace[line])
                            logMsg ("13] Became RES_SLV  P= %x A= %d \n", pstate, activity);
                        if (modrestrace[line] > 1)
                            logMsg ("Delay for random interval before proceeding to SLAVE loop...\n");
                        temp = ((tickGet () % 8) + 5); /* random 5 to 12 second delay */
                        for ( i = 0; i < temp; i++)
                        {
                           /******************************/
                           tisWatchDogPulse(watchdogId[line]);
                           /******************************/
                           taskDelay(60);
                        }
                        if (modrestrace[line] > 1)
                            logMsg ("Lockstep Recovery Delay completed.\n");
                        break;
                    }
                    scan_bcu(line);             /* I/O done here!             */

                    if (!pbcu->is_responding)
                    {
                        mark_not_valid(pbcu);
                    }
		}
		/* don't trash the command, so that we can still read it on the next loop */
                /* through this while statement.                                          */
		resGetCommand(prestable[line],&command);
		if (command == RES_RELINQUISH)
                {
                    pbcu->is_responding = FALSE;
                    break;
                }

                /* test for lockstep detection. */
                if (lstate != RES_MSTR) break;

                /************************************************************************************/
                /* as there is only one BCU per line, when it becomes invalid, all we can do is     */
                /* try to bring it back on line, even though it was just determined to be offline   */
                /* in the previous section of code, and that was after repeated reties at the       */
                /* application and datalink levels. however, it keeps the state from thrashing back */
                /* and forth between the two partners is the case where BCU is dead, and may result */
                /* is a successful online connection in the case of a transient connection loss.    */
                /* This code also is used to bring the BCU online the first time after becoming     */
                /* master after having failed to pass the master state to the partner.              */
                /************************************************************************************/

                pbcu = bcus[line];
                if ((pbcu) &&		/* verify pointer validity prior to use*/
                    (!pbcu->is_responding) &&
                     (pbcu->was_requested) &&
                     (!pbcu->cmd_force_offline))
                {
                    /* get access to the radio */

                    getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                    forced_bcu_disconnect(line);
                    on_line(line);	/* ' BCU connection attempt done here! */
                    semGive(linemux[line]);
		}
                /* end of bring it back online logic */

		/* see if anyone on the line has been responding. */
                /* if not, try to get partner to become slave.    */
		/* Check for no one responding */
		if (!any_responding(line))
		{
                    /******************************/
                    tisWatchDogPulse(watchdogId[line]);
                    /******************************/

		    /* See if it is time to let partner try (have we been master for long enough?)*/
		    this_time = tickGet();
		    if ((this_time - last_time) > (3*SLWWINDOW))
		    { 
                        if (!pbcu->cmd_force_offline)    /* user has forced it offline */
                        { 
                            forced_bcu_disconnect(line);
                        }
                        pbcu->is_responding = FALSE;

			/* Switch States to let partner know it's its time to try */

                        /*****************************************************************************/
                        /* make semGet(linemux[line]) call before the switch to make sure diagnostic */
                        /* task is quiescent while partner is attempting to CONNECT with the BCU.    */
                        /* if local not master, then diagnostic won't try anyway, for either master  */
                        /* or remote radios, but it might have begun a 12 second test sequence just  */
                        /* before we got here.                                                       */
                        /*****************************************************************************/

                        if (modrestrace[line] > 1)
                            logMsg ("We can't reach the BCU. lets let partner try.\n");

                        getsemaphore(line);       /* make sure radio diagnostics are quiescent */

                        /* we must semGive the semaphore back if and when we go to being the master */

			resPutLocalState(prestable[line],RES_SLVWANT);
			lstate = RES_SLVWANT;
			if (modrestrace[line])
				logMsg ("10] Became RES_SLVWANT  P= %x A= %d \n",pstate,activity);

			/* Give partner access to the hardware */
			clear_rts(line);
                        /* don't save the input. */
                        rxsave[line] = FALSE;
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        taskDelay(60);   /* wait three seconds before testing for activity. this */
                                         /* gives partner time to connect and get heartbeat.   */
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        taskDelay(60);
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                        taskDelay(60);

                        if (modrestrace[line] > 1)
                            logMsg ("Check for comm activity and partner state change.\n");
			/* Remember the time of this try */
			last_time = tickGet();
                        /* clear old activity info */
			lastactivity[line] = line_activity[line] = FALSE;
			for (i=0; (i<SLWWINDOW); i+=10)
			{       		/* SLWINDOW is the # of ticks for slave to try */
                            /******************************/
                            tisWatchDogPulse(watchdogId[line]);
                            /******************************/

			    taskDelay(10);
		    				/* If partner picked up let it have control */
			    activity = check_line_activity(line, 0);  /* check immediately */
			    resGetStates(prestable[line],&lstate,&pstate);
			    if ((pstate == RES_MSTR) || (pstate == RES_SLVWANT) || (activity))
			    {
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60);

                                if (modrestrace[line] > 1)
                                {
                                    if (pstate == RES_MSTR)
                                        logMsg ("Partner became Master(MSTR).\n");
                                    if (pstate == RES_SLVWANT)
                                        logMsg ("Partner became Master(SLVWANT).\n");
                                    if (activity)
                                        logMsg ("Activity detected.\n");
                                    if (!(pstate == RES_MSTR) && !(pstate == RES_SLVWANT))
                                        logMsg ("***** Partner NOT MSTR yet Activity detected *****\n");
                                }
				resClearCaAnswer(prestable[line]);
				resPutLocalState(prestable[line],RES_SLV);
				lstate = RES_SLV;
				if (modrestrace[line])
					logMsg ("11] Became RES_SLV  P= %x A= %d \n",pstate,activity);

                                /* don't save the input */
                                rxsave[line] = FALSE;

                                taskDelay(60); /* give things time to settle out */
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/
                                taskDelay(60); /* give things time to settle out */
                                /******************************/
                                tisWatchDogPulse(watchdogId[line]);
                                /******************************/

                                /* clear old activity info */
                                lastactivity[line] = line_activity[line] = FALSE;
                                activity = check_line_activity(line, 0);  /* check immediately */
                                resGetStates(prestable[line],&lstate,&pstate);
				break;
			    }
			}
			/* Go Back to being the Master and take control of the hardware */
			if (lstate != RES_SLV)
			{
                            if (modrestrace[line] > 1)
                                logMsg ("No sign of partner activity or state change..\n");
			    semGive(linemux[line]); /* give back semaphore so diagnostics can run. */
                            resSetCaAnswer (prestable [line]);
                            resPutLocalState (prestable [line], RES_MSTR);
			    lstate = RES_MSTR;
			    if (modrestrace[line])
			    	logMsg ("12] Became RES_MSTR  P= %x A= %d \n",pstate,activity);
                            /* flush the input queue */
                            disable_rx_ints(line);
                            rxrawqueinit(line);
                            enable_rx_ints(line);
                            /* start saving the input. */
                            rxsave[line] = TRUE;
                            if (!pbcu->cmd_force_offline)    /* user has forced it offline */
                            { 
                                forced_bcu_disconnect(line);
                            }
			}
		    }
                    else /* if no one is responding, but not time to give it up to partner, delay. */
                    {
                        if (modrestrace[line] > 2)
                            logMsg ("No one is responding. Waiting for time to let partner try...\n");
                        taskDelay(60);              /* give it a rest */
                        /******************************/
                        tisWatchDogPulse(watchdogId[line]);
                        /******************************/
                    }
		}
		/* take bcus off hold status. bcu's data are not to be held off since now master. */
                pbcu = bcus[line];
                pbcu->holdflag = FALSE;
                taskDelay(4);
	    }
	} /* end infinite task loop */
     }


static void getsemaphore(unsigned short line)
{
    int i;     

    while ((semTake(linemux[line], 10)) == ERROR)
    {
        i =+ 10;
        if (i >= MUXTIMEOUT)
        {
            i = 0;
            logMsg (" Waiting for Radio Diagnostics:");
            printf (" Mutual-Exclusion Semaphore Timeout on Line %d\n", line);
        }
        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/
    }
    return;
}


/*
** Try to bring a BCU on line
**
*/

/* this routine only called from MAIN */

static void on_line (unsigned short line)
    {
	BCU  *pbcu;


	pbcu = bcus[line];
	if (pbcu)			/* verify pointer prior to use */
	{
		if (mltrace[line] == 1)
		{
			logMsg ( "Bring Online line - %d\n", line);
	        }
                /* make sure we are connected before trying to talk. */
                if (bcu_connect(line) == TRUE) /* connected */
                {
                    mark_not_valid(pbcu);       /* a BCU that has just been brought online must */
                                                /* have it's data marked as being not valid.    */
                    pbcu->is_responding = TRUE;
                }
                else
                {
                    pbcu->is_responding = FALSE;
                }
                return;
        }
    }
/*							
** Mark all bcu data elements as not valid              
**                                             		
*/                                             	
/* called from on_line and prepresponses      		*/    	

static void mark_not_valid (BCU  *pbcu)
    {
	unsigned short i;

/*
**      BINARY OUTPUTS ARE INITIALIZED AS READ WRITE VALUES   
**              - READ BACK NOT VALID
*/
	for (i=0; (i<NUMBCUBOS); i++)
	{
	    pbcu->binaryoutputs[i].data_valid = FALSE;
	}

/*
**      BINARY INPUTS ARE INITIALIZED AS NOT VALID		
*/
	for (i=0; (i<NUMBCUBIS); i++)
	{
	    pbcu->binaryinputs[i].data_valid = FALSE;
	}

/*
**      ANALOG INPUTS ARE INITIALIZED AS NOT VALID		
*/
	for (i=0; (i<NUMBCUAIS); i++)
	{
	    pbcu->analoginputs[i].data_valid = FALSE;
	}

/*
**      ANALOG OUTPUTS ARE INITIALIZED AS READ WRITE VALUES	
**      WRITES ARE TREATED INDIVIDUALLY, NOT GROUPS             
**              - READ BACK NOT VALID      	               	
*/
	for (i=0; (i<NUMBCUAOS); i++)
	{
	    pbcu->analogoutputs[i].data_valid = FALSE;
	}
    }
/*                                                           	
** Scan a BCU  -  get inputs and set outputs as required        
**                                                            	
*/
/* this routine only called from MAIN 		*/

void scan_bcu (unsigned short line)
{

	BCU            *pbcu;
        unsigned short results;

	pbcu = bcus[line];

	checkoutputs(line);

	if (mltrace[line] == 2)
        {
            taskDelay(1);
            logMsg ( "Scan BCU Objects....\n");
            taskDelay(1);
        }
        /* read the binary output values to be scanned.                */
        /* note that readbinaryoutputs, not bcu_scan, now goes through */
        /*  the point list checking for requested objects.             */
	if (mltrace[line] == 3)
        {
            taskDelay(1);
            logMsg ( "  Scan Binary Outputs....\n");
            taskDelay(1);
        }

        results = readbinaryoutputs(line, pbcu);

        if (!results)
        {
            return;             /* if any error condition, abort processing. this logic assumes   */
        }                       /* that the problem is one of comm failure, or else we would keep */
                                /* on reading the other points.                                   */
        checkoutputs(line);

	/* read the binary input values to be scanned                   */
        /* note that readbinaryinputs, not bcu_scan, now goes through   */
        /*  the point list checking for requested objects.              */
	if (mltrace[line] == 3)
        {
            taskDelay(1);
            logMsg ( "  Scan Binary Inputs....\n");
            taskDelay(1);
        }
        if (!readbinaryinputs (line, pbcu))
            return;             /* if any error condition, abort processing. this logic assumes   */
                                /* that the problem is one of comm failure, or else we would keep */
                                /* on reading the other points.                                   */
        checkoutputs(line);

	/* read the analog input values to be scanned                   */
        /* note that readanaloginputs, not bcu_scan, now goes through   */
        /*  the point list checking for requested objects.              */
	if (mltrace[line] == 3)
        {
            taskDelay(1);
            logMsg ( "  Scan Analog Inputs....\n");
            taskDelay(1);
        }
        if (!readanaloginputs (line, pbcu))
            return;             /* if any error condition, abort processing. this logic assumes   */
                                /* that the problem is one of comm failure, or else we would keep */
                                /* on reading the other points.                                   */
        checkoutputs(line);

	/* read the analog output values to be scanned                  */
        /* note that readanalogoutputs, not bcu_scan, now goes through  */
        /*  the point list checking for requested objects.              */
	if (mltrace[line] == 3)
        {
            taskDelay(1);
            logMsg ( "  Scan Analog Outputs....\n");
            taskDelay(1);
        }
        if (!readanalogoutputs (line, pbcu))
            return;             /* if any error condition, abort processing. this logic assumes   */
                                /* that the problem is one of comm failure, or else we would keep */
                                /* on reading the other points.                                   */
        checkoutputs(line);
}

/*
** checkoutputs											
**      checks output que and returns if empty.							
**      if there is something on the queue it attempts to process all                           
**      pending outputs, doing immediate retries. If attempts fail the request is dropped.      
**                                                                                              
*/                                                                                              
/* this routine only called from scan_bcu */

static	void checkoutputs (unsigned short line)
    {
	OUTQENT         *optr;
	unsigned short  analogoutputaddr, analogoutputval, link, adapter, binaryoutputaddr, conv;
	unsigned long   binaryoutputmask, binaryoutputval;
	BCU          *pbcu;
	double 		dblaovalue;

	if (skip[line] & SKIPOUT)
        {
            logMsg("Skipping checkoutputs...\n");
            taskDelay(30);
            return;
        }

	while ((optr=ogetnextp(line)) != NULLP)
	{
	    if ((optr->otype)==AOUTTYPE)
	    {
		link = optr->out.aonode.link;
		adapter = optr->out.aonode.adapter;
		pbcu = bcus[link];
		if (pbcu == NULL)
		{
			if (!allocate_bcu(link))
				return; /* if not allocated, try. if can't allocate, get out. */
        	        pbcu = bcus[link];
		}
		analogoutputaddr = optr->out.aonode.aosignal;
		analogoutputval = optr->out.aonode.aovalue;
		dblaovalue = optr->out.aonode.dblaovalue;
		conv = optr->out.aonode.conversion;
		if (mltrace[line] == 4) 
			logMsg ( "Analog Output to L=%d, A=%d, S=%d, V=%d\n",
				link, adapter, analogoutputaddr ,analogoutputval);

		if ((!pbcu->cmd_force_offline) && (resresponse[link]) && (pbcu->is_responding))
		{
		    if (!(setanalogoutput(link, pbcu, analogoutputaddr,
                                          analogoutputval, dblaovalue, conv )))
		    {
		        pbcu->badoutcnt++;
                        if (mltrace[link] == 4)
                            logMsg("AO DEQUEUE: Output failed: L=%d, A=%d, S=%d, V=%d\n",
                                   link,adapter,analogoutputaddr,analogoutputval);
		    }
                    else
		    {
                        if (mltrace[link] == 4)
                            logMsg("AO DEQUEUE: Output succeeded: L=%d, A=%d, S=%d, V=%d\n",
                                   link,adapter,analogoutputaddr,analogoutputval); 
		    }
		}
                else
                {
                    if (mltrace[link] == 4)
                     logMsg("AO DEQUEUE: BCU not available: Output Discarded: L=%d, A=%d, S=%d, V=%d\n",
                               link,adapter,binaryoutputaddr,binaryoutputval); 
                }
	    }
	    else if ((optr->otype)==BOUTTYPE)
	    {
		link = optr->out.bonode.link;
		adapter = optr->out.bonode.adapter;
		pbcu = bcus[link];
		if (pbcu == NULL)
		{
			if (!allocate_bcu(link))
				return; /* if not allocated, try. if can't allocate, get out. */
        	        pbcu = bcus[link];
		}
		binaryoutputaddr = optr->out.bonode.bosignal;
		binaryoutputval = optr->out.bonode.bovalue;
		binaryoutputmask = optr->out.bonode.bomask;
		if (mltrace[line] == 5) 
			logMsg ( "Binary Output to L=%d, A=%d, S=%d, V=%d\n",
				link, adapter, binaryoutputaddr, binaryoutputval);

		if ((!pbcu->cmd_force_offline) && (resresponse[link]) && (pbcu->is_responding))
		{
		    if (!(setbinaryoutput (link, pbcu, binaryoutputaddr,
                                           binaryoutputmask, binaryoutputval)))
		    {
		        pbcu->badoutcnt++;
                        if (mltrace[link] == 5)
                            logMsg("BO DEQUEUE: Output failed: L=%d, A=%d, S=%d, V=%d\n",
                                   link,adapter,binaryoutputaddr,binaryoutputval);
		    }
                    else
		    {
                        if (mltrace[link] == 5)
                            logMsg("BO DEQUEUE: Output succeeded: L=%d, A=%d, S=%d, V=%d\n",
                                   link,adapter,binaryoutputaddr,binaryoutputval);
		    }
		}
                else
                {
                    if (mltrace[link] == 5)
                     logMsg("BO DEQUEUE: BCU not available: Output Discarded: L=%d, A=%d, S=%d, V=%d\n",
                               link,adapter,binaryoutputaddr,binaryoutputval); 
                }
	    }
	    oreleasefull(line);     /* release the output que entry */
	}
    }
/*                                                                                     
**      AIDRIVER                                                                        
**                                                                              	
**      This routines main purpose is to return the analog input value for the         	
**      specified module. For a module value                                           	
**      a (-1) will be returned if there is no valid data ready.                       	
**                                                                                     	
*/
/* this routine not called from within this driver */

int AIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, short *pvalue, unsigned short conversion,
		unsigned char *resname)
    {
	BCU  *pbcu;
	unsigned short  blkix;
        unsigned short  floathigh, floatlow;

	if (link > BCULINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMBCUS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != AICARD) && (card != AOCARD) && (card != PSEUDOCARD))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pbcu = bcus[link];
	if (pbcu == NULL)
	{
		if (!allocate_bcu(link))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pbcu = bcus[link];
	}

	if (card == PSEUDOCARD)
	{
	    switch (signal)
	    {
	    case 0: /* Were the PLC values requested */
		*pvalue = pbcu->was_requested;
		break;

	    case 1: /* Is the PLC responding */
		*pvalue = pbcu->is_responding;
		break;

	    case 5: /* Output Messages */
		*pvalue = pbcu->no_dataout_msgs & 0x7fff;
		break;

	    case 6: /* Input Messages */
		*pvalue = pbcu->no_datain_msgs & 0x7fff;
		break;

	    case 7: /* No Receiver Responses */
		*pvalue = pbcu->no_rxnoresp & 0x7fff;
		break;

	    case 8: /* No Transmitter Response */
		*pvalue = pbcu->no_txnoresp & 0x7fff;
		break;

	    case 9: /* Data Echo Errors */
		*pvalue = pbcu->no_dataerr & 0x7fff;
		break;

	    case 10: /* Message Retries */
		*pvalue = pbcu->no_retries & 0x7fff;
		break;

	    case 11: /* RX Hardware errors */
		*pvalue = pbcu->no_rxhwerrs & 0x7fff;
		break;

	    case 12: /* TX Hardware errors */
		*pvalue = pbcu->no_txhwerrs & 0x7fff;
		break;

	    case 13: /* CRC errors */
		*pvalue = pbcu->no_crcerrs & 0x7fff;
		break;

	    case 14: /* Offline transitions */
		*pvalue = pbcu->no_offlines & 0x7fff;
		break;

	    case 15: /* reset statistics */
		*pvalue = pbcu->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pbcu->cmd_force_offline;
		break;

	    case 17: /* Failed output commands */
		*pvalue = pbcu->badoutcnt & 0x7fff;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
	    }
	    return (0);
	}

	if (card == AICARD)
	{
	    if ((signal > MAXAINO) || (signal < MINAINO))
	    {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }

            if (resname != 0)
            { 
                register_resource(link, pbcu, resname, pointname);
            }

            /* check for valid conversion type */
            if (conversion == AICNVFLOAT)
            {
                    blkix = signal;

                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pbcu->was_requested = TRUE;
                    pbcu->analoginputs [blkix].was_requested = TRUE;

	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if (pbcu->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-2);
                    }
	            if (!pbcu->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if (!pbcu->analoginputs [blkix].data_valid)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
                    floathigh = ((pbcu->analoginputs [blkix].aivals [0]) << 8) +
                                  pbcu->analoginputs [blkix].aivals [1];
                    floatlow  = ((pbcu->analoginputs [blkix].aivals [2]) << 8) +
                                  pbcu->analoginputs [blkix].aivals [3];
		    pvalue[0] = floathigh;
		    pvalue[1] = floatlow;
                    if (mltrace[link] == 6)
                        logMsg("AIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal, floathigh, floatlow);
                    return(0);
            }
            else
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return(-1);
            }
	}

	if (card == AOCARD)
	{
	    if ((signal > MAXAONO) || (signal < MINAONO))
	    {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }

            if (resname != 0)
            { 
                register_resource(link, pbcu, resname, pointname);
            }

            /* check for valid conversion type */
            if (conversion == AICNVFLOAT)
            {
                    blkix = signal;

                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pbcu->was_requested = TRUE;
                    pbcu->analoginputs [blkix].was_requested = TRUE;

	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if (pbcu->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-2);
                    }
	            if (!pbcu->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if (!pbcu->analogoutputs [blkix].data_valid)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
                    floathigh = ((pbcu->analogoutputs [blkix].aovals [0]) << 8) +
                                  pbcu->analogoutputs [blkix].aovals [1];
                    floatlow  = ((pbcu->analogoutputs [blkix].aovals [2]) << 8) +
                                  pbcu->analogoutputs [blkix].aovals [3];
		    pvalue[0] = floathigh;
		    pvalue[1] = floatlow;
                    if (mltrace[link] == 6)
                        logMsg("AIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal,floathigh, floatlow);
                    return(0);
            }
            else
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AIDRIVER: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return(-1);
            }
	}
	return(-1);
    }

/*  										
**      AODRIVER                                                                
**                                                                            	
**      This routines main purpose is to set requested analog outputs to the  	
**      specified module.                                                     	
*/                                                                            	
/* this routine not called from within this driver */


int AODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	    unsigned short signal,double dvalue, unsigned short value,
	    unsigned short conversion, unsigned char *resname)

    {
	BCU  *pbcu;
	unsigned short  blkix;
	OUTQENT *oqp;

	if (link > BCULINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

	if (adapter > NUMBCUS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

	if ((card != AOCARD) && (card != PSEUDOCARD))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }


	pbcu = bcus[link];
	if (pbcu == NULL)
	{
		if (!allocate_bcu(link))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pbcu = bcus[link];
	}


	if (card == PSEUDOCARD)
	{
	    switch (signal)
	    {

	    case 15: /* Reset the accumulated statistics */
		if (value != 0)
			initstats(pbcu);
		break;

	    case 16: /* Force the PLC online/offline */
		pbcu->cmd_force_offline = (value != 0);
                if (value != 0 )
                    pbcu->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXAONO) || (signal < MINAONO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}

	if (resname != 0)
	{ 
	    register_resource(link, pbcu, resname, pointname);
	}

	blkix = signal;

        /* as soon as the address is confirmed as valid, set requested bits. */
        pbcu->was_requested = TRUE;
	pbcu->analogoutputs [blkix].was_requested = TRUE;

	if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	if ((!pbcu->is_responding) || (pbcu->cmd_force_offline))
	{
            if (trace[link] & CALLREJECTTRACE)
                logMsg("AODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("AODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, Value %d\n",
                        pointname, link, adapter, card, signal, value);
	    pbcu->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = AOUTTYPE;
	oqp->out.aonode.link = link;
	oqp->out.aonode.adapter = adapter;
	oqp->out.aonode.card = card;
	oqp->out.aonode.aosignal = signal;

        oqp->out.aonode.aovalue = value;

	oqp->out.aonode.dblaovalue = dvalue;
	oqp->out.aonode.conversion = conversion;

	omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 4)
            logMsg("AODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
	return (0);
    }
/*                                                                             
**      AOREAD                                                                  
**                                                                          	
**      This routines main purpose is to return the value last read back     	
**      from the analog output hardware. This is used to initialize analog   	
**      outputs.                                                             	
*/
/* this routine not called from within this driver */


int AOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
	  unsigned short signal, unsigned short *pvalue,
	  unsigned short conversion, unsigned char *resname)

    {
	BCU  *pbcu;
	unsigned short  blkix;
        unsigned short  floathigh, floatlow;

	if (link > BCULINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMBCUS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != AOCARD) && (card != PSEUDOCARD))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("AOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pbcu = bcus[link];
	if (pbcu == NULL)
	{
		if (!allocate_bcu(link))
                        return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pbcu = bcus[link];
	}

	if (card == PSEUDOCARD)
	{
	    switch (signal)
	    {
	    case 15: /* read statistics command value */
		*pvalue = pbcu->cmd_reset_stat;
		break;

	    case 16: /* Read the current PLC offline command status */
		*pvalue = pbcu->cmd_force_offline;
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
	    }
	    return (0);
	}

	if (card == AOCARD)
	{
            if ((signal > MAXAONO) || (signal < MINAONO))
	    {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }

            if (resname != 0)
            { 
                register_resource(link, pbcu, resname, pointname);
            }

            /* check for trans-REGBLOCK boundary access */
            if (conversion == ASCFLT)
            {
                    blkix = signal;

                    /* as soon as the address is confirmed as valid, set requested bits. */
                    pbcu->was_requested = TRUE;
                    pbcu->analogoutputs [blkix].was_requested = TRUE;

	            if (!resresponse[link])
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }

	            if (pbcu->holdflag)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-2);
                    }
	            if (!pbcu->is_responding)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
	            if (!pbcu->analogoutputs [blkix].data_valid)
                    {
                        if (trace[link] & CALLREJECTTRACE)
                            logMsg("AOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
                        return (-1);
                    }
                    floathigh = ((pbcu->analogoutputs [blkix].aovals [0]) << 8) +
                                  pbcu->analogoutputs [blkix].aovals [1];
                    floatlow  = ((pbcu->analogoutputs [blkix].aovals [2]) << 8) +
                                  pbcu->analogoutputs [blkix].aovals [3];
		    pvalue[0] = floathigh;
		    pvalue[1] = floatlow;
                    if (mltrace[link] == 7)
                        logMsg("AOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x 0x%x\n",
                                pointname, link, adapter, card, signal,floathigh, floatlow);
                    return(0);
            }
            else
            {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("AOREAD: Illegal Conversion Type:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return(-1);
            }
        }
	return(-1);
    }
/*                                                                                     
**      BIDRIVER                                                                        
**                                                                               	
**      The main purpose of this routine is to return the request binary input  	
**      value(s) from the requested card. This routine will return a (-1) if the  	
**      requested module is the wrong type or the data is not yet valid.          	
**                                                                                	
*/
/* this routine not called from within this driver */

int BIDRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long mask,unsigned long *pvalue,
		unsigned char *resname)

    {
	BCU  *pbcu;
	unsigned short blkix;
	unsigned long tvalue;

	if (link > BCULINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMBCUS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != BICARD) && (card != BOCARD) && (card != PSEUDOCARD))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BIDRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	pbcu = bcus[link];
	if (pbcu == NULL)
	{
		if (!allocate_bcu(link))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pbcu = bcus[link];
	}

	if (card == PSEUDOCARD)
	{
	    switch (signal)
	    {
		    case 0: /* Were the PLC values requested */
			*pvalue = pbcu->was_requested;
			break;

		    case 1: /* Is the PLC responding */
			*pvalue = pbcu->is_responding;
			break;

		    case 15: /* reset statistics */
			*pvalue = pbcu->cmd_reset_stat;
			break;

		    case 16: /* Force the PLC offline */
			*pvalue = pbcu->cmd_force_offline;
			break;

		    default:
                        if (trace[link] & CONFIGURATIONTRACE)
                            logMsg("BIDRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                                    pointname, link, adapter, card, signal);
			return (-1);
	    }
	    return (0);
	}

       /* note: as mbbo/mbbi points are not supported, mask is redundant, and therefore not used. */

	blkix = signal; 	/* 1 bit per binary BLOCK */

	tvalue = 0;
	if (card == BICARD)
	{
            if ((signal > MAXBINO) || (signal < MINBINO))
	    {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }

            if (resname != 0)
            { 
                register_resource(link, pbcu, resname, pointname);
            }

            pbcu->was_requested = TRUE;
            pbcu->binaryinputs [blkix].was_requested = TRUE;

            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }

            if (pbcu->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-2);
            }
            if (!pbcu->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (!pbcu->binaryinputs [blkix].data_valid)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }

	    tvalue = (unsigned long) pbcu->binaryinputs [blkix].last_read;

	    *pvalue = tvalue;
            if (mltrace[link] == 8)
                logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                        pointname, link, adapter, card, signal, pvalue);
	    return (0);
	}

	tvalue = 0;
	if (card == BOCARD)
	{
            if ((signal > MAXBONO) || (signal < MINBONO))
	    {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BIDRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }

            if (resname != 0)
            { 
                register_resource(link, pbcu, resname, pointname);
            }

            pbcu->was_requested = TRUE;
            pbcu->binaryoutputs [blkix].was_requested = TRUE;

            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }

            if (pbcu->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-2);
            }
            if (!pbcu->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
            if (!pbcu->binaryinputs [blkix].data_valid)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BIDRIVER: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }

	    tvalue = (unsigned long) pbcu->binaryoutputs [blkix].last_read;

	    *pvalue = tvalue;
            if (mltrace[link] == 8)
                logMsg("BIDRIVER: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                        pointname, link, adapter, card, signal, pvalue);
	    return (0);
	}
	return (-1);
    }
/*                                                                                	
**      BODRIVER                                                                        
**                                                                                 	
**      The main purpose of this routine is to set the request binary output      	
**      value(s) on the requested card. This routine will return a (-1) if the     	
**      requested module is the wrong type or not configured yet.                  	
**                                                                                 	
*/
/* this routine not called from within this driver */


int BODRIVER (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long value, unsigned long mask,
		unsigned char *resname)
    {
	BCU  *pbcu;
	OUTQENT *oqp;
	unsigned short  blkix;

	if (link > BCULINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

	if (adapter > NUMBCUS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }

	if ((card != BOCARD) && (card != PSEUDOCARD))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
            return (-1);
        }


	blkix = signal;	                /* 1 bit per binary output BLOCK */

	pbcu = bcus[link];
	if (pbcu == NULL)
	{
		if (!allocate_bcu(link))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pbcu = bcus[link];
	}

	if (card == PSEUDOCARD)
	{
	    switch (signal & 0x1f)
	    {

	    case 15: /* Reset the accumulated statistics */
		if (value != 0) initstats(pbcu);
		break;

	    case 16: /* Force the PLC offline */
		pbcu->cmd_force_offline = (value != 0);
                if (value != 0 )
                    pbcu->is_responding = FALSE;/* only required when asserting cmd_force_offline */
		break;

	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BODRIVER: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                            pointname, link, adapter, card, signal, value);
		return (-1);
	    }
	    return (0);
	}

        if ((signal > MAXBONO) || (signal < MINBONO))
	{
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BODRIVER: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}

	if (resname != 0)
	{ 
	    register_resource(link, pbcu, resname, pointname);
	}

	pbcu->was_requested = TRUE;
        pbcu->binaryoutputs [blkix].was_requested = TRUE;

	if (!resresponse[link])
        {
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BODRIVER: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }


	if ((!pbcu->is_responding) || (pbcu->cmd_force_offline))
	{
            if (trace[link] & CALLREJECTTRACE)
                logMsg("BODRIVER: Not Responding or Forced offline:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    return (-1);
	}

	oqp = ogetemptyp (link);
	if (oqp == NULLP)
	{
            if (trace[link] & RUNTIMEERRORTRACE)
                logMsg("BODRIVER: Queue Overflow:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                        pointname, link, adapter, card, signal, value);
	    pbcu->badoutcnt++;
	    return (-1);		/* output queue is full */
	}
	oqp->otype = BOUTTYPE;
	oqp->out.bonode.link = link;
	oqp->out.bonode.adapter = adapter;
	oqp->out.bonode.card = card;
	oqp->out.bonode.bosignal = signal;
	oqp->out.bonode.bomask = mask;
	oqp->out.bonode.bovalue = value;

	omarkfull (link);		/* Mark this entry as ready for output */

        if (mltrace[link] == 5)
            logMsg("BODRIVER: Queued:[%s] L=%d, A=%d, C=%d, S=%d, V=%d\n",
                    pointname, link, adapter, card, signal, value);
	return (0);
    }
/*                                                                             
**      BOREAD                                                                  
**                                                                              
**      This routines main purpose is to return the value last read back      	
**      from the binary output hardware. This is used to initialize binary      
**      outputs. This will return a (-1) if the module is the wrong type or    	
**      the data is not yet valid                                              	
*/
/* this routine not called from within this driver */

int BOREAD (char *pointname, unsigned short link, unsigned short adapter, unsigned short card,
		unsigned short signal, unsigned long *pvalue, unsigned long mask,
		unsigned char *resname)

    {
	BCU  *pbcu;
	unsigned short  blkix;
	unsigned long	tvalue;

	if (link > BCULINES)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal line:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if (adapter > NUMBCUS)
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal adapter:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }
	if ((card != BOCARD) && (card != PSEUDOCARD))
        {
            if (trace[link] & CONFIGURATIONTRACE)
                logMsg("BOREAD: Illegal card:[%s] L=%d, A=%d, C=%d, S=%d\n",
                        pointname, link, adapter, card, signal);
            return (-1);
        }

	blkix = signal;                         /* 8 bits per binary output BLOCK */

	pbcu = bcus[link];
	if (pbcu == NULL)
	{
		if (!allocate_bcu(link))
			return(-1); /* if not allocated, try. if can't allocate, get out. */
	        pbcu = bcus[link];
	}

	if (card == PSEUDOCARD)
	{
	    switch (signal)
	    {
	    case 15: /* reset statistics */
		*pvalue = pbcu->cmd_reset_stat;
		break;

	    case 16: /* Force the PLC offline */
		*pvalue = pbcu->cmd_force_offline;
		break;


	    default:
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal Pseudo Point:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }
	    return (0);
	}

	tvalue = 0;
	if (card == BOCARD)
	{
            if ((signal > MAXBONO) || (signal < MINBONO))
	    {
                if (trace[link] & CONFIGURATIONTRACE)
                    logMsg("BOREAD: Illegal signal:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
		return (-1);
	    }

            if (resname != 0)
            { 
                register_resource(link, pbcu, resname, pointname);
            }

            pbcu->was_requested = TRUE;
            pbcu->binaryoutputs [blkix].was_requested = TRUE;

            if (!resresponse[link])
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Driver Offline:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }

            if (pbcu->holdflag)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: On Hold:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-2);
            }
            if (!pbcu->is_responding)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Not Responding:[%s] L=%d, A=%d, C=%d, S=%d\n",
                             pointname, link, adapter, card, signal);
                return (-1);
            }
            if (!pbcu->binaryoutputs [blkix].data_valid)
            {
                if (trace[link] & CALLREJECTTRACE)
                    logMsg("BOREAD: Data Not Valid:[%s] L=%d, A=%d, C=%d, S=%d\n",
                            pointname, link, adapter, card, signal);
                return (-1);
            }
	    tvalue = (unsigned long) pbcu->binaryoutputs [blkix].last_read;

	    *pvalue = tvalue;
            if (mltrace[link] == 9)
                logMsg("BOREAD: Data Returned:[%s] L=%d, A=%d, C=%d, S=%d, V=0x%x\n",
                        pointname, link, adapter, card, signal, pvalue);
	    return (0);
	}
	return (-1);
    }
/*                                                                                     
** register_resource                                                              	
**                                                                                	
**	This routine is used to initialize the resource pointers                  	
**  If this is the first time the resource for this line is being                  	
**  referenced the pointer to the resource table entry will be set                  	
**  and the resource name will be saved. If the resource name has                       
**  already been set, this routine will verify that all other points                 	
**  for this driver are using the same resource name.                                	
**                                                                                   	
*/                                                                                    	
/* this routine called from AIDRIVER, AODRIVER, AOREAD, BIDRIVER, BODRIVER,		
			    BOREAD, SIDRIVER, and SODRIVER.                             
*/                               	

static void  register_resource (unsigned short link, BCU *pbcu,
                                unsigned char *resname, char *pointname)
    {
	if (resnames[link][0] == 0) /* This is the first reference */
	{
	    if (resGetByName( resname, &prestable[link]) != RES_OK)
	    {
		logMsg ("Resource not found in table.(Point Name = %s, Resource Name = %s)\n",
                                pointname,
				resname );
	    }
	    else strcpy(resnames[link], resname);
	}
	else
	{
	    if (strcmp(resnames[link], resname) != 0)
	    {
		logMsg ("Resource name[%s] conflict.(Point Name = %s, Resource Name = %s)\n",
				resnames[link],
                                pointname,
				resname );
	    }
	}
    }
/*
**      Initialize the Queue                                        		
*/                                                                        	
/* called from MAIN */

static	void outqueinit (unsigned short line)
    {
	oq[line]->ooutix = oq[line]->oinix = 0;
    }
/*                                                                     		
**  ogetempty - get the next available slot on the output list         		
*/
/*    called from AODRIVER and BODRIVER   */

static	OUTQENT *ogetemptyp (unsigned short line)
    {
	if (((oq[line]->oinix + 1) % OUTQSIZE) != oq[line]->ooutix)
	{
	    return (&oq[line]->outque[oq[line]->oinix]);
	}
        if (mltrace[line] == 1)
		logMsg ( "Output Que Full line - %d\n",line);
	return (NULLP);
    }
/*                                                                    		
** omarkfull                                                          		
**      mark the next block as full                                     	
*/
/*  called from AODRIVER and BODRIVER   */

static	void omarkfull (unsigned short line)
	{
	    oq[line]->oinix = ((oq[line]->oinix + 1) % OUTQSIZE);
	}
/*                                                                      	
**  ogetnextp - get the next full slot on the output list               	
*/                                                                      	
/* only called from checkoutputs */

static	OUTQENT *ogetnextp (unsigned short line)
    {
	if (oq[line]->ooutix != oq[line]->oinix)
	{
	    return (&oq[line]->outque[oq[line]->ooutix]);
	}
	else return (NULLP);
    }
/*                                                       	               	
** oreleasefull - release the current full output block    	              	
*/                                                                            	
/* only called from checkoutputs */

static	void oreleasefull (unsigned short line)
    {
	if (oq[line]->ooutix == oq[line]->oinix)
		return;
	oq[line]->ooutix = ((oq[line]->ooutix + 1) % OUTQSIZE);
    }

/*
**                                                                              
**	allocate_bcu                                                            
**                                                                              
**	The purpose of this routine is to allocate the memory for the BCU       
**	data structure. If not successful, a console error message is printed  	
**	and an error flag is returned to the caller.                            
**	If successful, the newly allocated data structures are initialized.     
**                                                                             	
*/

static int allocate_bcu (unsigned short line)
   {
	BCU  *pbcu;

	pbcu = (BCU *)calloc(1,(sizeof(BCU)));
	if (!pbcu)
	{
		logMsg ("Unable to allocate memory for BCU data structure on line %d\n",line);
		 return(FALSE);
	}

        logMsg ("Allocated memory for BCU data structure on line %d\n",line);
        init_bcu_tab(line, pbcu);	     /*	initialize the data structures. */
        bcus[line] = pbcu;
	return(TRUE);
   }



/*
**      check_line_activity
**                                                                             	
**      The purpose of this routine is to determine if there has been any       
**      activity on the line, or to wait a finite amount of time and check.     
**      for a given line.                                                       
**                                                                             	
*/
/* only called from MAIN  */

static	int check_line_activity (unsigned short line, unsigned short predelay )
    {
/*	RX_FRAME        *rxp; */
	long            thistime;
	short		status;

        /* wait, if so requested */
        if (predelay != 0)
		taskDelay(predelay);
	thistime = tickGet();
        /* if we have called this routine 'recently', return TRUE if current or older is TRUE */
	if ((thistime - activity_time[line]) < ACTIVITYTIME)
		return (lastactivity[line] || (line_activity[line]));

        /* if we have NOT called this routine 'recently', return current status only */
	lastactivity[line] = status = line_activity[line]; /* get activity since last check */
	line_activity[line] = FALSE;
	activity_time[line] = thistime;

	return (status);
    }

/*                                                                                     
**      init_bcu_tab                                                                    
**                                                                                      
**      The purpose of this routine is to initialize the line tables for the            
**      analog devices I/O                                                              
**                                                                                      
*/
/* only called from allocate_bcu  */


static	void init_bcu_tab (unsigned short line, BCU  *pbcu)

    {
	pbcu->is_responding = FALSE;
	pbcu->holdflag = FALSE;
	pbcu->was_requested = FALSE;
	pbcu->cmd_force_offline = FALSE;

	initbcu(pbcu);
	initstats(pbcu);
        initdatalayer(pbcu);
        initnetworklayer(pbcu);
        initapplicationlayer(pbcu);

	/* Initialize this tasks semaphore*/
	semids[line][0]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
	semids[line][1]=semBCreate(SEM_Q_PRIORITY, SEM_EMPTY);
    }
/*                                                      
** Cold Init a BCU                                      
**                                                      
*/
/* only called from init_line_tabs  */

static void initbcu (BCU  *pbcu)
    {
	unsigned short i;

/*                                                                      
**      BINARY OUTPUTS ARE INITIALIZED AS READ WRITE VALUES            	
**      WRITES ARE TREATED BY INDIVIDUAL BITS NOT GROUPS       		
**              - NOT REQUESTED                                		
**              - READ BACK NOT VALID                             	
**              - NO NEW VALUES TO GO                                	
*/
	for (i=0; (i<NUMBCUBOS); i++)
	{
	    pbcu->binaryoutputs[i].was_requested = FALSE;
	    pbcu->binaryoutputs[i].data_valid = FALSE;
	    pbcu->binaryoutputs[i].last_read = 0;
	}

/*                                                                 	
**      BINARY INPUTS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID	
*/
	for (i=0; (i<NUMBCUBIS); i++)
	{
	    pbcu->binaryinputs[i].was_requested = FALSE;
	    pbcu->binaryinputs[i].data_valid = FALSE;
	}

/*                                                                 	
**      ANALOG INS ARE INITIALIZED AS NOT REQUESTED AND NOT VALID    	
*/
	for (i=0; (i<NUMBCUAIS); i++)
	{
	    pbcu->analoginputs[i].was_requested = FALSE;
	    pbcu->analoginputs[i].data_valid = FALSE;
	}

/*                                                             		
**      REGISTERS ARE INITIALIZED AS READ WRITE VALUES             	
**      WRITES ARE TREATED BY INDIVIDUAL REGISTERS NOT GROUPS      	
**              - NOT REQUESTED                                    	
**              - READ BACK NOT VALID                              	
**              - NO NEW VALUES TO GO                               	
*/                                                                  	
	for (i=0; (i<NUMBCUAOS); i++)
	{
	    pbcu->analogoutputs[i].was_requested = FALSE;
	    pbcu->analogoutputs[i].data_valid = FALSE;
	}
    }

/*
**                                                              	
** initialize the statistics for a Trane BCU                            
**                                                              	
*/                                                               	
/* called from AODRIVER, BODRIVER, and init_line_tabs  */

static	void initstats (BCU *pbcu)
    {
	pbcu->no_dataout_msgs = 0;  /* 5  Count Output Msgs 		*/
	pbcu->no_datain_msgs = 0;   /* 6  Count Data Requests 		*/
	pbcu->no_rxnoresp = 0;      /* 7  Count No Responses 		*/
	pbcu->no_txnoresp = 0;      /* 8  Count No Responses 		*/
	pbcu->no_dataerr = 0;       /* 9  Count Message Echo Errors 	*/
	pbcu->no_retries = 0;       /* 10 Count Retries 		*/
	pbcu->no_rxhwerrs = 0;      /* 11 Count Comm Hardware Errors	*/
	pbcu->no_txhwerrs = 0;      /* 12 Count Comm Hardware Errors 	*/
	pbcu->no_crcerrs = 0;       /* 13 Count CRC Errors 		*/
	pbcu->no_offlines = 0;      /* 14 Count Off Line Transitions 	*/
	pbcu->badoutcnt = 0;	    /* 17 Count failed output commands 	*/
    }
/*
**     prepresponses                                                            
**                                                                             	
**      The purpose of this routine is to mark the PLCs as on hold and the    	
**	data as not valid until read again from the PLC                       	
**                                                                           	
*/
/* only called from MAIN */

static	void prepresponses (unsigned short line)

    {
	BCU  *pbcu;

        pbcu = bcus[line];
        pbcu->holdflag = TRUE;
	mark_not_valid(pbcu);
    }





/*                                                                  	
**      any_responding                                               	
**                                                                   	
**      The purpose of this routine is to see if any units are       	
**	responding on this line                                      	
**                                                                   	
*/
/* only called from MAIN */

static	int any_responding (unsigned short line)

    {
	BCU  *pbcu;
        pbcu = bcus[line];
        /* check cmd_force_offline flag because it is set in an asynchronous task */
        if ((pbcu->is_responding) && (!pbcu->cmd_force_offline))
        {
            return(TRUE);
        }
	return(FALSE);
    }

/********************************/
/********************************/
/*** NEWCODE ********************/
/********************************/
/********************************/
/* application layer procedures */
/********************************/
/********************************/
/********************************/
/********************************/
/*
**                                                              	
** initialize the Application Layer State Machines                      
**                                                              	
*/                                                               	
/* called from init_line_tabs  */

static	void initapplicationlayer (BCU *pbcu)
    {
        TSM    *tsmp;

        tsmp = &pbcu->clientTSM;
	tsmp->state = TSM_IDLE;     /* no messages pending, waiting to send a PDU    */

        tsmp = &pbcu->serverTSM;
	tsmp->state = TSM_IDLE;     /* no messages pending, waiting to receive a PDU */
    }

/*
** Readbinaryoutputs
**                                                                       
**      attempts to read all of the points requested. if the points      
**      cannot be read, then it returns FALSE.                           
*/
unsigned short readbinaryoutputs (unsigned short line, BCU *pbcu)

/* only called from scan_bcu */
{
    unsigned short  i, atleastone, readcount, saveindex, status;
    unsigned char   tagnumber, taglength;
    unsigned long   oi;
    unsigned short  results;


    TSM            *tsmp;

    if (skip[line] & SKIPBO)
    {
        if (trace[line] & APPLICATIONTRACE)
            logMsg("Skipping binary outputs...\n");
        taskDelay(30);
        manage_output_state(line, pbcu);
        return(TRUE);
    }

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

    /* verify proper transaction state. there should be nothing pending. */
    if (tsmp->state != TSM_IDLE)
    {
        /* print state machine failure message. should never happen. if it does, get out. */
        if (trace[line] & APPLICATIONTRACE)
            logMsg("clientTSM->state: expected == TSM_IDLE, actual == 0x%x\n", tsmp->state);
        taskDelay(60);
        return(FALSE);
    }

    /* define the Transaction State Machine Parameters. */
    tsmp->state = TSM_AWAIT_CONFIRMATION; 
    tsmp->confirmation = TSM_NOTCONFIRMED;

    /* Format the APDU output message */
    tsmp->Index = 0;
    tsmp->OutputBuffer[tsmp->Index++] =  ConfirmedRequest_PDU |
                                         NotSegmentedMessage |
                                         NoMoreFollows |
                                         SegmentedResponseNotAccepted;
    tsmp->OutputBuffer[tsmp->Index++] =  MaxADPUResponseSize;

    tsmp->OutputBuffer[tsmp->Index++] =  InvokeID[line];
    tsmp->OutputBuffer[tsmp->Index++] =  ReadPropertyMultiple_Request;

    /* the header of this buffer will be reused if more than one request is generated. */
    saveindex = tsmp->Index;

    /* build list of non-contiguous binary output object identifiers. */
    atleastone = FALSE;
    readcount = 0;

    for (i = 0; i < NUMBCUBOS; i++)
    {
        if (pbcu->binaryoutputs[i].was_requested)
        {
            atleastone = TRUE;
            readcount++;
            tagnumber = RAS_objectIdentifier;
            taglength = 3; /* primitive 3 octet value */
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);

            oi = (0 << 23) + (BAC_BinaryOutput << 14) + i;
            tsmp->OutputBuffer[tsmp->Index++] = (oi >> 16);       /* msb of object identifier   */
            tsmp->OutputBuffer[tsmp->Index++] = (oi >> 8) % 256;  /* msb-1 of object identifier */
            tsmp->OutputBuffer[tsmp->Index++] = (oi % 256);       /* lsb of object identifier   */

            /* Open Tag for List of Properties */
            tagnumber = RAS_listOfPropertyReferences;
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | OpeningTag);

                /* Context Tag for Item */
                tagnumber = BACnetPR_propertyIdentifier;
                taglength = 1; /* primitive 1 octet value */
                tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);
                tsmp->OutputBuffer[tsmp->Index++] = BACnetPI_present_value;

            /* Close Tag for List of Properties */
            tagnumber = RAS_listOfPropertyReferences;
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | ClosingTag);
        }
        /* see if we have enough to send a multiple request now. */
        if (readcount > 9)
        {
            /* re-assert definitions of the Transaction State Machine Parameters. */
            tsmp->state = TSM_AWAIT_CONFIRMATION; 
            tsmp->confirmation = TSM_NOTCONFIRMED;

            tsmp->DataLength = tsmp->Index - 1;
            status = launch_read(line, pbcu);
            if (status != TRUE)
            {
                pbcu->no_offlines++;
                pbcu->holdflag = TRUE;
                pbcu->is_responding = FALSE;
                return(status);
            }
            readcount = 0;
            atleastone = FALSE;
            tsmp->Index = saveindex;
        }
    }
    /* re-assert definitions of the Transaction State Machine Parameters. */
    tsmp->state = TSM_AWAIT_CONFIRMATION; 
    tsmp->confirmation = TSM_NOTCONFIRMED;

    tsmp->DataLength = tsmp->Index - 1;

    /* if no binary outputs objects requested, return without error. */
    if (atleastone == FALSE)
    {
        tsmp->state = TSM_IDLE;
        return(TRUE);
    }
    status = launch_read(line, pbcu);
    if (status != TRUE)
    {
        pbcu->no_offlines++;
        pbcu->holdflag = TRUE;
        pbcu->is_responding = FALSE;
    }
    return(status);
}


/*
** readbinaryinputs
**                                                                       
**      attempts to read all of the points requested. if the points      
**      cannot be read, then it returns FALSE.                           
*/
static	unsigned short readbinaryinputs (unsigned short line, BCU *pbcu)

/* only called from scan_bcu */
{
    unsigned short  i, atleastone, readcount, saveindex, status;
    unsigned char   tagnumber, taglength;
    unsigned long   oi;

    TSM            *tsmp;

    if (skip[line] & SKIPBI)
    {
        if (trace[line] & APPLICATIONTRACE)
            logMsg("Skipping binary inputs...\n");
        taskDelay(30);
        manage_output_state(line, pbcu);
        return(TRUE);
    }

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

    /* verify proper transaction state. there should be nothing pending. */
    if (tsmp->state != TSM_IDLE)
    {
        /* print state machine failure message. should never happen. if it does, get out. */
        if (trace[line] & APPLICATIONTRACE)
            logMsg("clientTSM->state: expected == TSM_IDLE, actual == 0x%x\n", tsmp->state);
        return(FALSE);
    }

    /* define the Transaction State Machine Parameters. */
    tsmp->state = TSM_AWAIT_CONFIRMATION; 
    tsmp->confirmation = TSM_NOTCONFIRMED;

    /* Format the APDU output message */
    tsmp->Index = 0;
    tsmp->OutputBuffer[tsmp->Index++] =  ConfirmedRequest_PDU |
                                         NotSegmentedMessage |
                                         NoMoreFollows |
                                         SegmentedResponseNotAccepted;
    tsmp->OutputBuffer[tsmp->Index++] =  MaxADPUResponseSize;

    tsmp->OutputBuffer[tsmp->Index++] =  InvokeID[line];
    tsmp->OutputBuffer[tsmp->Index++] =  ReadPropertyMultiple_Request;

    /* the header of this buffer will be reused if more than one request is generated. */
    saveindex = tsmp->Index;

    /* build list of non-contiguous binary input object identifiers. */
    atleastone = FALSE;
    readcount = 0;

    for (i = 0; i < NUMBCUBIS; i++)
    {
        if (pbcu->binaryinputs[i].was_requested)
        {
            atleastone = TRUE;
            readcount++;
            tagnumber = RAS_objectIdentifier;
            taglength = 3; /* primitive 3 octet value */
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);

            oi = (0 << 23) + (BAC_BinaryInput << 14) + i;
            tsmp->OutputBuffer[tsmp->Index++] = (oi >> 16);       /* msb of object identifier   */
            tsmp->OutputBuffer[tsmp->Index++] = (oi >> 8) % 256;  /* msb-1 of object identifier */
            tsmp->OutputBuffer[tsmp->Index++] = (oi % 256);       /* lsb of object identifier   */

            /* Open Tag for List of Properties */
            tagnumber = RAS_listOfPropertyReferences;
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | OpeningTag);

                /* Context Tag for Item */
                tagnumber = BACnetPR_propertyIdentifier;
                taglength = 1; /* primitive 1 octet value */
                tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);
                tsmp->OutputBuffer[tsmp->Index++] = BACnetPI_present_value;

            /* Close Tag for List of Properties */
            tagnumber = RAS_listOfPropertyReferences;
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | ClosingTag);
        }
        /* see if we have enough to send a multiple request now. */
        if (readcount > 9)
        {
            /* re-assert definitions of the Transaction State Machine Parameters. */
            tsmp->state = TSM_AWAIT_CONFIRMATION; 
            tsmp->confirmation = TSM_NOTCONFIRMED;

            tsmp->DataLength = tsmp->Index - 1;
            status = launch_read(line, pbcu);
            if (status != TRUE)
            {
                pbcu->no_offlines++;
                pbcu->holdflag = TRUE;
                pbcu->is_responding = FALSE;
                return(status);
            }
            readcount = 0;
            atleastone = FALSE;
            tsmp->Index = saveindex;
        }
    }
    /* re-assert definitions of the Transaction State Machine Parameters. */
    tsmp->state = TSM_AWAIT_CONFIRMATION; 
    tsmp->confirmation = TSM_NOTCONFIRMED;

    tsmp->DataLength = tsmp->Index - 1;

    /* if no DI objects requested, return without error. */
    if (atleastone == FALSE)
    {
        tsmp->state = TSM_IDLE;
        return(TRUE);
    }
    status = launch_read(line, pbcu);
    if (status != TRUE)
    {
        pbcu->no_offlines++;
        pbcu->holdflag = TRUE;
        pbcu->is_responding = FALSE;
    }
    return(status);
}
/*
** readanaloginputs
**                                                                       
**      attempts to read all of the points requested. if the points      
**      cannot be read, then it returns FALSE.                           
*/
static	unsigned short readanaloginputs (unsigned short line, BCU *pbcu)

/* only called from scan_bcu */
{
    unsigned short  i, atleastone, readcount, saveindex, status;
    unsigned char   tagnumber, taglength;
    unsigned long   oi;

    TSM            *tsmp;

    if (skip[line] & SKIPAI)
    {
        if (trace[line] & APPLICATIONTRACE)
            logMsg("Skipping analog inputs...\n");
        taskDelay(30);
        manage_output_state(line, pbcu);
        return(TRUE);
    }

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

    /* verify proper transaction state. there should be nothing pending. */
    if (tsmp->state != TSM_IDLE)
    {
        /* print state machine failure message. should never happen. if it does, get out. */
        if (trace[line] & APPLICATIONTRACE)
            logMsg("clientTSM->state: expected == TSM_IDLE, actual == 0x%x\n", tsmp->state);
        return(FALSE);
    }

    /* define the Transaction State Machine Parameters. */
    tsmp->state = TSM_AWAIT_CONFIRMATION; 
    tsmp->confirmation = TSM_NOTCONFIRMED;

    /* Format the APDU output message */
    tsmp->Index = 0;
    tsmp->OutputBuffer[tsmp->Index++] =  ConfirmedRequest_PDU |
                                         NotSegmentedMessage |
                                         NoMoreFollows |
                                         SegmentedResponseNotAccepted;
    tsmp->OutputBuffer[tsmp->Index++] =  MaxADPUResponseSize;

    tsmp->OutputBuffer[tsmp->Index++] =  InvokeID[line];
    tsmp->OutputBuffer[tsmp->Index++] =  ReadPropertyMultiple_Request;

    /* the header of this buffer will be reused if more than one request is generated. */
    saveindex = tsmp->Index;

    /* build list of non-contiguous analog input object identifiers. */
    atleastone = FALSE;
    readcount = 0;

    for (i = 0; i < NUMBCUAIS; i++)
    {
        if (pbcu->analoginputs[i].was_requested)
        {
            atleastone = TRUE;
            readcount++;
            tagnumber = RAS_objectIdentifier;
            taglength = 3; /* primitive 3 octet value */

            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);

            oi = (0 << 23) + (BAC_AnalogInput << 14) + i;
            tsmp->OutputBuffer[tsmp->Index++] = (oi >> 16);       /* msb of object identifier   */
            tsmp->OutputBuffer[tsmp->Index++] = (oi >> 8) % 256;  /* msb-1 of object identifier */
            tsmp->OutputBuffer[tsmp->Index++] = (oi % 256);       /* lsb of object identifier   */

            /* Open Tag for List of Properties */
            tagnumber = RAS_listOfPropertyReferences;
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | OpeningTag);

                /* Context Tag for Item */
                tagnumber = BACnetPR_propertyIdentifier;
                taglength = 1; /* primitive 1 octet value */
                tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);
                tsmp->OutputBuffer[tsmp->Index++] = BACnetPI_present_value;

            /* Close Tag for List of Properties */
            tagnumber = RAS_listOfPropertyReferences;
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | ClosingTag);
        }
        /* see if we have enough to send a multiple request now. */
        if (readcount > 9)
        {
            /* re-assert definitions of the Transaction State Machine Parameters. */
            tsmp->state = TSM_AWAIT_CONFIRMATION; 
            tsmp->confirmation = TSM_NOTCONFIRMED;

            tsmp->DataLength = tsmp->Index - 1;
            status = launch_read(line, pbcu);
            if (status != TRUE)
            {
                pbcu->no_offlines++;
                pbcu->holdflag = TRUE;
                pbcu->is_responding = FALSE;
                return(status);
            }
            readcount = 0;
            atleastone = FALSE;
            tsmp->Index = saveindex;
        }
    }
    /* re-assert definitions of the Transaction State Machine Parameters. */
    tsmp->state = TSM_AWAIT_CONFIRMATION; 
    tsmp->confirmation = TSM_NOTCONFIRMED;

    tsmp->DataLength = tsmp->Index - 1;

    /* if no AI objects requested, return without error. */
    if (atleastone == FALSE)
    {
        tsmp->state = TSM_IDLE;
        return(TRUE);
    }
    status = launch_read(line, pbcu);
    if (status != TRUE)
    {
        pbcu->no_offlines++;
        pbcu->holdflag = TRUE;
        pbcu->is_responding = FALSE;
    }
    return(status);
}
/*
** readanalogoutputs
**                                                                       
**      attempts to read all of the points requested. if the points      
**      cannot be read, then it returns FALSE.                           
*/
static	unsigned short readanalogoutputs (unsigned short line, BCU *pbcu)

/* only called from scan_bcu */
{
    unsigned short  i, atleastone, readcount, saveindex, status;
    unsigned char   tagnumber, taglength;
    unsigned long   oi;

    TSM            *tsmp;

    if (skip[line] & SKIPAO)
    {
        if (trace[line] & APPLICATIONTRACE)
            logMsg("Skipping analog outputs...\n");
        taskDelay(30);
        manage_output_state(line, pbcu);
        return(TRUE);
    }

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

    /* verify proper transaction state. there should be nothing pending. */
    if (tsmp->state != TSM_IDLE)
    {
        /* print state machine failure message. should never happen. if it does, get out. */
        if (trace[line] & APPLICATIONTRACE)
            logMsg("clientTSM->state: expected == TSM_IDLE, actual == 0x%x\n", tsmp->state);
        return(FALSE);
    }

    /* define the Transaction State Machine Parameters. */
    tsmp->state = TSM_AWAIT_CONFIRMATION; 
    tsmp->confirmation = TSM_NOTCONFIRMED;

    /* Format the APDU output message */
    tsmp->Index = 0;
    tsmp->OutputBuffer[tsmp->Index++] =  ConfirmedRequest_PDU |
                                         NotSegmentedMessage |
                                         NoMoreFollows |
                                         SegmentedResponseNotAccepted;
    tsmp->OutputBuffer[tsmp->Index++] =  MaxADPUResponseSize;

    tsmp->OutputBuffer[tsmp->Index++] =  InvokeID[line];
    tsmp->OutputBuffer[tsmp->Index++] =  ReadPropertyMultiple_Request;

    /* the header of this buffer will be reused if more than one request is generated. */
    saveindex = tsmp->Index;

    /* build list of non-contiguous analog output object identifiers. */
    atleastone = FALSE;
    readcount = 0;

    for (i = 0; i < NUMBCUAOS; i++)
    {
        if (pbcu->analogoutputs[i].was_requested)
        {
            atleastone = TRUE;
            readcount++;
            tagnumber = RAS_objectIdentifier;
            taglength = 3; /* primitive 3 octet value */
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);

            oi = (0 << 23) + (BAC_AnalogOutput << 14) + i;
            tsmp->OutputBuffer[tsmp->Index++] = (oi >> 16);       /* msb of object identifier   */
            tsmp->OutputBuffer[tsmp->Index++] = (oi >> 8) % 256;  /* msb-1 of object identifier */
            tsmp->OutputBuffer[tsmp->Index++] = (oi % 256);       /* lsb of object identifier   */

            /* Open Tag for List of Properties */
            tagnumber = RAS_listOfPropertyReferences;
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | OpeningTag);

                /* Context Tag for Item */
                tagnumber = BACnetPR_propertyIdentifier;
                taglength = 1; /* primitive 1 octet value */
                tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);
                tsmp->OutputBuffer[tsmp->Index++] = BACnetPI_present_value;

            /* Close Tag for List of Properties */
            tagnumber = RAS_listOfPropertyReferences;
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | ClosingTag);
        }
        /* see if we have enough to send a multiple request now. */
        if (readcount > 9)
        {
            /* re-assert definitions of the Transaction State Machine Parameters. */
            tsmp->state = TSM_AWAIT_CONFIRMATION; 
            tsmp->confirmation = TSM_NOTCONFIRMED;

            tsmp->DataLength = tsmp->Index - 1;
            status = launch_read(line, pbcu);
            if (status != TRUE)
            {
                pbcu->no_offlines++;
                pbcu->holdflag = TRUE;
                pbcu->is_responding = FALSE;
                return(status);
            }
            readcount = 0;
            atleastone = FALSE;
            tsmp->Index = saveindex;
        }
    }
    /* re-assert definitions of the Transaction State Machine Parameters. */
    tsmp->state = TSM_AWAIT_CONFIRMATION; 
    tsmp->confirmation = TSM_NOTCONFIRMED;

    tsmp->DataLength = tsmp->Index - 1;

    /* if no REG objects requested, return without error. */
    if (atleastone == FALSE)
    {
        tsmp->state = TSM_IDLE;
        return(TRUE);
    }
    status = launch_read(line, pbcu);
    if (status != TRUE)
    {
        pbcu->no_offlines++;
        pbcu->holdflag = TRUE;
        pbcu->is_responding = FALSE;
    }
    return(status);
}
/*
** launch_read                                                      	 
**                                                                       
**      attempts to read all of the points requested. if the points      
**      cannot be read, then it returns FALSE.                           
*/
static	unsigned short launch_read (unsigned short line, BCU *pbcu)
{
    TSM            *tsmp;
    APPINPUT       *appinp;

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

    /* Set up pointer to application pdu buffer. */
    appinp = &pbcu->application_input;

    /* Count number of data request messages */
    pbcu->no_datain_msgs++;

    /* verify proper transaction state. there should be nothing pending. */
    if (tsmp->state != TSM_AWAIT_CONFIRMATION)
    {
        /* print state machine failure message. */
        if (trace[line] & APPLICATIONTRACE)
            logMsg("clientTSM->state: expected = TSM_AWAIT_CONFIRMATION, actual = 0x%x\n", tsmp->state);
        /* should never happen. if it does, get out. */
        return(FALSE);
    }

    /**********************************************************/
    /* call the network layer to 'address' and send the data. */
    /**********************************************************/

    /* protocol allows for optional retry logic at the application level. */
    /* if we implement it, we'll do it here.                              */


    tsmp->starttime = tickGet();         /* store time stamp for starting.                      */

    if (build_NPDU(line, pbcu) == TRUE)  /* this is application level message, indicating       */
                                         /* that the message was transmitted successfully.      */ 
    {
        while (tsmp->state != TSM_IDLE)  /* wait for the response to be received properly.      */
        {
            taskDelay(1);

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            process_inputAPDU(line);     /* look to see if app level messages were passed 'up'  */
                                         /* to this level by processNPDU. if no, get out.       */
                                         /* if yes, process them. processing consists of state  */
                                         /* management and sending Abort commands as needed.    */
                                         /* It also consists of state management, parsing the   */
                                         /* responses to data requests and storing the values.  */

            if ((tickGet() - tsmp->starttime) > T_APDU_TIMEOUT) /* check for response timeout. */
            {
                tsmp->state = TSM_IDLE;
                tsmp->status = TSM_TIMEOUT;
                tsmp->confirmation = TSM_NOTCONFIRMED;
                /* print timeout message. during testing, always print message. */
                if (trace[line] & APPLICATIONTRACE)
                    logMsg("RPM: confirmed response timeout\n");
                return(FALSE);
            }
        }
        if (tsmp->confirmation == TSM_CONFIRMED)
        {
            /* we got the response type we were expecting. There is an ADPU in the application  */
            /* input buffer. Complete verification of a successful read, then exit.             */
            if (tsmp->status != TSM_COMPLEX_ACK)
            {
                if (trace[line] & APPLICATIONTRACE)
                    logMsg("RPM: expected response was COMPLEX_ACK, actual response was 0x%x.\n",
                            appinp->InputBuffer[0]);
                return(FALSE);
            }
            if (appinp->InputBuffer[1] != tsmp->invokeID)
            {
                if (trace[line] & APPLICATIONTRACE)
                    logMsg("RPM: request invokeID = 0x%x. response invokeID = 0x%x.\n",
                            tsmp->invokeID, appinp->InputBuffer[1]);
                return(FALSE);
            }
            if (appinp->InputBuffer[2] != ReadPropertyMultiple_ACK)
            {
                if (trace[line] & APPLICATIONTRACE)
                    logMsg("RPM: expected response Choice was ReadPropertyMultiple, actual was 0x%x\n",
                            appinp->InputBuffer[2]);
                return(FALSE);
            }
            /* we got the response we were expecting. There is an ADPU in the application input */
            /* buffer. Parse it and store the results. This will be a seperate routine.         */
/*            if (trace[line] & APPLICATIONTRACE)
            {
                logMsg("parseAPDU: pre-call in launch_read.\n");
                taskDelay(30);
            }
*/
            parseAPDU(line, pbcu);
/*            if (trace[line] & APPLICATIONTRACE)
            {
                logMsg("parseAPDU: post-call in launch_read.\n");
                taskDelay(30);
            }
*/
            return (TRUE);
        }
        if (tsmp->confirmation == TSM_NOTCONFIRMED)
        {
            /* something went wrong. didn't like the command, abort. something. */
            if (trace[line] & APPLICATIONTRACE)
                logMsg("RPM: expected response was COMPLEX_ACK, actual response was 0x%x.\n",
                        appinp->InputBuffer[0]);
            return(FALSE);
        }
    }
    else /* build_NPDU was FALSE */
    {
        if (trace[line] & APPLICATIONTRACE)
            logMsg("RPM: send_confirmed: incomplete transaction.\n");
        tsmp->state = TSM_IDLE;  /* since it failed, set state back to IDLE.      */
        return(FALSE);
    }
}
/*
**                                                                      
** Setbinaryoutput
**                                                                 	
*/
static	unsigned short setbinaryoutput (unsigned short line,
			 BCU *pbcu, unsigned short bitaddr,
			 unsigned long mask, unsigned long val)

/* only called from checkoutputs */
{
    unsigned char   tagnumber, taglength;
    unsigned long   oi;
    unsigned short  status;
    unsigned long   outputvalue;

    TSM            *tsmp;

    /* convert output from zero/non-zero to zero/one */
    outputvalue = (mask & val)?1:0;

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

    /* verify proper transaction state. there should be nothing pending. */
    if (tsmp->state != TSM_IDLE)
    {
        /* print state machine failure message. should never happen. if it does, get out. */
        if (trace[line] & APPLICATIONTRACE)
            logMsg("clientTSM->state: expected == TSM_IDLE, actual == 0x%x\n", tsmp->state);
        return(FALSE);
    }

    /* define the Transaction State Machine Parameters. */
    tsmp->state = TSM_AWAIT_CONFIRMATION; 
    tsmp->confirmation = TSM_NOTCONFIRMED;

    /* Format the APDU output message */
    tsmp->Index = 0;
    tsmp->OutputBuffer[tsmp->Index++] =  ConfirmedRequest_PDU |
                                         NotSegmentedMessage |
                                         NoMoreFollows |
                                         SegmentedResponseNotAccepted;
    tsmp->OutputBuffer[tsmp->Index++] =  MaxADPUResponseSize;

    tsmp->OutputBuffer[tsmp->Index++] =  InvokeID[line];
    tsmp->OutputBuffer[tsmp->Index++] =  WritePropertyMultiple_Request;

    /*********************************************************************************************/

    /* Context Tag: Object Identifier */
    tagnumber = WAS_objectIdentifier;
    taglength = 3; /* primitive 3 octet value */
    tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);

    oi = (0 << 23) + (BAC_BinaryOutput << 14) + bitaddr;
    tsmp->OutputBuffer[tsmp->Index++] = (oi >> 16);       /* msb of object identifier   */
    tsmp->OutputBuffer[tsmp->Index++] = (oi >> 8) % 256;  /* msb-1 of object identifier */
    tsmp->OutputBuffer[tsmp->Index++] = (oi % 256);       /* lsb of object identifier   */

    /* Context Tag: Open Tag: BACnetPropertyValue - List of Properties */
    tagnumber = WAS_listOfProperties;
    tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | OpeningTag);

        /* Context Tag: Property Identifier */
        tagnumber = BACnetPV_propertyIdentifier;
        taglength = 1; /* primitive 1 octet value */
        tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);
        tsmp->OutputBuffer[tsmp->Index++] = BACnetPI_present_value;

        /* Context Tag: Open Tag: Property Value */
        tagnumber = BACnetPV_value;
        tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | OpeningTag);

            /* Application Tag for Item */
            tagnumber = ApplicationEnumerated;
            taglength = 1;
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ApplicationTag | taglength);
            tsmp->OutputBuffer[tsmp->Index++] = (outputvalue % 256);

        /* Context Tag: Close Tag: Property Value */
        tagnumber = BACnetPV_value;
        tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | ClosingTag);

        /* Context Tag: Property Priority */
        tagnumber = BACnetPV_priority;
        taglength = 1; /* primitive 1 octet value */
        tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);
        tsmp->OutputBuffer[tsmp->Index++] = DefaultWritePriority;

    /* Context Tag: Close Tag: BACnetPropertyValue - List of Properties */
    tagnumber = WAS_listOfProperties;
    tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | ClosingTag);

    /*********************************************************************************************/


    tsmp->DataLength = tsmp->Index - 1;

    status = launch_write(line, pbcu);
    if (status != TRUE)
    {
        pbcu->no_offlines++;
        pbcu->holdflag = TRUE;
        pbcu->is_responding = FALSE;
    }
    return(status);
}

/*
** Setanalogoutput
**                                                                  	
*/
static	unsigned short setanalogoutput (unsigned short line,
			 BCU *pbcu, unsigned short analogoutputaddr,
			 unsigned short val, double dblval, unsigned short conv)
{
    unsigned char   tagnumber, taglength;
    unsigned long   oi;
    unsigned short  status;
    union u_value {
                    short		ivalue;
                    long		lvalue;
                    float		fvalue;
                    double		dvalue;
                    char		afvalue[100];
                  }  uval;

    TSM            *tsmp;

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

    /* verify proper transaction state. there should be nothing pending. */
    if (tsmp->state != TSM_IDLE)
    {
        /* print state machine failure message. should never happen. if it does, get out. */
        if (trace[line] & APPLICATIONTRACE)
            logMsg("clientTSM->state: expected == TSM_IDLE, actual == 0x%x\n", tsmp->state);
        return(FALSE);
    }

    uval.fvalue = dblval;

    /* define the Transaction State Machine Parameters. */
    tsmp->state = TSM_AWAIT_CONFIRMATION; 
    tsmp->confirmation = TSM_NOTCONFIRMED;

    /* Format the APDU output message */
    tsmp->Index = 0;
    tsmp->OutputBuffer[tsmp->Index++] =  ConfirmedRequest_PDU |
                                         NotSegmentedMessage |
                                         NoMoreFollows |
                                         SegmentedResponseNotAccepted;
    tsmp->OutputBuffer[tsmp->Index++] =  MaxADPUResponseSize;

    tsmp->OutputBuffer[tsmp->Index++] =  InvokeID[line];
    tsmp->OutputBuffer[tsmp->Index++] =  WritePropertyMultiple_Request;

    /*********************************************************************************************/

    /* Context Tag: Object Identifier */
    tagnumber = WAS_objectIdentifier;
    taglength = 3; /* primitive 3 octet value */
    tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);

    oi = (0 << 23) + (BAC_AnalogOutput << 14) + analogoutputaddr;
    tsmp->OutputBuffer[tsmp->Index++] = (oi >> 16);       /* msb of object identifier   */
    tsmp->OutputBuffer[tsmp->Index++] = (oi >> 8) % 256;  /* msb-1 of object identifier */
    tsmp->OutputBuffer[tsmp->Index++] = (oi % 256);       /* lsb of object identifier   */

    /* Context Tag: Open Tag: BACnetPropertyValue - List of Properties */
    tagnumber = WAS_listOfProperties;
    tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | OpeningTag);

        /* Context Tag: Property Identifier */
        tagnumber = BACnetPV_propertyIdentifier;
        taglength = 1; /* primitive 1 octet value */
        tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);
        tsmp->OutputBuffer[tsmp->Index++] = BACnetPI_present_value;

        /* Context Tag: Open Tag: Property Value */
        tagnumber = BACnetPV_value;
        tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | OpeningTag);

            /* Application Tag for Item */
            tagnumber = ApplicationReal;
            taglength = 4;
            tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ApplicationTag | taglength);
            tsmp->OutputBuffer[tsmp->Index++] = (uval.lvalue >> 24) & 0xFF;
            tsmp->OutputBuffer[tsmp->Index++] = (uval.lvalue >> 16) & 0xFF;
            tsmp->OutputBuffer[tsmp->Index++] = (uval.lvalue >>  8) & 0xFF;
            tsmp->OutputBuffer[tsmp->Index++] = (uval.lvalue >>  0) & 0xFF;

        /* Context Tag: Close Tag: Property Value */
        tagnumber = BACnetPV_value;
        tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | ClosingTag);

        /* Context Tag: Property Priority */
        tagnumber = BACnetPV_priority;
        taglength = 1; /* primitive 1 octet value */
        tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | taglength);
        tsmp->OutputBuffer[tsmp->Index++] = DefaultWritePriority;

    /* Context Tag: Close Tag: BACnetPropertyValue - List of Properties */
    tagnumber = WAS_listOfProperties;
    tsmp->OutputBuffer[tsmp->Index++] = ((tagnumber << 4) | ContextTag | ClosingTag);

    /*********************************************************************************************/


    tsmp->DataLength = tsmp->Index - 1;

    status = launch_write(line, pbcu);
    if (status != TRUE)
    {
        pbcu->no_offlines++;
        pbcu->holdflag = TRUE;
        pbcu->is_responding = FALSE;
    }
    return(status);
}
/*
** launch_write                                                      	 
**                                                                       
**      attempts to write the requested point object. if the point       
**      cannot be written, then it returns FALSE.                        
*/
static	unsigned short launch_write (unsigned short line, BCU *pbcu)
{
/*    unsigned short  i, atleastone; */
/*    unsigned char   tagnumber, taglength; */

    TSM            *tsmp;
    APPINPUT       *appinp;

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

    /* Set up pointer to application pdu buffer. */
    appinp = &pbcu->application_input;

    /* Count number of data output messages */
    pbcu->no_dataout_msgs++;

    /* verify proper transaction state. there should be nothing pending. */
    if (tsmp->state != TSM_AWAIT_CONFIRMATION)
    {
        /* print state machine failure message. should never happen. if it does, get out. */
        if (trace[line] & APPLICATIONTRACE)
            logMsg("clientTSM->state: expected = TSM_AWAIT_CONFIRMATION, actual = 0x%x\n", tsmp->state);
        return(FALSE);
    }

    /**********************************************************/
    /* call the network layer to 'address' and send the data. */
    /**********************************************************/

    /* protocol allows for optional retry logic at the application level. */
    /* if we implement it, we'll do it here.                              */


    tsmp->starttime = tickGet();         /* store time stamp for starting.                      */

    if (build_NPDU(line, pbcu) == TRUE)  /* this is application level message, indicating       */
                                         /* that the message was transmitted successfully.      */ 
    {
        while (tsmp->state != TSM_IDLE)  /* wait for the response to be received properly.      */
        {
            taskDelay(1);

            /******************************/
            tisWatchDogPulse(watchdogId[line]);
            /******************************/

            process_inputAPDU(line);     /* look to see if app level messages were passed 'up'  */
                                         /* to this level by processNPDU. if no, get out.       */
                                         /* if yes, process them. processing consists of state  */
                                         /* management and sending Abort commands as needed.    */
                                         /* It also consists of state management, parsing the   */
                                         /* responses to data requests and storing the values.  */

            if ((tickGet() - tsmp->starttime) > T_APDU_TIMEOUT) /* check for response timeout. */
            {
                tsmp->state = TSM_IDLE;
                tsmp->status = TSM_TIMEOUT;
                tsmp->confirmation = TSM_NOTCONFIRMED;
                /* print timeout message. during testing, always print message. */
                if (trace[line] & APPLICATIONTRACE)
                    logMsg("WPM: confirmed response timeout\n");
                return(FALSE);
            }
        }
        if (tsmp->confirmation == TSM_CONFIRMED)
        {
            /* we got the response type we were expecting. There is an ADPU in the application  */
            /* input buffer. Complete verification of a successful write, then exit.            */
            if (tsmp->status != TSM_SIMPLE_ACK)
            {
                if (trace[line] & APPLICATIONTRACE)
                    logMsg("WPM: expected response was SIMPLE_ACK, actual response was 0x%x.\n",
                            appinp->InputBuffer[0]);
                return(FALSE);
            }
            if (appinp->InputBuffer[1] != tsmp->invokeID)
            {
                if (trace[line] & APPLICATIONTRACE)
                    logMsg("WPM: request invokeID = 0x%x. response invokeID = 0x%x.\n",
                            tsmp->invokeID, appinp->InputBuffer[1]);
                return(FALSE);
            }
            if (appinp->InputBuffer[2] != WritePropertyMultiple_ACK)
            {
                if (trace[line] & APPLICATIONTRACE)
                    logMsg("WPM: expected response Choice was WritePropertyMultiple, actual was 0x%x\n",
                            appinp->InputBuffer[2]);
                return(FALSE);
            }
            return (TRUE);
        }
        if (tsmp->confirmation == TSM_NOTCONFIRMED)
        {
            /* something went wrong. didn't like the command, abort. something. */
            if (trace[line] & APPLICATIONTRACE)
                logMsg("WPM: expected response was SIMPLE_ACK, actual response was 0x%x.\n",
                        appinp->InputBuffer[0]);
            return(FALSE);
        }
    }
    else /* build_NPDU was FALSE */
    {
        if (trace[line] & APPLICATIONTRACE)
            logMsg("WPM: send_confirmed: incomplete transaction.\n");
        tsmp->state = TSM_IDLE;  /* since it failed, set state back to IDLE.      */
        return(FALSE);
    }
}

/***********************************************************************/
/* This Application Level routine is called from the network layer to  */
/* inform the app layer of the arrival of an app level message.        */
/***********************************************************************/
static unsigned short deliver_inputAPDU(unsigned short line, BCU *pbcu,
                                        unsigned short srcnet,
                                        unsigned short srcmac,
                                        unsigned short desnet,
                                        unsigned short desmac,
                                        unsigned char *msgaddress,
                                        unsigned short msglength)
{
    APPINPUT *appinp;

    unsigned short  i, j;

    /* Set up pointer to application pdu buffer. */
    appinp = &pbcu->application_input;

    if (appinp->InputValid == TRUE)           /* buffer should be empty */
    {
        if (trace[line] & APPLICATIONTRACE)
            logMsg("error: application input buffer not empty on delivery.\n");
        return(FALSE);
    }
    appinp->InputValid = TRUE;

    appinp->InputSNET[0] = srcnet/256;
    appinp->InputSNET[1] = srcnet%256;
    appinp->InputSMAC[0] = srcmac/256;
    appinp->InputSMAC[1] = srcmac%256;
    appinp->InputDNET[0] = desnet/256;
    appinp->InputDNET[1] = desnet%256;
    appinp->InputDMAC[0] = desmac/256;
    appinp->InputDMAC[1] = desmac%256;
    appinp->InputLength = msglength;          /* set apdu length */

    i = 0;

    /* transfer data from NPDU to APDU */
    for (j=0; j<appinp->InputLength ; j++)
    {
        appinp->InputBuffer[j] = msgaddress[j];
    }
    return(TRUE);
}
/****************************************************************************/
/****************************************************************************/
/****************************************************************************/
static unsigned short process_inputAPDU (unsigned short line)
{

        BCU   *pbcu;
        APPINPUT *appinp;
        TSM      *tsmp;


    unsigned char raw, type, segmented;

    pbcu = bcus[line];

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

/* note: the input APDU message was delivered by the network level. In the network      */
/*       level, the destination BACnet address and InvokeID are compared to insure that */
/*       they match the values extablished at this driver's invokation. therefore, we   */
/*       will never get one that doesn't match, and don't need to test for it here.     */

/* parse for PDU type to determine which TSM type to process under. */

/* check for proper TSM by comparing source address, destination address, and InvokeID against */
/* the existing TSMs in the system.                                                            */
/* Notes:                                                                                      */
/*        1) destination address for incoming PDUs is already tested for being for this driver */
/*           before getting to this level.                                                     */
/*        2) InvokeID, i haven't got a clue yet,                                               */
/*        3) source for received is the only thing i know for sure that it needs to be tested  */
/*           and how to test it.                                                               */

    process_inputNPDU(line, pbcu);  /* look to see if network level messages were passed   */
                                    /* 'up' to this level by receive frame. if no, get out.*/

    /* Set up pointer to application pdu buffer. */
    appinp = &pbcu->application_input;

    /* see if we got something. if not, just get out. */
    if (appinp->InputValid == FALSE)
       return(TRUE);

/* message received */

    /* since we got something, clear the flag for next time */
    appinp->InputValid = FALSE;
    
    /* verify that this is response from client transaction */
    if (tsmp->state == TSM_IDLE)
    {
        /* we do not handle server type requests from peer applications */
        /* we handle the unsolicted request by ignoring it.             */
        return(FALSE);
    }

    /**********************************************/
    /* see if this response is intended for us.  */
    /**********************************************/
    if (appinp->InputDNET[0] != sourceNET[line][0])
    {
        /* original (message destination):(confirmation source) net mismatch */
        /* we handle the unsolicted response by ignoring it.                 */
        return(FALSE);
    }
    if (appinp->InputDNET[1] != sourceNET[line][1])
    {
        /* original (message desitination):(confirmation source) net mismatch */
        /* we handle the unsolicted response by ignoring it.                 */
        return(FALSE);
    }
    if (appinp->InputDMAC[1] != sourceMAC[line])
    {
        /* original (message destination):(confirmation source) net mismatch */
        /* we handle the unsolicted response by ignoring it.                 */
        return(FALSE);
    }
/**********************************************/
/**********************************************/

    raw = appinp->InputBuffer[0];
    type = raw & 0xF0;   /* Mask out lower bit info */

    /* segmented responses and commands not accepted */
    segmented = raw & SegmentedMessage;
    if (segmented)
        return(ERROR);

    switch(type)    /* PDUtype */
    {
        case ConfirmedRequest_PDU:
        case UnconfirmedRequest_PDU:
            serverAPDUHandler(line, type); /* process state machine for responding user: server */
            return(TRUE);
            break;
        case SimpleACK_PDU:
        case ComplexACK_PDU:
        case Error_PDU:
        case Reject_PDU:
            clientAPDUHandler(line, type);/* process state machine for requesting user: client */
            return(FALSE);
            break;
        case SegmentACK_PDU:
        case Abort_PDU:
            /* test for (sent by server == TRUE) */
            if ((raw & 0x01) == 1)
            {
                serverAPDUHandler(line, raw);
                return(TRUE);
                break;
            }
            else
            {
                clientAPDUHandler(line, raw);
                return(TRUE);
                break;
            }
        default:
            return(FALSE);
    }
}
/****************************************************************************/
/****************************************************************************/

static void clientAPDUHandler(unsigned short line, unsigned char raw)
{
    TSM           *tsmp;
    unsigned char type, segmented;
    BCU        *pbcu;
    APPINPUT      *appinp;

    pbcu = bcus[line];

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

    /* Set up pointer to application pdu buffer. */
    appinp = &pbcu->application_input;

    type = raw & 0xF0;   /* Mask out lower bit info */

/* Note: the only valid APDUs are:
          SimpleACK_PDU:
          ComplexACK_PDU:
          Error_PDU:
          Reject_PDU:
          SegmentACK_PDU with server == FALSE:
          Abort_PDU with server == FALSE:
*/
    switch (tsmp->state)
    {
        case TSM_IDLE:
            /* no TSM exists. don't create one.       */
            /* all PDUs are Unexpected PDUs: discard. */
            switch(type)
            {
                case Abort_PDU:
                    /* tell the application level about this event */
                    tsmp->status = TSM_ABORT;
                    tsmp->confirmation = TSM_NOTCONFIRMED;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;
                default:
                    /******* Unexpected PDU handling *******/
                    /* Format the Abort PDU output message */
                    tsmp->Index = 0;
                    tsmp->OutputBuffer[0] =  Abort_PDU | Abort_Client_True;
                    tsmp->OutputBuffer[1] =  appinp->InputBuffer[1]; /* for all PDU types, invokeID */
                    tsmp->OutputBuffer[2] =  Invalid_APDU_In_This_State;
                    /* call network layer to send the message */
                    if (build_NPDU(line, pbcu) == FALSE) /* this is application level command. a    */
                                                         /* TRUE response indicates that the        */
                                                         /* message was transmitted successfully.   */
                    {
                        /* if abort fails, what else can we do? */
                    }
                    tsmp->status = TSM_ABORT;
                    tsmp->confirmation = TSM_NOTCONFIRMED;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;
            }
            break;

        case TSM_AWAIT_CONFIRMATION:
            switch(type)
            {
                case SimpleACK_PDU:
                    /*tell the application about this event (response write_property_multiple) */
                    tsmp->status = TSM_SIMPLE_ACK;
                    tsmp->confirmation = TSM_CONFIRMED;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;

                case ComplexACK_PDU:
                    segmented = raw & SegmentedMessage;   /* test for segmented bit set TRUE */
                    if (segmented == 0)
                    {
                        /*tell the application about this event (response read_property_multiple) */
                        tsmp->status = TSM_COMPLEX_ACK;
                        tsmp->confirmation = TSM_CONFIRMED;
                        tsmp->state = TSM_IDLE;
                        return;
                    }
                    else
                    {
                        /******* Unexpected PDU handling *******/
                        /* Format the Abort PDU output message */
                        tsmp->Index = 0;
                        tsmp->OutputBuffer[0] = Abort_PDU | Abort_Client_True;
                        /* for ComplexACK PDU, invokeID */
                        tsmp->OutputBuffer[1] = appinp->InputBuffer[1];
                        tsmp->OutputBuffer[2] = Segmentation_Not_Supported;
                        /* call network layer to send the message */
                        if (build_NPDU(line, pbcu) == FALSE) /* this is an application level command. */
                                                             /* a TRUE response indicates that the    */
                                                             /* message was transmitted successfully. */
                        {
                            /* if abort fails, what else can we do? */
                        }
                        tsmp->status = TSM_ABORT;
                        tsmp->confirmation = TSM_NOTCONFIRMED;
                        tsmp->state = TSM_IDLE;
                    }
                    break;

                case Error_PDU:
                    /*tell the application about this event (response read_property_multiple) */
                    tsmp->status = TSM_ERROR;
                    tsmp->confirmation = TSM_NOTCONFIRMED;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;

                case Reject_PDU:
                    /*tell the application about this event (response read_property_multiple) */
                    tsmp->status = TSM_REJECT;
                    tsmp->confirmation = TSM_NOTCONFIRMED;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;

                case Abort_PDU:
                    /*tell the application about this event (response read_property_multiple) */
                    tsmp->status = TSM_ABORT;
                    tsmp->confirmation = TSM_NOTCONFIRMED;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;
                default:
                    /******* Unexpected PDU handling *******/
                    /* Format the Abort PDU output message */
                    tsmp->Index = 0;
                    tsmp->OutputBuffer[0] =  Abort_PDU | Abort_Client_True;
                    tsmp->OutputBuffer[1] =  appinp->InputBuffer[1]; /* for all PDU types, invokeID */
                    tsmp->OutputBuffer[2] =  Invalid_APDU_In_This_State;
                    /* call network layer to send the message */
                    if (build_NPDU(line, pbcu) == FALSE) /* this is application level command. a    */
                                                         /* TRUE response indicates that the        */
                                                         /* message was transmitted successfully.   */
                    {
                        /* if abort fails, what else can we do? */
                    }
                    tsmp->status = TSM_ABORT;
                    tsmp->confirmation = TSM_NOTCONFIRMED;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;
            }
            break;
        default:
            /******* Unexpected PDU handling *******/
            /* Format the Abort PDU output message */
            tsmp->Index = 0;
            tsmp->OutputBuffer[0] =  Abort_PDU | Abort_Client_True;
            tsmp->OutputBuffer[1] =  appinp->InputBuffer[1]; /* for all PDU types, invokeID */
            tsmp->OutputBuffer[2] =  Invalid_APDU_In_This_State;
            /* call network layer to send the message */
            if (build_NPDU(line, pbcu) == FALSE) /* this is application level command. a    */
                                                 /* TRUE response indicates that the        */
                                                 /* message was transmitted successfully.   */
            {
                /* if abort fails, what else can we do? */
            }
            tsmp->status = TSM_ABORT;
            tsmp->confirmation = TSM_NOTCONFIRMED;
            tsmp->state = TSM_IDLE;
            return;
            break;
    }
}
/****************************************************************************/
/* called from the application to abort a previously sent confirmed command */
/****************************************************************************/

static void serverAPDUHandler(unsigned short line, unsigned char raw)
{
    TSM           *tsmp;
    APPINPUT      *appinp;
    unsigned char type, segmented;
    BCU        *pbcu;

    pbcu = bcus[line];

    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->clientTSM;

    /* Set up pointer to application pdu buffer. */
    appinp = &pbcu->application_input;

    type = raw & 0xF0;   /* Mask out lower bit info */

/* Note: the only valid APDU are:                     */
/*         ConfirmedRequest_PDU:                      */
/*         UnconfirmedRequest_PDU:                    */
/*         SegmentACK_PDU with server == TRUE:        */
/*         Abort_PDU with server == TRUE:             */

    switch (tsmp->state)
    {
        case TSM_IDLE:
            /* no TSM exists. don't create one.       */
            /* all PDUs are Unexpected PDUs: discard. */
            switch(type)
            {
                case UnconfirmedRequest_PDU:
                    /* we don't process these. just ignore them, as they require no response.       */
                    tsmp->status = TSM_ABORT;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;

                case ConfirmedRequest_PDU:
                    /******* Unexpected PDU handling *******/
                    /* Format the Abort PDU output message */
                    tsmp->Index = 0;
                    tsmp->OutputBuffer[0] =  Abort_PDU | Abort_Server_True;
                    tsmp->OutputBuffer[1] =  appinp->InputBuffer[2]; /* for this PDU type, invokeID */
                    tsmp->OutputBuffer[2] =  Other_Abort_Reason;
                    /* call network layer to send the message */
                    if (build_NPDU(line, pbcu) == FALSE) /* this is application level command. a    */
                                                         /* TRUE response indicates that the        */
                                                         /* message was transmitted successfully.   */
                    {
                        /* if abort fails, what else can we do? */
                    }
                    tsmp->status = TSM_ABORT;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;

                case SegmentACK_PDU:
                    /******* Unexpected PDU handling *******/
                    /* Format the Abort PDU output message */
                    tsmp->Index = 0;
                    tsmp->OutputBuffer[0] =  Abort_PDU | Abort_Server_True;
                    tsmp->OutputBuffer[1] =  appinp->InputBuffer[1]; /* for this PDU type, invokeID   */
                    tsmp->OutputBuffer[2] =  Invalid_APDU_In_This_State;
                    /* call network layer to send the message */
                    if (build_NPDU(line, pbcu) == FALSE) /* this is application level command. a    */
                                                         /* TRUE response indicates that the        */
                                                         /* message was transmitted successfully.   */
                    {
                        /* if abort fails, what else can we do? */
                    }
                    tsmp->status = TSM_ABORT;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;
                case Abort_PDU:
                    tsmp->status = TSM_ABORT;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;

                default:
                    /******* Unexpected PDU handling *******/
                    /* Format the Abort PDU output message */
                    tsmp->Index = 0;
                    tsmp->OutputBuffer[0] =  Abort_PDU | Abort_Server_Bit;
                    tsmp->OutputBuffer[1] =  appinp->InputBuffer[1]; /* for all PDU types, invokeID */
                    tsmp->OutputBuffer[2] =  Invalid_APDU_In_This_State;
                    /* call network layer to send the message */
                    if (build_NPDU(line, pbcu) == FALSE) /* this is application level command. a    */
                                                         /* TRUE response indicates that the        */
                                                         /* message was transmitted successfully.   */
                    {
                        /* if abort fails, what else can we do? */
                    }
                    tsmp->status = TSM_ABORT;
                    tsmp->state = TSM_IDLE;
                    return;
                    break;
            }
            break;
        /* end of TSM_IDLE case */

        case TSM_AWAIT_RESPONSE:
        default:
            /* IDLE is only valid state in current implementation. */
            return;
            break;
    }
}
/**********************************************************************/
/* This Application Level routine is called from the launch_read and   */
/* launch_write routines. its purpose is to parse the encoded response */
/* to the previous command and verify its correctness.                 */
/***********************************************************************/
static unsigned short parseAPDU(unsigned short line, BCU *pbcu)
{
    TSM           *tsmp;
    APPINPUT      *appinp;

    unsigned short  i, addr, type;

    unsigned char   state, octet, applicationtag, lengthvaluetype, property, realindex, real[4];
    unsigned long   oi;


    /* Set up pointer for transaction state stuff */
    tsmp = &pbcu->serverTSM;

    /* Set up pointer to application pdu buffer. */
    appinp = &pbcu->application_input;

    state = LOOKING_FOR_OBJECT_ID;
    i = 3;
    while (i < appinp->InputLength)
    {
        octet = appinp->InputBuffer[i++];
        switch (state)
        {
            case LOOKING_FOR_OBJECT_ID:
                if (((octet & ContextClassMask)    == ContextTag) &&
                    ((octet >> TagNumberShift)     == RAR_objectIdentifier) &&
                    ((octet & LengthValueTypeMask) == 3))
                {
                    oi = 0;
                    lengthvaluetype = octet & LengthValueTypeMask;
                    state = BUILDING_OBJECT_ID;
                    break;
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        if ((octet & ContextClassMask) == ApplicationTag)
                             printf("expecting context tag, found application tag.\n");
                        if ((octet >> TagNumberShift) != RAR_objectIdentifier)
                             printf("expecting ReadAccessResponse objectIdentifier.\n");
                        if ((octet & LengthValueTypeMask) != 3)
                             printf("expecting 3 octet length objectIdentifer, found 0x%x.\n",
                                (octet & LengthValueTypeMask));
                    } 
                    return(FALSE);
                    break;
                }

            case BUILDING_OBJECT_ID:
                oi = (oi*256) + octet;
                if (--lengthvaluetype == 0)
                   state = LOOKING_FOR_OPENING_RESULTS;
                break;

            case LOOKING_FOR_OPENING_RESULTS:
                if (((octet & ContextClassMask)    == ContextTag) &&
                    ((octet >> TagNumberShift)     == RAR_listOfResults) &&
                    ((octet & LengthValueTypeMask) == OpeningTag))
                {
                    state = LOOKING_FOR_PROPERTY_ID;
                    break;
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        if ((octet & ContextClassMask) == ApplicationTag)
                             printf("expecting context tag, found application tag.\n");
                        if ((octet >> TagNumberShift) != RAR_listOfResults)
                             printf("expecting ReadAccessResponse list of results.\n");
                        if ((octet & LengthValueTypeMask) != OpeningTag)
                             printf("expecting opening tag for list of results, found0x%x.\n",
                                (octet & LengthValueTypeMask));
                    }
                    return(FALSE);
                    break;
                }

            case LOOKING_FOR_PROPERTY_ID:
                if (((octet & ContextClassMask)    == ContextTag) &&
                    ((octet >> TagNumberShift)     == RAR_PropertyIdentifier) &&
                    ((octet & LengthValueTypeMask) == 1))
                {
                    lengthvaluetype = octet & LengthValueTypeMask;
                    state = GETTING_PROPERTY_ID;
                    break;
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        if ((octet & ContextClassMask) == ApplicationTag)
                             printf("expecting context tag, found application tag.\n");
                        if ((octet >> TagNumberShift) != RAR_PropertyIdentifier)
                             printf("expecting ReadAccessResponse list of results.\n");
                        if ((octet & LengthValueTypeMask) != 1)
                             printf("expecting 1 octet length PropertyIdentifer, found 0x%x.\n",
                                 (octet & LengthValueTypeMask));
                    }
                    return(FALSE);
                    break;
                }

            case GETTING_PROPERTY_ID:
                property = octet;
                state = LOOKING_FOR_OPENING_VALUE;
                break;

            case LOOKING_FOR_OPENING_VALUE:
                if (((octet & ContextClassMask) == ContextTag) &&
                    ((octet & LengthValueTypeMask) == OpeningTag))
                {
                    if ((octet >> TagNumberShift) == RAR_propertyValue)
                    {
                        state = LOOKING_FOR_DATATYPE;
                        break;
                    }
                    else
                    {
                        if ((octet >> TagNumberShift) == RAR_propertyAccessError)
                        {
                            state = LOOKING_FOR_ERROR_CLASS_TAG;
                            break;
                        }
                        else
                        {
                            if (trace[line] & APPLICATIONTRACE)
                            {
                                taskDelay(1);
                                logMsg("parseAPDU(%d): ", (i-1));
                                printf
                                ("expecting RAR property value or property access error, found 0x%x.\n",
                                (octet >> TagNumberShift));
                            }
                            return(FALSE);
                        }
                    }
                }
                else
                {
                    /* special case: bug in Trane BCU code: Error response not implemented correctly. */
                    if (((octet & ContextClassMask) == ContextTag) &&
                        ((octet >> TagNumberShift) == RAR_propertyAccessError) &&
                        ((octet & LengthValueTypeMask) == 1))
                    {
                            state = LOOKING_FOR_TRANE_BUG;
                            break;
                    }
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        if ((octet & ContextClassMask) == ApplicationTag)
                             printf("expecting context tag, found application tag.\n");
                        if ((octet & LengthValueTypeMask) != OpeningTag)
                             printf("expecting opening tag, found0x%x.\n",
                                (octet & LengthValueTypeMask));
                    }
                    return(FALSE);
                    break;
                }
                break;

            case LOOKING_FOR_DATATYPE:
                if ((octet & ContextClassMask) == ApplicationTag)
                {
                    lengthvaluetype = (octet & LengthValueTypeMask);
                    applicationtag = (octet >> TagNumberShift);
                    switch (applicationtag)
                    {
                        case ApplicationReal:
                            if (lengthvaluetype == 4)
                            {
                                realindex = 0;
                                state = GETTING_REALVALUE;
                                break;
                            }
                            else
                            {
                                if (trace[line] & APPLICATIONTRACE)
                                {
                                    taskDelay(1);
                                    logMsg("parseAPDU(%d): Real: Length = 0x%x; Expected 4.\n",
                                        (i-1), lengthvaluetype);
                                }
                                return(FALSE);
                                break;
                            }
                            break;

                        case ApplicationEnumerated:
                            if (lengthvaluetype == 1)
                            {
                                state = GETTING_ENUMERATEDVALUE;
                                break;
                            }
                            else
                            {
                                if (trace[line] & APPLICATIONTRACE)
                                {
                                    taskDelay(1);
                                    logMsg("parseAPDU(%d): Enumerated: Length = 0x%x; Expected 1.\n",
                                        (i-1), lengthvaluetype);
                                }
                                return(FALSE);
                                break;
                            }
                            break;

                        default:
                            if (trace[line] & APPLICATIONTRACE)
                            {
                                taskDelay(1);
                                logMsg
                                  ("parseAPDU(%d): Unexpected Application Tag (0x%x) encountered.\n",
                                    (i-1), applicationtag);
                            }
                            return(FALSE);
                            break;
                    }
                    break;
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): expecting application tag, found context tag.\n",(i-1));
                    }
                    return(FALSE);
                    break;
                }

            case GETTING_REALVALUE:
                real[realindex++] = octet;
                if (--lengthvaluetype == 0)
                {
                    /************************/
                    /* store the real value */
                    /************************/
                    if (property == BACnetPI_present_value)
                    {
                        addr = oi % 256;
                        type = (oi >> 14) % 256;
                        if (type == BAC_AnalogInput)
                        {
                            pbcu->analoginputs [addr].data_valid = TRUE;
                            pbcu->analoginputs [addr].aivals[0] = real[0];
                            pbcu->analoginputs [addr].aivals[1] = real[1];
                            pbcu->analoginputs [addr].aivals[2] = real[2];
                            pbcu->analoginputs [addr].aivals[3] = real[3];
                            state = LOOKING_FOR_CLOSING_VALUE;
                            break;
                        }
                        if (type == BAC_AnalogOutput)
                        {
                            pbcu->analogoutputs [addr].data_valid = TRUE;
                            pbcu->analogoutputs [addr].aovals[0] = real[0];
                            pbcu->analogoutputs [addr].aovals[1] = real[1];
                            pbcu->analogoutputs [addr].aovals[2] = real[2];
                            pbcu->analogoutputs [addr].aovals[3] = real[3];
                            state = LOOKING_FOR_CLOSING_VALUE;
                            break;
                        }
                        if (trace[line] & APPLICATIONTRACE)
                        {
                            taskDelay(1);
                            logMsg("parseAPDU(%d): Unexpected Object Type: 0x%x.\n", (i-1), type);
                        }
                        return(FALSE);
                        break;
                    }
                    /* if not present value, report it. its an error to be sent anything else. */
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg
                          ("parseAPDU(%d): Unexpected Property: expecting present value, found 0x%x.\n",
                            (i-1), property);
                    }
                    return(FALSE);
                    break;
                }
                break;

            case GETTING_ENUMERATEDVALUE:
                /******************************/
                /* store the enumerated value */
                /******************************/
                if (property == BACnetPI_present_value)
                {
                    addr = oi % 256;
                    type = (oi >> 14) % 256;
                    if (type == BAC_BinaryInput)
                    {
                        pbcu->binaryinputs [addr].data_valid = TRUE;
                        pbcu->binaryinputs [addr].last_read = octet;
                        state = LOOKING_FOR_CLOSING_VALUE;
                        break;
                    }
                    if (type == BAC_BinaryOutput)
                    {
                        pbcu->binaryoutputs [addr].data_valid = TRUE;
                        pbcu->binaryoutputs [addr].last_read = octet;
                        state = LOOKING_FOR_CLOSING_VALUE;
                        break;
                    }
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): Unexpected Object Type: 0x%x.\n", (i-1), type);
                    }
                    return(FALSE);
                    break;
                }
                /* if not present value, report it. its an error to be sent anything else. */
                if (trace[line] & APPLICATIONTRACE)
                {
                    taskDelay(1);
                    logMsg("parseAPDU(%d): Unexpected Property: expecting present value, found 0x%x.\n",
                           (i-1), property);
                }
                return(FALSE);
                break;

            case LOOKING_FOR_ERROR_CLASS_TAG:
                if ((octet & ContextClassMask) == ApplicationTag)
                {
                    lengthvaluetype = (octet & LengthValueTypeMask);
                    applicationtag = (octet >> TagNumberShift);
                    switch (applicationtag)
                    {
                        case ApplicationEnumerated:
                            if (lengthvaluetype == 1)
                            {
                                state = GETTING_ERROR_CLASS_VALUE;
                                break;
                            }
                            else
                            {
                                if (trace[line] & APPLICATIONTRACE)
                                {
                                    taskDelay(1);
                                    logMsg("parseAPDU(%d): Enumerated: Length = 0x%x; Expected 1.\n",
                                        (i-1), lengthvaluetype);
                                }
                                return(FALSE);
                                break;
                            }
                            break;

                        default:
                            if (trace[line] & APPLICATIONTRACE)
                            {
                                taskDelay(1);
                                logMsg
                                ("parseAPDU(%d): Unexpected Application Tag (0x%x) encountered.\n",
                                    (i-1), applicationtag);
                            }
                            return(FALSE);
                            break;
                    }
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        printf("expecting application tag, found context tag.\n");
                    }
                    return(FALSE);
                    break;
                }
                break;

            case GETTING_ERROR_CLASS_VALUE:
                if (octet == ErrorClass_Object)
                {
                    state = LOOKING_FOR_ERROR_CODE_TAG;
                    break;
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): Unexpected Error Class Value: 0x%x.\n", (i-1), type);
                    }
                    return(FALSE);
                    break;
                }

            case LOOKING_FOR_ERROR_CODE_TAG:
                if ((octet & ContextClassMask) == ApplicationTag)
                {
                    lengthvaluetype = (octet & LengthValueTypeMask);
                    applicationtag = (octet >> TagNumberShift);
                    switch (applicationtag)
                    {
                        case ApplicationEnumerated:
                            if (lengthvaluetype == 1)
                            {
                                state = GETTING_ERROR_CODE_VALUE;
                                break;
                            }
                            else
                            {
                                if (trace[line] & APPLICATIONTRACE)
                                {
                                    taskDelay(1);
                                    logMsg("parseAPDU(%d): Enumerated: Length = 0x%x; Expected 1.\n",
                                        (i-1), lengthvaluetype);
                                }
                                return(FALSE);
                                break;
                            }
                            break;

                        default:
                            if (trace[line] & APPLICATIONTRACE)
                            {
                                taskDelay(1);
                                logMsg
                                  ("parseAPDU(%d): Unexpected Application Tag (0x%x) encountered.\n",
                                    (i-1), applicationtag);
                            }
                            return(FALSE);
                            break;
                    }
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        printf("expecting application tag, found context tag.\n");
                    }
                    return(FALSE);
                    break;
                }
                break;

            case GETTING_ERROR_CODE_VALUE:
                if (octet == ErrorCode_UnknownObject)
                {
                    state = LOOKING_FOR_CLOSING_ACCESS_ERROR;
                    addr = oi % 256;
                    type = (oi >> 14) % 256;
                    if (type == BAC_AnalogInput)
                    {
                        if (trace[line] & APPLICATIONTRACE)
                        {
                            taskDelay(1);
                            logMsg("parseAPDU(%d): Invalid AI Object: Disabling L=%d,A=%d,C=%d,S=%d\n",
                                   (i-1), line, 0, type, addr);
                            taskDelay(1);
                        }
                        pbcu->analoginputs [addr].data_valid = FALSE;
                        pbcu->analoginputs [addr].was_requested = FALSE;
                        break;
                    }
                    if (type == BAC_AnalogOutput)
                    {
                        if (trace[line] & APPLICATIONTRACE)
                        {
                            taskDelay(1);
                            logMsg("parseAPDU(%d): Invalid AO Object: Disabling L=%d,A=%d,C=%d,S=%d\n",
                                   (i-1), line, 0, type, addr);
                            taskDelay(1);
                        }
                        pbcu->analogoutputs [addr].data_valid = FALSE;
                        pbcu->analogoutputs [addr].was_requested = FALSE;
                        break;
                    }
                    if (type == BAC_BinaryInput)
                    {
                        if (trace[line] & APPLICATIONTRACE)
                        {
                            taskDelay(1);
                            logMsg("parseAPDU(%d): Invalid BI Object: Disabling L=%d,A=%d,C=%d,S=%d\n",
                                   (i-1), line, 0, type, addr);
                            taskDelay(1);
                        }
                        pbcu->binaryinputs [addr].data_valid = FALSE;
                        pbcu->binaryinputs [addr].was_requested = FALSE;
                        break;
                    }
                    if (type == BAC_BinaryOutput)
                    {
                        if (trace[line] & APPLICATIONTRACE)
                        {
                            taskDelay(1);
                            logMsg("parseAPDU(%d): Invalid BO Object: Disabling L=%d,A=%d,C=%d,S=%d\n",
                                   (i-1), line, 0, type, addr);
                            taskDelay(1);
                        }
                        pbcu->binaryoutputs [addr].data_valid = FALSE;
                        pbcu->binaryoutputs [addr].was_requested = FALSE;
                        break;
                    }
                    break;
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): Unexpected Error Code Value: 0x%x.\n", (i-1), type);
                    }
                    return(FALSE);
                    break;
                }

            case LOOKING_FOR_CLOSING_ACCESS_ERROR:
                if (((octet & ContextClassMask)    == ContextTag) &&
                    ((octet >> TagNumberShift)     == RAR_propertyAccessError) &&
                    ((octet & LengthValueTypeMask) == ClosingTag))
                {
                    state = POST_CLOSING_VALUE;
                    break;
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        if ((octet & ContextClassMask) == ApplicationTag)
                             printf("expecting context tag, found application tag.\n");
                        if ((octet >> TagNumberShift) != RAR_propertyAccessError)
                             printf("expecting ReadAccessResponse property access error.\n");
                        if ((octet & LengthValueTypeMask) != ClosingTag)
                             printf("expecting closing tag for property access error, found0x%x.\n",
                                (octet & LengthValueTypeMask));
                    }
                    return(FALSE);
                    break;
                }

            case LOOKING_FOR_TRANE_BUG:
                /* we don't care what this byte value is. all we */
                /* care about is that the object is invalid.     */
                state = POST_CLOSING_VALUE;
                addr = oi % 256;
                type = (oi >> 14) % 256;
                if (type == BAC_AnalogInput)
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): Invalid AI Object: Disabling L=%d,A=%d,C=%d,S=%d\n",
                                (i-1), line, 0, type, addr);
                        taskDelay(1);
                    }
                    pbcu->analoginputs [addr].data_valid = FALSE;
                    pbcu->analoginputs [addr].was_requested = FALSE;
                    break;
                }
                if (type == BAC_AnalogOutput)
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): Invalid AO Object: Disabling L=%d,A=%d,C=%d,S=%d\n",
                               (i-1), line, 0, type, addr);
                        taskDelay(1);
                    }
                    pbcu->analogoutputs [addr].data_valid = FALSE;
                    pbcu->analogoutputs [addr].was_requested = FALSE;
                    break;
                }
                if (type == BAC_BinaryInput)
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): Invalid BI Object: Disabling L=%d,A=%d,C=%d,S=%d\n",
                                (i-1), line, 0, type, addr);
                        taskDelay(1);
                    }
                    pbcu->binaryinputs [addr].data_valid = FALSE;
                    pbcu->binaryinputs [addr].was_requested = FALSE;
                    break;
                }
                if (type == BAC_BinaryOutput)
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): Invalid BO Object: Disabling L=%d,A=%d,C=%d,S=%d\n",
                                (i-1), line, 0, type, addr);
                        taskDelay(1);
                    }
                    pbcu->binaryoutputs [addr].data_valid = FALSE;
                    pbcu->binaryoutputs [addr].was_requested = FALSE;
                    break;
                }
                break;

            case LOOKING_FOR_CLOSING_VALUE:
                if (((octet & ContextClassMask)    == ContextTag) &&
                    ((octet >> TagNumberShift)     == RAR_propertyValue) &&
                    ((octet & LengthValueTypeMask) == ClosingTag))
                {
                    state = POST_CLOSING_VALUE;
                    break;
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        if ((octet & ContextClassMask) == ApplicationTag)
                             printf("expecting context tag, found application tag.\n");
                        if ((octet >> TagNumberShift) != RAR_propertyValue)
                             printf("expecting ReadAccessResponse property value.\n");
                        if ((octet & LengthValueTypeMask) != ClosingTag)
                             printf("expecting closing tag for property value, found0x%x.\n",
                                (octet & LengthValueTypeMask));
                    }
                    return(FALSE);
                    break;
                }

            case POST_CLOSING_VALUE: /* either LOOKING_FOR_PROPERTY_ID or LOOKING_FOR_CLOSING_RESULTS */
                if ((octet & ContextClassMask) == ContextTag)
                {
                    if ((octet >> TagNumberShift) == RAR_PropertyIdentifier)
                    {
                        if ((octet & LengthValueTypeMask) == 1)          /* LOOKING_FOR_PROPERTY_ID   */
                        {
                            lengthvaluetype = octet & LengthValueTypeMask;
                            state = GETTING_PROPERTY_ID;
                            break;
                        }
                        else
                        {
                            if (trace[line] & APPLICATIONTRACE)
                            {
                                taskDelay(1);
                                logMsg("parseAPDU(%d): ", (i-1));
                                printf("expecting 1 octet length PropertyIdentifer, found 0x%x.\n",
                                      (octet & LengthValueTypeMask));
                            }
                            return(FALSE);
                        }
                    }
                    else
                    {
                        if ((octet >> TagNumberShift) == RAR_listOfResults)
                        {
                            /* LOOKING_FOR_CLOSING_RESULTS    */
                            if ((octet & LengthValueTypeMask) == ClosingTag)
                            {
                                state = LOOKING_FOR_OBJECT_ID;
                                break;
                            }
                            else
                            {
                                if (trace[line] & APPLICATIONTRACE)
                                {
                                    taskDelay(1);
                                    logMsg("parseAPDU(%d): ", (i-1));
                                    printf("expecting Closing Tag, found 0x%x.\n",
                                          (octet & LengthValueTypeMask));
                                }
                                return(FALSE);
                            }
                        }
                        else
                        {
                            if (trace[line] & APPLICATIONTRACE)
                            {
                                taskDelay(1);
                                logMsg("parseAPDU(%d): ", (i-1));
                 printf("expecting either another PropertyIdentifer or List Closing Tag, found 0x%x.\n",
                                     (octet & LengthValueTypeMask));
                            }
                            return(FALSE);
                        }
                    }
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        if ((octet & ContextClassMask) == ApplicationTag)
                             printf("expecting context tag, found application tag.\n");
                    }
                    return(FALSE);
                    break;
                }
                break;

            case LOOKING_FOR_CLOSING_RESULTS:
                if (((octet & ContextClassMask)    == ContextTag) &&
                    ((octet >> TagNumberShift)     == RAR_propertyValue) &&
                    ((octet & LengthValueTypeMask) == ClosingTag))
                {
                    state = LOOKING_FOR_OBJECT_ID;
                    break;
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        if ((octet & ContextClassMask) == ApplicationTag)
                             printf("expecting context tag, found application tag.\n");
                        if ((octet >> TagNumberShift) != RAR_propertyValue)
                             printf("expecting ReadAccessResponse property value.\n");
                        if ((octet & LengthValueTypeMask) != ClosingTag)
                             printf("expecting propertyValue Closing Tag, found 0x%x.\n",
                                 (octet & LengthValueTypeMask));
                    }
                    return(FALSE);
                    break;
                }
            case POST_CLOSING_RESULTS:
                /* see if there is another object (clone of LOOKING_FOR_OBJECT_ID code) */
                if (((octet & ContextClassMask)    == ContextTag) &&
                    ((octet >> TagNumberShift)     == RAR_objectIdentifier) &&
                    ((octet & LengthValueTypeMask) == 3))
                {
                    oi = 0;
                    lengthvaluetype = octet & LengthValueTypeMask;
                    state = BUILDING_OBJECT_ID;
                    break;
                }
                else
                {
                    if (trace[line] & APPLICATIONTRACE)
                    {
                        taskDelay(1);
                        logMsg("parseAPDU(%d): ", (i-1));
                        if ((octet & ContextClassMask) == ApplicationTag)
                             printf("expecting context tag, found application tag.\n");
                        if ((octet >> TagNumberShift) != RAR_objectIdentifier)
                             printf("expecting ReadAccessResponse objectIdentifier.\n");
                        if ((octet & LengthValueTypeMask) != 3)
                             printf("expecting 3 octet length objectIdentifer, found 0x%x.\n",
                                 (octet & LengthValueTypeMask));
                    } 
                    return(FALSE);
                    break;
                }
            default:
                if (trace[line] & APPLICATIONTRACE)
                {
                    taskDelay(1);
                    logMsg("parseAPDU(%d): Illegal state encountered.\n",(i-1));
                }
                return(FALSE);
        }
    }
    /* to arrive here says we have run out of input octets. */
    /* lets see if we were at an illegal stopping point when we ran out. */
    if (state == LOOKING_FOR_OBJECT_ID)
        return(TRUE);

    if (trace[line] & APPLICATIONTRACE)
    {
        taskDelay(1);
        logMsg("parseAPDU(%d): unexpected end of input encountered.\n",(i-1));
    }
    return(FALSE);
}

/********************************/
/*** NEWCODE ********************/
/********************************/
/********************************/
/********************************/
/* network layer procedures     */
/********************************/
/********************************/
/********************************/
/********************************/
/*
**                                                              	
** initialize the Network Layer State Machines                          
**                                                              	
*/                                                               	
/* called from init_line_tabs  */

static	void initnetworklayer (BCU *pbcu)
    {
        NSM    *nsmp;

        nsmp = &pbcu->networkSM;
        nsmp->version = BACnetNetworkVersion;
    }

/**********************************************************************/
/* This Network Level routine is called from the datalink layer to     */
/* inform the network layer of the arrival of a network level message. */
/***********************************************************************/
static unsigned short deliver_inputNPDU(unsigned short line, BCU *pbcu)
{
    NSM      *nsmp;
    RX_FRAME  *rxp;

    unsigned short  i;

    /* Set up pointer to frame buffer. */
    rxp = rxlinetab[line];

    /* Set up pointer to network state machine. */
    nsmp = &pbcu->networkSM;

    if (nsmp->InputValid == TRUE)       /* buffer should be empty */
        return(FALSE);

    /* transfer Frame Data to NPDU */
    for (i=0; i<rxp->DataLength ; i++)
    {
        nsmp->InputBuffer[i] = rxp->InputBuffer[i];
    }

    nsmp->InputLength = rxp->DataLength;
    nsmp->InputValid = TRUE;
    return(TRUE);
}
/***********************************************************************/
/* This Network Level routine is called from the application layer to  */
/* process network level messages. If one is ready for processing, it  */
/* is done. if not, it exits without error.                            */
/***********************************************************************/
static unsigned short process_inputNPDU(unsigned short line, BCU *pbcu)
{
    NSM      *nsmp;
    RX_FRAME  *rxp;

static unsigned short  i;
static unsigned char control;
static unsigned char hopcountlen, msglength;
static unsigned char srcnet, srcmac;
static unsigned char desnet, desmac;
static unsigned char *msgaddress;

    /* Set up pointer to frame buffer. */
    rxp = rxlinetab[line];

    /* Set up pointer to network state machine. */
    nsmp = &pbcu->networkSM;

    receive_frame(line, pbcu);          /* handle the datalink level stuff.                    */
                                        /* notice that it doesn't hang up down in here waiting */
                                        /* for input. it processes state changes for input,    */
                                        /* output and connection state machines.               */

    if (nsmp->InputValid == TRUE)       /* test for valid input */
    {
        nsmp->InputValid = FALSE;       /* set invalid for next time */

        if (nsmp->InputLength < 9)      /* minimum network level message */
        {
            /* reject because of gross length error */
            return(FALSE);
        }

        if (nsmp->InputBuffer[0] != nsmp->version)
        {
            /* reject because of version mismatch */
            if (trace[line] & NETWORKTRACE)
            {
                taskDelay(1);
                printf("Network Version mismatch: expected = 0x%x, actual = 0x%x.\n",
                       nsmp->version, nsmp->InputBuffer[0]);
            }
            return(FALSE);
        }

        control = nsmp->InputBuffer[1];

        /* test the network message bit */
        if ((control & 0x80) == 0x80)
        {
            /* this is a network level message. */
            nsmp->NetMessage = TRUE;
/*            return(FALSE); */
        }
        else
        {
            nsmp->NetMessage = FALSE;
        }

        /* position just beyond Control Octet */
        i = 2;
        nsmp->InputBroadcast = FALSE;

        /* parse destination info in bits 5&6 */
        switch ((control & 0x60) >> 5)
        {
            case 0:
                nsmp->InputDNET[0] = 0;
                nsmp->InputDNET[1] = 0;
                nsmp->InputDLEN[0] = 0;
                nsmp->InputDMAC[0] = 0;
                nsmp->InputDMAC[1] = 0;
                hopcountlen = 0;
                break;
            case 1:
                /* illegal. reject the message */
                break;
            case 2:
                nsmp->InputDNET[0] = nsmp->InputBuffer[i++];
                nsmp->InputDNET[1] = nsmp->InputBuffer[i++];
                nsmp->InputDLEN[0] = 1;
                nsmp->InputDMAC[0] = 0;
                nsmp->InputDMAC[1] = nsmp->InputBuffer[i++];
                hopcountlen = 1;
                break;
            case 3:
                nsmp->InputDNET[0] = nsmp->InputBuffer[i++];
                nsmp->InputDNET[1] = nsmp->InputBuffer[i++];
                nsmp->InputDLEN[0] = nsmp->InputBuffer[i++];
                switch (nsmp->InputDLEN[0])
                {
                    case 0:
                        nsmp->InputBroadcast = TRUE;
                        break;
                    case 1:
                        nsmp->InputDMAC[0] = 0;
                        nsmp->InputDMAC[1] = nsmp->InputBuffer[i++];
                        break;
                    case 2:
                        nsmp->InputDMAC[0] = nsmp->InputBuffer[i++];
                        nsmp->InputDMAC[1] = nsmp->InputBuffer[i++];
                        break;
                    default:
                        /* greater than two bytes is an error for this unit. reject command */
                        break;
                }
                hopcountlen = 1;
                break;
        }

        /* parse source info */
        switch ((control & 0x18) >> 3)
        {
            case 0:
                nsmp->InputSNET[0] = 0;
                nsmp->InputSNET[1] = 0;
                nsmp->InputSLEN[0] = 0;
                nsmp->InputSMAC[0] = 0;
                nsmp->InputSMAC[1] = 0;
                break;
            case 1:
                /* illegal. reject the message */
                break;
            case 2:
                nsmp->InputSNET[0] = nsmp->InputBuffer[i++];
                nsmp->InputSNET[1] = nsmp->InputBuffer[i++];
                nsmp->InputSLEN[0] = 1;
                nsmp->InputSMAC[0] = 0;
                nsmp->InputSMAC[1] = nsmp->InputBuffer[i++];
                break;
            case 3:
                nsmp->InputSNET[0] = nsmp->InputBuffer[i++];
                nsmp->InputSNET[1] = nsmp->InputBuffer[i++];
                nsmp->InputSLEN[0] = nsmp->InputBuffer[i++];
                switch (nsmp->InputSLEN[0])
                {
                    case 0:
                        /* illegal length value. report error */
                        break;
                    case 1:
                        nsmp->InputSMAC[0] = 0;
                        nsmp->InputSMAC[1] = nsmp->InputBuffer[i++];
                        break;
                    case 2:
                        nsmp->InputSMAC[0] = nsmp->InputBuffer[i++];
                        nsmp->InputSMAC[1] = nsmp->InputBuffer[i++];
                        break;
                    default:
                        /* greater than two bytes is an error for this unit. reject command */
                        break;
                }
                break;
        }

        /* parse reserved bit info */
        if (((control & 0x04) >> 2) == 1)
        {
            /* Reserved. must be zero. reject the message */
        }

        /* parse priority info. (no actions based on priority are currently defined) */
        switch (control & 0x03)
        {
            case 0:
                break;
            case 1:
                break;
            case 2:
                break;
            case 3:
                break;
        }


        if (hopcountlen == 1)
        {
            nsmp->InputHopCount = nsmp->InputBuffer[i++];
        }
        else
        {
            nsmp->InputHopCount = 0; /* we don't use it anyway. */
        }
        
        if (nsmp->NetMessage == TRUE)
        {
            nsmp->MessageType = nsmp->InputBuffer[i++];
            srcnet =     (256*(nsmp->InputSNET[0]) + nsmp->InputSNET[1]);
            srcmac =     (256*(nsmp->InputSMAC[0]) + nsmp->InputSMAC[1]);
            desnet =     (256*(nsmp->InputDNET[0]) + nsmp->InputDNET[1]);
            desmac =     (256*(nsmp->InputDMAC[0]) + nsmp->InputDMAC[1]);
            if (trace[line] & NETWORKTRACE)
            {
                taskDelay(1);
                printf("Unexpected Network Level Message: To: %d,%d  From: %d,%d \n",
                        desnet, desmac, srcnet, srcmac);
                taskDelay(1);
            }

            switch (nsmp->MessageType)
            {
                case Who_Is_Router_To_Network:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("Msg:'Who_Is_Router_To_Network'[%2x][%2x]\n");
                    }
                    break;

                case I_Am_Router_To_Network:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("'I_Am_Router_To_Network'\n");
                    }
                    break;

                case I_Could_Be_Router_To_Network:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("'I_Could_Be_Router_To_Network'\n");
                    }
                    break;

                case Reject_Message_To_Network:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("'Reject_Message_To_Network'\n");
                    }
                    break;

                case Router_Busy_To_Network:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("'Router_Busy_To_Network'\n");
                    }
                    break;

                case Router_Available_To_Network:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("'Router_Available_To_Network'\n");
                    }
                    break;

                case Initialize_Routing_Table:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("'Initialize_Routing_Table'\n");
                    }
                    break;
                case Initialize_Routing_Table_Ack:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("'Initialize_Routing_Table_Ack'\n");
                    }
                       break;
                case Establishing_Connection_To_Network:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("'Establishing_Connection_To_Network'\n");
                    }
                    break;
                case Disconnect_Connection_To_Network:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("'Disconnect_Connection_To_Network'\n");
                    }
                    break;

                default:
                    if (trace[line] & NETWORKTRACE)
                    {
                        taskDelay(1);
                        printf("Unknown Message Type: 0x%x\n", nsmp->MessageType);
                    }
                    return(FALSE);
                    break;
            }

            /* currently, we ignore all known network level messages.      */
            return(TRUE);
        }
        else /* this is an apdu message. give it up to the app layer. */
        {
            srcnet =     (256*(nsmp->InputSNET[0]) + nsmp->InputSNET[1]);
            srcmac =     (256*(nsmp->InputSMAC[0]) + nsmp->InputSMAC[1]);
            desnet =     (256*(nsmp->InputDNET[0]) + nsmp->InputDNET[1]);
            desmac =     (256*(nsmp->InputDMAC[0]) + nsmp->InputDMAC[1]);
            msgaddress = &nsmp->InputBuffer[i];
            msglength =  nsmp->InputLength - i;
            /* deliver APDU to the Network Layer */
            if (deliver_inputAPDU(line, pbcu, srcnet, srcmac, desnet, desmac, msgaddress, msglength)
                 == FALSE)
            {
                /* application layer queue was full */
            }
            return(TRUE);
        }
        return(TRUE);
    }
    return(TRUE); /* true = no error */
}
/**********************************************************************/
/* This Network Level routine is called from the Application Level to  */
/* send a confirmed request PDU to a BCU on the BACnet. The calling    */
/* procedure has already defined the APDU. This routine returns TRUE   */
/* if the message was sent successfully.                               */
/***********************************************************************/
static unsigned short build_NPDU(unsigned short line, BCU *pbcu)
{
    NSM      *nsmp;
    TSM      *tsmp;

    unsigned short  i;

    /* Set up pointer to transaction state machine. */
    tsmp = &pbcu->clientTSM;

    /* Set up pointer to network state machine. */
    nsmp = &pbcu->networkSM;

    /* Format network the output message. */
    nsmp->OutputBuffer[0] = 1;                       /* BACnet network version number */
    nsmp->OutputBuffer[1] = Non_Network_Message |
                            DefaultDestinationFormat |
                            DefaultSourceFormat |
                            DefaultPriority;
    nsmp->OutputBuffer[2] = destinationNET[line][0];
    nsmp->OutputBuffer[3] = destinationNET[line][1];
    nsmp->OutputBuffer[4] = destinationMAC[line];
    nsmp->OutputBuffer[5] = sourceNET[line][0];
    nsmp->OutputBuffer[6] = sourceNET[line][1];
    nsmp->OutputBuffer[7] = sourceMAC[line];
    nsmp->OutputBuffer[8] = 0xff;

    /* transfer APDU to NPDU */
    for (i=0; i<tsmp->Index ; i++)
    {
        nsmp->OutputBuffer[i+9] = tsmp->OutputBuffer[i];
    }
    nsmp->OutputLength = 9+i;

    if (send_data (line, pbcu) == FALSE)
                                         /* this builds the data frame message in txbuffer, fires it */
                                         /* off, and waits for a response. it will timeout if not    */
                                         /* received. if timeout, or reject response received, it    */
                                         /* will retry transmission until retries exhausted.         */
    {
        return(FALSE);  /* just report the failure up the line */
    }
    return(TRUE);
}

/********************************/
/********************************/
/*** NEWCODE ********************/
/********************************/
/********************************/
/* data link layer procedures   */
/********************************/
/********************************/
/********************************/
/********************************/
/*
**                                                              	
** initialize the Datalink Layer State Machines                         
**                                                              	
*/                                                               	
/* called from init_line_tabs  */

static	void initdatalayer (BCU *pbcu)
    {
        CSM    *csmp;
        ISM    *ismp;
        OSM    *osmp;

        csmp = &pbcu->connectionSM;
        ismp = &pbcu->inputSM;
        osmp = &pbcu->outputSM;

	csmp->state = DISCONNECTED;   /* not connected to peer network.                    */

	ismp->state = RECEIVE_IDLE;   /* waiting for data link to be made to peer network. */
        ismp->ReceptionBlocked = FALSE;
        ismp->LastFrameTime = tickGet();

	osmp->state = TRANSMIT_IDLE;  /* waiting for data link to be made to peer network. */
        osmp->LastFrameTime = tickGet();
    }


/******************************************************************************/
/******************************************************************************/
/* OUTPUT/TRANSMIT PROCEDURES *************************************************/
/******************************************************************************/
/******************************************************************************/

/******************************************************************************/
/*      bcu_connect                                                             
**                                                                              
**      The purpose of this procedure is to test the status of the connection   
**      state machine, and if it is not connected to the BCU, to try to do so.  
**      This driver is seen by the BCU as a Half-Router.                        
**                                                                              
**              returns         PTP State == CONNECTED if successful,           
**                                           DISCONNECTED if not.               
*/
/* called from MAIN only. */

static	unsigned short  bcu_connect (unsigned short line)
{
/*        unsigned int    tick1, tick2, tick3, tick4;
        unsigned int    delta12, delta23, delta34;
*/
        CSM             *csmp; /* pointer to connection state machine */
	unsigned short  retry;

        BCU             *pbcu;
        ISM             *ismp;
        OSM             *osmp;

        pbcu = bcus[line];

        csmp = &pbcu->connectionSM;
        osmp = &pbcu->outputSM;
        ismp = &pbcu->inputSM;

        /* if already connected, get out. */
        if (csmp->state == CONNECTED) return(TRUE);

        if (csmp->state != DISCONNECTED) return(FALSE);

        if (trace[line] & DATALINKTRACE)
        {
            taskDelay(1);
            logMsg ("Attempting connection to BCU...\n");
        }
        initdatalayer(pbcu);

	for (retry=0; retry< N_CONNECT_RETRIES ; retry++ )
	{
            if (output_connectinit(line, pbcu) == FALSE)     /* TX error only */
            {
                if (trace[line] & DATALINKTRACE)
                {
                    taskDelay(1);
                    logMsg ("Abandoning connection attempt. output_connectinit failed. \n");
                }
                csmp->state = DISCONNECTED;
                /* as we never connected, we don't bump the disconnect counter. */
                return(FALSE);
            }
            csmp->retry = 0;
            csmp->responsetimer = tickGet();
            csmp->state = OUTBOUND; /* message sent. */

            /* wait for timeout or proper response */
            while ((csmp->state == OUTBOUND) || (csmp->state == DISCONNECTING))
            {
                receive_frame(line, pbcu);  /* pull out of buffer & process.  */
                if ((tickGet() - csmp->responsetimer) > T_CONNECT_RESPONSE)
                {
                    /* timeout while waiting for a 'connect_request' response. */
                    pbcu->no_rxnoresp++;
                    pbcu->no_retries++;
                    csmp->state = OUTBOUND;
                    if (trace[line] & DATALINKTRACE)
                    {
                        taskDelay(1);
                        logMsg ("CONNECTING: Timeout waiting for connect request from BCU... \n");
                    }
                    break;                   /* fall through and try it again. */
                }
                taskDelay(6);                /* give OS some time to process.  */
            }
            if (csmp->state == CONNECTED)
            {
                /* nothing to do here, as it was already done in receive_frame */
                /* of course, notify network layer if not already done so.     */                
                return(TRUE);
            }
        }
        /* retry count is exhausted. give it up. */
        if (trace[line] & DATALINKTRACE)
        {
            taskDelay(1);
            logMsg ("Abandoning connection attempt. \n");
        }
        csmp->state = DISCONNECTED;
        ismp->state = RECEIVE_IDLE;
        osmp->state = TRANSMIT_IDLE;
        /* notify the network layer */

        /* notify the main loop */
        pbcu->is_responding = FALSE;

        return(FALSE);
}
/******************************************************************************/
/*      bcu_disconnect                                                          
**                                                                              
**      The purpose of this procedure is to effect an immediate non-negociable  
**      disconnection of the BACnet Half-Router link.                           
**                                                                              
*/
/* called from MAIN only. */

static	void bcu_disconnect (unsigned short line)
{
	unsigned short  retry;




        BCU             *pbcu;
        CSM             *csmp; /* pointer to connection state machine */
        ISM             *ismp;
        OSM             *osmp;

        pbcu = bcus[line];

        csmp = &pbcu->connectionSM;
        osmp = &pbcu->outputSM;
        ismp = &pbcu->inputSM;

        /* if already disconnected, get out. */
        if (csmp->state == DISCONNECTED) return;

        /* it should be in connected state. */

        if (trace[line] & DATALINKTRACE)
        {
            taskDelay(1);
            logMsg ("DISCONNECTING: Attempting orderly disconnection from BCU...\n");
        }
	for (retry=0; (retry<N_DISCONNECT_RETRIES); retry++ )
	{
            if (send_frame(line, DisconnectRequest, 0) == FALSE)   /* TX error only */
            {
               /* if hardware failure, exit immediately. */
                if (trace[line] & DATALINKTRACE)
                {
                    taskDelay(1);
                    logMsg ("DISCONNECTED: disconnect request command failed. \n");
                }
                csmp->state = DISCONNECTED;
                ismp->state = RECEIVE_IDLE;
                osmp->state = TRANSMIT_IDLE;
                return;
            }
            csmp->retry = 0;
            csmp->responsetimer = tickGet();
            csmp->state = DISCONNECTING;     /* message sent. */

            /* wait for timeout or proper response */
            while ((csmp->state == DISCONNECTING))
            {
                receive_frame(line, pbcu);         /* pull out of buffer & process.     */
                if ((tickGet() - csmp->responsetimer) > T_RESPONSE)
                {
                    /* timeout while waiting for a 'disconnect_request' response. */
                    pbcu->no_rxnoresp++;
                    pbcu->no_retries++;
                    if (trace[line] & DATALINKTRACE)
                    {
                        taskDelay(1);
                        logMsg
                          ("DISCONNECTING: timeout waiting for disconnect response from BCU... \n");
                    }
                    csmp->state = DISCONNECTING;
                    break;                   /* fall through and try it again.    */
                }
                 taskDelay(6);                /* give OS some time to process.     */
            }
            if (csmp->state == DISCONNECTED)
            {
                return;
            }
        }
        /* retry count is exhausted. give it up. */
        if (trace[line] & DATALINKTRACE)
        {
            taskDelay(1);
            logMsg ("DISCONNECTED: retries exhausted. proceeding with unacknowledged disconnect. \n");
        }
        csmp->state = DISCONNECTED;
        ismp->state = RECEIVE_IDLE;
        osmp->state = TRANSMIT_IDLE;
        return;
}

/******************************************************************************/
/*      forced_bcu_disconnect                                                   
**                                                                              
**      The purpose of this procedure is to effect an immediate non-negociable  
**      disconnection of the BACnet Half-Router link.                           
**                                                                              
*/
/* called from MAIN only. */

static	void forced_bcu_disconnect (unsigned short line)
{
	unsigned short  retry;
        unsigned char   entrystate;

        BCU             *pbcu;
        CSM             *csmp; /* pointer to connection state machine */
        ISM             *ismp;
        OSM             *osmp;

        pbcu = bcus[line];

        csmp = &pbcu->connectionSM;
        osmp = &pbcu->outputSM;
        ismp = &pbcu->inputSM;

        /* note entry connection state */
        entrystate = csmp->state;


        if (trace[line] & DATALINKTRACE)
        {
            taskDelay(1);
            logMsg ("DISCONNECTING: Attempting FORCED disconnection from BCU...\n");
        }

	for (retry=0; (retry<N_DISCONNECT_RETRIES); retry++ )
	{
            if (send_frame(line, DisconnectRequest, 0) == FALSE)     /* TX error only */
            {
               /* if hardware failure, exit immediately. */
                if (trace[line] & DATALINKTRACE)
                {
                    taskDelay(1);
                    logMsg ("DISCONNECTED: FORCED disconnect request command failed. \n");
                }
                csmp->state = DISCONNECTED;
                ismp->state = RECEIVE_IDLE;
                osmp->state = TRANSMIT_IDLE;

                /* if we were disconnected on entry, don't bump the offline counter. */
                if (entrystate != DISCONNECTED)
                {
                }
                return;
            }
            csmp->retry = 0;
            csmp->responsetimer = tickGet();
            csmp->state = DISCONNECTING;     /* message sent. */

            /* wait for timeout or proper response */
            while ((csmp->state == DISCONNECTING))
            {
                receive_frame(line, pbcu);         /* pull out of buffer & process.     */
                if ((tickGet() - csmp->responsetimer) > T_RESPONSE)
                {
                    /* timeout while waiting for a 'disconnect_request' response. */
                    pbcu->no_rxnoresp++;
                    pbcu->no_retries++;
                    if (trace[line] & DATALINKTRACE)
                    {
                        taskDelay(1);
                        logMsg (
                        "DISCONNECTED: no disconnect request from BCU. disconnection assumed.\n");
                    }
                    csmp->state = DISCONNECTING;
                    break;                   /* fall through and try it again.    */
                }
                 taskDelay(6);                /* give OS some time to process.     */
            }
            if (csmp->state == DISCONNECTED)
            {
                /* if we were disconnected on entry, don't bump the offline counter. */
                if (entrystate != DISCONNECTED)
                {
                }
                return;
            }
        }
        csmp->state = DISCONNECTED;
        ismp->state = RECEIVE_IDLE;
        osmp->state = TRANSMIT_IDLE;
        return;
}

/*********************************************************************/
/*********************************************************************/
/*********************************************************************/
static	unsigned short  output_connectinit (unsigned short line, BCU *pbcu)
{

	TX_FRAME          *txp;

	txp = txlinetab[line];

        strcpy(&txp->OutputBuffer,&initstring);      /* transfer the init string to TX buffer.     */
        txp->txstate = TXINITCONNECT;                /* special sub-state machine for init connect.*/

        /* this fires off the transmission. */
        return(send_frame(line, BACnetString, strlen(initstring)));
}



/*********************************************************************/
/*                                                                   */
/* send_data                                                         */
/*                                                                   */
/* this is a sender of datalink layer messages. here we do the       */
/* transmit state machine logic. prior to transmitting, we make sure */
/* that it is valid to do so. here we wait for confirmation of data  */
/* being received by the peer device. we return error if ANYTHING    */
/* goes wrong. if everything goes right, it means the peer layer has */
/* acknowledged receipt of the transmitted message.                  */
/*********************************************************************/

static	unsigned short  send_data (unsigned short line, BCU *pbcu)
{


    TX_FRAME          *txp;
    CSM               *csmp;
    NSM               *nsmp;
    OSM               *osmp;
    ISM               *ismp;

    csmp = &pbcu->connectionSM;
    nsmp = &pbcu->networkSM;
    osmp = &pbcu->outputSM;
    ismp = &pbcu->inputSM;

    txp = txlinetab[line];

    if (osmp->state == TRANSMIT_IDLE)
    {
        /* during testing, always print message. */
        if (trace[line] & DATALINKTRACE)
        {
            taskDelay(1);
            logMsg("transmit idle: transmit aborted.\n");
        }
        return(FALSE);
    }
    if (osmp->state == TRANSMIT_PENDING)
    {
        /* during testing, always print message. */
        if (trace[line] & DATALINKTRACE)
        {
            taskDelay(1);
            logMsg("transmit pending: transmit aborted.\n");
        }
        return(FALSE);
    }

/* transmit blocked: wait for finite time, then reject. */
    osmp->starttime = tickGet();         /* store time stamp for starting. */

    while (osmp->state != TRANSMIT_READY) /* wait for ready to transmit (if not ready, . */
                                           /* or disconnect to occur */
    {
        if (trace[line] & DATALINKTRACE)
        {
            taskDelay(1);
            logMsg("datalink transmit blocked: waiting ...\n");
        }
        taskDelay(20);               /* don't hog the CPU. */
        receive_frame(line, pbcu);   /* handle the datalink level stuff. notice that it     */
                                     /* doesn't wait for input. it processes state changes  */
                                     /* for input and and connection state machines.        */
        manage_output_state(line, pbcu);

        /* test for XON received to enable this transmission */
        if (osmp->TransmissionBlocked == FALSE)
        {
            osmp->state = TRANSMIT_READY;
        }
        /* test for disconnected */
        if (csmp->state == DISCONNECTED)
        {
            osmp->state = TRANSMIT_IDLE;
            /* during testing, always print message. */
            if (trace[line] & DATALINKTRACE)
            {
                taskDelay(1);
                logMsg("transmit idle: transmit aborted.\n");
            }
            return(FALSE);
        }
        /* test for response timeout. */
        if ((tickGet() - osmp->starttime) > T_TRANSMIT_BLOCKED)
        {
            /* during testing, always print message. */
            if (trace[line] & DATALINKTRACE)
            {
                taskDelay(1);
                logMsg("datalink transmit blocked timeout\n");
            }
            return(FALSE);
        }
    }
    /* to arrive here, state must be TRANSMIT_READY */
    /* transmission state setup */
    osmp->RetryCount = 0;

    while (osmp->RetryCount < N_RETRIES)
    {
        if (output_data (line, pbcu) == TRUE) /* means the message was transmitted successfully.     */
        {
            while (TRUE)                     /* wait for something to occur (including timeout).    */
            {
                taskDelay(1);                /* don't hog the CPU. */
                receive_frame(line, pbcu);   /* handle the datalink level stuff.                    */
                                             /* notice that it doesn't hang up down in here waiting */
                                             /* for input. it processes state changes for input,    */
                                             /* output and connection state machines.               */

                manage_output_state(line, pbcu); /* process the output state logic. acts on results */
                                             /* of input and connected state machines.              */


                /* test for disconnect */
                if (csmp->state == DISCONNECTED)
                {
                    /* during testing, always print message. */
                    if (trace[line] & DATALINKTRACE)
                    {
                        taskDelay(1);
                        logMsg("connection lost\n");
                    }
                    /* don't attempt retry on disconnect. */
                    return(FALSE);
                }

                /* test for transmit acknowledge.   */
                if (ismp->Ack0Received == TRUE)
                {
                    if (osmp->TxSequenceNumber == 0)
                    {
                        osmp->state = TRANSMIT_READY;
                        ismp->Ack0Received = FALSE;
                        ismp->Ack1Received = FALSE;
                        return(TRUE);
                    }
                    else
                    {
                        /* for now, let's just get this thing out of here. */
                        osmp->state = TRANSMIT_READY;
                        ismp->Ack0Received = FALSE;
                        ismp->Ack1Received = FALSE;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
                            logMsg("Invalid TXSequenceNumber(%d).\n", osmp->TxSequenceNumber);
                        }
                        return(TRUE);
                    }
                }
                /* test for transmit acknowledge.   */
                if (ismp->Ack1Received == TRUE)
                {
                    if (osmp->TxSequenceNumber == 1)
                    {
                        osmp->state = TRANSMIT_READY;
                        ismp->Ack0Received = FALSE;
                        ismp->Ack1Received = FALSE;
                        return(TRUE);
                    }
                    else
                    {
                        /* for now, let's just get this thing out of here. */
                        osmp->state = TRANSMIT_READY;
                        ismp->Ack0Received = FALSE;
                        ismp->Ack1Received = FALSE;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
                            logMsg("Invalid TXSequenceNumber(%d).\n", osmp->TxSequenceNumber);
                        }
                        return(TRUE);
                    }
                }


                /* test for transmit reject.   */
                if (ismp->Reject0Received == TRUE)
                {
                    if (trace[line] & DATALINKTRACE)
                    {
                        taskDelay(1);
                        logMsg("datalink message reject0ed: ");
                    }
                    if (osmp->TxSequenceNumber == 0)
                    {
                        osmp->RetryCount++;
                        osmp->state = TRANSMIT_PENDING;
                        ismp->Ack0Received = FALSE;
                        ismp->Ack1Received = FALSE;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
                            printf("Valid TXSequenceNumber(%d).\n", osmp->TxSequenceNumber);
                        }
                        /* break out forever loop for retry, if any left. */
                        break;
                    }
                    else
                    {
                        /* for now, let's just get this thing out of here. */
                        osmp->RetryCount++;
                        osmp->state = TRANSMIT_PENDING;
                        ismp->Ack0Received = FALSE;
                        ismp->Ack1Received = FALSE;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
                            printf("Invalid TXSequenceNumber(%d).\n", osmp->TxSequenceNumber);
                        }
                        /* break out forever loop for retry, if any left. */
                        break;
                    }
                }
                /* test for transmit reject.   */
                if (ismp->Reject1Received == TRUE)
                {
                    if (trace[line] & DATALINKTRACE)
                    {
                        taskDelay(1);
                        logMsg("datalink message reject1ed: ");
                    }
                    if (osmp->TxSequenceNumber == 0)
                    {
                        osmp->RetryCount++;
                        osmp->state = TRANSMIT_PENDING;
                        ismp->Ack0Received = FALSE;
                        ismp->Ack1Received = FALSE;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
                            printf("Valid TXSequenceNumber(%d).\n", osmp->TxSequenceNumber);
                        }
                        /* break out forever loop for retry, if any left. */
                        break;
                    }
                    else
                    {
                        /* for now, let's just get this thing out of here. */
                        osmp->RetryCount++;
                        osmp->state = TRANSMIT_PENDING;
                        ismp->Ack0Received = FALSE;
                        ismp->Ack1Received = FALSE;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
                            printf("Invalid TXSequenceNumber(%d).\n", osmp->TxSequenceNumber);
                        }
                        /* break out forever loop for retry, if any left. */
                        break;
                    }
                }

                /* test for response timeout. */
                if ((tickGet() - osmp->starttime) > T_RESPONSE)
                {
                    pbcu->no_rxnoresp++;
                    osmp->RetryCount++;
                    osmp->state = TRANSMIT_PENDING;
                    if (trace[line] & DATALINKTRACE)
                    {
                        taskDelay(1);
                        logMsg("datalink response timeout\n");
                    }
                    /* break out forever loop for retry, if any left. */
                    break;
                }
             }
        }
        else
        {
            if (trace[line] & DATALINKTRACE)
            {
                taskDelay(1);
                logMsg("send_confirmed returned FALSE. something went wrong sending the message.\n");
            }
            return(FALSE);
        }
    pbcu->no_retries++;
    }
    /* retry count exhausted. give up. reset this stuff and get out of here. */
     osmp->state = TRANSMIT_READY;
     ismp->Ack0Received = FALSE;
     ismp->Ack1Received = FALSE;
     ismp->Reject0Received = FALSE;
     ismp->Reject1Received = FALSE;
     if (trace[line] & DATALINKTRACE)
     {
         taskDelay(1);
         logMsg("retry count exhausted: transmit aborted.\n");
     }
     return(FALSE);
}

/*********************************************************************/
/*********************************************************************/
/*********************************************************************/
static	unsigned short  output_data (unsigned short line, BCU *pbcu)
{
    unsigned short    i, results;
    unsigned char     frametype;
    TX_FRAME          *txp;
    NSM               *nsmp;
    OSM               *osmp;
    ISM               *ismp;

    nsmp = &pbcu->networkSM;
    osmp = &pbcu->outputSM;
    ismp = &pbcu->inputSM;
    txp = txlinetab[line];

    /* transfer NPDU to transmit buffer (if non-zero length) */
    for (i=0; i<nsmp->OutputLength ; i++)
    {
        txp->OutputBuffer[i] = nsmp->OutputBuffer[i];
    }
    osmp->starttime = tickGet();         /* store time stamp for starting. */

    /* toggle data request sequence number for this transmission */
    /* (it will be matched against response)                     */
    if (osmp->TxSequenceNumber != 0)
    {
        osmp->TxSequenceNumber = 0;
        frametype = DataRequest0;
    }
    else
    {
        osmp->TxSequenceNumber = 1;
        frametype = DataRequest1;
    }

    /* fire off transmission, return results.     */
    results = send_frame(line, frametype, nsmp->OutputLength);
    return (results);
}
/*
**      SendFrame                                                               
**                                                                              
**      The purpose of this procedure is to transmit a buffer to the BACnet     
**      Half-Router and return from this procedure with an error/success        
**      status, on the TRANSMIT only.                                           
**                                                                              
**      on call, everything is set up, including frametype and txstate.         
**                                                                              
**              returns         XFERGOOD if response received                   
**                              XFERBAD  if no good response is received     	
**                                                                           	
*/

static	unsigned short send_frame (unsigned short line, unsigned char frametype, unsigned short length)
    {
	unsigned short  txstatus, txtimeout, ix;

	TX_FRAME       *txp;
        BCU            *pbcu;

        unsigned int    tick1, tick2, tick3, tick4;
        unsigned int    delta12, delta23, delta34;

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        tick1 = tick2 = tick3 = tick4 = 0;     /* pre-zero all time keep registers */
        delta12 = delta23 = delta34 = 0;

        pbcu = bcus[line];

	txp = txlinetab[line];

        txp->DataLength = length;

        switch (frametype)
        {
            case BACnetString:
                txp->txstate = TXINITCONNECT;
                txp->FrameType = frametype;
                break;
            case HeartbeatXOFF:
            case HeartbeatXON:
            case DataRequest0:
            case DataRequest1:
            case DataResponse0XOFF:
            case DataResponse1XOFF:
            case DataResponse0XON:
            case DataResponse1XON:
            case DataReject0XON:
            case DataReject0XOFF:
            case DataReject1XON:
            case DataReject1XOFF:
            case ConnectRequest:
            case ConnectResponse:
            case DisconnectRequest:
            case DisconnectResponse:
            case TestRequest:
            case TestResponse:
                txp->txstate = TXSTART;
                txp->FrameType = frametype;
                break;
            default:
                /* should never occur. */
                if (trace[line] & DATALINKTRACE)
                {
                    taskDelay(1);
                    printf ("send_frame: illegal frame type encountered.\n");
                }
                break;
        }

            if (trace[line] & ALLTRAFFICTRACE)
            {
                taskDelay(2);

                printf("TX: ");
                switch (txp->FrameType)
                {
                    case HeartbeatXOFF:
                        printf ("HeartbeatXOFF:     ");
                        break;
                    case HeartbeatXON:
                        printf ("HeartbeatXON:      ");
                        break;
                    case DataRequest0:
                        printf ("DataRequest0:      ");
                        break;
                    case DataRequest1:
                        printf ("DataRequest1:      ");
                        break;
                    case DataResponse0XOFF:
                        printf ("DataResponse0XOFF: ");
                        break;
                    case DataResponse1XOFF:
                        printf ("DataResponse1XOFF: ");
                        break;
                    case DataResponse0XON:
                        printf ("DataResponse0XON:  ");
                        break;
                    case DataResponse1XON:
                        printf ("DataResponse1XON:  ");
                        break;
                    case DataReject0XOFF:
                        printf ("DataReject0XOFF:   ");
                        break;
                    case DataReject0XON:
                        printf ("DataReject0XON:    ");
                        break;
                    case DataReject1XOFF:
                        printf ("DataReject1XOFF:   ");
                        break;
                    case DataReject1XON:
                        printf ("DataReject1XON:    ");
                        break;
                    case ConnectRequest:
                        printf ("ConnectRequest:    ");
                        break;
                    case ConnectResponse:
                        printf ("ConnectResponse:   ");
                        break;
                    case DisconnectRequest:
                        printf ("DisconnectRequest: ");
                        break;
                    case DisconnectResponse:
                        printf ("DisconnectResponse:");
                        break;
                    case TestRequest:
                        printf ("TestRequest:       ");
                        break;
                    case TestResponse:
                        printf ("TestResponse:      ");
                        break;
                    case BACnetString:
                        printf ("BACnetString:      ");
                        break;
                }
                for (ix = 0; ix < 36 ; ix++) /* 36 is maximum RX message length we display. */
                {
                     if (ix < txp->DataLength)
                         printf("_%2x", txp->OutputBuffer[ix]);
                     else
                         printf("...");
                } 
	        printf("\n");
            }

        if (intermsgdelay[line] != 0)
        {
            taskDelay (intermsgdelay[line]);
        }
        set_rts(line);

        if (pretxdelay[line] != 0)
        {
            taskDelay (pretxdelay[line]);
        }

        semTake(semids [line][TXSEM], NO_WAIT);

        txtimeout = FALSE;                   /* start our presuming a good transmission. */

        start_tx(line, semids[line][TXSEM], &txstatus); /* this fires off the transmission. */

        if ((semTake(semids[line][TXSEM], TXTIMEOUT)) == ERROR)
           txtimeout = TRUE;

        /* if transmit error occur , then error takes precidence over timeout. */
        if (txp->TransmitError == TRUE)
            txtimeout = FALSE;               /* this get path below to take error else */

        if (posttxdelay[line] != 0)
	{
            taskDelay (posttxdelay[line]);
        }

        if (txp->TransmittedValidFrame == TRUE)
        {
	       return (TRUE);
        }
	else
        {
            if (txtimeout == TRUE)
            {
                if (modtrace[line])
                {
                    taskDelay(1);
                    logMsg ("Transmit Timeout\n");
                }
	        pbcu->no_txnoresp++;
                return (FALSE);
            }
            else
            {
                if (modtrace[line])
                {
                    taskDelay(1);
                    logMsg ("Transmit Error\n");
                }
                pbcu->no_txhwerrs++;
                return (FALSE);
            }
        }
    }
/*****************************************************************************/
/*      manage_output_state                                                  	 
**                                                                           	 
**
*/
static void manage_output_state (unsigned short line, BCU *pbcu)
    {

         CSM             *csmp;
         OSM             *osmp;
         ISM             *ismp;

         csmp = &pbcu->connectionSM;
         osmp = &pbcu->outputSM;
         ismp = &pbcu->inputSM;

/* work the output state machine */
            switch(osmp->state)
            {
                case TRANSMIT_IDLE:      /* no action based on Frame reception */
                    break;

                case TRANSMIT_BLOCKED:   /* see page 115-116 of spec  */
                    /* send request: handled directly in send_frame   */
                    /* peer receiver ready:                           */
                    if (osmp->TransmissionBlocked == FALSE)
                    {
                        osmp->state = TRANSMIT_READY;
                    }
                    /* disconnect: handled directly in send_frame     */
                    /* heartbeat timer expired xon/xoff               */
                    if ((tickGet() - osmp->LastFrameTime) >= T_HEARTBEAT)
                    {
                        if (ismp->ReceptionBlocked == TRUE)
                        {
                            send_frame(line, HeartbeatXOFF, 0);
                            osmp->state = TRANSMIT_BLOCKED;
                        }
                        if (ismp->ReceptionBlocked == FALSE)
                        {
                            send_frame(line, HeartbeatXON, 0);
                            osmp->state = TRANSMIT_BLOCKED;
                        }
                        osmp->LastFrameTime = tickGet();
                    }
                    break;

                case TRANSMIT_READY:     /* see page 116-117 of spec    */
                    /* disconnect: handled directly in send_frame       */
                    /* send request: handled directly in send_frame     */

                    /* transmit message: handled elsewhere              */

                    /* remote busy:                                     */
                    if (osmp->TransmissionBlocked == TRUE)
                    {
                        osmp->state = TRANSMIT_BLOCKED;
                    }

                    /* heartbeat timer expired xon/xoff */
                    if ((tickGet() - osmp->LastFrameTime) >= T_HEARTBEAT)
                    {
                        if (ismp->ReceptionBlocked == TRUE)
                        {
                            send_frame(line, HeartbeatXOFF, 0);
                            osmp->state = TRANSMIT_READY;
                        }
                        if (ismp->ReceptionBlocked == FALSE)
                        {
                            send_frame(line, HeartbeatXON, 0);
                            osmp->state = TRANSMIT_READY;
                        }
                        osmp->LastFrameTime = tickGet();
                    }
                    break;


                case TRANSMIT_PENDING:     /* see page 117-118 of spec */
                    /* send request: handled directly in send_frame    */

                    /* disconnect: handled directly in send_frame      */

                    /* transmit message:                               */

                    /* receive acknowledgment: handled elsewhere       */

                    /* retry: handled elsewhere.                       */

                    /* retry failed: handled elsewhere                 */
            }
    }


/******************************************************************************/
/******************************************************************************/
/* INPUT/RECEIVE PROCEDURES ***************************************************/
/******************************************************************************/
/******************************************************************************/

/*      receive_frame                                                            
**                                                                           	 
**      The purpose of this routine is to parse and process the data layer DPDU. 
**      If there are no frames to process when called, it checks for inactivity  
**      timeout condition. Both Valid and InValid frames are handled. Only a     
**      maximum of one frame is processed during this call. more frames may      
**      well be contained in the raw buffer on exit.                             
**
*/
static	unsigned short  receive_frame (unsigned short line, BCU *pbcu)
    {
	unsigned short   ix;
	RX_FRAME          *rxp;

        unsigned int    tick1, tick2, tick3, tick4;
        unsigned int    delta12, delta23, delta34;

        CSM             *csmp;
        OSM             *osmp;
        ISM             *ismp;

        /******************************/
        tisWatchDogPulse(watchdogId[line]);
        /******************************/

        /* Set up pointer to frame buffer. */
        rxp = rxlinetab[line];

        csmp = &pbcu->connectionSM;
        osmp = &pbcu->outputSM;
        ismp = &pbcu->inputSM;

        tick1 = tick2 = tick3 = tick4 = 0;     /* pre-zero all time keep registers */
        delta12 = delta23 = delta34 = 0;

        /* process any stuff in the raw buffer */
        while ((rxrawgetnextp(line) != NULLP) && (rxp->rxstate != RXENDFRAME))
        {
                rxrawprocess(line);
                rxrawreleasefull(line);    /* point to the next raw queue entry */
        }
        /* see if we have a frame to process */
        if (rxp->rxstate == RXENDFRAME)
        {
            if (trace[line] & ALLTRAFFICTRACE)
            {
                taskDelay(2);
                printf("RX: ");
                switch (rxp->FrameType)
                {
                    case HeartbeatXOFF:
                        printf ("HeartbeatXOFF:     ");
                        break;
                    case HeartbeatXON:
                        printf ("HeartbeatXON:      ");
                        break;
                    case DataRequest0:
                        printf ("DataRequest0:      ");
                        break;
                    case DataRequest1:
                        printf ("DataRequest1:      ");
                        break;
                    case DataResponse0XOFF:
                        printf ("DataResponse0XOFF: ");
                        break;
                    case DataResponse1XOFF:
                        printf ("DataResponse1XOFF: ");
                        break;
                    case DataResponse0XON:
                        printf ("DataResponse0XON:  ");
                        break;
                    case DataResponse1XON:
                        printf ("DataResponse1XON:  ");
                        break;
                    case DataReject0XOFF:
                        printf ("DataReject0XOFF:   ");
                        break;
                    case DataReject0XON:
                        printf ("DataReject0XON:    ");
                        break;
                    case DataReject1XOFF:
                        printf ("DataReject1XOFF:   ");
                        break;
                    case DataReject1XON:
                        printf ("DataReject1XON:    ");
                        break;
                    case ConnectRequest:
                        printf ("ConnectRequest:    ");
                        break;
                    case ConnectResponse:
                        printf ("ConnectResponse:   ");
                        break;
                    case DisconnectRequest:
                        printf ("DisconnectRequest: ");
                        break;
                    case DisconnectResponse:
                        printf ("DisconnectResponse:");
                        break;
                    case TestRequest:
                        printf ("TestRequest:       ");
                        break;
                    case TestResponse:
                        printf ("TestResponse:      ");
                        break;
                    case BACnetString:
                        printf ("BACnetString:      ");
                        break;
                }
                for (ix = 0; ix < 36 ; ix++) /* 36 is maximum RX message length we display. */
                {
                     if (ix < rxp->DataLength)
                         printf("_%2x", rxp->InputBuffer[ix]);
                     else
                         printf("...");
                } 
	        printf("\n");
            }
            if (rxp->ReceivedInvalidFrame == TRUE)
            {
                rxp->ReceivedValidFrame = FALSE;
                rxp->ReceivedInvalidFrame = FALSE;
                /* (parse_bad_frame) */
                switch(ismp->state)
                {
                    case RECEIVE_READY:     /* see page 119-120 of spec */
                        switch (rxp->FrameType)
                        {
                            case DataRequest0:
                            case DataResponse0XON:
                            case DataResponse0XOFF:
                                ismp->LastFrameTime = tickGet();
                                if (ismp->ReceptionBlocked)
                                {
                                    send_frame(line, DataReject0XOFF, 0);
                                }
                                else
                                {
                                    send_frame(line, DataReject0XON, 0);
                                }
                                ismp->state = RECEIVE_READY; /* pass or fail, we still change state */
                                rxp->rxstate = RXIDLE;       /* indicates end of frame processing.  */
                                                             /* code is ready for next frame.       */
                                return(TRUE);
                                break;

                            case DataRequest1:
                            case DataResponse1XON:
                            case DataResponse1XOFF:
                                ismp->LastFrameTime = tickGet();
                                if (ismp->ReceptionBlocked)
                                {
                                    send_frame(line, DataReject1XOFF, 0);
                                }
                                else
                                {
                                    send_frame(line, DataReject1XON, 0);
                                }
                                ismp->state = RECEIVE_READY; /* pass or fail, we still change state */
                                rxp->rxstate = RXIDLE;       /* indicates end of frame processing.  */
                                                             /* code is ready for next frame.       */
                                return(TRUE);
                                break;
                            default:
                                /* by doing nothing, the frame is discarded. */
                                rxp->rxstate = RXIDLE;       /* indicates end of frame processing.  */
                                                             /* code is ready for next frame.       */
                                return(TRUE);
                                break;
                        }
                   default:
                        /* by doing nothing, the frame is discarded. */
                        rxp->rxstate = RXIDLE;       /* indicates end of frame processing.  */
                                                     /* code is ready for next frame.       */
                        return(TRUE);
                        break;
               }
            }
            if (rxp->ReceivedValidFrame == TRUE)
            {
                /* common actions for all affected SMs. all inputs must be handled in parse_frame. */
                ismp->LastFrameTime = tickGet();
                rxp->ReceivedValidFrame = FALSE;
                rxp->ReceivedInvalidFrame = FALSE;

                                             /***************************/
                parse_frame(line, pbcu);     /* ACTION TAKES PLACE HERE */
                                             /***************************/

                rxp->rxstate = RXIDLE;       /* indicates end of frame processing.  */
                                             /* code is ready for next frame.       */
                return(TRUE);
            }
        }
        else /* not at end frame */
        {
            if (csmp->state == DISCONNECTED)
            {
                ismp->state = RECEIVE_IDLE;
                osmp->state = TRANSMIT_IDLE;
            }
            /* test for timeout waiting for frame (InactivityTimer) */
            if ((tickGet() - ismp->LastFrameTime) > T_INACTIVITY)
            {
                if (trace[line] & DATALINKTRACE)
                {
                    taskDelay(1);
                    logMsg ("DISCONNECTED: RX inactivity timeout. \n");
                }
                csmp->state = DISCONNECTED;
                ismp->state = RECEIVE_IDLE;
                osmp->state = TRANSMIT_IDLE;
                rxp->rxstate = RXIDLE;       /* indicates end of frame processing.  */
                                             /* code is ready for next frame.       */
                return(TRUE);
            }
        }
}
/*****************************************************************************/
/*      parse_frame                                                         	 
**                                                                           	 
**      The purpose of this routine is to parse and process the data layer DPDU. 
**      The Connection State Machine, Output State Machine, and the Input State  
**      Machine are all processed here. send_frame calls are made from this      
**      procedure. This procedure does NOT contain all of the state logic for    
**      the three state machines.                                                
**                                                                               
*/
static	void  parse_frame (unsigned short line, BCU *pbcu)
    {

        RX_FRAME          *rxp;

        CSM             *csmp;
        OSM             *osmp;
        ISM             *ismp;

        /* Set up pointer to frame buffer. */
        rxp = rxlinetab[line];

        csmp = &pbcu->connectionSM;
        osmp = &pbcu->outputSM;
        ismp = &pbcu->inputSM;

/*********************************************/
/* work through the connection state machine */
/*********************************************/

        switch(csmp->state)
        {
            case DISCONNECTED:     /* see page 111 - 112 of spec */
                ismp->state = RECEIVE_IDLE;
                osmp->state = TRANSMIT_IDLE;
                /* by doing nothing, the frame is discarded. */
                return;
                break;

            case OUTBOUND:         /* see page 111 - 112 of spec */
                switch (rxp->FrameType)
                {
                    case ConnectRequest:
                         if (ismp->ReceptionBlocked == FALSE)
                         {
                             send_frame(line, ConnectResponse, 0);
                             send_frame(line, HeartbeatXON, 0);
                             osmp->TxSequenceNumber = 99;
                             ismp->RxSequenceNumber = 0;
                             if (trace[line] & DATALINKTRACE)
                             {
                                 taskDelay(1);
                 logMsg ("CONNECTED: ConnectRequest received from BCU. ConnectResponse sent.(XON) \n");
                             }
                             csmp->state = CONNECTED;
                             ismp->state = RECEIVE_READY;
                             osmp->state = TRANSMIT_BLOCKED;
                             return;
                         }
                         if (ismp->ReceptionBlocked == TRUE)
                         {
                             send_frame(line, ConnectResponse, 0);
                             send_frame(line, HeartbeatXOFF, 0);
                             osmp->TxSequenceNumber = 99;
                             ismp->RxSequenceNumber = 0;
                             if (trace[line] & DATALINKTRACE)
                             {
                                 taskDelay(1);
                logMsg ("CONNECTED: ConnectRequest received from BCU. ConnectResponse sent.(XOFF) \n");
                             }
                             csmp->state = CONNECTED;
                             osmp->state = TRANSMIT_BLOCKED;
                             return;
                         }
                         break;
                    default:
                         /* by doing nothing, the frame is discarded. */
                         return;
                         break;
                }
                break;

            case INBOUND:     /* see page 113 of spec */
                switch (rxp->FrameType)
                {
                    case ConnectResponse:
                        if (rxp->DataLength == 0) /* password not sent (we don't need it)       */
                        {
                            send_frame(line, HeartbeatXON, 0);
                            osmp->TxSequenceNumber = 99;
                            ismp->RxSequenceNumber = 0;
                            csmp->state = CONNECTED;
                            if (trace[line] & DATALINKTRACE)
                            {
                                taskDelay(1);
                                logMsg ("CONNECTED: ConnectResponse received from BCU. (Solicited)\n");
                            }
                            return;
                        }
                        else                      /* password sent (we don't want it)           */
                        {
                            send_frame(line, DisconnectRequest, 0);
                            csmp->state = DISCONNECTING;
                            if (trace[line] & DATALINKTRACE)
                            {
                                taskDelay(1);
                                logMsg ("DISCONNECTING: ConnectResponse not received from BCU. \n");
                            }
                            return;
                        }
                        return;
                        break;
                    case DisconnectRequest:
                        send_frame(line, DisconnectResponse, 0);
                        ismp->state = RECEIVE_IDLE;
                        osmp->state = TRANSMIT_IDLE;
                        csmp->state = DISCONNECTED;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
             logMsg ("DISCONNECTED: DisconnectRequest received from BCU. DisconnectResponse sent. \n");
                        }
                        return;
                        break;
                    default:
                        /* by doing nothing, the frame is discarded. */
                        return;
                        break;
                }
                break;

            case CONNECTED:         /* see page 113 - 114 of spec */
                switch (rxp->FrameType)
                {
                    case DisconnectRequest:
                        send_frame(line, DisconnectResponse, 0);
                        ismp->state = RECEIVE_IDLE;
                        osmp->state = TRANSMIT_IDLE;
                        csmp->state = DISCONNECTED;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
            logMsg ("DISCONNECTED: DisconnectRequest received from BCU. DisconnectResponse sent. \n");
                        }
                        return;
                        break;
                    case ConnectRequest:
                         send_frame(line, ConnectResponse, 0);
                         csmp->state = CONNECTED;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
          logMsg ("CONNECTED: ConnectRequest received from BCU. ConnectResponse sent. (Redundant)\n");
                        }
                         return;
                         break;
                    default:
                         /* fall through to crank the input state machine. */
                         break;
                }
                break;

            case DISCONNECTING:     /* see page 114 of spec */
                switch (rxp->FrameType)
                {
                    case DisconnectResponse:
                        ismp->state = RECEIVE_IDLE;
                        osmp->state = TRANSMIT_IDLE;
                        csmp->state = DISCONNECTED;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
                            logMsg ("DISCONNECTED: DisconnectResponse received from BCU. \n");
                        }
                        return;
                        break;
                    case DisconnectRequest:
                        send_frame(line, DisconnectResponse, 0);
                        ismp->state = RECEIVE_IDLE;
                        osmp->state = TRANSMIT_IDLE;
                        csmp->state = DISCONNECTED;
                        if (trace[line] & DATALINKTRACE)
                        {
                            taskDelay(1);
                            logMsg ("DISCONNECTED: DisconnectRequest received from BCU. DisconnectResponse sent. \n");
                        }
                        return;
                        break;
                    default:
                        /* by doing nothing, the frame is discarded. */
                        return;
                        break;
                }
                break;
            default:
                return;
                break;
        }

/* this point can only be reached by falling through from CONNECTED state above. */
/* work the input state machine */
        switch(ismp->state)
        {
            case RECEIVE_IDLE:      /* no action based on Frame reception */
                /* by doing nothing, the frame is discarded. */
                return;
                break;

            case RECEIVE_NOT_READY: /* no action based on Frame reception */
                /* by doing nothing, the frame is discarded. */
                return;
                break;

            case RECEIVE_READY:     /* see page 119-120 of spec */
                switch (rxp->FrameType)
                {
                    case DataRequest0:
                        ismp->state = DATA_REQUEST;
                        if (ismp->ReceptionBlocked == FALSE)
                        {
                            if (ismp->RxSequenceNumber == 0) /* no error. good stuff */
                            {
                                /* deliver NPDU to the Network Layer */
                                if (deliver_inputNPDU(line, pbcu) == FALSE)
                                {
                                    /* network layer queue was full */
                                }
                            }
                            else
                            {
                                /* for now, nothing special is done on a duplicate error */
                                if (trace[line] & DATALINKTRACE)
                                {
                                    taskDelay(1);
                        printf("RxSequenceNumber indicates duplicate record. no action taken(00).\n");
                                }
                            }
                            send_frame(line, DataResponse0XON, 0);
                            ismp->RxSequenceNumber = 1;
                            ismp->state = RECEIVE_READY; /* pass or fail, we still change state */
                        }
                        if (ismp->ReceptionBlocked == TRUE) /* meaning: room for this one only.  */
                        {
                            if (ismp->RxSequenceNumber == 0) /* no error. good stuff */
                            {
                                /* deliver NPDU to the Network Layer */
                                if (deliver_inputNPDU(line, pbcu) == FALSE)
                                {
                                    /* network layer queue was full */
                                }
                            }
                            else
                            {
                                /* for now, nothing special is done on a duplicate error */
                                if (trace[line] & DATALINKTRACE)
                                {
                                    taskDelay(1);
                        printf("RxSequenceNumber indicates duplicate record. no action taken(01).\n");
                                }
                            }
                            send_frame(line, DataResponse0XOFF, 0);
                            ismp->RxSequenceNumber = 1;
                            ismp->state = RECEIVE_NOT_READY; /* pass or fail, we still change state */
                        }
                        break;

                    case DataRequest1:
                        ismp->state = DATA_REQUEST;          /* only temporary, (or is it?)         */
                        if (ismp->ReceptionBlocked == FALSE) /* meaning: room for this one and      */
                                                             /* another one, too.                   */
                        {
                            if (ismp->RxSequenceNumber == 1) /* no error. good stuff.               */
                            {
                                /* deliver NPDU to the Network Layer */
                                if (deliver_inputNPDU(line, pbcu) == FALSE)
                                {
                                    /* network layer queue was full */
                                }
                            }
                            else
                            {
                                /* for now, nothing special is done on a duplicate error */
                                if (trace[line] & DATALINKTRACE)
                                {
                                    taskDelay(1);
                        printf("RxSequenceNumber indicates duplicate record. no action taken(02).\n");
                                }
                            }
                            send_frame(line, DataResponse1XON, 0);
                            ismp->RxSequenceNumber = 0;
                            ismp->state = RECEIVE_READY;     /* pass or fail, we still change state */
                        }
                        if (ismp->ReceptionBlocked == TRUE)  /* meaning: room for this one only.    */
                        {
                            if (ismp->RxSequenceNumber == 1) /* no error. good stuff.               */
                            {
                                /* deliver NPDU to the Network Layer */
                                if (deliver_inputNPDU(line, pbcu) == FALSE)
                                {
                                    /* network layer queue was full */
                                }
                            }
                            else
                            {
                                /* for now, nothing special is done on a duplicate error */
                                if (trace[line] & DATALINKTRACE)
                                {
                                    taskDelay(1);
                        printf("RxSequenceNumber indicates duplicate record. no action taken(03).\n");
                                }
                            }
                            send_frame(line, DataResponse1XOFF, 0);
                            ismp->RxSequenceNumber = 0;
                            ismp->state = RECEIVE_NOT_READY; /* pass or fail, we still change state */
                        }
                        break;
                        /* note: the other cases for DATA_REQUEST are not handled here. */


                    case DataResponse0XOFF:
                         ismp->state = DATA_RESPONSE;    /* only temporary, (or is it?) */
                         if (osmp->TxSequenceNumber == 1) /* Duplicate error */
                         {
                             /* discard data */
                             ismp->state = RECEIVE_READY;
                             return;
                         }
                         ismp->Ack0Received = TRUE;
                         osmp->TransmissionBlocked = TRUE;
                         if (ismp->FullBuffers == TRUE)
                         {
                             send_frame(line, HeartbeatXOFF, 0);
                             ismp->state = RECEIVE_NOT_READY;
                             return;
                         }
                         ismp->state = RECEIVE_READY;
                         return;
                         break;

                    case DataResponse1XOFF:
                         ismp->state = DATA_RESPONSE;
                         if (osmp->TxSequenceNumber == 0) /* Duplicate error */
                         {
                             /* discard data */
                             ismp->state = RECEIVE_READY;
                             return;
                         }
                         ismp->Ack1Received = TRUE;
                         osmp->TransmissionBlocked = TRUE;
                         if (ismp->FullBuffers == TRUE)
                         {
                             send_frame(line, HeartbeatXOFF, 0);
                             ismp->state = RECEIVE_NOT_READY;
                             return;
                         }
                         ismp->state = RECEIVE_READY;
                         return;
                         break;

                    case DataResponse0XON:
                         ismp->state = DATA_RESPONSE;
                         if (osmp->TxSequenceNumber == 1) /* Duplicate error */
                         {
                             /* discard data */
                             ismp->state = RECEIVE_READY;
                             return;
                         }
                         ismp->Ack0Received = TRUE;
                         if (ismp->FullBuffers == TRUE)
                         {
                             send_frame(line, HeartbeatXOFF, 0);
                             ismp->state = RECEIVE_NOT_READY;
                             return;
                         }
                         ismp->state = RECEIVE_READY;
                         return;
                         break;

                    case DataResponse1XON:
                         ismp->state = DATA_RESPONSE;
                         if (osmp->TxSequenceNumber == 0) /* Duplicate error */
                         {
                             /* discard data */
                             ismp->state = RECEIVE_READY;
                             return;
                         }
                         ismp->Ack1Received = TRUE;
                         osmp->TransmissionBlocked = FALSE;
                         if (ismp->FullBuffers == TRUE)
                         {
                             send_frame(line, HeartbeatXOFF, 0);
                             ismp->state = RECEIVE_NOT_READY;
                             return;
                         }
                         ismp->state = RECEIVE_READY;
                         return;
                         break;

                    case DataReject0XOFF:
                         ismp->state = DATA_REJECT;
                         if (osmp->TxSequenceNumber == 1) /* Duplicate error */
                         {
                             /* discard data */
                             ismp->state = RECEIVE_READY;
                             return;
                         }
                         ismp->Reject0Received = TRUE;
                         osmp->TransmissionBlocked = TRUE;
                         ismp->state = RECEIVE_READY;
                         return;
                         break;

                    case DataReject1XOFF:
                         ismp->state = DATA_REJECT;
                         if (osmp->TxSequenceNumber == 0) /* Duplicate error */
                         {
                             /* discard data */
                             ismp->state = RECEIVE_READY;
                             return;
                         }
                         ismp->Reject1Received = TRUE;
                         osmp->TransmissionBlocked = TRUE;
                         ismp->state = RECEIVE_READY;
                         return;
                         break;

                    case DataReject0XON:
                         ismp->state = DATA_REJECT;
                         if (ismp->RxSequenceNumber == 1) /* Duplicate error */
                         {
                             /* discard data */
                             ismp->state = RECEIVE_READY;
                             return;
                         }
                         ismp->Reject0Received = TRUE;
                         osmp->TransmissionBlocked = FALSE;
                         ismp->state = RECEIVE_READY;
                         return;
                         break;

                    case DataReject1XON:
                         ismp->state = DATA_REJECT;
                         if (ismp->RxSequenceNumber == 0) /* Duplicate error */
                         {
                             /* discard data */
                             ismp->state = RECEIVE_READY;
                             return;
                         }
                         ismp->Reject1Received = TRUE;
                         osmp->TransmissionBlocked = FALSE;
                         ismp->state = RECEIVE_READY;
                         return;
                         break;

                    case HeartbeatXOFF:
                         osmp->TransmissionBlocked = TRUE;
                         ismp->state = RECEIVE_READY;
                         return;
                         break;

                    case HeartbeatXON:
                         osmp->TransmissionBlocked = FALSE;
                         ismp->state = RECEIVE_READY;
                         return;
                         break;

                    case TestRequest:
                         send_frame(line, TestResponse, 0);
                         ismp->state = RECEIVE_READY;
                         break;

                    case TestResponse:
                         /*************************************************************/
                         /*************************************************************/
                         /* verify the response. store the results of the comparison. */
                         /*************************************************************/
                         /*************************************************************/
                         ismp->state = RECEIVE_READY;
                         break;

                    default: /* unknown frame type */
                        /* by doing nothing, the frame is discarded. */
                        return;
                        break;
                }
                break; /* end of RECEIVE_READY case statement */

            case DATA_REQUEST:      /* no action based on Frame reception */
                /* by doing nothing, the frame is discarded. */
                return;
                break;

            case DATA_RESPONSE:     /* no action based on Frame reception */
                /* by doing nothing, the frame is discarded. */
                return;
                break;

            case DATA_REJECT:       /* no action based on Frame reception */
                /* by doing nothing, the frame is discarded. */
                return;
                break;

            default:
                /* by doing nothing, the frame is discarded. */
                return;
                break;
        }


    }

/********************************/
/********************************/
/*** NEWCODE ********************/
/********************************/
/********************************/
/* physical/int layer procedures*/
/********************************/
/********************************/
/********************************/
/********************************/

/******************************************/
/*      Initialize the Raw RX Queue        */                                    		
/*******************************************/                                                                        	
/* called from MAIN */

static	void rxrawqueinit (unsigned short line)
    {
        RXRAWQUE    *qp;
        qp = rxrawq[line];
        qp->rxinix = qp->rxoutix = 0;
    }
/*                                                                     		
**  rxrawgetemptyp - get the next available slot on the rxraw list              
**                                                                              
*/
/*    called from rxraw_int_proc    */

static	RXRAW *rxrawgetemptyp (unsigned short line)
    {
        RXRAWQUE    *qp;
        qp = rxrawq[line];
	if (((qp->rxinix + 1) % RXRAWQSIZE) != qp->rxoutix)
	{
	    return(&qp->rxque[qp->rxinix]);
	}
        if (trace[line] & DATALINKTRACE)
        {
            taskDelay(1);
	    logMsg ( "Raw RX Queue Full: Line %d\n", line);
        }
	return (NULLP);
    }
/*                                                                    		
** rxrawmarkfull                                                                
**      mark the next RX block as full                                     	
*/
/*  called from rx_init_proc and rx_timer_thread   */

static	void rxrawmarkfull (unsigned short line)
    {
        RXRAWQUE    *qp;
        qp = rxrawq[line];
	qp->rxinix = ((qp->rxinix + 1) % RXRAWQSIZE);
    }
/*                                                                             	
**  rxrawgetnextp - get the next full RX slot in the circular buffer            
**                                                                              
*/                                                                      	
/* only called from msgxfer */

static	RXRAW *rxrawgetnextp (unsigned short line)
    {
        RXRAWQUE    *qp;
        qp = rxrawq[line];
	if (qp->rxoutix != qp->rxinix)
	{
	    return(&qp->rxque[qp->rxoutix]);
	}
	return (NULLP);
    }
/*                                                       	               	
** rxrawreleasefull - release the current full circular buffer entry            
**                                                                              
*/                                                                             
/* only called from msgxfer */

static	void rxrawreleasefull (unsigned short line)
    {
        RXRAWQUE    *qp;
        qp = rxrawq[line];
	if (qp->rxoutix == qp->rxinix)
		return;
	qp->rxoutix = ((qp->rxoutix + 1) % RXRAWQSIZE);
    }
/*                                                                             
**      start_rx                                                        	
**                                                                     	 	
**      The purpose of this routine is to initialize a line table        	
**      for receive and to enable the active parsing of data.                   
**                                                                        	
*/
/* only called from msgxfer */

static	void start_rx (unsigned short line)
    {
	RX_FRAME           *rxp;

        /* Set up pointer to frame buffer. */
        rxp = rxlinetab[line];

        /* test address of 'current' comm buffer before initalizing */
/*	if ((rxp = rxgetempty(line)) != NULLP) */
        {
           rxp->Index = 0;
           rxp->DLE_Mask = 0x00;
           rxp->ReceivedValidFrame = FALSE;
           rxp->ReceivedInvalidFrame = FALSE;
           rxp->SilenceTimer = 0;
           rxp->rxstate = RXIDLE;
        }
    }
/*                                                                              
**      next_rx                                                          	
**                                                                     	 	
**      The purpose of this routine is to set the rx state to enable the        
**      processing of the next frame.                                           
**                                                                              
*/
/* only called from msgxfer */

static	void next_rx (unsigned short line)
    {
	RX_FRAME           *rxp;

        /* Set up pointer to frame buffer. */
        rxp = rxlinetab[line];

        rxp->DLE_Mask = 0x00;
        rxp->SilenceTimer = 0;
        rxp->rxstate = RXIDLE;
    }
/*                                                                              
**      stop_rx                                                              	
**                                                                           	
**      The purpose of this routine is to disable the recieve interrupt service	
**                                                                              
*/
/* only called from msgxfer */

static	void stop_rx (unsigned short line)
    {
	RX_FRAME           *rxp;

        /* Set up pointer to frame buffer. */
        rxp = rxlinetab[line];

/*	if (rxp = rxgetempty(line) != NULLP) */
        {
           rxp->rxstate = RXIGNORE;
        }
    }
/*                                                                        	
**      BACnet PTP rx_int_proc                                                 	
**                                                                         	
**      The purpose of this routine is to process a receive character interrupt	
**      for a given BACnet PTP line. the received character and status are put  
**      into a circular queue for non-interrupt procesing.                      
*/
/* referenced in system call in MAIN. indirectly called through actions in msgxfer. */

static	void rx_int_proc (unsigned short line)
    {
	unsigned char   rxchar;
	unsigned short  rxstat;
	unsigned short  rx_err_mask;

        RXRAW    *rxrawp;

	/* Something is sending in data. */
	line_activity[line] = TRUE;

	read_rx_hw(line, &rxchar, &rxstat, &rx_err_mask);
        
        /* if not in master mode, or special slave mode, don't store the received characters. */
        if (rxsave[line] != TRUE)
            return;

	rxrawp = rxrawgetemptyp(line);

        if (rxrawp != NULLP)
        {
            rxrawp->rxchar = rxchar;
            rxrawp->rxstatus = ((rxstat & rx_err_mask) != 0);
            rxrawmarkfull(line);  /* release it by pointing to the next entry in the queue */
        }
        /* if buffer overflow, forget it. */
        return;
    }
/*
** this routine takes a raw input character, along with status info, and */
** parses the data link level state machine. it is currently called from */
/* a timer task supporting this driver, but with some minor re-write, it */
/* can be called directly from the rx interrupt procedure. If so done,   */
/* the raw input buffer and all of its attendant baggage can be deleted. */

static void rxrawprocess (unsigned short line)
{
        unsigned char   rxchar;
        unsigned char   rxstat;
        unsigned char   temp;

        BCU            *pbcu;

        ISM             *ismp;

        RX_FRAME        *rxp;
        RXRAW           *rxrawp;

        pbcu = bcus[line];      /* only used to access statistics */
        ismp = &pbcu->inputSM;

        /* Set up pointer to frame buffer. */
        rxp = rxlinetab[line];

        rxrawp = rxrawgetnextp(line); /* this is tested for validity before the call */
        rxchar = rxrawp->rxchar;
        rxstat = rxrawp->rxstatus;

        rxp->ReceiveError = rxstat;
        rxp->SilenceTimer = 0;

	switch (rxp->rxstate)
	{
	    case RXIGNORE:
                return;
                break;

            case RXIDLE:
                if (rxp->ReceiveError == TRUE)
                {
                    /* EatAnError */
                    rxp->rxstate = RXIDLE;
                    return;
                }
                switch (rxchar)
                {
                    case 0x55:
                        /* Preamble1 */
                        rxp->rxstate = RXPREAMBLE;
                        return;
                    default:
                        /* EatAnOctet */
                        rxp->rxstate = RXIDLE;
                        return;
                }
                break;

            case RXPREAMBLE:
                if (rxp->ReceiveError == TRUE)
                {
                    /* Error */
                    rxp->rxstate = RXIDLE;
                    return;
                }
                switch (rxchar)
                {
                    case 0x55:
                        /* RepeatedPreamble1 */
                        rxp->rxstate = RXPREAMBLE;
                        return;
                    case 0xFF:
                        /* Preamble2 */
                        rxp->DLE_Mask = 0x00;
                        rxp->HeaderCRC = 0xFF;
                        rxp->Index = 0;
                        rxp->rxstate = RXHEADER;
                        return;
                    default:
                        /* NotPreamble */
                        rxp->rxstate = RXIDLE;
                        return;
                }
                break;

            case RXHEADER:
                if (rxp->ReceiveError == TRUE)
                {
                    /* Error */
                    rxp->rxstate = RXIDLE;
                    return;
                }
                switch (rxchar)
                {
                    case 0x10:
                        /* DLE-Received */
                        rxp->DLE_Mask = 0x80;
                        rxp->rxstate = RXHEADER;
                        return;
                    default:
                        temp = (~(rxp->DLE_Mask) & (rxchar));
                        rxp->DLE_Mask = 0x00;
                        switch (rxp->Index)
                        {
                            case 0:
                                 /* FrameType */
                                 rxp->FrameType = temp;
                                 rxp->HeaderCRC = makeheadercrc(temp, rxp->HeaderCRC);
                                 rxp->Index = 1;
                                 rxp->rxstate = RXHEADER;
                                 return;
                            case 1:
                                 /* Length1 */
                                 rxp->HeaderCRC = makeheadercrc(temp, rxp->HeaderCRC);
                                 rxp->DataLength = 265*temp;
                                 rxp->Index = 2;
                                 rxp->rxstate = RXHEADER;
                                 return;
                            case 2:
                                 /* Length2 */
                                 rxp->HeaderCRC = makeheadercrc(temp, rxp->HeaderCRC);
                                 rxp->DataLength += temp;
                                 rxp->Index = 3;
                                 rxp->rxstate = RXHEADER;
                                 return;
                            case 3:
                                 /* HeaderCRC */
                                 rxp->HeaderCRC = makeheadercrc(temp, rxp->HeaderCRC);
                                 rxp->rxstate = RXHEADER_CRC; /* only here for a moment. */
                                 if (rxp->HeaderCRC != 0x55)
                                 {
                                     /* BadCRC */
                                     pbcu->no_crcerrs++;
                                     if (trace[line] & DATALINKTRACE)
                                     {
                                         taskDelay(1);
                                         logMsg("RX: InvalidFrame: HeaderCRC = %2x.\n",
                                           rxp->HeaderCRC);
                                     }
                                     rxp->ReceivedInvalidFrame = TRUE;
                                     rxp->rxstate = RXIDLE;
                                     return;
                                 }
                                 else
                                 {
                                     if (rxp->DataLength == 0)
                                     {
                                         /* NoData */
                                         rxp->ReceivedValidFrame = TRUE;
                                         rxp->rxstate = RXIDLE;
                                         rxp->rxstate = RXENDFRAME;
                                         /* clear timer on valid frame */
                                         ismp->LastFrameTime = tickGet();
                                         return;
                                     }
                                     else
                                     {
                                         /* Data */
                                         rxp->Index = 0;
                                         rxp->DataCRC = 0xFFFF;
                                         rxp->rxstate = RXDATA;
                                         return;
                                     }
                                 }
                            default:
                                 /* this should NEVER happen (but if it does, it is an error) */
                                 rxp->rxstate = RXIDLE;
                                 return;
                        }
                }
                break;

            case RXDATA:
                if (rxp->ReceiveError == TRUE)
                {
                    /* Error */
                    pbcu->no_rxhwerrs++;
                    rxp->rxstate = RXIDLE;
                    rxp->rxstate = RXENDFRAME;
                    rxp->ReceivedInvalidFrame = TRUE;
                    return;
                }
                switch (rxchar)
                {
                    case 0x10:
                        /* DLE-Received */
                        rxp->DLE_Mask = 0x80;
                        rxp->rxstate = RXDATA;
                        return;
                    default:
                        temp = (~(rxp->DLE_Mask) & (rxchar));
                        rxp->DLE_Mask = 0x00;
                        rxp->DataCRC = makedatacrc(temp, rxp->DataCRC);
                        if (rxp->Index < rxp->DataLength)
                        {
                            /* DataOctet */
                            rxp->InputBuffer[rxp->Index++] = temp;
                            rxp->rxstate = RXDATA;
                            return;
                        }
                        if (rxp->Index == rxp->DataLength)
                        {
                            /* CRC1 */
                            rxp->Index++;
                            rxp->rxstate = RXDATA;
                            return;
                        }
                        if (rxp->Index == (rxp->DataLength)+1)
                        {
                            /* CRC2 */
                            rxp->rxstate = RXDATA_CRC; /* only here for a moment. */

                            if ( rxp->DataCRC == 0xF0B8)
                            {
                                /* GoodCRC */
                                rxp->ReceivedValidFrame = TRUE;
                                rxp->rxstate = RXIDLE;
                                rxp->rxstate = RXENDFRAME;
                                /* clear timer on valid frame */
                                ismp->LastFrameTime = tickGet();
                                rxp->Index = 0;
                                return;
                            }
                            else
                            {
                                /* BadCRC */
                                pbcu->no_crcerrs++;
                                if (trace[line] & DATALINKTRACE)
                                {
                                    taskDelay(1);
                                    logMsg("RX: InvalidFrame: DataCRC = %4x.\n", rxp->DataCRC);
                                }
                                rxp->ReceivedInvalidFrame = TRUE;
                                rxp->rxstate = RXIDLE;
                                rxp->rxstate = RXENDFRAME;
                                return;
                            }
                        }
                        break;
                }
                break;

            default:
                /* this should NEVER happen (but if it does, it is an error) */
                rxp->rxstate = RXIDLE;
                return;
        }
}

static unsigned char makeheadercrc(unsigned char dataValue, unsigned char crcValue)
{
        unsigned short crc;

        crc = crcValue ^ dataValue;

        crc = crc ^
             (crc << 1) ^
             (crc << 2) ^
             (crc << 3) ^
             (crc << 4) ^
             (crc << 5) ^
             (crc << 6) ^
             (crc << 7);

        return (crc &0xFE) ^ ((crc >> 8) & 1);
}

static unsigned short makedatacrc(unsigned char dataValue, unsigned short crcValue)
{
        unsigned short crcLow, temp;;

        crcLow = (crcValue & 0xFF) ^ dataValue;

        temp = (
                 (crcValue >>  8)  ^
                 (crcLow   <<  8)  ^
                 (crcLow   <<  3)  ^
                 (crcLow   << 12)  ^
                 (crcLow   >>  4)  ^
                 (crcLow   & 0x0F) ^
                ((crcLow   & 0x0F) << 7)
               );
        return(temp);
}


/******************************************************************************
**      start_tx                                                            	
**                                                                          	
**      The purpose of this routine is to initialize a line table           	
**      for send and to enable the transmitter.                                 
**                                                                            	
*/
/* only called from msgxfer  */


static	void start_tx (unsigned short line, SEMAPHORE *semid, unsigned short *pstatus )
    {
	TX_FRAME                  *txp;

/* note that we DO NOT set the state here. instead it is set elsewhere. */
	disable_tx_ints(line);

	txp=txlinetab[line];
	txp->Index = 0;
        txp->TransmitError = FALSE;
        txp->TransmittedValidFrame = FALSE;
        txp->TransmittedInvalidFrame = FALSE;
	txp->semid = semid;
        txp->DLE_Mask = 0;            /* start out with no mask present */
	enable_tx_ints(line);
    }
/*
**      stop_tx                                                                	
**                                                                             	
*/
/* only called from msgxfer  */
**
static	void stop_tx (unsigned short line)
    {
	TX_FRAME    *txp;

	disable_tx_ints(line);
	txp=txlinetab[line];
	txp->txdisable=TRUE;
    }
*/
/*                                                                           	
**      tx_int_proc                                                           	   
**                                                                            	   
**      The purpose of this routine is to process a transmit character interrupt   
**      for a given line. [Ref: BSR/ASHRAE 135P 10.4.5 SendFrame Procedure]        
**                                                                         	   
*/
/* only referenced in MAIN  */

static void tx_int_proc (unsigned short line)
{
        unsigned char   temp;
        unsigned char   txchar;
/*        unsigned char   txstat;         */
/*        unsigned char   tx_err_mask;*/
	TX_FRAME        *txp;

	txp=txlinetab[line];

	switch (txp->txstate)
	{
	    case TXIGNORE:
                return;
                break;

            case TXINITCONNECT:
                txp->Index = 0; /* intentionally fall through to the case below */
                txp->txstate = TXCONNECT;
                txp->DLE_Mask = 0;            /* start out with no mask present */
            case TXCONNECT:
                temp = txp->OutputBuffer[txp->Index];
                if (txout(line, temp) == TXBAD) return;
                if (txp->Index >= txp->DataLength)
                {
                    txp->TransmittedValidFrame = TRUE;
                    txp->txstate = TXIGNORE;
                    /* disable the interrupt */
                    disable_tx_ints (line);
                    semGive(txp->semid);
                    return;
                }
                return;
                break;

            case TXSTART:
                txp->Index = 0; /* intentionally fall through to the case below */
                txp->txstate = TXPREAMBLE;
                txp->DLE_Mask = 0;            /* start out with no mask present */
            case TXPREAMBLE:
                switch(txp->Index)
                {
                    case 0:
                        temp = 0x55;
                        if (txout(line, temp) == TXBAD) return;
                        return;
                        break;

                    case 1:
                        temp = 0xFF;
                        if (txout(line, temp) == TXBAD) return;
                        if (txp->Index == 2)
                        {
                            txp->Index = 0;
                            txp->HeaderCRC = 0xFF;
                            txp->txstate = TXFRAME;
                        }
                        return;
                        break;
                }
                break;

            case TXFRAME:
                switch(txp->Index)
                {
                    case 0:
                        /* set escaped bit if there */
                        temp = (txp->FrameType);
                        temp = ((txp->DLE_Mask) | temp);
                        if (txp->DLE_Mask == 0)
                        {
                            txp->HeaderCRC = makeheadercrc(temp, txp->HeaderCRC);
                        }
                        if (txout(line, temp) == TXBAD) return;
                        if (txp->Index == 1)
                        {
                            txp->Index = 0;
                            txp->txstate = TXLENGTH;
                        }
                        return;
                        break;
                }
                break;
            case TXLENGTH:
                switch(txp->Index)
                {
                    case 0:
                        /* set escaped bit if there */
                        temp = (txp->DataLength >> 8);
                        temp = ((txp->DLE_Mask) | temp);
                        if (txp->DLE_Mask == 0)
                        {
                            txp->HeaderCRC = makeheadercrc(temp, txp->HeaderCRC);
                        }
                        if (txout(line, temp) == TXBAD) return;
                        return;
                        break;

                    case 1:
                        /* set escaped bit if there */
                        temp = (txp->DataLength & 0xFF);
                        temp = ((txp->DLE_Mask) | temp);
                        if (txp->DLE_Mask == 0)
                        {
                            txp->HeaderCRC = makeheadercrc(temp, txp->HeaderCRC);
                        }
                        if (txout(line, temp) == TXBAD) return;
                        if (txp->Index == 2)
                        {
                            txp->Index = 0;
                            txp->txstate = TXHEADER_CRC;
                        }
                        return;
                        break;
                }
                break;
            case TXHEADER_CRC:
                switch(txp->Index)
                {
                    case 0:
                        temp = ~txp->HeaderCRC; /* transmit ones complement of accumulated CRC */
                        temp = ((txp->DLE_Mask) | temp);
                        if (txout(line, temp) == TXBAD) return;
                        if (txp->Index == 1) /* meaning the character has been output */
                        {
                            txp->Index = 0;
                            txp->DataCRC = 0xFFFF;
                            txp->txstate = TXDATA;
                            /* check for zero length message */
                            if (txp->DataLength == 0)
                            {
                                txp->TransmittedValidFrame = TRUE;
                                txp->txstate = TXIGNORE;
                                /* disable the interrupt */
                                disable_tx_ints (line);
                                semGive(txp->semid);
                                return;
                            }
                            return;
                        }
                        return;
                        break;
                }
                break;
            case TXDATA:
                temp = txp->OutputBuffer[txp->Index];
                temp = ((txp->DLE_Mask) | temp);
                if (txp->DLE_Mask == 0)
                {
                    txp->DataCRC = makedatacrc(temp, txp->DataCRC);
                }
                if (txout(line, temp) == TXBAD) return;
                if (txp->Index >= txp->DataLength)
                {
                    txp->Index = 0;
                    txp->txstate=TXDATA_CRC;
                    return;
                }
                return;
                break;
            case TXDATA_CRC:
                switch(txp->Index)
                {
                    case 0:
                        temp = ~((txp->DataCRC) & 0xFF); /* transmit ones complement of LSB CRC */
                        temp = ((txp->DLE_Mask) | temp);
                        if (txout(line, temp) == TXBAD) return;
                        return;
                        break;
                    case 1:
                        temp = ~((txp->DataCRC) >> 8); /* transmit ones complement of MSB CRC */
                        temp = ((txp->DLE_Mask) | temp);
                        if (txout(line, temp) == TXBAD) return;
                        if (txp->Index == 2)
                        {
                            txp->TransmittedValidFrame = TRUE;
                            txp->txstate = TXIGNORE;
                            /* disable the interrupt */
                            disable_tx_ints (line);
                            semGive(txp->semid);
                            return;
                        }
                        return;
                        break;
                }
                break;
            default:
                /* this should NEVER happen (but if it does, it is an error) */
                txp->txstate = TXUNKNOWN;
                return;
        }
}

unsigned short txout(unsigned short line, unsigned char txchar)
{
    unsigned short          txstat;
    unsigned short          tx_err_mask;
    TX_FRAME                *txp;

    txp=txlinetab[line];

    switch(txchar)
    {
        case 0x10:
        case 0x11:
        case 0x13:
            txp->DLE_Mask = 0x80;  /* set mask for escaped character on next TX interrupt */
            txchar = 0x10;         /* send out 'escape' character */
            break;
        default:
            txp->Index++;
            txp->DLE_Mask = 0x00; /* clear mask */
            break;
    }    
    /* output the character */
    write_tx_hw (line, txchar, &txstat, &tx_err_mask);
    if ((txstat & tx_err_mask) != 0)
    {
        txp->TransmitError = TRUE;
        /* disable the interrupt */
        disable_tx_ints (line);
        semGive(txp->semid);
        txp->txstate = TXIGNORE;
        return(TXBAD);
    }
    return(TXGOOD);
}



/*
**      dumplinestats                                                       	          
**                                                                           	          
**      The purpose of this routine is to dump the line level statistics for this driver. 
**                                                                                        
*/
/* called from TABLEINFO */

/*void dumplinestats (unsigned short line)

    {
        unsigned long temp, t, x, y, z;

        temp = tickGet();
        t = (temp - linestats[line].startingtick);

 	x = linestats[line].TXintcount;
	y = linestats[line].RXintcount;
	z = linestats[line].msgxfercount;

        if (z == 0)
        {
            printf (" ******  No Messages Transferred ****** \n");
            return;
        }

 	printf ("\n");
printf ("Measurement Interval: clock ticks = %d, seconds = %d.%1d \n", t, t/60, (t%60)/6);
printf ("\n");
printf ("TX Interrupt Count    = %10d   Avg TX cnts/sec        = %d \n", x, (60*x)/t);
printf ("RX Interrupt Count    = %10d   Avg RX cnts/sec        = %d \n", y, (60*y)/t);
printf ("                                     Avg RX cnts/Msgxfer    = %d.\n", x/z);
printf ("                                     Avg TX cnts/Msgxfer    = %d.\n", y/z);
printf ("\n");
printf ("RX+TX Interrupt Count = %10d   Avg RX+TX cnts/sec     = %d \n",(x+y),(60*(x+y))/t);
printf ("                                     Avg RX+TX cnts/Msgxfer = %d \n",(x+y)/z);
printf ("\n");
rintf ("Msgxfer Count         = %10d   Avg Msgxfers/sec       = %d \n", z,(60*z)/t);
rintf ("                                     Avg msec/Msgxfer       = %d \n",(t*1000)/(z*60));
printf ("\n");
      return;
    }
*/
/*                                                                                        
**      clearlinestats                                                       	          
**                                                                           	          
**      The purpose of this routine is to dump and clear the line level statistics        
**      for this driver.                                                                  
**                                                                                        
*/
/* called from TABLEINFO */
/*
void clearlinestats (unsigned short line)

    {
        dumplinestats(line);

	linestats[line].TXintcount = 0;
	linestats[line].RXintcount = 0;
	linestats[line].msgxfercount = 0;

        linestats[line].startingtick = tickGet();
	printf (" ******  All Counts Cleared  ****** \n", linestats[line].msgxfercount);
 	printf ("\n");
        return;
    }
*/
/*
**      dumptranestats                                                                    
**                                                                           	          
**      The purpose of this routine is to dump the line statistics for this driver.       
**                                                                                        
*/
/* called from TABLEINFO */

void dumptranestats (unsigned short line)
    {
	BCU  *pbcu;

	pbcu = bcus[line];
	if (!pbcu)
	{
	    logMsg("BCU Not Defined \n");
	    return;
	}
	printf (" Was requested = %d \n", pbcu->was_requested);
	printf (" Is responding = %d \n", pbcu->is_responding);
	printf (" # DataIn messages = %d \n", pbcu->no_dataout_msgs);
	printf (" # Data in messages = %d \n", pbcu->no_datain_msgs);
	printf (" #No Rx Response = %d \n", pbcu->no_rxnoresp);
	printf (" #No Tx Responses = %d \n", pbcu->no_txnoresp);
	printf (" #Data Errors = %d \n", pbcu->no_dataerr);
	printf (" #Retries = %d \n", pbcu->no_retries);
	printf (" #Rx Hw Errors = %d \n", pbcu->no_rxhwerrs);
	printf (" #Tx Hw Errors = %d \n", pbcu->no_txhwerrs);
	printf (" #Crc Errors = %d \n", pbcu->no_crcerrs);
	printf (" #Off Lines = %d \n", pbcu->no_offlines);
	printf (" Reset Statistics = %d \n", pbcu->cmd_reset_stat);
	printf (" Force Offline = %d \n", pbcu->cmd_force_offline);
	printf (" #Failed Outputs = %d \n", pbcu->badoutcnt);

	printf (" Resource Responding = %d \n", resresponse[line]);
	printf (" Hold flag  = %d \n", pbcu->holdflag );
        return;
    }
/*
**      cleartranestats                                                                      
**                                                                              	     
**      The purpose of this routine is to clear the line level statistics for this driver.   
**                                                                                           
*/
/* called from TABLEINFO */

void cleartranestats (unsigned short line)
    {
	BCU  *pbcu;

	pbcu = bcus[line];
	if (!pbcu)
	{
	    logMsg("BCU Not Defined \n");
	    return;
	}

        dumptranestats(line);
	initstats(pbcu); /* use existing procedure */

        return;
    }
/*
**      dump_trane_table                                                       	
**                                                                           	
**      The purpose of this routine is to dump the line level statistics        
**       for the trane driver.                                                  
**                                                                              
*/
/* not called from within this driver */

void TABLEINFO (unsigned short line)
    {
	BCU          *pbcu;
	short           ix;
	unsigned	short	i, n, j; 

	BINARYOUTPUTS   *boptr;
	BINARYINPUTS    *biptr;
	ANALOGOUTPUTS	*aoptr;
	ANALOGINPUTS	*aiptr;
	unsigned	short   req, val, value, addr, firstaiinblk, firstanalogoutputinblk, linecnt;
	unsigned	long	bigvalue;
	unsigned	char	buffer[200];
        unsigned        short   columns;

	pbcu = bcus[line];
	if (!pbcu)
	{
	    logMsg("Line Not Defined \n");
	    return;
	}

        dumptranestats(line);

	columns = 10;
        linecnt = 1;
	printbinouthdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < (MAXBONO); i += columns)
	{
		printf("%4d    ", addr);
		for (n = 0; n < columns; n++)
		{		
		        boptr = &pbcu->binaryoutputs[i+n];
			printf("%1x,%1x,  %lx    ",
                                      boptr->was_requested,
                                      boptr->data_valid,
                                      boptr->last_read);
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + columns)  < (MAXBONO)) )
		{
			linecnt = 1;
			printbinouthdr(buffer, linecnt);
		}
		addr += columns;
	}

	columns = 10;
	linecnt = 1;
	printbininhdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < (MAXBINO); i += columns)
	{
		printf("%4d    ", addr);
		for (n = 0; n < columns ; n++)
		{		
 			biptr = &pbcu->binaryinputs[i+n];
			printf("%1x,%1x,  %lx    ",
                               biptr->was_requested,
                               biptr->data_valid,
                               biptr->last_read);
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + columns )  < (MAXBINO)) )
		{
			linecnt = 1;
			printbininhdr(buffer, linecnt);
		}
		addr += columns;
	}


	columns = 5;
	linecnt = 1;
	printaninhdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < MAXAINO; i += columns)
	{

		printf("%4d    ", addr);
				   
		for (n = 0; n < columns ; n++ )
		{		
		    aiptr = &pbcu->analoginputs[i+n];
		    printf("%1x,%1x  ", aiptr->was_requested, aiptr->data_valid);
		    for (j = 0; j < 4; j++)
		    {
			printf(" %2x",  aiptr->aivals[j]);
		    }
                    printf("   ");
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + columns)  < MAXAINO) )
		{
			linecnt = 1;
			printaninhdr(buffer, linecnt);
		}
		addr += columns;
	}

	columns = 5;
	linecnt = 1;
	printanouthdr(buffer, linecnt);
	addr = 1;
	for (i=0; i < MAXAONO; i += columns)
	{
		printf("%4d    ", addr);

		for (n = 0; n < columns; n++)
		{		
		    aoptr = &pbcu->analogoutputs[i+n];
		    printf("%1x,%1x  ", aoptr->was_requested, aoptr->data_valid);
		    for (j = 0; j < 4; j++)
		    {
			printf(" %2x",aoptr->aovals[j]);
		    }
                    printf("   ");
		}
		printf("\n");
		linecnt += 1;
		if ( (linecnt >= 17) && ((i + columns)  < MAXAONO) )
		{
			linecnt = 1;
			printanouthdr(buffer, linecnt);
		}
		addr += columns;		
	}
    }

/*
** only called from dump_trane_table 
*/


static void printbinouthdr (unsigned char *buffer, unsigned short cnt)
{	
        unsigned int     i;
        unsigned short   columns;

	columns = 10;

	taskDelay(120);
	printf("\n");
	cnt += 1;
        sprintf(buffer,"                                                  TRANE BINARY OUTPUTS ");
	printf( "%s\n", buffer);
	cnt += 1;
        printf("        ");
        for (i=0 ; i < columns; i++)
        {
            printf("R V Val    ");
        }
	printf("\n");
 	cnt += 1;
}
/*
** only called from dump_mod_table
*/


static void printbininhdr (unsigned char *buffer, unsigned short cnt)
{
        unsigned int     i;
        unsigned short   columns;

	columns = 10;

        taskDelay(120);
	printf("\n");
	cnt += 1;
        sprintf(buffer,"                                                  TRANE BINARY INPUTS");
	printf( "%s\n", buffer);
	cnt += 1;
        printf("        ");
        for (i=0 ; i < columns; i++)
        {
            printf("R V Val    ");
        }
	printf("\n");
 	cnt += 1;
}
/*
** only called from dump_mod_table
*/


static void printaninhdr(unsigned char *buffer, unsigned short cnt)
{
        unsigned int     i;
        unsigned short   columns;

	columns = 5;

	taskDelay(120);
	printf("\n");
	cnt += 1;
        sprintf(buffer,"                                              TRANE ANALOG INPUTS");
	printf( "%s\n", buffer);
	cnt += 1;
        printf("        ");
        for (i=0 ; i < columns; i++)
        {
            printf("R V   Val           ");
        }
	printf("\n");
 	cnt += 1;
}

/*
** only called from dump_mod_table
*/


static void printanouthdr (unsigned char *buffer, unsigned short cnt)
{
        unsigned int     i;
        unsigned short   columns;

	columns = 5;

	taskDelay(120);
	printf("\n");
	cnt += 1;
        sprintf(buffer,"                                              TRANE ANALOG OUTPUT");
	printf( "%s\n", buffer);
	cnt += 1;
        printf("        ");
        for (i=0 ; i < columns; i++)
        {
            printf("R V   Val           ");
        }
	printf("\n");
 	cnt += 1;

}


/* End of File: drvTrane.c */

void quicktest()
{
    unsigned short DataCRC;
    unsigned char temp;

    DataCRC = 0xFFFF;

    printf("\n\n                   CRC = %4x (Initial)\n", DataCRC);

    temp = 0x01;
    DataCRC = makedatacrc(temp, DataCRC);
    printf("First Octet    %2x  CRC = %4x  %4x\n", temp, DataCRC, ~DataCRC);
    temp = 0x22;
    DataCRC = makedatacrc(temp, DataCRC);
    printf("Second Octet   %2x  CRC = %4x  %4x\n", temp, DataCRC, ~DataCRC);
    temp = 0x30;
    DataCRC = makedatacrc(temp, DataCRC);
    printf("Third Octet    %2x  CRC = %4x  %4x\n", temp, DataCRC, ~DataCRC);
    temp = 0x10;
    DataCRC = makedatacrc(temp, DataCRC);
    printf("CRC1 (LSD)     %2x  CRC = %4x  %4x\n", temp, DataCRC, ~DataCRC);
    temp = 0xBD;
    DataCRC = makedatacrc(temp, DataCRC);
    printf("CRC2 (MSD)     %2x  CRC = %4x  %4x\n\n", temp, DataCRC, ~DataCRC);
    return;
}
